# Makefile.OS - Do magic to set OS-specific stuff

# This makefile should be included in a lower-level NRIA makefile
# in which BASEDIR, OS, and OS_VER have already been defined; it
# sets appropriate macro values for the OS and sometimes version.


### Add appropriate OS and version combinations below

# Name of binary directory for objects, libs, and executables
BDR_SunOS_4.1.3 = SunOS-4
BDR_SunOS_5.5.1 = SunOS-5
BDR_SunOS = $(BDR_SunOS_$(OS_VER))
BDR_Linux = Linux
BINDIR = $(BASEDIR)/bin/$(BDR_$(OS))

# Name of the C compiler
CC_SunOS = cc
CC_Linux = gcc
CC = $(CC_$(OS))

# Options for the C compiler
CFLG_SunOS = -O2 -DSYSV
CFLG_Linux = -g -O -Wall
CFLG = $(CFLG_$(OS))

# Location of X include files
XINC_SunOS = -I/usr/openwin/include
XINC_Linux = -I/usr/openwin/include -I/usr/X11/include
XINC = $(XINC_$(OS))

# Location of X library files
XLIB_SunOS = -L/usr/openwin/lib
XLIB_Linux = -L/usr/openwin/lib -L/usr/X11R6/lib
XLIB = $(XLIB_$(OS))

# Allow user to test 
bdrtest:
	echo "BINDIR = " $(BINDIR)
	echo "CC = " $(CC)
	echo "CFLG = " $(CFLG)
	echo "XINC = " $(XINC)
	echo "XLIB = " $(XLIB)

