From:	MX%"dalsop@mrssparc.mri.upenn.edu" 17-JAN-1995 10:48:18.62
To:	MX%"thew@bbl.psycha.upenn.edu"
CC:	
Subj:	

Return-Path: <dalsop@mrssparc.mri.upenn.edu>
Received: from noc1.dccs.upenn.edu by BBL.PSYCHA.UPENN.EDU (MX V4.1 AXP) with
          SMTP; Tue, 17 Jan 1995 10:48:17 EST
Return-Path: <dalsop@mrssparc.mri.upenn.edu>
Received: from MRSSPARC.MRI.UPENN.EDU by noc1.dccs.upenn.edu id AA26176; Tue,
          17 Jan 95 10:48:25 -0500
Received: by mrssparc.mri.upenn.edu.noname (4.1/SMI-4.1) id AA14859; Tue, 17
          Jan 95 10:48:35 EST
Date: Tue, 17 Jan 95 10:48:35 EST
From: dalsop@mrssparc.mri.upenn.edu (Dave Alsop - 349-5295)
Message-ID: <9501171548.AA14859@mrssparc.mri.upenn.edu.noname>
To: thew@bbl.psycha.upenn.edu

/* @(#)rdbm52.h	1.1 rdbm52.h       From: */
/*@Start***********************************************************/
/* GEMSBG Include File
 * Copyright (C) 1992 The General Electric Company
 *
 *      Include File Name:  @RDBM@
 *      Developer:  X. Zang
 *
 * $Source: /export/devel/cvsroot/bbl/nria/lib/include/dav1.h,v $
 * $Revision: 1.1 $  $Date: 1998/02/26 22:08:14 $
 */


/*@Synopsis

	Define all constants and structures needed to interface with RDBM.
*/

/*@Description

	Applications who uses RDBM must include this file.
	There are two ways this file can be used.

	1.	Applications who uses the toolsdata, exam header, serise
		header and/or image header section of the raw header must
		include the following files prior to the #include
		directive of this file.

				#include toolsdata.h 
				#include imagedb.h

	2.	Applications who wish to do away with the objcc dependancy
		and have no need to access the sections mentioned above
		can do so by 
		
				#define RECON_FLAG 
				
		prior to the #include directive of this file.

/*@End*********************************************************/

#ifndef RDBM52_INCL /* only do this once in any given compilation.*/
#define RDBM52_INCL

/*---------------------------------------------------------------------
 | RDBM Function codes
 ---------------------------------------------------------------------*/
#define RDB_ALLOCATE                    1
#define RDB_CLOSE                       2
#define RDB_DEALLOCATE                  3
#define RDB_INIT                        4
#define RDB_LOCK                        5
#define RDB_OPEN                        6
#define RDB_RDHEADER                    7
#define RDB_UNLOCK                      8
#define RDB_WRHEADER                    9
#define RDB_PREALLOCATE                10
#define RDB_LASTRUN                    11
#define RDB_CLEANUP                    12
#define RDB_LOPEN                      13
#define RDB_LCLOSE                     14
#define RDB_READ                       15
#define RDB_WRITE                      16
#define RDB_LOCK_TO_TAPE               17
#define RDB_UNLOCK_FROM_TAPE           18
#define RDB_HDR_UNLOCK                 19
#define RDB_GETADDR                    20
#define RDB_VALID                      21
#define RDB_RDPFRAME                   22
#define RDB_PERM                       23
#define RDB_HIDE                       24
#define RDB_UNHIDE                     25
#define RDB_RDTFRAME                   26
#define RDB_RDPOPS                     27
#define RDB_RDTOPS                     28
#define RDB_CREATE_LINK                29
#define RDB_LOCK_SLICE                 30
#define RDB_DEALLOCATE_RFF             31
#define RDB_PERM_RFF                   32
#define RDB_UNLOCK_RFF                 33
#define RDB_UNLOCK_FROM_TAPE_RFF       34
#define RDB_DEALLOCATE_DS              35
#define RDB_HDR_UNLOCK_RFF             36
#define RDB_SET_RECEIVER               37
#define RDB_DISK_TO_TAPE               38
#define RDB_TAPE_TO_DISK               39
#define RDB_CLEARDB                    40
#define RDB_UNINIT                     41

/*---------------------------------------------------------------------
 | RDBM status codes
 ---------------------------------------------------------------------*/
#define RDB_STATUS_OK                  0
#define RDB_STATUS_ERR                -1
#define RDB_NO_RUNS                   -2

/*---------------------------------------------------------------------
 | rdb_hdr_rdbm_rev
 | RDBM header fields that filled by rdbm routines
 ---------------------------------------------------------------------*/
#define RDB_RDBM_REVISION              5.2

/*---------------------------------------------------------------------
 | rdb_hdr_transpose
 | Relating to transpose and rotating the image 16 bit integer
 ---------------------------------------------------------------------*/
#define RDB_TRANSPOSE                  3
#define RDB_NO_TRANSPOSE               0
#define RDB_TRANSPOSE_AFTER           -1
#define RDB_TRANSPOSE_BEFORE           1

/*---------------------------------------------------------------------
 | rdb_hdr_rotation
 | For 'ROTATION' field in header 
 ---------------------------------------------------------------------*/
#define RDB_NO_ROTATION                0
#define RDB_ROTATE_90                  1
#define RDB_ROTATE_180                 2
#define RDB_ROTATE_270                 3

/*---------------------------------------------------------------------
 | rdb_hdr_scan_type
 | Scan types, may be added together to form the right combination
 | storage is 16 bit mask.
 ---------------------------------------------------------------------*/
#define RDB_SPIN_ECHO                  0x0002	/* 2 */
#define RDB_PARTIAL_SAT                0x0008	/* 8 */
#define RDB_INVERSION_REC              0x0010	/* 16 */
#define RDB_HADAMARD                   0x0020	/* 32 */
#define RDB_SPIN_WARP                  0x0800	/* 2048 */
#define RDB_GRE                        0x1000	/* 4096 */

/*---------------------------------------------------------------------
 | rdb_hdr_data_collect_type
 | Data collection types are a bitmask which may be added together
 | to form the right combination of bits.
 ---------------------------------------------------------------------*/
#define RDB_CHOPPER                    0x0001
#define RDB_CINE                       0x0002
#define RDB_SHIM                       0x0004
#define RDB_GRASS                      0x0008
#define RDB_HNEX                       0x0010	/* 16 */
#define RDB_STRIP                      0x0020	/* 32 */
#define RDB_Y_STRIP                    0x0020	/* 32 */
#define RDB_3DFFT                      0x0040	/* 64 */
#define RDB_EXORCIST                   0x0080	/* 128 */
#define RDB_NO_PHASE_WRAP              0x0100	/* 256 */
#define RDB_NO_FREQ_WRAP               0x0200	/* 512 */
#define RDB_X_STRIP                    0x0400	/* 1024 */
#define RDB_HECHO                      0x0800	/* 2048 */
#define RDB_OVERSCAN                   0x1000	/* 4096 */
#define RDB_3QNEX                      0x2000	/* 8192 */
#define RDB_POMP                       0x4000	/* 16384 */

/*---------------------------------------------------------------------
| rdb_hdr_data_collect_type1
| Data collection types are a bitmask which may be added together
| to form the right combination of bits.
| RDB_USE_NEXA is used to indicated that the nex abort table will be
| used to store the nex values during the collection of the 2nd echo.
| RDB_USE_NEXA is normally used for Odd Nex Fast Spin Echo scans with
| two echoes.
---------------------------------------------------------------------*/
#define RDB_HRHOMO                     0x0001
#define RDB_USE_NEXA                   0x0002

/*---------------------------------------------------------------------
 | rdb_hdr_format
 | Define bits for the FORMAT offset in the RDBM hdr. These define 
 | various non-data related processes which may be turned on or off 
 | just for fun. These bits may be added together to form a 16-bit    
 | bitmask.  Please note that there is NOT a clear distinction being 
 | made between what should be in the FORMAT offset and what should 
 | be in the DATA COLLECTION offset. It's up to the keeper of the RDBM.	
 ---------------------------------------------------------------------*/
#define RDB_NO_GRADWARP                0x0001	/* 1 */
#define RDB_NO_FERMI                   0x0002	/* 2 */
#define RDB_ZCHOP                      0x0004	/* 4 */
#define RDB_YCHOP                      0x0008	/* 8 */
#define RDB_IIC                        0x0010	/* 16 */
#define RDB_CSI                        0x0020	/* 32 */
#define RDB_HS                         0x0040	/* 64 */
#define RDB_SPECTRO                    0x0080   /* 128 */
#define RDB_IMAGE_CHECKSUM             0x0100   /* 256 */
#define RDB_NOREC_CHECKSUM             0x0200   /* 512 */

/*---------------------------------------------------------------------
 | Define the different gradwarp types.
 ---------------------------------------------------------------------*/
#define RDB_GWTYPE_NONE                0
#define RDB_GWTYPE_PHASE               1
#define RDB_GWTYPE_FREQ                2
#define RDB_GWTYPE_RADIAL              3

/*---------------------------------------------------------------------
 | rdb_hdr_gradcoil
 | Define the different gradcoil types
 ---------------------------------------------------------------------*/
#define RDB_GRADCOIL_SCHENKE           1
#define RDB_GRADCOIL_ROEMER            2

/*---------------------------------------------------------------------
 | Define a few maximums for number of echoes, slices, 
 | dabs, and the I/O packet size
 ---------------------------------------------------------------------*/
#define RDB_MAX_SLICES                 512
#define RDB_MAX_PASSES                 RDB_MAX_SLICES
#define RDB_MAX_ECHOES                 16
#define RDB_IOPACKET_SIZE              sizeof(RDB_IO_PACKET)
#define RDB_MAX_DABS                   1

/*---------------------------------------------------------------------
 |	Value of the dab board.
 ---------------------------------------------------------------------*/
#define DAB_VALUE                      0

/*---------------------------------------------------------------------
 | rdb_hdr_file_contents
 | Data type of locked data set.
 ---------------------------------------------------------------------*/
#define RDB_FILE_EMPTY                 0
#define RDB_FILE_NOREC                 1
#define RDB_FILE_RAW                   2

/*---------------------------------------------------------------------
 | Constants for rdb_tape_disk routine.
 ---------------------------------------------------------------------*/
#define RDB_RET_RUN                    0
#define RDB_OVERWRITE                  1
#define RDB_NOOVERWRITE                2

/*---------------------------------------------------------------------
 | rdb_hdr_dacq_ctrl
 | Control bit definitions for how the data was played out by the psd.
 ---------------------------------------------------------------------*/
#define RDB_RAW_COLLECT                0x0001	/* 1 */
#define RDB_FLIP_PHASE_EVEN            0x0002	/* 2 */
#define RDB_FLIP_PHASE_ODD             0x0004	/* 4 */
#define RDB_FLIP_FREQ_EVEN             0x0008	/* 8 */
#define RDB_FLIP_FREQ_ODD              0x0010	/* 16 */
#define RDB_RAW_WITHOUT_SSP            0x0020	/* 32 */
#define RDB_RAW_WRAP_AROUND            0x0040	/* 64 */

/*---------------------------------------------------------------------
 | rdb_hdr_exec_ctrl
 | Control bit definitions for what results the tps will transfer to the host.
 ---------------------------------------------------------------------*/
#define RDB_AUTO_DISPLAY               0x0001	/* 1 */
#define RDB_AUTO_LOCK                  0x0002	/* 2 */
#define RDB_AUTO_PERM                  0x0004	/* 4 */
#define RDB_XFER_IM                    0x0008	/* 8 */
#define RDB_SAVE_IM                    0x0010	/* 16 */
#define RDB_TAPE_LOCK                  0x0020	/* 32 */
#define RDB_INTERMEDIATE               0x0040	/* 64 */
#define RDB_OVERRIDE_BROADCAST         0x0080	/* 128 */
#define RDB_OVERRIDE_IMG_INSTALL       0x0100	/* 256 */
#define RDB_OVERRIDE_AUTODISPLAY       0x0200	/* 512 */

/*---------------------------------------------------------------------
 | rdb_hdr_recon_ctrl
 | Control bit definitions for determining what type of images tps will cresate.
 ---------------------------------------------------------------------*/
#define RDB_MAG_IM                     0x0001	/* 1 */
#define RDB_PHASE_IM                   0x0002	/* 2 */
#define RDB_I_IM                       0x0004	/* 4 */
#define RDB_Q_IM                       0x0008	/* 8 */
#define RDB_COMPRESSION                0x0010	/* 16 */

/*---------------------------------------------------------------------
 | rdb_hdr_fd_ctrl
 | Control bits for feeder.
 ---------------------------------------------------------------------*/
#define RDB_FD_DF                      0x0001	/* 1 */
#define RDB_FD_UNLOCKED                0x0002	/* 2 */
#define RDB_FD_ALGOR                   0x0004	/* 4 */
#define RDB_FD_VALIDATE                0x0008	/* 8 */
#define RDB_FD_DEBUG_SS                0x0010	/* 16 */
#define RDB_FD_TE                      0x0020	/* 32 */
#define RDB_FD_ISR_ALGR                0x0040	/* 64 */


#define RDB_FD_SINK_DF                 0x0001
#define RDB_FD_SOURCE_UNLOCKED         0x0002
#define RDB_FD_SOURCE_ALGOR            0x0004
#define RDB_FD_5XVALIDATE              0x0008
#define RDB_FD_5XDEBUG_SS              0x0010
#define RDB_FD_TE_ENABLE               0x0020
#define RDB_FD_ISR_ALGOR               0x0040
#define RDB_FD_SOURCE_LOCKED           0x0080
#define RDB_FD_SOURCE_RCVR             0x0100
#define RDB_FD_SINK_DAB                0x0200
#define RDB_FD_EXTERNAL_SSP            0x0400
#define RDB_FD_DEBUG                   0x8000

#define RDB_FD_AUTOSTART               0x1000
#define RDB_FD_CHKSUM                  0x2000


/*---------------------------------------------------------------------
 | RDBM constants used by rdbm functions.
 ---------------------------------------------------------------------*/
#define RDB_VALID_LOGO                 "GE_MED_NMR"
#define RDB_INVALID_LOGO               "INVALIDNMR"
#define RDB_MAX_OPS                    4
#define RDB_ISVALID                    0
#define RDB_INVALID                   -2

#define RDB_HDR_LOCK_PASS              00
#define RDB_HDR_LOCK_SLICE             01
#define RDB_HDR_LOCK_TAPE              02

#define RDB_DS_SCAN                    -3
#define RDB_RAWFF_SCAN                 -2
#define RDB_RAWFF_TYPE                 -2
#define RDB_RAWFF_ALL                  -1
#define RDB_NORMAL_SCAN                 0

#define PHASE_ORDERED                  0
#define TIME_ORDERED                   1

#define RDB_POOL_FILE                  "HEADER_POOL"
#define RDB_DIR_FILE                   "/usr/g/mrraw"
#define RDB_HDR_FILE                   "/usr/g/mrraw/HEADER_POOL"
#define RDB_LCK_FILE                   "/usr/g/mrraw/Pxxxxx"
#define RDBM_NMRID                     "RDBM_xxxxxx"

#define DATA_AREA                      0
#define SSP_AREA                       1
#define UDA_AREA                       2


/*---------------------------------------------------------------------
 | rdb_hdr_v_type
 | Define constants for Vascular
 ---------------------------------------------------------------------*/
#define RDB_VASC                       0x00000001	/* 1 */
#define RDB_PC                         0x00000002	/* 2 */
#define RDB_2SETS                      0x00000008	/* 8 */
#define RDB_ALIAS                      0x00000010	/* 16 */
#define RDB_PHASE1                     0x00000020	/* 32 */
#define RDB_PHASE2                     0x00000040	/* 64 */
#define RDB_NMASK                      0x00000080	/* 128 */
#define RDB_MAG                        0x00000100	/* 256 */
#define RDB_XFLOW                      0x00000200	/* 512 */
#define RDB_YFLOW                      0x00000400	/* 1024 */
#define RDB_ZFLOW                      0x00000800	/* 2048 */
#define RDB_SLICE                      0x00001000	/* 4096 */
#define RDB_READOUT                    0x00002000	/* 8192 */
#define RDB_PHASE                      0x00004000	/* 16384 */
#define RDB_VINNIE1                    0x00008000	/* 32768 */
#define RDB_VINNIE2                    0x00010000	/* 65536 */
#define RDB_VINNIE3                    0x00020000	/* 131072 */
#define RDB_PROJ10                     0x00080000	/* 524288 */
#define RDB_PROJ5                      0x00100000	/* 1048576 */
#define RDB_NMASK2                     0x00200000	/* 2097152 */

/*---------------------------------------------------------------------
 |  Constants used to identify vascular image types
 ---------------------------------------------------------------------*/
#define VASC_PROJ                      0x00000200	/* 512 */
#define VASC_ZPHASE                    0x00000400	/* 1024 */
#define VASC_YPHASE                    0x00000800	/* 2048 */
#define VASC_XPHASE                    0x00001000	/* 4096 */
#define VASC_MAG                       0x00002000	/* 8192 */
#define VASC_VASC                      0x00004000	/* 16384 */
#define VASC_COLLAPSE                  0x00008000	/* 32768 */


/**********************************************************************
 *
 *	The following is the typedef of the raw header structure.
 *
 **********************************************************************/

/*---------------------------------------------------------------------
 |	Multiple receiver structure
 ---------------------------------------------------------------------*/
typedef struct
{
	short   start_rcv;
	short   stop_rcv;
}       RDB_MULTI_RCV_TYPE;


/*---------------------------------------------------------------------
 |	 Header record
 |
 |		 quota = 2048   old
 |		 used  =  888   858   474  432
 |		 -----------------------------
 |		 excess= 1160  1190  1574 1616
 |
 ---------------------------------------------------------------------*/
typedef struct _RDB_HEADER52_REC
{
   float    rdb_hdr_rdbm_rev;
   long     rdb_hdr_run_int;           /* Rdy pkt Run Number */
   short    rdb_hdr_scan_seq;          /* Rdy pkt Sequence Number */
   char     rdb_hdr_run_char [6];      /* 10 Rdy pkt Run no in char */
   char     rdb_hdr_scan_date [10];    /* 16 */
   char     rdb_hdr_scan_time [8];     /* 26 */
   char     rdb_hdr_logo [10];         /* rdbm  used to verify file */

   short    rdb_hdr_file_contents;     /* Data type 0=emp 1=nrec 2=rw 	0, 1, 2 */
   short    rdb_hdr_lock_mode;         /* unused */
   short    rdb_hdr_dacq_ctrl;         /* rhdacqctrl bit mask		15 bits */
   short    rdb_hdr_recon_ctrl;        /* rhrcctrl bit mask 		15 bits */
   short    rdb_hdr_exec_ctrl;         /* rhexecctrl bit mask 		15 bits */
   short    rdb_hdr_scan_type;         /* bit mask 			15 bits */
   short    rdb_hdr_data_collect_type; /* rhtype  bit mask		15 bits */
   short    rdb_hdr_data_format;       /* rhformat  bit mask 		15 bits */
   short    rdb_hdr_recon;             /* rhrecon proc-a-son recon	0 - 100 */
   short    rdb_hdr_datacq;            /* rhdatacq proc-a-son dacq */

   short    rdb_hdr_npasses;           /* 64-rhnpasses  passes for a scan  0 - 256 */
   short    rdb_hdr_npomp;             /* 66-rhnpomp  pomp group slices  	1,2 */
   short    rdb_hdr_nslices;           /* 68 rhnslices  slices in a pass	0 - 256 */
   short    rdb_hdr_nechoes;           /* 70 rhnecho  echoes of a slice	1 - 32 */
   short    rdb_hdr_navs;              /* rhnavs  num of excitiations  	1 - 32727 */
   short    rdb_hdr_nframes;           /* 74 rhnframes  yres		0 - 1024 */
   short    rdb_hdr_baseline_views;    /* 76 rhbline  baselines		0 - 1028 */
   short    rdb_hdr_hnover;            /* 78-rhhnover  overscans		0 - 1024 */
   short    rdb_hdr_frame_size;        /* 80 rhfrsize  xres 		0 - 1024 */
   short    rdb_hdr_point_size;        /* rhptsize			2 - 4 */

   short    rdb_hdr_vquant;            /* rhvquant 3d volumes		1 */

   short    rdb_hdr_cheart;            /* RX Cine heart phases 		1 - 32 */
   float    rdb_hdr_ctr;               /* 88 RX Cine TR in sec		0 - 3.40282e38*/
   float    rdb_hdr_ctrr;              /* RX Cine RR in sec 		0 - 30.0 */

   short    rdb_hdr_initpass;          /* rhinitpass allocate passes    0 - 32767 */
   short    rdb_hdr_incrpass;          /* rhincrpass tps autopauses	0 - 32767 */

   short    rdb_hdr_method_ctrl;       /* rhmethod  0=recon, 1=psd	0, 1 */
   short    rdb_hdr_da_xres;           /* 102 rhdaxres 			0 - 1024 */
   short    rdb_hdr_da_yres;           /* 104 rhdayres 			0 - 2049 */
   short    rdb_hdr_rc_xres;           /* 106 rhrcxres 			0 - 1024 */
   short    rdb_hdr_rc_yres;           /* 108 rhrcyres 			0 - 1024 */
   short    rdb_hdr_im_size;           /* rhimsize 			0 - 512 */
   long     rdb_hdr_rc_zres;           /* power of 2 > rhnslices	0 - 128 */
 
   long     rdb_hdr_raw_pass_size;     /* rhrawsize 			0 - 2147483647*/
   long     rdb_hdr_sspsave;           /* 120 rhsspsave 			0 - 2147483647*/
   long     rdb_hdr_udasave;           /* rhudasave 			0 - 2147483647*/
 
   float    rdb_hdr_fermi_radius;      /* rhfermr fermi radius		0 - 3.40282e38*/
   float    rdb_hdr_fermi_width;       /* rhfermw fermi width		0 - 3.40282e38*/
   float    rdb_hdr_fermi_ecc;         /* rhferme fermi excentiricty	0 - 3.40282e38*/
   float    rdb_hdr_clip_min;          /* rhclipmin 4x IP limit		+-16383 */
   float    rdb_hdr_clip_max;          /* rhclipmax 4x IP limit		+-16383 */
   float    rdb_hdr_default_offset;    /* rhdoffset default offset = 0	+-3.40282e38 */
   float    rdb_hdr_xoff;              /* rhxoff scroll img in x 	+-256 */
   float    rdb_hdr_yoff;              /* rhyoff scroll img in y	+-256 */
   float    rdb_hdr_nwin;              /* rhnwin hecho window width	0 - 256 */
   float    rdb_hdr_ntran;             /* rhntran hecho trans width	0 - 256 */
   float    rdb_hdr_scalei;            /* PS rhscalei			+-3.40282e38 */
   float    rdb_hdr_scaleq;            /* PS rhscaleq  def = 0		+-3.40282e38 */
   short    rdb_hdr_rotation;          /* 176 RX 0 90 180 270 deg		0 - 3 */
   short    rdb_hdr_transpose;         /* RX 0, 1 n / y transpose 	0 - 1*/
   short    rdb_hdr_kissoff_views;     /* rhblank zero image views	0 - 512 */
   short    rdb_hdr_slblank;           /* rhslblank  slice blank 3d	0 - 128 */ 
   short    rdb_hdr_gradcoil;          /* RX 0=off 1=Schnk 2=Rmr	0 - 2 */
   short    rdb_hdr_ddaover;           /* rhddaover unused */
 
   short    rdb_hdr_sarr;              /* SARR bit mask 		15 bits */
   short    rdb_hdr_fd_tr;             /* SARR feeder timing info */
   short    rdb_hdr_fd_te;             /* SARR feeder timing info */
   short    rdb_hdr_fd_ctrl;           /* SARR control of feeder */
   short    rdb_hdr_algor_num;         /* SARR df decimation ratio */
   short    rdb_hdr_fd_df_dec;         /* SARR which feeder algor */
 
   RDB_MULTI_RCV_TYPE rdb_hdr_dab[4];  /* rhdab0s rhdab0e st, stp rcv 	0 - 15 */
 
   float    rdb_hdr_user0;             /* 216 rhuser0 			+-3.40282e38 */
   float    rdb_hdr_user1;             /* rhuser1 			+-3.40282e38 */
   float    rdb_hdr_user2;             /* rhuser2 			+-3.40282e38 */
   float    rdb_hdr_user3;             /* rhuser3 			+-3.40282e38 */
   float    rdb_hdr_user4;             /* 232 rhuser4 			+-3.40282e38 */
   float    rdb_hdr_user5;             /* rhuser5 			+-3.40282e38 */
   float    rdb_hdr_user6;             /* rhuser6 			+-3.40282e38 */
   float    rdb_hdr_user7;             /* rhuser7 			+-3.40282e38 */
   float    rdb_hdr_user8;             /* rhuser8 			+-3.40282e38 */
   float    rdb_hdr_user9;             /* rhuser9 			+-3.40282e38 */
   float    rdb_hdr_user10;            /* rhuser10			+-3.40282e38 */
   float    rdb_hdr_user11;            /* rhuser11			+-3.40282e38 */
   float    rdb_hdr_user12;            /* rhuser12			+-3.40282e38 */
   float    rdb_hdr_user13;            /* rhuser13			+-3.40282e38 */
   float    rdb_hdr_user14;            /* rhuser14			+-3.40282e38 */
   float    rdb_hdr_user15;            /* rhuser15			+-3.40282e38 */
   float    rdb_hdr_user16;            /* rhuser16			+-3.40282e38 */
   float    rdb_hdr_user17;            /* rhuser17			+-3.40282e38 */
   float    rdb_hdr_user18;            /* rhuser18			+-3.40282e38 */
   float    rdb_hdr_user19;            /* rhuser19			+-3.40282e38 */
   
   long     rdb_hdr_v_type;	       /* 296 rhvtype  bit mask		31 bits */
   float    rdb_hdr_v_coefxa;	       /* RX x flow direction control	0 - 4 */
   float    rdb_hdr_v_coefxb;	       /* RX x flow direction control	0 - 4 */
   float    rdb_hdr_v_coefxc;	       /* RX x flow direction control	0 - 4 */
   float    rdb_hdr_v_coefxd;	       /* RX x flow direction control	0 - 4 */
   float    rdb_hdr_v_coefya;	       /* RX y flow direction control	0 - 4 */
   float    rdb_hdr_v_coefyb;	       /* RX y flow direction control	0 - 4 */
   float    rdb_hdr_v_coefyc;	       /* RX y flow direction control	0 - 4 */
   float    rdb_hdr_v_coefyd;	       /* RX y flow direction control	0 - 4 */
   float    rdb_hdr_v_coefza;	       /* RX z flow direction control	0 - 4 */

   float    rdb_hdr_v_coefzb;	       /* 336 RX z flow direction control	0 - 4 */
   float    rdb_hdr_v_coefzc;	       /* RX z flow direction control	0 - 4 */
   float    rdb_hdr_v_coefzd;	       /* RX z flow direction control	0 - 4 */
   float    rdb_hdr_vm_coef1;	       /* RX weight for mag image 1	0 - 1 */
   float    rdb_hdr_vm_coef2;	       /* RX weight for mag image 2	0 - 1 */
   float    rdb_hdr_vm_coef3;	       /* RX weight for mag image 3	0 - 1 */
   float    rdb_hdr_vm_coef4;	       /* RX weight for mag image 4	0 - 1 */
   float    rdb_hdr_v_venc;            /* RX vel encodeing cm / sec	0.001 - 5000 */
   float    spectral_width;            /* specwidth  filter width kHz	500 - 3355432 */
   short    csi_dims;                  /* spectro */
   short    xcsi;                      /* 374 rhspecrescsix  		2 - 64 */

   short    ycsi;                      /* 376 rhspecrescsiy  		2 - 64 */
   short    zcsi;                      /* spectro */
   float    roilenx;                   /* 380 RX x csi volume dimension */
   float    roileny;                   /* RX y csi volume dimension */
   float    roilenz;                   /* RX z csi volume dimension */
   float    roilocx;                   /* RX x csi volume center */
   float    roilocy;                   /* RX y csi volume center */
   float    roilocz;                   /* RX z csi volume center */
   float    numdwell;                  /* specdwells			0 - 3.40282e38*/

   long     rdb_hdr_ps_command;	       /* PS internal use only	*/
   long     rdb_hdr_ps_mps_r1;	       /* PS MPS R1 setting  		1 - 7 */
   long     rdb_hdr_ps_mps_r2;	       /* PS MPS R2 setting		1 - 30 */
   long     rdb_hdr_ps_mps_tg;	       /* PS MPS Transmit gain setting	0 - 200*/
   long     rdb_hdr_ps_mps_freq;       /* PS MPS Center frequency hz	+-3.40282e38 */
   long     rdb_hdr_ps_aps_r1;	       /* PS APS R1 setting		1 - 7 */
   long     rdb_hdr_ps_aps_r2;	       /* PS APS R2 setting		1 - 30 */
   long     rdb_hdr_ps_aps_tg;	       /* PS APS Transmit gain setting	0 - 200*/
   long     rdb_hdr_ps_aps_freq;       /* PS APS Center frequency hz	+-3.40282e38 */
   float    rdb_hdr_ps_scalei;	       /* PS rational scaling 		+-3.40282e38 */
   float    rdb_hdr_ps_scaleq;	       /* PS unused */			
   long     rdb_hdr_ps_snr_warning;    /* PS noise test 0=16 1=32 bits	0, 1 */
   long     rdb_hdr_ps_aps_or_mps;     /* PS prescan order logic	0 - 5 */
   long     rdb_hdr_ps_mps_bitmap;     /* PS bit mask			4 bits*/
   char     rdb_hdr_ps_powerspec [256];/* PS                             */
   long     rdb_hdr_ps_filler1;	       /* PS filler */
   long     rdb_hdr_ps_filler2;	       /* PS filler */
   float    rdb_hdr_rec_noise_mean[16];/* PS mean noise each receiver   +-3.40282e38 */
   float    rdb_hdr_rec_noise_std[16]; /* PS noise calc for muti rec  	+-3.40282e38 */

   short    halfecho;                  /* spectro full, half echo       0, 1 */
   /* 858 bytes */

   /* New fields 02-19-92 */
   short    rdb_hdr_im_size_y;         /* rh???? 			0 - 512 */
   long     rdb_hdr_data_collect_type1;/* rh???? bit mask		31 bits */
   float    rdb_hdr_freq_scale;        /* rh???? freq k-space step      +-3.40282e38 */
   float    rdb_hdr_phase_scale;       /* rh???? freq k-space step      +-3.40282e38 */
   /* 14 bytes */

   short    rdb_hdr_excess [588];      /* free space for later expansion */
 
} RDB_HEADER52_REC;
 
/*---------------------------------------------------------------------
 | Per Pass Table and Unlocked RAW Table
 |
 |	Per Pass DACQ table
 |        1. Pointers to data (data, ssp and uda)
 |        2. Index by (pass number - 1) in Data Acquisition Table.
 |
 |	Unlocked RAW table
 |        1. pointers to where UNLOCKED RAW DATA is in BAM
 |        2. index by (pass number - 1)
 |
 ---------------------------------------------------------------------*/
typedef struct
{
	long    bam_modifier;
	long    bam_address;
}       VME_ADDRESS;



typedef struct			       
{
	VME_ADDRESS dab_bam[RDB_MAX_DABS];
}       RDB_PASS_INFO_ENTRY;

typedef RDB_PASS_INFO_ENTRY RDB_PER_PASS_TAB[RDB_MAX_PASSES];

typedef RDB_PASS_INFO_ENTRY RDB_UNLOCK_RAW_TAB[RDB_MAX_PASSES];

/*---------------------------------------------------------------------
 |	DATA ACQUISITION TABLE
 |
 |	CVs used in setting this table up (by Scan):
 |       SI_RDBSLICE RH_SLPASS RH_SLTIME RH_SLLOC
 |
 ---------------------------------------------------------------------*/

typedef struct
{
	short   pass_number;	       /* which pass this slice is in */
	short   slice_in_pass;	       /* which slice in this pass */
	float   gw_point1[3];	       /* corner points of image */
	float   gw_point2[3];
	float   gw_point3[3];
}       RDB_SLICE_INFO_ENTRY;

typedef RDB_SLICE_INFO_ENTRY RDB_DATA_ACQ_TAB[RDB_MAX_SLICES];

/*---------------------------------------------------------------------
 |	NEX Table
 ---------------------------------------------------------------------*/

/***********************/
/* gain table structure */

typedef struct
{
	short        range;          /* view range for this gain */
	float        gaini;          /* real part of gain */
	float        gainq;          /* imaginary part */
} RDB_GAIN_ENTRY;

typedef RDB_GAIN_ENTRY  RDB_GAIN_TAB[5]; /* max # of ranges */

 /* nex table structure */
 typedef short   RDB_NEX_ENTRY;
 typedef RDB_NEX_ENTRY   RDB_NEX_TAB[1026]; /* max da_yres */

typedef struct
{
	short int rdb_hdr_nex_size[1026];
}       RDB_NEX_TYPE;


/*---------------------------------------------------------------------
 |	RDBM HEADER
 ---------------------------------------------------------------------*/
#ifdef RECON_FLAG

	/*
	 * This section of typedef's depending on the structures
	 * defined in toolsdata.h and imagedb.h
	 *
	 * If the size of any following structure changes in the
	 * above include file, this file must be updated accordingly.
	 */
#ifndef TOOLSDATA_INCL
#define TOOLSDATA_INCL
	typedef char TOOLSDATA[2048];
#endif

#ifndef IMAGEDB_H_INCL     
#define IMAGEDB_H_INCL
	typedef char EXAMDATATYPE[1024];
	typedef char SERIESDATATYPE[1020];
	typedef char MRIMAGEDATATYPE[1022];
#endif

#endif   /* RECON_FLAG */

typedef struct
{
	RDB_HEADER52_REC         rdb_hdr_rec;
	RDB_PER_PASS_TAB       rdb_hdr_per_pass;
	RDB_PER_PASS_TAB       rdb_hdr_unlock_raw;
	RDB_DATA_ACQ_TAB       rdb_hdr_data_acq_tab;
	RDB_NEX_TYPE           rdb_hdr_nex_tab;
	RDB_NEX_TYPE           rdb_hdr_nex_abort_tab;
}       RDBM_HEADER;

typedef struct
{
	TOOLSDATA              rdb_hdr_tool;         /* 2048 - From toolsdata.h */
	EXAMDATATYPE           rdb_hdr_exam;         /* 1024 - From imagedb.h */
	SERIESDATATYPE         rdb_hdr_series;       /* 1020 - From imagedb.h */
	MRIMAGEDATATYPE        rdb_hdr_image;        /* 1022 - From imagedb.h */
}       IMAGE_HEADER;

typedef struct
{
        RDB_HEADER52_REC         rdb_hdr_rec;          /*0-2047 2048 bytes */
	RDB_PER_PASS_TAB       rdb_hdr_per_pass;     /*  2048-6143 4096 bytes */
	RDB_PER_PASS_TAB       rdb_hdr_unlock_raw;   /*  6144-10239 4096 bytes */
	RDB_DATA_ACQ_TAB       rdb_hdr_data_acq_tab; /*  10240-30719 20480 bytes */
	RDB_NEX_TYPE           rdb_hdr_nex_tab;      /*  30720-32771 2052 bytes */
	RDB_NEX_TYPE           rdb_hdr_nex_abort_tab;/*  32772-34823 2052 bytes */
	TOOLSDATA              rdb_hdr_tool;         /*  34824-36871 2048 toolsdata.h */
	EXAMDATATYPE           rdb_hdr_exam;         /*  36872-37895 1024 imagedb.h */
	SERIESDATATYPE         rdb_hdr_series;       /*  37896-38915 1020 imagedb.h */
	MRIMAGEDATATYPE        rdb_hdr_image;        /*  38916-39937 1022 imagedb.h */
	short                  dummy_filler;         /*  39938-39939   2 sparc align */
}       POOL_HEADER;                                 /* 39940 total */


/*---------------------------------------------------------------------
 |	RDBM header size and offset
 ---------------------------------------------------------------------*/
#define RDB_HDR_OFF				0
#define RDB_HDR_SIZE			sizeof(RDB_HEADER52_REC)

#define RDB_PER_PASS_OFF		RDB_HDR_OFF + RDB_HDR_SIZE
#define RDB_PER_PASS_SIZE		sizeof(RDB_PER_PASS_TAB)

#define RDB_UNLOCK_RAW_OFF		RDB_PER_PASS_OFF + RDB_PER_PASS_SIZE
#define RDB_UNLOCK_RAW_SIZE		sizeof(RDB_PER_PASS_TAB)

#define RDB_DATACQ_OFF			RDB_UNLOCK_RAW_OFF + RDB_UNLOCK_RAW_SIZE
#define RDB_DATAACQ_OFF			RDB_UNLOCK_RAW_OFF + RDB_UNLOCK_RAW_SIZE
#define RDB_DATAACQ_SIZE		sizeof(RDB_DATA_ACQ_TAB)

#define RDB_NEX_OFF				RDB_DATAACQ_OFF + RDB_DATAACQ_SIZE
#define RDB_NEX_SIZE			sizeof(RDB_NEX_TYPE)

#define RDB_NEX_ABORT_OFF		RDB_NEX_OFF + RDB_NEX_SIZE
#define RDB_NEX_ABORT_SIZE		sizeof(RDB_NEX_TYPE)

#define RDB_TOOLSDATA_OFF		RDB_NEX_ABORT_OFF + RDB_NEX_ABORT_SIZE
#define RDB_TOOLSDATA_SIZE		sizeof(TOOLSDATA)

#define RDB_EXAMDATATYPE_OFF	RDB_TOOLSDATA_OFF + RDB_TOOLSDATA_SIZE
#define RDB_EXAMDATATYPE_SIZE	sizeof(EXAMDATATYPE)

#define RDB_SERIESDATATYPE_OFF	RDB_EXAMDATATYPE_OFF + \
								RDB_EXAMDATATYPE_SIZE
#define RDB_SERIESDATATYPE_SIZE	sizeof(SERIESDATATYPE)

#define RDB_MRIMAGEDATATYPE_OFF	RDB_SERIESDATATYPE_OFF + \
								RDB_SERIESDATATYPE_SIZE
#define RDB_MRIMAGEDATATYPE_SIZE	sizeof(MRIMAGEDATATYPE)


#define RDB_HEADER_SIZE_BYTES   sizeof(POOL_HEADER)

#define RDB_NUMB_HDRS      8
#define RDB_ALL_HEADERS_SIZE_BYTES RDB_HEADER_SIZE_BYTES * RDB_NUMB_HDRS

#define RDB_SHARED_SIZE_BYTES   sizeof( RDB_SHARED_BUFF)

/*---------------------------------------------------------------------
 |	RDBM frame index structure for reading NOPROC data.
 ---------------------------------------------------------------------*/
typedef struct _frame_node
{
	struct _frame_node *time_slice_next;
	struct _frame_node *time_echo_next;
	struct _frame_node *time_view_next;
	struct _frame_node *phase_next;
	short   op_code;
	short   index;
}       frame_node;

typedef struct _op_node
{
	long    frame_cnt;
	frame_node *phase_first;
}       op_node;

typedef struct _view_node
{
	frame_node *time_view_first;
	op_node op_ptr[4];
}       view_node;

typedef struct _echo_node
{
	frame_node *time_echo_first;
	view_node *view_ptr;
}       echo_node;

/*---------------------------------------------------------------------
 |	RDBM IO_PACKET structure
 ---------------------------------------------------------------------*/
typedef struct
{
	long    hdr_no;
	long    fd;
	VME_ADDRESS bam_addr;
	VME_ADDRESS ssp_addr;
	VME_ADDRESS uda_addr;
	long    data_len;
	long    run_num;
	long    rawsize;
	long    sspsave;
	long    udasave;
	long    content;
	long    col_type;
	long    npasses;
	long    nslices;
	long    nechoes;
	long    nframes;
	long    nbaseline;
	long    order;
	long    xres;
	long    yres;
	long    point_size;
	long    start_rcv;
	long    stop_rcv;
	long    rcv_no;
	echo_node *echo_ptr;
	frame_node *time_ptr;
}       RDB_IO_PACKET;

/*---------------------------------------------------------------------
 |	RDBM TAPE_PACKET structure.
 ---------------------------------------------------------------------*/
typedef struct
{
	long    fd;
	long    d_type;
	long    offset;
	char   *buffer;
}       RDB_TAPE_PACKET;

/*---------------------------------------------------------------------
 |	RDBM read header codes and other constants
 ---------------------------------------------------------------------*/
#define RDB_HDR_REC_HEADER                    0x0001 
#define RDB_PER_PASS_HEADER                   0x0002 
#define RDB_UNLOCK_RAW_HEADER                 0x0004 
#define RDB_DATA_ACQ_TAB_HEADER               0x0008 
#define RDB_NEX_TAB_HEADER                    0x0010 
#define RDB_NEX_ABORT_TAB_HEADER              0x0020 
#define RDB_TOOLSDATA_HEADER                  0x0040 
#define RDB_EXAM_HEADER                       0x0080 
#define RDB_SERIES_HEADER                     0x0100 
#define RDB_IMAGE_HEADER                      0x0200 
#define RDB_POOL_HEADER                       0x0400 

#define LOCK_SLICE                            1 
#define LOCK_PASS                             2 
#define LOCK_SCAN                             3 

#define RDB_BLOCK                             1 
#define RDB_UNBLOCK                           2 
#define RDB_READONLY                          3 
#define RDB_UNLOCKED                          0
#define RDB_LOCKED                            1

#ifndef TRUE
#define TRUE    1
#endif

#ifndef FALSE
#define FALSE 	0
#endif

/*---------------------------------------------------------------------
 |	RDBM macros
 ---------------------------------------------------------------------*/
#define rdbm_log_error(aMethod) \
{ \
	[theMsgHandler EXCEPTION \
		line	: __LINE__ \
		method	: aMethod \
		ier		: _rdbm_errmes_() \
		args	: _rdbm_err_msg_(), LST_END]; \
}

#define rdbm_nslices(io_pkt)	(io_pkt)->nslices
#define rdbm_npasses(io_pkt)	(io_pkt)->npasses
#define rdbm_nechoes(io_pkt)	(io_pkt)->nechoes
#define rdbm_nframes(io_pkt)	(io_pkt)->nframes
#define rdbm_nbaseline(io_pkt)	(io_pkt)->nbaseline
#define rdbm_content(io_pkt)	(io_pkt)->content
#define rdbm_col_type(io_pkt)	(io_pkt)->col_type
#define rdbm_xres(io_pkt)		(io_pkt)->xres
#define rdbm_yres(io_pkt)		(io_pkt)->yres
#define rdbm_start_rcv(io_pkt)	(io_pkt)->start_rcv
#define rdbm_stop_rcv(io_pkt)	(io_pkt)->stop_rcv
#define rdbm_n_rcv(io_pkt)		(io_pkt)->stop_rcv - (io_pkt)->start_rcv + 1
#define rdbm_raw_pass_size(io_pkt)	(io_pkt)->rawsize

#endif /* RDBM52_INCL */
