/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

This header file depends on XView.  It also appears to not be used anywhere
in NRIA.
****************************************************************************/

#ifndef DISPLAY_ITEMS_H
#define DISPLAY_ITEMS_H

#include <stdio.h>

#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>

  
struct file_toggle_panel_rec
   {
    Panel panel;
    Scrollbar vsb;
    int num_items;
    char **msg;
    int panel_height;
    int max_str_display_len;   /* max str length for each string */
    };
    
struct file_button_panel_rec
   {
    Panel panel;
    Scrollbar vsb;
    int num_items;
    Panel_item *items;
    char **msg;
    int panel_height;
    };
    
struct file_edit_panel_rec
   {
    Panel panel;
    Scrollbar vsb;
    int num_items;
    Panel_item *items;
    char **msg; /* if the msg[i] is preceded by an 'e', the item is editable */
    int panel_height;
    char **value_str; /* initial value strings */
    int max_str_display_len;   /* max str length for each string */
    };

struct file_items_rec
   {
    Frame frame;
    struct file_toggle_panel_rec panel1;
    struct file_button_panel_rec panel2;
    struct file_edit_panel_rec panel3;
   };

struct selected_fn_rec 
    {
    char *root;
    char *dat_fn_dir,*dat_fn_prefix;
    unsigned int num_fns;
    char **fns; 
   };

struct dir_fn_rec
   {
    char temp_dir_fn[256],patt_fn[256],old_patt_fn[256],
         dat_fn_dir[100],dat_fn_prefix[100];
    unsigned int num_dirs,cur_dir;
    unsigned int cur_selected_dir_fns,total_selected_fns;
    struct selected_fn_rec *dir; 
   };

struct select_fns_rec
   {
   struct dir_fn_rec dir;
   struct file_items_rec win;
   int command;
  };

#define MENU_ITEMS_NO_CENTER_FRAME 0
#define MENU_ITEMS_CENTER_FRAME 1

#endif  /* DISPLAY_ITEMS_H */

