/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/


#ifndef MENU_ITEMS_H
#define	MENU_ITEMS_H

#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>
#include <stdio.h>
#include "str_def.h"
#include "error_constants.h"
  
struct file_toggle_panel_rec
   {
    Panel panel;
    Panel_item item;
    Scrollbar vsb;
    int num_items;
    char **msg;
    int panel_height;
    int max_str_display_len; /* max. str length for each string */
    };
    
struct file_button_panel_rec
   {
    Panel panel;
    Scrollbar vsb;
    int num_items;
    Panel_item *items;
    char **msg;
    int panel_height;
    };
    
struct file_edit_panel_rec
   {
    Panel panel;
    Scrollbar vsb;
    int num_items;
    Panel_item *items;
    char **msg; /* if the msg[i] is preceded by an 'e', the item is editable */
    int panel_height;
    char **value_str; /* initial value strings */
    int max_str_display_len; /* max. str length for each string */
    };

struct file_items_rec
   {
    Frame frame;
    char *label;
    struct file_toggle_panel_rec panel1;
    struct file_button_panel_rec panel2;
    struct file_edit_panel_rec panel3;
    Panel_item last_activated_item;
   };

struct fn_rec
   {
    char *dir,*fn;
   };

struct selected_fn_rec
   {
    struct fn_rec hdr_fn;
    struct fn_rec dat_fn;
    unsigned int num_fns;
    char **fns;
   };

struct the_dir_fn_rec
   {
    unsigned char dir_valid;
    struct fn_rec hdr_fn;
    struct fn_rec dat_fn;
    unsigned int num_dirs,last_dir,cur_dir;
    unsigned int cur_selected_dir_fns,total_selected_fns;
    struct selected_fn_rec *dir; 
   };

#define SELECT_FNS_SAVE_SETTINGS 1
struct select_fns_rec
  {unsigned short status;
   struct the_dir_fn_rec dir;
   struct file_items_rec win;
   int (*user_done_proc)();
   void *user_done_proc_arg;
   Panel_item user_item;
   Event user_event;
  };

#define MENU_ITEMS_NO_CENTER_FRAME 0
#define MENU_ITEMS_CENTER_FRAME 1


#endif MENU_ITEMS.H
