/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/


#ifndef RIA_EXTERN_CONSTANTS_H
#define RIA_EXTERN_CONSTANTS_H

extern char *FILE_MENU;
extern char *IMAGE_MENU;
extern char *ROI_MENU;
extern char *PIXEL_TYPE_ANALYSIS_STR;
extern char *GA_STR;
extern char *TA_STR;
extern char *CA_STR;
extern char *PIXEL_TYPE_GA_STR;
extern char *PIXEL_TYPE_TA_STR;
extern char *PIXEL_TYPE_CA_STR;
extern char *PIXEL_TYPE_GROW_REGION_ANALYSIS_STR;
extern char *PIXEL_TYPE_PARTITION_ANALYSIS_STR;
extern char *CA_OPTIONS_STR;

extern char *CHANNEL_MENU;
extern char *SELECT_FNS_MENU;
extern char *IMAGE_CONTRAST; 
extern char *COLOR_PALLETTES; 

extern char *IMAGE_VIEW_FILTER; 
extern char *PIXEL_SELECTION; 
extern char *GROW_REGION; 
extern char *_3D; 
extern char *CURSOR_MODE; 
extern char *MODIFY_IMAGE; 
extern char *PRINT_OR_SAVE_IMAGE; 
extern char *COLOR_EDITOR; 
extern char *WINDOW_MENU; 
extern char *QUIT_AND_SAVE_FILE; 
extern char *EXIT_PROGRAM; 
extern char *HELP_STR; 

extern char *MENU_SEPARATOR; 
extern char *HDR_SUFFIX; 
extern char *DAT_SUFFIX; 
extern char *TXT_SUFFIX; 
extern char *BIN_SUFFIX; 
extern char *NPAR_SUFFIX; 
extern char *NPCO_SUFFIX; 
extern char *PIXMAP_SUFFIX; 
extern char *COUNT_SUFFIX; 
extern char *NO_ROI_STR; 
extern char *NO_PIXEL_TYPE_STR; 
extern char *IMAGE_ANALYSIS_PROGRAM; 
extern char *NO_EDITING; 

extern char *TISSUE_TYPES_DEFINED; 

extern char *BATCH_FILE_MENU; 
extern char *MAIN_MENU_HELP; 
extern char *BEGINNER_HELP; 

extern char *MAIN_MENU_HELP_FN; 
extern char *DISPLAY_MENU_HELP_FN; 
extern char *ANALYSIS_MENU_HELP_FN; 
extern char *GET_DIR_FN_MENU_HELP_FN; 
extern char *BEGINNER_HELP_FN; 
extern char *COLOR_EDITOR_HELP_FN; 
extern char *BATCH_HELP_FN;
extern char *TEXT_FORMAT_HELP_FN;
extern char *PIXEL_SELECTION_HELP_FN;

/* GENERIC WINDOW MENU ITEM STRINGS */
extern char *SLICE_SELECTION_MENU;
extern char *PEN_ENABLED;
extern char *PEN_DISABLED;

extern char *LABEL_ROI_AND_CURVE;


extern char *SHOW_ROI;
extern char *SHOW_PIXEL_TYPE_ROI;
extern char *MORE_ROI_OPTIONS;
extern char *HIGHLIGHT_NEXT_CURVE;
extern char *HIGHLIGHT_NEXT_ROI;
extern char *EDIT_NEXT_NEW_CURVE;
extern char *EDIT_SCRATCH;
extern char *ALL_WINS_CUR_ROI;
extern char *SLICE_RECT;
extern char *DELETE_ROI;

extern char *BREAKER;
extern char *BREAKER_ENABLE;
extern char *BREAKER_LABEL;
extern char *BREAKER_UNDO_LABEL; 
extern char *BREAK_IT;
extern char *BREAK_UNDO;
extern char *CLIPBOARD_LABEL;

extern char *CLIPBOARD;
extern char *CUT;
extern char *CUT_APPEND;
extern char *PASTE;
extern char *COPY;
extern char *COPY_APPEND;
extern char *CLIPBOARD_FIRST;
extern char *CLIPBOARD_LAST;
extern char *PASTE_ALL;

extern char *BKG_PIXELS;
extern char *HISTOGRAM_ROI;
extern char *IMPORT_PIXEL_TYPE_MAP;
extern char *HISTO_CURRENT_SLICE_1D;
extern char *HISTO_ALL_SLICES_1D;
extern char *HISTO_CURRENT_SLICE;
extern char *HISTO_ALL_SLICES;
extern char *HISTO_SHOW;
extern char *HISTO_CLEAR;
extern char *PARTITION_PIXEL_TYPES;
extern char *SEGMENT_PIXEL_TYPES;
extern char *GROW_REGION_OPTIONS;
extern char *EDITED_PIXEL_TYPES;
extern char *PARTITIONED_PIXEL_TYPES;

extern char *ANALYSIS_STR;
extern char *ANALYSIS_CUR_SLICE_STR; 
extern char *FORMAT_TEXT;
extern char *OUTPUT_ANALYSIS;
extern char *SAVE_TEXT_TO_FILE;
extern char *SAVE_THEN_PRINT_TEXT; 
extern char *PRINT_TEXT_TO_WINDOW;
extern char *PRINT_ROIS_AND_PIXEL_TYPES;
extern char *SHOW_ROI_PIXEL_TYPE;
extern char *DONT_SHOW_ROI_PIXEL_TYPE;
extern char *SHOW_ALL_ROIS_PIXEL_TYPE;
extern char *DONT_SHOW_ALL_ROIS_PIXEL_TYPE;
extern char *SHOW_SLICE_PIXEL_TYPE;
extern char *DONT_SHOW_SLICE_PIXEL_TYPE;
extern char *FILTER_SHOW_TISSUES;
extern char *SHOW_TISSUE_WINS;

extern char *SEGMENT_SLICE;

extern char *SAVE_DATA;
extern char *ANALYSIS_MENU_HELP;
extern char *REDEFINE_PIXEL_TYPE_ORDER;
extern char *OUTPUT_BIN;

extern char *SAVE_CUR_WIN_IMAGE;
extern char *PRINT_CURRENT_IMAGE; 
extern char *PRINT_ALL_IMAGES;


extern char *SAVE_DAT_FILE;
extern char *LOAD_FILE_SLICE_ROIS;
extern char *RELOAD_SLICE_ROIS;
extern char *RELOAD_CUR_SLICE_ROIS;
extern char *LOAD_DAT_FILE;
extern char *ENTER_DAT_FN;
extern char *FILE_INFO;
extern char *ENTER_FILE_COMMENT;


extern char *OPTIONS;
extern char *ALL_ECHO_WINS;
extern char *GET_NEW_WINS;
extern char *DUPLICATE_WINDOW;
extern char *SLAVE_WINDOW;
extern char *GET_9_WINS;
extern char *GET_9_WINS_ALL_ECHOES;
extern char *GET_12_WINS;
extern char *GET_12_WINS_ALL_ECHOES;
extern char *STACK_SLICE_OR_SCAN;
extern char *MAGNIFY_PIXEL;
extern char *EXIT_DISPLAY_WINDOW;
extern char *EXIT_MULTIPLE_DISPLAY_WINDOW;
extern char *EXIT_STACK_WINDOWS;

extern char *DISPLAY_MENU_HELP;
extern char *IMAGE_ENHANCEMENT;
extern char *EDGE_DETECTION;
extern char *POLARITY;

/* magnify pixel menu items */
extern char *MAGNIFY_WINDOW;
extern char *MAGNIFY_SHRINK_WINDOW;
extern char *MAGNIFY_LAST_WINDOW;
extern char *MAGNIFY_DEFAULT_WINDOW;


/* GENERIC PEN TYPE MENU ITEM STRINGS */
extern char *PEN_FREE_AND_CLOSED;
extern char *PEN_FREE_AND_CLOSED_LABEL;
extern char *PEN_POLYGON;
extern char *PEN_POLYGON_LABEL;
extern char *PEN_LINE;
extern char *PEN_LINE_LABEL;
extern char *PEN_FREE;
extern char *PEN_FREE_LABEL;
extern char *PEN_POINT_MODE;
extern char *PEN_POINT_MODE_LABEL;

extern char *PEN_CIRCLE;
extern char *PEN_CIRCLE_LABEL;

extern char *PEN_ELLIPSE;
extern char *PEN_ELLIPSE_LABEL;
extern char *PEN_RECT;
extern char *PEN_RECT_LABEL;

/* GENERIC DISPLAY OPTION MENU ITEM STRINGS */
extern char *HIDE_SHOW_ALL_ROIS_OF_CURRENT_SLICE;
extern char *HIDE_ALL_ROIS_OF_CUR_SLICE_BUT_CUR;
extern char *FILL_ROIS;
extern char *DONT_FILL_ROIS;
extern char *DISPLAY_PEN_ENABLED_LABEL;
extern char *DONT_DISPLAY_PEN_ENABLED_LABEL;
extern char *DISPLAY_THE_PIXEL_POSITION;
extern char *DONT_DISPLAY_THE_PIXEL_POSITION;
extern char *OUT_OF_BOUND_ROIS;
extern char *MAKE_ROI_CONVEX;


/* GENERIC DELETE_ROI MENU ITEM STRINGS */
extern char *DELETE_CURRENT_POINT_STR;
extern char *DELETE_CURRENT_CURVE_STR;
extern char *DELETE_CURRENT_ROI_STR;
extern char *DELETE_ALL_ROIS_STR;
extern char *DELETE_ALL_FILE_ROIS_STR;

extern char *_3D_FILE_MENU;
extern char *_3D_IMAGE_OPTIONS;
extern char *_3D_MENU;
extern char *_3D_PLANE_OPTIONS;
extern char *_3D_MORE_PLANE_OPTIONS;
extern char *_3D_CO_REGISTRATION;
extern char *_3D_ROI_TYPE_MENU;
extern char *_3D_ROIS_PIXEL_TYPES;
extern char *_3D_SPLIT_ROIS_MENU;
extern char *_3D_SPLIT_ROIS;
extern char *_3D_DISPLAY_MENU;
extern char *_3D_DISPLAY_OPTIONS;
extern char *_3D_SAVE_MENU;
extern char *_3D_PARAM_MENU;

extern char *_3D_CURSOR_MENU;
extern char *_3D_CUT_MODE;
extern char *_3D_ANGLE_CUT_MODE;
extern char *_3D_ROTATE_VERTICAL_MODE;
extern char *_3D_ROTATE_HORIZONTAL_MODE;
extern char *_3D_ROTATE_MODE;

extern char *_3D_ORIENTATION;
extern char *_3D_0_ROTATION;
extern char *_3D_90_ROTATION;
extern char *_3D_180_ROTATION;
extern char *_3D_270_ROTATION;
extern char *_3D_Y_X_REFLECTION;
extern char *_3D_YX_REFLECTION;
extern char *_3D_NO_REFLECTION;
extern char *_3D_Y_REFLECTION;
extern char *_3D_X_REFLECTION;
extern char *FLIP_PLANE_CLOCKWISE;
extern char *FLIP_PLANE_ANTI_CLOCKWISE;

extern char *_3D_LAST_PLANE;

extern char *_3D_BUTTON_STR;

extern char *ANAL;
extern char *WIN;

extern char *IMAGE_FUSION_MENU;
extern char *OVERLAY_IMAGE;
extern char *OVERLAYED_BY_WID;
extern char *DELETE_OVERLAY;
extern char *CLOSE_WIN;
extern char *CLOSE_STACK_WINS;
extern char *CLOSE_FILE_WINS;
extern char *OPEN_WIN;
extern char *OPEN_STACK_WINS;
extern char *OPEN_FILE_WINS;

extern char *OPERATION_ABORTED;
extern char *PLEASE_WAIT;
extern char *OK;
extern char *MEMORY_ERR;
extern char *GRADIENT;
extern char *GRADIENTX;
extern char *GRADIENTY;
extern char *SEGMENTED;
extern char *EDITED;
extern char *PARTITIONED;
extern char *MARKER;
extern char *EMPTY;

extern char *ALL_SLICES_LABEL;
extern char *ALL_ROIS_LABEL;
extern char *CUR_ROI_LABEL;
extern char *CUR_CURVE_LABEL;

extern char *TRANS_ROI;
extern char *ALL_SLICES_ITEM_LABEL;
extern char *ALL_ROIS_ITEM_LABEL;
extern char *CUR_ROI_ITEM_LABEL;
extern char *CUR_CURVE_ITEM_LABEL;
extern char *SLICE_ROI_PRIOR;
extern char *SLICE_ROI_NEXT;

extern char *CURSOR_DEFAULT_LABEL;
extern char *CURSOR_PEN_LABEL;
extern char *CURSOR_DELETE_ROI_MODE;
extern char *CURSOR_MOVE_ROI_LABEL;
extern char *CURSOR_RESIZE_ROI_LABEL;
extern char *CURSOR_ROTATE_ROI_LABEL;

extern char *PIXEL_TYPES_TO_HISTO_ROIS;
extern char *CUR_SLICE_TYPES_TO_HISTO_ROIS;
extern char *ALL_SLICE_TYPES_TO_HISTO_ROIS;

extern char *CUR_ROI_TO_HISTO_ROI;
extern char *CUR_ROI_TO_HISTO_POINTS;
extern char *CUR_ROI_TO_HISTO_CONVEX_REGION;
extern char *CUR_ROI_TO_HISTO_RANGE_REGION;

extern char *HISTO_ROI_TO_SLICE_ROI;
extern char *WHOLE_SLICE_STR;
extern char *CUR_ROI_STR;
extern char *CUR_CURVE_STR;
extern char *ALL_ROIS_STR;
extern char *VIEW_FILTER_ROI_STR;

extern char *HISTO_ROI;
extern char *SLICE_ROI;


extern char *YES;
extern char *NO;
extern char *WILL_CONTINUE;
extern char *NON_BACKGROUND;
extern char *HISTO_NON_BACKGROUND;

extern char *SLICE_RECT_ROI;

extern char *_3D_PT1_LABEL;
extern char *_3D_PT2_LABEL;
extern char *_3D_PT3_LABEL;

extern char *ROI_INVISIBLE;

extern char *NO_OTHER_FILE_WID;
extern char *SCRATCH_STR;

#endif RIA_EXTERN_CONSTANTS_H
