/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

#ifndef SPM_HDR_H
#define	SPM_HDR_H

struct spm_hdr_key
   {int size;
    char data_type[10];
    char name[18];
    int extents;
    short int session_error;
    char regular;
    char hkey_un0;
   };

struct spm_hdr_dimension
   {
 /* dim[8]-2int */
    unsigned short int num_dims;    
    unsigned short int dimx,dimy;
    unsigned short max_slices;
    unsigned short int num_vols;
    unsigned short int histo_dimx,histo_dimy;
    unsigned short status;

    char vox_units[4],cal_units[8];
    short unused1,datatype;
/*
    unsigned short unused_ints[8];
*/

    short int pixel_depth_bits;    /* bitpix */
    short int dim_un0;   /* unused */

/*    float pixdim[8];*/
    float pixdim_unused1;  
    float xpixel_size,ypixel_size;
    float pixel_thickness;
    float spacing;
    float pixdim_unused2;  
    float pixdim_unused3;  
    float pixdim_unused4;  
/*
    short plane_type;  
    short pulse_sequence;  
    short orientation;     
    short position;        
    short num_echoes;
    short flip_angle;
*/

    float vox_offset;
/* 
    short scan_dimx;
    short scan_dimy;
*/
    float funused1;  /* field_of_view */
    float funused2; /* num_excitations */
    float funused3;    /* tr */

    float cal_max,cal_min;
    long compressed;
/* 
    char te[12];    
*/

    float verified;
 /* unused_floats[1] */

    int glmax,glmin;
   };


struct spm_hdr_history 
    {
     char descrip[80];
     char aux_file[24];
     char orient;
     unsigned short origin[5];
     char generated[10];
     char scannum[10];
     char patient_id[10];
     char exp_date[10];
     char exp_time[10];
     char hist_un0[3];
     long views,vols_added,start_field,field_skip,
          omax,omin,smax,smin;
    };

struct spm_hdr
   {struct spm_hdr_key key;
    struct spm_hdr_dimension dimen;
    char history[200];
   };

#endif SPM_HDR_H
