/****************************************************************************
2d_buf_opr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 2d_buf_opr.c,v 1.10 1999/07/07 18:01:05 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/timeb.h>

#include "common.h"
#include "error_constants.h"
#include "rect.h"
#include "nria_lib.h"

/*
 cc -o 2d_buf_opr 2d_buf_opr.c ptr_and_dim.o
 cc -c 2d_buf_opr.c
*/

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
*/
#define PRT5(x)
#define PRT1(x)
#define TRACE(x)
#define PRT(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT6(x)
#define PRT8(x)
#define PRT10(x)
#define PRT7(x)
#define PRT9(x)



/* Private functions defined in this file */
void get_range_byte_offsets(unsigned long left, unsigned long right, 
    unsigned long pixel_depth, unsigned char *first_and_byte, 
    unsigned long *start, unsigned long *width, unsigned char *last_and_byte);
int Get1dBitMapFirstNon0Posi(unsigned char *buf, unsigned long dim, 
    unsigned long pixel_depth, unsigned long *posi);
int Get1dBitMapLastNon0Posi(unsigned char *buf, unsigned long dim, 
    unsigned long pixel_depth, unsigned long *posi);
extern void init_buf_2d_rec_status(struct buf_2d_rec *_2d);
extern void init_ary_of_buf_2d_rec_data(struct buf_2d_rec **_2ds, 
    unsigned long num_2ds, unsigned long val);
extern unsigned long get_buf_2d_rec_size(struct buf_2d_rec *_2d);
extern int get_buf_2d_rec_bound(struct buf_2d_rec *_2d, unsigned long *left, 
    unsigned long *top, unsigned long *right, unsigned long *bottom);
extern void set_2d_ustart_xy(struct buf_2d_rec *_2d, double ustartx, 
    double ustarty);
extern void set_2d_unit_xy(struct buf_2d_rec *_2d, double unitx, double unity);
extern void set_2d_use_min_max(struct buf_2d_rec *_2d, int use_which);
extern int GetUstartXY(struct buf_2d_rec *_2d, float *ustartx, float *ustarty);
extern int GetUnitXY(struct buf_2d_rec *_2d, float *unitx, float *unity);
extern void Get2dUnitInfo(struct buf_2d_rec *_2d, float *ustartx, 
    float *ustarty, float *unitx, float *unity, unsigned long *dimx, 
    unsigned long *dimy, double def_ustartx, double def_ustarty, 
    double def_unitx, double def_unity, unsigned long def_dimx, 
    unsigned long def_dimy);
extern int SetupNoncontiguosBuf2dRec(struct buf_2d_rec *_2d, 
    unsigned long dimx, unsigned long dimy, unsigned long pixel_depth, 
    unsigned long select);
extern int setup_ptr_buf_2d_rec(struct buf_2d_rec **_2d, unsigned long dimx, 
    unsigned long dimy, unsigned long pixel_depth, int flags);
extern int Check2dToFitResult(struct buf_2d_rec *dest, 
    struct buf_2d_rec *src1, struct buf_2d_rec *src2, long vs1left, 
    long vs1top, long vs1right, long vs1bottom, unsigned long select);
extern int copy_buf_2d_rec_data(struct buf_2d_rec *dest, 
    struct buf_2d_rec *src);
extern int Cp2dByteByBound(struct buf_2d_rec *dest, long dleft, long dtop, 
    long dright, long dbottom, long dx, long dy, struct buf_2d_rec *src, 
    long sleft, long stop, long sright, long sbottom);
extern int Cp2dBitByBound(struct buf_2d_rec *dest, long dleft, long dtop, 
    long dright, long dbottom, long dx, long dy, struct buf_2d_rec *src, 
    long sleft, long stop, long sright, long sbottom);
extern int CpBuf2dRecByBound(struct buf_2d_rec *dest, long dleft, long dtop, 
    long dright, long dbottom, long dx, long dy, struct buf_2d_rec *src, 
    long sleft, long stop, long sright, long sbottom);
extern int DiffBuf2dRec(struct buf_2d_rec *dest, struct buf_2d_rec *src, 
    long left, long right, long top, long bottom);
extern int DiffBuf2dRecVal(struct buf_2d_rec *dest, struct buf_2d_rec *src, 
    long left, long right, long top, long bottom);
extern int cnt_buf_2d_rec_in_bound(struct buf_2d_rec *_2d, long left, 
    long right, long top, long bottom);
extern int is_2d_buf_rec_data_original(struct buf_2d_rec *_2d);
extern int IsDiffBuf2dRec(struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2);
extern int is_same_buf_2d_rec_dimxy(struct buf_2d_rec *_2d1, 
    struct buf_2d_rec *_2d2);
extern int validate_2d_bound(struct buf_2d_rec *_2d, long *left, long *top, 
    long *right, long *bottom);
extern int CntNonValBuf2dRec(struct buf_2d_rec *dest, double val);
extern int CntValBuf2dRec(struct buf_2d_rec *dest, double val);
extern int CntRangeValBuf2dRec(struct buf_2d_rec *dest, double min, 
    double max);
extern double CntTotal2dValues(struct buf_2d_rec *_2d);


/*----------------------------------------------------------------------
init_buf_2d_rec_status - ???
----------------------------------------------------------------------*/

void
init_buf_2d_rec_status(_2d)
 struct buf_2d_rec *_2d;
{
 _2d->status4 = BUF_VERSION_NUM_USED;
 _2d->version_num = BUF_2D_VERSION_NUM;
 _2d->prog_status2 = 0;
}


/*----------------------------------------------------------------------
init_buf_2d_rec - ???
----------------------------------------------------------------------*/

void
init_buf_2d_rec(
    struct buf_2d_rec *_2d)
{
  init_buf_2d_rec_status(_2d);
  _2d->GetVal = NULL;
  _2d->SetVal = NULL;
  _2d->total_bytes = 0;
  _2d->startoffx = _2d->startoffy = 0;

  /*  DRW 961114: Bug fix (?)  did not initialize dimx and dimy, so
   *    free'ing a buf_2d_rec struct would crash (thinking dimx and
   *    dimy were > 0).  */
  _2d->dimx = _2d->dimy = 0;
  return;
}


/*----------------------------------------------------------------------
free_buf_2d_rec - ???
----------------------------------------------------------------------*/

void
free_buf_2d_rec(
    struct buf_2d_rec *_2d)
{
 unsigned long lcv;

 if (_2d->status4 & BUF_NON_EMPTY)
    {
     if (_2d->prog_status2 & BUF_OWN_CONTIGUOUS_MEMORY)
        {TRACE(printf("deallocate BUF_OWN_CONTIGUOUS_MEMORY\n"))
         if (_2d->prog_status2 & BUF_DATA_MMAP)
            munmap_buf_2d_rec(_2d);
         c_free(_2d->buf[0]);
        }
       else if (_2d->prog_status2 & BUF_OWN_NON_CONTIGUOUS_MEMORY)
        for (lcv = 0; lcv < _2d->dimy; lcv++) c_free(_2d->buf[lcv]);
     TRACE(printf("deallocate _2d->buf \n"))
     
     c_free(_2d->buf);
     _2d->status4 = 0;
     _2d->prog_status2 = 0;
    }
 return;
}


/*----------------------------------------------------------------------
InitBuf2dRecData - ???
----------------------------------------------------------------------*/

int
InitBuf2dRecData(_2d,val)
 struct buf_2d_rec *_2d;
 double val;
{
 unsigned long row_bytes,row,col;

 if (!(_2d->status4 & BUF_NON_EMPTY)) return CANCEL;
 PRT8(printf("InitBuf2dRecData val = %f\n",val))
 PRT8(pr_buf_2d_rec(_2d))
 if (val == 0)
    {if (_2d->status4 & BUF_PIXEL_FLOAT_OR_DOUBLE)
        {for (row = 0; row < _2d->dimy; row++)
            for (col = 0; col < _2d->dimx; col++)
               _2d->SetVal(_2d,row,col,(double) .0);
        }
       else if (_2d->prog_status2 & BUF_OWN_CONTIGUOUS_MEMORY)
        {PRT8(printf("InitBuf2dRecData...BUF_OWN_CONTIGUOUS_MEMORY\n"))
         for (col = 0; col < _2d->total_bytes; col++) _2d->buf[0][col] = 0;}
       else 
        {row_bytes = GetRowBytes(_2d->dimx,_2d->pixel_depth);
         for (row = 0; row < _2d->dimy; row++)
            memset(_2d->buf[row],0,(size_t) row_bytes);
        }
    }
   else
    for (row = 0; row < _2d->dimy; row++)
       for (col = 0; col < _2d->dimx; col++)
          _2d->SetVal(_2d,row,col,val);

 _2d->status4 &= BUF_FLUSH_DATA_STATUS;
 return NO_ERROR;
}


/*----------------------------------------------------------------------
init_ary_of_buf_2d_rec_data - ???
----------------------------------------------------------------------*/

void
init_ary_of_buf_2d_rec_data(_2ds,num_2ds,val)
 struct buf_2d_rec **_2ds;
 unsigned long num_2ds;
 unsigned long val;
{
 unsigned long lcv;

 for (lcv = 0; lcv < num_2ds; lcv++)
    InitBuf2dRecData(_2ds[lcv],(double) val);
}


/*----------------------------------------------------------------------
get_buf_2d_rec_size - ???
----------------------------------------------------------------------*/

unsigned long
get_buf_2d_rec_size(_2d)
 struct buf_2d_rec *_2d;
{
 unsigned long size;

 size = sizeof(struct buf_2d_rec);
 if (_2d->status4 & BUF_NON_EMPTY)
    size += _2d->total_bytes;
 TRACE(printf("sizeof(_2d->buf) = %d  size = %d\n",(int) sizeof(_2d->buf),size))

 return size;
}


/*----------------------------------------------------------------------
get_range_byte_offsets - ???
----------------------------------------------------------------------*/

void
get_range_byte_offsets(left,right,pixel_depth,
                       first_and_byte,start,width,last_and_byte)
 unsigned long left,right,pixel_depth,*start,*width;
 unsigned char *first_and_byte,*last_and_byte;
{
 unsigned long temp,temp1,last;

 temp = left * pixel_depth;
 if (temp % 8)
    {*start = temp / 8 + 1;
     *first_and_byte = C_end_bits[(temp % 8)];}
   else
    {*first_and_byte = 0; /* no bits to be and with */
     *start = temp / 8;}

 temp1 = right * pixel_depth;
 if (temp1 % 8 == 7)
    {last = temp1 / 8 + 1;
     *last_and_byte = 0;
    }
   else
    {
     *last_and_byte = C_start_bits[temp1 % 8];
     last = temp1 / 8;
    }
 if (*start > last)
    {*width = 0;
     *last_and_byte = 0;
     *first_and_byte = C_end_bits[(temp % 8)] & C_start_bits[temp1 % 8];
    }
   else *width = last - *start;

}


/*----------------------------------------------------------------------
get_buf_2d_rec_bound - ???
----------------------------------------------------------------------*/

int
get_buf_2d_rec_bound(_2d,left,top,right,bottom)
 struct buf_2d_rec *_2d;
 unsigned long *left,*top,*right,*bottom;
{
 unsigned long row,col;
 
 *top = _2d->dimy;
 *left = _2d->dimx;
 *right = *bottom = 0;
 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col++)
       {if (_2d->GetVal(_2d,row,col) != .0)
           {if (row < *top) *top = row;
            if (row > *bottom) *bottom = row;
            if (col < *left) *left = col;
            if (col > *right) *right = col;
           }
       }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dStartOffsetXY - ???
----------------------------------------------------------------------*/

void
Set2dStartOffsetXY(
    struct buf_2d_rec *_2d,
    long startoffx,
    long startoffy)
{
 _2d->startoffx = startoffx;
 _2d->startoffy = startoffy;
}


/*----------------------------------------------------------------------
set_2d_ustart_xy - ???
----------------------------------------------------------------------*/

void
set_2d_ustart_xy(_2d,ustartx,ustarty)
 struct buf_2d_rec *_2d;
 float ustartx,ustarty;
{
 _2d->ustartx = ustartx;
 _2d->ustarty = ustarty;
 _2d->status4 |= BUF_USTARTXY_VALID;
}


/*----------------------------------------------------------------------
set_2d_unit_xy - ???
----------------------------------------------------------------------*/

void
set_2d_unit_xy(_2d,unitx,unity)
 struct buf_2d_rec *_2d;
 float unitx,unity;
{
 _2d->unitx = unitx;
 _2d->unity = unity;
 _2d->status4 |= BUF_UNITXY_VALID;
}


/*----------------------------------------------------------------------
set_2d_use_min_max - ???
----------------------------------------------------------------------*/

void
set_2d_use_min_max(_2d,use_which)
 struct buf_2d_rec *_2d;
 unsigned short use_which;
{
 _2d->prog_status2 &= USE_MIN_MAX_RESET;
 _2d->prog_status2 |= use_which;
}


/*----------------------------------------------------------------------
GetUstartXY - ???
----------------------------------------------------------------------*/

int
GetUstartXY(_2d,ustartx,ustarty)
 struct buf_2d_rec *_2d;
 float *ustartx,*ustarty;
{
 if (_2d->status4 & BUF_USTARTXY_VALID)
    {*ustartx = _2d->ustartx;
     *ustarty = _2d->ustarty;
     return NO_ERROR;
    }
   else return CANCEL;
}


/*----------------------------------------------------------------------
GetUnitXY - ???
----------------------------------------------------------------------*/

int
GetUnitXY(_2d,unitx,unity)
 struct buf_2d_rec *_2d;
 float *unitx,*unity;
{
 if (_2d->status4 & BUF_UNITXY_VALID)
    {*unitx = _2d->unitx;
     *unity = _2d->unity;
     return NO_ERROR;
    }
   else return CANCEL;
}


/*----------------------------------------------------------------------
Get2dUnitInfo - ???
----------------------------------------------------------------------*/

void
Get2dUnitInfo(_2d,ustartx,ustarty,unitx,unity,dimx,dimy,
              def_ustartx,def_ustarty,def_unitx,def_unity,def_dimx,def_dimy)
 struct buf_2d_rec *_2d;
 float *ustartx,*ustarty,*unitx,*unity,
       def_ustartx,def_ustarty,def_unitx,def_unity;
 unsigned long *dimx,*dimy,def_dimx,def_dimy;
{
 float size;

 if (GetUstartXY(_2d,ustartx,ustarty) != NO_ERROR)
    {*ustartx = def_ustartx;
     *ustarty = def_ustarty;
    }
 if (GetUnitXY(_2d,unitx,unity) != NO_ERROR)
    {*unitx = def_unitx;
     *unity = def_unity;
    }
 size = def_unitx * def_dimx / (*unitx);
 *dimx = (long) floor(size + .5); 
 size = def_unity * def_dimy / *unity;
 *dimy = (long) floor(size + .5); 
 PRT9(printf("*unitx = %f *unity = %f dimx = %d y = %d\n",
        *unitx,*unity,*dimx,*dimy);)
 PRT9(printf("*def_unitx = %f unity = %f def_dimx = %d y = %d\n",
         def_unitx,def_unity,def_dimx,def_dimy);)
}


/*------------------------------------------------------------------
SetupBuf2dRec - ???

 flags & 1 zero out the buffer only if it is new
 if (flags & BUF_VALUE_FLOAT) then data is float
   else if (flags & BUF_VALUE_DOUBLE) then data is double
   else if (flags & BUF_VALUE_SIGNED) then data is signed of pixel_depth
   else data is unsigned of pixel_depth
-------------------------------------------------------------------*/

int 
SetupBuf2dRec(
    struct buf_2d_rec *_2d,
    unsigned long dimx,  /* # of bits used in the x & y dimensions */
    unsigned long dimy,
    unsigned long pixel_depth,
    unsigned long flags)
{
 struct buf_2d_rec _2d1;
 unsigned long total,dimx_bytes,depth;
 unsigned char *ptr;
 int err;

 PRT5(printf("\nSetupBuf2dRec..."))PRT5(pr_buf_2d_rec(_2d))

 if (flags & BUF_PIXEL_SIGNED)
    {if (flags & BUF_VALUE_FLOAT)
        depth = 32;
       else if (flags & BUF_VALUE_DOUBLE)
        depth = 64;
       else depth = pixel_depth;
    }
   else depth = pixel_depth;

 if (_2d->status4 & BUF_NON_EMPTY)
    {if ((_2d->dimx == dimx) && (_2d->dimy == dimy) &&
         (_2d->pixel_depth == depth))
        {_2d->status4 |= flags & BUF_VALUE_TYPE;
         Get2dValProc(_2d,&(_2d->GetVal));
         Set2dValProc(_2d,&(_2d->SetVal));
         PRT7(pr_buf_2d_rec(_2d))
         PRT7(printf("SetupBuf2dRec same size done...\n"))
         return NO_ERROR;}

    }

 dimx_bytes = GetRowBytes(dimx,depth);
 total = dimx_bytes * dimy;

 PRT5(printf("total = %d  dimx = %d  dimy = %d  depth = %d\n",
        total,dimx,dimy,depth));

 init_buf_2d_rec(&_2d1);
 ptr = NULL;
 if (((err = get_ptr(&ptr,NULL,total,(size_t) 1)) != NO_ERROR) ||
     ((err = Setup2dOn1dAry(ptr,dimx,dimy,depth,
               (unsigned long) 0,(unsigned long) 0,dimx - 1,dimy - 1,
               &(_2d1.buf))) != NO_ERROR))
     {c_free(ptr);
      return err;
     }

 _2d1.total_bytes = total;
 _2d1.dimx = dimx;
 _2d1.dimy = dimy;
 _2d1.pixel_depth = depth;
 _2d1.status4 |= BUF_NON_EMPTY | BUF_2D;
 _2d1.prog_status2 |= BUF_OWN_CONTIGUOUS_MEMORY;
 free_buf_2d_rec(_2d);
 *_2d = _2d1;

 if (flags & 1)
    {PRT5(printf("SetupBuf2dRec memset...\n"))
     memset(_2d->buf[0],0,total);
     PRT5(printf("****total = %d...",total);pr_buf_2d_rec(_2d))
    }
 _2d->status4 |= flags & BUF_VALUE_TYPE;
 Get2dValProc(_2d,&(_2d->GetVal));
 Set2dValProc(_2d,&(_2d->SetVal));
 PRT7(pr_buf_2d_rec(_2d))
 PRT7(printf("SetupBuf2dRec done...\n"))
 return err;
}


/*-------------------------------------------------------------
SetupBuf2dRecIfSmall - ???

 flags = 1 zero out the buffer only if it is new
 if (flags & BUF_VALUE_FLOAT) then data is float
   else if (flags & BUF_VALUE_DOUBLE) then data is double
   else if (flags & BUF_VALUE_SIGNED) then data is signed of pixel_depth
   else data is unsigned of pixel_depth
--------------------------------------------------------------*/

int
SetupBuf2dRecIfSmall(
    struct buf_2d_rec *_2d,
    unsigned long dimx,  /* # of bits used in the x & y dimensions */
    unsigned long dimy,
    unsigned long pixel_depth,
    int flags)
{
 unsigned long total,dimx_bytes,depth;
 struct buf_2d_rec _2d1;
 unsigned char *ptr;
 int err,is_init;

 if (flags & BUF_PIXEL_SIGNED)
    {if (flags & BUF_VALUE_FLOAT)
        depth = 32;
       else if (flags & BUF_VALUE_DOUBLE)
        depth = 64;
       else depth = pixel_depth;
    }
   else depth = pixel_depth;
 is_init = 0;
 if ((_2d->status4 & BUF_NON_EMPTY) &&
     (_2d->prog_status2 & BUF_OWN_CONTIGUOUS_MEMORY))
    {PRT10(printf("SetupBuf2dRecIfSmall...1\n"))
     if ((_2d->dimx == dimx) && (_2d->dimy == dimy) &&
         (_2d->pixel_depth == depth)) 
        {_2d->status4 |= flags & BUF_VALUE_TYPE;
         Get2dValProc(_2d,&(_2d->GetVal));
         Set2dValProc(_2d,&(_2d->SetVal));
         PRT7(pr_buf_2d_rec(_2d))
         PRT10(printf("SetupBuf2dRecIfSmall same size done...\n"))
         return NO_ERROR;}
     dimx_bytes = GetRowBytes(dimx,depth);
     total = dimx_bytes * dimy;
     if (_2d->total_bytes < total)
        is_init = 1;
    }
   else
    {dimx_bytes = GetRowBytes(dimx,depth);
     total = dimx_bytes * dimy;
     is_init = 1;}
 PRT10(printf("total = %d  dimx = %d  dimy = %d  depth = %d is_init = %d\n",
        total,dimx,dimy,depth,is_init));
 init_buf_2d_rec(&_2d1);
 if (is_init)
    {ptr = NULL;
     _2d1.buf = NULL;
     if (((err = get_ptr(&ptr,NULL,total,(size_t) 1)) != NO_ERROR) ||
         ((err = Setup2dOn1dAry(ptr,dimx,dimy,depth,
               (unsigned long) 0,(unsigned long) 0,dimx - 1,dimy - 1,
               &(_2d1.buf))) != NO_ERROR))
        {TRACE(printf("error from SetupBuf2dRecIfSmall...total_bytes = %d\n",
                    (int) total))
         c_free(ptr);
         c_free(_2d1.buf);
         return err;
        }
    }
   else 
    {PRT10(printf("Setup2dOn1dAry...\n"))
     _2d1.buf = NULL;
     if ((err = Setup2dOn1dAry(_2d->buf[0],dimx,dimy,depth,
             (unsigned long) 0,(unsigned long) 0,dimx - 1,dimy - 1,
             &(_2d1.buf))) != NO_ERROR)
        {TRACE(printf("error from SetupBuf2dRecIfSmall.1..total_bytes = %d\n",
                    (int) total))
         c_free(_2d1.buf);
         return err;
        }
     _2d->dimx = dimx;
     _2d->dimy = dimy;
     _2d->pixel_depth = depth;
     c_free(_2d->buf);
     _2d->buf = _2d1.buf;
    }
 if (is_init)
    {_2d1.total_bytes = total;
     PRT10(printf("_2d1.total_bytes = %d  tortal = %d is_init = %d\n",
        _2d1.total_bytes,total,is_init))
     _2d1.dimx = dimx;
     _2d1.dimy = dimy;
     _2d1.pixel_depth = depth;
     _2d1.status4 |= BUF_NON_EMPTY | BUF_2D;
     _2d1.prog_status2 |= BUF_OWN_CONTIGUOUS_MEMORY;
     if (_2d->prog_status2 & BUF_DATA_MMAP) _2d1.prog_status2 |= BUF_DATA_MMAP;
     PRT10(printf("_2d->buf = %u\n",_2d->buf))
     free_buf_2d_rec(_2d);
     *_2d = _2d1;}

 if (flags & 1) memset(_2d->buf[0],0,total);
 _2d->status4 |= flags & BUF_VALUE_TYPE;
 Get2dValProc(_2d,&(_2d->GetVal));
 Set2dValProc(_2d,&(_2d->SetVal));
 PRT7(pr_buf_2d_rec(_2d))
 PRT10(printf("SetupBuf2dRecIfSmall done...\n"))
 return err;
}


/*-------------------------------------------------------------------
SetupNoncontiguosBuf2dRec - ???

if select & 1 initialize buf
if select & 2 set up buf areas if they dont exists
if select & 4 deallocate buf areas if they exists

 if (flags & BUF_VALUE_FLOAT) then data is float
   else if (flags & BUF_VALUE_DOUBLE) then data is double
   else if (flags & BUF_VALUE_SIGNED) then data is signed of pixel_depth
   else data is unsigned of pixel_depth
---------------------------------------------------------------------*/

int
SetupNoncontiguosBuf2dRec(_2d,dimx,dimy,pixel_depth,select)
 struct buf_2d_rec *_2d;
 unsigned long dimx,dimy,pixel_depth;
 unsigned long select;
{
 int err,is_init,is_buf_area;
 unsigned long lcv,row_bytes,col,depth;

 PRT6(printf("SetupNoncontiguosBuf2dRec status4 = %x select = %x\n",
          _2d->status4,select))
 if (select & BUF_PIXEL_SIGNED)
    {if (select & BUF_VALUE_FLOAT)
        depth = 32;
       else if (select & BUF_VALUE_DOUBLE)
        depth = 64;
       else depth = pixel_depth;
    }
   else depth = pixel_depth;
 if (_2d->status4 & BUF_NON_EMPTY)
    if ((_2d->prog_status2 & BUF_OWN_CONTIGUOUS_MEMORY) ||
        (_2d->dimx != dimx) || (_2d->dimy != dimy) ||
        (_2d->pixel_depth != depth))       
       free_buf_2d_rec(_2d);
 if (!(_2d->status4 & BUF_NON_EMPTY))
    {if ((err = get_ptr(&(_2d->buf),NULL,dimy,
          sizeof(*(_2d->buf)))) != NO_ERROR)
        return err;
     for (lcv = 0; lcv < _2d->dimy; lcv++)
        _2d->buf[lcv] = NULL;
     PRT6(printf("SetupNoncontiguosBuf2dRec 1\n"))
     init_buf_2d_rec_status(_2d);
     _2d->status4 |= BUF_NON_EMPTY | BUF_2D;
     _2d->prog_status2 |= BUF_OWN_NON_CONTIGUOUS_MEMORY;
     _2d->dimx = dimx;
     _2d->dimy = dimy;
     _2d->pixel_depth = depth;
     row_bytes = GetRowBytes(dimx,depth);
     _2d->total_bytes = row_bytes * dimy;

     if (!(select & 2)) is_buf_area = 0;
       else
        {
         for (is_buf_area = 1,lcv = 0; lcv < _2d->dimy; lcv++)
            if ((err = get_ptr(&(_2d->buf[lcv]),NULL,row_bytes,
                (size_t) 1)) != NO_ERROR)
               {free_buf_2d_rec(_2d);
                return err;}
        }
     is_init = 1;
    }
   else
    {is_init = 0;
     is_buf_area = 1;
     err = NO_ERROR;
     PRT6(printf("SetupNoncontiguosBuf2dRec 2\n"))
    }
 if (!is_init)
    if (select & 4)
       for (is_buf_area = 0,lcv = 0; lcv < _2d->dimy; lcv++)
          if (_2d->buf[lcv] != NULL)
             {c_free(_2d->buf[lcv]);
              _2d->buf[lcv] = NULL;}

 _2d->status4 |= select & BUF_VALUE_TYPE;
 Get2dValProc(_2d,&(_2d->GetVal));
 Set2dValProc(_2d,&(_2d->SetVal));
 PRT7(pr_buf_2d_rec(_2d))
 if (is_buf_area && (select & 1))
    {
     row_bytes = GetRowBytes(_2d->dimx,_2d->pixel_depth);
     for (lcv = 0; lcv < _2d->dimy; lcv++)
       if (_2d->buf[lcv] != NULL)
          {if (_2d->status4 & BUF_PIXEL_FLOAT_OR_DOUBLE)
              for (col = 0; col < _2d->dimx; col++)
                 _2d->SetVal(_2d,lcv,col,(double) .0);
             else memset(_2d->buf[lcv],0,row_bytes);
          }
    }
 PRT7(printf("SetupBuf2dRecIfSmall done...\n"))
 return NO_ERROR;
}


/*----------------------------------------------------------------
setup_ptr_buf_2d_rec - ???

 flags = 1 zero out the buffer only if it is new
-----------------------------------------------------------------*/

int
setup_ptr_buf_2d_rec(_2d,dimx,dimy,pixel_depth,flags)
 struct buf_2d_rec **_2d;
 unsigned long dimx,dimy;  /* # of bits used in the x & y dimensions */
 unsigned long pixel_depth;
 int flags;
{
 int err;

 *_2d = NULL;
 if ((err = get_ptr(_2d,NULL,1,(size_t) sizeof(**_2d))) != NO_ERROR)
    return err;
 init_buf_2d_rec(*_2d);
 return SetupBuf2dRec(*_2d,dimx,dimy,pixel_depth,flags);
}



/*---------------------------------------------------------
DefineDstDepthAndType - ???

select & 1 then dst = src1 + src2
select & 2 then dst = src1 - src2
----------------------------------------------------------*/

int
DefineDstDepthAndType(
    struct buf_2d_rec *src1,
    struct buf_2d_rec *src2,
    unsigned long *depth,
    unsigned long *type4,
    unsigned long select)
{
 if ((src1->status4 & BUF_VALUE_DOUBLE) || (src2->status4 & BUF_VALUE_DOUBLE))
    {*type4 = BUF_VALUE_DOUBLE;
     *depth = 8 * sizeof(double);}
   else if ((src1->status4 & BUF_VALUE_FLOAT) || (src2->status4 & BUF_VALUE_FLOAT))
    {*type4 = BUF_VALUE_FLOAT;
     *depth = 8 * sizeof(float);}
   else
    {if (src1->pixel_depth > src2->pixel_depth) *depth = src1->pixel_depth;
       else *depth = src1->pixel_depth;
     if (select & 3) *depth += 1;
     if ((src1->status4 & BUF_PIXEL_SIGNED) || (src2->status4 & BUF_PIXEL_SIGNED))
        {if (select & 3) *depth += 1;
         *type4 = BUF_VALUE_SIGNED;}
       else *type4 = 0;
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
SetupSameDimxyDst2d - ???

select & 1 then dst = src1 + src2
select & 2 then dst = src1 - src2
------------------------------------------------------------------------*/

int
SetupSameDimxyDst2d(
    struct buf_2d_rec *dst,
    struct buf_2d_rec *src1,
    struct buf_2d_rec *src2,
    unsigned long select)
{
 unsigned long depth,type4; 
 int err;

 if ((src1->dimx != src2->dimx) || (src1->dimy != src2->dimy))
    return CANCEL;
 DefineDstDepthAndType(src1,src2,&depth,&type4,select);
 if (!(dst->status4 & BUF_NON_EMPTY) || (dst->pixel_depth != depth) ||
      (dst->dimx != src1->dimx) || (dst->dimy != src1->dimy))
    {if ((dst == src1) || (dst == src2)) return CANCEL;
     if ((err = SetupBuf2dRec(dst,src1->dimx,src1->dimy,
             depth,type4)) != NO_ERROR)
        return err;
    }
   else Set2dValueType(dst,type4);
 return NO_ERROR;
}



/*----------------------------------------------------------------------
Check2dToFitResult - ???
----------------------------------------------------------------------*/

int
Check2dToFitResult(dest,src1,src2,vs1left,vs1top,vs1right,vs1bottom,select)
 struct buf_2d_rec *dest,*src1,*src2;
 long vs1left,vs1top,vs1right,vs1bottom;
 unsigned long select;
{
 unsigned long depth,type4,dimx,dimy; 
 int err;

 DefineDstDepthAndType(src1,src2,&depth,&type4,select);
 if (!(dest->status4 & BUF_NON_EMPTY) || (dest->pixel_depth != depth) ||
      (dest->buf != src1->buf))
    {dimx = vs1right - vs1left + 1;
     dimy = vs1bottom - vs1top + 1;
     if (!(dest->status4 & BUF_NON_EMPTY) || (dest->pixel_depth != depth) ||
         (dest->pixel_depth < src1->pixel_depth) ||
         (dest->pixel_depth < src2->pixel_depth) ||
          (dest->dimx < dimx) || (dest->dimy < dimy))
        {if (dest->buf == src2->buf) return CANCEL;
         if ((err = SetupBuf2dRec(dest,dimx,dimy,depth,type4)) != NO_ERROR) 
            return err;
         Set2dStartOffsetXY(dest,vs1left,vs1top);}
       else
        {Set2dValueType(dest,type4);
         if ((dest->dimx < src1->dimx) || (dest->dimy < src1->dimy))
             Set2dStartOffsetXY(dest,vs1left,vs1top);
        }
    }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
copy_buf_2d_rec_hdr_only - ???
----------------------------------------------------------------------*/

int
copy_buf_2d_rec_hdr_only(dst,src)
 struct buf_2d_rec *dst,*src;
{
 unsigned long status4;
 unsigned short prog_status2;
 unsigned char **ptr;

 if( (dst == NULL) || (src == NULL)) return CANCEL;
 status4 = dst->status4;
 prog_status2 = dst->prog_status2;
 ptr = dst->buf;
 memcpy(dst,src,(size_t) sizeof(struct buf_2d_rec));
 dst->buf = ptr;
 dst->status4 |= status4;
 dst->prog_status2 |= prog_status2;

 return NO_ERROR;
}


/*----------------------------------------------------------------------
copy_buf_2d_rec - ???
----------------------------------------------------------------------*/

int
copy_buf_2d_rec(dst,src)
 struct buf_2d_rec *dst,*src;
{
 int err;
 unsigned long lcv,row_bytes;
 unsigned char **ptr;

 if ((err = SetupBuf2dRec(dst,src->dimx,src->dimy,
         src->pixel_depth,src->status4 & BUF_VALUE_TYPE))
          != NO_ERROR) 
    return err;
 ptr = dst->buf;
 memcpy(dst,src,(size_t) sizeof(struct buf_2d_rec));
 dst->buf = ptr;

 row_bytes = GetRowBytes(dst->dimx,dst->pixel_depth);
 for (lcv = 0; lcv < dst->dimy; lcv++)
    memcpy(dst->buf[lcv],src->buf[lcv],(size_t) row_bytes);
/*
 dst->status4 &= BUF_FLUSH_MEMORY_STATUS;
 dst->status4 |= BUF_DATA_VALID;
*/

 return NO_ERROR;
}


/*----------------------------------------------------------------------
copy_buf_2d_rec_data - ???
----------------------------------------------------------------------*/

int
copy_buf_2d_rec_data(dest,src)
 struct buf_2d_rec *dest,*src;
{
 unsigned long lcv,total_bytes,row_bytes;

 if (!(dest->status4 & BUF_NON_EMPTY) ||
     !(src->status4 & BUF_NON_EMPTY)) return ~NO_ERROR;
 if ((dest->dimy == src->dimy) && (dest->dimx == src->dimx) &&
     (dest->pixel_depth == src->pixel_depth) &&
     ((dest->status4 & BUF_VALUE_TYPE) == (src->status4 & BUF_VALUE_TYPE)))
    {row_bytes = GetRowBytes(dest->dimx,dest->pixel_depth);
     if ((dest->prog_status2 & BUF_OWN_NON_CONTIGUOUS_MEMORY) ||
         (src->prog_status2 & BUF_OWN_NON_CONTIGUOUS_MEMORY))
        {
         for (lcv = 0; lcv < dest->dimy; lcv++)
            memcpy(dest->buf[lcv],src->buf[lcv],(size_t) row_bytes);
        }
       else
        {total_bytes = row_bytes * dest->dimy;
         memcpy(dest->buf[0],src->buf[0],total_bytes);
        }
     return NO_ERROR;
    }
   else
    return CpBuf2dRecByBound(dest,0,0,dest->dimx - 1,dest->dimy - 1,0,0,
                src,0,0,src->dimx - 1,src->dimy - 1);

}


/*----------------------------------------------------------------------
copy_buf_2d_rec_content - ???
----------------------------------------------------------------------*/

int
copy_buf_2d_rec_content(dst,src)
 struct buf_2d_rec *dst,*src;
{
 unsigned long lcv,row_bytes;
 unsigned char **ptr;

 if (!(dst->status4 & BUF_NON_EMPTY) ||
     (dst->prog_status2 & BUF_OWN_NON_CONTIGUOUS_MEMORY) ||
     (dst->total_bytes != src->total_bytes) ||
     ((dst->status4 & BUF_VALUE_TYPE) != (src->status4 & BUF_VALUE_TYPE)))
    return copy_buf_2d_rec(dst,src);
   else
    {ptr = dst->buf;
     memcpy(dst,src,(size_t) sizeof(struct buf_2d_rec));
     dst->buf = ptr;
     row_bytes = GetRowBytes(dst->dimx,dst->pixel_depth);
     if (((row_bytes * dst->dimy) == dst->total_bytes) &&
         (src->prog_status2 & BUF_OWN_CONTIGUOUS_MEMORY))
        memcpy(dst->buf[0],src->buf[0],
                       (size_t) src->total_bytes);
       else
        {
         for (lcv = 0; lcv < dst->dimy; lcv++)
            memcpy(dst->buf[lcv],src->buf[lcv],(size_t) row_bytes);
        }
    dst->status4 |= BUF_DATA_VALID;
    return NO_ERROR;
   }
}


/*----------------------------------------------------------------------
CopyToNonContiguos2d - ???
----------------------------------------------------------------------*/

int
CopyToNonContiguos2d(result,src)
 struct buf_2d_rec *result,*src;
{
 unsigned long lcv,row_bytes;
 int err;

 if ((err = SetupNoncontiguosBuf2dRec(result,
         src->dimx,src->dimy,src->pixel_depth,2)) != NO_ERROR)
    return err;
 copy_buf_2d_rec_hdr_only(result,src);
 result->prog_status2 &= ~BUF_AREA_STATUS;
 result->prog_status2 |= BUF_OWN_NON_CONTIGUOUS_MEMORY;
 row_bytes = GetRowBytes(src->dimx,src->pixel_depth);
 for (lcv = 0; lcv < result->dimy; lcv++)
    memcpy(result->buf[lcv],src->buf[lcv],row_bytes);
 return NO_ERROR;
}


/*------------------------------------------------------------
Cp2dByBound - ???

  option == 0 then copy all
         == 1 then copy if in range
         == 2 then copy if not in range
         == 3 then copy if pixel <= min
------------------------------------------------------------*/

int
Cp2dByBound(
    struct buf_2d_rec *dest,
    long dleft,
    long dtop,
    long dright,
    long dbottom,
    long dx,
    long dy,
    struct buf_2d_rec *src,
    long sleft,
    long stop,
    long sright,
    long sbottom,
    int option,
    double min,
    double max,
    int is_unselected_to_0)
{
 long row,col,x;
 double val;
 int err;
 long vs1left,vs1top,vs1right,vs1bottom,vs2left,vs2top,vs2right,vs2bottom;

 PRT9(printf("Cp2dByBound...option = %d\n",option))
 PRT9(printf("Cp2dByBound...\n");
     printf("dest...\n");
     pr_buf_2d_rec(dest);
     printf("src...\n");
     pr_buf_2d_rec(src);
    )
 if ((err = ValidDstAndSrcBound(dleft,dtop,dright,dbottom,dx,dy,
          sleft,stop,sright,sbottom,
          &vs1left,&vs1top,&vs1right,&vs1bottom,
          &vs2left,&vs2top,&vs2right,&vs2bottom)) != NO_ERROR)
    return NO_ERROR;
 PRT9(printf("dl = %d dt = %d dr = %d db = %d dx = %d dy = %d\n",
     dleft,dtop,dright,dbottom,dx,dy))
 PRT9(printf("sl = %d st = %d sr = %d sb = %d\n",
     sleft,stop,sright,sbottom))

 PRT7(printf("Cp2dByBound...option = %d min = %f max = %f = %d\n",option,min,max,
     is_unselected_to_0))
 if (option == 0)
    {for (row = vs2top; row <= vs2bottom; row++,vs1top++)
        for (x = vs1left,col = vs2left; col <= vs2right; col++,x++)
           {val = src->GetVal(src,row,col);
            dest->SetVal(dest,vs1top,x,val);
           }
    }
   else if (option == 1)
    {for (row = vs2top; row <= vs2bottom; row++,vs1top++)
        for (x = vs1left,col = vs2left; col <= vs2right; col++,x++)
           {val = src->GetVal(src,row,col);
            if ((val >= min) && (val <= max))
               dest->SetVal(dest,vs1top,x,val);
              else if (is_unselected_to_0)
               dest->SetVal(dest,vs1top,x,(double) .0);
           }
    }
   else if (option == 2)
    {for (row = vs2top; row <= vs2bottom; row++,vs1top++)
        for (x = vs1left,col = vs2left; col <= vs2right; col++,x++)
           {val = src->GetVal(src,row,col);
            if ((val < min) && (val > max))
               dest->SetVal(dest,vs1top,x,val);
              else if (is_unselected_to_0)
               dest->SetVal(dest,vs1top,x,(double) .0);
           }
    }
   else if (option == 3)
    {PRT9(printf("Cp2dByBound min = %f  vs2 l = %d t = %d r = %d b = %d\n",min,vs2left,vs2top,vs2right,vs2bottom))
     PRT9(printf("vs1 l = %d t = %d r = %d b = %d\n",vs1left,vs1top,vs1right,vs1bottom))
     for (row = vs2top; row <= vs2bottom; row++,vs1top++)
        for (x = vs1left,col = vs2left; col <= vs2right; col++,x++)
           {
            if ((val = src->GetVal(src,row,col)) >= min)
               dest->SetVal(dest,vs1top,x,val);
              else if (is_unselected_to_0)
               dest->SetVal(dest,vs1top,x,(double) .0);
           }
    }
   else if (option == 4)
    {PRT9(printf("Cp2dByBound min = %f  vs2 l = %d t = %d r = %d b = %d\n",min,vs2left,vs2top,vs2right,vs2bottom))
     PRT9(printf("vs1 l = %d t = %d r = %d b = %d\n",vs1left,vs1top,vs1right,vs1bottom))
     for (row = vs2top; row <= vs2bottom; row++,vs1top++)
        for (x = vs1left,col = vs2left; col <= vs2right; col++,x++)
           {
            if ((val = src->GetVal(src,row,col)) > min)
               dest->SetVal(dest,vs1top,x,val);
              else if (is_unselected_to_0)
               dest->SetVal(dest,vs1top,x,(double) .0);
           }
    }
 PRT9(printf("Cp2dByBound.4..end...\n"))
 dest->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Cp2dByteByBound - ???
----------------------------------------------------------------------*/

int
Cp2dByteByBound(dest,dleft,dtop,dright,dbottom,dx,dy,
                       src,sleft,stop,sright,sbottom)
 struct buf_2d_rec *dest,*src;
 long dleft,dtop,dright,dbottom,dx,dy,sleft,stop,sright,sbottom;
{
 long bytes;
 long vs1left,vs1top,vs1right,vs1bottom,vs2left,vs2top,vs2right,vs2bottom;
 int err;

 PRT3(printf("\nCp2dByteByBound...\n");)
 PRT3(printf("Cp2dByteByBound...\n");
     printf("dest...\n");
     pr_buf_2d_rec(dest);
     printf("src...\n");
     pr_buf_2d_rec(src);
    )
 if (dest->pixel_depth != src->pixel_depth) return CANCEL;
 if ((err = ValidDstAndSrcBound(dleft,dtop,dright,dbottom,dx,dy,
          sleft,stop,sright,sbottom,
          &vs1left,&vs1top,&vs1right,&vs1bottom,
          &vs2left,&vs2top,&vs2right,&vs2bottom)) != NO_ERROR)
    return NO_ERROR;
 if ((vs1left * dest->pixel_depth) % 8) return CANCEL;
 if ((vs2left * dest->pixel_depth) % 8) return CANCEL;
 if ((vs1right * dest->pixel_depth) % 8) return CANCEL;
 vs1left = (vs1left * dest->pixel_depth) / 8;
 vs1right = (vs1right * dest->pixel_depth) / 8;
 vs2left = (vs2left * dest->pixel_depth) / 8;
 bytes = vs1right - vs1left + 1;

 PRT3(printf(" vs1top = %d  vs1bottom = %d  vs2top = %d  vs2bottom = %d\n",vs1top,
      vs1bottom,vs2top,vs2bottom))
 PRT3(printf(" vs1left = %d  vs2left = %d  bytes = %d\n",vs1left,
      vs2left,bytes))

 for (; (vs1top <= vs1bottom) && (vs2top <= vs2bottom); vs1top++,vs2top++)
    memcpy(&(dest->buf[vs1top][vs1left]),&(src->buf[vs2top][vs2left]),bytes);
 dest->status4 |= BUF_DATA_VALID;
 PRT3(printf("Cp2dByteByBound...end\n"))

 return NO_ERROR;
}


/*--------------------------------------------------------------------
Cp2dBitByBound - ???

 dest & src are aligned on the global coordinate...
--------------------------------------------------------------------*/

int
Cp2dBitByBound(dest,dleft,dtop,dright,dbottom,dx,dy,
                      src,sleft,stop,sright,sbottom)
 struct buf_2d_rec *dest,*src;
 long dleft,dtop,dright,dbottom,dx,dy,sleft,stop,sright,sbottom;
{
 long right1,width;
 int err;
 long vs1left,vs1top,vs1right,vs1bottom,vs2left,vs2top,vs2right,vs2bottom;

 PRT7(printf("Cp2dBitByBound...\n"))
 PRT(printf("dest...\n"))
 PRT(pr_buf_2d_rec(dest))
 PRT(printf("src...\n"))
 PRT(pr_buf_2d_rec(src))
 if ((err = ValidDstAndSrcBound(dleft,dtop,dright,dbottom,dx,dy,
          sleft,stop,sright,sbottom,
          &vs1left,&vs1top,&vs1right,&vs1bottom,
          &vs2left,&vs2top,&vs2right,&vs2bottom)) != NO_ERROR)
    return NO_ERROR;

 if (((vs1left % 8) != 0) || ((vs2left % 8) != 0) ||
     ((vs1right - vs1left) < 8) || 
     (vs1left != vs2left) || (vs1right != vs2right))
    {
     TRACE(printf("cp_by bound...l = %d  t = %d r = %d  b = %d\n",
         left,top,right,bottom))
     Cp2dByBound(dest,dleft,dtop,dright,dbottom,dx,dy,
          src,sleft,stop,sright,sbottom,0,(double) .0,(double) .0,0);
     return NO_ERROR;
    }
 width = (vs1right - vs1left + 1) / 8;
 width *= 8;
 right1 = vs1left + width;
 if ((err = Cp2dByteByBound(dest,vs1left,vs1top,right1,vs1bottom,vs1left,vs1top,
          src,vs2left,vs2top,vs2left + width - 1,vs2bottom)) != NO_ERROR)
    return err;
 vs1left = vs1left + width;
 vs2left = vs2left + width;
 if (vs1left > vs1right) return NO_ERROR;
 err = Cp2dByBound(dest,vs1left,vs1top,vs1right,vs1bottom,vs1left,vs1top,
          src,vs2left,vs2top,vs2right,vs2bottom,0,(double) .0,(double) .0,0);
 PRT7(printf("Cp2dBitByBound...err = %d end\n",err))
 return err;
}


/*----------------------------------------------------------------------
CpBuf2dRecByBound - ???
----------------------------------------------------------------------*/

int
CpBuf2dRecByBound(dest,dleft,dtop,dright,dbottom,dx,dy,
                         src,sleft,stop,sright,sbottom)
 struct buf_2d_rec *dest,*src;
 long dleft,dtop,dright,dbottom,dx,dy,sleft,stop,sright,sbottom;
{
 PRT7(printf("CpBuf2dRecByBound...\n"))
 if ((dest->pixel_depth == src->pixel_depth) && ((dest->pixel_depth % 8) == 0))
    return Cp2dByteByBound(dest,dleft,dtop,dright,dbottom,dx,dy,
                   src,sleft,stop,sright,sbottom);
   else if ((dest->pixel_depth == src->pixel_depth) && (dest->pixel_depth == 1))
    return Cp2dBitByBound(dest,dleft,dtop,dright,dbottom,dx,dy,
                   src,sleft,stop,sright,sbottom);
   else
    return Cp2dByBound(dest,dleft,dtop,dright,dbottom,dx,dy,
                   src,sleft,stop,sright,sbottom,0,(double) .0,(double) .0,0);
}



/*----------------------------------------------------------------------
DiffBuf2dRec - ???
----------------------------------------------------------------------*/

int
DiffBuf2dRec(dest,src,left,right,top,bottom)
 struct buf_2d_rec *dest,*src;
 long left,right,top,bottom;
{
 long row,col,x,y;
 double val;

 y = src->startoffy + top - dest->startoffy;
 for (row = top; row <= bottom; row++,y++)
    {
     if ((y >= 0) && (y < dest->dimy))
        {x = src->startoffx + left - dest->startoffx;
         for (col = left; col <= right; col++,x++)
           {
            if ((x >= 0) && (x < dest->dimx))
               {if (val = src->GetVal(src,row,col))
                   if (dest->GetVal(dest,y,x) == .0)
                      {printf("diff row = %ld col = %ld  y = %ld x = %ld\n",
                               row,col,y,x);}
               }
              else break;
           }
        }
    }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
DiffBuf2dRecVal - ???
----------------------------------------------------------------------*/

int
DiffBuf2dRecVal(dest,src,left,right,top,bottom)
 struct buf_2d_rec *dest,*src;
 long left,right,top,bottom;
{
 long row,col,x,y;
 double val;

 y = src->startoffy + top - dest->startoffy;
 for (row = top; row <= bottom; row++,y++)
    {
     if ((y >= 0) && (y < dest->dimy))
        {x = src->startoffx + left - dest->startoffx;
         for (col = left; col <= right; col++,x++)
           {
            if ((x >= 0) && (x < dest->dimx))
               {if (val = src->GetVal(src,row,col))
                   if (dest->GetVal(dest,y,x) != val)
                      {printf("diff row = %ld col = %ld  y = %ld x = %ld\n",
                               row,col,y,x);}
               }
              else break;
           }
        }
    }
 return NO_ERROR;
}


/*---------------------------------------------------------------------
cnt_buf_2d_rec_in_bound - ???

 conditions :-
 -------------
 1) row height_cnt_ary->buf[0] has the occurrences (height of) for all cols.
 2) value is the value to be assigned.
------------------------------------------------------------------------*/

int
cnt_buf_2d_rec_in_bound(_2d,left,right,top,bottom)
 struct buf_2d_rec *_2d;
 long left,right,top,bottom;
{
 unsigned long row,col,cnt;

 for (cnt = 0,row = top; row <= bottom; row++)
    {
     for (col = left; col <= right; col++)
        if (_2d->GetVal(_2d,row,col,_2d->pixel_depth))
           cnt += 1;
    }
 return cnt;
}


/*----------------------------------------------------------------------
is_2d_buf_rec_data_original - ???
----------------------------------------------------------------------*/

int
is_2d_buf_rec_data_original(_2d)
 struct buf_2d_rec *_2d;
{
 if (_2d->status4 & BUF_DATA_GRADIENT) return 0;
   else if (_2d->status4 & BUF_MIN_MAX_SET)
           {if ((_2d->minval == _2d->minval_set) &&
                (_2d->maxval == _2d->maxval_set)) return 1;
              else return 0;}
   else return 1;
}


/*----------------------------------------------------------------------
IsDiffBuf2dRec - ???
----------------------------------------------------------------------*/

int
IsDiffBuf2dRec(_2d1,_2d2)
 struct buf_2d_rec *_2d1,*_2d2;
{
 unsigned long row,col,row_bytes;

 if (!is_same_buf_2d_rec_data_size(_2d1,_2d2)) return 1;

 row_bytes = GetRowBytes(_2d1->dimx,_2d1->pixel_depth);

 for (row = 0; row < _2d1->dimy; row++)
    for (col = 0; col < row_bytes; col++)
       if (_2d1->buf[row][col] != _2d2->buf[row][col]) return 1;

 return 0;
}


/*----------------------------------------------------------------------
is_same_buf_2d_rec_data_size - ???
----------------------------------------------------------------------*/

int
is_same_buf_2d_rec_data_size(
    struct buf_2d_rec *_2d1,
    struct buf_2d_rec *_2d2)
{
 if ((_2d1->status4 & BUF_NON_EMPTY) &&
     (_2d2->status4 & BUF_NON_EMPTY) &&
     (_2d1->dimx == _2d2->dimx) &&
     (_2d1->dimy == _2d2->dimy) &&
     (_2d1->pixel_depth == _2d2->pixel_depth))
    return 1;
 else return 0;
}


/*----------------------------------------------------------------------
is_same_buf_2d_rec_dimxy - ???
----------------------------------------------------------------------*/

int
is_same_buf_2d_rec_dimxy(_2d1,_2d2)
 struct buf_2d_rec *_2d1,*_2d2;
{
 if ((_2d1->status4 & BUF_NON_EMPTY) &&
     (_2d2->status4 & BUF_NON_EMPTY) &&
     (_2d1->dimx == _2d2->dimx) &&
     (_2d1->dimy == _2d2->dimy))
    return 1;
   else return 0;
}


/*----------------------------------------------------------------------
Get1dBitMapFirstNon0Posi - ???
----------------------------------------------------------------------*/

int
Get1dBitMapFirstNon0Posi(buf,dim,pixel_depth,posi)
 unsigned char *buf;
 unsigned long dim,pixel_depth,*posi;
{
 unsigned long row_bytes,col,bit,indx;

 *posi = 0;
 row_bytes = GetRowBytes(dim,pixel_depth);
 for (col = 0; col < row_bytes; col++)
    if (buf[col])
       {for (bit = col * 8,indx = 0; indx < 8; indx++)
           {if (buf[col] & C_which_bit[indx])
               {*posi = bit;
                return NO_ERROR;}
            bit++;
            if (bit >= dim) return ~NO_ERROR;
           }
       }
              
 return ~NO_ERROR;
}


/*----------------------------------------------------------------------
Get1dBitMapLastNon0Posi - ???
----------------------------------------------------------------------*/

int
Get1dBitMapLastNon0Posi(buf,dim,pixel_depth,posi)
 unsigned char *buf;
 unsigned long dim,pixel_depth,*posi;
{
 unsigned long row_bytes,bit;
 int col,indx;

 *posi = 0;
 row_bytes = GetRowBytes(dim,pixel_depth);
 if (row_bytes == 0) return ~NO_ERROR;
 for (col = row_bytes - 1; col >= 0 ; col--)
    if (buf[col])
       {bit = (col + 1) * 8 - 1;
        if (bit >= dim)
           {indx = 7 - bit + dim - 1;
            bit = dim - 1;
           }
          else indx = 7;
        for (; indx >= 0; indx--)
           {if (buf[col] & C_which_bit[indx])
               {*posi = bit;
                return NO_ERROR;}
            bit--;
           }
       }
              
 return ~NO_ERROR;
}


/*----------------------------------------------------------------------
validate_2d_bound - ???
----------------------------------------------------------------------*/

int
validate_2d_bound(_2d,left,top,right,bottom)
 struct buf_2d_rec *_2d;
 long *left,*top,*right,*bottom;
{
 if ((_2d->dimx == 0) || (_2d->dimy == 0)) return CANCEL;
 if (*left < 0) *left = 0;
   else if (*left >= _2d->dimx) return CANCEL;
 if (*top < 0) *top = 0;
   else if (*top >= _2d->dimy) return CANCEL;
 if (*right >= _2d->dimx) *right = _2d->dimx - 1;
 if (*bottom >= _2d->dimy) *bottom = _2d->dimy - 1;
 return NO_ERROR;
}


/*----------------------------------------------------------------------
CntNonValBuf2dRec - ???
----------------------------------------------------------------------*/

int
CntNonValBuf2dRec(dest,val)
 struct buf_2d_rec *dest;
 double val;
{
 unsigned long row,col,cnt;

 if (!(dest->status4 & BUF_NON_EMPTY)) return 0;
 for (cnt = 0,row = 0; row < dest->dimy; row++)
    for (col = 0; col < dest->dimx; col++)
       {if (dest->GetVal(dest,row,col) != val)
           cnt += 1;}
 return cnt;

}


/*----------------------------------------------------------------------
CntValBuf2dRec - ???
----------------------------------------------------------------------*/

int
CntValBuf2dRec(dest,val)
 struct buf_2d_rec *dest;
 double val;
{
 unsigned long row,col,cnt;

 if (!(dest->status4 & BUF_NON_EMPTY)) return 0;
 for (cnt = 0,row = 0; row < dest->dimy; row++)
    for (col = 0; col < dest->dimx; col++)
       {if (dest->GetVal(dest,row,col) == val)
           cnt += 1;}
 return cnt;

}


/*----------------------------------------------------------------------
CntRangeValBuf2dRec - ???
----------------------------------------------------------------------*/

int
CntRangeValBuf2dRec(dest,min,max)
 struct buf_2d_rec *dest;
 double min,max;
{
 unsigned long row,col,cnt;
 double val1;

 if (!(dest->status4 & BUF_NON_EMPTY)) return 0;
 for (cnt = 0,row = 0; row < dest->dimy; row++)
    for (col = 0; col < dest->dimx; col++)
       {val1 = dest->GetVal(dest,row,col);
        if ((val1 >= min) && (val1 <= max))
           cnt += 1;
       }
 return cnt;

}


/*----------------------------------------------------------------------
CntTotal2dValues - ???
----------------------------------------------------------------------*/

double 
CntTotal2dValues(_2d)
 struct buf_2d_rec *_2d;
{
 unsigned long row,col;
 double cnt;

 for (cnt = .0,row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col++)
       cnt += _2d->GetVal(_2d,row,col);
 return cnt;
}



/*----------------------------------------------------------------------
ValidDstAndSrcBound - ???
----------------------------------------------------------------------*/

int 
ValidDstAndSrcBound(
    long dleft,
    long dtop,
    long dright,
    long dbottom,
    long dx,
    long dy,
    long sleft,
    long stop,
    long sright,
    long sbottom,
    long *vdleft,
    long *vdtop,
    long *vdright,
    long *vdbottom,
    long *vsleft,
    long *vstop,
    long *vsright,
    long *vsbottom)
{
 long right,bottom,width,height,diff;

 PRT3(printf("ValidDstAndSrcBound...\n");
     printf("dst l = %d t = %d r = %d b = %d dx = %d dy = %d\n",
      dleft,dtop,dright,dbottom,dx,dy);
     printf("src l = %d t = %d r = %d b = %d\n",
      sleft,stop,sright,sbottom);
     )
 width = sright - sleft + 1;
 height = sbottom - stop + 1;
 right = dx + width - 1;
 bottom = dy + height - 1;
 if ((right < dleft) ||  (bottom < dtop) || (dx > right) || (dy > bottom) ||
     (dx > dright) || (dy > dbottom))
    return CANCEL;
 if (dx < dleft)
    {diff = dleft - dx;
     *vsleft = sleft + diff;
     width -= diff;
     if (width == 0) return CANCEL;
     dx = dleft;
    }
   else *vsleft = sleft;
 if (dy < dtop)
    {diff = dtop - dy;
     *vstop = stop + diff;
     height -= diff;
     if (height == 0) return CANCEL;
     dy = dtop;
    }
   else *vstop = stop;

 if (right > dright)
    {width = width - (right - dright);
     if (width == 0) return CANCEL;
     right = dright;}
 if (bottom > dbottom)
    {height = height - (bottom - dbottom);
     if (height == 0) return CANCEL;
     bottom = dbottom;}
 *vdleft = dx;
 *vdtop = dy;
 *vdright = right;
 *vdbottom = bottom;

 *vsright = *vsleft + width - 1;
 *vsbottom = *vstop + height - 1;

 PRT3(
     printf("final dst vl = %d vt = %d vr = %d vb = %d\n",
            *vdleft,*vdtop,*vdright,*vdbottom);
     printf("src vl = %d vt = %d vr = %d vb = %d\n",
      *vsleft,*vstop,*vsright,*vsbottom);)
 return NO_ERROR;
}


