/****************************************************************************
2d_value.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 2d_value.c,v 1.14 1999/07/07 18:01:05 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/timeb.h>

#include "common.h"
#include "error_constants.h"
#include "rect.h"
#include "edge.h"
#include "nria_lib.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
*/
#define PRT1(x)
#define TRACE(x)
#define PRT(x)
#define PRT2(x)
#define PRT4(x)
#define PRT5(x)
#define PRT6(x)
#define PRT7(x)


/* Private functions */
unsigned long GetMax4ByteBufValue(unsigned char *buf, 
    unsigned long col, unsigned long pixel_depth, int is_long_buf);
float get_1d_buf_float(unsigned char *buf, unsigned long col);
double get_1d_buf_double(unsigned char *buf, unsigned long col);
long get_1d_buf_signed_value(char *buf, unsigned long col, 
    unsigned long pixel_depth);
double Get1dValue(unsigned char *buf, unsigned long col, 
    unsigned long pixel_depth, unsigned long type4);
void set_unaligned_any_size_1d_buf_value(unsigned char *buf, 
    int col, int pixel_depth, unsigned char *addr_of_val);
int set_any_size_1d_buf_value(unsigned char *buf, unsigned long col, 
    unsigned long pixel_depth, unsigned char *addr_of_val);
int set_1d_buf_signed_value(unsigned char *buf, unsigned long col, 
    unsigned long pixel_depth, unsigned long value);
void set_1d_buf_float(unsigned char *buf, unsigned long col, 
    double value);
void set_1d_buf_double(unsigned char *buf, unsigned long col, 
    double value);
void Set1dValue(unsigned char *buf, unsigned long col, 
    unsigned long pixel_depth, unsigned long type4, double val);
int set_2d_buf( struct buf_2d_rec *_2d, unsigned long num_values, ...);
int FindBitmapBound(struct buf_2d_rec *_2d, 
    struct int_bound_rec *bound, int *is_empty);
double DoubleMax4ByteBufValue(unsigned char *buf, unsigned long col, 
    unsigned long pixel_depth, unsigned long select);
double Get2dUnsignedBit(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
double Get2dUnsignedByte(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
double Get2dUnsignedShort(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
double Get2dUnsignedLong(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
double Get2dUnsignedGeneral(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
double Get2dSignedByte(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
double Get2dSignedShort(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
double Get2dSignedLong(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
double Get2dSignedGeneral(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
double Get2dFloat(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
double Get2dDouble(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col);
int Set2dUnsignedBit(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
int Set2dUnsignedByte(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
int Set2dUnsignedShort(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
int Set2dUnsignedLong(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
int Set2dUnsignedGeneral(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
int Set2dSignedByte(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
int Set2dSignedShort(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
int Set2dSignedLong(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
int Set2dSignedGeneral(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
int Set2dFloat(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
int Set2dDouble(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double val);
void set_2d_bitmap_row_bits(struct buf_2d_rec *bitmap, 
    unsigned long row, unsigned long first_col, unsigned long last_col);
int Set2dByIndexValueRange(struct buf_2d_rec *out_2d, 
    struct buf_2d_rec *in_2d, struct buf_2d_rec *mask, unsigned long *indxs, 
    unsigned long num_indxs, unsigned long first, unsigned long findxval, 
    unsigned long lindxval, double setval);
int set_2d_area_values(struct buf_2d_rec *_2d, long left, long top, 
    long right, long bottom, unsigned long *vals, unsigned long num_vals);
int Set2dNon0Value(struct buf_2d_rec *_2d, double value);
int Set2d0Value(struct buf_2d_rec *_2d, double value);
int Set2dByValue(struct buf_2d_rec *_2d, double value);
int Set2dByMask(struct buf_2d_rec *_2d, struct buf_2d_rec *mask, 
    double val);
int AddConstantTo2dValInLbUb(struct buf_2d_rec *_2d, double lbval, 
    double ubval, double const1);
int Get2dAreavalues(struct buf_2d_rec *_2d, long left, long top, 
    long right, long bottom, double *vals, long max_vals, long *num_vals);
void Get2dMean(struct buf_2d_rec *_2d, int is_recompute);
double Total2dValues(struct buf_2d_rec **_2d1, 
    struct buf_2d_rec **_2d2, unsigned long num_2ds, unsigned long select);
int Div2ds(struct buf_2d_rec *result, struct buf_2d_rec *_2d1, 
    struct buf_2d_rec *_2d2, int is_div_0_equal_0);
int Mult2ds(struct buf_2d_rec *result, struct buf_2d_rec *_2d1, 
    struct buf_2d_rec *_2d2);
int Div2dByConstant(struct buf_2d_rec *result, struct buf_2d_rec *_2d1,
    double constant, int is_div_0_equal_0);
int Mult2dByConstant(struct buf_2d_rec *result, struct buf_2d_rec *_2d1,
    double constant);
int Add2dArys(struct buf_2d_rec *result, struct buf_2d_rec **_2ds, 
    unsigned long num_2ds, int select);
int Sqrt2d(struct buf_2d_rec *result, struct buf_2d_rec *_2d);
int SelectAssign2dProc(struct buf_2d_rec *result, unsigned long row, 
    unsigned long col, struct buf_2d_rec *_2d, unsigned long select, 
    double *min, double *max, double *setval, double *addval, 
    unsigned long *map_2d_indxs, unsigned long *num_map_2d_indxs, 
    unsigned long *first_2d_indx);
int Assign2dByGeneralMask(struct buf_2d_rec *result, 
    struct buf_2d_rec *src, struct buf_2d_rec *mask, unsigned long select);
int pr_buf_2d_rec(struct buf_2d_rec *_2d);
void pr_buf_2d_rec_addr(struct buf_2d_rec *_2d);
void Pr2dValues(struct buf_2d_rec *_2d);



/*----------------------------------------------------------------------
Set2dValueType - ???
-----------------------------------------------------------------------*/

int
Set2dValueType(_2d,type4)
 struct buf_2d_rec *_2d;
 unsigned long type4;
{
 _2d->status4 &= ~BUF_VALUE_TYPE;
 _2d->status4 |= type4;
 Get2dValProc(_2d,&(_2d->GetVal));
 Set2dValProc(_2d,&(_2d->SetVal));
 return NO_ERROR;
}



/*----------------------------------------------------------------------
GetMinMaxValues - ???
-----------------------------------------------------------------------*/

int
GetMinMaxValues(
    struct buf_2d_rec *_2d,
    double *min,
    double *max)
{
 unsigned long select4;

 if (_2d->status4 & BUF_VALUE_FLOAT) select4 = 2;
   else if (_2d->status4 & BUF_VALUE_DOUBLE) select4 = 3;
   else if (_2d->status4 & BUF_VALUE_SIGNED) select4 = 1;
   else select4 = 0;
 MinMaxValues(select4,_2d->pixel_depth,min,max);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
GetDepthNeeded - ???
-----------------------------------------------------------------------*/

unsigned long 
GetDepthNeeded(min,max,type4)
 double min,max;
 unsigned long *type4;
{
 unsigned long depth;

 depth = NumBitsNeeded(min,max,type4);
 if (*type4 == 1) *type4 = BUF_VALUE_SIGNED;
   else if (*type4 == 2) *type4 = BUF_VALUE_FLOAT;
   else if (*type4 == 3) *type4 = BUF_VALUE_DOUBLE;
 return depth;
}


/*----------------------------------------------------------------------
GetMax4ByteBufValue - ???
-----------------------------------------------------------------------*/

unsigned long 
GetMax4ByteBufValue(buf,col,pixel_depth,is_long_buf)
 unsigned char *buf;
 unsigned long col,pixel_depth;
 int is_long_buf;
{
 unsigned long indx,bit,last_bit,num_bytes,last;
 unsigned long value,val;

 indx = col * pixel_depth;
 bit = indx % 8;
 last = indx + pixel_depth;
 last /= 8;
 indx /= 8;
 num_bytes = last - indx + 1;
 if (num_bytes > 5) value = 0;
   else 
    {if (is_long_buf)
        {if (num_bytes == 5) memcpy(&value,&(buf[indx]),(size_t) 4);
           else memcpy(&value,&(buf[indx]),(size_t) num_bytes);
        }
       else if (num_bytes == 5) memcpy(&value,buf,(size_t) 4);
       else memcpy(&value,buf,(size_t) num_bytes);

     if (bit) value <<= bit;
     num_bytes = pixel_depth / 8;
     bit = pixel_depth % 8;
     if (bit)
        {num_bytes += 1;
         bit = (8 - bit) + (4 - num_bytes) * 8;}
       else bit = (4 - num_bytes) * 8;
     value = value >> bit;
     if (num_bytes == 5)
        {val = (unsigned long) buf[4];
 	 /* FIXME!! last_bit is never initialized! */
         val >>= (7 - last_bit);
         value <<= (last_bit + 1);
         value |= val;}
    }
 return value;
}


/*----------------------------------------------------------------------
DoubleMax4ByteBufValue - ???

if select & 1 then is_long_buf
if select & 2 then is_signed_value
-----------------------------------------------------------------------*/

double 
DoubleMax4ByteBufValue(buf,col,pixel_depth,select)
 unsigned char *buf;
 unsigned long col,pixel_depth,select;
{
 long svalue;
 unsigned long value;

 value = GetMax4ByteBufValue(buf,col,pixel_depth,select & 1);
 if (select & 2)
    {if (value == 0) return (double) value;
     if (value & _LONG_BITS[pixel_depth - 1])
        value |= _OR_SIGNED_EXTENDED_BITS[pixel_depth - 1];
     memcpy(&svalue,&value,(size_t) sizeof(long));
     return (double) svalue;
    }
   else return (double) value;
}


/*----------------------------------------------------------------------
get_1d_buf_float - ???
-----------------------------------------------------------------------*/

float 
get_1d_buf_float(buf,col)
 unsigned char *buf;
 unsigned long col;
{
 float *fl_ptr;

 fl_ptr = (float *) buf;
 return fl_ptr[col];
}


/*----------------------------------------------------------------------
get_1d_buf_double - ???
-----------------------------------------------------------------------*/

double 
get_1d_buf_double(buf,col)
 unsigned char *buf;
 unsigned long col;
{
 double *fl_ptr;

 fl_ptr = (double *) buf;
 return fl_ptr[col];
}



/*----------------------------------------------------------------------
get_1d_buf_value - ???

This function returns an element of specified length in bits from an
array of such elements.  The beginning of the array is always passed 
as unsigned char *, regardless of the actual element length.

FIXME: Portability problems.  Assumed lengths for char, short, and
long ints.  Possible byte order problems if used to convert between
different bit lengths.
-----------------------------------------------------------------------*/

unsigned long 
get_1d_buf_value(
    unsigned char *buf,
    unsigned long col,
    unsigned long pixel_depth)
{
 unsigned long byte_posi,bit_posi;
 unsigned short *short_ptr;
 unsigned long *int_ptr;

 switch (pixel_depth)
    {
     case 8 :
        return (unsigned long) buf[col];
     case 1 :
        byte_posi = col / 8;
        bit_posi = col % 8;
        if (buf[byte_posi] & C_which_bit[bit_posi]) return (unsigned long) 1;
          else return (unsigned long) 0;
     case 16 :
        short_ptr = (unsigned short *) buf;
        return (unsigned long) short_ptr[col];
     case 32 : 
        int_ptr = (unsigned long *) buf;
        return (unsigned long) int_ptr[col];
     default : 
        return GetMax4ByteBufValue(buf,col,pixel_depth,1);
    }
}


/*----------------------------------------------------------------------
get_1d_buf_signed_value - ???
-----------------------------------------------------------------------*/

long 
get_1d_buf_signed_value(buf,col,pixel_depth)
 char *buf;
 unsigned long col,pixel_depth;
{
 unsigned long val;
 long value;

 val = get_1d_buf_value(buf,col,pixel_depth);
 if (val == 0) return 0;
 if (val & _LONG_BITS[pixel_depth - 1])
    val |= _OR_SIGNED_EXTENDED_BITS[pixel_depth - 1];
 memcpy(&value,&val,(size_t) sizeof(long));
 return value;
}


/*----------------------------------------------------------------------
Get1dValue - ???
-----------------------------------------------------------------------*/

double 
Get1dValue(buf,col,pixel_depth,type4)
 unsigned char *buf;
 unsigned long col,pixel_depth;
 unsigned long type4;
{
 if (type4 & BUF_PIXEL_SIGNED)
    {
     if (type4 & BUF_VALUE_SIGNED)
        return (double) get_1d_buf_signed_value(buf,col,pixel_depth);
       else if (type4 & BUF_VALUE_FLOAT)
        return (double) get_1d_buf_float(buf,col);
       else return get_1d_buf_double(buf,col);
    }
   else return (double) get_1d_buf_value(buf,col,pixel_depth);
}


/*----------------------------------------------------------------------
get_1d_buf_addr - ???
-----------------------------------------------------------------------*/

void *
get_1d_buf_addr(buf,col,pixel_depth,start_bit)
 unsigned char *buf;
 unsigned long col,pixel_depth,*start_bit;
{
 unsigned long indx;

 indx = col * pixel_depth;
 *start_bit = indx % 8;
 indx /= 8;
 return &(buf[indx]);
}


/*----------------------------------------------------------------------
set_unaligned_any_size_1d_buf_value - ???
-----------------------------------------------------------------------*/

void
set_unaligned_any_size_1d_buf_value(buf,col,pixel_depth,addr_of_val)
 unsigned char *buf;
 unsigned char *addr_of_val;
{
 unsigned long lcv,num_bytes,start,num_bits,cnt,bit_posi,byte_posi;

 num_bytes = pixel_depth / 8;
 start = col * pixel_depth;
 for (cnt = 0; cnt < num_bytes; cnt++)
    for (lcv = 0; lcv < 8; lcv++,start++)
       {
        bit_posi = start % 8;
        byte_posi = start / 8;

        if (addr_of_val[cnt] & C_which_bit[lcv])
           buf[byte_posi] |= C_which_bit[bit_posi];
          else buf[byte_posi] &= C_not_bit[bit_posi];
       }
 num_bits = pixel_depth % 8;
 for (lcv = 0; lcv < num_bits; lcv++,start++)
    {bit_posi = start % 8;
     byte_posi = start / 8;

     if (addr_of_val[cnt] & C_which_bit[lcv])
        buf[byte_posi] |= C_which_bit[bit_posi];
       else buf[byte_posi] &= C_not_bit[bit_posi];
    }
}


/*----------------------------------------------------------------------
set_any_size_1d_buf_value - ???
-----------------------------------------------------------------------*/

int
set_any_size_1d_buf_value(buf,col,pixel_depth,addr_of_val)
 unsigned char *buf;
 unsigned long col,pixel_depth;
 unsigned char *addr_of_val;
{
 unsigned long num_bytes,indx,num_bits,start_bit;
 char value;

 indx = col * pixel_depth;
 start_bit = indx % 8;
 if (start_bit > 0)
    {set_unaligned_any_size_1d_buf_value(buf,col,pixel_depth,addr_of_val);
     return NO_ERROR;
    }
 indx /= 8;
 num_bytes = pixel_depth / 8;
 num_bits = pixel_depth % 8;
/*
 PRT2(printf("indx = %d col = %d depth = %d val = %x = %d\n",
        indx,col,pixel_depth,*((unsigned long *) addr_of_val),start_bit);)
*/
 if (num_bytes > 0)
    memcpy(&(buf[indx]),addr_of_val,num_bytes);

 if (num_bits)
    {indx += num_bytes;
     memcpy(&value,&(addr_of_val[num_bytes]),1);
     value &= C_start_bits[num_bits - 1];
     buf[indx] &= ~C_start_bits[num_bits - 1];
     buf[indx] |= value;
    }

 return NO_ERROR;
}


/*----------------------------------------------------------------------
set_1d_buf_value - ???
-----------------------------------------------------------------------*/

int
set_1d_buf_value(buf,col,pixel_depth,value)
 unsigned char *buf;
 unsigned long col,pixel_depth;
 unsigned long value;
{
 unsigned long byte_posi,bit_posi;
 unsigned short *short_ptr;
 unsigned long *int_ptr;

 switch (pixel_depth)
    {
     case 8 :
        buf[col] = (unsigned char) value;
        return NO_ERROR;
     case 1 :
        byte_posi = col / 8;
        bit_posi = col % 8;
        if (value) buf[byte_posi] |= C_which_bit[bit_posi];
          else buf[byte_posi] &= C_not_bit[bit_posi];
        return NO_ERROR;
     case 16 :
        short_ptr = (unsigned short *) buf;
        short_ptr[col] = value;
        return NO_ERROR;
     case 32 : 
        int_ptr = (unsigned long *) buf;
        int_ptr[col] = value;
        return NO_ERROR;
     default : 
        value <<= (32 - pixel_depth);
        return set_any_size_1d_buf_value(buf,col,pixel_depth,&value);
    }
}


/*----------------------------------------------------------------------
set_1d_buf_signed_value - ???
-----------------------------------------------------------------------*/

int
set_1d_buf_signed_value(buf,col,pixel_depth,value)
 unsigned char *buf;
 unsigned long col,pixel_depth;
 unsigned long value;
{
 return set_1d_buf_value(buf,col,pixel_depth,value);
}


/*----------------------------------------------------------------------
set_1d_buf_float - ???
-----------------------------------------------------------------------*/

void
set_1d_buf_float(buf,col,value)
 unsigned char *buf;
 unsigned long col;
 float value;
{
 float *fl_ptr;

 fl_ptr = (float *) buf;
 fl_ptr[col] = value;
}


/*----------------------------------------------------------------------
set_1d_buf_double - ???
-----------------------------------------------------------------------*/

void
set_1d_buf_double(buf,col,value)
 unsigned char *buf;
 unsigned long col;
 double value;
{
 double *fl_ptr;

 fl_ptr = (double *) buf;
 fl_ptr[col] = value;
}


/*----------------------------------------------------------------------
Set1dValue - ???
-----------------------------------------------------------------------*/

void
Set1dValue(buf,col,pixel_depth,type4,val)
 unsigned char *buf;
 unsigned long col,pixel_depth;
 unsigned long type4;
 double val;
{
 if (type4 & BUF_PIXEL_SIGNED)
    {
     if (type4 & BUF_VALUE_SIGNED)
        set_1d_buf_value(buf,col,pixel_depth,LongRound(val));
       else if (type4 & BUF_VALUE_FLOAT)
        set_1d_buf_float(buf,col,(float) val);
       else set_1d_buf_double(buf,col,val);
    }
   else set_1d_buf_value(buf,col,pixel_depth,ULongRound(val));
}


/*----------------------------------------------------------------------
Get2dUnsignedBit - ???
-----------------------------------------------------------------------*/

double 
Get2dUnsignedBit(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 unsigned long byte_posi,bit_posi;
 unsigned char *buf;
        
 buf = (unsigned char *) _2d->buf[row];
 byte_posi = col / 8;
 bit_posi = col % 8;
 if (buf[byte_posi] & C_which_bit[bit_posi]) return (double) 1.0;
 return (double) 0;
}


/*----------------------------------------------------------------------
Get2dUnsignedByte - ???
-----------------------------------------------------------------------*/

double 
Get2dUnsignedByte(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 return (double) _2d->buf[row][col];
}


/*----------------------------------------------------------------------
Get2dUnsignedShort - ???
-----------------------------------------------------------------------*/

double 
Get2dUnsignedShort(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 unsigned short *short_ptr;

 short_ptr = (unsigned short *) _2d->buf[row];
 return (double) short_ptr[col];
}


/*----------------------------------------------------------------------
Get2dUnsignedLong - ???
-----------------------------------------------------------------------*/

double 
Get2dUnsignedLong(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 unsigned long *int_ptr;

 int_ptr = (unsigned long *) _2d->buf[row];
 return (double) int_ptr[col];
}


/*----------------------------------------------------------------------
Get2dUnsignedGeneral - ???
-----------------------------------------------------------------------*/

double 
Get2dUnsignedGeneral(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 return (double) GetMax4ByteBufValue(_2d->buf[row],col,_2d->pixel_depth,1);
}


/*----------------------------------------------------------------------
Get2dSignedByte - ???
-----------------------------------------------------------------------*/

double 
Get2dSignedByte(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 char *buf;

 buf = (char *) _2d->buf[row];
 return (double) buf[col];
}


/*----------------------------------------------------------------------
Get2dSignedShort - ???
-----------------------------------------------------------------------*/

double 
Get2dSignedShort(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 short *short_ptr;

 short_ptr = (short *) _2d->buf[row];
 return (double) short_ptr[col];
}


/*----------------------------------------------------------------------
Get2dSignedLong - ???
-----------------------------------------------------------------------*/

double 
Get2dSignedLong(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 long *int_ptr;

 int_ptr = (long *) _2d->buf[row];
 return (double) int_ptr[col];
}


/*----------------------------------------------------------------------
Get2dSignedGeneral - ???
-----------------------------------------------------------------------*/

double 
Get2dSignedGeneral(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 unsigned long val;
 long value;

 val = GetMax4ByteBufValue(_2d->buf[row],col,_2d->pixel_depth,1);
 if (val == 0) return (double) .0;
 if (val & _LONG_BITS[_2d->pixel_depth - 1])
    val |= _OR_SIGNED_EXTENDED_BITS[_2d->pixel_depth - 1];
 memcpy(&value,&val,(size_t) sizeof(long));
 return (double) value;
}


/*----------------------------------------------------------------------
Get2dFloat - ???
-----------------------------------------------------------------------*/

double 
Get2dFloat(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 float *fl_ptr;

 fl_ptr = (float *) _2d->buf[row];
 return (double) fl_ptr[col];
}


/*----------------------------------------------------------------------
Get2dDouble - ???
-----------------------------------------------------------------------*/

double 
Get2dDouble(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 double *fl_ptr;

 fl_ptr = (double *) _2d->buf[row];
 return (double) fl_ptr[col];
}


/*----------------------------------------------------------------------
Get2dValProc - ???
-----------------------------------------------------------------------*/

int
Get2dValProc(_2d,getproc)
 struct buf_2d_rec *_2d;
 double (**getproc)();
{
 if (_2d->status4 & BUF_PIXEL_SIGNED)
    {
     if (_2d->status4 & BUF_VALUE_SIGNED)
        {if (_2d->pixel_depth == 8)
            *getproc = Get2dSignedByte;
	else if (_2d->pixel_depth == 1)
            *getproc = Get2dUnsignedBit;
	else if (_2d->pixel_depth == 16)
            *getproc = Get2dSignedShort;
	else if (_2d->pixel_depth == 32)
            *getproc = Get2dSignedLong;
	else 
	    *getproc = Get2dSignedGeneral;
        }


     /*  DRW 960905: took out "else" so this section of code
      *  will OVERRIDE previous if statement.  Fixes problem
      *  where wrong procedure gets used if float or double.
      */
     if (_2d->status4 & BUF_VALUE_FLOAT)
       *getproc = Get2dFloat;
     else if (_2d->status4 & BUF_VALUE_DOUBLE)
       *getproc = Get2dDouble;
    }
 else 
    {if (_2d->pixel_depth == 8)
        *getproc = Get2dUnsignedByte;
    else if (_2d->pixel_depth == 1)
        *getproc = Get2dUnsignedBit;
    else if (_2d->pixel_depth == 16)
        *getproc = Get2dUnsignedShort;
    else if (_2d->pixel_depth == 32)
        *getproc = Get2dUnsignedLong;
    else 
	*getproc = Get2dUnsignedGeneral;
    }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dUnsignedBit - ???
-----------------------------------------------------------------------*/

int
Set2dUnsignedBit(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 unsigned long byte_posi,bit_posi;

 byte_posi = col / 8;
 bit_posi = col % 8;
 if (val) _2d->buf[row][byte_posi] |= C_which_bit[bit_posi];
   else _2d->buf[row][byte_posi] &= C_not_bit[bit_posi];
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dUnsignedByte - ???
-----------------------------------------------------------------------*/

int
Set2dUnsignedByte(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 _2d->buf[row][col] = (unsigned char) ULongRound(val);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dUnsignedShort - ???
-----------------------------------------------------------------------*/

int
Set2dUnsignedShort(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 unsigned short *short_ptr;

 short_ptr = (unsigned short *) _2d->buf[row];
 short_ptr[col] = (unsigned short) ULongRound(val);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dUnsignedLong - ???
-----------------------------------------------------------------------*/

int
Set2dUnsignedLong(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 unsigned long *int_ptr;

 int_ptr = (unsigned long *) _2d->buf[row];
 int_ptr[col] = (unsigned long) ULongRound(val);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dUnsignedGeneral - ???
-----------------------------------------------------------------------*/

int
Set2dUnsignedGeneral(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 unsigned long value;

 value = (unsigned long) ULongRound(val);
 value <<= (32 - _2d->pixel_depth);
 return set_any_size_1d_buf_value(_2d->buf[row],col,_2d->pixel_depth,&value);
}


/*----------------------------------------------------------------------
Set2dSignedByte - ???
-----------------------------------------------------------------------*/

int
Set2dSignedByte(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 char *buf;

 buf = (char *) _2d->buf[row];
 buf[col] = (char) LongRound(val);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dSignedShort - ???
-----------------------------------------------------------------------*/

int
Set2dSignedShort(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 short *short_ptr;

 short_ptr = (short *) _2d->buf[row];
 short_ptr[col] = (short) LongRound(val);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dSignedLong - ???
-----------------------------------------------------------------------*/

int
Set2dSignedLong(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 long *int_ptr;

 int_ptr = (long *) _2d->buf[row];
 int_ptr[col] = LongRound(val);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dSignedGeneral - ???
-----------------------------------------------------------------------*/

int
Set2dSignedGeneral(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 long value;

 value = LongRound(val);
 value <<= (32 - _2d->pixel_depth);
 return set_any_size_1d_buf_value(_2d->buf[row],col,_2d->pixel_depth,&value);
}


/*----------------------------------------------------------------------
Set2dFloat - ???
-----------------------------------------------------------------------*/

int
Set2dFloat(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 float *fl_ptr;

 fl_ptr = (float *) _2d->buf[row];
 fl_ptr[col] = (float) val;
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dDouble - ???
-----------------------------------------------------------------------*/

int
Set2dDouble(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 double *fl_ptr;

 fl_ptr = (double *) _2d->buf[row];
 fl_ptr[col] = val;
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dValProc - ???
-----------------------------------------------------------------------*/

int
Set2dValProc(_2d,setproc)
 struct buf_2d_rec *_2d;
 int (**setproc)();
{
 if (_2d->status4 & BUF_PIXEL_SIGNED)
    {
     if (_2d->status4 & BUF_VALUE_SIGNED)
        {if (_2d->pixel_depth == 8)
            *setproc = Set2dSignedByte;
	else if (_2d->pixel_depth == 1)
            *setproc = Set2dUnsignedBit;
	else if (_2d->pixel_depth == 16)
            *setproc = Set2dSignedShort;
	else if (_2d->pixel_depth == 32)
            *setproc = Set2dSignedLong;
	else 
	       *setproc = Set2dSignedGeneral;
        }


     /*  DRW 960905: took out "else" so this section of code
      *  will OVERRIDE previous if statement.  Fixes problem
      *  where wrong procedure gets used if float or double.
      */
     if (_2d->status4 & BUF_VALUE_FLOAT)
       *setproc = Set2dFloat;
     else if (_2d->status4 & BUF_VALUE_DOUBLE)
       *setproc = Set2dDouble;
    }
 else 
    {if (_2d->pixel_depth == 8)
        *setproc = Set2dUnsignedByte;
    else if (_2d->pixel_depth == 1)
	*setproc = Set2dUnsignedBit;
    else if (_2d->pixel_depth == 16)
	*setproc = Set2dUnsignedShort;
    else if (_2d->pixel_depth == 32)
	*setproc = Set2dUnsignedLong;
    else 
	*setproc = Set2dUnsignedGeneral;
    }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
set_2d_buf - ???

set_2d_buf(_2d,num_values,[row1,col1,value1,]...)
-----------------------------------------------------------------------*/

int
set_2d_buf(
    struct buf_2d_rec *_2d,
    unsigned long num_values,
    ...)
{
 va_list args;
 unsigned long row,col;
 double value;

 unsigned long cnt;

 va_start(args, num_values);
 for (cnt = 0; cnt < num_values; cnt++)
    {
     row = va_arg(args,unsigned long);
     col = va_arg(args,unsigned long);
     value = va_arg(args,double);
     if ((row >= _2d->dimy) || (col >= _2d->dimx)) return CANCEL;
     _2d->SetVal(_2d,row,col,value);
    }
 va_end(args);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
set_2d_bitmap_row_bits - ???
-----------------------------------------------------------------------*/

void
set_2d_bitmap_row_bits(bitmap,row,first_col,last_col)
 struct buf_2d_rec *bitmap;
 unsigned long row,first_col,last_col;
{
 unsigned long next,before_last,indx;

 next = ((first_col / 8) + 1) * 8;
 last_col += 1;
 if (next > last_col) next = last_col;

 for (indx = first_col; indx < next; indx += 1)
    bitmap->buf[row][indx / 8] |= C_which_bit[indx % 8];      

 if (next < last_col)     
    {before_last = last_col / 8;
     for (indx = next / 8; indx < before_last; indx += 1)
        bitmap->buf[row][indx] |= 0xff;

     for (indx = before_last * 8; indx < last_col; indx += 1)
        bitmap->buf[row][indx / 8] |= C_which_bit[indx % 8];}       
}


/*----------------------------------------------------------------------
Set2dByIndexValueRange - ???
-----------------------------------------------------------------------*/

int
Set2dByIndexValueRange(out_2d,in_2d,mask,
                       indxs,num_indxs,first,findxval,lindxval,setval)
 struct buf_2d_rec *out_2d,*in_2d,*mask;
 unsigned long *indxs,num_indxs,first,findxval,lindxval;
 double setval;
{
 unsigned long row,col,indx,cnt;
 double val;

/*
 printf("Set num_indxs = %d first = %d findxval = %d lindxval = %d\n",
            num_indxs,first,findxval,lindxval);
*/
 for (cnt = 0,row = 0; row < out_2d->dimy; row++)
    for (col = 0; col < out_2d->dimx; col++)
       {if (mask != NULL)
           if (mask->GetVal(mask,row,col) == .0)
              continue;
        val = in_2d->GetVal(in_2d,row,col);
        val -= first;
        indx = (unsigned long) val;
        if ((indx < num_indxs) &&
            (indxs[indx] >= findxval) && (indxs[indx] <= lindxval))
           {cnt += 1;
            out_2d->SetVal(out_2d,row,col,setval);}
       }
/*
 printf("Set2dByIndexValueRange cnt = %d\n",cnt);
*/
 return NO_ERROR;
}



/*----------------------------------------------------------------------
Set2dByArea - ???
-----------------------------------------------------------------------*/

int
Set2dByArea(
    struct buf_2d_rec *_2d,
    int left,
    int top,
    int right,
    int bottom,
    double value)
{
 unsigned long row,col;

 TRACE(printf("init l = %d  t = %d   r = %d  b = %d  val = %d\n",
        left,top,right,bottom,value))
 if (left < 0) left = 0;
 if (top < 0) top = 0;
 if (right >= _2d->dimx) right = _2d->dimx - 1;
 if (bottom >= _2d->dimy) bottom = _2d->dimy - 1;
 TRACE(printf("non-0 = %d\n",cnt_non_val_buf_2d_rec(_2d,0)))
 for (row = top; row <= bottom; row++)
    for (col = left; col <= right; col++)
       _2d->SetVal(_2d,row,col,value);
 TRACE(printf("after set non-0 = %d\n",cnt_non_val_buf_2d_rec(_2d,0)))
 return NO_ERROR;
}




/*----------------------------------------------------------------------
set_2d_area_values - ???
-----------------------------------------------------------------------*/

int
set_2d_area_values(_2d,left,top,right,bottom,vals,num_vals)
 struct buf_2d_rec *_2d;
 long left,top,right,bottom;
 unsigned long *vals,num_vals;
{
 long row,col,lcv;

 if (num_vals <= 0) return NO_ERROR;
 if (left < 0) left = 0;
   else if (left >= _2d->dimx) left = _2d->dimx - 1;
 if (right >= _2d->dimx) right = _2d->dimx - 1;
 if (top < 0) top = 0;
   else if (top >= _2d->dimy) top = _2d->dimy - 1;
 if (bottom >= _2d->dimy) bottom = _2d->dimy - 1;

 for (lcv = 0,row = top; row <= bottom; row++)
    for (col = left; col <= right; col++)
       {_2d->SetVal(_2d,row,col,(double) vals[lcv]);
        lcv += 1;
        if (lcv == num_vals) break;}

 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dNon0Value - ???
-----------------------------------------------------------------------*/

int
Set2dNon0Value(_2d,value)
 struct buf_2d_rec *_2d;
 double value;
{
 unsigned long row,col;

 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col++)
       if (_2d->GetVal(_2d,row,col) != .0)
          _2d->SetVal(_2d,row,col,value);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2d0Value - ???
-----------------------------------------------------------------------*/

int
Set2d0Value(_2d,value)
 struct buf_2d_rec *_2d;
 double value;
{
 unsigned long row,col;

 printf("Set2d0Value valu = %f\n",value);
 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col++)
       if (_2d->GetVal(_2d,row,col) == .0)
          _2d->SetVal(_2d,row,col,value);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dByValue - ???
-----------------------------------------------------------------------*/

int
Set2dByValue(_2d,value)
 struct buf_2d_rec *_2d;
 double value;
{
 unsigned long row,col;

 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col++)
       _2d->SetVal(_2d,row,col,value);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Set2dByMask - ???
-----------------------------------------------------------------------*/

int
Set2dByMask(_2d,mask,val)
 struct buf_2d_rec *_2d,*mask;
 double val;
{
 unsigned long row,col;
 unsigned long dimx,dimy;

 if ((_2d->dimx != mask->dimx) || (_2d->dimy != mask->dimy)) return CANCEL;
 if (mask->dimy > _2d->dimy) dimy = _2d->dimy;
    else dimy = mask->dimy; 
 if (mask->dimx > _2d->dimx) dimx = _2d->dimx;
    else dimx = mask->dimx;

 for (row = 0; row < dimy; row++)
    for (col = 0; col < dimx; col++)
       if ((double) mask->GetVal(mask,row,col) != .0)
          _2d->SetVal(_2d,row,col,val);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Add2dVal - ???
-----------------------------------------------------------------------*/

int
Add2dVal(_2d,row,col,val)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double val;
{
 double val1;

 val1 = _2d->GetVal(_2d,row,col);
 return _2d->SetVal(_2d,row,col,val1 + val);
}


/*----------------------------------------------------------------------
AddConstantTo2d - ???
-----------------------------------------------------------------------*/

int
AddConstantTo2d(_2d,value,is_non0_elems)
 struct buf_2d_rec *_2d;
 double value;
 int is_non0_elems;
{
 unsigned long row,col,cnt;
 double val;

 for (cnt = 0,row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col += 1)
       {val = _2d->GetVal(_2d,row,col);
        if (is_non0_elems && (val == .0)) 
           {cnt++;
            continue;}
          else val += value;
        _2d->SetVal(_2d,row,col,val);
       }
 PRT7(printf("AddConstantTo2d cnt = %d\n",cnt);)
 return NO_ERROR;
}


/*----------------------------------------------------------------------
AddConstantTo2dValInLbUb - ???
-----------------------------------------------------------------------*/

int
AddConstantTo2dValInLbUb(_2d,lbval,ubval,const1)
 struct buf_2d_rec *_2d;
 double lbval,ubval,const1;
{
 unsigned long row,col;
 double val;

 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col += 1)
       {val = _2d->GetVal(_2d,row,col);
        if ((val >= lbval) && (val <= ubval))
           Add2dVal(_2d,row,col,const1);
       }
 return NO_ERROR;
}



/*----------------------------------------------------------------------
SelectSet2dValue - ???
-----------------------------------------------------------------------*/

int
SelectSet2dValue(
    struct buf_2d_rec *_2d,
    struct int_bound_rec *bound,
    double lb,
    double ub,
    double setval,
    int isSetNotInRange,
    double NotInRangeVal)
{
 long row,col;
 double val;
 int left,right,top,bottom;
 struct int_bound_rec bound1;

 if (bound == NULL)
    {left = top = 0;
     right = _2d->dimx - 1;
     bottom = _2d->dimy - 1;}
   else
    {setup_int_bound_rec(&bound1,0,0,_2d->dimx - 1,_2d->dimy - 1);
     valid_bound(bound,&bound1,&left,&right,&top,&bottom);
    }

 for (row = top; row <= bottom; row++)
    for (col = left; col <= right; col++)
       {val = _2d->GetVal(_2d,row,col);
        if ((val >= lb) && (val <= ub))
           _2d->SetVal(_2d,row,col,setval);
          else if (isSetNotInRange)
           _2d->SetVal(_2d,row,col,NotInRangeVal);
       }
 return NO_ERROR;
}




/*----------------------------------------------------------------------
Get2dAreavalues - ???
-----------------------------------------------------------------------*/

int
Get2dAreavalues(_2d,left,top,right,bottom,vals,max_vals,num_vals)
 struct buf_2d_rec *_2d;
 double *vals;
 long left,top,right,bottom,max_vals,*num_vals;
{
 unsigned long row,col;

 if (max_vals <= 0) return NO_ERROR;
 if (left < 0) left = 0;
   else if (left >= _2d->dimx) left = _2d->dimx - 1;
 if (right >= _2d->dimx) right = _2d->dimx - 1;
 if (top < 0) top = 0;
   else if (top >= _2d->dimy) top = _2d->dimy - 1;
 if (bottom >= _2d->dimy) bottom = _2d->dimy - 1;

 for (*num_vals = 0,row = top; row <= bottom; row++)
    for (col = left; col <= right; col++)
       {
        vals[*num_vals] = _2d->GetVal(_2d,row,col);
        *num_vals += 1;
        if (*num_vals == max_vals) break;}

 return NO_ERROR;
}


/*----------------------------------------------------------------------
Get2dMean - ???
-----------------------------------------------------------------------*/

void
Get2dMean(_2d,is_recompute)
 struct buf_2d_rec *_2d;
 int is_recompute;
{
 unsigned long row,col;
 double ave;

 if (((_2d->status4 & BUF_MEAN_VALUE_COMPUTED) == 0) || is_recompute)
    {
     for (ave = .0,row = 0; row < _2d->dimy; row++)
        for (col = 0; col < _2d->dimx; col++)
           ave += _2d->GetVal(_2d,row,col);
     ave /= (double) (_2d->dimy * _2d->dimx);
     _2d->meanval = ave;
     _2d->status4 |= BUF_MEAN_VALUE_COMPUTED;
    }
}


/*----------------------------------------------------------------------
Total2dValues - ???

 if (_2d2 != NULL) then val = pixel(_2d1) * pixel(_2d2)
 select & 1 use val = val * val
 select & 2 return the mean value
-----------------------------------------------------------------------*/

double 
Total2dValues(_2d1,_2d2,num_2ds,select)
 struct buf_2d_rec **_2d1,**_2d2;
 unsigned long num_2ds,select;
{
 double total,val1;
 unsigned long row,col,lcv;

 total = .0;
 for (row = 0; row < _2d1[0]->dimy; row++)
    for (col = 0; col < _2d1[0]->dimx; col++)
       {for (val1 = .0,lcv = 0; lcv < num_2ds; lcv++)
           if (_2d2 != NULL)
              {val1 += _2d1[lcv]->GetVal(_2d1[lcv],row,col) *
                       _2d2[lcv]->GetVal(_2d2[lcv],row,col);
              }
             else val1 += _2d1[lcv]->GetVal(_2d1[lcv],row,col);
        if (num_2ds > 1) val1 /= (double) num_2ds;
        if (select & 1) total += val1 * val1;
          else total += val1;
       }
 if (select & 2) total = total / ((double) _2d1[0]->dimy * (double) _2d1[0]->dimx);
 return total;
}



/*----------------------------------------------------------------------
Sub2ds - ???
-----------------------------------------------------------------------*/

int
Sub2ds(
    struct buf_2d_rec *result,
    struct buf_2d_rec *_2d1,
    struct buf_2d_rec *_2d2)
{
 unsigned long row,col;

 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < result->dimx; col++)
       result->SetVal(result,row,col,
          _2d1->GetVal(_2d1,row,col) - _2d2->GetVal(_2d2,row,col));
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Div2ds - ???
-----------------------------------------------------------------------*/

int
Div2ds(result,_2d1,_2d2,is_div_0_equal_0)
 struct buf_2d_rec *result,*_2d1,*_2d2;
 int is_div_0_equal_0;
{
 unsigned long row,col;
 double val;

 if (is_div_0_equal_0)
    for (row = 0; row < result->dimy; row++)
       for (col = 0; col < result->dimx; col++)
          {val = _2d2->GetVal(_2d2,row,col);
           if (val == .0)
              result->SetVal(result,row,col,val);
             else 
              result->SetVal(result,row,col,_2d1->GetVal(_2d1,row,col) / val);
          }
  else
   for (row = 0; row < result->dimy; row++)
      for (col = 0; col < result->dimx; col++)
         result->SetVal(result,row,col,
           _2d1->GetVal(_2d1,row,col) / _2d2->GetVal(_2d2,row,col));
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Mult2ds - ???
-----------------------------------------------------------------------*/

int
Mult2ds(result,_2d1,_2d2)
 struct buf_2d_rec *result,*_2d1,*_2d2;
{
 unsigned long row,col;

 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < result->dimx; col++)
       result->SetVal(result,row,col,
          _2d1->GetVal(_2d1,row,col) * _2d2->GetVal(_2d2,row,col));
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Div2dByConstant - ???
-----------------------------------------------------------------------*/

int
Div2dByConstant(result,_2d1,constant,is_div_0_equal_0)
 struct buf_2d_rec *result,*_2d1;
 double constant;
 int is_div_0_equal_0;
{
 unsigned long row,col;

 if ((is_div_0_equal_0) && (constant == .0))
    for (row = 0; row < result->dimy; row++)
       for (col = 0; col < result->dimx; col++)
          result->SetVal(result,row,col,(double) .0);
   else
    for (row = 0; row < result->dimy; row++)
       for (col = 0; col < result->dimx; col++)
          result->SetVal(result,row,col,
             _2d1->GetVal(_2d1,row,col) / constant);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Mult2dByConstant - ???
-----------------------------------------------------------------------*/

int
Mult2dByConstant(result,_2d1,constant)
 struct buf_2d_rec *result,*_2d1;
 double constant;
{
 unsigned long row,col;

 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < result->dimx; col++)
       result->SetVal(result,row,col,_2d1->GetVal(_2d1,row,col) * constant);
 return NO_ERROR;
}



/*----------------------------------------------------------------------
Add2ds - ???
-----------------------------------------------------------------------*/

int
Add2ds(
    struct buf_2d_rec *result,
    struct buf_2d_rec *_2d1,
    struct buf_2d_rec *_2d2)
{
 unsigned long row,col;

 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < result->dimx; col++)
       result->SetVal(result,row,col,
          _2d1->GetVal(_2d1,row,col) + _2d2->GetVal(_2d2,row,col));
 return NO_ERROR;
}



/*----------------------------------------------------------------------
Add2dArys - ???

select & 1...add _2d value * _2d value else add _2d value
select & 2...ave _2ds values
-----------------------------------------------------------------------*/

int
Add2dArys(result,_2ds,num_2ds,select)
 struct buf_2d_rec *result,**_2ds;
 unsigned long num_2ds;
 int select;
{
 unsigned long row,col,lcv;
 double val,val2;

 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < result->dimx; col++)
       {for (val = .0,lcv = 0; lcv < num_2ds; lcv++)
           if (select & 1)
              {val2 = _2ds[lcv]->GetVal(_2ds[lcv],row,col);
               val += val2 * val2;}
             else val += _2ds[lcv]->GetVal(_2ds[lcv],row,col);
         
        if (select & 2) if (num_2ds > 1) val /= (double) num_2ds;
        result->SetVal(result,row,col,val);
       }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Sqrt2d - ???
-----------------------------------------------------------------------*/

int
Sqrt2d(result,_2d)
 struct buf_2d_rec *result,*_2d;
{
 unsigned long row,col;
 double dou_val;

 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < result->dimx; col++)
       {dou_val = _2d->GetVal(_2d,row,col);
        dou_val = sqrt(dou_val);
        result->SetVal(result,row,col,dou_val);
       }
 return NO_ERROR;
}



/*----------------------------------------------------------------------
Abs2d - ???
-----------------------------------------------------------------------*/

int
Abs2d(
    struct buf_2d_rec *_2d)
{
 unsigned long row,col;
 double val;

 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col++)
       {val = _2d->GetVal(_2d,row,col);
        if (val < .0)
           _2d->SetVal(_2d,row,col,-val);
       }
 return NO_ERROR;
}



/*----------------------------------------------------------------------
Assign2d - ???
-----------------------------------------------------------------------*/

int
Assign2d(
    struct buf_2d_rec *dst,
    struct buf_2d_rec *src)
{
 unsigned long row,col,dimx,dimy,total,dim_bytes;

 if (!(dst->status4 & BUF_NON_EMPTY) || !(src->status4 & BUF_NON_EMPTY))
    return ~NO_ERROR;
 if (dst->dimx > src->dimx) dimx = src->dimx;
   else dimx = dst->dimx;
 if (dst->dimy > src->dimy) dimy = src->dimy;
   else dimy = dst->dimy;

 if ((dst->pixel_depth == src->pixel_depth) &&
     ((dst->status4 & BUF_VALUE_TYPE) == (src->status4 & BUF_VALUE_TYPE)))
    {
     dim_bytes = GetRowBytes(dimx,dst->pixel_depth);
     if ((dst->prog_status2 & BUF_OWN_CONTIGUOUS_MEMORY) &&
         (src->prog_status2 & BUF_OWN_CONTIGUOUS_MEMORY) &&
         (dst->dimx == src->dimx) && (dst->dimy == src->dimy))
        {total = dst->dimy * dim_bytes;
         memcpy(dst->buf[0],src->buf[0],(size_t) total);
        }
       else for (row = 0; row < dimy; row++)
        memcpy(dst->buf[row],src->buf[row],(size_t) dim_bytes);
    }
   else
    for (row = 0; row < dimy; row++)
       for (col = 0; col < dimx; col++)
          dst->SetVal(dst,row,col,src->GetVal(src,row,col));
 return NO_ERROR;
}


/*----------------------------------------------------------------------
SelectAssign2dProc - ???

if (select & 0x00010000) val = map_2d_indxs(value(_2d))
  else val = value(_2d);
if (select & 0x00100000) if (val != .0) selected = 1;

select & 1 then selected if val < min
select & 2 then selected if val > min    these 4 are mutually exclusive
select & 4 then selected if val <= min
select & 8 then selected if val >= min

select & 0x00000010 then selected if val < max
select & 0x00000020 then selected if val > max  these 4 are
select & 0x00000040 then selected if val <= max    mutually exclusive
select & 0x00000080 then selected if val >= max

if selected then
   {if select & 0x00000100 then value(result) = addval
      else if select & 0x00000200 then value(result) = abs(val)
      else if select & 0x00000800 then value(result) = val + addval
      else if select & 0x00001000 then value(result) += addval
      else if select & 0x00002000 then value(result) = -val
      else if select & 0x00004000 then value(result) = val
   }
  else if select & 0x00000400 then value(result) = setval
-----------------------------------------------------------------------*/

int
SelectAssign2dProc(result,row,col,_2d,select,min,max,setval,addval,
                   map_2d_indxs,num_map_2d_indxs,first_2d_indx)
 struct buf_2d_rec *result,*_2d;
 unsigned long row,col,select;
 double *min,*max,*setval,*addval;
 unsigned long *map_2d_indxs,*num_map_2d_indxs,*first_2d_indx;
{
 unsigned long num;
 double val;
 int is_sel;

 val = _2d->GetVal(_2d,row,col);
 is_sel = 0;
 if (select & 0x00100000) if (val != .0) is_sel = 1;

 if (select & 0x00010000)
    {num = (unsigned long) val;
     if ((num >= *first_2d_indx) && 
         ((num = (num - *first_2d_indx)) < *num_map_2d_indxs))
        val = map_2d_indxs[num];}
 if (!is_sel && (select & 0x000000ff))
    {if (select & 0x0000000f)
        if (select & 1) {if (val < *min) is_sel = 1;}
          else if (select & 2) {if (val > *min) is_sel = 1;}
          else if (select & 4) {if (val <= *min) is_sel = 1;}
          else {if (val >= *min) is_sel = 1;}
     if (!is_sel && (select & 0x000000f0))
        if (select & 0x00000010) {if (val < *max) is_sel = 1;}
          else if (select & 0x00000020) {if (val > *max) is_sel = 1;}
          else if (select & 0x00000040) {if (val <= *max) is_sel = 1;}
          else {if (val >= *max) is_sel = 1;}
    }
 if (is_sel)
    {if (select & 0x00007b00)
        {if (select & 0x00000100) val = *addval;
           else if (select & 0x00000200)
            {if (val < .0) val = -val;}
           else if (select & 0x00000800)
            {val += *addval;}
            else if (select & 0x00001000)
            {val = result->GetVal(result,row,col);
             val += *addval;}
            else if (select & 0x00002000)
            {val = -val;}
         result->SetVal(result,row,col,val);
        }
    }
   else if (select & 0x00000400) 
    result->SetVal(result,row,col,*setval);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
SelectAssign2d - ???
-----------------------------------------------------------------------*/

int
SelectAssign2d(result,_2d,select,min,max,setval,addval,
               map_2d_indxs,num_map_2d_indxs,first_2d_indx)
 struct buf_2d_rec *result,*_2d;
 unsigned long select;
 double min,max,setval,addval;
 unsigned long *map_2d_indxs,num_map_2d_indxs,first_2d_indx;
{
 unsigned long row,col,num;
 int is_sel;
 double val;

 PRT5(printf("SelectAssign2d select = %x min = %f max = %f setval = %f addval = %f num_map_2d_indxs = %d first_2d_indx = %d\n",
      select,min,max,setval,addval,num_map_2d_indxs,first_2d_indx);)

 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < result->dimx; col++)
       {val = _2d->GetVal(_2d,row,col);
        is_sel = 0;
        if (select & 0x00100000) if (val != .0) is_sel = 1;
        if (select & 0x00010000)
           {num = (unsigned long) val;
            if ((num >= first_2d_indx) &&
                ((num = (num - first_2d_indx)) < num_map_2d_indxs))
               {
                val = (double) map_2d_indxs[num];}
           }
        if (!is_sel && (select & 0x000000ff))
           {if (select & 0x0000000f)
               if (select & 1) {if (val < min) is_sel = 1;}
                 else if (select & 2) {if (val > min) is_sel = 1;}
                 else if (select & 4) {if (val <= min) is_sel = 1;}
                 else if (select & 8) {if (val >= min) is_sel = 1;}
            
            if (!is_sel && (select & 0x000000f0))
               if (select & 0x00000010) {if (val < max) is_sel = 1;}
                 else if (select & 0x00000020) {if (val > max) is_sel = 1;}
                 else if (select & 0x00000040) {if (val <= max) is_sel = 1;}
                 else if (select & 0x00000080) {if (val >= max) is_sel = 1;}
           }
        if (is_sel)
           {if (select & 0x00007b00)
               {if (select & 0x00000100) val = addval;
                  else if (select & 0x00000200)
                   {if (val < .0) val = -val;}
                  else if (select & 0x00000800)
                   {val += addval;}
                  else if (select & 0x00001000)
                   {val = result->GetVal(result,row,col);
                    val += addval;}
                  else if (select & 0x00002000)
                   {val = -val;}
                result->SetVal(result,row,col,val);}
/*
            if (select & 0x10000000)
               printf("%d/%d val = %f val1 = %f \n",row,col,val,val1);
*/
           }
          else if (select & 0x00000400) 
           {
            result->SetVal(result,row,col,setval);
/*
            if (select & 0x10000000)
               printf("%d) %d/%d val = %f val1 = %f\n",cnt,row,col,val,val1);
*/
           }
       }
/*
 printf("SelectAssign2d select = %x min = %f max = %f setval = %f addval = %f num_map_2d_indxs = %d first_2d_indx = %d\n",
      select,min,max,setval,addval,num_map_2d_indxs,first_2d_indx);
*/
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Assign2dByGeneralMask - ???
-----------------------------------------------------------------------*/

/*
 if (mask(row,col))
    if (select & 0x00002000) result(row,col) = -src(row,col);
      else result(row,col) = src(row,col);
*/

int
Assign2dByGeneralMask(result,src,mask,select)
 struct buf_2d_rec *result,*src,*mask;
 unsigned long select;
{
 long row,col;
 double val;

 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < result->dimx; col++)
       if ((val = mask->GetVal(mask,row,col)) != .0)
          {val = src->GetVal(src,row,col);
           if (select & 0x00002000) val = -val;
           result->SetVal(result,row,col,val);
          }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
FindBitmapBound - ???
-----------------------------------------------------------------------*/

int
FindBitmapBound(_2d,bound,is_empty)
 struct buf_2d_rec *_2d;
 struct int_bound_rec *bound;
 int *is_empty;
{
 unsigned long row_bytes,first;
 long row,col,cnt;

 row_bytes = GetRowBytes(_2d->dimx,_2d->pixel_depth);
 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < row_bytes; col++)
       if (_2d->buf[row][col])
          {bound->top = row;
           break;}
 if (row == _2d->dimy) 
    {setup_int_bound_rec(bound,0,0,-1,-1);
     *is_empty = 1;
     return NO_ERROR;}
 *is_empty = 0;
 for (col = 0; col < row_bytes; col++)
    for (row = 0; row < _2d->dimy; row++)
       if (_2d->buf[row][col])
          {for (cnt = 7; cnt > 0; cnt--)
              if (_2d->buf[row][col] & _EdgeBit[cnt]) break;
           cnt = col * 8 + 7 - cnt;
           if (cnt >= _2d->dimx) cnt = _2d->dimx - 1;
           bound->left = cnt;
           first = col;
           break;}

 for (col = _2d->dimx - 1; col >= first; col--)
    for (row = 0; row < _2d->dimy; row++)
       if (_2d->buf[row][col])
          {for (cnt = 0; cnt < 8; cnt++)
              if (_2d->buf[row][col] & _EdgeBit[cnt]) break;
           cnt = col * 8 + 7 - cnt;
           if (cnt < 0) cnt = 0;
           bound->right = cnt;
           break;}

 /* FIXME!!  The following code appears to be broken, since the break
    statement exits only the innermost for loop.  -PWH 19990302 */
 for (row = _2d->dimy - 1; row > bound->top; row--)
    for (col = 0; col < row_bytes; col++)
       if (_2d->buf[row][col])
          break;
 bound->bottom = row;
 return NO_ERROR;
}


/*----------------------------------------------------------------------
pr_buf_2d_rec - ???
-----------------------------------------------------------------------*/

int
pr_buf_2d_rec(_2d)
 struct buf_2d_rec *_2d;
{
 static void *GetVals[] = {(void *) Get2dFloat,(void *) Get2dDouble,
         (void *) Get2dUnsignedBit,(void *) Get2dUnsignedByte,
         (void *) Get2dUnsignedShort,(void *) Get2dUnsignedLong,
         (void *) Get2dUnsignedGeneral,(void *) Get2dSignedByte,
         (void *) Get2dSignedShort,(void *) Get2dSignedLong,
         (void *) Get2dSignedGeneral
        };
 static char *GetLabels[] = {"Get2dFloat","Get2dDouble","Get2dUnsignedBit",
     "Get2dUnsignedByte","Get2dUnsignedShort","Get2dUnsignedLong","Get2dUnsignedGeneral",
      "Get2dSignedByte","Get2dSignedShort","Get2dSignedLong","Get2dSignedGeneral"
     };
 static long num_GetVals = 11;

 static void *SetVals[] = {(void *) Set2dFloat,(void *) Set2dDouble,
         (void *) Set2dUnsignedBit,(void *) Set2dUnsignedByte,
         (void *) Set2dUnsignedShort,(void *) Set2dUnsignedLong,
         (void *) Set2dUnsignedGeneral,(void *) Set2dSignedByte,
         (void *) Set2dSignedShort,(void *) Set2dSignedLong,
         (void *) Set2dSignedGeneral,
        };

 static char *SetLabels[] = {"Set2dFloat","Set2dDouble","Set2dUnsignedBit",
     "Set2dUnsignedByte","Set2dUnsignedShort","Set2dUnsignedLong","Set2dUnsignedGeneral",
     "Set2dSignedByte","Set2dSignedShort","Set2dSignedLong","Set2dSignedGeneral"
    };
 static long num_SetVals = 11;
 unsigned long lcv;

 printf("pr_buf_2d_rec...begin\n");
 printf("..status4 = %x  prog_status2 = %x...startx = %ld   starty = %ld\n",
     (unsigned int) _2d->status4,(unsigned int) _2d->prog_status2,
      _2d->startoffx,_2d->startoffy);
 if (_2d->prog_status2 & BUF_OWN_CONTIGUOUS_MEMORY)
    printf("BUF_OWN_CONTIGUOUS_MEMORY...\n");
 if (_2d->status4 & BUF_VALUE_SIGNED)
    printf("BUF_VALUE_SIGNED...\n");
 if (_2d->status4 & BUF_VALUE_FLOAT)
    printf("BUF_VALUE_FLOAT...\n");
   else if (_2d->status4 & BUF_VALUE_DOUBLE)
    printf("BUF_VALUE_DOUBLE...\n");
 printf("..dimx = %ld  dimy = %ld  dimx * dimy = %ld total_bytes = %lu depth = %ld\n",_2d->dimx, _2d->dimy,_2d->dimx * _2d->dimy,
         _2d->total_bytes,_2d->pixel_depth);
 if (_2d->status4 & BUF_NON_EMPTY)
    printf("BUF_NON_EMPTY   buf = %p\n",_2d->buf);
 if (_2d->status4 & BUF_DATA_VALID) printf("BUF_DATA_VALID\n");
 if (_2d->GetVal != NULL)
    for (lcv = 0; lcv < num_GetVals; lcv++)
       if (GetVals[lcv] == (void *) _2d->GetVal)
          printf("%s\n",GetLabels[lcv]);
 if (_2d->SetVal != NULL)
    for (lcv = 0; lcv < num_SetVals; lcv++)
       if (SetVals[lcv] == (void *) _2d->SetVal)
          printf("%s\n",SetLabels[lcv]);

 printf("...pr_buf_2d_rec...end\n");
 return NO_ERROR;
}

/*
    if ((void *) _2d->GetVal == (void *) Get2dSigned)
       printf("Get2dSigned\n");
      else if ((void *) _2d->GetVal == (void *) Get2dFloat)
       printf("Get2dFloat\n");
      else if ((void *) _2d->GetVal == (void *) Get2dDouble)
       printf("Get2dDouble\n");
      else if ((void *) _2d->GetVal == (void *) Get2dUnsignedByte)
       printf("Get2dUnsignedByte\n");
      else if ((void *) _2d->GetVal == (void *) Get2dUnsignedBit)
       printf("Get2dUnsignedBit\n");
      else if ((void *) _2d->GetVal == (void *) Get2dUnsignedShort)
       printf("Get2dUnsignedShort\n");
      else if ((void *) _2d->GetVal == (void *) Get2dUnsignedLong)
       printf("Get2dUnsignedLong\n");
      else if ((void *) _2d->GetVal == (void *) Get2dUnsignedGeneral)
       printf("Get2dUnsignedGeneral\n");
 if (_2d->SetVal != NULL)
    if ((void *) _2d->SetVal == (void *) Set2dSigned)
       printf("Set2dSigned\n");
      else if ((void *) _2d->SetVal == (void *) Set2dFloat)
       printf("Set2dFloat\n");
      else if ((void *) _2d->SetVal == (void *) Set2dDouble)
       printf("Set2dDouble\n");
      else if ((void *) _2d->SetVal == (void *) Set2dUnsigned)
       printf("Set2dUnsignedByte\n");
*/


/*----------------------------------------------------------------------
pr_buf_2d_rec_addr - ???
-----------------------------------------------------------------------*/

void
pr_buf_2d_rec_addr(_2d)
 struct buf_2d_rec *_2d;
{
 unsigned long row,num_bytes,cnt;

 pr_buf_2d_rec(_2d);
 if (_2d->status4 & BUF_NON_EMPTY)
    {num_bytes = _2d->pixel_depth / 8;
     for (cnt = row = 0; row < _2d->dimy; row++)
       {printf("%ld) %p",row,_2d->buf[row]);
        if (((row + 1) < _2d->dimy) && (row != 0))
           printf(" %d ",(_2d->buf[row] - _2d->buf[row - 1]) / 2);
          else printf(" ");
        cnt++;
        if (cnt == 5)
           {printf("\n");cnt = 0;}
       }
    }
 printf("...pr_buf_2d_rec_addr...end\n");
}


/*----------------------------------------------------------------------
Pr2dValues - ???
-----------------------------------------------------------------------*/

void
Pr2dValues(_2d)
 struct buf_2d_rec *_2d;
{
 unsigned long row,col,cnt;
 double val;

 pr_buf_2d_rec(_2d);
 for (cnt = 0,row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col++)
       {val = _2d->GetVal(_2d,row,col);
        printf("%lu,%lu = %.4f ",row,col,val);
        cnt += 1;
        if (cnt == 5)
           {printf("\n");
            cnt = 0;}
       }
 printf("\n");
}

