/****************************************************************************
2dminmaxscal.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 2dminmaxscal.c,v 1.9 1999/07/07 18:01:05 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <math.h>

#include <sys/types.h>
#include <sys/timeb.h>

#include "common.h"
#include "rect.h"
#include "error_constants.h"
#include "nria_lib.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
*/

#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT3(x)
#define PRT2(x)


/* Private functions */
extern int Byte2dMinMax(unsigned char **_2d, unsigned long dimx,
    unsigned long dimy, unsigned long *min, unsigned long *max,
    int exclude_range, double range_min, double range_max);
extern int Short2dMinMax(unsigned short **_2d, unsigned long dimx,
    unsigned long dimy, unsigned long *min, unsigned long *max,
    int exclude_range, double range_min, double range_max);
extern int Int2dMinMax(unsigned long **_2d, unsigned long dimx,
    unsigned long dimy, unsigned long *min, unsigned long *max,
    int exclude_range, double range_min, double range_max);
extern double ScaleVal(double old_val, double old_min, double old_max,
    double new_min, double new_max);
extern int Scale2dBytes(unsigned char **out_2d, unsigned char **in_2d,
    unsigned long dimx, unsigned long dimy, double min, double max,
    double new_min, double new_max, int exclude_range, double range_min,
    double range_max);
extern int Scale2dShorts(unsigned short **out_2d, unsigned short **in_2d,
    unsigned long dimx, unsigned long dimy, double min, double max,
    double new_min, double new_max, int exclude_range, double range_min,
    double range_max);
extern int Scale2dInts(unsigned int **out_2d, unsigned int **in_2d,
    unsigned long dimx, unsigned long dimy, double min, double max,
    double new_min, double new_max, int exclude_range, double range_min,
    double range_max);
extern int MinMax2dByMaskProc(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, double *min, double *max);
extern double Scaled2dPixelValue(struct buf_2d_rec *in_2d, unsigned long row,
    unsigned long col, double new_min, double new_max, int exclude_range,
    double range_min, double range_max);
extern int Scale2dValues(struct buf_2d_rec *result, struct buf_2d_rec *_2d,
    double min, double max, int exclude_range, double range_min,
    double range_max, double newmin, double newmax);
extern int Scale2dByMaskProc(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, struct buf_2d_rec *dest, double *ratio, double *old_min,
    double *old_max, double *new_min, double *new_max);
extern int Assin2dMinMaxSetVals(struct buf_2d_rec *dst,
    struct buf_2d_rec *src);



/*---------------------------------------------------------------------
Byte2dMinMax - ???
----------------------------------------------------------------------*/

int
Byte2dMinMax(_2d,dimx,dimy,min,max,exclude_range,range_min,range_max)
 unsigned char **_2d;
 unsigned long dimx,dimy;
 unsigned long *min,*max;
 int exclude_range;
 double range_min,range_max;
{
 unsigned long row,col;

 *min = 0xffffffff;
 *max = 0;
 if (exclude_range)
    {for (row = 0; row < dimy; row++)
        for (col = 0; col < dimx; col++)
           if (((double) _2d[row][col] < range_min) || ((double) _2d[row][col] > range_max))
              {if (_2d[row][col] < *min) *min = _2d[row][col];
               if (_2d[row][col] > *max) *max = _2d[row][col];}
    }
   else 
    for (row = 0; row < dimy; row++)
       for (col = 0; col < dimx; col++)
          {if (_2d[row][col] < *min) *min = _2d[row][col];
           if (_2d[row][col] > *max) *max = _2d[row][col];}
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Short2dMinMax - ???
----------------------------------------------------------------------*/

int
Short2dMinMax(_2d,dimx,dimy,min,max,exclude_range,range_min,range_max)
 unsigned short **_2d;
 unsigned long dimx,dimy;
 unsigned long *min,*max;
 int exclude_range;
 double range_min,range_max;
{
 unsigned long row,col;

 *min = 0xffffffff;
 *max = 0;
 if (exclude_range)
    {for (row = 0; row < dimy; row++)
        for (col = 0; col < dimx; col++)
           if (((double) _2d[row][col] < range_min) || ((double) _2d[row][col] > range_max))
              {if (_2d[row][col] < *min) *min = _2d[row][col];
               if (_2d[row][col] > *max) *max = _2d[row][col];}
    }
   else 
    for (row = 0; row < dimy; row++)
       for (col = 0; col < dimx; col++)
          {if (_2d[row][col] < *min) *min = _2d[row][col];
           if (_2d[row][col] > *max) *max = _2d[row][col];}
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Int2dMinMax - ???
----------------------------------------------------------------------*/

int
Int2dMinMax(_2d,dimx,dimy,min,max,exclude_range,range_min,range_max)
 unsigned long **_2d;
 unsigned long dimx,dimy;
 unsigned long *min,*max;
 int exclude_range;
 double range_min,range_max;
{
 unsigned long row,col;

 *min = 0xffffffff;
 *max = 0;
 if (exclude_range)
    {for (row = 0; row < dimy; row++)
        for (col = 0; col < dimx; col++)
           if (((double) _2d[row][col] < range_min) || ((double) _2d[row][col] > range_max))
              {if (_2d[row][col] < *min) *min = _2d[row][col];
               if (_2d[row][col] > *max) *max = _2d[row][col];}
    }
   else 
    for (row = 0; row < dimy; row++)
       for (col = 0; col < dimx; col++)
          {if (_2d[row][col] < *min) *min = _2d[row][col];
           if (_2d[row][col] > *max) *max = _2d[row][col];}
 PRT3(printf("Int2dMinMax exclude_range = %d dimx = %d dimy = %d min = %d max = %d\n",exclude_range,dimx,dimy,*min,*max))
 return NO_ERROR;
}


/*---------------------------------------------------------------------
MinMax2dValues - ???
----------------------------------------------------------------------*/

int
MinMax2dValues(_2d,exclude_range,range_min,range_max,min,max)
 struct buf_2d_rec *_2d;
 int exclude_range;
 double range_min,range_max,*min,*max;
{
 unsigned long row,col;
 double val;

 *max = *min = (double) _2d->GetVal(_2d,0,0);
 if (exclude_range)
    for (row = 0; row < _2d->dimy; row++)
       for (col = 0; col < _2d->dimx; col++)
          {val = (double) _2d->GetVal(_2d,row,col);
           if ((val < range_min) || (val > range_max))
              {if (val > *max) *max = val;
               if (val < *min) *min = val;}
          }
   else
    for (row = 0; row < _2d->dimy; row++)
       for (col = 0; col < _2d->dimx; col++)
          {val = (double) _2d->GetVal(_2d,row,col);
           if (val > *max) *max = val;
           if (val < *min) *min = val;}
 return NO_ERROR;
}


/*---------------------------------------------------------------------
MinMax2d - ???
----------------------------------------------------------------------*/

int
MinMax2d(_2d,exclude_range,range_min,range_max)
 struct buf_2d_rec *_2d;
 int exclude_range;
 double range_min,range_max;
{
 unsigned long min,max;

 TRACE(printf("computing min max...1\n"))
 if (!(_2d->status4 & BUF_MIN_MAX_COMPUTED))
    {TRACE(printf("computing min max...2\n"));
     if (!(_2d->status4 & BUF_PIXEL_SIGNED))
        {switch (_2d->pixel_depth)
            {case 8 : 
                Byte2dMinMax(_2d->buf,_2d->dimx,_2d->dimy,&min,&max,
                        exclude_range,range_min,range_max);
                break;
             case 16 : 
                Short2dMinMax(_2d->buf,_2d->dimx,_2d->dimy,&min,&max,
                        exclude_range,range_min,range_max);
                break;
             case 32 :
                PRT3(pr_buf_2d_rec(_2d))
                Int2dMinMax(_2d->buf,_2d->dimx,_2d->dimy,&min,&max,
                        exclude_range,range_min,range_max);
                break;
             default : 
                MinMax2dValues(_2d,exclude_range,range_min,range_max,
                         &(_2d->minval),&(_2d->maxval));
                _2d->status4 |= BUF_MIN_MAX_COMPUTED;
                return NO_ERROR;
            }  /* switch */
         _2d->minval = (double) min;
         _2d->maxval = (double) max;
        } /* not signed data */
       else {
	 MinMax2dValues(_2d,exclude_range,range_min,range_max,
			&(_2d->minval),&(_2d->maxval));
       } /* signed data */

     _2d->status4 |= BUF_MIN_MAX_COMPUTED;
     TRACE(printf("min = %f   max = %f\n",_2d->minval,_2d->maxval))
     return NO_ERROR;
    }
 TRACE(printf("min = %f   max = %f\n",_2d->minval,_2d->maxval))
 return NO_ERROR;    /* Added by PWH 19990305 */
}



/*---------------------------------------------------------------------
Default2dMinMax - ???
----------------------------------------------------------------------*/

void
Default2dMinMax(
     struct buf_2d_rec *_2d,
    double *minval,
    double *maxval,
    int exclude_range,
    double range_min,
    double range_max)
{
 if (_2d->status4 & BUF_MIN_MAX_SET)
    {*minval = _2d->minval_set;
     *maxval = _2d->maxval_set;
    }
   else
    {MinMax2d(_2d,exclude_range,range_min,range_max);
     *minval = _2d->minval;
     *maxval = _2d->maxval;}
}



/*---------------------------------------------------------------------
MinMax2dByMaskProc - ???
----------------------------------------------------------------------*/

int
MinMax2dByMaskProc(_2d,row,col,min,max)
 struct buf_2d_rec *_2d;      
 unsigned long row,col;
 double *min,*max;
{
 double value;

 value = (double) _2d->GetVal(_2d,row,col);
 if (value > *max) *max = value;
 if (value < *min) *min = value;
 return NO_ERROR;
}



/*---------------------------------------------------------------------
MinMax2dByMask - ???
----------------------------------------------------------------------*/

int
MinMax2dByMask(
    struct buf_2d_rec *_2d,
    unsigned long startleft,
    unsigned long starttop,
    struct buf_2d_rec *mask,
    struct int_bound_rec *bound,
    double *min,
    double *max)
{
 int err;

 GetMinMaxValues(_2d,max,min);
 err = process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,bound,
                           MinMax2dByMaskProc,min,max,0,0,0,0,0,0,0);
 TRACE(printf("min_max_2d_by_mask min = %f max = %f err = %d\n",
        *min,*max,err))
 return err;
}



/*---------------------------------------------------------------------
ScaleVal - ???
----------------------------------------------------------------------*/

double 
ScaleVal(old_val,old_min,old_max,new_min,new_max)
 double old_val,old_min,old_max,new_min,new_max;
{
 double old_height,new_height,ratio,val;

 if ((old_min == new_min) && (old_max == new_max)) return old_val;
 if ((new_min == new_max) || (old_min == old_max)) return new_min;
 if (old_val >= old_max) return new_max;
 if (old_val <= old_min) return new_min;

 old_height = old_max - old_min + 1;
 new_height = new_max - new_min + 1;
 ratio = new_height / old_height;
 val = new_min + floor((old_val - old_min) * ratio + .5);
 return val;
}


/*---------------------------------------------------------------------
Scaled2dPixelValue - ???
----------------------------------------------------------------------*/

double 
Scaled2dPixelValue(in_2d,row,col,new_min,new_max,
                          exclude_range,range_min,range_max)
 struct buf_2d_rec *in_2d;
 unsigned long row,col;
 int exclude_range;
 double new_min,new_max,range_min,range_max;
{
 double val,old_min,old_max;

 if ((in_2d->status4 & BUF_MIN_MAX_SET))
    {old_min = in_2d->minval_set;
     old_max = in_2d->maxval_set;}
   else
    {if (!(in_2d->status4 & BUF_MIN_MAX_COMPUTED))
        MinMax2d(in_2d,exclude_range,range_min,range_max);
     old_min = in_2d->minval;
     old_max = in_2d->maxval;}
 val = (double) in_2d->GetVal(in_2d,row,col);
 if (!exclude_range)
    val = ScaleVal(val,old_min,old_max,new_min,new_max);
   else if ((val < range_min) || (val > range_max))
    val = ScaleVal(val,old_min,old_max,new_min,new_max);
   else if (exclude_range & 0x0000000e)
    if (exclude_range & 2)
       val = new_min;
      else if (exclude_range & 8)
       val = 0;
 return val;
}


/*---------------------------------------------------------------------
Scale2dBytes - ???
----------------------------------------------------------------------*/

int
Scale2dBytes(out_2d,in_2d,dimx,dimy,min,max,new_min,new_max,
               exclude_range,range_min,range_max)
 unsigned char **out_2d,**in_2d;
 unsigned long dimx,dimy;
 double min,max,new_min,new_max,range_min,range_max;
 int exclude_range;
{
 unsigned long row,col;
 double height,new_height,ratio;
 unsigned long new_min1,new_max1,tempmax,tempmin;
 long num;
 static unsigned char buf[256];
 static double last_min,last_max,last_new_min,last_new_max;
 static char first = 1;

 TRACE(printf("Scale2dBytes...in_2d = %u  out_2d = %u min = %f max = %f  new_min = %f  new_max = %f\n",in_2d,out_2d,
    min,max,new_min,new_max))
 if ((min == new_min) && (max == new_max) && (in_2d == out_2d))
    return NO_ERROR;
 new_min1 = (unsigned long) new_min;
 new_max1 = (unsigned long) new_max;
 if ((new_min == new_max) || (min == max))
    {if (exclude_range)
        {for (row = 0; row < dimy; row++)
            for (col = 0; col < dimx; col++)
               if (((double) in_2d[row][col] < range_min) || 
                   ((double) in_2d[row][col] > range_max))
                  out_2d[row][col] = new_min1;
                 else if (exclude_range & 0x0000000e)
                  if (exclude_range & 2)
                     out_2d[row][col] = new_min1;
                    else if (exclude_range & 4)
                     out_2d[row][col] = in_2d[row][col];
                    else out_2d[row][col] = 0;
        }
       else
        for (row = 0; row < dimy; row++)
           for (col = 0; col < dimx; col++)
              out_2d[row][col] = new_min1;
     return NO_ERROR;
    }

 height = max - min;
 new_height = new_max - new_min;
 ratio = new_height / height;
 if (first || (last_min != min) || (last_max != max) ||
     (last_new_min != new_min) || (last_new_max != new_max))
    {
     first = 0;
     last_min = min;
     last_max = max;
     last_new_min = new_min;
     last_new_max = new_max;
     if (min > 255) tempmin = 255;
       else tempmin = (unsigned long) floor(min + .5);
     for (row = 0; row < tempmin; row++)
         buf[row] = new_min;

     if (max > 255) tempmax = 255;
       else tempmax = (unsigned long) floor(max + .5);
     for (row = tempmin; row <= tempmax; row++)
        {num = new_min1 + (long) floor((double) ((row - min) * ratio + .5));
         if (num > new_max1)
            {buf[row] = new_max1;}
           else if (num < new_min1)
             {buf[row] = new_min1;}
           else buf[row] = num;
        }
     for (row = tempmax; row < 256; row++)
         buf[row] = new_max1;
    }

 if (exclude_range)
    {for (row = 0; row < dimy; row++)
        for (col = 0; col < dimx; col++)
           if (((double) in_2d[row][col] < range_min) ||
               ((double) in_2d[row][col] > range_max))
              out_2d[row][col] = buf[in_2d[row][col]];
             else if (exclude_range & 0x0000000e)
              if (exclude_range & 2)
                out_2d[row][col] = new_min1;
               else if (exclude_range & 4)
                out_2d[row][col] = in_2d[row][col];
               else out_2d[row][col] = 0;
    }
   else
    for (row = 0; row < dimy; row++)
       for (col = 0; col < dimx; col++)
          out_2d[row][col] = buf[in_2d[row][col]];
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Scale2dShorts - ???
----------------------------------------------------------------------*/

int
Scale2dShorts(out_2d,in_2d,dimx,dimy,min,max,new_min,new_max,
               exclude_range,range_min,range_max)
 unsigned short **out_2d,**in_2d;
 unsigned long dimx,dimy;
 double min,max,new_min,new_max,range_min,range_max;
 int exclude_range;
{
 unsigned long row,col;
 long new_min1,new_max1,num;
 double height,new_height,ratio;

 /*printf("Scale2dShorts...\n");*/
 if ((min == new_min) && (max == new_max) && (in_2d == out_2d))
    return NO_ERROR;
 new_min1 = (unsigned long) new_min;
 new_max1 = (unsigned long) new_max;
 if ((new_min == new_max) || (min == max))
    {if (exclude_range)
        {for (row = 0; row < dimy; row++)
            for (col = 0; col < dimx; col++)
               if (((double) in_2d[row][col] < range_min) ||
                   ((double) in_2d[row][col] > range_max))
                  out_2d[row][col] = new_min1;
                 else if (exclude_range & 0x0000000e)
                  if (exclude_range & 2)
                     out_2d[row][col] = new_min1;
                    else if (exclude_range & 4)
                     out_2d[row][col] = in_2d[row][col];
                    else out_2d[row][col] = 0;
        }
       else
        for (row = 0; row < dimy; row++)
           for (col = 0; col < dimx; col++)
              out_2d[row][col] = new_min1;
     return NO_ERROR;
    }

 height = max - min;
 new_height = new_max - new_min;
 ratio = new_height / height;

 if (exclude_range)
    {for (row = 0; row < dimy; row++)
       for (col = 0; col < dimx; col++)
          if (((double) in_2d[row][col] < range_min) ||
              ((double) in_2d[row][col] > range_max))
             {if ((double) in_2d[row][col] <= min) out_2d[row][col] = new_min1;
                else if ((double) in_2d[row][col] >= max) 
                 out_2d[row][col] = new_max1;
                else
                 {
                  num = new_min1 + 
                      (long) floor((double)(((double) in_2d[row][col] - min) 
                                    * ratio + .5));
                  if (num < new_min1) out_2d[row][col] = new_min1;
                    else if (num > new_max1) out_2d[row][col] = new_max1;
                    else out_2d[row][col] = num;
                 }
             }
            else if (exclude_range & 0x0000000e)
             if (exclude_range & 2)
                out_2d[row][col] = new_min1;
               else if (exclude_range & 4)
                out_2d[row][col] = in_2d[row][col];
               else out_2d[row][col] = 0;
    }
   else
    for (row = 0; row < dimy; row++)
       for (col = 0; col < dimx; col++)
          if ((double) in_2d[row][col] <= min) out_2d[row][col] = new_min1;
            else if ((double) in_2d[row][col] >= max) 
             out_2d[row][col] = new_max1;
            else
             {num = new_min1 +  
                (long) floor((double)(((double) in_2d[row][col] - min)
                      * ratio + .5));
              if (num < new_min1) out_2d[row][col] = new_min1;
                else if (num > new_max1) out_2d[row][col] = new_max1;
                else out_2d[row][col] = num;
             }
 /*printf("Scale2dShorts...end\n");*/
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Scale2dInts - ???
----------------------------------------------------------------------*/

int
Scale2dInts(out_2d,in_2d,dimx,dimy,min,max,new_min,new_max,
               exclude_range,range_min,range_max)
 unsigned int **out_2d,**in_2d;
 unsigned long dimx,dimy;
 double min,max,new_min,new_max,range_min,range_max;
 int exclude_range;
{
 unsigned long row,col;
 double ratio,height,new_height;
 unsigned long new_min1,new_max1;
 long num;

 if ((min == new_min) && (max == new_max) && (in_2d == out_2d))
    return NO_ERROR;
 new_min1 = (unsigned long) new_min;
 new_max1 = (unsigned long) new_max;
 PRT3(printf("Scale2dInts(...exclude_range  = %d new_min = %f new_max = %f\n",
           exclude_range,new_min,new_max))
 PRT3(printf("new_min1 = %d new_max1 = %d\n",new_min1,new_max1))
 PRT3(printf("min = %f max = %f\n",min,max))
 if ((new_min == new_max) || (min == max))
    {
     PRT3(printf("new_min == new_max) || (min == max\n"))
     if (exclude_range)
        {for (row = 0; row < dimy; row++)
            for (col = 0; col < dimx; col++)
               if ((in_2d[row][col] < range_min) ||
                   (in_2d[row][col] > range_max))
                  out_2d[row][col] = new_min1;
                 else if (exclude_range & 0x0000000e)
                  if (exclude_range & 2)
                     out_2d[row][col] = new_min1;
                    else if (exclude_range & 4)
                     out_2d[row][col] = in_2d[row][col];
                    else out_2d[row][col] = 0;
        }
       else
        for (row = 0; row < dimy; row++)
           for (col = 0; col < dimx; col++)
              out_2d[row][col] = new_min1;
     return NO_ERROR;
    }
 height = max - min;
 new_height = new_max - new_min;
 ratio = new_height / height;

 PRT3(printf("exclude_range = %d new_height = %f height = %f ratio = %f\n",
         exclude_range,new_height,height,ratio))
 if (exclude_range)
    {for (row = 0; row < dimy; row++)
       for (col = 0; col < dimx; col++)
          if ((in_2d[row][col] < range_min) || (in_2d[row][col] > range_max))
             {if (in_2d[row][col] <= min) out_2d[row][col] = new_min1;
                else if (in_2d[row][col] >= max) out_2d[row][col] = new_max1;
                else
                 {num = new_min1 +  
                     (long) floor((double)((in_2d[row][col] - min) * ratio + .5));
                  if (num < new_min1) out_2d[row][col] = new_min1;
                    else if (num > new_max1) out_2d[row][col] = new_max1;
                    else out_2d[row][col] = num;
                 }
             }
            else if (exclude_range & 0x0000000e)
             if (exclude_range & 2)
                out_2d[row][col] = new_min1;
               else if (exclude_range & 4)
                out_2d[row][col] = in_2d[row][col];
               else out_2d[row][col] = 0;
    }
   else
    for (row = 0; row < dimy; row++)
       for (col = 0; col < dimx; col++)
          if (in_2d[row][col] <= min) out_2d[row][col] = new_min1;
            else if (in_2d[row][col] >= max) out_2d[row][col] = new_max1;
            else
             {num = new_min1 +  
                (long) floor((double)((in_2d[row][col] - min) * ratio + .5));
              if (num < new_min1) out_2d[row][col] = new_min1;
                else if (num > new_max1) out_2d[row][col] = new_max1;
                else out_2d[row][col] = num;
             }
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Scale2dValues - ???
----------------------------------------------------------------------*/

int
Scale2dValues(result,_2d,min,max,exclude_range,range_min,range_max,newmin,newmax)
 struct buf_2d_rec *result,*_2d;
 double min,max,range_min,range_max,newmin,newmax;
 int exclude_range;
{
 unsigned long row,col;
 double val,ratio;

 if (max == min) ratio = .0;
   else ratio = (newmax - newmin) / (max - min);
 PRT2(if (exclude_range)
         printf("range_min = %f range_max = %f\n",range_min,range_max))

 PRT2(printf("Scale2dValues newmin = %f newmax = %f min = %f max = %f\n",
       newmin,newmax,min,max))
 if (exclude_range)
    {for (row = 0; row < result->dimy; row++)
        for (col = 0; col < result->dimx; col++)
           {val = (double) _2d->GetVal(_2d,row,col);
            if ((val < range_min) || (val > range_max))
               {val = (val - min) * ratio + newmin;
                if (val < newmin) val = newmin;
                  else if (val > newmax) val = newmax;
                result->SetVal(result,row,col,val);}
              else if (exclude_range & 0x0000000e)
               if (exclude_range & 2)
                  result->SetVal(result,row,col,newmin);
                else if (exclude_range & 4)
                  result->SetVal(result,row,col,val);
                else result->SetVal(result,row,col,(double) .0);
           }
    }
   else if (min <= max)
    {
     PRT2(printf("Scale2dValues ratio = %f\n",ratio))
     for (row = 0; row < result->dimy; row++)
       for (col = 0; col < result->dimx; col++)
          {val = (double) _2d->GetVal(_2d,row,col);
           if (val <= min) val = newmin;
             else if (val >= max) val = newmax;
             else val = (val - min) * ratio + newmin;
           result->SetVal(result,row,col,val);}
    }
   else 
    for (row = 0; row < result->dimy; row++)
       for (col = 0; col < result->dimx; col++)
          {val = (double) _2d->GetVal(_2d,row,col);
           val = (val - min) * ratio + newmin;
           if (val < newmin) val = newmin;
             else if (val > newmax) val = newmax;
           result->SetVal(result,row,col,val);}
 return NO_ERROR;
}

/*-------------------------------------------------------------------------
Scale2dPixels - ???

if use_which_min_max == 0 then use BUF_MIN_MAX_SET or BUF_MIN_MAX_COMPUTED
   if use_which_min_max == 1 then use BUF_MIN_MAX_SET
   if use_which_min_max == 2 then use BUF_MIN_MAX_COMPUTED
--------------------------------------------------------------------------*/

int
Scale2dPixels(
    struct buf_2d_rec *out_2d,
    struct buf_2d_rec *in_2d,
    double min,
    double max,
    int exclude_range,
    double range_min,
    double range_max,
    int use_which_min_max)
{
 double min_val,max_val;

 TRACE(printf("scale min_val_set = %f  max_val_set = %f use_which_min_max = %d\n",
        in_2d->minval_set,in_2d->maxval_set,use_which_min_max))
 if (use_which_min_max == 1)
    {if (!(in_2d->status4 & BUF_MIN_MAX_SET)) return CANCEL;}
   else if (use_which_min_max == 0)
    {
     if (in_2d->status4 & BUF_MIN_MAX_SET)
        {TRACE(printf("scale BUF_MIN_MAX_SET\n"))
         use_which_min_max = 1;}
    }
 PRT3(printf("scale min = %f max = %f use_which_min_max = %d\n",min,max,use_which_min_max))
 if (use_which_min_max == 1)
    {min_val = in_2d->minval_set;
     max_val = in_2d->maxval_set;
     TRACE(printf("scale use_which_min_max == 1\n"))
    }
   else
    {if (!(in_2d->status4 & BUF_MIN_MAX_COMPUTED))
        {PRT3(printf("in_2d not BUF_MIN_MAX_COMPUTED\n"))
         MinMax2d(in_2d,exclude_range,range_min,range_max);}
     min_val = in_2d->minval;
     max_val = in_2d->maxval;}

 PRT3(printf("buf = %u scale...min_val = %f max_val = %f  min = %f max = %f\n",
             in_2d->buf,min_val,max_val,min,max);)

 if ((min_val == min) && (max_val == max))
    {
     if (in_2d != out_2d)
        {if (in_2d->pixel_depth != out_2d->pixel_depth)
            Assign2d(out_2d,in_2d);
           else copy_buf_2d_rec_content(out_2d,in_2d);
        }
     return NO_ERROR;
    }
 TRACE(printf("buf = %u ==scale...min_val = %f max_val = %f min = %f max = %f\n",
             in_2d->buf,min_val,max_val,min,max);)
 if ((in_2d->pixel_depth != out_2d->pixel_depth) || (min > max) ||
     (in_2d->status4 & BUF_PIXEL_SIGNED) || (out_2d->status4 & BUF_PIXEL_SIGNED))
    {PRT(printf("Scale2dPixels...signed\n"))
     Scale2dValues(out_2d,in_2d,
                  min_val,max_val,exclude_range,range_min,range_max,min,max);}
   else
    {PRT(printf("Scale2dPixels...unsigned\n"))
     switch (in_2d->pixel_depth)
        {case 8 : 
            Scale2dBytes(out_2d->buf,in_2d->buf,in_2d->dimx,in_2d->dimy,
             min_val,max_val,min,max,exclude_range,range_min,range_max);
            break;
         case 16 :
            Scale2dShorts(out_2d->buf,in_2d->buf,in_2d->dimx,in_2d->dimy,
                     min_val,max_val,min,max,exclude_range,range_min,range_max);
            break;
         case 32 :
            Scale2dInts(out_2d->buf,in_2d->buf,in_2d->dimx,in_2d->dimy,
                     min_val,max_val,min,max,exclude_range,range_min,range_max);
            break;
         default :
            PRT(printf("Scale2dPixels...unsigned\n"))
            Scale2dValues(out_2d,in_2d,
                  min_val,max_val,exclude_range,range_min,range_max,min,max);
            break;
        }
    }
 out_2d->minval_set = min;
 out_2d->maxval_set = max;
 out_2d->status4 |= BUF_MIN_MAX_SET;
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Scale2dByMaskProc - ???
----------------------------------------------------------------------*/

int
Scale2dByMaskProc(_2d,row,col,dest,ratio,old_min,old_max,new_min,new_max)
 struct buf_2d_rec *_2d,*dest;
 unsigned long row,col;
 double *ratio,*old_min,*old_max,*new_min,*new_max;
{
 double val;

 val = (double) _2d->GetVal(_2d,row,col);
 if (val <= *old_min) val = *new_min;
   else if (val >= *old_max) val = *new_max;
   else val = *new_min + floor((double) ((val - *old_min) * (*ratio) + .5));
 dest->SetVal(dest,row,col,val);
 return NO_ERROR;

}



/*---------------------------------------------------------------------
Scale2dByMask - ???
----------------------------------------------------------------------*/

int
Scale2dByMask(
    struct buf_2d_rec *_2d,
    struct buf_2d_rec *dest,
    unsigned long startleft,
    unsigned long starttop,
    struct buf_2d_rec *mask,
    struct int_bound_rec *bound,
    double old_min,
    double old_max,
    double new_min,
    double new_max)
{
 int err;
 double ratio;

 ratio = (new_max - new_min)  / (old_max - old_min);
 err = process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,
                 bound,Scale2dByMaskProc,dest,&ratio,
                  &old_min,&old_max,&new_min,&new_max,0,0,0);
 return err;

}


/*---------------------------------------------------------------------
ScaleAssign2d - ???
----------------------------------------------------------------------*/

int
ScaleAssign2d(_2d,src)
 struct buf_2d_rec *_2d,*src;
{
 unsigned long row,col,dimx,dimy;
 double minval,maxval,min,max,height,new_height,val,ratio;

 TRACE(printf("ScaleAssign2d...\n")) 

 MinMax2dValues(src,0,(double) .0,(double) .0,&min,&max);
 TRACE(printf("ScaleAssign2d...1\n")) 
 Default2dMinMax(_2d,&minval,&maxval,0,(double) .0,(double) .0);
 height = max - min;
 new_height = maxval - minval;
 ratio = new_height / height;
 dimy = _2d->dimy;
 if (dimy > src->dimy) dimy = src->dimy;
 dimx = _2d->dimx;
 if (dimx > src->dimx) dimx = src->dimx;
 for (row = 0; row < dimy; row++)
    {
     for (col = 0; col < dimx; col++)
        {val =  src->GetVal(src,row,col);
         val = minval + (val - min) * ratio;
         _2d->SetVal(_2d,row,col,val);
        }
    }
 TRACE(printf("ScaleAssign2d...2\n")) 
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Assin2dMinMaxSetVals - ???
----------------------------------------------------------------------*/

int
Assin2dMinMaxSetVals(dst,src)
 struct buf_2d_rec *dst,*src;
{
 if (src->status4 & BUF_MIN_MAX_SET)
    {dst->minval_set = src->minval_set;
     dst->maxval_set = src->maxval_set;
     dst->status4 |= BUF_MIN_MAX_SET;
    }
 return NO_ERROR;
}
