/****************************************************************************
3d_data.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 3d_data.c,v 1.6 1999/07/07 18:01:05 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <math.h>

#include <sys/types.h>

#include "geometry.h"
#include "buf_3d_rec.h"
#include "common.h"
#include "error_constants.h"
#include "ia_hdr.h"
#include "rect.h"
#include "nria_lib.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)



/*---------------------------------------------------------------------
Get3dValApprox - ???
----------------------------------------------------------------------*/

int
Get3dValApprox(_3d,x,y,z,value)
 struct buf_3d_rec *_3d;
 float x,y,z;
 double *value;
{
 long tx,ty,tz,px,py;
 double val;
 float disx,disy,disz,dx,dy,dz;
 struct buf_2d_rec *s1;
 struct slice_3d_rec *sl;

 TRACE(printf("Get3dValApprox\n"));
 dx = x - (double) ((long) _3d->startx);
 tx = (long) dx;
 disx = dx - (float) tx;
 if (disx >= .5) tx += 1;
 if ((dx < .0) || (tx < 0) || (tx >= _3d->dimx))
    {*value = 0;
     return CANCEL;}
 dy = y - (double) ((long) _3d->starty);
 ty = (long) dy;
 disy = dy - (float) ty;
 if (disy >= .5) ty += 1;
 if ((dy < .0) || (ty < 0) || (ty >= _3d->dimy))
    {*value = 0;
     return CANCEL;}
 dz = z - (double) ((long) _3d->startz);
 tz = (long) dz;
 disz = dz - (float) tz;
 if (disz >= .5) tz += 1;
 if ((dz < .0) || (tz < 0) || (tz >= _3d->dimz))
    {*value = 0;
     return CANCEL;}

 sl = &(_3d->sls[tz]);
 if ((sl == NULL) || ((s1 = sl->s1) == NULL))
    {*value = 0;
     return CANCEL;}

 px = tx - (long) s1->startoffx;
 py = ty - (long) s1->startoffy;
 if (((sl->ratio > .5) && (sl->s2 != NULL)) ||
     (px < 0) || (py < 0) ||
     (px >= s1->dimx) || (py >= s1->dimy))
    {if (sl->s2 == NULL) val = .0;
       else 
        {px = tx - (long) sl->s2->startoffx;
         py = ty - (long) sl->s2->startoffy;
         if ((px >= 0) && (py >= 0) &&
             (py < sl->s2->dimy) && (px < sl->s2->dimx))
            val = sl->s2->GetVal(sl->s2,py,px);
           else val = .0;
        }
    }
   else val = s1->GetVal(s1,py,px);
 *value = val;
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Get3dVal - ???
----------------------------------------------------------------------*/

int
Get3dVal(_3d,x,y,z,value)
 struct buf_3d_rec *_3d;
 float x,y,z;
 double *value;
{
 double val,val2,fval,fval1;
 long tx,ty,tz,px,py,px2,py2,nx2,ny2,nx,ny,nz;
 float dx,dy,dz,disx,disy,disz,ndisz,ndisx_ndisy,disx_ndisy,ndisx_disy,disx_disy;
 struct buf_2d_rec *s1,*s2;
 struct slice_3d_rec *sl;

 TRACE(printf("Get3dVal\n"));
 dx = x - (double) ((long) _3d->startx);
 tx = (long) dx;
 if ((dx < .0) || (tx < 0) || (tx >= _3d->dimx))
    {*value = 0;
     return CANCEL;}
 dy = y - (double) ((long) _3d->starty);
 ty = (long) dy;
 if ((dy < .0) || (ty < 0) || (ty >= _3d->dimy))
    {*value = 0;
     return CANCEL;}
 dz = z - (double) ((long) _3d->startz);
 tz = (long) dz;
 if ((dz < .0) || (tz < 0) || (tz >= _3d->dimz))
    {*value = 0;
     return CANCEL;}

 sl = &(_3d->sls[tz]);
 if ((sl == NULL) || ((s1 = sl->s1) == NULL))
    {*value = 0;
     return CANCEL;}
 disx = dx - (float) tx;
 disy = dy - (float) ty;
 disz = dz - (float) tz;

 ndisz = 1.0 - disz;
 disx_disy = disx * disy;
 disx_ndisy = disx - disx_disy;
 ndisx_disy = disy - disx_disy;
 ndisx_ndisy = 1 - disx - ndisx_disy;

 if ((s2 = sl->s2) != NULL)
    {px2 = tx - (long) s2->startoffx;
     py2 = ty - (long) s2->startoffy;
     nx2 = px2 + 1;
     ny2 = py2 + 1;
    }
 px = tx - (long) s1->startoffx;
 py = ty - (long) s1->startoffy;
 nx = px + 1;
 ny = py + 1;
 if (ndisz > ALMOST_0)
    {if (ndisx_ndisy <= ALMOST_0) fval = .0;
       else 
        {/* val = AbsXYZVal(_3d,tx,ty,tz) */
         if ((px < 0) || (py < 0) ||
             (px >= s1->dimx) || (py >= s1->dimy))
            val = 0;
           else val = s1->GetVal(s1,py,px);
         if ((s2 != NULL) && (px2 >= 0) && (py2 >= 0) &&
             (py2 < s2->dimy) && (px2 < s2->dimx))
            {val2 = s2->GetVal(s2,py2,px2);
             if (val != val2) val += sl->ratio * (val2 - val);
            }
         if (val == 0) fval = .0;
           else fval = ndisx_ndisy * val;
        }
     if (disx_ndisy > ALMOST_0)
        {/* val = AbsXYZVal(_3d,nx,ty,tz) */
         if ((nx < 0) || (py < 0) ||
             (nx >= s1->dimx) || (py >= s1->dimy))
            val = 0;
           else val = s1->GetVal(s1,py,nx);
         if ((s2 != NULL) && (nx2 >= 0) && (py2 >= 0) &&
             (py2 < s2->dimy) && (nx2 < s2->dimx))
            {val2 = s2->GetVal(s2,py2,nx2);
             if (val != val2) val += sl->ratio * (val2 - val);
            }
         if (val != 0) fval += disx_ndisy * val;}
     if (ndisx_disy > ALMOST_0)
        {/* val = AbsXYZVal(_3d,tx,ny,tz) */
         if ((px < 0) || (ny < 0) ||
             (px >= s1->dimx) || (ny >= s1->dimy))
            val = 0;
           else val = s1->GetVal(s1,ny,px);
         if ((s2 != NULL) && (px2 >= 0) && (ny2 >= 0) &&
             (ny2 < s2->dimy) && (px2 < s2->dimx))
            {val2 = s2->GetVal(s2,ny2,px2);
             if (val != val2) val += sl->ratio * (val2 - val);
            }
         if (val != 0) fval += ndisx_disy * val;
        }
     if (disx_disy > ALMOST_0)
        {/* val = AbsXYZVal(_3d,nx,ny,tz) */
         if ((nx < 0) || (ny < 0) ||
             (nx >= s1->dimx) || (ny >= s1->dimy))
            val = 0;
           else val = s1->GetVal(s1,ny,nx);
         if ((s2 != NULL) && (nx2 >= 0) && (ny2 >= 0) &&
             (ny2 < s2->dimy) && (nx2 < s2->dimx))
            {val2 = s2->GetVal(s2,ny2,nx2);
             if (val != val2) val += sl->ratio * (val2 - val);
            }
         if (val != 0) fval += disx_disy * val;
        }
     if (fval != 0) fval *= ndisz;
    }
   else fval = .0;
 if ((disz > ALMOST_0) && ((nz = tz + 1) < _3d->dimz) &&
     ((sl = &(_3d->sls[nz])) != NULL) &&
     ((s1 = sl->s1) != NULL))
    {
     if ((s2 = sl->s2) != NULL)
        {px2 = tx - (long) s2->startoffx;
         py2 = ty - (long) s2->startoffy;
         nx2 = px2 + 1;
         ny2 = py2 + 1;
        }
     px = tx - (long) s1->startoffx;
     py = ty - (long) s1->startoffy;
     nx = px + 1;
     ny = py + 1;
     if (ndisx_ndisy <= ALMOST_0) fval1 = .0;
       else 
        {/* val = AbsXYZVal(_3d,tx,ty,nz) */
         if ((px < 0) || (py < 0) ||
             (px >= s1->dimx) || (py >= s1->dimy))
            val = 0;
           else val = s1->GetVal(s1,py,px);
         if ((s2 != NULL) && (px2 >= 0) && (py2 >= 0) &&
             (py2 < s2->dimy) && (px2 < s2->dimx))
            {val2 = s2->GetVal(s2,py2,px2);
             if (val != val2) val += sl->ratio * (val2 - val);
            }
         if (val == 0) fval1 = .0;
           else fval1 = ndisx_ndisy * val;
        }
    
     if (disx_ndisy > ALMOST_0)
	{/* val = AbsXYZVal(_3d,nx,ty,nz) */
         if ((nx < 0) || (py < 0) ||
             (nx >= s1->dimx) || (py >= s1->dimy))
            val = 0;
           else val = s1->GetVal(s1,py,nx);
         if ((s2 != NULL) && (nx2 >= 0) && (py2 >= 0) &&
             (py2 < s2->dimy) && (nx2 < s2->dimx))
            {val2 = s2->GetVal(s2,py2,nx2);
             if (val != val2) val += sl->ratio * (val2 - val);
            }
         if (val != 0) fval1 += disx_ndisy * val;}
     if (ndisx_disy > ALMOST_0)
        {/* val = AbsXYZVal(_3d,tx,ny,nz) */
         if ((px < 0) || (ny < 0) ||
             (px >= s1->dimx) || (ny >= s1->dimy))
            val = 0;
           else val = s1->GetVal(s1,ny,px);
         if ((s2 != NULL) && (px2 >= 0) && (ny2 >= 0) &&
             (ny2 < s2->dimy) && (px2 < s2->dimx))
            {val2 = s2->GetVal(s2,ny2,px2);
             if (val != val2) val += sl->ratio * (val2 - val);
            }
         if (val != 0) fval1 += ndisx_disy * val;
        }
     if (disx_disy > ALMOST_0)
        {/* val = AbsXYZVal(_3d,nx,ny,nz) */
         if ((nx < 0) || (ny < 0) ||
             (nx >= s1->dimx) || (ny >= s1->dimy))
            val = 0;
           else val = s1->GetVal(s1,ny,nx);
         if ((s2 != NULL) && (nx2 >= 0) && (ny2 >= 0) &&
             (ny2 < s2->dimy) && (nx2 < s2->dimx))
            {val2 = s2->GetVal(s2,ny2,nx2);
             if (val != val2) val += sl->ratio * (val2 - val);
            }
         if (val != 0) fval1 += disx_disy * val;
        }
     if (fval1 != 0) fval += fval1 * disz;
    }
 *value = fval;
 return NO_ERROR;
}


/*---------------------------------------------------------------------
_3dVal - ???
----------------------------------------------------------------------*/

int
_3dVal(plane,_3d,x,y,z,value)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 float x,y,z;
 double *value;
{
 if ((plane->status & PLANE_APPROX_VALUE) || (_3d->status & _3D_APPROX))
    return Get3dValApprox(_3d,x,y,z,value);
 return Get3dVal(_3d,x,y,z,value);
}


/*---------------------------------------------------------------------
AbsXYZVal - ???
----------------------------------------------------------------------*/

double 
AbsXYZVal(_3d,tx,ty,tz)
 struct buf_3d_rec *_3d;
 long tx,ty,tz;
{
 struct buf_2d_rec *s1,*s2;
 struct slice_3d_rec *sl;
 double val2,val1,num;

 if ((tz < 0) || (tz >= _3d->dimz) || (ty < 0) || (tx < 0))
    return 0;
 sl = &(_3d->sls[tz]);
 if ((sl == NULL) || ((s1 = sl->s1) == NULL)) return 0;
 if ((tx >= s1->dimx) || (ty >= s1->dimy))
    {if (((s2 = sl->s2) == NULL) || (ty >= s2->dimy) || (tx >= s2->dimx))
        return 0;
       else return s2->GetVal(s2,ty,tx);
    }
 val1 = s1->GetVal(s1,ty,tx);
 if (((s2 = sl->s2) != NULL) && (ty < s2->dimy) && (tx < s2->dimx))
    {val2 = s2->GetVal(s2,ty,tx);
     if (val1 != val2)
        if (val1 > val2)
           {num = sl->ratio * (val1 - val2);
            val1 -= num;}
          else
           {num = sl->ratio * (val2 - val1);
            val1 += num;}
    }
 return val1;
}



/*---------------------------------------------------------------------
PlaneData_00_10Approx - ???
----------------------------------------------------------------------*/

int
PlaneData_00_10Approx( plane, _3d, result_2d, the_planetoxyz )
     struct plane_3d_rec *plane;
     struct buf_3d_rec *_3d;
     struct buf_2d_rec *result_2d;
     struct matrix_3d_rec *the_planetoxyz;
{
  long		x, y, tx, ty, tz;
  double		val;
  float			disx, disy, disz;
  struct vector_3d_rec	*coord_ratio;
  struct matrix_3d_rec	mat, *planetoxyz, planetoxyz1;

  float	dx, dy, dz; 
  float			xstart, ystart, zstart, z20, y10, x00, z21, y11, x01;
  unsigned long		dimx, dimy, _3d_dimx, _3d_dimy, _3d_dimz;

  struct buf_2d_rec	*s1;
  struct slice_3d_rec	*slice;


  if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK)
    return CANCEL;

  TRACE(printf("PlaneData_00_10Approx...result_2d\n"));
  PRT1(pr_buf_2d_rec(result_2d));
  PRT1(printf("coord_ratio...\n"));
  PRT1(pr_vector_3d_rec(&(plane->coord_ratio)));


  if (_3d->status & _3D_XYZ_XY_10) {
    identity_3d_matrix(&mat);
    TRACE(printf("3D_XYZ_XY_10...\n"));
    assign_translation(&mat,
		       (float) -((long) _3d->startx),
		       (float) -((long) _3d->starty),
		       (float) -((long)_3d->startz));
    mult_3d_matrix(&planetoxyz1,&mat,the_planetoxyz);
    planetoxyz = &planetoxyz1;
  }
  else
    planetoxyz = the_planetoxyz;
  coord_ratio = &(plane->coord_ratio);

  trans_3d_xyz( planetoxyz,
	       (float) plane->firstx, (float) plane->firsty, 0.0,
	       &xstart, &ystart, &zstart,
	       0 );
  xstart = (xstart * coord_ratio->x);
  ystart = (ystart * coord_ratio->y);
  zstart = (zstart * coord_ratio->z);

  x00 = planetoxyz->buf[0][0] * coord_ratio->x;
  y10 = planetoxyz->buf[1][0] * coord_ratio->y;
  z20 = planetoxyz->buf[2][0] * coord_ratio->z;

  x01 = planetoxyz->buf[0][1] * coord_ratio->x;
  y11 = planetoxyz->buf[1][1] * coord_ratio->y;
  z21 = planetoxyz->buf[2][1] * coord_ratio->z;

  dimy = plane->proj_dimy;
  dimx = plane->proj_dimx;

#if 0
  printf("PlaneData_00_10Approx...result_2d\n");
  pr_buf_2d_rec(result_2d);
  printf("proj_dimx = %d proj_dimy = %d\n",plane->proj_dimx,plane->proj_dimy);
  printf("PlaneData_00_10Approx...x00 = %f y = %f z = %f\n",x00,y10,z20);
  printf("PlaneData_00_10Approx...x01 = %f y1 = %f z1 = %f\n",x01,y11,z21);
#endif

  _3d_dimx = _3d->dimx;
  _3d_dimy = _3d->dimy;
  _3d_dimz = _3d->dimz;

  for (y = 0; y < dimy; y++,xstart += x01,ystart += y11,zstart += z21) {
    dx = xstart;
    dy = ystart;
    dz = zstart;

    for (x = 0; x < dimx; x++,dx += x00,dy += y10,dz += z20) {

      tx = (long) dx;
      disx = dx - (float) tx;
      if (disx >= .5) tx += 1;
      if ((dx < .0) || (tx < 0) || (tx >= _3d_dimx)) {
	result_2d->SetVal(result_2d,y,x,(double) .0);
	continue;
      }

      ty = (long) dy;
      disy = dy - (float) ty;
      if (disy >= .5) ty += 1;
      if ((dy < .0) || (ty < 0) || (ty >= _3d_dimy)) {
	result_2d->SetVal(result_2d,y,x,(double) .0);
	continue;
      }

      tz = (long) dz;
      disz = dz - (float) tz;
      if (disz >= .5) tz += 1;
      if ((dz < .0) || (tz < 0) || (tz >= _3d_dimz)) {
	result_2d->SetVal(result_2d,y,x,(double) .0);
	continue;
      }

      slice = &(_3d->sls[tz]);
      if ((slice == NULL) || ((s1 = slice->s1) == NULL)) {
	result_2d->SetVal(result_2d,y,x,(double) .0);
	continue;
      }
      if ((slice->ratio <= .5) || (slice->s2 == NULL)) 
	val = s1->GetVal(s1,ty,tx);
      else {
	if ((ty >= slice->s2->dimy) || (tx >= slice->s2->dimx))
	  val = 0;
	else
	  val = slice->s2->GetVal(slice->s2,ty,tx);
      }
      result_2d->SetVal(result_2d,y,x,val);
    }
  }

  PRT1(printf("base..."));
  PRT1(pr_vector_3d_rec(&(plane->base)));
  PRT1(MinMax2dValues(result_2d,0,(double) .0,(double) .0,&val,&max);
       printf("PlaneData_00_10Approx result_2d min = %f max = %f\n",val,max));

  result_2d->status4 |= BUF_DATA_VALID;
  return NO_ERROR;
}



/*---------------------------------------------------------------------
PlaneData_00_10 - ???
----------------------------------------------------------------------*/

int
PlaneData_00_10(plane,_3d,result_2d,the_planetoxyz)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 struct buf_2d_rec *result_2d;
 struct matrix_3d_rec *the_planetoxyz;
{
 long x,y,tx,ty,tz,nx,ny,nz;
 double fval1,fval,val,val2;
 float disx,disy,disz,ndisz,ndisx_ndisy,disx_ndisy,ndisx_disy,disx_disy;
 struct vector_3d_rec *coord_ratio;
 struct matrix_3d_rec mat,*planetoxyz,planetoxyz1;

 float dx,dy,dz; 
 float xstart,ystart,zstart,z20,y10,x00,z21,y11,x01;
 unsigned long dimx,dimy,_3d_dimx,_3d_dimy,_3d_dimz;

 struct buf_2d_rec *s1,*s2;
 struct slice_3d_rec *sl;

 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK)
    return CANCEL;
 TRACE(printf("PlaneData_00_10...result_2d\n"))
 PRT3(pr_buf_2d_rec(result_2d))


 PRT1(printf("coord_ratio...\n"));
 PRT1(pr_vector_3d_rec(&(plane->coord_ratio)));

 /*  Translate the_planetoxyz matrix if origin not (0,0,0).  */
 if (_3d->status & _3D_XYZ_XY_10)
    {identity_3d_matrix(&mat);
     TRACE(printf("3D_XYZ_XY_10...\n"))
     assign_translation(&mat,(float) -((long) _3d->startx),
        (float) -((long) _3d->starty),(float)-((long)_3d->startz));
     mult_3d_matrix(&planetoxyz1,&mat,the_planetoxyz);
     planetoxyz = &planetoxyz1;
    }
   else planetoxyz = the_planetoxyz;
 coord_ratio = &(plane->coord_ratio);
 PRT3(printf("coord_ratio...\n");pr_vector_3d_rec(coord_ratio);)
 PRT3(printf("planetoxyz...\n");pr_3d_matrix(planetoxyz);)
 PRT3(printf("_3d->id = %s\n",_3d->id);)

 trans_3d_xyz(planetoxyz,(float) plane->firstx,(float) plane->firsty,.0,
         &xstart,&ystart,&zstart,0);
 xstart = (xstart * coord_ratio->x);
 ystart = (ystart * coord_ratio->y);
 zstart = (zstart * coord_ratio->z);

 x00 = planetoxyz->buf[0][0] * coord_ratio->x;
 y10 = planetoxyz->buf[1][0] * coord_ratio->y;
 z20 = planetoxyz->buf[2][0] * coord_ratio->z;

 x01 = planetoxyz->buf[0][1] * coord_ratio->x;
 y11 = planetoxyz->buf[1][1] * coord_ratio->y;
 z21 = planetoxyz->buf[2][1] * coord_ratio->z;
 dimy = plane->proj_dimy;
 dimx = plane->proj_dimx;
/*
 printf("PlaneData_00_10...result_2d\n");
 pr_buf_2d_rec(result_2d);
 printf("proj_dimx = %d proj_dimy = %d\n",plane->proj_dimx,plane->proj_dimy);
 printf("PlaneData_00_10...x00 = %f y = %f z = %f\n",x00,y10,z20);
 printf("PlaneData_00_10...x01 = %f y1 = %f z1 = %f\n",x01,y11,z21);
*/
 _3d_dimx = _3d->dimx;
 _3d_dimy = _3d->dimy;
 _3d_dimz = _3d->dimz;
 for (y = 0; y < dimy; y++,xstart += x01,ystart += y11,zstart += z21)
    {dx = xstart;
     dy = ystart;
     dz = zstart;
     for (x = 0; x < dimx; x++,dx += x00,dy += y10,dz += z20)
        {
         tx = (long) dx;
         if ((dx < .0) || (tx < 0) || (tx >= _3d_dimx))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
         ty = (long) dy;
         if ((dy < .0) || (ty < 0) || (ty >= _3d_dimy))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
         tz = (long) dz;
         if ((dz < .0) || (tz < 0) || (tz >= _3d_dimz))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
         sl = &(_3d->sls[tz]);
         if ((sl == NULL) || ((s1 = sl->s1) == NULL))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}

         disx = dx - (float) tx;
         disy = dy - (float) ty;
         disz = dz - (float) tz;
         ndisz = 1.0 - disz;
         disx_disy = disx * disy;
         disx_ndisy = disx - disx_disy;
         ndisx_disy = disy - disx_disy;
         ndisx_ndisy = 1 - disx - ndisx_disy;
         nx = tx + 1;
         ny = ty + 1;
         if (ndisz > ALMOST_0)
            {s2 = sl->s2;
             if (ndisx_ndisy <= ALMOST_0) fval = .0;
               else 
                {/* val = AbsXYZVal(_3d,tx,ty,tz) */
                 if ((tx >= s1->dimx) || (ty >= s1->dimy))
                    {if ((s2 == NULL) || (ty >= s2->dimy) || (tx >= s2->dimx))
                        val = 0;
                       else val = s2->GetVal(s2,ty,tx);
                    }
                   else
                    {val = s1->GetVal(s1,ty,tx);
                     if ((s2 != NULL) && (ty < s2->dimy) && (tx < s2->dimx))
                        {val2 = s2->GetVal(s2,ty,tx);
                         if (val != val2)
                            val += sl->ratio * (val2 - val);
                         }
                     }
                  if (val == 0) fval = .0;
                    else fval = ndisx_ndisy * val;
                }
             if (disx_ndisy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,nx,ty,tz) */
                 if ((nx >= s1->dimx) || (ty >= s1->dimy))
                     {if ((s2 == NULL) || (ty >= s2->dimy) || (nx >= s2->dimx))
                         val = 0;
                        else val = s2->GetVal(s2,ty,nx);
                     }
                    else
                     {val = s1->GetVal(s1,ty,nx);
                      if ((s2 != NULL) && (ty < s2->dimy) && (nx < s2->dimx))
                         {val2 = s2->GetVal(s2,ty,nx);
                          if (val != val2)
                            val += sl->ratio * (val2 - val);
                         }
                     }
                 if (val != 0) fval += disx_ndisy * val;}
             if (ndisx_disy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,tx,ny,tz) */
                 if ((tx >= s1->dimx) || (ny >= s1->dimy))
                     {if ((s2 == NULL) || (ny >= s2->dimy) || (tx >= s2->dimx))
                         val = 0;
                        else val = s2->GetVal(s2,ny,tx);
                     }
                    else
                     {val = s1->GetVal(s1,ny,tx);
                      if ((s2 != NULL) && (ny < s2->dimy) && (tx < s2->dimx))
                         {val2 = s2->GetVal(s2,ny,tx);
                          if (val != val2)
                             val += sl->ratio * (val2 - val);
                         }
                     }
                 if (val != 0)
                    fval += ndisx_disy * val;
                }
             if (disx_disy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,nx,ny,tz) */
                 if ((nx >= s1->dimx) || (ny >= s1->dimy))
                     {if ((s2 == NULL) || (ny >= s2->dimy) || (nx >= s2->dimx))
                         val = 0;
                        else val = s2->GetVal(s2,ny,nx);
                     }
                    else
                     {val = s1->GetVal(s1,ny,nx);
                      if ((s2 != NULL) && (ny < s2->dimy) && (nx < s2->dimx))
                         {val2 = s2->GetVal(s2,ny,nx);
                          if (val != val2)
                             val += sl->ratio * (val2 - val);
                         }
                     }
                 if (val != 0)
                    fval += disx_disy * val;
                }
             if (fval != 0) fval *= ndisz;
            }
           else fval = .0;
         if ((disz > ALMOST_0) && ((nz = tz + 1) < _3d_dimz) &&
             ((sl = &(_3d->sls[nz])) != NULL) &&
             ((s1 = sl->s1) != NULL))
            {
             s2 = sl->s2;
             if (ndisx_ndisy <= ALMOST_0) fval1 = .0;
               else 
                {/* val = AbsXYZVal(_3d,tx,ty,nz) */
                 if ((tx >= s1->dimx) || (ty >= s1->dimy))
                    {if ((s2 == NULL) || (ty >= s2->dimy) || (tx >= s2->dimx))
                        val = 0;
                       else val = s2->GetVal(s2,ty,tx);
                    }
                   else
                    {val = s1->GetVal(s1,ty,tx);
                     if ((s2 != NULL) && (ty < s2->dimy) && (tx < s2->dimx))
                        {val2 = s2->GetVal(s2,ty,tx);
                         if (val != val2)
                            val += sl->ratio * (val2 - val);
                        }
                     }
                 if (val == 0) fval1 = .0;
                   else fval1 = ndisx_ndisy * val;
                }

             if (disx_ndisy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,nx,ty,nz) */
                 if ((nx >= s1->dimx) || (ty >= s1->dimy))
                     {if ((s2 == NULL) || (ty >= s2->dimy) || (nx >= s2->dimx))
                         val = 0;
                        else val = s2->GetVal(s2,ty,nx);
                     }
                    else
                     {val = s1->GetVal(s1,ty,nx);
                      if ((s2 != NULL) && (ty < s2->dimy) && (nx < s2->dimx))
                         {val2 = s2->GetVal(s2,ty,nx);
                          if (val != val2)
                             val += sl->ratio * (val2 - val);
                         }
                     }
                 if (val != 0) fval1 += disx_ndisy * val;}
             if (ndisx_disy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,tx,ny,nz) */
                 if ((tx >= s1->dimx) || (ny >= s1->dimy))
                     {if ((s2 == NULL) || (ny >= s2->dimy) || (tx >= s2->dimx))
                         val = 0;
                        else val = s2->GetVal(s2,ny,tx);
                     }
                    else
                     {val = s1->GetVal(s1,ny,tx);
                      if ((s2 != NULL) && (ny < s2->dimy) && (tx < s2->dimx))
                         {val2 = s2->GetVal(s2,ny,tx);
                          if (val != val2)
                             val += sl->ratio * (val2 - val);
                         }
                     }
                 if (val != 0)
                    fval1 += ndisx_disy * val;
                }
             if (disx_disy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,nx,ny,nz) */
                 if ((nx >= s1->dimx) || (ny >= s1->dimy))
                     {if ((s2 == NULL) || (ny >= s2->dimy) || (nx >= s2->dimx))
                         val = 0;
                        else val = s2->GetVal(s2,ny,nx);
                     }
                    else
                     {val = s1->GetVal(s1,ny,nx);
                      if ((s2 != NULL) && (ny < s2->dimy) && (nx < s2->dimx))
                         {val2 = s2->GetVal(s2,ny,nx);
                          if (val != val2)
                             val += sl->ratio * (val2 - val);
                         }
                     }
                 if (val != 0)
                    fval1 += disx_disy * val;
                }
             if (fval1 != 0) fval += fval1 * disz;
            }
         result_2d->SetVal(result_2d,y,x,fval);
        }
    }
 PRT1(printf("base..."))
 PRT1(pr_vector_3d_rec(&(plane->base)))
 PRT3(MinMax2dValues(result_2d,0,(double) .0,(double) .0,&val,&val2);
 printf("PlaneData_00_10 result_2d min = %f max = %f\n\n\n",val,val2))

 result_2d->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/************ Start chopped out section

zPlaneData_00_10(plane,_3d,result_2d)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 struct buf_2d_rec *result_2d;
{
 struct timeb the_time;
 double val1,val2,num;
 unsigned long depth1,depth2,depth;
 struct buf_2d_rec *s1,*s2;
 struct slice_3d_rec *sl;
 long x,y,z;
 float ratio;
 unsigned char **buf;

 PRT1(ftime(&the_time))
 PRT1(printf("zPlaneData_00_10 sec = %d  msecs = %d\n",
         (int) the_time.time,the_time.millitm))
 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK)
    {
     return CANCEL;}

 if (_3d->status & _3D_XYZ_XY_10)
    z = (long) floor((double) plane->base.z) - (long) _3d->startz;
   else z = (long) floor((double) plane->base.z);
 if ((z < 0) || (z >= _3d->dimz))
    {InitBuf2dRecData(result_2d,(double) .0);
     return NO_ERROR;}

 if (_3d->sls[z].s2 == NULL)
   {if (_3d->sls[z].s1 == NULL)
       InitBuf2dRecData(result_2d,(double) .0);
      else if ((result_2d->startoffx == 0) && (result_2d->startoffy == 0) &&
           (plane->proj_dimx == result_2d->dimx) && 
           (plane->proj_dimy == result_2d->dimy) &&
           (_3d->sls[z].s1->pixel_depth == result_2d->pixel_depth) &&
           (_3d->sls[z].s1->startoffx == 0) && 
           (_3d->sls[z].s1->startoffy == 0) &&
           (_3d->sls[z].s1->dimx == result_2d->dimx) &&
           (_3d->sls[z].s1->dimy == result_2d->dimy))
          copy_buf_2d_rec_data(result_2d,_3d->sls[z].s1);
      else
       {InitBuf2dRecData(result_2d,(double) .0);
        cp_buf_2d_rec_content_by_bound(result_2d,_3d->sls[z].s1,
               0,_3d->sls[z].s1->dimx - 1,0,_3d->sls[z].s1->dimy - 1);
       }
    }
   else
    {ratio = _3d->sls[z].ratio;
     s1 = _3d->sls[z].s1;
     s2 = _3d->sls[z].s2;
     depth1 = s1->pixel_depth;
     depth2 = s2->pixel_depth;
     depth = result_2d->pixel_depth;
     buf = result_2d->buf;
     for (y = 0; y < plane->proj_dimy; y++)
        for (x = 0; x < plane->proj_dimx; x++)
           {val1 = s1->GetVal(s1,y,x);
            val2 = s2->GetVal(s2,y,x);
            if (val1 != val2)
               if (val1 > val2)
                  {num = ratio * (val1 - val2);
                   val1 -= num;}
                 else
                  {num = ratio * (val2 - val1);
                   val1 += num;}
            result_2d->SetVal(result_2d,y,x,val1);
           }
    }
 PRT1(ftime(&the_time))
 PRT1(printf("zPlaneData_00_10 sec end = %d  msecs = %d\n\n",
         (int) the_time.time,the_time.millitm))

 result_2d->status |= BUF_DATA_VALID;
 return NO_ERROR;
 
}
End chopped-out section ******************/


/*---------------------------------------------------------------------
Plane2ds_10Approx - ???
----------------------------------------------------------------------*/

int
Plane2ds_10Approx(plane,_3d_2ds,num_3d_2ds,the_planetoxyz)
 struct plane_3d_rec *plane;
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long num_3d_2ds;
 struct matrix_3d_rec *the_planetoxyz;
{
 long lcv,x,y,tx,ty,tz;
 double val;
 float disx,disy,disz;
 struct matrix_3d_rec *planetoxyz;
 struct vector_3d_rec *coord_ratio;
 float dx,dy,dz; 
 float xstart,ystart,zstart,z20,y10,x00,z21,y11,x01;
 struct buf_3d_rec *_3d;
 unsigned long depth,dimx,dimy,_3d_dimx,_3d_dimy,_3d_dimz;

 struct buf_2d_rec *s1,*result_2d;
 struct slice_3d_rec *sl;

 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK) return CANCEL;
 TRACE(printf("Plane2ds_10Approx...\n"))
 planetoxyz = the_planetoxyz;
 coord_ratio = &(plane->coord_ratio);

 trans_3d_xyz(planetoxyz,(float) plane->firstx,(float) plane->firsty,.0,
         &xstart,&ystart,&zstart,0);
 xstart = (xstart * coord_ratio->x);
 ystart = (ystart * coord_ratio->y);
 zstart = (zstart * coord_ratio->z);

 x00 = planetoxyz->buf[0][0] * coord_ratio->x;
 y10 = planetoxyz->buf[1][0] * coord_ratio->y;
 z20 = planetoxyz->buf[2][0] * coord_ratio->z;

 x01 = planetoxyz->buf[0][1] * coord_ratio->x;
 y11 = planetoxyz->buf[1][1] * coord_ratio->y;
 z21 = planetoxyz->buf[2][1] * coord_ratio->z;
 dimy = plane->proj_dimy;
 dimx = plane->proj_dimx;
 PRT1(printf("Plane2ds_10Approx...num_3d_2ds = %d\n",num_3d_2ds))
 for (y = 0; y < dimy; y++,xstart += x01,ystart += y11,zstart += z21)
    {
     for (lcv = 0; lcv < num_3d_2ds; lcv++)
        {_3d = _3d_2ds[lcv]._3d;
         _3d_dimx = _3d->dimx;
         _3d_dimy = _3d->dimy;
         _3d_dimz = _3d->dimz;
         dx = xstart - (double) ((long) _3d->startx);
         dy = ystart - (double) ((long) _3d->starty);
         dz = zstart - (double) ((long) _3d->startz);
         depth = _3d_2ds[lcv].plane_2d->pixel_depth;
         result_2d = _3d_2ds[lcv].plane_2d;

         for (x = 0; x < dimx; x++,dx += x00,dy += y10,dz += z20)
            {
             tx = (long) dx;
             disx = dx - (float) tx;
             if (disx >= .5) tx += 1;
             if ((dx < .0) || (tx < 0) || (tx >= _3d_dimx))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             ty = (long) dy;
             disy = dy - (float) ty;
             if (disy >= .5) ty += 1;
             if ((dy < .0) || (ty < 0) || (ty >= _3d_dimy))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             tz = (long) dz;
             disz = dz - (float) tz;
             if (disz >= .5) tz += 1;
             if ((dz < .0) || (tz < 0) || (tz >= _3d_dimz))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}

             sl = &(_3d->sls[tz]);
             if ((sl == NULL) || ((s1 = sl->s1) == NULL))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}

             if ((sl->ratio <= .5) || (sl->s2 == NULL)) 
                val = s1->GetVal(s1,ty,tx);
               else
                {if ((ty >= sl->s2->dimy) || (tx >= sl->s2->dimx))
                    val = 0;
                   else val = sl->s2->GetVal(sl->s2,ty,tx);
                }
             result_2d->SetVal(result_2d,y,x,val);
            } 
        }
    }

 for (lcv = 0; lcv < num_3d_2ds; lcv++)
    _3d_2ds[lcv].plane_2d->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Plane2ds_10 - ???
----------------------------------------------------------------------*/

int
Plane2ds_10(plane,_3d_2ds,num_3d_2ds,the_planetoxyz)
 struct plane_3d_rec *plane;
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long num_3d_2ds;
 struct matrix_3d_rec *the_planetoxyz;
{
 long lcv,x,y,tx,ty,tz,nx,ny,nz;
 double fval,fval1,val,val2;
 float disx,disy,disz,ndisz,ndisx_ndisy,disx_ndisy,ndisx_disy,disx_disy;
 struct matrix_3d_rec *planetoxyz;
 struct vector_3d_rec *coord_ratio;
 float dx,dy,dz; 
 float xstart,ystart,zstart,z20,y10,x00,z21,y11,x01;
 struct buf_3d_rec *_3d;
 unsigned long depth,dimx,dimy,_3d_dimx,_3d_dimy,_3d_dimz;

 struct buf_2d_rec *s1,*s2,*result_2d;
 struct slice_3d_rec *sl;

 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK) return CANCEL;
 TRACE(printf("Plane2ds_10...\n"))
 planetoxyz = the_planetoxyz;
 coord_ratio = &(plane->coord_ratio);

 trans_3d_xyz(planetoxyz,(float) plane->firstx,(float) plane->firsty,.0,
         &xstart,&ystart,&zstart,0);
 xstart = (xstart * coord_ratio->x);
 ystart = (ystart * coord_ratio->y);
 zstart = (zstart * coord_ratio->z);

 x00 = planetoxyz->buf[0][0] * coord_ratio->x;
 y10 = planetoxyz->buf[1][0] * coord_ratio->y;
 z20 = planetoxyz->buf[2][0] * coord_ratio->z;

 x01 = planetoxyz->buf[0][1] * coord_ratio->x;
 y11 = planetoxyz->buf[1][1] * coord_ratio->y;
 z21 = planetoxyz->buf[2][1] * coord_ratio->z;
 dimy = plane->proj_dimy;
 dimx = plane->proj_dimx;
 PRT1(printf("Plane2ds_10...num_3d_2ds = %d\n",num_3d_2ds))
 for (y = 0; y < dimy; y++,xstart += x01,ystart += y11,zstart += z21)
    {
     for (lcv = 0; lcv < num_3d_2ds; lcv++)
        {_3d = _3d_2ds[lcv]._3d;
         _3d_dimx = _3d->dimx;
         _3d_dimy = _3d->dimy;
         _3d_dimz = _3d->dimz;
         dx = xstart - (double) ((long) _3d->startx);
         dy = ystart - (double) ((long) _3d->starty);
         dz = zstart - (double) ((long) _3d->startz);
         depth = _3d_2ds[lcv].plane_2d->pixel_depth;
         result_2d = _3d_2ds[lcv].plane_2d;

         for (x = 0; x < dimx; x++,dx += x00,dy += y10,dz += z20)
            {
             tx = (long) dx;
             if ((dx < .0) || (tx < 0) || (tx >= _3d_dimx))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             ty = (long) dy;
             if ((dy < .0) || (ty < 0) || (ty >= _3d_dimy))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             tz = (long) dz;
             if ((dz < .0) || (tz < 0) || (tz >= _3d_dimz))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             sl = &(_3d->sls[tz]);
             if ((sl == NULL) || ((s1 = sl->s1) == NULL))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}

             disx = dx - (float) tx;
             disy = dy - (float) ty;
             disz = dz - (float) tz;
             ndisz = 1.0 - disz;
             disx_disy = disx * disy;
             disx_ndisy = disx - disx_disy;
             ndisx_disy = disy - disx_disy;
             ndisx_ndisy = 1 - disx - ndisx_disy;

             nx = tx + 1;
             ny = ty + 1;
	     if (ndisz > ALMOST_0)
		{s2 = sl->s2;
		 if (ndisx_ndisy <= ALMOST_0) fval = .0;
		   else 
		    {/* val = AbsXYZVal(_3d,tx,ty,tz) */
		     if ((tx >= s1->dimx) || (ty >= s1->dimy))
			{if ((s2 == NULL) || (ty >= s2->dimy) || (tx >= s2->dimx))
			    val = 0;
			   else val = s2->GetVal(s2,ty,tx);
			}
		       else
			{val = s1->GetVal(s1,ty,tx);
			 if ((s2 != NULL) && (ty < s2->dimy) && (tx < s2->dimx))
			    {val2 = s2->GetVal(s2,ty,tx);
			     if (val != val2)
                                val += sl->ratio * (val2 - val);
			     }
			 }
		      if (val == 0) fval = .0;
			else fval = ndisx_ndisy * val;
		    }
		 if (disx_ndisy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,nx,ty,tz) */
		     if ((nx >= s1->dimx) || (ty >= s1->dimy))
			 {if ((s2 == NULL) || (ty >= s2->dimy) || (nx >= s2->dimx))
			     val = 0;
			    else val = s2->GetVal(s2,ty,nx);
			 }
			else
			 {val = s1->GetVal(s1,ty,nx);
			  if ((s2 != NULL) && (ty < s2->dimy) && (nx < s2->dimx))
			     {val2 = s2->GetVal(s2,ty,nx);
			      if (val != val2)
                                 val += sl->ratio * (val2 - val);
			     }
			 }
		     if (val != 0) fval += disx_ndisy * val;}
		 if (ndisx_disy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,tx,ny,tz) */
		     if ((tx >= s1->dimx) || (ny >= s1->dimy))
			 {if ((s2 == NULL) || (ny >= s2->dimy) || (tx >= s2->dimx))
			     val = 0;
			    else val = s2->GetVal(s2,ny,tx);
			 }
			else
			 {val = s1->GetVal(s1,ny,tx);
			  if ((s2 != NULL) && (ny < s2->dimy) && (tx < s2->dimx))
			     {val2 = s2->GetVal(s2,ny,tx);
			      if (val != val2)
                                 val += sl->ratio * (val2 - val);
			     }
			 }
		     if (val != 0)
			fval += ndisx_disy * val;
		    }
		 if (disx_disy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,nx,ny,tz) */
		     if ((nx >= s1->dimx) || (ny >= s1->dimy))
			 {if ((s2 == NULL) || (ny >= s2->dimy) || (nx >= s2->dimx))
			     val = 0;
			    else val = s2->GetVal(s2,ny,nx);
			 }
			else
			 {val = s1->GetVal(s1,ny,nx);
			  if ((s2 != NULL) && (ny < s2->dimy) && (nx < s2->dimx))
			     {val2 = s2->GetVal(s2,ny,nx);
			      if (val != val2)
                                 val += sl->ratio * (val2 - val);
			     }
			 }
		     if (val != 0)
			fval += disx_disy * val;
		    }
		 if (fval != 0) fval *= ndisz;
		}
	       else fval = .0;
	     if ((disz > ALMOST_0) && ((nz = tz + 1) < _3d_dimz) &&
		 ((sl = &(_3d->sls[nz])) != NULL) &&
		 ((s1 = sl->s1) != NULL))
		{
                 s2 = sl->s2;
		 if (ndisx_ndisy <= ALMOST_0) fval1 = .0;
		   else 
		    {/* val = AbsXYZVal(_3d,tx,ty,nz) */
		     if ((tx >= s1->dimx) || (ty >= s1->dimy))
			{if ((s2 == NULL) || (ty >= s2->dimy) || (tx >= s2->dimx))
			    val = 0;
			   else val = s2->GetVal(s2,ty,tx);
			}
		       else
			{val = s1->GetVal(s1,ty,tx);
			 if ((s2 != NULL) && (ty < s2->dimy) && (tx < s2->dimx))
			    {val2 = s2->GetVal(s2,ty,tx);
			     if (val != val2)
                                val += sl->ratio * (val2 - val);
			     }
			 }
		     if (val == 0) fval1 = .0;
		       else fval1 = ndisx_ndisy * val;
		    }
    
		 if (disx_ndisy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,nx,ty,nz) */
		     if ((nx >= s1->dimx) || (ty >= s1->dimy))
			 {if ((s2 == NULL) || (ty >= s2->dimy) || (nx >= s2->dimx))
			     val = 0;
			    else val = s2->GetVal(s2,ty,nx);
			 }
			else
			 {val = s1->GetVal(s1,ty,nx);
			  if ((s2 != NULL) && (ty < s2->dimy) && (nx < s2->dimx))
			     {val2 = s2->GetVal(s2,ty,nx);
			      if (val != val2)
                                 val += sl->ratio * (val2 - val);
			     }
			 }
		     if (val != 0) fval1 += disx_ndisy * val;}
		 if (ndisx_disy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,tx,ny,nz) */
		     if ((tx >= s1->dimx) || (ny >= s1->dimy))
			 {if ((s2 == NULL) || (ny >= s2->dimy) || (tx >= s2->dimx))
			     val = 0;
			    else val = s2->GetVal(s2,ny,tx);
			 }
			else
			 {val = s1->GetVal(s1,ny,tx);
			  if ((s2 != NULL) && (ny < s2->dimy) && (tx < s2->dimx))
			     {val2 = s2->GetVal(s2,ny,tx);
			      if (val != val2)
                                 val += sl->ratio * (val2 - val);
			     }
			 }
		     if (val != 0)
			fval1 += ndisx_disy * val;
		    }
		 if (disx_disy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,nx,ny,nz) */
		     if ((nx >= s1->dimx) || (ny >= s1->dimy))
			 {if ((s2 == NULL) || (ny >= s2->dimy) || (nx >= s2->dimx))
			     val = 0;
			    else val = s2->GetVal(s2,ny,nx);
			 }
			else
			 {val = s1->GetVal(s1,ny,nx);
			  if ((s2 != NULL) && (ny < s2->dimy) && (nx < s2->dimx))
			     {val2 = s2->GetVal(s2,ny,nx);
			      if (val != val2)
                                 val += sl->ratio * (val2 - val);
			     }
			 }
		     if (val != 0)
			fval1 += disx_disy * val;
		    }
		 if (fval1 != 0) fval += fval1 * disz;
		}
             result_2d->SetVal(result_2d,y,x,fval);
            } 
        }
    }

 for (lcv = 0; lcv < num_3d_2ds; lcv++)
    _3d_2ds[lcv].plane_2d->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*---------------------------------------------------------------------
PlaneData_11Approx - ???
----------------------------------------------------------------------*/

int
PlaneData_11Approx(plane,_3d,result_2d,the_planetoxyz)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 struct buf_2d_rec *result_2d;
 struct matrix_3d_rec *the_planetoxyz;
{
 long x,y,tx,ty,tz,px,py;
 double val;
 float disx,disy,disz;
 struct matrix_3d_rec *planetoxyz;
 struct vector_3d_rec *coord_ratio;
 float dx,dy,dz; 
 float xstart,ystart,zstart,z20,y10,x00,z21,y11,x01;
 unsigned long dimx,dimy,_3d_dimx,_3d_dimy,_3d_dimz;

 struct buf_2d_rec *s1;
 struct slice_3d_rec *sl;

 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK)
    return CANCEL;

 TRACE(printf("PlaneData_11Approx...\n"))

 planetoxyz = the_planetoxyz;
 PRT(printf("planetoxyz...\n");pr_3d_matrix(planetoxyz))
 coord_ratio = &(plane->coord_ratio);
 trans_3d_xyz(planetoxyz,(float) plane->firstx,(float) plane->firsty,.0,
         &xstart,&ystart,&zstart,0);
 xstart = (xstart * coord_ratio->x);
 ystart = (ystart * coord_ratio->y);
 zstart = (zstart * coord_ratio->z);

 x00 = planetoxyz->buf[0][0] * coord_ratio->x;
 y10 = planetoxyz->buf[1][0] * coord_ratio->y;
 z20 = planetoxyz->buf[2][0] * coord_ratio->z;

 x01 = planetoxyz->buf[0][1] * coord_ratio->x;
 y11 = planetoxyz->buf[1][1] * coord_ratio->y;
 z21 = planetoxyz->buf[2][1] * coord_ratio->z;
 dimy = plane->proj_dimy;
 dimx = plane->proj_dimx;
 _3d_dimx = _3d->dimx;
 _3d_dimy = _3d->dimy;
 _3d_dimz = _3d->dimz;
 PRT3(printf("xstart = %f ystart = %f zstart = %f\n",xstart,ystart,zstart);)
 PRT3(printf("_3d xstart = %d ystart = %d zstart = %d\n",
            _3d->startx,_3d->starty,_3d->startz);)

 xstart = xstart - (float) ((long) _3d->startx);
 ystart = ystart - (float) ((long) _3d->starty);
 zstart = zstart - (float) ((long) _3d->startz);

 for (y = 0; y < dimy; y++,xstart += x01,ystart += y11,zstart += z21)
    {
/*
     dx = xstart - (double) ((long) _3d->startx);
     dy = ystart - (double) ((long) _3d->starty);
     dz = zstart - (double) ((long) _3d->startz);
*/
     dx = xstart;
     dy = ystart;
     dz = zstart;

     for (x = 0; x < dimx; x++,dx += x00,dy += y10,dz += z20)
        {
         tx = (long) dx;
         disx = dx - (float) tx;
         if (disx >= .5) tx += 1;
         if ((dx < .0) || (tx < 0) || (tx >= _3d_dimx))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
         ty = (long) dy;
         disy = dy - (float) ty;
         if (disy >= .5) ty += 1;
         if ((dy < .0) || (ty < 0) || (ty >= _3d_dimy))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
         tz = (long) dz;
         disz = dz - (float) tz;
         if (disz >= .5) tz += 1;
         if ((dz < .0) || (tz < 0) || (tz >= _3d_dimz))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
        /* PRT1(printf("y = %d x = %d tx = %d ty = %d tz = %d  %f %f %f",
                   y,x,tx,ty,tz,disx,disy,disz))*/
         sl = &(_3d->sls[tz]);
         if ((sl == NULL) || ((s1 = sl->s1) == NULL))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
         px = tx - (long) s1->startoffx;
         py = ty - (long) s1->startoffy;
         if (((sl->ratio > .5) && (sl->s2 != NULL)) ||
             (px < 0) || (py < 0) ||
             (px >= s1->dimx) || (py >= s1->dimy))
            {if (sl->s2 == NULL) val = .0;
               else 
                {px = tx - (long) sl->s2->startoffx;
                 py = ty - (long) sl->s2->startoffy;
                 if ((px >= 0) && (py >= 0) &&
                     (py < sl->s2->dimy) && (px < sl->s2->dimx))
                    val = sl->s2->GetVal(sl->s2,py,px);
                   else val = .0;
                }
            }
           else val = s1->GetVal(s1,py,px);
         result_2d->SetVal(result_2d,y,x,val);
        }
    }

 result_2d->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*---------------------------------------------------------------------
PlaneData_11 - ???
----------------------------------------------------------------------*/

int
PlaneData_11(plane,_3d,result_2d,the_planetoxyz)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 struct buf_2d_rec *result_2d;
 struct matrix_3d_rec *the_planetoxyz;
{
 long x,y,tx,ty,tz,px,py,px2,py2,nx2,ny2,nx,ny,nz;
 double fval,fval1,val,val2;
 float disx,disy,disz,ndisz,ndisx_ndisy,disx_ndisy,ndisx_disy,disx_disy;
 struct matrix_3d_rec mat,*planetoxyz,planetoxyz1;
 struct vector_3d_rec *coord_ratio;
 float dx,dy,dz; 
 float xstart,ystart,zstart,z20,y10,x00,z21,y11,x01;
 unsigned long dimx,dimy,_3d_dimx,_3d_dimy,_3d_dimz;

 struct buf_2d_rec *s1,*s2;
 struct slice_3d_rec *sl;

 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK)
    return CANCEL;
 TRACE(printf("PlaneData_11....\n"))
 identity_3d_matrix(&mat);
 assign_translation(&mat,(float) -((long) _3d->startx),
       (float) -((long) _3d->starty),(float)-((long)_3d->startz));
 mult_3d_matrix(&planetoxyz1,&mat,the_planetoxyz);
 planetoxyz = &planetoxyz1;
 PRT1(printf("planetoxyz...\n");pr_3d_matrix(planetoxyz))

 coord_ratio = &(plane->coord_ratio);

 trans_3d_xyz(planetoxyz,(float) plane->firstx,(float) plane->firsty,.0,
         &xstart,&ystart,&zstart,0);
 xstart = (xstart * coord_ratio->x);
 ystart = (ystart * coord_ratio->y);
 zstart = (zstart * coord_ratio->z);

 x00 = planetoxyz->buf[0][0] * coord_ratio->x;
 y10 = planetoxyz->buf[1][0] * coord_ratio->y;
 z20 = planetoxyz->buf[2][0] * coord_ratio->z;

 x01 = planetoxyz->buf[0][1] * coord_ratio->x;
 y11 = planetoxyz->buf[1][1] * coord_ratio->y;
 z21 = planetoxyz->buf[2][1] * coord_ratio->z;
 dimy = plane->proj_dimy;
 dimx = plane->proj_dimx;
 _3d_dimx = _3d->dimx;
 _3d_dimy = _3d->dimy;
 _3d_dimz = _3d->dimz;
 for (y = 0; y < dimy; y++,xstart += x01,ystart += y11,zstart += z21)
    {dx = xstart;
     dy = ystart;
     dz = zstart;
     for (x = 0; x < dimx; x++,dx += x00,dy += y10,dz += z20)
        {
         tx = (long) dx;
         if ((dx < .0) || (tx < 0) || (tx >= _3d_dimx))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
         ty = (long) dy;
         if ((dy < .0) || (ty < 0) || (ty >= _3d_dimy))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
         tz = (long) dz;
         if ((dz < .0) || (tz < 0) || (tz >= _3d_dimz))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
         sl = &(_3d->sls[tz]);
         if ((sl == NULL) || ((s1 = sl->s1) == NULL))
            {result_2d->SetVal(result_2d,y,x,(double) .0);
             continue;}
         disx = dx - (float) tx;
         disy = dy - (float) ty;
         disz = dz - (float) tz;

         ndisz = 1.0 - disz;
         disx_disy = disx * disy;
         disx_ndisy = disx - disx_disy;
         ndisx_disy = disy - disx_disy;
         ndisx_ndisy = 1 - disx - ndisx_disy;

         if ((s2 = sl->s2) != NULL)
            {px2 = tx - (long) s2->startoffx;
             py2 = ty - (long) s2->startoffy;
             nx2 = px2 + 1;
             ny2 = py2 + 1;
            }
         px = tx - (long) s1->startoffx;
         py = ty - (long) s1->startoffy;
         nx = px + 1;
         ny = py + 1;
         if (ndisz > ALMOST_0)
            {if (ndisx_ndisy <= ALMOST_0) fval = .0;
               else 
                {/* val = AbsXYZVal(_3d,tx,ty,tz) */
                 if ((px < 0) || (py < 0) ||
                     (px >= s1->dimx) || (py >= s1->dimy))
                    val = 0;
                   else val = s1->GetVal(s1,py,px);
                 if ((s2 != NULL) && (px2 >= 0) && (py2 >= 0) &&
                     (py2 < s2->dimy) && (px2 < s2->dimx))
                    {val2 = s2->GetVal(s2,py2,px2);
                     if (val != val2) val += sl->ratio * (val2 - val);
                    }
                 if (val == 0) fval = .0;
                    else fval = ndisx_ndisy * val;
                }
             if (disx_ndisy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,nx,ty,tz) */
                 if ((nx < 0) || (py < 0) ||
                     (nx >= s1->dimx) || (py >= s1->dimy))
                    val = 0;
                   else val = s1->GetVal(s1,py,nx);
                 if ((s2 != NULL) && (nx2 >= 0) && (py2 >= 0) &&
                     (py2 < s2->dimy) && (nx2 < s2->dimx))
                    {val2 = s2->GetVal(s2,py2,nx2);
                     if (val != val2) val += sl->ratio * (val2 - val);
                    }
                 if (val != 0) fval += disx_ndisy * val;}
             if (ndisx_disy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,tx,ny,tz) */
                 if ((px < 0) || (ny < 0) ||
                     (px >= s1->dimx) || (ny >= s1->dimy))
                    val = 0;
                   else val = s1->GetVal(s1,ny,px);
                 if ((s2 != NULL) && (px2 >= 0) && (ny2 >= 0) &&
                     (ny2 < s2->dimy) && (px2 < s2->dimx))
                    {val2 = s2->GetVal(s2,ny2,px2);
                     if (val != val2) val += sl->ratio * (val2 - val);
                    }
                 if (val != 0) fval += ndisx_disy * val;
                }
             if (disx_disy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,nx,ny,tz) */
                 if ((nx < 0) || (ny < 0) ||
                     (nx >= s1->dimx) || (ny >= s1->dimy))
                    val = 0;
                   else val = s1->GetVal(s1,ny,nx);
                 if ((s2 != NULL) && (nx2 >= 0) && (ny2 >= 0) &&
                     (ny2 < s2->dimy) && (nx2 < s2->dimx))
                    {val2 = s2->GetVal(s2,ny2,nx2);
                     if (val != val2) val += sl->ratio * (val2 - val);
                    }
                 if (val != 0) fval += disx_disy * val;
                }
             if (fval != 0) fval *= ndisz;
            }
           else fval = .0;
         if ((disz > ALMOST_0) && ((nz = tz + 1) < _3d_dimz) &&
             ((sl = &(_3d->sls[nz])) != NULL) &&
             ((s1 = sl->s1) != NULL))
            {
             if ((s2 = sl->s2) != NULL)
                {px2 = tx - (long) s2->startoffx;
                 py2 = ty - (long) s2->startoffy;
                 nx2 = px2 + 1;
                 ny2 = py2 + 1;
                }
             px = tx - (long) s1->startoffx;
             py = ty - (long) s1->startoffy;
             nx = px + 1;
             ny = py + 1;
             if (ndisx_ndisy <= ALMOST_0) fval1 = .0;
               else 
                {/* val = AbsXYZVal(_3d,tx,ty,nz) */
                 if ((px < 0) || (py < 0) ||
                     (px >= s1->dimx) || (py >= s1->dimy))
                    val = 0;
                   else val = s1->GetVal(s1,py,px);
                 if ((s2 != NULL) && (px2 >= 0) && (py2 >= 0) &&
                     (py2 < s2->dimy) && (px2 < s2->dimx))
                    {val2 = s2->GetVal(s2,py2,px2);
                     if (val != val2) val += sl->ratio * (val2 - val);
                    }
                 if (val == 0) fval1 = .0;
                   else fval1 = ndisx_ndisy * val;
                }

             if (disx_ndisy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,nx,ty,nz) */
                 if ((nx < 0) || (py < 0) ||
                     (nx >= s1->dimx) || (py >= s1->dimy))
                    val = 0;
                   else val = s1->GetVal(s1,py,nx);
                 if ((s2 != NULL) && (nx2 >= 0) && (py2 >= 0) &&
                     (py2 < s2->dimy) && (nx2 < s2->dimx))
                    {val2 = s2->GetVal(s2,py2,nx2);
                     if (val != val2) val += sl->ratio * (val2 - val);
                    }
                 if (val != 0) fval1 += disx_ndisy * val;}
             if (ndisx_disy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,tx,ny,nz) */
                 if ((px < 0) || (ny < 0) ||
                     (px >= s1->dimx) || (ny >= s1->dimy))
                    val = 0;
                   else val = s1->GetVal(s1,ny,px);
                 if ((s2 != NULL) && (px2 >= 0) && (ny2 >= 0) &&
                     (ny2 < s2->dimy) && (px2 < s2->dimx))
                    {val2 = s2->GetVal(s2,ny2,px2);
                     if (val != val2) val += sl->ratio * (val2 - val);
                    }
                 if (val != 0) fval1 += ndisx_disy * val;
                }
             if (disx_disy > ALMOST_0)
                {/* val = AbsXYZVal(_3d,nx,ny,nz) */
                 if ((nx < 0) || (ny < 0) ||
                     (nx >= s1->dimx) || (ny >= s1->dimy))
                    val = 0;
                   else val = s1->GetVal(s1,ny,nx);
                 if ((s2 != NULL) && (nx2 >= 0) && (ny2 >= 0) &&
                     (ny2 < s2->dimy) && (nx2 < s2->dimx))
                    {val2 = s2->GetVal(s2,ny2,nx2);
                     if (val != val2) val += sl->ratio * (val2 - val);
                    }
                 if (val != 0) fval1 += disx_disy * val;
                }
             if (fval1 != 0) fval += fval1 * disz;
            }
         result_2d->SetVal(result_2d,y,x,fval);
        }
    }

 result_2d->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Plane2ds_11Approx - ???
----------------------------------------------------------------------*/

int
Plane2ds_11Approx(plane,_3d_2ds,num_3d_2ds,the_planetoxyz)
 struct plane_3d_rec *plane;
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long num_3d_2ds;
 struct matrix_3d_rec *the_planetoxyz;
{
 long lcv,x,y,tx,ty,tz,px,py;
 double val;
 float disx,disy,disz;
 struct matrix_3d_rec *planetoxyz;
 struct vector_3d_rec *coord_ratio;

 float dx,dy,dz; 
 float xstart,ystart,zstart,z20,y10,x00,z21,y11,x01;
 struct buf_3d_rec *_3d;
 unsigned long dimx,dimy,_3d_dimx,_3d_dimy,_3d_dimz;

 struct buf_2d_rec *s1,*result_2d;
 struct slice_3d_rec *sl;

 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK) return CANCEL;
 TRACE(printf("Plane2ds_11Approx...\n"))

 planetoxyz = the_planetoxyz;
 coord_ratio = &(plane->coord_ratio);

 trans_3d_xyz(planetoxyz,(float) plane->firstx,(float) plane->firsty,.0,
         &xstart,&ystart,&zstart,0);
 xstart = (xstart * coord_ratio->x);
 ystart = (ystart * coord_ratio->y);
 zstart = (zstart * coord_ratio->z);

 x00 = planetoxyz->buf[0][0] * coord_ratio->x;
 y10 = planetoxyz->buf[1][0] * coord_ratio->y;
 z20 = planetoxyz->buf[2][0] * coord_ratio->z;

 x01 = planetoxyz->buf[0][1] * coord_ratio->x;
 y11 = planetoxyz->buf[1][1] * coord_ratio->y;
 z21 = planetoxyz->buf[2][1] * coord_ratio->z;
 dimy = plane->proj_dimy;
 dimx = plane->proj_dimx;
 PRT1(printf("Plane2ds_11Approx..num_3d_2ds = %d\n",num_3d_2ds))
 for (y = 0; y < dimy; y++,xstart += x01,ystart += y11,zstart += z21)
    {
     for (lcv = 0; lcv < num_3d_2ds; lcv++)
        {_3d = _3d_2ds[lcv]._3d;
         _3d_dimx = _3d->dimx;
         _3d_dimy = _3d->dimy;
         _3d_dimz = _3d->dimz;
         dx = xstart - (double) ((long) _3d->startx);
         dy = ystart - (double) ((long) _3d->starty);
         dz = zstart - (double) ((long) _3d->startz);
         result_2d = _3d_2ds[lcv].plane_2d;

         for (x = 0; x < dimx; x++,dx += x00,dy += y10,dz += z20)
            {
             tx = (long) dx;
             disx = dx - (float) tx;
             if (disx >= .5) tx += 1;
             if ((tx < 0) || (tx >= _3d_dimx))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             ty = (long) dy;
             disy = dy - (float) ty;
             if (disy >= .5) ty += 1;
             if ((ty < 0) || (ty >= _3d_dimy))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             tz = (long) dz;
             disz = dz - (float) tz;
             if (disz >= .5) tz += 1;
             if ((tz < 0) || (tz >= _3d_dimz))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             sl = &(_3d->sls[tz]);
             if ((sl == NULL) || ((s1 = sl->s1) == NULL))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}

             px = tx - (long) s1->startoffx;
             py = ty - (long) s1->startoffy;
             if ((sl->ratio > .5) || (px < 0) || (py < 0) ||
                 (px >= s1->dimx) || (py >= s1->dimy))
                {if (sl->s2 == NULL) val = .0;
                   else 
                    {px = tx - (long) sl->s2->startoffx;
                     py = ty - (long) sl->s2->startoffy;
                     if ((px >= 0) && (py >= 0) &&
                         (py < sl->s2->dimy) && (px < sl->s2->dimx))
                        val = sl->s2->GetVal(sl->s2,py,px);
                       else val = .0;
                    }
                }
               else val = s1->GetVal(s1,py,px);
             result_2d->SetVal(result_2d,y,x,val);
            }
        }
    }

 for (lcv = 0; lcv < num_3d_2ds; lcv++)
    _3d_2ds[lcv].plane_2d->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*---------------------------------------------------------------------
Plane2ds_11 - ???
----------------------------------------------------------------------*/

int
Plane2ds_11(plane,_3d_2ds,num_3d_2ds,the_planetoxyz)
 struct plane_3d_rec *plane;
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long num_3d_2ds;
 struct matrix_3d_rec *the_planetoxyz;
{
 long lcv,x,y,tx,ty,tz,px,py,px2,py2,nx2,ny2,nx,ny,nz;
 double fval,fval1,val,val2;
 float disx,disy,disz,ndisz,ndisx_ndisy,disx_ndisy,ndisx_disy,disx_disy;
 struct matrix_3d_rec *planetoxyz;
 struct vector_3d_rec *coord_ratio;

 float dx,dy,dz; 
 float xstart,ystart,zstart,z20,y10,x00,z21,y11,x01;
 struct buf_3d_rec *_3d;
 unsigned long dimx,dimy,_3d_dimx,_3d_dimy,_3d_dimz;

 struct buf_2d_rec *s1,*s2,*result_2d;
 struct slice_3d_rec *sl;

 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK) return CANCEL;
 TRACE(printf("Plane2ds_11...\n"));

 planetoxyz = the_planetoxyz;
 PRT(printf("planetoxyz...\n");pr_3d_matrix(planetoxyz))
 coord_ratio = &(plane->coord_ratio);

 trans_3d_xyz(planetoxyz,(float) plane->firstx,(float) plane->firsty,.0,
         &xstart,&ystart,&zstart,0);
 xstart = (xstart * coord_ratio->x);
 ystart = (ystart * coord_ratio->y);
 zstart = (zstart * coord_ratio->z);

 x00 = planetoxyz->buf[0][0] * coord_ratio->x;
 y10 = planetoxyz->buf[1][0] * coord_ratio->y;
 z20 = planetoxyz->buf[2][0] * coord_ratio->z;

 x01 = planetoxyz->buf[0][1] * coord_ratio->x;
 y11 = planetoxyz->buf[1][1] * coord_ratio->y;
 z21 = planetoxyz->buf[2][1] * coord_ratio->z;
 dimy = plane->proj_dimy;
 dimx = plane->proj_dimx;
 PRT3(printf("xstart = %f ystart = %f zstart = %f\n",xstart,ystart,zstart);)
 PRT3(for (lcv = 0; lcv < num_3d_2ds; lcv++)
        {_3d = _3d_2ds[lcv]._3d;
         printf("%d) _3d xstart = %d ystart = %d zstart = %d\n",
            lcv,_3d->startx,_3d->starty,_3d->startz);
        }
     )
 for (y = 0; y < dimy; y++,xstart += x01,ystart += y11,zstart += z21)
    {
     for (lcv = 0; lcv < num_3d_2ds; lcv++)
        {_3d = _3d_2ds[lcv]._3d;
         _3d_dimx = _3d->dimx;
         _3d_dimy = _3d->dimy;
         _3d_dimz = _3d->dimz;

         dx = xstart - (double) ((long) _3d->startx);
         dy = ystart - (double) ((long) _3d->starty);
         dz = zstart - (double) ((long) _3d->startz);
         result_2d = _3d_2ds[lcv].plane_2d;

         for (x = 0; x < dimx; x++,dx += x00,dy += y10,dz += z20)
            {
             tx = (long) dx;
             if ((dx < .0) || (tx < 0) || (tx >= _3d_dimx))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             ty = (long) dy;
             if ((dy < .0) || (ty < 0) || (ty >= _3d_dimy))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             tz = (long) dz;
             if ((dz < .0) || (tz < 0) || (tz >= _3d_dimz))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             sl = &(_3d->sls[tz]);
             if ((sl == NULL) || ((s1 = sl->s1) == NULL))
                {result_2d->SetVal(result_2d,y,x,(double) .0);
                 continue;}
             disx = dx - (float) tx;
             disy = dy - (float) ty;
             disz = dz - (float) tz;

             ndisz = 1.0 - disz;
             disx_disy = disx * disy;
             disx_ndisy = disx - disx_disy;
             ndisx_disy = disy - disx_disy;
             ndisx_ndisy = 1 - disx - ndisx_disy;

             if ((s2 = sl->s2) != NULL)
                {px2 = tx - (long) s2->startoffx;
                 py2 = ty - (long) s2->startoffy;
                 nx2 = px2 + 1;
                 ny2 = py2 + 1;
                }
             px = tx - (long) s1->startoffx;
             py = ty - (long) s1->startoffy;
             nx = px + 1;
             ny = py + 1;
	     if (ndisz > ALMOST_0)
		{if (ndisx_ndisy <= ALMOST_0) fval = .0;
		   else 
		    {/* val = AbsXYZVal(_3d,tx,ty,tz) */
                     if ((px < 0) || (py < 0) ||
                         (px >= s1->dimx) || (py >= s1->dimy))
                        val = 0;
                       else val = s1->GetVal(s1,py,px);
                     if ((s2 != NULL) && (px2 >= 0) && (py2 >= 0) &&
                         (py2 < s2->dimy) && (px2 < s2->dimx))
                        {val2 = s2->GetVal(s2,py2,px2);
                         if (val != val2) val += sl->ratio * (val2 - val);
                        }
                     if (val == 0) fval = .0;
                       else fval = ndisx_ndisy * val;
		    }
		 if (disx_ndisy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,nx,ty,tz) */
                     if ((nx < 0) || (py < 0) ||
                         (nx >= s1->dimx) || (py >= s1->dimy))
                        val = 0;
                       else val = s1->GetVal(s1,py,nx);
                     if ((s2 != NULL) && (nx2 >= 0) && (py2 >= 0) &&
                         (py2 < s2->dimy) && (nx2 < s2->dimx))
                        {val2 = s2->GetVal(s2,py2,nx2);
                         if (val != val2) val += sl->ratio * (val2 - val);
                        }
                     if (val != 0) fval += disx_ndisy * val;}
		 if (ndisx_disy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,tx,ny,tz) */
                     if ((px < 0) || (ny < 0) ||
                         (px >= s1->dimx) || (ny >= s1->dimy))
                        val = 0;
                       else val = s1->GetVal(s1,ny,px);
                     if ((s2 != NULL) && (px2 >= 0) && (ny2 >= 0) &&
                         (ny2 < s2->dimy) && (px2 < s2->dimx))
                        {val2 = s2->GetVal(s2,ny2,px2);
                         if (val != val2) val += sl->ratio * (val2 - val);
                        }
                     if (val != 0) fval += ndisx_disy * val;
		    }
		 if (disx_disy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,nx,ny,tz) */
                     if ((nx < 0) || (ny < 0) ||
                         (nx >= s1->dimx) || (ny >= s1->dimy))
                        val = 0;
                       else val = s1->GetVal(s1,ny,nx);
                     if ((s2 != NULL) && (nx2 >= 0) && (ny2 >= 0) &&
                         (ny2 < s2->dimy) && (nx2 < s2->dimx))
                        {val2 = s2->GetVal(s2,ny2,nx2);
                         if (val != val2) val += sl->ratio * (val2 - val);
                        }
                     if (val != 0) fval += disx_disy * val;
		    }
		 if (fval != 0) fval *= ndisz;
		}
	       else fval = .0;
	     if ((disz > ALMOST_0) && ((nz = tz + 1) < _3d_dimz) &&
		 ((sl = &(_3d->sls[nz])) != NULL) &&
		 ((s1 = sl->s1) != NULL))
		{
                 if ((s2 = sl->s2) != NULL)
                    {px2 = tx - (long) s2->startoffx;
                     py2 = ty - (long) s2->startoffy;
                     nx2 = px2 + 1;
                     ny2 = py2 + 1;
                    }
                 px = tx - (long) s1->startoffx;
                 py = ty - (long) s1->startoffy;
                 nx = px + 1;
                 ny = py + 1;
		 if (ndisx_ndisy <= ALMOST_0) fval1 = .0;
		   else 
		    {/* val = AbsXYZVal(_3d,tx,ty,nz) */
                     if ((px < 0) || (py < 0) ||
                         (px >= s1->dimx) || (py >= s1->dimy))
                        val = 0;
                       else val = s1->GetVal(s1,py,px);
                     if ((s2 != NULL) && (px2 >= 0) && (py2 >= 0) &&
                         (py2 < s2->dimy) && (px2 < s2->dimx))
                        {val2 = s2->GetVal(s2,py2,px2);
                         if (val != val2) val += sl->ratio * (val2 - val);
                        }
                     if (val == 0) fval1 = .0;
                       else fval1 = ndisx_ndisy * val;
		    }
    
		 if (disx_ndisy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,nx,ty,nz) */
                     if ((nx < 0) || (py < 0) ||
                         (nx >= s1->dimx) || (py >= s1->dimy))
                        val = 0;
                       else val = s1->GetVal(s1,py,nx);
                     if ((s2 != NULL) && (nx2 >= 0) && (py2 >= 0) &&
                         (py2 < s2->dimy) && (nx2 < s2->dimx))
                        {val2 = s2->GetVal(s2,py2,nx2);
                         if (val != val2) val += sl->ratio * (val2 - val);
                        }
                     if (val != 0) fval1 += disx_ndisy * val;}

		 if (ndisx_disy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,tx,ny,nz) */
                     if ((px < 0) || (ny < 0) ||
                         (px >= s1->dimx) || (ny >= s1->dimy))
                        val = 0;
                       else val = s1->GetVal(s1,ny,px);
                     if ((s2 != NULL) && (px2 >= 0) && (ny2 >= 0) &&
                         (ny2 < s2->dimy) && (px2 < s2->dimx))
                        {val2 = s2->GetVal(s2,ny2,px2);
                         if (val != val2) val += sl->ratio * (val2 - val);
                        }
                     if (val != 0) fval1 += ndisx_disy * val;
		    }
		 if (disx_disy > ALMOST_0)
		    {/* val = AbsXYZVal(_3d,nx,ny,nz) */
                     if ((nx < 0) || (ny < 0) ||
                         (nx >= s1->dimx) || (ny >= s1->dimy))
                        val = 0;
                       else val = s1->GetVal(s1,ny,nx);
                     if ((s2 != NULL) && (nx2 >= 0) && (ny2 >= 0) &&
                         (ny2 < s2->dimy) && (nx2 < s2->dimx))
                        {val2 = s2->GetVal(s2,ny2,nx2);
                         if (val != val2) val += sl->ratio * (val2 - val);
                        }
                     if (val != 0) fval1 += disx_disy * val;
		    }
		 if (fval1 != 0) fval += fval1 * disz;
		}
             result_2d->SetVal(result_2d,y,x,fval);
            }
        }
    }

 for (lcv = 0; lcv < num_3d_2ds; lcv++)
    _3d_2ds[lcv].plane_2d->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}

/****************************  Begin chop
zplane_coords_00_10(plane,_3d,xyz)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 struct ary_pt_3d_rec *xyz;
{
 long x,y,z;
 unsigned long total;
 int err;

 if (_3d->status & _3D_XYZ_XY_10)
    z = (long) floor((double) (plane->base.z)) - (long) _3d->startz;
   else z = (long) floor((double) (plane->base.z));
 if ((z < 0) || (z >= _3d->dimz))
    {return NO_ERROR;}
 total = plane->proj_dimy * plane->proj_dimx;
 if ((total + xyz->num_coords) > xyz->total_coords)
    {total = total + xyz->num_coords - xyz->total_coords;
     if ((err = get_ptr(&(xyz->coords),&(xyz->total_coords),total,
             (size_t) sizeof(*(xyz->coords)))) != NO_ERROR)
        return err;
    }
 for (y = 0; y < plane->proj_dimy; y++)
    for (x = 0; x < plane->proj_dimx; x++)
       {xyz->coords[xyz->num_coords].x = x;
        xyz->coords[xyz->num_coords].y = y;
        xyz->coords[xyz->num_coords].z = z;
        xyz->num_coords += 1;}
 return NO_ERROR;
}
End chop ***************************/


/*---------------------------------------------------------------------
PlaneCoords_11 - ???
----------------------------------------------------------------------*/

int
PlaneCoords_11(plane,_3d,xyz,the_planetoxyz)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 struct ary_pt_3d_rec *xyz;
 struct matrix_3d_rec *the_planetoxyz;
{
 int err;
 long x,y,tx,ty,tz;
 struct matrix_3d_rec *planetoxyz,planetoxyz1,mat;
 struct vector_3d_rec *coord_ratio;
 float dx,dy,dz; 
 float xstart,ystart,zstart,z20,y10,x00,z21,y11,x01;
 unsigned long dimx,dimy,total;

 identity_3d_matrix(&mat);
 assign_translation(&mat,(float) -((long) _3d->startx),
       (float) -((long) _3d->starty),(float)-((long)_3d->startz));
 mult_3d_matrix(&planetoxyz1,&mat,the_planetoxyz);

 planetoxyz = &planetoxyz1;
 coord_ratio = &(plane->coord_ratio);

 trans_3d_xyz(planetoxyz,(float) plane->firstx,(float) plane->firsty,.0,
         &xstart,&ystart,&zstart,0);
 xstart = (xstart * coord_ratio->x);
 ystart = (ystart * coord_ratio->y);
 zstart = (zstart * coord_ratio->z);

 x00 = planetoxyz->buf[0][0] * coord_ratio->x;
 y10 = planetoxyz->buf[1][0] * coord_ratio->y;
 z20 = planetoxyz->buf[2][0] * coord_ratio->z;

 x01 = planetoxyz->buf[0][1] * coord_ratio->x;
 y11 = planetoxyz->buf[1][1] * coord_ratio->y;
 z21 = planetoxyz->buf[2][1] * coord_ratio->z;

 total = plane->proj_dimy * plane->proj_dimx;
 if ((total + xyz->num_coords) > xyz->total_coords)
    {total = total + xyz->num_coords - xyz->total_coords;
     if ((err = get_ptr(&(xyz->coords),&(xyz->total_coords),total,
             (size_t) sizeof(*(xyz->coords)))) != NO_ERROR)
        return err;
    }
 dimy = plane->proj_dimy;
 dimx = plane->proj_dimx;
 for (y = 0; y < dimy; y++,xstart += x01,ystart += y11,zstart += z21)
    {dx = xstart;
     dy = ystart;
     dz = zstart;
     for (x = 0; x < dimx; x++,dx += x00,dy += y10,dz += z20)
        {tz = (long) dz;
         ty = (long) dy;
         tx = (long) dx;
         if ((dx < .0) || (dy < .0) || (dz < .0) ||
             (tz < 0) || (tz >= _3d->dimz) || 
             (ty < 0) || (ty >= _3d->dimy) || (tx < 0) || (tx >= _3d->dimx))
            {continue;}
         xyz->coords[xyz->num_coords].x = tx;
         xyz->coords[xyz->num_coords].y = ty;
         xyz->coords[xyz->num_coords].z = tz;
         xyz->num_coords += 1;
        }
    }
 return NO_ERROR;
}



/*---------------------------------------------------------------------
_3d_plane_coords - ???

FIXME:  update this
----------------------------------------------------------------------*/

int
_3d_plane_coords(plane,_3d,xyz)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 struct ary_pt_3d_rec *xyz;
{
 struct matrix_3d_rec *planetoxyz,planetoxyz1;

 TRACE(printf("_3d_plane_coords..._3d->status = %x\n",_3d->status))
/*
 if ((err = natural_zplane(plane)) == NO_ERROR)
     return zplane_coords_00_10(plane,_3d,xyz);
   else
*/
 if (plane->rotate.z != 0.0)
 /*if (!(plane->status & PLANE_TRANS_IDENTITY))*/
    {setup_zrotate_3d_matrix(&planetoxyz1,plane->rotate.z);
     mult_3d_matrix(&planetoxyz1,&planetoxyz1,&(plane->xyztoplane));

     /*mult_3d_matrix(&planetoxyz1,&(plane->trans),&(plane->xyztoplane));*/
     inverse_4d_matrix(&planetoxyz1,&planetoxyz1);
     planetoxyz = &planetoxyz1;
    }
   else planetoxyz = &(plane->planetoxyz);
 return PlaneCoords_11(plane,_3d,xyz,planetoxyz);
}


/*---------------------------------------------------------------------
xyz_xy_status - ???
----------------------------------------------------------------------*/

int
xyz_xy_status(_3d_2ds,num_3d_2ds)
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long num_3d_2ds;
{
 unsigned long cnt;

 for (cnt = 0; cnt < num_3d_2ds; cnt++)
    if (_3d_2ds[cnt]._3d->status & _3D_XYZ_XY_01) return _3D_XYZ_XY_11;
      else if (_3d_2ds[cnt]._3d->status & _3D_XYZ_XY_11) 
       return _3D_XYZ_XY_11;

 return _3D_XYZ_XY_10;
}


/*---------------------------------------------------------------------
Get3dPlaneDataApprox - ???
----------------------------------------------------------------------*/

int
Get3dPlaneDataApprox(plane,_3d,result_2d)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 struct buf_2d_rec *result_2d;
{
 struct matrix_3d_rec *planetoxyz,planetoxyz1;

 TRACE(printf("Get3dPlaneDataApprox..._3d->status = %x\n",_3d->status));
 if (((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK) ||
     (plane->proj_dimx == 0) || (plane->proj_dimy == 0))
    {InitBuf2dRecData(result_2d,(double) .0);
     return NO_ERROR;}
   else
    {
     if (plane->rotate.z != 0.0)
        {setup_zrotate_3d_matrix(&planetoxyz1,plane->rotate.z);
         mult_3d_matrix(&planetoxyz1,&planetoxyz1,&(plane->xyztoplane));
         inverse_4d_matrix(&planetoxyz1,&planetoxyz1);
         planetoxyz = &planetoxyz1;
        }
       else planetoxyz = &(plane->planetoxyz);

     if ((_3d->status & _3D_XYZ_XY_00) || (_3d->status & _3D_XYZ_XY_10))
        return PlaneData_00_10Approx(plane,_3d,result_2d,planetoxyz);
       else
        return PlaneData_11Approx(plane,_3d,result_2d,planetoxyz);
    }
}


/*---------------------------------------------------------------------
Get3dPlaneData - ???
----------------------------------------------------------------------*/

int
Get3dPlaneData(plane,_3d,result_2d)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 struct buf_2d_rec *result_2d;
{
 struct matrix_3d_rec *planetoxyz,planetoxyz1;

 TRACE(printf("Get3dPlaneData..._3d->status = %x\n",_3d->status));
 if (((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK) ||
     (plane->proj_dimx == 0) || (plane->proj_dimy == 0))
    {InitBuf2dRecData(result_2d,(double) .0);
     return NO_ERROR;}
   else
    {
     if (plane->rotate.z != 0.0)
        {setup_zrotate_3d_matrix(&planetoxyz1,plane->rotate.z);
         mult_3d_matrix(&planetoxyz1,&planetoxyz1,&(plane->xyztoplane));
         inverse_4d_matrix(&planetoxyz1,&planetoxyz1);
         planetoxyz = &planetoxyz1;
        }
       else planetoxyz = &(plane->planetoxyz);

     if ((_3d->status & _3D_XYZ_XY_00) || (_3d->status & _3D_XYZ_XY_10))
        return PlaneData_00_10(plane,_3d,result_2d,planetoxyz);
       else
        return PlaneData_11(plane,_3d,result_2d,planetoxyz);
    }
}



/*---------------------------------------------------------------------
Get3dPlane2dsApprox - ???
----------------------------------------------------------------------*/

int
Get3dPlane2dsApprox( plane,
		    _3d_2ds,
		    num_3d_2ds )
     struct plane_3d_rec *plane;
     struct _3d_plane_2d_rec *_3d_2ds;
     unsigned long num_3d_2ds;
{
  unsigned long cnt;
  struct matrix_3d_rec *planetoxyz,planetoxyz1;

  TRACE(printf("Get3dPlane2dsApprox...num_3d_2ds = %d\n",num_3d_2ds));
  if (((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK) ||
      (plane->proj_dimx == 0) ||
      (plane->proj_dimy == 0))
  {
    for (cnt = 0; cnt < num_3d_2ds; cnt++)
      InitBuf2dRecData( _3d_2ds[cnt].plane_2d,
		       (double) .0 );
    return CANCEL;
  }
  else if (num_3d_2ds == 1)
  {
    PRT1(printf("Get3dPlane2ds...Get3dPlaneData\n"));
    return Get3dPlaneDataApprox( plane,
				_3d_2ds[0]._3d,
				_3d_2ds[0].plane_2d );
  }
  else
  {
    if (plane->rotate.z != 0.0)
      /*if (!(plane->status & PLANE_TRANS_IDENTITY))*/
    {
      setup_zrotate_3d_matrix(&planetoxyz1,plane->rotate.z);
      mult_3d_matrix(&planetoxyz1,&planetoxyz1,&(plane->xyztoplane));
      inverse_4d_matrix(&planetoxyz1,&planetoxyz1);
      planetoxyz = &planetoxyz1;
    }
    else
      planetoxyz = &(plane->planetoxyz);
    if (xyz_xy_status(_3d_2ds,num_3d_2ds) == _3D_XYZ_XY_10)
    {
      PRT1(printf("Get3dPlane2ds...Plane2ds_10\n"));
      return Plane2ds_10Approx(plane,_3d_2ds,num_3d_2ds,planetoxyz);
    }
    else 
    {
      PRT1(printf("Get3dPlane2ds...Plane2ds_11\n"));
      return Plane2ds_11Approx(plane,_3d_2ds,num_3d_2ds,planetoxyz);
    }
  }
}



/*---------------------------------------------------------------------
Get3dPlane2ds - ???
----------------------------------------------------------------------*/

int
Get3dPlane2ds(plane,_3d_2ds,num_3d_2ds)
 struct plane_3d_rec *plane;
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long num_3d_2ds;
{
 int err=0,is_same;
 unsigned long cnt;
 struct matrix_3d_rec *planetoxyz,planetoxyz1;

 TRACE(printf("Get3dPlane2ds...num_3d_2ds = %d\n",num_3d_2ds));
 if (((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK) ||
     (plane->proj_dimx == 0) || (plane->proj_dimy == 0))
    {for (cnt = 0; cnt < num_3d_2ds; cnt++)
        InitBuf2dRecData(_3d_2ds[cnt].plane_2d,(double) .0);
     return NO_ERROR;}
   else
    {if (num_3d_2ds == 1) is_same = 0;
       else
        for (is_same = 1,cnt = 1; cnt < num_3d_2ds; cnt++)
           if ((_3d_2ds[cnt]._3d->status & _3D_APPROX) !=
               (_3d_2ds[0]._3d->status & _3D_APPROX))
              {is_same = 0;
               break;}
     PRT3(printf("===is_same = %d\n",is_same))
     if (is_same == 0)
        {for (cnt = 0; cnt < num_3d_2ds; cnt++)
            if (_3d_2ds[cnt]._3d->status & _3D_APPROX)
               {if ((err = Get3dPlaneDataApprox(plane,_3d_2ds[cnt]._3d,
                        _3d_2ds[cnt].plane_2d)) != NO_ERROR)
                   break;
               }
              else if ((err = Get3dPlaneData(plane,_3d_2ds[cnt]._3d,
                      _3d_2ds[cnt].plane_2d)) != NO_ERROR)
                   break;
         return err;
        }
       else
        {PRT3(printf("$$$ is_same = %d\n",is_same))
         if (plane->rotate.z != 0.0)
            {setup_zrotate_3d_matrix(&planetoxyz1,plane->rotate.z);
             mult_3d_matrix(&planetoxyz1,&planetoxyz1,&(plane->xyztoplane));
             inverse_4d_matrix(&planetoxyz1,&planetoxyz1);
             planetoxyz = &planetoxyz1;
            }
           else planetoxyz = &(plane->planetoxyz);
         if (xyz_xy_status(_3d_2ds,num_3d_2ds) == _3D_XYZ_XY_10)
            {if (_3d_2ds[0]._3d->status & _3D_APPROX)
                return Plane2ds_10Approx(plane,_3d_2ds,num_3d_2ds,planetoxyz);
               else return Plane2ds_10(plane,_3d_2ds,num_3d_2ds,planetoxyz);
            }
           else 
            {if (_3d_2ds[0]._3d->status & _3D_APPROX)
                return Plane2ds_11Approx(plane,_3d_2ds,num_3d_2ds,planetoxyz);
               else return Plane2ds_11(plane,_3d_2ds,num_3d_2ds,planetoxyz);
            }
        }
    }
}


/*---------------------------------------------------------------------
_3dPlaneData - ???
----------------------------------------------------------------------*/

int
_3dPlaneData(plane,_3d,result_2d,is_approx)
 struct plane_3d_rec *plane;
 struct buf_3d_rec *_3d;
 struct buf_2d_rec *result_2d;
 unsigned long is_approx;
{
 if ((plane->status & PLANE_APPROX_VALUE) || (_3d->status & _3D_APPROX))
    return Get3dPlaneDataApprox(plane,_3d,result_2d);
   else return Get3dPlaneData(plane,_3d,result_2d);
}



/*---------------------------------------------------------------------
_3dPlane2ds - ???
----------------------------------------------------------------------*/

int
_3dPlane2ds( plane,
	    _3d_2ds,
	    num_3d_2ds )
     struct plane_3d_rec *plane;
     struct _3d_plane_2d_rec *_3d_2ds;
     unsigned long num_3d_2ds;
{
  if (plane->status & PLANE_APPROX_VALUE)
    return Get3dPlane2dsApprox( plane, _3d_2ds, num_3d_2ds );
  else
    return Get3dPlane2ds( plane, _3d_2ds, num_3d_2ds );
}



/*---------------------------------------------------------------------
paste_plane_2d_data - ???
----------------------------------------------------------------------*/

int
paste_plane_2d_data(plane,_2d,result_2d)
 struct plane_3d_rec *plane;
 struct buf_2d_rec *_2d,*result_2d;
{
 long starty,startx,x,y,firstx,nextx;
 long dimx,dimy;
 double val;

 PRT1(printf("paste_plane_2d_data...result_2d\n"))
 PRT1(pr_buf_2d_rec(result_2d))

 if ((plane->trans_proj_dimx == 0) && (plane->trans_proj_dimy == 0))
    {InitBuf2dRecData(result_2d,(double) .0);
     return NO_ERROR;}

 if ((plane->trans_proj_dimx < result_2d->dimx) ||
     (plane->trans_proj_dimy < result_2d->dimy))
    InitBuf2dRecData(result_2d,(double) .0);

 if (plane->trans_proj_dimy > (long) result_2d->dimy) 
    {starty = 0;
     y = plane->trans_proj_dimy / 2 - result_2d->dimy / 2;
     dimy = result_2d->dimy;}
   else
    {starty = ((long) result_2d->dimy - (long) plane->trans_proj_dimy) / 2;
     dimy = plane->trans_proj_dimy;
     y = 0;}

 if (plane->trans_proj_dimx > (long) result_2d->dimx) 
    {startx = 0;
     firstx = plane->trans_proj_dimx / 2 - result_2d->dimx / 2;
     dimx = result_2d->dimx;}
   else
    {startx = ((long) result_2d->dimx - (long) plane->trans_proj_dimx) / 2;
     dimx = plane->trans_proj_dimx;
     firstx = 0;}

 for (; y < dimy; y++,starty++)
    {for (nextx = startx,x = firstx; x < dimx; x++,nextx++)
        {
         val = _2d->GetVal(_2d,y,x);
         result_2d->SetVal(result_2d,starty,nextx,val);
        }
    }
 result_2d->status4 |= BUF_DATA_VALID;
 PRT1(MinMax2dValues(result_2d,0,(double) .0,(double) .0,&val,&val2);
     printf("paste_plane_2d_data result_2d min = %f max = %f\n",val,val2))
 return NO_ERROR;
}


/*---------------------------------------------------------------------
trans_plane_2d_data - ???
----------------------------------------------------------------------*/

int
trans_plane_2d_data(plane,_2d,result_2d)
 struct plane_3d_rec *plane;
 struct buf_2d_rec *_2d,*result_2d;
{
 long x,y,ty,tx,nx,ny;
 double fval,fval1,val;
 float dx,dy,xstart,ystart,disx,disy,ndisx,ndisy;
 unsigned long _2d_dimx,_2d_dimy;
 struct matrix_3d_rec inv;
 long starty,startx,firstx,nextx;
 long dimx,dimy;

 PRT1(printf("trans_plane_2d_data...\n"))

 InitBuf2dRecData(result_2d,(double) .0);
 if ((plane->trans_proj_dimx == 0) && (plane->trans_proj_dimy == 0))
    return NO_ERROR;

 inverse_4d_matrix(&inv,&(plane->trans));
 if (plane->trans_proj_dimy > (long) result_2d->dimy) 
    {starty = 0;
     y = plane->trans_proj_dimy / 2 - result_2d->dimy / 2;
     dimy = result_2d->dimy;}
   else
    {starty = ((long) result_2d->dimy - (long) plane->trans_proj_dimy) / 2;
     dimy = plane->trans_proj_dimy;
     y = 0;}

 if (plane->trans_proj_dimx > (long) result_2d->dimx) 
    {startx = 0;
     firstx = plane->trans_proj_dimx / 2 - result_2d->dimx / 2;
     dimx = result_2d->dimx;
    }
   else
    {startx = ((long) result_2d->dimx - (long) plane->trans_proj_dimx) / 2;
     dimx = plane->trans_proj_dimx;
     firstx = 0;}

 xstart = inv.buf[0][0] * firstx + inv.buf[0][1] * y + inv.buf[0][3];
 ystart = inv.buf[1][0] * firstx + inv.buf[1][1] * y + inv.buf[1][3];
/*
 printf("startx = %d starty = %d\n",startx,starty);
 printf("y = %d  dimy = %d  fx = %d dimx = %d\n",y,dimy,firstx,dimx,nextx);
 printf("xstart = %f  ystart = %f\n",xstart,ystart);
 printf("_2d = %u proj_dimx = %d proj_dimy = %d\n",_2d,plane->proj_dimx,plane->proj_dimy);
*/
 _2d_dimx = _2d->dimx;
 _2d_dimy = _2d->dimy;

 for (; y < dimy; y++,starty++)
    {dx = xstart;
     dy = ystart;
     for (nextx = startx,x = firstx; x < dimx; x++,nextx++,
                 dx += inv.buf[0][0],dy += inv.buf[1][0])
        {
         tx = (long) dx;
         if ((tx < 0) || (tx >= _2d_dimx)) continue;
         ty = (long) dy;
         if ((ty < 0) || (ty >= _2d_dimy)) continue;
         disx = dx - (float) tx;
         disy = dy - (float) ty;

         ndisy = 1.0 - disy;
         ndisx = 1.0 - disx;

         nx = tx + 1;
         if (ndisy > ALMOST_0)
            {if ((val = _2d->GetVal(_2d,ty,tx)) == 0) fval = .0;
               else fval = ndisx * val;
             if (nx < _2d_dimx)
                {if ((val = _2d->GetVal(_2d,ty,nx)) != 0)
                    fval += disx * val;
                }
             if (fval != .0) fval *= ndisy;
            }
           else fval = 0.0;
         if ((disy > ALMOST_0) && ((ny = (ty + 1)) < _2d_dimy))
            {if ((val = _2d->GetVal(_2d,ny,tx)) == 0) fval1 = .0;
               else fval1 = ndisx * val;
             if (nx < _2d_dimx)
                {if ((val = _2d->GetVal(_2d,ny,nx)) != 0)
                    fval1 += disx * val;}
             if (fval1 != .0) 
                fval += fval1 * disy;
            }
         result_2d->SetVal(result_2d,starty,nextx,fval);
        }
     xstart += inv.buf[0][1];
     ystart += inv.buf[1][1];
    }
/* printf("\n");*/
 result_2d->status4 |= BUF_DATA_VALID;

 return NO_ERROR;
}


/*---------------------------------------------------------------------
paste_plane_2ds - ???
----------------------------------------------------------------------*/

int
paste_plane_2ds(plane,_3d_2ds,num_3d_2ds)
 struct plane_3d_rec *plane;
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long num_3d_2ds;
{
 long starty,startx,x,y,firstx,nextx,lcv,dimx,dimy;
 double val; 
 struct buf_2d_rec *_2d,*result_2d;


 if ((plane->trans_proj_dimx == 0) && (plane->trans_proj_dimy == 0))
    {
     for (lcv = 0; lcv < num_3d_2ds; lcv++)
        InitBuf2dRecData(_3d_2ds[lcv].transform_2d,(double) .0);
     return NO_ERROR;}
 for (lcv = 0; lcv < num_3d_2ds; lcv++)
    if ((plane->trans_proj_dimx < _3d_2ds[lcv].transform_2d->dimx) ||
        (plane->trans_proj_dimy < _3d_2ds[lcv].transform_2d->dimy))
       InitBuf2dRecData(_3d_2ds[lcv].transform_2d,(double) .0);

 if (plane->trans_proj_dimy > (long) plane->proj_buf_dimy) 
    {starty = 0;
     y = plane->trans_proj_dimy / 2 - plane->proj_buf_dimy / 2;
     dimy = y + plane->proj_buf_dimy;}
   else
    {starty = ((long) plane->proj_buf_dimy - (long) plane->trans_proj_dimy) / 2;
     dimy = plane->trans_proj_dimy;
     y = 0;}

 if (plane->trans_proj_dimx > (long) plane->proj_buf_dimx) 
    {startx = 0;
     firstx = plane->trans_proj_dimx / 2 - plane->proj_buf_dimx / 2;
     dimx = firstx + plane->proj_buf_dimx;}
   else
    {startx = ((long) plane->proj_buf_dimx - (long) plane->trans_proj_dimx) / 2;
     dimx = plane->trans_proj_dimx;
     firstx = 0;}

 for (; y < dimy; y++,starty++)
    for (lcv = 0; lcv < num_3d_2ds; lcv++)
       {_2d = _3d_2ds[lcv].plane_2d;
        result_2d = _3d_2ds[lcv].transform_2d;
        for (x = firstx,nextx = startx; x < dimx; x++,nextx++)
           {
            val = _2d->GetVal(_2d,y,x);
            result_2d->SetVal(result_2d,starty,nextx,val);
           }
       }
 for (lcv = 0; lcv < num_3d_2ds; lcv++)
    _3d_2ds[lcv].transform_2d->status4 |= BUF_DATA_VALID;

 return NO_ERROR;
}


/*---------------------------------------------------------------------
trans_plane_2ds - ???
----------------------------------------------------------------------*/

int
trans_plane_2ds(plane,_3d_2ds,num_3d_2ds)
 struct plane_3d_rec *plane;
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long num_3d_2ds;
{
 struct matrix_3d_rec inv;
 long starty,startx,x,y,firstx,nextx;
 double fval,fval1,val;
 float dx,dy,xstart,ystart,disx,disy,ndisx,ndisy;
 long ty,tx,lcv,dimx,dimy,ny,nx;
 struct buf_2d_rec *_2d,*result_2d;
 unsigned long _2d_dimx,_2d_dimy;

 for (lcv = 0; lcv < num_3d_2ds; lcv++)
    InitBuf2dRecData(_3d_2ds[lcv].transform_2d,(double) .0);
 if ((plane->trans_proj_dimx == 0) && (plane->trans_proj_dimy == 0)) return NO_ERROR;
 inverse_4d_matrix(&inv,&(plane->trans));

 if (plane->trans_proj_dimy > (long) plane->proj_buf_dimy) 
    {starty = 0;
     y = plane->trans_proj_dimy / 2 - plane->proj_buf_dimy / 2;
     dimy = y + plane->proj_buf_dimy;}
   else
    {starty = ((long) plane->proj_buf_dimy - (long) plane->trans_proj_dimy) / 2;
     dimy = plane->trans_proj_dimy;
     y = 0;}

 if (plane->trans_proj_dimx > (long) plane->proj_buf_dimx) 
    {startx = 0;
     firstx = plane->trans_proj_dimx / 2 - plane->proj_buf_dimx / 2;
     dimx = firstx + plane->proj_buf_dimx;}
   else
    {startx = ((long) plane->proj_buf_dimx - (long) plane->trans_proj_dimx) / 2;
     dimx = plane->trans_proj_dimx;
     firstx = 0;}

 xstart = inv.buf[0][0] * firstx + inv.buf[0][1] * y + inv.buf[0][3];
 ystart = inv.buf[1][0] * firstx + inv.buf[1][1] * y + inv.buf[1][3];
 for (; y < dimy; y++,starty++)
    {
     for (lcv = 0; lcv < num_3d_2ds; lcv++)
        {
         _2d = _3d_2ds[lcv].plane_2d;
         _2d_dimx = _2d->dimx;
         _2d_dimy = _2d->dimy;
         result_2d = _3d_2ds[lcv].transform_2d;

         dx = xstart;
         dy = ystart;
         for (nextx = startx,x = firstx; x < dimx; x++,nextx++,
                 dx += inv.buf[0][0],dy += inv.buf[1][0])
            {
             tx = (long) dx;
             if ((tx < 0) || (tx >= _2d_dimx)) continue;
             ty = (long) dy;
             if ((ty < 0) || (ty >= _2d_dimy)) continue;
             disx = dx - (float) tx;
             disy = dy - (float) ty;
             ndisy = 1.0 - disy;
             ndisx = 1.0 - disx;
             nx = tx + 1;
             if (ndisy > ALMOST_0)
                {if ((val = _2d->GetVal(_2d,ty,tx)) == 0) fval = .0;
                   else fval = ndisx * val;
                 if (nx < _2d_dimx)
                    {if ((val = _2d->GetVal(_2d,ty,nx)) != 0)
                        fval += disx * val;
                    }
                 if (fval != .0) fval *= ndisy;
                }
               else fval = 0.0;
             if ((disy > ALMOST_0) && ((ny = (ty + 1)) < _2d_dimy))
                {if ((val = _2d->GetVal(_2d,ny,tx)) == 0) fval1 = .0;
                   else fval1 = ndisx * val;
                 if (nx < _2d_dimx)
                    {if ((val = _2d->GetVal(_2d,ny,nx)) != 0)
                        fval1 += disx * val;}
                 if (fval1 != .0) 
                    fval += fval1 * disy;
                }
             result_2d->SetVal(result_2d,starty,nextx,fval);
            }
        }
     xstart += inv.buf[0][1];
     ystart += inv.buf[1][1];
    }

 for (lcv = 0; lcv < num_3d_2ds; lcv++)
    _3d_2ds[lcv].transform_2d->status4 |= BUF_DATA_VALID;

 return NO_ERROR;
}



/*---------------------------------------------------------------------
transform_plane_2d_data - ???
----------------------------------------------------------------------*/

int
transform_plane_2d_data(plane,_2d,result_2d)
 struct plane_3d_rec *plane;
 struct buf_2d_rec *_2d,*result_2d;
{
 PRT(printf("===transform_plane_2d_data...===\n");)
 return paste_plane_2d_data(plane,_2d,result_2d);
/*
 return copy_buf_2d_rec(result_2d,_2d);
*/
/*
 if (plane->status & PLANE_TRANS_IDENTITY)
    return paste_plane_2d_data(plane,_2d,result_2d);
   else return trans_plane_2d_data(plane,_2d,result_2d);
*/
}


/*---------------------------------------------------------------------
transform_plane_2ds - ???
----------------------------------------------------------------------*/

int
transform_plane_2ds(plane,_3d_2ds,num_3d_2ds)
 struct plane_3d_rec *plane;
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long num_3d_2ds;
{
/*
 unsigned long lcv;
 int err;
*/

 PRT(printf("transform_plane_2ds...Get3dPlane2ds\n"))
/*
 for (lcv = 0; lcv < num_3d_2ds; lcv++)
    if ((err = copy_buf_2d_rec(_3d_2ds[lcv].transform_2d,
          _3d_2ds[lcv].plane_2d))) != NO_ERROR)
       return err;
 return err;
*/
 if (num_3d_2ds == 1)
    return transform_plane_2d_data(plane,_3d_2ds[0].plane_2d,
               _3d_2ds[0].transform_2d);
   else return paste_plane_2ds(plane,_3d_2ds,num_3d_2ds);
}

