#include <stdio.h>
#include <sys/types.h>
#include <varargs.h>
#include "typedef.h"
#include "ia_hdr.h"
#include "error_constants.h"
/*
 cc -c hdr_opr.c
*/
/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT2(x)
#define PRT4(x)
#define PRT3(x)
#define PRT5(x)
#define PRT8(x)
/*
init_color_control_rec(color_control)
init_extra_file_info_rec(extra_info)
init_hdr_scan_entry_rec(slice)
free_hdr_scan_entry_rec(slice)
init_patient_rec(patient)
free_patient_rec(patient)
init_data_info_rec(info)
free_data_info_rec(info)
init_analysis_group_rec(group)
init_hdr_analysis_rec(analysis)
init_hdr_rec(hdr)

free_analysis_group_rec(groups,num_analysis_groups)
free_hdr_analysis_rec(analysis)
setup_hdr_analysis_rec(va_alist)
free_hdr_scan_entry_recs(scans,num_scans);
free_extra_file_info_rec(extra_info)
free_hdr_rec(hdr)

char get_plane_type_indicator(plane_type)
char *get_plane_type(plane_type)
char *get_patient_id(hdr)
build_default_datafn(hdr)

slice_entry_index_to_addr(scans,num_scans)
slice_entry_addr_to_index(scans,num_scans)
wr_extra_file_info_rec(fid,extra_info)
wr_hdr(fid,hdr)
wr_the_hdr(fn,hdr)

wr_patient_rec(fid,patient)
wr_data_info_rec(fid,info)
wr_analysis_group(fid,group,num_groups)
wr_analysis_rec(fid,analysis)

wr_slice_entries(fid,scans,num_scans)

rd_the_hdr(fn,hdr)
rd_hdr(fid,hdr)
rd_extra_file_info_rec(fid,extra_info)

rd_patient_rec(fid,patient)
rd_data_info_rec(fid,info)
rd_analysis_group(fid,group,num_groups)
rd_analysis_rec(fid,analysis)
RdSliceEntries(fid,scans,num_scans,hdr)

unsigned long NumberOfSliceScans(info)
unsigned long NumberOfSliceCuts(info)
ValidateHdrParams(hdr,maxdimx,maxdimy,maxscans,maxechoes)
ScanEchoNum(hdr,scan,echo_num)
LocateScanEntry(hdr,slice_num,scan_num,echo_num,scan_entry)
FileHdrScan(hdr,scan,indx)
ComputeScanEntryExtraInfo(hdr)
RedefineHdrNumBySliceNum(hdr)
ReverseHdrScans(hdr)
unsigned long SetHdrScanEntryStatus(hdr,fsnum,lsnum,fecho,
                      lecho,fscan,lscan,set_select,status)

cp_patient_rec(dest,src,is_dest_new)
cp_data_info_rec(dest,src,is_dest_new)
cp_analysis_group_rec(dest,src,is_dest_new)
cp_hdr_analysis_rec(dest,src,is_dest_new)
cp_extra_file_info_rec(dest,src,is_dest_new)
cp_hdr_scan_entry_rec(dest,src,is_dest_new)
cp_hdr_rec(dest,src,is_dest_new)

unsigned long ImageFileSize(hdr)
*/
unsigned long NumberOfSliceScans();
unsigned long NumberOfSliceCuts();

init_color_control_rec(color_control)
 struct color_control_rec *color_control;
{
 color_control->status = 0;
}

init_extra_file_info_rec(extra_info)
 struct extra_file_info_rec *extra_info;
{
 extra_info->color_bundle_label = NULL;
 init_color_control_rec(&(extra_info->color_control));
 extra_info->last_edit_begin = NULL;
 extra_info->last_edit_end = NULL;
}

init_hdr_scan_entry_rec(slice)
 struct hdr_scan_entry_rec *slice;
{
 slice->status = 0;
 slice->img_label = NULL;
 slice->img_addr = slice->num = 0;
 slice->slice_num = slice->scan_num = 0;
 slice->prior_slice = slice->partner_slice = slice->next_slice = NULL;
 slice->slice = NULL;
}

free_hdr_scan_entry_rec(slice)
 struct hdr_scan_entry_rec *slice;
{
 c_free(slice->img_label);
}

init_patient_rec(patient)
 struct patient_rec *patient;
{
 patient->name = patient->ssnum = patient->patient_num =
        patient->patient_id = patient->study_num = NULL;
 patient->sex = ' ';
 patient->age = 0;
 patient->height = patient->weight = 0;
}

free_patient_rec(patient)
 struct patient_rec *patient;
{
 c_free(patient->name);
 c_free(patient->ssnum);
 c_free(patient->patient_id);
 c_free(patient->study_num);
 c_free(patient->patient_num);
}

init_data_info_rec(info)
 struct data_info_rec *info;
{
 static float trans_matrix[4][4] = { {1.0,.0,.0,.0},{.0,1.0,.0,.0},
                                     {.0,.0,1.0,.0},{.0,.0,.0,1.0}};
 info->image_id = NULL;
 info->default_datafn = NULL;
 info->dimx = info->dimy = info->max_scans = 0;
 info->pixval_max = info->pixval_min = 0;
 info->histo_dimx = info->histo_dimy = 256;
 info->pixel_depth_bits = 0;
 info->xpixel_size = info->ypixel_size = .0;
 info->spacing = info->pixel_thickness = .0;
 info->plane_type = -1;
 memcpy(info->trans_matrix,trans_matrix,(size_t) sizeof(info->trans_matrix));

 info->var_use_status = 0;
 info->actual_pixval_min = 0;
 info->num_scans = 0;
 info->unused2 = info->unused3 = info->unused4 = info->unused5 = 0;
 info->unused6 = info->unused7 = .0;
 info->num_echoes = 0;
 info->tr = 0;
 info->te = info->date_of_study = info->time_of_study = NULL;
 init_patient_rec(&(info->patient));
 info->refered_by = info->description = info->hosp_name = NULL;
}

free_data_info_rec(info)
 struct data_info_rec *info;
{
 c_free(info->image_id);
 c_free(info->default_datafn);
 c_free(info->te);
 c_free(info->date_of_study);
 c_free(info->time_of_study);
 free_patient_rec(&(info->patient));
 c_free(info->refered_by);
 c_free(info->description);
 c_free(info->hosp_name);
 init_data_info_rec(info);
}

init_analysis_group_rec(group)
 struct analysis_group_rec *group;
{
 group->num_members = 0;
 group->member_img_label_indx = 0;
}

init_hdr_analysis_rec(analysis)
 struct hdr_analysis_rec *analysis;
{
 analysis->num_img_labels = 0;
 analysis->img_labels = NULL;
 analysis->num_analysis_groups = 0;
 analysis->groups = NULL;
}

/* initialize the pointers & the counters */
init_hdr_rec(hdr)
 struct hdr_rec *hdr;
{
 hdr->size = 0;
 hdr->id = NULL;
 hdr->offset.info_start = hdr->offset.info_size = 0;
 hdr->offset.extra_info_start = hdr->offset.extra_info_size = 0;
 hdr->offset.comment_start = hdr->offset.comment_size = 0;
 hdr->offset.user_defined_start = hdr->offset.user_defined_size = 0;

 init_data_info_rec(&(hdr->data_info));
 init_hdr_analysis_rec(&(hdr->analysis));

 hdr->num_scans = 0;
 hdr->scans = NULL;
 init_extra_file_info_rec(&(hdr->extra_info));
 hdr->comment_size = 0;
 hdr->comment = NULL;
 hdr->user_defined_size = 0;
 hdr->user_defined = NULL;
}

free_analysis_group_rec(groups,num_analysis_groups)
 struct analysis_group_rec *groups;
 unsigned_int num_analysis_groups;
{
 unsigned_int lcv;

 for (lcv = 0; lcv < num_analysis_groups; lcv++)
    c_free(groups[lcv].member_img_label_indx);
}

free_hdr_analysis_rec(analysis)
 struct hdr_analysis_rec *analysis;
{
 free_handle_memory(analysis->img_labels,analysis->num_img_labels);
 free_analysis_group_rec(analysis->groups,analysis->num_analysis_groups);
 c_free(analysis->groups);
 init_hdr_analysis_rec(analysis);
}

/*
setup_hdr_analysis_rec(analysis,num_img_labels[,labe1,...,labeln,
            [num_analysis_groups[,num_members,g1_num1,...,g1_numn,
                num_members,g2_num1,...,g2_numn,...]]])
*/
setup_hdr_analysis_rec(va_alist)
 va_dcl
{
 va_list args;

 unsigned_int lcv,cnt;
 unsigned_int num_img_labels,num_analysis_groups,num_members;
 struct hdr_analysis_rec *analysis;
 struct analysis_group_rec *group;
 int err;
 char *str;

 va_start(args);
 analysis = va_arg(args, struct hdr_analysis_rec *);
 num_img_labels = va_arg(args, unsigned_int);
 if (num_img_labels <= 0) return CANCEL;
 get_ptr_memory(&(analysis->img_labels),&(analysis->num_img_labels),num_img_labels,
    (size_t) sizeof(*(analysis->img_labels)),&err);
 if (err != NO_ERROR) return err;
 for (lcv = 0; lcv < analysis->num_img_labels; lcv++)
    analysis->img_labels[lcv] = NULL;

 for (lcv = 0; lcv < analysis->num_img_labels; lcv++)
    {if ((str = va_arg(args, char *)) != NULL)
        if ((err = cp_str(&(analysis->img_labels[lcv]),str)) != NO_ERROR)
           break;
    }
 if (err == NO_ERROR)
    {num_analysis_groups = va_arg(args, unsigned_int);
     if (num_analysis_groups > 0)
        {get_ptr_memory(&(analysis->groups),
             &(analysis->num_analysis_groups),num_analysis_groups,
            (size_t) sizeof(*(analysis->groups)),&err);
         if (err == NO_ERROR) 
            {for (lcv = 0; lcv < analysis->num_analysis_groups; lcv++)
                init_analysis_group_rec(&(analysis->groups[lcv]));
             for (lcv = 0; lcv < analysis->num_analysis_groups; lcv++)
                {num_members = va_arg(args, unsigned_int);
                 group = &(analysis->groups[lcv]);
                 get_ptr_memory(&(group->member_img_label_indx),
                     &(group->num_members),num_members,
                     (size_t) sizeof(*(group->member_img_label_indx)),&err);
                 if (err != NO_ERROR) break;
                 for (cnt = 0; cnt < num_members; cnt++)
                    group->member_img_label_indx[cnt] = va_arg(args, unsigned_int);
                }
            }
        }
    }
 va_end(args);
 if (err != NO_ERROR) free_hdr_analysis_rec(analysis);
 return err;
}


free_hdr_scan_entry_recs(scans,num_scans)
 struct hdr_scan_entry_rec *scans;
 unsigned_int num_scans;
{
 unsigned_int lcv;

 for (lcv = 0; lcv < num_scans; lcv++)
    free_hdr_scan_entry_rec(&(scans[lcv]));
}

free_hdr_rec(hdr)
 struct hdr_rec *hdr;
{
 c_free(hdr->id);
 free_data_info_rec(&(hdr->data_info));
 free_hdr_analysis_rec(&(hdr->analysis));
 free_hdr_scan_entry_recs(hdr->scans,hdr->num_scans);
 c_free(hdr->scans);
 free_extra_file_info_rec(&(hdr->extra_info));
 if (hdr->comment_size > 0) c_free(hdr->comment);
 if (hdr->user_defined_size > 0) c_free(hdr->user_defined);
 init_hdr_rec(hdr);
}

free_extra_file_info_rec(extra_info)
 struct extra_file_info_rec *extra_info;
{
 c_free(extra_info->color_bundle_label);
 c_free(extra_info->last_edit_begin);
 c_free(extra_info->last_edit_end);
 init_extra_file_info_rec(extra_info);
}

char get_plane_type_indicator(plane_type)
 int plane_type;
{
 switch (plane_type)
    {case 0 : return 'a';
     case 1 : return 's';
     case 2 : return 'c';
     case 3 : return 'o';
     default : return 'u';
    }
}

char *get_plane_type(plane_type)
 int plane_type;
{
 switch (plane_type)
    {case 0 : return "AXIAL";
     case 1 : return "SAGITTAL";
     case 2 : return "CORONAL";
     case 3 : return "OBLIQUE";
     default : return "UNKNOWN";
    }
}

char *get_patient_id(hdr)
 struct hdr_rec *hdr;
{
 if ((hdr->data_info.patient.patient_num != NULL) &&
     (strlen(hdr->data_info.patient.patient_num) != 0))
    return hdr->data_info.patient.patient_num;
 return hdr->data_info.patient.study_num;
}
    
build_default_datafn(hdr)
 struct hdr_rec *hdr;
{
 char *str,*str1,str2[2];
 int err;

 if ((err = cp_str(&str1,hdr->data_info.image_id)) != NO_ERROR)
    return err;
 str2[0] = get_plane_type_indicator(hdr->data_info.plane_type);
 str2[1] = '\0';

 if ((err = concat_strs(&str,5,str1,get_patient_id(hdr),str2,".","hdr"))
         != NO_ERROR)
    {c_free(hdr->data_info.default_datafn);
     hdr->data_info.default_datafn = str;
    }
 c_free(str1);
 return err;
 
}

slice_entry_index_to_addr(scans,num_scans)
 struct hdr_scan_entry_rec *scans;
 unsigned_int num_scans;
{
 unsigned_int lcv;

 for (lcv = 0; lcv < num_scans; lcv += 1)
    {
     scans[lcv].prior_slice = &(scans[(int) scans[lcv].prior_slice]);
     scans[lcv].next_slice = &(scans[(int) scans[lcv].next_slice]);
     scans[lcv].partner_slice = &(scans[(int) scans[lcv].partner_slice]);
    }

}

slice_entry_addr_to_index(scans,num_scans)
 struct hdr_scan_entry_rec *scans;
 unsigned_int num_scans;
{
 unsigned_int lcv;

 for (lcv = 0; lcv < num_scans; lcv += 1)
    {scans[lcv].prior_slice = (struct hdr_scan_entry_rec *)
                               (scans[lcv].prior_slice - 
                                &(scans[0]));
     scans[lcv].next_slice =  (struct hdr_scan_entry_rec *)
                              (scans[lcv].next_slice - 
                                &(scans[0]));
     scans[lcv].partner_slice = (struct hdr_scan_entry_rec *)
                                (scans[lcv].partner_slice -
                                 &(scans[0]));
    }

}

wr_extra_file_info_rec(fid,extra_info)
 FILE *fid;
 struct extra_file_info_rec *extra_info;
{
 unsigned_int hdr_size;
 int err;

 err = WRITE_ERROR;
 if (((err = wr_file_strs(fid,&(extra_info->color_bundle_label),1)) 
                 != NO_ERROR) ||
     (fwrite(&(extra_info->color_control),
        sizeof(extra_info->color_control),1,fid) != 1) ||
     ((err = wr_file_strs(fid,&(extra_info->last_edit_begin),1)) != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(extra_info->last_edit_end),1)) != NO_ERROR))
     return err;
 return NO_ERROR;
}

wr_hdr(fid,hdr)
 FILE *fid;
 struct hdr_rec *hdr;
{
 unsigned_int posi;
 size_t amt,offset;
 int err;

 fseek(fid,0L,0);
 err = WRITE_ERROR;
 TRACE(printf("wr_hdr...hdr->id = %s\n",hdr->id))
 if ((fwrite(&(hdr->size),sizeof(hdr->size),1,fid) != 1) ||
     ((err = wr_file_strs(fid,&(hdr->id),1)) != NO_ERROR))
    {if (err == NO_ERROR) err = WRITE_ERROR;
     return err;}
 TRACE(printf("wr_hdr...\n"))
 fflush(fid);
 offset = ftell(fid);
 if (fwrite(&(hdr->offset),sizeof(hdr->offset),1,fid) != 1)
    return WRITE_ERROR;
 fflush(fid);
 hdr->offset.info_start = ftell(fid);

 err = WRITE_ERROR;
 if ((fwrite(&(hdr->status),sizeof(hdr->status),1,fid) != 1) ||
     ((err = wr_data_info_rec(fid,&(hdr->data_info))) != NO_ERROR) ||
     (wr_analysis_rec(fid,&(hdr->analysis)) != 0) ||
     (fwrite(&(hdr->num_scans),sizeof(hdr->num_scans),1,fid) != 1) ||
     (wr_slice_entries(fid,hdr->scans,hdr->num_scans) != 0))
    {if (err == NO_ERROR) err = WRITE_ERROR;
     return err;}
 fflush(fid);
 hdr->offset.info_size = hdr->offset.extra_info_start = ftell(fid);
 hdr->offset.info_size -= hdr->offset.info_start;
 TRACE(printf("info start = %d size = %d\n",hdr->offset.info_start,hdr->offset.info_size))

 if ((err = wr_extra_file_info_rec(fid,&(hdr->extra_info))) != NO_ERROR)
    return err;
 fflush(fid);
 hdr->offset.extra_info_size = hdr->offset.comment_start = ftell(fid);
 hdr->offset.extra_info_size -= hdr->offset.extra_info_start;
 TRACE(printf("extra_info start = %d size = %d\n",hdr->offset.extra_info_start,hdr->offset.extra_info_size))

 err = WRITE_ERROR;
 TRACE(printf("hdr->comment_size = %d\n",hdr->comment_size))
 if ((fwrite(&(hdr->comment_size),sizeof(hdr->comment_size),1,fid) != 1) ||
     ((err = fwr(hdr->comment,hdr->comment_size,1,fid,&amt))
          != NO_ERROR))
    {if (err == NO_ERROR) err = WRITE_ERROR;
     return err;
    }
 fflush(fid);
 hdr->offset.user_defined_start = hdr->offset.comment_size = ftell(fid);
 hdr->offset.comment_size -= hdr->offset.comment_start;

 if ((fwrite(&(hdr->user_defined_size),sizeof(hdr->user_defined_size),1,
          fid) != 1) ||
     ((err = fwr(hdr->user_defined,hdr->user_defined_size,1,fid,&amt))
          != NO_ERROR))
    {if (err == NO_ERROR) err = WRITE_ERROR;
     return err;}
 fflush(fid);
 hdr->offset.user_defined_size = ftell(fid);
 hdr->offset.user_defined_size -= hdr->offset.user_defined_start;

 hdr->size = ftell(fid);
 fseek(fid,0L,0);
 TRACE(printf("hdr->size = %d\n",(int) hdr->size))
 if (fwrite(&(hdr->size),sizeof(hdr->size),1,fid) != 1)
    return WRITE_ERROR;

 fseek(fid,offset,0);
 if (fwrite(&(hdr->offset),sizeof(hdr->offset),1,fid) != 1)
    return WRITE_ERROR;

 return NO_ERROR;
}

wr_the_hdr(fn,hdr)
 char *fn;
 struct hdr_rec *hdr;
{
 FILE *fid;
 int err;

 if (hdr == NULL) return CANCEL;
 TRACE(printf("wr_the_hdr...hdr = %u\n",hdr))
 if ((fid = fopen(fn,"w+")) == NULL)
    {TRACE(printf("\nCould not open output file: %s\n",fn))
     return FILE_ACCESS_ERROR;}

 err = wr_hdr(fid,hdr);
 TRACE(printf("wr_the_hdr...err = %d\n",err))

 fclose(fid);
 return err;
}

wr_patient_rec(fid,patient)
 FILE *fid;
 struct patient_rec *patient;
{
 int err;

 err = WRITE_ERROR;
 if (((err = wr_file_strs(fid,&(patient->name),(unsigned_int) 1))
              != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(patient->ssnum),(unsigned_int) 1))
          != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(patient->patient_id),(unsigned_int) 1))
          != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(patient->study_num),(unsigned_int) 1))
          != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(patient->patient_num),(unsigned_int) 1))
          != NO_ERROR) ||
     (fwrite(&(patient->sex),sizeof(patient->sex),1,fid) != 1) ||
     (fwrite(&(patient->age),sizeof(patient->age),1,fid) != 1) ||
     (fwrite(&(patient->height),sizeof(patient->height),1,fid) != 1) ||
     (fwrite(&(patient->weight),sizeof(patient->weight),1,fid) != 1))
    return err;
 return NO_ERROR;
}

wr_data_info_rec(fid,info)
 FILE *fid;
 struct data_info_rec *info;
{
 int err;

 TRACE(printf("wr_data_info_rec...\n"))
 err = WRITE_ERROR;
 if (((err = wr_file_strs(fid,&(info->image_id),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->default_datafn),(unsigned_int) 1))
         != NO_ERROR) ||
     (fwrite(&(info->num_scans),sizeof(info->num_scans),1,fid) != 1) ||
     (fwrite(&(info->dimx),sizeof(info->dimx),1,fid) != 1) ||
     (fwrite(&(info->dimy),sizeof(info->dimy),1,fid) != 1) ||
     (fwrite(&(info->max_scans),sizeof(info->max_scans),1,fid) != 1) ||
     (fwrite(&(info->pixval_max),sizeof(info->pixval_max),1,fid) != 1) ||
     (fwrite(&(info->pixval_min),sizeof(info->pixval_min),1,fid) != 1) ||
     (fwrite(&(info->actual_pixval_min),sizeof(info->actual_pixval_min),1,fid) != 1) ||
     (fwrite(&(info->histo_dimx),sizeof(info->histo_dimx),1,fid) != 1) ||
     (fwrite(&(info->histo_dimy),sizeof(info->histo_dimy),1,fid) != 1) ||
     (fwrite(&(info->pixel_depth_bits),sizeof(info->pixel_depth_bits),1,fid)
                          != 1) ||
     (fwrite(&(info->xpixel_size),sizeof(info->xpixel_size),1,fid) != 1) ||
     (fwrite(&(info->ypixel_size),sizeof(info->ypixel_size),1,fid) != 1) ||
     (fwrite(&(info->pixel_thickness),sizeof(info->pixel_thickness),1,fid)
                  != 1) ||
     (fwrite(&(info->spacing),sizeof(info->spacing),1,fid) != 1) ||
     (fwrite(&(info->plane_type),sizeof(info->plane_type),1,fid) != 1) ||
     (fwrite(info->trans_matrix,sizeof(info->trans_matrix),1,fid) != 1) ||
     (fwrite(&(info->unused2),sizeof(info->unused2),1,fid) != 1) ||
     (fwrite(&(info->var_use_status),sizeof(info->var_use_status),1,fid) != 1) ||
     (fwrite(&(info->num_echoes),sizeof(info->num_echoes),1,fid) != 1) ||
     (fwrite(&(info->unused3),sizeof(info->unused3),1,fid) != 1) ||
     (fwrite(&(info->unused4),sizeof(info->unused4),1,fid) != 1) ||
     (fwrite(&(info->unused5),sizeof(info->unused5),1,fid) != 1) ||
     (fwrite(&(info->unused6),sizeof(info->unused6),1,fid) != 1) ||
     (fwrite(&(info->unused7),sizeof(info->unused7),1,fid) != 1) ||
     (fwrite(&(info->tr),sizeof(info->tr),1,fid) != 1) ||
     ((err = wr_file_strs(fid,&(info->te),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->date_of_study),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->time_of_study),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = wr_patient_rec(fid,&(info->patient))) != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->refered_by),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->description),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->hosp_name),(unsigned_int) 1))
         != NO_ERROR))
    return err;
 PRT(printf("wr_data_info_rec...num_scans = %d\n",info->num_scans))

 return NO_ERROR;
}

wr_analysis_group(fid,group,num_groups)
 FILE *fid;
 struct analysis_group_rec *group;
 unsigned_int num_groups;
{
 unsigned_int lcv;

 for (lcv = 0; lcv < num_groups; lcv++)
    if ((fwrite(&(group[lcv].num_members),sizeof(group[lcv].num_members),1,
            fid) != 1) ||
        (wr_file_ints(fid,group[lcv].member_img_label_indx,
                group[lcv].num_members) != NO_ERROR))
       return WRITE_ERROR;
 return NO_ERROR;
}

wr_analysis_rec(fid,analysis)
 FILE *fid;
 struct hdr_analysis_rec *analysis;
{
 if ((fwrite(&(analysis->num_img_labels),sizeof(analysis->num_img_labels),1,fid)
         != 1) ||
     (wr_file_strs(fid,analysis->img_labels,analysis->num_img_labels) != 0) ||
     (fwrite(&(analysis->num_analysis_groups),
          sizeof(analysis->num_analysis_groups),1,fid) != 1) ||
     (wr_analysis_group(fid,analysis->groups,analysis->num_analysis_groups)
         != 0))
    return WRITE_ERROR;
 return NO_ERROR;
}

wr_slice_entries(fid,scans,num_scans)
 FILE *fid;
 struct hdr_scan_entry_rec *scans;
 unsigned_int num_scans;
{
 unsigned_int lcv;

 TRACE(printf("wr_slice_entries...\n"))
 slice_entry_addr_to_index(scans,num_scans);
 for (lcv = 0; lcv < num_scans; lcv++)
    {if ((fwrite(&(scans[lcv].status),sizeof(scans[lcv].status),1,
           fid) != 1) ||
         (wr_file_strs(fid,&(scans[lcv].img_label),(unsigned_int) 1) != 
                 NO_ERROR) ||
         (fwrite(&(scans[lcv].num),sizeof(scans[lcv].num),1,fid) != 1) ||
         (fwrite(&(scans[lcv].img_addr),
                 sizeof(scans[lcv].img_addr),1,fid) != 1) ||
         (fwrite(&(scans[lcv].plane.vector),sizeof(scans[lcv].plane.vector),
                   1,fid) != 1) ||
         (fwrite(&(scans[lcv].plane.constant),sizeof(
                   scans[lcv].plane.constant),1,fid) != 1) ||
         (fwrite(&(scans[lcv].prior_slice),sizeof(scans[lcv].prior_slice),
               1,fid) != 1) ||
         (fwrite(&(scans[lcv].next_slice),sizeof(scans[lcv].next_slice),
               1,fid) != 1) ||
         (fwrite(&(scans[lcv].partner_slice),sizeof(scans[lcv].partner_slice),
               1,fid) != 1))
       {slice_entry_index_to_addr(scans,num_scans);
        return WRITE_ERROR;}
    }
 slice_entry_index_to_addr(scans,num_scans);
 return NO_ERROR;

}

rd_the_hdr(fn,hdr)
 char *fn;
 struct hdr_rec *hdr;
{
 FILE *fid;
 int err;

 if ((fid = fopen(fn,"r")) == NULL)
    {TRACE(printf("\nCould not open output file: %s\n",fn))
     return FILE_ACCESS_ERROR;}
 if ((err = rd_hdr(fid,hdr)) == NO_ERROR)
    ComputeScanEntryExtraInfo(hdr);

 TRACE(printf("rd_the_hdr err = %d\n",err))
 fclose(fid);
 return err;

}

rd_hdr(fid,hdr)
 FILE *fid;
 struct hdr_rec *hdr;
{
 unsigned_int total_items;
 size_t amt;
 int err;

 fseek(fid,0L,0);
 err = READ_ERROR;
 if ((fread(&(hdr->size),sizeof(hdr->size),1,fid) != 1) ||
     ((err = rd_file_strs(fid,&(hdr->id),1)) != NO_ERROR) ||
     (fread(&(hdr->offset),sizeof(hdr->offset),1,fid) != 1))
    {if (err == NO_ERROR) err = READ_ERROR;
     return err;}

 fseek(fid,hdr->offset.info_start,0);
 TRACE(printf("rd..hdr->offset.info_start = %d hdr->offset.info_size = %d\n",hdr->offset.info_start,hdr->offset.info_size))
 err = READ_ERROR;

 if (fread(&(hdr->status),sizeof(hdr->status),1,fid) != 1)
    {
     if (err == NO_ERROR) err = READ_ERROR;
     return err;}

 if (((err = rd_data_info_rec(fid,&(hdr->data_info))) != NO_ERROR) ||
     ((err = rd_analysis_rec(fid,&(hdr->analysis))) != NO_ERROR) ||
     (fread(&(hdr->num_scans),sizeof(hdr->num_scans),1,fid) != 1) ||
     ((err = RdSliceEntries(fid,&(hdr->scans),&(hdr->num_scans),hdr))
              != NO_ERROR))
    {
     if (err == NO_ERROR) err = READ_ERROR;
     return err;}

 
 fseek(fid,hdr->offset.extra_info_start,0);
 TRACE(printf("hdr->offset.extra_info_start = %d hdr->offset.extra_info_size = %d\n",hdr->offset.extra_info_start,hdr->offset.extra_info_size))
 if (hdr->offset.extra_info_size > 0)
    if ((err = rd_extra_file_info_rec(fid,&(hdr->extra_info))) != NO_ERROR)
       return err;

 fseek(fid,hdr->offset.comment_start,0);
 err = READ_ERROR;
 if (fread(&(hdr->comment_size),sizeof(hdr->comment_size),1,fid) != 1)
    {if (err == NO_ERROR) err = READ_ERROR;
     return err;}
 if (hdr->comment_size > 0)
    {total_items = 0;
     get_ptr_memory(&(hdr->comment),&total_items,(size_t) hdr->comment_size,
               (size_t) sizeof(char), &err);
     if (err) return NOT_ENOUGH_MEMORY;
     if ((err = frd(hdr->comment,hdr->comment_size,1,fid,&amt)) != NO_ERROR)
        {if (err == NO_ERROR) err = READ_ERROR;
         return err;
        }
    }

 TRACE(printf("hdr->comment_size = %u hdr->offset.user_defined_start = %u\n",hdr->comment_size,hdr->offset.user_defined_start))

 fseek(fid,hdr->offset.user_defined_start,0);
 if (fread(&(hdr->user_defined_size),sizeof(hdr->user_defined_size),1,fid) != 1)
    {if (err == NO_ERROR) err = READ_ERROR;
     return err;
    }
 TRACE(printf("rd user_defined...size = %u\n",hdr->user_defined_size))
 if (hdr->user_defined_size > 0)
    {total_items = 0;
     get_ptr_memory(&(hdr->user_defined),&total_items,
          (size_t) hdr->user_defined_size,(size_t) sizeof(char), &err);
     if (err) return NOT_ENOUGH_MEMORY;
     if ((err = frd(hdr->user_defined,hdr->user_defined_size,1,fid,&amt))
             != NO_ERROR)
        {if (err == NO_ERROR) err = READ_ERROR;
         return err;
        }
    }
  if (hdr->data_info.pixval_min >= hdr->data_info.pixval_max)
     hdr->status |= GLOBAL_MIN_MAX_UNDEFINED;
 TRACE(printf("rd hdr end...\n"))
 return NO_ERROR;

}

rd_extra_file_info_rec(fid,extra_info)
 FILE *fid;
 struct extra_file_info_rec *extra_info;
{
 unsigned_int hdr_size;
 int err;

 TRACE(printf("rd_extra_file_info_rec...\n"))
 err = READ_ERROR;
 if (((err = rd_file_strs(fid,&(extra_info->color_bundle_label),1))
                 != NO_ERROR) ||
     (fread(&(extra_info->color_control),
        sizeof(extra_info->color_control),1,fid) != 1) ||
     ((err = rd_file_strs(fid,&(extra_info->last_edit_begin),1)) != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(extra_info->last_edit_end),1)) != NO_ERROR))
     return err;
 return NO_ERROR;
}


rd_patient_rec(fid,patient)
 FILE *fid;
 struct patient_rec *patient;
{
 int err;

 err = READ_ERROR;
 if (((err = rd_file_strs(fid,&(patient->name),(unsigned_int) 1))
              != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(patient->ssnum),(unsigned_int) 1))
          != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(patient->patient_id),(unsigned_int) 1))
          != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(patient->study_num),(unsigned_int) 1))
          != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(patient->patient_num),(unsigned_int) 1))
          != NO_ERROR) ||
     (fread(&(patient->sex),sizeof(patient->sex),1,fid) != 1) ||
     (fread(&(patient->age),sizeof(patient->age),1,fid) != 1) ||
     (fread(&(patient->height),sizeof(patient->height),1,fid) != 1) ||
     (fread(&(patient->weight),sizeof(patient->weight),1,fid) != 1))
    return err;
 return NO_ERROR;
}

rd_data_info_rec(fid,info)
 FILE *fid;
 struct data_info_rec *info;
{
 int err;

 TRACE(printf("rd_data_info_rec...\n"))
 err = READ_ERROR;
 if (((err = rd_file_strs(fid,&(info->image_id),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(info->default_datafn),(unsigned_int) 1))
         != NO_ERROR) ||
     (fread(&(info->num_scans),sizeof(info->num_scans),1,fid) != 1) ||
     (fread(&(info->dimx),sizeof(info->dimx),1,fid) != 1) ||
     (fread(&(info->dimy),sizeof(info->dimy),1,fid) != 1) ||
     (fread(&(info->max_scans),sizeof(info->max_scans),1,fid) != 1) ||
     (fread(&(info->pixval_max),sizeof(info->pixval_max),1,fid) != 1) ||
     (fread(&(info->pixval_min),sizeof(info->pixval_min),1,fid) != 1) ||
     (fread(&(info->actual_pixval_min),sizeof(info->actual_pixval_min),1,fid) != 1) ||
     (fread(&(info->histo_dimx),sizeof(info->histo_dimx),1,fid) != 1) ||
     (fread(&(info->histo_dimy),sizeof(info->histo_dimy),1,fid) != 1) ||
     (fread(&(info->pixel_depth_bits),sizeof(info->pixel_depth_bits),1,fid)
                          != 1) ||
     (fread(&(info->xpixel_size),sizeof(info->xpixel_size),1,fid) != 1) ||
     (fread(&(info->ypixel_size),sizeof(info->ypixel_size),1,fid) != 1) ||
     (fread(&(info->pixel_thickness),sizeof(info->pixel_thickness),1,fid)
                  != 1) ||
     (fread(&(info->spacing),sizeof(info->spacing),1,fid) != 1) ||
     (fread(&(info->plane_type),sizeof(info->plane_type),1,fid) != 1) ||
     (fread(info->trans_matrix,sizeof(info->trans_matrix),1,fid) != 1) ||
     (fread(&(info->unused2),sizeof(info->unused2),1,fid) != 1) ||
     (fread(&(info->var_use_status),sizeof(info->var_use_status),1,fid) != 1) ||
     (fread(&(info->num_echoes),sizeof(info->num_echoes),1,fid) != 1) ||
     (fread(&(info->unused3),sizeof(info->unused3),1,fid) != 1) ||
     (fread(&(info->unused4),sizeof(info->unused4),1,fid) != 1) ||
     (fread(&(info->unused5),sizeof(info->unused5),1,fid) != 1) ||
     (fread(&(info->unused6),sizeof(info->unused6),1,fid) != 1) ||
     (fread(&(info->unused7),sizeof(info->unused7),1,fid) != 1) ||
     (fread(&(info->tr),sizeof(info->tr),1,fid) != 1) ||
     ((err = rd_file_strs(fid,&(info->te),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(info->date_of_study),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(info->time_of_study),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = rd_patient_rec(fid,&(info->patient))) != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(info->refered_by),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(info->description),(unsigned_int) 1))
         != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(info->hosp_name),(unsigned_int) 1))
         != NO_ERROR))
    return err;
 PRT(printf("rd_data_info_rec...num_scans = %d\n",info->num_scans))
 TRACE(printf("rd_data_info_rec...end\n"))

 return NO_ERROR;
}

rd_analysis_group(fid,group,num_groups)
 FILE *fid;
 struct analysis_group_rec **group;
 unsigned_int num_groups;
{
 unsigned_int lcv;
 unsigned_int total_items;
 int err;

 total_items = 0;
 get_ptr_memory(group,&total_items,(size_t) num_groups,
               (size_t) sizeof(struct analysis_group_rec), &err);
 if (err) return NOT_ENOUGH_MEMORY;

 for (lcv = 0; lcv < num_groups; lcv++)
    {if (fread(&((*group)[lcv].num_members),sizeof((*group)[lcv].num_members),1,
            fid) != 1)
        return READ_ERROR;

     total_items = 0;
     get_ptr_memory(&((*group)[lcv].member_img_label_indx),&total_items,
              (size_t) (*group)[lcv].num_members,
               (size_t) sizeof(*((*group)[lcv].member_img_label_indx)), &err);
     if (err) return NOT_ENOUGH_MEMORY;

     if (rd_file_ints(fid,(*group)[lcv].member_img_label_indx,
                (*group)[lcv].num_members) != NO_ERROR)
        return READ_ERROR;
    }
 return NO_ERROR;
}

rd_analysis_rec(fid,analysis)
 FILE *fid;
 struct hdr_analysis_rec *analysis;
{
 if ((fread(&(analysis->num_img_labels),sizeof(analysis->num_img_labels),1,fid)
         != 1) ||
     (rd_file_labels(fid,&(analysis->img_labels),
              analysis->num_img_labels) != NO_ERROR) ||
     (fread(&(analysis->num_analysis_groups),
          sizeof(analysis->num_analysis_groups),1,fid) != 1) ||
     (rd_analysis_group(fid,&(analysis->groups),analysis->num_analysis_groups)
         != NO_ERROR))
    return READ_ERROR;
 return NO_ERROR;
}

RdSliceEntries(fid,scans,num_scans,hdr)
 FILE *fid;
 struct hdr_scan_entry_rec **scans;
 unsigned_int *num_scans;
 struct hdr_rec *hdr;
{
 unsigned_int lcv,num_cuts,max_scans;
 struct hdr_scan_entry_rec scan;
 int err;

 num_cuts = NumberOfSliceCuts(&(hdr->data_info));
 max_scans = NumberOfSliceScans(&(hdr->data_info));
 hdr->data_info.max_scans = num_cuts * hdr->data_info.num_echoes * max_scans;    
 if ((err = get_ptr(scans,NULL,(size_t) hdr->data_info.max_scans,
               (size_t) sizeof(struct hdr_scan_entry_rec))) != NO_ERROR)
    {*num_scans = 0;
     return NOT_ENOUGH_MEMORY;}
 for (lcv = 0; lcv < hdr->data_info.max_scans; lcv++)
    init_hdr_scan_entry_rec(&((*scans)[lcv]));

 for (lcv = 0; lcv < *num_scans; lcv++)
    {init_hdr_scan_entry_rec(&scan);
     if ((fread(&(scan.status),sizeof(scan.status),1,fid) != 1) ||
         (rd_file_strs(fid,&(scan.img_label),(unsigned_int) 1) != NO_ERROR) ||
         (fread(&(scan.num),sizeof(scan.num),1,fid) != 1) ||
         (fread(&(scan.img_addr),sizeof(scan.img_addr),1,fid) != 1) ||
         (fread(&(scan.plane.vector),
                   sizeof(scan.plane.vector),1,fid) != 1) ||
         (fread(&(scan.plane.constant),sizeof(
                   scan.plane.constant),1,fid) != 1) ||
         (fread(&(scan.prior_slice),
               sizeof(scan.prior_slice),1,fid) != 1) ||
         (fread(&(scan.next_slice),sizeof(scan.next_slice),1,fid) != 1) ||
         (fread(&(scan.partner_slice),sizeof(scan.partner_slice),
               1,fid) != 1))
        {free_hdr_scan_entry_rec(&scan);
         return READ_ERROR;}
     if (lcv < hdr->data_info.max_scans)
        (*scans)[lcv] = scan;
       else free_hdr_scan_entry_rec(&scan);
    }
 *num_scans = hdr->data_info.max_scans;
 slice_entry_index_to_addr(*scans,*num_scans);
 return NO_ERROR;

}

unsigned long NumberOfSliceScans(info)
 struct data_info_rec *info;
{
 if (info->var_use_status & NUM_SCANS_USED)
    return info->num_scans;
   else return 1;
}

unsigned long NumberOfSliceCuts(info)
 struct data_info_rec *info;
{
 if (info->var_use_status & NUM_SCANS_USED)
    return info->max_scans / (info->num_echoes *
               info->num_scans);
   else return info->max_scans / info->num_echoes;
}

ValidateHdrParams(hdr,maxdimx,maxdimy,maxscans,maxechoes)
 struct hdr_rec *hdr;
 unsigned long maxdimx,maxdimy,maxscans,maxechoes;
{
 struct data_info_rec *info;

 info = &(hdr->data_info);
 PRT4(printf("ValidateHdrParams...info->pixel_depth_bits = %d\n",
       info->pixel_depth_bits))
 if ((info->dimx == 0) || (info->dimy == 0) ||
     (info->max_scans == 0) || (info->pixel_depth_bits == 0) ||
     (info->num_echoes == 0))
    return 1;
 if ((info->dimx > maxdimx) || (info->dimy > maxdimy) ||
     (info->max_scans > maxscans) || (info->pixel_depth_bits > 32) ||
     (info->num_echoes > maxechoes))
    return 2;
 if (hdr->num_scans != info->max_scans)
    return 3;
 if (hdr->analysis.num_img_labels != info->num_echoes)
    return 4;
 return NO_ERROR;
}
/*
CurSliceHeadLast(hdr,head,last,cur_slice)
 struct hdr_rec *hdr;
 struct hdr_scan_entry_rec *head,*last,*cur_slice;
{
 unsigned long num_scans;

 num_scans = NumberOfSliceScans(&(hdr->data_info));
 
}

ScanEchoNum(hdr,scan,echo_num)
 struct hdr_rec *hdr;
 struct hdr_scan_entry_rec *scan;
 unsigned long *echo_num;
{
 unsigned long indx;

 *echo_num = 0;
 if (hdr->scans > scan) return ~NO_ERROR;
 indx = scan - hdr->scans;
 printf("ScanEchoNum indx = %d scan = %u hdr->scans = %u\n",indx,scan,hdr->scans);
 if (indx >= hdr->data_info.max_scans) return ~NO_ERROR;
 *echo_num = indx % hdr->data_info.num_echoes;
 return NO_ERROR;
}
*/

LocateScanEntry(hdr,slice_num,scan_num,echo_num,scan_entry)
 struct hdr_rec *hdr;
 unsigned long slice_num,scan_num,echo_num;
 struct hdr_scan_entry_rec **scan_entry;
{
 unsigned long num_scans,num_slices,indx;

 PRT2(printf("\nslice_num = %d scan_num = %d echo_num = %d\n",
         slice_num,scan_num,echo_num))
 if (echo_num >= hdr->data_info.num_echoes) return ~NO_ERROR;
 num_scans = NumberOfSliceScans(&(hdr->data_info));
 num_slices = NumberOfSliceCuts(&(hdr->data_info));
 if (scan_num >= num_scans) return ~NO_ERROR;
 if (slice_num >= num_slices) return ~NO_ERROR;
 indx = (scan_num * num_slices + slice_num) *
        hdr->data_info.num_echoes + echo_num;
 PRT2(printf("indx = %d num_scans = %d\n",
         indx,hdr->num_scans))
 if (indx >= hdr->num_scans) return ~NO_ERROR;
 *scan_entry = &(hdr->scans[indx]);
 PRT8(printf("final addr = %u num = %d snum = %d scan = %d echo = %d\n\n",
         (*scan_entry)->img_addr,
         (*scan_entry)->num,(*scan_entry)->slice_num,
         (*scan_entry)->scan_num,(unsigned long)(*scan_entry)->echo_num))
 return NO_ERROR;
}

FileHdrScan(hdr,scan,indx)
 struct hdr_rec *hdr;
 struct hdr_scan_entry_rec *scan;
 unsigned long *indx;
{
 if (hdr->scans > scan) return ~NO_ERROR;
 *indx = scan - hdr->scans;
 if (*indx >= hdr->data_info.max_scans) return ~NO_ERROR;
 return NO_ERROR;
}

ComputeScanEntryExtraInfo(hdr)
 struct hdr_rec *hdr;
{
 unsigned long num_slices,cnt,num;

 PRT3(printf("ComputeScanEntryExtraInfo...\n"))
 num_slices = NumberOfSliceCuts(&(hdr->data_info));
 PRT3(printf("ComputeScanEntryExtraInfo...num_slices = %d num_scans = %d\n",
           num_slices,hdr->num_scans))
 PRT3(printf("ComputeScanEntryExtraInfo...num_echoes = %d\n",
           hdr->data_info.num_echoes))
 for (cnt = 0; cnt < hdr->num_scans; cnt++)
    {num = cnt / hdr->data_info.num_echoes;
     hdr->scans[cnt].echo_num = cnt % hdr->data_info.num_echoes;
     hdr->scans[cnt].slice_num = num % num_slices;
     hdr->scans[cnt].scan_num = num / num_slices;
     PRT3(printf("%d) echo_num = %d  slice_num = %d  scan_num = %d\n",
           cnt,(unsigned long) hdr->scans[cnt].echo_num,
         hdr->scans[cnt].slice_num,hdr->scans[cnt].scan_num))

    }
}

RedefineHdrNumBySliceNum(hdr)
 struct hdr_rec *hdr;
{
 unsigned long cnt;

 for (cnt = 0; cnt < hdr->num_scans; cnt++)
    hdr->scans[cnt].num = hdr->scans[cnt].slice_num + 1;
 return NO_ERROR;
}

ReverseHdrScans(hdr)
 struct hdr_rec *hdr;
{
 unsigned long num_slices,num_scans,off,num_group_slices,lcv,
              cnt,start_last,start_next,last,next,indx,indx1;
 struct hdr_scan_entry_rec scan,*cur;

 if (hdr->num_scans == 1) return NO_ERROR;
 num_slices = NumberOfSliceCuts(&(hdr->data_info));
 num_scans = NumberOfSliceScans(&(hdr->data_info));
 if (num_slices % 2)
    {start_next = (num_slices + 1) / 2;
     start_last = start_next - 2;}
   else
    {start_next = num_slices / 2;
     start_last = start_next - 1;}
 off = 0;
 num_group_slices = num_slices * hdr->data_info.num_echoes;
 for (cnt = 0; cnt < num_scans; cnt++)
    {
     next = start_next;
     last = start_last;
     for (;;)
        {indx = next * hdr->data_info.num_echoes + off;
         indx1 = last * hdr->data_info.num_echoes + off;
         for (lcv = 0; lcv < hdr->data_info.num_echoes; lcv++)
            {scan = hdr->scans[indx + lcv];
             hdr->scans[indx + lcv] = hdr->scans[indx1 + lcv];
             hdr->scans[indx1 + lcv] = scan;
            }
         if (last == 0) break;
         last -= 1;
         next += 1;
        }
     off += num_group_slices;
    }
 for (off = 0,cnt = 0; cnt < num_scans; cnt++)
    {last = off + num_group_slices - hdr->data_info.num_echoes;
     indx = off;
     indx1 = indx + hdr->data_info.num_echoes;
     for (next = 0; next < num_slices; next++)
        {
         for (lcv = 0; lcv < hdr->data_info.num_echoes; lcv++)
            {hdr->scans[indx + lcv].next_slice = &(hdr->scans[indx1 + lcv]);
             hdr->scans[indx + lcv].prior_slice = &(hdr->scans[last + lcv]);
             hdr->scans[indx + lcv].partner_slice = 
                  &(hdr->scans[indx + (lcv + 1) % hdr->data_info.num_echoes]);
            }
         last = indx;
         indx = indx1;
         if (next == (num_slices - 2))
            indx1 = off;
           else indx1 += hdr->data_info.num_echoes;
        }
     off += num_group_slices;
    }
 PRT8(for (cnt = 0; cnt < hdr->num_scans; cnt++)
    printf("%d) s# = %d e# = %d sc# = %d n# = %d  ns# = %d\n",cnt,
      hdr->scans[cnt].slice_num,hdr->scans[cnt].echo_num,
      hdr->scans[cnt].scan_num,hdr->scans[cnt].num,
      hdr->scans[cnt].next_slice->slice_num);)

/*
 for (cnt = 0; cnt < num_scans; cnt++)
    {for (lcv = 0; lcv < hdr->data_info.num_echoes; lcv++)
        {next = start_next;
         last = start_last;
         for (;;)
            {indx = next * hdr->data_info.num_echoes + lcv + off;
             scan = hdr->scans[indx];
             indx1 = last * hdr->data_info.num_echoes + lcv + off;
             hdr->scans[indx] = hdr->scans[indx1];
             hdr->scans[indx1] = scan;
             if (last == 0) break;
             last -= 1;
             next += 1;
            }
        }
     off += num_group_slices;
    }
*/
 return NO_ERROR;
}


/*
set_select = 1 then scan_entry->status = status
set_select = 2 then scan_entry->status |= status
set_select = 3 then scan_entry->status &= ~status
else no operation
*/
unsigned long SetHdrScanEntryStatus(hdr,fsnum,lsnum,fecho,
                      lecho,fscan,lscan,set_select,status)
 struct hdr_rec *hdr;
 unsigned long fsnum,lsnum,fecho,lecho,fscan,lscan;
 int set_select;
 unsigned short status;
{
 unsigned long lcv,cnt,num,total;
 struct hdr_scan_entry_rec *scan_entry;

 total = 0;
 for (lcv = fsnum; lcv <= lsnum; lcv++)
    for (cnt = fecho; cnt <= lecho; cnt++)
       for (num = fscan; num <= lscan; num++)
          if (LocateScanEntry(hdr,lcv,num,cnt,&scan_entry) == NO_ERROR)
             {total += 1;
              if (set_select == 1) scan_entry->status = status;
                else if (set_select == 2) scan_entry->status |= status;
                else if (set_select == 3) scan_entry->status &= ~status;
             }
 return total;
}

cp_patient_rec(dest,src,is_dest_new)
 struct patient_rec *dest,*src;
 int is_dest_new;
{
 struct patient_rec temp,*pat;
 int err;

 PRT5(printf("cp_patient_rec 0\n"))
 if (!is_dest_new)
    {init_patient_rec(&temp);
     pat = &temp;}
   else pat = dest;
 pat->sex = src->sex;
 pat->age = src->age;
 pat->height = src->height;
 pat->weight = src->weight;
 if (((err = cp_str(&(pat->name),src->name)) != NO_ERROR) ||
     ((err = cp_str(&(pat->ssnum),src->ssnum)) != NO_ERROR) ||
     ((err = cp_str(&(pat->patient_id),src->patient_id)) != NO_ERROR) ||
     ((err = cp_str(&(pat->study_num),src->study_num)) != NO_ERROR) ||
     ((err = cp_str(&(pat->patient_num),src->patient_num)) != NO_ERROR))
    {if (!is_dest_new) free_patient_rec(&temp);
     return err;}
 if (!is_dest_new)
    {free_patient_rec(dest);
     *dest = temp;}
 PRT5(printf("cp_patient_rec end\n"))
 return NO_ERROR;
}

cp_data_info_rec(dest,src,is_dest_new)
 struct data_info_rec *dest,*src;
 int is_dest_new;
{
 struct data_info_rec temp,*info;
 int err;

 PRT5(printf("cp_data_info_rec 0\n"))
 if (!is_dest_new)
    {init_data_info_rec(&temp);
     info = &temp;}
   else info = dest;
 *info = *src;
 info->image_id = info->default_datafn = info->te = NULL;
 info->date_of_study = info->time_of_study = NULL;
 info->refered_by = info->description = info->hosp_name = NULL;
 init_patient_rec(&(info->patient));
 if (((err = cp_str(&(info->image_id),src->image_id)) != NO_ERROR) ||
     ((err = cp_str(&(info->default_datafn),src->default_datafn)) != NO_ERROR) ||
     ((err = cp_str(&(info->te),src->te)) != NO_ERROR) ||
     ((err = cp_str(&(info->date_of_study),src->date_of_study)) != NO_ERROR) ||
     ((err = cp_str(&(info->time_of_study),src->time_of_study)) != NO_ERROR) ||
     ((err = cp_patient_rec(&(info->patient),&(src->patient),is_dest_new)) != NO_ERROR) ||
     ((err = cp_str(&(info->refered_by),src->refered_by)) != NO_ERROR) ||
     ((err = cp_str(&(info->description),src->description)) != NO_ERROR) ||
     ((err = cp_str(&(info->hosp_name),src->hosp_name)) != NO_ERROR))
    {if (!is_dest_new) free_data_info_rec(&temp);
     return err;}
 if (!is_dest_new)
    {free_data_info_rec(dest);
     *dest = temp;}
 PRT5(printf("cp_data_info_rec end\n"))
 return NO_ERROR;
}

cp_analysis_group_rec(dest,src,is_dest_new)
 struct analysis_group_rec *dest,*src;
 int is_dest_new;
{
 struct analysis_group_rec temp,*anal;
 int err;
 unsigned long lcv;

 PRT5(printf("cp_analysis_group_rec 0\n"))
 if (!is_dest_new)
    {init_analysis_group_rec(&temp);
     anal = &temp;}
   else anal = dest;

 anal->num_members = 0;
 if ((err = get_ptr(&(anal->member_img_label_indx),&(anal->num_members),
          src->num_members,(size_t) sizeof(*(anal->member_img_label_indx)))) != NO_ERROR)
    {return err;}
 for (lcv = 0; lcv < anal->num_members; lcv++)
    anal->member_img_label_indx[lcv] = src->member_img_label_indx[lcv];

 if (!is_dest_new)
    {free_analysis_group_rec(dest);
     *dest = temp;}
 PRT5(printf("cp_analysis_group_rec end\n"))
 return NO_ERROR;
}

cp_hdr_analysis_rec(dest,src,is_dest_new)
 struct hdr_analysis_rec *dest,*src;
 int is_dest_new;
{
 struct hdr_analysis_rec temp,*anal;
 int err;
 unsigned long lcv;

 PRT5(printf("cp_hdr_analysis_rec 0\n"))
 if (!is_dest_new)
    {init_hdr_analysis_rec(&temp);
     anal = &temp;}
   else anal = dest;

 anal->num_img_labels = 0;
 anal->num_analysis_groups = 0;
 if (((err = copy_strs(&(anal->img_labels),&(anal->num_img_labels),
           src->img_labels,src->num_img_labels)) != NO_ERROR) ||
     ((err = get_ptr(&(anal->groups),&(anal->num_analysis_groups),
          src->num_analysis_groups,(size_t) sizeof(*(anal->groups)))) != NO_ERROR))
    {if (!is_dest_new) free_hdr_analysis_rec(&temp);
     return err;}
 PRT5(printf("cp_hdr_analysis_rec 1\n"))
 for (lcv = 0; lcv < anal->num_analysis_groups; lcv++)
    init_analysis_group_rec(&(anal->groups[lcv]));

 for (lcv = 0; lcv < anal->num_analysis_groups; lcv++)
    if ((err = cp_analysis_group_rec(&(anal->groups[lcv]),
            &(src->groups[lcv]),is_dest_new)) != NO_ERROR)
       {if (!is_dest_new) free_hdr_analysis_rec(&temp);
        return err;}

 if (!is_dest_new)
    {free_hdr_analysis_rec(dest);
     *dest = temp;}
 PRT5(printf("cp_hdr_analysis_rec end\n"))
 return NO_ERROR;
}

cp_extra_file_info_rec(dest,src,is_dest_new)
 struct extra_file_info_rec *dest,*src;
 int is_dest_new;
{
 struct extra_file_info_rec temp,*ptr;
 int err;

 PRT5(printf("cp_extra_file_info_rec 0\n"))
 if (!is_dest_new)
    {init_extra_file_info_rec(&temp);
     ptr = &temp;}
   else ptr = dest;

 if (((err = cp_str(&(ptr->color_bundle_label),src->color_bundle_label)) != NO_ERROR) ||
     ((err = cp_str(&(ptr->last_edit_begin),src->last_edit_begin)) != NO_ERROR) ||
     ((err = cp_str(&(ptr->last_edit_end),src->last_edit_end)) != NO_ERROR))
    {if (!is_dest_new) free_extra_file_info_rec(&temp);
     return err;}
 ptr->color_control = src->color_control;
 if (!is_dest_new)
    {free_extra_file_info_rec(dest);
     *dest = temp;}
 PRT5(printf("cp_extra_file_info_rec end\n"))
 return NO_ERROR;
}

cp_hdr_scan_entry_rec(dest,src,is_dest_new)
 struct hdr_scan_entry_rec *dest,*src;
 int is_dest_new;
{
 struct hdr_scan_entry_rec temp,*ptr;
 int err;

 if (!is_dest_new)
    {init_hdr_scan_entry_rec(&temp);
     ptr = &temp;}
   else ptr = dest;
 *ptr = *src;
 ptr->img_label = NULL;
 if ((err = cp_str(&(ptr->img_label),src->img_label)) != NO_ERROR)
    {return err;}
 if (!is_dest_new)
    {free_hdr_scan_entry_rec(dest);
     *dest = temp;}
 return NO_ERROR;
}

cp_hdr_rec(dest,src,is_dest_new)
 struct hdr_rec *dest,*src;
 int is_dest_new;
{
 struct hdr_rec temp,*hdr;
 unsigned long lcv;
 int err;

 PRT5(printf("cp_hdr_rec 0\n"))
 if (!is_dest_new)
    {init_hdr_rec(&temp);
     hdr = &temp;}
   else hdr = dest;
 hdr->size = src->size;
 hdr->status = src->status;
 hdr->offset = src->offset;
 hdr->num_scans = 0;
 hdr->comment_size = 0;
 hdr->user_defined_size = 0;
 if (((err = cp_str(&(hdr->id),src->id)) != NO_ERROR) ||
     ((err = cp_data_info_rec(&(hdr->data_info),&(src->data_info),
              is_dest_new)) != NO_ERROR) ||
     ((err = cp_hdr_analysis_rec(&(hdr->analysis),&(src->analysis),
              is_dest_new)) != NO_ERROR) ||
     ((err = get_ptr(&(hdr->scans),&(hdr->num_scans),
       src->num_scans,(size_t) sizeof(*(hdr->scans)))) != NO_ERROR) ||
     ((err = cp_extra_file_info_rec(&(hdr->extra_info),
              &(src->extra_info),is_dest_new)) != NO_ERROR) ||
     ((err = get_ptr(&(hdr->comment),&(hdr->comment_size),
       src->comment_size,(size_t) sizeof(*(hdr->comment)))) != NO_ERROR) ||
     ((err = get_ptr(&(hdr->user_defined),&(hdr->user_defined_size),
       src->user_defined_size,(size_t) sizeof(*(hdr->user_defined)))) != NO_ERROR))
    {if (!is_dest_new) free_hdr_rec(&temp);
     return err;}
 PRT5(printf("cp_hdr_rec 1\n"))
 for (lcv = 0; lcv < hdr->num_scans; lcv++)
    init_hdr_scan_entry_rec(&(hdr->scans[lcv]));

 for (lcv = 0; lcv < hdr->num_scans; lcv++)
    if ((err = cp_hdr_scan_entry_rec(&(hdr->scans[lcv]),
           &(src->scans[lcv]),is_dest_new)) != NO_ERROR)
       {if (is_dest_new) free_hdr_rec(&temp);
        return err;}
 memcpy(hdr->comment,src->comment,hdr->comment_size);
 memcpy(hdr->user_defined,src->user_defined,hdr->user_defined_size);
 if (!is_dest_new)
    {free_hdr_rec(dest);
     *dest = temp;}
 PRT5(printf("cp_hdr_rec end\n"))
 return NO_ERROR;
}

unsigned long ImageFileSize(hdr)
 struct hdr_rec *hdr;
{
 unsigned long size;

 size = GetImageSize(hdr->data_info.dimx,hdr->data_info.dimy,
               hdr->data_info.pixel_depth_bits);
 size *= hdr->data_info.max_scans;
 return size;
}
