/****************************************************************************
line.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  This file calls some functions that are part of NRIA proper rather
than the library.
****************************************************************************/

static const char rcsid[] = "$Id: line.c,v 1.6 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <math.h>

#include <sys/types.h>
#include <sys/timeb.h>

/*  FIXME:  Are these necessary?
#include <xview/xview.h>      
#include <xview/canvas.h>
#include <xview/panel.h>
*/

#include "common.h"
#include "geometry.h"
#include "error_constants.h"
#include "typedef.h"
#include "coord_rec.h"
#include "slice_roi_rec.h"
#include "nria_lib.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT5(x)
#define PRT4(x)



/*-----------------------------------------------------------------------
show_buf_pixels - ???
-----------------------------------------------------------------------*/

void
show_buf_pixels(dest)
 struct buf_2d_rec *dest;
{
 long row,col;

 printf("\n");
 for (row = 0; row < dest->dimy; row++)
    {for (col = 0; col < dest->dimx; col++)
        {if (dest->GetVal(dest,row,col) != .0)
            printf("1");
           else printf("0");
        }
     printf("\n");
    }
}


/*-----------------------------------------------------------------------
DrawBufPts - ???
-----------------------------------------------------------------------*/

int
DrawBufPts(buf,left,top,right,bottom,pixel_depth,pts,num_pts,value,coords,total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 long lcv,x,y;
 int err;

 *total_pts_drawn = 0;
 if (coords != NULL)
    if ((err = get_coord_rec_memory(coords,(long) num_pts)) != NO_ERROR) 
       return err;
 for (lcv = 0; lcv < num_pts; lcv++)
    {x = floor((double) (pts[lcv].x + .5));
     y = floor((double) (pts[lcv].y + .5));
     if ((y >= top) && (y <= bottom) && (x >= left) && (x <= right))
        {if (buf != NULL)
            set_1d_buf_value(buf[y],x,pixel_depth,(long) value);
         if (coords != NULL)
            {coords->pts[coords->num_pts].y = y;
             coords->pts[coords->num_pts++].x = x;}
         *total_pts_drawn += 1;
        }
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
DrawBufPtsByMatrix - ???
-----------------------------------------------------------------------*/

int
DrawBufPtsByMatrix(buf,left,top,right,bottom,pixel_depth,pts,num_pts,matrix,
                       value,coords,total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 struct matrix_2d_rec *matrix;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 long lcv;
 float newx,newy;
 long x,y;
 int err;

 *total_pts_drawn = 0;
 if (coords != NULL)
    if ((err = get_coord_rec_memory(coords,(long) num_pts)) != NO_ERROR) 
       return err;
 for (lcv = 0; lcv < num_pts; lcv++)
    {newx = matrix->buf[0][0] * pts[lcv].x + 
             matrix->buf[0][1] * pts[lcv].y + matrix->buf[0][2];
     newy = matrix->buf[1][0] * pts[lcv].x + 
             matrix->buf[1][1] * pts[lcv].y + matrix->buf[1][2];
     x = (long) floor((double) (newx + .5));
     y = (long) floor((double) (newy + .5));
     if ((y >= top) && (y <= bottom) && (x >= left) && (x <= right))
        {if (buf != NULL) set_1d_buf_value(buf[y],x,pixel_depth,value);
         if (coords != NULL)
            {coords->pts[coords->num_pts].y = y;
             coords->pts[coords->num_pts++].x = x;
            }
         *total_pts_drawn += 1;
        }
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
draw_buf_xline - ???
-----------------------------------------------------------------------*/

int
draw_buf_xline(buf,left,top,right,bottom,pixel_depth,x0,y0,x1,y1,value,coords,total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth;
 long x0,y0,x1,y1,value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 long dx,dy,d,incrE,incrNE,x,y,maxx;
 float gradient;
 int err;

 TRACE(printf("draw_buf_xline x0 = %d  y0 = %d  x1 = %d  y1 = %d\n",x0,y0,x1,y1))
 if (y0 >= y1)
    {if (y1 > bottom) return NO_ERROR;}
   else if (y0 > bottom) return NO_ERROR;

 if (x1 > x0)
    {if (x0 > right) return NO_ERROR;
       else if (x1 < left) return NO_ERROR;
     dx = x1 - x0;
     dy = y1 - y0;
     x = x0;
     y = y0;
     maxx = x1;}
   else
    {if (x1 > right) return NO_ERROR;
       else if (x0 < left) return NO_ERROR;
     dx = x0 - x1;
     dy = y0 - y1;
     x = x1;
     y = y1;
     maxx = x0;}

 if (maxx > right) maxx = right;

 incrE = 2 * dy;
 gradient = (float) dy / (float) dx;
 if (gradient < 0)
    {incrNE = 2 * (dy + dx);
     d = 2 * dy + dx;}
   else
    {incrNE = 2 * (dy - dx);
     d = 2 * dy - dx;}

 if ((y >= top) && (y <= bottom) && (x >= left) && (x <= right))
    {
     if (coords != NULL)
        {
         if (coords->num_pts == coords->total_pts)
            if ((err = get_coord_rec_memory(coords,ADD_NUM_PTS))
                        != NO_ERROR) 
               return err;
         TRACE(printf("%d  %d) x1 ...y = %d  x = %d\n",
                   coords->total_pts,coords->num_pts,y,x))
         coords->pts[coords->num_pts].x = x;
         coords->pts[(coords->num_pts)++].y = y;}

     if (buf != NULL)
        {
         set_1d_buf_value(buf[y],x,pixel_depth,value);}
     *total_pts_drawn += 1;
    }
 TRACE(printf("x  draw line..dx = %d dy = %d   gradient = %f d = %d\n",dx,dy,gradient,d))

 if (gradient < 0)
    {
     while (x < maxx)
        {
         if (d <= 0)
            {d += incrNE;
             y -= 1;}
           else d += incrE;
         x += 1;
         if ((x <= right) && (x >= left) && (y >= top) && (y <= bottom))
            {if (buf != NULL)
                {
                 set_1d_buf_value(buf[y],x,pixel_depth,value);}
             if (coords != NULL)
                {TRACE(printf("%d  %d) x2 ...y = %d  x = %d\n",
                         coords->total_pts,coords->num_pts,y,x))
                 if (coords->num_pts == coords->total_pts)
                    if ((err = get_coord_rec_memory(coords,ADD_NUM_PTS))
                        != NO_ERROR)
                       return err;

                 coords->pts[coords->num_pts].x = x;
                 coords->pts[(coords->num_pts)++].y = y;}
             *total_pts_drawn += 1;
            }
        }
    }
   else
    {
     while (x < maxx)
        {
         if (d <= 0) d += incrE;
           else
            {d += incrNE;
             y += 1;}
         x += 1;
         if ((x <= right) && (x >= left) && (y >= top) && (y <= bottom))
            {if (buf != NULL)
                {
                 set_1d_buf_value(buf[y],x,pixel_depth,value);}
             if (coords != NULL)
                {TRACE(printf("%d  %d) ...y = %d  x = %d\n",
                       coords->total_pts,coords->num_pts,y,x))
                 if (coords->num_pts == coords->total_pts)
                    if ((err = get_coord_rec_memory(coords,ADD_NUM_PTS))
                        != NO_ERROR)
                       return err;
                 coords->pts[coords->num_pts].x = x;
                 coords->pts[(coords->num_pts)++].y = y;}
             *total_pts_drawn += 1;
            }
        }
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
draw_buf_yline - ???
-----------------------------------------------------------------------*/

int
draw_buf_yline(buf,left,top,right,bottom,pixel_depth,x0,y0,x1,y1,value,coords,total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth;
 long x0,y0,x1,y1,value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 long dx,dy,d,incrE,incrNE,x,y,maxy;
 float gradient;
 int err;

 TRACE(printf("draw_buf_yline x0 = %d  y0 = %d  x1 = %d  y1 = %d\n",x0,y0,x1,y1))
 if (x0 >= x1)
    {if (x1 > right) return NO_ERROR;}
   else if (x0 > right) return NO_ERROR;

 if (y1 > y0)
    {if (y0 > bottom) return NO_ERROR;
       else if (y1 < top) return NO_ERROR;
     dx = x1 - x0;
     dy = y1 - y0;
     x = x0;
     y = y0;
     maxy = y1;}
   else
    {if (y1 > bottom) return NO_ERROR;
       else if (y0 < top) return NO_ERROR;
     dx = x0 - x1;
     dy = y0 - y1;
     x = x1;
     y = y1;
     maxy = y0;}
 if (maxy > bottom) maxy = bottom;

 incrE = -2 * dx;
 gradient = (float) dx / (float) dy;
 if (gradient < 0)
    {incrNE = 2 * (-dy - dx);
     d = -dy - 2 * dx;}
   else
    {incrNE = 2 * (dy - dx);
     d = dy - 2 * dx;}

 if ((x >= left) && (x <= right) && (y >= top) && (y <= bottom))
    {if (coords != NULL)
        {
         if (coords->num_pts == coords->total_pts)
            if ((err = get_coord_rec_memory(coords,ADD_NUM_PTS))
                        != NO_ERROR)
               return err;
         TRACE(printf("%d  %d) ...y = %d  x = %d\n",
                coords->total_pts,coords->num_pts,y,x))
         coords->pts[coords->num_pts].x = x;
         coords->pts[(coords->num_pts)++].y = y;}
     if (buf != NULL)
        {
         set_1d_buf_value(buf[y],x,pixel_depth,value);}
     *total_pts_drawn += 1;
    }
 TRACE(printf("draw line..dx = %d dy = %d   gradient = %f  d = %d  maxy = %d\n",dx,dy,gradient,d,maxy))

 if (gradient < 0)
    {
     while (y < maxy)
        {
         if (d > 0)
            {d += incrNE;
             x -= 1;}
           else d += incrE;
         y += 1;
         if ((y <= bottom) && (y >= top) && (x >= left) && (x <= right))
            {if (buf != NULL)
                {
                 set_1d_buf_value(buf[y],x,pixel_depth,value);}
             if (coords != NULL)
                {TRACE(printf("%d  %d) ...y = %d  x = %d\n",
                         coords->total_pts,coords->num_pts,y,x))
                 if (coords->num_pts == coords->total_pts)
                    if ((err = get_coord_rec_memory(coords,ADD_NUM_PTS))
                            != NO_ERROR)
                       return err;
                 coords->pts[coords->num_pts].x = x;
                 coords->pts[(coords->num_pts)++].y = y;}
             *total_pts_drawn += 1;
            }
        }
    }
   else
    {
     while (y < maxy)
        {
         if (d > 0) d += incrE;
           else
            {d += incrNE;
             x += 1;}
         y += 1;
         if ((y <= bottom) && (y >= top) && (x >= left) && (x <= right))
            {if (buf != NULL)
                {
                 set_1d_buf_value(buf[y],x,pixel_depth,value);}
             if (coords != NULL)
                {TRACE(printf("%d  %d) ...y = %d  x = %d\n",
                    coords->total_pts,coords->num_pts,y,x))
                 if (coords->num_pts == coords->total_pts)
                    if ((err = get_coord_rec_memory(coords,ADD_NUM_PTS))
                            != NO_ERROR)
                       return err;
                 coords->pts[coords->num_pts].x = x;
                 coords->pts[(coords->num_pts)++].y = y;}
             *total_pts_drawn += 1;
            }
        }
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
DrawLineInBuf - ???
-----------------------------------------------------------------------*/

int
DrawLineInBuf(buf,left,top,right,bottom,pixel_depth,x0,y0,x1,y1,value,coords,total_pts_drawn,
              is_init_total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth;
 long x0,y0,x1,y1,value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
 int is_init_total_pts_drawn;
{
 long dx,dy,x,y,temp,maxx,maxy;
 int err;

 TRACE(printf("draw_buf_line x0 = %d  y0 = %d  x1 = %d  y1 = %d\n",
        x0,y0,x1,y1))
 if (is_init_total_pts_drawn)
    {
     *total_pts_drawn = 0;}
 if (((x0 < left) && (x1 < left)) || ((x0 > right) && (x1 > right)) ||
     ((y0 < top) && (y1 < top)) || ((y0 > bottom) && (y1 > bottom)))
    return NO_ERROR;
 err = NO_ERROR;
 if (x0 == x1)
    {
     if (y0 < y1)
        {y = y0;
         maxy = y1;}
       else   
        {y = y1;
         maxy = y0;}
     if (y < top) y = top;
       else if (y > bottom) return NO_ERROR;

     if (maxy < top) return NO_ERROR;
       else if (maxy > bottom) maxy = bottom;
     temp = y;
     if (buf != NULL)
        {
         for (;y <= maxy; y++)
            {
             set_1d_buf_value(buf[y],x0,pixel_depth,value);}
        }
     if (coords != NULL)
        {y = temp;
         TRACE(printf("in total_pts = %d num_pts = %d\n",
                  coords->total_pts,coords->num_pts))
         if ((err = get_coord_rec_memory(coords,
                    (long) (maxy - y + 1)))
                        == NO_ERROR)
            {
             for (;y <= maxy; y++)
                {TRACE(printf("%d  %d) same x ...y = %d  x = %d\n",
                     coords->total_pts,coords->num_pts,y,x0))
                 coords->pts[coords->num_pts].x = x0;
                 coords->pts[(coords->num_pts)++].y = y;}
            }
         TRACE(printf("out total_pts = %d num_pts = %d\n",
                  coords->total_pts,coords->num_pts))
        }
     *total_pts_drawn += maxy - temp + 1;
     return err;
    }
   else if (y0 == y1)
    {
     if (x0 < x1)
        {x = x0;
         maxx = x1;}
       else   
        {x = x1;
         maxx = x0;}
     if (x < left) x = left;
       else if (x > right) return NO_ERROR;

     if (maxx < left) return NO_ERROR;
       else if (maxx > right) maxx = right;
     temp = x;
     if (buf != NULL)
        {for (;x <= maxx; x++)
            {
            set_1d_buf_value(buf[y0],x,pixel_depth,value);}
        }
     if (coords != NULL)
        {x = temp;
         TRACE(printf("in total_pts = %d num_pts = %d\n",
                  coords->total_pts,coords->num_pts))
         if ((err = get_coord_rec_memory(coords,(long) (maxx - x + 1)))
                        == NO_ERROR)
           {for (;x <= maxx; x++)
               {TRACE(printf("%d  %d) same y ...y0 = %d  x = %d\n",
                     coords->total_pts,coords->num_pts,y0,x))
                coords->pts[coords->num_pts].x = x;
                coords->pts[(coords->num_pts)++].y = y0;
               }
           }
         TRACE(printf("out total_pts = %d num_pts = %d\n",
                  coords->total_pts,coords->num_pts))
        }
     *total_pts_drawn += maxx - temp + 1;
     return err;
    }
 dx = x1 - x0;
 dy = y1 - y0;
 if (dx < 0) dx = -dx;
 if (dy < 0) dy = -dy;
 if (dx > dy)
    err = draw_buf_xline(buf,left,top,right,bottom,pixel_depth,x0,y0,x1,y1,value,coords,
              total_pts_drawn);
   else
    err = draw_buf_yline(buf,left,top,right,bottom,pixel_depth,x0,y0,x1,y1,value,coords,
              total_pts_drawn);
 return err;
}


/*-----------------------------------------------------------------------
DrawBufLines - ???
-----------------------------------------------------------------------*/

int
DrawBufLines(buf,left,top,right,bottom,pixel_depth,pts,num_pts,value,coords,total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 long lcv,x,y,x1,y1;
 int err;

 *total_pts_drawn = 0;
 if (num_pts == 0) return NO_ERROR;
 if (num_pts == 1)
    {
     err = DrawBufPts(buf,left,top,right,bottom,pixel_depth,pts,num_pts,
                         value,coords,total_pts_drawn);
     return err;}
 x = (long) floor((double) (pts[0].x + .5));
 y = (long) floor((double) (pts[0].y + .5));
 PRT2(printf("DrawBufLines...num_pts = %d %f/%f y = %d  x = %d l = %d t = %d r = %d b = %d\n",
         num_pts,pts[0].y,pts[0].x,y,x,left,top,right,bottom))
 for (lcv = 1; lcv < num_pts; lcv++)
    {
     x1 = (long) floor((double) (pts[lcv].x + .5));
     y1 = (long) floor((double) (pts[lcv].y + .5));
     if ((err = DrawLineInBuf(buf,left,top,right,bottom,pixel_depth,x,y,x1,y1,
            value,coords,total_pts_drawn,0)) != NO_ERROR) 
        return err;
     x = x1;
     y = y1;}
 PRT2(printf("DrawBufLines...end...total_pts_drawn = %d\n",*total_pts_drawn))
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
DrawBufLinesByMatrix - ???
-----------------------------------------------------------------------*/

int
DrawBufLinesByMatrix(buf,left,top,right,bottom,pixel_depth,pts,num_pts,matrix,
                         value,coords,total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 struct matrix_2d_rec *matrix;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 long lcv,x,y,x1,y1;
 int err;
 float newx,newy;

 *total_pts_drawn = 0;
 if (num_pts == 0) return NO_ERROR;
 if (num_pts == 1)
    {
     err = DrawBufPtsByMatrix(buf,left,top,right,bottom,pixel_depth,pts,num_pts,matrix,
                      value,coords,total_pts_drawn);
     return err;}
 newx = matrix->buf[0][0] * pts[0].x + 
             matrix->buf[0][1] * pts[0].y + matrix->buf[0][2] + .5;
 newy = matrix->buf[1][0] * pts[0].x + 
             matrix->buf[1][1] * pts[0].y + matrix->buf[1][2] + .5;
 x = (long) floor((double) newx);
 y = (long) floor((double) newy);

 PRT2(printf("DrawBufLinesByMatrix...%f/%f y = %d  x = %d  dimx = %d  dimy = %d\n",
         pts[0].y,pts[0].x,y,x,dimx,dimy))
 PRT2(pr_2d_matrix(matrix))
 for (lcv = 1; lcv < num_pts; lcv++)
    {
     newx = matrix->buf[0][0] * pts[lcv].x + 
             matrix->buf[0][1] * pts[lcv].y + matrix->buf[0][2] + .5;
     newy = matrix->buf[1][0] * pts[lcv].x + 
             matrix->buf[1][1] * pts[lcv].y + matrix->buf[1][2] + .5;
     x1 = (long) floor((double) newx);
     y1 = (long) floor((double) newy);
/*
     PRT2(printf("%d) %f/%f  y1 = %d   x1 = %d\n",lcv,pts[lcv].y,pts[lcv].x,y1,x1))
*/
     if ((err = DrawLineInBuf(buf,left,top,right,bottom,pixel_depth,x,y,x1,y1,
            value,coords,total_pts_drawn,0)) != NO_ERROR)
        return err;
     x = x1;
     y = y1;
    }
 PRT2(printf("DrawBufLinesByMatrix...end...total_pts_drawn = %d\n",*total_pts_drawn))
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
DrawCircleInBuf - ???
-----------------------------------------------------------------------*/

int
DrawCircleInBuf(buf,left,top,right,bottom,pixel_depth,centerx,centery,radius,
                         value,coords,total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth;
 long centerx,centery,radius,value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 struct float_xy_rec *the_pts,pts[2];
 float next;
 struct coord_rec the_coords;
 int err;
 long cnt,lcv,x,y,last,num;

 TRACE(printf("DrawCircleInBuf...centerx = %d centery = %d rx = %d  ry = %d\n",
          centerx,centery,rx,ry);)
 if (radius == 0)
    {pts[0].x = centerx;
     pts[0].y = centery;
     the_pts = pts;
     return DrawBufPts(buf,left,top,right,bottom,pixel_depth,the_pts,1,
               value,coords,total_pts_drawn);
    }
 if (radius < 0) radius = -radius;

 *total_pts_drawn = 0;
 err = NO_ERROR;
 next = 3.0 - 2.0 * (float) radius;
 init_coord_rec(&the_coords);
 x = 0; 
 y = radius;
 TRACE(printf("DrawCircleInBuf...radius = %d\n",radius))
 do
    {
     if (the_coords.num_pts == the_coords.total_pts)
        if ((err = get_coord_rec_memory(&the_coords,ADD_NUM_PTS)) != NO_ERROR)
           break;
     the_coords.pts[the_coords.num_pts].x = x;
     the_coords.pts[(the_coords.num_pts)++].y = y;
     next = next + 4.0 * x + 6.0;
     if (next >= 0)
        {
         next = next + 4 - 4 * y;
         y -= 1;
        }
     if (x >= y) break;
     x += 1;
    }
 while (1);
 if (err == NO_ERROR)
    {if (the_coords.num_pts == the_coords.total_pts)
        err = get_coord_rec_memory(&the_coords,ADD_NUM_PTS);
     if (err == NO_ERROR)
        {the_coords.pts[the_coords.num_pts].x = x;
         the_coords.pts[(the_coords.num_pts)++].y = y;
         last = the_coords.num_pts - 1;
         for (num = 0,lcv = last,cnt = 0; (cnt < 8) && (err == NO_ERROR); cnt++)
            while (err == NO_ERROR)
               {
                if ((cnt % 4) <= 1)
                   {if (cnt % 4)
                       {if (lcv > last)
                           {lcv = last - 1;
                            break;}
                       }
                      else if (lcv < 0)
                      {lcv = 1;
                       break;}

                    if (cnt % 5) x = -the_coords.pts[lcv].x;
                      else x = the_coords.pts[lcv].x;
                    if (cnt > 1) y = -the_coords.pts[lcv].y;
                       else y = the_coords.pts[lcv].y;
                    if (cnt % 4) lcv += 1;
                      else lcv -= 1;
                   }
                  else
                   {if (cnt % 2)
                       {if (lcv > last)
                           {lcv = last - 1;
                            break;}
                       }
                      else if (lcv < 0)
                      {lcv = 1;
                       break;}

                    if (cnt % 3) y = the_coords.pts[lcv].x;
                      else y = -the_coords.pts[lcv].x;

                    if (cnt > 5) x = the_coords.pts[lcv].y;
                       else x = -the_coords.pts[lcv].y;

                    if (cnt % 2) lcv += 1;
                      else lcv -= 1;
                   }
                /*printf("cnt = %d lcv = %d ...%d) x = %d  y = %d ",cnt,lcv,
                       (long) *total_pts_drawn,x,y);*/
                num += 1;

                y += centery;
                x += centerx;
                if ((x < left) || (x > right) || (y < top) || (y > bottom))
                   continue;

                if (buf != NULL) set_1d_buf_value(buf[y],x,pixel_depth,value);    
                if (coords != NULL)
                   {
                    if (coords->num_pts == coords->total_pts)
                       if ((err = get_coord_rec_memory(coords,ADD_NUM_PTS))
                                 != NO_ERROR)
                          break;
                    coords->pts[coords->num_pts].x = x;
                    coords->pts[(coords->num_pts)++].y = y;}
                *total_pts_drawn += 1;
               }
        }
    }
free_coord_rec(&the_coords);
 TRACE(printf("DrawCircleInBuf...err = %d\n",err))
 return err;
}


/*-----------------------------------------------------------------------
GetOctant - ???
-----------------------------------------------------------------------*/

int
GetOctant(coD,coE)
 int coD,coE;
{
 PRT(printf("GetOctant coD = %d coE = %d\n",coD,coE);)
 if (coD > 0)
    {if (coE < 0)
        if (coD < -coE) return 1;
          else return 2;
       else if (coD < coE) return 4;
       else return 3;
    }
   else if (coE < 0)
    {if (-coD < -coE) return 7;
       else return 8;}
   else if (-coD < coE) return 6;
   else return 5;
}


/*-----------------------------------------------------------------------
next_params - ???
-----------------------------------------------------------------------*/

static char DX[] = {1,0,0,-1,-1,0,0,1};
static char DY[] = {0,1,1,0,0,-1,-1,0};
static char DIAX[] = {1,1,-1,-1,-1,-1,1,1};
static char DIAY[] = {1,1,1,1,-1,-1,-1,-1};

void
next_params(oct,incd,incu,incv,k1,k2,k3,coA,coB,coC,coD,coE,coF,x,y)
 int oct,*incd,*incu,*incv,*k1,*k2,*k3,coA,coB,coC,coD,coE,coF,x,y;
{
 float num;
 float dx,dy;
 int oct1;

 PRT(printf("oct = %d   x = %d  y = %d\n",oct,x,y))
 oct1 = oct - 1;
 dx = x + (float) (DX[oct1] + DIAX[oct1]) / 2.0;
 dy = y + (float) (DY[oct1] + DIAY[oct1]) / 2.0;
 num = coA * dx * dx + coB * dx * dy + coC * dy * dy + coD * dx + coE * dy + coF;
 *incd = (int) floor((double) (num + .5));
 switch (oct)
    {case 1 : 
        num = coA * (2 * x + 1) + coB * (y + .5) + coD;
        *incu = (int) floor((double) (num + .5));
        num =  (2 * coA + coB) * x + (coB + 2 * coC) * y + coA + coB / 2.0 +
               coD + coE;
        *incv = (int) floor((double) (num + .5));
        *k1 = 2 * coA;
        *k2 = *k1 + coB;
        *k3 = *k2 + coB + 2 * coC;
        break;
     case 2 :
        num = coC * (2 * y + 1) + coB * (x + .5) + coE;
        *incu = (int) floor((double) (num + .5));
        num =  (2 * coA + coB) * x + (coB + 2 * coC) * y + coC + coB / 2.0 +
               coD + coE;
        *incv = (int) floor((double) (num + .5));

        *k1 = 2 * coC;
        *k2 = *k1 + coB;
        *k3 = *k2 + coB + 2 * coA;
        break;
     case 3 :
        num = coC * (2 * y + 1) + coB * (x - .5) + coE;
        *incu = (int) floor((double) (num + .5));
        num =  (-2 * coA + coB) * x + (-coB + 2 * coC) * y + coC - coB / 2.0 -
               coD + coE;

        *incv = (int) floor((double) (num + .5));
        *k1 = 2 * coC;
        *k2 = *k1 - coB;
        *k3 = *k2 - coB + 2 * coA;
        break;
     case 4 :
        num = coA * (-2 * x + 1) + coB * (-y - .5) - coD;
        *incu = (int) floor((double) (num + .5));
        num =  (-2 * coA + coB) * x + (-coB + 2 * coC) * y + coA - coB / 2.0 -
               coD + coE;
        *incv = (int) floor((double) (num + .5));
        *k1 = 2 * coA;
        *k2 = *k1 - coB;
        *k3 = *k2 - coB + 2 * coC;
        break;
     case 5 :
        num = coA * (-2 * x + 1) + coB * (-y + .5) - coD;
        *incu = (int) floor((double) (num + .5));
        num =  (-2 * coA - coB) * x + (-coB - 2 * coC) * y + coA + coB / 2.0 -
               coD - coE;
        *incv = (int) floor((double) (num + .5));
        *k1 = 2 * coA;
        *k2 = *k1 + coB;
        *k3 = *k2 + coB + 2 * coC;
        break;
     case 6 :
        num = coC * (-2 * y + 1) + coB * (-x + .5) - coE;
        *incu = (int) floor((double) (num + .5));
        num =  (-2 * coA - coB) * x + (-coB - 2 * coC) * y + coC + coB / 2.0 -
               coD - coE;
        *incv = (int) floor((double) (num + .5));
        *k1 = 2 * coC;
        *k2 = *k1 + coB;
        *k3 = *k2 + coB + 2 * coA;
        break;
     case 7 :
        num = coC * (-2 * y + 1) - coB * (x + .5) - coE;
        *incu = (int) floor((double) (num + .5));
        num =  (2 * coA - coB) * x + (coB - 2 * coC) * y + coC - coB / 2.0 +
               coD - coE;
        *incv = (int) floor((double) (num + .5));
        *k1 = 2 * coC;
        *k2 = *k1 - coB;
        *k3 = *k2 - coB + 2 * coA;
        break;
     case 8 :
        num = coA * (2 * x + 1) + coB * (y - .5) + coD;
        *incu = (int) floor((double) (num + .5));
        num =  (2 * coA - coB) * x + (coB - 2 * coC) * y + coA - coB / 2.0 +
               coD - coE;
        *incv = (int) floor((double) (num + .5));
        *k1 = 2 * coA;
        *k2 = *k1 - coB;
        *k3 = *k2 - coB + 2 * coC;
        break;
    }
}


/*-----------------------------------------------------------------------
DrawConic - ???
-----------------------------------------------------------------------*/

int
DrawConic(centerx,centery,startx,starty,endx,endy,coA,coB,coC,coD,coE,coF,
          buf,left,top,right,bottom,pixel_depth,value,coords,total_pts_drawn)
 long centerx,centery,startx,starty,endx,endy,coA,coB,coC,coD,coE,coF;
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 int err,x,y,oct,oct1,octcnt,dx,dy,diax,diay,tmp,incd,incu,incv,
     k1,k2,k3,k2_over_2;
 int x1,y1;
 int keep;
#define OCTANT_DONE 12
 oct = GetOctant(coD,coE);
 PRT(printf("DrawConic(oct = %d buf = %u coords = %u startx = %d starty = %d endx = %d endy = %d\n",oct,buf,coords,startx,starty,endx,endy);)
 PRT(printf("DrawConic coA = %d coB = %d coC = %d coD = %d coE = %d coF = %d\n",
       coA,coB,coC,coD,coE,coF);)

 oct1 = oct - 1;
 dx = DX[oct1];
 dy = DY[oct1];
 diax = DIAX[oct1];
 diay = DIAY[oct1];
 PRT(printf("DrawConic dx = %d dy = %d diax = %d diay = %d\n",dx,dy,diax,diay);)

/*
 x = endx - startx;
 y = endy - starty;
 gdx = 2 * coA * x + coB * y + coD;
 gdy = coB + 2 * coC * y + coE;
 octcnt = GetOctant(gdx,gdy);
 octcnt -= oct;
 if (octcnt <= 0) octcnt += 8;
 PRT(printf("DrawConic 2 octcnt = %d\n",octcnt);)
*/
 octcnt = 1;
 x = startx;
 y = starty;
 x1 = x + centerx;
 y1 = y + centery;
 err = NO_ERROR;
 keep = 1;
 while (1)
    {
     next_params(oct,&incd,&incu,&incv,&k1,&k2,&k3,coA,coB,coC,coD,coE,coF,
              x - startx,y - starty);
     k2_over_2 = k2 / 2;
     if (oct % 2)
        {PRT(printf("oct = %d octcnt = %d d = %d u = %d v = %d k1 = %d k2 = %d k3 = %d  k2 / 2 = %d %d %d %d %d x = %d y = %d %d %d\n",oct,octcnt,
                 incd,incu,incv,k1,k2,k3,k2_over_2,dx,dy,diax,diay,x,y,centerx,centery);)
         
         while (incv <= k2_over_2)
            {
             x1 = x + centerx;
             y1 = y + centery;
             if ((x1 >= left) && (x1 <= right) && (y1 >= top) && (y1 <= bottom))
                {
                 if (buf != NULL) set_1d_buf_value(buf[y1],x1,pixel_depth,value);    
                 if (coords != NULL)
                    {
                     if (coords->num_pts == coords->total_pts)
                        if ((err = get_coord_rec_memory(coords,ADD_NUM_PTS))
                                  != NO_ERROR)
                           break;
                     coords->pts[coords->num_pts].x = x1;
                     coords->pts[(coords->num_pts)++].y = y1;}
                 *total_pts_drawn += 1;
                }
             if ((x == endx) && (y == endy))
                if (keep > 1)
                   {PRT(printf("x == endx = %d  && y == endy = %d\n",x,y);)
                    octcnt = OCTANT_DONE;
                    break;}

             if (incd < 0)
                {x += dx;
                 y += dy;
                 incu += k1;
                 incv += k2;
                 incd += incu;
                }
               else
                {x += diax;
                 y += diay;
                 incu += k2;
                 incv += k3;
                 incd += incv;
                }
             PRT(printf("%d)  d = %d u = %d v = %d x = %d y = %d  x1 = %d y1 = %d\n",
                     keep,incd,incu,incv,x,y,x1,y1);)
             keep += 1;
             }
         tmp = dx;
         dx = -dy;
         dy = tmp;
        }
       else
        {PRT(printf("oct = %d octcnt = %d d = %d u = %d v = %d k1 = %d k2 = %d k3 = %d  k2 / 2 = %d %d %d %d %d x = %d y = %d %d %d\n",oct,octcnt,
                 incd,incu,incv,k1,k2,k3,k2_over_2,dx,dy,diax,diay,x,y,centerx,centery);)
         while (incu <= k2_over_2)
            {
             x1 = x + centerx;
             y1 = y + centery;
             if ((x1 >= left) && (x1 <= right) && (y1 >= top) && (y1 <= bottom))
                {
                 if (buf != NULL) set_1d_buf_value(buf[y1],x1,pixel_depth,value);    
                 if (coords != NULL)
                    {
                     if (coords->num_pts == coords->total_pts)
                        if ((err = get_coord_rec_memory(coords,ADD_NUM_PTS))
                                  != NO_ERROR)
                           break;
                     coords->pts[coords->num_pts].x = x1;
                     coords->pts[(coords->num_pts)++].y = y1;}
                 *total_pts_drawn += 1;
                }
             if ((x == endx) && (y == endy))
                if (keep > 1)
                   {PRT(printf("x == endx = %d  && y == endy = %d\n",x,y);)
                    octcnt = OCTANT_DONE;
                    break;}
             if (incd < 0)
                {x += diax;
                 y += diay;
                 incu += k2;
                 incv += k3;
                 incd += incv;
                }
               else
                {x += dx;
                 y += dy;
                 incu += k1;
                 incv += k2;
                 incd += incu;
                }
             PRT(printf("===%d)  d = %d u = %d v = %d x = %d y = %d  x1 = %d y1 = %d\n",
                     keep,incd,incu,incv,x,y,x1,y1);)
             keep += 1;

             }
         tmp = diax;
         diax = -diay;
         diay = tmp;
        }
     PRT(printf("----- octcnt = %d \n",octcnt);)
     oct += 1;
     if (oct > 8) oct -= 8;
     octcnt += 1;
     if (octcnt >= OCTANT_DONE) break;
    }
 PRT(printf("DrawConic err = %d end\n",err);)
 return err;
}


/*-----------------------------------------------------------------------
Conjugate - ???
-----------------------------------------------------------------------*/

#define FULL_ELLIPSE 1

int
Conjugate(centerx,centery,xp,yp,xq,yq,mode,
          buf,left,top,right,bottom,pixel_depth,value,coords,total_pts_drawn)
 int centerx,centery,xp,yp,xq,yq,mode;
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 int err,xprod,tmp,endx,endy,coA,coB,coC,coD,coE,coF;

 PRT(printf("Conjugate(centerx = %d centery = %d xp = %d yp = %d xq = %d yq = %d\n",centerx,centery,xp,yp,xq,yq);)
 *total_pts_drawn = 0;
 /****
      centerx = 83 centery = 103 xp = 88 yp = 90 xq = 90 yq = 105
      Conjugate(centerx = 79 centery = 99 xp = 71 yp = 101 xq = 75 yq = 85
      centerx = 79;
      centery = 99;
      xp = 71;
      yp = 101;
      xq = 75;
      yq = 85;
 ****/

 xp -= centerx;
 xq -= centerx;
 yp -= centery;
 yq -= centery;

 PRT(printf(" xp = %d yp = %d xq = %d yq = %d\n",xp,yp,xq,yq);)
 xprod = xp * yq - xq * yp;
 if (xprod != 0)
    {if (xprod < 0)
        {tmp = xp; xp = xq; xq = tmp;
         tmp = yp; yp = yq; yq = tmp;
         xprod = -xprod;}
     coA = yp * yp + yq * yq;
     coB = -2 * (xp * yp + xq * yq);
     coC = xp * xp + xq * xq;
     coD = 2 * yq * xprod;
     coE = -2 * xq * xprod;
     coF = 0;
     if (mode == FULL_ELLIPSE)
        {endx = xp; endy = yp;}
       else {endx = xq; endy = yq;}
     err = DrawConic(centerx,centery,xp,yp,endx,endy,coA,coB,coC,coD,coE,coF,
         buf,left,top,right,bottom,pixel_depth,value,coords,total_pts_drawn);
    }
   else err = NO_ERROR;
 return err;
}


/*-----------------------------------------------------------------------
DrawCircleOrEllipse - ???

1st pt = [centerx,centery]
2nd pt = [x,y]  where radiusx = |x - centerx|   and   radiusy = |y - centery|
-----------------------------------------------------------------------*/

int
DrawCircleOrEllipse(buf,rleft,rtop,rright,rbottom,pixel_depth,pts,num_pts,curve_type,
                    value,coords,total_pts_drawn)
 unsigned char **buf;
 long rleft,rtop,rright,rbottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 unsigned long curve_type;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 float rx,ry,left1,top1,bottom1,right1;
 long x,y,x1,y1;

 if (num_pts == 1)
    return DrawBufPts(buf,rleft,rtop,rright,rbottom,pixel_depth,pts,num_pts,
               value,coords,total_pts_drawn);
 rx = pts[0].x - pts[1].x;
 ry = pts[0].y - pts[1].y;
 if (rx < 0) rx = -rx;
 if (ry < 0) ry = -ry;
 left1 = pts[0].x - rx;
 right1 = pts[0].x + rx;
 top1 = pts[0].y - ry;
 bottom1 = pts[0].y + ry;
/*
 if ((left1 < rleft) || (left1 > rright) || (top1 < rtop) || (top1 > rbottom))
    if ((right1 < rleft) || (right1 > rright) || (bottom1 < rtop) || (bottom1 > rbottom))
       return NO_ERROR;
*/
 PRT(printf("draw_circle_or_ellipse...num_pts = %d\n",num_pts))
 x = (long) floor((double) (pts[0].x + .5));
 y = (long) floor((double) (pts[0].y + .5));
 if (curve_type == DRAW_CIRCLE)
    {x1 = (long) floor((double) (rx + .5));
     return DrawCircleInBuf(buf,rleft,rtop,rright,rbottom,pixel_depth,x,y,
            (long) x1,value,coords,total_pts_drawn);}
   else  
    {
     x1 = (long) floor((double) (pts[0].x + rx + .5));
     y1 = (long) floor((double) (pts[0].y + ry + .5));
     return Conjugate(x,y,x1,y,x,y1,FULL_ELLIPSE,
           buf,rleft,rtop,rright,rbottom,pixel_depth,value,coords,total_pts_drawn);
    }
}


/*-----------------------------------------------------------------------
DrawCircleOrEllipseByMatrix - ???

1st pt = [centerx,centery]
2nd pt = [x,y]  where radiusx = |x - centerx|   and   radiusy = |y - centery|
-----------------------------------------------------------------------*/

int
DrawCircleOrEllipseByMatrix(buf,rleft,rtop,rright,rbottom,pixel_depth,pts,num_pts,curve_type,
               matrix,value,coords,total_pts_drawn)
 unsigned char **buf;
 long rleft,rtop,rright,rbottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 unsigned long curve_type;
 struct matrix_2d_rec *matrix;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 float rx,ry,left1,top1,bottom1,right1,centerx,centery;
 long x,y,x1,y1,x2,y2;

 if (num_pts == 1)
    {
     return DrawBufPtsByMatrix(buf,rleft,rtop,rright,rbottom,pixel_depth,pts,num_pts,matrix,
               value,coords,total_pts_drawn);
    }
 rx = pts[0].x - pts[1].x;
 ry = pts[0].y - pts[1].y;
 if (rx < 0) rx = -rx;
 if (ry < 0) ry = -ry;
 left1 = pts[0].x - rx;
 right1 = pts[0].x + rx;
 top1 = pts[0].y - ry;
 bottom1 = pts[0].y + ry;

 TRACE(printf("draw_circle_or_ellipse_by_matrix...num_pts = %d\n",num_pts))
 trans_2d_pt(matrix,left1,top1,&left1,&top1,1);
 trans_2d_pt(matrix,right1,bottom1,&right1,&bottom1,1);
/*
 if ((left1 < rleft) || (left1 > rright) || (top1 < rtop) || (top1 > rbottom))
    if ((right1 < rleft) || (right1 > rright) || (bottom1 < rtop) || (bottom1 > rbottom))
       return NO_ERROR;
*/
 trans_2d_pt(matrix,pts[0].x,pts[0].y,&centerx,&centery,0);

 if (curve_type == DRAW_CIRCLE)
    {left1 = pts[0].x + rx;
     top1 = pts[0].y + ry;
     PRT3(printf("DRAW_CIRCLE cx/cy = %f %f y/x = %f/%f \n",centery,centerx,pts[0].y,pts[0].x);
          printf("ry = %f rx = %f top1 = %f l = %f\n",
         ry,rx,top1,left1))

     trans_2d_pt(matrix,left1,top1,&left1,&top1,0);
     PRT3(printf("top1 = %f l = %f\n",top1,left1))

     rx = centerx - left1;
     rx = rx * rx;
     ry = centery - top1;
     ry = ry * ry;
     rx = sqrt((double) rx + (double) ry);
     x = floor((double) (centerx + .5));
     y = floor((double) (centery + .5));
     x1 = floor((double) (rx + .5));
     PRT3(printf("y/x = %d/%d  rx = %d\n",y,x,x1))
     return DrawCircleInBuf(buf,rleft,rtop,rright,rbottom,pixel_depth,x,y,
                         x1,value,coords,total_pts_drawn);}
   else
    {
     left1 = pts[0].x;
     top1 = pts[0].y + ry;
     PRT4(printf("DRAW_ELLIPSE cx/cy = %f %f y/x = %f/%f \n",centery,centerx,pts[0].y,pts[0].x);
     printf("  y[1]/x[1] = %f/%f \n",pts[1].y,pts[1].x);)
/*
          printf("ry = %f rx = %f top = %f l = %f\n",
         ry,rx,top,left1))
*/
     trans_2d_pt(matrix,left1,top1,&left1,&top1,1);
     PRT3(printf("top = %f l = %f\n",top,left1))

     right1 = pts[0].x + rx;
     bottom1 = pts[0].y;
     trans_2d_pt(matrix,right1,bottom1,&right1,&bottom1,1);
     x = floor((double) (centerx + .5));
     y = floor((double) (centery + .5));
     x1 = floor((double) (right1 + .5));
     y1 = floor((double) (bottom1 + .5));
     x2 = floor((double) (left1 + .5));
     y2 = floor((double) (top1 + .5));
     PRT5(printf("Mat y/x = %d/%d  y1/x1 = %d/%d  y2/x2 = %d/%d\n",y,x,y1,x1,y2,x2))
     return Conjugate(x,y,x1,y1,x2,y2,FULL_ELLIPSE,
           buf,rleft,rtop,rright,rbottom,pixel_depth,value,coords,total_pts_drawn);
    }
}


/*-----------------------------------------------------------------------
draw_rect_in_buf - ???
-----------------------------------------------------------------------*/

int
draw_rect_in_buf(buf,rleft,rtop,rright,rbottom,pixel_depth,
                 left1,top1,right1,bottom1,value,coords,total_pts_drawn)
 unsigned char **buf;
 long rleft,rtop,rright,rbottom,pixel_depth;
 long left1,top1,right1,bottom1,value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 int err;

 *total_pts_drawn = 0;
 if (((err = DrawLineInBuf(buf,rleft,rtop,rright,rbottom,pixel_depth,
            left1,top1,right1,top1,value,coords,total_pts_drawn,0)) == NO_ERROR) &&
     ((err = DrawLineInBuf(buf,rleft,rtop,rright,rbottom,pixel_depth,
            right1,top1,right1,bottom1,value,coords,total_pts_drawn,0)) == NO_ERROR) &&
     ((err = DrawLineInBuf(buf,rleft,rtop,rright,rbottom,pixel_depth,
            right1,bottom1,left1,bottom1,value,coords,total_pts_drawn,0)) == NO_ERROR))
    err = DrawLineInBuf(buf,rleft,rtop,rright,rbottom,pixel_depth,
            left1,bottom1,left1,top1,value,coords,total_pts_drawn,0);
 return err;
}


/*-----------------------------------------------------------------------
DrawBufRect - ???
-----------------------------------------------------------------------*/

int
DrawBufRect(buf,left,top,right,bottom,pixel_depth,
                 pts,num_pts,value,coords,total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 long x,y,x1,y1;

 if (num_pts == 1)
    return DrawBufPts(buf,left,top,right,bottom,pixel_depth,pts,num_pts,
               value,coords,total_pts_drawn);
 x = floor((double) (pts[0].x + .5));
 y = floor((double) (pts[0].y + .5));
 x1 = floor((double) (pts[1].x + .5));
 y1 = floor((double) (pts[1].y + .5));
 return draw_rect_in_buf(buf,left,top,right,bottom,pixel_depth,x,y,
                 x1,y1,value,coords,total_pts_drawn);
}


/*-----------------------------------------------------------------------
DrawBufRectByMatrix - ???
-----------------------------------------------------------------------*/

int
DrawBufRectByMatrix(buf,left,top,right,bottom,pixel_depth,
                 pts,num_pts,matrix,value,coords,total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 struct matrix_2d_rec *matrix;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 float newx,newy;
 int err;
 long xys[4][4];

 if (num_pts == 1)
    return DrawBufPts(buf,left,top,right,bottom,pixel_depth,pts,num_pts,
               value,coords,total_pts_drawn);
 trans_2d_pt(matrix,pts[0].x,pts[0].y,&newx,&newy,1);
 xys[0][0] = (long) floor((double) newx);
 xys[0][1] = (long) floor((double) newy);
 trans_2d_pt(matrix,pts[0].x,pts[1].y,&newx,&newy,1);
 xys[1][0] = (long) floor((double) newx);
 xys[1][1] = (long) floor((double) newy);
 trans_2d_pt(matrix,pts[1].x,pts[1].y,&newx,&newy,1);
 xys[2][0] = (long) floor((double) newx);
 xys[2][1] = (long) floor((double) newy);
 trans_2d_pt(matrix,pts[1].x,pts[0].y,&newx,&newy,1);
 xys[3][0] = (long) floor((double) newx);
 xys[3][1] = (long) floor((double) newy);

 *total_pts_drawn = 0;
 if (((err = DrawLineInBuf(buf,left,top,right,bottom,pixel_depth,xys[0][0],xys[0][1],
            xys[1][0],xys[1][1],value,coords,total_pts_drawn,0)) == NO_ERROR) &&
     ((err = DrawLineInBuf(buf,left,top,right,bottom,pixel_depth,xys[1][0],xys[1][1],
            xys[2][0],xys[2][1],value,coords,total_pts_drawn,0)) == NO_ERROR) &&
     ((err = DrawLineInBuf(buf,left,top,right,bottom,pixel_depth,xys[2][0],xys[2][1],
            xys[3][0],xys[3][1],value,coords,total_pts_drawn,0)) == NO_ERROR))
    err = DrawLineInBuf(buf,left,top,right,bottom,pixel_depth,xys[3][0],xys[3][1],
            xys[0][0],xys[0][1],value,coords,total_pts_drawn,0);
 return err;
}


/*-----------------------------------------------------------------------
DrawInBuffer - ???
-----------------------------------------------------------------------*/

int
DrawInBuffer(buf,left,top,right,bottom,pixel_depth,pts,num_pts,curve_type,value,coords,
            total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 unsigned long curve_type;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{

 if (num_pts == 0) return NO_ERROR;

 if ((curve_type == DRAW_POINT) || (num_pts == 1))
    return DrawBufPts(buf,left,top,right,bottom,pixel_depth,pts,num_pts,
               value,coords,total_pts_drawn);
   else if ((curve_type == DRAW_CIRCLE) || (curve_type == DRAW_ELLIPSE))
     return DrawCircleOrEllipse(buf,left,top,right,bottom,pixel_depth,pts,num_pts,curve_type,
               value,coords,total_pts_drawn);
   else if (curve_type == DRAW_RECT)
     return DrawBufRect(buf,left,top,right,bottom,pixel_depth,
                 pts,num_pts,value,coords,total_pts_drawn);
   else
    {
     return DrawBufLines(buf,left,top,right,bottom,pixel_depth,
                 pts,num_pts,value,coords,total_pts_drawn);
    }

}



/*-----------------------------------------------------------------------
DrawInBufByMatrix - ???
-----------------------------------------------------------------------*/

int
DrawInBufByMatrix(buf,left,top,right,bottom,pixel_depth,pts,num_pts,curve_type,matrix,
                      value,coords,total_pts_drawn)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 unsigned long curve_type;
 struct matrix_2d_rec *matrix;
 long value;
 struct coord_rec *coords;
 unsigned long *total_pts_drawn;
{
 if (num_pts == 0) return NO_ERROR;
 if ((curve_type == DRAW_POINT) || (num_pts == 1))
    return DrawBufPtsByMatrix(buf,left,top,right,bottom,pixel_depth,pts,num_pts,matrix,
                 value,coords,total_pts_drawn);
   else if ((curve_type == DRAW_CIRCLE) || (curve_type == DRAW_ELLIPSE))
     return DrawCircleOrEllipseByMatrix(buf,left,top,right,bottom,pixel_depth,pts,num_pts,
               curve_type,matrix,value,coords,total_pts_drawn);
   else if (curve_type == DRAW_RECT)
     return DrawBufRectByMatrix(buf,left,top,right,bottom,pixel_depth,
                 pts,num_pts,matrix,value,coords,total_pts_drawn);
   else
    return DrawBufLinesByMatrix(buf,left,top,right,bottom,pixel_depth,
                 pts,num_pts,matrix,value,coords,total_pts_drawn);

}


/*-----------------------------------------------------------------------
DrawInBuf - ???
-----------------------------------------------------------------------*/

int
DrawInBuf(buf,left,top,right,bottom,pixel_depth,pts,num_pts,
          curve_type,matrix,use_matrix,value,coords,total_pts_drawn,sroi_inv)
 unsigned char **buf;
 long left,top,right,bottom,pixel_depth,num_pts;
 struct float_xy_rec *pts;
 long value;
 struct coord_rec *coords;
 unsigned long curve_type;
 struct matrix_2d_rec *matrix;
 int use_matrix;
 unsigned long *total_pts_drawn;
 struct matrix_2d_rec *sroi_inv;
{
 struct matrix_2d_rec mat,*pmat;
 int err;

 if (total_pts_drawn != NULL) *total_pts_drawn = 0;
 if (use_matrix) 
    {if (sroi_inv != NULL)
        {mult_2d_matrix(&mat,sroi_inv,matrix);
         pmat = &mat;}
       else pmat = matrix;
    }
   else if (sroi_inv != NULL)
    pmat = sroi_inv;
   else pmat = NULL;
 if (pmat != NULL)
    err = DrawInBufByMatrix(buf,left,top,right,bottom,pixel_depth,pts,num_pts,
            curve_type,pmat,value,coords,total_pts_drawn);
   else
    err = DrawInBuffer(buf,left,top,right,bottom,pixel_depth,pts,num_pts,
            curve_type,value,coords,total_pts_drawn);
 return err;
}


/*-----------------------------------------------------------------------
XorBitmapByCurvePts - ???

FIXME:  The function LongCurvePtByIndx called below belongs to NRIA
proper rather than to the library.  This function may be misplaced
here in the library.  -PWH 19990517
-----------------------------------------------------------------------*/

int
XorBitmapByCurvePts(dest,curves,num_curves,sroi_inv)
 struct buf_2d_rec *dest;
 struct curve_rec **curves;
 unsigned int num_curves;
 struct matrix_2d_rec *sroi_inv;
{
 unsigned int lcv,cnt,val;
 long x,y;

 for (lcv = 0; lcv < num_curves; lcv++)
    for (cnt = 0; cnt < curves[lcv]->num_xys; cnt++)
       {if ((LongCurvePtByIndx(curves[lcv],cnt,&x,&y,sroi_inv) == NO_ERROR) &&
            (y >= 0) && (y < dest->dimy) &&
            (x >= 0) && (x < dest->dimx)) 
           {val = get_1d_buf_value(dest->buf[y],x,dest->pixel_depth);
            if (val)
               set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,0);
              else set_1d_buf_value(dest->buf[y],x,dest->pixel_depth,1);
           }
       }
 return NO_ERROR;

}


/*-----------------------------------------------------------------------
XorBitmapByCurveLines - ???
-----------------------------------------------------------------------*/

int
XorBitmapByCurveLines(dest,curves,num_curves,sroi_inv)
 struct buf_2d_rec *dest;
 struct curve_rec **curves;
 unsigned int num_curves;
 struct matrix_2d_rec *sroi_inv;
{
 unsigned int lcv,cnt,val;
 struct coord_rec coords;
 int err;
 unsigned long total_pts_drawn;

 for (lcv = 0; lcv < num_curves; lcv++)
    {if (curves[lcv]->num_xys == 0) continue;
     init_coord_rec(&coords);
     if ((err = DrawInBuf(NULL,0,0,dest->dimx - 1,dest->dimy - 1,dest->pixel_depth,
            curves[lcv]->xys,curves[lcv]->num_xys,(int) DRAW_LINE,
            &(curves[lcv]->matrix),(int) (curves[lcv]->status & CURVE_MATRIX_IN_USE),
            (long) 1,&coords,&total_pts_drawn,sroi_inv)) != NO_ERROR)
        {free_coord_rec(&coords);
         return err;}

     for (cnt = 0; cnt < coords.num_pts; cnt++)
       {val = get_1d_buf_value(dest->buf[(int) coords.pts[cnt].y],
                (int) coords.pts[cnt].x,dest->pixel_depth);
        if (val)
           set_1d_buf_value(dest->buf[(int) coords.pts[cnt].y],
                (int) coords.pts[cnt].x,dest->pixel_depth,0);
          else set_1d_buf_value(dest->buf[(int) coords.pts[cnt].y],
                (int) coords.pts[cnt].x,dest->pixel_depth,1);
       }
    free_coord_rec(&coords);
   }
 return NO_ERROR;

}


/*-----------------------------------------------------------------------
XorBitmapByCurves - ???
-----------------------------------------------------------------------*/

int
XorBitmapByCurves(dest,curves,num_curves,sroi_inv,is_line)
 struct buf_2d_rec *dest;
 struct curve_rec **curves;
 unsigned int num_curves;
 struct matrix_2d_rec *sroi_inv;
 int is_line;
{
 if (is_line) return XorBitmapByCurveLines(dest,curves,num_curves,sroi_inv);
 else         return XorBitmapByCurvePts(dest,curves,num_curves,sroi_inv);
}
