/****************************************************************************
mark_hdr_opr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: mark_hdr_opr.c,v 1.5 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <sys/types.h>

#include "error_constants.h"
#include "mark_hdr.h"
#include "nria_lib.h"




/*------------------------------------------------------------------------
init_makr_hdr_key - ???
------------------------------------------------------------------------*/

void
init_makr_hdr_key(key)
 struct mark_hdr_key *key;
{
 key->size = sizeof(struct mark_hdr);
 strcpy(key->data_type,"\0");
 strcpy(key->name,"\0");
 key->extents = 0;
 key->session_error = 0;
 key->regular = ' ';
 key->hkey_un0 = ' ';
}


/*------------------------------------------------------------------------
init_mark_patient_rec - ???
------------------------------------------------------------------------*/

void
init_mark_patient_rec(patient)
 struct mark_patient_rec *patient;
{
 strcpy(patient->name,"\0");
 strcpy(patient->ssnum,"\0");
 strcpy(patient->patient_id,"\0");
 strcpy(patient->study_num,"\0");
 strcpy(patient->patient_num,"\0");
 patient->sex = ' ';
 patient->age = 0;
 patient->height = 0;
 patient->weight = 0;

}


/*------------------------------------------------------------------------
init_mark_hdr_history - ???
------------------------------------------------------------------------*/

void
init_mark_hdr_history(history)
 struct mark_hdr_history *history;
{
 init_mark_patient_rec(&(history->patient));
 strcpy(history->date_of_study,"\0");
 strcpy(history->time_of_study,"\0");
 strcpy(history->comment,"\0");
}


/*------------------------------------------------------------------------
init_mark_hdr_dimension - ???
------------------------------------------------------------------------*/

void
init_mark_hdr_dimension(dimen)
 struct mark_hdr_dimension *dimen;
{
 dimen->num_dims = 4;
 dimen->dimx = 0;
 dimen->dimy = 0;
 dimen->max_slices = 0;
 dimen->num_vols = 1;
 dimen->histo_dimx = 0;
 dimen->histo_dimy = 0;

 dimen->pixel_depth_bits = 0;
 dimen->xpixel_size = 0;
 dimen->ypixel_size = 0;
 dimen->pixel_thickness = 0;
 dimen->glmax = 0;
 dimen->glmin = 0;

}


/*------------------------------------------------------------------------
init_mark_hdr - ???
------------------------------------------------------------------------*/

void
init_mark_hdr(hdr)
 struct mark_hdr *hdr;
{

 init_makr_hdr_key(&(hdr->key));
 init_mark_hdr_history(&(hdr->history));
 init_mark_hdr_dimension(&(hdr->dimen));
}


/*------------------------------------------------------------------------
wr_the_mark_hdr - ???
------------------------------------------------------------------------*/

int
wr_the_mark_hdr(fn,mark)
 char *fn;
 struct mark_hdr *mark;
{
 FILE *fid;

/*
 if ((fid = fopen(fn,"w","rfm=udf")) == NULL)
*/
 if ((fid = fopen(fn,"w")) == NULL)
    {
     return FILE_ACCESS_ERROR;}

 if (fwrite(mark,(size_t) sizeof(struct mark_hdr),1,fid) != 1)
    {fclose(fid);
     delete_file(fn);
     return ~NO_ERROR;}
 fclose(fid);
 return NO_ERROR;

}


/*------------------------------------------------------------------------
load_hdr_file - ???
------------------------------------------------------------------------*/

int
load_hdr_file(fn,db)
 char *fn;
 struct mark_hdr *db;
{
 FILE *fid;

 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;

 if (fread(db,sizeof(struct mark_hdr),1,fid) != 1)
    {
     fclose(fid);
     /* Was: printf("%s is a BAD DATA %s FILE !!!",fn);
	-PWH 19990311 */
     printf("%s is a BAD DATA HDR FILE !!!",fn);
     return READ_ERROR;}
 fclose(fid);
 return NO_ERROR;
}

