/****************************************************************************
plane.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: plane.c,v 1.5 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <sys/types.h>
#include <math.h>

#include "geometry.h"
#include "error_constants.h"
#include "nria_lib.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);

*/
#define TRACE(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)
#define PRT6(x)
#define PRT7(x)
#define PRT8(x)


float vector_distance();
double degree();
float length_vector();
float pt_line_dist();
float vector_dot_product();
double acos_to_degree();
double radian();
double float_precision();
float vector_distance_from_abs();
float degree_angle_vectors();
char *get_vector_angle_str();
char *get_vector_angle_str1();



/*-------------------------------------------------------------------------
init_plane_3d_rec - ???
-------------------------------------------------------------------------*/

void
init_plane_3d_rec(plane)
 struct plane_3d_rec *plane;
{
 plane->status = 0;
 plane->more_status = 0;
}


/*-------------------------------------------------------------------------
calc_plane_const - ???
-------------------------------------------------------------------------*/

void
calc_plane_const(plane)
 struct plane_3d_rec *plane;
{
 plane->constk = plane->normal.x * plane->base.x + plane->normal.y * plane->base.y +
     plane->normal.z * plane->base.z;
 plane->status |= PLANE_CONST_COMPUTED;
}


/*-------------------------------------------------------------------------
closer_to_plane_origin - ???
-------------------------------------------------------------------------*/

int
closer_to_plane_origin(pt1,pt2)
 struct vector_3d_rec *pt1,*pt2;
{
 int cnt,same;
 float temp1,temp2;

 cnt = 3;
 same = 0;
 if (pt1->x < .0) temp1 = -pt1->x;
   else temp1 = pt1->x;
 if (pt2->x < .0) temp2 = -pt2->x;
   else temp2 = pt2->x;
 if (temp1 > temp2) cnt--;
   else if (temp1 == temp2) same++;

 if (pt1->y < .0) temp1 = -pt1->y;
   else temp1 = pt1->y;
 if (pt2->y < .0) temp2 = -pt2->y;
   else temp2 = pt2->y;
 if (temp1 > temp2) cnt--;
   else if (temp1 == temp2) same++;

 if (pt1->z < .0) temp1 = -pt1->z;
   else temp1 = pt1->z;
 if (pt2->z < .0) temp2 = -pt2->z;
   else temp2 = pt2->z;
 if (temp1 > temp2) cnt--;
   else if (temp1 == temp2) same++;
/*
 printf("same = %d cnt = %d\n",same,cnt);
 printf("pt1..\n");pr_vector_3d_rec(pt1);
 printf("pt2..\n");pr_vector_3d_rec(pt2);
 printf("\n");
*/
 if (cnt == 3) {/* printf("...pt1..\n");*/ return 1;}
 if (cnt <= 1) {/*printf("...pt2..\n"); */ return 0;}
 if (same == 2) {/*printf("...pt2..\n");*/ return 0;}
   else if (same == 0) {/*printf("...pt1..\n");*/ return 1;}
   else if (length_vector(pt1) > length_vector(pt2)) 
    {/* printf("...pt2..\n");*/return 0;}
   else {/*printf("...pt1..\n");*/ return 1;}
}


/*-------------------------------------------------------------------------
get_3d_rect_base - ???
-------------------------------------------------------------------------*/

void
get_3d_rect_base(bounds,indx)
 struct vector_3d_rec bounds[4];
 int *indx;
{
 int lcv;

 for (*indx = 0,lcv = 1; lcv < 4; lcv++)
    if (!closer_to_plane_origin(&(bounds[*indx]),&(bounds[lcv]))) *indx = lcv;
/*
 printf("get_3d_rect_base...end\n\n");
*/
}


/*-------------------------------------------------------------------------
closest_pt_to_origin - ???
-------------------------------------------------------------------------*/

void
closest_pt_to_origin(bounds,indx)
 struct vector_3d_rec bounds[4];
 int *indx;
{
 int lcv;
 float dist,dist1;

 dist = length_vector(&(bounds[0]));
 for (*indx = 0,lcv = 1; lcv < 4; lcv++)
    {dist1 = length_vector(&(bounds[lcv]));
     if (dist1 < dist)
        {dist = dist1;
         *indx = lcv;}
    }
}


/*-------------------------------------------------------------------------
GlobalXYZ - ???
-------------------------------------------------------------------------*/

int
GlobalXYZ(plane,localx,localy,localz,globalx,globaly,globalz)
 struct plane_3d_rec *plane;
 float localx,localy,localz,*globalx,*globaly,*globalz;
{
 *globalx = localx * plane->coord_ratio.x;
 *globaly = localy * plane->coord_ratio.y;
 *globalz = localz * plane->coord_ratio.z;
 return 1;
}


/*-------------------------------------------------------------------------
GlobalPt - ???
-------------------------------------------------------------------------*/

int
GlobalPt(plane,localpt,globalpt)
 struct plane_3d_rec *plane;
 struct vector_3d_rec *localpt,*globalpt;
{
 return GlobalXYZ(plane,localpt->x,localpt->y,localpt->z,
                  &(globalpt->x),&(globalpt->y),&(globalpt->z));
}


/*-------------------------------------------------------------------------
LocalXYZ - ???
-------------------------------------------------------------------------*/

int
LocalXYZ(plane,globalx,globaly,globalz,localx,localy,localz)
 struct plane_3d_rec *plane;
 float globalx,globaly,globalz,*localx,*localy,*localz;
{
 *localx = globalx / plane->coord_ratio.x;
 *localy = globaly / plane->coord_ratio.y;
 *localz = globalz / plane->coord_ratio.z;
 return 1;
}


/*-------------------------------------------------------------------------
LocalPt - ???
-------------------------------------------------------------------------*/

int
LocalPt(plane,globalpt,localpt)
 struct plane_3d_rec *plane;
 struct vector_3d_rec *globalpt,*localpt;
{
 return LocalXYZ(plane,globalpt->x,globalpt->y,globalpt->z,
                  &(localpt->x),&(localpt->y),&(localpt->z));
}



/*-------------------------------------------------------------------------
LocalToGlobalXYZ - ???
-------------------------------------------------------------------------*/

int
LocalToGlobalXYZ(coord_matrix,coord_ratio,x,y,z,proj_ptx,proj_pty,proj_ptz,
                 is_result_rounded)
 struct matrix_3d_rec *coord_matrix;
 struct vector_3d_rec *coord_ratio;
 float x,y,z,*proj_ptx,*proj_pty,*proj_ptz;
 int is_result_rounded;
{
 trans_3d_xyz(coord_matrix,x,y,z,proj_ptx,proj_pty,proj_ptz,is_result_rounded);
 *proj_ptx = *proj_ptx * coord_ratio->x;
 *proj_pty = *proj_pty * coord_ratio->y;
 *proj_ptz = *proj_ptz * coord_ratio->z;
 return 1;
}


/*-------------------------------------------------------------------------
GlobalToLocalXYZ - ???
-------------------------------------------------------------------------*/

int
GlobalToLocalXYZ(coord_matrix,coord_ratio,x,y,z,proj_ptx,proj_pty,proj_ptz,
                 is_result_rounded)
 struct matrix_3d_rec *coord_matrix;
 struct vector_3d_rec *coord_ratio;
 float x,y,z,*proj_ptx,*proj_pty,*proj_ptz;
 int is_result_rounded;
{
 trans_3d_xyz(coord_matrix,x,y,z,proj_ptx,proj_pty,proj_ptz,is_result_rounded);
 *proj_ptx = *proj_ptx / coord_ratio->x;
 *proj_pty = *proj_pty / coord_ratio->y;
 *proj_ptz = *proj_ptz / coord_ratio->z;
 return 1;
}


/*-------------------------------------------------------------------------
define_plane_orientation - ???

   select = 1 use the bottom left corner as the origin
                        = 2 use the bottom right corner as the origin
                        = 4 use the top right corner as the origin
                        = 8 use the top left corner as the origin
     1,2,4,8 are mutually exclusive and they can co-exist with 16 & 32
                        = 16 reflection about the line y = x

 select = 32 check to see if 16 should be enabled
-------------------------------------------------------------------------*/

int
define_plane_orientation(plane,select)
 struct plane_3d_rec *plane;
 int select;
{
 struct vector_3d_rec v;
 struct matrix_3d_rec ma1;
 long temp;

 if ((plane->proj_dimx <= 1) || (plane->proj_dimy <= 1))
    {
     return NO_ERROR;}

 PRT8(printf("define_plane_orientation select = %d\n",select))
 if (select & GY_REFLECTION)
    {setup_vector_3d_rec(&v,(float) (plane->actual_proj_dimx - 1),.0,.0);
     identity_3d_matrix(&ma1);
     ma1.buf[0][0] = -1;
/*
     translate_3d_matrix(&ma1,v.x,v.y,v.z);
*/
     plane->status &= ~PLANE_PLANE_GRAVITY_IDENTITY;
     PRT8(printf("GY_REFLECTION actual dimx = %d dimy = %d  proj dimx = %d  dimy = %d  %x\n",
             plane->actual_proj_dimx,plane->actual_proj_dimy,
             plane->proj_dimx,plane->proj_dimy,(unsigned int) plane->plane_gravity_status))
    }
   else if (select & GX_REFLECTION)
    {
     setup_vector_3d_rec(&v,.0,(float) (plane->actual_proj_dimy - 1),.0);

     identity_3d_matrix(&ma1);
     ma1.buf[1][1] = -1;
/*
     translate_3d_matrix(&ma1,v.x,v.y,v.z);
*/
     plane->status &= ~PLANE_PLANE_GRAVITY_IDENTITY;
     PRT8(printf("GX_REFLECTION actual dimx = %d dimy = %d  proj dimx = %d  dimy = %d  %x\n",
             plane->actual_proj_dimx,plane->actual_proj_dimy,
             plane->proj_dimx,plane->proj_dimy,(unsigned int) plane->plane_gravity_status))
    }
   else if (select & GY_X_REFLECTION)
    {

     setup_vector_3d_rec(&v,(float) (plane->actual_proj_dimy - 1),
                            (float) (plane->actual_proj_dimx - 1),.0);

     identity_3d_matrix(&ma1);
     ma1.buf[0][0] = 0;
     ma1.buf[1][1] = 0;
     ma1.buf[0][1] = -1;
     ma1.buf[1][0] = -1;

/*
     translate_3d_matrix(&ma1,v.x,v.y,v.z);
*/
     temp = plane->actual_proj_dimx;
     plane->actual_proj_dimx = plane->actual_proj_dimy;
     plane->actual_proj_dimy = temp;

     if (plane->plane_gravity_status & 1)
        {plane->plane_gravity_status &= ~1;
         plane->plane_gravity_status |= 2;}
       else 
        {plane->plane_gravity_status &= ~2;
         plane->plane_gravity_status |= 1;}

     plane->status &= ~PLANE_PLANE_GRAVITY_IDENTITY;
     PRT8(printf("GY_X_REFLECTION actual dimx = %d dimy = %d  proj dimx = %d  dimy = %d  %x\n",
             plane->actual_proj_dimx,plane->actual_proj_dimy,
             plane->proj_dimx,plane->proj_dimy,(unsigned int) plane->plane_gravity_status))
    }    
  else if (select & GYX_REFLECTION)
    {
     identity_3d_matrix(&ma1);
     ma1.buf[0][0] = 0;
     ma1.buf[1][1] = 0;
     ma1.buf[0][1] = 1;
     ma1.buf[1][0] = 1;

     if (plane->plane_gravity_status & 1)
        {plane->plane_gravity_status &= ~1;
         plane->plane_gravity_status |= 2;}
       else 
        {plane->plane_gravity_status &= ~2;
         plane->plane_gravity_status |= 1;}
     temp = plane->actual_proj_dimx;
     plane->actual_proj_dimx = plane->actual_proj_dimy;
     plane->actual_proj_dimy = temp;

     plane->status &= ~PLANE_PLANE_GRAVITY_IDENTITY;
     PRT8(printf("GYX_REFLECTION actual dimx = %d dimy = %d  proj dimx = %d  dimy = %d  %x\n",
             plane->actual_proj_dimx,plane->actual_proj_dimy,
             plane->proj_dimx,plane->proj_dimy,(unsigned int) plane->plane_gravity_status))
    }    

 if (select & GNO_REFLECTION)
    {
     inverse_4d_matrix(&(plane->plane_gravity),&(plane->plane_gravity));
     mult_3d_matrix(&(plane->xyztoplane),&(plane->plane_gravity),
             &(plane->xyztoplane));
     inverse_4d_matrix(&(plane->planetoxyz),&(plane->xyztoplane));

     identity_3d_matrix(&(plane->plane_gravity));
     plane->actual_proj_dimx = plane->proj_dimx;
     plane->actual_proj_dimy = plane->proj_dimy;
     plane->plane_gravity_status = 1;
     PRT8(printf("GNO_REFLECTION actual dimx = %d dimy = %d  proj dimx = %d  dimy = %d\n",
             plane->actual_proj_dimx,plane->actual_proj_dimy,
             plane->proj_dimx,plane->proj_dimy))
     plane->status |= PLANE_PLANE_GRAVITY_IDENTITY;}
   else
    {mult_3d_matrix(&(plane->plane_gravity),&ma1,&(plane->plane_gravity));
     mult_3d_matrix(&(plane->xyztoplane),&ma1,&(plane->xyztoplane));
     inverse_4d_matrix(&(plane->planetoxyz),&(plane->xyztoplane));
     PRT8(printf("ma1...\n");pr_3d_matrix(&ma1))
    }
 PRT8(printf("xyztoplane...\n");pr_3d_matrix(&(plane->xyztoplane)))
 PRT8(printf("planetoxyz...\n");pr_3d_matrix(&(plane->planetoxyz)))
 PRT8(printf("plane_gravity...\n");pr_3d_matrix(&(plane->plane_gravity)))

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
redefine_plane_orientation - ???
-------------------------------------------------------------------------*/

void
redefine_plane_orientation(plane,last_proj_dimx,last_proj_dimy)
 struct plane_3d_rec *plane;
 long last_proj_dimx,last_proj_dimy;
{
 TRACE(printf(".....redefine_plane_orientation....\n"))
 TRACE(pr_3d_matrix(&(plane->plane_gravity)))
 TRACE(printf("last_proj_dimx = %d last_proj_dimy = %d\n",last_proj_dimx,last_proj_dimy))
 TRACE(printf(" actual dimx = %d dimy = %d  proj dimx = %d  dimy = %d  %x\n",
             plane->actual_proj_dimx,plane->actual_proj_dimy,
             plane->proj_dimx,plane->proj_dimy,(unsigned int) plane->plane_gravity_status))

 if (plane->plane_gravity_status & 1)
    {plane->actual_proj_dimx = plane->proj_dimx;
     plane->actual_proj_dimy = plane->proj_dimy;}
   else
    {plane->actual_proj_dimx = plane->proj_dimy;
     plane->actual_proj_dimy = plane->proj_dimx;}

 if (plane->plane_gravity.buf[0][3] != .0)
    {if (plane->plane_gravity_status & 1)
        plane->plane_gravity.buf[0][3] = (float) (plane->proj_dimx - 1);
       else plane->plane_gravity.buf[0][3] = (float) (plane->proj_dimy - 1);
    }
 if (plane->plane_gravity.buf[1][3] != .0)
    {if (plane->plane_gravity_status & 1)
        plane->plane_gravity.buf[1][3] = (float) (plane->proj_dimy - 1);
       else plane->plane_gravity.buf[1][3] = (float) (plane->proj_dimx - 1);
    }
 TRACE(printf(".....new....\n"))
 TRACE(printf(" actual dimx = %d dimy = %d  proj dimx = %d  dimy = %d  %x\n",
             plane->actual_proj_dimx,plane->actual_proj_dimy,
             plane->proj_dimx,plane->proj_dimy,(unsigned int) plane->plane_gravity_status))
 TRACE(pr_3d_matrix(&(plane->plane_gravity)))

 plane->status |= PLANE_ACTUAL_PROJ_DIM_VALID;
 
(plane);
}


/*-------------------------------------------------------------------------
define_default_plane_orientation - ???
-------------------------------------------------------------------------*/

int
define_default_plane_orientation(plane)
 struct plane_3d_rec *plane;
{
 TRACE(printf("define_default_plane_orientation...\n"))
 identity_3d_matrix(&(plane->plane_gravity));
 plane->status |= PLANE_PLANE_GRAVITY_VALID | PLANE_PLANE_GRAVITY_IDENTITY;
 plane->actual_proj_dimx = plane->proj_dimx;
 plane->actual_proj_dimy = plane->proj_dimy;
 plane->plane_gravity_status = 1;
 plane->status |= PLANE_ACTUAL_PROJ_DIM_VALID;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
define_bound_vertices - ???
-------------------------------------------------------------------------*/

int
define_bound_vertices(plane,pts)
 struct plane_3d_rec *plane;
 struct vector_3d_rec pts[4];
{
 if ((plane->proj_dimx == 0) || (plane->proj_dimy == 0)) return CANCEL;
 TRACE(printf("plane_proj_corner_pts...proj_dimx = %d proj_dimy = %d\n",
      plane->proj_dimx,plane->proj_dimy))
 trans_3d_xyz(&(plane->planetoxyz),
          (float) plane->firstx,(float) plane->firsty,.0,
           &(pts[0].x),&(pts[0].y),&(pts[0].z),0);
 trans_3d_xyz(&(plane->planetoxyz),
         (float) plane->lastx,(float) plane->firsty,.0,
           &(pts[1].x),&(pts[1].y),&(pts[1].z),0);
 trans_3d_xyz(&(plane->planetoxyz),
          (float) plane->lastx,(float) plane->lasty,.0,
           &(pts[2].x),&(pts[2].y),&(pts[2].z),0);
 trans_3d_xyz(&(plane->planetoxyz),
          (float) plane->firstx,(float) plane->lasty,.0,
           &(pts[3].x),&(pts[3].y),&(pts[3].z),0);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
DefinePlaneDim - ???
-------------------------------------------------------------------------*/

void
DefinePlaneDim(plane)
 struct plane_3d_rec *plane;
{
 struct vector_3d_rec center;
 float halfx,halfy;

 TRACE(printf("DefinePlaneDim...\n"))
 trans_3d_xyz(&(plane->xyztoplane),
             plane->base.x,plane->base.y,plane->base.z,
             &(center.x),&(center.y),&(center.z),0);
 TRACE(printf("DefinePlaneDim  center..."))
 TRACE(pr_vector_3d_rec(&center))
 halfx = (float) plane->proj_buf_dimx / 2.0;
 halfy = (float) plane->proj_buf_dimy / 2.0;
 plane->firstx = (long) floor((double) (center.x - halfx));
 plane->firsty = (long) floor((double) (center.y - halfy));
 plane->lastx = plane->firstx + plane->proj_buf_dimx - 1;
 plane->lasty = plane->firsty + plane->proj_buf_dimy - 1;
 plane->proj_dimx = plane->lastx - plane->firstx + 1;
 plane->proj_dimy = plane->lasty - plane->firsty + 1;

/*
 printf(" Fx = %d Fy = %d Lx = %d Ly = %d\n",plane->firstx,plane->firsty,
           plane->lastx,plane->lasty);
 printf("  dimx = %d  dimy = %d  buf dimx = %d domy = %d\n",
     plane->proj_dimx,plane->proj_dimy,plane->proj_buf_dimx,plane->proj_buf_dimy);
*/
 plane->status |= PLANE_PROJ_DIM_VALID;    

}


/********************
plane_origin_index(plane)
 struct plane_3d_rec *plane;
{
 int select;

 if (plane->select_3d_gravity & 4) select = 2;
   else if (plane->select_3d_gravity & 2) select = 3;
   else if (plane->select_3d_gravity & 1) select = 1;
   else select = 0;
 if (plane->select_3d_gravity & 8) select += 4;
 return select;
}

set_plane_origin(plane,select_3d_origin_index)
 struct plane_3d_rec *plane;
 int select_3d_origin_index;
{
 static unsigned char sels[8] = {0,1,4,2,8,9,12,10};

 if ((select_3d_origin_index >= 0) && (select_3d_origin_index <= 7))
    {define_plane_3d_gravity(plane,
                  (unsigned int) sels[select_3d_origin_index]);
     return NO_ERROR;}
 return CANCEL;
}
*********************/

/************************
 assume that image starts at [0,0,0] located at the front top left corner
 select_3d_gravity == 0 ...[0,0,0] to top left corner...unchanged
 select_3d_gravity & 1 ...to front top right corner
 select_3d_gravity & 2 ...to front bottom right corner
 select_3d_gravity & 4 ...to front bottom left corner
 select_3d_gravity & 8 ...front to back
***************************/

/*************************
define_plane_3d_gravity(plane,select_3d_gravity)
 struct plane_3d_rec *plane;
 unsigned int select_3d_gravity;
{
 struct vector_3d_rec dire,base;

 identity_3d_matrix(&(plane->_3d_gravity));

 if (select_3d_gravity & 1)
    {
     assign_translation(&(plane->_3d_gravity),plane->center.x,.0,.0);
     plane->_3d_gravity.buf[0][0] = -1;
     translate_3d_matrix(&(plane->_3d_gravity),plane->center.x,.0,.0);
    }
   else if (select_3d_gravity & 2)
    {
     setup_vector_3d_rec(&base,plane->center.x,plane->center.y,.0);
     setup_vector_3d_rec(&dire,.0,.0,1.0);
     rotate_3d_matrix_from_axis(&(plane->_3d_gravity),&base,&dire,RADIAN);
    }
   else if (select_3d_gravity & 4)
    {
     assign_translation(&(plane->_3d_gravity),.0,plane->center.y,.0);
     plane->_3d_gravity.buf[1][1] = -1;
     translate_3d_matrix(&(plane->_3d_gravity),.0,plane->center.y,.0);
    }
 if (select_3d_gravity & 8)
    {
     assign_translation(&(plane->_3d_gravity),.0,.0,plane->center.z);
     plane->_3d_gravity.buf[2][2] = -1;
     translate_3d_matrix(&(plane->_3d_gravity),.0,.0,plane->center.z);
    }
 plane->select_3d_gravity = select_3d_gravity;
 plane->status |= PLANE_3D_GRAVITY_VALID;
}
****************************/


/*-------------------------------------------------------------------------
DefinePlaneTransformation - ???
-------------------------------------------------------------------------*/

int
DefinePlaneTransformation(plane)
 struct plane_3d_rec *plane;
{
 double max;
 float x,y;
 int iden;

 iden = 1;
 /*printf("DefinePlaneTransformation plane->rotate.z = %f\n",
          plane->rotate.z);*/

 if (plane->rotate.z != 0.0)
    {
     max = plane->actual_proj_dimx * plane->actual_proj_dimx +
               plane->actual_proj_dimy * plane->actual_proj_dimy;
     max = sqrt(max);
     plane->trans_proj_dimx = (long) rint(max);
     plane->trans_proj_dimy = plane->trans_proj_dimx;
     if (plane->trans_proj_dimx > plane->proj_buf_dimx)
        plane->trans_proj_dimx = plane->proj_buf_dimx;
     if (plane->trans_proj_dimy > plane->proj_buf_dimy)
        plane->trans_proj_dimy = plane->proj_buf_dimy;
     setup_translate_3d_matrix(&(plane->trans),
                  -((float) plane->actual_proj_dimx - 1.0) / 2.0,
                  -((float) plane->actual_proj_dimy - 1.0) / 2.0,.0);
     Rotate3dMatrix(&(plane->trans),plane->rotate.z);
     translate_3d_matrix(&(plane->trans),
                 ((float) plane->actual_proj_dimx - 1.0) / 2.0,
                 ((float) plane->actual_proj_dimy - 1.0) / 2.0,.0);

     x = ((float) plane->trans_proj_dimx - (float) plane->actual_proj_dimx) / 2.0;
     y = ((float) plane->trans_proj_dimy - (float) plane->actual_proj_dimy) / 2.0;
     translate_3d_matrix(&(plane->trans),x,y,.0);

 TRACE(printf("===buf_dimx = %d dimy = %d  trans_dimx = %d dimy = %d actual_dimx = %d    dimy = %d\n",
        plane->proj_buf_dimx,plane->proj_buf_dimx,
        plane->trans_proj_dimx,plane->trans_proj_dimy,plane->actual_proj_dimx,
        plane->actual_proj_dimy))
     iden = 0;
    }
   else
    {

     plane->trans_proj_dimx = plane->actual_proj_dimx;
     plane->trans_proj_dimy = plane->actual_proj_dimy;
     identity_3d_matrix(&(plane->trans));

    }

 plane->status |= PLANE_TRANS_PROJ_DIM_VALID;

 if ((plane->translate.x != .0) || (plane->translate.y != .0))
    {iden = 0;
     translate_3d_matrix(&(plane->trans),plane->translate.x,
                     plane->translate.y,.0);}

 if ((plane->scale.x != 1.0) || (plane->scale.y != 1.0))
    {iden = 0;
     scale_3d_matrix(&(plane->trans),plane->scale.x,plane->scale.y,1.0);}
/*
 if (!(plane->status & PLANE_PLANE_GRAVITY_IDENTITY))
    {iden = 0;
     mult_3d_matrix(&(plane->trans),&(plane->trans),&(plane->plane_gravity));}
*/
 if (iden) plane->status |= PLANE_TRANS_IDENTITY;
   else plane->status &= ~PLANE_TRANS_IDENTITY;
 plane->status |= PLANE_TRANS_VALID;
 TRACE(printf("DefinePlaneTransformation...\n"))
 TRACE(pr_3d_matrix(&(plane->trans)))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
set_plane_orientation - ???
-------------------------------------------------------------------------*/

void
set_plane_orientation(plane,select)
 struct plane_3d_rec *plane;
 int select;
{
 define_plane_orientation(plane,select);
 DefinePlaneTransformation(plane);
}


/*-------------------------------------------------------------------------
define_obl_matrix - ???
-------------------------------------------------------------------------*/

void
define_obl_matrix(plane,obl_deg,obj_proj_deg)
  struct plane_3d_rec *plane;
 float obl_deg,obj_proj_deg;
{
 float l1;

 plane->obl_deg = obl_deg;
 plane->obj_proj_deg = obj_proj_deg;
 identity_3d_matrix(&(plane->obl));
 if (obl_deg != 90.0)
    {l1 = 1.0 / (float) tan(radian(obl_deg));
     TRACE(printf("define_obl_matrix l1 = %f\n",l1))
     plane->obl.buf[2][0] = l1 * (float) cos(radian(obj_proj_deg));
     plane->obl.buf[2][1] = l1 * (float) sin(radian(obj_proj_deg));

     inverse_4d_matrix(&(plane->obl_proj),&(plane->obl));

    }
   else identity_3d_matrix(&(plane->obl_proj));
 TRACE(printf("define_obl_matrix obl_deg = %f  obl_proj_deg = %f\n",
         plane->obl_deg,plane->obj_proj_deg))
 TRACE(printf("...obl   obl_proj...\n"))
 TRACE(pr_3d_matrix(&(plane->obl)))
 TRACE(pr_3d_matrix(&(plane->obl_proj)))
}


/***********************
base_as_plane_center(plane)
 struct plane_3d_rec *plane;
{
 struct vector_3d_rec and_pt;
 float line_move_unit_ratio;
 int is_and_status;

 PlaneAndLineIntersection(&(plane->base),&(plane->normal_cosine),
           &(plane->center),&(plane->normal_cosine),
           &and_pt,&line_move_unit_ratio,&is_and_status);
 plane->base = and_pt;
}

check_params(plane)
 struct plane_3d_rec *plane;
{
 struct vector_3d_rec v;
 int lcv;

 printf("\ncheck_params base...");pr_vector_3d_rec(&(plane->base));
 printf("check_params norm...");pr_vector_3d_rec(&(plane->normal_cosine));
 printf("....%s\n",get_vector_angle_str(&(plane->normal_cosine)));
 printf("ratio...");pr_vector_3d_rec(&(plane->coord_ratio));
 printf("plane_max_vector...");pr_vector_3d_rec(&(plane->plane_max_vector));
 printf("plane_0_vector...");pr_vector_3d_rec(&(plane->plane_0_vector));
 printf("Firstx = %d lastx = %d  firsty = %d  lasty = %d\n",
    plane->firstx,plane->lasty,plane->firsty,plane->lasty);
 printf("proj...\n");pr_3d_matrix(&(plane->proj));
 printf("plane gravity...\n");
 pr_3d_matrix(&(plane->plane_gravity));
 printf("tran...\n");
 pr_3d_matrix(&(plane->trans));
 for (lcv = 0; lcv < 4; lcv++)
    {printf("%d)..",lcv);pr_vector_3d_rec(&(plane->bound_vertices[lcv]));}
 sub_vectors(&v,&(plane->plane_max_vector),&(plane->plane_0_vector));
 direction_cosine_vector(&v);
 printf("check_params dir...");pr_vector_3d_rec(&v);
 sub_vectors(&v,&(plane->plane_max_vector),&(plane->base));
 direction_cosine_vector(&v);
 printf("max - base...");pr_vector_3d_rec(&v);
 printf("pr_dimx = %d pr_dimy = %d\n",plane->proj_dimx,plane->proj_dimy);
 printf("\n");
}
********************/


/*-------------------------------------------------------------------------
DefinePlaneAttrs - ???
-------------------------------------------------------------------------*/

void
DefinePlaneAttrs(base,normal_cosine,
            startx,endx,starty,endy,startz,endz,tot_planes,plane_num,
            plane_0_vector,plane_max_vector)
 struct vector_3d_rec *base,*normal_cosine;
 float startx,endx,starty,endy,startz,endz;
 long *tot_planes,*plane_num;
 struct vector_3d_rec *plane_0_vector,*plane_max_vector;
{
 float len;

 PRT5(printf("DefinePlaneAttrs base...\n");pr_vector_3d_rec(base);)
 PRT5(printf("normal_cosine =...");pr_vector_3d_rec(normal_cosine);)
 PRT5(printf("plane_0_vector = %d\n");pr_vector_3d_rec(plane_0_vector);)
 PRT5(printf("plane_max_vector = %d\n");pr_vector_3d_rec(plane_max_vector);)
 max_normal_extents(base,normal_cosine,
                   startx,endx,starty,endy,
                   startz,endz,plane_0_vector,plane_max_vector);
 PRT5(printf("after max 0_vector = %d\n");pr_vector_3d_rec(plane_0_vector);)
 PRT5(printf("plane_max_vector = %d\n");pr_vector_3d_rec(plane_max_vector);)
 len = vector_distance(base,plane_0_vector);
 len = (float) floor((double) len);
 *plane_num = (long) len;
 setup_vector_3d_rec(plane_0_vector,base->x - len * normal_cosine->x,
      base->y - len * normal_cosine->y,
      base->z - len * normal_cosine->z);
 *tot_planes = (long) len + 1;
 len = vector_distance(base,plane_max_vector);
 len = (float) rint((double) len);
 setup_vector_3d_rec(plane_max_vector,base->x + len * normal_cosine->x,
      base->y + len * normal_cosine->y,
      base->z + len * normal_cosine->z);
 *tot_planes += (long) len;

 PRT5(printf("\n...0_vector....plane_max_vector...v1\n");
    pr_vector_3d_rec(plane_0_vector);
    pr_vector_3d_rec(plane_max_vector);
    len = vector_distance(plane_max_vector,plane_0_vector);
    printf("*tot_planes = %d  *plane_num = %d  plane_len = %f\n\n",
           *tot_planes, *plane_num,len);)

}


/*-------------------------------------------------------------------------
PlaneAttrs - ???
-------------------------------------------------------------------------*/

void
PlaneAttrs(base,center,normal_cosine,
            startx,endx,starty,endy,startz,endz,tot_planes,plane_num,
            plane_0_vector,plane_max_vector,is_adjust_to_center)
 struct vector_3d_rec *base,*center,*normal_cosine;
 float startx,endx,starty,endy,startz,endz;
 long *tot_planes,*plane_num;
 struct vector_3d_rec *plane_0_vector,*plane_max_vector;
 int is_adjust_to_center;
{
 float line_move_unit_ratio;
 int is_and_status;

 PRT4(printf("PlaneAttrs is_adjust = %d...\n",is_adjust_to_center);)
 if (is_adjust_to_center)
    {PRT7(printf("is_adjust_to_center...");pr_vector_3d_rec(center);)
     PRT7(printf("base...");pr_vector_3d_rec(base);)
     PRT7(printf("normal_cosine...");pr_vector_3d_rec(normal_cosine);)
     PlaneAndLineIntersection(base,normal_cosine,center,normal_cosine,
           base,&line_move_unit_ratio,&is_and_status);
    }
 DefinePlaneAttrs(base,normal_cosine,
            startx,endx,starty,endy,startz,endz,tot_planes,plane_num,
            plane_0_vector,plane_max_vector);
}


/*-------------------------------------------------------------------------
define_plane_trans - ???
-------------------------------------------------------------------------*/

void
define_plane_trans(plane,is_init_plane_trans)
 struct plane_3d_rec *plane;
 int is_init_plane_trans;
{
 int is_plane_trans;

 if (!(plane->status & PLANE_TRANS_USED) || is_init_plane_trans)
    identity_3d_matrix(&(plane->plane_trans));
 plane->status &= ~PLANE_TRANS_USED;

 DefPlaneOrientation(&(plane->xyztoplane),&(plane->planetoxyz),
                &(plane->plane_trans),&(plane->base),
                &(plane->normal_cosine),&is_plane_trans);
 if (is_plane_trans) plane->status |= PLANE_TRANS_USED;
}


/*-------------------------------------------------------------------------
DefPlaneRotation - ???
-------------------------------------------------------------------------*/

void
DefPlaneRotation(plane)
 struct plane_3d_rec *plane;
{
 struct vector_3d_rec dire,dire1,pt;

 PRT6(printf("DefPlaneRotation \n");
     printf("base...");pr_vector_3d_rec(&(plane->base));
     printf("normal...");pr_vector_3d_rec(&(plane->normal_cosine));
     printf("nor = %s\n",get_vector_angle_str1(&(plane->normal_cosine)));)
/*
 cuboid_edges(vertices,
             plane->local_start.x,plane->local_end.x,
             plane->local_start.y,plane->local_end.y,
             plane->local_start.z,plane->local_end.z);
 for (num_ands = 0,lcv = 0; lcv < 24; lcv += 2)
    {sub_vectors(&dire,&(vertices[lcv + 1]),&(vertices[lcv]));
     printf("v%d...",lcv);pr_vector_3d_rec(&(vertices[lcv]));
     printf("v%d...",lcv+1);pr_vector_3d_rec(&(vertices[lcv+1]));
     PlaneAndLineIntersection(&(plane->base),&(plane->normal_cosine),
           &(vertices[lcv]),&dire,
           &(ands[num_ands]),&line_move_unit_ratio,&is_and_status);
     if (is_and_status != NO_INTERSECTION)
        {printf("%d) &...",num_ands);pr_vector_3d_rec(&(ands[num_ands]));
         trans_3d_pt(&(plane->xyztoplane),&(ands[num_ands]),&(pands[num_ands]),0);
         num_ands += 1;
        }
    }

 PRT6(printf("DefPlaneRotation num_ands = %d\n",num_ands));
 for (lcv = 0; lcv < num_ands; lcv++)
    {sub_vectors(&dire,&(ands[lcv]),&(plane->base));
     setup_vector_3d_rec(&dire1,1.0,.0,.0);
     deg = degree_angle_vectors(&dire,&dire1);

     deg1 = degree_angle_vectors(&(pands[lcv]),&dire1);
     printf("%d) deg = %f  deg1 = %f\n",lcv,deg,deg1);

     printf("ands...");pr_vector_3d_rec(&(ands[lcv]));
     printf("pands...");pr_vector_3d_rec(&(pands[lcv]));
     printf("\n");
    }
 printf("\n");
*/
 setup_vector_3d_rec(&dire1,0.0,1.0,.0);
 trans_3d_pt(&(plane->planetoxyz),&dire1,&pt,0);
 PRT6(printf("[0,1]...");pr_vector_3d_rec(&pt);)
 sub_vectors(&dire,&pt,&(plane->base));
 direction_cosine_vector(&dire);
 PRT6(printf("dire...");pr_vector_3d_rec(&dire);
      printf("ang = %s\n",get_vector_angle_str1(&dire));)
}


/*-------------------------------------------------------------------------
PtNormalPlane - ???
-------------------------------------------------------------------------*/

int
PtNormalPlane(plane,x,y,z,normalx,normaly,normalz,
              startx,endx,starty,endy,startz,endz,
              buf_dimx,buf_dimy,
              translate,scale,rotate,center,obl_deg,obj_proj_deg,
              xratio,yratio,zratio,global_matrix,is_def_trans,
              is_adjust_to_center,is_approx_value)
 struct plane_3d_rec *plane;
 float x,y,z,normalx,normaly,normalz;
 float startx,endx,starty,endy,startz,endz;
 long buf_dimx,buf_dimy;
 struct vector_3d_rec *translate,*scale,*rotate,*center;
 float obl_deg,obj_proj_deg,xratio,yratio,zratio;
 struct matrix_3d_rec *global_matrix;
 int is_def_trans,is_adjust_to_center;
 unsigned long is_approx_value;
{
 plane->status = 0;
 plane->more_status = 0;
 plane->status |= PLANE_BASE_VALID;
 if (is_approx_value) plane->status |= PLANE_APPROX_VALUE;
 setup_vector_3d_rec(&(plane->global_start),startx,starty,startz);
 setup_vector_3d_rec(&(plane->global_end),endx,endy,endz);
 startx /= xratio;
 starty /= yratio;
 startz /= zratio;
 endx /= xratio;
 endy /= yratio;
 endz /= zratio;
 setup_vector_3d_rec(&(plane->local_start),startx,starty,startz);
 setup_vector_3d_rec(&(plane->local_end),endx,endy,endz);
 if (center == NULL)
    {plane->status |= PLANE_CENTER_DEFAULT;
     setup_vector_3d_rec(&(plane->center),(startx + endx) / 2.0,
             (starty + endy) / 2.0,(startz + endz) / 2.0);}
   else plane->center = *center;

 plane->status |= PLANE_PROJ_BUF_DIM_VALID | PLANE_BOUNDED;
 plane->proj_buf_dimx = buf_dimx;
 plane->proj_buf_dimy = buf_dimx;
 if (rotate != NULL) plane->rotate = *rotate;
   else setup_vector_3d_rec(&(plane->rotate),.0,.0,.0);
 if (scale != NULL) plane->scale = *scale;
   else setup_vector_3d_rec(&(plane->scale),1.0,1.0,1.0);
 if (translate != NULL) plane->translate = *translate;
   else setup_vector_3d_rec(&(plane->translate),.0,.0,.0);
 plane->status |= PLANE_TRANSLATE_VALID |
                  PLANE_SCALE_VALID | PLANE_ROTATE_VALID;

 setup_vector_3d_rec(&(plane->actual_base),x,y,z);
 setup_vector_3d_rec(&(plane->normal),normalx,normaly,normalz);
 plane->status |= PLANE_FROM_PT_NORMAL | PLANE_P1_VALID;
 plane->normal.status |= get_vector_plane_type(&(plane->normal));

 plane->normal_cosine = plane->normal;
 direction_cosine_vector(&(plane->normal_cosine));
 setup_vector_3d_rec(&(plane->coord_ratio),xratio,yratio,zratio);

 if (global_matrix != NULL) plane->global = *global_matrix;
   else identity_3d_matrix(&(plane->global));
 plane->base = plane->actual_base;
 if (is_adjust_to_center) plane->status |= PLANE_ADJUST_TO_CENTER;
 PlaneAttrs(&(plane->base),&(plane->center),&(plane->normal_cosine),
             plane->local_start.x,plane->local_end.x,
             plane->local_start.y,plane->local_end.y,
             plane->local_start.z,plane->local_end.z,
             &(plane->total_planes),&(plane->plane_num),
             &(plane->plane_0_vector),
             &(plane->plane_max_vector),is_adjust_to_center);

 PlaneCoordMatrix(&(plane->xyztoplane),&(plane->planetoxyz),
                    &(plane->base),&(plane->normal_cosine),0.0);
 define_plane_trans(plane,1);


 PRT3(printf("start...");pr_vector_3d_rec(&(plane->local_start));
      printf("local_end...");pr_vector_3d_rec(&(plane->local_end));)
/*
 if (is_def_trans)
    define_plane_trans(plane,1);
   else identity_3d_matrix(&(plane->plane_trans));
*/
 mult_3d_matrix(&(plane->planetoxyz),&(plane->global),&(plane->planetoxyz));
 inverse_4d_matrix(&(plane->xyztoplane),&(plane->planetoxyz));
 calc_plane_const(plane);
 define_obl_matrix(plane,obl_deg,obj_proj_deg);

 DefinePlaneDim(plane);
 define_bound_vertices(plane,plane->bound_vertices);
 plane->status |= PLANE_BOUND_VERTICES_COMPUTED;    
 plane->status |= PLANE_PLANE_PROJ_VALID;

 define_default_plane_orientation(plane);
 DefinePlaneTransformation(plane);
/*
 if ((rotate == NULL) || (rotate->z == .0))
    DefPlaneRotation(plane);
*/
 TRACE(printf("pt_normal_plane plane_num = %d\n",plane->plane_num))
 plane->more_status |= PLANE_M_PARAMS_COMPUTED;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
ChangePlane - ???

sel_adjust_to_center = 0 ...use current default
sel_adjust_to_center = 1 ...adjust to center
sel_adjust_to_center = 2 ...don't adjust to center
-------------------------------------------------------------------------*/

int
ChangePlane(plane,x,y,z,normalx,normaly,normalz,center,rotate,
            sel_adjust_to_center,xyztoplane)
 struct plane_3d_rec *plane;
 float x,y,z,normalx,normaly,normalz;
 struct vector_3d_rec *center,*rotate;
 int sel_adjust_to_center;
 struct matrix_3d_rec *xyztoplane;
{
 PRT4(printf("ChangePlane sel_adjust_to_center = %d...\n",sel_adjust_to_center);)
 if (center != NULL) plane->center = *center;
 if (rotate != NULL) plane->rotate = *rotate;
 if (sel_adjust_to_center)
    {if (sel_adjust_to_center == 1) plane->status |= PLANE_ADJUST_TO_CENTER;
       else plane->status &= ~PLANE_ADJUST_TO_CENTER;
    }
   else if (plane->more_status & PLANE_ADJUST_TO_CENTER_DURING_NEXT_CHANGE)
    {plane->status |= PLANE_ADJUST_TO_CENTER;
     plane->more_status &= ~PLANE_ADJUST_TO_CENTER_DURING_NEXT_CHANGE;
    }
 setup_vector_3d_rec(&(plane->actual_base),x,y,z);
 setup_vector_3d_rec(&(plane->normal),normalx,normaly,normalz);
 plane->normal.status |= get_vector_plane_type(&(plane->normal));
 plane->normal_cosine = plane->normal;
 direction_cosine_vector(&(plane->normal_cosine));
 plane->base = plane->actual_base;
 PlaneAttrs(&(plane->base),&(plane->center),&(plane->normal_cosine),
             plane->local_start.x,plane->local_end.x,
             plane->local_start.y,plane->local_end.y,
             plane->local_start.z,plane->local_end.z,
             &(plane->total_planes),&(plane->plane_num),
             &(plane->plane_0_vector),&(plane->plane_max_vector),
             (int) (plane->status & PLANE_ADJUST_TO_CENTER));
 if (xyztoplane == NULL)
    {PlaneCoordMatrix(&(plane->xyztoplane),&(plane->planetoxyz),
                    &(plane->base),&(plane->normal_cosine),0.0);
     define_plane_trans(plane,1);}
   else
    {PRT7(printf("use predefine xyztoplane\n");
          pr_3d_matrix(xyztoplane))
     inverse_4d_matrix(&(plane->planetoxyz),xyztoplane);
    }

 mult_3d_matrix(&(plane->planetoxyz),&(plane->global),&(plane->planetoxyz));
 inverse_4d_matrix(&(plane->xyztoplane),&(plane->planetoxyz));

 define_bound_vertices(plane,plane->bound_vertices);
 plane->status |= PLANE_BOUND_VERTICES_COMPUTED;    
 define_default_plane_orientation(plane);
 DefinePlaneTransformation(plane);
/*
 if ((rotate == NULL) || (rotate->z == .0))
    DefPlaneRotation(plane);
*/
 TRACE(printf("pt_normal_plane plane_num = %d\n",plane->plane_num))
 plane->more_status |= PLANE_M_PARAMS_COMPUTED;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
is_same_plane - ???
-------------------------------------------------------------------------*/

int
is_same_plane(gplane1,gplane2)
 struct plane_3d_rec *gplane1,*gplane2;
{
 if (same_3d_pt(&(gplane1->actual_base),&(gplane2->actual_base)) &&
     same_3d_pt(&(gplane1->normal_cosine),&(gplane2->normal_cosine)) &&
     same_3d_pt(&(gplane1->center),&(gplane2->center)) &&
     same_3d_pt(&(gplane1->rotate),&(gplane2->rotate)) &&
     is_same_matrix_3d_rec(&(gplane1->xyztoplane),&(gplane2->xyztoplane)))
    return 1;
 return 0;
/*
 if (!same_3d_pt(&(gplane1->actual_base),&(gplane2->actual_base)))
    {printf("actual_base not same\n");
     pr_vector_3d_rec(&(gplane1->actual_base));
     pr_vector_3d_rec(&(gplane2->actual_base));
     return 0;}
 if (!same_3d_pt(&(gplane1->normal_cosine),&(gplane2->normal_cosine)))
    {printf("normal_cosine not same\n");
     pr_vector_3d_rec(&(gplane1->normal_cosine));
     pr_vector_3d_rec(&(gplane2->normal_cosine));
     return 0;}
 if (!same_3d_pt(&(gplane1->center),&(gplane2->center)))
    {printf("center not same\n");
     pr_vector_3d_rec(&(gplane1->center));
     pr_vector_3d_rec(&(gplane2->center));
     return 0;}
 if (!same_3d_pt(&(gplane1->rotate),&(gplane2->rotate)))
    {printf("rotate not same\n");
     pr_vector_3d_rec(&(gplane1->rotate));
     pr_vector_3d_rec(&(gplane2->rotate));
     return 0;}
 if (!is_same_matrix_3d_rec(&(gplane1->xyztoplane),&(gplane2->xyztoplane)))
    {printf("is_same_matrix_3d_rec not same\n");
     pr_3d_matrix(&(gplane1->xyztoplane));
     pr_3d_matrix(&(gplane2->xyztoplane));
     return 0;}
 return 1;
*/

}


/*-------------------------------------------------------------------------
adjust_to_center - ???

 adjust == 0 then if adjusted before, set flag to no else set flag to yes
 adjust == 1, it must be adjusted to the center
 adjust == 2, set flag to no
-------------------------------------------------------------------------*/

int
adjust_to_center(plane,adjust)
 struct plane_3d_rec *plane;
 int adjust;
{
 struct vector_3d_rec base;
 struct vector_3d_rec diff;
 float line_move_unit_ratio;
 int is_and_status;

 PRT3(printf("adjust_to_center...1\n"))
 if (adjust == 0)
    {if (plane->status & PLANE_ADJUST_TO_CENTER)
        {plane->status &= ~PLANE_ADJUST_TO_CENTER;
         return 0;}
    }
   else if (adjust == 1)
    {if (plane->status & PLANE_ADJUST_TO_CENTER) return 0;
    }
   else
    {plane->status &= ~PLANE_ADJUST_TO_CENTER;
     return 0;}

 PRT3(printf("adjust_to_center...2\n"))
 plane->status |= PLANE_ADJUST_TO_CENTER;
 PlaneAndLineIntersection(&(plane->base),&(plane->normal_cosine),
      &(plane->center),&(plane->normal_cosine),
      &base,&line_move_unit_ratio,&is_and_status);
 if (same_3d_pt(&(plane->base),&base)) return 0;
 PRT3(printf("adjust_to_center...update\n"))
 plane->actual_base = plane->base;
 plane->base = base;
 DefinePlaneAttrs(&(plane->base),&(plane->normal_cosine),
             plane->local_start.x,plane->local_end.x,
             plane->local_start.y,plane->local_end.y,
             plane->local_start.z,plane->local_end.z,
             &(plane->total_planes),&(plane->plane_num),
            &(plane->plane_0_vector),&(plane->plane_max_vector));
 sub_vectors(&diff,&base,&(plane->base));
 translate_3d_matrix(&(plane->planetoxyz),diff.x,
           diff.y,diff.z);
 inverse_4d_matrix(&(plane->xyztoplane),&(plane->planetoxyz));
 calc_plane_const(plane);
 define_bound_vertices(plane,plane->bound_vertices);
 return 1;
}
