/****************************************************************************
plane_opr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: plane_opr.c,v 1.6 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <sys/types.h>
#include <math.h>

#include "geometry.h"
#include "buf_3d_rec.h"
#include "error_constants.h"
#include "nria_lib.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x)
#define PRT6(x) x; fflush(stdout);
#define PRT6(x)
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
#define PRT12(x) x; fflush(stdout);
#define PRT13(x) x; fflush(stdout);
#define PRT14(x) x; fflush(stdout);
#define PRT11(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRINT(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT13(x)
#define PRT14(x)

#define PRT6(x)
#define PRT7(x)
#define PRT8(x)
#define PRT10(x)
#define PRT12(x)
#define PRT9(x)
#define PRT11(x)



float degree_angle_vectors();
float vector_distance();
double degree();
double radian();
float length_vector();
float pt_line_dist();
float vector_dot_product();
double acos_to_degree();
double float_precision();
float vector_distance_from_abs();
char *get_vector_angle_str();



/*------------------------------------------------------------------------
DistOfPtFromPlane - ???
------------------------------------------------------------------------*/

float 
DistOfPtFromPlane(base,normal,pt,sign)
 struct vector_3d_rec *base,*normal,*pt;
 int *sign;
{
 float constk,dot;
/*
 printf("DistOfPtFromPlane...\n");
 printf("base...");pr_vector_3d_rec(base);
 printf("normal...");pr_vector_3d_rec(normal);
 printf("pt...");pr_vector_3d_rec(pt);
*/
 constk = normal->x * base->x + normal->y * base->y + normal->z * base->z;
 dot = vector_dot_product(normal,pt);
/*
 printf("constk = %f dot = %f total = %f\n\n",constk,dot);
*/
 dot -= constk;
 if (dot < 0) 
    {dot = -dot;
     *sign = -1;}
   else *sign = 1;

 return dot;
}


/*------------------------------------------------------------------------
max_plane_dims - ???
------------------------------------------------------------------------*/

long 
max_plane_dims(plane)
 struct plane_3d_rec *plane;
{
 float dim,dim1;

 dim = plane->local_end.x - plane->local_start.x + 1;
 dim1 = plane->local_end.y - plane->local_start.y + 1;
 if (dim < dim1) dim = dim1;
 dim1 = plane->local_end.z - plane->local_start.z + 1;
 if (dim < dim1) dim = dim1;
 return (long) rint((double) dim) + 1;
}


/*------------------------------------------------------------------------
set_plane_move_params - ???
------------------------------------------------------------------------*/

void
set_plane_move_params(plane,x,y)
 struct plane_3d_rec *plane;
 float x,y;
{
 plane->translate.x = x;
 plane->translate.y = y;
 DefinePlaneTransformation(plane);
}

/******************
pr_neg_plane_coord(matrix,coord_ratio,dimx,dimy,dimz)
 struct matrix_3d_rec *matrix;
 struct vector_3d_rec *coord_ratio;
 unsigned long dimx,dimy,dimz;
{
 long x,y;
 float newx,newy,newz;

 printf("\n\n");
 for (y = 0; y < dimy; y++)
    {printf("row=%d   ",-y);
     for (x = 0; x < dimx; x++)
        {trans_3d_xyz(matrix,
            (float) -x,(float) -y,.0,&newx,&newy,&newz,1);
         printf("%d) [%3.1f,%3.1f,%3.1f]  ",-x,newx,newy,newz);
        }
     printf("\n");
    }
 printf("\n\n");
}
***************/


/*------------------------------------------------------------------------
pr_plane_corner_pts - ???
------------------------------------------------------------------------*/

void
pr_plane_corner_pts(plane)
 struct plane_3d_rec *plane;
{
 struct vector_3d_rec pts[4];
 int lcv;

 define_bound_vertices(plane,pts);
 printf("pr_plane_corner_pts ....dimx = %ld   dimy = %ld\n",plane->proj_dimx,
               plane->proj_dimy);
 for (lcv = 0; lcv < 4; lcv++)
    {printf("%d) ",lcv);
     pr_vector_3d_rec(&(pts[lcv]));
    }
 printf("pr_plane_corner_pts ....end\n");

}


/*------------------------------------------------------------------------
pr_plane_3d_rec - ???
------------------------------------------------------------------------*/

void
pr_plane_3d_rec(plane)
 struct plane_3d_rec *plane;
{

 printf("plane_3d_rec  = %p  status = %lx\n",plane,plane->status);
 printf("   normal...\n");
 pr_vector_3d_rec(&(plane->normal));
 printf("   normal_cosine...\n");
 pr_vector_3d_rec(&(plane->normal_cosine));
 if (plane->status & PLANE_COORD_RATIO_VALID)
    {printf("   coord ratio...\n");
     pr_vector_3d_rec(&(plane->coord_ratio));}
 if (plane->status & PLANE_BASE_VALID)
    {printf("   base...\n");
     pr_vector_3d_rec(&(plane->base));}

 if (plane->status & PLANE_P1_VALID)
    {printf("   actual_base...\n");
     pr_vector_3d_rec(&(plane->actual_base));}
 if (plane->status & PLANE_P2_VALID)
    {printf("   p2...\n");
     pr_vector_3d_rec(&(plane->p2));}
 if (plane->status & PLANE_P3_VALID)
    {printf("   p3...\n");
     pr_vector_3d_rec(&(plane->p3));}

 if (plane->status & PLANE_TRANSLATE_VALID)
    {printf("   PLANE_TRANSLATE_VALID...\n");
     pr_vector_3d_rec(&(plane->translate));}
 if (plane->status & PLANE_SCALE_VALID)
    {printf("   PLANE_SCALE_VALID...\n");
     pr_vector_3d_rec(&(plane->scale));}
 if (plane->status & PLANE_ROTATE_VALID)
    {printf("   PLANE_ROTATE_VALID...\n");
     pr_vector_3d_rec(&(plane->rotate));}
 printf("\n");

 if (plane->status & PLANE_BOUNDED)
    {printf("   start...\n");
     pr_vector_3d_rec(&(plane->local_start));
     printf("   end...\n");
     pr_vector_3d_rec(&(plane->local_end));
     printf("\n");
    }
 if (plane->status & PLANE_BOUND_VERTICES_COMPUTED)
    {printf("   bound ver[0]...\n");
     pr_vector_3d_rec(&(plane->bound_vertices[0]));
     printf("   bound ver[1]...\n");
     pr_vector_3d_rec(&(plane->bound_vertices[1]));
     printf("   bound ver[2]...\n");
     pr_vector_3d_rec(&(plane->bound_vertices[2]));
     printf("   bound ver[3]...\n");
     pr_vector_3d_rec(&(plane->bound_vertices[3]));
     printf("\n");
    }
 if (plane->status & PLANE_CONST_COMPUTED)
    printf("   constk = %f...",plane->constk);

 if (plane->status & PLANE_PROJ_DIM_VALID)
    {printf("firstx = %ld   lastx = %ld  firsty = %ld   lasty = %ld",
          plane->firstx,plane->lastx,plane->firsty,plane->lasty);
     printf("proj_dimx = %ld   proj_dimy = %ld...",
          plane->proj_dimx,plane->proj_dimy);}
 if (plane->status & PLANE_ACTUAL_PROJ_DIM_VALID)
    printf("actual dimx = %ld   actual dimy = %ld...",
          plane->actual_proj_dimx,plane->actual_proj_dimy);
 printf("\n");
 if (plane->status & PLANE_TRANS_PROJ_DIM_VALID)
    printf("trans_proj_dimx = %ld   trans_proj_dimy = %ld...\n",
          plane->trans_proj_dimx,plane->trans_proj_dimy);
 if (plane->status & PLANE_PROJ_BUF_DIM_VALID)
    printf("proj_buf_dimx = %ld   proj_buf_dimy = %ld\n",
          plane->proj_buf_dimx,plane->proj_buf_dimy);
 if (plane->status & PLANE_ACTUAL_VALID)
    {printf("PLANE_ACTUAL_VALID\n");
     pr_3d_matrix(&(plane->xyztoplane));}
 if (plane->status & PLANE_TRANS_USED)
    {printf("PLANE_PROJ_VALID\n");
     pr_3d_matrix(&(plane->plane_trans));}

 if (plane->status & PLANE_PLANE_PROJ_VALID)
    {printf("PLANE_PLANE_PROJ_VALID\n");
     pr_3d_matrix(&(plane->planetoxyz));}
 if (plane->status & PLANE_PLANE_GRAVITY_VALID)
    {printf("PLANE_PLANE_GRAVITY_VALID\n");
     pr_3d_matrix(&(plane->plane_gravity));}
 if (plane->status & PLANE_TRANS_VALID)
    {printf("PLANE_TRANS_VALID\n");
     pr_3d_matrix(&(plane->trans));}

 printf("plane_3d_rec...end\n");

}


/*------------------------------------------------------------------------
RdPlaneParams - ???
------------------------------------------------------------------------*/

int
RdPlaneParams(fid,base,normal,center,coord_ratio,rotate,which_format,adjust_to_center,
              xyztoplane)
 FILE *fid;
 struct vector_3d_rec *base,*normal,*center,*coord_ratio,*rotate;
 int *which_format;
 unsigned long *adjust_to_center;
 struct matrix_3d_rec *xyztoplane;
{
 int err;
 long total;
 float fls[25],fl3[3];

#define RD_FLOAT 3
 total = 25;
 if (((err = RdText(fid,fls,&total,RD_FLOAT,0)) == NO_ERROR) && (total == 25))
    {*which_format = (long) fls[0];
     PRT2(printf("RdPlaneParams 1 total = %d\n",total);)
     if (*which_format & 1)
        {total = 3;
         if (((err = RdText(fid,fl3,&total,RD_FLOAT,0)) == NO_ERROR) && (total == 3))
            setup_vector_3d_rec(center,fl3[0],fl3[1],fl3[2]);
           else if (err == NO_ERROR) err = CANCEL;
        }
     if ((err == NO_ERROR) && (*which_format & 2))
        {total = 3;
         if (((err = RdText(fid,fl3,&total,RD_FLOAT,0)) == NO_ERROR) && (total == 3))
            setup_vector_3d_rec(coord_ratio,fl3[0],fl3[1],fl3[2]);
           else if (err == NO_ERROR) err = CANCEL;
        }
     if (err == NO_ERROR)
        {*adjust_to_center = fls[1];
         setup_vector_3d_rec(base,fls[2],fls[3],fls[4]);
         setup_vector_3d_rec(normal,fls[5],fls[6],fls[7]);
         setup_vector_3d_rec(rotate,.0,.0,fls[8]);
         setup_4d_matrix(xyztoplane,
                         fls[9],fls[10],fls[11],fls[12], 
                         fls[13],fls[14],fls[15],fls[16],
                         fls[17],fls[18],fls[19],fls[20],
                         fls[21],fls[22],fls[23],fls[24]);
        }
    }
   else if (err == NO_ERROR) err = CANCEL;
 PRT2(printf("RdPlaneParams 2 total = %d\n",total);)
 return err;
}


/*------------------------------------------------------------------------
WrPlaneParams - ???
------------------------------------------------------------------------*/

int
WrPlaneParams(fid,base,normal,center,coord_ratio,rotate,which_format,adjust_to_center,
              xyztoplane)
 FILE *fid;
 struct vector_3d_rec *base,*normal,*center,*coord_ratio,*rotate;
 int which_format;
 unsigned long adjust_to_center;
 struct matrix_3d_rec *xyztoplane;
{
 int err,row;

 fprintf(fid,"%-3d # the format of the parameter file\n",which_format);
 fprintf(fid,"   # format = 0 or 1 or 2 or 3\n");
 fprintf(fid,"   # if format = 0 then both center & coord ratio don't exists\n");
 fprintf(fid,"   # if format = 1 then center exists after the xyztoplane matrix\n");
 fprintf(fid,"   # if format = 2 then coord ratio exists after the xyztoplane matrix &\n");
 fprintf(fid,"   #       center (if exists)\n");
 fprintf(fid,"   # if format = 4 then this file has 2 parameter sets\n");
 fprintf(fid,"   #     & they are the co-registered parameters for 2 data sets\n");
 fprintf(fid,"   # if format = 8 then ignore xyztoplane\n");
 fprintf(fid,"   #  otherwise xyztoplane will be used to from the plane\n");
 fprintf(fid,"%-3ld # adjust to center = 1 or 0 = don't\n",adjust_to_center);

 fprintf(fid,"%-.6f  %-.6f  %-.6f # base [x,y,z]\n",base->x,base->y,base->z);
 fprintf(fid,"%-.6f  %-.6f  %-.6f # normal [x,y,z]\n\n",normal->x,normal->y,normal->z);
 fprintf(fid,"%-.6f # plane rotation angle in radian\n\n",rotate->z);
 fprintf(fid,"#  the xyztoplane 4 * 4 matrix...\n");
 for (row = 0; row < 4; row++)
    fprintf(fid,"%-.6f  %-.6f  %-.6f  %-.6f #  row%d\n",
           xyztoplane->buf[row][0],xyztoplane->buf[row][1],
           xyztoplane->buf[row][2],xyztoplane->buf[row][3],row);
 if (which_format & 3) fprintf(fid,"\n");
 if (which_format & 1)
    fprintf(fid,"%-.6f  %-.6f  %-.6f # center [x,y,z]\n",center->x,center->y,center->z);
 if (which_format & 2)
    fprintf(fid,"%-.6f  %-.6f  %-.6f # coord_ratio [x,y,z]\n",
        coord_ratio->x,coord_ratio->y,coord_ratio->z);
 fprintf(fid,"\n");
 err = ferror(fid);
 return err;
}


/*------------------------------------------------------------------------
PlaneLabel - ???
------------------------------------------------------------------------*/

char *
PlaneLabel(base,normal,center,coord_ratio,rotate,which_format,adjust_to_center)
 struct vector_3d_rec *base,*normal,*center,*coord_ratio,*rotate;
 int which_format;
 unsigned long adjust_to_center;
{
 static char str[250];
 int len;

 if (adjust_to_center) adjust_to_center = 1;
 if (which_format == 0)
    sprintf(str,"0F%-.4f,%-.4f,%-.4f[%-.4f/%-.4f/%-.4f]@%-.4fA%ld",
              base->x,base->y,base->z,
              normal->x,normal->y,normal->z,rotate->z,adjust_to_center);
   else
    {
     sprintf(str,"%-dF%-.4f,%-.4f,%-.4f[%-.4f/%-.4f/%-.4f]@%-.4f",
             which_format,base->x,base->y,base->z,
             normal->x,normal->y,normal->z,rotate->z);
     if (which_format & 1)
        {len = strlen(str);
         sprintf(&(str[len]),"C%-.4f,%-.4f,%-.4f",
              center->x,center->y,center->z);
        }
    if (which_format & 2)
        {len = strlen(str);
	/* FIXME:  Too many args for format below.  -PWH 19990430 */
         sprintf(&(str[len]),"S,%-.6f,%-.6f",
              coord_ratio->x,coord_ratio->y,coord_ratio->z);
        }
    len = strlen(str);
    sprintf(&(str[len]),"A%-ld",adjust_to_center);
   }
 PRT12(printf("PlaneLabel...1\n");)
 PRT12(printf("label = %s\n",str);)
 return str;
}


/*------------------------------------------------------------------------
get_plane_img_label - ???
------------------------------------------------------------------------*/

char *
get_plane_img_label(plane)
 struct plane_3d_rec *plane;
{
 return PlaneLabel(&(plane->base),
           &(plane->normal_cosine),&(plane->center),
           &(plane->coord_ratio),&(plane->rotate),0,
           (unsigned long) (plane->status & PLANE_ADJUST_TO_CENTER));
}


/*------------------------------------------------------------------------
DecodePlaneLabel - ???
------------------------------------------------------------------------*/

int
DecodePlaneLabel(label,base,normal,center,coord_ratio,rotate,which_format,
                 adjust_to_center)
 char *label;
 struct vector_3d_rec *base,*normal,*center,*coord_ratio,*rotate;
 int *which_format;
 unsigned long *adjust_to_center;
{
 int num,err;
 float rotate_deg;
 long start_indx;

 PRT12(printf("DecodePlaneLabel...1\n");)
 PRT12(printf("label = %s\n",label);)
 sscanf(label,"%d",which_format);
 err = NO_ERROR;
 if (*which_format == 0)
    {if ((num = sscanf(label,"0F%f,%f,%f[%f/%f/%f]@%fA%ld",
              &(base->x),&(base->y),&(base->z),&(normal->x),&(normal->y),
              &(normal->z),&rotate_deg,adjust_to_center)) != 8)
        err = CANCEL;
    }
   else
    {if ((num = sscanf(label,"%dF%f,%f,%f[%f/%f/%f]@%f",which_format,
              &(base->x),&(base->y),&(base->z),&(normal->x),&(normal->y),
              &(normal->z),&rotate_deg)) != 8)
        err = CANCEL;
       else
        {if (*which_format & 1)
            if (find_sub_str(label,"C",&start_indx) == NO_ERROR)
               {if ((num = sscanf(&(label[start_indx]),
                     "C%f,%f,%f",
                    &(center->x),&(center->y),&(center->z))) != 3)
                    err = CANCEL;
               }
         PRT12(printf("DecodePlaneLabel..2.err = %d\n",err);)
         if ((err == NO_ERROR) && (*which_format & 2))
            if (find_sub_str(label,"S",&start_indx) == NO_ERROR)
               {if ((num = sscanf(&(label[start_indx]),
                     "S%f,%f,%f",
                    &(coord_ratio->x),&(coord_ratio->y),&(coord_ratio->z))) != 3)
                    err = CANCEL;
               }
         PRT12(printf("DecodePlaneLabel..3.err = %d\n",err);)
         if (err == NO_ERROR)
            if (find_sub_str(label,"A",&start_indx) == NO_ERROR)
               if ((num = sscanf(&(label[start_indx]),"A%ld",adjust_to_center)) != 1)
                  err = CANCEL;
         PRT12(printf("DecodePlaneLabel..4.err = %d\n",err);)
        }
    }
 if (err == NO_ERROR)
    {setup_vector_3d_rec(rotate,.0,.0,rotate_deg);}
 PRT12(printf("DecodePlaneLabel..end.err = %d\n",err);)
 return err;
}


/*------------------------------------------------------------------------
CenterOf2Lines - ???
------------------------------------------------------------------------*/

void
CenterOf2Lines(base1,dire1,base2,dire2,center)
 struct vector_3d_rec *base1,*dire1,*base2,*dire2,*center;
{
 if (!lines_intersection(base1,dire1,base2,dire2,center))
    mid_vectors(center,base1,base2);
}


/*------------------------------------------------------------------------
plane_and_1 - ???
------------------------------------------------------------------------*/

int
plane_and_1(plane_normal1,plane_k1,plane_normal2,plane_k2,
                     and_base,and_direction)
 struct vector_3d_rec *plane_normal1,*plane_normal2,*and_base,*and_direction;
 float plane_k1,plane_k2;
{
 int err;
 struct matrix_3d_rec m1,inv;

 cross_product(&(and_direction->x),&(and_direction->y),&(and_direction->z),
               plane_normal1->x,plane_normal1->y,plane_normal1->z,
               plane_normal2->x,plane_normal2->y,plane_normal2->z);
 setup_3d_matrix(&m1,plane_normal1->x,plane_normal1->y,plane_normal1->z,
               plane_normal2->x,plane_normal2->y,plane_normal2->z,
               and_direction->x,and_direction->y,and_direction->z);
 if ((err = inverse_3d_matrix(&inv,&m1)) != NO_ERROR) return 0;

 and_base->x = inv.buf[0][0] * plane_k1 + inv.buf[0][1] * plane_k2;
 and_base->y = inv.buf[1][0] * plane_k1 + inv.buf[1][1] * plane_k2;
 and_base->z = inv.buf[2][0] * plane_k1 + inv.buf[2][1] * plane_k2;
 return 1;
}


/*------------------------------------------------------------------------
plane_lines_intersection - ???

Because of rounding errors, plane lines that intersect do not really intersect
sometimes.  This routine differs from lines_intersection in that if lines are
known to have intersected and they do not, when solving the 3d equations,
the closest point of intersection is computed.
------------------------------------------------------------------------*/

int
plane_lines_intersection(base1,direction1,base2,direction2,and)
 struct vector_3d_rec *base1,*direction1,*base2,*direction2,*and;
{
 double ratio1,ratio2,temp1,temp2;
 double x1,y1,z1,x2,y2,z2,dx1,dy1,dz1,dx2,dy2,dz2,last1,next1,last2,next2,
        change1,change2;
 int which,pick;

 x1 = base1->x;
 y1 = base1->y;
 dx1 = direction1->x;
 dy1 = direction1->y;
 x2 = base2->x;
 y2 = base2->y;
 dx2 = direction2->x;
 dy2 = direction2->y;
 z1 = base1->z;
 z2 = base2->z;
 dz1 = direction1->z;
 dz2 = direction2->z;

 if (!lines_intersection_2(x1,y1,dx1,dy1,x2,y2,dx2,dy2,&ratio1,&ratio2))
    {
     if (!lines_intersection_2(x1,z1,dx1,dz1,x2,z2,dx2,dz2,&ratio1,&ratio2))
        {
         if (!lines_intersection_2(y1,z1,dy1,dz1,y2,z2,dy2,dz2,&ratio1,&ratio2))
            {
             return 0;}
         temp1 = x1 + ratio1 * dx1;
         temp2 = x2 + ratio2 * dx2;
         which = 1;
         change1 = dx1;
         change2 = dx2;
        }
       else
        {temp1 = y1 + ratio1 * dy1;
         temp2 = y2 + ratio2 * dy2;
         change1 = dy1;
         change2 = dy2;
         which = 2;
        }
    }
   else
    {
     temp1 = z1 + ratio1 * dz1;
     temp2 = z2 + ratio2 * dz2;
     change1 = dz1;
     change2 = dz2;
     which = 3;
    }
 last1 = temp1 - change1;
 next1 = temp1 + change1;
 last2 = temp2 - change2;
 next2 = temp2 + change2;

 temp2 -= temp1;
 if (temp2 < .0) temp2 = -temp2;
 pick = 2;
 if (temp2 != .0)
    {last2 -= last1;
     if (last2 < .0) last2 = -last2;
     if (temp2 > last2)
        {pick = 1;
         temp2 = last2;}
     if (temp2 != .0)
        {next2 -= next1;
         if (next2 < .0) next2 = -next2;
         if (temp2 > next2)
            {temp2 = next2;
             pick = 3;}
        }
    }


 if (temp2 >= 1.0)
    {return 0;}
 if (which == 1)
    {if (pick == 1) and->x = (float) last1;
       else if (pick == 2) and->x = (float) temp1;
       else and->x = (float) next1;
    }
   else and->x = (float) (x1 + ratio1 * dx1);

 if (which == 2)
    {if (pick == 1) and->y = (float) last1;
       else if (pick == 2) and->y = (float) temp1;
       else and->y = (float) next1;
    }
   else and->y = (float) (y1 + ratio1 * dy1);

 if (which == 3)
    {if (pick == 1) and->z = (float) last1;
       else if (pick == 2) and->z = (float) temp1;
       else and->z = (float) next1;
    }
   else and->z = (float) (z1 + ratio1 * dz1);


 return 1;
}


/*------------------------------------------------------------------------
plane_line_and_bound_intersection - ???
------------------------------------------------------------------------*/

int
plane_line_and_bound_intersection(bounds,line_base,line_direction,
                                  startpt,endpt,is_result_rounded)
 struct vector_3d_rec bounds[4],*line_base,*line_direction,*startpt,*endpt;
 int is_result_rounded;
{
 int lcv,next,cnt;
 struct vector_3d_rec dire,v1,and,rounded_bounds[4];
 float dist,ratio;
 int is_and_status,num_coords_in_range;

 for (lcv = 0,cnt = 0; lcv < 4; lcv++)
    {rounded_bounds[lcv] = bounds[lcv];
     round_vector_3d_rec(&(rounded_bounds[lcv]));
    }

 for (lcv = 0,cnt = 0; lcv < 4; lcv++)
    {next = (lcv + 1) % 4;
     setup_vector_3d_rec(&dire,bounds[next].x - bounds[lcv].x,
            bounds[next].y - bounds[lcv].y,bounds[next].z - bounds[lcv].z);
     if (plane_lines_intersection(line_base,line_direction,&(bounds[lcv]),&dire,&and))
        {
         v1 = and;
         round_vector_3d_rec(&v1);
         num_pt_coords_in_range(&v1,&(rounded_bounds[lcv]),&(rounded_bounds[next]),
                  &num_coords_in_range);
         if (num_coords_in_range < 2) continue;
         if (num_coords_in_range == 2)
            if ((dist = pt_line_dist(&(bounds[lcv]),&dire,&and)) <= 1.0)
               {PlaneAndLineIntersection(&and,&dire,&(bounds[lcv]),&dire,
                               &v1,&ratio,&is_and_status);
                and = v1;
                round_vector_3d_rec(&v1);
                if (!pt_in_range(&v1,&(rounded_bounds[lcv]),&(rounded_bounds[next])))
                   continue;
               }
              else
               {
                continue;
               }

         and.status = 0;
         if (cnt == 0)
            {
             cnt += 1;
             *startpt = and;}
           else if ((startpt->x != v1.x) || (startpt->y != v1.y) ||
                    (startpt->z != v1.z))
            {*endpt = and;
             cnt += 1;
             if (cnt == 2)
                {
                 if (is_result_rounded)
                    {round_vector_3d_rec(startpt);
                     round_vector_3d_rec(endpt);}
                 return 1;}
            }
        }
    }
 return 0;
}


/*------------------------------------------------------------------------
PlaneLineAndBoundIntersection - ???
------------------------------------------------------------------------*/

int
PlaneLineAndBoundIntersection(plane,line_base,line_direction,and1,and2,
                   is_result_rounded)
 struct plane_3d_rec *plane;
 struct vector_3d_rec *line_base,*line_direction,*and1,*and2;
 int is_result_rounded;
{
 struct vector_3d_rec vs[4],base,dire,dire1,and;
 int lcv,next,cnt;

 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK)
    {TRACE(printf("PlaneLineAndBoundIntersection...status = %x\n",plane->status))
     return 0;}
 if ((plane->proj_dimx == 0) || (plane->proj_dimy == 0))
    {TRACE(printf("PlaneLineAndBoundIntersection...plane->proj_dimx = %d = %d\n",
          plane->proj_dimx,plane->proj_dimy))
     return 0;}
 trans_3d_xyz(&(plane->xyztoplane),
                line_base->x,line_base->y,line_base->z,
                &(base.x),&(base.y),&(base.z),0);
 base.z = .0;

 dire = *line_direction;
 mult_vector_with_const(&dire,10.0);
 add_vector_3d(&dire,line_base);
 trans_3d_xyz(&(plane->xyztoplane),dire.x,dire.y,dire.z,
         &(dire.x),&(dire.y),&(dire.z),0);
 dire.z = 0;

 sub_vector_3d(&dire,&base);
 setup_vector_3d_rec(&(vs[0]),(float) plane->firstx,(float) plane->firsty,.0);
 setup_vector_3d_rec(&(vs[1]),(float) plane->lastx,(float) plane->firsty,.0);
 setup_vector_3d_rec(&(vs[2]),(float) plane->lastx,(float) plane->lasty,.0);
 setup_vector_3d_rec(&(vs[3]),(float) plane->firstx,(float) plane->lasty,.0);
 for (cnt = 0,lcv = 0; lcv < 4; lcv++)
    {next = (lcv + 1) % 4;
     sub_vectors(&dire1,&(vs[next]),&(vs[lcv]));

     if (plane_lines_intersection(&base,&dire,&(vs[lcv]),&dire1,&and))
        {
         if ((and.x >= vs[0].x) && (and.x <= vs[1].x) && 
             (and.y >= vs[0].y) && (and.y <= vs[2].y))
            {
             if (cnt == 0)
                {trans_3d_xyz(&(plane->planetoxyz),
                    and.x,and.y,and.z,&(and1->x),&(and1->y),&(and1->z),0);
                }
               else
                {trans_3d_xyz(&(plane->planetoxyz),
                    and.x,and.y,and.z,&(and2->x),&(and2->y),&(and2->z),0);
                 break;}
             cnt += 1;
            }
        }
     TRACE(printf("\n\n"))
    }
 if (cnt == 1) return 1;
   else return 0;
}


/*------------------------------------------------------------------------
OnPlane - ???
------------------------------------------------------------------------*/

int
OnPlane(plane_coord,plane_normal,pt)
 struct vector_3d_rec *plane_coord,*plane_normal,*pt;
{
 float dot;
 struct vector_3d_rec temp;

 sub_vectors(&temp,pt,plane_coord);
 dot = vector_dot_product(plane_normal,&temp);
 if (dot == .0) return 1;
 return 0;
}


/*------------------------------------------------------------------------
PlaneAndLineIntersection - ???
------------------------------------------------------------------------*/

void
PlaneAndLineIntersection(plane_coord,plane_normal,line_base,line_direction,
                        and_pt,line_move_unit_ratio,is_and_status)
 struct vector_3d_rec *plane_coord,*plane_normal,*line_base,*line_direction,
        *and_pt;
 float *line_move_unit_ratio;
 int *is_and_status;
{
 float dot,dot1,k;

 dot = vector_dot_product(plane_normal,line_direction);
 if (dot == .0)
    {
     if (OnPlane(plane_coord,plane_normal,line_base))
        {PRT11(printf("PlaneAndLineIntersection...PLANE_LINE\n");)
         *is_and_status = PLANE_LINE;
         *and_pt = *line_base;
/*
         *and_pt = *plane_coord;
*/
        }
       else
        {PRT11(printf("PlaneAndLineIntersection...NO_INTERSECTION\n");)
         *is_and_status = NO_INTERSECTION;
         setup_vector_3d_rec(and_pt,.0,.0,.0);
        }
    }
   else
    {
     dot1 = vector_dot_product(plane_normal,line_base);
     k = vector_dot_product(plane_normal,plane_coord);
     *line_move_unit_ratio = (k - dot1) / dot;
     setup_vector_3d_rec(and_pt,
            line_base->x + (*line_move_unit_ratio) * line_direction->x,
            line_base->y + (*line_move_unit_ratio) * line_direction->y,
            line_base->z + (*line_move_unit_ratio) * line_direction->z);
     PRT11(printf("Inter and...\n");pr_vector_3d_rec(and_pt);)
     *is_and_status = ONE_INTERSECTION;}
}


/*------------------------------------------------------------------------
max_normal_extents - ???
------------------------------------------------------------------------*/

void
max_normal_extents(plane_coord,plane_normal,
                   startx,endx,starty,endy,
                   startz,endz,startpt,endpt)
 struct vector_3d_rec *plane_coord,*plane_normal,*startpt,*endpt;
 float startx,endx,starty,endy,startz,endz;
{
 struct vector_3d_rec vertices[8],ands[8],dire,dire1;
 float ratio,dist,max,min,deg,deg1;
 int cnt,is_and_status,maxindx,minindx;

 cuboid_vertices(vertices,startx,endx,starty,endy,startz,endz);
 for (cnt = 0; cnt < 8; cnt++)
    {PlaneAndLineIntersection(&(vertices[cnt]),plane_normal,plane_coord,
                        plane_normal,&(ands[cnt]),&ratio,&is_and_status);
     if (ratio < 0.0) dist = -vector_distance(plane_coord,&(ands[cnt]));
       else dist = vector_distance(plane_coord,&(ands[cnt]));

     if (cnt == 0)
        {min = max = dist;
         maxindx = minindx = 0;}
       else
        {if (min > dist)
            {min = dist;
             minindx = cnt;}
         if (max < dist)
            {max = dist;
             maxindx = cnt;}
        }
    }
 sub_vectors(&dire,&(ands[maxindx]),&(ands[minindx]));
 sub_vectors(&dire1,&(ands[minindx]),&(ands[maxindx]));
 deg = degree_angle_vectors(&dire,plane_normal);
 deg1 = degree_angle_vectors(&dire1,plane_normal);
 PRT4(printf("max_normal_extents...norm");pr_vector_3d_rec(plane_normal);
      printf("dire...");pr_vector_3d_rec(&dire);
      printf("dire1...");pr_vector_3d_rec(&dire1);
      printf("dire&n = %f...dir1&n = %f\n",deg,deg1);
     )
 if (deg < .0) deg = -deg;
 if (deg1 < .0) deg1 = -deg1;

  if (deg < deg1)
    {PRT4(printf("minindx...maxindx sel\n");)
     *startpt = ands[minindx];
     *endpt = ands[maxindx];
    }
   else
    {PRT4(printf("maxindx...minindx sel\n");)
     *startpt = ands[maxindx];
     *endpt = ands[minindx];}
     PRT4(printf("minindx...");pr_vector_3d_rec(&(ands[minindx]));
     printf("maxindx...");pr_vector_3d_rec(&(ands[maxindx]));)

/*
 if (length_vector(&(ands[maxindx])) < length_vector(&(ands[minindx])))
    {*startpt = ands[maxindx];
     *endpt = ands[minindx];}
   else
    {*startpt = ands[minindx];
     *endpt = ands[maxindx];}
*/
}


/*------------------------------------------------------------------------
one_valid_plane_pt - ???
------------------------------------------------------------------------*/

int
one_valid_plane_pt(base,normal,local_start,local_end,pt)
 struct vector_3d_rec *base,*normal,*local_start,*local_end;
 struct vector_3d_rec *pt;
{
 struct vector_3d_rec vertices[24],dir,and;
 float ratio;
 int cnt,is_and_status;

 cuboid_edges(vertices,local_start->x,local_end->x,
           local_start->y,local_end->y,
           local_start->z,local_end->z);
 for (cnt = 0; cnt < 24; cnt += 2)
    {sub_vectors(&dir,&(vertices[cnt + 1]),&(vertices[cnt]));
     PlaneAndLineIntersection(base,normal,&(vertices[cnt]),
                        &dir,&and,&ratio,&is_and_status);
     if (is_and_status != NO_INTERSECTION)
        if (pt_in_volume(local_start,local_end,and.x,and.y,and.z))
           {*pt = and;
/*
     if (is_and_status == ONE_INTERSECTION) printf("ONE_INTERSECTION...\n");
     printf("one_valid_plane_pt..plane base.");pr_vector_3d_rec(base);
     printf("one_valid_plane_pt..normal.");pr_vector_3d_rec(normal);
     printf("one_valid_plane_pt..line base.");pr_vector_3d_rec(&(vertices[cnt]));
     printf("one_valid_plane_pt..line base+1.");pr_vector_3d_rec(&(vertices[cnt + 1]));
     printf("one_valid_plane_pt..dir.");pr_vector_3d_rec(&dir);
     printf("one_valid_plane_pt ratio = %f\n",ratio);
*/
            return NO_ERROR;}
    }
 return CANCEL;
}

/**********************
define_next_slice_base(base,normal,plane_0_vector,plane_max_vector,total_planes,
            next_plane_num,local_start,local_end)
 struct vector_3d_rec *base,*normal,*plane_0_vector,*plane_max_vector,
           *local_start,*local_end;
 long total_planes,next_plane_num;
{
 struct vector_3d_rec dir,v1;

 if (total_planes == 1) *base = *plane_0_vector;
   else
    {
     sub_vectors(&v1,plane_max_vector,plane_0_vector);
     direction_cosine_vector(&v1);
     base->x = plane_0_vector->x + next_plane_num * v1.x;
     base->y = plane_0_vector->y + next_plane_num * v1.y;
     base->z = plane_0_vector->z + next_plane_num * v1.z;}
}
****************/


/*------------------------------------------------------------------------
locate_plane - ???
------------------------------------------------------------------------*/

int
locate_plane(plane,new_plane_num,is_plane_num_relative)
 struct plane_3d_rec *plane;
 long new_plane_num;
 int is_plane_num_relative;
{
 long next,temp;
 struct vector_3d_rec v1;

 if (is_plane_num_relative)
    {next = plane->plane_num + new_plane_num;
     if (next < 0) next += plane->total_planes;}
   else next = new_plane_num;
 if (next >= plane->total_planes) next %= plane->total_planes;
 if (next == plane->plane_num) return 0;

 PRT4(printf("locate base...");pr_vector_3d_rec(&(plane->base));
    printf(" next = %d plane_num = %d len = %f\n",next,plane->plane_num,
           vector_distance(&(plane->base),&(plane->plane_0_vector)));
    printf(" locate xyztoplane...");pr_3d_matrix(&(plane->xyztoplane));
    printf(" locate planetoxyz...");pr_3d_matrix(&(plane->planetoxyz));)
 PRT4(printf("norm...\n");pr_vector_3d_rec(&(plane->normal_cosine));
      sub_vectors(&v1,&(plane->base),&(plane->center));
      direction_cosine_vector(&v1);
      printf("base - center...\n");pr_vector_3d_rec(&v1);
      sub_vectors(&v1,&(plane->center),&(plane->base));
      direction_cosine_vector(&v1);
      printf("center - base...\n");pr_vector_3d_rec(&v1);
 printf("\n...0_vector....plane_max_vector...v1\n");
    pr_vector_3d_rec(&(plane->plane_0_vector));
    pr_vector_3d_rec(&(plane->plane_max_vector));
     )
 temp = next - plane->plane_num;
 v1 = plane->normal_cosine;
 mult_vector_with_const(&v1,(float) temp);
 PRT4(printf("tran diff = %d...",temp);pr_vector_3d_rec(&v1);)

 translate_3d_matrix(&(plane->planetoxyz),v1.x,v1.y,v1.z);
 inverse_4d_matrix(&(plane->xyztoplane),&(plane->planetoxyz));
 add_vector_3d(&(plane->base),&v1);
 add_vector_3d(&(plane->actual_base),&v1);
 plane->plane_num = next;

 calc_plane_const(plane);
 define_bound_vertices(plane,plane->bound_vertices);

 PRT4(printf("base...");pr_vector_3d_rec(&(plane->base));
    printf(" plane_num = %d len = %f\n",plane->plane_num,
           vector_distance(&(plane->base),&(plane->plane_0_vector)));
    printf("after locate xyztoplane...");pr_3d_matrix(&(plane->xyztoplane));
    printf("after locate planetoxyz...");pr_3d_matrix(&(plane->planetoxyz));
    printf("\n\n");)
 PRT4(printf("norm...\n");pr_vector_3d_rec(&(plane->normal_cosine));
      sub_vectors(&v1,&(plane->base),&(plane->center));
      direction_cosine_vector(&v1);
      printf("base - center...\n");pr_vector_3d_rec(&v1);
      sub_vectors(&v1,&(plane->center),&(plane->base));
      direction_cosine_vector(&v1);
      printf("center - base...\n\n");pr_vector_3d_rec(&v1);
     )
 return 1;
}


/*------------------------------------------------------------------------
PlaneXYZToLocalXYZ - ???
------------------------------------------------------------------------*/

int
PlaneXYZToLocalXYZ(plane,planex,planey,planez,localx,localy,localz,is_round)
 struct plane_3d_rec *plane;
 float planex,planey,planez;
 float *localx,*localy,*localz;
 int is_round;
{
 float nx,ny,nx1,ny1;
 struct matrix_3d_rec *trans,inv;

 TRACE(printf("PlaneXYZToLocalXYZ...plane = %u\n",plane))
 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK)
    {TRACE(printf("PLANE_PROJ_DIM_DATA_OK...plane->status = %x  %x\n",
              plane->status,plane->status & PLANE_PROJ_DIM_DATA_OK))
     return 1;}

 if (!(plane->status & PLANE_PROJ_BUF_DIM_VALID))
    {TRACE(printf("PLANE_PROJ_BUF_DIM_VALID...\n"))
     return 1;}

 inverse_4d_matrix(&inv,&(plane->trans));
 TRACE(printf("PlaneXYZToLocalXYZ...1\n"))
 trans = &inv;
 nx = planex - (float) ((long) plane->proj_buf_dimx -
                      (long) plane->trans_proj_dimx) / 2.0;
 ny = planey - (float) ((long) plane->proj_buf_dimy - 
                      (long) plane->trans_proj_dimy) / 2.0;
 nx1 = trans->buf[0][0] * nx + trans->buf[0][1] * ny + trans->buf[0][3] + 
           plane->firstx;
 ny1 = trans->buf[1][0] * nx + trans->buf[1][1] * ny + trans->buf[1][3] + 
           plane->firsty;
 TRACE(printf("PlaneXYZToLocalXYZ...0\n"))

 trans_3d_xyz(&(plane->planetoxyz),nx1,ny1,planez,localx,localy,localz,is_round);
/*
 printf("PlaneXYZToLocalXYZ   nx1 = %f  ny1 = %f  z = %f acx = %f  acy = %f  acz = %f\n\n",
                nx1,ny1,*localx,*localy,*localz);
*/
 return NO_ERROR;
}


/*------------------------------------------------------------------------
LocalXYZToPlaneXYZ - ???
------------------------------------------------------------------------*/

int
LocalXYZToPlaneXYZ(plane,localx,localy,localz,planex,planey,planez)
 struct plane_3d_rec *plane;
 float localx,localy,localz;
 float *planex,*planey,*planez;
{
 float nx,ny,nx1,ny1;
 struct matrix_3d_rec *trans;

 if ((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK)
    {TRACE(printf("PLANE_PROJ_DIM_DATA_OK...plane->status = %x  %x\n",
              plane->status,plane->status & PLANE_PROJ_DIM_DATA_OK))
     return 1;}

 if (!(plane->status & PLANE_PROJ_BUF_DIM_VALID))
    {
     return 1;}

 trans_3d_xyz(&(plane->xyztoplane),localx,localy,localz,&nx,&ny,planez,0);
 trans = &(plane->trans);
/*
 trans_3d_xyz(&(plane->proj),nx,ny,*planez,&tx,&ty,&tz,0);
printf("\nlocalx = %f  y = %f  z = %f\n",localx,localy,localz);
printf("tx = %f  y = %f  z = %f\n",tx,ty,tz);

printf("  nx = %f  y = %f\n",nx,ny);
 trans_3d_xyz(&(plane->actual),plane->base.x,plane->base.y,
        plane->base.z,&tx,&ty,&tz,0);
printf("base..");pr_vector_3d_rec(&(plane->base));
printf("bx = %f  y = %f  z = %f\n",tx,ty,tz);
 trans_3d_xyz(&(plane->proj),(float) -plane->firstx,(float) -plane->firsty,
        .0,&tx,&ty,&tz,0);
printf("-fx = %f  y = %f  z = %f\n",tx,ty,tz);
*/

 nx -= plane->firstx;
 ny -= plane->firsty;
 nx1 = trans->buf[0][0] * nx + trans->buf[0][1] * ny + trans->buf[0][3];
 ny1 = trans->buf[1][0] * nx + trans->buf[1][1] * ny + trans->buf[1][3];

 nx1 += (float) ((long) plane->proj_buf_dimx - (long) plane->trans_proj_dimx) / 2.0;
 ny1 += (float) ((long) plane->proj_buf_dimy - (long) plane->trans_proj_dimy) / 2.0;

 *planex = nx1;
 *planey = ny1;
/*
 printf("===nx = %f  y = %f\n",nx,ny);
 printf("  planex = %f planey = %f planez = %f fx = %d  fy = %d\n",
          *planex,*planey,*planez,
          plane->firstx,plane->firsty);
*/
 return NO_ERROR;
}


/*------------------------------------------------------------------------
base_normal_after_angle_cut - ???
------------------------------------------------------------------------*/

int
base_normal_after_angle_cut(plane,x1,y1,x2,y2,cut_deg,base,normal)
 struct plane_3d_rec *plane;
 float x1,y1,x2,y2,cut_deg;
 struct vector_3d_rec *base,*normal;
{
 struct vector_3d_rec v1,v2,norm1,norm2;
 struct vector_3d_rec origin,dire,dire1;
 float rad_deg,deg1,deg2,line_move_unit_ratio;
 int err,yes;

 PRT7(printf("base_normal_after_angle_cut x1 = %f y1 = %f   x2 = %f  y2 = %f cut_deg = %f\n",x1,y1,
           x2,y2,cut_deg))
 if ((err = PlaneXYZToLocalXYZ(plane,x1,y1,.0,
         &(v1.x),&(v1.y),&(v1.z),0)) != NO_ERROR)
    return err;
 PRT7(printf("base_normal_after_angle_cut...1\n"))
 if ((err = PlaneXYZToLocalXYZ(plane,x2,y2,.0,
         &(v2.x),&(v2.y),&(v2.z),0)) != NO_ERROR)
    return err;
 setup_vector_3d_rec(&origin,.0,.0,.0);
 PRT7(printf("v1..");pr_vector_3d_rec(&v1);)
 PRT7(printf("v2...");pr_vector_3d_rec(&v2);)
/*
 mid_vectors(base,&v2,&v1);
*/
 rad_deg = (float) radian(cut_deg);
 sub_vectors(&dire,&v1,&v2);
 norm1 = plane->normal_cosine;

 rotate_pt_fr_line(&origin,&(plane->normal_cosine),RADIAN / 2.0,&dire,&dire1);
 PRT7(printf("deg(dire,dire1) = %f\n",
          degree_angle_vectors(&dire,&dire1)))
 PlaneAndLineIntersection(&v1,&dire1,&(plane->base),&dire1,
           base,&line_move_unit_ratio,&yes);

 PRT7(printf("yes = %d\n",yes);
      printf("old base...");pr_vector_3d_rec(&(plane->base));)
 PRT7(printf("new base...");pr_vector_3d_rec(base);)
 PRT7(printf("old normal...");pr_vector_3d_rec(&norm1);)

 rotate_pt_fr_line(&origin,&dire,rad_deg,&norm1,&norm1);
 deg1 = degree_angle_vectors(&norm1,&dire);

 norm2 = plane->normal_cosine;
 sub_vectors(&dire,&v2,&v1);
 rotate_pt_fr_line(&origin,&dire,rad_deg,&norm2,&norm2);
 deg2 = degree_angle_vectors(&norm2,&dire);
 PRT7(printf(" normal 1...");pr_vector_3d_rec(&norm1);)
 PRT7(printf(" normal 2...");pr_vector_3d_rec(&norm2);)
 PRT7(printf("cut_deg = %f deg1 = %f deg2 = %f\n",cut_deg,deg1,deg2);)

 deg1 -= cut_deg;
 if (deg1 < .0) deg1 = -deg1;
 deg2 -= cut_deg;
 if (deg2 < .0) deg2 = -deg2;
 if (deg1 <= deg2)
    {*normal = norm1;
     PRT7(printf("---final deg normal 1...");)}
   else 
    {*normal = norm2;
     PRT7(printf("---final deg normal 2...");)}

 PRT7(pr_vector_3d_rec(normal);printf("\n");)
 return NO_ERROR;
}


/*------------------------------------------------------------------------
base_normal_after_axis_rotation - ???
------------------------------------------------------------------------*/

int
base_normal_after_axis_rotation(plane,x1,y1,x2,y2,cut_deg,base,normal)
 struct plane_3d_rec *plane;
 float x1,y1,x2,y2,cut_deg;
 struct vector_3d_rec *base,*normal;
{
 struct vector_3d_rec v1,v2;
 struct vector_3d_rec origin,dire,dire1;
 float rad_deg;
 int err,yes,line_move_unit_ratio;

 PRT14(printf("base_normal_after_axis_rotation x1 = %f y1 = %f   x2 = %f  y2 = %f cut_deg = %f\n",x1,y1,
           x2,y2,cut_deg))
 if ((err = PlaneXYZToLocalXYZ(plane,x1,y1,.0,
         &(v1.x),&(v1.y),&(v1.z),0)) != NO_ERROR)
    return err;
 PRT14(printf("base_normal_after_axis_rotation...1\n"))
 if ((err = PlaneXYZToLocalXYZ(plane,x2,y2,.0,
         &(v2.x),&(v2.y),&(v2.z),0)) != NO_ERROR)
    return err;
 setup_vector_3d_rec(&origin,.0,.0,.0);
 PRT14(printf("v1..");pr_vector_3d_rec(&v1);)
 PRT14(printf("v2...");pr_vector_3d_rec(&v2);)

 rad_deg = (float) radian(cut_deg);
 sub_vectors(&dire,&v1,&v2);
 PRT14(printf("rad = %f dire...",rad_deg);pr_vector_3d_rec(&dire);)

 rotate_pt_fr_line(&origin,&dire,rad_deg,
      &(plane->normal_cosine),normal);
 PRT14(printf("old normal...");pr_vector_3d_rec(&(plane->normal_cosine));)
 PRT14(printf("new normal...");pr_vector_3d_rec(normal);)

/*
 mid_vectors(base,&v2,&v1);
*/

 rotate_pt_fr_line(&origin,&(plane->normal_cosine),RADIAN / 2.0,&dire,&dire1);
 PRT14(printf("deg(dire,dire1) = %f\n",
          degree_angle_vectors(&dire,&dire1)))
 PlaneAndLineIntersection(&v1,&dire1,&(plane->base),&dire1,
           base,&line_move_unit_ratio,&yes);
 PRT14(printf("old base...");pr_vector_3d_rec(&(plane->base));)
 PRT14(printf("new base...");pr_vector_3d_rec(base);)

 return NO_ERROR;
}


/*------------------------------------------------------------------------
natural_zplane - ???
------------------------------------------------------------------------*/

int
natural_zplane(plane)
 struct plane_3d_rec *plane;
{
 struct vector_3d_rec v[4];
 int lcv;

 if (((plane->status & PLANE_PROJ_DIM_DATA_OK) != PLANE_PROJ_DIM_DATA_OK) ||
     (plane->proj_dimx == 0) || (plane->proj_dimy == 0))
    return 2;
 if (get_vector_plane_type(&(plane->normal)) == VECTOR_Z_PLANE)
    {
     if (!(plane->status & PLANE_TRANS_IDENTITY)) return 1;
     define_bound_vertices(plane,v);
     for (lcv = 1; lcv < 4; lcv++)
        if (v[0].x > v[lcv].x) return 1;
     for (lcv = 1; lcv < 4; lcv++)
        if (v[0].y > v[lcv].y) return 1;
     if (v[1].y > v[3].y) return 1;
     return NO_ERROR;
    }
 return 1;
}


/*------------------------------------------------------------------------
pt_in_volume - ???
------------------------------------------------------------------------*/

int
pt_in_volume(local_start,local_end,x,y,z)
 struct vector_3d_rec *local_start,*local_end;
 float x,y,z;
{
 if ((x >= local_start->x) && (x <= local_end->x) &&
     (y >= local_start->y) && (y <= local_end->y) &&
     (z >= local_start->z) && (z <= local_end->z))
    return 1;
   else return 0;
}


/*------------------------------------------------------------------------
plane_pt_in_3d - ???
------------------------------------------------------------------------*/

int
plane_pt_in_3d(plane,x,y,z)
 struct plane_3d_rec *plane;
 float x,z,y;
{
 if ((x >= plane->local_start.x) && (x <= plane->local_end.x) &&
     (y >= plane->local_start.y) && (y <= plane->local_end.y) &&
     (z >= plane->local_start.z) && (z <= plane->local_end.z))
    return 1;
   else return 0;
}


/*------------------------------------------------------------------------
largest_plane - ???
------------------------------------------------------------------------*/

int
largest_plane(plane,firstx,lastx,firsty,lasty,direction)
 struct plane_3d_rec *plane;
 long *firstx,*lastx,*firsty,*lasty;
 int direction;
{
 *firstx = plane->firstx;
 *lastx = plane->lastx;
 *firsty = plane->firsty;
 *lasty = plane->lasty;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
PlaneIntersection - ???
------------------------------------------------------------------------*/

int
PlaneIntersection(plane1,plane2,and_base,and_direction)
 struct plane_3d_rec *plane1,*plane2;
 struct vector_3d_rec *and_base,*and_direction;
{
 float const1,const2;
 struct vector_3d_rec base1,base2;

/*
 printf("plane_and...dot norm = %f...",degree_angle_vectors(&(plane1->normal_cosine),
                 &(plane2->normal_cosine)));
*/
 GlobalPt(plane1,&(plane1->base),&base1);
 GlobalPt(plane2,&(plane2->base),&base2);
 const1 = plane1->normal.x * base1.x + plane1->normal.y * base1.y +
     plane1->normal.z * base1.z;
 const2 = plane2->normal.x * base2.x + plane2->normal.y * base2.y +
     plane2->normal.z * base2.z;
 if (plane_and_1(&(plane1->normal),const1,
                      &(plane2->normal),const2,and_base,and_direction))
    {return 1;
    }
   else
    {PRT13(printf("const1 = %f const2 = %f\n",const1,const2))
     PRT13(printf("base1..");pr_vector_3d_rec(&base1))
     PRT13(printf("normal1..");pr_vector_3d_rec(&(plane1->normal)))
     PRT13(printf("base2..");pr_vector_3d_rec(&base2))
     PRT13(printf("normal2..");pr_vector_3d_rec(&(plane2->normal)))
     PRT13(printf("\n");)
    }
 return 0;
}


/*------------------------------------------------------------------------
IsSameNormalAndOverlapped - ???
------------------------------------------------------------------------*/

int
IsSameNormalAndOverlapped(plane1,plane2)
 struct plane_3d_rec *plane1,*plane2;
{
 float const1,const2;
 struct vector_3d_rec base1,base2;

 if (same_direction_vectors(&(plane1->normal),&(plane2->normal)))
    {GlobalPt(plane1,&(plane1->base),&base1);
     GlobalPt(plane2,&(plane2->base),&base2);
     const1 = plane1->normal.x * base1.x + plane1->normal.y * base1.y +
              plane1->normal.z * base1.z;
     const2 = plane2->normal.x * base2.x + plane2->normal.y * base2.y +
              plane2->normal.z * base2.z;
     const1 -= const2;
     if (const1 < .0) const1 = -const1;
     if (const1 < 1.0) return 1;
    }
 return 0;
}


/*------------------------------------------------------------------------
reverse_plane - ???
------------------------------------------------------------------------*/

void
reverse_plane(plane)
 struct plane_3d_rec *plane;
{
 struct vector_3d_rec temp;
 float len;
 struct matrix_3d_rec mat;

 PRT6(printf("reverse normal_cosine...");pr_vector_3d_rec(&(plane->normal_cosine));
    printf("plane_0_vector...");pr_vector_3d_rec(&(plane->plane_0_vector));
    printf("plane_max_vector...");pr_vector_3d_rec(&(plane->plane_max_vector));
    printf("plane_num...%d\n",plane->plane_num);
    printf("  xyztoplane...");pr_3d_matrix(&(plane->xyztoplane));
    printf("  planetoxyz...");pr_3d_matrix(&(plane->planetoxyz));)

 reverse_vector_3d_rec(&(plane->normal_cosine));
 plane->normal = plane->normal_cosine;
 temp = plane->plane_0_vector;
 plane->plane_0_vector = plane->plane_max_vector;
 plane->plane_max_vector = temp;
 len = vector_distance(&(plane->base),&(plane->plane_0_vector));
 plane->plane_num = (long) floor((double) len);

/*
 identity_3d_matrix(&planetoxyz);
 identity_3d_matrix(&xyztoplane);
 setup_vector_3d_rec(&base,.0,.0,.0);
 setup_vector_3d_rec(&dire,.0,.0,-1.0);
 Rotate3dMatrixFromAxis(&xyztoplane,&planetoxyz,&base,&dire,.0);
 mult_3d_matrix(&(plane->xyztoplane),&xyztoplane,&(plane->xyztoplane));
 inverse_4d_matrix(&(plane->xyztoplane),&(plane->planetoxyz));
*/
 identity_3d_matrix(&mat);
 mat.buf[2][2] = -1.0;
 mult_3d_matrix(&(plane->xyztoplane),&mat,&(plane->xyztoplane));
 inverse_4d_matrix(&(plane->planetoxyz),&(plane->xyztoplane));

 PRT6(printf("after  normal_cosine...");pr_vector_3d_rec(&(plane->normal_cosine));
    printf("plane_0_vector...");pr_vector_3d_rec(&(plane->plane_0_vector));
    printf("plane_max_vector...");pr_vector_3d_rec(&(plane->plane_max_vector));
    printf("plane_num...%d\n",plane->plane_num);
    printf(" 1 xyztoplane...");pr_3d_matrix(&(plane->xyztoplane));
    printf(" 1 planetoxyz...");pr_3d_matrix(&(plane->planetoxyz));)


}


/*------------------------------------------------------------------------
move_center - ???
------------------------------------------------------------------------*/

void
move_center(plane,new_rel_globalcenter,old_rel_globalcenter,is_rel)
 struct plane_3d_rec *plane;
 struct vector_3d_rec *new_rel_globalcenter,*old_rel_globalcenter;
 int is_rel;
{
 struct vector_3d_rec diff,new_center,old_center;

 PRT9(printf("move_center is_rel = %d\n",is_rel);
      printf("base...");pr_vector_3d_rec(&(plane->base));
printf("norm...\n");pr_vector_3d_rec(&(plane->normal_cosine));
    printf(" plane_num = %d len = %f\n",plane->plane_num,
           vector_distance(&(plane->base),&(plane->plane_0_vector)));
      printf("plane_0_vector...\n");pr_vector_3d_rec(&(plane->plane_0_vector));
      printf("plane_max_vector...\n");pr_vector_3d_rec(&(plane->plane_max_vector));
    printf("xyztoplane...");pr_3d_matrix(&(plane->xyztoplane));
    printf("planetoxyz...");pr_3d_matrix(&(plane->planetoxyz));
    printf("\n");)

 LocalPt(plane,new_rel_globalcenter,&new_center);
 if (is_rel)
    LocalPt(plane,old_rel_globalcenter,&old_center);
   else old_center = plane->center;

 PRT9(printf("is_rel = %d new_center...",is_rel);pr_vector_3d_rec(&new_center);
      printf("old_center...");pr_vector_3d_rec(&old_center);
      printf("local_start...");pr_vector_3d_rec(&(plane->local_start));
      printf("local_end...");pr_vector_3d_rec(&(plane->local_end));
     )
 sub_vectors(&diff,&new_center,&old_center);
 add_vector_3d(&(plane->center),&diff);
 add_vector_3d(&(plane->base),&diff);
 add_vector_3d(&(plane->actual_base),&diff);
 PRT9(printf("*** diff...");pr_vector_3d_rec(&diff);)
 PRT9(printf("\n***after center...");pr_vector_3d_rec(&(plane->center));)
 PRT9(printf("*** base...");pr_vector_3d_rec(&(plane->base));
      printf("local_start...");pr_vector_3d_rec(&(plane->local_start));
      printf("local_end...");pr_vector_3d_rec(&(plane->local_end));)
 translate_3d_matrix(&(plane->planetoxyz),diff.x,
           diff.y,diff.z);

 inverse_4d_matrix(&(plane->xyztoplane),&(plane->planetoxyz));

 PRT9(setup_vector_3d_rec(&v1,.0,.0,.0);
 trans_3d_pt(&(plane->planetoxyz),&v1,&v1,0);
 printf("***[0,0,0]...\n");pr_vector_3d_rec(&v1);)

 PlaneAttrs(&(plane->base),&(plane->center),&(plane->normal_cosine),
             plane->local_start.x,plane->local_end.x,
             plane->local_start.y,plane->local_end.y,
             plane->local_start.z,plane->local_end.z,
             &(plane->total_planes),&(plane->plane_num),
             &(plane->plane_0_vector),&(plane->plane_max_vector),
             (int) (plane->status & PLANE_ADJUST_TO_CENTER));

 calc_plane_const(plane);
 define_bound_vertices(plane,plane->bound_vertices);

 PRT9(printf("\nmove_center base...");pr_vector_3d_rec(&(plane->base));
    printf(" plane_num = %d len = %f\n",plane->plane_num,
           vector_distance(&(plane->base),&(plane->plane_0_vector)));
    printf("after locate xyztoplane...");pr_3d_matrix(&(plane->xyztoplane));
    printf("after locate planetoxyz...");pr_3d_matrix(&(plane->planetoxyz));
    printf("\n");)
 PRT9(printf("norm...\n");pr_vector_3d_rec(&(plane->normal_cosine));
      printf("plane_0_vector...\n");pr_vector_3d_rec(&(plane->plane_0_vector));
      printf("plane_max_vector...\n");pr_vector_3d_rec(&(plane->plane_max_vector));
      printf("\n");
     )

}


/*------------------------------------------------------------------------
move_center_by_planexyz - ???
------------------------------------------------------------------------*/

int
move_center_by_planexyz(plane,planex,planey,planez,center)
 struct plane_3d_rec *plane;
 float planex,planey,planez;
 struct vector_3d_rec *center;
{
 struct vector_3d_rec v1;

 PRT9(printf(" move planex = %f y = %f = %f...\n",planex,planey,planez);)
 PlaneXYZToLocalXYZ(plane,planex,planey,planez,
         &(center->x),&(center->y),&(center->z),0);
 PlaneXYZToLocalXYZ(plane,.0,.0,.0,&(v1.x),&(v1.y),&(v1.z),0);
 sub_vectors(center,&v1,center);
 add_vector_3d(center,&(plane->base));
 return NO_ERROR;
}


/*------------------------------------------------------------------------
RotatePlaneLine - ???
------------------------------------------------------------------------*/

void
RotatePlaneLine(plane,planex1,planey1,planex2,planey2,rot_deg,
                rplanex1,rplaney1,rplanex2,rplaney2)
 struct plane_3d_rec *plane;
 float planex1,planey1,planex2,planey2,rot_deg;
 float *rplanex1,*rplaney1,*rplanex2,*rplaney2;
{
 float planez,rot_rad;
 struct vector_3d_rec v1,v2;
 struct matrix_3d_rec xyztoplane,planetoxyz;

 PlaneXYZToLocalXYZ(plane,planex1,planey1,.0,&(v1.x),&(v1.y),&(v1.z),0);
 trans_3d_pt(&(plane->xyztoplane),&v1,&v1,0);
 PlaneXYZToLocalXYZ(plane,planex2,planey2,.0,&(v2.x),&(v2.y),&(v2.z),0);
 trans_3d_pt(&(plane->xyztoplane),&v2,&v2,0);
 xyztoplane = plane->xyztoplane;
 rot_rad = radian(rot_deg);
 zrotate_3d_matrix(&xyztoplane,rot_rad);
 inverse_4d_matrix(&planetoxyz,&xyztoplane);
 trans_3d_pt(&planetoxyz,&v1,&v1,0);
 trans_3d_pt(&planetoxyz,&v2,&v2,0);

 LocalXYZToPlaneXYZ(plane,v1.x,v1.y,v1.z,rplanex1,rplaney1,&planez);
 PRT10(printf("rot_deg = %f planex1 = %f planey1 = %f\n",rot_deg,planex1,planey1);
       printf("rplanex1 = %f rplaney1 = %f planez = %f\n",*rplanex1,*rplaney1,
              planez);
      )

 LocalXYZToPlaneXYZ(plane,v2.x,v2.y,v2.z,rplanex2,rplaney2,&planez);
 PRT10(printf("planex2 = %f planey2 = %f\n",planex2,planey2);
       printf("rplanex2 = %f rplaney2 = %f planez = %f\n",*rplanex2,*rplaney2,
              planez);
      )
}
