/****************************************************************************
rd_text.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: rd_text.c,v 1.13 1999/07/07 18:18:15 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <string.h>
#include <sys/types.h>

#include "error_constants.h"
#include "debug.h"
#include "nria_lib.h"


/* used in rd_text.c  */
#define RD_TEXT 1
#define RD_INT  2
#define RD_FLOAT 3



/*------------------------------------------------------------------------
rd_text_text - ???
------------------------------------------------------------------------*/

void
rd_text_text(fid,ary,tot,ok,str,indx,is_one_line)
     FILE *fid;
     char *ary;
     unsigned int *tot;
     int *ok;
     char str[256];
     unsigned int *indx;
     int is_one_line;
{
  char *addr,*addr1,*addr2,*addr3;
  static char delimiter[] = {' ','\t','\n','\0'};
  unsigned int len,len1;


  *ok = NO_ERROR;
  addr = NULL;

  if (*indx != 0)
    len1 = strlen(str);


  while (addr == NULL) {

    if (*indx == 0) {

      if (fgets( str, 255, fid ) == NULL) {
	str[0] = '\0';
	len1 = 0;
	*ok = END_OF_FILE;
	break;
      }

      len1 = strlen(str);
      *(str + len1 - 1) = '\0';	/* Remove newline */
    }


    /*  Completely ignore comment and empty lines  */
    if (str[0] == '#' || str[0] == '\0')
      continue;


    if ((addr = strchr(str,'#')) != 0)
      addr[0] = '\0';


    if (((addr = strchr(&(str[*indx]),'%')) != 0) &&
	((addr1 = strchr(addr+1,'%')) != 0)) {

      addr1[0] = '\0';
      addr3 = &(str[*indx]);
      addr2 = strtok(addr3,delimiter);
      len = strlen(addr2);

      if (len < (addr - addr3)) {
	addr1[0] = '%';
	addr = addr3;
      }

      else {
	addr += 1;
	addr2[len] = ' ';
      }
    }

    else if (((addr = strchr(&(str[*indx]),'"')) != 0) &&
	     ((addr1 = strchr(addr+1,'"')) != 0)) {

      addr1[0] = '\0';
      addr3 = &(str[*indx]);
      addr2 = strtok(addr3,delimiter);
      len = strlen(addr2);

      if (len < (addr - addr3)) {
	addr1[0] = '"';
	addr = addr3;
      }

      else {
	addr += 1;
	addr2[len] = ' ';
      }
    }

    else {
      /* No quotes, no percent signs */
      addr = strtok(&(str[*indx]),delimiter);
    }

    if (addr == NULL)
      *indx = 0;

    if (is_one_line)
      break;
  }


  if ((*ok == NO_ERROR) && (addr != NULL)) {

    len = strlen(addr);
    *indx = addr - str + len + 1;

    if (len >= *tot) {
      len = *tot - 1;
      strncpy(ary,addr,(size_t) len);
      ary[*tot] = '\0';
    }

    else
      strcpy(ary,addr);

    *tot = len;

    if (*indx >= len1)
      *indx = 0;
  }

  else if ((*ok != NO_ERROR) || (addr == NULL))
    *tot = 0;
}



/*------------------------------------------------------------------------
rd_text_line - ???
------------------------------------------------------------------------*/

int
rd_text_line(fid,str,len,maxlen)
     FILE *fid;
     char *str;
     unsigned int *len,maxlen;
{
  *len = 0;
  if (fgets(str,(size_t) maxlen,fid) == NULL) {
    str[0] = '\0';
    len = 0;
    return END_OF_FILE;
  }
  *len = strlen(str);
  return NO_ERROR;
}



/*------------------------------------------------------------------------
def_rd_signed_int - ???
------------------------------------------------------------------------*/

void
def_rd_signed_int(fid,num,lb,ub,defnum)
     FILE *fid;
     int *num,lb,ub,defnum;
{
  char str[30];
  unsigned int len;

  rd_text_line(fid,str,&len,30);
  *num = defnum;
  sscanf(str,"%d",num);
  if ((*num < lb) || (*num > ub))
    *num = defnum;
}



/*------------------------------------------------------------------------
range_rd_signed_int - ???
------------------------------------------------------------------------*/

void
range_rd_signed_int(fid,num,lb,ub,defnum)
     FILE *fid;
     int *num,lb,ub,defnum;
{
  char str[30],str1[256];
  unsigned int len,len1;
  int ok;

  len = sizeof(str);
  len1 = 0;
  rd_text_text(fid,str,&len,&ok,str1,&len1,0); 
  *num = defnum;
  if ((len == 0) || (ok != NO_ERROR))
    return;
  sscanf(str,"%d",num);
  if ((*num < lb) || (*num > ub))
    *num = defnum;
}



/*------------------------------------------------------------------------
def_rd_float - ???
------------------------------------------------------------------------*/

void
def_rd_float(fid,num,lb,ub,defnum)
     FILE *fid;
     float *num,lb,ub,defnum;
{
  char str[30];
  unsigned int len;

  rd_text_line(fid,str,&len,30);
  *num = defnum;
  sscanf(str,"%f",num);
  if ((*num < lb) || (*num > ub))
    *num = defnum;
}



/*------------------------------------------------------------------------
range_rd_float - ???
------------------------------------------------------------------------*/

void
range_rd_float(fid,num,lb,ub,defnum)
     FILE *fid;
     float *num,lb,ub,defnum;
{
  char str[30],str1[256];
  unsigned int len,len1;
  int ok;

  len = sizeof(str);
  len1 = 0;
  rd_text_text(fid,str,&len,&ok,str1,&len1,0); 
  *num = defnum;
  if ((len == 0) || (ok != NO_ERROR))
    return;
  sscanf(str,"%f",num);
  if ((*num < lb) || (*num > ub))
    *num = defnum;
}



/*------------------------------------------------------------------------
get_text_int - ???
------------------------------------------------------------------------*/

void
get_text_int(str,indx,ary,tot,cnt,ok)
     char *str;
     unsigned int *indx;
     int *ary;
     unsigned int tot,*cnt;
     int *ok;
{
  unsigned int len;
  char done,*addr;
  static char delimiter[] = { ' ', '\t', '\n', '\0' };


  addr = strtok(&(str[*indx]),delimiter);		
  *ok = NO_ERROR;
  if (addr == NULL)
    *indx = 0;
  else {
    for (done = 0; !done && (*cnt < tot) && (addr != NULL);) {
      if ((*ok = sscanf(addr,"%d",&(ary[*cnt]))) == 1) {
	*cnt += 1;
	if (*cnt < tot)
	  addr = strtok(NULL,delimiter);
      }
      else {
	done = 1;
	*indx = 0;
	if (*ok == EOF)
	  *ok = NO_ERROR;
	else
	  *ok = READ_ERROR;
      }
    }
    if (!done) {
      if (addr == NULL)
	*indx = 0;
      else
      {
	len = strlen(addr);
	*indx = addr - str + len + 1;
      }
      *ok = NO_ERROR;
    }
    else if (addr == NULL)
      *indx = 0;
    else if (*ok == NO_ERROR)
      *indx = addr - str + 1;
  }
}



/*------------------------------------------------------------------------
rd_text_int - ???

Read in text from file fid and extract integer
------------------------------------------------------------------------*/

void
rd_text_int( fid, ary, tot, ok, str, indx )
     FILE *fid;			/* File from which to read */
     int *ary;			/*
				 * Storage space for integers (MUST be
				 * large enough to store tot number of
				 * sizeof(int)!)
				 */
     unsigned int *tot;		/* How many integers in a row to be read */
     int *ok;
     char str[256];		/* Read buffer: MUST be at least 256 chars
				   large */
     unsigned int *indx;	/* Current index (into buffer) holder */
{
  unsigned int	len1 = 0;
  unsigned int	cnt = 0;
  char *	str1 = NULL;


  *ok = NO_ERROR;
  cnt = 0;

  /* If we are at the beginning of the line, then our current length is zero.
   * Otherwise, take into account what has been previously read. */
  if (*indx != 0)
    len1 = strlen(str);
  else
    len1 = 0;

  while ((*ok == NO_ERROR) && (cnt < *tot))
  {

    /* fgets(): read up to next newline or 256 characters,
       whichever comes first; returns NULL on EOF or error */
    if ((*indx >= len1) && (fgets( str, 256, fid ) == NULL)) {
      str[0] = '\0';
      *ok = END_OF_FILE;
      *tot = cnt;
      continue;
    }


    /*  Completely ignore comment and empty lines  */
    if (str[0] == '#' || str[0] == '\0')
      continue;


    if (*indx >= len1) {
      *indx = 0;
      len1 = strlen(str);
      *(str + len1 - 1) = '\0';  /* Remove newline */
    }

    if ((str1 = strchr( str, '#' )) != 0)
      str1[0] = '\0';

    get_text_int( str, indx, ary, *tot, &cnt, ok );

    if (*indx == 0)
      len1 = 0;

  }

  if (*indx >= len1)
    *indx = 0;
}



/*------------------------------------------------------------------------
get_text_float - ???
------------------------------------------------------------------------*/

void
get_text_float(str,indx,ary,tot,cnt,ok)
     char *str;
     unsigned int *indx;
     float *ary;
     unsigned int tot,*cnt;
     int *ok;
{
  unsigned int len;
  char done,*addr;
  static char delimiter[] = { ' ', '\t', '\n', '\0' };

  addr = strtok(&(str[*indx]),delimiter);		
  *ok = NO_ERROR;
  if (addr == NULL)
    *indx = 0;
  else {
    for (done = 0; !done && (*cnt < tot) && (addr != NULL);) {
      if ((*ok = sscanf(addr,"%e",&(ary[*cnt]))) == 1) {
	*cnt += 1;
	if (*cnt < tot)
	  addr = strtok(NULL,delimiter);
      }
      else {
	done = 1;
	*indx = 0;
	if (*ok == EOF)
	  *ok = NO_ERROR;
	else
	  *ok = READ_ERROR;
      }
    }
    if (!done) {
      if (addr == NULL)
	*indx = 0;
      else {
	len = strlen(addr);
	*indx = addr - str + len + 1;
      }
      *ok = NO_ERROR;
    }
    else if (addr == NULL)
      *indx = 0;
    else if (*ok == NO_ERROR)
      *indx = addr - str + 1;
  }
}



/*------------------------------------------------------------------------
rd_text_float - ???
------------------------------------------------------------------------*/

void
rd_text_float(fid,ary,tot,ok,str,indx)
     FILE *fid;
     float *ary;
     unsigned int *tot;
     int *ok;
     char str[256];
     unsigned int *indx;
{
  unsigned int cnt,len1;
  char *str1;


  *ok = NO_ERROR;
  cnt = 0;

  if (*indx != 0)
    len1 = strlen(str);
  else
    len1 = 0;


  while ((*ok == NO_ERROR) && (cnt < *tot)) {

    if ((*indx >= len1) && (fgets( str, 255, fid ) == NULL)) {
      str[0] = '\0';
      *ok = END_OF_FILE;
      *tot = cnt;
      continue;
    }


    /*  Completely ignore comment and empty lines  */
    if (str[0] == '#' || str[0] == '\0')
      continue;


    if (*indx >= len1) {
      *indx = 0;
      len1 = strlen(str);
      *(str + len1 - 1) = '\0';  /* Remove newline */
    }


    if ((str1 = strchr(str,'#')) != 0)
      str1[0] = '\0';

    get_text_float( str, indx, ary, *tot, &cnt, ok );

    if (*indx == 0)
      len1 = 0;
  }

  if (*indx >= len1)
    *indx = 0;
}



/*------------------------------------------------------------------------
RdText - ???
------------------------------------------------------------------------*/

int
RdText(fid,ary,tot,select,is_flush_input_before)
     FILE *fid;
     char *ary;
     unsigned int *tot;
     unsigned char select;
     int is_flush_input_before;
{
  static unsigned int indx;
  static char str[256];
  static FILE *temp_fid = NULL;
  int err;


  if ((temp_fid == NULL) || (temp_fid != fid) || is_flush_input_before) {
    temp_fid = fid;
    indx = 0;
  }


  if (select == RD_TEXT)
    rd_text_text(fid,ary,tot,&err,str,&indx,0);
  else if (select == RD_INT)
    rd_text_int(fid,ary,tot,&err,str,&indx);
  else if (select == RD_FLOAT)
    rd_text_float(fid,ary,tot,&err,str,&indx);
  else {
    *tot = 0;
    return NO_ERROR;
  }


  if ((err == NO_ERROR) && (indx != 0)) {
    str[0] = ' ';
    strcpy(&(str[1]),&(str[indx]));
    indx = 1;
  }

  return err;
}



/*------------------------------------------------------------------------
rd_all_texts - ???
------------------------------------------------------------------------*/

int
rd_all_texts(fid,strs,num_strs)
     FILE *fid;
     char ***strs;
     unsigned int *num_strs;
{
  char str[256];
  unsigned int len;
  int err;

  err = NO_ERROR;
  do {
    len = 256;
    if ((err = RdText(fid,str,&len,RD_TEXT,0)) == NO_ERROR)
    {
      if ((err = get_handle(strs,num_strs,(unsigned int) 1,
			    (size_t) sizeof(char *))) == NO_ERROR)
	if ((err = cp_str(&((*strs)[*num_strs - 1]),str))
	    != NO_ERROR) {
	  DropHandleAryPtr(strs,num_strs,(*strs)[*num_strs - 1]);
	  break;
	}
    }
  }
  while (err == NO_ERROR);
  if (err == END_OF_FILE)
    return NO_ERROR;
  return err;
}



/*------------------------------------------------------------------------
rd_all_file_texts - ???
------------------------------------------------------------------------*/

int
rd_all_file_texts(fn,strs,num_strs)
     char *fn;
     char ***strs;
     unsigned int *num_strs;
{
  FILE *fid;
  int err;

  *num_strs = 0;
  *strs = NULL;
  if (fn == NULL)
    return FILE_NAME_ERROR;
  if ((fid = fopen(fn,"r")) == NULL) {
    return FILE_ACCESS_ERROR;
  }
  err = rd_all_texts(fid,strs,num_strs);
  fclose(fid);
  return err;
}



/*------------------------------------------------------------------------
rd_text_fields - ???
------------------------------------------------------------------------*/

int
rd_text_fields(fid,labels,num_labels)
     FILE *fid;
     char ***labels;
     unsigned int *num_labels;
{
  unsigned int total,num,cnt;
  char str[256];
  int err;

  *num_labels = 0;
  *labels = NULL;
  total = 1;
  if ((err = RdText(fid,&num,&total,RD_INT,0)) != NO_ERROR)
    return err;
  if (num == 0)
    return NO_ERROR;
  total = 0;
  get_ptr_memory(labels,&total,num,(size_t) sizeof(char *),&err);
  if (err)
    return err;
  *num_labels = num;

  for (cnt = 0; cnt < num; cnt++) {
    total = 255;
    if ((err = RdText(fid,str,&total,RD_TEXT,0)) != NO_ERROR)
      return err;
    if ((err = cp_str(&((*labels)[cnt]),str)) != NO_ERROR)
      return err;
  }
  return NO_ERROR;
}



/*------------------------------------------------------------------------
wr_all_texts - ???
------------------------------------------------------------------------*/

int
wr_all_texts(fid,strs,num_strs)
     FILE *fid;
     char **strs;
     unsigned int num_strs;
{
  unsigned int lcv,len,blank_posi;
  int err;


  for (lcv = 0; lcv < num_strs; lcv++) {
    len = get_strlen(strs[lcv]);
    if (len > 0) {
      if ((err = blank_in_str(strs[lcv],&blank_posi)) == NO_ERROR) {
	if (fprintf(fid,"\"%s\"\n",strs[lcv]) == 0) {
	  return WRITE_ERROR;
	}
      }
      else if (fprintf(fid,"%s\n",strs[lcv]) == 0) {
	return WRITE_ERROR;
      }
    }
    else if (fprintf(fid,"\n") == 0) {
      return WRITE_ERROR;
    }
  }
  return NO_ERROR;
}



/*------------------------------------------------------------------------
wr_all_file_texts - ???
------------------------------------------------------------------------*/

int
wr_all_file_texts(fn,strs,num_strs)
     char *fn;
     char **strs;
     unsigned int num_strs;
{
  FILE *fid;
  int err;


  if (fn == NULL)
    return FILE_NAME_ERROR;
  if ((fid = fopen(fn,"w")) == NULL) {
    return FILE_ACCESS_ERROR;
  }
  err = wr_all_texts(fid,strs,num_strs);
  fclose(fid);
  return err;
}
