/****************************************************************************
region.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: region.c,v 1.5 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <math.h>

#include "rect.h"
#include "nria_lib.h"


/*
cc -c region.c
cc -o region region.c
cc -o t6 t6.c $lib/rect_opr.o $lib/str.o $lib/ptr_and_dim.o -lm
*/


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)




/*-------------------------------------------------------------------------
init_dimension - ???

  magrect ... the [left,top] specify the mag factors in the x & y directions,
              and the [width,height] specify the max mag factors in the x & y.
----------------------------------------------------------------------------*/

void
init_dimension(dim,limitrr,rr,magrect,limitboundrect,bound)
 struct int_region_rect *dim;
 struct int_rect_rec *limitrr,*rr;
 struct int_rect_rec *magrect,*limitboundrect;
 struct int_bound_rec *bound; 
{
 dim->limitrr = *limitrr;
 dim->rr = *rr;
 dim->limitboundrect = *limitboundrect;
 dim->bound = *bound;
 dim->magrect = *magrect;
}

/*******************
init_int_region_rect(dimension,win_dimx,win_dimy,dimx,dimy,
                     left,right,top,bottom)
 struct int_region_rect *dimension;
 int win_dimx,win_dimy;
 int dimx,dimy,left,top,right,bottom;
{
 dimension->win_dimx = win_dimx;
 dimension->win_dimy = win_dimy;
 dimension->dimx = dimx;
 dimension->dimy = dimy;
 dimension->left = left;
 dimension->top = top;
 dimension->right = right;
 dimension->bottom = bottom;
}
*******************************/


/*----------------------------------------------------------------------
set_bound_by_int_rect - ???
----------------------------------------------------------------------*/

void
set_bound_by_int_rect(bound,rr)
 struct int_bound_rec *bound; 
 struct int_rect_rec *rr;
{
 setup_int_bound_rec(bound,rr->left,rr->top,rr->left + rr->width - 1,
                     rr->top + rr->height - 1);
}


/*----------------------------------------------------------------------
bound_centerx - ???
----------------------------------------------------------------------*/

int
bound_centerx(bound)
 struct int_bound_rec *bound; 
{
 return (bound->left + bound->right) / 2;
}


/*----------------------------------------------------------------------
 - ???
----------------------------------------------------------------------*/

int
bound_centery(bound)
 struct int_bound_rec *bound; 
{
 return (bound->top + bound->bottom) / 2;
}


/*----------------------------------------------------------------------
move_bound_in_xdim - ???
----------------------------------------------------------------------*/

void
move_bound_in_xdim(bound,limitboundrect,leftoffset,rightoffset)
 struct int_bound_rec *bound; 
 struct int_rect_rec *limitboundrect;
 int leftoffset,rightoffset;
{
 int temp,temp1;

 temp = bound->left - leftoffset;
 if (temp < limitboundrect->left)
    {bound->left = limitboundrect->left;
     rightoffset += limitboundrect->left - temp;
    }
   else bound->left = temp;
 temp = bound->right + rightoffset;
 temp1 = limitboundrect->left + limitboundrect->width;
 if (temp >= temp1)
    {bound->right = temp1 - 1;
     leftoffset = temp - temp1;
     bound->left = bound->left - leftoffset;
     if (bound->left < limitboundrect->left) 
        bound->left = limitboundrect->left;
    }
   else bound->right = temp;

}


/*----------------------------------------------------------------------
move_bound_in_ydim - ???
----------------------------------------------------------------------*/

void
move_bound_in_ydim(bound,limitboundrect,topoffset,bottomoffset)
 struct int_bound_rec *bound; 
 struct int_rect_rec *limitboundrect;
 int topoffset,bottomoffset;
{
 int temp,temp1;

 temp = bound->top - topoffset;
 if (temp < limitboundrect->top)
    {bound->top = limitboundrect->top;
     bottomoffset += limitboundrect->top - temp;
    }
   else bound->top = temp;
 temp = bound->bottom + bottomoffset;
 temp1 = limitboundrect->top + limitboundrect->height;
 if (temp >= temp1)
    {bound->bottom = temp1 - 1;
     topoffset = temp - temp1;
     bound->top = bound->top - topoffset;
     if (bound->top < limitboundrect->top) bound->top = limitboundrect->top;
    }
   else bound->bottom = temp;

}


/*----------------------------------------------------------------------
in_bound - ???
----------------------------------------------------------------------*/

void
in_bound(bound,limitboundrect)
 struct int_bound_rec *bound; 
 struct int_rect_rec *limitboundrect;
{
 int width,right;

 width = bound->right - bound->left + 1;
 right = limitboundrect->left + limitboundrect->width - 1;
 if (bound->left < limitboundrect->left)
    {bound->left = limitboundrect->left;
     bound->right = bound->left + width - 1;
     if (bound->right > right) bound->right = right;}
   else if (bound->right > right)
    {bound->right = right;
     bound->left = right - width + 1;
     if (bound->left < limitboundrect->left)
	 bound->left = limitboundrect->left;}

}


/*----------------------------------------------------------------------
expand_bound_in_xdim - ???
----------------------------------------------------------------------*/

void
expand_bound_in_xdim(bound,limitboundrect,width)
 struct int_bound_rec *bound; 
 struct int_rect_rec *limitboundrect;
 int width;
{
 int half,half1,width1;

 if (width > limitboundrect->width) width = limitboundrect->width;
 width1 = width - (bound->right - bound->left + 1);
 if (width1 == 0) return;
 half = width1 / 2;
 if (width1 % 2)
    {if (width1 < 0) half1 = half - 1;
       else half1 = half + 1;}
   else half1 = half;
 move_bound_in_xdim(bound,limitboundrect,half,half1);
}


/*----------------------------------------------------------------------
expand_bound_in_ydim - ???
----------------------------------------------------------------------*/

void
expand_bound_in_ydim(bound,limitboundrect,height)
 struct int_bound_rec *bound; 
 struct int_rect_rec *limitboundrect;
 int height;
{
 int half,half1,height1;

 if (height > limitboundrect->height) height = limitboundrect->height;
 height1 = height - (bound->bottom - bound->top + 1);
 if (height1 == 0) return;

 half = height1 / 2;
 if (height1 % 2) 
    {if (height1 < 0) half1 = half - 1;
       else half1 = half + 1;}
   else half1 = half;

 move_bound_in_ydim(bound,limitboundrect,half,half1);
}


/*----------------------------------------------------------------------
center_bound_in_xdim - ???
----------------------------------------------------------------------*/

void
center_bound_in_xdim(bound,limitboundrect,use_center,centerx)
 struct int_bound_rec *bound;
 struct int_rect_rec *limitboundrect;
 int use_center,centerx;
{
 int width,half,half1;

 width = bound->right - bound->left + 1;
 half1 = half = width / 2;
 if (width % 2) half1 += 1;
 if (use_center) centerx = limitboundrect->left + limitboundrect->width / 2;
 bound->left = centerx - half;
 bound->right = centerx + half1 - 1;
 if (use_center) move_bound_in_xdim(bound,limitboundrect,0,0);
}


/*----------------------------------------------------------------------
center_bound_in_ydim - ???
----------------------------------------------------------------------*/

void
center_bound_in_ydim(bound,limitboundrect,use_center,centery)
 struct int_bound_rec *bound;
 struct int_rect_rec *limitboundrect;
 int use_center,centery;
{
 int height,half,half1;

 height = bound->bottom - bound->top + 1;
 half1 = half = height / 2;
 if (height % 2) half1 += 1;
 if (use_center) centery = limitboundrect->top + limitboundrect->height / 2;
 bound->top = centery - half;
 bound->bottom = centery + half1 - 1;
 if (!use_center) move_bound_in_ydim(bound,limitboundrect,0,0);
}


/*----------------------------------------------------------------------
center_bound - ???
----------------------------------------------------------------------*/

void
center_bound(bound,limitboundrect,use_center,centerx,centery)
 struct int_bound_rec *bound;
 struct int_rect_rec *limitboundrect;
 int use_center,centerx,centery;
{
 center_bound_in_xdim(bound,limitboundrect,use_center,centerx);
 center_bound_in_ydim(bound,limitboundrect,use_center,centery);
}


/*----------------------------------------------------------------------
validate_boundx - ???
----------------------------------------------------------------------*/

void
validate_boundx(bound,limitboundrect,invalidate_reset)
 struct int_bound_rec *bound;
 struct int_rect_rec *limitboundrect;
 int invalidate_reset;
{
 int right,left1,right1;

 right = limitboundrect->left + limitboundrect->width - 1;
 if (invalidate_reset)
    {left1 = bound->left;
     right1 = right;}
 get_valid_value(&(bound->left),limitboundrect->left,right,bound->left);
 get_valid_value(&(bound->right),limitboundrect->left,right,bound->right);
 if (invalidate_reset)
    if ((left1 != bound->left) || (right1 != bound->right))
       {bound->left = limitboundrect->left;
        bound->right = right;}
}


/*----------------------------------------------------------------------
validate_boundy - ???
----------------------------------------------------------------------*/

void
validate_boundy(bound,limitboundrect,invalidate_reset)
 struct int_bound_rec *bound;
 struct int_rect_rec *limitboundrect;
 int invalidate_reset;
{
 int bottom,top1,bottom1;

 bottom = limitboundrect->top + limitboundrect->height - 1;
 if (invalidate_reset)
    {top1 = bound->top;
     bottom1 = bottom;}
 get_valid_value(&(bound->top),limitboundrect->top,bottom,bound->top);
 get_valid_value(&(bound->bottom),limitboundrect->top,bottom,bound->bottom);
 if (invalidate_reset)
    if ((top1 != bound->top) || (bottom1 != bound->bottom))
       {bound->top = limitboundrect->top;
        bound->bottom = bottom;}
}



/*----------------------------------------------------------------------
define_dimension_by_fixed_magx - ???
----------------------------------------------------------------------*/

void
define_dimension_by_fixed_magx(dim)
 struct int_region_rect *dim;
{
 int width,width1;

 TRACE(printf("DIM_FIXED_MAG...x\n"))
 width1 = dim->bound.right - dim->bound.left + 1;
 width = (int) floor((double) dim->rr.width / (double) dim->magrect.left + .5);
 if (width == 0)
    {dim->magrect.left = dim->rr.width;
     width = 1;}
   else if ((width * dim->magrect.left) > dim->limitrr.width)
    width -= 1;
 expand_bound_in_xdim(&(dim->bound),&(dim->limitboundrect),width);

}


/*----------------------------------------------------------------------
define_dimension_by_fixed_magy - ???
----------------------------------------------------------------------*/

void
define_dimension_by_fixed_magy(dim)
 struct int_region_rect *dim;
{
 int height,height1;

 TRACE(printf("DIM_FIXED_MAG...y\n"))
 height1 = dim->bound.bottom - dim->bound.top + 1;
 height = (int) floor((double) dim->rr.height / (double) dim->magrect.top + .5);
 if (height == 0)
    {dim->magrect.top = dim->rr.height;
     height = 1;}
   else if ((height * dim->magrect.top) > dim->limitrr.height)
    height -= 1;
 expand_bound_in_ydim(&(dim->bound),&(dim->limitboundrect),height);
}


/*----------------------------------------------------------------------
define_dimension_by_fixed_boundx - ???
----------------------------------------------------------------------*/

void
define_dimension_by_fixed_boundx(dim,opr,CanChangeBound)
 struct int_region_rect *dim;
 int opr,CanChangeBound;
{
 int width1;

 PRT(printf("DIM_FIXED_BOUND...x..opr = %d CanChangeBound = %d\n",opr,CanChangeBound))
 width1 = dim->bound.right - dim->bound.left + 1;
 if (width1 > dim->limitrr.width)
    {dim->magrect.left = 1;
     dim->bound.right = dim->bound.left + dim->limitrr.width - 1;
     return;
    }
 PRT(printf("dim->rr.width = %d  width1 = %d\n",dim->rr.width,width1))
 dim->magrect.left = dim->rr.width / width1;
 if (!(opr & DIM_SHRINK))
    {if (dim->rr.width % width1)
        if ((dim->magrect.left + 1) * width1 <= dim->limitrr.width)
           dim->magrect.left += 1;
    }
   else
    {PRT(printf("DIM_FIXED_BOUND..X DIM_SHRINK...\n"))
    }
 if (dim->magrect.left == 0) 
    {dim->magrect.left = 1;
    }
  else if (dim->magrect.left > dim->magrect.width)
    {dim->magrect.left = dim->magrect.width;
     if (CanChangeBound) define_dimension_by_fixed_magx(dim);}
 PRT(printf("dim->magrect.left = %d\n",dim->magrect.left))
}


/*----------------------------------------------------------------------
define_dimension_by_fixed_boundy - ???
----------------------------------------------------------------------*/

void
define_dimension_by_fixed_boundy(dim,opr,CanChangeBound)
 struct int_region_rect *dim;
 int opr,CanChangeBound;
{
 int height1;

 PRT(printf("DIM_FIXED_BOUND...y..opr = %d CanChangeBound = %d\n",opr,CanChangeBound))
 height1 = dim->bound.bottom - dim->bound.top + 1;
 if (height1 > dim->limitrr.height)
    {dim->magrect.top = 1;
     dim->bound.bottom = dim->bound.top + dim->limitrr.height - 1;
     return;
    }
 dim->magrect.top = dim->rr.height / height1;
 PRT(printf("dim->rr.height = %d  height1 = %d\n",dim->rr.height,height1))
 if (!(opr & DIM_SHRINK))
    {if (dim->rr.height % height1)
        if ((dim->magrect.top + 1) * height1 <= dim->limitrr.height)
           dim->magrect.top += 1;
    }
   else
    {PRT(printf("DIM_SHRINK...\n"))
    }

 if (dim->magrect.top == 0) 
    {dim->magrect.top = 1;}
   else if (dim->magrect.top > dim->magrect.height)
    {dim->magrect.top = dim->magrect.height;
     if (CanChangeBound) define_dimension_by_fixed_magy(dim);}
 PRT(printf("dim->magrect.top = %d\n",dim->magrect.top))

}


/*----------------------------------------------------------------------
define_dimension_by_fixed_bound - ???
----------------------------------------------------------------------*/

void
define_dimension_by_fixed_bound(dim,opr,CanChangeBound)
 struct int_region_rect *dim;
 int opr;
{TRACE(printf("DIM_FIXED_BOUND..\n"))
 define_dimension_by_fixed_boundx(dim,opr,CanChangeBound);
 define_dimension_by_fixed_boundy(dim,opr,CanChangeBound);
 get_same_mag_factor(dim,opr);
}


/*----------------------------------------------------------------------
define_dimension_by_max_areax - ???
----------------------------------------------------------------------*/

void
define_dimension_by_max_areax(dim)
 struct int_region_rect *dim;
{
 int width,width1,magx,temp,max,lcv;
 struct int_bound_rec bound;

 TRACE(printf("DIM_MAX_AREA...x\n"))
 width1 = dim->limitboundrect.width;
 bound = dim->bound;
 for (magx = 0,max = 0,lcv = dim->magrect.width; lcv > 0; lcv--)
    {
     width = (int) ((float) dim->rr.width / (float) lcv);
     if (width == 0) continue;
     if (width > width1)
        {
         expand_bound_in_xdim(&bound,&(dim->limitboundrect),width);
         width = bound.right - bound.left + 1;
        }
     temp = lcv * width;
     TRACE(printf("lcv = %d  temp = %d  width = %d\n",lcv,temp,width))
     if (max < temp)
        {magx = lcv;
         bound = dim->bound;
         TRACE(printf("old max = %d new = %d magx = %d\n",max,temp,magx))
         max = temp;
        }
    }
 dim->magrect.left = magx;
 TRACE(printf("DIM_MAX_AREA...magx = %d\n",magx))
}


/*----------------------------------------------------------------------
define_dimension_by_max_areay - ???
----------------------------------------------------------------------*/

void
define_dimension_by_max_areay(dim)
 struct int_region_rect *dim;
{
 int height,height1,magy,temp,max,lcv;
 struct int_bound_rec bound;

 TRACE(printf("DIM_MAX_AREA...y\n"))
 height1 = dim->limitboundrect.height;
 for (magy = 0,max = 0,lcv = dim->magrect.height; lcv > 0; lcv--)
    {
     height = (int) ((float) dim->rr.height / (float) lcv);
     if (height == 0) continue;
     if (height > height1)
        {if ((temp * height1) > dim->limitboundrect.height) continue;
         expand_bound_in_ydim(&bound,&(dim->limitboundrect),height);
         height = bound.bottom - bound.top + 1;
        }
     temp = lcv * height;
     TRACE(printf("lcv = %d  temp = %d  height = %d\n",lcv,temp,height))
     if (max < temp)
        {magy = lcv;
         bound = dim->bound;
         TRACE(printf("old max = %d new = %d magx = %d\n",max,temp,magy))
         max = temp;}
    }
 dim->magrect.top = magy;
 TRACE(printf("DIM_MAX_AREA...magy = %d\n",magy))
}


/*----------------------------------------------------------------------
get_same_mag_factor - ???
----------------------------------------------------------------------*/

void
get_same_mag_factor(dim,opr)
 struct int_region_rect *dim;
 int opr;
{
 int bigger,smaller,temp;

 if (opr & DIM_OPR_SAME_DIM_MAG_FACTOR)
    if (dim->magrect.top != dim->magrect.left)
       if (opr & DIM_OPR_USE_SMALLER_MAG_FACTOR) 
          {if (dim->magrect.top > dim->magrect.left)
              dim->magrect.top = dim->magrect.left;
             else
              dim->magrect.left = dim->magrect.top;}
         else
          {if (dim->magrect.top > dim->magrect.left)
              {bigger = dim->magrect.top;
               smaller = dim->magrect.left;}
            else
              {bigger = dim->magrect.top;
               smaller = dim->magrect.left;}
           temp = dim->bound.right - dim->bound.left + 1;
           if ((bigger * temp) > dim->rr.width) bigger = smaller;
           temp = dim->bound.bottom - dim->bound.top + 1;
           if ((bigger * temp) > dim->rr.height) bigger = smaller;
           dim->magrect.top = dim->magrect.left = bigger;
          }
}


/*----------------------------------------------------------------------
define_dimension_by_max_area - ???
----------------------------------------------------------------------*/

void
define_dimension_by_max_area(dim,opr)
 struct int_region_rect *dim;
 int opr;
{
 TRACE(printf("DIM_MAX_AREA..\n"))
 define_dimension_by_max_areax(dim);
 define_dimension_by_max_areay(dim);

 if (opr & DIM_OPR_SAME_DIM_MAG_FACTOR)
    get_same_mag_factor(dim,opr);

 define_dimension_by_fixed_magx(dim);
 define_dimension_by_fixed_magy(dim);
 TRACE(printf("effective magx = %d magy = %d\n",dim->magrect.left,
           dim->magrect.top))
}

/************************
#define DIM_MAX_AREA 1
#define DIM_FIXED_BOUND 2
#define DIM_FIXED_MAG 3

  opr 
       & DIM_CENTER_AT_LIMITBOUNDRECT
           if the focus is to move to the center of the limitboundrect

       & DIM_CENTER_AT_POINT
           if the focus is to move to the center specified by [centerx,centery].
           however, it may adjust itself if the new center is less
           than half the "bound" from the edges.

      otherwise
        the window will make self adjustment depending on the current value
           of "bound" so that the new center of the window is always >=
           the distance to the edges.

      [centerx,centery] can be simply 0s if opr is not & DIM_CENTER_AT_POINT.

      & 

define_dimension(dim,0,opr,centerx,centery)
    the initial mag factor & "bound" values are used and "rr" values
    are the multiplication of the 2.

define_dimension(dim,DIM_MAX_AREA,opr,centerx,centery)
define_dimension(dim,DIM_FIXED_BOUND,opr,centerx,centery)
define_dimension(dim,DIM_FIXED_MAG,opr,centerx,centery)
****************************/



/*----------------------------------------------------------------------
define_dimension - ???
----------------------------------------------------------------------*/

void
define_dimension(dim,HowToDefine,opr,centerx,centery)
 struct int_region_rect *dim;
 int HowToDefine,opr,centerx,centery;
{
 TRACE(printf("\n\n*********define_dimension...\n"))
 TRACE(pr_int_region_rect(dim))
 if (HowToDefine == DIM_MAX_AREA)
     define_dimension_by_max_area(dim,opr);
   else if (HowToDefine == DIM_FIXED_BOUND)
     define_dimension_by_fixed_bound(dim,opr,0);
  else if (HowToDefine == DIM_FIXED_MAG)
    {TRACE(printf("DIM_FIXED_BOUND..\n"))
     define_dimension_by_fixed_magx(dim);
     define_dimension_by_fixed_magy(dim);}

 if (opr & DIM_CENTER_AT_LIMITBOUNDRECT)
    center_bound(&(dim->bound),&(dim->limitboundrect),1,0,0);
   else if (opr & DIM_CENTER_AT_POINT)
    center_bound(&(dim->bound),&(dim->limitboundrect),0,centerx,centery);

 in_bound(&(dim->bound),&(dim->limitboundrect));
 setup_int_rect_rec(&(dim->rr),dim->rr.left,dim->rr.top,
         dim->magrect.left * (dim->bound.right - dim->bound.left + 1),
         dim->magrect.top * (dim->bound.bottom - dim->bound.top + 1));
 TRACE(pr_int_region_rect(dim))
 TRACE(printf("*********define_dimension..end\n\n"))

}


/*----------------------------------------------------------------------
valid_dimension - ???
----------------------------------------------------------------------*/

void
valid_dimension(dim1,dim2,left,right,top,bottom)
 struct int_region_rect *dim1,*dim2;
 int *left,*right,*top,*bottom;
{
 get_valid_value(left,dim2->bound.left,dim2->bound.right,dim1->bound.left);
 get_valid_value(right,dim2->bound.left,dim2->bound.right,dim1->bound.right);
 get_valid_value(top,dim2->bound.top,dim2->bound.bottom,dim1->bound.top);
 get_valid_value(bottom,dim2->bound.top,dim2->bound.bottom,dim1->bound.bottom);
}


/************************
get_valid_dimension_elems(dim,dimx,dimy,left,right,top,bottom)
 struct int_region_rect *dim;
 unsigned int dimx,dimy;
 int *left,*right,*top,*bottom;
{
 PRT1(printf("valid_dim bound l = %d t = %d r = %d b = %d\n",
    dim->bound.left,dim->bound.top,dim->bound.right,dim->bound.bottom))
 if ((dim->bound.left >= 0) && (dim->bound.left < dimx))
    *left = dim->bound.left;
   else *left = 0;
 if ((dim->bound.right >= 0) && (dim->bound.right < dimx))
    *right = dim->bound.right;
   else *right = dimx - 1;
 if ((dim->bound.top >= 0) && (dim->bound.top < dimy))
    *top = dim->bound.top;
   else *top = 0;
 if ((dim->bound.bottom >= 0) && (dim->bound.bottom < dimy))
    *bottom = dim->bound.bottom;
   else *bottom = dimy - 1;
}
**************************/


/*----------------------------------------------------------------------
is_pt_in_int_region_rect - ???
----------------------------------------------------------------------*/

int
is_pt_in_int_region_rect(r1,ptx,pty)
 struct int_region_rect *r1;
 int ptx,pty;
{
 if (is_pt_in_area(r1->bound.left,r1->bound.top,
             r1->bound.right,r1->bound.bottom,ptx,pty))
    return 1;
    else return 0;
}


/*----------------------------------------------------------------------
is_int_region_rect_intersect - ???
----------------------------------------------------------------------*/

int
is_int_region_rect_intersect(r1,r2)
 struct int_region_rect *r1,*r2;
{
 if ((is_between(r1->bound.left,r2->bound.left,r2->bound.right) ||
      is_between(r1->bound.right,r2->bound.left,r2->bound.right)) &&
     (is_between(r1->bound.top,r2->bound.top,r2->bound.bottom) ||
      is_between(r1->bound.bottom,r2->bound.top,r2->bound.bottom)))
    return 1;
   else if ((is_between(r2->bound.left,r1->bound.left,r1->bound.right) ||
      is_between(r2->bound.right,r1->bound.left,r1->bound.right)) &&
     (is_between(r2->bound.top,r1->bound.top,r1->bound.bottom) ||
      is_between(r2->bound.bottom,r1->bound.top,r1->bound.bottom)))
    return 1;
   else return 0;
}



/*----------------------------------------------------------------------
pr_int_region_rect - ???
----------------------------------------------------------------------*/

void
pr_int_region_rect(region)
 struct int_region_rect *region;
{
 printf("limitrr...");
 pr_int_rect_rec(&(region->limitrr));
 printf("rr...");
 pr_int_rect_rec(&(region->rr));
 printf("magrect...");
 pr_int_rect_rec(&(region->magrect));
 printf("limitboundrect...");
 pr_int_rect_rec(&(region->limitboundrect));
 printf("bound...");
 pr_int_bound_rec(&(region->bound));

}


/*----------------------------------------------------------------------
pr_int_bound_rec - ???
----------------------------------------------------------------------*/

void
pr_int_bound_rec(bound)
 struct int_bound_rec *bound;
{
 struct int_rect_rec rr;

 setup_int_rect_rec(&rr,bound->left,bound->top,bound->right - bound->left + 1,
                bound->bottom - bound->top + 1);
 pr_int_rect_rec(&rr);
}


/*----------------------------------------------------------------------
pt_as_center_or_within_int_region_rect - ???
----------------------------------------------------------------------*/

void
pt_as_center_or_within_int_region_rect(r1,x,y)
 struct int_region_rect *r1;
 int x,y;
{
 int refx,refy,diff;
 struct int_bound_rec *bound;

 if (pt_in_int_rect(&(r1->limitboundrect),x,y))
    {
     bound = &(r1->bound);
     refx = (bound->left + bound->right) / 2;
     refy = (bound->top + bound->bottom) / 2;
     move_area(&(bound->left),&(bound->top),&(bound->right),&(bound->bottom),
              refx,refy,x,y);
     diff = (bound->right - bound->left);
     if (bound->left < 0)
        {bound->left = 0;
         bound->right = bound->left + diff;
         if (bound->right >= r1->limitboundrect.width)
            bound->right = r1->limitboundrect.width - 1;
        }
       else if (bound->right >= r1->limitboundrect.width)
        {bound->right = r1->limitboundrect.width - 1;
         bound->left = bound->right - diff;
         if (bound->left < 0) bound->left = 0;
        }

     diff = (bound->bottom - bound->top);
     if (bound->top < 0)
        {bound->top = 0;
         bound->bottom = bound->top + diff;
         if (bound->bottom >= r1->limitboundrect.height)
            bound->bottom = r1->limitboundrect.height - 1;
        }
       else if (bound->bottom >= r1->limitboundrect.height)
        {bound->bottom = r1->limitboundrect.height - 1;
         bound->top = bound->bottom - diff;
         if (bound->top < 0) bound->top = 0;
        }
    }
}


/*----------------------------------------------------------------------
int_rect_to_bound - ???
----------------------------------------------------------------------*/

void
int_rect_to_bound(bound,rect)
 struct int_bound_rec *bound;
 struct int_rect_rec *rect;
{
 bound->left = rect->left;
 bound->top = rect->top;
 bound->right = rect->left + rect->width - 1;
 bound->bottom = rect->top + rect->height - 1;
}

/*****************************
main(argc,argv)
 int argc;
 char *argv[];
{
 struct int_rect_rec limitrr,rr,magrect,limitboundrect;
 struct int_bound_rec bound;
 struct int_region_rect dim;
 int mag,dims,size,win,how,center,centerx,centery;

 if (argc != 9) exit(0);
 sscanf(argv[1],"%d",&mag);
 sscanf(argv[2],"%d",&dims);
 sscanf(argv[3],"%d",&size);
 sscanf(argv[4],"%d",&win);
 sscanf(argv[5],"%d",&how);
 sscanf(argv[6],"%d",&center);
 sscanf(argv[7],"%d",&centerx);
 sscanf(argv[8],"%d",&centery);

 setup_int_rect_rec(&limitrr,0,0,1151,899);
 setup_int_rect_rec(&rr,0,0,win,win);
 setup_int_rect_rec(&magrect,mag,mag,20,20);
 setup_int_rect_rec(&limitboundrect,0,0,dims,dims);
 setup_int_bound_rec(&bound,0,0,size - 1,size - 1);
 init_dimension(&dim,&limitrr,&rr,&magrect,&limitboundrect,&bound);
 define_dimension(&dim,how,center,centerx,centery);
 pr_int_region_rect(&dim);
}

*********************************/
