/****************************************************************************
ria2mrvbr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: ria2mrvbrhdr.c,v 1.5 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <math.h>

#include <sys/types.h>

#include "typedef.h"
#include "mark_hdr.h"
#include "ia_hdr.h"
#include "error_constants.h"
#include "nria_lib.h"



/*--------------------------------------------------------------------------
assign_nhdr_to_hdr - ???
--------------------------------------------------------------------------*/

int
assign_nhdr_to_hdr(mark,hdr)
 struct mark_hdr *mark;
 struct hdr_rec *hdr;
{
 init_mark_hdr(mark);
 if (hdr->data_info.default_datafn != NULL)
    str_ncpy(mark->key.name,sizeof(mark->key.name),
             hdr->data_info.default_datafn);

 mark->dimen.num_dims = 3;
 mark->dimen.dimx = hdr->data_info.dimx;
 mark->dimen.dimy = hdr->data_info.dimy;
 mark->dimen.max_slices = hdr->data_info.max_scans;
 mark->dimen.num_vols = 0;
 mark->dimen.pixel_depth_bits = hdr->data_info.pixel_depth_bits;
 mark->dimen.xpixel_size = hdr->data_info.xpixel_size;
 mark->dimen.ypixel_size = hdr->data_info.ypixel_size;
 mark->dimen.pixel_thickness = hdr->data_info.pixel_thickness;
 mark->dimen.spacing = hdr->data_info.spacing;
 mark->dimen.plane_type = hdr->data_info.plane_type;
 mark->dimen.unused2 = hdr->data_info.unused2;
 mark->dimen.var_use_status = hdr->data_info.var_use_status;
 mark->dimen.num_echoes = hdr->data_info.num_echoes;
 mark->dimen.unused3 = hdr->data_info.unused3;
 mark->dimen.unused4 = hdr->data_info.unused4;
 mark->dimen.unused5 = hdr->data_info.unused5;
 mark->dimen.unused6 = hdr->data_info.unused6;
 mark->dimen.unused7 = hdr->data_info.unused7;
 mark->dimen.tr = hdr->data_info.tr;
 if (hdr->data_info.te != NULL)
    str_ncpy(mark->dimen.te,sizeof(mark->dimen.te),hdr->data_info.te);
 mark->dimen.glmax = (unsigned long) hdr->data_info.max_pixel;
 mark->dimen.glmin = (unsigned long) hdr->data_info.min_pixel;

 if (hdr->data_info.patient.name != NULL)
    str_ncpy(mark->history.patient.name,sizeof(mark->history.patient.name),
         hdr->data_info.patient.name);

 if (hdr->data_info.patient.ssnum != NULL)
    str_ncpy(mark->history.patient.ssnum,sizeof(mark->history.patient.ssnum),
         hdr->data_info.patient.ssnum);

 if (hdr->data_info.patient.patient_id != NULL)
    str_ncpy(mark->history.patient.patient_id,
         sizeof(mark->history.patient.patient_id),
         hdr->data_info.patient.patient_id);

 if (hdr->data_info.patient.study_num != NULL)
    str_ncpy(mark->history.patient.study_num,
         sizeof(mark->history.patient.study_num),
         hdr->data_info.patient.study_num);

 if (hdr->data_info.patient.patient_num != NULL)
    str_ncpy(mark->history.patient.patient_num,
         sizeof(mark->history.patient.patient_num),
         hdr->data_info.patient.patient_num);
 mark->history.patient.age = hdr->data_info.patient.age;
 mark->history.patient.sex = hdr->data_info.patient.sex;
 mark->history.patient.height = hdr->data_info.patient.height;
 mark->history.patient.weight = hdr->data_info.patient.weight;
 if (hdr->data_info.date_of_study != NULL)
    str_ncpy(mark->history.date_of_study,sizeof(mark->history.date_of_study),
         hdr->data_info.date_of_study);

 if (hdr->data_info.time_of_study != NULL)
    str_ncpy(mark->history.time_of_study,sizeof(mark->history.time_of_study),
         hdr->data_info.time_of_study);
 if (hdr->data_info.description != NULL)
    str_ncpy(mark->history.comment,sizeof(mark->history.comment),
         hdr->data_info.description);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
wr_hdr_file - ???
--------------------------------------------------------------------------*/

int
wr_hdr_file(fn,db)
 char *fn;
 struct mark_hdr *db;
{
 FILE *fid;

 if ((fid = fopen(fn,"w")) == NULL) return FILE_ACCESS_ERROR;

 if (fwrite(db,sizeof(struct mark_hdr),1,fid) != 1)
    {
     fclose(fid);
     printf("Error writing the mri.hdr file..%s!!!",fn);
     return READ_ERROR;}
 fclose(fid);
 return NO_ERROR;
}

