/****************************************************************************
systemspecif.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME: Some of this code appears to be relics from the VAX era.  Is
any of it still relevant and used?  Is it portable??  I have updated
to ANSI prototypes anyway.  -PWH 19990315
****************************************************************************/

static const char rcsid[] = "$Id: systemspecif.c,v 1.8 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>
#include <sys/types.h>

#include "error_constants.h"
#include "nria_lib.h"


#define PRT(x) x; fflush(stdout);
#undef PRT
#define PRT(x)

/* Functions defined in this file */
int rewind_the_tape(char *fn);
void skip_logical_end_of_tape(char *fn, long img_start);
void skip_tape_files(char *fn, long skip);
int rename_file(char *fn, char *outfn);
void swapUShorts(unsigned short *ushort_array, size_t len);
void swapULongs(unsigned long *ulong_array, size_t len);
unsigned short to_dec_short(int num);
unsigned long to_dec_long(unsigned long num);
void dec2sun_word(short buf[], int len);
void dec2sun_long(unsigned long buf[], int len);
float get_float_data(unsigned char fl_buf[4]);
void sun2dec_float(unsigned char *inbuf, unsigned char *outbuf);
void dec2sun_float(unsigned char *inbuf, unsigned char *outbuf);
void decfl2sun_float(double fl, unsigned char *outbuf);
void dec2sun_float_ary(float *in_ary, float *out_ary, unsigned long num_elems);
void pr_hex(unsigned char *hex_ary, unsigned long len);



/*---------------------------------------------------------------------------
rewind_the_tape - ???

FIXME:  This looks like a VAXish routine.  -PWH 19990430
---------------------------------------------------------------------------*/

int
rewind_the_tape(fn)
 char *fn;
{
 char str[100];

/*
 if (system(NULL))
    {
*/
 sprintf(str,"   mount/foreign/blocksize=8192 %s",fn);
/*
 msgs("Please wait !!!",4,"Rewinding the tape ...!!!",
      "Use this command : ",str,
      "  to mount the DEC tape drive...");
*/
 sprintf(str,"set magtape/rewind %s",fn);
 system(str);
 return NO_ERROR;
/*
    }
   else return ~NO_ERROR;
*/
}


/*---------------------------------------------------------------------------
skip_logical_end_of_tape - ???

FIXME:  This looks like a VAXish routine.  -PWH 19990430
---------------------------------------------------------------------------*/

void
skip_logical_end_of_tape(fn,img_start)
 char *fn;
 long img_start;
{
 char str1[200];

 sprintf(str1,"set magtape %s/skip=end_of_tape",fn);
 system(str1);
 if (img_start == 5)
    system(str1);
}


/*---------------------------------------------------------------------------
skip_tape_files - ???

FIXME:  This looks like a VAXish routine.  -PWH 19990430
---------------------------------------------------------------------------*/

void
skip_tape_files(fn,skip)
 char *fn;
 long skip;
{
 char str[200],str1[200];

 if (skip > 0)
    {sprintf(str,"***Skipping %ld image files!!!",skip);
     sprintf(str1,"set magtape/skip=files:%ld %s",skip,fn);
/*
     msgs("Please wait !!!",2,str,str1);
*/
     system(str1);
    }
}



/*---------------------------------------------------------------------------
rename_file - ???
---------------------------------------------------------------------------*/

int
rename_file(fn,outfn)
 char *fn,*outfn;
{
 return rename(fn,outfn);
}



/*---------------------------------------------------------------------------
swapUShorts - ???
---------------------------------------------------------------------------*/

void
swapUShorts( ushort_array, len )
     unsigned short *ushort_array;
     size_t len;
{
  unsigned char tmp;
  unsigned char *ptr = (unsigned char *) ushort_array;

  while (len--) {
    tmp = *ptr;
    *ptr = *(ptr + 1);
    *(ptr + 1) = tmp;
    ptr += sizeof(unsigned short);
  }
}



/*---------------------------------------------------------------------------
swapULongs - ???
---------------------------------------------------------------------------*/

void
swapULongs( ulong_array, len )
     unsigned long *ulong_array;
     size_t len;
{
  unsigned char tmp;
  unsigned char *ptr = (unsigned char *) ulong_array;

  while (len--) {
    PRT(printf("Original Long: %02X%02X%02X%02X, ptr=%08p\n",
	   *ptr, *(ptr+1), *(ptr+2), *(ptr+3), (void *)ptr););
    tmp = *ptr;
    *ptr = *(ptr + 3);
    *(ptr + 3) = tmp;
    tmp = *(ptr + 1);
    *(ptr + 1) = *(ptr + 2);
    *(ptr + 2) = tmp;
    PRT(printf("Resultant Long: %02X%02X%02X%02X, ptr=%08p\n",
	   *ptr, *(ptr+1), *(ptr+2), *(ptr+3), (void *)ptr););
    ptr += sizeof(unsigned long);
    PRT(printf("Ptr=%08p\n", (void *)ptr););
  }
}



/*---------------------------------------------------------------------------
to_dec_short - ???
---------------------------------------------------------------------------*/

unsigned short
to_dec_short(num)
 unsigned short int num;
{
 unsigned short int temp;

 temp = num >> 8;
 temp += (num << 8);
 return temp;
}


/*---------------------------------------------------------------------------
to_dec_long - ???
---------------------------------------------------------------------------*/

unsigned long
to_dec_long(num)
 unsigned long num;
{
 unsigned long temp1,temp2;
 
 temp1 = (unsigned long) to_dec_short((unsigned short) (num >> 16));
 temp2 = num & 0x0000ffff;
 temp2 = (unsigned long) to_dec_short((unsigned short) temp2);
 temp2 = temp2 << 16;
 return temp2 | temp1;
}


/*---------------------------------------------------------------------------
dec2sun_word - ???
---------------------------------------------------------------------------*/

void
dec2sun_word(buf,len)
 short	buf[];	/* Input buffer of word-length integers. */
 int	len;	/* Length of input buffer. */
{
 int i;

 for (i=0;i<len;i++) 
    buf[i] = (buf[i]<<8) | ((buf[i]>>8)&0xff);
}


/*---------------------------------------------------------------------------
dec2sun_long - ???
---------------------------------------------------------------------------*/

void
dec2sun_long(buf,len)
 unsigned long	buf[];	/* Input buffer of word-length integers. */
 int	len;	/* Length of input buffer. */
{
 int i;

 for (i=0;i<len;i++) buf[i] = to_dec_long(buf[i]);
}



/*---------------------------------------------------------------------------
get_float_data - ???
---------------------------------------------------------------------------*/

float 
get_float_data(fl_buf)
 unsigned char fl_buf[4];
{
 float value;
 int j,k;
 static float f[3]={256,65536,16777216};

 value = ((float)fl_buf[1] / f[0] + (float) fl_buf[2] / f[1] +
          (float) fl_buf[3] / f[2]);
 k = (fl_buf[0] - 64);

 if (k==0) return value;

 if (k > 0)
    for (j=1;j <=k; j++) value = value * 16;
   else if (k < 0)
    for (j= -1;j>=k;j--) value = value / 16;
 return value;
}



/*---------------------------------------------------------------------------
sun2dec_float - ???

Purpose: Convert SUN floating point to DEC floating point.
---------------------------------------------------------------------------*/

void 
sun2dec_float(inbuf,outbuf)
 unsigned char *inbuf,*outbuf;/* Pointer to character array
                                   to hold output.	*/
{
 union junk
    {
     char cnum[4];
     short snum[2];
     float rnum;
    } tmp;
 int i;

 memcpy(tmp.cnum,inbuf,4);
 tmp.rnum = 4.0 * tmp.rnum;
 dec2sun_word(tmp.snum, 2);
 for (i=0; i < 4;i++)
    outbuf[i] = tmp.cnum[i];
}



/*---------------------------------------------------------------------------
dec2sun_float - ???

   from sun side 
---------------------------------------------------------------------------*/

void 
dec2sun_float(inbuf,outbuf)
 unsigned char *inbuf,*outbuf;
{
 union junk
    {
     unsigned char cnum[4];
     short snum[2];
     float rnum;
    } tmp;

 memcpy(tmp.cnum,inbuf,4);
 dec2sun_word(tmp.snum, 2);
 if ((tmp.cnum[0] != 0) && (tmp.cnum[0] != 0xff))
    {
     tmp.cnum[0] -= 1;
    }
 memcpy(outbuf,&tmp,4);
}

/***************
void dec2sun_float(inbuf,outbuf)
 unsigned char *inbuf,*outbuf;
{
 union junk
    {
     char cnum[4];
     short snum[2];
     float rnum;
    } tmp;
 int i;

 memcpy(tmp.cnum,inbuf,4);
 tmp.rnum = tmp.rnum / 4.0;
 dec2sun_word(tmp.snum, 2);
 for (i=0;i < 4;i++)
    outbuf[i] = tmp.cnum[i];
}
**************/



/*---------------------------------------------------------------------------
decfl2sun_float - ???
---------------------------------------------------------------------------*/

void 
decfl2sun_float(fl,outbuf)
 float fl;
 unsigned char *outbuf;
{
 dec2sun_float(&fl,outbuf);
}


/*---------------------------------------------------------------------------
dec2sun_float_ary - ???
---------------------------------------------------------------------------*/

void 
dec2sun_float_ary(in_ary,out_ary,num_elems)
 float *in_ary;
 float *out_ary;
 unsigned long num_elems;
{
 unsigned long lcv;

 for (lcv = 0; lcv < num_elems; lcv++)
    dec2sun_float(&(in_ary[lcv]),&(out_ary[lcv]));
}


/*---------------------------------------------------------------------------
pr_hex - ???
---------------------------------------------------------------------------*/

void
pr_hex(hex_ary,len)
 unsigned char *hex_ary;
 unsigned long len;
{
 unsigned long lcv;

 for (lcv = 0; lcv < len; lcv++)
    {printf("%s ",(char *) byte_hex((unsigned long) hex_ary[lcv]));
     if (((lcv + 1) % 10) == 0) printf("\n");
    }
 if ((len > 0) && (((lcv + 1) % 10) != 0))
    printf("\n");

}
