/****************************************************************************
nria_procedures.h - Prototypes for functions defined in NRIA

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.


This header file should be included after all other NRIA header files
(which are needed to define the structures passed as arguments).

This file was originally designed to support the process_key.c file.
Eventually, it should be broken up into the appropriate packages
in NRIA, and used by all source files.  It will probably also need
to be split into GUI/XView dependent functions and others.

The word (COMPLETE) below means that, as far as I know, the list of
prototypes includes all those defined in that source file and used
elsewhere.

FIXME: This header file is almost certainly not yet complete.

FIXME:  Since this header file contains everything indiscriminately,
it is often the case that it attempts to prototype functions that
depend on a type declaration not in scope.  To temporarily ignore
such problems we use the ugly kluge of skipping such prototypes
in the absense of the flag showing that the header file defining
the type has been loaded.  Some such instances are marked as "Ugly kluge".

FIXME:  This header file probably contains prototypes for functions that
are called only within the file in which they are defined and which
ought not to be publicly prototyped.

****************************************************************************/

#ifndef NRIA_PROCEDURES_H
#define NRIA_PROCEDURES_H

#include "nria_lib.h"          /* Prototypes for NRIA library */



/* Defined in 3d.c */
#ifdef INPUT_H
extern int _3d_axis_rotate_plane(struct view_rec *view, int rot_angle);
extern int _3d_last_plane(struct image_display_window *win,
    int is_adjust_recoreg);
extern int BuildAndDisplayPlaneData(struct view_rec *view);
extern int ChangeCutPlane(struct view_rec *view, int use_old_normal);
extern struct view_rec *find_any_view_rec(struct input_file_rec *file,
    char *view_win_label);
extern struct view_rec *find_file_view_rec(struct input_file_rec *file,
    char *view_win_label);
extern struct view_rec *find_view_rec(struct view_rec *view,
    char *view_win_label);
extern int FormPlane(struct view_rec *result_view, struct vector_3d_rec *pt,
    struct vector_3d_rec *normal, struct vector_3d_rec *center,
    struct vector_3d_rec *rotate, int is_pt_global, int sel_adjust_center,
    struct matrix_3d_rec *xyztoplane);
extern void FormPlaneNoDisplay(struct view_rec *result_view,
    struct vector_3d_rec *pt, struct vector_3d_rec *normal,
    struct vector_3d_rec *center, struct vector_3d_rec *rotate,
    int is_pt_global, int sel_adjust_center, struct matrix_3d_rec *xyztoplane);
extern int FormPlaneAndAdjust(struct view_rec *result_view,
    struct vector_3d_rec *pt, struct vector_3d_rec *normal,
    struct vector_3d_rec *center, struct vector_3d_rec *rotate,
    int is_pt_global);
extern int OutputPlaneData(struct view_rec *view, int is_trigger_co,
    int is_trigger_lock);
extern int RotatePlaneFromCenter(struct view_rec *view, double angle,
    int is_rel);
extern int run_next_view_proc(struct view_rec *view, int (*run_proc)(),
    void *arg1, void *arg2, void *arg3, void *arg4, void *arg5, void *arg6);
extern int run_file_views_proc(struct view_rec *view, int (*run_proc)(),
    void *arg1, void *arg2);
extern int win_new_view(struct image_display_window *win,
    struct plane_3d_rec *new_plane);
extern int win_resize_voxel_now1(struct image_display_window *win,
    int use_dimxy, unsigned long dimx, unsigned long dimy, double xpixel_size,
    double ypixel_size, double zpixel_size);
extern int get_plane_slice_data(struct view_rec *view);
extern void set_view_group_num(struct view_rec *view);
extern int project_view_recs(struct view_rec *view);
extern int win_resize_voxel1(struct image_display_window *win,
    struct image_display_window *dp_to_win, int use_dimxy, unsigned long dimx,
    unsigned long dimy, float *xpixel_size, float *ypixel_size,
    float *zpixel_size, struct strs_rec *resize_wids, int (*next_proc)(),
    int (*conti_proc)(), void *arg1, void *arg2);
extern int view_labels_to_group_nums(struct input_file_rec *file,
    struct strs_rec *labels, int **gnums, int *num_gnums);
extern int update_view_slice_roi_rec(struct view_rec *view);
extern int win_move_mouse_to_cur_roi_wid(struct image_display_window *win);
extern int _3d_plane_orientation(struct view_rec *view, int select);
extern int _3dAxisCutPlane(struct view_rec *result_view,
    struct view_rec *view, double cut_deg, double x1, double y1, double x2,
    double y2, int use_refxy, double rx1, double ry1, double rx2, double ry2);
extern int _3d_default_cur_line(struct view_rec *view, long *x1, long *y1,
    long *x2, long *y2);
extern int win_new_3d_win_normal_to_centers(struct image_display_window *win,
    char *wid);
extern int win_new_3d_win_normal_to_normals(struct image_display_window *win,
    char *wid);
extern int run_any_file_views_proc(struct view_rec *view, int (*run_proc)(),
    void *arg1, void *arg2);
extern int win_enable_3d_draw_mode(struct image_display_window *win);
extern int win_next_plane_roi(struct image_display_window *win);
extern char *plane_data_pixel_type(struct view_rec *view, int x, int y);
extern struct slice_3d_rec *plane_data_slice_info(struct view_rec *view,
    int x, int y);
extern int win_3d_locate_plane(struct image_display_window *win, Event *event);
extern int locate_new_plane(struct view_rec *view, int slice_offset,
    int is_rel);
extern void _3d_after_next_roi_proc(struct image_display_window *win);
extern int win_new_3d_win(struct image_display_window *win,
    struct vector_3d_rec *normal);
extern int exec_3d_win_exit_proc(struct image_display_window *win);
#endif


/* Defined in 3d_co_register_menu.c */
#ifdef DISPLAY_WIN_H
extern int update_co_register_menu(struct image_display_window *win);
extern int enter_3d_co_menu(struct image_display_window *win, int status);
#endif


/* Defined in 3d_file_menu.c */
#ifdef DISPLAY_WIN_H
extern int win_reverse_image_order(struct image_display_window *win);
extern int win_save_cur_image_order(struct image_display_window *win);
extern int win_cur_default_image_order(struct image_display_window *win);
extern int win_default_image_order(struct image_display_window *win);
extern int enter_3d_file_menu(struct image_display_window *win, int status);
extern int open_view_win(struct view_rec *view);
extern int close_view_win(struct view_rec *view);
#endif


/* Defined in 3d_menu.c */
#ifdef DISPLAY_WIN_H
extern int  add_plane_window_list(struct view_rec *view);
extern int bring_up_cur_win(struct image_display_window *win);
extern int  get_3d_plane_cut_angle(struct image_display_window *win);
extern void update_3d_menu(struct image_display_window *win);
extern void update_3d_cut_mode(struct image_display_window *win);
extern int get_3d_plane_rot_angle(struct image_display_window *win);
extern int win_reverse_plane(struct image_display_window *win);
extern void win_same_plane(struct image_display_window *win, char *wid);
extern void win_same_orientation(struct image_display_window *win, char *wid);
extern unsigned long enter_3d_plane(struct image_display_window *win,
    int status);
#endif


/* Defined in 3d_more_plane_menu.c */
#ifdef DISPLAY_WIN_H
extern void update_more_plane_menu(struct image_display_window *win);
extern int win_3d_delete_last_cursor_pt(struct image_display_window *win);
extern int win_form_plane_by_3_pts(struct image_display_window *win);
extern unsigned long enter_3d_more_plane(struct image_display_window *win,
    int status);
extern int win_enable_3d_pt_mode(struct image_display_window *win);
extern int WinMove3dPlane(struct image_display_window *win, int is_rotated,
    struct matrix_2d_rec *rotate_mat, int x, int y, int is_rel,
    int is_cur_group, int is_dp);
#endif


/* Defined in 3d_param_menu.c */
#ifdef GEOMETRY_H
#ifdef xview_xview_DEFINED
extern int SaveNpar(char *dir, char *fn1, char *suffix, Frame frame,
    int is_replace, struct plane_3d_rec *gplane1, struct plane_3d_rec *gplane2,
    int which_format);
extern unsigned long enter_3d_param_menu(struct image_display_window *win,
    int status);
extern int WinShowCurDirParamFns(struct image_display_window *win,
    char *fn_patt);
extern int win_save_npar(struct image_display_window *win);
extern int win_save_which_npco(struct image_display_window *win);
extern int win_show_param_fns(struct image_display_window *win, char *dirfn,
    char *fn_patt, int (*action_proc)());
#endif
#endif


/* Defined in 3d_resize.c */
#ifdef INPUT_H
extern int setup_view_window_list(struct img_buf_rec *img, Panel_item item,
    int is_select_all, int which_view, int inc_cur_file, int inc_cur_group,
    int cur_group_num);
extern int win_3d_resize_voxel1(struct image_display_window *win,
    int use_dimxy, unsigned long dimx, unsigned long dimy,
    float *resize_xpixel_size, float *resize_ypixel_size,
    float *resize_zpixel_size, struct strs_rec *resize_wids,
    int (*conti_proc)(), void *arg1, void *arg2);
extern int win_3d_resize_voxel1(struct image_display_window *win,
    int use_dimxy, unsigned long dimx, unsigned long dimy,
    float *resize_xpixel_size, float *resize_ypixel_size,
    float *resize_zpixel_size, struct strs_rec *resize_wids,
    int (*conti_proc)(), void *arg1, void *arg2);
extern int win_resize_group_voxel(struct image_display_window *win, char *wid);
extern int enter_3d_resize_menu(struct image_display_window *win, int status);
#endif


/* Defined in 3d_roi_types.c */
#ifdef DISPLAY_WIN_H
extern void add_roi_type_window_list(struct image_display_window *win,
    struct view_rec *view);
extern int setup_file_rois_list_item(struct img_buf_rec *img,
    Panel_item roi_item);
extern int WinUpdate3dRois(struct image_display_window *win);
extern unsigned long enter_3d_rois_and_pixel_types(
    struct image_display_window *win, int status);
#endif


/* Defined in 3d_save_menu.c */
#ifdef DISPLAY_WIN_H
extern int open_output_file(char *dir, char *fn, char *suffix, char **the_fn,
    FILE **fid, Frame frame, int is_replace);
extern void update_3d_save_menu(struct image_display_window *win);
extern int open_input_file(char *dir, char *fn, char *suffix, char **the_fn,
    FILE **fid, Frame frame);
extern unsigned long enter_3d_save_menu(struct image_display_window *win,
    int status);
#endif


/* Defined in 3d_setup.c */
#ifdef INPUT_H
extern void delete_view_rec(struct input_file_rec *file,
    struct view_rec *view);
extern int find_file_3d(struct input_file_rec *file, char *id,
    struct buf_3d_rec **_3d);
extern int SetupFileViewRec(struct input_file_rec *file, char *id, double x,
    double y, double z, double normalx, double normaly, double normalz,
    struct vector_3d_rec *start, struct vector_3d_rec *end, long buf_dimx,
    long buf_dimy, struct vector_3d_rec *translate,
    struct vector_3d_rec *scale, struct vector_3d_rec *rotate,
    struct vector_3d_rec *center, double xratio, double yratio, double zratio,
    struct matrix_3d_rec *global_matrix, int is_adjust_to_center,
    unsigned long option, struct view_rec **view_data);
extern int GroupViewWids(struct view_rec *view, struct strs_rec *labels,
    int is_cp_str, int is_sorted);
extern int AnyViewWids(struct input_file_rec *file, struct strs_rec *labels,
    int is_cp_str, int is_sorted, int inc_cur_file, int inc_cur_group,
    int cur_group_num);
extern int FileViewWids(struct input_file_rec *file, struct strs_rec *labels,
    int is_cp_str, int is_sorted, int inc_cur_group, int cur_group_num);
extern void setup_and_display_3d_rois(struct view_rec *view,
    struct list_rec *list);
extern void setup_and_display_3d_pixel_types(struct view_rec *view,
    struct list_rec *list);
extern int Setup3dRoi(struct input_file_rec *file, char *roi_label,
    struct buf_3d_rec *_3d, int (*next_proc)(), int *error, void *arg1,
    void *arg2, void *arg3, void *arg4);
extern int is_file_3d_valid(struct input_file_rec *file,
    struct buf_3d_rec *_3d);
extern int get_file_3d(struct input_file_rec *file, char *id,
    int (*project_plane_proc)(), int (*project_plane_proc_if_found)(),
    struct view_rec *view, void *arg2, void *arg3, void *arg4,
    int interpolation_method, char *msg);
extern void SetupAll3dEchoes(struct view_rec *view, int indx,
    int (*next_proc)(), void *next_proc_arg, int method, char *msg);
extern int get_file_sub_obj_volume(struct view_rec *view,
    struct strs_rec *roi_strs, struct int_bound_rec *area,
    long *minz, long *maxz);
extern char *decode_img_label(char *img_label);
extern int rois_to_img_label(char **img_label, char *img_type,
    struct strs_rec *roi, struct strs_rec *pixel_type);
extern int volume_to_img_label(char **img_label, char *img_type,
    struct int_bound_rec *area, long minz, long maxz,
    struct strs_rec *pixel_type);
extern int get_file_3d_sub_obj(struct input_file_rec *file,
    struct view_rec *view, struct strs_rec *roi_strs,
    struct strs_rec *pixel_types, char *plane_id,
    struct int_bound_rec *area, long minz, long maxz, int is_roi);
extern int setup_file_3d_sub_obj(struct input_file_rec *file, char *id,
    struct view_rec *view);
extern int setup_file_3d(struct input_file_rec *file, char *id,
    unsigned long option);
extern void WinRedefine3dPixmaps(struct image_display_window *win);
extern int _3d_xyz_pixel_sizes(struct img_buf_rec *img, float *xpixel_size,
    float *ypixel_size, float *zpixel_size);
extern int Redefine3dPixmaps(struct input_file_rec *file);
#endif


/* Defined in 3d_split.c */
#ifdef DISPLAY_WIN_H
int enter_3d_split_rois(struct image_display_window *win, int status);
#endif


/* Defined in 3d_win_menu.c */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern void _3d_co_register_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int select);
extern void _3d_cur_default_image_order_proc(Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void _3d_cur_wid_roi_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int mode);
extern void _3d_default_image_order_proc(Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void _3d_delete_last_cursor_pt_proc( Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void _3d_enable_dp_xyz_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int val);
extern void _3d_enable_locate_plane_proc( Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void enter_3d_resize_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void _3d_form_plane_by_3_pts_proc( Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void _3d_last_plane_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int val);
extern void _3d_locate_plane_cursor_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int val);
extern void _3d_new_plane_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int select);
extern void enter_3d_param_menu_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void _3d_plane_key_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int mode);
extern void _3d_plane_orientation_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int key);
extern void _3d_pt_cursor_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void _3d_reproject_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int val);
extern void _3d_resize_group_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void _3d_reverse_image_order_proc( Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void _3d_reverse_plane_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void _3d_same_co_plane_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void _3d_save_image_order_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void _3d_select_cursor_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int val);

extern void enter_3d_co_menu_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void enter_3d_file_menu_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void enter_3d_more_plane_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void enter_3d_plane_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void enter_3d_rois_and_pixel_types_proc(Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void enter_3d_save_menu_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void rotate_plane_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int angle);
extern void save_open_cur_plane_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int select);
extern void segment_pixel_type_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void update_3d_rois_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void win_3d_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void _3d_move_mouse_to_wid(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
#endif


/* Defined in anal_dp_options.c */
#ifdef DISPLAY_WIN_H
extern int win_image_tissue_type_to_screen(struct image_display_window *win);
extern int disable_display_tissue_type(struct image_display_window *win);
extern int enable_display_tissue_type(struct image_display_window *win,
    int option);
extern int enter_anal_display_options(struct image_display_window *win,
    int status);
extern int WinShowPixelTypes(struct image_display_window *win, int option);
extern int WinReshowPixelTypesToScreen(struct image_display_window *win);
extern int win_filter_image_tissue_types(struct image_display_window *win);
extern int WinSlicePixelTypeOverlayOn(struct image_display_window *win);
#endif


/* Defined in anal_menu.c */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern void analysis_menu_help_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void analyze_all_slices_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void analyze_cur_slice_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void bkg_pixels_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void ca_options_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void cur_roi_to_histo_roi_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void dp_grow_region_params_proc( Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void histogram_options_proc( Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
extern void histogram_roi_proc( Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int arg_value);
extern void histo_roi_to_slice_roi_proc( Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event, int arg_value);
extern void import_pixel_type_map_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void output_text_format_proc(Menu menu, Menu_item item, void *arg,
  Xv_Window window, Event *last_event);
extern void pixel_types_to_histo_rois_proc( Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event, int option);
extern void redefine_pixel_type_order_proc(Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event, int option);
extern void segment_cur_slice_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void show_histogram_menu( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void show_roi_tissue_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void text_output_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int output_option);
extern void wr_bin_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern Menu gen_output_text_proc(Menu menu, Menu_generate operation);
extern Menu gen_analysis_proc(Menu menu, Menu_generate operation);
extern Menu gen_cur_roi_to_histo_roi_proc(Menu menu, Menu_generate operation);
extern Menu setup_pixel_type_menu(void);
extern Menu gen_show_pixel_type_roi_proc(Menu main_menu,
    Menu_generate operation);
extern Menu pixel_types_to_histo_rois_menu(void);
extern Menu setup_histogram_menu(void);
#endif


/* Defined in analysis.c */
#ifdef ANALYSIS_H
#ifdef TEXT_FORMAT_H
#ifdef INPUT_H
extern void init_analysis_rec(struct analysis_rec *anal);
extern void free_analysis_rec(struct analysis_rec *analysis);
extern int setup_analysis_params(struct analysis_rec *anal,
    struct output_text_format_rec *format, struct pixel_type_rec *pixel_type);
extern void check_analysis_status(struct analysis_rec *analysis);
extern int unset_slice_counts(struct slice_roi_rec *slice_roi,
    struct output_text_format_rec *format, unsigned long last_roi_indx);
extern int correct_slice_counts(struct analysis_rec *anal,
    struct output_text_format_rec *format, struct slice_roi_rec *slice_roi);
extern int add_global_pixel_rec_matrix_by_mask(struct buf_2d_rec *common,
    struct buf_2d_rec *mask, struct int_bound_rec *affected,
    struct buf_2d_rec *pixel_types, unsigned long roi_indx);
extern int cnt_pixel_types_by_mask(struct buf_2d_rec *_2d,
    struct buf_2d_rec *mask, struct int_bound_rec *affected,
    unsigned int *pixel_type_cnts, unsigned int num_pixel_types);
extern int setup_pixel_type_cnt_rec(struct pixel_type_cnt_rec **ptr,
    struct pixel_type_rec *pixel_type);
extern void init_common_pixel_rec_matrix(struct buf_2d_rec *common,
    int is_init_total_indxs);
#endif
#endif
#endif


/* Defined in analysis_opr.c */
#ifdef DISPLAY_WIN_H
extern int win_analysis(struct image_display_window *win,
    unsigned int num_slices, int anal_status);
extern int win_delete_all_slices_pixel_type_cnt_rec(
    struct image_display_window *win);
#endif


/* Defined in ask_file.c */
extern int ask_files(int status, ...);


/* Defined in break_objects.c */
#ifdef SLICE_ROI_REC_H
#ifdef GEOMETRY_H
int ScanAndBreakCurCurve(struct curve_rec *cur_curve,
    struct matrix_2d_rec *localto, unsigned int pen_type,
    struct roi_rec *breaker, struct curve_rec ***curves,
    unsigned int *total_curves, unsigned int *num_curves);
#endif
#endif


/* Defined in breaker.c */
#ifdef DISPLAY_WIN_H
extern int win_must_show_breaker(struct image_display_window *win);
extern void win_delete_breaker(struct image_display_window *win);
extern int win_move_show_breaker(struct image_display_window *win);
extern int win_break_undo_cur_curve(struct image_display_window *win);
extern int win_show_breaker(struct image_display_window *win);
extern int win_hide_breaker(struct image_display_window *win);
extern int win_break_cur_curve(struct image_display_window *win);
#endif


/* Defined in clipboard.c */
#ifdef DISPLAY_WIN_H
extern int win_show_clipboard(struct image_display_window *win);
extern int win_hide_clipboard(struct image_display_window *win);
extern int win_setup_clipboard(struct image_display_window *win);
extern int win_clipboard(struct image_display_window *win, int is_append,
    int which_curve, int option);
#endif


/* Defined in color.c */
#ifdef INTENSITY_H    /* For color_rec */
#ifdef WIN_H          /* For pallette_rec */
extern void init_color_scale_rec(struct color_scale_rec *scale);
extern void free_color_scale_rec(struct color_scale_rec *scale);
extern void unmap_all_scale_rgb(struct color_rec *color);
extern void init_pallette_rec(struct pallette_rec *def_color);
extern void free_pallette_rec(struct pallette_rec *def_color);
extern int copy_pallette_rec(struct pallette_rec *dest,
    struct pallette_rec *src, int status);
extern int def_color_scale_rec_control(struct color_scale_rec *scale);
extern struct color_scale_rec *find_scale(struct intensity_rec *intensity,
    char *label, int set_cur);
extern struct intensity_rec *find_intensity_rec(struct pallette_rec *def_color,
    char *intensity_label, int set_cur);
extern int rd_pallette_rec(char *fn, struct pallette_rec *def_color);
extern int wr_pallette_rec(char *fn, struct pallette_rec *def_color);
extern void set_scale_range(struct color_scale_rec *scale, int value);
extern int define_actual_scale(struct color_rec *color,
    int is_GT_ub_background, struct color_scale_rec *scale);
extern int define_actual_color_scale(unsigned long *color_indxs,
    struct color_scale_rec *scale, int is_GT_ub_background);
extern int delete_cur_intensity_rec(struct pallette_rec *def_color);
extern int define_actual_intensity_scale(struct intensity_rec *intensity,
    int is_GT_ub_background, long cur_scale);
extern int add_intensity_rec(struct pallette_rec *def_color,
    struct intensity_rec *intensity, int status, int is_create_new,
    long *indx);
extern void set_cur_color_scale_save_status(struct intensity_rec *intensity,
    int status, int is_and);
extern void default_map_intensity_rgb(struct intensity_rec *intensity);
extern void unmap_scale_rgb(struct color_rec *color,
    struct color_scale_rec *scale);
extern int cp_color_scale_rec(struct color_scale_rec *dest,
    struct color_scale_rec *src);
extern int GlobalToLocalColorIndx(struct color_scale_rec *scale,
    unsigned long global_indx, unsigned long *color_indxs);
extern int check_save_color(struct pallette_rec *def_color);

#ifdef xview_cms_h_DEFINED     /* For Xv_singlecolor */
extern int setup_pallette_rec(char *fn, struct pallette_rec *def_color,
    Xv_singlecolor *system_colors, unsigned long num_system_colors);
#endif

#endif
#endif


/* Defined in color_editor.c */
#ifdef DISPLAY_WIN_H
extern int enter_color_editor(struct image_display_window *win, int status);
#endif


/* Defined in color_opr.c */
#ifdef DISPLAY_WIN_H
extern int win_set_color_by_new_intensity_rec(struct image_display_window *win,
    struct intensity_rec *intensity, int is_create_new, int is_to_all_window);
extern int WinDefaultColorScale(struct image_display_window *win,
    struct color_data_rec *color_data);
extern void win_update_color_opr(struct image_display_window *win);
extern int win_define_color_map(struct image_display_window *win,
    int is_GT_ub_background);
extern int WinCurScaleAndColorIndxs(struct image_display_window *win,
    struct color_data_rec *color_data, struct color_scale_rec **scale,
    unsigned long **color_indxs, unsigned long *num_color_indxs);
extern int win_first_and_num_colors(struct image_display_window *win,
    unsigned long *first, unsigned long *num_colors);
extern int WinSetContrastLbUb(struct image_display_window *win,
    char *scale_label, unsigned long scale_indx, long lb, long ub,
    long is_GT_ub_background);
extern int win_same_local_contrast(struct image_display_window *win,
    struct image_display_window *def_win);
extern int WinSetRangeContrast(struct image_display_window *win,
    char *scale_label, unsigned long scale_indx, int value,
    int is_GT_ub_background);
extern int WinSetMidContrast(struct image_display_window *win,
    char *scale_label, unsigned long scale_indx, int value,
    int is_GT_ub_background);
extern int WinSelectScale(struct image_display_window *win,
    unsigned long color_data_indx);
extern int WinFindLocalAndGlocalScale(struct image_display_window *win,
    struct color_scale_rec **local, struct color_scale_rec **global);
extern struct color_scale_rec *win_cur_scale(struct image_display_window *win);
extern int WinEnableGlobalLocalContrast(struct image_display_window *win,
    int how);
extern int win_actual_color_indx(struct image_display_window *win,
    unsigned long color_indx);
extern int WinMapActualColorData(struct image_display_window *win,
    struct color_data_rec *cur_color_data, struct buf_2d_rec *color_data_2d);
extern int WinSetCurColorDataByScaleLabel(struct image_display_window *win,
    char *scale_label, int option);
extern int WinSetupScaleLabels(struct image_display_window *win,
    struct strs_rec *labels);
extern int WinSetDefaultColorDataScale(struct image_display_window *win,
    char *scale_label);
extern void win_change_color_scale(struct image_display_window *win,
    char *intensity_label, char *scale_label);
extern int win_image_enhancement(struct image_display_window *win);
extern int Set2dBackgroundColor(struct buf_2d_rec *result,
    struct buf_2d_rec *_2d, struct buf_2d_rec *mask, struct color_rec *color,
    unsigned long *color_indxs, unsigned long num_indxs,
    unsigned long first_indx, double setval, unsigned long select);
extern int WinSet2dByColorValueRange(struct image_display_window *win,
    struct buf_2d_rec *_2d, struct buf_2d_rec *mask,
    unsigned long first_color_val, unsigned long last_color_val);
extern int win_cur_scale_is_default(struct image_display_window *win);
extern int win_setup_default_local_color_indxs(
    struct image_display_window *win, struct image_display_window *def_win);
extern int WinSetDefaultScaleLabels(struct image_display_window *win,
    struct image_display_window *def_win);
extern int WinDefaultColorScaleLabels(struct image_display_window *win);
#endif


/* Defined in color_screen_rec.c */
#ifdef DISPLAY_WIN_H
extern int WinDropColorDataRec1(struct image_display_window *win,
    unsigned long gid, int drop_whole_group, unsigned long member_id,
    struct color_data_rec *color_data, int is_deallocate);
extern int WinSetupColorDataRec2(struct image_display_window *win, int is_new,
    unsigned long gid, unsigned long member_id, int use_dimxy,
    unsigned long dimx, unsigned long dimy, unsigned long pixel_depth,
    int is_init, struct color_data_rec **new_color_data,
    unsigned long color_data_type);
extern int win_setup_mask_bufs(struct image_display_window *win,
    long startoffx, long startoffy, long dimx, long dimy);
extern int WinFindColorDataRec1(struct image_display_window *win,
    unsigned long gid, unsigned long member_id,
    struct color_data_rec **color_data, unsigned long *indx);
extern int WinEnableDisableColorData(struct image_display_window *win,
    unsigned long gid, int is_disable);
extern int WinColorDataDims(struct image_display_window *win,
    unsigned long *dimx, unsigned long *dimy, unsigned long *pixel_depth);
extern int WinSetColorDataStatus(struct image_display_window *win,
    unsigned long gid, unsigned long andstatus, unsigned long orstatus);
extern int init_draw_mask_value(struct image_display_window *win);
extern int ValidateLocalColorIndxs(struct color_data_rec *color_data,
    struct color_scale_rec *scale);
extern struct color_data_rec *WinCurColorData(
    struct image_display_window *win);
extern int SetupLocalScale(struct color_data_rec *color_data,
    struct color_scale_rec *scale, unsigned long *color_indxs,
    unsigned long num_color_indxs);
extern int WinFindPosNegColorDataRec(struct image_display_window *win,
    struct color_data_rec **color_data, unsigned long *indx, int is_pos);
extern int WinGetColorDataVal(struct image_display_window *win,
    unsigned long x, unsigned long y, double *val);
extern int free_color_screen_rec(struct color_screen_rec *display);
extern void init_color_screen_rec(struct color_screen_rec *display);
extern int cp_color_screen_rec(struct color_screen_rec *dst,
    struct color_screen_rec *src, int is_cp_hidden, int is_cp_pixel_selection,
    int is_cp_mask);
extern int TurnOffColorScreenRecNonLocalScales(struct color_screen_rec *dp);
extern int SetupColorScreenRecLocalScales(struct intensity_rec *intensity,
    struct color_screen_rec *dp);
extern void init_shared_buf_2d_rec(struct shared_buf_2d_rec *share);
extern int win_free_pixel_selection_rec(struct image_display_window *win);
extern int SetupLocalColorScale(struct intensity_rec *intensity,
    struct color_data_rec *color_data);
extern int WinAddColorDataRec(struct image_display_window *win,
    struct color_data_rec *color_data, int is_new_gid);
extern void init_color_data_rec(struct color_data_rec *color_data);
extern void free_color_data_rec(struct color_data_rec *color_data);
extern int WinInitScreenBuffer(struct image_display_window *win,
    int screen_depth);
extern int setup_color_data_rec(struct image_display_window *win);
#endif


/* Defined in color_to_screen.c */
#ifdef DISPLAY_WIN_H
#ifdef COORD_REC_H      /* For coord_rec */
#ifdef RECT_H           /* For int_bound_rec */
extern int draw_pt_to_screen_buf(struct screen_data_rec *screen,
    struct coord_rec *coords, int pixel_value, unsigned long *real_color_indxs,
    unsigned int num_real_color_indxs,
    struct int_bound_rec *dirty_screen_bound, unsigned short *display_status);
extern int ErasePtFromScreenBuf(struct screen_data_rec *screen,
    struct coord_rec *coords, struct color_screen_rec *data,
    struct draw_mask_rec *draw_masks[], unsigned int num_masks,
    unsigned long *real_color_indxs, unsigned int num_real_color_indxs,
    int bkg_color, struct int_bound_rec *dirty_screen_bound,
    unsigned short *display_status);
extern int PaintCurCurve(struct screen_data_rec *screen,
    struct draw_mask_rec *draw_masks[], unsigned int num_draw_masks,
    struct color_screen_rec *data, unsigned long *real_color_indxs,
    unsigned long num_real_color_indxs, unsigned long bkg_color);
extern int PaintCurvesToScreen(struct screen_data_rec *screen,
    struct draw_mask_rec *draw_masks[], unsigned int num_draw_masks,
    struct color_screen_rec *data, unsigned long *real_color_indxs,
    unsigned long num_real_color_indxs, unsigned long bkg_color);
extern int win_refresh_screen_data(struct image_display_window *win);
extern int WinBufScreenData(struct image_display_window *win,
    struct buf_2d_rec *_2d, long left, long top, long right, long bottom,
    struct buf_2d_rec *screen_2d);
#endif
#endif
#endif


/* Defined in contrast.c */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
#ifdef DISPLAY_WIN_H
extern void enable_global_local_contrast_proc( Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void win_update_contrast(struct image_display_window *win);
extern void win_update_cur_contrast(struct image_display_window *win);
extern void win_update_cur_contrast_settings(struct image_display_window *win);
extern int contrast_mouse_proc(struct image_display_window *win, Event *event);
extern int win_set_slice_min_max(struct image_display_window *win, int select);
extern int enter_image_contrast(struct image_display_window *win, int status);
#endif
#endif


/* Defined in co_register.c */
#ifdef INPUT_H
extern int CoRegBaseAndNormal(struct matrix_3d_rec *xyztoplane,
    struct matrix_3d_rec *coplanetoxyz, struct vector_3d_rec *base,
    struct vector_3d_rec *normal, struct vector_3d_rec *new_cobase,
    struct vector_3d_rec *new_conormal);
extern int co_registered_wids(struct view_rec *view, struct strs_rec *wids,
    int is_cp_str, int is_sorted, int locked_or_reg);
extern int DpAllCoRegPlanes(struct view_rec *view, int is_trigger_co,
    int is_trigger_lock, int is_dp_cur, int is_dp_whole_group,
    int is_mv_recoreg);
extern int view_auto_adjust_reco_register(struct view_rec *view);
extern int view_check_cross_registered(struct view_rec *view);
extern int view_check_locked(struct view_rec *view);
extern int win_co_register_to_wid(struct image_display_window *win, char *wid);
extern int win_unco_register_all_group_wids(struct image_display_window *win,
    int is_unlock_all, int is_unco_all);
extern int WinUncoRegisterFromWid(struct image_display_window *win, char *wid,
    int is_update_coplane_of_wid);
extern struct co_register_rec *find_co_register_rec(struct view_rec *view,
    char *wid, long *indx, int *err, int is_new);
extern int view_adjust_reco_register(struct view_rec *view,
    struct view_rec *reg_view, struct view_rec *co_view,
    struct co_register_rec *co);
extern int DisplayCoRegisteredAdjustedPlanes(struct view_rec *view,
    int is_trigger_co, int is_trigger_lock);
extern void clear_all_planes_co_process_status(struct view_rec *view,
    int is_fusion_sync, int is_clear);
extern int cp_co_register_rec(struct co_register_rec *dest,
    struct co_register_rec *src);
extern void CoRegisteredParams(struct view_rec *view,
    struct co_register_rec *co, struct vector_3d_rec *base,
    struct vector_3d_rec *normal, unsigned int is_same_group);
extern int win_move_mouse_to_co_reg_wid(struct image_display_window *win);
extern int win_co_registered_wids(struct image_display_window *win,
    struct strs_rec *wids, int is_cp_str, int is_sorted, int locked_or_reg);
extern void win_xyz_by_co_reg_wid(struct image_display_window *win, char *wid);
extern int is_3d_win_locked(struct image_display_window *win);
extern int WinUncoRegisterWithAll(struct image_display_window *win,
    int is_unlock_all, int is_unco_all);
extern int win_unco_register_every_wid(struct image_display_window *win,
    int is_unlock_all, int is_unco_all);
extern int win_lock_coplanes_of_wid(struct image_display_window *win);
extern int win_unlock_coplanes_of_wid(struct image_display_window *win);
extern int win_wid_and_coplane_adjust_mode_on(
   struct image_display_window *win);
extern int win_wid_and_coplane_adjust_mode_off(
   struct image_display_window *win);
extern int win_wid_adjust_mode_on(struct image_display_window *win);
extern int win_wid_adjust_mode_off(struct image_display_window *win);
extern int win_reco_register(struct image_display_window *win, char *co_wid);
extern int win_check_and_co_register_to_wid(struct image_display_window *win,
    char *wid);
extern int win_co_plane(struct image_display_window *win, char *reg_wid,
    char *coreg_wid, char *coreg_coplane_wid);
extern int win_co_reg_path_wids(struct image_display_window *win,
    struct strs_rec *wids);
extern int view_co_reg_xyz(struct view_rec *view, double x, double y, double z,
    float *cx, float *cy, float *cz);
extern int unco_register_file(struct input_file_rec *file);
#endif


/* Defined in co_register_file.c */
#ifdef DISPLAY_WIN_H
extern int enter_co_register_file(struct image_display_window *win,
    int status);
extern int win_co_register_with_wid_file(struct image_display_window *win,
    char *wid);
extern int win_load_npco_2d(struct image_display_window *win);
extern int win_unco_register_with_wid_file(struct image_display_window *win,
    char *wid);
extern int WinCoRegFiles(struct image_display_window *win,
    struct strs_rec *fns);
extern int win_save_file_npco_2d(struct image_display_window *win,
    struct input_file_rec *file, struct input_file_rec *regfile);
extern int win_reverse_npco_2d_params(struct image_display_window *win,
    char *fn);
extern int win_save_npco_2d(struct image_display_window *win, char *fn);
extern int WinSetupFileListItem(struct image_display_window *win,
    Panel_item item, int select);
#endif


/* Defined in count_analysis_rec.c */
#ifdef COUNT_H
extern void free_count_analysis_rec(struct count_analysis_rec *count);
extern void free_slice_count_anal_rec(
    struct slice_count_anal_rec *slice_count);
extern void init_count_analysis_rec(struct count_analysis_rec *count,
    struct input_file_rec *file);
extern void init_roi_count_anal_rec(struct roi_count_anal_rec *roi_count);
extern void init_slice_count_anal_rec(
    struct slice_count_anal_rec *slice_count);
extern int setup_roi_count_anal_rec(struct roi_count_anal_rec *roi_count,
    int label);
extern int RdCountFormat(char *count_format_fn,
    struct count_analysis_rec *count);
extern int copy_count_format_only(struct count_analysis_rec *dst,
    struct count_analysis_rec *src, int option);
extern int setup_count_output_format(struct count_analysis_rec *count,
    struct unit_2d_rec *unit);
extern int setup_slice_count_anal_rec(struct count_analysis_rec *count,
    int slice_num);
extern int setup_count_analysis_rec_params(struct count_analysis_rec *count);
#endif


/* Defined in count_output.c */
#ifdef DISPLAY_WIN_H
extern int win_save_count_output_to_file(struct image_display_window *win,
    int to_printer);
extern int PrintCountOutputToTempFile(struct count_analysis_rec *count);
#endif


/* Defined in cursor.c */
#ifdef DISPLAY_WIN_H
extern int win_select_cursor(struct image_display_window *win,
    unsigned long select);
extern int dwin_default_cursor(struct display_win_rec *win);
extern int win_get_cursor_xy_and_bound(struct image_display_window *win,
    Event *event, long *x, long *y, int *use_this_xybound,
    struct int_bound_rec *xybound);
extern int win_set_def_cursor(struct image_display_window *win);
#endif


/* Defined in d_interface.c */
#ifdef DISPLAY_WIN_H
#ifdef xview_xview_DEFINED
extern int dwin_get_coord_xy_from_event(struct display_win_rec *disp_win,
    Event *event, long *x, long *y);
extern int win_multiple_set_frame_label(struct image_display_window *win);
extern int set_win_busy(struct image_display_window *win);
extern int set_win_not_busy(struct image_display_window *win);
extern int win_close_multiple_windows(struct image_display_window *win);
extern int win_draw_enabled_label(struct image_display_window *win,
    int *is_clear_label);
extern int win_move_mouse_to(struct image_display_window *win, long x, long y);
extern int win_show_multiple_windows(struct image_display_window *win);
extern int win_cursor_row_col(struct image_display_window *win);
extern int dwin_screenxy_to_bufxy(struct display_win_rec *disp_win,
    long *x, long *y);
extern int WinMultiEchoRunProc(struct image_display_window *win,
    int (*proc)(), void *arg2, void *arg3);
extern int win_execute_proc_to_partner_wins(struct image_display_window *win,
    int (*proc)(), void *arg2, void *arg3);
extern int WinRelativeMoveListWindows(struct image_display_window *win,
    unsigned long select);
extern int win_show_pixel_value(struct image_display_window *win, Event *event,
    int x, int y);
extern int win_display_row_col(struct image_display_window *win,
    int x, int y, int must_draw, int is_clear_label);
extern int win_action_label(struct image_display_window *win);
extern int win_show_edited(struct image_display_window *win);
extern int win_multiple_win_top(struct image_display_window *win);
extern int clear_label_area(struct image_display_window *win,
    struct int_rect_rec *area, int is_clear_label, int clear_status);
extern int win_right_angle_dist(struct image_display_window *win,
    int x, int y, int is_clear_label);
extern int win_is_window_open(struct image_display_window *win);
extern int dwin_get_coord_xy_from_mouse_xy(struct display_win_rec *win,
    long *x, long *y);
extern int win_show_file_windows(struct image_display_window *win);
extern int win_show_stack_windows(struct image_display_window *win);
extern int win_close_file_windows(struct image_display_window *win);
extern int win_close_stack_windows(struct image_display_window *win);
extern int win_make_window_cur(struct image_display_window *win, char *wid);
extern int win_set_frame_label(struct image_display_window *win);
extern int win_is_window_open_show(struct image_display_window *win);
extern int win_show_partner_windows_proc(struct image_display_window *win,
    int which);
extern int position_partner_wins(struct image_display_window *win,
    Frame *setup_fr_frame, int *direction);
#endif
#endif


/* Defined in display_bin.c */
#ifdef DISPLAY_WIN_H
extern int win_setup_bin(struct image_display_window *win);
/* FIXME!!  The following function has conflicting argument types for
its definition and use, so skip for now.  -PWH 19990706
extern void init_bin_rec(struct bin_rec *bin);
*/
#endif


/* Defined in display_canvas.c */
#ifdef xview_xview_DEFINED
#ifdef DISPLAY_WIN_H
extern int create_image(XImage **im, Display *dp, int screen_num,
    struct buf_2d_rec *_2d, unsigned long screen_depth);
extern int dwin_set_scrollbar(struct display_win_rec *win);
extern void init_frame_canvas_rec(struct frame_canvas_rec *frame_canvas);
extern Notify_value frame_interposer(Xv_Window frame, Event *event,
    Notify_arg arg, Notify_event_type type);
extern int dshow_buf(struct display_win_rec *win1, int x, int y,
    int width, int height);
extern int SelectCurve(struct image_display_window *win, Event *event,
    int is_select_curve, int is_beep, int *is_selected);
extern int WinCanvas(struct image_display_window *win, int is_show_canvas);
extern int display_data_to_canvas1(struct image_display_window *win,
    int is_show_canvas);
#endif
#endif


/* Defined in display_general.c */
#ifdef xview_cms_h_DEFINED        /* FIXME: An ugly kluge */
extern Cms setup_color_segment( Xv_Screen screen, char *segment_name,
     struct color_rec *color);
extern int ChangeColorSegment(Xv_Window win, char *segment_name,
    struct color_rec *color, int use_original);
extern int SetColorSegment(Xv_Window win, char *segment_name,
    struct color_rec *color, int use_original);
extern int ChangeExistingColorSegment(Xv_Window win, char *segment_name,
    struct color_rec *color, int use_original, int *redisplay);
extern int get_system_colors(Xv_Server server, int screen_num,
    Xv_singlecolor **system_colors, unsigned int *num_system_colors);
#endif


/* Defined in display_init_free.c (COMPLETE) */
#ifdef WIN_H     /* Ugly kluge on struct pallette_rec */
extern Menu setup_color_pallette_menu(int select,
   struct pallette_rec *pallette, Xv_Window xvwin);
#endif

#ifdef DISPLAY_WIN_H      /* Ugly kluge */
extern void do_CA_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void do_GA_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int sel);
extern void do_TA_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void init_display_win_rec(struct display_win_rec *win);
extern void free_display_win_rec(struct display_win_rec *win);
extern void init_image_display_window(struct image_display_window *win);
extern void free_image_display_window(struct image_display_window *win);
extern int win_error_exit_cur_win(struct image_display_window *win,
   int err);
extern int win_done_it_proc(Xv_window win);
extern Menu setup_3d_cursor_menu();
extern Menu setup_roi_menu();
extern int SetupDisplayWinRec(struct display_win_rec *win,
     struct image_display_window *owner, Frame ancestor,
     struct display_win_rec *master);
#endif /* DISPLAY_WIN_H */


/* Defined in display_interface.c */
#ifdef DISPLAY_WIN_H
extern int win_display_all_curves(struct image_display_window *win);
extern int win_execute_proc_to_multiple_wins(struct image_display_window *win,
    int (*proc)(), void *arg2, void *arg3, void *arg4, void *arg5, void *arg6);
extern int win_redisplay_all_curves(struct image_display_window *win);
extern int WinRunProcInList(int select, struct image_display_window *win,
    int (*proc)(), void *arg1, void *arg2, void *arg3, void *arg4,
    void *arg5, void *arg6);
extern int win_get_file_pixel_type_map(struct image_display_window *win,
    char *output_fn, int is_free_output_fn);
extern int win_execute_proc_to_related_wins(struct image_display_window *win,
    int (*proc)(), void *arg2, void *arg3);
extern struct image_display_window *find_file_first_window(
   struct input_file_rec *file, unsigned long *indx, unsigned long select);
extern int win_run_proc_to_all_file_wins(struct image_display_window *win,
    int (*proc)(), unsigned int is_which, void *arg2, void *arg3, void *arg4);
extern int WinFindNextEchoWin(struct image_display_window *win,
    struct image_display_window *nextwin,
    struct image_display_window **result);
extern int win_apply_partner_linked_wins(struct image_display_window *win,
    int (*proc)(), void *arg2, void *arg3);
extern int win_run_proc_on_slice_roi_wins(
    struct slice_roi_win_rec *slice_roi_win,
    int (*proc)(), void *arg2, void *arg3);
extern int win_display_cur_roi(struct image_display_window *win);
extern int win_scale_color_2d(struct image_display_window *win,
    struct buf_2d_rec *dest_2d, struct buf_2d_rec *src_2d);
extern int win_reverse_images(struct image_display_window *win);
extern int wr_file_hdr(struct input_file_rec *file);
extern void ndat_err_msg(struct input_file_rec *file, int err,
    int is_check_exist);
extern int win_reverse_slice_rois(struct image_display_window *win);
extern int win_show_row_col(struct image_display_window *win,
    int is_clear_label);
extern int win_display_masks_to_multiple_wins(
   struct image_display_window *win);
extern int win_display_clear_curves(struct image_display_window *win);
extern struct image_display_window *WinFindAvailNextEchoWin(
   struct image_display_window *win);
extern int win_is_file_img_valid(struct image_display_window *win,
    struct input_file_rec *file, struct img_buf_rec *img);
extern int win_paint_all_curves(struct image_display_window *win);
extern int WinWidFiles(struct image_display_window *win, struct strs_rec *wids,
    struct strs_rec *result);
#endif


/* Defined in display_main.c */
extern int abortFlag;
extern int debugFlag;


/* Defined in display_main_extra.c */
#ifdef MRI_FORMAT_H              /* For struct prog_rec */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern int cleanup_prog( struct prog_rec *prog, int must_quit );
extern Frame *main_display( int select, struct prog_rec *prog,
     Xv_Server server, int screen_num);
extern void program_exit_proc(Menu menu, Menu_item item);
extern void about_ria_proc( Menu menu, Menu_item item);
extern void beginner_help_proc( Menu menu, Menu_item item);
extern void main_event_proc(Frame frame, Event *event);
#endif
#endif


/* Defined in display_msg.c */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern Frame ShowMsgStrs(Frame frame, int err_display_option, int err,
    long wait_timer, int n_strs, ...);
extern Notify_value next_func(Xv_Window frame, Event *event, Notify_arg arg,
    Notify_event_type type);
extern void will_not_save_err_msg(Frame frame, int err, char *msg,
    char *reason);
#endif


/* Defined in display_pixel_type_order.c */
#ifdef DISPLAY_WIN_H
int enter_pixel_type_order(struct image_display_window *win, int status);
#endif


/* Defined in display_select_slice.c (COMPLETE) */
#ifdef DISPLAY_WIN_H    /* Ugly kluge */
extern void auto_slice_proc(Panel_item item, Event event, void *arg,
   Xv_Window window, Event *last_event, int dummy);
extern void next_group_slice_proc(Panel_item item, Event *event, void *arg,
   Xv_Window window, Event *last_event, int val);
extern void select_slice_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void select_slice_order_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void select_slice_slider_proc(Panel_item item, int value, 
   Event *last_event, void *arg, Xv_Window window);
extern int auto_on_proc(struct display_win_rec *win, int which);
extern int win_auto_arg(struct image_display_window *win,
   unsigned long *auto_on);
extern int update_cur_slice_num(struct image_display_window *win);
extern int win_release_slice_roi_win(struct image_display_window *win);
extern int win_get_slice_roi_win(struct image_display_window *win);
extern int win_before_enter_next_slice(struct image_display_window *win);
extern int WinSliceProcessed(struct image_display_window *win,
   unsigned long which_processed4);
extern int WinStackSliceOrScan(struct image_display_window *win);
extern int setup_select_slice_win(struct select_slice_win *win,
   struct display_win_rec *dwin);
extern void copy_select_slice_win(struct select_slice_win *dst, 
   struct select_slice_win *src, struct display_win_rec *dwin);
#endif  /* DISPLAY_WIN_H */


/* Defined in display_text_format.c */
#ifdef DISPLAY_WIN_H
int enter_text_format_rec(struct image_display_window *win, int status);
#endif


/* Defined in dp_breaker_options.c */
#ifdef DISPLAY_WIN_H
extern int enter_dp_breaker_options(struct image_display_window *win,
    int status);
#endif


/* Defined in dp_ca_options.c */
#ifdef DISPLAY_WIN_H
extern int enter_ca_options(struct image_display_window *win, int status);
extern int win_update_ca_options(struct image_display_window *win);
#endif


/* Defined in dp_delete_roi.c */
#ifdef DISPLAY_WIN_H
extern void update_dp_delete_roi_menu(struct image_display_window *win,
    int is_slice_rois);
extern int enter_dp_delete_roi(struct image_display_window *win, int status);
#endif


/* Defined in dp_draw_list.c */
#ifdef DISPLAY_WIN_H
extern int WinSetDrawLinkCoRegParams(struct image_display_window *win);
extern int win_delete_draw_lists(struct image_display_window *win);
extern int win_is_draw_list_processed(struct image_display_window *win,
    struct list_rec *list);
extern int WinDrawListWids(struct image_display_window *win,
    struct strs_rec *wids, int is_recursive);
extern int win_draw_link_with_wid(struct image_display_window *win, char *wid);
extern int win_delete_draw_link_with_wid(struct image_display_window *win,
    char *wid);
extern int enter_dp_draw_list(struct image_display_window *win, int status);
#endif


/* Defined in dp_grow_region_params.c */
#ifdef DISPLAY_WIN_H
extern int enter_grow_region_params_proc(struct image_display_window *win,
    int status);
extern int win_def_grow_region_params(struct image_display_window *win);
#endif


/* Defined in dp_histogram.c */
#ifdef DISPLAY_WIN_H
extern int enter_histogram(struct image_display_window *win, int status);
extern int Setup1dhistoByOptions(struct buf_2d_rec *result,
    struct img_buf_rec *img);
extern int Setup2dhistoByOptions(struct buf_2d_rec *result,
    struct buf_2d_rec *echo1, struct buf_2d_rec *echo2,
    struct img_buf_rec *img);
#endif


/* Defined in dp_more_roi_options.c */
#ifdef DISPLAY_WIN_H
extern int enter_more_roi_options_proc(struct image_display_window *win,
    int status);
#endif


/* Defined in dp_resize.c */
#ifdef DISPLAY_WIN_H
extern int WinScaleViewScreenDimXY(struct image_display_window *win,
    unsigned long dimx, unsigned long dimy, unsigned long use_magxy,
    unsigned long magx, unsigned long magy);
extern int WinRotate2dImage(struct image_display_window *win, double angle,
    int is_rel);
extern int WinResizeDefImgView(struct image_display_window *win);
extern int WinResizeDefImgSize(struct image_display_window *win);
extern int WinResizeLastImgSize(struct image_display_window *win);
extern int win_zoom(struct image_display_window *win, int is_doom_in);
extern int win_resize_to_wid(struct image_display_window *win, char *wid);
extern int enter_resize_image(struct image_display_window *win, int status);
extern int WinImageUnitSize(struct image_display_window *win,
    float *xpix, float *ypix, float *zpix,
    unsigned long *dimx, unsigned long *dimy);
extern int win_move_img(struct image_display_window *win, double x, double y);
#endif


/* Defined in dp_segment_echo.c */
#ifdef DISPLAY_WIN_H
extern int enter_dp_segment_echo(struct image_display_window *win, int status);
#endif


/* Defined in dp_slice_scans.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern struct all_slice_scans_recs *enter_process_slice_scans(
    struct image_display_window *win, int status);
#endif


/* Defined in dp_trans_roi.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern int enter_dp_trans_roi(struct image_display_window *win, int status);
extern int win_move_slice_rois_prior(struct image_display_window *win);
extern int win_move_slice_rois_next(struct image_display_window *win);
extern void update_dp_trans_roi(struct image_display_window *win);
#endif


/* Defined in draw_bitmap.c */
#ifdef DISPLAY_WIN_H
extern int GetFilledRoiMask(struct roi_rec *roi, struct matrix_2d_rec *localto,
    struct draw_mask_rec *mask, struct int_bound_rec *affected);
extern int GetRoiMask(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, long dimx, long dimy,
    struct draw_mask_rec *mask, struct int_bound_rec *affected, int option,
    struct roi_rec *image_view_roi);
extern int GetFilledAllRoisMask(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, struct draw_mask_rec *mask);
extern int DrawCurveRec(struct draw_mask_rec *mask, struct curve_rec *curve,
    struct matrix_2d_rec *localto, int curve_type);
extern int DrawCurRoiRec(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, struct draw_mask_rec *cur_roi_mask,
    struct draw_mask_rec *cur_curve_mask, int is_polygon);
extern int FillDrawRoiRec(struct draw_mask_rec *cur_roi_mask,
    struct draw_mask_rec *cur_curve_mask, struct roi_rec *roi,
    struct matrix_2d_rec *localto);
extern int DrawSliceRoiRec(struct draw_mask_rec *other_roi_mask,
    struct draw_mask_rec *cur_roi_mask, struct draw_mask_rec *cur_curve_mask,
    struct slice_roi_rec *slice_roi, struct matrix_2d_rec *localto,
    unsigned long is_win_visible_option);
extern int FillDrawSliceRoiRec(struct draw_mask_rec *other_roi_mask,
    struct draw_mask_rec *cur_roi_mask, struct draw_mask_rec *cur_curve_mask,
    struct slice_roi_rec *slice_roi, struct matrix_2d_rec *localto,
    int plot_cur_roi, unsigned long is_win_visible_option);
extern void win_draw_cur_roi_rec(struct image_display_window *win);
extern int Get1DRegionMask(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, long dimx, struct draw_mask_rec *mask,
    struct int_bound_rec *affected, unsigned long option,
    struct strs_rec *roi_labels, int *is_mask_dirty);
extern int GetRegionMask(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, long dimx, long dimy,
    struct draw_mask_rec *mask, struct int_bound_rec *affected,
    unsigned long option, struct strs_rec *roi_labels, int *is_mask_dirty);
extern int GetFilledCurveMask(struct curve_rec *curve,
    struct matrix_2d_rec *localto, int pen_type, struct draw_mask_rec *mask,
    struct int_bound_rec *affected);
extern int DrawRoiRec(struct draw_mask_rec *cur_roi_mask,
    struct draw_mask_rec *cur_curve_mask, struct roi_rec *roi,
    struct matrix_2d_rec *localto);
extern int win_draw_cur_curve_rec(struct image_display_window *win);
#endif


/* Defined in draw_line_to_screen.c */
#ifdef DISPLAY_WIN_H
extern int WinDrawCurrentLine(struct image_display_window *win,
    int use_start_pt, unsigned long start_pt, unsigned long num_pts,
    int is_erase, int is_display);
extern int WinListProcessCurLine(struct image_display_window *win,
    struct image_display_window *linkfrom_win, int use_start_pt,
    unsigned long start_pt, unsigned long num_pts, int is_erase, int select,
    struct list_rec *cur_list);
extern int win_show_screen_bound(struct image_display_window *win);
extern int win_draw_cur_curve_to_screen(struct image_display_window *win,
    int is_erase, int is_display, int is_cur_win_only);
extern int win_draw_all_rois_to_screen(struct image_display_window *win,
    int is_erase, int is_display, int is_cur_win_only);
extern int win_draw_cur_roi_to_screen(struct image_display_window *win,
    int is_erase, int is_display, int is_cur_win_only);
#endif


/* Defined in draw_mask_rec.c */
#ifdef DISPLAY_WIN_H
extern void init_draw_mask_rec(struct draw_mask_rec *draw_mask);
extern void free_draw_mask_rec(struct draw_mask_rec *draw_mask);
extern int get_draw_mask_rec(struct draw_mask_rec *draw_mask,
    unsigned int dimx, unsigned int dimy);
extern void set_paint_status(struct draw_mask_rec *draw_masks,
    unsigned int num_draw_masks, int paint_status);
extern void clear_draw_masks(struct draw_mask_rec *draw_masks,
    unsigned int num_draw_masks);
extern int cp_draw_mask_rec(struct draw_mask_rec *dst,
    struct draw_mask_rec *src);
#endif


/* Defined in draw_setting_rec.c */
#ifdef DISPLAY_WIN_H
extern void set_allowable_pen_types(struct draw_setting_rec *control,
    int allowable_pen_types);
extern void set_max_input_curve_pts(struct draw_setting_rec *control,
    int max_input_pts);
extern void set_proc_upon_input_done(struct draw_setting_rec *control,
    int (*proc_upon_input_done)(), void *proc_arg);
extern void win_enable_draw_pen(struct image_display_window *win);
extern void set_proc_upon_cursor_change(struct draw_setting_rec *control,
    int (*proc_upon_cursor_change)(), void *proc_arg);
extern void free_draw_setting_rec(struct draw_setting_rec *control,
    unsigned int dimx, unsigned int dimy);
extern void init_draw_setting_rec1(struct draw_setting_rec *control,
    unsigned int dimx, unsigned int dimy);
extern void init_input_pt_state(struct draw_setting_rec *control);
extern void clear_allowable_pen_types(struct draw_setting_rec *control);
extern void clear_max_input_curve_pts(struct draw_setting_rec *control);
#endif


/* Defined in draw_to_screen.c */
#ifdef DISPLAY_WIN_H
extern int paint_cur_curve_to_multiple_win(struct image_display_window *win,
    struct draw_mask_rec *draw_masks, unsigned int num_draw_masks,
    int is_paint_cur_win_only);
extern int paint_curves_to_multiple_win(struct image_display_window *win,
    struct draw_mask_rec *draw_masks, unsigned int num_draw_masks,
    int is_paint_cur_win_only);
extern void win_get_actual_draw_masks(struct image_display_window *win,
    struct draw_mask_rec **actual_draw_masks,
    unsigned int total_actual_draw_masks, unsigned int *num_actual_draw_masks,
    struct draw_mask_rec *draw_masks, unsigned int num_draw_masks,
    int is_paint_cur_curve);
#endif


/* Defined in edge_detector.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern struct all_edge_detector_recs *enter_edge_detector(
    struct image_display_window *win, int status);
#endif


/* Defined in edit_and_display.c */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern void enter_display_text_file(Frame owner, int status, char *frame_label,
     char *fn);
extern int enter_edit_file(Frame win_owner, void *client_unique_handle,
    char *win_label, char *fn, int can_edit, int (*exit_proc)(), void *arg,
    int option);
#endif


/* Defined in error_handler.c (COMPLETE) */
#ifdef MRI_FORMAT_H              /* For struct prog_rec */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern int abort_program( struct prog_rec *prog, int option);
extern int exit_handler( int select, struct prog_rec *prog,
     Notify_func exit_called_proc );
extern int xv_error_handler( Xv_object obj, Attr_avlist vlist);
extern Notify_value bad_exit_called_proc( struct prog_rec *prog,
     int sig, Notify_signal_mode when);
#endif
#endif


/* Defined in file_menu.c */
#ifdef xview_xview_DEFINED    /* For xview related stuff */
#ifdef MRI_FORMAT_H           /* For struct prog_rec */
#ifdef ASK_FILE_H             /* For struct chosen_fn_rec */
extern show_all_file_proc( struct prog_rec *prog, struct chosen_fn_rec *chosen,
     Panel_item item, char *str, int row, Panel_list_op op, Event *event);
#endif
#endif
#endif

#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern void get_fns_menu( Frame frame, int which);
extern void import_image_file_from_main_proc( Menu menu, Menu_item item);
extern void color_editor_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void color_pallette_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void display_menu_help_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void enter_save_dat_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void file_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void image_color_scale_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void import_image_file_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void select_cursor_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, long which_cursor);
extern void win_quit_and_save_file_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void win_select_fns_menu_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern Menu gen_cursor_menu_proc(Menu menu, Menu_generate operation);
extern Menu setup_file_info_menu(void);
extern void next_color_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
#endif


/* Defined in fill_objects.c */
#ifdef SLICE_ROI_REC_H
#ifdef OBJECT_H
extern int FillObjRegion(struct all_object_rec *all_objs, int is_fill_id_2d,
    struct curve_rec **curves, unsigned long num_curves,
    struct matrix_2d_rec *localto, struct coord_rec *coords,
    struct buf_2d_rec *_2d, unsigned long filled_val);
#endif
#endif

#ifdef SLICE_ROI_REC_H
#ifdef COMMON_H           /* For buf_2d_rec */
extern int FillEexclusiveObjRegions(struct curve_rec **curves,
    unsigned long num_curves, struct matrix_2d_rec *localto,
    struct buf_2d_rec *out_2d, unsigned long filled_val, int is_init_out_2d);
extern int FillROi(struct roi_rec *roi, struct matrix_2d_rec *localto,
    struct buf_2d_rec *out_2d, unsigned long filled_val, int is_init_out_2d,
    int is_exclusive);
extern int ScanRoiFromBuf(struct slice_roi_rec *slice_roi,
    struct strs_rec *roi_label, struct buf_2d_rec *_2d,
    unsigned long roi_prog_status, int *is_roi_ok);
#endif
#endif


/* Defined in fmri.c */
#ifdef COMMON_H       /* For buf_2d_rec */
#ifdef IA_HDR_H       /* For hdr_rec */
extern int setup_ref_waveform(float **phases, float *phases_sd,
    unsigned long num_phases, unsigned long right_shift,
    unsigned long num_scans);
extern int setup_cc_buf(struct hdr_rec *hdr, struct buf_2d_rec ***scans,
    unsigned long *num_scans);
extern int SliceMotionCorrection(FILE *fid, struct hdr_rec *hdr,
    struct buf_2d_rec **scans, unsigned long num_scans,
    unsigned long slice_num, unsigned long echo_num,
    struct buf_2d_rec **temps, unsigned long num_temps,
    double *min, double *max);
extern int SingleSampleTTest(FILE *fid, struct hdr_rec *hdr,
    struct buf_2d_rec **scans, unsigned long num_scans,
    unsigned long slice_num, unsigned long echo_num,
    struct buf_2d_rec **temps, unsigned long num_temps, int num_pairs,
    int seq, int is_pair_pts, int is_motion_correction,
    struct buf_2d_rec *slice);
extern int SliceCorrelationCoeff(FILE *fid, struct hdr_rec *hdr,
    struct buf_2d_rec **scans, unsigned long num_scans,
    unsigned long slice_num, unsigned long echo_num,
    struct buf_2d_rec **temps, unsigned long num_temps, int is_ref_wave_form,
    float *phases, double phases_sd, int is_normalized,
    int is_motion_correction, struct buf_2d_rec *slice);
#endif
#endif


/* Defined in fusion.c */
#ifdef DISPLAY_WIN_H
extern int WinRotateFusion(struct image_display_window *win, double fl_angle);
extern int WinDynamicBackwardFusion(struct image_display_window *win);
extern int WinDynamicForwardFusion1(struct image_display_window *win,
    int has_been_transformed);
extern int WinMoveFusion2dToSuperimpose2d(struct image_display_window *win);
extern int WinImageFusion1(struct image_display_window *win,
    struct int_bound_rec *src_bound, struct int_bound_rec *dst_bound, int opr,
    char *src_wid);
#endif


/* Defined in grow_region.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern int setup_pt_to_region(struct image_display_window *win);
extern void update_pt_to_region(struct image_display_window *win,
    Event *event);
#endif


/* Defined in histogram.c */
#ifdef INPUT_H   /* For img_buf_rec */
#ifdef COMMON_H  /* For buf_2d_rec */
extern int SetupAllSlicesHisto(struct img_buf_rec *img, int is_normalized,
    struct buf_2d_rec *_2d, int rd_select, int histo_option, int histo_kind);
extern int is_img_histo_ready(struct img_buf_rec *img, unsigned long dimx,
    unsigned long *indx);
extern int HistoCurSlice(struct buf_2d_rec *_2d, struct win_rec *win,
    int histo_option, int roi_option, struct roi_rec *image_view_roi,
    int is_use_cur_img_2d);
extern int HistoAllSlices(struct buf_2d_rec *_2d, struct win_rec *win,
    int histo_option, int roi_option, struct roi_rec *image_view_roi);
extern int ComputeHisto1d(struct img_buf_rec *img, struct buf_2d_rec *_2d,
    unsigned long dimx);
extern int Get1dHistoBuf(struct buf_2d_rec *output_2d, struct img_buf_rec *img,
    struct buf_2d_rec *mask, int is_use_cur_img_2d);
extern int get_2d_histo_buf(struct buf_2d_rec *output_2d,
    struct img_buf_rec *img, struct buf_2d_rec *mask);
#endif
#endif


/* Defined in histo_interface.c */
#ifdef DISPLAY_WIN_H
extern int WinSegmentCurSlice(struct image_display_window *win, int sel);
extern int win_segment_and_get_pixel_types(struct image_display_window *win);
extern int win_histogram_show(struct image_display_window *win);
extern void win_histogram_clear(struct image_display_window *win);
extern void win_histogram_show_it(struct image_display_window *win);
extern int win_partitioned_pixel_type(struct image_display_window *win);
extern int win_edited_pixel_type(struct image_display_window *win);
extern int win_histogram(struct image_display_window *win, int option,
    int roi_option);
#endif


/* Defined in histo_more_opr.c */
#ifdef INPUT_H       /* For histo_params_rec */
extern int thresholding_pixels(struct histo_params_rec *histo);
extern int get_bkg_histo_stat(struct pixel_center_rec *center,
    struct buf_2d_rec *occurence, struct buf_2d_rec *mask,
    struct int_bound_rec *affected, int which_gradient);
#endif


/* Defined in histo_params_rec.c */
#ifdef HISTO_H     /* For struct pixel_center_rec */
extern void free_histo_bkg_rec(struct histo_bkg_rec *bkg);
extern void free_histo_params_rec(struct histo_params_rec *histo);
extern void free_histo_pixel_center_rec(struct histo_params_rec *histo);
extern void free_histo_pixel_tissue_type_rec(struct histo_params_rec *histo);
extern void free_pixel_center_rec(struct pixel_center_rec *center);
extern void init_histo_params_rec(struct histo_params_rec *histo,
    struct input_file_rec *file);
extern void init_histo_pixel_tissue_type_rec(struct histo_params_rec *histo);
extern void init_pixel_center_rec(struct pixel_center_rec *center);
extern unsigned short file_get_def_histo_type(struct input_file_rec *file);
extern struct slice_roi_win_rec *GetHistoSliceRoiWinRec(
   struct histo_params_rec *histo, int histo_type2);
extern void get_histo_dim(struct histo_params_rec *histo,
    unsigned int *histo_dimx, unsigned int *histo_dimy,
    unsigned int *pixel_depth, int histo_type2);
extern int setup_histo_params_rec(struct histo_params_rec *histo,
    struct input_file_rec *file, int histo_type2);
extern int HistoBufReady(struct input_file_rec *file, int histo_type2);
extern struct buf_2d_rec *GetHistoBuf(struct histo_params_rec *histo,
    int histo_type2);
extern int init_default_histo_bkgs(struct histo_params_rec *histo);
extern void init_pixel_type_ave_rec(struct pixel_type_ave_rec *type_ave);
extern void init_pixel_tissue_type_rec(struct pixel_tissue_type_rec *type);
#endif


/* Defined in histo_segment.c */
#ifdef HISTO_H
extern void free_all_neighbor_elem_recs(struct neighbor_elem_rec *members,
    unsigned long num_members);
extern void init_neighbor_elem_rec(struct neighbor_elem_rec *member);
extern int PartitionPixelTypes(struct histo_table_elem_rec **elems,
    unsigned long num_rows, struct histo_params_rec *histo,
    struct neighbor_elem_rec *members, struct slice_roi_rec *slice_roi);
extern int get_2_intersections(int x, int y, int angular_gradient, int left,
    int right, int top, int bottom, int *x1, int *y1, int *x2, int *y2);
#endif


/* Defined in icon.c */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern get_ria_icon(Xv_Window frame);
extern set_icon_label( Xv_Window frame, char *label);
#endif


/* Defined in image_view_filter.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern struct all_image_view_recs *enter_image_view_filter(
    struct image_display_window *win, int status);
extern void win_change_view_roi(struct image_display_window *win, int is_exc,
    int which_quadrant);
#endif


/* Defined in img_buf_opr.c */
#ifdef INPUT_H
extern struct img_buf_rec *NewImgBuf(struct img_rec *img,
    struct hdr_scan_entry_rec *cur_slice, int *err, int get_win_rec,
    int use_this_buf_dims, unsigned long dimx, unsigned long dimy,
    unsigned long pixel_depth_bits, unsigned long data_type,
    int is_all_echoes);
extern void free_img_rec(struct img_rec *img);
extern void init_img_rec(struct img_rec *img, struct input_file_rec *file);
extern int drop_img_dst_wids(struct img_buf_rec *img, char *wid);
extern int all_img_echoes_exist(struct img_buf_rec *img);
extern int delete_img_if_not_use(struct img_buf_rec *img);
extern int delete_img(struct img_buf_rec *img);
extern int add_img_dst_wids(struct img_buf_rec *img, char *wid);
extern void free_sel_buf_2d_rec(struct sel_buf_2d_rec *buf);
extern int delete_img_and_partner_bufs(struct img_buf_rec *img);
#endif


/* Defined in img_menu.c */
#ifdef xview_xview_DEFINED     /* Ugly kluge */
extern void change_view_roi_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int which_quadrant);
extern void co_register_file_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void edge_detection_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void enable_move_superimpose_cursor_proc(Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void enter_co_register_file_proc(Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void fusion_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void fusion_image_action_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int select);
extern void image_contrast_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void image_enhancement_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void image_view_filter_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void modify_image_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void overlay_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int value);
extern void pixel_selection_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void print_or_save_image_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void process_slice_scans_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void pt_to_region_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void resize_image_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void resize_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void reverse_images_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void set_slice_min_max_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int select);
extern void rotate_2d_image_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, double angle);
extern Menu setup_print_or_save_image_menu(void);
#endif /* xview_xview_DEFINED */


/* Defined in img_opr.c */
#ifdef INPUT_H
extern int RdCurSliceEchoes(struct img_buf_rec *img, int is_normalized,
    int rd_select);
extern int rd_cur_slice_data(FILE *fid, struct hdr_scan_entry_rec *cur_slice,
    struct buf_2d_rec *buf);
extern char *get_img_type_label(struct img_buf_rec *img);
extern int RdSlice(struct img_buf_rec *img, int is_normalized,
    struct buf_2d_rec *_2d, int rd_select);
extern int SetupImgRegParams(struct img_buf_rec *img,
    struct img_buf_rec *regimg,
    unsigned long select, struct file_register_rec *fco1,
    struct file_register_rec *fco2);
extern void GetImgSliceMinMax(struct img_buf_rec *img, struct buf_2d_rec *_2d);
extern int get_next_slice(char *action_str, struct img_buf_rec *img,
    int slice_offset, int is_locate_scan);
extern unsigned long get_img_slice_num(struct img_buf_rec *img);
extern int get_slice_info(char *action_str, struct img_buf_rec *img,
    int slice_offset, struct hdr_scan_entry_rec **slice_info,
    int is_locate_scan);
extern unsigned long total_slice_scans(struct img_buf_rec *img);
extern int LocateAllSliceEchoes(struct img_buf_rec *img, long slice_num,
    long scan_num, long echo_num);
extern int LoadAllNextSliceEchoes(char *action_str, struct img_buf_rec *img,
    int slice_offset, int is_locate_scan, int rd_select);
extern unsigned long total_slice_cuts(struct img_buf_rec *img);
extern int UseCurrentImgRegParams(struct img_buf_rec *img,
    struct img_buf_rec *regimg);
extern int GetImgUnit2dRec(struct img_buf_rec *img, struct unit_2d_rec *unit,
    struct unit_2d_rec **unit_ptr);
extern int RdSliceData(struct img_buf_rec *img,
    struct hdr_scan_entry_rec *slice_info, int is_normalized,
    struct buf_2d_rec *buf, int rd_select);
extern int wr_slice(struct img_buf_rec *img, struct buf_2d_rec *img_2d,
    char **err_reason);
extern int get_all_next_slice_echoes(struct img_buf_rec *img,
    struct hdr_scan_entry_rec *cur_slice);
extern struct img_buf_rec *pick_first_img_buf_rec_partner(
   struct img_buf_rec *img);
extern unsigned long cnt_img_buf_rec_partners(struct img_buf_rec *img);
extern int SaveImgBufToFileBuf(struct img_buf_rec *img);
extern int LocateSlice(struct img_buf_rec *img, long slice_num, long scan_num,
    long echo_num);
extern int RdFilePixel(struct input_file_rec *file,
    struct hdr_scan_entry_rec *cur_slice, unsigned long row,
    unsigned long col, double *val);
extern struct hdr_scan_entry_rec *pick_first_partner_slice(
   struct hdr_scan_entry_rec *slice);
extern int ImgAdvanceRelative(struct img_buf_rec *img,
    struct img_buf_rec *ref_img);
extern int ExtractImgPosOrNegEcho(struct img_buf_rec *img,
    struct buf_2d_rec *_2d, struct buf_2d_rec *result);
extern int RdImgPosNegEchoes(struct img_buf_rec *img, int is_normalized,
    struct buf_2d_rec *_2d, int rd_select);
extern int get_img_scan_num(struct img_buf_rec *img);
extern char *get_img_label(struct img_buf_rec *img);
extern char *get_img_fn(struct img_buf_rec *img);
#endif


/* Defined in import_img.c */

/* FIXME!  The following function cannot be given a proper prototype until
   it gets rewritten.  See the definition for details.  -PWH 19990618
struct all_import_img_recs *enter_import_img_rec(void *win_or_main_frame,
    int status);
*/


/* Defined in import_rois.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern struct all_import_roi_recs *enter_import_rois(
     struct image_display_window *win, int status);
#endif


/* Defined in input_file_rec.c */
#ifdef INPUT_H
extern void reflect_view_slice_num(struct view_rec *view);
extern int change_slice_image_label(struct hdr_scan_entry_rec *slice,
    char *img_label);
extern int add_slice_info_3d(struct slice_info_rec *slice_info,
    struct buf_3d_rec *_3d);
extern int drop_slice_info_3d(struct slice_info_rec *slice_info,
    struct buf_3d_rec *_3d);
extern void init_data_slice_rec(struct data_slice_rec *slice);
extern void free_data_slice_rec(struct data_slice_rec *slice);
extern int setup_data_slice_rec(struct data_slice_rec *slice,
    struct slice_info_rec *info, struct view_rec *view, char *img_label,
    unsigned long num, struct hdr_scan_entry_rec *prior_slice,
    struct hdr_scan_entry_rec *next_slice,
    struct hdr_scan_entry_rec *partner_slice);
extern int add_view_rec(struct slice_info_rec *slice_info,
    struct view_rec *view);
extern int drop_view_rec(struct slice_info_rec *slice_info,
    struct view_rec *view);
extern void init_view_rec(struct view_rec *view);
extern void free_view_rec(struct view_rec *view);
extern void init_co_register_rec(struct co_register_rec *co);
extern void free_co_register_rec(struct co_register_rec *co);
extern int add_file_register_rec(struct input_file_rec *file,
    struct input_file_rec *regfile, struct file_register_rec *co,
    unsigned long *coindx, int which);
extern int FileName(struct input_file_rec *file, char **fn);
extern int AllFiles(struct input_file_rec *file, struct strs_rec *fns,
    int is_sorted, int select);
extern struct input_file_rec *find_file(struct input_file_rec *file, char *fn,
    unsigned long *indx);
extern int SetFileRegisterRecInUse(struct input_file_rec *file,
    struct input_file_rec *regfile, int which);
extern struct file_register_rec *find_file_register_rec(
    struct input_file_rec *file, struct input_file_rec *regfile,
    unsigned long *indx, int which);
extern void file_def_3d_gravity(struct input_file_rec *file);
extern void init_input_file_rec(struct input_file_rec *file,
    struct prog_rec *prog);
extern int free_input_file_rec(struct input_file_rec *file);
extern int setup_default_text_format_fn(struct input_file_rec *file);
extern int setup_file_attrs(struct input_file_rec *file);
#endif

#ifdef MRI_FORMAT_REC       /* For input_rec */
extern void init_input_rec(struct input_rec *input, struct prog_rec *prog);
extern void free_input_rec(struct input_rec *input);
#endif


/* Defined in label_roi.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern int setup_label_roi(struct image_display_window *win,
    Frame owner_frame, int (*ready_proc)(), void *ready_arg,
    int (*cancel_proc)(), void *cancel_arg, char *title,
    unsigned short which_roi_list);
extern int win_show_sub_list_roi_labels(struct image_display_window *win,
    int is_rename_roi);
#endif
#endif


/* Defined in list.c */
#ifdef DISPLAY_WIN_H
extern int num_continuous_win_list_slices(struct image_display_window *win);
extern int win_delete_multiple_wins_in_list(struct image_display_window *win);
extern int get_win_list_wids(struct image_display_window *win,
    struct strs_rec *wids);
#endif


/* Defined in list_rec.c */
#ifdef LIST_REC_H
extern void *head_item(struct list_rec *list, int which_item);
extern int add_item_after_cur_list(struct list_rec *list,
    struct list_rec *item_list);
extern struct list_rec *delete_item_from_list(struct list_rec *item_list);
extern struct list_rec *head_list(struct list_rec *list);
extern void setup_list_rec(struct list_rec *list, void *item, void *item1,
    struct list_rec *head, struct list_rec *before, struct list_rec *next);
extern struct list_rec *find_item(struct list_rec *list, void *item,
    int select);
extern unsigned long cnt_num_list_items(struct list_rec *item_list);
extern void *list_item(struct list_rec *list, int which_item);
extern void add_item_as_cur_list_tail(struct list_rec *list,
    struct list_rec *item_list);
#endif


/* Defined in look_objects.c */
#ifdef OBJECT_H      /* For all_object_rec */
extern int detect_all_sub_objs(struct all_object_rec *all_objs,
    int is_delete_internal_bpt, int is_breaker);
#endif


/* Defined in mag_win_pixels.c */
#ifdef DISPLAY_WIN_H
extern int enter_magnify_pixel(struct image_display_window *win, int status);
#endif


/* Defined in magnify_img.c */
#ifdef PIXEL_DESC_H
extern void get_mag_image_size1(unsigned long *mag_total_size,
    unsigned long *mag_dimx, unsigned long *mag_dimy,
    unsigned long dimx, unsigned long dimy,
    unsigned long pixel_depth, struct pixel_desc_rec *pixel_desc);
extern void get_magnify_pixel_proc(int **whch_magnify_pixel_proc,
    unsigned long pixel_depth);
extern int MagnifyTheImage(struct color_data_rec **colors,
    unsigned long num_colors,
    struct int_bound_rec *bound, unsigned short **out_2d_buf,
    unsigned long out_dimx, unsigned long out_dimy,
    unsigned long out_pixel_depth, struct int_region_rect *dimension,
    struct pixel_desc_rec *pixel_desc, unsigned long *map_values,
    unsigned long num_map_values, unsigned long bkg_color);
extern void GetMagnifyPixelProc(int **whch_magnify_pixel_proc,
    unsigned long pixel_depth);
extern int get_shrink_dim(unsigned long dimx, unsigned long dimy,
    double shrink_xratio, double shrink_yratio, unsigned long *new_dimx,
    unsigned long *new_dimy);
#endif


/* Defined in menu.c */
#ifdef xview_xview_DEFINED
extern int ShowMenuStrsProc(Xv_Window win, Event *event, char *menu_title,
    struct strs_rec *strs_rec_ptr, int free_str_status, int (*proc)(),
    void *arg1, int is_return_proc_str_arg, void *arg2, void *arg3);
extern void make_menu_items_active(Menu menu);
extern void make_menu_items_inactive(Menu menu);
extern int SetupTheMenu(Menu *menu, char *menu_title, int is_release,
    Xv_Window win, struct strs_rec *ptr, int (*action_proc)(),
    void *menu_client_data);
extern int show_menu_dir_fns(Xv_Window win, Event *event, char *dir_fn,
    struct strs_rec *dirs, int (*action)(), void *arg);
#endif


/* Defined in modify_img.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern struct all_modify_img_recs *enter_modify_image(
    struct image_display_window *win, int status);
extern int win_modify_update_color_opr(struct image_display_window *win);
#endif


/* Defined in mri_file_info.c */
#ifdef INPUT_H   /* For input_file_rec */
extern int file_info(struct input_file_rec *file, char **fn);
#endif


/* Defined in outline_objects.c */
#ifdef OBJECT_H
#ifdef SLICE_ROI_REC_H
int get_all_obj_curve_recs(struct all_object_rec *all_objs,
    struct curve_rec ***curves, unsigned int *total_curves,
    unsigned int *num_curves);
#endif
#endif


/* Defined in pixel_count_anal.c */
#ifdef DISPLAY_WIN_H
/* FIXME:  See win_analysis() for an explanation why the following
   prototype is commented out.  -PWH 19990527 */
/* extern int win_pixel_count_analysis(struct dp_anal_rec **anal,
    struct image_display_window *win, unsigned int num_slices,
    int anal_status);  
*/
#endif


/* Defined in pixel_desc_rec.c */
#ifdef DISPLAY_WIN_H
extern int bufx_to_screenx(struct screen_data_rec *screen, long x);
extern int bufy_to_screeny(struct screen_data_rec *screen, int y);
extern long screenx_to_bufx(struct screen_data_rec *screen, long x,
    unsigned long dimx);
extern long screeny_to_bufy(struct screen_data_rec *screen, long y,
    unsigned long dimy);
extern void init_pixel_desc_rec(struct pixel_desc_rec *pixel, int def_magx,
    int def_magy);
extern void free_pixel_desc_rec(struct pixel_desc_rec *pixel);
extern int copy_pixel_desc_rec(struct pixel_desc_rec *dest,
    struct pixel_desc_rec *source);
extern int setup_pixel_desc_rec(struct pixel_desc_rec *pixel,
    unsigned int dimx, unsigned int dimy, unsigned char **mask,
    unsigned int **value);
extern int swap_pixel_desc_rec(struct pixel_desc_rec *pixel1,
    struct pixel_desc_rec *pixel2);
#endif


/* Defined in pixel_selection.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern void setup_pixel_selection(struct image_display_window *win);
extern int paste_selected_pixels(struct image_display_window *win);
#endif


/* Defined in pixel_type.c */
#ifdef INPUT_H
extern int SetupAllSliceMaps(struct input_file_rec *file, int *is_ready);
extern int get_2d_map_pick(struct buf_2d_rec *_2dx, struct buf_2d_rec *_2dy,
    struct buf_2d_rec *pixel_type_map, struct buf_2d_rec *result_map,
    char *picks);
extern int Get1dMapPick(struct buf_2d_rec *pixel_type_map,
    struct buf_2d_rec *result_map, char *picks, unsigned long num_picks);
extern int IsAllPixelTypeMapReady(struct pixel_type_rec *pixel_type,
    struct hdr_rec *hdr);
extern struct buf_2d_rec *get_cur_slice_map(struct input_file_rec *file,
    struct hdr_scan_entry_rec *cur_slice);
extern struct buf_2d_rec *get_histo_map(struct img_buf_rec *img);
extern int is_all_pixel_type_map_ready(struct input_file_rec *file);
extern struct buf_2d_rec *get_img_pixel_type_map(struct img_buf_rec *img);
extern int setup_cur_slice_map(struct buf_2d_rec *slice_map,
    struct buf_2d_rec **slice_map_ptr, struct input_file_rec *file,
    struct hdr_scan_entry_rec *cur_slice);
extern int get_map(struct img_buf_rec *img, struct buf_2d_rec *slice_map,
    struct buf_2d_rec *mask, struct int_bound_rec *affected,
    struct buf_2d_rec *pixel_type_map);
extern int build_pixel_type_map(struct histo_params_rec *histo,
    struct pixel_type_rec *pixel_type);
extern int setup_slice_mask(struct img_buf_rec *img, struct buf_2d_rec *img_2d,
    struct buf_2d_rec *slice_mask, unsigned char *selected);
extern int get_slice_mask(struct img_buf_rec *img, struct buf_2d_rec *img_2d,
    struct buf_2d_rec *slice_mask, unsigned char *selected);
extern int GetHistoRoiMask(struct img_buf_rec *img, struct draw_mask_rec *mask,
    struct int_bound_rec *affected, int option,
    struct roi_rec *image_view_roi);
extern int GetHistoMapMask(struct img_buf_rec *img,
    struct buf_2d_rec *histo_mask, struct buf_2d_rec *mask,
    struct int_bound_rec *affected);
extern char *get_pixel_type_label(struct img_buf_rec *img, unsigned int x,
     unsigned int y);
extern char *GetHistoPixelTypeLabel(struct img_buf_rec *img, unsigned int x,
     unsigned int y, int win_type2);
#endif


/* Defined in pixel_type_rec.c */
#ifdef TEXT_FORMAT_H    /* For struct pixel_type_cnt_rec */
extern void exit_pixel_type_cnt_rec(struct pixel_type_cnt_rec **ptr);
extern void free_pixel_type_rec(struct pixel_type_rec *pixel_type);
extern void init_pixel_type_cnt_rec(struct pixel_type_cnt_rec *ptr);
extern void init_pixel_type_rec(struct pixel_type_rec *pixel_type);
extern int rd_file_pixmap_for_slice_num(char *dir, char *fn, char *suffix,
    struct pixel_type_rec *pixel_type, long num_slices,
    struct buf_2d_rec *slice_map, int slice_num);
extern int AutoRdFilePixmapHdr1(char *dir, char *fn, char *suffix,
    struct pixel_type_rec *pixel_type);
extern int rd_file_pixmap_slices(char *dir, char *fn, char *suffix,
    struct pixel_type_rec *pixel_type, long num_slices);
#endif


/* Defined in polarity.c */
#ifdef COMMON_H        /* For buf_2d_rec */
#ifdef RECT_H          /* For int_bound_rec */
int pt_polarity(struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2,
    int num_echoes, long max_diff_val, long row, long col,
    struct buf_2d_rec *direction_mask, struct int_bound_rec *bound_area,
    float *ave1, float *ave2);
#endif
#endif


/* Defined in process_draw.c */
#ifdef xview_xview_DEFINED
extern void process_draw_proc(Xv_Window canvas, Event *event);
extern int process_loc_move(Xv_Window canvas, Event *event,
    int must_display_loc);
#endif

#ifdef xview_xview_DEFINED
#ifdef DISPLAY_WIN_H
extern int WinDeleteCurPts(struct image_display_window *win, int use_start_pt,
    unsigned long start_pt, unsigned long num_pts);
extern int win_move_mouse_to_cur_pt(struct image_display_window *win);
extern void WinEraseAndDisplayPts(struct image_display_window *win,
    int use_start_pt, unsigned long start_pt, unsigned long num_pts);
extern int win_delete_cur_roi_curve(struct image_display_window *win);
#endif
#endif


/* Defined in process_key.c */
#ifdef xview_xview_DEFINED
extern int process_ascii_event(Xv_Window canvas, Event *event);
#endif


/* Defined in process_region.c */
#ifdef COMMON_H
extern int or_ary_2ds(struct buf_2d_rec *dest, struct buf_2d_rec **_2ds,
    unsigned long num_2ds);
extern int superimpose_bitmap_region(struct buf_2d_rec *dest,
    struct buf_2d_rec *source, struct int_bound_rec *source_dim);
extern int Select2d(struct buf_2d_rec *_2d, double lb, double ub,
    struct buf_2d_rec *result_2d, unsigned long set_selected,
    double selected_val, unsigned long set_not_selected,
    double not_selected_val);
extern int NotBitmap(struct buf_2d_rec *result, struct buf_2d_rec *src);
extern int AndBitmaps(struct buf_2d_rec *result, struct buf_2d_rec *src1,
    struct buf_2d_rec *src2);
extern int OrBitmaps(struct buf_2d_rec *result, struct buf_2d_rec *src1,
    struct buf_2d_rec *src2);
extern int OrAndBitmaps(struct buf_2d_rec *result, struct buf_2d_rec *src1,
    struct buf_2d_rec *src2);
extern int xor_bitmaps_by_bound(struct buf_2d_rec *dest,
    struct buf_2d_rec *source, unsigned long left, unsigned long top,
    unsigned long right, unsigned long bottom);
extern int select_2d_by_val(struct buf_2d_rec *_2d, struct buf_2d_rec *result,
    unsigned char *selected);
extern int Invert2dValProc(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, double *min, double *newmin, double *ratio);
extern int Invert2d(struct buf_2d_rec *_2d);
extern int Select2dByMask(struct buf_2d_rec *_2d, unsigned long startleft,
    unsigned long starttop, struct buf_2d_rec *mask,
    struct int_bound_rec *affected, double lb, double ub,
    struct buf_2d_rec *result_2d, int set_selected, double selected_val,
    int set_not_selected, double not_selected_val);
extern int fill_2d_convex_area(struct buf_2d_rec *_2d, unsigned long value);
#endif


/* Defined in prog_rec.c */
#ifdef MRI_FORMAT_H   /* For struct prog_rec */
extern void free_prog_rec( struct prog_rec *prog );
extern char *get_prog_def_fn( struct prog_rec *prog, char *fn);
extern char *get_prog_dir(struct prog_rec *prog);
extern void init_prog_rec(struct prog_rec *prog, char *prog_name);
extern int setup_prog_rec(struct prog_rec *prog, char *defaults_fn,
    int is_defaults_fn_supplied);
#endif


/* Defined in rdir.c */
extern char *get_dat_fn(char *hdr_fn, char *dat_patt);

#ifdef MRI_FORMAT_H   /* Ugly kluge on struct input_rec */
extern int close_all_files( struct input_rec *input, int must_close);
extern int close_and_delete_file(struct input_file_rec *file, int must_close);
extern int open_a_file(struct prog_rec *prog, char *dir, char *fn,
    char *hdr_suffix, char *img_suffix, char *dat_dir, char *dat_fn,
    char *dat_fn_suffix, char *bin_fn_suffix);
#endif

#ifdef MRI_FORMAT_H   /* Ugly kluge on struct prog_rec */
#ifdef ASK_FILE_H     /* Ugly kluge for struct dir_fn_rec */
extern int open_fn_proc( struct prog_rec *prog, struct dir_fn_rec *dir);
#endif
#endif

#ifdef DISPLAY_WIN_H      /* For struct display_win_rec */
extern void win_rd_breaker_check( void *dummy1, void *dummy2,
   struct display_win_rec *win1);
#endif

#ifdef OUTPUT_H     /* For output_file_rec */
extern int AutoSaveDatOutput(struct output_file_rec *output,
    int is_quit_file);
extern int rd_dat_output(struct output_file_rec *output);
#endif

#ifdef INPUT_H      /* For input_file_rec */
#ifdef xview_xview_DEFINED
extern int save_pixel_types(struct input_file_rec *file, Frame frame,
    int is_dp_msg);
#endif
#endif


/* Defined in roi_menu.c */
#ifdef xview_xview_DEFINED
extern void activate_pen_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void all_wins_cur_roi_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void breaker_it_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void breaker_options_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void clipboard_it_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void clipboard_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void delete_roi_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int arg_value);
extern void delete_the_grown_roi_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void dp_delete_roi_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void dp_draw_list_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void dp_more_rois_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void dp_trans_roi_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void draw_link_with_wid_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int is_delete);
extern void edit_next_empty_curve_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void edit_scratch_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void highlight_next_curve_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int is_backward);
extern void highlight_next_roi_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int is_backward);
extern void import_slice_rois_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void label_roi_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void more_roi_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int display_option);
extern void pen_type_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int pen_type);
extern void reverse_slice_rois_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void show_pixel_type_roi_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void show_roi_menu_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void slice_rect_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void trans_roi_mode_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern int trans_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
extern Menu gen_clipboard_proc(Menu menu, Menu_generate operation);
extern Menu gen_more_roi_proc(Menu menu, Menu_generate operation);
extern Menu setup_delete_roi_menu(void);
extern Menu gen_show_roi_proc1(Menu main_menu, Menu_generate operation);
extern Menu setup_breaker_menu(void);
extern Menu gen_pen_type_proc(Menu menu, Menu_generate operation);
#endif /* xview_xview_DEFINED */

#ifdef DISPLAY_WIN_H   /* For struct display_win_rec */
extern void break_the_region(struct image_display_window *win);
#endif

#ifdef xview_xview_DEFINED
#ifdef DISPLAY_WIN_H   /* For struct display_win_rec */
extern void key_activated_show_roi_proc( Menu menu, Menu_item item,
   struct display_win_rec *win, Xv_Window window, Event *last_event);
extern void show_the_menu(struct show_menu_rec *show_menu, int which);
extern int delete_curve_mode(Menu menu, Menu_item item,
    struct display_win_rec *win1, Xv_Window canvas_win, Event *event);
extern int win_enable_pen_draw_mode(struct image_display_window *win);
extern void key_activated_show_roi_proc( Menu menu, Menu_item item,
   struct display_win_rec *win, Xv_Window window, Event *last_event);
#endif
#endif /* xview_xview_DEFINED */


/* Defined in roi_to_histo_roi.c */
#ifdef DISPLAY_WIN_H
extern int cur_slice_types_to_histo_rois(struct image_display_window *win);
extern int win_cur_histo_roi_to_slice_roi(struct image_display_window *win);
extern int roi_to_histo_roi(struct image_display_window *win,
    struct roi_rec *this_roi, int option, char *histo_roi_label, Frame frame);
extern void all_slice_types_to_histo_rois(struct image_display_window *win);
extern int win_mask_to_histo_roi(struct image_display_window *win,
    struct buf_2d_rec *mask, struct int_bound_rec *mask_area, char *label,
    int option, Frame frame);
#endif


/* Defined in save_data_file.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern void setup_enter_data_file_rec(struct image_display_window *win);
extern int rd_file_slice_rois(struct input_file_rec *file,
    struct image_display_window *win, char *fn, int is_free_fn,
    int use_output_file_rec_fn, int is_rd_all, long slice_num);
extern int win_rd_pixmap(struct image_display_window *win);
extern int win_rd_dat_output(struct image_display_window *win);
#endif


/* Defined in scan_objects.c */
#ifdef OBJECT_H
extern void free_all_object_rec1(struct all_object_rec *all_objs,
    int free_id_2d);
extern void init_all_object_rec(struct all_object_rec *all_objs);
extern int setup_all_object_rec(struct all_object_rec *all_objs,
    struct buf_2d_rec *in_2d, struct buf_2d_rec *id_2d, int is_clear_id_2d,
    struct int_bound_rec *bound, unsigned long lbval, unsigned long ubval);
extern int merge_all_objs_rec_merged_objs(struct all_object_rec *all_objs,
    int update_id_2d, int is_pr);
extern int merge_objs(struct all_object_rec *all_objs,
    struct object_rec *dest_obj, struct object_rec *src_obj);
extern int enter_obj_xy(struct object_rec *obj, int status, unsigned long x,
    unsigned long y);
extern struct object_rec *get_obj(struct all_object_rec *all_objs,
    unsigned long id, int *err);
extern int scan_objects(struct buf_2d_rec *_2d,
    struct int_bound_rec *bound_area, struct curve_rec ***curves,
    unsigned int *total_curves, unsigned int *num_curves,
    unsigned long lbval, unsigned long ubval);
extern int detect_all_objs(struct all_object_rec *all_objs, int update_id_2d);
extern void sort_xy_rec(struct object_rec *obj);
extern void free_object_rec(struct object_rec *obj);
extern void init_object_rec(struct object_rec *obj);
extern void delete_all_object_rec_id_2d(struct all_object_rec *all_objs,
    int free_id_2d);
extern void get_object_rec_obj_bound(struct object_rec *obj);
extern int delete_all_negative_boundary_objs(struct all_object_rec *sub);
extern int define_all_negative_boundary_objs(struct all_object_rec *sub,
    struct object_rec *obj);
extern int delete_duplicate_object_rec_obj_pts(struct object_rec *obj);
extern int discard_bounded_pts(struct all_object_rec *all_objs);
extern int scan_objects(struct buf_2d_rec *_2d,
    struct int_bound_rec *bound_area, struct curve_rec ***curves,
    unsigned int *total_curves, unsigned int *num_curves,
    unsigned long lbval, unsigned long ubval);
extern int scan_objects(struct buf_2d_rec *_2d,
    struct int_bound_rec *bound_area, struct curve_rec ***curves,
    unsigned int *total_curves, unsigned int *num_curves,
    unsigned long lbval, unsigned long ubval);
#endif


/* Defined in screen_data_rec.c */
#ifdef DISPLAY_WIN_H      /* For struct screen_data_rec */
extern setup_def_screen_data_rec(
   struct screen_data_rec *screen,
   struct int_rect_rec *limitrr,
   unsigned int left,
   unsigned int top,
   unsigned int width,
   unsigned int height,
   int magx,
   int magy, int is_same_magxy);
extern int setup_screen_dimension(struct int_region_rect *dim,
    struct int_region_rect *last_dim, struct pixel_desc_rec *pixel,
    struct pixel_desc_rec *last_pixel, int HowToDefine, int CenterIt,
    int centerx, int centery);
extern void free_screen_data_rec(struct screen_data_rec *screen);
extern void init_screen_data_rec(struct screen_data_rec *screen);
extern int ScaleViewScreenDimXY(struct screen_data_rec *screen,
    unsigned long dimx, unsigned long dimy, unsigned long use_magxy,
    unsigned long magx, unsigned long magy);
extern int setup_screen_pixel_desc_rec1(struct pixel_desc_rec *pixel,
    struct pixel_desc_rec *last_pixel, unsigned int num_rows,
    unsigned int num_cols);
extern void swap_screen_dimension(struct int_region_rect *dimension1,
    struct int_region_rect *dimension2);
#endif


/* Defined in screen_overlay.c */
#ifdef DISPLAY_WIN_H
extern int win_delete_overlay_list(struct image_display_window *win,
    int is_delete_img);
extern int WinMultiEchoComputeOverlay(struct image_display_window *win,
    int is_dp_canvas, int is_processed_draw_list);
extern int WinShowHideOverlay(struct image_display_window *win);
extern int WinDeleteOverlay(struct image_display_window *win);
extern int win_overlayed_by_wid(struct image_display_window *win, char *wid,
    long select);
#endif


/* Defined in segment_echo.c */
#ifdef INPUT_H    /* For histo_params_rec */
#ifdef SEGMENT_H  /* For all_segment_rec */
extern int segment_1_echo_1(struct histo_params_rec *histo,
    struct img_buf_rec *img, struct pixel_type_rec *pixel_type);
extern int segment_2_echo_1(struct histo_params_rec *histo,
    struct img_buf_rec *img, struct all_segment_rec *allseg,
    struct pixel_type_rec *pixel_type);
#endif
#endif

#ifdef INPUT_H    /* For histo_params_rec */
extern int segment_1_echo(struct histo_params_rec *histo,
    struct img_buf_rec *img, struct pixel_type_rec *pixel_type,
    struct strs_rec *priority, unsigned long num_slice_maps);
extern int segment_2_echo(struct histo_params_rec *histo,
    struct img_buf_rec *img, struct pixel_type_rec *pixel_type,
    struct strs_rec *priority, unsigned long num_slice_maps);
#endif


/* Defined in segment_1_echo-1.c */
#ifdef COMMON_H    /* For buf_2d_rec */
#ifdef HISTO_H     /* For pixel_type_ave_rec */
#ifdef SEGMENT_H   /* For pixel_stack_rec_ptr */
extern int solve_deadlock_pixels(struct pixel_type_ave_rec *type_aves,
    unsigned long num_type_aves, struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve,
    struct pixel_stack_rec_ptr *image_mask, int *is_done);
#endif
#endif
#endif


/* Defined in segment_1_echo.c */
#ifdef SEGMENT_H
extern int drop_empty_stack_lists(struct pixel_stack_rec_ptr *resolve);
#endif

#ifdef INPUT_H    /* For histo_params_rec, pixel_type_rec */
extern int setup_pixel_type_maps(struct pixel_type_rec *pixel_type,
    unsigned long num_slice_maps);
extern int setup_pixel_type_order(struct pixel_type_rec *pixel_type,
    struct histo_params_rec *histo);
#endif

#ifdef INPUT_H    /* For histo_params_rec, pixel_type_rec */
#ifdef SEGMENT_H  /* For all_segment_rec */
#ifdef STR_DEF_H  /* For strs_rec */
extern int setup_segment_1_echo(struct histo_params_rec *histo,
    struct pixel_type_rec *pixel_type, struct strs_rec *priority,
    unsigned long num_slice_maps);
extern int update_neighs(struct neighbor_type_rec *neigh,
    struct buf_2d_rec *neigh_2d, long row, long col, long type);
extern long cnt_pixel_stack_rec_ptr(struct pixel_stack_rec_ptr *resolve);
extern int sort_type_conn_fac_rec_proc(const void *type1, const void *type2);
extern void free_neighbor_type_rec(struct buf_2d_rec *neigh_2d);
extern int setup_1_echo_histo_pixel_type_order(struct histo_params_rec *histo);
extern int segment_1_echo_pixels(struct pixel_tissue_type_rec *types,
    unsigned long num_types, struct buf_2d_rec *_2d,
    struct buf_2d_rec *pixel_map, struct histo_params_rec *histo, int option);
extern int setup_segment_rois(struct pixel_tissue_type_rec **types,
    unsigned long *total_types, unsigned long *num_types,
    struct strs_rec *order, struct slice_roi_rec *slice_roi, int is_xdim,
    long the_lb, long the_ub);
#endif
#endif
#endif


/* Defined in segment_2_echo.c */
#ifdef INPUT_H    /* For histo_params_rec */
#ifdef SEGMENT_H  /* For all_segment_rec */
#ifdef STR_DEF_H  /* For strs_rec */
extern void init_all_segment_rec(struct all_segment_rec *allseg);
extern void free_all_segment_rec(struct all_segment_rec *allseg);
extern int setup_segment_2_echo(struct histo_params_rec *histo,
    struct all_segment_rec *allseg, struct pixel_type_rec *pixel_type,
    struct strs_rec *priority, unsigned long num_slice_maps,
    unsigned long img_dimx, unsigned long img_dimy);
extern int setup_pixel_type_ave_rec(struct pixel_type_ave_rec **type_aves,
    long *num_type_aves, long num_types);
extern int compute_2_echo_weights(struct neighbor_type_rec *neigh,
    struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2, long x, long y);
extern int segment_pixel_map(struct buf_2d_rec *pixel_map,
    struct buf_2d_rec *neigh_2d, struct buf_2d_rec *image_mask);
extern int setup_neighbor_type_rec(struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve, struct buf_2d_rec *_2d1,
    struct buf_2d_rec *_2d2, struct buf_2d_rec *image_mask, int num_echoes);
extern int neighbor_weights(struct neighbor_type_rec *neigh,
    struct type_val_rec *cur_pix, long x, long y, struct buf_2d_rec *neigh_2d,
    struct buf_2d_rec *image_mask);
extern void incompatible_type_by_neighbors(struct neighbor_type_rec *neigh,
    struct type_val_rec *cur_pix, long x, long y, struct buf_2d_rec *neigh_2d);
extern long cnt_stack_xy_rec(struct stack_xy_rec *top);
extern int setup_stack_xy_rec(struct stack_list_rec *list, long x, long y,
    struct stack_xy_rec **xy);
extern void init_type_val_rec(struct type_val_rec *set);
extern void init_stack_list_rec(struct stack_list_rec *list);
extern void free_type_val_rec(struct type_val_rec *set);
extern void init_pixel_stack_rec_ptr(struct pixel_stack_rec_ptr *resolve_ptr);
extern void free_pixel_stack_rec_ptr(struct pixel_stack_rec_ptr *resolve_ptr,
    int is_free_lists);
extern int segment_2_echo_pixels(struct segment_rec *seg,
    struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2,
    struct buf_2d_rec *pixel_map, struct histo_params_rec *histo,
    int option);
extern int setup_all_segment_rec(struct all_segment_rec *allseg,
    struct histo_params_rec *histo, int is_quadrant,
    struct strs_rec *quadrant_label, unsigned long img_dimx,
    unsigned long img_dimy);
#endif
#endif
#endif

#ifdef INPUT_H    /* For histo_params_rec */
#ifdef STR_DEF_H  /* For strs_rec */
extern int SetupHistoPixelTypeOrder(struct histo_params_rec *histo,
    struct strs_rec *priority, int is_quadrant_allow, int *is_quadrant,
    struct strs_rec *quadrant_label, int histo_type2);
#endif
#endif

extern void view_quadrant_xys(long dimx, long dimy, long *x1, long *y1,
    long *x2, long *y2, int which_quadrant);



/* Defined in set_image_backgroud.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern void setup_enter_bkg(struct image_display_window *win);
#endif


/* Defined in show_color_screen.c */
#ifdef DISPLAY_WIN_H
extern int win_filter_image_data(struct image_display_window *win);
extern int WinNewColorMultiCanvas(struct image_display_window *win);
extern int WinNewImgMultiCanvas(struct image_display_window *win);
extern int WinMultiScreenCanvas(struct image_display_window *win);
extern int WinScreenCanvas(struct image_display_window *win);
extern int WinMultiCanvas(struct image_display_window *win);
extern int WinNewColorScreenForSliceRoiWins(struct image_display_window *win);
extern int WinNewColorCanvas(struct image_display_window *win);
extern int WinColorCanvas(struct image_display_window *win);
extern int WinMultiEchoMultiScreenCanvas(struct image_display_window *win);
extern int WinNewColorData(struct image_display_window *win);
extern int WinNewColorRequest(struct image_display_window *win);
extern int WinHistoNewColorMultiCanvas(struct image_display_window *win);
extern int WinHistoMultiCanvas(struct image_display_window *win);
extern int WinScreen(struct image_display_window *win);
extern int WinNewColorScreen(struct image_display_window *win);
extern int WinMultiEchoNewColorMultiCanvas(struct image_display_window *win);
#endif


/* Defined in slice_roi_rec.c */
#ifdef SLICE_ROI_REC_H   /* For struct slice_roi_rec */
extern void free_curve_rec(struct curve_rec *curve);
extern void free_curve_recs(struct curve_rec **curves,
    unsigned long num_curves);
extern int delete_all_cur_pen_curves(struct roi_rec *roi,
    unsigned short *status);
extern int delete_all_roi_curves(struct roi_rec *roi, unsigned short *status);
extern int delete_cur_roi_curve(struct slice_roi_rec *slice_roi);
extern int delete_curve_all_pts(struct curve_rec *curve,
    unsigned short *status);
extern int EnterPtsIntoSliceRoiRec(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *tolocal, char *label, unsigned long pen_type,
    int new_curve, unsigned long num_xys, ...);
extern void free_slice_roi_rec(struct slice_roi_rec *slice_roi);
extern void free_user_defined_rec(struct user_defined_rec *user);
extern int  delete_roi(struct slice_roi_rec *slice_roi, struct roi_rec *roi);
extern int  DeleteRoisOfType(struct slice_roi_rec *slice_roi, int roi_type,
    int select);
extern void init_curve_2d_rec(struct curve_2d_rec *pen, int pen_type);
extern void init_curve_rec(struct curve_rec *curve);
extern int  init_roi_rec(struct roi_rec *roi, char *label);
extern void init_slice_roi_rec(struct slice_roi_rec *slice_roi);
extern void init_user_defined_rec(struct user_defined_rec *user);
extern int  JoinRois(struct slice_roi_rec *slice_roi1,
    struct slice_roi_rec *slice_roi2, int set_cur, double sx, double sy,
    struct matrix_2d_rec *tolocal1, struct matrix_2d_rec *localto1,
    struct matrix_2d_rec *localto2);
extern int keep_only_non_empty_curves(struct slice_roi_rec *slice_roi);
extern int setup_more_rois(struct slice_roi_rec *slice_roi, char *label,
    int set_cur_roi);
extern int CpSliceRoiRec(struct slice_roi_rec *slice_roi1,
    struct slice_roi_rec *slice_roi2, struct matrix_2d_rec *tolocal1,
    struct matrix_2d_rec *localto1, struct matrix_2d_rec *localto2);
extern int JoinRoiToSliceRoiRec(struct slice_roi_rec *slice_roi,
    struct roi_rec *roi, int set_cur_roi, double sx, double sy,
    struct matrix_2d_rec *tolocal1, struct matrix_2d_rec *localto1,
    struct matrix_2d_rec *localto2);
extern void free_curve_recs(struct curve_rec **curves,
    unsigned long num_curves);
extern int append_curve_to_roi_rec(struct roi_rec *roi,
    struct curve_rec *curve, int pen_type, int set_cur,
    unsigned short *status);
extern int delete_cur_curve(struct curve_2d_rec *pen, unsigned short *status,
    int is_free_curve);
extern int JoinCurveToRoiRec(struct roi_rec *roi, struct curve_rec *curve,
    int pen_type, int set_cur, unsigned short *status, double sx, double sy,
    struct matrix_2d_rec *tolocal1, struct matrix_2d_rec *localto1,
    struct matrix_2d_rec *localto2);
extern int JoinRoiRecs(struct roi_rec *roi1, struct roi_rec *roi2, int set_cur,
    unsigned short *status, double sx, double sy,
    struct matrix_2d_rec *tolocal1, struct matrix_2d_rec *localto1,
    struct matrix_2d_rec *localto2);
extern void delete_all_rois(struct slice_roi_rec *slice_roi);
extern int JoinCurveToSliceRoiRec(struct slice_roi_rec *slice_roi,
    char *roi_label, int pen_type, struct curve_rec *curve, int set_cur_roi,
    int set_cur_pen, int set_cur_curve, double sx, double sy,
    struct matrix_2d_rec *tolocal1, struct matrix_2d_rec *localto1,
    struct matrix_2d_rec *localto2);
extern void setup_slice_roi_rec_dim(struct slice_roi_rec *slice_roi,
    unsigned long dimx, unsigned long dimy);
extern int EnterCurveXY(struct curve_rec *curve, double x, double y,
    unsigned short *status, struct matrix_2d_rec *tolocal,
    int is_check_matrix, int use_xy_indx, unsigned long xy_indx);
extern int setup_curve_rec_ptr(struct curve_rec **curve, int pen_type);
extern void free_roi_rec(struct roi_rec *roi);
extern int JoinCurveRec(struct curve_rec *dest, struct curve_rec *src,
    int use_src_indx, unsigned long src_indx, unsigned short *status,
    double sx, double sy, struct matrix_2d_rec *tolocal1,
    struct matrix_2d_rec *localto1, struct matrix_2d_rec *localto2);
extern int JoinCurvesToRoiRec(struct roi_rec *roi, struct curve_rec **curves,
    unsigned long num_curves, unsigned short *status, double sx, double sy,
    struct matrix_2d_rec *tolocal1, struct matrix_2d_rec *localto1,
    struct matrix_2d_rec *localto2);
extern int EnterRoiCurvePt(struct roi_rec *roi, int pen_type, int new_curve,
    double x, double y, unsigned short *status, struct matrix_2d_rec *tolocal);
extern int joint_curves_of_type(struct slice_roi_rec *slice_roi,
    char *roi_label, int pen_type, int set_cur);
extern int EnterCurvePts(struct curve_rec *curve, unsigned short *status,
    struct matrix_2d_rec *tolocal, unsigned long num_xys, ...);
extern int EnterPtsIntoRoiRec(struct roi_rec *roi, unsigned long pen_type,
    unsigned short *status, struct matrix_2d_rec *tolocal, int new_curve,
    unsigned long num_xys, ...);
extern int append_curves_to_roi_rec(struct roi_rec *roi,
    struct curve_rec **curves, unsigned long num_curves,
    unsigned short *status);
extern int EnterSliceRoiRecPt(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *tolocal, char *label, int pen_type, int new_curve,
    double x, double y);
extern int DeleteSliceRoiCurPts(struct slice_roi_rec *slice_roi,
    int use_start_pt, unsigned long start_pt, unsigned long num_pts);
extern int EnterPtAryIntoRoiRec(struct roi_rec *roi, unsigned long pen_type,
    unsigned short *status, struct matrix_2d_rec *tolocal, int new_curve,
    unsigned long num_xys, float *aryx, float *aryy);
extern int delete_cur_roi(struct slice_roi_rec *slice_roi);
extern int add_roi_rec_handle(struct slice_roi_rec *slice_roi,
    unsigned long add_num_rois);
extern int setup_cur_curve_rec(struct curve_2d_rec *pen);
extern int setup_cur_curve_2d_rec(struct roi_rec *roi, int pen_type,
    int set_cur_pen);
extern int change_cur_curve_pen_type(struct slice_roi_rec *slice_roi,
    int pen_type);
#endif


/* Defined in slice_roi_rec_extra.c */
#ifdef SLICE_ROI_REC_H   /* For struct curve_rec */
#ifdef GEOMETRY_H        /* For struct matrix_2d_rec */
extern struct curve_rec *get_cur_curve(struct slice_roi_rec *slice_roi);
extern struct roi_rec *get_cur_roi(struct slice_roi_rec *slice_roi);
extern char *get_cur_roi_label(struct slice_roi_rec *slice_roi);
extern int is_slice_roi_non_empty(struct slice_roi_rec *slice_roi);
extern struct roi_rec *find_roi_rec(struct slice_roi_rec *slice_roi,
    char *label, int set_cur_roi);
extern struct roi_rec *get_roi(struct slice_roi_rec *slice_roi, char *label);
extern struct curve_rec *locate_curve_of_type(struct slice_roi_rec *slice_roi,
    int curve_type, int set_cur);
extern int LongCurvePtByIndx(struct curve_rec *cur_curve, unsigned long indx,
    long *x, long *y, struct matrix_2d_rec *localto);
extern int CurvePtByIndx(struct curve_rec *cur_curve, unsigned long indx,
    float *x, float *y, struct matrix_2d_rec *localto);
extern struct roi_rec *next_cur_roi(struct slice_roi_rec *slice_roi,
    char *label);
extern int next_curve(struct slice_roi_rec *slice_roi, int new_curve);
extern int is_roi_non_empty(struct roi_rec *roi);
extern int FindRoiLongMinMax(struct roi_rec *roi,
    struct matrix_2d_rec *localto, long *minx, long *maxx, long *miny,
    long *maxy, int use_start_indx, unsigned long start_indx,
    int is_recompute);
extern int SetSameRoisStatus(struct slice_roi_rec *slice_roi1,
    struct slice_roi_rec *slice_roi2, int and_status2, int or_status2,
    int and_prog_status2, int or_prog_status2);
extern int is_curve_closed(struct curve_rec *curve);
extern int FindCurveLongMinMax(struct curve_rec *curve,
    struct matrix_2d_rec *localto, long *minx, long *maxx, long *miny,
    long *maxy, int curve_type, int use_start_indx, unsigned long start_indx,
    int is_recompute);
extern struct roi_rec *get_roi_of_type(struct slice_roi_rec *slice_roi,
    int roi_type, int set_cur_roi);
extern int is_curve_non_empty(struct curve_rec *curve);
extern int sort_curve_min_max_lt(struct curve_rec **curve1,
    struct curve_rec **curve2);
extern int FindTheCurveMinMax(struct curve_rec *curve,
    struct matrix_2d_rec *localto, int curve_type, int use_start_indx,
    unsigned long start_indx, int is_recompute);
extern struct curve_2d_rec *get_cur_pen(struct slice_roi_rec *slice_roi);
extern int is_cur_curve_non_empty(struct slice_roi_rec *slice_roi);
extern void set_roi_saved(struct slice_roi_rec *slice_roi);
extern int GetCurveLast2LongPts(struct curve_rec *curve, long *x0, long *y0,
    long *x1, long *y1, struct matrix_2d_rec *localto);
extern int FindSliceRoiMinMax(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, float *minx, float *maxx, float *miny,
    float *maxy, int use_start_indx, unsigned long start_indx,
    int is_recompute);
extern int LoopCurCurve(struct slice_roi_rec *slice_roi);
extern int GetRoiLabelPtrs(struct slice_roi_rec *slice_roi,
    struct strs_rec *roi_labels, int is_inc_empty_roi, int is_sort);
extern int AddOffsetToRoiXYs(struct roi_rec *roi, unsigned long select,
    long minx, long maxx, long miny, long maxy, long offset,
    unsigned short *status, struct matrix_2d_rec *tolocal,
    struct matrix_2d_rec *localto);
extern int NewMappedCurve(struct curve_rec *result, struct curve_rec *curve,
    struct matrix_2d_rec *localto, struct matrix_2d_rec *maptolocal);
extern int MatchCurve(struct curve_rec *curve, struct matrix_2d_rec *localto,
    struct curve_rec *match_curve, struct matrix_2d_rec *match_localto,
    double diff_allowed, unsigned long *num_xys, int *is_match_longer);
extern void mark_roi_delete(struct roi_rec *roi, unsigned short *status,
    int is_mark_delete);
extern int next_curve_of_type(struct slice_roi_rec *slice_roi, char *roi_label,
    int pen_type, int new_curve, int set_cur);
extern int rename_roi_label(struct slice_roi_rec *slice_roi,
    struct roi_rec *roi, char *label);
extern int reverse_curve_rec(struct curve_rec *curve);
extern int optimize_curve_rec(struct curve_rec *curve);
extern int set_curve_or(struct curve_rec *curve);
extern int apply_to_slice_roi_rec(struct slice_roi_rec *slice_roi,
    int (*proc)(), void *arg2, void *arg3, void *arg4, void *arg5,
    void *arg6, void *arg7, void *arg8, void *arg9, void *arg10);
extern int LongCurPt(struct slice_roi_rec *slice_roi, long *x, long *y,
    struct matrix_2d_rec *localto);
extern int set_curve_matrix(struct curve_rec *curve,
    struct matrix_2d_rec *matrix, int is_mult, unsigned short *status);
extern int num_curve_pts(struct curve_rec *curve);
extern int delete_roi_marked_delete(struct slice_roi_rec *slice_roi,
    int *is_some_deleted);
extern int set_cur_pen(struct slice_roi_rec *slice_roi, int pen_type,
    int must_exist);
extern int apply_to_roi_rec(struct roi_rec *roi, int (*proc)(), void *arg2,
    void *arg3, void *arg4, void *arg5, void *arg6, void *arg7, void *arg8,
    void *arg9, void *arg10);
extern void set_curve_bound_computed_status(struct curve_rec *curve,
    int is_computed);
extern struct roi_rec *next_roi(struct slice_roi_rec *slice_roi,
    int is_backward);
extern struct roi_rec *exclude_roi_of_type(struct slice_roi_rec *slice_roi,
    int roi_type, int set_cur_roi);
extern struct roi_rec *next_not_cur_roi(struct slice_roi_rec *slice_roi,
    char *label);
extern struct curve_2d_rec *find_pen(struct roi_rec *roi, int pen_type,
    int set_cur_pen);
extern void curve_matrix(struct curve_rec *curve,
    struct matrix_2d_rec *trans_mat, struct matrix_2d_rec *mat,
    struct matrix_2d_rec **pmat, int is_localto);
extern int MoveOutOfBoundRois(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, double left, double top, double right,
    double bottom, double moveto_x, double moveto_y);
extern int MustLoopCurCurve(struct slice_roi_rec *slice_roi);
extern int is_cur_roi_pen_type(struct slice_roi_rec *slice_roi,
    unsigned short *ary, int num_pens);
extern struct roi_rec *next_pen_type(struct slice_roi_rec *slice_roi);
extern int make_next_curve_cur(struct slice_roi_rec *slice_roi,
    int is_backward);
extern int CloseCurCurve(struct curve_2d_rec *pen, unsigned short *status,
    int is_optional);
extern void set_roi_visibility(struct roi_rec *roi, int visibility);
extern void set_all_rois_visibility(struct slice_roi_rec *slice_roi,
    int visibility);
extern int is_slice_roi_no_roi(struct slice_roi_rec *slice_roi);
extern int LongCurPtByIndx(struct slice_roi_rec *slice_roi, unsigned long indx,
    long *x, long *y, struct matrix_2d_rec *localto);
#endif
#endif


/* Defined in slice_roi_rec_interface.c */
#ifdef SLICE_ROI_REC_H
#ifdef DISPLAY_WIN_H
extern int win_get_cur_slice_roi_rec(struct image_display_window *win,
    struct slice_roi_rec **slice_roi, char **cur_roi_label);
extern int FileGetAllRoiLabelPtrs(struct input_file_rec *file,
    struct strs_rec *roi_labels, int is_inc_empty_roi, int is_sort);
extern int WinNextCurRoi(struct image_display_window *win, char *label);
extern int win_get_all_pixel_type_ptrs(struct image_display_window *win,
    struct strs_rec *pixel_types);
extern int win_is_slice_roi_non_empty(struct image_display_window *win);
extern int win_set_control_pen_type(struct image_display_window *win,
    int is_dp_label);
extern int WinGetAllRoiLabelPtrs(struct image_display_window *win,
    struct strs_rec *roi_labels, int is_inc_empty_roi, int is_sorted);
extern int win_search_enclosing_curve(struct image_display_window *win,
    int x, int y, int use_xybound, struct int_bound_rec *xybound);
extern int win_is_slice_roi_no_roi(struct image_display_window *win);
extern int win_move_show_cur_curve(struct image_display_window *win);
extern int win_make_roi_no_display(struct image_display_window *win,
    char *roi_label, int set_cur_roi);
extern int WinDeleteMarkRoi(struct image_display_window *win, int is_dp_cur);
extern int win_set_pt_status(struct image_display_window *win);
extern void WinGetRoiLabelPtrs(struct image_display_window *win,
    struct strs_rec *roi_labels, int is_inc_empty_roi, int is_sort);
extern unsigned long win_num_cur_curve_pts(struct image_display_window *win);
extern int win_change_cur_curve_pen(struct image_display_window *win,
    int pen_type);
extern int win_delete_roi_by_label(struct image_display_window *win,
    char *roi_label);
extern int win_set_pen_type(struct image_display_window *win,
    int use_this_pen_type, int pen_type);
extern int win_join_curve_roi_rec(struct image_display_window *win,
    char *roi_label);
extern int win_rename_cur_roi_label(struct image_display_window *win,
    char *roi_label);
extern char *win_get_cur_roi_label(struct image_display_window *win);
extern int win_next_curve(struct image_display_window *win);
extern int win_loop_cur_curve(struct image_display_window *win, int must_loop);
extern int win_get_cur_pt(struct image_display_window *win, long *x, long *y);
extern int win_get_cur_pt_by_indx(struct image_display_window *win,
    unsigned long indx, long *x, long *y);
extern int win_is_non_empty_roi(struct image_display_window *win, int label);
extern int win_is_non_empty_cur_curve(struct image_display_window *win);
extern int win_bring_back_out_of_bound_rois(struct image_display_window *win);
extern int win_set_all_rois_visibility(struct image_display_window *win,
    int visibility, int is_inc_cur);
extern int win_delete_all_file_rois(struct image_display_window *win);
extern void win_delete_all_rois(struct image_display_window *win, int whch);
extern int win_delete_cur_roi(struct image_display_window *win);
extern int win_find_enclosing_curve(struct image_display_window *win,
    int x, int y, int use_this_xybound, struct int_bound_rec *xybound);
extern int win_slice_rect_roi(struct image_display_window *win);
extern int win_highlight_roi_in_all_wins(struct image_display_window *win,
    int is_which);
extern int WinMakeCurRoi(struct image_display_window *win, char *label);
extern int win_next_defined_roi(struct image_display_window *win,
    int is_backward);
extern int win_make_next_curve_cur(struct image_display_window *win,
    int is_backward);
extern int win_set_roi_visibility(struct image_display_window *win,
    char *label, int visibility);
extern int win_highlight_roi_cur(struct image_display_window *win,
    char *label);
extern int win_is_cur_curve_non_empty(struct image_display_window *win);
extern int win_make_cur_roi_convex(struct image_display_window *win);
#endif
#endif


/* Defined in slice_roi_win_rec.c */
#ifdef INPUT_H
extern void AssociateSlicesWithSliceRoiWinRecs(struct hdr_rec *hdr,
    struct hdr_scan_entry_rec *scans, unsigned long num_scans,
    struct slice_roi_win_rec **sroi_wins, unsigned long num_sroi_wins);
extern void init_slice_roi_win_rec(struct slice_roi_win_rec *slice_roi_win,
    unsigned int dimx, unsigned int dimy);
extern void free_slice_roi_win_rec(struct slice_roi_win_rec *slice_roi_win);
extern void set_cur_curve_status(struct slice_roi_rec *slice_roi,
    int or_status);
extern int AssociateWinWithSliceRoiWinRec(
    struct slice_roi_win_rec *slice_roi_win,
    struct image_display_window *win);
extern int DisassociateWinWithSliceRoiWinRec(
    struct slice_roi_win_rec *slice_roi_win,
    struct image_display_window *win);
extern int build_slice_roi_win_rec(struct input_file_rec *file);
extern void FreeSliceRoiWinRecs(struct slice_roi_win_rec **sroi_wins,
    unsigned int num_sroi_wins);
extern struct slice_roi_win_rec *file_scan_slice_roi_win(
    struct input_file_rec *file, struct hdr_scan_entry_rec *scan_entry);
#endif


/* Defined in superimpose.c */
#ifdef DISPLAY_WIN_H   /* For struct image_display_window */
extern void setup_fusion_menu(struct image_display_window *win);
extern int win_fusion_which_win_proc(struct image_display_window *win,
    char *wid);
extern int WinSetupWindowListItem(struct image_display_window *win,
    Panel_item item, int select, int win_type2);
extern void win_set_redefine_dst_fusion_params(
    struct image_display_window *win);
extern void win_add_or_drop_dynamic_fusion(struct image_display_window *win,
    int is_add);
extern unsigned long fusion_method(int opr);
extern int win_redefine_fusion_bounds(struct image_display_window *win,
    struct image_display_window *src_win, char *src_wid);
extern int win_delete_fusion(struct image_display_window *win);
extern void win_fusion_switching(struct image_display_window *win);
extern int win_fusion_last_left_top(struct image_display_window *win);
extern int win_show_hide_fusion(struct image_display_window *win);
extern int win_show_fusion(struct image_display_window *win);
extern int win_fusion_which_win(struct image_display_window *win);
extern int fusion_event_action_proc(struct image_display_window *win,
    Event *event);
extern void update_fusion_menu(struct image_display_window *win);
extern int win_move_show_hide_fusion(struct image_display_window *win,
    int select);
extern int win_fusion_move_img(struct image_display_window *win);
#endif


/* Defined in text_output.c */
#ifdef TEXT_FORMAT_H
extern void flush_the_text_output(struct text_output_rec *text);
extern int print_pixel_type_text_to_temp_file(struct text_output_rec *text);
extern int save_pixel_type_text_to_file(char *fn,
    struct text_output_rec *text);
#endif


/* Defined in text_output_rec.c */
#ifdef TEXT_FORMAT_H     /* For struct text_output_analysis_group_rec */
extern void free_analysis_group_recs(
    struct text_output_analysis_group_rec *groups, unsigned int num_groups);
extern void free_output_text_format_rec(struct output_text_format_rec *format);
extern void free_text_output_analysis_group_rec(
   struct text_output_analysis_group_rec *group);
extern void init_text_output_analysis_group_rec(
   struct text_output_analysis_group_rec *group);
extern void init_output_text_format_rec(struct output_text_format_rec *format);
extern int setup_output_format(struct text_output_rec *text);
extern int cp_text_output_analysis_group_recs(
    struct text_output_analysis_group_rec **dest, 
    unsigned int *dest_num_groups,
    struct text_output_analysis_group_rec *source,
    unsigned int source_num_groups, int option);
extern int RdTextFormat(char *fn,
    struct text_output_analysis_group_rec **groups,
    unsigned int *num_groups, struct output_text_format_rec *format,
    int is_count_format);
extern void free_text_output_rec(struct text_output_rec *text);
extern int copy_text_format_only(struct text_output_rec *dest_text,
    struct text_output_rec *source_text, int option);
extern int WrTextFormat(char *fn, struct output_text_format_rec *format,
    struct text_output_analysis_group_rec *groups, unsigned long num_groups);
extern void init_text_output_rec(struct text_output_rec *text,
    struct input_file_rec *file);
extern int setup_text_output_params(struct text_output_rec *text);
extern void init_collection_rec(struct collection_rec *collection);
extern void free_collection_rec(struct collection_rec *collection);
extern void init_page_rec(struct page_rec *page);
extern void free_all_collection_rec(struct all_collection_rec *analysis);
#endif


/* Defined in trans_roi_rec.c */
#ifdef DISPLAY_WIN_H
extern void setup_trans_roi_rec(struct image_display_window *win);
extern int win_update_trans_roi_rec(struct image_display_window *win);
extern void init_trans_roi_rec(struct trans_roi_rec *trans);
extern int move_superimpose_proc(struct image_display_window *win,
    int use_degree, double xdegree, double ydegree);
extern int transform_roi_proc(struct image_display_window *win,
    int use_degree, double xdegree, double ydegree);
extern int win_transform_by_keypad(struct image_display_window *win,
    Event *event, int off);
extern int trans_roi(struct image_display_window *win, Event *event);
#endif


/* Defined in window.c */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
#ifdef WIN_H
extern int win_setup_windows(struct win_rec *owner, Frame setup_fr_win,
    int direction, int status);
extern int win_show_tissue_wins(struct image_display_window *win);
extern void add_master_slave_relationship(struct display_win_rec *master,
    struct display_win_rec *slave);
extern int delete_dwin(struct display_win_rec *dwin);
extern void drop_dwin_from_master_slave_relationship(
   struct display_win_rec *dwin);
extern int NewWin(struct image_display_window *win, int win_type2,
    int use_this_buf_dims, unsigned long dimx, unsigned long dimy,
    unsigned long pixel_depth_bits, unsigned long data_type,
    unsigned long img_type4, struct image_display_window **newwin);
extern int NewWinAllSlicesHisto(struct image_display_window *win,
    int win_type2, int use_this_buf_dims,
    unsigned long dimx, unsigned long dimy,
    unsigned long pixel_depth_bits, unsigned long data_type,
    unsigned long img_type4, int histo_option, int histo_kind,
    struct image_display_window **newwin);
extern int win_rec_setup_histogram(struct win_rec *win, int win_type2);
extern int win_delete_multiple_wins(struct image_display_window *win);
extern int win_get_multiple_win(struct image_display_window *win,
    int magnify_which_win, int magx, int magy, int center_win,
    int center_x, int center_y, int scale_option);
extern int ProjectWins(struct image_display_window *win,
    struct int_rect_rec *projected_rect, int num_projected_wins,
    int num_echoes, int win_type2);
extern int win_master_slave_mouse_xy(struct image_display_window *win,
    int x, int y);
extern int win_all_win_echoes_exist(struct image_display_window *win);
extern int redisplay_cur_win(struct image_display_window *win, int center_win,
    int center_x, int center_y, int is_display_cur_win);
extern int WinSetupMagnifyWindow(struct image_display_window *win,
    int mag_factorx, int mag_factory, int magnify_which_win,
    int center_win, int center_x, int center_y);
#endif
#endif


/* Defined in win_general.c */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern void deselect_all_list_items(Panel_item item);
extern void destroy_all_subframes(Frame frame);
extern void grap_keyboard (Xv_opaque xvwin);
extern void make_2_wins_adjacent(Frame win_move_to, Frame win_same_place,
    int is_win_same_place_movable);
extern int  select_list_items(struct strs_rec *list, Panel_item item);
extern void set_big_win(Xv_opaque win);
extern int  set_win_foreground_to_default_gc(Xv_opaque win);
extern int  set_win_background_to_default_gc(Xv_opaque win);
extern void win_alarm(Frame frame, int num_alarms);
extern void win_clear( Xv_opaque win, Pixmap pm, int is_wr_to_win);
extern void win_set_mouse_at_center(Xv_opaque win);
extern int setup_list_items(struct strs_rec *list, Panel_item item,
    int is_select_all);
extern int selected_list_items(struct strs_rec *list, Panel_item item);
extern int select_list_str_item(char *selected_item_str, Panel_item item,
    int is_sel);
extern void none_list_proc(Panel_item item, Event *event);
extern void all_list_proc(Panel_item item, Event *event);
extern int list_items(struct strs_rec *list, Panel_item item);
extern void delete_all_list_items(Panel_item item);
extern void deselect_list_proc(Panel_item item, Event *event);
extern void select_list_proc  (Panel_item item, Event *event);
extern int selected_list_item_ptrs(struct strs_rec *list, Panel_item item);
extern int deselect_list_items(struct strs_rec *list, Panel_item item);
extern void select_all_list_items(Panel_item item);
extern Xv_opaque root_menu(Menu menu);
extern int next_selected_item(Panel_item item, int item_start_indx,
    int *selected_indx);
extern void win_flush(Xv_opaque win);
extern void win_flush_input(Xv_opaque win);
extern void center_frame(Xv_opaque window, int is_just_setup);
extern int double_click(Xv_opaque canvas, Event *event);
extern int delete_list_item_by_str(char *str, Panel_item item);
extern int win_setup_pixmap(Xv_opaque win, Pixmap *pm);
extern int win_copy_from_and_to_pixmap(Xv_opaque win, Pixmap pm,
    int dx, int dy, int op, int sx, int sy, int width, int height,
    int is_copy_from);
extern void win_free_pixmap(Xv_opaque win, Pixmap pm);
extern int user_write(Xv_opaque win, int dx, int dy, int width, int height,
    int op, XImage *im, int sx, int sy);
extern int get_xwin_valid_mouse_xy(Xv_opaque win, long *x, long *y);
extern void top_frame_and_subframes(Frame frame);
extern void open_close_frame_and_subframes(Frame frame, int is_open);
extern void show_hide_frame_and_subframes(Xv_opaque win, int is_show);
extern void make_2_wins_top_down(Frame win_move_to, Frame win_same_place,
    int is_win_same_place_movable);
extern void get_win_absolute_area(Frame win, Rect *rr);
extern void set_win_absolute_area(Xv_opaque win, Rect *rr);
extern int set_win_back_and_foreground(Xv_opaque win, int is_set_bg,
    unsigned long bg, int is_set_fg, unsigned long fg);
extern int pt_in_Rect(Rect *rr, int x, int y);
extern void apply_proc_to_all_tree_window(Xv_opaque win, int (*proc)(),
    void *arg1, void *arg2, void *arg3, void *arg4, int num);
extern void destroy_menu_and_submenus(Menu menu, int num);
extern void update_list_client_data(Panel_item item);
extern void list_insert(Panel_item from_item, int from_item_indx,
    Panel_item to_item, int *to_item_indx);
extern void list_swap(Panel_item item, Panel_list_op op, int *cur_indx,
    int swap_indx, char *swap_str);
extern void list_delete(Panel_item item, int *item_indx);
extern int find_list_item_by_str(Panel_item item, char *str,
    unsigned long *indx);
extern int is_list_item_empty(Panel_item list_item);
extern int win_cur_event(Xv_opaque win, Event *event);
extern int delete_selected_list_items(Panel_item item);
extern int list_item_ptrs(struct strs_rec *list, Panel_item item);
extern void win_in_screen_rect(Xv_opaque win);
extern void move_win_to_mouse_xy(Xv_opaque win, Xv_opaque mouse_win);
extern void center_window(Xv_opaque window);
#endif

#ifdef xview_xview_DEFINED       /* For xview related stuff */
#ifdef RECT_H                    /* For int_rect_rec */
extern void int_rect_rec_to_Rect(struct int_rect_rec *rr, Rect *rect);
extern void Rect_to_int_rect_rec(Rect *rect, struct int_rect_rec *rr);
#endif
#endif


/* Defined in win_init_free.c */
int write_labels(char *fn, char **strs, unsigned long num_strs);

#ifdef STR_DEF_H        /* For strs_rec */
int setup_roi_labels(char **roi_label_fn, struct strs_rec *roi_labels,
    char *label_fn, unsigned short *status, int flag);
#endif

#ifdef WIN_H
extern void all_win_rec_get_default_color_values(struct all_win_rec *win);
extern int delete_win_rec(struct win_rec *win, int window_type,
    int free_img_bufs);
extern void init_all_win_rec(struct all_win_rec *win, struct prog_rec *prog);
extern void free_all_win_rec(struct all_win_rec *win);
extern int init_win_rec(struct win_rec *win, struct all_win_rec *win_root);
#endif

#ifdef WIN_H
#ifdef xview_cms_h_DEFINED   /* For Xv_singlecolor */
extern void setup_all_win_rec(struct all_win_rec *win, struct prog_rec *prog,
    char *color_fn, char *roi_label_fn, char *sec_roi_label_fn,
    char *cv_roi_label_fn, char *cv_sec_roi_label_fn, char *pixel_type_fn,
    char *sec_pixel_type_fn, int pixel_type_priority_fn,
    Xv_singlecolor *system_colors, unsigned int num_system_colors);
#endif
#endif


/* Defined in win_menu.c */
#ifdef xview_xview_DEFINED
extern void all_echo_wins_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void duplicate_win_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void get_new_win_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void image_histogram_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void magnify_pixel_option_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int option);
extern void magnify_pixel_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void make_window_cur_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void project_1_echoe_wins_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int value);
extern void project_all_echoe_wins_proc(Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event, int value);
extern void win_exit_cur_win_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void win_exit_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void win_stack_exit_proc( Menu menu, Menu_item item, void *arg,
   Xv_Window window, Event *last_event);
extern void win_stack_slice_or_scan_proc(Menu menu, Menu_item item,
   void *arg, Xv_Window window, Event *last_event);
extern void close_file_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
extern void open_win_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
extern void get_channel_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
extern Menu setup_magnify_pixel_menu();
extern void open_file_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
extern void open_stack_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
extern void close_file_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
extern void close_stack_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
extern void close_win_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);

/* FIXME!  The following prototype has been commented out since it causes
   a fatal compiler error in display_canvas.c; note that this probably
   reflects a serious bug in the code.  -PWH 19990607 */
#if 0
extern void slave_win_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
#endif

#endif /* xview_xview_DEFINED */

#ifdef DISPLAY_WIN_H
#ifdef xview_xview_DEFINED
extern int change_window_channel_proc(struct display_win_rec *dwin,
    Xv_Window window, Event *event);
extern int change_channel(struct display_win_rec *dwin, int indx);
#endif
#endif


/* Defined in win_opr.c */
#ifdef INPUT_H
extern struct img_buf_rec *win_rec_cur_img_buf(struct win_rec *win);
extern char *WinRecGetWid(struct win_rec *win, int win_type2);
extern char *win_rec_win_id_title(struct win_rec *win, char *subtitle);
extern unsigned long win_total_slice_cuts(struct win_rec *win);
extern struct slice_roi_rec *win_rec_get_breaker(struct win_rec *win);
extern struct draw_mask_rec *win_rec_get_breaker_mask(struct win_rec *win);
extern struct slice_roi_rec *win_rec_get_clipboard(struct win_rec *win);
extern struct draw_mask_rec *win_rec_get_clipboard_mask(struct win_rec *win);
extern struct win_rec *get_win_rec_by_wid_str(struct win_rec *win,
    char *wid_str);
extern int AllWids(struct win_rec *win, struct strs_rec *wids, int is_sorted,
    int select, int win_type2);
extern struct buf_2d_rec *win_rec_cur_data_buf(struct win_rec *win,
    int win_type);
extern char *win_rec_get_pixel_type_label(struct win_rec *win, int win_type,
    unsigned long x, unsigned long y);
extern struct image_display_window *win_rec_get_last_open_window1(
   struct win_rec *win, int win_type);
extern char *win_rec_get_histo_label1(struct win_rec *win, int win_type);
extern char *win_rec_get_frame_label(struct win_rec *win, char *extra_label);
extern struct strs_rec *win_rec_get_roi_labels_PTR(struct win_rec *win,
    int win_type);
extern int win_rec_label_file_access(struct win_rec *win,
    int is_which_label_file, int mode, char **reason);
extern struct strs_rec *win_rec_get_sec_roi_labels_PTR(struct win_rec *win,
    int win_type);
extern void win_rec_get_label_fns(struct win_rec *win, int win_type,
    char **main, char **sub);
extern int win_rec_rd_label_fns(struct win_rec *win, int win_type, char *main,
    char *sub);
extern int win_rec_wr_label_fns(struct win_rec *win, int win_type, char *main,
    char *sub);
extern int win_rec_save_labels(struct win_rec *win, int win_type,
    struct strs_rec *labels, int is_replace, int is_sec);
extern struct strs_rec *win_rec_pixel_types_PTR(struct win_rec *win);
#endif


/* Defined in win_text.c */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern int get_strs_dim( Xv_Window win, char *strs[], int num_strs,
     int *width, int *height, int *line_height );
extern int writeTextToXY( Xv_window win, Pixmap pm, int is_wr_to_win,
     int x, int y, char *text);
extern int largest_ch_dim(Xv_Window win, int *width, int *height);
#endif

#ifdef RECT_H                    /* For int_rect_rec */
#ifdef xview_xview_DEFINED       /* For xview related stuff */
extern int draw_int_rect(Xv_Window win, Pixmap pm, int is_wr_to_win,
    struct int_rect_rec *rr, int color, int is_polygon);
extern void win_center_text_in_int_rect(Xv_Window win, Pixmap pm,
    int is_wr_to_win, struct int_rect_rec *rr, int rr_frame_color,
    int rr_bkg_color, char *font_name, char *text, int text_color,
    int text_op, int erase, int trans_x, int trans_y);
#endif
#endif


/* Defined in wr_bin.h */
#ifdef DISPLAY_WIN_H
int enter_wr_bin(struct image_display_window *win, int status);
#endif


/* Defined in wr_ntxt.c */
#ifdef DISPLAY_WIN_H
extern int show_temp_text_file(struct image_display_window *win);
extern int win_print_text_to_temp_file(struct image_display_window *win);
extern int win_save_text_to_file(struct image_display_window *win);
extern int win_save_text_to_file_and_printer(struct image_display_window *win);
#endif


/* Defined in win_text.c */
#ifdef xview_xview_DEFINED
int user_text(Xv_Window win, Pixmap pm, int is_wr_to_win, int x, int y,
    int op, char *font_name, char *text);
#endif


#endif  /* NRIA_PROCEDURES_H */
