
#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include "lib/mri_format.h"
#include "lib/segment.h"
/*
cc -c gr.c
*/
/*
#define PRINT(x) x; fflush(stdout);
#define TIME(x) x; fflush(stdout);
#define TRACE(x) x; fflush(stdout);
*/
#define PRINT(x)
#define TIME(x)
#define TRACE(x)
/*
RdCurSlice(fid,cur_slice,_2d)
grow_region_1_echo(imgfid,hdr,histo,pixel_type,order)
GrowRegion2Echo(imgfid,hdr,histo,pixel_type,order,start_slice_num,end_slice_num)
*/
unsigned long NumberOfSliceCuts();

RdCurSlice(fid,cur_slice,_2d)
 FILE *fid;
 struct hdr_scan_entry_rec *cur_slice;
 struct buf_2d_rec *_2d;
{
 TRACE(printf("rd_cur_slice_data...\n"))
 _2d->status4 &= ~BUF_DATA_VALID;
 if (fseek(fid,(size_t) cur_slice->img_addr,0) != 0)
    {
     return ILLEGAL_FILE_ADDRESS;}
 if (fread(_2d->buf[0],(size_t) _2d->total_bytes,(size_t) 1,fid) != 1)
    {
     return READ_ERROR;}

 _2d->status4 |= BUF_DATA_VALID;
 return NO_ERROR;

}

grow_region_1_echo(imgfid,hdr,histo,pixel_type,order)
 FILE *imgfid;
 struct hdr_rec *hdr;
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
 struct strs_rec *order;
{
 int err;
 long num_slice_maps,cnt,indx,lcv,histo_dimx,histo_dimy,pixel_depth;
 struct buf_2d_rec _2d1,*ptr_2d;
 struct hdr_scan_entry_rec *cur1;
 TIME(struct timeb the_time)

 TIME(ftime(&the_time))
 TIME(printf("grow_region_1_echo sec = %d  msecs = %d\n",
         (int) the_time.time,the_time.millitm))
 num_slice_maps = NumberOfSliceCuts(&(hdr->data_info));
 init_buf_2d_rec(&_2d1);
 if (((err = setup_segment_1_echo(histo,pixel_type,order,num_slice_maps)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&_2d1,hdr->data_info.dimx,hdr->data_info.dimy,
             hdr->data_info.pixel_depth_bits,0)) != NO_ERROR))
    {free_buf_2d_rec(&_2d1);
     printf("Error setting up the 1 echo segmentation parameters...err = %d\n",err);
     return err;}
 TRACE(pr_strs_rec(&(histo->pixel_type_order));)
 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,HISTO_1D);
 for (cnt = 0,lcv = 0; lcv < num_slice_maps; lcv++)
    {cur1 = &(hdr->scans[cnt++]);
     printf("%d) Segmenting %s/%d...",lcv,cur1->img_label,cur1->num);
     if ((err = RdCurSlice(imgfid,cur1,&_2d1)) != NO_ERROR) 
        {printf("Error reading the slice...err = %d\n",err);
         break;}
     _2d1.minval_set = hdr->data_info.min_pixel;
     _2d1.maxval_set = hdr->data_info.max_pixel;
     _2d1.status4 |= BUF_MIN_MAX_SET;
     if ((err = Scale2dPixels(&_2d1,&_2d1,(double) .0,
           (double) (histo_dimx - 1),0,(double) .0,(double) .0,0)) == NO_ERROR)
        {
         if ((err = segment_1_echo_pixels(histo->types,histo->num_types,&_2d1,
                pixel_type->slice_maps[lcv],histo,
                (unsigned long) pixel_type->status)) == NO_ERROR)
            {pixel_type->status &= ~PIXEL_TYPE_SEGMENTED;
             pixel_type->status |= PIXEL_TYPE_GROW_REGION;
            }
        }
     if (err != NO_ERROR)
        {printf("Error segmenting the slice...err = %d\n",err);
         break;}
     printf("%c",10);
    }
 printf("\n");
 free_buf_2d_rec(&_2d1);
 TIME(ftime(&the_time);
       printf("grow_region_1_echo sec = %d  msecs = %d\n",
         (int) the_time.time,the_time.millitm))
 TRACE(printf("grow_region_1_echo...end..err = %d\n",err))
 return err;
}

GrowRegion2Echo(imgfid,hdr,histo,pixel_type,order,start_slice_num,end_slice_num)
 FILE *imgfid;
 struct hdr_rec *hdr;
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
 struct strs_rec *order;
 long start_slice_num,end_slice_num;
{
 struct all_segment_rec allseg;
 int err;
 long num_slice_maps,cnt,indx,lcv,histo_dimx,histo_dimy,pixel_depth,next;
 struct buf_2d_rec _2d1,_2d2,*ptr_2d;
 struct hdr_scan_entry_rec *cur1,*cur2;
 TIME(struct timeb the_time)

 TIME(ftime(&the_time))
 TIME(printf("GrowRegion2Echo sec = %d  msecs = %d\n",
         (int) the_time.time,the_time.millitm))
 num_slice_maps = NumberOfSliceCuts(&(hdr->data_info));
 if ((start_slice_num < 0) || (end_slice_num < 0))
    {    
     start_slice_num = 0;
     end_slice_num = num_slice_maps - 1;}
 init_all_segment_rec(&allseg);
 init_buf_2d_rec(&_2d1);
 init_buf_2d_rec(&_2d2);
 if (((err = setup_segment_2_echo(histo,&allseg,
          pixel_type,order,num_slice_maps,
          hdr->data_info.dimx,hdr->data_info.dimy)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&_2d1,hdr->data_info.dimx,hdr->data_info.dimy,
             hdr->data_info.pixel_depth_bits,0)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&_2d2,hdr->data_info.dimx,hdr->data_info.dimy,
             hdr->data_info.pixel_depth_bits,0)) != NO_ERROR))
    {free_all_segment_rec(&allseg);
     free_buf_2d_rec(&_2d1);
     free_buf_2d_rec(&_2d2);
     printf("Error setting up the 2 echo segmentation parameters...err = %d\n",err);
     return err;}
 TRACE(pr_strs_rec(&(histo->pixel_type_order));)

 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,HISTO_MULTI_D);

 for (cnt = start_slice_num * hdr->data_info.num_echoes,
              lcv = start_slice_num; lcv <= end_slice_num; lcv++)
    {cur1 = &(hdr->scans[cnt++]);
     cur2 = &(hdr->scans[cnt++]);
     printf("%d) Segmenting %s/%d & %s/%d\n",lcv+1,cur1->img_label,cur1->num,
           cur2->img_label,cur2->num);
     if (((err = RdCurSlice(imgfid,cur1,&_2d1)) != NO_ERROR) || 
         ((err = RdCurSlice(imgfid,cur2,&_2d2)) != NO_ERROR))
        {printf("Error reading the slice...err = %d\n",err);
         break;}
     _2d1.minval_set = _2d2.minval_set = hdr->data_info.min_pixel;
     _2d1.maxval_set = _2d2.maxval_set = hdr->data_info.max_pixel;
     _2d1.status4 |= BUF_MIN_MAX_SET;
     _2d2.status4 |= BUF_MIN_MAX_SET;

     if (((err = Scale2dPixels(&_2d1,&_2d1,(double) .0,
           (double) (histo_dimx - 1),0,(double) .0,(double) .0,0)) == NO_ERROR)
 &&
         ((err = Scale2dPixels(&_2d2,&_2d2,(double) .0,
           (double) (histo_dimy - 1),0,(double) .0,(double) .0,0)) == NO_ERROR))
        {TRACE(printf("before segment_2_echo_pixels...\n"));
         for (next = 0; next < allseg.num_segs; next++)
            if ((err = segment_2_echo_pixels(&(allseg.segs[next]),&_2d1,&_2d2,
                pixel_type->slice_maps[lcv],histo,
                (unsigned long) pixel_type->status)) != NO_ERROR)
               break;
         if (err == NO_ERROR)
            {pixel_type->status &= ~PIXEL_TYPE_SEGMENTED;
             pixel_type->status |= PIXEL_TYPE_GROW_REGION;
             TRACE(ptr_2d = pixel_type->slice_maps[lcv];
                for (indx = 0; indx < histo->pixel_type_order.num_strs + 1; indx++)
                  printf("2 echo %d = %d\n",indx,
                        CntValBuf2dRec(ptr_2d,(double) indx));
                printf("\n\n");
               )
            }
         }
     if (err != NO_ERROR)
        {printf("Error segmenting the slice...err = %d\n",err);
         break;}
    }

 free_all_segment_rec(&allseg);
 free_buf_2d_rec(&_2d1);
 free_buf_2d_rec(&_2d2);
 TIME(ftime(&the_time);
       printf("GrowRegion2Echo sec = %d  msecs = %d\n",
         (int) the_time.time,the_time.millitm))
 TRACE(printf("GrowRegion2Echo...end...err = %d\n",err))
 return err;
}
