/****************************************************************************
3d.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 3d.c,v 1.10 1999/07/07 17:41:12 hughett Exp $ Release $Name: nria_1_0_6 $";


#include "geometry.h"
#include "buf_3d_rec.h"
#include "mri_format.h"

#include "nria_procedures.h"

#if 0
#  define PRT2(x) x; fflush(stdout);
#  define PRT4(x) x; fflush(stdout);
#  define PRT(x) x; fflush(stdout);
#  define PRT5(x) x; fflush(stdout);
#  define PRT6(x) x; fflush(stdout);
#  define PRT7(x) x; fflush(stdout);
#  define PRT8(x) x; fflush(stdout);
#  define PRT(x) x; fflush(stdout);
#  define PRT9(x) x; fflush(stdout);
#  define PRT10(x) x; fflush(stdout);
#  define PRT11(x) x; fflush(stdout);
#  define PRT3(x) x; fflush(stdout);
#  define PRT12(x) x; fflush(stdout);
#  define PRT13(x) x; fflush(stdout);
#  define PRT31(x) x; fflush(stdout);
#  define PRT30(x) x; fflush(stdout);
#else
#  define PRT(x)
#  define PRT2(x)
#  define PRT4(x)
#  define PRT5(x)
#  define PRT7(x)
#  define PRT6(x)
#  define PRT8(x)
#  define PRT9(x)
#  define PRT10(x)
#  define PRT11(x)
#  define PRT1(x)
#  define PRT3(x)
#  define PRT12(x)
#  define PRT13(x)
#  define PRT30(x)
#  define PRT31(x)
#endif



/* Local functions */
int run_next_view_proc(struct view_rec *view, int (*run_proc)(),
    void *arg1, void *arg2, void *arg3, void *arg4, void *arg5, void *arg6);
int run_file_views_proc(struct view_rec *view, int (*run_proc)(),
    void *arg1, void *arg2);
int run_any_file_views_proc(struct view_rec *view, int (*run_proc)(),
    void *arg1, void *arg2);
int win_next_plane_roi(struct image_display_window *win);
int update_group_view_after_delete_view(struct view_rec *view,
    char *deleted_wid);
int UpdateFileViewAfterDeleteView(struct view_rec *view,
    char *deleted_wid, int is_update_co_reg_link);
int exec_3d_win_exit_proc(struct image_display_window *win);
struct view_rec *find_view_rec(struct view_rec *view,
    char *view_win_label);
struct view_rec *find_file_view_rec(struct input_file_rec *file,
    char *view_win_label);
struct view_rec *find_any_view_rec(struct input_file_rec *file,
    char *view_win_label);
int is_view_valid(struct input_file_rec *file, struct view_rec *view);
int set_view_group_num_1(struct view_rec *view, int *group_num);
void set_view_group_num(struct view_rec *view);
int view_labels_to_group_nums(struct input_file_rec *file,
    struct strs_rec *labels, int **gnums, int *num_gnums);
int setup_plane_3d_2ds(struct _3d_plane_2d_rec **_3d_2ds,
    unsigned long *total_3d_2ds, unsigned long *num_3d_2ds,
    struct view_rec *view);
int setup_plane_roi_and_pixel_types(struct view_rec *view);
int get_plane_slice_data(struct view_rec *view);
int transform_plane_slice_data(struct view_rec *view);
int win_enable_3d_draw_mode(struct image_display_window *win);
int show_view_rec(struct input_file_rec *file, struct view_rec *view,
    Frame fr_frame);
int dp_3d_plane_images(struct view_rec *view);
int dp_file_3d_images(struct input_file_rec *file);
int plane_bound_xy_pts(struct view_rec *view,
    struct slice_roi_rec *slice_roi, char *str);
int view_and_view1_roi(struct view_rec *view, struct view_rec *view1,
    int *status);
int setup_plane_slice_roi_rec(struct view_rec *view);
int setup_all_plane_slice_roi_recs(struct input_file_rec *file);
void dp_all_plane_rois(struct view_rec *view);
int update_view_slice_roi_rec(struct view_rec *view);
int project_view_recs(struct view_rec *view);
void UpdatePlaneInfoBeforeDisplay(struct view_rec *view);
void UpdatePlaneInfoAfterDisplay(struct view_rec *view);
void UpdatePlaneInfo(struct view_rec *view);
int BuildAndDisplayPlaneData(struct view_rec *view);
int OutputPlaneData(struct view_rec *view, int is_trigger_co,
    int is_trigger_lock);
int AdjustOutputPlaneData(struct view_rec *view, int is_trigger_co,
    int is_trigger_lock, int is_dp_cur, int is_dp_whole_group);
void FormPlaneNoDisplay(struct view_rec *result_view,
    struct vector_3d_rec *pt, struct vector_3d_rec *normal,
    struct vector_3d_rec *center, struct vector_3d_rec *rotate,
    int is_pt_global, int sel_adjust_center, struct matrix_3d_rec *xyztoplane);
int FormPlane(struct view_rec *result_view, struct vector_3d_rec *pt,
    struct vector_3d_rec *normal, struct vector_3d_rec *center,
    struct vector_3d_rec *rotate, int is_pt_global, int sel_adjust_center,
    struct matrix_3d_rec *xyztoplane);
int FormPlaneAndAdjust(struct view_rec *result_view,
    struct vector_3d_rec *pt, struct vector_3d_rec *normal,
    struct vector_3d_rec *center, struct vector_3d_rec *rotate,
    int is_pt_global);
int RotatePlaneFromCenter(struct view_rec *view, double angle,
    int is_rel);
char *plane_data_pixel_type(struct view_rec *view, int x, int y);
struct slice_3d_rec *plane_data_slice_info(struct view_rec *view,
    int x, int y);
int locate_new_plane(struct view_rec *view, int slice_offset,
    int is_rel);
int win_new_3d_win(struct image_display_window *win,
    struct vector_3d_rec *normal);
int win_new_3d_win_normal_to_centers(struct image_display_window *win,
    char *wid);
int win_new_3d_win_normal_to_normals(struct image_display_window *win,
    char *wid);
int _3d_default_cur_line(struct view_rec *view, long *x1, long *y1,
    long *x2, long *y2);
int rotate_plane(struct view_rec *view, long x1, long y1, long x2,
    long y2, unsigned long mode);
int rotate_plane_by_cur_line(struct view_rec *view, unsigned long mode);
int _3d_rotate(struct view_rec *view, unsigned long mode);
int _3dCRModeAction(struct view_rec *view, unsigned long mode);
int _3d_plane_orientation(struct view_rec *view, int select);
int win_new_view(struct image_display_window *win,
    struct plane_3d_rec *new_plane);
int _3d_last_plane(struct image_display_window *win,
    int is_adjust_recoreg);
int _3dDegreeCutPlane(struct view_rec *result_view,
    struct view_rec *view, double cut_deg, long x1, long y1, long x2, long y2,
    struct vector_3d_rec *use_this_normal);
int ChangeCutPlane(struct view_rec *view, int use_old_normal);
int view_same_angle_cut(struct view_rec *view);
int win_3d_locate_plane(struct image_display_window *win, Event *event);
int _3dAxisCutPlane(struct view_rec *result_view,
    struct view_rec *view, double cut_deg, double x1, double y1, double x2,
    double y2, int use_refxy, double rx1, double ry1, double rx2, double ry2);
int _3d_axis_rotate_plane(struct view_rec *view, int rot_angle);
void _3d_after_next_roi_proc(struct image_display_window *win);
int _3d_cur_curve(struct image_display_window *win);
int win_resize_voxel_now1(struct image_display_window *win,
    int use_dimxy, unsigned long dimx, unsigned long dimy, double xpixel_size,
    double ypixel_size, double zpixel_size);
int win_resize_voxel1(struct image_display_window *win,
    struct image_display_window *dp_to_win, int use_dimxy, unsigned long dimx,
    unsigned long dimy, float *xpixel_size, float *ypixel_size,
    float *zpixel_size, struct strs_rec *resize_wids, int (*next_proc)(),
    int (*conti_proc)(), void *arg1, void *arg2);
int win_move_mouse_to_cur_roi_wid(struct image_display_window *win);




/*-------------------------------------------------------------------------
run_next_view_proc - ???
-------------------------------------------------------------------------*/

int
run_next_view_proc(view,run_proc,arg1,arg2,arg3,arg4,arg5,arg6)
 struct view_rec *view;
 int (*run_proc)();
 void *arg1,*arg2,*arg3,*arg4,*arg5,*arg6;
{
 struct list_rec *cur,*next;
 struct view_rec *view1;
 int err;

 next = cur = &(view->_3d_list);
 do 
    {view1 = next->item;
     if (!(view1->status & PLANE_DELETED))
        if ((err = run_proc(view1,arg1,arg2,arg3,arg4,arg5,arg6)) 
              != NO_ERROR) 
           return err;
     next = next->next;}
 while (cur != next);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
run_file_views_proc - ???
-------------------------------------------------------------------------*/

int
run_file_views_proc(view,run_proc,arg1,arg2)
 struct view_rec *view;
 int (*run_proc)();
 void *arg1,*arg2;
{
 int err;
 struct slice_info_rec *slice_info;
 long lcv;

 slice_info = &(view->file->slice_info);
 for (lcv = 0; lcv < slice_info->num_views; lcv++)
    if (!(slice_info->views[lcv]->status & PLANE_DELETED))
       if ((err = run_proc(slice_info->views[lcv],arg1,arg2)) != NO_ERROR) return err;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
run_any_file_views_proc - ???
-------------------------------------------------------------------------*/

int
run_any_file_views_proc(view,run_proc,arg1,arg2)
 struct view_rec *view;
 int (*run_proc)();
 void *arg1,*arg2;
{
 int err;
 struct slice_info_rec *slice_info;
 long lcv,cnt;

 for (cnt = 0; cnt < view->file->prog->input.num_files; cnt++)
    {slice_info = &(view->file->prog->input.files[cnt]->slice_info);
     for (lcv = 0; lcv < slice_info->num_views; lcv++)
        if (!(slice_info->views[lcv]->status & PLANE_DELETED))
           if ((err = run_proc(slice_info->views[lcv],arg1,arg2)) != NO_ERROR)
              return err;
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_next_plane_roi - ???
-------------------------------------------------------------------------*/

int
win_next_plane_roi(win)
 struct image_display_window *win;
{
 struct list_rec *cur,*next;
 struct img_buf_rec *img;
 struct view_rec *view,*view1;
 struct roi_rec *roi;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 next = cur = &(view->_3d_list);
 next = next->next;
 do 
    {view1 = next->item;
     if (!(view1->status & PLANE_DELETED))
        if ((roi = find_roi_rec(&(win->control.sroi.sroi_win->slice_roi),
                 view1->wid,1)) != NULL)
           break;
     if (cur == next) break;
     next = next->next;
    }
 while (1);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
update_group_view_after_delete_view - ???
-------------------------------------------------------------------------*/

int
update_group_view_after_delete_view(view,deleted_wid)
 struct view_rec *view;
 char *deleted_wid;
{
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;

 PRT31(printf("update_group_view_after_delete_view...viw = %s wid = %s\n",
         view->wid,deleted_wid))
 if (view->img->win == NULL) return CANCEL;
 slice_roi = &(view->img->win->image_display->control.sroi.sroi_win->slice_roi);
 if ((roi = get_roi(slice_roi,deleted_wid)) != NULL)
    {delete_roi(slice_roi,roi);
     PRT(printf("update_group_view_after_delete_view..deleted\n"))
     win_redisplay_all_curves(view->img->win->image_display);
    }
 view_check_locked(view);
 PRT31(printf("update_group_view_after_delete_view...done\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
UpdateFileViewAfterDeleteView - ???
-------------------------------------------------------------------------*/

int
UpdateFileViewAfterDeleteView(view,deleted_wid,is_update_co_reg_link)
 struct view_rec *view;
 char *deleted_wid;
 int is_update_co_reg_link;
{
 PRT31(printf("UpdateFileViewAfterDeleteView...1...num_cos = %d\n",view->num_cos))
 if (view->img->win != NULL) 
    {if (view->num_cos > 0)
        {WinUncoRegisterFromWid(view->img->win->image_display,deleted_wid,
                is_update_co_reg_link);
         view_check_cross_registered(view);
         update_co_register_menu(view->img->win->image_display);}
     update_3d_menu(view->img->win->image_display);}
 PRT31(printf("UpdateFileViewAfterDeleteView...2...1\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
exec_3d_win_exit_proc - ???
-------------------------------------------------------------------------*/

int
exec_3d_win_exit_proc(win)
 struct image_display_window *win;
{
 struct view_rec *view,*view1;
 struct img_buf_rec *img;
 struct list_rec *next;

 PRT31(printf("exec_3d_win_exit_proc...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 view->status |= PLANE_DELETED;
 PRT30(printf("exec_3d_win_exit_proc...1...1\n"))
 if ((next = (struct list_rec *) delete_item_from_list(&(view->_3d_list))) != NULL)
    {view1 = next->item;
     run_next_view_proc(view1,update_group_view_after_delete_view,
			view->wid,0,0,0,0,0);
     run_any_file_views_proc(view1,UpdateFileViewAfterDeleteView,view->wid,
               0);
     PRT30(printf("exec_3d_win_exit_proc...2...1\n"))
    }
 PRT31(printf("exec_3d_win_exit_proc...2...end\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_view_rec - ???
-------------------------------------------------------------------------*/

struct view_rec *
find_view_rec(view,view_win_label)
 struct view_rec *view;
 char *view_win_label;
{
 struct list_rec *cur,*next;
 struct view_rec *view1;

 cur = &(view->_3d_list);
 next = cur;
 do 
    {view1 = next->item;
     if ((view1->img != NULL) && (view1->img->win != NULL))
        {if (!(view->status & PLANE_DELETED))
            if (str_cmp(view1->wid,view_win_label) == 0)
               return view1;
        }
     next = next->next;
    }
 while (next != cur);
 return NULL;
}


/*-------------------------------------------------------------------------
find_file_view_rec - ???
-------------------------------------------------------------------------*/

struct view_rec *
find_file_view_rec(file,view_win_label)
 struct input_file_rec *file;
 char *view_win_label;
{
 struct slice_info_rec *slice_info;
 long lcv;

 slice_info = &(file->slice_info);
 for (lcv = 0; lcv < slice_info->num_views; lcv++)
    if (!(slice_info->views[lcv]->status & PLANE_DELETED))
       if (str_cmp(slice_info->views[lcv]->wid,view_win_label) == 0)
          return slice_info->views[lcv];
 return NULL;
}


/*-------------------------------------------------------------------------
find_any_view_rec - ???
-------------------------------------------------------------------------*/

struct view_rec *
find_any_view_rec(file,view_win_label)
 struct input_file_rec *file;
 char *view_win_label;
{
 struct slice_info_rec *slice_info;
 long lcv,cnt;

 for (cnt = 0; cnt < file->prog->input.num_files; cnt++)
    {slice_info = &(file->prog->input.files[cnt]->slice_info);
     for (lcv = 0; lcv < slice_info->num_views; lcv++)
        if (!(slice_info->views[lcv]->status & PLANE_DELETED))
           if (str_cmp(slice_info->views[lcv]->wid,view_win_label) == 0)
              return slice_info->views[lcv];
    }
 return NULL;
}


/*-------------------------------------------------------------------------
is_view_valid - ???
-------------------------------------------------------------------------*/

int
is_view_valid(file,view)
 struct input_file_rec *file;
 struct view_rec *view;
{
 struct slice_info_rec *slice_info;
 long lcv,cnt;

 for (cnt = 0; cnt < file->prog->input.num_files; cnt++)
    {slice_info = &(file->prog->input.files[cnt]->slice_info);
     for (lcv = 0; lcv < slice_info->num_views; lcv++)
        if (!(slice_info->views[lcv]->status & PLANE_DELETED) &&
            (view == slice_info->views[lcv]))
           return 1;
    }
 return 0;
}


/*-------------------------------------------------------------------------
set_view_group_num_1 - ???
-------------------------------------------------------------------------*/

int
set_view_group_num_1(view,group_num)
 struct view_rec *view;
 int *group_num;
{
 view->group_num = *group_num;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
set_view_group_num - ???
-------------------------------------------------------------------------*/

void
set_view_group_num(view)
 struct view_rec *view;
{
 view->file->slice_info.group_num += 1;
 run_next_view_proc(view,set_view_group_num_1,
		    &(view->file->slice_info.group_num),0,0,0,0,0);
}


/*-------------------------------------------------------------------------
view_labels_to_group_nums - ???
-------------------------------------------------------------------------*/

int
view_labels_to_group_nums(file,labels,gnums,num_gnums)
 struct input_file_rec *file;
 struct strs_rec *labels;
 int **gnums,*num_gnums;
{
 int err;
 struct view_rec *view;
 unsigned long lcv;

 *gnums = NULL;
 *num_gnums = 0;
 if ((err = get_ptr(gnums,NULL,labels->num_strs,
     (size_t) sizeof(**gnums))) == NO_ERROR)
    {for (lcv = 0; lcv < labels->num_strs; lcv++)
        if ((view = find_file_view_rec(file,labels->strs[lcv])) != NULL)
           {(*gnums)[*num_gnums] = view->group_num;
            *num_gnums += 1;
           }
    }
 return err;
}


/*-------------------------------------------------------------------------
setup_plane_3d_2ds - ???
-------------------------------------------------------------------------*/

int
setup_plane_3d_2ds(_3d_2ds,total_3d_2ds,num_3d_2ds,view)
 struct _3d_plane_2d_rec **_3d_2ds;
 unsigned long *total_3d_2ds,*num_3d_2ds;
 struct view_rec *view;
{
 unsigned long total,lcv,depth;
 int err;
 struct buf_3d_rec *_3d,*_3d1;
 struct input_file_rec *file;

 *_3d_2ds = NULL;
 *total_3d_2ds = *num_3d_2ds = 0;
 if ((view->gplane.proj_dimx == 0) && (view->gplane.proj_dimy == 0)) return NO_ERROR;
 file = view->file;

 if (file == NULL) return CANCEL;
 PRT(printf("setup_plane_3d_2ds...1\n"))

 if (view->all_rois.num_strs > 0)
     total = view->num_roi_2ds;
   else total = 0;

 PRT1(printf("setup_plane_3d_2ds...all_rois.num_strs = %d total = %d\n",
        view->all_rois.num_strs,total))
 if ((view->img->status4 & IMAGE_3D_SUPERIMPOSED_READY) &&
     (view->status & PLANE_PROJECT_PIXEL_TYPES) && (view->pixel_types.num_strs > 0) &&
     (view->status & PLANE_3D_PIXEL_TYPES_READY))
    total += 1;
 if ((view->status & PROJECT_PLANE_DATA) && (view->status & PLANE_3D_PLANE_READY))
    total++;
 PRT1(printf("setup_plane_3d_2ds...final total = %d\n",total))
 if (total == 0) return NO_ERROR;
 if ((err = get_ptr(_3d_2ds,total_3d_2ds,total,
           (size_t) sizeof(**_3d_2ds))) != NO_ERROR)
    return err;
 for (lcv = 0; lcv < *total_3d_2ds; lcv++)
    setup_3d_plane_2d_rec(&((*_3d_2ds)[lcv]),NULL,NULL,NULL);

 PRT1(printf("setup_plane_3d_2ds...1\n"))
 if ((view->status & PROJECT_PLANE_DATA) && (view->status & PLANE_3D_PLANE_READY))
    {if (find_file_3d(file,view->id,&_3d) == NO_ERROR)
        {setup_3d_plane_2d_rec(&((*_3d_2ds)[*num_3d_2ds]),
              _3d,&(view->sl.slice.slice->_2d),NULL);
         if ((err = SetupBuf2dRec(&(view->sl.slice.slice->_2d),
               view->gplane.proj_dimx,view->gplane.proj_dimy,
               file->hdr.data_info.pixel_depth_bits,
               InputDataTypeToBufType(&(file->hdr.data_info)))) != NO_ERROR)
            return err;
         (*num_3d_2ds) += 1;}
    }
/*
 if ((view->status & PLANE_PROJECT_ROIS) &&
     (view->status & PLANE_3D_ROIS_READY))
*/
 if (view->all_rois.num_strs > 0) 
    {PRT1(printf("setup_plane_3d_2ds...****all_rois.num_strs = %d\n",view->all_rois.num_strs))
     PRT1(for (lcv = 0; lcv < view->all_rois.num_strs; lcv++)
              printf("%d) %s\n",lcv,view->all_rois.strs[lcv]);
          printf("all 3ds...\n");
          for (lcv = 0; lcv < file->slice_info.num_3ds; lcv++)
              printf("%d) %s\n",lcv,file->slice_info._3ds[lcv]->id);
          printf("all 3ds...end\n");)

     for (lcv = 0; lcv < view->all_rois.num_strs; lcv++)
       if (find_file_3d(file,view->all_rois.strs[lcv],&_3d1) == NO_ERROR)
          {setup_3d_plane_2d_rec(&((*_3d_2ds)[*num_3d_2ds]),
                           _3d1,view->roi_2ds[lcv],NULL);
           if ((err = SetupBuf2dRec(view->roi_2ds[lcv],
                view->gplane.proj_dimx,
                view->gplane.proj_dimy,1,0)) != NO_ERROR)
              return err;
           (*num_3d_2ds) += 1;}
         else
          {PRT1(printf("setup_plane_3d_2ds..not found %s\n",view->all_rois.strs[lcv]))}
    }
 PRT1(printf("setup_plane_3d_2ds rois.num_strs = %d  num_roi_2ds = %d status = %x\n",
       view->rois.num_strs,view->num_roi_2ds,(unsigned long) view->status))
 PRT1(printf("all_rois.num_strs = %d\n",view->all_rois.num_strs))

 PRT1(printf(" pixel_types.num_strs = %d  num_type_2ds = %d \n",
       view->pixel_types.num_strs,view->num_type_2ds))
 if ((view->status & PLANE_PROJECT_PIXEL_TYPES) && (view->pixel_types.num_strs > 0) &&
     (view->status & PLANE_3D_PIXEL_TYPES_READY))
    {PRT1(printf("....PIXEL_TYPE_3D_ID = %s\n",PIXEL_TYPE_3D_ID))
     if (find_file_3d(file,PIXEL_TYPE_3D_ID,&_3d) == NO_ERROR)
        {PRT1(printf("....1\n"))
         setup_3d_plane_2d_rec(&((*_3d_2ds)[*num_3d_2ds]),
                  _3d,view->type_2ds[0],NULL);
         (*num_3d_2ds) += 1;
         depth = find_num_bits_needed((unsigned long)
                  (view->img->file->pixel_type.order.num_strs + 1));
         err = SetupBuf2dRec(view->type_2ds[0],
                    view->gplane.proj_dimx,view->gplane.proj_dimy,depth,0);
        }
    }
 PRT1(printf("setup_plane_3d_2ds...num_3d_2ds = %d err = %d END\n",*num_3d_2ds,err))

 return err;
}


/*************************
 if ((err = SetupBuf2dRec(&(view->img->_3d_fusion._2d),
                  view->img->_2d.dimx,view->img->_2d.dimy,
                  view->img->_2d.pixel_depth,
                  view->img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR)
    return err;

     if (view->img->status4 & IMAGE_3D_SUPERIMPOSED_FILLED)
        {depth = find_num_bits_needed(
                 (unsigned long) win->intensity->color.total_colors);
         PRT1(printf("IMAGE_3D_SUPERIMPOSED_FILLED...depth = %d\n",depth))
         if ((err = SetupBuf2dRec(&_2d,view->roi_2ds[0]->dimx,
                   view->roi_2ds[0]->dimy,depth,1)) != NO_ERROR)
            return err;
         max = color = start_color + view->num_roi_2ds - 1;
         if (max >= win->intensity->color.total_colors) 
             max = win->intensity->color.total_colors - 1;
         for (lcv = view->num_roi_2ds - 1; ; lcv--,color--)
            {if (color < start_color) color = start_color;
             Set2d(&_2d,0,0,view->roi_2ds[lcv],NULL,(double) color);
             if (lcv == 0) break;}
         PRT1(printf("start_color = %d max = %d num_strs = %d cnt_buf = %d\n",
                  start_color,max,view->num_roi_2ds,CntNonValBuf2dRec(&_2d,(double) 0)))     
         if (transform_plane_2d_data(&(view->gplane),
                   &_2d,&(view->img->_3d_fusion._2d)) == NO_ERROR)
            {
             view->img->_3d_fusion.srcmin = start_color;
             view->img->_3d_fusion.srcmax = max;
             view->img->status4 |= IMAGE_3D_SUPERIMPOSED;}
         free_buf_2d_rec(&_2d);
        }
**************************/


/*-------------------------------------------------------------------------
setup_plane_roi_and_pixel_types - ???
-------------------------------------------------------------------------*/

int
setup_plane_roi_and_pixel_types(view)
 struct view_rec *view;
{
 unsigned long lcv,cnt,start_color,depth;
 struct color_data_rec *new_color_data;
 struct buf_2d_rec _2d,*_2d_ptr;
 struct strs_rec *order;
 char *picks;
 int err,is_roi_ok,yes,first;
 struct image_display_window *win;
 struct slice_roi_rec *slice_roi;

 PRT1(printf("setup_plane_roi_and_pixel_types...wid = %s view->img->status4 = %x\n",
      view->wid,view->img->status4))
 if ((view->img->status4 & IMAGE_3D_SUPERIMPOSED_OPRS) &&
     !(view->img->status4 & IMAGE_3D_SUPERIMPOSED_READY))
    {view->status |= PLANE_3D_ROIS_NEED_UPDATED | PLANE_3D_PIXEL_TYPES_NEED_UPDATED;
     PRT1(printf("setup_plane_roi_and_pixel_types...not IMAGE_3D_SUPERIMPOSED_READY\n"))
     return NO_ERROR;}
            
 if ((view->status & PLANE_PROJECT_ROIS) && (view->rois.num_strs > 0) &&
     (view->status & PLANE_3D_ROIS_READY))
    yes = 1;
   else yes = 0;
 if ((view->status & PLANE_PROJECT_PIXEL_TYPES) && 
     (view->pixel_types.num_strs > 0) && (view->status & PLANE_3D_PIXEL_TYPES_READY))
    yes |= 2;
 PRT1(printf("setup_plane_roi_and_pixel_types...yes = %d\n",yes))
 if (!yes) 
    {view->img->status4 &= ~IMAGE_3D_SUPERIMPOSED_READY;
     return NO_ERROR;}

 if ((view->img == NULL) || (view->img->win == NULL) ||
     ((win = view->img->win->image_display) == NULL) || (win->intensity == NULL))
    return CANCEL;

 PRT1(printf("setup_plane_roi_and_pixel_types...num_strs = %d\n",view->rois.num_strs))

 err = NO_ERROR;
 view->img->status4 &= ~IMAGE_3D_SUPERIMPOSED;
 if ((view->status & PLANE_PROJECT_ROIS) && (view->rois.num_strs > 0))
    {slice_roi = &(view->sl.slice_roi_win.slice_roi);
     view->status &= ~PLANE_3D_ROIS_NEED_UPDATED;
     PRT1(printf("***num_roi_2ds = %d rois.num_strs = %d %d\n",
             view->num_roi_2ds,view->rois.num_strs,view->all_rois.num_strs))
     for (cnt = 0; cnt < view->rois.num_strs; cnt++)
        for (lcv = cnt; lcv < view->all_rois.num_strs; lcv++)
           if (yes = str_cmp(view->rois.strs[cnt],view->all_rois.strs[lcv]))
              {if (yes < 0) break;}
             else
              {PRT1(printf("%d) lcv = %d %s\n",cnt,lcv,view->rois.strs[cnt]))
               PRT1(pr_buf_2d_rec(view->roi_2ds[lcv]))
               if ((err = ScanRoiFromBuf(slice_roi,view->all_rois.strs[lcv],
                    view->roi_2ds[lcv],ROI_3D_ROI,&is_roi_ok)) != NO_ERROR)
                  return err;
               break;
              }
    }
 PRT1(printf("num_strs = %d num_type_2ds = %d %d\n",view->pixel_types.num_strs,
     view->num_type_2ds,view->roi_pixel_types.num_strs))
 depth = find_num_bits_needed((unsigned long) (win->intensity->color.total_colors +
                 view->img->file->pixel_type.order.num_strs));
 if ((view->status & PLANE_PROJECT_PIXEL_TYPES) && (view->pixel_types.num_strs > 0) &&
     (view->num_type_2ds > 0) && 
     (view->type_2ds[0]->status4 & BUF_NON_EMPTY) &&
     ((err = WinSetupColorDataRec2(win,0,SUPERIMPOSE_3D_ID,0,0,0,0,
         depth,0,&new_color_data,0)) == NO_ERROR))
    {
     init_buf_2d_rec(&_2d);
     PRT1(printf("roi_pixel_types.num_strs = %d  num_roi_2ds = %d\n",
                   view->roi_pixel_types.num_strs,view->num_roi_2ds))
     if (view->roi_pixel_types.num_strs > 0)
        {
         for (first = 1,cnt = 0; cnt < view->roi_pixel_types.num_strs; cnt++)
            for (lcv = cnt; lcv < view->all_rois.num_strs; lcv++)
               if (yes = str_cmp(view->roi_pixel_types.strs[cnt],view->all_rois.strs[lcv]))
                  {if (yes < 0) break;}
                 else 
                  {PRT1(printf("%d) lcv = %d %s\n",cnt,lcv,view->roi_pixel_types.strs[cnt]))
                   if ((cnt < view->num_roi_2ds) && (view->roi_2ds[lcv] != NULL) &&
                       (view->roi_2ds[lcv]->status4 & BUF_NON_EMPTY) &&
                       (view->roi_2ds[lcv]->status4 & BUF_DATA_VALID))
                      if (first)
                         {first = 0;
                          if ((err = copy_buf_2d_rec(&_2d,view->roi_2ds[lcv])) != NO_ERROR)
                             {free_buf_2d_rec(&_2d);
                              PRT1(printf("copy_buf_2d_rec err = %d\n",err))
                              return err;}
                         }
                        else if ((err = or_ary_2ds(&_2d,&(view->roi_2ds[lcv]),1)) != NO_ERROR)
                         {free_buf_2d_rec(&_2d);
                          PRT1(printf("or_ary_2ds err = %d\n",err))
                          return err;}
                   break;
                  }
         if (first) _2d_ptr = NULL;
           else _2d_ptr = &_2d;
        }
       else _2d_ptr = NULL;
     PRT1(printf("_2d_ptr = %u\n",_2d_ptr);)

     start_color = win->intensity->color.reserve_color_start;
     view->status &= ~PLANE_3D_PIXEL_TYPES_NEED_UPDATED;
     order = &(view->img->file->pixel_type.order);
     picks = NULL;
     PRT1(printf("order->num_strs = %d view->pixel_types.num_strs = %d\n",
              order->num_strs,view->pixel_types.num_strs))
     InitBuf2dRecData(&(new_color_data->_2d),(double) .0);
     if (order->num_strs != view->pixel_types.num_strs)
        {err = selected_strs(order,&(view->pixel_types),&picks);
         PRT1(printf("PLANE_PROJECT_PIXEL_TYPES...err = %d picks = %u\n",err,picks))
         if (err == NO_ERROR)
            {
             PRT1(for (lcv = 0; lcv < order->num_strs + 1; lcv++)
                     printf("%d) picks = %d\n",lcv,(unsigned long) picks[lcv]);
                 )
             err = PickAssign2d(&(new_color_data->_2d),view->type_2ds[0],
                   view->type_2ds[0],0,0,_2d_ptr,NULL,picks,
                        order->num_strs + 1);
            }
         }
        else if (_2d_ptr == NULL)
         err = Assign2d(&(new_color_data->_2d),view->type_2ds[0]);
        else err = assign_buf_2d_rec_by_mask(&(new_color_data->_2d),view->type_2ds[0],
                  0,0,_2d_ptr,NULL);

      PRT1(printf("depth = %d...err = %d new_color_data->_2d\n",depth,err);
           pr_buf_2d_rec(&(new_color_data->_2d)))
      PRT1(MinMax2dValues(&(new_color_data->_2d),0,(double) .0,(double) .0,&min4,&max4);
          printf("new_color_data min4 = %f max4 = %f  %d\n",min4,max4,
             CntValBuf2dRec(&(new_color_data->_2d),(double) .0));)
      if (err == NO_ERROR)
         {AddConstantTo2d(&(new_color_data->_2d),(double) start_color,1);
          new_color_data->_2d.status4 |= BUF_DATA_VALID;}
        else WinDropColorDataRec1(win,SUPERIMPOSE_3D_ID,1,0,NULL,1);
     c_free(picks);

     PRT1(MinMax2dValues(&(new_color_data->_2d),0,(double) .0,(double) .0,&min4,&max4);
          printf("new_color_data min4 = %f max4 = %f\n",min4,max4);)
     PRT1(printf("start_color = %d num_colors = %d  num_color_datas = %d %d %d\n",
             start_color,win->data.num_colors,win->data.num_color_datas,
             CntValBuf2dRec(&(new_color_data->_2d),(double) .0),
             CntValBuf2dRec(view->type_2ds[0],(double) .0)))
     free_buf_2d_rec(&_2d);
    }

 PRT1(printf("setup_plane_roi_and_pixel_types...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
get_plane_slice_data - ???
-------------------------------------------------------------------------*/

int
get_plane_slice_data(view)
 struct view_rec *view;
{
 int err;
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long total_3d_2ds,num_3d_2ds;

 PRT1(printf("get_plane_slice_data...1\n"))
 DeleteRoisOfType(&(view->sl.slice_roi_win.slice_roi),ROI_3D_ROI,2);
 if (((err = setup_plane_3d_2ds(&_3d_2ds,&total_3d_2ds,&num_3d_2ds,view)) == NO_ERROR) &&
     (num_3d_2ds > 0))
    {
     PRT1(printf("get_plane_slice_data...num_3d_2ds = %d\n",num_3d_2ds))
     if ((err = _3dPlane2ds(&(view->gplane),_3d_2ds,num_3d_2ds)) == NO_ERROR)
        {
         PRT1(printf("get_plane_slice_data...3\n"))
         setup_plane_roi_and_pixel_types(view);

         view->status &= ~PROJECT_PLANE_DATA;
         view->status |= PLANE_DATA_READY;
         PRT(printf("get_plane_slice_data...ok...1\n"))
        }
    }
 PRT1(printf("get_plane_slice_data...end num_3d_2ds = %d\n",num_3d_2ds))
 if (total_3d_2ds) c_free(_3d_2ds);
 return err;
}


/*-------------------------------------------------------------------------
transform_plane_slice_data - ???
-------------------------------------------------------------------------*/

int
transform_plane_slice_data(view)
 struct view_rec *view;
{
 int err;
 struct _3d_plane_2d_rec *_3d_2ds;
 unsigned long total_3d_2ds,num_3d_2ds;

 if (((err = setup_plane_3d_2ds(&_3d_2ds,&total_3d_2ds,&num_3d_2ds,view)) == NO_ERROR) &&
     (num_3d_2ds > 0))
    {
     if ((err = transform_plane_2ds(&(view->gplane),_3d_2ds,num_3d_2ds)) == NO_ERROR)
        {
         setup_plane_roi_and_pixel_types(view);

         view->status &= ~PROJECT_PLANE_DATA;
         view->status |= PLANE_DATA_READY;
         PRT(printf("get_plane_slice_data...ok...1\n"))
        }
    }
 if (total_3d_2ds) c_free(_3d_2ds);
 return err;
}


/*-------------------------------------------------------------------------
win_enable_3d_draw_mode - ???
-------------------------------------------------------------------------*/

int
win_enable_3d_draw_mode(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;

 set_allowable_pen_types(&(win->control),DRAW_LINE);
 set_max_input_curve_pts(&(win->control),2);
 win->control.status |= _3D_DRAW_MODE;
 set_proc_upon_input_done(&(win->control),_3dCRModeAction,view);
 win_enable_draw_pen(win);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
show_view_rec - ???
-------------------------------------------------------------------------*/

int
show_view_rec(
    struct input_file_rec *file,
    struct view_rec *view,
    Frame fr_frame)
{
 struct image_display_window *win;
 int err;

 PRT(printf("show_view_rec...1\n"));
 err = NO_ERROR;
 if ((view->status & PROJECT_THE_PLANE_DATA) == PROJECT_THE_PLANE_DATA)
    {if (((view->img = NewImgBuf(&(file->img),&(view->sl.slice),&err,1,
           1,view->gplane.proj_buf_dimx,view->gplane.proj_buf_dimy,
            file->hdr.data_info.pixel_depth_bits,
            InputDataTypeToBufType(&(file->hdr.data_info)),0)) != NULL) &&
         ((err = get_plane_slice_data(view)) == NO_ERROR))
        {
         if (view->img->file->hdr.data_info.var_use_status & CHANGES_ACTIVATION)
            view->img->status4 |= IMAGE_POS_NEG_ACTIVATION;
         if (view->img->win == NULL) return CANCEL;
         PRT(printf("show_view_rec...ok...3\n"))
         view->status |= PLANE_SLICE_ROI_NEED_SETUP;
         view->img->status4 |= IMAGE_NEED_DISPLAY;
         if (((err = win_setup_windows(view->img->win,fr_frame,
                        EAST,DISPLAY_WINDOW_3D)) == NO_ERROR) &&
             ((win = view->img->win->image_display) != NULL))
            {
             if ((err = cp_str(&(view->wid),
                     WinRecGetWid(win->owner,win->type2))) != NO_ERROR) 
                return err;
             win_enable_3d_draw_mode(win);
             add_roi_type_window_list(win,view);
             add_plane_window_list(view);
             update_view_slice_roi_rec(view);
             win_display_all_curves(win);
            }
          
         PRT(printf("show_view_rec...ok...err = %d\n",err))
        }
    }
 PRT(printf("show_view_rec...2\n"));
 return err;
}



/*-------------------------------------------------------------------------
dp_3d_plane_images - ???
-------------------------------------------------------------------------*/

int
dp_3d_plane_images(view)
 struct view_rec *view;
{
 struct view_rec *view1;
 struct list_rec *cur,*next;
 struct img_buf_rec *img;
 Frame setup_fr_win;
 int err,cnt;
 static int dires[5] = {SCREEN_CENTER_AT_BR,EAST,SOUTH_WEST,EAST,NORTH_EAST};

 setup_fr_win = 0;
 next= cur = &(view->_3d_list);
 err = NO_ERROR;
 cnt = 0;
 do
    {view1 = next->item;
     img = view1->img;
     if ((img != NULL) && (img->status4 & IMAGE_NEED_DISPLAY) && (img->win != NULL))
        if ((err = win_setup_windows(img->win,setup_fr_win,dires[cnt % 4],
                  DISPLAY_WINDOW_3D)) == NO_ERROR)
           {img->status4 &= ~IMAGE_NEED_DISPLAY;
            img->cur_slice->slice->view->status |= PLANE_DATA_PROJECTED;
            win_enable_3d_draw_mode(img->win->image_display);
            setup_fr_win = img->win->image_display->dwin->frame;

            cnt++;
           }
          else break;
      next = next->next;}
 while (cur != next);
 return err;
}


/*-------------------------------------------------------------------------
dp_file_3d_images - ???
-------------------------------------------------------------------------*/

int
dp_file_3d_images(file)
 struct input_file_rec *file;
{
 unsigned long cnt;
 Frame setup_fr_win;
 struct img_buf_rec *img;
 struct slice_info_rec *slice_info;
 static int dires[5] = {SCREEN_CENTER_AT_BR,EAST,SOUTH_WEST,EAST,NORTH_EAST};
 int err,lcv;

 setup_fr_win = 0;
 slice_info = &(file->slice_info);
 for (lcv = 0,cnt = 0; cnt < slice_info->num_views; cnt++)
    {img = slice_info->views[cnt]->img;
     if ((img != NULL) && (img->status4 & IMAGE_NEED_DISPLAY) && 
         (img->cur_slice->slice->view != NULL) && (img->win != NULL))
        if ((err = win_setup_windows(img->win,setup_fr_win,dires[lcv % 5],
                  DISPLAY_WINDOW_3D)) == NO_ERROR)
           {img->status4 &= ~IMAGE_NEED_DISPLAY;
            img->cur_slice->slice->view->status |= PLANE_DATA_PROJECTED;
            win_enable_3d_draw_mode(img->win->image_display);
            setup_fr_win = img->win->image_display->dwin->frame;
            lcv++;
           }
          else break;
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
plane_bound_xy_pts - ???
-------------------------------------------------------------------------*/

int
plane_bound_xy_pts(view,slice_roi,str)
 struct view_rec *view;
 struct slice_roi_rec *slice_roi;
 char *str;
{
 return EnterPtsIntoSliceRoiRec(slice_roi,NULL,str,
            (unsigned int) DRAW_LINE,0,5,1.0,1.0,
            (float) (view->img->_2d.dimx - 2),1.0,
            (float) (view->img->_2d.dimx - 2),(float) (view->img->_2d.dimy - 2),
            1.0,(float) (view->img->_2d.dimy - 2),1.0,1.0);
}


/*-------------------------------------------------------------------------
view_and_view1_roi - ???
-------------------------------------------------------------------------*/

int
view_and_view1_roi(view,view1,status)
 struct view_rec *view,*view1;
 int *status;
{
 struct slice_roi_rec *slice_roi;
 struct vector_3d_rec base1,dire1,base3,and1,and2;
 float nx1,ny1,nx2,ny2,tempz;
 long x1,y1,x2,y2;
 int err;

 slice_roi = &(view->sl.slice_roi_win.slice_roi);
 *status = 0;
 err = NO_ERROR;
 if (IsSameNormalAndOverlapped(&(view->gplane),&(view1->gplane)))
    {*status = 1;
     return plane_bound_xy_pts(view,slice_roi,view1->wid);}
   else if (PlaneIntersection(&(view->gplane),
                    &(view1->gplane),&base1,&dire1))
    {*status = 2;
     if (LocalPt(&(view->gplane),&base1,&base3) &&
         PlaneLineAndBoundIntersection(&(view->gplane),
                      &base3,&dire1,&and1,&and2,1) &&
         (LocalXYZToPlaneXYZ(&(view->gplane),
              and1.x,and1.y,and1.z,&nx1,&ny1,&tempz) == NO_ERROR) &&
         (LocalXYZToPlaneXYZ(&(view->gplane),
              and2.x,and2.y,and2.z,&nx2,&ny2,&tempz) == NO_ERROR))
        {
         x1 = (long) ULongRound((double) nx1);
         y1 = (long) ULongRound((double) ny1);
         x2 = (long) ULongRound((double) nx2);
         y2 = (long) ULongRound((double) ny2);

         err = EnterPtsIntoSliceRoiRec(slice_roi,NULL,view1->wid,
              (unsigned int) DRAW_LINE,0,2,
              (float) x1,(float) y1,(float) x2,(float) y2);
        }
    }
 return err;
}


/*-------------------------------------------------------------------------
setup_plane_slice_roi_rec - ???
-------------------------------------------------------------------------*/

int
setup_plane_slice_roi_rec(view)
 struct view_rec *view;
{
 struct list_rec *cur,*next;
 struct view_rec *view1;
 struct slice_roi_rec *slice_roi;
 struct vector_3d_rec base1,dire1,and1,and2,base3;
 float nx1,ny1,nx2,ny2,tempz;
 long x1,y1,x2,y2;
 int err;
 struct roi_rec *roi;

 PRT(printf("setup_plane_slice_roi_rec...\n"))
 if (!(((view->gplane.status & PLANE_PROJ_DIM_DATA_OK) == PLANE_PROJ_DIM_DATA_OK) &&
       (view->gplane.status & PLANE_PROJ_BUF_DIM_VALID))) return CANCEL;
 if ((view->img == NULL) || (view->img->win == NULL)) return CANCEL;
 cur = &(view->_3d_list);
 slice_roi = &(view->sl.slice_roi_win.slice_roi);
 err = setup_more_rois(slice_roi,view->wid,1);
 if (err != NO_ERROR) return err;

 next = cur->next;
 err = NO_ERROR;
 while (next != cur)
    {view1 = next->item;
     if (view1 != NULL)
        {PRT(printf("setup_ plane  img_label = %s   view1 img_label = %s\n",
         view->sl.slice.img_label,view1->sl.slice.img_label))}
     if ((view1 != NULL) && (view1->img != NULL) && (view1->img->win != NULL))
        {
         if ((roi = get_roi(slice_roi,view1->wid)) != NULL)
            {err = delete_roi(slice_roi,roi);
             if (err == NOT_FOUND) err = NO_ERROR;}
         if ((err == NO_ERROR) && 
             ((view1->gplane.status & PLANE_PROJ_DIM_DATA_OK) == PLANE_PROJ_DIM_DATA_OK))
            {if (IsSameNormalAndOverlapped(&(view->gplane),&(view1->gplane)))
                {if (plane_bound_xy_pts(view,slice_roi,view1->wid) == NO_ERROR)
                    {
                     set_cur_curve_status(slice_roi,CURVE_NEVER_CURRENT);
                     next_curve(slice_roi,1);
                    }
                   else err = setup_more_rois(slice_roi,view1->wid,0);
                }
               else if (PlaneIntersection(&(view->gplane),&(view1->gplane),
                            &base1,&dire1) &&
                 LocalPt(&(view->gplane),&base1,&base3) &&
                 PlaneLineAndBoundIntersection(&(view->gplane),&base3,&dire1,
                      &and1,&and2,1) &&
                 (LocalXYZToPlaneXYZ(&(view->gplane),and1.x,and1.y,and1.z,
                             &nx1,&ny1,&tempz)
                     == NO_ERROR) &&
                 (LocalXYZToPlaneXYZ(&(view->gplane),and2.x,and2.y,and2.z,
                             &nx2,&ny2,&tempz)
                     == NO_ERROR))
                {x1 = (long) ULongRound((double) nx1);
                 y1 = (long) ULongRound((double) ny1);
                 x2 = (long) ULongRound((double) nx2);
                 y2 = (long) ULongRound((double) ny2);
                 if ((err = EnterPtsIntoSliceRoiRec(slice_roi,NULL,view1->wid,
                        (unsigned int) DRAW_LINE,0,2,
                      (float) x1,(float) y1,(float) x2,(float) y2)) == NO_ERROR)
                    {PRT(printf("EnterPtsIntoSliceRoiRec...\n"))
                     set_cur_curve_status(slice_roi,CURVE_NEVER_CURRENT);
                     next_curve(slice_roi,1);
                    }
                   else err = setup_more_rois(slice_roi,view1->wid,0);
                }
               else err = setup_more_rois(slice_roi,view1->wid,0);
             }
          if (err != NO_ERROR) return err;
         }
     next = next->next;
    }
 PRT(printf("setup_plane_slice_roi_rec...end\n"))
 view->status &= ~PLANE_SLICE_ROI_NEED_SETUP;
 view->status |= PLANE_SLICE_ROI_SETUP;

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
setup_all_plane_slice_roi_recs - ???
-------------------------------------------------------------------------*/

int
setup_all_plane_slice_roi_recs(file)
 struct input_file_rec *file;
{
 unsigned long cnt;
 struct slice_info_rec *slice_info;

 PRT(printf("setup_all_plane_slice_roi_recs...1\n"));
 slice_info = &(file->slice_info);
 for (cnt = 0; cnt < slice_info->num_views; cnt++)
    {if (slice_info->views[cnt]->status & PLANE_SLICE_ROI_NEED_SETUP)
        setup_plane_slice_roi_rec(slice_info->views[cnt]);
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
dp_all_plane_rois - ???
-------------------------------------------------------------------------*/

void
dp_all_plane_rois(view)
 struct view_rec *view;
{
 struct list_rec *cur,*next;
 struct view_rec *view1;

 PRT(printf("dp_all_plane_rois...\n"))
 cur = &(view->_3d_list);
 view->status &= ~PLANE_SLICE_ROI_UPDATED;
 next = cur->next;
 while (next != cur)
    {view1 = next->item;
     if (view1->status & PLANE_SLICE_ROI_UPDATED)
        {view1->status &= ~PLANE_SLICE_ROI_UPDATED;
         if ((view1->img->win != NULL) &&
             (view1->img->win->image_display != NULL))
            {
             PRT(printf("*********dp_all_plane_rois...\n"))
             win_redisplay_all_curves(view1->img->win->image_display);}
        }
     next = next->next;
    }
}


/*-------------------------------------------------------------------------
update_view_slice_roi_rec - ???
-------------------------------------------------------------------------*/

int
update_view_slice_roi_rec(view)
 struct view_rec *view;
{
 struct list_rec *cur,*next;
 struct view_rec *view1;
 struct slice_roi_rec *slice_roi,*cur_slice_roi;
 struct vector_3d_rec base1,dire1,and1,and2,base3;
 float nx1,ny1,nx2,ny2,tempz;
 long x1,y1,x2,y2;
 int err,cnt,ok1,ok2;
 char *cur_roi_label,*cur_roi1_label;
 struct roi_rec *roi,*cur_roi,*cur_roi1;

 PRT(printf("update_view_slice_roi_rec...\n"))
 if (!(((view->gplane.status & PLANE_PROJ_DIM_DATA_OK) == PLANE_PROJ_DIM_DATA_OK) &&
       (view->gplane.status & PLANE_PROJ_BUF_DIM_VALID))) return CANCEL;
 if ((view->img == NULL) || (view->img->win == NULL)) return CANCEL;
/*
 printf("wid = %s\n",view->wid);
 printf("center...");pr_vector_3d_rec(&(view->gplane.center));
 printf("base...");pr_vector_3d_rec(&(view->gplane.base));
       printf("normal...");pr_vector_3d_rec(&(view->gplane.normal));
 pr_plane_corner_pts(&(view->gplane));
*/
 PRT(printf("update_view_slice_roi_rec...%s\n",view->sl.slice.img_label))
 cur_slice_roi = &(view->sl.slice_roi_win.slice_roi);
 if ((roi = get_roi(cur_slice_roi,view->wid)) == NULL)
    setup_more_rois(cur_slice_roi,view->wid,1);
   else delete_all_cur_pen_curves(roi,&(cur_slice_roi->status));
 if ((cur_roi = get_cur_roi(cur_slice_roi)) != NULL)
    cp_str(&cur_roi_label,cur_roi->label);
   else cur_roi_label = NULL;

 cur = &(view->_3d_list);
 next = cur->next;
 cnt = 0;
 err = NO_ERROR;
 while (next != cur)
    {view1 = next->item;
     if ((view1 != NULL) && (view1->img != NULL) && (view1->img->win != NULL) &&
         ((view1->gplane.status & PLANE_PROJ_DIM_DATA_OK) == PLANE_PROJ_DIM_DATA_OK))
        {
         slice_roi = &(view1->sl.slice_roi_win.slice_roi);
         if ((cur_roi1 = get_cur_roi(slice_roi)) != NULL)
            cp_str(&cur_roi1_label,cur_roi1->label);
           else cur_roi1_label = NULL;

         if ((roi = get_roi(slice_roi,view->wid)) != NULL)
            {
             err = delete_roi(slice_roi,roi);
             PRT(printf("0..roi->label = %s deleted err = %d\n",view->wid,err))
             if (err == NOT_FOUND)
                {cnt++;
                 err = NO_ERROR;}
            }
         if (err == NO_ERROR)
            {
             if ((roi = get_roi(cur_slice_roi,view1->wid)) != NULL)
                {err = delete_roi(cur_slice_roi,roi);
                 PRT(printf("1..roi->label = %s deleted err = %d\n",view1->wid,err))
                 if (err == NOT_FOUND) err = NO_ERROR;}
            }

         if (err == NO_ERROR)  
            {ok1 = ok2 = 0;
             if (IsSameNormalAndOverlapped(&(view->gplane),&(view1->gplane)))
                {
                 if (plane_bound_xy_pts(view,cur_slice_roi,view1->wid) == NO_ERROR)
                    {
                     set_cur_curve_status(cur_slice_roi,CURVE_NEVER_CURRENT);
                     next_curve(cur_slice_roi,1);
                    }
                   else err = setup_more_rois(cur_slice_roi,view1->wid,0);
                 if (err == NO_ERROR)
                    if (plane_bound_xy_pts(view1,slice_roi,view->wid) == NO_ERROR)
                       {
                        set_cur_curve_status(slice_roi,CURVE_NEVER_CURRENT);
                        next_curve(slice_roi,1);
                       }
                      else err = setup_more_rois(slice_roi,view->wid,0);
                }
               else if (PlaneIntersection(&(view->gplane),
                    &(view1->gplane),&base1,&dire1))
                {PRT(printf("\n");
                        printf("base1...");pr_vector_3d_rec(&base1);
                        printf("dire1...");pr_vector_3d_rec(&dire1);)
                 if (LocalPt(&(view->gplane),&base1,&base3) &&
                     PlaneLineAndBoundIntersection(&(view->gplane),
                      &base3,&dire1,&and1,&and2,1) &&
                     (LocalXYZToPlaneXYZ(&(view->gplane),
                          and1.x,and1.y,and1.z,&nx1,&ny1,&tempz) == NO_ERROR) &&
                     (LocalXYZToPlaneXYZ(&(view->gplane),
                          and2.x,and2.y,and2.z,&nx2,&ny2,&tempz) == NO_ERROR))
                    {
                     x1 = (long) ULongRound((double) nx1);
                     y1 = (long) ULongRound((double) ny1);
                     x2 = (long) ULongRound((double) nx2);
                     y2 = (long) ULongRound((double) ny2);
                     PRT(
                        printf("view1->wid = %s of view->wid = %s\n",
                          view1->wid,view->wid); 
                        printf("base3...");pr_vector_3d_rec(&base3);

                        printf("EnterPtsIntoSliceRoiRec...x1 = %d  y1 = %d  x2 = %d  y2 = %d\n",
                    x1,y1,x2,y2);)

                     if ((err = EnterPtsIntoSliceRoiRec(cur_slice_roi,NULL,
                        view1->wid,
                        (unsigned int) DRAW_LINE,0,2,(float) x1,(float) y1,
                          (float) x2,(float) y2)) == NO_ERROR)
                        {PRT(printf("EnterPtsIntoSliceRoiRec...1\n"))
                         view->status |= PLANE_SLICE_ROI_UPDATED;
                         set_cur_curve_status(cur_slice_roi,CURVE_NEVER_CURRENT);
                         next_curve(cur_slice_roi,1);
                         PRT(printf("EnterPtsIntoSliceRoiRec...2\n"))

                         ok1 = 1;
                        }
                    }
/*
                 printf("view->wid = %s to view1->wid = %s\n",
                          view->wid,view1->wid); 
*/
                 if (err == NO_ERROR)
                    if (LocalPt(&(view1->gplane),&base1,&base3) &&
                        PlaneLineAndBoundIntersection(&(view1->gplane),
                            &base3,&dire1,&and1,&and2,1) &&
                        (LocalXYZToPlaneXYZ(&(view1->gplane),
                          and1.x,and1.y,and1.z,&nx1,&ny1,&tempz) == NO_ERROR) &&
                        (LocalXYZToPlaneXYZ(&(view1->gplane),
                          and2.x,and2.y,and2.z,&nx2,&ny2,&tempz) == NO_ERROR))
                    {x1 = (long) ULongRound((double) nx1);
                     y1 = (long) ULongRound((double) ny1);
                     x2 = (long) ULongRound((double) nx2);
                     y2 = (long) ULongRound((double) ny2);
                     PRT(
                        printf("\n\nview->wid = %s of view1->wid = %s\n",
                          view->wid,view1->wid); 
                          printf("base3...");pr_vector_3d_rec(&base3);

                          printf("EnterPtsIntoSliceRoiRec...x1 = %d  y1 = %d  x2 = %d  y2 = %d\n",x1,y1,x2,y2);
                         )

                     if ((err = EnterPtsIntoSliceRoiRec(slice_roi,NULL,
                        view->wid,
                        (unsigned int) DRAW_LINE,0,2,(float) x1,(float) y1,
                           (float) x2,(float) y2)) == NO_ERROR)
                        {PRT(printf("EnterPtsIntoSliceRoiRec...3\n"))
                         view1->status |= PLANE_SLICE_ROI_UPDATED;
                         set_cur_curve_status(slice_roi,CURVE_NEVER_CURRENT);
                         next_curve(slice_roi,1);
                         PRT(printf("EnterPtsIntoSliceRoiRec...4\n"))
                         ok2 = 1;
                         cnt += 1;}
                    }
                }
              else
               {
                PRT(printf("\n\nupdate...no plane_and plane view1\n"))
                PRT(pr_plane_3d_rec(&(view->gplane)))
                PRT(pr_plane_3d_rec(&(view1->gplane)))
                PRT(printf("\n"))
               }
             if (!ok1)
                {PRT(printf("setup_more_rois...view1->wid = %s\n",view1->wid))
                 if ((err = setup_more_rois(cur_slice_roi,view1->wid,0)) == NO_ERROR)
                    {view->status |= PLANE_SLICE_ROI_UPDATED;}
                }
             if (!ok2)
                {PRT(printf("setup_more_rois...view->wid = %s\n",view->wid))
                 if ((err = setup_more_rois(slice_roi,view->wid,0)) == NO_ERROR)
                    {view1->status |= PLANE_SLICE_ROI_UPDATED;
                     cnt += 1;}
                }
            }
          if (cur_roi1_label != NULL)
             {PRT(printf("next_cur_roi...cur_roi1_label = %s\n",cur_roi1_label))
              next_cur_roi(slice_roi,cur_roi1_label);
              c_free(cur_roi1_label);}

          if (err != NO_ERROR) break;
         }
     next = next->next;
    }
 PRT(printf("update_view_slice_roi_rec...err = %d...cnt = %d\n",err,cnt))
 if (cur_roi_label != NULL)
    {next_cur_roi(cur_slice_roi,cur_roi_label);
     c_free(cur_roi_label);}

 if (cnt)
    {
     if ((view->img->win != NULL) &&
         (view->img->win->image_display != NULL))
        {view->img->win->image_display->proc_after_dp.item = 
                     (void *) dp_all_plane_rois;
         view->img->win->image_display->proc_after_dp.item1 = (void *) view;
        }
    }

 return err;
}


/*-------------------------------------------------------------------------
project_view_recs - ???
-------------------------------------------------------------------------*/

int
project_view_recs(view)
 struct view_rec *view;
{
 struct list_rec *cur,*next;
 struct view_rec *view1;
 int err,is_dp;

 PRT(printf("project_view_recs...plane = %u\n",view));

 next= cur = &(view->_3d_list);
 is_dp = 0;
 err = NO_ERROR;
 do
    {view1 = next->item;
     if (view1->status & PLANE_3D_LOAD_DATA_ERROR)
        view1->status &= ~PLANE_3D_LOAD_DATA_ERROR;
       else
        {view1->status |= PLANE_3D_PLANE_READY;
         if ((view1->status & PROJECT_THE_PLANE_DATA) == PROJECT_THE_PLANE_DATA)
            {
             if ((view1->img = NewImgBuf(&(view1->file->img),
                     &(view1->sl.slice),&err,1,
                     1,view->gplane.proj_buf_dimx,view->gplane.proj_buf_dimy,
                     view1->file->hdr.data_info.pixel_depth_bits,
                     InputDataTypeToBufType(&(view1->file->hdr.data_info)),
                     0)) != NULL)
                {if (view1->img->file->hdr.data_info.var_use_status & CHANGES_ACTIVATION)
                    view1->img->status4 |= IMAGE_POS_NEG_ACTIVATION;

                 PRT(printf("view1->img->win = %u\n",view1->img->win))
                 PRT(printf("view1->img->win->wid = %u\n",view1->img->win->wid))
                 PRT(printf("image_display = %u\n",view1->img->win->image_display))

                 if (((err = cp_str(&(view1->wid),
                       WinRecGetWid(view1->img->win,DISPLAY_WINDOW_3D))) == NO_ERROR) &&
                     ((err = get_plane_slice_data(view1)) == NO_ERROR))
                     {
                      view1->img->status4 |= IMAGE_NEED_DISPLAY;
                      view1->status |= PLANE_SLICE_ROI_NEED_SETUP;
                      is_dp = 1;
                     }
                 PRT(printf("==== after =======\n"))
                }
            }
        }
      next = next->next;}
 while (cur != next);
 
 if (is_dp)
    {run_next_view_proc(view,setup_plane_slice_roi_rec,0,0,0,0,0,0);
     dp_3d_plane_images(view);
     if ((view->img != NULL) && (view->img->win != NULL) &&
        (view->img->win->image_display != NULL))
        {add_roi_type_window_list(view->img->win->image_display,view);
         run_next_view_proc(view,add_plane_window_list,0,0,0,0,0,0);
        }
    }

 PRT(printf("project_view_recs...2\n"));
 return err;
}


/*-------------------------------------------------------------------------
UpdatePlaneInfoBeforeDisplay - ???
-------------------------------------------------------------------------*/

void
UpdatePlaneInfoBeforeDisplay(view)
 struct view_rec *view;
{
 PRT(printf("UpdatePlaneInfoBeforeDisplay...wid = %s\n",view->wid))
 reflect_view_slice_num(view);
 change_slice_image_label(&(view->sl.slice),
      (char *) get_plane_img_label(&(view->gplane)));
 PRT(printf("UpdatePlaneInfoBeforeDisplay...1\n"))
 update_view_slice_roi_rec(view);
}


/*-------------------------------------------------------------------------
UpdatePlaneInfoAfterDisplay - ???
-------------------------------------------------------------------------*/

void
UpdatePlaneInfoAfterDisplay(view)
 struct view_rec *view;
{
 PRT(printf("UpdatePlaneInfoAfterDisplay...2\n"))
 if (view->img->win == NULL) return;
 update_3d_save_menu(view->img->win->image_display);
 PRT(printf("UpdatePlaneInfoAfterDisplay...2\n"))
 update_3d_menu(view->img->win->image_display);
 PRT(printf("UpdatePlaneInfoAfterDisplay...3\n"))
 update_more_plane_menu(view->img->win->image_display);
 update_cur_slice_num(view->img->win->image_display);
 PRT(printf("UpdatePlaneInfoAfterDisplay...5\n"))
 win_multiple_set_frame_label(view->img->win->image_display);
 PRT(printf("UpdatePlaneInfoAfterDisplay...4\n"))
 setup_plane_roi_and_pixel_types(view);
}


/*-------------------------------------------------------------------------
UpdatePlaneInfo - ???
-------------------------------------------------------------------------*/

void
UpdatePlaneInfo(view)
 struct view_rec *view;
{
 UpdatePlaneInfoBeforeDisplay(view);
 UpdatePlaneInfoAfterDisplay(view);
}


/*-------------------------------------------------------------------------
BuildAndDisplayPlaneData - ???
-------------------------------------------------------------------------*/

int
BuildAndDisplayPlaneData(view)
 struct view_rec *view;
{
 PRT9(printf("BuildAndDisplayPlaneData...wid = %s\n",view->wid))
 if (view->img->win == NULL) return CANCEL;
 set_win_busy(view->img->win->image_display);
 view->status |= PROJECT_THE_PLANE_DATA;
 UpdatePlaneInfoBeforeDisplay(view);
 RdCurSliceEchoes(view->img,0,0);
 if (view->img->win->image_display->status4 & FILTER_ON) 
    win_filter_image_data(view->img->win->image_display);
 WinNewColorMultiCanvas(view->img->win->image_display);
 UpdatePlaneInfoAfterDisplay(view);
 PRT9(printf("BuildAndDisplayPlaneData...5\n"))
 set_win_not_busy(view->img->win->image_display);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
OutputPlaneData - ???
-------------------------------------------------------------------------*/

int
OutputPlaneData(view,is_trigger_co,is_trigger_lock)
 struct view_rec *view;
 int is_trigger_co,is_trigger_lock;
{
 int err;

 PRT13(printf("OutputPlaneData...view wid = %s status = %x num_cos = %d\n",
        view->wid,(unsigned long) view->status,view->num_cos))
 if ((view->status & PLANE_CO_REGISTERED) && (view->num_cos > 0))
    err = DpAllCoRegPlanes(view,is_trigger_co,is_trigger_lock,1,0,0);
   else if ((err = BuildAndDisplayPlaneData(view)) != NO_ERROR) return err;

 return err;
}


/*-------------------------------------------------------------------------
AdjustOutputPlaneData - ???
-------------------------------------------------------------------------*/

int
AdjustOutputPlaneData(view,is_trigger_co,is_trigger_lock,is_dp_cur,is_dp_whole_group)
 struct view_rec *view;
 int is_trigger_co,is_trigger_lock,is_dp_cur,is_dp_whole_group;
{
 PRT3(printf("AdjustOutputPlaneData...view wid = %s status = %x num_cos = %d\n",
        view->wid,(unsigned long) view->status,view->num_cos))
 if ((view->status & PLANE_CROSS_REGISTERED) && (view->num_cos > 0))
    {if (view->status & PLANE_CO_REG_ADJUST) view_auto_adjust_reco_register(view);
     return DpAllCoRegPlanes(view,is_trigger_co,is_trigger_lock,
                      is_dp_cur,is_dp_whole_group,0);}
   else return BuildAndDisplayPlaneData(view);
}


/*-------------------------------------------------------------------------
FormPlaneNoDisplay - ???
-------------------------------------------------------------------------*/

void
FormPlaneNoDisplay(result_view,pt,normal,center,rotate,is_pt_global,sel_adjust_center,
                   xyztoplane)
 struct view_rec *result_view;
 struct vector_3d_rec *pt,*normal,*center,*rotate;
 int is_pt_global,sel_adjust_center;
 struct matrix_3d_rec *xyztoplane;
{
 struct plane_3d_rec *gplane;
 struct vector_3d_rec base1,*base;

 gplane = &(result_view->gplane);
 if (is_pt_global)
    {LocalPt(gplane,pt,&base1);
     base = &base1;
    }
   else base = pt;
 result_view->last_gplane = *gplane;
 result_view->status |= PLANE_LAST_PLANE_VALID;
 ChangePlane(gplane,base->x,base->y,base->z,
             normal->x,normal->y,normal->z,center,rotate,sel_adjust_center,
             xyztoplane);
 PRT(printf("FormPlane...4\n"))
}


/*-------------------------------------------------------------------------
FormPlane - ???
-------------------------------------------------------------------------*/

int
FormPlane(result_view,pt,normal,center,rotate,is_pt_global,sel_adjust_center,
          xyztoplane)
 struct view_rec *result_view;
 struct vector_3d_rec *pt,*normal,*center,*rotate;
 int is_pt_global,sel_adjust_center;
 struct matrix_3d_rec *xyztoplane;
{
 FormPlaneNoDisplay(result_view,pt,normal,center,rotate,is_pt_global,
       sel_adjust_center,xyztoplane);
 return AdjustOutputPlaneData(result_view,1,1,1,0);
}


/*-------------------------------------------------------------------------
FormPlaneAndAdjust - ???
-------------------------------------------------------------------------*/

int
FormPlaneAndAdjust(result_view,pt,normal,center,rotate,is_pt_global)
 struct view_rec *result_view;
 struct vector_3d_rec *pt,*normal,*center,*rotate;
 int is_pt_global;
{
 FormPlaneNoDisplay(result_view,pt,normal,center,rotate,is_pt_global,1,NULL);
 return AdjustOutputPlaneData(result_view,1,1,1,0);
}


/*-------------------------------------------------------------------------
RotatePlaneFromCenter - ???
-------------------------------------------------------------------------*/

int
RotatePlaneFromCenter(view,angle,is_rel)
 struct view_rec *view;
 float angle;
 int is_rel;
{
 double rad;

 view->last_gplane = view->gplane;
 view->status |= PLANE_LAST_PLANE_VALID;
 rad = radian_1(angle,6);
 if (is_rel) view->gplane.rotate.z += (float) rad;
   else  view->gplane.rotate.z = (float) rad;
 PRT9(printf("RotatePlaneFromCenter rel = %d rad = %f deg = %f rotate = %f %f\n",
      is_rel,rad,angle,view->gplane.rotate.z,degree(view->gplane.rotate.z)))
 DefinePlaneTransformation(&(view->gplane));
 return AdjustOutputPlaneData(view,1,0,1,0);
}


/*-------------------------------------------------------------------------
plane_data_pixel_type - ???
-------------------------------------------------------------------------*/

char *
plane_data_pixel_type(view,x,y)
 struct view_rec *view;
 int x,y;
{
 struct vector_3d_rec v;
 struct buf_3d_rec *_3d;
 double value;
 unsigned long indx;
 char *str;
 int err;

 if (view->img == NULL) return NULL;
 if (view->img->file->pixel_type.order.num_strs == 0) return NULL;
 if (find_file_3d(view->img->file,PIXEL_TYPE_3D_ID,&_3d) != NO_ERROR) return NULL;

 PlaneXYZToLocalXYZ(&(view->gplane),(float) x, (float) y, .0,
                      &(v.x),&(v.y),&(v.z),0);
 if (_3dVal(&(view->gplane),_3d,v.x,v.y,v.z,&value) != NO_ERROR) return NULL;
 if (value <= .0) 
    {if ((err = cp_str(&str,"UNKNOWN")) != NO_ERROR) return NULL;}
   else
    {indx = (unsigned long) value;
     if (indx > view->img->file->pixel_type.order.num_strs) return NULL;
       else if ((err = cp_str(&str,view->img->file->pixel_type.order.strs[indx - 1]))
           != NO_ERROR) return NULL;
    }
 return str;
}
  

/*-------------------------------------------------------------------------
plane_data_slice_info - ???
-------------------------------------------------------------------------*/
       
struct slice_3d_rec *
plane_data_slice_info(view,x,y)
 struct view_rec *view;
 int x,y;
{
 struct buf_3d_rec *_3d;
 struct vector_3d_rec v;
 int err;
 long tz;

 if (view->img == NULL) return NULL;
 PlaneXYZToLocalXYZ(&(view->gplane),(float) x, (float) y, .0,
                      &(v.x),&(v.y),&(v.z),0);
 if (plane_pt_in_3d(&(view->gplane),v.x,v.y,v.z))
    {
/*
     pr_vector_3d_rec(&v);
*/
     tz = (long) ULongRound((double) v.z);
     if ((err = find_file_3d(view->img->file,view->id,&_3d)) != NO_ERROR) return NULL;
/*
     PRT(printf("tz = %d  stx = %d  sty = %d stz = %d\n",
           tz,_3d->startx,_3d->starty,_3d->startz))
*/
     tz -= (long) _3d->startz;
     if ((tz < 0) || (tz >= _3d->dimz)) return NULL;
/*
     printf("plane_data_slice_info tz = %d s1 = %u s2 = %u\n",tz,_3d->sls[tz].s1,_3d->sls[tz].s2);
*/
     return &(_3d->sls[tz]);
    }
 return NULL;
}


/*-------------------------------------------------------------------------
locate_new_plane - ???
-------------------------------------------------------------------------*/

int
locate_new_plane(view,slice_offset,is_rel)
 struct view_rec *view;
 int slice_offset,is_rel;
{
 struct plane_3d_rec temp;

 temp = view->gplane;
 PRT13(printf("locate_new_plane...view wid = %s\n",view->wid))
 if (locate_plane(&(view->gplane),slice_offset,is_rel))
    {view->status |= PROJECT_THE_PLANE_DATA;
     UpdatePlaneInfo(view);
     view->last_gplane = temp;
     view->status |= PLANE_LAST_PLANE_VALID;
     PRT13(printf("locate_new_plane...AdjustOutputPlaneData\n"))
     AdjustOutputPlaneData(view,1,1,0,0);
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_new_3d_win - ???
-------------------------------------------------------------------------*/

int
win_new_3d_win(win,normal)
 struct image_display_window *win;
 struct vector_3d_rec *normal;
{
 struct view_rec *view,*new_view;
 struct plane_3d_rec *gplane;
 struct img_buf_rec *img;
 int err,is_adjust_to_center;
 struct vector_3d_rec *norm;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 gplane = &(view->gplane);
 if (gplane->status & PLANE_ADJUST_TO_CENTER) is_adjust_to_center = 1;
   else is_adjust_to_center = 0;
 if (normal == NULL) norm = &(gplane->normal_cosine);
   else norm = normal;
 if ((err = SetupFileViewRec(view->file,view->id,
        gplane->base.x,gplane->base.y,gplane->base.z,
        norm->x,norm->y,norm->z,
        &(gplane->global_start),&(gplane->global_end),
        gplane->proj_buf_dimx,gplane->proj_buf_dimy,
        &(gplane->translate),&(gplane->scale),&(gplane->rotate),
        &(gplane->center),
        gplane->coord_ratio.x,gplane->coord_ratio.y,gplane->coord_ratio.z,
        &(gplane->global),is_adjust_to_center,
        view->more_status & VIEW_3D_APPROX,
        &new_view)) != NO_ERROR)
    {
     ShowMsgStrs(win->dwin->frame,0,err,0,1,
               "Fail to create the new 3d window !!!",NULL,0);
     return err;}
 new_view->last_gplane = view->last_gplane;
 new_view->status |= PROJECT_THE_PLANE_DATA | PLANE_3D_PLANE_READY | 
           PLANE_LAST_PLANE_VALID;
 add_item_after_cur_list(&(view->_3d_list),&(new_view->_3d_list));
 set_view_group_num(new_view);

 if ((err = show_view_rec(view->file,new_view,win->dwin->frame)) != NO_ERROR)
    {delete_view_rec(view->file,new_view);
     ShowMsgStrs(win->dwin->frame,0,err,0,1,
               "Error creating the new 3d window !!!",NULL,0);}
 return err;
}


/*-------------------------------------------------------------------------
win_new_3d_win_normal_to_centers - ???
-------------------------------------------------------------------------*/

int
win_new_3d_win_normal_to_centers(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct vector_3d_rec normal;
 struct view_rec *view,*view1;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view1 = find_any_view_rec(img->file,wid)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 sub_vectors(&normal,&(view1->gplane.base),&(view->gplane.base));
 if (get_vector_plane_type(&normal) == VECTOR_ORIGIN)
    normal = view->gplane.normal_cosine;
 return win_new_3d_win(win,&normal);
}


/*-------------------------------------------------------------------------
win_new_3d_win_normal_to_normals - ???
-------------------------------------------------------------------------*/

int
win_new_3d_win_normal_to_normals(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct vector_3d_rec base,normal;
 struct view_rec *view,*view1;
 struct img_buf_rec *img;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view1 = find_any_view_rec(img->file,wid)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 sub_vectors(&normal,&(view1->gplane.base),&(view->gplane.base));
 vector_cross_product(&normal,&(view1->gplane.normal_cosine),
         &(view->gplane.normal_cosine));
 if (get_vector_plane_type(&normal) == VECTOR_ORIGIN)
    if ((err = base_normal_after_axis_rotation(&(view->gplane),
          .0,.0,.0,1.0,90.0,&base,&normal)) != NO_ERROR)
       return err;
 return win_new_3d_win(win,&normal);
}


/*-------------------------------------------------------------------------
_3d_default_cur_line - ???
-------------------------------------------------------------------------*/

int
_3d_default_cur_line(view,x1,y1,x2,y2)
 struct view_rec *view;
 long *x1,*y1,*x2,*y2;
{
 struct roi_rec *cur_roi;
 struct slice_roi_rec *slice_roi;
 struct curve_rec *cur_curve;
 int x3,y3;

 slice_roi = &(view->sl.slice_roi_win.slice_roi);
 if ((LongCurPtByIndx(slice_roi,1,x2,y2,NULL) != NO_ERROR) ||
     (LongCurPtByIndx(slice_roi,0,x1,y1,NULL) != NO_ERROR))
    {if (((cur_roi = get_cur_roi(slice_roi)) != NULL) &&
         ((cur_curve = locate_curve_of_type(slice_roi,
                  CURVE_NEVER_CURRENT,0)) != NULL) &&
         (LongCurvePtByIndx(cur_curve,0,x1,y1,NULL) == NO_ERROR) )
        {if (LongCurvePtByIndx(cur_curve,1,x2,y2,NULL) != NO_ERROR)
            {PRT4(printf("_3d_default_cur_line...1\n"))
             return CANCEL;}
           else if (LongCurvePtByIndx(cur_curve,2,&x3,&y3,NULL) == NO_ERROR)
            {/* same plane */
             *x1 = 0;
             *x2 = view->img->_2d.dimx - 1;
             *y1 = *y2 = view->img->_2d.dimy / 2;
            }
        }
       else 
        {PRT4(printf("_3d_default_cur_line...2\n"))
         return CANCEL;}
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
rotate_plane - ???
-------------------------------------------------------------------------*/

int
rotate_plane(view,x1,y1,x2,y2,mode)
 struct view_rec *view;
 long x1,y1,x2,y2;
 unsigned long mode;
{
 float rad_angle,angle,angle1;
 struct image_display_window *win;
 int err;

 PRT(printf("rotate_plane x1 = %d  y1 = %d   x2 = %d  y2 = %d\n",x1,y1,x2,y2))
 if (view->img->win == NULL) return CANCEL;
 win = view->img->win->image_display;
 if (x1 < x2)
    {if (y1 == y2) rad_angle = .0;
       else
        {rad_angle = (float) atan2((double) (y2 - y1),(double) (x2 - x1));
         if (rad_angle < .0)
            {PRT(printf("...1st\n"))
             rad_angle = -rad_angle;}
           else
            {PRT(printf("...4th\n"))
             rad_angle = 2 * RADIAN - rad_angle;}
        }
    }
   else if (x2 < x1)
    {if (y1 == y2) rad_angle = RADIAN;
       else
        {rad_angle = (float) atan2((double) (y2 - y1),(double) (x2 - x1));
         if (rad_angle < .0)
            {PRT(printf("...3th\n"))
             rad_angle = RADIAN - rad_angle;}
           else
            {PRT(printf("...2th\n"))
             rad_angle = RADIAN - rad_angle;}
        }
    }
   else if (x1 == x2)
    {if (y1 == y2) rad_angle = .0;
       else if (y2 < y1) rad_angle = RADIAN / 2.0;
        else rad_angle = 1.5 * RADIAN;
    }
 angle = (float) degree(rad_angle);
 angle1 = (float) degree(view->gplane.rotate.z);
 PRT(printf("rotate_plane rad_angle = %f  angle = %f angle1 = %f",
             rad_angle,angle,angle1))

 if (win->control.which_cursor == CURSOR_ROTATE_HORIZONTAL)
    {if (angle <= 90.0) angle = angle1 - angle;
       else if (angle <= 180.0) angle = angle1 - angle + 180.0;
       else if (angle <= 270.0) angle = angle1 - angle + 180.0;
       else angle = angle1 - angle + 360.0;
     if (angle < .0) angle += 360;
     angle = (float) fmod((double) angle, (double) 360.0);
     if (mode == CTRL_COMMAND_KEY) angle = 180 + angle;
     PRT(printf("CURSOR_ROTATE_HORIZONTAL...\n"))
    }
   else if (win->control.which_cursor == CURSOR_ROTATE_VERTICAL)
    {if (angle <= 90.0) angle = 90.0 - angle + angle1;
       else if (angle <= 180.0) angle = angle1 - angle + 90.0;
       else if (angle <= 270.0) angle = 270.0 - angle + angle1;
       else angle = angle1 - angle + 270.0;
     if (angle < .0) angle += 360;
     angle = (float) fmod((double) angle, (double) 360.0);
     PRT(printf("CURSOR_ROTATE_VERTICAL...\n"))
     if (mode == CTRL_COMMAND_KEY) angle = 180 + angle;
    }
 PRT(printf("which_cursor = %x  angle = %f\n",win->control.which_cursor,angle))
 err = RotatePlaneFromCenter(view,angle,0);
 angle1 = (float) degree(view->gplane.rotate.z);
 PRT(printf(" ==== new angle = %f  new angle1 = %f\n",angle,angle1))

 return err;
}


/*-------------------------------------------------------------------------
rotate_plane_by_cur_line - ???
-------------------------------------------------------------------------*/

int
rotate_plane_by_cur_line(view,mode)
 struct view_rec *view;
 unsigned long mode;
{
 long x1,y1,x2,y2;
 struct slice_roi_rec *slice_roi;
 int err;

 if (view->img->win == NULL) return CANCEL;
 set_win_busy(view->img->win->image_display);

 slice_roi = &(view->sl.slice_roi_win.slice_roi);
 if ((err = _3d_default_cur_line(view,&x1,&y1,&x2,&y2)) == NO_ERROR)
    err = rotate_plane(view,x1,y1,x2,y2,mode);
 set_win_not_busy(view->img->win->image_display);

 return err;
}


/*-------------------------------------------------------------------------
_3d_rotate - ???
-------------------------------------------------------------------------*/

int
_3d_rotate(view,mode)
 struct view_rec *view;
 unsigned long mode;
{
 long x1,y1,x2,y2;
 int err;

 if ((err = _3d_default_cur_line(view,&x1,&y1,&x2,&y2)) != NO_ERROR) return err;
 PRT(printf("_3d_absolute_rotate...x1 = %d  %d  %d  %d\n",x1,y1,x2,y2))
 return rotate_plane(view,x1,y1,x2,y2,mode);
}


/*-------------------------------------------------------------------------
_3dCRModeAction - ???
-------------------------------------------------------------------------*/

int
_3dCRModeAction(view,mode)
 struct view_rec *view;
 unsigned long mode;
{
 unsigned long which_cursor;

 if (view->img->win == NULL) return CANCEL;
 which_cursor = view->img->win->image_display->control.which_cursor;
 if ((which_cursor == CURSOR_CUT) || (which_cursor == CURSOR_ANGLE_CUT))
    return ChangeCutPlane(view,0);
   else if ((which_cursor == CURSOR_ROTATE_VERTICAL) ||
            (which_cursor == CURSOR_ROTATE) ||
            (which_cursor == CURSOR_ROTATE_HORIZONTAL))
    return rotate_plane_by_cur_line(view,mode);
   else if (which_cursor == CURSOR_SAME_ANGLE_CUT)
    return view_same_angle_cut(view);
   else if (which_cursor == CURSOR_LOCATE_PLANE)
    {PRT2(printf("_3dCRModeAction CURSOR_LOCATE_PLANE...\n"))
     return ChangeCutPlane(view,1);}
   else return NO_ERROR;
}


/*-------------------------------------------------------------------------
_3d_plane_orientation - ???
-------------------------------------------------------------------------*/

int
_3d_plane_orientation(view,select)
 struct view_rec *view;
 int select;
{
 view->last_gplane = view->gplane;
 view->status |= PLANE_LAST_PLANE_VALID;
 set_plane_orientation(&(view->gplane),select);
 return AdjustOutputPlaneData(view,1,0,1,0);
}


/*-------------------------------------------------------------------------
win_new_view - ???
-------------------------------------------------------------------------*/

int
win_new_view(win,new_plane)
 struct image_display_window *win;
 struct plane_3d_rec *new_plane;
{
 struct img_buf_rec *img;
 struct view_rec *pl;
 struct plane_3d_rec temp;
 int which,err;
 struct buf_2d_rec _2d,_2d1;

 PRT6(printf("....win_new_view 1...\n");)
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 pl = img->cur_slice->slice->view;
 which = 0;
 PRT6(printf("....win_new_view 2...proj_dimx = %d = %d\n",
         new_plane->proj_dimx,new_plane->proj_dimy);)
 if ((new_plane->proj_dimx != pl->sl.slice.slice->_2d.dimx) || 
     (new_plane->proj_dimy != pl->sl.slice.slice->_2d.dimy))
    {init_buf_2d_rec(&_2d);
     PRT6(printf("....win_new_view 3...\n");)
     if ((err = SetupBuf2dRec(&_2d,
               new_plane->proj_dimx,new_plane->proj_dimy,
               pl->sl.slice.slice->_2d.pixel_depth,
               pl->sl.slice.slice->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR)
        {free_buf_2d_rec(&_2d);
         return err;}
     which = 1;
    }
 PRT6(printf("....win_new_view 2...proj_dimx = %d = %d\n",
         new_plane->proj_buf_dimx,new_plane->proj_buf_dimy);)
 if ((new_plane->proj_buf_dimx != img->_2d.dimx) || 
     (new_plane->proj_buf_dimy != img->_2d.dimy))
    {init_buf_2d_rec(&_2d1);
     PRT6(printf("....win_new_view 4...\n");)
     if (((err = SetupBuf2dRec(&_2d1,
               new_plane->proj_buf_dimx,new_plane->proj_buf_dimy,
               img->_2d.pixel_depth,
               img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR) ||
         ((err = win_setup_mask_bufs(win,0,0,
               new_plane->proj_buf_dimx,new_plane->proj_buf_dimy)) != NO_ERROR))
        {if (which & 1) free_buf_2d_rec(&_2d);
         free_buf_2d_rec(&_2d1);
         return err;}
     which |= 2;
     setup_int_bound_rec(&(win->data.bound),0,0,new_plane->proj_buf_dimx - 1,
          new_plane->proj_buf_dimy - 1);
    }

 if (which & 1)
    {free_buf_2d_rec(&(pl->sl.slice.slice->_2d));
     pl->sl.slice.slice->_2d = _2d;
    }
 if (which & 2)
    {free_buf_2d_rec(&(img->_2d));
     img->_2d = _2d1;
     PRT6(printf("....win_new_view 5...\n");)
     setup_def_screen_data_rec(&(win->dwin->screen),
            &(win->dwin->screen.def_dimension.limitrr),
                     0,0,img->_2d.dimx,img->_2d.dimy,1,1,1);
    }
 PRT6(printf("....win_new_view 6...\n");)

 temp = pl->gplane;
 pl->gplane = *new_plane;
 pl->last_gplane = temp;
 pl->status |= PLANE_LAST_PLANE_VALID;
 PRT6(printf("....win_new_view...7\n");)
 OutputPlaneData(pl,1,1);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
_3d_last_plane - ???
-------------------------------------------------------------------------*/

int
_3d_last_plane(win,is_adjust_recoreg)
 struct image_display_window *win;
 int is_adjust_recoreg;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 struct plane_3d_rec gplane;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
     return CANCEL;
 set_win_busy(win);
 view = img->cur_slice->slice->view;
 if (view->status & PLANE_LAST_PLANE_VALID)
    {if (is_adjust_recoreg && 
         (view->status & PLANE_CROSS_REGISTERED) &&
         (view->num_cos > 0))
        {gplane = view->last_gplane;
         view->last_gplane = view->gplane;
         view->gplane = gplane;
         view_auto_adjust_reco_register(view);
         OutputPlaneData(view,1,1);}
       else win_new_view(win,&(view->last_gplane));
    }
 set_win_not_busy(win);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
_3dDegreeCutPlane - ???
-------------------------------------------------------------------------*/

int
_3dDegreeCutPlane(result_view,view,cut_deg,x1,y1,x2,y2,use_this_normal)
 struct view_rec *result_view,*view;
 float cut_deg;
 long x1,y1,x2,y2;
 struct vector_3d_rec *use_this_normal;
{
 int err;
 struct vector_3d_rec base,normal;

 PRT6(printf("_3dDegreeCutPlane...plane = %u\n",view))
 if ((err = base_normal_after_angle_cut(&(view->gplane),(float) x1,(float) y1,
          (float) x2,(float) y2,cut_deg,&base,&normal)) == NO_ERROR)
   {PRT6(printf("_3dDegreeCutPlane...base\n");pr_vector_3d_rec(&base))
    if (use_this_normal != NULL) normal = *use_this_normal;

    GlobalPt(&(view->gplane),&base,&base);
    PRT6(printf("GlobalPt...base\n");pr_vector_3d_rec(&base))
    PRT6(printf("GlobalPt...center\n");
        pr_vector_3d_rec(&(result_view->gplane.center)))
    err = FormPlaneAndAdjust(result_view,&base,&normal,NULL,NULL,1);
    PRT(printf("_3dDegreeCutPlane...4\n"))
   }
 return err;
}


/*-------------------------------------------------------------------------
ChangeCutPlane - ???
-------------------------------------------------------------------------*/

int
ChangeCutPlane(view,use_old_normal)
 struct view_rec *view;
 int use_old_normal;
{
 struct view_rec *result_view;
 struct image_display_window *win;
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 struct vector_3d_rec *norm;
 long x1,y1,x2,y2,cut_angle;
 int err;

 PRT(printf("ChangeCutPlane...plane = %u\n",view))
 if ((win = view->img->win->image_display) == NULL) return CANCEL;
 set_win_busy(win);
 slice_roi = &(view->sl.slice_roi_win.slice_roi);
 if ((LongCurPtByIndx(slice_roi,1,&x2,&y2,NULL) == NO_ERROR) &&
     (LongCurPtByIndx(slice_roi,0,&x1,&y1,NULL) == NO_ERROR))
    {
     PRT(printf("****x1 = %d  y1 = %d   x2 = %d  y2 = %d\n",x1,y1,x2,y2))
     err = NO_ERROR;
     cut_angle = get_3d_plane_cut_angle(win);
     if (((roi = get_cur_roi(slice_roi)) != NULL) &&
         ((result_view = find_view_rec(view,roi->label)) != NULL))
        {if (use_old_normal) norm = &(result_view->gplane.normal_cosine);
           else norm = NULL;
         err = _3dDegreeCutPlane(result_view,view,(float) cut_angle,x1,y1,x2,y2,
                       norm);
        }
       else win_alarm(win->dwin->frame,2);
    }
   else
    {err = delete_cur_roi_curve(slice_roi);
     win_redisplay_all_curves(win);}
 set_win_not_busy(win);
 return err;

}


/*-------------------------------------------------------------------------
view_same_angle_cut - ???
-------------------------------------------------------------------------*/

int
view_same_angle_cut(view)
 struct view_rec *view;
{
 struct view_rec *result_view;
 struct image_display_window *win;
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 long x1,y1,x2,y2;
 float cut_angle;
 int err;

 PRT2(printf("view_same_angle_cut \n");)
 if ((win = view->img->win->image_display) == NULL) return CANCEL;
 set_win_busy(win);
 slice_roi = &(view->sl.slice_roi_win.slice_roi);
 if ((LongCurPtByIndx(slice_roi,1,&x2,&y2,NULL) == NO_ERROR) &&
     (LongCurPtByIndx(slice_roi,0,&x1,&y1,NULL) == NO_ERROR))
    {
     PRT(printf("****x1 = %d  y1 = %d   x2 = %d  y2 = %d\n",x1,y1,x2,y2))
     err = NO_ERROR;
     if (((roi = get_cur_roi(slice_roi)) != NULL) &&
         ((result_view = find_view_rec(view,roi->label)) != NULL))
        {cut_angle = degree_angle_vectors(&(result_view->gplane.normal_cosine),
                             &(view->gplane.normal_cosine));
         PRT2(printf("cut_angle = %f\n",cut_angle);)
         err = _3dDegreeCutPlane(result_view,view,cut_angle,x1,y1,x2,y2,NULL);
        }
       else win_alarm(win->dwin->frame,2);
    }
   else
    {err = delete_cur_roi_curve(slice_roi);
     win_redisplay_all_curves(win);}
 set_win_not_busy(win);
 PRT2(printf("view_same_angle_cut err = %d\n",err);)
 return err;
}


/*-------------------------------------------------------------------------
win_3d_locate_plane - ???
-------------------------------------------------------------------------*/

int
win_3d_locate_plane(
    struct image_display_window *win,
    Event *event)
{
 struct view_rec *view,*view1;
 struct slice_roi_rec *slice_roi;
 struct img_buf_rec *img;
 struct roi_rec *roi;
 struct vector_3d_rec v1,base;
 long x,y,x1,y1,x2,y2;
 int err,status;

 PRT2(printf("win_3d_locate_plane \n");)
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 if (dwin_get_coord_xy_from_event(win->dwin,event,&x,&y) != NO_ERROR)
    return CANCEL;
 slice_roi = &(view->sl.slice_roi_win.slice_roi);
 if (((roi = get_cur_roi(slice_roi)) == NULL) ||
     ((view1 = find_view_rec(view,roi->label)) == NULL) ||
     (view1 == view))
    {win_alarm(win->dwin->frame,2);
     return NO_ERROR;}
 set_win_busy(win);
 if ((LongCurPtByIndx(slice_roi,1,&x2,&y2,NULL) != NO_ERROR) &&
     (x == x2) && (y == y2) &&
     (LongCurPtByIndx(slice_roi,0,&x1,&y1,NULL) != NO_ERROR))
    {
     PRT2(printf("same spot \n");)
     err = _3dDegreeCutPlane(view1,view,.0,x1,y1,x2,y2,
            &(view1->gplane.normal_cosine));
     set_win_not_busy(win);
     return err;
    }
 if ((err = PlaneXYZToLocalXYZ(&(view->gplane),(float) x,(float) y,.0,
             &(v1.x),&(v1.y),&(v1.z),0)) == NO_ERROR)
   {         
    delete_all_roi_curves(roi,NULL);
    view_and_view1_roi(view,view1,&status);
    if (status)
       {set_cur_curve_status(slice_roi,CURVE_NEVER_CURRENT);
        next_curve(slice_roi,1);
        if (status == 2)
           {GlobalPt(&(view->gplane),&v1,&v1);
            LocalPt(&(view1->gplane),&v1,&v1);
            base = view1->gplane.base;
            view1->gplane.base = v1;
            view_and_view1_roi(view,view1,&status);
            view1->gplane.base = base;
           }
       }
    win_redisplay_all_curves(win);
   }
  else win_alarm(win->dwin->frame,2);
 set_win_not_busy(win);
 PRT2(printf("win_3d_locate_plane err = %d\n",err);)
 return err;
}

/*****************
view_same_angle_cut(view)
 struct view_rec *view;
{
 struct view_rec *result_view;
 struct image_display_window *win;
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 long x1,y1,x2,y2;
 struct vector_3d_rec v1,v2,base,dire;
 int err,yes,line_move_unit_ratio;

 PRT2(printf("view_same_angle_cut \n");)
 if ((win = view->img->win->image_display) == NULL) return CANCEL;
 set_win_busy(win);
 slice_roi = &(view->sl.slice_roi_win.slice_roi);
 if ((LongCurPtByIndx(slice_roi,1,&x2,&y2,NULL) == NO_ERROR) &&
     (LongCurPtByIndx(slice_roi,0,&x1,&y1,NULL) == NO_ERROR) &&
     ((x1 != x2) || (y1 != y2)))
    {
     err = CANCEL;
     if (((roi = get_cur_roi(slice_roi)) != NULL) &&
         ((result_view = find_view_rec(view,roi->label)) != NULL) &&
         ((err = PlaneXYZToLocalXYZ(&(view->gplane),(float) x1,(float) y1,.0,
             &(v1.x),&(v1.y),&(v1.z),0)) == NO_ERROR) &&
         ((err = PlaneXYZToLocalXYZ(&(view->gplane),(float) x2,(float) y2,.0,
              &(v2.x),&(v2.y),&(v2.z),0)) == NO_ERROR))
        {sub_vectors(&dire,&v1,&v2);
         PlaneAndLineIntersection(&(view->gplane.base),&(view->gplane.normal_cosine),
               &v1,&dire,&base,&line_move_unit_ratio,&yes);
         GlobalPt(&(view->gplane),&base,&base);
         PRT2(printf("GlobalPt...base\n");pr_vector_3d_rec(&base))
         err = FormPlaneAndAdjust(result_view,&base,&(result_view->gplane.normal_cosine),
                 NULL,NULL,1);
        }
       else win_alarm(win->dwin->frame,2);
    }
   else
    {err = delete_cur_roi_curve(slice_roi);
     win_redisplay_all_curves(win);}
 set_win_not_busy(win);
 PRT2(printf("view_same_angle_cut err = %d\n",err);)
 return err;
}
******************************/


/*-------------------------------------------------------------------------
_3dAxisCutPlane - ???

similar to _3dDegreeCutPlane
-------------------------------------------------------------------------*/

int
_3dAxisCutPlane(result_view,view,cut_deg,x1,y1,x2,y2,use_refxy,rx1,ry1,rx2,ry2)
 struct view_rec *result_view,*view;
 float cut_deg,x1,y1,x2,y2,rx1,ry1,rx2,ry2;
 int use_refxy;
{
 int err,is_done;
 struct vector_3d_rec base,normal,norm,pt,pt1,pt2,pt3,pt4,pt5,pt6,pt7;
 float angle,fx1,fy1,fx2,fy2,dot,dot1;
 double rad;

 PRT12(printf("_3dAxisCutPlane...plane = %u\n",view))
 PRT12(printf("_3dAxisCutPlane..cut_deg = %f x1 = %f y1 = %f  x2 = %f y2 = %f\n",cut_deg,x1,y1,x2,y2);)
 PRT12(printf("..rx1 = %f ry1 = %f  rx2 = %f ry2 = %f\n",rx1,ry1,rx2,ry2);)
 if ((err = base_normal_after_axis_rotation(&(view->gplane),x1,y1,x2,y2,
          cut_deg,&base,&normal)) == NO_ERROR)
   {PRT(printf("_3dAxisCutPlane...base\n");pr_vector_3d_rec(&base))
    GlobalPt(&(view->gplane),&base,&base);
    PRT(printf("  GlobalPt...base\n");pr_vector_3d_rec(&base))
    if (use_refxy)
       {PlaneXYZToLocalXYZ(&(view->gplane),rx1,ry1,.0,&(pt.x),&(pt.y),&(pt.z),0);
        PlaneXYZToLocalXYZ(&(view->gplane),rx2,ry2,.0,&(pt1.x),&(pt1.y),&(pt1.z),0);
        PRT12(printf("pt...");pr_vector_3d_rec(&pt))
        PRT12(printf("pt1...");pr_vector_3d_rec(&pt1))
        RotatePlaneLine(&(view->gplane),rx1,ry1,rx2,ry2,
                90.0,&fx1,&fy1,&fx2,&fy2);
        PlaneXYZToLocalXYZ(&(view->gplane),fx1,fy1,.0,&(pt6.x),&(pt6.y),&(pt6.z),0);
        PlaneXYZToLocalXYZ(&(view->gplane),fx2,fy2,.0,&(pt7.x),&(pt7.y),&(pt7.z),0);
        sub_vectors(&norm,&pt6,&pt7);
        sub_vectors(&pt7,&pt6,&pt);
        dot = vector_dot_product(&norm,&pt7);
        setup_vector_3d_rec(&pt4,rx1,ry1,.0);
        setup_vector_3d_rec(&pt5,rx2,ry2,.0);
        sub_vector_3d(&pt4,&pt5);
       }
    FormPlaneNoDisplay(result_view,&base,&normal,NULL,&(view->gplane.rotate),1,1,NULL);
    if (use_refxy)
       for (is_done = 0; ;)
          {LocalXYZToPlaneXYZ(&(result_view->gplane),
                 pt.x,pt.y,pt.z,&(pt2.x),&(pt2.y),&(pt2.z));
           LocalXYZToPlaneXYZ(&(result_view->gplane),
                 pt1.x,pt1.y,pt1.z,&(pt3.x),&(pt3.y),&(pt3.z));
           PRT12(printf("pt2...");pr_vector_3d_rec(&pt2))
           PRT12(printf("pt3...");pr_vector_3d_rec(&pt3))
           pt2.z = .0;
           pt3.z = .0;
           sub_vector_3d(&pt2,&pt3);
           angle = degree_angle_vectors(&pt2,&pt4);
           PRT12(printf("angle = %f  rotate.z = %f\n",angle,result_view->gplane.rotate.z))
           if (angle != .0)
              {
               rad = radian(angle);
               PRT12(printf("=== rad = %f\n",rad))
               result_view->gplane.rotate.z += (float) rad;
               PRT12(printf("final rotate.z = %f\n",result_view->gplane.rotate.z))
               DefinePlaneTransformation(&(result_view->gplane));
              }
           if (is_done == 2) break;
           PlaneXYZToLocalXYZ(&(result_view->gplane),
                fx1,fy1,.0,&(pt6.x),&(pt6.y),&(pt6.z),0);
           sub_vectors(&pt7,&pt6,&pt);
           dot1 = vector_dot_product(&norm,&pt7);
           if (dot < .0) dot = -1.0;
             else if (dot > .0) dot = 1.0;
           if (dot1 < .0) dot1 = -1.0;
             else if (dot1 > .0) dot1 = 1.0;
           PRT12(printf("is_done = %d dot = %f...dot1 = %f\n",is_done,dot,dot1);)
           if (dot != dot1)
              {if (is_done == 1)
                  define_plane_orientation(&(result_view->gplane),GX_REFLECTION);
                 else define_plane_orientation(&(result_view->gplane),GYX_REFLECTION);
              }
           is_done += 1;
          }
    PRT12(printf("  rotate.z = %f\n",result_view->gplane.rotate.z))
    return AdjustOutputPlaneData(result_view,1,1,1,0);

   }
 PRT12(printf("\n"))
 return err;
}


/*-------------------------------------------------------------------------
_3d_axis_rotate_plane - ???
-------------------------------------------------------------------------*/

int
_3d_axis_rotate_plane(view,rot_angle)
 struct view_rec *view;
 int rot_angle;
{
 long x1,y1,x2,y2;
 unsigned long temp;
 int err;

 PRT4(printf("_3d_axis_rotate_plane...view = %u rot_angle = %d\n",view,rot_angle))

 if ((err = _3d_default_cur_line(view,&x1,&y1,&x2,&y2)) != NO_ERROR) 
    return err;
 PRT4(printf("_3d_axis_rotate_plane...1\n"))
 temp = view->img->win->image_display->control.which_cursor;
 if (rot_angle < 0) win_select_cursor(view->img->win->image_display,CURSOR_CLOCKWISE);
   else win_select_cursor(view->img->win->image_display,CURSOR_ANTICLOCKWISE);
 PRT(printf("_3d_axis_rotate_plane...plane = %u\n",view))


 PRT4(printf("_3d_axis_rotate_plane base = ");
         pr_vector_3d_rec(&(view->gplane.base));)
 PRT4(printf(" normal = ");pr_vector_3d_rec(&(view->gplane.normal));)
 err = _3dAxisCutPlane(view,view,(float) rot_angle,(float) x1,(float) y1,
        (float) x2,(float) y2,
        1,(float) x1,(float) y1,(float) x2,(float) y2);
 PRT4(printf("after base = ");pr_vector_3d_rec(&(view->gplane.base));)
 PRT(printf(" normal = ");pr_vector_3d_rec(&(view->gplane.normal));)
 PRT(printf("_3d_axis_rotate_plane...3\n"))
 win_select_cursor(view->img->win->image_display,temp);
 return err;
}


/*-------------------------------------------------------------------------
_3d_after_next_roi_proc - ???
-------------------------------------------------------------------------*/

void
_3d_after_next_roi_proc(win)
 struct image_display_window *win;
{
 bring_up_cur_win(win);
}


/*-------------------------------------------------------------------------
_3d_cur_curve - ???
-------------------------------------------------------------------------*/

int
_3d_cur_curve(win)
 struct image_display_window *win;
{
 struct slice_roi_rec *slice_roi;
 struct curve_rec *cur_curve;
 long x1,y1,x2,y2,err;
 struct img_buf_rec *img;
 struct view_rec *view;

 slice_roi = &(view->sl.slice_roi_win.slice_roi);
 if ((cur_curve = get_cur_curve(slice_roi)) == NULL)
    {if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
     if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
     if ((err = _3d_default_cur_line(view,&x1,&y1,&x2,&y2)) != NO_ERROR)
        return err;
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_resize_voxel_now1 - ???
-------------------------------------------------------------------------*/

int
win_resize_voxel_now1(win,use_dimxy,dimx,dimy,xpixel_size,ypixel_size,zpixel_size)
 struct image_display_window *win;
 int use_dimxy;
 unsigned long dimx,dimy;
 float xpixel_size,ypixel_size,zpixel_size;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 struct plane_3d_rec *plane,plane1;
 struct buf_3d_rec *_3d;
 float xratio,yratio,zratio,temp,temp1;
 long proj_buf_dimx,proj_buf_dimy;
 int err;

 PRT30(printf("win_resize_voxel_now...wid = %s x = %f y = %f z = %f\n",
           win->owner->wid,xpixel_size,ypixel_size,zpixel_size))
 PRT30(printf("win_resize_voxel_now...use_dimxy = %d dimx = %d dimy = %d\n",
           use_dimxy,dimx,dimy))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 if (view == NULL) return CANCEL;
 find_file_3d(img->file,view->id,&_3d);
 if (_3d == NULL) return CANCEL;
 plane = &(view->gplane);

 xratio = plane->coord_ratio.x * _3d->xpixel_size;
 yratio = plane->coord_ratio.y * _3d->ypixel_size;
 zratio = plane->coord_ratio.z * _3d->zpixel_size;
 PRT30(printf("win_resize_voxel_now...old xratio = %f y = %f z = %f\n",
           xratio,yratio,zratio))
 PRT30(printf("coord_ratio x = %f y = %f z = %f\n",
           plane->coord_ratio.x,plane->coord_ratio.y,plane->coord_ratio.z))
 PRT30(printf("pixel_size x = %f y = %f z = %f\n",
           xpixel_size,ypixel_size,zpixel_size))
 xratio -= xpixel_size;
 yratio -= ypixel_size;
 zratio -= zpixel_size;
 if (xratio < .0) xratio = -xratio;
 if (yratio < .0) yratio = -yratio;
 if (zratio < .0) zratio = -zratio;
 if ((xratio <= .000001) && (yratio <= .000001) &&
     (zratio <= .000001))
    {PRT6(printf("same pixel size...\n");)
     return NO_ERROR;}
 win_unco_register_all_group_wids(win,1,1);

 PRT30(printf("3d->pixel_size x = %f y = %f z = %f\n",
           _3d->xpixel_size,_3d->ypixel_size,_3d->zpixel_size))
 xratio = xpixel_size / _3d->xpixel_size;
 yratio = ypixel_size / _3d->ypixel_size;
 zratio = zpixel_size / _3d->zpixel_size;

 if (!use_dimxy)
    {PRT30(printf("not use_dimxy...\n"))
     temp = (plane->global_end.x - plane->global_start.x + 1.0) / xratio;
     temp1 = (plane->global_end.y - plane->global_start.y + 1.0) / yratio;
     if (temp < temp1) temp = temp1;
     temp1 = (plane->global_end.z - plane->global_start.z + 1.0) / zratio;
     if (temp < temp1) temp = temp1;
     proj_buf_dimx = proj_buf_dimy = (long) temp;}
   else 
    {proj_buf_dimx = dimx;
     proj_buf_dimy = dimy;}

 PRT10(printf("global st x = %f end x = %f\n",
           plane->global_start.x,plane->global_end.x))
 PRT10(printf("global st y = %f end y = %f\n",
           plane->global_start.y,plane->global_end.y))
 PRT10(printf("global st z = %f end z = %f\n",
           plane->global_start.z,plane->global_end.z))
 PRT10(printf("===> xratio = %f y = %f z = %f dimx = %d dimy = %d\n",
      xratio,yratio,zratio,proj_buf_dimx,proj_buf_dimy);)
 PRT30(printf("....orig bas...ratio center\n");)
 PRT30(pr_vector_3d_rec(&(plane->base));)
 PRT30(pr_vector_3d_rec(&(plane->coord_ratio));)
 PRT30(pr_vector_3d_rec(&(plane->center));)
 PRT30(printf("proj_buf_dimx = %d y = %d...\n",plane->proj_buf_dimx,plane->proj_buf_dimy);)
 PRT30(printf("trans_proj_dimx = %d y = %d...\n",plane->trans_proj_dimx,plane->trans_proj_dimy);)
 PRT30(printf("proj_dimx = %d y = %d...\n",plane->proj_dimx,plane->proj_dimy);)
 PRT30(printf("actual_proj_dimx = %d y = %d...\n",plane->actual_proj_dimx,plane->actual_proj_dimy);)

 plane1.base.x = plane->base.x * plane->coord_ratio.x / xratio;
 plane1.base.y = plane->base.y * plane->coord_ratio.y / yratio;
 plane1.base.z = plane->base.z * plane->coord_ratio.z / zratio;
 plane1.center.x = plane->center.x * plane->coord_ratio.x / xratio;
 plane1.center.y = plane->center.y * plane->coord_ratio.y / yratio;
 plane1.center.z = plane->center.z * plane->coord_ratio.z / zratio;
 PtNormalPlane(&plane1,plane1.base.x,plane1.base.y,plane1.base.z,
             plane->normal.x,plane->normal.y,plane->normal.z,
             plane->global_start.x,plane->global_end.x,
             plane->global_start.y,plane->global_end.y,
             plane->global_start.z,plane->global_end.z,
             proj_buf_dimx,proj_buf_dimy,
             &(plane->translate),&(plane->scale),&(plane->rotate),
             &(plane1.center),
             plane->obl_deg,plane->obj_proj_deg,
             xratio,yratio,zratio,&(plane->global),0,
             (int) plane->status & PLANE_ADJUST_TO_CENTER,
             view->more_status & VIEW_3D_APPROX);

 set_win_busy(win);
 err = win_new_view(win,&plane1);

 PRT30(printf("....new bas...ratio center\n");)
 PRT30(pr_vector_3d_rec(&(plane->base));)
 PRT30(pr_vector_3d_rec(&(plane->coord_ratio));)
 PRT30(pr_vector_3d_rec(&(plane->center));)
 PRT30(printf("proj_buf_dimx = %d y = %d...\n",plane->proj_buf_dimx,plane->proj_buf_dimy);)
 PRT30(printf("trans_proj_dimx = %d y = %d...\n",plane->trans_proj_dimx,plane->trans_proj_dimy);)
 PRT30(printf("proj_dimx = %d y = %d...\n",plane->proj_dimx,plane->proj_dimy);)
 PRT30(printf("actual_proj_dimx = %d y = %d...\n",plane->actual_proj_dimx,plane->actual_proj_dimy);)


 set_win_not_busy(win);
 if (err != NO_ERROR) return err;

 PRT30(printf("win_resize_voxel_now...end\n\n");)
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_resize_voxel1 - ???
-------------------------------------------------------------------------*/

int
win_resize_voxel1(win,dp_to_win,use_dimxy,dimx,dimy,
                 xpixel_size,ypixel_size,zpixel_size,resize_wids,
                 next_proc,conti_proc,arg1,arg2)
 struct image_display_window *win,*dp_to_win;
 int use_dimxy;
 unsigned long dimx,dimy;
 float *xpixel_size,*ypixel_size,*zpixel_size;
 struct strs_rec *resize_wids;
 int (*next_proc)();
 int (*conti_proc)();
 void *arg1,*arg2;
{
 int err;

 PRT30(printf("win_resize_voxel win = %u dp_to_win = %u...x = %f y = %f z = %f\n",
           win,dp_to_win,*xpixel_size,*ypixel_size,*zpixel_size))
 PRT30(printf("win_resize_voxel use_dimxy = %d.. dimx = %d dimy = %d\n",
           use_dimxy,dimx,dimy))
 if (dp_to_win == NULL) return NO_ERROR;
 if ((err = win_resize_voxel_now1(dp_to_win,use_dimxy,dimx,dimy,
               *xpixel_size,*ypixel_size,*zpixel_size))
      != NO_ERROR)
    ShowMsgStrs(dp_to_win->dwin->frame,0,err,0,3,
               "Error occurred when",
               "resizing the image voxels...",
               OK,NULL,0);
   else err = next_proc(win,use_dimxy,dimx,dimy,
                    xpixel_size,ypixel_size,zpixel_size,resize_wids,
                    conti_proc,arg1,arg2);
 return err;
}


/*-------------------------------------------------------------------------
win_move_mouse_to_cur_roi_wid - ???
-------------------------------------------------------------------------*/

int
win_move_mouse_to_cur_roi_wid(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view,*view1;
 struct roi_rec *roi;
 Rect *rr;
 struct vector_3d_rec pt;

 PRT(printf("win_move_mouse_to_cur_roi_wid..\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (((view = img->cur_slice->slice->view) != NULL) &&
     ((roi = get_cur_roi(&(view->sl.slice_roi_win.slice_roi))) != NULL) &&
     ((view1 = find_any_view_rec(view->file,roi->label)) != NULL) &&
     (view1->img->win->image_display != NULL))
    {if (view == view1) return NO_ERROR;
     rr = (Rect *) xv_get(canvas_paint_window(win->dwin->frame_canvas.canvas),
                    WIN_MOUSE_XY);
     PRT(printf("0...r_left = %d top = %d\n",rr->r_left,rr->r_top);)
     PlaneXYZToLocalXYZ(&(view->gplane),(float) rr->r_left,
                (float) rr->r_top,.0,&(pt.x),&(pt.y),&(pt.z),0);
     PRT(printf("1...pt\n");pr_vector_3d_rec(&pt))
     GlobalPt(&(view->gplane),&pt,&pt);
     PRT(printf("2...pt\n");pr_vector_3d_rec(&pt))
     LocalPt(&(view1->gplane),&pt,&pt);
     PRT(printf("3...pt\n");pr_vector_3d_rec(&pt))
     /* Removed final argument '0' from the next line, since the
	called function does not expect it.  -PWH 19990312 */
     LocalXYZToPlaneXYZ(&(view1->gplane),pt.x,pt.y,pt.z,
                &(pt.x),&(pt.y),&(pt.z));
     PRT(printf("4...pt\n");pr_vector_3d_rec(&pt))
     win_move_mouse_to(view1->img->win->image_display,
                (long) pt.x,(long) pt.y);
     return NO_ERROR;
    }
 win_alarm(win->dwin->frame,2);
 PRT(printf("win_move_mouse_to_cur_roi_wid..end\n"))
 return CANCEL;
}
