/****************************************************************************
3d_more_plane_menu.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 3d_more_plane_menu.c,v 1.9 1999/07/07 17:41:13 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "buf_3d_rec.h"
#include "geometry.h"
#include "mri_format.h"
#include "nria_procedures.h"


#if 0
#   define TRACE(x) x; fflush(stdout);
#   define PRT(x) x; fflush(stdout);
#   define PRT1(x) x; fflush(stdout);
#   define PRT2(x) x; fflush(stdout);
#   define PRT3(x) x; fflush(stdout);
#   define PRT4(x) x; fflush(stdout);
#else
#   define TRACE(x)
#   define PRT(x)
#   define PRT1(x)
#   define PRT2(x)
#   define PRT3(x)
#   define PRT4(x)
#endif


/* External functions */
/***
extern int DpAllCoRegPlanes();
extern int OutputPlaneData();
extern unsigned long enter_3d_more_plane();
extern unsigned long ULongRound();
extern struct img_buf_rec *win_rec_cur_img_buf();
extern char *win_rec_win_id_title();
extern double cos_degree();
extern struct roi_rec *get_cur_roi();
extern struct roi_rec *get_roi();
extern int win_redisplay_all_curves();
extern int pr_xyztoplane();
***/


/* ??? */
#define CLEAN_UP_MORE_PLANE 0
#define SETUP_MORE_PLANE 1
#define GET_ALL_MORE_PLANE_PTR 2


/* Local structures */
struct more_plane_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item /*cur_plane_msg,*/fn,dir,x,y,rel_abs,for_which,
               center_choice,image_center,plane_center,cur_center;
   };

struct all_more_plane_recs
   {
    int num_3ds;
    struct more_plane_rec **_3ds;
   };


/* Local functions */
void init_more_plane_rec(struct more_plane_rec *_3d);
void free_more_plane_rec(struct more_plane_rec *_3d);
void init_all_more_plane_recs(struct all_more_plane_recs *all_3ds);
void _3d_more_plane_done_proc(Frame frame);
void image_center(struct view_rec *view, struct vector_3d_rec *center);
void dp_center_msg(struct more_plane_rec *_3d);
int view_move_center(struct view_rec *view,
    struct vector_3d_rec *new_rel_globalcenter,
    struct vector_3d_rec *old_rel_globalcenter, int is_rel, int is_trigger_co,
    int is_trigger_lock, int is_dp);
int view_move_plane(struct view_rec *view, struct matrix_3d_rec *trans,
    struct matrix_3d_rec *coplanetoxyz);
int WinMove3dPlane(struct image_display_window *win, int is_rotated,
    struct matrix_2d_rec *rotate_mat, int x, int y, int is_rel,
    int is_cur_group, int is_dp);
void change_center_proc(Panel_item item, Event *event);
void plane_pt_proc(Panel_item item, Event *event);
void delete_plane_pt_proc(Panel_item item, Event *event);
int delete_pt_cursor_rois_proc(struct view_rec *view);
int win_form_plane_by_3_pts(struct image_display_window *win);
void form_plane_by_3_pts_proc(Panel_item item, Event *event);
int win_check_select_3d_pt_cursor(struct view_rec *view,
    unsigned long which_cursor);
int win_3d_delete_last_cursor_pt(struct image_display_window *win);
int _3dPtAction(struct view_rec *view);
int win_enable_3d_pt_mode(struct image_display_window *win);
int setup_more_plane_rec(struct more_plane_rec *_3d,
    struct image_display_window *win);
struct more_plane_rec *find_more_plane_rec(struct all_more_plane_recs *all_3ds,
    struct image_display_window *win);
void update_more_plane_menu(struct image_display_window *win);
unsigned long enter_3d_more_plane(struct image_display_window *win,
    int status);



/*-------------------------------------------------------------------------
init_more_plane_rec - ???
-------------------------------------------------------------------------*/

void
init_more_plane_rec(_3d)
 struct more_plane_rec *_3d;
{
 _3d->status = 0;
 _3d->win = NULL;
 _3d->frame  = 0;
}


/*-------------------------------------------------------------------------
free_more_plane_rec - ???
-------------------------------------------------------------------------*/

void
free_more_plane_rec(_3d)
 struct more_plane_rec *_3d;
{
 struct all_more_plane_recs *all_3ds;

 if (_3d->frame != 0)
    {
     destroy_all_subframes(_3d->frame);
     xv_destroy_safe(_3d->frame);}
 all_3ds = (struct all_more_plane_recs *) enter_3d_more_plane(NULL,
            GET_ALL_MORE_PLANE_PTR);
 c_free(_3d);
 DropHandleAryPtr(&(all_3ds->_3ds),&(all_3ds->num_3ds),_3d);
}


/*-------------------------------------------------------------------------
init_all_more_plane_recs - ???
-------------------------------------------------------------------------*/

void
init_all_more_plane_recs(all_3ds)
 struct all_more_plane_recs *all_3ds;
{
 all_3ds->num_3ds = 0;
 all_3ds->_3ds = NULL;
}


/*-------------------------------------------------------------------------
_3d_more_plane_done_proc - ???
-------------------------------------------------------------------------*/

void
_3d_more_plane_done_proc(frame)
 Frame frame;
{
 struct more_plane_rec *_3d;

 _3d = (struct more_plane_rec *)
                     xv_get(frame,WIN_CLIENT_DATA);
 free_more_plane_rec(_3d);
}


/*********************
show_cur_plane_params1(_3d)
 struct more_plane_rec *_3d;
{
 char str[100];
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 sprintf(str,"PLANE = %s",view->sl.slice.img_label);
 xv_set(_3d->cur_plane_msg,PANEL_LABEL_STRING,str,0);
}
**********************/


/*-------------------------------------------------------------------------
image_center - ???
-------------------------------------------------------------------------*/

void
image_center(view,center)
 struct view_rec *view;
 struct vector_3d_rec *center;
{
 struct buf_3d_rec *_3d1;
 int err;

 if ((view == NULL) ||
     ((err = find_file_3d(view->file,view->id,&_3d1)) != NO_ERROR))
    {setup_vector_3d_rec(center,.0,.0,.0);
     return;}
 setup_vector_3d_rec(center,(float) (_3d1->dimx - 1.0) / 2.0,
       (float) (_3d1->dimy - 1.0)  / 2.0,(float) (_3d1->dimz - 1.0) / 2.0);
}


/*-------------------------------------------------------------------------
dp_center_msg - ???
-------------------------------------------------------------------------*/

void
dp_center_msg(_3d)
 struct more_plane_rec *_3d;
{
 struct view_rec *view;
 struct img_buf_rec *img;
 struct vector_3d_rec center,base;
 char str1[60];

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 view = img->cur_slice->slice->view;
 image_center(view,&center);

 LocalPt(&(view->gplane),&center,&center);
 sprintf(str1,"3D IMAGE CENTER x/y/z = %-.2f/%-.2f/%-.2f",
            center.x,center.y,center.z);
 xv_set(_3d->image_center,PANEL_LABEL_STRING,str1,0);

/* GlobalPt(&(view->gplane),&(view->gplane.center),&base);*/
 base = view->gplane.center;
 sprintf(str1,"PLANE IMAGE CENTER x/y/z = %-.2f/%-.2f/%-.2f",
            base.x,base.y,base.z);
 xv_set(_3d->plane_center,PANEL_LABEL_STRING,str1,0);
/* GlobalPt(&(view->gplane),&(view->gplane.base),&base);*/
 base = view->gplane.base;
 sprintf(str1,"PLANE CENTER x/y/z = %-.2f/%-.2f/%-.2f",
            base.x,base.y,base.z);
 xv_set(_3d->cur_center,PANEL_LABEL_STRING,str1,0);

}


/*-------------------------------------------------------------------------
view_move_center - ???
-------------------------------------------------------------------------*/

int
view_move_center(view,new_rel_globalcenter,old_rel_globalcenter,is_rel,
                 is_trigger_co,is_trigger_lock,is_dp)
 struct view_rec *view;
 struct vector_3d_rec *new_rel_globalcenter,*old_rel_globalcenter;
 int is_rel,is_trigger_co,is_trigger_lock,is_dp;
{
 view->last_gplane = view->gplane;
 view->status |= PLANE_LAST_PLANE_VALID;
 PRT2(printf("is_dp = %d view_move...wid = %s\n",is_dp,view->wid);)
 move_center(&(view->gplane),new_rel_globalcenter,old_rel_globalcenter,is_rel);
 if (is_dp)
    return OutputPlaneData(view,is_trigger_co,is_trigger_lock);
 return NO_ERROR;
}


/********************
WinChange3dCenterByPlanexy(win,x,y,is_rel,is_cur_group,is_dp)
 struct image_display_window *win;
 int x,y;
 int is_rel,is_cur_group,is_dp;
{
 struct view_rec *view;
 struct img_buf_rec *img;
 struct vector_3d_rec center,old,v1;
 int err;

 PRT3(printf("\n\nWinChange3dCenterByPlanexy ...x = %d y = %d\n",x,y);)
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 PRT3(run_any_file_views_proc(view,pr_xyztoplane);)

 move_center_by_planexyz(&(view->gplane),(float) x,(float) y,.0,&center,1);

 GlobalPt(&(view->gplane),&center,&center);
 GlobalPt(&(view->gplane),&(view->gplane.base),&old);
 if (is_cur_group)
    err = run_next_view_proc(view,view_move_center,&center,&old,is_rel,
                 0,0,0);
   else err = view_move_center(view,&center,&old,is_rel,
                       0,0,is_dp);
 if (err == NO_ERROR)
    {
     view_auto_adjust_reco_register(view,is_cur_group);
     if (is_dp)
        if (is_cur_group)
           DpAllCoRegPlanes(view,1,1,1,1,1);
          else OutputPlaneData(view,1,1);
    }
 PRT3(printf(" WinChange3dCenterByPlanexy ...err = %d\n",err);)
 return err;
}
**********************/


/*-------------------------------------------------------------------------
view_move_plane - ???
-------------------------------------------------------------------------*/

int
view_move_plane(view,trans,coplanetoxyz)
 struct view_rec *view;
 struct matrix_3d_rec *trans;
 struct matrix_3d_rec *coplanetoxyz;
{
 struct matrix_3d_rec xyztoplane;
 struct vector_3d_rec base,normal;

 PRT4(printf("view_move_plane...view->wid = %s\n",view->wid))
 PRT4(printf(" trans...\n"))
 PRT4(pr_3d_matrix(trans));
 PRT4(printf(" coplanetoxyz...\n"))
 PRT4(pr_3d_matrix(coplanetoxyz));

 mult_3d_matrix(&xyztoplane,&(view->gplane.xyztoplane),trans);
 CoRegBaseAndNormal(&(view->gplane.xyztoplane),coplanetoxyz,
            &(view->gplane.base),&(view->gplane.normal_cosine),
            &base,&normal);
 PRT4(printf("view_rec xyztoplane...\n"))
 PRT4(pr_3d_matrix(&xyztoplane));
 PRT4(printf("old view xyztoplane...\n"))
 PRT4(pr_3d_matrix(&(view->gplane.xyztoplane)));
 FormPlaneNoDisplay(view,&base,&normal,NULL,&(view->gplane.rotate),
                                0,0,&xyztoplane);
 PRT4(printf("new view xyztoplane...\n"))
 PRT4(pr_3d_matrix(&(view->gplane.xyztoplane)));
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinMove3dPlane - ???
-------------------------------------------------------------------------*/

int
WinMove3dPlane(win,is_rotated,rotate_mat,x,y,is_rel,is_cur_group,is_dp)
 struct image_display_window *win;
 struct matrix_2d_rec *rotate_mat;
 int is_rotated,x,y;
 int is_rel,is_cur_group,is_dp;
{
 struct view_rec *view;
 struct img_buf_rec *img;
 struct vector_3d_rec center,old,v1;
 struct matrix_3d_rec trans,mat,xyztoplane,coplanetoxyz;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 PRT3(run_any_file_views_proc(view,pr_xyztoplane);)
 PRT4(printf("\n\nWinChange3dCenterByPlanexy ...wid = %s is_cur_group = %d is_rotated = %d x = %d y = %d\n",view->wid,is_cur_group,is_rotated,x,y);)

 if (is_rotated) 
    {
     LocalXYZToPlaneXYZ(&(view->gplane),view->gplane.base.x,
          view->gplane.base.y,view->gplane.base.z,&(v1.x),&(v1.y),&(v1.z));


     matrix_2d_to_3d(&trans,rotate_mat);
     PRT4(printf("rotate_mat = ...\n"); pr_3d_matrix(&trans))
/*
     translate_3d_matrix(&trans,v1.x,v1.y,.0);
     PRT4(printf("rotate_mat move to center = ...\n"); pr_3d_matrix(&trans))
     setup_vector_3d_rec(&v1,trans.buf[0][3] + (float) x,
            trans.buf[1][3] + (float) y,.0);
     drop_3d_matrix_translation(&trans);
     PRT4(printf("new rotate_mat = ...\n"); pr_3d_matrix(&trans))
*/
    }
   else setup_vector_3d_rec(&v1,(float) x,(float) y,.0);

 PRT4(printf("rel center = ...\n"); pr_vector_3d_rec(&v1))
/*
 if ((v1.x != .0) || (v1.y != 0))
*/
 if (is_rotated) 
    {
     PRT4(printf("base plane xyz = ...\n"); pr_vector_3d_rec(&v1))
     setup_translate_3d_matrix(&mat,v1.x,v1.y,v1.z);
     mult_3d_matrix(&trans,&trans,&mat);
     setup_translate_3d_matrix(&mat,-v1.x,-v1.y,-v1.z);
     mult_3d_matrix(&trans,&mat,&trans);
     PRT4(printf("new rotate_mat move to center = ...\n"); pr_3d_matrix(&trans))

     mult_3d_matrix(&xyztoplane,&trans,&(view->gplane.xyztoplane));
     inverse_4d_matrix(&coplanetoxyz,&xyztoplane);
     mult_3d_matrix(&trans,&(view->gplane.planetoxyz),&xyztoplane);
     PRT4(printf(" xyztoplane...\n"))
     PRT4(pr_3d_matrix(&xyztoplane));
     if (is_cur_group)
        err = run_next_view_proc(view,view_move_plane,&trans,&coplanetoxyz,
				 0,0,0,0);
     else err = view_move_plane(view,&trans,&coplanetoxyz);
    }

 if ((x != 0) || (y != 0))
    {
    /* Removed final argument '1' from the call below, because the called
       function does not expect it.  -PWH 19990312*/
     move_center_by_planexyz(&(view->gplane),(float) x,(float) y,.0,&center);
     PRT4(printf("move_center_by_planexyz...\n"))
     PRT4(pr_vector_3d_rec(&center);)
     GlobalPt(&(view->gplane),&center,&center);
     GlobalPt(&(view->gplane),&(view->gplane.base),&old);
     if (is_cur_group)
        err = run_next_view_proc(view,view_move_center,&center,&old,is_rel,0,0,0);
       else err = view_move_center(view,&center,&old,is_rel,0,0,is_dp);
   }

 if (err == NO_ERROR) {
     /* FIXME:  Is the argument "is_cur_group" below supposed to be
	significant?  The function being called has no second argument.
        -PWH 19990517 */
     view_auto_adjust_reco_register(view /*,is_cur_group*/);
     if (is_dp)
        if (is_cur_group)
           DpAllCoRegPlanes(view,1,1,1,1,1);
          else OutputPlaneData(view,1,1);
    }
 PRT4(printf(" WinChange3dCenterByPlanexy ...err = %d\n",err);)
 return err;
}


/*-------------------------------------------------------------------------
change_center_proc - ???
-------------------------------------------------------------------------*/

void
change_center_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct more_plane_rec *_3d;
 int center_choice,rel_abs,for_which,x,y;
 struct view_rec *view;
 struct img_buf_rec *img;
 struct vector_3d_rec center,old;
 int is_rel,err;

 PRT1(printf(" change_center_proc ...\n");)
 _3d = (struct more_plane_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 view = img->cur_slice->slice->view;
 center_choice = (int) xv_get(_3d->center_choice,PANEL_VALUE);
 PRT1(printf(" change_center_proc ...center_choice = %d\n",center_choice);)
 if (center_choice == 0)
    {if (img->file->slice_info.num_3d_sampled_pts < 1)
        {notice_prompt(_3d->dwin->frame,(Event *) NULL,
           NOTICE_MESSAGE_STRINGS,"No plane point sampled yet !!! ",
                            "Image center will not be moved !!!",0,
                            NOTICE_BUTTON_YES,"OK !",0);
         return;
        }
     center = img->file->slice_info.sampled_pts[0];
    }
   else if (center_choice == 1)
    image_center(view,&center);
   else
    {x = (int) xv_get(_3d->x,PANEL_VALUE);
     y = (int) xv_get(_3d->y,PANEL_VALUE);
     if ((x == 0) && (y == 0)) return;
     move_center_by_planexyz(&(view->gplane),(float) x,(float) y,.0,&center);
     GlobalPt(&(view->gplane),&center,&center);
     PRT1(printf(" G center ...");pr_vector_3d_rec(&center))
    }
 PRT1(printf(" change_center_proc ...1\n");)
 rel_abs = (int) xv_get(_3d->rel_abs,PANEL_VALUE);
 if (rel_abs == 0)
    {if (center_choice == 0) old = img->file->slice_info.sampled_pt0_base;
       else GlobalPt(&(view->gplane),&(view->gplane.base),&old);
     is_rel = 1;
    }
   else is_rel = 0;
 for_which = (int) xv_get(_3d->for_which,PANEL_VALUE);
 if (for_which == 0)
    {if ((err = run_next_view_proc(view,view_move_center,&center,
                      &old,is_rel,0,0,0)) == NO_ERROR)
	/* FIXME:  Is the ",1" below supposed to be significant?
           The routine called has no 2nd argument.  -PWH 19990517 */
        {view_auto_adjust_reco_register(view /*,1*/);
         DpAllCoRegPlanes(view,1,1,1,1,1);
        }
    }
   else view_move_center(view,&center,&old,is_rel,0,1,1);
 xv_set(_3d->x,PANEL_VALUE,0,0);
 xv_set(_3d->y,PANEL_VALUE,0,0);
}


/*-------------------------------------------------------------------------
plane_pt_proc - ???
-------------------------------------------------------------------------*/

void
plane_pt_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct more_plane_rec *_3d;

 _3d = (struct more_plane_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win_select_cursor(_3d->win,CURSOR_3D_PT1);
 win_set_mouse_at_center(_3d->win->dwin->frame);
}


/*-------------------------------------------------------------------------
delete_plane_pt_proc - ???
-------------------------------------------------------------------------*/

void
delete_plane_pt_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct more_plane_rec *_3d;

 _3d = (struct more_plane_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win_3d_delete_last_cursor_pt(_3d->win);
}


/*-------------------------------------------------------------------------
delete_pt_cursor_rois_proc - ???
-------------------------------------------------------------------------*/

int
delete_pt_cursor_rois_proc(view)
 struct view_rec *view;
{
 struct image_display_window *win;
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 int yes;

 if (view->img->win == NULL) return CANCEL;
 win = view->img->win->image_display;
 slice_roi = &(win->control.sroi.sroi_win->slice_roi);
 if ((roi = get_roi(slice_roi,_3D_PT1_LABEL)) != NULL)
    {delete_roi(slice_roi,roi);
     yes = 1;}
   else yes = 0;
 if ((roi = get_roi(slice_roi,_3D_PT2_LABEL)) != NULL)
    {delete_roi(slice_roi,roi);
     yes = 1;}
 if ((roi = get_roi(slice_roi,_3D_PT3_LABEL)) != NULL)
    {delete_roi(slice_roi,roi);
     yes = 1;}
 if (yes)
     win_execute_proc_to_multiple_wins(win,win_redisplay_all_curves,
				       0,0,0,0,0);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_form_plane_by_3_pts - ???
-------------------------------------------------------------------------*/

int
win_form_plane_by_3_pts(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 struct vector_3d_rec v1,v2,v3,normal;
 struct vector_3d_rec *pt1,*pt2,*pt3;
 int err;

 PRT(printf("---win_form_plane_by_3_pts... \n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 PRT(printf("---num_3d_sampled_pts = %d... \n",
          img->file->slice_info.num_3d_sampled_pts))
 if (img->file->slice_info.num_3d_sampled_pts != 3) 
    {win_alarm(win->dwin->frame,2);
     return NO_ERROR;}
 view = img->cur_slice->slice->view;
 pt1 = &(img->file->slice_info.sampled_pts[0]);
 pt2 = &(img->file->slice_info.sampled_pts[1]);
 pt3 = &(img->file->slice_info.sampled_pts[2]);

 PRT(printf("form_plane_by_3_pts ...0\n"))
 PRT(printf("pt1 ...\n");pr_vector_3d_rec(pt1))
 PRT(printf("pt2 ...\n");pr_vector_3d_rec(pt2))
 PRT(printf("pt3 ...\n");pr_vector_3d_rec(pt3))
 sub_vectors(&v1,pt2,pt1);
 if (colinear_3_pts(pt1->x,pt1->y,pt1->z,
         pt2->x,pt2->y,pt2->z,pt3->x,pt3->y,pt3->z))
    {v3 = view->gplane.base;
     GlobalPt(&(view->gplane),&v3,&v3);
     if (colinear_3_pts(v3.x,v3.y,v3.z,
         pt2->x,pt2->y,pt2->z,pt3->x,pt3->y,pt3->z))
        {PlaneXYZToLocalXYZ(&(view->gplane),1.0,1.0,.0,
                   &(v3.x),&(v3.y),&(v3.z),0);
         GlobalPt(&(view->gplane),&v3,&v3);
         if (colinear_3_pts(v3.x,v3.y,v3.z,
                pt2->x,pt2->y,pt2->z,pt3->x,pt3->y,pt3->z))
            {normal = view->gplane.normal;
             PRT(printf("form_plane_by_3_pts ...1\n"))
            }
           else
            {sub_vectors(&v2,&v3,pt1);
             vector_cross_product(&normal,&v1,&v2);
             PRT(printf("form_plane_by_3_pts ...2\n"))
            }
        }
       else
        {sub_vectors(&v2,&v3,pt1);
         vector_cross_product(&normal,&v1,&v2);
         PRT(printf("form_plane_by_3_pts ...3\n"))
        }
    }
   else
    {
     sub_vectors(&v2,pt3,pt1);
     vector_cross_product(&normal,&v1,&v2);
     PRT(printf("form_plane_by_3_pts ...4\n"))
    }
 if ((err = FormPlane(view,pt1,&normal,NULL,NULL,1,1,NULL)) == NO_ERROR)
    {img->file->slice_info.num_3d_sampled_pts = 0;
     run_file_views_proc(view,delete_pt_cursor_rois_proc,0,0);
    }
 PRT(printf("normal ...3\n");pr_vector_3d_rec(&normal))
 PRT(printf("form_plane_by_3_pts err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
form_plane_by_3_pts_proc - ???
-------------------------------------------------------------------------*/

void
form_plane_by_3_pts_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct more_plane_rec *_3d;

 PRT(printf("---form_plane_by_3_pts_proc \n"))
 _3d = (struct more_plane_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win_form_plane_by_3_pts(_3d->win);
 PRT(printf("---form_plane_by_3_pts_proc...end\n"))
}


/*-------------------------------------------------------------------------
win_check_select_3d_pt_cursor - ???
-------------------------------------------------------------------------*/

int
win_check_select_3d_pt_cursor(view,which_cursor)
 struct view_rec *view;
 unsigned long which_cursor;
{
 struct image_display_window *win;

 if (view->img->win == NULL) return CANCEL;
 win = view->img->win->image_display;
 PRT(printf("win_check_select_3d_pt_cursor...which_cursor = %d = %d\n",which_cursor,
        win->control.which_cursor);)
 if ((win->control.which_cursor == CURSOR_3D_PT1) ||
     (win->control.which_cursor == CURSOR_3D_PT2) ||
     (win->control.which_cursor == CURSOR_3D_PT3))
    {PRT(printf("win_check_select_3d_pt_cursor...1\n");)
     win_select_cursor(win,which_cursor);}
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_3d_delete_last_cursor_pt - ???
-------------------------------------------------------------------------*/

int
win_3d_delete_last_cursor_pt(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 PRT(printf("---win_3d_delete_last_cursor_pt num_3d_sampled_pts = %d\n",
          img->file->slice_info.num_3d_sampled_pts))
 if (img->file->slice_info.num_3d_sampled_pts == 0) return NO_ERROR;
 img->file->slice_info.num_3d_sampled_pts -= 1;
 view = img->cur_slice->slice->view;
 run_file_views_proc(view,win_check_select_3d_pt_cursor,CURSOR_3D_PT1,0);
 PRT(printf("---win_3d_delete_last_cursor_pt end\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
_3dPtAction - ???
-------------------------------------------------------------------------*/

int
_3dPtAction(view)
 struct view_rec *view;
{ 
 unsigned long which_cursor;
 struct slice_roi_rec *slice_roi;
 struct image_display_window *win;
 long x1,y1;
 struct vector_3d_rec *v1;
 long indx;

 PRT(printf("---3dPtAction \n"))
 if (view->img->win == NULL) return CANCEL;
 win = view->img->win->image_display;
 which_cursor = win->control.which_cursor;
 slice_roi = &(view->sl.slice_roi_win.slice_roi);
 indx = -1;
 if (which_cursor == CURSOR_3D_PT1)
    {
     if (LongCurPtByIndx(slice_roi,0,&x1,&y1,NULL) == NO_ERROR)
        {which_cursor = CURSOR_3D_PT2;
         indx = 0;
        }
    }
   else if (which_cursor == CURSOR_3D_PT2)
    {if (LongCurPtByIndx(slice_roi,0,&x1,&y1,NULL) == NO_ERROR)
        {indx = 1;
         which_cursor = CURSOR_3D_PT3;
        }
    }
   else if (LongCurPtByIndx(slice_roi,0,&x1,&y1,NULL) == NO_ERROR)
    {indx = 2;
     which_cursor = CURSOR_CUT;
    }
 PRT(printf("_3dPtAction...indx = %d\n",indx))
 if (indx >= 0)
    {view->img->file->slice_info.num_3d_sampled_pts += 1;
     PRT(printf(" x1 = %d y1 = %d\n",x1,y1))
     v1 = &(view->img->file->slice_info.sampled_pts[indx]);
     PlaneXYZToLocalXYZ(&(view->gplane),(float) x1,(float) y1,.0,
             &(v1->x),&(v1->y),&(v1->z),0);
     PRT(printf("_3dPtAction...LOCAL\n"))
     PRT(pr_vector_3d_rec(v1))
     GlobalPt(&(view->gplane),v1,v1);
     if (indx == 0)
        {view->img->file->slice_info.sampled_pt0_base = 
                       view->gplane.base;
        }

     PRT(printf("_3dPtAction..***.GlobalPt\n"))
     PRT(pr_vector_3d_rec(v1))
     run_file_views_proc(view,win_check_select_3d_pt_cursor,which_cursor,0);
    }
         
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_enable_3d_pt_mode - ???
-------------------------------------------------------------------------*/

int
win_enable_3d_pt_mode(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 int err;
 char *str;

 PRT(printf("win_enable_3d_pt_mode...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 set_allowable_pen_types(&(win->control),DRAW_LINE);
 set_max_input_curve_pts(&(win->control),1);
 set_proc_upon_input_done(&(win->control),_3dPtAction,view);
 win_enable_draw_pen(win);
 if (win->control.which_cursor == CURSOR_3D_PT1)
    str = _3D_PT1_LABEL;
   else if (win->control.which_cursor == CURSOR_3D_PT2)
    str = _3D_PT2_LABEL;
   else if (win->control.which_cursor == CURSOR_3D_PT3)
    str = _3D_PT2_LABEL;
 slice_roi = &(win->control.sroi.sroi_win->slice_roi);
 if ((err = setup_more_rois(slice_roi,str,1)) == NO_ERROR)
    {if ((roi = get_cur_roi(slice_roi)) != NULL)
        {delete_cur_roi_curve(slice_roi);}
    }
 PRT(printf("win_enable_3d_pt_mode...end\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
setup_more_plane_rec - ???
-------------------------------------------------------------------------*/

int
setup_more_plane_rec(_3d,win)
 struct more_plane_rec *_3d;
 struct image_display_window *win;
{
 Cms cms;
 Panel_item item;
 int row,offset;
 struct img_buf_rec *img;
 struct view_rec *view;
 char *str;
 Rect *rr;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;

 cms = (Cms) xv_get(win->dwin->frame,WIN_CMS);
 _3d->frame = xv_create(win->dwin->frame, FRAME,
			/*WIN_DYNAMIC_VISUAL,TRUE,*/
			FRAME_INHERIT_COLORS,TRUE,
			WIN_CLIENT_DATA,_3d,
			0);
 if (_3d->frame == 0)
    {free_more_plane_rec(_3d);
     return ~NO_ERROR;}
 xv_set(_3d->frame,		/* DRW 19970811  See display_init_free.c */
	WIN_CMS,cms,
	NULL);
 _3d->win = win;
 _3d->dwin = win->dwin;
 str = win_rec_win_id_title(win->owner,_3D_MORE_PLANE_OPTIONS);
 xv_set(_3d->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,_3d_more_plane_done_proc,
              0);
 c_free(str);
 xv_set(_3d->frame,FRAME_CLOSED,FALSE,0);

 _3d->panel = xv_create(_3d->frame,PANEL,
               FRAME_INHERIT_COLORS,TRUE,
               0);
 cms = (Cms) xv_get(_3d->panel,WIN_CMS);

 if (_3d->panel == 0)
    {free_more_plane_rec(_3d);
     return ~NO_ERROR;}

 row = 5;
 offset = xv_rows(_3d->panel,1) - xv_rows(_3d->panel,0) - 10;
/*
  _3d->cur_plane_msg = xv_create(_3d->panel,PANEL_MESSAGE,
                      XV_X,5,XV_Y,row,0);
 show_cur_plane_params1(_3d);
 row += offset;
*/
 xv_create(_3d->panel,PANEL_MESSAGE,
	PANEL_LABEL_STRING,"SAMPLE 3 PLANE PTS TO FORM A PLANE...",
        XV_X,5,XV_Y,row,
	0);
 row += offset - 5;
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"ENABLE PLANE PT CURSOR - F9",
	PANEL_NOTIFY_PROC,plane_pt_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 row += offset;
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"DELETE LAST PLANE PT - <Shift> F9",
	PANEL_NOTIFY_PROC,delete_plane_pt_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 row += offset;
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"FORM PLANE FROM 3 PLANE PTS - F10",
	PANEL_NOTIFY_PROC,form_plane_by_3_pts_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 row += offset;
 _3d->image_center = xv_create(_3d->panel,PANEL_MESSAGE,
        XV_X,5,XV_Y,row,
	0);
 row += offset - 7;
 _3d->plane_center = xv_create(_3d->panel,PANEL_MESSAGE,
        XV_X,5,XV_Y,row,
	0);
 row += offset - 7;
 _3d->cur_center = xv_create(_3d->panel,PANEL_MESSAGE,
        XV_X,5,XV_Y,row,
	0);
 dp_center_msg(_3d);

 row += offset - 5;
 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"MOVE IMAGE CENTER",
	PANEL_NOTIFY_PROC,change_center_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 _3d->for_which = xv_create(_3d->panel,PANEL_CHOICE_STACK,
	PANEL_LABEL_STRING,"FOR",
        PANEL_CHOICE_STRINGS,"CUR GROUP","CUR PLANE",NULL,
        PANEL_CLIENT_DATA,_3d,
        PANEL_VALUE,0,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        0);
 row += offset;
 _3d->rel_abs = xv_create(_3d->panel,PANEL_CHOICE_STACK,
        PANEL_CHOICE_STRINGS,"REL. TO","=",NULL,
        PANEL_CLIENT_DATA,_3d,
        XV_X,5,XV_Y,row,
        PANEL_VALUE,0,
        0);
 rr = (Rect *) xv_get(_3d->rel_abs,XV_RECT);
 _3d->center_choice = xv_create(_3d->panel,PANEL_CHOICE_STACK,
        PANEL_CHOICE_STRINGS,"1st PLANE PT SAMPLED",
              "DEFAULT","PLANE X/Y INPUT",NULL,
        PANEL_CLIENT_DATA,_3d,
        PANEL_VALUE,0,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        0);
 row += offset;
 _3d->x = xv_create(_3d->panel,PANEL_NUMERIC_TEXT,
        XV_X,5,XV_Y,row,
        PANEL_VALUE_DISPLAY_LENGTH,5,
 	PANEL_LABEL_STRING, "PLANE X",PANEL_VALUE,0,
        PANEL_MIN_VALUE,-1000,PANEL_MAX_VALUE,1000,
        0);
 rr = (Rect *) xv_get(_3d->x,XV_RECT);
 _3d->y = xv_create(_3d->panel,PANEL_NUMERIC_TEXT,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_VALUE_DISPLAY_LENGTH,5,
 	PANEL_LABEL_STRING, "Y",PANEL_VALUE,0,
        PANEL_MIN_VALUE,-1000,PANEL_MAX_VALUE,1000,
        0);

 /******
 row += offset;
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"FORM PLANE",
	PANEL_NOTIFY_PROC,form_plane_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 row += offset - 2;

 _3d->basex = xv_create(_3d->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"Base X:",
        PANEL_VALUE_DISPLAY_LENGTH,6,
        PANEL_VALUE_STORED_LENGTH,7,
        XV_X,7,XV_Y,row,
	0);
 _3d->basey = xv_create(_3d->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"Y:",
        PANEL_VALUE_DISPLAY_LENGTH,6,
        PANEL_VALUE_STORED_LENGTH,7,
        XV_Y,row,
	0);
 _3d->basez = xv_create(_3d->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"Z:",
        PANEL_VALUE_DISPLAY_LENGTH,6,
        PANEL_VALUE_STORED_LENGTH,7,
        XV_Y,row,
	0);
 row += offset - 5;
 _3d->normalx = xv_create(_3d->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"Normal X:",
        XV_X,7,XV_Y,row,
        PANEL_VALUE_DISPLAY_LENGTH,6,
        PANEL_VALUE_STORED_LENGTH,7,
	0);
 _3d->normaly = xv_create(_3d->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"Y:",
        XV_Y,row,
        PANEL_VALUE_DISPLAY_LENGTH,6,
        PANEL_VALUE_STORED_LENGTH,7,
	0);
 _3d->normalz = xv_create(_3d->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"Z:",
        XV_Y,row,
        PANEL_VALUE_DISPLAY_LENGTH,6,
        PANEL_VALUE_STORED_LENGTH,7,
	0);

 row += offset;
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"MOVE",
	PANEL_NOTIFY_PROC,move_plane_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);

 dim = max_plane_dims(&(view->gplane));
 _3d->y = xv_create(_3d->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"ROW",
	PANEL_VALUE,(int) ULongRound((double) view->gplane.translate.y),
	PANEL_MIN_VALUE,-dim / 2,
	PANEL_MAX_VALUE,dim / 2,
	PANEL_SLIDER_WIDTH,65,
        XV_Y,row,
	0);
 rr = (Rect *) xv_get(_3d->y,XV_RECT);
 row += offset;
 _3d->x = xv_create(_3d->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"COL",
	PANEL_VALUE,(int) ULongRound((double) view->gplane.translate.x),
	PANEL_MIN_VALUE,-dim / 2,
	PANEL_MAX_VALUE,dim / 2,
	PANEL_SLIDER_WIDTH,65,
        XV_X,rr->r_left,XV_Y,row,
	0);
 rr = (Rect *) xv_get(_3d->x,XV_RECT);
 xv_set(_3d->panel,XV_WIDTH,rr->r_left + rr->r_width + 5,
           XV_HEIGHT,rr->r_top + rr->r_height + 5,0);
 ******/
 window_fit(_3d->panel);
 rr = (Rect *) xv_get(_3d->panel,XV_RECT);
 xv_set(_3d->panel,XV_WIDTH,rr->r_width - 10,
               XV_HEIGHT,rr->r_height - 10,0);
 window_fit(_3d->frame);
 make_2_wins_adjacent(_3d->frame,win->dwin->frame,0);
 win_set_mouse_at_center(_3d->frame);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_more_plane_rec - ???
-------------------------------------------------------------------------*/

struct more_plane_rec *
find_more_plane_rec(all_3ds,win)
 struct all_more_plane_recs *all_3ds;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_3ds->num_3ds; lcv++)
    if (all_3ds->_3ds[lcv]->win == win)
       return all_3ds->_3ds[lcv];
 return NULL;
}


/*-------------------------------------------------------------------------
update_more_plane_menu - ???
-------------------------------------------------------------------------*/

void
update_more_plane_menu(win)
 struct image_display_window *win;
{
 struct all_more_plane_recs *all_3ds;
 struct more_plane_rec *_3d;

 if ((all_3ds = (struct all_more_plane_recs *) enter_3d_more_plane(win,
              GET_ALL_MORE_PLANE_PTR)) != NULL)
    {
     if ((_3d = find_more_plane_rec(all_3ds,win)) != NULL)
        {
         /*show_cur_plane_params1(_3d);*/
         dp_center_msg(_3d);}
    }
}


/*-------------------------------------------------------------------------
enter_3d_more_plane - ???
-------------------------------------------------------------------------*/

unsigned long 
enter_3d_more_plane(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_more_plane_recs all_3ds;
 static char first_time = 1;
 int err;
 struct more_plane_rec *_3d;

 err = NO_ERROR;
 if (status == GET_ALL_MORE_PLANE_PTR)
     {if (first_time) return 0;
        else return (unsigned long) &all_3ds;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_MORE_PLANE)
   {if (!first_time)
       if ((_3d = find_more_plane_rec(&all_3ds,win)) != NULL)
          free_more_plane_rec(_3d);
    return NO_ERROR;}

 if (first_time)
    {init_all_more_plane_recs(&all_3ds);
     first_time = 0;}
   else
    {if ((_3d = find_more_plane_rec(&all_3ds,win)) != NULL)
        {xv_set(_3d->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
         win_set_mouse_at_center(_3d->frame);
         wmgr_top(_3d->frame);
         return NO_ERROR;}
    }
/*
    {if ((_3d = find_more_plane_rec(&all_3ds,win)) != NULL)
        {_3d->win = win;
         _3d->dwin = win->dwin;
         xv_set(_3d->frame,XV_SHOW,TRUE,0);
         xv_set(_3d->frame,XV_OWNER,win->dwin->frame,
              XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
         str = win_rec_win_id_title(win->owner,_3D_MORE_PLANE_OPTIONS);
         xv_set(_3d->frame,XV_LABEL,str,0);
         c_free(str);
         win_set_mouse_at_center(_3d->frame);

         wmgr_top(_3d->frame);
         _3d->status &= ~CLOSE_UPON_OWNER_REQUEST;
         return NO_ERROR;}
    }
*/

 get_handle_memory(&(all_3ds._3ds),&(all_3ds.num_3ds),1,
     (size_t) sizeof(struct more_plane_rec),&err);
 if (err != NO_ERROR) return err;
 _3d = all_3ds._3ds[all_3ds.num_3ds - 1];
 init_more_plane_rec(_3d);
 if ((err = setup_more_plane_rec(_3d,win)) == NO_ERROR)
    xv_set(_3d->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 return err;
}
