/****************************************************************************
3d_save_menu.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 3d_save_menu.c,v 1.11 1999/07/07 17:41:13 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <unistd.h>

#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "buf_3d_rec.h"
#include "geometry.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define PRT9(x)
#define PRINT(x) printf(x); fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRINT(x)
#define PRT8(x)
#define PRT5(x)
#define PRT6(x)
#define PRT7(x)
#define PRT9(x)
#define PRT10(x)
#define PRT3(x)
#define PRT4(x)



#define SAVE_3D_ROIS "SAVE 3D ROIS..."

#define CLEAN_UP_3D_MENU 0
#define SETUP_3D_MENU 1
#define GET_ALL_3D_MENU_PTR 2

#define SAVE_START 2
#define SAVE_IMG_OK 4
#define SAVE_HDR_OK 8
#define SAVE_NDAT_OK 0x0010
#define SAVE_PIXMAP_OK 0x0020
#define CAN_DELETE_IMG 0x0100
#define CAN_DELETE_NHDR 0x0200
#define CAN_DELETE_NDAT 0x0400
#define CAN_DELETE_PIXMAP 0x0800
#define SAVE_SUPERIMPOSE_3D_EXIST 0x1000
#define SAVE_SHOW_SUPERIMPOSE_3D 0x2000
#define SAVE_CO_REG_OK 0x4000
struct save_rois_rec
   {
    Frame frame;
    Panel panel;
    Panel_item rois;
   };

#define SAVE_COREG_NHDR_OK 0x0020
#define SAVE_COREG_IMG_OK 0x0004
#define SAVE_COREG_NDAT_OK 0x0008
#define SAVE_COREG_IMG_READY 0x0010
#define SAVE_COREG_NDAT_READY 0x0020
#define SAVE_COREG_NHDR_READY 0x0040
#define SAVE_CO_REG_BUF_READY 0x0080
#define SAVE_CO_REG_ALL_ECHOES_READY 0x0100
struct save_co_reg_rec
   {
    unsigned short status;
    int err;
    char *hdrfn,*imgfn,*ndatfn;
    FILE *fid,*imgfid;
    struct co_register_rec co;
    struct plane_3d_rec gplane;
    unsigned long num_2ds;
    struct buf_2d_rec *_2ds;
    struct _3d_plane_2d_rec *_3d_2ds;
   };

struct save_menu_3d_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item dir,fn,orig_size,orig_dim,start,end,all_echoes,skip,
               cur_size,cur_dim,cancel,save_npar,save_pixmap_item,save_img_item,
               save_rois_item,show_rois_on_img_item,show_pixel_types_item,
               save_which_rois,select_rois,save_coreg;

    struct plane_3d_rec plane;
    FILE *fid,*imgfid;
    char *hdr_fn,*imgfn,*ndatfn,*pixmapfn;
    int save_err,is_save_rois,is_show_rois_on_img,
        is_all_echoes,is_save_pixmap,is_save_img;
    long total_slices_saved,cur_sl,start_sl,end_sl,skip_sl,cur_slice_num,
         num_slice_rois;
    struct slice_roi_rec *slice_rois;
    unsigned long total_3d_2ds,num_3d_2ds,total_2ds,
                  num_bufs,num_echoes,roi_start,cur_img_buf_indx;
    struct _3d_plane_2d_rec *_3d_2ds;
    struct buf_2d_rec *_2ds;
    unsigned long num_slice_maps,pixmap_start;
    struct buf_2d_rec **slice_maps;

    struct save_rois_rec save_rois;
    struct strs_rec roi_labels;

    unsigned long num_coregs;
    struct save_co_reg_rec *coregs;
   };

struct all_save_menu_3d_recs
   {
    int num_3ds;
    struct save_menu_3d_rec **_3ds;
   };



/* Functions defined in this file */
void init_save_rois_rec(struct save_rois_rec *save_rois);
void free_save_rois_rec(struct save_rois_rec *save_rois);
void init_save_co_reg_rec(struct save_co_reg_rec *coreg);
void free_3d_co_reg_rec(struct save_menu_3d_rec *_3d);
void init_save_menu_3d_rec(struct save_menu_3d_rec *_3d);
void free_save_menu_3d_rec(struct save_menu_3d_rec *_3d);
void init_all_save_menu_3d_recs(struct all_save_menu_3d_recs *all_3ds);
unsigned long num_output_3d_slices(struct save_menu_3d_rec *_3d,
    int num_echoes);
void setup_save_co_reg_item(struct save_menu_3d_rec *_3d);
int setup_save_co_reg_rec(struct save_menu_3d_rec *_3d);
int open_coreg_files(struct save_menu_3d_rec *_3d);
int setup_coreg_memory(struct save_menu_3d_rec *_3d);
int save_coreg_image(struct save_menu_3d_rec *_3d);
int save_co_reg_end(struct save_menu_3d_rec *_3d);
int is_save_coreg(struct save_menu_3d_rec *_3d);
void setup_orig_size_msg(struct save_menu_3d_rec *_3d);
void setup_orig_dim_msg(struct save_menu_3d_rec *_3d);
int DefinePixelSize(struct save_menu_3d_rec *_3d, float *xpixel_size,
    float *ypixel_size, float *thickness, struct plane_3d_rec *gplane,
    struct buf_3d_rec *_3d_data);
void setup_cur_size_msg(struct save_menu_3d_rec *_3d);
void setup_cur_dim_msg(struct save_menu_3d_rec *_3d);
void _3d_save_done_proc(Frame frame);
void set_slice_proc(Panel_item item, int value, Event *event);
void set_skip_proc(Panel_item item, int value, Event *event);
int Setup3dPlane2dRecBufs(struct _3d_plane_2d_rec *_3d_2ds,
    struct input_file_rec *file, char *id, struct buf_2d_rec *plane_2d,
    struct buf_2d_rec *transform_2d, unsigned long dimx, unsigned long dimy,
    unsigned long dimx1, unsigned long dimy1, unsigned long pixel_depth,
    unsigned long type4);
int GetAllViewEchoesMemory(struct save_menu_3d_rec *save_3d,
    struct view_rec *view, struct _3d_plane_2d_rec **_3d_2ds,
    unsigned long *total_3d_2ds, struct buf_2d_rec **_2ds,
    unsigned long *total_2ds, int is_all_echoes, int is_save_rois,
    struct strs_rec *roi_labels);
void save_3d_err_message(struct save_menu_3d_rec *_3d, int select);
int enlarge_view_bufs(struct save_menu_3d_rec *_3d, struct view_rec *view);
int save_3d_img(struct save_menu_3d_rec *_3d, int whch);
int save_the_3d_hdr(FILE *fid, struct save_menu_3d_rec *_3d,
    struct plane_3d_rec *gplane, struct buf_3d_rec *_3d_data,
    struct hdr_rec *def_hdr);
int save_3d_hdr(FILE *fid, struct save_menu_3d_rec *_3d);
int save_3d_ndat(struct save_menu_3d_rec *_3d);
int save_3d_pixmap(struct save_menu_3d_rec *_3d);
int open_input_file(char *dir, char *fn, char *suffix, char **the_fn,
    FILE **fid, Frame frame);
int open_output_file(char *dir, char *fn, char *suffix, char **the_fn,
    FILE **fid, Frame frame, int is_replace);
int alloc_img_file(FILE *imgfid, struct save_menu_3d_rec *_3d);
int Save3dStart(struct save_menu_3d_rec *_3d, struct img_buf_rec *img,
    struct view_rec *view);
int save_3d_end(struct save_menu_3d_rec *_3d);
int Save3d(struct view_rec *view, struct save_menu_3d_rec *_3d);
void load_3d_pixel_types_proc(struct view_rec *view,
    struct save_menu_3d_rec *_3d);
void load_3d_rois_proc(struct view_rec *view, struct save_menu_3d_rec *_3d);
int SaveThe3dNow(struct view_rec *view, struct save_menu_3d_rec *_3d);
void SaveThe3d(struct save_menu_3d_rec *_3d);
int Save3dNpar(struct save_menu_3d_rec *_3d);
void save_3d_proc(Panel_item item, Event *event);
void cancel_save_3d_proc(Panel_item item, Event *event);
void check_show_pixel_types_proc(Panel_item item, int value, Event *event);
void check_pixel_type_ready_proc(Panel_item item, int value, Event *event);
void all_echo_proc(Panel_item item, int value, Event *event);
int save_selected_rois(struct save_menu_3d_rec *_3d);
void is_save_rois_proc(Panel_item item, int value, Event *event);
void cur_image_only_proc(Panel_item item, Event *event);
void activated_and_done_proc(Panel_item item, Event *event);
void save_3d_rois_done_proc(Frame frame);
int setup_save_3d_rois_proc(Panel_item item, Event *event);
int setup_save_menu_3d_rec(struct save_menu_3d_rec *_3d,
    struct image_display_window *win);
struct save_menu_3d_rec *find_save_menu_3d_rec(
   struct all_save_menu_3d_recs *all_3ds, struct image_display_window *win);
void update_start_end(struct save_menu_3d_rec *_3d);
void update_3d_save_menu(struct image_display_window *win);
unsigned long enter_3d_save_menu(struct image_display_window *win, int status);




/*****************************************************************
 *  Start of code
 *****************************************************************/


/*----------------------------------------------------------------
init_save_rois_rec - ???
----------------------------------------------------------------*/

void
init_save_rois_rec(save_rois)
 struct save_rois_rec *save_rois;
{
 save_rois->frame = 0;
}


/*----------------------------------------------------------------
free_save_rois_rec - ???
----------------------------------------------------------------*/

void
free_save_rois_rec(save_rois)
 struct save_rois_rec *save_rois;
{
 if (save_rois->frame != 0) xv_destroy_safe(save_rois->frame);
 save_rois->frame = 0;
}


/*----------------------------------------------------------------
init_save_co_reg_rec - ???
----------------------------------------------------------------*/

void
init_save_co_reg_rec(coreg)
 struct save_co_reg_rec *coreg;
{
 coreg->hdrfn = coreg->imgfn = coreg->ndatfn = NULL;
 coreg->fid = coreg->imgfid = NULL;
 init_co_register_rec(&(coreg->co));
 coreg->status = 0;
 coreg->err = 0;
 coreg->num_2ds = 0;
 coreg->_2ds = NULL;
 coreg->_3d_2ds = NULL;
}


/*----------------------------------------------------------------
free_3d_co_reg_rec - ???
----------------------------------------------------------------*/

void
free_3d_co_reg_rec(_3d)
  struct save_menu_3d_rec *_3d;
{
 unsigned long lcv,indx;
 struct save_co_reg_rec *coreg;
 unsigned long status;

 PRT3(printf("free_3d_co_reg_rec..._3d->num_coregs = %d\n",_3d->num_coregs))
 if (_3d->num_coregs == 0) return;
 
 for (lcv = 0; lcv < _3d->num_coregs; lcv++)
    {coreg = &(_3d->coregs[lcv]);
     status = 0;
     if (coreg->imgfid != NULL)
        {fclose(coreg->imgfid);
         status |= 1;
         coreg->imgfid = NULL;}
     if (coreg->fid != NULL)
        {fclose(coreg->fid);
         status |= 2;
         coreg->fid = NULL;}

     if (!(coreg->status & SAVE_COREG_IMG_OK))
        if ((coreg->imgfn != NULL) && (status & 1))
           {PRT10(printf("deleting file = %s\n",coreg->imgfn))
            delete_file(coreg->imgfn);}
     if (!(coreg->status & SAVE_COREG_NHDR_OK))
        if ((coreg->hdrfn != NULL) && (status & 2))
           {PRT10(printf("deleting file = %s\n",coreg->hdrfn))
            delete_file(coreg->hdrfn);}

     if (!(coreg->status & SAVE_COREG_NDAT_OK))
        if (coreg->ndatfn != NULL) 
           {PRT10(printf("deleting file = %s\n",coreg->ndatfn))
            delete_file(coreg->ndatfn);}
     c_free(coreg->hdrfn);
     c_free(coreg->imgfn);
     c_free(coreg->ndatfn);
     free_co_register_rec(&(coreg->co));

     for (indx = 0; indx < coreg->num_2ds; indx++)
        free_buf_2d_rec(&(coreg->_2ds[lcv]));
     c_free(coreg->_2ds);
     c_free(coreg->_3d_2ds);
    }
 c_free(_3d->coregs);
 _3d->num_coregs = 0;
 _3d->coregs = NULL;
 PRT10(printf("free_3d_co_reg_rec...done  _3d->num_coregs= %d\n",_3d->num_coregs))
}


/*----------------------------------------------------------------
init_save_menu_3d_rec - ???
----------------------------------------------------------------*/

void
init_save_menu_3d_rec(_3d)
 struct save_menu_3d_rec *_3d;
{
 _3d->status = 0;
 _3d->win = NULL;
 _3d->frame  = 0;
 init_strs_rec(&(_3d->roi_labels));
 init_save_rois_rec(&(_3d->save_rois));
 _3d->num_coregs = 0;
 _3d->coregs = NULL;
}


/*----------------------------------------------------------------
free_save_menu_3d_rec - ???
----------------------------------------------------------------*/

void
free_save_menu_3d_rec(_3d)
 struct save_menu_3d_rec *_3d;
{
 struct all_save_menu_3d_recs *all_3ds;

 TRACE(printf("free_save_menu_3d_rec...\n"))
 free_save_rois_rec(&(_3d->save_rois));
 free_strs_rec(&(_3d->roi_labels));
 if (_3d->frame != 0) xv_destroy_safe(_3d->frame);

 all_3ds = (struct all_save_menu_3d_recs *) enter_3d_save_menu(NULL,
            GET_ALL_3D_MENU_PTR);
 c_free(_3d);
 DropHandleAryPtr(&(all_3ds->_3ds),&(all_3ds->num_3ds),_3d);
 TRACE(printf("free_save_menu_3d_rec...end\n"))
}


/*----------------------------------------------------------------
init_all_save_menu_3d_recs - ???
----------------------------------------------------------------*/

void
init_all_save_menu_3d_recs(all_3ds)
 struct all_save_menu_3d_recs *all_3ds;
{
 all_3ds->num_3ds = 0;
 all_3ds->_3ds = NULL;
}


/*----------------------------------------------------------------
num_output_3d_slices - ???
----------------------------------------------------------------*/

unsigned long 
num_output_3d_slices(_3d,num_echoes)
 struct save_menu_3d_rec *_3d;
 int num_echoes;
{
 long max_slices,num;
 int skip;

 max_slices = (int) xv_get(_3d->end,PANEL_VALUE) - 
              (int) xv_get(_3d->start,PANEL_VALUE) + 1;
 skip = (int) xv_get(_3d->skip,PANEL_VALUE);
 num = max_slices / skip;
 if (max_slices % skip) max_slices = num + 1;
   else max_slices = num;
 if ((_3d->all_echoes != 0) &&
       xv_get(_3d->all_echoes,PANEL_VALUE))
    max_slices *= num_echoes;
 return max_slices;

}


/*----------------------------------------------------------------
setup_save_co_reg_item - ???
----------------------------------------------------------------*/

void
setup_save_co_reg_item(_3d)
 struct save_menu_3d_rec *_3d;
{
 unsigned long lcv;
 struct img_buf_rec *img;
 struct view_rec *view;
 struct strs_rec list;

 if (_3d->save_coreg == 0) return;
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 init_strs_rec(&list);
 selected_list_items(&list,_3d->save_coreg);
 delete_all_list_items(_3d->save_coreg);
 view = img->cur_slice->slice->view;
 if ((view->status & PLANE_CROSS_REGISTERED) && (view->num_cos > 0))
    for (lcv = 0; lcv < view->num_cos; lcv++)
       {xv_set(_3d->save_coreg,PANEL_LIST_STRING,lcv,view->cos[lcv].wid,
               PANEL_LIST_CLIENT_DATA,lcv,lcv,0);
       }
 select_list_items(&list,_3d->save_coreg);
 free_strs_rec(&list);
}


/*----------------------------------------------------------------
setup_save_co_reg_rec - ???
----------------------------------------------------------------*/

int
setup_save_co_reg_rec(_3d)
 struct save_menu_3d_rec *_3d;
{
 unsigned long lcv,cnt;
 long indx;
 struct strs_rec wids;
 int err,err1;
 char *str,*fn,*fn1,*dir;
 struct img_buf_rec *img;
 struct view_rec *view1,*view;
 struct co_register_rec *co;
 struct save_co_reg_rec *coreg;

 PRT10(printf("setup_save_co_reg_rec..1\n"))
 if (_3d->save_coreg == 0) return NO_ERROR;
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;

 init_strs_rec(&wids);
 if ((err = selected_list_items(&wids,_3d->save_coreg)) != NO_ERROR)
    {free_strs_rec(&wids);
     return err;}
 if (wids.num_strs == 0) return NO_ERROR;
 view = img->cur_slice->slice->view;

 for (cnt = 0,lcv = 0; lcv < wids.num_strs; lcv++)
    if (((co = find_co_register_rec(view,wids.strs[lcv],&indx,&err1,0)) != NULL) &&
        ((view1 = find_any_view_rec(img->file,wids.strs[lcv])) != NULL))
       cnt += 1;
 PRT10(printf("setup_save_co_reg_rec cnt = %d _3d->status = %x\n",cnt,
     (unsigned long) _3d->status))
 PRT10(if (_3d->status & CAN_DELETE_NDAT) printf("setup_save_co_reg_rec CAN_DELETE_NDAT\n"))

 if ((err == NO_ERROR) && (cnt > 0) &&
     ((err = get_ptr(&(_3d->coregs),&(_3d->num_coregs),cnt,
        (size_t) sizeof(*(_3d->coregs)))) == NO_ERROR))
    {
     for (lcv = 0; lcv < cnt; lcv++)
        init_save_co_reg_rec(&(_3d->coregs[lcv]));
     if (((fn1 = (char *) xv_get(_3d->fn,PANEL_VALUE)) == NULL) ||
         (get_strlen(fn1) == 0))
        fn1 = img->file->fn;
     dir = (char *) xv_get(_3d->dir,PANEL_VALUE);
     if ((err = build_fn(&fn,dir,fn1,"")) == NO_ERROR)
        for (cnt = 0,lcv = 0; lcv < wids.num_strs; lcv++)
           {coreg = &(_3d->coregs[lcv]);
            if (((co = find_co_register_rec(view,wids.strs[lcv],&indx,&err1,0)) != NULL) &&
                ((view1 = find_any_view_rec(img->file,wids.strs[lcv])) != NULL))
               {
                if (view1->img->file == img->file)
                   {if ((err = concat_strs(&str,3,fn,"-",wids.strs[lcv])) != NO_ERROR)
                       break;}
                  else if ((err = concat_strs(&str,5,fn,"-",view1->img->file->fn,
                       "-",wids.strs[lcv])) != NO_ERROR)
                   break;
                if (((err = concat_strs(&(coreg->hdrfn),2,str,".nhdr")) == NO_ERROR) &&
                    ((err = concat_strs(&(coreg->imgfn),2,str,".img")) == NO_ERROR) &&
                    ((err = cp_co_register_rec(&(coreg->co),co)) == NO_ERROR))
                   {if (_3d->is_save_rois)
                       err = concat_strs(&(coreg->ndatfn),2,str,".ndat");
                    PRT10(printf("..hdr_fn = %s imgfn = %s ndatfn = %s\n",
                      coreg->hdrfn,coreg->imgfn,coreg->ndatfn))
                    if (err == NO_ERROR)
                       coreg->gplane = view1->gplane;}
                c_free(str);
                if (err != NO_ERROR) break;
               }
           }
    }
 if (err == NO_ERROR) _3d->status |= SAVE_CO_REG_OK;
 PRT10(printf("setup_save_co_reg_rec..err = %d\n",err))
 free_strs_rec(&wids);
 return err;
}


/*----------------------------------------------------------------
open_coreg_files - ???
----------------------------------------------------------------*/

int
open_coreg_files(_3d)
 struct save_menu_3d_rec *_3d;
{
 FILE *fid;
 unsigned long lcv;
 char *fn;
 struct save_co_reg_rec *coreg;

 PRT9(printf("open_coreg_files..1\n"))
 if ((_3d->num_coregs == 0) || !(_3d->status & SAVE_CO_REG_OK)) return NO_ERROR;
 for (lcv = 0; lcv < _3d->num_coregs; lcv++)
     {coreg = &(_3d->coregs[lcv]);
      if ((coreg->err = open_output_file(NULL,coreg->hdrfn,NULL,
          &fn,&(coreg->fid),_3d->frame,0)) == NO_ERROR)
         {coreg->status |= SAVE_COREG_NHDR_READY;
          c_free(fn);
          if ((coreg->err = open_output_file(NULL,coreg->imgfn,NULL,
               &fn,&(coreg->imgfid),_3d->frame,0)) == NO_ERROR)
             {coreg->status |= SAVE_COREG_IMG_READY;
              c_free(fn);
              if (_3d->is_save_rois && (get_strlen(coreg->ndatfn) > 0))
                 {PRT9(printf("open_coreg_files..ndatfn\n"))
                  if ((coreg->err = open_output_file(NULL,coreg->ndatfn,NULL,
                     &fn,&fid,_3d->frame,0)) == NO_ERROR)
                    {coreg->status |= SAVE_COREG_NDAT_READY;
                     fclose(fid);
                     c_free(fn);}
                 }
             }
         }
    }
 PRT9(printf("open_coreg_files..2\n"))
 return NO_ERROR;
}



/*----------------------------------------------------------------
setup_coreg_memory - ???
----------------------------------------------------------------*/

int
setup_coreg_memory(_3d)
 struct save_menu_3d_rec *_3d;
{
 unsigned long lcv,cnt,num,plane_indx,pixel_depth,type4;
 struct save_co_reg_rec *coreg;
 struct img_buf_rec *img;
 struct view_rec *view,*view1;
 char *id;
 int err;

 PRT3(printf("setup_coreg_memory.._3d->  coregs = %u num_coregs = %d num_echoes = %d\n",
       _3d->coregs,_3d->num_coregs,_3d->num_echoes))
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 if (_3d->num_coregs == 0) return NO_ERROR;
 view = img->cur_slice->slice->view;
 for (plane_indx = lcv = 0; lcv < view->img->file->hdr.analysis.num_img_labels; lcv++)
    {PRT9(printf("%d) view->id = %s label = %s\n",lcv,view->id,
                view->img->file->hdr.analysis.img_labels[lcv]))
     if (str_cmp(view->id,view->img->file->hdr.analysis.img_labels[lcv]) == 0)
        {plane_indx = lcv;
        break;}
    }

 for (lcv = 0; lcv < _3d->num_coregs; lcv++)
    {coreg = &(_3d->coregs[lcv]);
     if (!(coreg->status & SAVE_COREG_IMG_READY)) continue;
     PRT3(printf("setup_coreg_memory..lcv = %d \n",lcv))
     if ((err = get_ptr(&(coreg->_3d_2ds),NULL,_3d->num_echoes,
            (size_t) sizeof(*(coreg->_3d_2ds)))) != NO_ERROR) 
        break;

     if ((err = get_ptr(&(coreg->_2ds),&(coreg->num_2ds),_3d->num_echoes,
            (size_t) sizeof(*(coreg->_2ds)))) != NO_ERROR) 
        break;
     for (cnt = 0; cnt < coreg->num_2ds; cnt++)
        init_buf_2d_rec(&(coreg->_2ds[cnt]));

     for (cnt = 0; cnt < coreg->num_2ds; cnt++)
        {
         if ((view1 = find_any_view_rec(img->file,coreg->co.wid)) == NULL)
            {err = CANCEL;
             break;}
         for (num = 0; num < view1->img->file->hdr.analysis.num_img_labels; num++)
            if (_3d->num_echoes == view1->img->file->hdr.data_info.num_echoes)
               id = view1->img->file->hdr.analysis.img_labels[num];
              else id = view1->img->file->hdr.analysis.img_labels[plane_indx];
         PRT9(printf("setup_coreg_memory..%d) id = %s cowid = %s\n",cnt,id,coreg->co.wid))

         pixel_depth = view1->img->file->hdr.data_info.pixel_depth_bits;
         type4 = InputDataTypeToBufType(&(view1->img->file->hdr.data_info));
         PRT9(printf("setup_coreg_memory.Setup3dPlane2dRecBufs pixel_depth = %d type4 = %x\n",
                 pixel_depth,type4))
         if ((err = Setup3dPlane2dRecBufs(&(coreg->_3d_2ds[cnt]),view1->img->file,
             id,&(coreg->_2ds[cnt]),NULL,
             view->gplane.proj_dimx,view->gplane.proj_dimy,
             view->gplane.proj_buf_dimx,view->gplane.proj_buf_dimy,
             pixel_depth,type4)) != NO_ERROR)
            break;
         }
     if (err != NO_ERROR) break;
     coreg->status |= SAVE_CO_REG_BUF_READY;
    }
 PRT9(printf("setup_coreg_memory..55555 err = %d\n",err))
 PRT9(if (err == NO_ERROR)
         for (lcv = 0; lcv < _3d->num_coregs; lcv++)
            {coreg = &(_3d->coregs[lcv]);
             for (cnt = 0; cnt < coreg->num_2ds; cnt++)
                {printf("%d) _3d = %u id = %s pl_2d = %u transform_2d = %u\n\n",cnt,
                 coreg->_3d_2ds[cnt]._3d,coreg->_3d_2ds[cnt]._3d->id,
                  coreg->_3d_2ds[cnt].plane_2d,coreg->_3d_2ds[cnt].transform_2d);
                printf("plane_2d\n");
                pr_buf_2d_rec(coreg->_3d_2ds[cnt].plane_2d);
                printf("\n");
               }
            }
      )
 PRT9(printf("setup_coreg_memory..err = %d\n",err))
 return err;
}


/*----------------------------------------------------------------
save_coreg_image - ???
----------------------------------------------------------------*/

int
save_coreg_image(_3d)
 struct save_menu_3d_rec *_3d;
{
 unsigned long lcv,cnt;
 struct save_co_reg_rec *coreg;
 struct img_buf_rec *img;
 struct view_rec *view;
 struct vector_3d_rec base,normal;
 struct matrix_3d_rec xyztoplane;

 PRT9(printf("save_coreg_image..1\n"))
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;

 PRT9(printf("save_coreg_image.._3d->num_coregs = %d\n",_3d->num_coregs))
 for (lcv = 0; lcv < _3d->num_coregs; lcv++)
    {coreg = &(_3d->coregs[lcv]);
     if (coreg->err != NO_ERROR) continue;
     for (cnt = 0; cnt < coreg->num_2ds; cnt++)
        {if (!is_file_3d_valid(img->file,coreg->_3d_2ds[cnt]._3d)) 
            {coreg->err = CANCEL;
             break;}
        }
     PRT9(printf("save_coreg_image..coreg->err = %d\n",coreg->err))
     if (coreg->err != NO_ERROR) break;
     CoRegisteredParams(view,&(coreg->co),&base,&normal,0);
     coreg->gplane.status &= ~PLANE_ADJUST_TO_CENTER;
     mult_3d_matrix(&xyztoplane,&(coreg->co.reg.planetoxyz),&(coreg->co.coreg.xyztoplane));
     mult_3d_matrix(&xyztoplane,&(view->gplane.xyztoplane),&xyztoplane);
     PRT9(printf("save_coreg_image..base\n");pr_vector_3d_rec(&base))
     PRT9(printf("normal \n");pr_vector_3d_rec(&normal))
     ChangePlane(&(coreg->gplane),base.x,base.y,base.z,
             normal.x,normal.y,normal.z,NULL,&(view->gplane.rotate),0,
             &xyztoplane);
     PRT9(printf("xyztoplane \n");pr_3d_matrix(&(coreg->gplane.xyztoplane)))
     PRT9(printf("planetoxyz \n");pr_3d_matrix(&(coreg->gplane.planetoxyz)))
     PRT9(printf("save_coreg_image..after ChangePlane coreg->num_2ds= %d\n",coreg->num_2ds))
     if ((coreg->err = _3dPlane2ds(&(coreg->gplane),
             coreg->_3d_2ds,coreg->num_2ds)) == NO_ERROR)
        for (cnt = 0; cnt < coreg->num_2ds; cnt++)
           {PRT9(printf("saving %d) cnt = %d total_bytes = %d %s\n",
               lcv,cnt,coreg->_3d_2ds[cnt].plane_2d->total_bytes,coreg->hdrfn))
            PRT9(
               MinMax2dValues(coreg->_3d_2ds[cnt].plane_2d,0,(double) .0,(double) .0,&min,&max);
                printf("min = %f max = %fCntValBuf2dRec = %d\n",min,max,
               CntValBuf2dRec(coreg->_3d_2ds[cnt].plane_2d,(double) .0));)

            if (fwrite(coreg->_3d_2ds[cnt].plane_2d->buf[0],
                     (size_t) coreg->_3d_2ds[cnt].plane_2d->total_bytes,1,
                      coreg->imgfid) != 1)
               {PRT9(printf("fwrite WRITE_ERROR\n"))
                coreg->err = WRITE_ERROR;
                break;
               }
           }
    }
 PRT9(printf("save_coreg_image..end..coreg->err = %d\n",coreg->err))
 return NO_ERROR;
}


/*----------------------------------------------------------------
save_co_reg_end - ???
----------------------------------------------------------------*/

int
save_co_reg_end(_3d)
 struct save_menu_3d_rec *_3d;
{
 unsigned long lcv;
 struct img_buf_rec *img;
 struct view_rec *view1;
 struct save_co_reg_rec *coreg;

 PRT9(printf("save_co_reg_end..._3d->num_coregs = %d\n",_3d->num_coregs))
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 for (lcv = 0; lcv < _3d->num_coregs; lcv++)
    {coreg = &(_3d->coregs[lcv]);
     if (coreg->err != NO_ERROR) continue;
     PRT9(printf("%d) coreg->status  = %d coreg->err = %d\n",
            lcv,(unsigned long) coreg->status,coreg->err))
     if ((view1 = find_any_view_rec(img->file,coreg->co.wid)) == NULL)
        continue;
     if (coreg->status & SAVE_CO_REG_BUF_READY)
        {
         PRT9(printf("save_co_reg_end...SAVE_CO_REG_BUF_READY\n"))
         if (coreg->status & SAVE_COREG_IMG_READY) coreg->status |= SAVE_COREG_IMG_OK;
         if (coreg->status & SAVE_COREG_NHDR_READY) 
            {
             if ((coreg->err = save_the_3d_hdr(coreg->fid,_3d,&(coreg->gplane),
                 coreg->_3d_2ds[0]._3d,&(view1->img->file->hdr))) != NO_ERROR)
                continue;
             coreg->status |= SAVE_COREG_NHDR_OK;}
        }
     if ((coreg->status & SAVE_COREG_NDAT_READY) && _3d->is_save_rois)
        {PRT9(printf("save_co_reg_end...WrRiaNdatFile\n"))

         if ((coreg->err = WrRiaNdatFile(coreg->ndatfn,&(view1->img->file->output.hdr),
                    _3d->slice_rois,_3d->num_slice_rois,NULL,NULL,
                     NULL,0,NULL,NULL)) != NO_ERROR)
            continue;
         PRT9(printf("save_co_reg_end...WrRiaNdatFile..ok\n"))
         coreg->status |= SAVE_COREG_NDAT_OK;}
    }
 PRT9(printf("save_co_reg_end...end\n"))
 return NO_ERROR;
}


/*----------------------------------------------------------------
is_save_coreg - ???
----------------------------------------------------------------*/

int
is_save_coreg(_3d)
 struct save_menu_3d_rec *_3d;
{
 unsigned long lcv;
 struct save_co_reg_rec *coreg;

 for (lcv = 0; lcv < _3d->num_coregs; lcv++)
    {coreg = &(_3d->coregs[lcv]);
     if (coreg->err != NO_ERROR) continue;
     if (coreg->status & SAVE_COREG_NDAT_READY) return 1;
     if ((coreg->status & SAVE_CO_REG_BUF_READY) &&
         (coreg->status & SAVE_COREG_NHDR_READY) &&
         (coreg->status & SAVE_COREG_IMG_READY))
        return 1;
    }
 return 0;
}


/*----------------------------------------------------------------
setup_orig_size_msg - ???
----------------------------------------------------------------*/

void
setup_orig_size_msg(_3d)
 struct save_menu_3d_rec *_3d;
{
 char str[80];
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 sprintf(str,"Orig. Size [X,Y,Thickness] = [%-.4f,%-.4f,%-.4f]",
       img->file->hdr.data_info.xpixel_size,img->file->hdr.data_info.ypixel_size,
       img->file->hdr.data_info.pixel_thickness);
 xv_set(_3d->orig_size,PANEL_LABEL_STRING,str,0);
}


/*----------------------------------------------------------------
setup_orig_dim_msg - ???
----------------------------------------------------------------*/

void
setup_orig_dim_msg(_3d)
 struct save_menu_3d_rec *_3d;
{
 char str[80];
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 sprintf(str,"Orig. Dimension [X,Y,Total Slices] = [%-d,%-d,%-ld]",
       (unsigned int) img->file->hdr.data_info.dimx,
       (unsigned int) img->file->hdr.data_info.dimy,
       NumberOfSliceCuts(&(img->file->hdr.data_info)) *
           img->file->hdr.data_info.num_echoes);
 xv_set(_3d->orig_dim,PANEL_LABEL_STRING,str,0);

}


/*----------------------------------------------------------------
DefinePixelSize - ???
----------------------------------------------------------------*/

int
DefinePixelSize(_3d,xpixel_size,ypixel_size,thickness,gplane,_3d_data)
 struct save_menu_3d_rec *_3d;
 float *xpixel_size,*ypixel_size,*thickness;
 struct plane_3d_rec *gplane;
 struct buf_3d_rec *_3d_data;
{
/*
 *xpixel_size = _3d_data->xpixel_size;
 *ypixel_size = _3d_data->ypixel_size;
 *thickness = _3d_data->zpixel_size;
*/
 *xpixel_size = gplane->coord_ratio.x * _3d_data->xpixel_size;
 *ypixel_size = gplane->coord_ratio.y * _3d_data->ypixel_size;
 *thickness = gplane->coord_ratio.z * _3d_data->zpixel_size;
 *thickness *= (float) ((int) xv_get(_3d->skip,PANEL_VALUE));
 PRT9(printf("gplane x = %f y = %f z = %f\n",
    gplane->coord_ratio.x,gplane->coord_ratio.y,gplane->coord_ratio.z))
 PRT9(printf("_3d_data x = %f y = %f z = %f  thickness= %f\n",
    _3d_data->xpixel_size,_3d_data->ypixel_size,_3d_data->zpixel_size,*thickness))
 return NO_ERROR;
}


/*----------------------------------------------------------------
setup_cur_size_msg - ???
----------------------------------------------------------------*/

void
setup_cur_size_msg(_3d)
 struct save_menu_3d_rec *_3d;
{
 char str[80];
 float xpixel,ypixel,thickness;
 struct img_buf_rec *img;
 struct view_rec *view;
 struct buf_3d_rec *_3d_data;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 view = img->cur_slice->slice->view;
 if (view == NULL) return;
 find_file_3d(img->file,view->id,&_3d_data);
 if (_3d_data == NULL) return;

 DefinePixelSize(_3d,&xpixel,&ypixel,&thickness,&(view->gplane),_3d_data);
 sprintf(str,"Cur. Size [X,Y,Thickness] = [%-.4f,%-.4f,%-.4f]",
       xpixel,ypixel,thickness);
 xv_set(_3d->cur_size,PANEL_LABEL_STRING,str,0);
}


/*----------------------------------------------------------------
setup_cur_dim_msg - ???
----------------------------------------------------------------*/

void
setup_cur_dim_msg(_3d)
 struct save_menu_3d_rec *_3d;
{
 char str[80];
 struct img_buf_rec *img;
 struct view_rec *view;
 unsigned long max_slices;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 view = img->cur_slice->slice->view;
 if (view == NULL) return;
 max_slices = num_output_3d_slices(_3d,(int) img->file->hdr.analysis.num_img_labels);

 sprintf(str,"Cur. Dimension [X,Y,Total slices] = [%-ld,%-ld,%-ld]",
       view->gplane.proj_buf_dimx,
       view->gplane.proj_buf_dimy,
       max_slices);
 xv_set(_3d->cur_dim,PANEL_LABEL_STRING,str,0);
}


/*----------------------------------------------------------------
_3d_save_done_proc - ???
----------------------------------------------------------------*/

void
_3d_save_done_proc(frame)
 Frame frame;
{
 struct save_menu_3d_rec *_3d;

 _3d = (struct save_menu_3d_rec *) xv_get(frame,WIN_CLIENT_DATA);
 if (_3d->status & SAVE_START) cancel_save_3d_proc(_3d->cancel,NULL);
 free_save_menu_3d_rec(_3d);
}


/*----------------------------------------------------------------
set_slice_proc - ???
----------------------------------------------------------------*/

void
set_slice_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct save_menu_3d_rec *_3d;
 int val1;

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (item == _3d->start)
    {val1 = (int) xv_get(_3d->end,PANEL_VALUE);
     if (value > val1) xv_set(_3d->end,PANEL_VALUE,value,0);
    }
   else 
    {val1 = (int) xv_get(_3d->start,PANEL_VALUE);
     if (value < val1) xv_set(_3d->start,PANEL_VALUE,value,0);
    }
 setup_cur_dim_msg(_3d);
}


/*----------------------------------------------------------------
set_skip_proc - ???
----------------------------------------------------------------*/

void
set_skip_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct save_menu_3d_rec *_3d;

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 setup_cur_size_msg(_3d);
 setup_cur_dim_msg(_3d);
}


/*----------------------------------------------------------------
Setup3dPlane2dRecBufs - ???
----------------------------------------------------------------*/

int
Setup3dPlane2dRecBufs(_3d_2ds,file,id,plane_2d,transform_2d,
                      dimx,dimy,dimx1,dimy1,pixel_depth,type4)
 struct _3d_plane_2d_rec *_3d_2ds;
 struct input_file_rec *file;
 char *id;
 struct buf_2d_rec *plane_2d,*transform_2d;
 unsigned long dimx,dimy,dimx1,dimy1,pixel_depth,type4;
{
 struct buf_3d_rec *_3d;
 int err;

 PRT3(printf("pixel_depth = %d type4 = %x  id = %s\n",pixel_depth,type4,id))
 PRT3(if ((err = find_file_3d(file,id,&_3d)) != NO_ERROR)
    printf("find_file_3d(file,id,&_3d)) != NO_ERROR...\n"))
 if (((err = find_file_3d(file,id,&_3d)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(plane_2d,dimx,dimy,pixel_depth,type4)) != NO_ERROR))
    return err;
 PRT3(printf("Setup3dPlane2dRecBufs...1\n"))
 if ((transform_2d != NULL) &&
     ((err = SetupBuf2dRec(transform_2d,dimx1,dimy1,pixel_depth,type4)) != NO_ERROR))
    return err;
 PRT3(printf("Setup3dPlane2dRecBufs...NO_ERROR\n"))

 _3d_2ds->_3d = _3d;
 _3d_2ds->plane_2d = plane_2d;
 _3d_2ds->transform_2d = transform_2d;
 return NO_ERROR;
}


/*----------------------------------------------------------------
GetAllViewEchoesMemory - ???
----------------------------------------------------------------*/

int
GetAllViewEchoesMemory(save_3d,view,_3d_2ds,total_3d_2ds,_2ds,total_2ds,
                       is_all_echoes,is_save_rois,roi_labels)
 struct save_menu_3d_rec *save_3d;
 struct view_rec *view;
 struct _3d_plane_2d_rec **_3d_2ds;
 unsigned long *total_3d_2ds;
 struct buf_2d_rec **_2ds;
 unsigned long *total_2ds;
 int is_all_echoes,is_save_rois;
 struct strs_rec *roi_labels;
{
 unsigned long total,cnt,plane_indx,indx,lcv,
               pixel_depth,type4;
 char *id;
 int err;

 PRT3(printf("GetAllViewEchoesMemory...is_save_rois = %d num_strs = %d\n",
          is_save_rois,roi_labels->num_strs))
 
 PRT3(if (is_save_coreg(save_3d))
        printf("GetAllViewEchoesMemory is_save_coreg = 1\n"))
 if (save_3d->is_save_img || is_save_coreg(save_3d))
    {if (is_all_echoes) 
        save_3d->num_echoes = save_3d->num_bufs = view->img->file->hdr.analysis.num_img_labels;
       else save_3d->num_echoes = save_3d->num_bufs = 1;}
   else if (save_3d->is_show_rois_on_img)
    save_3d->num_echoes = save_3d->num_bufs = 1;
   else
    {save_3d->num_bufs = 0;
     save_3d->num_echoes = 1;}
 PRT3(printf("GetAllViewEchoesMemory num_bufs = %d\n",save_3d->num_bufs))
 save_3d->roi_start = total = save_3d->num_bufs;
 if (is_save_rois) total += roi_labels->num_strs;
 if (save_3d->is_save_pixmap)
    {save_3d->pixmap_start = total;
     total += 1;}

 *_2ds = NULL;
 *_3d_2ds = NULL;
 *total_3d_2ds = 0;
 *total_2ds = 0;
 PRT3(printf("GetAllViewEchoesMemory...total = %d\n",total))
 if (total > 0)
    {if ((err = get_ptr(_2ds,total_2ds,total,
          (size_t) sizeof(**_2ds))) != NO_ERROR) 
        return err;
     for (lcv = 0; lcv < *total_2ds; lcv++)
        init_buf_2d_rec(&((*_2ds)[lcv]));

     if ((err = get_ptr(_3d_2ds,total_3d_2ds,total,
           (size_t) sizeof(**_3d_2ds))) != NO_ERROR)
        return err;
     for (lcv = 0; lcv < *total_3d_2ds; lcv++)
        setup_3d_plane_2d_rec(&((*_3d_2ds)[lcv]),NULL,NULL,NULL);
    }
 PRT3(printf("..dimx = %d..dimy = %d is_all_echoes = %d num_img_labels = %d\n",
           view->gplane.proj_buf_dimx,view->gplane.proj_buf_dimy,
           is_all_echoes,view->img->file->hdr.analysis.num_img_labels))
 indx = cnt = 0;
 if (save_3d->num_bufs)
    {for (plane_indx = lcv = 0; lcv < view->img->file->hdr.analysis.num_img_labels; lcv++)
        {PRT3(printf("%d) view->id = %s label = %s\n",lcv,view->id,
                view->img->file->hdr.analysis.img_labels[lcv]))
         if (str_cmp(view->id,view->img->file->hdr.analysis.img_labels[lcv]) == 0)
            {plane_indx = lcv;
             break;}
        }
     pixel_depth = view->img->file->hdr.data_info.pixel_depth_bits;
     type4 = InputDataTypeToBufType(&(view->img->file->hdr.data_info));
     for (lcv = 0; lcv < save_3d->num_bufs; lcv++,cnt++,indx += 1)
        {PRT3(printf("==%d) plane_indx = %d indx = %d id = %s\n",lcv,plane_indx,indx,
              view->img->file->hdr.analysis.img_labels[plane_indx]))
         if ((save_3d->num_bufs != 1) && is_all_echoes)
            {id = view->img->file->hdr.analysis.img_labels[lcv];
             if (lcv == plane_indx) save_3d->cur_img_buf_indx = cnt;}
           else 
            {id = view->img->file->hdr.analysis.img_labels[plane_indx];
             save_3d->cur_img_buf_indx = cnt;
            }
         if ((err = Setup3dPlane2dRecBufs(&((*_3d_2ds)[indx]),view->img->file,
             id,&((*_2ds)[cnt]),NULL,
             view->gplane.proj_dimx,view->gplane.proj_dimy,
             view->gplane.proj_buf_dimx,view->gplane.proj_buf_dimy,
             pixel_depth,type4)) != NO_ERROR)
           return err;
        }
    }
 PRT3(printf("indx = %d cnt = %d cur_img_buf_indx = %d\n",
         indx,cnt,save_3d->cur_img_buf_indx))
 if (is_save_rois) 
    {for (lcv = 0; lcv < roi_labels->num_strs; lcv++,cnt += 1,indx+= 1)
        {if ((err = Setup3dPlane2dRecBufs(&((*_3d_2ds)[indx]),view->img->file,
              roi_labels->strs[lcv],&((*_2ds)[cnt]),NULL,
              view->gplane.proj_dimx,view->gplane.proj_dimy,
              view->gplane.proj_buf_dimx,view->gplane.proj_buf_dimy,
              1,0)) != NO_ERROR)
            return err;
        }
     PRT3(printf("num_slice_rois = %d size = % d\n",save_3d->num_slice_rois,
              sizeof(*(save_3d->slice_rois))))
     if ((err = get_ptr(&(save_3d->slice_rois),NULL,save_3d->num_slice_rois,
               sizeof(*(save_3d->slice_rois)))) != NO_ERROR)
        return err;
     for (lcv = 0; lcv < save_3d->num_slice_rois; lcv++)
        init_slice_roi_rec(&(save_3d->slice_rois[lcv]));
    }
 if (save_3d->is_save_pixmap) 
    {PRT3(printf("is_save_pixmap...num_slice_maps = %d\n",
                save_3d->num_slice_maps))
     pixel_depth = find_num_bits_needed((unsigned long)
                  (view->img->file->pixel_type.order.num_strs + 1));
     if ((err = Setup3dPlane2dRecBufs(&((*_3d_2ds)[indx]),view->img->file,
              PIXEL_TYPE_3D_ID,&((*_2ds)[cnt]),NULL,
              view->gplane.proj_dimx,view->gplane.proj_dimy,
              view->gplane.proj_buf_dimx,view->gplane.proj_buf_dimy,
              pixel_depth,0)) != NO_ERROR)
       return err;
     if ((err = get_handle(&(save_3d->slice_maps),NULL,save_3d->num_slice_maps,
               sizeof(**(save_3d->slice_maps)))) != NO_ERROR)
        return err;
     for (lcv = 0; lcv < save_3d->num_slice_maps; lcv++)
        init_buf_2d_rec(save_3d->slice_maps[lcv]);
     PRT3(printf("is_save_pixmap...pixel_depth = %d\n",pixel_depth))
     for (lcv = 0; lcv < save_3d->num_slice_maps; lcv++)
         if ((err = SetupBuf2dRec(save_3d->slice_maps[lcv],
                    view->gplane.proj_dimx,view->gplane.proj_dimy,pixel_depth,
                    0)) != NO_ERROR)
            return err;
     
    }

 PRT3(for (lcv = 0; lcv < total; lcv++)
          {printf("%d) _3d = %u id = %s pl_2d = %u transform_2d = %u\n\n",lcv,
               (*_3d_2ds)[lcv]._3d,(*_3d_2ds)[lcv]._3d->id,
                (*_3d_2ds)[lcv].plane_2d,(*_3d_2ds)[lcv].transform_2d);
           pr_buf_2d_rec((*_3d_2ds)[lcv].plane_2d);
           if ((*_3d_2ds)[lcv].transform_2d != NULL)
              pr_buf_2d_rec((*_3d_2ds)[lcv].transform_2d);
           printf("\n");
          }
      )
 PRT3(printf("GetAllViewEchoesMemory..\n\n"))
 if ((save_3d->num_coregs > 0) && (save_3d->status & SAVE_CO_REG_OK))
    return setup_coreg_memory(save_3d);

 return NO_ERROR;
}


/*----------------------------------------------------------------
save_3d_err_message - ???
----------------------------------------------------------------*/

void
save_3d_err_message(_3d,select)
 struct save_menu_3d_rec *_3d;
 int select;
{
 char str[100],str1[100];
 int result;

 if (select == 1)
    {sprintf(str,"Error saving %s...err = %d",_3d->hdr_fn,_3d->save_err);
     sprintf(str1,"%s was ok !!! Delete it anyway...?",_3d->imgfn);
     result = notice_prompt(_3d->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,str,str1,0,
            NOTICE_BUTTON_YES," Delete it !",
            NOTICE_BUTTON_NO," NO !",
            0);
     if (result == NOTICE_YES) _3d->status &= ~SAVE_IMG_OK;
    }
   else if (select == 2)
    {sprintf(str,"Error saving %s...err = %d",_3d->imgfn,_3d->save_err);
     notice_prompt(_3d->frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,str,0,
          NOTICE_BUTTON_YES,FAILED,0);}
   else if (select == 3)
    {sprintf(str,"Not enough disk space for %s...",_3d->imgfn);
     notice_prompt(_3d->frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,str,0,
          NOTICE_BUTTON_YES,FAILED,0);}
   else if (select == 4)
    {sprintf(str,"Not enough Memory space for saving the data");
     notice_prompt(_3d->frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,str,0,
          NOTICE_BUTTON_YES,FAILED,0);}
   else if (select == 5)
    {sprintf(str,"Error saving the 3d ndat data");
     notice_prompt(_3d->frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,str,0,
          NOTICE_BUTTON_YES,FAILED,0);}

}


/*----------------------------------------------------------------
enlarge_view_bufs - ???
----------------------------------------------------------------*/

int
enlarge_view_bufs(_3d,view)
 struct save_menu_3d_rec *_3d;
 struct view_rec *view;
{
 long lcv;
 int err;

 TRACE(printf("enlarge_view_bufs proj dimx = %d dimy = %d dimx = %d dimy = %d\n",
       view->gplane.proj_dimx,view->gplane.proj_dimy,
       _3d->_3d_2ds[0].plane_2d->dimx,_3d->_3d_2ds[0].plane_2d->dimy))
 for (lcv = 0; lcv < _3d->num_bufs; lcv++)
    {TRACE(printf("%d) enlarge_view_bufs...\n",lcv))
     TRACE(pr_buf_2d_rec(_3d->_3d_2ds[lcv].plane_2d))

     if ((err = SetupBuf2dRecIfSmall(_3d->_3d_2ds[lcv].plane_2d,
          view->gplane.proj_dimx,view->gplane.proj_dimy,
          view->img->file->hdr.data_info.pixel_depth_bits, 
          InputDataTypeToBufType(&(view->img->file->hdr.data_info)))) != NO_ERROR)
        return err;
     TRACE(printf("......%d) enlarge_view_bufs...\n",lcv))
     TRACE(pr_buf_2d_rec(_3d->_3d_2ds[lcv].plane_2d))
    }
 return NO_ERROR;
}


/*----------------------------------------------------------------
save_3d_img - ???
----------------------------------------------------------------*/

int
save_3d_img(_3d,whch)
 struct save_menu_3d_rec *_3d;
 int whch;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 long indx,lcv,cnt;
 unsigned long status4;
 struct slice_roi_rec *slice_roi,*slice_roi1;
 int is_roi_ok,err;
 struct buf_2d_rec _2d;
 struct color_data_rec *color_data;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 PRT4(printf("\nsave_3d_img _3d->cur_sl = %d  end_sl = %d num_3d_2ds = %d is_save_img = %d\n",
     _3d->cur_sl,_3d->end_sl,_3d->num_3d_2ds,_3d->is_save_img))

 if (_3d->cur_sl <= _3d->end_sl)
    {status4 = view->img->status4;
     view->img->status4 &= ~IMAGE_3D_SUPERIMPOSED_READY;
     locate_plane(&(view->gplane),_3d->cur_sl - 1,0);
/*
     if ((_3d->_3d_2ds[0].plane_2d->dimx != view->gplane.proj_dimx) ||
         (_3d->_3d_2ds[0].plane_2d->dimy != view->gplane.proj_dimy))
        _3d->save_err = enlarge_view_bufs(_3d,view);
*/
     if ((_3d->save_err == NO_ERROR) && (_3d->num_3d_2ds > 0))
        _3d->save_err = _3dPlane2ds(&(view->gplane),
             _3d->_3d_2ds,_3d->num_3d_2ds);

     PRT3(printf("_3d->cur_sl = %d   proj dimx = %d dimy = %d num_3d_2ds = %d num_bufs = %d\n",
       _3d->cur_sl,view->gplane.proj_buf_dimx,
       view->gplane.proj_buf_dimy,_3d->num_3d_2ds,_3d->num_bufs))
/*
     if ((_3d->save_err == NO_ERROR) &&
         ((_3d->save_err = transform_plane_2ds(&(view->gplane),_3d->_3d_2ds,
                 _3d->num_bufs)) == NO_ERROR))
*/
     if (_3d->save_err == NO_ERROR)
        {if (_3d->is_save_img)
            for (indx = 0; indx < _3d->num_bufs; indx++)
               {
                if (fwrite(_3d->_3d_2ds[indx].plane_2d->buf[0],
                     (size_t) _3d->_3d_2ds[indx].plane_2d->total_bytes,1,
                      _3d->imgfid) != 1)
                   {_3d->save_err = WRITE_ERROR;
                    break;}
               }
         if ((_3d->save_err == NO_ERROR) && _3d->is_save_rois)
            {
             PRT3(printf("show img..._3d->num_bufs = %d\n",
                    _3d->is_show_rois_on_img,_3d->num_bufs))
             cnt = (_3d->cur_sl - _3d->start_sl) / _3d->skip_sl;
             PRT3(printf("num_slice_rois = %d  sl-indx = %d\n",
                _3d->num_slice_rois,cnt))
             slice_roi1 = &(_3d->slice_rois[cnt]);
             PRT3(printf("num_rois = %d\n",slice_roi1->num_rois))
             if (_3d->is_show_rois_on_img)
                {slice_roi = &(view->sl.slice_roi_win.slice_roi);
                 DeleteRoisOfType(slice_roi,ROI_3D_ROI,2);}

             for (indx = _3d->roi_start,lcv = 0;lcv < _3d->roi_labels.num_strs; lcv++)
                if ((_3d->save_err = ScanRoiFromBuf(slice_roi1,
                       _3d->roi_labels.strs[lcv],_3d->_3d_2ds[indx].plane_2d,
                       ROI_3D_ROI,&is_roi_ok)) != NO_ERROR)
                   break;
                  else 
                   {if (_3d->is_show_rois_on_img)
                       if (((err = CpSliceRoiRec(slice_roi,slice_roi1,NULL,NULL,NULL))
                              != NO_ERROR) ||
                           ((err = SetSameRoisStatus(slice_roi,slice_roi1,
                              (unsigned short) 0xffff,0,
                              (unsigned short) 0xffff,ROI_3D_ROI)) != NO_ERROR))
                          break;
                    indx += 1;}
            }
         if ((_3d->save_err == NO_ERROR) && _3d->is_save_pixmap)
            {cnt = (_3d->cur_sl - _3d->start_sl) / _3d->skip_sl;
             PRT3(printf(" cnt = %d pix start = %d num_slice_maps = %d num_3d_2ds = %d\n",
               cnt,_3d->pixmap_start,_3d->num_slice_maps,_3d->num_3d_2ds))
             if ((_3d->save_err = copy_buf_2d_rec(_3d->slice_maps[cnt],
                            _3d->_3d_2ds[_3d->pixmap_start].plane_2d)) == NO_ERROR)
                _3d->slice_maps[cnt]->status4 |= BUF_DATA_VALID;
             if (xv_get(_3d->show_pixel_types_item,PANEL_VALUE))
                if (WinFindColorDataRec1(_3d->win,SUPERIMPOSE_3D_ID,0,
                          &color_data,NULL) == NO_ERROR)
                   {PRT7(printf("...show...SUPERIMPOSE_3D_ID\n"))
                    if (color_data->status4 & COLOR_DATA_DISABLED)
                       {PRT7(printf("...enable...SUPERIMPOSE_3D_ID\n"))
                        WinEnableDisableColorData(_3d->win,SUPERIMPOSE_3D_ID,0);}
                    InitBuf2dRecData(&(color_data->_2d),(double) .0);
                    Assign2d(&(color_data->_2d),_3d->slice_maps[cnt]);
                    AddConstantTo2d(&(color_data->_2d),
                     (double) _3d->win->intensity->color.reserve_color_start,1);
                    color_data->_2d.status4 |= BUF_DATA_VALID;}

             PRT7(printf("is_save_pixmap err = %d\n",_3d->save_err);)
            }
        }
     if (_3d->save_err == NO_ERROR)
        {view->sl.slice.num = _3d->cur_sl;
         xv_set(_3d->start,PANEL_VALUE,_3d->cur_sl,0);
         if (_3d->is_save_img || _3d->is_show_rois_on_img)
            {PRT3(printf("is_save_img = %d\n",_3d->is_save_img))
             update_view_slice_roi_rec(view);
             if (view->img->win != NULL)
                {win_multiple_set_frame_label(_3d->win);
                 _2d = view->img->_2d;
                 view->img->_2d = *(_3d->_3d_2ds[_3d->cur_img_buf_indx].plane_2d);
                 Assin2dMinMaxSetVals(&(view->img->_2d),&_2d);
                 WinNewColorMultiCanvas(_3d->win);
                 view->img->_2d = _2d;
                }
            }
         _3d->cur_sl += _3d->skip_sl;
        }
       else save_3d_err_message(_3d,2);
     
     view->img->status4 = status4;
     if (_3d->save_err == NO_ERROR)
        {if ((_3d->num_coregs > 0) && (_3d->status & SAVE_CO_REG_OK))
            save_coreg_image(_3d);
        }
    }

 if ((_3d->save_err == NO_ERROR) && (_3d->cur_sl > _3d->end_sl))
    {
     PRT3(printf("....done...\n"))
     if (_3d->is_save_img)
        {_3d->status |= SAVE_IMG_OK;
         if ((_3d->save_err = save_3d_hdr(_3d->fid,_3d)) != NO_ERROR)
            save_3d_err_message(_3d,1);
           else _3d->status |= SAVE_HDR_OK;
        }
     if ((_3d->save_err == NO_ERROR) && _3d->is_save_rois)
        save_3d_ndat(_3d);
     if ((_3d->save_err == NO_ERROR) && _3d->is_save_pixmap)
        save_3d_pixmap(_3d);

     if (_3d->save_err == NO_ERROR)
        {if ((_3d->num_coregs > 0) && (_3d->status & SAVE_CO_REG_OK))
            save_co_reg_end(_3d);
        }
    }

 if (_3d->save_err || (_3d->cur_sl > _3d->end_sl))
    {notify_set_itimer_func((Notify_client) _3d,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
     return save_3d_end(_3d);}
 return _3d->save_err;
}


/*----------------------------------------------------------------
save_the_3d_hdr - ???
----------------------------------------------------------------*/

int
save_the_3d_hdr(fid,_3d,gplane,_3d_data,def_hdr)
 FILE *fid;
 struct save_menu_3d_rec *_3d;
 struct plane_3d_rec *gplane;
 struct buf_3d_rec *_3d_data;
 struct hdr_rec *def_hdr;
{
 struct hdr_rec hdr;
 struct data_info_rec *info;
 int err;

 hdr = *def_hdr;
 info = &(hdr.data_info);
 info->dimx = gplane->proj_buf_dimx;
 info->dimy = gplane->proj_buf_dimy;
 info->max_scans = _3d->total_slices_saved;
 info->var_use_status &= ~NUM_SCANS_USED;

 DefinePixelSize(_3d,&(info->xpixel_size),&(info->ypixel_size),
          &(info->pixel_thickness),gplane,_3d_data);
 PRT9(printf("xpixel_size = %f y = %f z = %f \n",
    info->xpixel_size,info->ypixel_size,info->pixel_thickness))

 if ( (_3d->all_echoes != 0) &&
      ((int) xv_get(_3d->all_echoes,PANEL_VALUE) == 0) )
    {info->num_echoes = 1;
     hdr.status |= _1_ECHO_IMAGE;
     hdr.analysis.num_img_labels = 1;
     hdr.analysis.img_labels = &(_3d_data->id);
    }
 hdr.num_scans = 0;
 hdr.scans = NULL;
 if ((err = BuildRiaHdr(&hdr,0)) == NO_ERROR)
    {
 PRT9(printf("===xpixel_size = %f y = %f z = %f \n",
    info->xpixel_size,info->ypixel_size,info->pixel_thickness))
     err = wr_hdr(fid,&hdr);}

 c_free(hdr.scans);
 return err;
}


/*----------------------------------------------------------------
save_3d_hdr - ???
----------------------------------------------------------------*/

int
save_3d_hdr(fid,_3d)
 FILE *fid;
 struct save_menu_3d_rec *_3d;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 struct buf_3d_rec *_3d_data;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 if (view == NULL) return CANCEL;
 find_file_3d(img->file,view->id,&_3d_data);
 if (_3d_data == NULL) return CANCEL;
 return save_the_3d_hdr(fid,_3d,&(view->gplane),_3d_data,&(img->file->hdr));
}


/*----------------------------------------------------------------
save_3d_ndat - ???
----------------------------------------------------------------*/

int
save_3d_ndat(_3d)
 struct save_menu_3d_rec *_3d;
{
 struct img_buf_rec *img;
 struct pixel_type_rec *pixel_type,type;

 PRT3(printf("save_3d_ndat..._3d->ndatfn = %s\n",_3d->ndatfn))
 if ((get_strlen(_3d->ndatfn) == 0) || (_3d->slice_rois == NULL) ||
     ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL))
    return CANCEL;
 PRT3(printf("save_3d_ndat...1\n"))
 if ((get_strlen(_3d->pixmapfn) != 0) && _3d->is_save_pixmap &&
     (_3d->slice_maps != NULL))
    {init_pixel_type_rec(&type);
     type.order = img->file->pixel_type.order;
     type.status = PIXEL_TYPE_COMPUTED | PIXEL_TYPE_ALL_ROIS_COMPUTED;
     if ((img->file->hdr.data_info.num_echoes == 2) &&
        !(img->file->pixel_type.status & PIXMAP_METHOD_DEFINED))
        {type.status |= PIXEL_TYPE_2D_PARTITION_SETUP;
         type.pixmap_hdr.status |= PIXEL_TYPE_SETUP_2D_PARTITION;}
       else
        type.status |= PIXEL_TYPE_GROW_REGION_SETUP;
     PRT6(printf("save_3d_ndat...type.status = %x\n",(unsigned long) type.status))
     pixel_type = &type;}
   else pixel_type = NULL;
 if ((_3d->save_err = WrRiaNdatFile(_3d->ndatfn,&(img->file->output.hdr),
       _3d->slice_rois,_3d->num_slice_rois,NULL,pixel_type,
       img->file->text.groups,img->file->text.num_groups,
       &(img->file->text.format),NULL)) != NO_ERROR)
    {save_3d_err_message(_3d,5);
     return _3d->save_err;}
 PRT3(printf("save_3d_ndat...end\n"))
 _3d->status |= SAVE_NDAT_OK;
 return NO_ERROR;
}


/*----------------------------------------------------------------
save_3d_pixmap - ???
----------------------------------------------------------------*/

int
save_3d_pixmap(_3d)
 struct save_menu_3d_rec *_3d;
{
 struct img_buf_rec *img;
 struct pixmap_hdr_rec hdr;

 PRT3(printf("save_3d_pixmap..._3d->pixmapfn = %s\n",_3d->pixmapfn))
 if ((get_strlen(_3d->pixmapfn) == 0) || (_3d->slice_maps == NULL) ||
     ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL))
    return CANCEL;
 PRT3(printf("save_3d_pixmap...1\n"))

 init_pixmap_hdr_rec(&hdr);
 if ((img->file->hdr.data_info.num_echoes == 2) &&
     !(img->file->pixel_type.status & PIXMAP_METHOD_DEFINED))
    {hdr.status |= PIXEL_TYPE_SETUP_2D_PARTITION;}
 PRT6(printf("save_3d_pixmap...hdr.status = %x\n",(unsigned long) hdr.status))
 _3d->save_err = WrPixmap(_3d->pixmapfn,&(img->file->pixel_type.order),
             _3d->slice_maps,_3d->num_slice_maps,&hdr); 
 PRT6(printf("after...hdr.status = %x\n",(unsigned long) hdr.status))
 free_pixmap_hdr_rec(&hdr);
 if (_3d->save_err != NO_ERROR)
    {save_3d_err_message(_3d,5);
     return _3d->save_err;}
 PRT3(printf("save_3d_pixmap...end\n"))
 _3d->status |= SAVE_PIXMAP_OK;
 return NO_ERROR;
}


/*----------------------------------------------------------------
open_input_file - ???
----------------------------------------------------------------*/

int
open_input_file(dir,fn,suffix,the_fn,fid,frame)
 char *dir,*fn,*suffix,**the_fn;
 FILE **fid;
 Frame frame;
{
 int err;
 char *reason;

 *fid = NULL;
 *the_fn = NULL;
 if ((err = build_fn(the_fn,dir,fn,suffix)) != NO_ERROR)
    {notice_prompt(frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,"Error setting up the input file names !!!",0,
          NOTICE_BUTTON_YES,FAILED,0);
     return err;}
 if ((err = file_access(*the_fn,12,NULL,&reason)) != NO_ERROR)
    {notice_prompt(frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,"File Access Error !!!",
          reason,0,
          NOTICE_BUTTON_YES,FAILED,0);
     c_free(reason);
     return err;}
 if ((*fid = fopen(*the_fn,"r")) == NULL)
    {notice_prompt(frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,"File Open Error !!!",
          "NO Read Privilege !!! ?",0,
          NOTICE_BUTTON_YES,FAILED,0);
     fclose(*fid);
     return FILE_ACCESS_ERROR;}
 return NO_ERROR;
}


/*----------------------------------------------------------------
open_output_file - ???
----------------------------------------------------------------*/

int
open_output_file(dir,fn,suffix,the_fn,fid,frame,is_replace)
 char *dir,*fn,*suffix,**the_fn;
 FILE **fid;
 Frame frame;
 int is_replace;
{
 int err,result;
 char str[150],*reason;

 *fid = NULL;
 *the_fn = NULL;
 if ((err = build_fn(the_fn,dir,fn,suffix)) != NO_ERROR)
    {notice_prompt(frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,"Error setting up the output file names !!!",0,
          NOTICE_BUTTON_YES,FAILED,0);
     return err;}
 else if (!is_replace && (access(*the_fn,F_OK) == 0))
    {sprintf(str,"File %s already exists !!!",*the_fn);

     result = notice_prompt(frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,str,"Replace it ? !!!",0,
            NOTICE_BUTTON_YES," Replace !",
            NOTICE_BUTTON_NO," NO !",
            0);
     if (result == NOTICE_NO) return CANCEL;
    }

 if ((err = file_access(*the_fn,WORLD_WRITE_MODE,NULL,&reason)) != NO_ERROR)
    {notice_prompt(frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,"File Access Error !!!",
          reason,0,
          NOTICE_BUTTON_YES,FAILED,0);
     c_free(reason);
     return err;}
 if ((*fid = fopen(*the_fn,"w+")) == NULL)
    {notice_prompt(frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,"File Open Error !!!",
          "NO Write Privilege !!! ?",0,
          NOTICE_BUTTON_YES,FAILED,0);
     return FILE_ACCESS_ERROR;}
 return NO_ERROR;
}


/*----------------------------------------------------------------
alloc_img_file - ???
----------------------------------------------------------------*/

int
alloc_img_file(imgfid,_3d)
 FILE *imgfid;
 struct save_menu_3d_rec *_3d;
{
 unsigned long max_slices,size,num_row_bytes;
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 max_slices = num_output_3d_slices(_3d,(int) img->file->hdr.analysis.num_img_labels);
 num_row_bytes = GetRowBytes(view->gplane.proj_buf_dimx,
                    img->file->hdr.data_info.pixel_depth_bits);
 size = num_row_bytes * view->gplane.proj_buf_dimy * max_slices;
 TRACE(printf("num_row_bytes = %d dimx = %d dimy = %d  size = %d\n",
      num_row_bytes,view->gplane.proj_buf_dimx,view->gplane.proj_buf_dimy,size))
 return file_set_size(imgfid,size);
}


/*----------------------------------------------------------------
Save3dStart - ???
----------------------------------------------------------------*/

int
Save3dStart(_3d,img,view)
 struct save_menu_3d_rec *_3d;
 struct img_buf_rec *img;
 struct view_rec *view;
{
 struct color_data_rec *color_data;

 _3d->coregs = NULL;
 _3d->num_coregs = 0;

_3d->fid = NULL;
 _3d->imgfid = NULL;
 _3d->hdr_fn = NULL;
 _3d->imgfn = NULL;
 _3d->ndatfn = NULL;
 _3d->pixmapfn = NULL;
 _3d->save_err = NO_ERROR;
 _3d->status |= SAVE_START;
 PRT3(printf("Save3dStart...num_output_3d_slices\n"))
 if ( (_3d->all_echoes != 0) &&
       xv_get(_3d->all_echoes,PANEL_VALUE) )
    _3d->is_all_echoes = 1;
   else _3d->is_all_echoes = 0;

 _3d->total_slices_saved = num_output_3d_slices(_3d,
                 (int) img->file->hdr.analysis.num_img_labels);
 if (_3d->is_all_echoes) 
    _3d->num_slice_maps = _3d->num_slice_rois = _3d->total_slices_saved / 
         img->file->hdr.analysis.num_img_labels;
   else 
    {_3d->num_slice_maps = _3d->num_slice_rois = _3d->total_slices_saved;}

 PRT3(printf("Save3dStart...total_slices_saved = %d num_slice_rois = %d\n",
         _3d->total_slices_saved,_3d->num_slice_rois))

 PRT3(printf("Save3dStart...2\n"))
 _3d->total_3d_2ds = 0;
 _3d->_3d_2ds = NULL;
 _3d->total_2ds = 0;
 _3d->_2ds = NULL;
 _3d->slice_rois = NULL;

 _3d->slice_maps = NULL;

 _3d->plane = view->gplane;
 _3d->cur_sl = _3d->start_sl = (int) xv_get(_3d->start,PANEL_VALUE);
 _3d->end_sl = (int) xv_get(_3d->end,PANEL_VALUE);
 _3d->skip_sl = (int) xv_get(_3d->skip,PANEL_VALUE);
 _3d->cur_slice_num = view->sl.slice.num;

 if (_3d->total_slices_saved == 0)
    {_3d->save_err = CANCEL;
     return save_3d_end(_3d);}
 if (WinFindColorDataRec1(_3d->win,SUPERIMPOSE_3D_ID,0,&color_data,NULL) == NO_ERROR)
    {_3d->status |= SAVE_SUPERIMPOSE_3D_EXIST;
     if (!(color_data->status4 & COLOR_DATA_DISABLED))
        {_3d->status |= SAVE_SHOW_SUPERIMPOSE_3D;
         if (xv_get(_3d->show_pixel_types_item,PANEL_VALUE) == 0)
            {PRT7(printf("Save3dStart disabling SUPERIMPOSE_3D_ID\n");)
             WinEnableDisableColorData(_3d->win,SUPERIMPOSE_3D_ID,1);}
        }
    }
 xv_set(_3d->save_rois_item,PANEL_INACTIVE,TRUE,0);
 xv_set(_3d->show_rois_on_img_item,PANEL_INACTIVE,TRUE,0);
 xv_set(_3d->save_npar,PANEL_INACTIVE,TRUE,0);
 xv_set(_3d->save_pixmap_item,PANEL_INACTIVE,TRUE,0);
 xv_set(_3d->save_img_item,PANEL_INACTIVE,TRUE,0);
 if (_3d->save_coreg != 0) return setup_save_co_reg_rec(_3d);
 return NO_ERROR;
}


/*----------------------------------------------------------------
save_3d_end - ???
----------------------------------------------------------------*/

int
save_3d_end(_3d)
 struct save_menu_3d_rec *_3d;
{
 long lcv;
 struct img_buf_rec *img;
 struct view_rec *view;
 struct color_data_rec *color_data;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 PRT3(printf("save_3d_end...start\n"))
 if (_3d->fid != NULL) fclose(_3d->fid);
 if (_3d->imgfid != NULL) fclose(_3d->imgfid);

 PRT3(printf("save_3d_end...2\n"))
 if (_3d->save_err)
    {if ((_3d->hdr_fn != NULL) && (_3d->status & CAN_DELETE_NHDR) &&
         !(_3d->status & SAVE_HDR_OK)) 
        {PRT3(printf("CAN_DELETE_NHDR...\n"))
         delete_file(_3d->hdr_fn);}
     if ((_3d->imgfn != NULL) && (_3d->status & CAN_DELETE_IMG) &&
         !(_3d->status & SAVE_IMG_OK))
        {PRT3(printf("CAN_DELETE_IMG...\n"))
         delete_file(_3d->imgfn);}
     if ((_3d->ndatfn != NULL) && (_3d->status & CAN_DELETE_NDAT) &&
         !(_3d->status & SAVE_NDAT_OK))
        {PRT3(printf("CAN_DELETE_NDAT...\n"))
         delete_file(_3d->ndatfn);}
      if ((_3d->pixmapfn != NULL) && (_3d->status & CAN_DELETE_PIXMAP) &&
         !(_3d->status & SAVE_PIXMAP_OK))
        {PRT3(printf("CAN_DELETE_PIXMAP...\n"))
         delete_file(_3d->pixmapfn);}
   }
 PRT3(printf("save_3d_end...free_3d_co_reg_rec\n"))
 c_free(_3d->hdr_fn);
 c_free(_3d->imgfn);
 c_free(_3d->ndatfn);
 c_free(_3d->pixmapfn);

 if (_3d->num_coregs > 0) free_3d_co_reg_rec(_3d);

 PRT3(printf("save_3d_end...3\n"))

 if (_3d->total_3d_2ds) c_free(_3d->_3d_2ds);
 for (lcv = 0; lcv < _3d->total_2ds; lcv++)
    free_buf_2d_rec(&(_3d->_2ds[lcv]));
 c_free(_3d->_2ds);
 if (_3d->is_save_rois && (_3d->slice_rois != NULL))
    {for (lcv = 0; lcv < _3d->num_slice_rois; lcv++)
        free_slice_roi_rec(&(_3d->slice_rois[lcv]));
     c_free(_3d->slice_rois);
    }

 if (_3d->is_save_pixmap && (_3d->slice_maps != NULL))
    {
     for (lcv = 0; lcv < _3d->num_slice_maps; lcv++)
        {free_buf_2d_rec(_3d->slice_maps[lcv]);
         c_free(_3d->slice_maps[lcv]);}
     c_free(_3d->slice_maps);
     _3d->slice_maps = NULL;
    }

 view->sl.slice.num = _3d->cur_slice_num;
 view->gplane = _3d->plane;
 PRT3(printf("save_3d_end...is_show_rois_on_img = %d\n",_3d->is_show_rois_on_img))
 if (_3d->is_show_rois_on_img)
    {PRT3(printf("save_3d_end...num_rois = %d\n",
           view->sl.slice_roi_win.slice_roi.num_rois))
     DeleteRoisOfType(&(view->sl.slice_roi_win.slice_roi),ROI_3D_ROI,2);
     PRT3(printf("save_3d_end...num_rois = %d\n",
           view->sl.slice_roi_win.slice_roi.num_rois))}

 PRT3(printf("save_3d_end.._3d->status = %x\n\n",(unsigned long) _3d->status))
 if (_3d->status & SAVE_SUPERIMPOSE_3D_EXIST)
    {if (_3d->status & SAVE_SHOW_SUPERIMPOSE_3D)
        WinEnableDisableColorData(_3d->win,SUPERIMPOSE_3D_ID,0);
       else WinEnableDisableColorData(_3d->win,SUPERIMPOSE_3D_ID,1);
    }
   else if (WinFindColorDataRec1(_3d->win,SUPERIMPOSE_3D_ID,0,
                &color_data,NULL) == NO_ERROR)
    {PRT7(printf("save_3d_end..delete SUPERIMPOSE_3D_ID\n"))
     WinDropColorDataRec1(_3d->win,SUPERIMPOSE_3D_ID,1,0,NULL,1);}

 _3d->status = 0;
 BuildAndDisplayPlaneData(view);
 PRT3(printf("save_3d_end...5\n"))

 xv_set(_3d->start,PANEL_VALUE,_3d->start_sl,0);
 setup_cur_dim_msg(_3d);

 xv_set(_3d->save_rois_item,PANEL_INACTIVE,FALSE,0);
 xv_set(_3d->show_rois_on_img_item,PANEL_INACTIVE,FALSE,0);
 xv_set(_3d->save_npar,PANEL_INACTIVE,FALSE,0);
 xv_set(_3d->save_pixmap_item,PANEL_INACTIVE,FALSE,0);
 xv_set(_3d->save_img_item,PANEL_INACTIVE,FALSE,0);
 set_win_not_busy(_3d->win);
 return _3d->save_err;
}


/*----------------------------------------------------------------
Save3d - ???
----------------------------------------------------------------*/

int
Save3d(view,_3d)
 struct view_rec *view;
 struct save_menu_3d_rec *_3d;
{
 struct img_buf_rec *img;
 char *dir,*fn;
 int err;
 FILE *fid;

 PRT3(printf("save_3d...view->wid = %s roi_labels\n",view->wid))
 if ((img = view->img) == NULL) return CANCEL;
 if ((int) xv_get(_3d->save_npar,PANEL_VALUE)) 
    if ((err = Save3dNpar(_3d)) != NO_ERROR) return err;

 if ((err = Save3dStart(_3d,img,view)) != NO_ERROR)
    {notice_prompt(_3d->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,"3D SAVE SETUP ERROR !!!",0,
            NOTICE_BUTTON_YES," ABORT !",
            0);
     return err;}
 PRT3(printf("save_3d...1\n"))
 dir = (char *) xv_get(_3d->dir,PANEL_VALUE);
 fn = (char *) xv_get(_3d->fn,PANEL_VALUE);
 set_win_busy(_3d->win);

 if (_3d->is_save_img)
    {if ((_3d->save_err = open_output_file(dir,fn,img->file->hdr_fn_suffix,
          &(_3d->hdr_fn),&(_3d->fid),_3d->frame,0)) == NO_ERROR)
        {_3d->status |= CAN_DELETE_NHDR;
         if ((_3d->save_err = open_output_file(dir,fn,img->file->img_fn_suffix,
              &(_3d->imgfn),&(_3d->imgfid),_3d->frame,0)) == NO_ERROR)
            _3d->status |= CAN_DELETE_IMG;
           else return save_3d_end(_3d);
        }
       else return save_3d_end(_3d);
    }
 PRT3(printf("save_3d..._3d->imgfid = %u\n",_3d->imgfid))
 if (_3d->is_save_rois)
    {fid = NULL;
      _3d->save_err = open_output_file(dir,fn,".ndat",
             &(_3d->ndatfn),&fid,_3d->frame,0);
     if (fid != NULL) fclose(fid);
     if (_3d->save_err != NO_ERROR)
        return save_3d_end(_3d);
       else _3d->status |= CAN_DELETE_NDAT;
    }
 if (_3d->is_save_pixmap)
    {fid = NULL;
      _3d->save_err = open_output_file(dir,fn,".pixmap",
             &(_3d->pixmapfn),&fid,_3d->frame,0);
     if (fid != NULL) fclose(fid);
     if (_3d->save_err != NO_ERROR)
        return save_3d_end(_3d);
       else _3d->status |= CAN_DELETE_PIXMAP;
    }

 if ((_3d->num_coregs > 0) && (_3d->status & SAVE_CO_REG_OK))
    open_coreg_files(_3d);

 if (_3d->is_save_img &&
     ((_3d->save_err = alloc_img_file(_3d->imgfid,_3d)) != NO_ERROR))
    {save_3d_err_message(_3d,3);
     return save_3d_end(_3d);
    }
   else if ((_3d->save_err = GetAllViewEchoesMemory(_3d,view,&(_3d->_3d_2ds),
         &(_3d->total_3d_2ds),&(_3d->_2ds),&(_3d->total_2ds),
         _3d->is_all_echoes,_3d->is_save_rois,&(_3d->roi_labels))) != NO_ERROR)
    {if (_3d->save_err != CANCEL) save_3d_err_message(_3d,4);
     return save_3d_end(_3d);}
   else
    {
     _3d->num_3d_2ds = _3d->total_3d_2ds;
     PRT3(printf(".........save_3d_img\n"))
     PRT3(printf("save_3d..._3d->imgfid = %u\n",_3d->imgfid))
     notify_set_itimer_func((Notify_client) _3d,
                (Notify_func) save_3d_img,ITIMER_REAL,
                &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
     return NO_ERROR;
    }
}


/*----------------------------------------------------------------
load_3d_pixel_types_proc - ???
----------------------------------------------------------------*/

void
load_3d_pixel_types_proc(view,_3d)
 struct view_rec *view;
 struct save_menu_3d_rec *_3d;
{
 PRT5(printf("load_3d_pixel_types_proc...\n"))
 get_file_3d(view->img->file,PIXEL_TYPE_3D_ID,
           Save3d,Save3d,view,_3d,NULL,NULL,2,NULL);
}


/*----------------------------------------------------------------
load_3d_rois_proc - ???
----------------------------------------------------------------*/

void
load_3d_rois_proc(view,_3d)
 struct view_rec *view;
 struct save_menu_3d_rec *_3d;
{
 unsigned long cur;

 PRT3(printf("load_3d_rois_proc..plane id = %s   num_strs = %d cur_str = %d  _3d = %u\n",
                view->id,_3d->roi_labels.num_strs,view->rois.cur_str,_3d))
 if (!(view->status & PLANE_3D_LOAD_DATA_ERROR))
    if (_3d->roi_labels.cur_str < _3d->roi_labels.num_strs)
       {
        PRT3(printf("_3d->roi_labels.cur_str = %d\n",_3d->roi_labels.cur_str))
        cur = _3d->roi_labels.cur_str;
        _3d->roi_labels.cur_str += 1;
        get_file_3d(view->img->file,_3d->roi_labels.strs[cur],
           load_3d_rois_proc,load_3d_rois_proc,view,_3d,NULL,NULL,3,NULL);
        PRT3(printf("continue with get_file_3d \n"))
       }
      else if (_3d->is_save_pixmap)
       load_3d_pixel_types_proc(view,_3d);
      else Save3d(view,_3d);
}


/*----------------------------------------------------------------
SaveThe3dNow - ???

FIXME:  It's not clear whether this should be type int or void.
It is used in SetupAll3dEchoes below, but it chases through so
many levels of obfuscation that I can't tell how it is eventually
called.  -PWH 19990319
----------------------------------------------------------------*/

SaveThe3dNow(view,_3d)
 struct view_rec *view;
 struct save_menu_3d_rec *_3d;
{
 struct img_buf_rec *img;
 struct view_rec *view1;
 int (*proc)();
 unsigned long lcv;
 struct save_co_reg_rec *coreg;

 PRT10(printf("SaveThe3dNow..._3d = %u _3d->num_coregs = %d\n",_3d,_3d->num_coregs))
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 if (_3d->is_all_echoes)
    {for (lcv = 0; lcv < _3d->num_coregs; lcv++)
        {coreg = &(_3d->coregs[lcv]);
         if (coreg->err != NO_ERROR) continue;
         if ((coreg->status & SAVE_CO_REG_BUF_READY) &&
             (coreg->status & SAVE_COREG_NHDR_READY) &&
             (coreg->status & SAVE_COREG_IMG_READY))
            return 1;
         if (coreg->status & SAVE_CO_REG_ALL_ECHOES_READY)
            continue;
         coreg->status |= SAVE_CO_REG_ALL_ECHOES_READY;
         if ((view1 = find_any_view_rec(view->file,coreg->co.wid)) != NULL) {
	    /* FIXME: Function called in next line returns no value but 
	       was the return value of this function.  -PWH 19990519 */
            SetupAll3dEchoes(view1,0,SaveThe3dNow,_3d,
			     1,"Loading all 3D image echoes...");
	    return; }
        }
    }

 if (_3d->is_save_rois)
    {_3d->roi_labels.cur_str = 0;
     proc = load_3d_rois_proc;}
   else if (_3d->is_save_pixmap)
    {
     proc = load_3d_pixel_types_proc;}
   else proc = Save3d;
 proc(view,_3d);
 PRT10(printf("SaveThe3dNow...end\n"))
}


/*----------------------------------------------------------------
SaveThe3d - ???

FIXME:  This is probably return type void but that is not yet
completely clear.  -PWH 19990321
----------------------------------------------------------------*/

void
SaveThe3d(_3d)
 struct save_menu_3d_rec *_3d;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ( (_3d->all_echoes != 0) &&
       xv_get(_3d->all_echoes,PANEL_VALUE) )
    {_3d->is_all_echoes = 1;
     if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL)
       return /* CANCEL */;
     view = img->cur_slice->slice->view;
     SetupAll3dEchoes(view,0,SaveThe3dNow,_3d,
               1,"Loading all 3D image echoes...");
    }
   else
    {_3d->is_all_echoes = 0;
     SaveThe3dNow(view,_3d);}
}


/*----------------------------------------------------------------
Save3dNpar - ???
----------------------------------------------------------------*/

int
Save3dNpar(_3d)
 struct save_menu_3d_rec *_3d;
{
 char *dir,*fn;
 struct img_buf_rec *img;
 struct view_rec *view;
 int err;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 dir = (char *) xv_get(_3d->dir,PANEL_VALUE);
 fn = (char *) xv_get(_3d->fn,PANEL_VALUE);
 if ((err = SaveNpar(dir,fn,NPAR_SUFFIX,_3d->frame,0,
            &(view->gplane),NULL,0)) != NO_ERROR)
    return err;
 return err;
/*
 if (_3d->is_save_rois || _3d->is_save_img))
    return ShowMsgStrs(_3d->frame,1,NO_ERROR,0,2,
               "Saving 3d...",PLEASE_WAIT,SaveThe3d,1,_3d);
   else return NO_ERROR;
*/
}


/*----------------------------------------------------------------
save_3d_proc - ???
----------------------------------------------------------------*/

void
save_3d_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct save_menu_3d_rec *_3d;
 int is_coreg;

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (_3d->status & SAVE_START) return;
 _3d->is_save_rois = xv_get(_3d->save_rois_item,PANEL_VALUE);
 if (_3d->roi_labels.num_strs == 0)
    {_3d->is_save_rois = _3d->is_show_rois_on_img = 0;
     xv_set(_3d->save_rois_item,PANEL_VALUE,0,0);}
   else
    _3d->is_show_rois_on_img = xv_get(_3d->show_rois_on_img_item,PANEL_VALUE);
 _3d->is_save_img = xv_get(_3d->save_img_item,PANEL_VALUE);
 _3d->is_save_pixmap = xv_get(_3d->save_pixmap_item,PANEL_VALUE);
 if (setup_save_co_reg_rec(_3d) != NO_ERROR) is_coreg = 0;
   else if (_3d->num_coregs > 0) is_coreg = 1;
   else is_coreg = 0;
 PRT10(printf("save_3d_proc before free_3d_co_reg_rec\n"))
 free_3d_co_reg_rec(_3d);
 PRT10(printf("save_3d_proc after free_3d_co_reg_rec\n"))
 if ((_3d->is_save_rois == 0) && (_3d->is_save_img == 0) &&
     (_3d->is_save_pixmap == 0) && !is_coreg)
    {
     if ((int) xv_get(_3d->save_npar,PANEL_VALUE)) {
	 Save3dNpar(_3d);
	 return; }
     else
        {notice_prompt(_3d->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,"NO SAVE OPTIONS ENABLED !!!",0,
            NOTICE_BUTTON_YES," NOTHING TO SAVE !",
            0);
        return;}
    }

 SaveThe3d(_3d);
}


/*----------------------------------------------------------------
cancel_save_3d_proc - ???
----------------------------------------------------------------*/

void
cancel_save_3d_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct save_menu_3d_rec *_3d;
 struct img_buf_rec *img;
 struct view_rec *view;

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 view = img->cur_slice->slice->view;
 if (_3d->status & SAVE_START) 
    {_3d->save_err = CANCEL;
     notify_set_itimer_func((Notify_client) _3d,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
     save_3d_end(_3d);
     return;}
}


/*----------------------------------------------------------------
check_show_pixel_types_proc - ???
----------------------------------------------------------------*/

void
check_show_pixel_types_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct save_menu_3d_rec *_3d;
 unsigned long depth;
 struct color_data_rec *color_data;
 struct img_buf_rec *img;

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 if (value)
    if (xv_get(_3d->save_pixmap_item,PANEL_VALUE) == 0)
       xv_set(item,PANEL_VALUE,0,0);
 if (_3d->status & SAVE_START)
    {if (value)
        {depth = find_num_bits_needed(
                 (unsigned long) (_3d->win->intensity->color.total_colors +
                         img->file->pixel_type.order.num_strs));
         WinSetupColorDataRec2(_3d->win,0,SUPERIMPOSE_3D_ID,0,0,0,0,
                depth,0,&color_data,0);
	 return;
        }
       else WinEnableDisableColorData(_3d->win,SUPERIMPOSE_3D_ID,1);
    }
}


/*----------------------------------------------------------------
check_pixel_type_ready_proc - ???
----------------------------------------------------------------*/

void
check_pixel_type_ready_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct save_menu_3d_rec *_3d;
 struct img_buf_rec *img;
 int val,how;
 static char *str = "The pixel types will not be saved !!!";

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 val = value;
 if (!(img->file->pixel_type.status & PIXEL_TYPE_2D_PARTITION))
    {if (event != NULL)
        ShowMsgStrs(_3d->frame,0,NO_ERROR,0,2,
               "Please define the pixel types by thresholding first...!!!",
               str,NULL,0);
     val = 0;}
   else if ((how = IsAllPixelTypeMapReady(&(img->file->pixel_type),
                  &(img->file->hdr))) <= 1)
    {if (event != NULL)
        {if (how == 1)
            ShowMsgStrs(_3d->frame,0,NO_ERROR,0,2,
               "The pixel types for some slices are not defined yet !!!",
               str,NULL,0);
           else
            ShowMsgStrs(_3d->frame,0,NO_ERROR,0,2,
               "Please define the pixel types by grow region first...!!!",
               str,NULL,0);
        }
     val = 0;
    }
 xv_set(_3d->save_pixmap_item,PANEL_VALUE,val,0);
}


/*----------------------------------------------------------------
all_echo_proc - ???
----------------------------------------------------------------*/

void
all_echo_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct save_menu_3d_rec *_3d;

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 setup_cur_dim_msg(_3d);
}


/*----------------------------------------------------------------
save_selected_rois - ???
----------------------------------------------------------------*/

int
save_selected_rois(_3d)
 struct save_menu_3d_rec *_3d;
{
 int lcv;

 PRT3(printf("save_selected_rois...\n"))
 deselect_all_list_items(_3d->save_rois.rois);
 for (lcv = 0; lcv < _3d->roi_labels.num_strs; lcv++)
    select_list_str_item(_3d->roi_labels.strs[lcv],_3d->save_rois.rois,1);
 free_strs_rec(&(_3d->roi_labels));
 selected_list_items(&(_3d->roi_labels),_3d->save_rois.rois);
 PRT3(printf("save_selected_rois...end\n"))
 return NO_ERROR;
}


/*----------------------------------------------------------------
is_save_rois_proc - ???
----------------------------------------------------------------*/

void
is_save_rois_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct save_menu_3d_rec *_3d;
 int flag;

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (!is_slice_roi_non_empty(&(_3d->win->control.sroi.sroi_win->slice_roi)))
    {xv_set(_3d->save_rois_item,PANEL_VALUE,0,0);
     flag = TRUE;}
   else flag = FALSE;
 xv_set(_3d->select_rois,PANEL_INACTIVE,flag,0);
 xv_set(_3d->show_rois_on_img_item,PANEL_INACTIVE,flag,0);
 PRT3(printf("is_save_rois_proc...value = %d\n",value))
}


/*----------------------------------------------------------------
cur_image_only_proc - ???
----------------------------------------------------------------*/

void
cur_image_only_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct save_menu_3d_rec *_3d;
 struct img_buf_rec *img;
 struct view_rec *view;

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 view = img->cur_slice->slice->view;
 xv_set(_3d->start,PANEL_VALUE,view->sl.slice.num,0);
 xv_set(_3d->end,PANEL_VALUE,view->sl.slice.num,0);
 setup_cur_dim_msg(_3d);
}


/*----------------------------------------------------------------
activated_and_done_proc - ???
----------------------------------------------------------------*/

void
activated_and_done_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct save_menu_3d_rec *_3d;

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 PRT3(printf("activated_and_done_proc...\n"))
 free_strs_rec(&(_3d->roi_labels));
 selected_list_items(&(_3d->roi_labels),_3d->save_rois.rois);
 if (_3d->roi_labels.num_strs > 0) xv_set(_3d->save_rois_item,PANEL_VALUE,1,0);
   else xv_set(_3d->save_rois_item,PANEL_VALUE,0,0);
 free_save_rois_rec(&(_3d->save_rois));
}


/*----------------------------------------------------------------
save_3d_rois_done_proc - ???
----------------------------------------------------------------*/

void
save_3d_rois_done_proc(frame)
 Frame frame;
{
 struct save_menu_3d_rec *_3d;

 _3d = (struct save_menu_3d_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_save_rois_rec(&(_3d->save_rois));
}


/*----------------------------------------------------------------
setup_save_3d_rois_proc - ???
----------------------------------------------------------------*/

int
setup_save_3d_rois_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct save_menu_3d_rec *_3d;
 char *str;
 struct img_buf_rec *img;
 int row,offset;
 Rect *rr;

 _3d = (struct save_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 if (!is_slice_roi_non_empty(&(_3d->win->control.sroi.sroi_win->slice_roi)))
    {ShowMsgStrs(_3d->frame,0,0,0,2,
               "Sorry, no rois defined yet !!!",
               "No ndat will be saved...",NULL,0);
     return NO_ERROR;}
 if (_3d->save_rois.frame != 0)
    {xv_set(_3d->save_rois.frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
     PRT3(printf("setup_save_3d_rois_proc...use old\n"))
     return NO_ERROR;
    }
 PRT3(printf("setup_save_3d_rois_proc...new\n"))
 _3d->save_rois.frame = xv_create(_3d->frame, FRAME,
              WIN_CLIENT_DATA,_3d,
              FRAME_CLOSED,FALSE,
              0);
 if (_3d->save_rois.frame == 0) return CANCEL;

 str = win_rec_win_id_title(_3d->win->owner,SAVE_3D_ROIS);
 xv_set(_3d->save_rois.frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,save_3d_rois_done_proc,
              0);
 c_free(str);
 _3d->save_rois.panel = xv_create(_3d->save_rois.frame,PANEL,0);
 if (_3d->save_rois.panel == 0)
    {
     save_3d_rois_done_proc(_3d->save_rois.frame);
     return CANCEL;}
 row = 5;
 offset = xv_rows(_3d->save_rois.panel,1) - xv_rows(_3d->save_rois.panel,0) - 5;
 _3d->save_rois.rois = xv_create(_3d->save_rois.panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,3,
        PANEL_LIST_WIDTH,150,
        XV_X,5,XV_Y,row,0);
 setup_file_rois_list_item(img,_3d->save_rois.rois);
 if (_3d->roi_labels.num_strs == 0)
    select_all_list_items(_3d->save_rois.rois);
   else save_selected_rois(_3d);

 rr = (Rect *) xv_get(_3d->save_rois.rois,XV_RECT);
 xv_create(_3d->save_rois.panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"ALL",
	PANEL_NOTIFY_PROC,select_list_proc,
        XV_X,rr->r_left + rr->r_width + 5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d->save_rois.rois,
	0);
 row += offset;
 xv_create(_3d->save_rois.panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"NONE",
	PANEL_NOTIFY_PROC,deselect_list_proc,
        XV_X,rr->r_left + rr->r_width + 5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d->save_rois.rois,
	0);
 row += offset;
 xv_create(_3d->save_rois.panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"ACTIVATE & DONE",
	PANEL_NOTIFY_PROC,activated_and_done_proc,
        XV_X,rr->r_left + rr->r_width + 5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 window_fit(_3d->save_rois.panel);
 window_fit(_3d->save_rois.frame);
 make_2_wins_adjacent(_3d->save_rois.frame,_3d->frame,0);
 win_set_mouse_at_center(_3d->save_rois.frame);
 xv_set(_3d->save_rois.panel,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 xv_set(_3d->save_rois.frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 return NO_ERROR;
}


/*----------------------------------------------------------------
setup_save_menu_3d_rec - ???
----------------------------------------------------------------*/

int
setup_save_menu_3d_rec(_3d,win)
 struct save_menu_3d_rec *_3d;
 struct image_display_window *win;
{
 Cms cms;
 int row,offset;
 unsigned long max;
 struct img_buf_rec *img;
 struct view_rec *view;
 struct buf_3d_rec *_3d_data;
 char *str,str1[200];
 long skip;
 Rect *rr,*rr1;
 Panel_item item;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 if (view == NULL) return CANCEL;
 cms = (Cms) xv_get(win->dwin->frame,WIN_CMS);
 _3d->frame = xv_create(win->dwin->frame, FRAME,
			/*WIN_DYNAMIC_VISUAL,TRUE,*/
			FRAME_INHERIT_COLORS,TRUE,
			WIN_CLIENT_DATA,_3d,
			0);
 if (_3d->frame == 0)
    {free_save_menu_3d_rec(_3d);
     return ~NO_ERROR;}
 xv_set(_3d->frame,		/* DRW 19970811  See display_init_free.c */
	WIN_CMS,cms,
	NULL);
 _3d->win = win;
 _3d->dwin = win->dwin;
 str = win_rec_win_id_title(win->owner,_3D_SAVE_MENU);
 xv_set(_3d->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,_3d_save_done_proc,
              0);
 c_free(str);
 xv_set(_3d->frame,FRAME_CLOSED,FALSE,0);

 _3d->panel = xv_create(_3d->frame,PANEL,
               FRAME_INHERIT_COLORS,TRUE,
               0);
 cms = (Cms) xv_get(_3d->panel,WIN_CMS);

 if (_3d->panel == 0)
    {free_save_menu_3d_rec(_3d);
     return ~NO_ERROR;}

 row = 5;
 offset = xv_rows(_3d->panel,1) - xv_rows(_3d->panel,0) - 10;
 str = "DIR :";
 _3d->dir = xv_create(_3d->panel,PANEL_TEXT,
                      XV_X,5,XV_Y,row,
	              PANEL_LABEL_STRING, str,
                      PANEL_VALUE_DISPLAY_LENGTH,30,
                      PANEL_VALUE_STORED_LENGTH,100,
                      PANEL_VALUE,img->file->output.dirfn,
                      0);

 row += offset;
 sprintf(str1,"Suffix of %s & %s is assumed for FN !!!",
        img->file->hdr_fn_suffix,img->file->img_fn_suffix);
 xv_create(_3d->panel,PANEL_MESSAGE,
                      XV_X,5,XV_Y,row,
	              PANEL_LABEL_STRING,str1,0);
 row += offset;
 str = "FN ";
 sprintf(str1,"%sr",img->file->output.fn);
 _3d->fn = xv_create(_3d->panel,PANEL_TEXT,
                      XV_X,5,XV_Y,row,
	              PANEL_LABEL_STRING, str,
                      PANEL_VALUE_DISPLAY_LENGTH,30,
                      PANEL_VALUE_STORED_LENGTH,100,
                      PANEL_VALUE,str1,
                      0);

 row += offset;
 _3d->orig_size = xv_create(_3d->panel,PANEL_MESSAGE,
                      XV_X,5,XV_Y,row,
	              PANEL_LABEL_STRING,"",0);
 setup_orig_size_msg(_3d);
 row += offset - 5;
 _3d->orig_dim = xv_create(_3d->panel,PANEL_MESSAGE,
                      XV_X,5,XV_Y,row,
	              PANEL_LABEL_STRING,"",0);
 setup_orig_dim_msg(_3d);

 row += offset;
 _3d->save_npar = xv_create(_3d->panel,PANEL_CHECK_BOX,
	PANEL_CHOICE_STRINGS,"SAVE PARAMETER .npar",NULL,
        XV_X,5,XV_Y,row,
        PANEL_VALUE,1,
        PANEL_CLIENT_DATA,_3d,
	0);
 rr = (Rect *) xv_get(_3d->save_npar,XV_RECT);
 _3d->cancel = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"CANCEL SAVE",
	PANEL_NOTIFY_PROC,cancel_save_3d_proc,
        XV_X,rr->r_left + rr->r_width + 35,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 row += offset;
 _3d->save_pixmap_item = xv_create(_3d->panel,PANEL_CHECK_BOX,
	PANEL_CHOICE_STRINGS,"SAVE PIXEL TYPE TO .pixmap",NULL,
        XV_X,5,XV_Y,row,
        PANEL_VALUE,0,
	PANEL_NOTIFY_PROC,check_pixel_type_ready_proc,
        PANEL_CLIENT_DATA,_3d,
	0);
 check_pixel_type_ready_proc(_3d->save_pixmap_item,1,NULL);

 rr = (Rect *) xv_get(_3d->cancel,XV_RECT);
 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"SAVE NOW",
	PANEL_NOTIFY_PROC,save_3d_proc,
        XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 rr1 = (Rect *) xv_get(item,XV_RECT);
 xv_set(item,XV_X,rr->r_left + rr->r_width - rr1->r_width,0);

 row += offset;
 _3d->show_pixel_types_item = xv_create(_3d->panel,PANEL_CHECK_BOX,
	PANEL_CHOICE_STRINGS,"SHOW PIXEL TYPES WHILE SAVING",NULL,
        XV_X,35,XV_Y,row,
        PANEL_VALUE,0,
	PANEL_NOTIFY_PROC,check_show_pixel_types_proc,
        PANEL_CLIENT_DATA,_3d,
	0);

 row += offset;
 _3d->save_rois_item = xv_create(_3d->panel,PANEL_CHECK_BOX,
	PANEL_CHOICE_STRINGS,"SAVE ROIS TO .ndat",NULL,
        XV_X,5,XV_Y,row,
        PANEL_VALUE,1,
	PANEL_NOTIFY_PROC,is_save_rois_proc,
        PANEL_CLIENT_DATA,_3d,
	0);

  rr = (Rect *) xv_get(_3d->save_rois_item,XV_RECT);
_3d->select_rois = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"SELECT ROIS",
	PANEL_NOTIFY_PROC,setup_save_3d_rois_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 row += offset - 4;
 _3d->show_rois_on_img_item = xv_create(_3d->panel,PANEL_CHECK_BOX,
	PANEL_CHOICE_STRINGS,"SHOW SAVED ROIS ON IMAGE",NULL,
        XV_X,35,XV_Y,row,
        PANEL_VALUE,1,
	0);
 FileGetAllRoiLabelPtrs(img->file,&(_3d->roi_labels),0,1);
 is_save_rois_proc(_3d->save_rois_item,1,NULL);
 row += offset;
 _3d->save_img_item = xv_create(_3d->panel,PANEL_CHECK_BOX,
	PANEL_CHOICE_STRINGS,"SAVE IMAGE",NULL,
        XV_X,5,XV_Y,row,
        PANEL_VALUE,1,
	0);

 rr = (Rect *) xv_get(_3d->save_img_item,XV_RECT);
 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"CUR IMAGE",
	PANEL_NOTIFY_PROC,cur_image_only_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 if (img->file->hdr.analysis.num_img_labels > 1)
    {sprintf(str1,"%ld echoes",img->file->hdr.analysis.num_img_labels);
     rr = (Rect *) xv_get(item,XV_RECT);
     _3d->all_echoes = xv_create(_3d->panel,PANEL_CHECK_BOX,
 	           PANEL_LABEL_STRING, str1,PANEL_VALUE,1,
                   XV_X,rr->r_left + rr->r_width + 5,XV_Y,row,
                   PANEL_CLIENT_DATA,_3d,
	           PANEL_NOTIFY_PROC,all_echo_proc,
                   0);
    }
   else _3d->all_echoes = 0;

 if ((view->status & PLANE_CROSS_REGISTERED) && (view->num_cos > 0))
    {row += offset;
     _3d->save_coreg = xv_create(_3d->panel,PANEL_LIST,
 	PANEL_LABEL_STRING, "SAVE CO-REGISTERED IMAGE",
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,1,
        PANEL_LIST_WIDTH,70,
        PANEL_LAYOUT,PANEL_HORIZONTAL,
        XV_X,5,XV_Y,row,
        0);
     setup_save_co_reg_item(_3d);
     row += offset + 10;
    }
   else _3d->save_coreg = 0;
 row += offset;

 _3d->start = xv_create(_3d->panel,PANEL_SLIDER,
        PANEL_LABEL_STRING,"1st Slice#",
	PANEL_VALUE,1,
	PANEL_MIN_VALUE,1,
	PANEL_MAX_VALUE,view->gplane.total_planes,
	PANEL_SLIDER_WIDTH,70,
        PANEL_CLIENT_DATA,_3d,
        XV_X,5,XV_Y,row,
	PANEL_NOTIFY_PROC,set_slice_proc,
	0);

 row += offset;
 _3d->end = xv_create(_3d->panel,PANEL_SLIDER,
        PANEL_LABEL_STRING,"LAST",
	PANEL_VALUE,view->gplane.total_planes,
	PANEL_MIN_VALUE,1,
	PANEL_MAX_VALUE,view->gplane.total_planes,
	PANEL_SLIDER_WIDTH,70,
        PANEL_CLIENT_DATA,_3d,
        XV_X,5,XV_Y,row,
	PANEL_NOTIFY_PROC,set_slice_proc,
	0);

 row += offset;
 if (find_file_3d(view->img->file,view->id,&_3d_data) == NO_ERROR)
    skip = (long) ULongRound(
              (double) (_3d_data->slice_thickness / _3d_data->zpixel_size));
   else 
    skip = (long) ULongRound(
              (double) (view->img->file->hdr.data_info.pixel_thickness /
                img->file->hdr.data_info.xpixel_size));

 max = max_plane_dims(&(view->gplane));
 _3d->skip = xv_create(_3d->panel,PANEL_SLIDER,
        PANEL_LABEL_STRING,"SKIP",
	PANEL_VALUE,skip,
	PANEL_MIN_VALUE,1,
	PANEL_MAX_VALUE,max,
	PANEL_SLIDER_WIDTH,90,
        PANEL_CLIENT_DATA,_3d,
        XV_X,5,XV_Y,row,
	PANEL_NOTIFY_PROC,set_skip_proc,
	0);

 row += offset;
 _3d->cur_size = xv_create(_3d->panel,PANEL_MESSAGE,
                      XV_X,5,XV_Y,row,
	              PANEL_LABEL_STRING,"",0);
 setup_cur_size_msg(_3d);
 row += offset - 5;
 _3d->cur_dim = xv_create(_3d->panel,PANEL_MESSAGE,
                      XV_X,5,XV_Y,row,
	              PANEL_LABEL_STRING,"",0);
 setup_cur_dim_msg(_3d);

 window_fit(_3d->panel);
 window_fit(_3d->frame);
 make_2_wins_adjacent(_3d->frame,win->dwin->frame,0);
 win_set_mouse_at_center(_3d->frame);

 return NO_ERROR;
}


/*----------------------------------------------------------------
find_save_menu_3d_rec - ???
----------------------------------------------------------------*/

struct save_menu_3d_rec *
find_save_menu_3d_rec(all_3ds,win)
 struct all_save_menu_3d_recs *all_3ds;
 struct image_display_window *win;
{
 int lcv;
 struct input_file_rec *f1;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NULL;
 f1 = img->file;
 for (lcv = 0; lcv < all_3ds->num_3ds; lcv++)
    if ((img = win_rec_cur_img_buf(all_3ds->_3ds[lcv]->win->owner)) != NULL)
       if (img->file == f1)
          return all_3ds->_3ds[lcv];
 return NULL;
}


/*----------------------------------------------------------------
update_start_end - ???
----------------------------------------------------------------*/

void
update_start_end(_3d)
 struct save_menu_3d_rec *_3d;
{
 int start,end;
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 view = img->cur_slice->slice->view;
 if (view == NULL) return;
 start = (int) xv_get(_3d->start,PANEL_VALUE);
 if (start > view->gplane.total_planes) start = 1;

 end = (int) xv_get(_3d->end,PANEL_VALUE);
 if (end > view->gplane.total_planes) end = view->gplane.total_planes;
 xv_set(_3d->end,PANEL_MAX_VALUE,view->gplane.total_planes,PANEL_VALUE,end,0);
 xv_set(_3d->start,PANEL_MAX_VALUE,view->gplane.total_planes,
        PANEL_VALUE,start,0);
}


/*----------------------------------------------------------------
update_3d_save_menu - ???
----------------------------------------------------------------*/

void
update_3d_save_menu(win)
 struct image_display_window *win;
{
 struct all_save_menu_3d_recs *all_3ds;
 struct save_menu_3d_rec *_3d;

 if ((all_3ds = (struct all_save_menu_3d_recs *) enter_3d_save_menu(win,
              GET_ALL_3D_MENU_PTR)) != NULL)
    {
     if ((_3d = find_save_menu_3d_rec(all_3ds,win)) != NULL)
        if (_3d->win == win)
           {TRACE(printf("update_3d_save_menu..found.._3d = %u\n",_3d))
            update_start_end(_3d);
            setup_cur_size_msg(_3d);
            setup_cur_dim_msg(_3d);
           }
    }
}


/*----------------------------------------------------------------
enter_3d_save_menu - ???
----------------------------------------------------------------*/

unsigned long 
enter_3d_save_menu(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_save_menu_3d_recs all_3ds;
 static char first_time = 1;
 int err;
 struct save_menu_3d_rec *_3d;

 err = NO_ERROR;
 if (status == GET_ALL_3D_MENU_PTR)
     {if (first_time) return 0;
        else return (unsigned long) &all_3ds;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_3D_MENU)
   {if (!first_time)
       if ((_3d = find_save_menu_3d_rec(&all_3ds,win)) != NULL)
          free_save_menu_3d_rec(_3d);
    return NO_ERROR;}

 if (first_time)
    {init_all_save_menu_3d_recs(&all_3ds);
     first_time = 0;}
   else
    {if ((_3d = find_save_menu_3d_rec(&all_3ds,win)) != NULL)
        if (_3d->win == win)
           {xv_set(_3d->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
            setup_save_co_reg_item(_3d);
            win_set_mouse_at_center(_3d->frame);
            wmgr_top(_3d->frame);
            return NO_ERROR;}
          else free_save_menu_3d_rec(_3d);
    }
 get_handle_memory(&(all_3ds._3ds),&(all_3ds.num_3ds),1,
     (size_t) sizeof(struct save_menu_3d_rec),&err);
 if (err != NO_ERROR) return err;
 _3d = all_3ds._3ds[all_3ds.num_3ds - 1];
 init_save_menu_3d_rec(_3d);
 if ((err = setup_save_menu_3d_rec(_3d,win)) == NO_ERROR)
    xv_set(_3d->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 return err;
}
