/****************************************************************************
3d_win_menu.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  The functions in this file that are referenced in process_key.c
   and related places as void have been changed from type int to type void
   without actually checking that no one calls them as int.  This is likely
   but not guaranteed, so watch out for possible problems.  -PWH 19990225 
****************************************************************************/

static const char rcsid[] = "$Id: 3d_win_menu.c,v 1.11 1999/07/07 17:41:13 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/scrollbar.h>
#include <xview/notify.h>
#include <xview/font.h>

#include <math.h>   /* Must follow xview.h to avoid BITSPERBYTE bug */

#include "geometry.h"
#include "buf_3d_rec.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
#define PRT11(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)
#define PRT1(x)
#define PRT2(x)
#define PRT6(x)
#define PRT7(x)
#define PRT8(x)
#define PRT9(x)
#define PRT10(x)
#define PRT11(x)



/* Functions defined in this file */
void the_win_3d_proc(struct display_win_rec *dwin, int which);
void win_3d_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int option);
void _3d_reproject_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int val);
void _3d_move_mouse_to_wid(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_reverse_image_order_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_save_image_order_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_cur_default_image_order_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_default_image_order_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_enable_dp_xyz_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int val);
void _3d_enable_locate_plane_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_select_cursor_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int val);
void _3d_pt_cursor_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_form_plane_by_3_pts_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_delete_last_cursor_pt_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_locate_plane_cursor_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int val);
void win_plane_orientation(struct image_display_window *win, int key,
    int is_shift_down);
int win_abs_flip_plane(struct image_display_window *win, int key,
    int is_shift_down);
int win_rel_flip_plane(struct image_display_window *win, int key,
    int is_shift_down);
int win_adjust_to_center(struct image_display_window *win, int adjust);
void _3d_plane_orientation_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int key);
void _3d_rotate_plane_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, double angle);
void rotate_plane_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int angle);
int view_3d_last_plane(struct view_rec *view);
void group_last_plane_proc(struct image_display_window *win);
void _3d_last_plane_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int val);
void _3d_co_register_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int select);
int same_co_plane_proc(struct image_display_window *win, char *str,
    int is_superimpose);
void _3d_same_co_plane_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
int resize_group_proc(struct image_display_window *win, char *wid);
void _3d_resize_group_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_reverse_plane_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void _3d_new_plane_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int select);
void _3d_plane_key_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int mode);
int _3d_cur_wid_roi(struct view_rec *view, char *wid);
void _3d_cur_wid_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int mode);
void update_3d_rois_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void enter_3d_plane_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void enter_3d_more_plane_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void enter_3d_co_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void enter_3d_file_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void enter_3d_resize_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void enter_3d_rois_and_pixel_types_proc(Menu menu, Menu_item item,
    void *arg, Xv_Window window, Event *last_event);
void enter_3d_save_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void enter_3d_param_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void enter_3d_split_rois_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void save_open_cur_plane_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int select);




/*-----------------------------------------------------------------------
the_win_3d_proc - ???

FIXME!!  There are some hints from context that this function really
ought to be type int or type Notify_func.  -PWH 19990319
-----------------------------------------------------------------------*/

void
the_win_3d_proc(dwin,which)
 struct display_win_rec *dwin;
 int which;
{
 struct img_buf_rec *img;
 char *img_label;
 unsigned long option;

 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL)
   return /* CANCEL */;
 (void) notify_set_itimer_func((Notify_client) dwin,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 img_label = (char *) get_img_type_label(img);
 set_win_busy(dwin->owner);
 if (dwin->owner->process_status4 & WIN_STARTUP_3D_APPROX)
    {dwin->owner->process_status4 &= ~WIN_STARTUP_3D_APPROX;
     option = VIEW_3D_APPROX;}
   else option = 0;
 setup_file_3d(img->file,img_label,option);
 set_win_not_busy(dwin->owner);
 c_free(img_label);
}


/*-----------------------------------------------------------------------
win_3d_proc - ???
-----------------------------------------------------------------------*/

void 
win_3d_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *dwin;
 Menu root;

 TRACE(printf("win_3d_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     option = (int) xv_get(item,MENU_VALUE);
    }

 dwin->owner->dwin = dwin;

 /*
  *  if (option == 1)
  *    then {use closest-value algorithm}
  *    else {use pixel-interpolation algorithm}
  *  when reslicing
  */
  if (option)
    dwin->owner->process_status4 |= WIN_STARTUP_3D_APPROX;

 (void) notify_set_itimer_func((Notify_client) dwin,
             (Notify_func) the_win_3d_proc,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);

}


/*-----------------------------------------------------------------------
_3d_reproject_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_reproject_proc(menu,item,arg,window,last_event,val)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int val;
{
 struct display_win_rec *dwin;
 struct img_buf_rec *img;
 struct view_rec *view;

 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return;
 set_win_busy(dwin->owner);
 view = img->cur_slice->slice->view;
 PRT8(printf("_3d_reproject_proc...\n"))
 FormPlane(view,&(view->gplane.base),&(view->gplane.normal_cosine),
        NULL,&(view->gplane.rotate),0,0,NULL);
 set_win_not_busy(dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_move_mouse_to_wid - ???
-----------------------------------------------------------------------*/

void
_3d_move_mouse_to_wid(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;

 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 set_win_busy(dwin->owner);
 if (event_shift_is_down(last_event))
    {PRT9(printf("_3d_move_mouse_to_wid...shift\n"))
     win_move_mouse_to_co_reg_wid(dwin->owner);
    }
   else 
    {PRT9(printf("_3d_move_mouse_to_wid...shift\n"))
     win_move_mouse_to_cur_roi_wid(dwin->owner);}

 set_win_not_busy(dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_reverse_image_order_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_reverse_image_order_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;

 if (menu == 0) dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 ShowMsgStrs(dwin->frame,1,NO_ERROR,0,1,
         "Reversing the image order !!!",
         win_reverse_image_order,1,dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_save_image_order_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_save_image_order_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;

 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 ShowMsgStrs(dwin->frame,1,NO_ERROR,1,2,
         "Saving the image order !!!",
         "Will update the nhdr file !!!",
         win_save_cur_image_order,1,dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_cur_default_image_order_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_cur_default_image_order_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;

 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
         "Currently saved default image order !!!",
         win_cur_default_image_order,1,dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_default_image_order_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_default_image_order_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;

 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 ShowMsgStrs(dwin->frame,1,NO_ERROR,1,2,
         "Change to the default image order !!!",
         "Will not update the nhdr file !!!",
         win_default_image_order,1,dwin->owner);
}




/*-----------------------------------------------------------------------
_3d_enable_dp_xyz_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_enable_dp_xyz_proc(menu,item,arg,window,last_event,val)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int val;
{
 struct display_win_rec *dwin;
 struct img_buf_rec *img;
 struct view_rec *view;
 struct strs_rec *wids;
 char *str;
 int err;

 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return;
 set_win_busy(dwin->owner);
 if ((view = img->cur_slice->slice->view) != NULL)
    {if (view->more_status & DP_XYZ)
        {view->more_status &= ~DP_XYZ;
         if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
            {if ((err = win_co_registered_wids(dwin->owner,wids,0,1,2))
                       == NO_ERROR)
             if ((err != NO_ERROR) || (wids->num_strs <= 1))
                {
                 win_cursor_row_col(dwin->owner);
                 free_strs_rec_ptrs(wids);
                 c_free(wids);}
               else
                {str = win_rec_win_id_title(dwin->owner->owner,"XYZ BY");
                 ShowMenuStrsProc(window,last_event,str,
                       wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       win_xyz_by_co_reg_wid,dwin->owner,1,0,0);
                 c_free(str);}
            }
        }
       else
        {view->more_status |= DP_XYZ;
         win_cursor_row_col(dwin->owner);}
    }
 set_win_not_busy(dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_enable_locate_plane_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_enable_locate_plane_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;

 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 win_select_cursor(dwin->owner,CURSOR_LOCATE_PLANE);
}


/*-----------------------------------------------------------------------
_3d_select_cursor_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_select_cursor_proc(menu,item,arg,window,last_event,val)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int val;
{
 struct display_win_rec *dwin;
 unsigned long which_cursor;
 static unsigned long cursors[] = 
                {CURSOR_CUT,CURSOR_ROTATE_VERTICAL,CURSOR_ROTATE_HORIZONTAL,
                 CURSOR_ROTATE,CURSOR_SAME_ANGLE_CUT,CURSOR_ANGLE_CUT};
 static int num_cursors = 6;
 int lcv;
 Menu root;

 PRT7(printf("_3d_select_cursor_proc...val = %d\n",val))
 if (menu == 0)
    {dwin = (struct display_win_rec *) arg;
     if (val != 0)
        which_cursor = val;
       else
        {for (lcv = 0; lcv < num_cursors; lcv++)
            if (cursors[lcv] == dwin->owner->control.which_cursor)
               {if ((last_event != NULL) && event_shift_is_down(last_event))
                   {if (lcv == 0) lcv = num_cursors - 1;
                      else lcv -= 1;}
                  else
                   {lcv += 1;
                    if (lcv == num_cursors) lcv = 0;}
                which_cursor = cursors[lcv];
                break;}
          if (lcv == num_cursors) 
             {for (lcv = 0; lcv < num_cursors; lcv++)
                 if (cursors[lcv] == dwin->owner->control.last_which_cursor)
                    {which_cursor = cursors[lcv];
                     break;}
              if (lcv == num_cursors) which_cursor = cursors[0];}
        }
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     which_cursor = (unsigned long) xv_get(item,MENU_CLIENT_DATA);
    }
 dwin->owner->dwin = dwin;
 PRT7(printf("_3d_select_cursor_proc...which_cursor = %d\n",which_cursor))
 win_select_cursor(dwin->owner,which_cursor);
 if ((which_cursor == CURSOR_CUT) || (which_cursor == CURSOR_ANGLE_CUT) ||
     (which_cursor == CURSOR_SAME_ANGLE_CUT)) 
    update_3d_cut_mode(dwin->owner);

}


/*-----------------------------------------------------------------------
_3d_pt_cursor_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_pt_cursor_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 Menu root;

 if (menu == 0)
    {dwin = (struct display_win_rec *) arg;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 dwin->owner->dwin = dwin;
 win_select_cursor(dwin->owner,CURSOR_3D_PT1);
}


/*-----------------------------------------------------------------------
_3d_form_plane_by_3_pts_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_form_plane_by_3_pts_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 Menu root;

 if (menu == 0)
    {dwin = (struct display_win_rec *) arg;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 dwin->owner->dwin = dwin;
 win_form_plane_by_3_pts(dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_delete_last_cursor_pt_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_delete_last_cursor_pt_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 Menu root;

 PRT4(printf("_3d_delete_last_cursor_pt_proc...\n"))
 if (menu == 0)
    {dwin = (struct display_win_rec *) arg;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 dwin->owner->dwin = dwin;
 win_3d_delete_last_cursor_pt(dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_locate_plane_cursor_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_locate_plane_cursor_proc(menu,item,arg,window,last_event,val)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int val;
{
 struct display_win_rec *dwin;
 Menu root;

 if (menu == 0)
    {dwin = (struct display_win_rec *) arg;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 dwin->owner->dwin = dwin;
 win_select_cursor(dwin->owner,CURSOR_LOCATE_PLANE);
}


/*-----------------------------------------------------------------------
win_plane_orientation - ???
-----------------------------------------------------------------------*/

void
win_plane_orientation(win,key,is_shift_down)
 struct image_display_window *win;
 int key,is_shift_down;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 float angle;
 unsigned long select,temp;
 int orient;

 if (key >= 9) return;
 PRT1(printf("win_plane_orientation...key = %d  is_shift_down = %d\n",key,is_shift_down))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;
 if ((view = img->cur_slice->slice->view) == NULL) return;
 if ((key % 2)) 
    {
     if (key == 1)
        {
         if (is_shift_down) select = CURSOR_R270;
           else select = CURSOR_270;
         angle = 270.0;}
       else if (key == 3)
        {if (is_shift_down) select = CURSOR_R180;
            else select = CURSOR_180;
         angle = 180.0;}
       else if (key == 7) 
        {if (is_shift_down) select = CURSOR_R90;
            else select = CURSOR_90;
         angle = 90.0;}
       else 
        {select = CURSOR_0;
         angle = .0;}
     if (is_shift_down)
        {TRACE(printf("event_shift_is_down...\n"))
         if (angle == .0) return;
         angle += (float) degree(view->gplane.rotate.z);
         angle = (float) fmod((double) angle, (double) 360.0);}
     temp = win->control.which_cursor;
     win_select_cursor(win,select);
     RotatePlaneFromCenter(view,angle,0);
     win_select_cursor(win,temp);
    }
   else
    {
     if (key == 0) 
        {select = CURSOR_Y_REFLECTION;
         orient = GY_REFLECTION;
        }
       else if (key == 2)
        {select = CURSOR_X_REFLECTION;
         orient = GX_REFLECTION;
        }
       else if (key == 6) 
        {select = CURSOR_Y_X_REFLECTION;
         orient = GY_X_REFLECTION;
        }
       else if (key == 8) 
        {select = CURSOR_YX_REFLECTION;
         orient = GYX_REFLECTION;
        }
       else 
        {select = CURSOR_NO_REFLECTION;
         orient = GNO_REFLECTION;
        }
     temp = win->control.which_cursor;
     win_select_cursor(win,select);
     _3d_plane_orientation(view,orient);
     win_select_cursor(win,temp);
    }

}


/*-----------------------------------------------------------------------
win_abs_flip_plane - ???
-----------------------------------------------------------------------*/

int
win_abs_flip_plane(win,key,is_shift_down)
 struct image_display_window *win;
 int key,is_shift_down;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 int deg,x1,y1,centerx,centery;

 PRT1(printf("win_abs_flip_plane...key = %d  is_shift_down = %d\n",key,is_shift_down))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 if (key == 4)
    {
     return NO_ERROR;
    }
   else if (key == 10)
    {
     return NO_ERROR;
    }

 if (is_shift_down == 1) deg = 2;
   else if (is_shift_down == 2) deg = 90;
   else deg = 1;

 if ((key == 1) || (key == 2) || (key == 5) || (key == 8))
    deg *= -1;
 centerx = img->_2d.dimx / 2;
 centery = img->_2d.dimy / 2;
 if (key == 8)
    {x1 = img->_2d.dimx;
     y1 = img->_2d.dimy;}
   else if (key == 7)
    {x1 = centerx;
     y1 = centery;
     centerx = img->_2d.dimx;
     centery = centery;}
   else if (key == 6)
    {x1 = centerx;
     y1 = centery;
     centerx = img->_2d.dimx;
     centery = 0;}
   else if (key == 5)
    {x1 = centerx;
     y1 = img->_2d.dimy;}
   else if (key == 3)
    {x1 = centerx;
     y1 = centery;
     centery = 0;
    }
   else if (key == 2)
    {x1 = 0;
     y1 = img->_2d.dimy;}
   else if (key == 1)
    {x1 = 0;
     y1 = centery;}
   else if (key == 0)
    {x1 = centerx;
     y1 = centery;
     centerx = centery = 0; 
    }

 PRT1(printf("centerx = %d centery = %d x1 = %d y1 = %d deg = %d\n",
    centerx,centery,x1,y1,deg);)
 return _3dAxisCutPlane(view,view,(float) deg,
           (float) centerx,(float) centery,(float) x1,(float) y1,
               1,(float) img->_2d.dimx / 2.0,.0,
               (float) img->_2d.dimx / 2.0,(float) img->_2d.dimy - 1);
}


/*-----------------------------------------------------------------------
win_rel_flip_plane - ???
-----------------------------------------------------------------------*/

int
win_rel_flip_plane(win,key,is_shift_down)
 struct image_display_window *win;
 int key,is_shift_down;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 int x1,y1,x2,y2;
 float rot_deg,fx1,fy1,fx2,fy2;

 PRT1(printf("win_rel_flip_plane...key = %d  is_shift_down = %d\n",key,is_shift_down))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 if (key == 4)
    {
     return NO_ERROR;
    }
   else if (key == 10)
    {
     return NO_ERROR;
    }
 if (_3d_default_cur_line(view,&x1,&y1,&x2,&y2) != NO_ERROR) 
    return win_abs_flip_plane(win,key,is_shift_down);
/*
 if (key == 0) rot_deg = 45.0;
   else if (key == 8) rot_deg = -135.0;
   else if (key == 1) rot_deg = 90.0;
   else if (key == 7) rot_deg = -90.0;
   else if (key == 2) rot_deg = 135.0;
   else if (key == 6) rot_deg = -45.0;
   else if (key == 5) rot_deg = 180.0;
*/
 if (key == 0) rot_deg = -45.0;
   else if (key == 8) rot_deg = 135.0;
   else if (key == 1) rot_deg = 90.0;
   else if (key == 7) rot_deg = -90.0;
   else if (key == 2) rot_deg = -135.0;
   else if (key == 6) rot_deg = 45.0;
   else if (key == 5) rot_deg = 180.0;
   else rot_deg = 0.0;

 PRT10(printf("x1 = %d y1 = %d x2 = %d y2 = %d  rot_deg = %f\n",x1,y1,x2,y2,rot_deg))

 if (rot_deg != .0)
    RotatePlaneLine(&(view->gplane),(float) x1,(float) y1,(float) x2,(float) y2,
                rot_deg,&fx1,&fy1,&fx2,&fy2);
   else
    {
     fx1 = (float) x1;
     fy1 = (float) y1;
     fx2 = (float) x2;
     fy2 = (float) y2;
    }

 if (is_shift_down == 1) rot_deg = 2.0;
   else if (is_shift_down == 2) rot_deg = 90.0;
   else rot_deg = 1.0;

 return _3dAxisCutPlane(view,view,(float) rot_deg,fx1,fy1,fx2,fy2,
               1,(float) x1,(float) y1,(float) x2,(float) y2);

}


/*-----------------------------------------------------------------------
win_adjust_to_center - ???
-----------------------------------------------------------------------*/

int
win_adjust_to_center(win,adjust)
 struct image_display_window *win;
 int adjust;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 int is_clear,update,err;

 PRT5(printf("win_adjust_to_center...\n");)
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 err = NO_ERROR;
 update = adjust_to_center(&(view->gplane),adjust);
 PRT5(printf("win_adjust_to_center...update = %d\n",update);)
 if (update)
    err = OutputPlaneData(view,1,1);
 is_clear = 1;
 win_execute_proc_to_multiple_wins(win,win_draw_enabled_label,&is_clear,
				   0,0,0,0);
 PRT5(printf("win_adjust_to_center...err = %d\n",err);)
 return err;
}


/*-----------------------------------------------------------------------
_3d_plane_orientation_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_plane_orientation_proc(menu,item,arg,window,last_event,key)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int key;
{
 struct display_win_rec *dwin;
 Menu root;
 int is_key_mode;
 struct img_buf_rec *img;
 struct view_rec *view;
 int deg;

 TRACE(printf("_3d_plane_orientation_proc...\n"))
 if (menu == 0)
    {dwin = (struct display_win_rec *) arg;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     key = (int) xv_get(item,MENU_CLIENT_DATA);
    }
 dwin->owner->dwin = dwin;
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return;
 set_win_busy(dwin->owner);

 if (event_shift_is_down(last_event)) is_key_mode = 1;
   else is_key_mode = 0;
 PRT1(printf("=== key = %d\n",key);)
 if ((key == 9) || (key == 15))
    {if (is_key_mode) deg = get_3d_plane_rot_angle(dwin->owner);
       else deg = 1;
     if (key == 9) deg = -deg;
     if ((view = img->cur_slice->slice->view) == NULL) return;
     _3d_axis_rotate_plane(view,deg);
    }
   else if (key == 10)
    ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
               "Adjust or don't adjust plane to center !!!",
                win_adjust_to_center,2,dwin->owner,0);
   else if (img->file->slice_info.status & _3D_ORIENTATION_KEY_ENABLED)
    win_plane_orientation(dwin->owner,key,is_key_mode);
   else
    {if ((is_key_mode == 0) && event_ctrl_is_down(last_event))
        is_key_mode = 2;
     if (img->file->slice_info.status & _3D_ABS_FLIP_KEY_ENABLED)
        win_abs_flip_plane(dwin->owner,key,is_key_mode);
       else win_rel_flip_plane(dwin->owner,key,is_key_mode);
    }

 set_win_not_busy(dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_rotate_plane_proc - ???
-----------------------------------------------------------------------*/

void
_3d_rotate_plane_proc(menu,item,arg,window,last_event,angle)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 float angle;
{
 struct display_win_rec *dwin;
 Menu root;
 struct img_buf_rec *img;
 struct view_rec *view;
 int is_rel;

 PRT11(printf("_3d_rotate_plane_proc..angle = %f\n",angle))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     angle = 1.0;
    }
 dwin->owner->dwin = dwin;
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return;
 if ((view = img->cur_slice->slice->view) == NULL) return;
 set_win_busy(dwin->owner);
 if (angle == .0) is_rel = 0;
   else is_rel = 1;
 PRT11(printf("_3d_rotate_plane_proc..final angle = %f\n",angle))
 RotatePlaneFromCenter(view,angle,is_rel);
 set_win_not_busy(dwin->owner);
}


/*-----------------------------------------------------------------------
rotate_plane_proc - ???
-----------------------------------------------------------------------*/

void 
rotate_plane_proc(menu,item,arg,window,last_event,angle)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int angle;
{
 struct display_win_rec *dwin;
 Menu root;
 float fl_angle;

 PRT11(printf("rotate_plane_proc..angle = %d\n",angle))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 dwin->owner->dwin = dwin;
 if (angle < -10) fl_angle = (float) (angle + 10) * .1;
   else if (angle > 10) fl_angle = (float) (angle - 10) * .1;
   else fl_angle = (float) angle;
 PRT11(printf("angle = %d  fl_angle = %f\n",angle,fl_angle))
 if (dwin->owner->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE)
    WinRotateFusion(dwin->owner,fl_angle);
   else if (dwin->owner->type2 & DISPLAY_WINDOW_3D)
    _3d_rotate_plane_proc(menu,item,arg,window,last_event,fl_angle);
   else if (dwin->owner->type2 & DISPLAY_WINDOW)
    rotate_2d_image_proc(menu,item,arg,window,last_event,fl_angle);
   else win_alarm(dwin->frame,2);
}


/*-----------------------------------------------------------------------
view_3d_last_plane - ???
-----------------------------------------------------------------------*/

int
view_3d_last_plane(view)
 struct view_rec *view;
{
 if (view->img->win == NULL) return CANCEL;
 return _3d_last_plane(view->img->win->image_display,0);
}


/*-----------------------------------------------------------------------
group_last_plane_proc - ???

FIXME:  This might possibly need to be type int, but the actual usage is
buried under a couple layers of obfuscation.  -PWH
-----------------------------------------------------------------------*/

void
group_last_plane_proc(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
   return /* CANCEL */;
 PRT5(printf("group_last_plane_proc...\n"));
 run_next_view_proc(img->cur_slice->slice->view,view_3d_last_plane,
		    0,0,0,0,0,0);
}


/*-----------------------------------------------------------------------
_3d_last_plane_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_last_plane_proc(menu,item,arg,window,last_event,val)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int val;
{
 struct display_win_rec *dwin;
 Menu root;
 struct img_buf_rec *img;
 struct view_rec *view;

 TRACE(printf("_3d_last_plane_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 dwin->owner->dwin = dwin;
 if (last_event != NULL)
    {if (event_shift_is_down(last_event))
        {ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
               "Last plane for the whole group !!!",
                group_last_plane_proc,1,dwin->owner);
         return;}
    }

 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return;
 view = img->cur_slice->slice->view;
 if (event_meta_is_down(last_event) &&
     (view->status & PLANE_CROSS_REGISTERED) &&
     (view->num_cos > 0))
    ShowMsgStrs(dwin->frame,1,NO_ERROR,1,2,
               "Adjust and reco-register",
               "using the Last plane !!!",
                _3d_last_plane,2,dwin->owner,1);
   else ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
               "Last plane !!!",
                _3d_last_plane,2,dwin->owner,0);
}


/******************
_3d_rotate_proc(menu,item,arg,window,last_event,mode)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 unsigned long mode;
{
 struct display_win_rec *dwin;
 struct img_buf_rec *img;
 struct view_rec *view;
 unsigned long temp,tmode;
 int err;

 TRACE(printf("_3d_rotate_proc\n"))
 if (menu == NULL) dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 set_win_busy(dwin->owner);
 temp = dwin->owner->control.which_cursor;
 if (!(temp & mode))
    win_select_cursor(dwin->owner,mode);
 tmode = 0;
 if (last_event != NULL)
    {if (event_ctrl_is_down(last_event)) tmode = CTRL_COMMAND_KEY;
    }
 err = _3d_rotate(view,tmode);
 set_win_not_busy(dwin->owner);
 if (!(temp & mode))
    win_select_cursor(dwin->owner,temp);

 return err;
}
***************/


/*-----------------------------------------------------------------------
_3d_co_register_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_co_register_proc(menu,item,arg,window,last_event,select)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int select;
{
 struct display_win_rec *dwin;
 struct img_buf_rec *img;
 struct strs_rec *wids;
 struct view_rec *view;
 int err;
 char str[100],*str1;

 PRT6(printf("_3d_co_register_proc...select = %d\n",select))
 if (menu == 0)    dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return;
 set_win_busy(dwin->owner);
 if ((select >= COREG_LOCKED_TO_VALUE) && 
     (select <= COREG_ADJUST_VIEW_OFF_VALUE))
    {if (select == COREG_LOCKED_TO_VALUE)
        {
         if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
            {view = img->cur_slice->slice->view;
             if ((err = GroupViewWids(view,wids,0,1)) == NO_ERROR)
                {drop_str_ptr_from_strs_rec(wids,view->wid);
                 if (wids->num_strs == 0)
                    ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
                         "No other WID to lock to !!!",NULL,0);
                   else
                    {str1 = win_rec_win_id_title(dwin->owner->owner,"Lock to");
                     ShowMenuStrsProc(window,last_event,str1,
                       wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       win_co_register_to_wid,dwin->owner,1,0,0);
                     c_free(str1);}
                }
             if ((err != NO_ERROR) || (wids->num_strs == 0))
                {free_strs_rec_ptrs(wids);
                 c_free(wids);}
            }
        }
       else if (select == COREG_UNLOCK_FROM_VALUE)
        {if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
            {if ((err = win_co_registered_wids(dwin->owner,wids,0,1,1)) == NO_ERROR)
                {if (wids->num_strs == 0)
                    ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
                         "Not locked !!!",NULL,0);
                   else 
                    {str1 = win_rec_win_id_title(dwin->owner->owner,
                           "Unlock from");
                     ShowMenuStrsProc(window,last_event,str1,
                       wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       WinUncoRegisterFromWid,dwin->owner,1,1,0);
                     c_free(str1);}
                }
             if ((err != NO_ERROR) || (wids->num_strs == 0))
                {free_strs_rec_ptrs(wids);
                 c_free(wids);}
            }
        }
       else if (select == COREG_UNLOCK_CUR_WID_FROM_ALL_GROUP_WIDS_VALUE)
        {
         if (is_3d_win_locked(dwin->owner) & 8)
            {view = img->cur_slice->slice->view;
             sprintf(str,"Unlocked %s",view->wid);
             ShowMsgStrs(dwin->frame,1,NO_ERROR,1,2,
                  str, "from all WIDs in the same group !!!",
                  WinUncoRegisterWithAll,3,dwin->owner,1,0);}
           else
            ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
                         "Not locked !!!",NULL,0);
        }
       else if (select == COREG_UNLOCK_ALL_GROUP_WIDS_VALUE)
        {ShowMsgStrs(dwin->frame,1,NO_ERROR,1,2,
               "Unlocked all WIDs...","in the same group !!!",
         win_unco_register_all_group_wids,3,dwin->owner,1,0);}
       else if (select == COREG_UNLOCK_ALL_WIDS_VALUE)
        {ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
               "Unlocked every Wid for every group...",
         win_unco_register_every_wid,3,dwin->owner,1,0);}
       else if (select == COREG_LOCK_ALL_COPLANES_VALUE)
        {ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
               "Lock all co-planes of wid...",
         win_lock_coplanes_of_wid,1,dwin->owner);}
       else if (select == COREG_UNLOCK_ALL_COPLANES_VALUE)
        {ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
               "Unlock all co-planes of wid...",
         win_unlock_coplanes_of_wid,1,dwin->owner);}
       else if (select == COREG_ADJUST_VIEW_AND_COPLANES_ON_VALUE)
        {ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
               "Turn on the Adjust mode for the wid & all its co-planes...",
         win_wid_and_coplane_adjust_mode_on,1,dwin->owner);}
       else if (select == COREG_ADJUST_VIEW_AND_COPLANES_OFF_VALUE)
        {ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
               "Turn off the Adjust mode for the wid & all its co-planes...",
         win_wid_and_coplane_adjust_mode_off,1,dwin->owner);}
       else if (select == COREG_ADJUST_VIEW_ON_VALUE)
        {ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
               "Turn on the Adjust mode for the wid only...",
         win_wid_adjust_mode_on,1,dwin->owner);}
       else if (select == COREG_ADJUST_VIEW_OFF_VALUE)
        {ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
               "Turn off the Adjust mode for the wid only...",
         win_wid_adjust_mode_off,1,dwin->owner);}
    }
   else if ((select >= COREG_CO_VALUE) && (select <= COREG_RECO_VALUE))
    {
     if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
        {view = img->cur_slice->slice->view;
         if (select == COREG_CO_VALUE)
            err = AnyViewWids(img->file,wids,0,1,0,0,view->group_num);
           else err = win_co_registered_wids(dwin->owner,wids,0,1,2);
         if (err != NO_ERROR)
            {free_strs_rec_ptrs(wids);
             c_free(wids);}
           else
            {if (wids->num_strs == 0)
                {if (select == COREG_UNCO_VALUE)
                    ShowMsgStrs(dwin->frame,1,NO_ERROR,2,1,
                        "NOTHING TO UNCO-REGISTER !!!",NULL,0);
                   else if (select == COREG_CO_AND_FUSION_VALUE)
                    ShowMsgStrs(dwin->frame,1,NO_ERROR,2,1,
                        "No CO-REGISTERED wid to superimpose !!!",NULL,0);
                   else if (select == COREG_RECO_VALUE)
                    ShowMsgStrs(dwin->frame,1,NO_ERROR,2,2,
                        "Hasn't been CO-REGISTERED yet !!!",
                        "Cannot reco-register !!!",NULL,0);
                   else
                    ShowMsgStrs(dwin->frame,1,NO_ERROR,2,1,
                        "NO OTHER FILE WIDs TO BE CO-REGISTERED !!!",NULL,0);
                 c_free(wids);}
               else if (select == COREG_UNCO_VALUE)
                {str1 = win_rec_win_id_title(dwin->owner->owner,
                          "UNCO-REGISTER WITH");
                 ShowMenuStrsProc(window,last_event,str1,
                       wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       WinUncoRegisterFromWid,dwin->owner,1,1,0);
                 c_free(str1);
                }
               else if (select == COREG_CO_AND_FUSION_VALUE)
                {if (wids->num_strs == 1)
                    {sprintf(str,"SUPERIMPOSE CUR WINDOW WITH %s",wids->strs[0]);
                     ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
                        str,win_fusion_which_win_proc,2,
                              dwin->owner,wids->strs[0]);
                     free_strs_rec_ptrs(wids);
                     c_free(wids);
                    }
                   else
                    {str1 = win_rec_win_id_title(dwin->owner->owner,
                          "SUPERIMPOSE CO-REG IMAGE");
                     ShowMenuStrsProc(window,last_event,str1,
                       wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       win_fusion_which_win_proc,dwin->owner,1,0,0);
                     c_free(str1);
                    }
                }
               else if (select == COREG_RECO_VALUE)
                {if (wids->num_strs == 1) 
                    {sprintf(str,"Reco-register with %s",wids->strs[0]);
                     ShowMsgStrs(dwin->frame,1,NO_ERROR,1,1,
                        str,win_reco_register,2,
                              dwin->owner,wids->strs[0]);
                     free_strs_rec_ptrs(wids);
                     c_free(wids);
                    }
                   else
                    {add_str_to_strs_rec(wids,"ALL CO-REG WIDS");
                     str1 = win_rec_win_id_title(dwin->owner->owner,
                          RECO_REGISTER_WITH_WID);
                     ShowMenuStrsProc(window,last_event,str1,
                       wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       win_reco_register,dwin->owner,1,0,0);
                     c_free(str1);
                    }
                }
               else
                {str1 = win_rec_win_id_title(dwin->owner->owner,
                          "CO-REGISTER WITH");
                 ShowMenuStrsProc(window,last_event,str1,
                   wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                      win_check_and_co_register_to_wid,dwin->owner,1,0,0);
                 c_free(str1);
                }
             }
         }
     }
   else if (select == COREG_UNCO_ALL_GROUP_WIDS_VALUE)
    {
     ShowMsgStrs(dwin->frame,1,NO_ERROR,2,1,
         "UNCO-REGISTER all group WIDs !!!...",
         win_unco_register_all_group_wids,3,dwin->owner,0,1);}
   else if (select == COREG_UNCO_ALL_WIDS_VALUE)
    {
     ShowMsgStrs(dwin->frame,1,NO_ERROR,2,1,
         "UNCO-REGISTER every WID for every group !!!",
         win_unco_register_every_wid,3,dwin->owner,0,1);}
   else if (select == COREG_UNCO_CUR_WID_FROM_EVERY_GROUP_VALUE)
    {
     ShowMsgStrs(dwin->frame,1,NO_ERROR,2,1,
         "UNCO-REGISTER cur WID from every group !!!",
         WinUncoRegisterWithAll,3,dwin->owner,0,1);}
/*
   else if (select == 14)
    {win_co_register_onoff(dwin->owner,0);
    }
*/
   else if (select == COREG_UNCO_AND_UNLOCK_ALL_WIDS_VALUE)
    {
     ShowMsgStrs(dwin->frame,1,NO_ERROR,2,1,
         "Unlock & UNCO-REGISTER every WID for every group !!!...",
         win_unco_register_all_group_wids,3,dwin->owner,1,1);
    }
 set_win_not_busy(dwin->owner);
 PRT2(printf("_3d_co_register_proc...done\n"))
}


/*-----------------------------------------------------------------------
same_co_plane_proc - ???
-----------------------------------------------------------------------*/

int
same_co_plane_proc(win,str,is_superimpose)
 struct image_display_window *win;
 char *str;
 int is_superimpose;
{
 char *str1,reg_wid[30],co_reg_wid[30],co_wid[30];
 int start_indx1,start_indx2;
 struct img_buf_rec *img;
 struct view_rec *view;
 int err;

 PRT3(printf("same_co_plane_proc str = %s su = %d\n",str,is_superimpose);)
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) 
    return CANCEL;
 if (str != NULL)
    {if (((err = find_sub_str(str,"@",&start_indx1)) != NO_ERROR) ||
         ((err = find_sub_str(&(str[start_indx1 + 1]),"@",&start_indx2))
                   != NO_ERROR))
        return err;
     strncpy(reg_wid,str,start_indx1);
     reg_wid[start_indx1] = '\0';
     strncpy(co_reg_wid,&(str[start_indx1 + 1]),start_indx2);
     co_reg_wid[start_indx2] = '\0';
     start_indx1 += start_indx2 + 2;
     strcpy(co_wid,&(str[start_indx1]));

     PRT2(printf("reg_wid = %s co_reg_wid = %s co_wid = %s\n",
              reg_wid,co_reg_wid,co_wid);)
     if ((err = win_co_plane(win,reg_wid,co_reg_wid,co_wid)) ==
            NO_ERROR)
        {PRT8(printf("is_superimpose = %d\n",is_superimpose))
         if (is_superimpose)
            if ((view = find_any_view_rec(img->file,co_wid)) != NULL)
               {concat_strs(&str1,2,"SUPERIMPOSE CUR WINDOW WITH ",view->wid);
                ShowMsgStrs(win->dwin->frame,1,NO_ERROR,1,1,
                        str1,win_fusion_which_win_proc,2,
                              win,view->wid);
                c_free(str1);}
        }
       else
        ShowMsgStrs(win->dwin->frame,0,err,0,1,
                "Fail to make the same co-plane orientation !!",NULL,0);
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
_3d_same_co_plane_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_same_co_plane_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct strs_rec *wids;
 int err;
 static int is_superimpose;
 char *str;

 PRT2(printf("_3d_same_co_plane_proc...\n"))
 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 set_win_busy(dwin->owner);
 if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
    if ((err = win_co_reg_path_wids(dwin->owner,wids)) == NO_ERROR)
       {if (wids->num_strs == 0)
           add_str_to_strs_rec(wids,"NO CO-REG WIDs !!!");
        is_superimpose = 1;
        if (last_event != NULL)
           {if (event_shift_is_down(last_event))
               {is_superimpose = 0;
                str = win_rec_win_id_title(dwin->owner->owner,
                          "SAME CO-PLANE ORIENTATION");
                err = ShowMenuStrsProc(window,last_event,str,
                    wids,USER_MENU_FREE_STRS_AND_PTR,
                      same_co_plane_proc,dwin->owner,1,is_superimpose,0);
                c_free(str);
               }
           }
        if (is_superimpose)
           {str = win_rec_win_id_title(dwin->owner->owner,
                          "SAME CO-PLANE ORIENTATION & SUPERIMPOSE");
            err = ShowMenuStrsProc(window,last_event,str,
                    wids,USER_MENU_FREE_STRS_AND_PTR,
                      same_co_plane_proc,dwin->owner,1,is_superimpose,0);
            c_free(str);
           }
       }
      else
       {free_strs_rec(wids);
        c_free(wids);}
 if (err != NO_ERROR)
    ShowMsgStrs(dwin->frame,0,err,0,1,
                "Insufficient Memory !!",NULL,0);
 set_win_not_busy(dwin->owner);
 PRT2(printf("_3d_same_co_plane_proc...done\n"))
}


/*-----------------------------------------------------------------------
resize_group_proc - ???
-----------------------------------------------------------------------*/

int
resize_group_proc(win,wid)
 struct image_display_window *win;
 char *wid;
{
 PRT1(printf("resize_group_proc...wid = %s\n",wid);)
 if (wid != NULL)
    win_resize_group_voxel(win,wid);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
_3d_resize_group_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_resize_group_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct img_buf_rec *img;
 struct strs_rec *wids;
 char *str;
 int err;

 PRT2(printf("_3d_resize_group_proc...\n"))
 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) 
    return;
 dwin->owner->dwin = dwin;
 set_win_busy(dwin->owner);
 if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
    if ((err = AnyViewWids(img->file,wids,1,1,1,1,0)) == NO_ERROR)
       {
        str = win_rec_win_id_title(dwin->owner->owner,
                          "RESIZE GROUP TO WID VOXEL SIZE");
        ShowMenuStrsProc(window,last_event,str,
                    wids,USER_MENU_FREE_STRS_AND_PTR,
                      resize_group_proc,dwin->owner,1,0,0);
        c_free(str);
       }
     else
      {free_strs_rec(wids);
       c_free(wids);}
 set_win_not_busy(dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_reverse_plane_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_reverse_plane_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;

 TRACE(printf("_3d_reverse_plane_proc\n"))
 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 set_win_busy(dwin->owner);
 ShowMsgStrs(dwin->frame,1,NO_ERROR,2,1,
               "Reverse the plane sequence !!!",
                win_reverse_plane,1,dwin->owner);
 set_win_not_busy(dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_new_plane_proc - ???

 select = 0 then is_same_orientation
 select = 1 then is_same_plane
 select = 2 then new window <-- 90 degree to center(wid - cur)
 select = 3 then new window <-- 90 degree to both normal(wid,cur)
-----------------------------------------------------------------------*/

void 
_3d_new_plane_proc(menu,item,arg,window,last_event,select)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int select;
{
 struct display_win_rec *dwin;
 struct strs_rec *wids;
 struct img_buf_rec *img;
 struct view_rec *view;
 char *str;
 int err;

 TRACE(printf("_3d_new_plane_proc\n"))
 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 dwin->owner->dwin = dwin;
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return;
 if (select)
    {
     if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
        {view = img->cur_slice->slice->view;
         if ((err = GroupViewWids(view,wids,0,1)) == NO_ERROR)
            {drop_str_ptr_from_strs_rec(wids,view->wid);
             if (wids->num_strs == 0)
                {if (select == 1)
                    ShowMsgStrs(dwin->frame,1,NO_ERROR,1,2,
                         "Same plane action not done !!!",
                         "No other WID available !!!",NULL,0);
                   else if (select == 2)
                    ShowMsgStrs(dwin->frame,1,NO_ERROR,1,2,
                         "NEW WID = 90_DEG to CENTER(WID - CUR_WID) not done !!!",
                         "No other WID available !!!",NULL,0);
                   else ShowMsgStrs(dwin->frame,1,NO_ERROR,1,2,
                         "NEW WID = 90_DEG to CUR_WID & WID not done !!!",
                         "No other WID available !!!",NULL,0);
                }
               else 
                {if (select == 1)
                    {str = win_rec_win_id_title(dwin->owner->owner,
                          "Same plane as");
                     ShowMenuStrsProc(window,last_event,str,
                       wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       win_same_plane,dwin->owner,1,0,0);
                    }
                   else if (select == 2)
                    {str = win_rec_win_id_title(dwin->owner->owner,
                          "NEW = 90_DEG to CENTER(WID - CUR_WID)");
                     ShowMenuStrsProc(window,last_event,str,
                       wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       win_new_3d_win_normal_to_centers,dwin->owner,1,0,0);
                    }
                   else 
                    {str = win_rec_win_id_title(dwin->owner->owner,
                          "NEW = 90_DEG to CUR_WID & WID");
                     ShowMenuStrsProc(window,last_event,str,
                       wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       win_new_3d_win_normal_to_normals,dwin->owner,1,0,0);
                    }
                 c_free(str);
                }
            }
         if ((err != NO_ERROR) || (wids->num_strs == 0))
            {free_strs_rec_ptrs(wids);
             c_free(wids);}
        }
    }
   else
    {if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
        {if ((err = AnyViewWids(img->file,wids,0,1,1,1,0)) == NO_ERROR)
            {
             if (wids->num_strs > 1)
                {view = img->cur_slice->slice->view;
                 drop_str_ptr_from_strs_rec(wids,view->wid);
                 str = win_rec_win_id_title(dwin->owner->owner,
                          "SAME ORIENTATION AS");
                 ShowMenuStrsProc(window,last_event,str,
                       wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       win_same_orientation,dwin->owner,1,0,0);
                 c_free(str);
                }
               else
                {free_strs_rec_ptrs(wids);
                 c_free(wids);
                 ShowMsgStrs(dwin->frame,1,err,2,1,
                    "Sorry...no other WID available !!",NULL,0);
                }
            }
           else
            {free_strs_rec_ptrs(wids);
             c_free(wids);}
        }
    }
}


/*-----------------------------------------------------------------------
_3d_plane_key_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_plane_key_proc(menu,item,arg,window,last_event,mode)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int mode;
{
 struct display_win_rec *dwin;
 struct img_buf_rec *img;
 int is_clear;
 unsigned short status;

 PRT1(printf("_3d_plane_key_proc\n"))
 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return;
 set_win_busy(dwin->owner);
 status = img->file->slice_info.status & _3D_KP_MODE;
 img->file->slice_info.status &= ~_3D_KP_MODE;
 if (status & _3D_ORIENTATION_KEY_ENABLED)
    img->file->slice_info.status |= _3D_ABS_FLIP_KEY_ENABLED;
   else if (!(status & _3D_ABS_FLIP_KEY_ENABLED))
    {img->file->slice_info.status |= _3D_ORIENTATION_KEY_ENABLED;}
 is_clear = 1;
 win_execute_proc_to_multiple_wins(dwin->owner,win_draw_enabled_label,
				   &is_clear,0,0,0,0);
 set_win_not_busy(dwin->owner);
}


/*-----------------------------------------------------------------------
_3d_cur_wid_roi - ???
-----------------------------------------------------------------------*/

int
_3d_cur_wid_roi(view,wid)
 struct view_rec *view;
 char *wid;
{
 if ((view->img != NULL) && (view->img->win != NULL) &&
     (view->img->win->image_display != NULL))
    WinNextCurRoi(view->img->win->image_display,wid);
 return NO_ERROR;    
}


/*-----------------------------------------------------------------------
_3d_cur_wid_roi_proc - ???
-----------------------------------------------------------------------*/

void 
_3d_cur_wid_roi_proc(menu,item,arg,window,last_event,mode)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int mode;
{
 struct display_win_rec *dwin;
 struct img_buf_rec *img;
 struct view_rec *view;

 PRT1(printf("_3d_plane_key_proc\n"))
 if (menu == 0)   dwin = (struct display_win_rec *) arg;
   else dwin = (struct display_win_rec *) xv_get(menu,MENU_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return;
 set_win_busy(dwin->owner);
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) != NULL) 
    {view = img->cur_slice->slice->view;
     run_next_view_proc(view,_3d_cur_wid_roi,view->wid,0,0,0,0,0);
    }
 set_win_not_busy(dwin->owner);
}


/*-----------------------------------------------------------------------
update_3d_rois_proc - ???
-----------------------------------------------------------------------*/

void 
update_3d_rois_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("update_3d_rois_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;
 WinUpdate3dRois(win);
}


/*-----------------------------------------------------------------------
enter_3d_plane_proc - ???
-----------------------------------------------------------------------*/

void 
enter_3d_plane_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_3d_plane_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;

 enter_3d_plane(win,1);
}


/*-----------------------------------------------------------------------
enter_3d_more_plane_proc - ???
-----------------------------------------------------------------------*/

void 
enter_3d_more_plane_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_3d_more_plane_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;

 enter_3d_more_plane(win,1);
}


/*-----------------------------------------------------------------------
enter_3d_co_menu_proc - ???
-----------------------------------------------------------------------*/

void 
enter_3d_co_menu_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_3d_co_register_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;
 enter_3d_co_menu(win,1);

}


/*-----------------------------------------------------------------------
enter_3d_file_menu_proc - ???
-----------------------------------------------------------------------*/

void 
enter_3d_file_menu_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_3d_file_menu_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;

 enter_3d_file_menu(win,1);
}


/*-----------------------------------------------------------------------
enter_3d_resize_proc - ???
-----------------------------------------------------------------------*/

void 
enter_3d_resize_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_3d_resize_image_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;

 enter_3d_resize_menu(win,1);
}


/*-----------------------------------------------------------------------
enter_3d_rois_and_pixel_types_proc - ???
-----------------------------------------------------------------------*/

void 
enter_3d_rois_and_pixel_types_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_3d_rois_and_pixel_types_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;

 enter_3d_rois_and_pixel_types(win,1);
}


/*-----------------------------------------------------------------------
enter_3d_save_menu_proc - ???
-----------------------------------------------------------------------*/

void 
enter_3d_save_menu_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_3d_save_menu_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;

 enter_3d_save_menu(win,1);
}


/*-----------------------------------------------------------------------
enter_3d_param_menu_proc - ???
-----------------------------------------------------------------------*/

void 
enter_3d_param_menu_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_3d_save_menu_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;
 enter_3d_param_menu(win,1);
}


/*-----------------------------------------------------------------------
enter_3d_split_rois_proc - ???
-----------------------------------------------------------------------*/

void
enter_3d_split_rois_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct img_buf_rec *img;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_3d_split_rois_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;
 if (img->cur_slice->slice->view->status & PLANE_3D_SUB_OBJ)
    {ShowMsgStrs(dwin->frame,0,NO_ERROR,0,2,
         "This is already a sub object !!!",
         "It can be sub-divided further !!!",NULL,0);
    }
 else enter_3d_split_rois(win,1);
}


/******************
enter_3d_display_menu_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_3d_display_menu_proc...\n"))
 if (menu == NULL)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;

 enter_3d_display_menu(win,1);
}
**********************/


/*-----------------------------------------------------------------------
save_open_cur_plane_proc - ???
-----------------------------------------------------------------------*/

void 
save_open_cur_plane_proc(menu,item,arg,window,last_event,select)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int select;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 int err;
 Menu root;

 TRACE(printf("save_open_cur_plane_proc...\n"))
 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        {dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
         window = canvas_paint_window(dwin->frame_canvas.canvas);}
    }

 win = dwin->owner;
 win->dwin = dwin;
 set_win_busy(win);
 if (select == 1)
    err = WinShowCurDirParamFns(win,"*.npar");
   else if (select == 0)
     err = win_save_npar(win);
   else if (select == 3)
    err = WinShowCurDirParamFns(win,"*.npco");
   else err = win_save_which_npco(win);

 set_win_not_busy(win);
 return;
}
