#include "mri_format.h"
/*
cc -c v3_wr_ria_dat.c
*/
/*
#define TRACE(x)
#define PRT(x) x; fflush(stdout);
*/
#define PRT(x)
#define TRACE(x)
/*
init_output_hdr_info_rec(info)
init_output_hdr_rec(hdr)
free_output_hdr_info_rec(info)
free_output_hdr_rec(hdr)

wr_strs_rec(fid,ptr)
wr_str_value_rec(fid,str_value)
wr_str_value_recs(fid,str_values,num_str_values)
wr_output_hdr_info_rec(fid,info)
wr_output_field_offset_rec(fid,offset)
wr_output_hdr_rec(fid,hdr,offset)

wr_output_slice_nums(fid,slice_nums,num_slice_rois)
wr_histo_pixel_center_recs(fid,centers,num_centers)
wr_histo_bkg_rec(fid,bkg)
wr_histo_params(fid,histo)
wr_text_output_analysis_group_rec(fid,group)
wr_pixel_type_cnt_rec(fid,pixel_cnt)
wr_roi_pixel_type_cnts(fid,sroi_wins,num_sroi_wins)
wr_pixel_type_params(fid,pixel_type)
wr_input_text_file_format(fid,text)
wr_output_field_rec(fid,group)
wr_output_count_field_rec(fid,group)
wr_output_count_group_rec(fid,count)
wr_output_text_file_format(fid,text)
wr_text_file_format(fid,text)

wr_roi_count_anal_rec(fid,roi)
wr_slice_count_anal_rec(fid,slice)
wr_slice_count_anal_recs(fid,slices,num_slices)
wr_count_analysis_rec(fid,count)

wr_ria_slice_rois(fid,slices,num_slices)
setup_slice_nums(hdr,slices,num_slices,total_slices)
wr_ria_dat_file(fn,hdr,slices,num_slices,total_slices,
                histo,pixel_type,text)
setup_slice_num_and_roi_rec(slice_rois,total_slices,slices,num_slices)
WrRiaNdatFile(fn,hdr,slice_rois,total_slices,
                histo,pixel_type,groups,num_groups,format,count)
*/
init_output_hdr_info_rec(info)
 struct output_hdr_info_rec *info;
{
 info->status = 0;
 info->dirfn = NULL;
 info->fn = NULL;
 info->hdr_fn_suffix = NULL;
 info->img_fn_suffix = NULL;

}

init_output_hdr_rec(hdr)
 struct output_hdr_rec *hdr;
{
 hdr->id = NULL;
 hdr->rater = NULL;
 init_output_hdr_info_rec(&(hdr->info));
 hdr->actual_total_slice_rois = 0;
 hdr->num_slice_rois = 0;
 hdr->slice_nums = NULL;
}

free_output_hdr_info_rec(info)
 struct output_hdr_info_rec *info;
{
 TRACE(printf("info->dirfn = %s %s %s %s\n",info->dirfn,info->fn,info->hdr_fn_suffix,
    info->img_fn_suffix))

 c_free(info->dirfn);
 c_free(info->fn);
 c_free(info->hdr_fn_suffix);
 c_free(info->img_fn_suffix);
 init_output_hdr_info_rec(info);
}

free_output_hdr_rec(hdr)
 struct output_hdr_rec *hdr;
{
 TRACE(printf("free_output_hdr_rec...end hdr->num_slice_rois = %d\n",
           hdr->num_slice_rois))
 c_free(hdr->id);
 c_free(hdr->rater);
 free_output_hdr_info_rec(&(hdr->info));
 if (hdr->num_slice_rois > 0)
    c_free(hdr->slice_nums);
 init_output_hdr_rec(hdr);

}

/*
wr_str_value_rec(fid,str_value)
 FILE *fid;
 struct str_value_rec *str_value;
{
 int err;

 if ((err = wr_file_strs(fid,&(str_value->str),1)) != NO_ERROR)
    return err;
 if (fwrite(&(str_value->value),(size_t) sizeof(str_value->value),1,fid) != 1)
    return WRITE_ERROR;
 return NO_ERROR;
}

wr_str_value_recs(fid,str_values,num_str_values)
 FILE *fid;
 struct str_value_rec *str_values;
 unsigned long num_str_values;
{
 unsigned long lcv;
 int err;

 if (fwrite(&num_str_values,(size_t) sizeof(num_str_values),1,fid) != 1)
    return WRITE_ERROR;
 if (num_str_values == 0) return NO_ERROR;

 for (lcv = 0; lcv < num_str_values; lcv++)
    if ((err = wr_str_value_rec(fid,&(str_values[lcv]))) != NO_ERROR)
       {return err;}
 return NO_ERROR;
}
*/
/*
wr_output_hdr_info_rec(fid,info)
 FILE *fid;
 struct output_hdr_info_rec *info;
{
 int err;

 err = WRITE_ERROR;
 if (((err = wr_file_strs(fid,&(info->dirfn),1)) != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->fn),1)) != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->hdr_fn_suffix),1)) != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->img_fn_suffix),1)) != NO_ERROR) ||
     (fwrite(&(info->dimx),
              sizeof(info->dimx),1,fid) != 1) ||
     (fwrite(&(info->dimy),
              sizeof(info->dimy),1,fid) != 1) ||
     (fwrite(&(info->max_slices),
              sizeof(info->max_slices),1,fid) != 1) ||
     (fwrite(&(info->pixel_depth_bits),
              sizeof(info->pixel_depth_bits),1,fid) != 1))
    return err;
 TRACE(printf("info->dirfn = %s %s %s %s\n",info->dirfn,info->fn,
       info->hdr_fn_suffix,info->img_fn_suffix))
 return NO_ERROR;
}
*/

wr_output_field_offset_rec(fid,offset)
 FILE *fid;
 struct output_field_offset_rec *offset;
{
 if (fwrite(&(offset->slice_roi_start),40,1,fid) != 1)
    return WRITE_ERROR;
 return NO_ERROR;
}

wr_output_hdr_rec(fid,hdr,offset)
 FILE *fid;
 struct output_hdr_rec *hdr;
 unsigned long *offset;
{
 int err;

 TRACE(printf("wr_output_hdr_rec...id = %s rater = %s\n",hdr->id,hdr->rater);)
 err = WRITE_ERROR;
 hdr->size = 0;
 if ((hdr->id == NULL) || (str_cmp(hdr->id,DAT_ID_V3) != 0))
    {c_free(hdr->id);
     cp_str(&(hdr->id),DAT_ID_V3);}
 if ((fwrite(&(hdr->size),(size_t) sizeof(hdr->size),1,fid) == 1) &&
     ((err = wr_file_strs(fid,&(hdr->id),1)) == NO_ERROR) &&
     ((err = wr_file_strs(fid,&(hdr->rater),1)) == NO_ERROR))
    {fflush(fid);
     *offset = ftell(fid);}
   else return err;
 TRACE(printf("wr_output_hdr_rec...3\n");)
 if ((err = wr_output_field_offset_rec(fid,&(hdr->offset))) != NO_ERROR)
   return err;
 fflush(fid);
/*
 hdr->offset.info_start = ftell(fid);
 if ((err = wr_output_hdr_info_rec(fid,&(hdr->info))) == NO_ERROR)
    {fflush(fid);
     hdr->offset.info_size = sizeof(hdr->info);
    }
*/
 TRACE(printf("wr_output_hdr_rec...err = %d\n",err);)
 return err;
}

wr_output_slice_nums(fid,slice_nums,num_slice_rois)
 FILE *fid;
 unsigned long *slice_nums;
 unsigned long num_slice_rois;
{
 unsigned long total;
 int err;

 if (num_slice_rois == 0) return NO_ERROR;
 TRACE(printf("wr_output_slice_nums\n"))
 if (fwrite(slice_nums,(size_t) (sizeof(*slice_nums) * num_slice_rois),
              1,fid) != 1)
     return WRITE_ERROR;
 return NO_ERROR;

}
/*
wr_histo_pixel_center_recs(fid,centers,num_centers)
 FILE *fid;
 struct pixel_center_rec *centers;
 unsigned long num_centers;
{
 unsigned long lcv;
 int err;

  TRACE(printf("wr_histo_pixel_center_recs...\n"))

 if (fwrite(&(num_centers),(size_t) sizeof(num_centers),1,fid) == 1)
    for (lcv = 0; lcv < num_centers; lcv++)
       {if (((err = wr_file_strs(fid,&(centers[lcv].roi_label),1)) !=
                  NO_ERROR) ||
            ((err = wr_file_strs(fid,&(centers[lcv].segmented_roi_label),1)) !=
                  NO_ERROR))
           return err;
        if (fwrite(&(centers[lcv]),(size_t) sizeof(centers[lcv]),1,fid) != 1)
           return err;
       }
   else return WRITE_ERROR;
  TRACE(printf("wr_histo_pixel_center_recs...end\n"))

 return NO_ERROR;
}
*/
wr_histo_bkg_rec(fid,bkg)
 FILE *fid;
 struct histo_bkg_rec *bkg;
{
 int err;

 TRACE(printf("wr_histo_bkg_rec...bkg->num_bkgs = %d\n",bkg->num_bkgs))
 if (fwrite(&(bkg->num_bkgs),(size_t) sizeof(bkg->num_bkgs),1,fid) != 1)
    return WRITE_ERROR;
 if (bkg->num_bkgs == 0) return NO_ERROR;
 if (fwrite(bkg->bkgs,(size_t) (bkg->num_bkgs * sizeof(*(bkg->bkgs))),1,fid)
           != 1)
    return WRITE_ERROR;
 TRACE(printf("wr_histo_bkg_rec.2..bkg->num_bkgs = %d\n",bkg->num_bkgs))
 TRACE(pr_roi_rec(&(bkg->roi));)

 err = v3_wr_roi_rec(fid,&(bkg->roi));
 TRACE(printf("wr_histo_bkg_rec...err = %d\n",err))
 return err;
}

wr_histo_params(fid,histo)
 FILE *fid;
 struct histo_params_rec *histo;
{
 int err;
 unsigned short histo_status2;

 TRACE(printf("wr_histo_params..\n"))
 if (histo == NULL) histo_status2 = 0;
   else histo_status2 = histo->status2;
 if (fwrite(&histo_status2,(size_t) sizeof(histo_status2),1,fid) != 1)
    return WRITE_ERROR;

 TRACE(printf("wr_histo_params...\n"))
 if (histo_status2 & HISTO_TYPE)
    {if (((err = v3_wr_slice_roi_rec(fid,&(histo->slice_roi_win_2d.slice_roi)))
              != NO_ERROR) ||
         ((err = v3_wr_slice_roi_rec(fid,&(histo->slice_roi_win_1d.slice_roi)))
              != NO_ERROR) ||
         ((err = wr_histo_bkg_rec(fid,&(histo->bkg))) != NO_ERROR) ||
         ((err = wr_strs_rec(fid,&(histo->pixel_type_order))) == NO_ERROR))
        return err;
    }
   else err = NO_ERROR;
 if (err == NO_ERROR)
    if (histo_status2 & HISTO_CNT_1D_VALID)
       err = v3_wr_non_contiguos_buf_2d_rec(fid,&(histo->histo_1d));
 return err;
}

wr_text_output_analysis_group_rec(fid,group)
 FILE *fid;
 struct text_output_analysis_group_rec *group;
{
 unsigned long lcv;
 int err;

 if (fwrite(&(group->num_rois),(size_t) sizeof(group->num_rois),1,fid) != 1)
    return WRITE_ERROR;
 if (group->num_rois == 0) return NO_ERROR;
 if ((err = wr_file_strs(fid,group->roi_labels,group->num_rois)) != NO_ERROR)
    return err;

 if (fwrite(&(group->num_pixel_types),(size_t) sizeof(group->num_pixel_types),1,fid)
        != 1) return WRITE_ERROR;
 if (group->num_pixel_types == 0) return NO_ERROR;

 if ((err = wr_file_strs(fid,group->pixel_type_labels,group->num_pixel_types))
        != NO_ERROR) return WRITE_ERROR;
 return NO_ERROR;
}

wr_pixel_type_cnt_rec(fid,pixel_cnt)
 FILE *fid;
 struct pixel_type_cnt_rec *pixel_cnt;
{
 TRACE(printf("wr_pixel_type_cnt_rec...begin\n"))
 if (pixel_cnt->num_pixel_type_cnts == 0) return NO_ERROR;
 if ((fwrite(&(pixel_cnt->status),(size_t) sizeof(pixel_cnt->status),1,fid) != 1) ||
     (fwrite(&(pixel_cnt->num_pixel_type_cnts),
             sizeof(pixel_cnt->num_pixel_type_cnts),1,fid) != 1) ||
     (fwrite(pixel_cnt->pixel_type_cnts,
       (size_t) (pixel_cnt->num_pixel_type_cnts * sizeof(unsigned long)),
            1,fid) != 1))
    return WRITE_ERROR;
 TRACE(printf("wr_pixel_type_cnt_rec...end\n"))
 return NO_ERROR;
}
/*
wr_roi_pixel_type_cnts(fid,sroi_wins,num_sroi_wins)
 FILE *fid;
 struct slice_roi_win_rec **sroi_wins;
 unsigned long num_sroi_wins;
{
 unsigned long lcv,cnt,num_slices,num_rois;
 unsigned long next_start,first_slice_start,first_roi_start;
 char first_slice,first_roi;
 struct slice_roi_rec *slice_roi;
 int err;

 TRACE(printf("wr_roi_pixel_type_cnts...begin\n"))
 num_slices = 0;
 fflush(fid);
 first_slice_start = ftell(fid);
 if (fseek(fid,(size_t) sizeof(num_slices),1) != 0) return WRITE_ERROR;
 TRACE(printf("wr_roi_pixel_type_cnts...1\n"))

 for (lcv = 0; lcv < num_sroi_wins; lcv++)
    {
     slice_roi = &(sroi_wins[lcv]->slice_roi);
     for (num_rois = 0,first_roi = 1,cnt = 0; cnt < slice_roi->num_rois; cnt++)
        if (slice_roi->rois[cnt]->user.ptr != NULL)
           {
            if (first_roi)
               {if (fwrite(&lcv,(size_t) sizeof(lcv),1,fid) != 1) return WRITE_ERROR;
     TRACE(printf("wr_roi_pixel_type_cnts...lcv = %d slice_roi->num_rois = %d\n",lcv,
            slice_roi->num_rois))
                num_slices += 1;
                fflush(fid);
                first_roi_start = ftell(fid);
                first_roi = 0;
                if (fwrite(&num_rois,(size_t) sizeof(num_rois),1,fid) != 1)
                   return WRITE_ERROR;
               }
            if (((err = wr_file_strs(fid,&(slice_roi->rois[cnt]->label),1))
                  != NO_ERROR) ||
                ((err = wr_pixel_type_cnt_rec(fid,
                   slice_roi->rois[cnt]->user.ptr)) != NO_ERROR))
               return err;
            num_rois += 1;
           }
     if (first_roi == 0)
        {fflush(fid);
         next_start = ftell(fid);
         fseek(fid,first_roi_start,0);
         if (fwrite(&num_rois,(size_t) sizeof(num_rois),1,fid) != 1) return WRITE_ERROR;
         TRACE(printf("wr_roi_pixel_type_cnts...num_rois = %d\n",num_rois))
         fseek(fid,next_start,0);
        }
    }
 fflush(fid);
 next_start = ftell(fid);
 fseek(fid,first_slice_start,0);
 TRACE(printf("before writing num_slices offset = %d\n",first_slice_start))
 if (fwrite(&num_slices,(size_t) sizeof(num_slices),1,fid) != 1)
    return WRITE_ERROR;
 TRACE(printf("wr_roi_pixel_type_cnts...num_slices = %d\n",num_slices))
 fseek(fid,next_start,0);

 TRACE(printf("wr_roi_pixel_type_cnts...end\n"))
 return NO_ERROR;
}
*/
wr_pixel_type_params(fid,pixel_type)
 FILE *fid;
 struct pixel_type_rec *pixel_type;
{
 int err;

 if (pixel_type == NULL) return NO_ERROR;
 PRT(printf("\n\nwr_pixel_type_params...status = %x pixel_type->order.num_strs = %d\n",
     (unsigned long) pixel_type->status,pixel_type->order.num_strs))

 if (pixel_type->order.num_strs == 0) return NO_ERROR;
 if (!(pixel_type->map.status4 & BUF_DATA_VALID)) return NO_ERROR;

 if (fwrite(&(pixel_type->status),
           (size_t) sizeof(pixel_type->status),1,fid) != 1)
    return WRITE_ERROR;
 TRACE(printf("wr_pixel_type_params...order map\n"))
 if (((err = wr_strs_rec(fid,&(pixel_type->order))) != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(pixel_type->slice_map_data_creation_date),1
            )) != NO_ERROR) ||
     ((err = v3_wr_buf_2d_rec(fid,&(pixel_type->map))) != NO_ERROR))
    return err;

 TRACE(printf("wr_pixel_type_params...err = %d\n",err))
 return err;

}

wr_input_text_file_format(fid,groups,num_groups)
 FILE *fid;
 struct text_output_analysis_group_rec *groups;
 unsigned long num_groups;
{
 unsigned long lcv;
 int err;

 if (groups == NULL) num_groups = 0;
 if (fwrite(&num_groups,(size_t) sizeof(num_groups),1,fid) != 1)
    return WRITE_ERROR;
 if (num_groups <= 0) return NO_ERROR;

 for (lcv = 0; lcv < num_groups; lcv++)
    if ((err = wr_text_output_analysis_group_rec(fid,&(groups[lcv])))
           != NO_ERROR) 
       return err;
 TRACE(printf("wr_input_text_file_format...end\n"))
 return NO_ERROR;
}

wr_output_field_rec(fid,group)
 FILE *fid;
 struct output_field_rec *group;
{
 if ((fwrite(&(group->pixel_type_indx),(size_t) sizeof(group->pixel_type_indx),
              1,fid) != 1) ||
     (fwrite(&(group->num_roi_indxs),(size_t) sizeof(group->num_roi_indxs),
              1,fid) != 1))
    return WRITE_ERROR;
 if (group->num_roi_indxs > 0)
    if (fwrite(group->roi_indxs,(size_t) sizeof(*(group->roi_indxs)) *
              group->num_roi_indxs,1,fid) != 1)
       return WRITE_ERROR;
 return NO_ERROR;
}

wr_output_count_field_rec(fid,group)
 FILE *fid;
 struct output_count_field_rec *group;
{
 if (fwrite(&(group->num_fields),(size_t) sizeof(group->num_fields),1,fid) != 1)
    return WRITE_ERROR;
 if (group->num_fields > 0)
    if (fwrite(group->fields,(size_t) sizeof(*(group->fields)) *
              group->num_fields,1,fid) != 1)
       return WRITE_ERROR;

 return NO_ERROR;

}

wr_output_count_group_rec(fid,count)
 FILE *fid;
 struct output_count_group_rec *count;
{
 unsigned long lcv;
 int err;

 if (fwrite(&(count->num_groups),(size_t) sizeof(count->num_groups),1,fid) != 1)
    return WRITE_ERROR;

 for (lcv = 0; lcv < count->num_groups; lcv++)
    if ((err = wr_output_count_field_rec(fid,&(count->groups[lcv])))
               != NO_ERROR)
       return err;
 return NO_ERROR;
}

wr_output_text_file_format(fid,format)
 FILE *fid;
 struct output_text_format_rec *format;
{
 unsigned long lcv;
 int err;
 unsigned short status;

 TRACE(printf("wr_output_text_file_format...begin\n"))
 if (format == NULL) status = 0;
   else
    {status = format->status;
     if (format->status & OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW)
        status &= ~OUT_FORMAT_UNIT_2D_VALID;}

 if (fwrite(&status,(size_t) sizeof(status),1,fid) != 1)
    return WRITE_ERROR;
 TRACE(printf("wr_output_text_file_format...status = %x\n",(unsigned long) status))

 if (!(status & OUT_FORMAT_DEFINED))
    {TRACE(printf("!(status & OUT_FORMAT_DEFINED)\n"))
     return NO_ERROR;}

 if ((err = wr_strs_rec(fid,&(format->roi_labels))) != NO_ERROR)
    return err;
 if (format->roi_labels.num_strs > 0)
    if (fwrite(format->roi_nums,(size_t) sizeof(*(format->roi_nums)) *
              format->roi_labels.num_strs,1,fid) != 1)
       return WRITE_ERROR;

 if ((err = wr_strs_rec(fid,&(format->pixel_type_labels))) != NO_ERROR)
    return err;
 if (format->pixel_type_labels.num_strs > 0)
    if (fwrite(format->pixel_type_nums,
          sizeof(*(format->pixel_type_nums)) *
              format->pixel_type_labels.num_strs,1,fid) != 1)
       return WRITE_ERROR;

 if (fwrite(&(format->num_groups),(size_t) sizeof(format->num_groups),
              1,fid) != 1)
    return WRITE_ERROR;
 for (lcv = 0; lcv < format->num_groups; lcv++)
    if ((err = wr_output_field_rec(fid,&(format->groups[lcv])))
           != NO_ERROR) return err;

 if (fwrite(&(format->num_slices),(size_t) sizeof(format->num_slices),
              1,fid) != 1)
    return WRITE_ERROR;
 for (lcv = 0; lcv < format->num_slices; lcv++)
    if ((err = wr_output_count_group_rec(fid,&(format->counts[lcv])))
           != NO_ERROR) return err;

 if ((fwrite(&(format->page_num_rows),(size_t) sizeof(format->page_num_rows),
              1,fid) != 1) ||
     (fwrite(&(format->page_row_size),(size_t) sizeof(format->page_row_size),
              1,fid) != 1) ||
     (fwrite(&(format->num_field_spaces),
         sizeof(format->num_field_spaces),1,fid) != 1) ||
     (fwrite(&(format->num_collect_spaces),
         sizeof(format->num_collect_spaces),1,fid) != 1) ||
     (fwrite(&(format->xpixel_size),
           (size_t) sizeof(format->xpixel_size),1,fid) != 1) ||
     (fwrite(&(format->ypixel_size),
           (size_t) sizeof(format->ypixel_size),1,fid) != 1) ||
     (fwrite(&(format->pixel_thickness),
         sizeof(format->pixel_thickness),1,fid) != 1) ||
     (fwrite(&(format->voxel_size),
              (size_t) sizeof(format->voxel_size),1,fid) != 1))
    return WRITE_ERROR;
 if (status & OUT_FORMAT_LT_PERCENT_MEAN)
    if (fwrite(&(format->lt_percent),
              (size_t) sizeof(format->lt_percent),1,fid) != 1)
       return WRITE_ERROR;
 if (status & OUT_FORMAT_GT_PERCENT_MEAN)
    if (fwrite(&(format->gt_percent),
              (size_t) sizeof(format->gt_percent),1,fid) != 1)
       return WRITE_ERROR;

 if (status & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
    if (fwrite(&(format->roi_lt_percent),
              (size_t) sizeof(format->roi_lt_percent),1,fid) != 1)
       return WRITE_ERROR;
 if (status & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
    if (fwrite(&(format->roi_gt_percent),
              (size_t) sizeof(format->roi_gt_percent),1,fid) != 1)
       return WRITE_ERROR;

 if (!(status & OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW) &&
     (status & OUT_FORMAT_UNIT_2D_VALID))
    {
     if (fwrite(&(format->img_unit),
              (size_t) sizeof(format->img_unit),1,fid) != 1)
        return READ_ERROR;
    }

 TRACE(printf("wr_output_text_file_format...end\n"))
 return NO_ERROR;
}

wr_text_file_format(fid,text)
 FILE *fid;
 struct text_output_rec *text;
{
 int err;
 struct output_text_format_rec *format;

 if (text == NULL) 
    {if ((err = wr_input_text_file_format(fid,NULL,0)) != NO_ERROR)
        return err;
     return wr_output_text_file_format(fid,NULL);}
   else
    {if ((err = wr_input_text_file_format(fid,text->groups,
              text->num_groups)) != NO_ERROR)
        return err;
     return wr_output_text_file_format(fid,&(text->format));}

}

/*
old struct roi_count_anal_rec
   {char *label;
    long min,max;
    unsigned long num_pixels;
    double total_counts,sd;
   };
*/
wr_roi_count_anal_rec(fid,roi)
 FILE *fid;
 struct roi_count_anal_rec *roi;
{
 int err;

 if ((err = wr_file_strs(fid,&(roi->label),1)) != NO_ERROR)
    return err;
 if ((fwrite(&(roi->status2),(size_t) sizeof(roi->status2),1,fid) != 1) ||
     (fwrite(&(roi->min),(size_t) sizeof(roi->min),1,fid) != 1) ||
     (fwrite(&(roi->max),(size_t) sizeof(roi->max),1,fid) != 1) ||
     (fwrite(&(roi->num_pixels),(size_t) sizeof(roi->num_pixels),1,fid) != 1) ||
     (fwrite(&(roi->total_counts),(size_t) sizeof(roi->total_counts),1,fid) != 1) ||
     (fwrite(&(roi->sd),(size_t) sizeof(roi->sd),1,fid) != 1) ||
     (fwrite(&(roi->cnt_neg_val),(size_t) sizeof(roi->cnt_neg_val),1,fid) != 1) ||
     (fwrite(&(roi->cnt_smean_min_rej),
            (size_t) sizeof(roi->cnt_smean_min_rej),1,fid) != 1) ||
     (fwrite(&(roi->cnt_smean_max_rej),
            (size_t) sizeof(roi->cnt_smean_max_rej),1,fid) != 1) ||
     (fwrite(&(roi->cnt_rmean_min_rej),
            (size_t) sizeof(roi->cnt_rmean_min_rej),1,fid) != 1) ||
     (fwrite(&(roi->cnt_rmean_max_rej),
            (size_t) sizeof(roi->cnt_rmean_max_rej),1,fid) != 1) ||
     (fwrite(&(roi->slice_mean),(size_t) sizeof(roi->slice_mean),1,fid) != 1) ||
     (fwrite(&(roi->min_smean_threshold),
             (size_t) sizeof(roi->min_smean_threshold),1,fid) != 1) ||
     (fwrite(&(roi->max_smean_threshold),
             (size_t) sizeof(roi->max_smean_threshold),1,fid) != 1) ||
     (fwrite(&(roi->roi_mean),(size_t) sizeof(roi->roi_mean),1,fid) != 1) ||
     (fwrite(&(roi->min_rmean_threshold),
             (size_t) sizeof(roi->min_rmean_threshold),1,fid) != 1) ||
     (fwrite(&(roi->max_rmean_threshold),
             (size_t) sizeof(roi->max_rmean_threshold),1,fid) != 1))
    return WRITE_ERROR;
 return NO_ERROR;
}

wr_slice_count_anal_rec(fid,slice)
 FILE *fid;
 struct slice_count_anal_rec *slice;
{
 int err;
 unsigned long lcv;

 slice->status1 |= COUNT_NEW_FORMAT;
 if ((fwrite(&(slice->status1),(size_t) sizeof(slice->status1),1,fid) != 1) ||
     (fwrite(&(slice->num_rois),(size_t) sizeof(slice->num_rois),1,fid) != 1))
    return WRITE_ERROR;

 for (lcv = 0; lcv < slice->num_rois; lcv++)
    if ((err = wr_roi_count_anal_rec(fid,&(slice->rois[lcv]))) != NO_ERROR)
       return err;
 return NO_ERROR;
}

wr_slice_count_anal_recs(fid,slices,num_slices)
 FILE *fid;
 struct slice_count_anal_rec *slices;
 unsigned long num_slices;
{
 unsigned long lcv;
 int err;

 TRACE(printf("wr_slice_count_anal_recs...num_slices = %d\n",num_slices))
 if (slices == NULL) num_slices = 0;
 if (fwrite(&num_slices,(size_t) sizeof(num_slices),1,fid) != 1)
    return WRITE_ERROR;
 if (num_slices <= 0) return NO_ERROR;
 for (lcv = 0; lcv < num_slices; lcv++)
    if ((err = wr_slice_count_anal_rec(fid,&(slices[lcv]))) != NO_ERROR) 
       return err;
 TRACE(printf("wr_slice_count_anal_rec...end\n"))
 return NO_ERROR;
}

wr_count_analysis_rec(fid,count)
 FILE *fid;
 struct count_analysis_rec *count;
{
 int err;

 if (count == NULL) 
    {if ((err = wr_input_text_file_format(fid,NULL,0)) != NO_ERROR)
        return err;
     if ((err = wr_output_text_file_format(fid,NULL)) != NO_ERROR)
        return err;
     TRACE(printf("wr_count_analysis_rec...after wr_output_text_file_format\n"))
     return wr_slice_count_anal_recs(fid,NULL,0);
    }
   else
    {if ((err = wr_input_text_file_format(fid,count->groups,
              count->num_groups)) != NO_ERROR)
        return err;

     if ((err =  wr_output_text_file_format(fid,
            &(count->format))) != NO_ERROR)
        return err;
     if (count->format.status & OUT_FORMAT_COUNT_CUR_ECHO_ONLY)
        if (fwrite(&(count->echo_num),(size_t) sizeof(count->echo_num),1,fid) != 1)
           return WRITE_ERROR;

     return wr_slice_count_anal_recs(fid,count->slices,
            count->num_slices);
    }
}

wr_ria_slice_rois(fid,slices,num_slices)
 FILE *fid;
 struct slice_num_and_roi_rec *slices;
 long num_slices;
{
 unsigned long lcv;
 int err;

 if (num_slices == 0) return NO_ERROR;
 TRACE(printf("wr_ria_slice_rois\n"))
 for (lcv = 0; lcv < num_slices; lcv++)
    {
     if ((err = v3_wr_slice_roi_rec(fid,slices[lcv].slice_roi))
              != NO_ERROR)
       {TRACE(printf("wr_ria_slice_rois err = %d\n",err))
        return err;}
    }
 TRACE(printf("wr_ria_slice_rois...1\n"))
 return NO_ERROR;
}

setup_slice_nums(hdr,slices,num_slices,total_slices)
 struct output_hdr_rec *hdr;
 struct slice_num_and_roi_rec *slices;
 long num_slices,total_slices;
{
 unsigned long lcv;
 int err;

 if (hdr->num_slice_rois > 0)
    {c_free(hdr->slice_nums);
     hdr->slice_nums = NULL;}
 hdr->actual_total_slice_rois = total_slices;
 hdr->num_slice_rois = num_slices;
 if (hdr->num_slice_rois == 0) return NO_ERROR;

 if ((err = get_ptr(&(hdr->slice_nums),NULL,hdr->num_slice_rois,
           (size_t) sizeof(*(hdr->slice_nums)))) != NO_ERROR)
    {hdr->num_slice_rois = 0;
     return err;}

 for (lcv = 0; lcv < num_slices; lcv++)
    hdr->slice_nums[lcv] = slices[lcv].slice_num;
 TRACE(printf("setup_slice_nums...end\n"))
 return NO_ERROR;
}

wr_ria_dat_file(fn,hdr,slices,num_slices,total_slices,
                histo,pixel_type,text,count)
 char *fn;
 struct output_hdr_rec *hdr;
 struct slice_num_and_roi_rec *slices;
 long num_slices,total_slices;
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
 struct text_output_rec *text;
 struct count_analysis_rec *count;
{
 FILE *fid;
 unsigned long total_items,offset;
 int err;

 TRACE(printf("wr_ria_dat_file...\n");)
 if ((err = setup_slice_nums(hdr,slices,num_slices,total_slices)) !=
            NO_ERROR)
    return err;
 if ((fid = fopen(fn,"w")) == NULL) return FILE_ACCESS_ERROR;
 TRACE(printf("wr_ria_dat_file begin\n"))
 err = NO_ERROR;
 hdr->size = 0;
 if ((hdr->id == NULL) || (str_cmp(hdr->id,DAT_ID_V3) != 0))
    {c_free(hdr->id);
     cp_str(&(hdr->id),DAT_ID_V3);}
 if ((fwrite(&(hdr->size),(size_t) sizeof(hdr->size),1,fid) == 1) &&
     ((err = wr_file_strs(fid,&(hdr->id),1)) == NO_ERROR) &&
     ((err = wr_file_strs(fid,&(hdr->rater),1)) == NO_ERROR))
    {fflush(fid);
     offset = ftell(fid);}
   else
    {fclose(fid);
     return err;}
 if ((err = wr_output_field_offset_rec(fid,&(hdr->offset))) == NO_ERROR)
    {fflush(fid);
     hdr->offset.slice_roi_start = ftell(fid);

     TRACE(printf("slice_roi_start = %d\n",
         hdr->offset.slice_roi_start))

     if ((fwrite(&(hdr->actual_total_slice_rois),
                 sizeof(hdr->actual_total_slice_rois),1,fid)  == 1) &&
         (fwrite(&(hdr->num_slice_rois),
               (size_t) sizeof(hdr->num_slice_rois),1,fid) == 1) &&
         (wr_output_slice_nums(fid,hdr->slice_nums,hdr->num_slice_rois) ==
               NO_ERROR))
        {if ((err = wr_ria_slice_rois(fid,slices,num_slices)) == NO_ERROR)
            {fflush(fid);
             hdr->offset.histo_params_start = hdr->offset.slice_roi_size = 
                       ftell(fid);
             hdr->offset.slice_roi_size -= hdr->offset.slice_roi_start;

             if ((err = wr_histo_params(fid,histo)) != NO_ERROR)
                {fclose(fid);
                 TRACE(printf("2wr_ria_dat_file end err = %d\n",err))
                 return err;}

             TRACE(printf("after wr_histo_params...\n"))
             fflush(fid);
             hdr->offset.histo_params_size =
                           hdr->offset.pixel_type_params_start = ftell(fid);
             hdr->offset.histo_params_size -= 
                          hdr->offset.histo_params_start;
             TRACE(printf("histo_params_size = %d\n",
                        hdr->offset.histo_params_size))

             if ((err = wr_pixel_type_params(fid,pixel_type)) != NO_ERROR)
                {fclose(fid);
                 TRACE(printf("&&&wr_ria_dat_file end err = %d\n",err))
                 return err;}
             fflush(fid);

             hdr->offset.pixel_type_params_size =
                           hdr->offset.text_format_start = ftell(fid);
             hdr->offset.pixel_type_params_size -= 
                          hdr->offset.pixel_type_params_start;
             TRACE(printf("pixel_type_params_size = %d\n",
                        hdr->offset.pixel_type_params_size))

             if ((err = wr_text_file_format(fid,text))
                             != NO_ERROR)
                {fclose(fid);
                 TRACE(printf("&&&wr_ria_dat_file end err = %d\n",err))
                 return err;}
             TRACE(printf("wr_text_file_format...end\n"))
             fflush(fid);
             hdr->offset.text_format_size = hdr->offset.count_start = ftell(fid);
             hdr->offset.text_format_size -=
                            hdr->offset.text_format_start;

             TRACE(printf("wr_count_analysis_rec\n"))
             if ((err = wr_count_analysis_rec(fid,count)) != NO_ERROR)
                {c_free(slices);
                 fclose(fid);
                 return err;}
             TRACE(printf("wr_count_analysis_rec...end\n"))
             fflush(fid);
             hdr->offset.count_size = hdr->size = ftell(fid);
             hdr->offset.count_size -= hdr->offset.count_start;

             fseek(fid,0L,0);
             if (fwrite(&(hdr->size),(size_t) sizeof(hdr->size),1,fid) == 1)
                {fseek(fid,(size_t) offset,0);
                 err = wr_output_field_offset_rec(fid,&(hdr->offset)); 
                }
               else err = WRITE_ERROR;

            }
        }
    }

 fclose(fid);
 TRACE(printf("wr_ria_dat_file end err = %d\n",err))
 return err;

}

setup_slice_num_and_roi_rec(slice_rois,total_slices,slices,num_slices)
 struct slice_roi_rec *slice_rois;
 struct slice_num_and_roi_rec **slices;
 long total_slices,*num_slices;
{
 unsigned long lcv,cnt;
 int err;

 TRACE(printf("setup_slice_num_and_roi_rec...slice_rois = %u total_slices = %d\n",
             slice_rois,total_slices))
 *num_slices = 0;
 if (slice_rois == NULL) 
    {*slices = NULL;
     return NO_ERROR;}
 for (cnt = 0,lcv = 0; lcv < total_slices; lcv++)
    if (is_slice_roi_non_empty(&(slice_rois[lcv])))
       cnt += 1;
 TRACE(printf("setup_slice_num_and_roi_rec...cnt = %d\n",
             cnt))
 if (cnt == 0)
    *slices = NULL;
   else
    {if ((err = get_ptr(slices,num_slices,cnt,sizeof(**slices))) != NO_ERROR)
        return err;
     for (cnt = 0,lcv = 0; lcv < total_slices; lcv++)
        if (is_slice_roi_non_empty(&(slice_rois[lcv])))
           {(*slices)[cnt].slice_num = lcv;
            (*slices)[cnt++].slice_roi = &(slice_rois[lcv]);}
    }
 TRACE(printf("setup_slice_num_and_roi_rec...end\n"))
 return NO_ERROR;
}

WrRiaNdatFile(fn,hdr,slice_rois,total_slices,
                histo,pixel_type,groups,num_groups,format,count)
 char *fn;
 struct output_hdr_rec *hdr;
 struct slice_roi_rec *slice_rois;
 long total_slices;
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
 struct text_output_analysis_group_rec *groups;
 unsigned long num_groups;
 struct output_text_format_rec *format;
 struct count_analysis_rec *count;
{
 FILE *fid;
 unsigned long total_items,offset;
 struct slice_num_and_roi_rec *slices;
 long num_slices;
 int err;

 TRACE(printf("WrRiaNdatFile...\n");)
 if (((err = setup_slice_num_and_roi_rec(slice_rois,total_slices,
                 &slices,&num_slices)) != NO_ERROR) ||
     ((err = setup_slice_nums(hdr,slices,num_slices,total_slices)) != NO_ERROR))
    {c_free(slices);
     return err;}
 TRACE(printf("WrRiaNdatFile...1\n");)

 if ((fid = fopen(fn,"w")) == NULL)
    {c_free(slices);
     return FILE_ACCESS_ERROR;}

 if ((err = wr_output_hdr_rec(fid,hdr,&offset)) != NO_ERROR)
    {c_free(slices);
     fclose(fid);
     return err;}
 TRACE(printf("WrRiaNdatFile...2\n");)

 hdr->offset.slice_roi_start = ftell(fid);
 TRACE(printf("slice_roi_start = %d\n",
         hdr->offset.slice_roi_start))
 err = WRITE_ERROR;
 if ((fwrite(&(hdr->actual_total_slice_rois),
                 sizeof(hdr->actual_total_slice_rois),1,fid) == 1) &&
     (fwrite(&(hdr->num_slice_rois),
               (size_t) sizeof(hdr->num_slice_rois),1,fid) == 1) &&
     ((err = wr_output_slice_nums(fid,hdr->slice_nums,hdr->num_slice_rois)) ==
               NO_ERROR) &&
     ((err = wr_ria_slice_rois(fid,slices,num_slices)) == NO_ERROR))
    {
     fflush(fid);
     hdr->offset.histo_params_start = hdr->offset.slice_roi_size = 
                       ftell(fid);
     hdr->offset.slice_roi_size -= hdr->offset.slice_roi_start;

     if ((err = wr_histo_params(fid,histo)) != NO_ERROR)
        {c_free(slices);
         fclose(fid);
         return err;}

     TRACE(printf("after wr_histo_params...\n"))
     fflush(fid);
     hdr->offset.histo_params_size =
                           hdr->offset.pixel_type_params_start = ftell(fid);
     hdr->offset.histo_params_size -= 
                          hdr->offset.histo_params_start;
     TRACE(printf("histo_params_size = %d\n",
                        hdr->offset.histo_params_size))

     if ((err = wr_pixel_type_params(fid,pixel_type)) != NO_ERROR)
        {c_free(slices);
         fclose(fid);
         return err;}
     fflush(fid);

     hdr->offset.pixel_type_params_size =
                           hdr->offset.text_format_start = ftell(fid);
     hdr->offset.pixel_type_params_size -= 
                          hdr->offset.pixel_type_params_start;
     TRACE(printf("pixel_type_params_size = %d\n",
                        hdr->offset.pixel_type_params_size))

     if (((err = wr_input_text_file_format(fid,groups,num_groups)) != NO_ERROR) ||
         ((err = wr_output_text_file_format(fid,format)) != NO_ERROR))
        {c_free(slices);
         fclose(fid);
         return err;}
     fflush(fid);
     hdr->offset.text_format_size = hdr->offset.count_start = ftell(fid);
     hdr->offset.text_format_size -=
                            hdr->offset.text_format_start;
     if ((err = wr_count_analysis_rec(fid,count)) != NO_ERROR)
        {c_free(slices);
         fclose(fid);
         return err;}
     fflush(fid);
     hdr->offset.count_size = hdr->size = ftell(fid);
     hdr->offset.count_size -= hdr->offset.count_start;

     fseek(fid,0L,0);
     if (fwrite(&(hdr->size),(size_t) sizeof(hdr->size),1,fid) == 1)
        {fseek(fid,(size_t) offset,0);
         err = wr_output_field_offset_rec(fid,&(hdr->offset)); 
        }
       else err = WRITE_ERROR;
     }
 c_free(slices);
 fclose(fid);
 TRACE(printf("WrRiaNdatFile end err = %d\n",err))
 return err;

}

