/****************************************************************************
anal_menu.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  The functions in this file that are referenced in process_key.c
and related places as void have been changed from type int to type void
without actually checking that no one calls them as int.  This is likely
but not guaranteed, so watch out for possible problems.  -PWH 19990225 
****************************************************************************/

static const char rcsid[] = "$Id: anal_menu.c,v 1.13 1999/07/07 17:41:13 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <stdio.h>
#include <sys/types.h>

/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
/* #include <xview/cms.h> */
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/textsw.h>
#include <xview/notify.h>

#include "mri_format.h"
#include "debug.h"
#include "nria_procedures.h"



struct histogram_interface_rec
   {struct image_display_window *win;
    int value;
    unsigned int selected;
   };



/* Functions defined in this file */
void bkg_pixels_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
int win_histogram_it(struct histogram_interface_rec *histo_inter);
void win_histogram_action(struct histogram_interface_rec *histo_inter,
    struct user_menu_rec *user);
void histogram_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int arg_value);
void histogram_options_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
Menu setup_histogram_menu(void);
Menu setup_pixel_type_menu(void);
void histogram_menu_constraints(Menu histogram_roi_menu,
    struct display_win_rec *win);
void show_histogram_menu(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void segment_pixel_type_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
void win_get_file_pixel_type_map_proc(struct image_display_window *win,
    char *dir, char *fn);
void import_pixel_type_map_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void show_pixel_type_proc(Menu menu, Menu_item item);
Menu gen_show_pixel_type_roi_proc(Menu main_menu, Menu_generate operation);
Menu setup_analysis_menu(int select);
void analyze_cur_slice_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void analyze_all_slices_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
Menu gen_analysis_proc(Menu menu, Menu_generate operation);
void ca_options_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
void output_text_format_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
Menu setup_output_text_menu(void);
void text_output_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int output_option);
Menu gen_output_text_proc(Menu menu, Menu_generate operation);
void analysis_menu_help_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void redefine_pixel_type_order_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
void wr_bin_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int option);
void segment_cur_slice_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
Menu cur_roi_to_histo_roi_menu(void);
void cur_roi_to_histo_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
Menu gen_cur_roi_to_histo_roi_proc(Menu menu, Menu_generate operation);
void histo_roi_to_slice_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int arg_value);
void show_roi_tissue_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
void dp_grow_region_params_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
Menu pixel_types_to_histo_rois_menu(void);
void pixel_types_to_histo_rois_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);



/*------------------------------------------------------------------------
bkg_pixels_proc - ???
------------------------------------------------------------------------*/

void 
bkg_pixels_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("bkg_pixels_proc...MENU = %u\n",menu))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 TRACE(printf("bkg_pixels_proc...3\n"))

 win = win1->owner;
 win->dwin = win1;

 if (!(win->type2 & EDITING_WINDOW)) return;
 if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
    do_TA_proc(menu,item,arg,window,last_event);
 setup_enter_bkg(win);

}


/*------------------------------------------------------------------------
win_histogram_it - ???
------------------------------------------------------------------------*/

int
win_histogram_it(histo_inter)
struct histogram_interface_rec *histo_inter;
{
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(histo_inter->win->owner)) == NULL)
    return CANCEL;
 return win_histogram(histo_inter->win,histo_inter->value,
           histo_inter->selected);
}


/*------------------------------------------------------------------------
win_histogram_action - ???
------------------------------------------------------------------------*/

void
win_histogram_action(histo_inter,user)
 struct histogram_interface_rec *histo_inter;
 struct user_menu_rec *user;
{
 if ((user->strs_rec_ptr != NULL) && 
     (user->strs_rec_ptr->cur_str < user->strs_rec_ptr->num_strs))
    {
     if (user->strs_rec_ptr->cur_str == 3)
        histo_inter->selected = WHOLE_SLICE;
       else histo_inter->selected = user->strs_rec_ptr->cur_str + 1;
     ShowMsgStrs(histo_inter->win->dwin->frame,1,NO_ERROR,0,5,
               "Generating the histogram data...",
               "If sucessful, you may then draw your histogram ROIs...",
               "After fully defining the histogram ROIs, ",
               "   define the pixel types then...",
               PLEASE_WAIT,win_histogram_it,1,histo_inter);
    }
}


/*------------------------------------------------------------------------
histogram_roi_proc - ???
------------------------------------------------------------------------*/

void 
histogram_roi_proc(menu,item,arg,window,last_event,arg_value)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int arg_value;
{
 struct strs_rec *ptr;
 struct display_win_rec *win1;
 struct image_display_window *win;
 int err,value;
 static struct histogram_interface_rec histo_inter;
 char *str;
 Menu root;

 TRACE(printf("histogram_roi_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     value = arg_value;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        {win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
         window = win1->panel;}
     value = (int) xv_get(item,MENU_VALUE);}

 win = win1->owner;
 win->dwin = win1;
 TRACE(printf("histogram_roi_proc...value = %d   type2 = %x\n",value,
              (unsigned long) win->type2))

 if (win->type2 & HISTOGRAM_WINDOW)
    {if (value == VALUE_EDITED_PIXEL_TYPES)
        win_edited_pixel_type(win);
       else if (value == VALUE_PARTITIONED_PIXEL_TYPES)
        win_partitioned_pixel_type(win);
       else if (value == VALUE_HISTO_CLEAR)
        {ShowMsgStrs(win1->frame,1,NO_ERROR,0,2,
        "CLEARING THE HISTOGRAM...",PLEASE_WAIT,win_histogram_clear,1,win);
         return;}
     return;}
 TRACE(printf("histogram_roi_proc...VALUE_HISTO_SHOW = %d\n",VALUE_HISTO_SHOW))
 if (value == VALUE_HISTO_SHOW)
    {
     ShowMsgStrs(win1->frame,1,NO_ERROR,0,6,
               "Showing the histogram data...",
               "If successful, you may then draw your histogram ROIs",
               "   even if the histogram is empty...",
               "After fully defining the histogram ROIs, use the option",
               "   SEGMENT & GET PIXEL TYPES to define pixel types...",
               PLEASE_WAIT,win_histogram_show_it,1,win);
     return;}
   else if (value == VALUE_HISTO_CLEAR)
    {ShowMsgStrs(win1->frame,1,NO_ERROR,0,2,
        "CLEARING THE HISTOGRAM...",PLEASE_WAIT,win_histogram_clear,1,win);
     return;}
 if ((err = setup_strs_rec(&ptr,0,0)) != NO_ERROR) return;
 if ((err = build_strs_rec(ptr,(unsigned int) 0,4,
              "CURRENT REGION","CURRENT ROI","ALL ROIS","WHOLE SLICE"
              )) != NO_ERROR)
    {free_strs_rec(ptr);
     c_free(ptr);
     return;}

 histo_inter.value = value;
 histo_inter.win = win;
 if (value == VALUE_HISTO_CURRENT_SLICE_1D) str = "1D : CUR SLICE";
   else if (value == VALUE_HISTO_ALL_SLICE_1D) str = "2D : ALL SLICES";
   else if (value == VALUE_HISTO_CURRENT_SLICE) str = "2D : CUR SLICE";
   else if (value == VALUE_HISTO_ALL_SLICE) str = "2D : ALL SLICES";
   else str = "";

 ShowMenuStrsProc(window,last_event,str,
      ptr,USER_MENU_FREE_STRS_AND_PTR,win_histogram_action,&histo_inter,0,0,0);
}


/*------------------------------------------------------------------------
histogram_options_proc - ???
------------------------------------------------------------------------*/

void 
histogram_options_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("histogram_roi_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        {win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
         window = win1->panel;}
     }
 win = win1->owner;
 win->dwin = win1;
 enter_histogram(win,1);
}


/*------------------------------------------------------------------------
setup_histogram_menu - ???
------------------------------------------------------------------------*/

Menu 
setup_histogram_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0, MENU,
                       MENU_TITLE_ITEM,"HISTOGRAM",
                       MENU_NOTIFY_PROC,histogram_roi_proc,
                       MENU_STRING_ITEM,HISTO_CURRENT_SLICE_1D,
                         (int) VALUE_HISTO_CURRENT_SLICE_1D,
                       MENU_STRING_ITEM,HISTO_ALL_SLICES_1D,
                          (int) VALUE_HISTO_ALL_SLICE_1D,
                       MENU_STRING_ITEM,HISTO_CURRENT_SLICE,
                         (int) VALUE_HISTO_CURRENT_SLICE,
                       MENU_STRING_ITEM,HISTO_ALL_SLICES,
                          (int) VALUE_HISTO_ALL_SLICE,
                      MENU_STRING_ITEM,HISTO_SHOW,
                          (int) VALUE_HISTO_SHOW,
                       MENU_STRING_ITEM,HISTO_CLEAR,
                          (int) VALUE_HISTO_CLEAR,
                       0);
 return menu;
}


/*------------------------------------------------------------------------
setup_pixel_type_menu - ???
------------------------------------------------------------------------*/

Menu 
setup_pixel_type_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                       MENU_NOTIFY_PROC,segment_pixel_type_proc,
                       MENU_STRING_ITEM,EDITED_PIXEL_TYPES,
                          (int) VALUE_EDITED_PIXEL_TYPES,
                       MENU_STRING_ITEM,PARTITIONED_PIXEL_TYPES,
                          (int) VALUE_PARTITIONED_PIXEL_TYPES,
                       MENU_STRING_ITEM,HISTO_CLEAR,
                          (int) VALUE_HISTO_CLEAR,
                       0);
 return menu;
}



/*------------------------------------------------------------------------
histogram_menu_constraints - ???
------------------------------------------------------------------------*/

void
histogram_menu_constraints(histogram_roi_menu,win)
 Menu histogram_roi_menu;
 struct display_win_rec *win;
{
 struct img_buf_rec *img;
 Menu_item item;

 if (((img = win_rec_cur_img_buf(win->owner->owner)) != NULL) &&
      (img->file->hdr.status & _1_ECHO_IMAGE))
    {if ((item = menu_find(histogram_roi_menu,
                     MENU_VALUE,(int) VALUE_HISTO_CURRENT_SLICE,0)) != 0)
        xv_set(item,MENU_INACTIVE,TRUE,0);
     if ((item = menu_find(histogram_roi_menu,
                      MENU_VALUE,(int) VALUE_HISTO_ALL_SLICE,0)) != 0)
        xv_set(item,MENU_INACTIVE,TRUE,0);
    }
}


/*------------------------------------------------------------------------
show_histogram_menu - ???
------------------------------------------------------------------------*/

void 
show_histogram_menu(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu histogram_roi_menu;
 static struct show_menu_rec show_menu;
 Menu root;

 TRACE(printf("show_histogram_menu...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        {win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
         last_event = (Event *) xv_get(root,MENU_LAST_EVENT);
         window = win1->panel;}
    }
 win = win1->owner;
 win->dwin = win1;

 if ((histogram_roi_menu = setup_histogram_menu()) != 0)
    {/*xv_set(histogram_roi_menu,
                 MENU_NOTIFY_PROC,histogram_roi_proc,0);*/
     histogram_menu_constraints(histogram_roi_menu,win1);
     show_menu.win = win1;
     show_menu.window = window;
     show_menu.menu = histogram_roi_menu;
     show_menu.event = *last_event;
     (void) notify_set_itimer_func((Notify_client) &show_menu,
             (Notify_func) show_the_menu,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
    }

 TRACE(printf("show_histogram_menu...end\n"))
}


/*------------------------------------------------------------------------
segment_pixel_type_proc - ???
------------------------------------------------------------------------*/

void 
segment_pixel_type_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 struct img_buf_rec *img;
 struct slice_roi_win_rec *slice_roi_win;
 Menu root;

 PRT(printf("segment_pixel_type_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS) return;

 if ((img = win_rec_cur_img_buf(win->owner)) != NULL)
    {
     PRT(printf("segment_pixel_type_proc...1\n"))
     slice_roi_win = (struct slice_roi_win_rec *) 
              GetHistoSliceRoiWinRec(&(img->file->histo_params),
                   file_get_def_histo_type(img->file));
     PRT(printf("segment_pixel_type_proc...analysis_status = %x\n",
         (unsigned long) win->dwin->analysis_status))
     if (!is_slice_roi_non_empty(&(slice_roi_win->slice_roi)))
        ShowMsgStrs(win->dwin->frame,0,NO_ERROR,0,2,
               "No histogram rois have been defined...",
               "Cannot define pixel types yet !!!",NULL,0);
       else if (win->dwin->analysis_status & PIXEL_TYPE_GROW_REGION_ANALYSIS)
        ShowMsgStrs(win1->frame,1,NO_ERROR,0,3,
               "Segment by region growing & get",
               "pixel type maps for all the slices...",
               PLEASE_WAIT,win_segment_and_get_pixel_types,1,win);
       else ShowMsgStrs(win1->frame,1,NO_ERROR,0,3,
               "Thresholding by partitioning & get",
               "pixel type map for all the slices...",
               PLEASE_WAIT,win_segment_and_get_pixel_types,1,win);
    }
 return;
}


/************************
Menu gen_histogram_roi_proc(menu,operation)
 Menu menu;
 Menu_generate operation;
{
 struct display_win_rec *win1;
 Menu menu1,histogram_roi_menu,root;
 Event *last_event;
 Xv_Window window;

 switch (operation)
    {
     case MENU_DISPLAY : 
        menu1 = xv_get(menu,MENU_PARENT);
        root = (Menu) root_menu(menu);
        if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
           {window = (Xv_Window) event_window(last_event);
            win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
           }
          else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
        
        if (win->type2 & DISPLAY_WINDOW)
           histogram_roi_menu = setup_histogram_menu();
         else
          histogram_roi_menu = setup_pixel_type_menu(0);
        xv_set(histogram_roi_menu,
                 MENU_NOTIFY_PROC,histogram_roi_proc,0);

        if (win->type2 & DISPLAY_WINDOW)
           {xv_set(menu,MENU_STRING,HISTOGRAM_ROI,
               MENU_NOTIFY_PROC,show_histogram_menu,
               MENU_PULLRIGHT,histogram_roi_menu,0);
            histogram_menu_constraints(histogram_roi_menu,win1);
           }
          else
           {xv_set(menu,MENU_STRING,PARTITION_PIXEL_TYPES,
                 MENU_NOTIFY_PROC,segment_pixel_type_proc,
                 MENU_PULLRIGHT,histogram_roi_menu,0);
           }
    }
 return menu;

}
**********************/



/*------------------------------------------------------------------------
win_get_file_pixel_type_map_proc - ???

FIXME:  It's not clear whether this function should return void or
int.  I've made it void for the moment.  -PWH 19990322
------------------------------------------------------------------------*/

void
win_get_file_pixel_type_map_proc(win,dir,fn)
 struct image_display_window *win;
 char *dir,*fn;
{
 char *output_fn;
 int err;

 if ((err = build_fn(&output_fn,dir,fn,"")) != NO_ERROR) 
    {ShowMsgStrs(win->dwin->frame,0,err,0,1,
             "Error setting up the data fn !!!",NULL,0);
    return /* err */;}
 ShowMsgStrs(win->dwin->frame,1,NO_ERROR,0,5,
               "Importing the pixel type map from...",
               output_fn,
               "To verify, if successfull,show the histogram",
               "  pixel type !!!",PLEASE_WAIT,
               win_get_file_pixel_type_map,3,win,output_fn,1);
}


/*------------------------------------------------------------------------
import_pixel_type_map_proc - ???
------------------------------------------------------------------------*/

void 
import_pixel_type_map_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 char *dir,*str;
 Menu root;

 TRACE(printf("import_pixel_type_map_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }

 win = win1->owner;
 win->dwin = win1;
 if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
     return;
 dir = get_prog_dir(win->owner->root->prog);
 str = win_rec_win_id_title(win->owner,"IMPORT PIXEL TYPE MAP");
 ask_files(1,win->dwin->frame,str,
       NULL,1,0,win_get_file_pixel_type_map_proc,win,
       NULL,NULL,1,"*.ndat",0,0,5,285,NULL,NULL,1,
       dir,NULL,NULL,
       "FN","",NULL,NULL
      );
 c_free(dir);
 c_free(str);
}


/*------------------------------------------------------------------------
show_pixel_type_proc - ???
------------------------------------------------------------------------*/

void
show_pixel_type_proc(menu,item)
 Menu menu;
 Menu_item item;
{
 char *str;
 struct display_win_rec *win1;
 struct image_display_window *win;
 Xv_Window window;
 Event *last_event;
 Menu root;

 root = (Menu) root_menu(menu);
 if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
    {window = (Xv_Window) event_window(last_event);
     win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
    }
   else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);

 win = win1->owner;
 win->dwin = win1;

 if (!win_is_slice_roi_non_empty(win)) return;
 str = (char *) xv_get(item,MENU_STRING);
 WinNextCurRoi(win,str);

}


/*------------------------------------------------------------------------
gen_show_pixel_type_roi_proc - ???
------------------------------------------------------------------------*/

Menu 
gen_show_pixel_type_roi_proc(main_menu,operation)
 Menu main_menu;
 Menu_generate operation;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu menu,root;
 struct strs_rec roi_labels;
 int err;
 Xv_Window window;
 Event *last_event;

 TRACE(printf("gen_show_pixel_type_roi_proc...\n");)
 root = (Menu) root_menu(main_menu);
 if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
    {window = (Xv_Window) event_window(last_event);
     win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
    }
   else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
 win = win1->owner;
 win->dwin = win1;
 TRACE(printf("gen_show_pixel_type_roi_proc...1\n");)

 switch (operation)
    {
     case MENU_DISPLAY : 
     case MENU_NOTIFY :
        TRACE(printf("gen_show_pixel_type_roi_proc...2\n");)
        menu = (Menu) xv_get(main_menu,MENU_PULLRIGHT);
        if (menu != 0)
           {if (operation == MENU_NOTIFY) break;
            xv_destroy_safe(menu);
            menu = 0;}
        if ((err = win_get_all_pixel_type_ptrs(win,&roi_labels)) != NO_ERROR)
           free_strs_rec_ptrs(&roi_labels);
        if (roi_labels.num_strs > 0)
           {SetupTheMenu(&menu,NULL,
                 1,win1->frame,&roi_labels,show_pixel_type_proc,0);
           }
          else menu = (Menu) xv_create(0,MENU,0);

        if (menu != 0)
           {if (xv_get(menu,MENU_NITEMS) == 0)
               {
                xv_set(menu,MENU_ITEM,MENU_STRING,
                        NO_PIXEL_TYPE_STR,0,0);}
            xv_set(menu,
                   MENU_TITLE_ITEM,TISSUE_TYPES_DEFINED,0);
            xv_set(main_menu,MENU_PULLRIGHT,menu,0);}
        free_strs_rec_ptrs(&roi_labels);
        break;
     case MENU_DISPLAY_DONE :
          break;
/*
     case MENU_NOTIFY :
       TRACE(printf("gen_show_pixel_type_roi_proc...3\n"))
       menu = (Menu) xv_get(main_menu,MENU_PULLRIGHT);
       if (menu == NULL) menu = (Menu) xv_create(NULL,MENU,0);
       if ((menu != NULL) && ((Menu_item) xv_get(menu,MENU_NITEMS) == 0))
          {xv_set(menu,MENU_ITEM,MENU_STRING,NO_PIXEL_TYPE_STR,0,0);
           xv_set(main_menu,MENU_PULLRIGHT,menu,0);}
        printf("MENU_DISPLAY...end\n");fflush(stdout);
        break;
*/

     case MENU_NOTIFY_DONE :
        break;
    }
 TRACE(printf("gen_show_pixel_type_roi_proc...4\n"))
 return main_menu;

}


/*------------------------------------------------------------------------
setup_analysis_menu - ???
------------------------------------------------------------------------*/

Menu 
setup_analysis_menu(select)
 int select;
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                   MENU_STRING_ITEM,ANALYSIS_CUR_SLICE_STR,0,0);

 return menu;
}


/*------------------------------------------------------------------------
analyze_cur_slice_proc - ???

This procedure gets called when an 'a' key event
occurs (see process_key.c, clipboard_key_actions[]).
------------------------------------------------------------------------*/

void 
analyze_cur_slice_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("analyze_cur_slice_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 if (!(win->type2 & EDITING_WINDOW)) return;
 win_analysis(win,1,win1->analysis_status);
 return;
}



/*------------------------------------------------------------------------
analyze_all_slices_proc - ???

This procedure gets called when a 'SHIFT-a' key event
occurs (see process_key.c, shifted_key_actions[]).
------------------------------------------------------------------------*/

void 
analyze_all_slices_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("analyze_all_slices_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 if (!(win->type2 & EDITING_WINDOW)) return;

 set_win_busy(win);
 win_analysis(win,win_total_slice_cuts(win->owner),win1->analysis_status);
 set_win_not_busy(win);
}




/*------------------------------------------------------------------------
gen_analysis_proc - ???
------------------------------------------------------------------------*/

Menu 
gen_analysis_proc(menu,operation)
 Menu menu;
 Menu_generate operation;
{
 struct display_win_rec *win1;
 Menu menu1,root;
 struct img_buf_rec *img;
 Event *last_event;
 Xv_Window window;

 switch (operation)
    {
     case MENU_DISPLAY : 
        menu1 = xv_get(menu,MENU_PARENT);
        root = (Menu) root_menu(menu);
        if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
           {window = (Xv_Window) event_window(last_event);
            win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
           }
          else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
        menu1 = setup_analysis_menu(0);
        if (!(win1->owner->type2 & EDITING_WINDOW) ||
            ((img = win_rec_cur_img_buf(win1->owner->owner)) == NULL) ||
            (get_img_pixel_type_map(img) == NULL))
           make_menu_items_inactive(menu1);
          else make_menu_items_active(menu1);

        xv_set(menu1,
                 MENU_NOTIFY_PROC,analyze_cur_slice_proc,0);
        xv_set(menu,MENU_PULLRIGHT,menu1,0);
    }
 return menu;

}


/*------------------------------------------------------------------------
ca_options_proc - ???
------------------------------------------------------------------------*/

void 
ca_options_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("ca_options_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 if (!(win->type2 & EDITING_WINDOW)) return;
 if (!(win1->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)) return;
 enter_ca_options(win,1);
}


/*------------------------------------------------------------------------
output_text_format_proc - ???

Called when Shift-F12 pressed.
------------------------------------------------------------------------*/

void 
output_text_format_proc( menu, item, arg, window, last_event )
     Menu menu;
     Menu_item item;
     void *arg;
     Xv_Window window;
     Event *last_event;
{
  struct display_win_rec *win1;
  struct image_display_window *win;
  Menu root;

  TRACE(printf("output_text_format_proc...\n"));
  if (menu == 0)
  {
    win1 = (struct display_win_rec *) arg;
  }
  else
  {
    root = (Menu) root_menu(menu);
    if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
    {
      window = (Xv_Window) event_window(last_event);
      win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
    }
    else
      win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
  }

  win = win1->owner;
  win->dwin = win1;


  set_win_busy(win);

  if (win1->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
    enter_text_format_rec(win,4);
  else
    enter_text_format_rec(win,1);

  set_win_not_busy(win);
}



/*------------------------------------------------------------------------
setup_output_text_menu - ???
------------------------------------------------------------------------*/

Menu
setup_output_text_menu()
{
  static Menu menu = 0;

  if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu)
      xv_create( 0, MENU,

		 MENU_STRING_ITEM, SAVE_TEXT_TO_FILE,
		 (int) VALUE_SAVE_TEXT_TO_FILE,

		 MENU_STRING_ITEM, SAVE_THEN_PRINT_TEXT,
		 (int) VALUE_SAVE_THEN_PRINT_TEXT,

		 MENU_STRING_ITEM, PRINT_TEXT_TO_WINDOW,
		 (int) VALUE_PRINT_TEXT_TO_WINDOW,

		 MENU_STRING_ITEM, PRINT_ROIS_AND_PIXEL_TYPES,
		 (int) VALUE_PRINT_ROIS_AND_PIXEL_TYPES,

		 MENU_STRING_ITEM, SHOW_ROI_PIXEL_TYPE,
		 (int) VALUE_SHOW_ROI_PIXEL_TYPE,

		 MENU_STRING_ITEM, SHOW_ALL_ROIS_PIXEL_TYPE,
		 (int) VALUE_SHOW_ALL_ROIS_PIXEL_TYPE,

		 MENU_STRING_ITEM, SHOW_SLICE_PIXEL_TYPE,
		 (int) VALUE_SHOW_SLICE_PIXEL_TYPE,

		 MENU_STRING_ITEM, FILTER_SHOW_TISSUES,
		 (int) VALUE_FILTER_SHOW_TISSUES,

		 MENU_STRING_ITEM, SHOW_TISSUE_WINS,
		 (int) VALUE_SHOW_TISSUE_WINS,

		 NULL );

  return menu;
}




/*------------------------------------------------------------------------
text_output_proc - ???

This procedure gets called when a 't' key event, unmodified,
occurs (see process_key.c, clipboard_key_actions[]).
------------------------------------------------------------------------*/

void 
text_output_proc(menu,item,arg,window,last_event,output_option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int output_option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 int err,define;
 struct img_buf_rec *img;
 char *str;
 Menu root;

 TRACE(printf("text_output_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     output_option = (int) xv_get(item,MENU_VALUE);}

 win = win1->owner;
 win->dwin = win1;


#if 0
 printf( "output_option == " ); /*  DEBUGGING  DRW 960830  */
 switch (output_option) {
 case VALUE_SHOW_ROI_PIXEL_TYPE:
   printf( "Value_SHOW_ROI_PIXEL_TYPE\n\n" );
   break;
 case VALUE_SHOW_ALL_ROIS_PIXEL_TYPE:
   printf( "Value_SHOW_ALL_ROIS_PIXEL_TYPE\n\n" );
   break;
 case VALUE_SHOW_SLICE_PIXEL_TYPE:
   printf( "Value_SHOW_SLICE_PIXEL_TYPE\n\n" );
   break;
 case VALUE_FILTER_SHOW_TISSUES:
   printf( "Value_FILTER_SHOW_TISSUES\n\n" );
   break;
 case VALUE_SHOW_TISSUE_WINS:
   printf( "Value_SHOW_TISSUE_WINS\n\n" );
   break;
 case VALUE_PRINT_ROIS_AND_PIXEL_TYPES:
   printf( "Value_PRINT_ROIS_AND_PIXEL_TYPES\n\n" );
   break;
 case VALUE_SAVE_TEXT_TO_FILE:
   printf( "Value_SAVE_TEXT_TO_FILE\n\n" );
   break;
 case VALUE_SAVE_THEN_PRINT_TEXT:
   printf( "Value_SAVE_THEN_PRINT_TEXT\n\n" );
   break;
 case VALUE_PRINT_TEXT_TO_WINDOW:
   printf( "Value_PRINT_TEXT_TO_WINDOW\n\n" );
   break;
 }
#endif


 if ((output_option == VALUE_SHOW_ROI_PIXEL_TYPE) ||
     (output_option == VALUE_SHOW_ALL_ROIS_PIXEL_TYPE) ||
     (output_option == VALUE_SHOW_SLICE_PIXEL_TYPE))
    {TRACE(printf("WinShowPixelTypes\n"))
     set_win_busy(win);
/*
     if (!(win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS))
*/
     WinShowPixelTypes(win,(int) output_option);
     set_win_not_busy(win);
    }
   else if (output_option == VALUE_FILTER_SHOW_TISSUES)
       {if (!(win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)) {
	   enter_anal_display_options(win,1);
	   return; }
    }
   else if (output_option == VALUE_SHOW_TISSUE_WINS)
    {set_win_busy(win);
     err = win_show_tissue_wins(win);
     set_win_not_busy(win);
    }
   else if (output_option == VALUE_PRINT_ROIS_AND_PIXEL_TYPES)
    {if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS) 
        return;
     if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;
     if ((define = is_all_pixel_type_map_ready(img->file)) == 2)
        {if (output_option == VALUE_PRINT_ROIS_AND_PIXEL_TYPES) 
            ShowMsgStrs(win1->frame,1,NO_ERROR,0,3,
               "Displaying the pixel types for the ROI pixels",
               "Computing the pixel type maps...",
               PLEASE_WAIT,win_setup_bin,1,win);
         }
       else if (define == 1)
         ShowMsgStrs(win1->frame,0,NO_ERROR,0,2,
               "The pixel types are only defined for some slices...",
               OPERATION_ABORTED,NULL,0);

       else ShowMsgStrs(win1->frame,0,NO_ERROR,0,3,
               "The pixel types for all slices have not been defined...",
               "Please define the pixel type map first !!!",
               "Operation Cancelled !!!",NULL,0);
    }
   else
    {
     if (output_option == VALUE_SAVE_TEXT_TO_FILE)
        {if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
           str = "Saving the count text file.";
          else str = "Saving the pixel type text file.";
         ShowMsgStrs(win1->frame,1,NO_ERROR,0,2,
               str,
               PLEASE_WAIT,win_save_text_to_file,1,win);
        }
       else if (output_option == VALUE_SAVE_THEN_PRINT_TEXT)
        {if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
           str = "Saving  & printing the count text file.";
          else str = "Saving & printing the pixel type text file.";
         ShowMsgStrs(win1->frame,1,NO_ERROR,0,2,
               str,
               PLEASE_WAIT,win_save_text_to_file_and_printer,1,win);
        }
       else if (output_option == VALUE_PRINT_TEXT_TO_WINDOW)
        {if ((err = win_print_text_to_temp_file(win)) == NO_ERROR)
            show_temp_text_file(win);
        }
    }
}


/*------------------------------------------------------------------------
gen_output_text_proc - ???
------------------------------------------------------------------------*/

Menu 
gen_output_text_proc(menu,operation)
 Menu menu;
 Menu_generate operation;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu menu1,root;
 struct img_buf_rec *img;
 Menu_item item;
 char active;
 Event *last_event;
 Xv_Window window;

 switch (operation)
    {
     case MENU_DISPLAY : 
        menu1 = xv_get(menu,MENU_PARENT);
        root = (Menu) root_menu(menu);
        last_event = (Event *) xv_get(root,MENU_FIRST_EVENT);
        window = (Xv_Window) event_window(last_event);
        win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        win = win1->owner;
        win->dwin = win1;
        menu1 = setup_output_text_menu();
        active = 1;
        make_menu_items_active(menu1);
        if ((item = menu_find(menu1,MENU_VALUE,
                     (int) VALUE_SHOW_ROI_PIXEL_TYPE,0)) != 0)
           {if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
               xv_set(item,MENU_INACTIVE,TRUE,0);
              else if (win->dwin->display_status & VALUE_SHOW_ROI_PIXEL_TYPE)
               xv_set(item,MENU_STRING,DONT_SHOW_ROI_PIXEL_TYPE,0);
              else
               xv_set(item,MENU_STRING,SHOW_ROI_PIXEL_TYPE,0);
           }
        if ((item = menu_find(menu1,MENU_VALUE,
                    (int) VALUE_SHOW_ALL_ROIS_PIXEL_TYPE,0)) != 0)
           {if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
               xv_set(item,MENU_INACTIVE,TRUE,0);
              else if (win->dwin->display_status & 
                              VALUE_SHOW_ALL_ROIS_PIXEL_TYPE)
              xv_set(item,MENU_STRING,DONT_SHOW_ALL_ROIS_PIXEL_TYPE,0);
             else xv_set(item,MENU_STRING,SHOW_ALL_ROIS_PIXEL_TYPE,0);
           }
        if ((item = menu_find(menu1,MENU_VALUE,
                 (int) VALUE_SHOW_SLICE_PIXEL_TYPE,0)) != 0)
           {if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
               xv_set(item,MENU_INACTIVE,TRUE,0);
              else if (win->dwin->display_status &
                              VALUE_SHOW_SLICE_PIXEL_TYPE)
              xv_set(item,MENU_STRING,
                           DONT_SHOW_SLICE_PIXEL_TYPE,0);
             else xv_set(item,MENU_STRING,SHOW_SLICE_PIXEL_TYPE,0);
           }

        if (((img = win_rec_cur_img_buf(win1->owner->owner)) == NULL) ||
            (img->file->pixel_type.order.num_strs == 0))
           active = 0;
        if (!active)
           {if ((item = menu_find(menu1,
                MENU_VALUE,(int) VALUE_PRINT_ROIS_AND_PIXEL_TYPES,0)) != 0)
               xv_set(item,MENU_INACTIVE,TRUE,0);
            if ((item = menu_find(menu1,MENU_VALUE,
                   (int) VALUE_SHOW_ROI_PIXEL_TYPE,0)) != 0)
               xv_set(item,MENU_INACTIVE,TRUE,0);
            if ((item = menu_find(menu1,MENU_VALUE,
                    (int) VALUE_SHOW_ALL_ROIS_PIXEL_TYPE,0)) != 0)
               xv_set(item,MENU_INACTIVE,TRUE,0);
            if ((item = menu_find(menu1,MENU_VALUE,
                   (int) VALUE_SHOW_SLICE_PIXEL_TYPE,0)) != 0)
               xv_set(item,MENU_INACTIVE,TRUE,0);
           }
        xv_set(menu1,
                 MENU_NOTIFY_PROC,text_output_proc,0);
        xv_set(menu,MENU_PULLRIGHT,menu1,0);
    }
 return menu;
}


/*------------------------------------------------------------------------
analysis_menu_help_proc - ???
------------------------------------------------------------------------*/

void 
analysis_menu_help_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 char *fn;
 Menu root;

 TRACE(printf("analysis_menu_help_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 fn = (char *) get_prog_def_fn(win->owner->root->prog,ANALYSIS_MENU_HELP_FN);
 enter_display_text_file(win1->frame,1,NULL,fn);
 c_free(fn);

}


/*------------------------------------------------------------------------
redefine_pixel_type_order_proc - ???
------------------------------------------------------------------------*/

void 
redefine_pixel_type_order_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 struct img_buf_rec *img;
 Menu root;

 TRACE(printf("redefine_pixel_type_order_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;
 if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS) return;
 if ((img = win_rec_cur_img_buf(win->owner)) != NULL)
    {if (img->file->histo_params.pixel_type_order.num_strs == 0)
        {ShowMsgStrs(win->dwin->frame,0,0,0,3,
               "Please define the pixel types first",
               "  before redefining their order !!!",
               "Operation aborted !!!",NULL,0);
         return;}
     enter_pixel_type_order(win,1);}
}


/*------------------------------------------------------------------------
wr_bin_proc - ???
------------------------------------------------------------------------*/

void 
wr_bin_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("wr_bin_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }

 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;
 if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS) return;
 enter_wr_bin(win,1);
}


/*------------------------------------------------------------------------
segment_cur_slice_proc - ???
------------------------------------------------------------------------*/

void 
segment_cur_slice_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 struct img_buf_rec *img;
 Menu root;
 int val;

 TRACE(printf("segment_cur_slice_proc...MENU = %u\n",menu))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     val = 0;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     val = (int) xv_get(item,MENU_VALUE);
     printf("win_segment_cur_slice val = %d\n",val);
    }
 TRACE(printf("win_segment_cur_slice...1\n"))

 win = win1->owner;
 win->dwin = win1;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;
/*
 if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS) return NO_ERROR;
*/

 if (!(win->dwin->analysis_status & PIXEL_TYPE_GROW_REGION_ANALYSIS))
    do_GA_proc(menu,item,arg,window,last_event,0);

 ShowMsgStrs(win1->frame,1,NO_ERROR,0,3,
               "Segment by region growing & get",
               "pixel type map for the current slice...",
               PLEASE_WAIT,WinSegmentCurSlice,2,win,val);
/*
   else
    ShowMsgStrs(win1->frame,1,NO_ERROR,0,3,
               "Thresholding by partitioning & get",
               "pixel type map for the current slice...",
               PLEASE_WAIT,WinSegmentCurSlice,2,win,val);
*/
}


/*------------------------------------------------------------------------
cur_roi_to_histo_roi_menu - ???
------------------------------------------------------------------------*/

Menu 
cur_roi_to_histo_roi_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                       MENU_NOTIFY_PROC,cur_roi_to_histo_roi_proc,
                       MENU_STRING_ITEM,CUR_ROI_TO_HISTO_CONVEX_REGION,
                           HISTO_ROI_CONVEX_REGION,
                       MENU_STRING_ITEM,CUR_ROI_TO_HISTO_RANGE_REGION,
                           HISTO_ROI_RANGE_REGION,
                       MENU_STRING_ITEM,CUR_ROI_TO_HISTO_POINTS,
                           HISTO_ROI_POINTS,
                       0);
 return menu;
}


/*------------------------------------------------------------------------
cur_roi_to_histo_roi_proc - ???
------------------------------------------------------------------------*/

void 
cur_roi_to_histo_roi_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 struct img_buf_rec *img;
 Menu root;

 TRACE(printf("file_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     option = (int) xv_get(item,MENU_VALUE);}

 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;
 if (!(win->type2 & DISPLAY_WINDOW))
    {ShowMsgStrs(win1->frame,1,NO_ERROR,0,3,
               "Option unavailable from this window...",
               "Please use the option from the image window...",
               OK,
               NULL,0);
     return;}

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;
 if (img->file->hdr.data_info.num_echoes == 2)
    if (menu == 0)
       {if ((root = cur_roi_to_histo_roi_menu()) != 0)
           menu_show(root,window,last_event,0);
        return;}
 roi_to_histo_roi(win,NULL,option,HISTO_ROI,NULL);
 return;
}


/*------------------------------------------------------------------------
gen_cur_roi_to_histo_roi_proc - ???
------------------------------------------------------------------------*/

Menu 
gen_cur_roi_to_histo_roi_proc(menu,operation)
 Menu menu;
 Menu_generate operation;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu menu1,root;
 Event *last_event;
 Xv_Window window;

 switch (operation)
    {
     case MENU_DISPLAY : 
        menu1 = xv_get(menu,MENU_PARENT);
        root = (Menu) root_menu(menu);
        last_event = (Event *) xv_get(root,MENU_FIRST_EVENT);
        window = (Xv_Window) event_window(last_event);
        win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        win = win1->owner;
        win->dwin = win1;
        menu1 = cur_roi_to_histo_roi_menu();
        xv_set(menu,MENU_PULLRIGHT,menu1,0);
        if (win->type2 & HISTOGRAM_WINDOW)
           xv_set(menu,MENU_INACTIVE,TRUE,0);
    }
 return menu;

}


/*------------------------------------------------------------------------
histo_roi_to_slice_roi_proc - ???
------------------------------------------------------------------------*/

void 
histo_roi_to_slice_roi_proc(menu,item,arg,window,last_event,arg_value)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int arg_value;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("histo_roi_to_slice_roi_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }

 win = win1->owner;
 win->dwin = win1;

 win_cur_histo_roi_to_slice_roi(win);
 return;

}


/*------------------------------------------------------------------------
show_roi_tissue_proc - ???
------------------------------------------------------------------------*/

void 
show_roi_tissue_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;
 int is_done;

 TRACE(printf("show_roi_tissue_proc...MENU = %u\n",menu))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 TRACE(printf("show_roi_tissue_proc...3\n"))

 win = win1->owner;
 win->dwin = win1;
 if (win->type2 & DISPLAY_WINDOW_3D) return;
 if (win->status4 & DISPLAY_TISSUE_TYPE)
    {is_done = 0;
     if (win->status4 & DISPLAY_SLICE_TISSUE_TYPE)
        {if (option == WHOLE_SLICE) is_done = 1;}
       else if (win->status4 & DISPLAY_CUR_CURVE_TISSUE_TYPE)
        {if (option == CUR_CURVE) is_done = 1;}
       else if (win->status4 & DISPLAY_CUR_ROI_TISSUE_TYPE)
        {if (option == CUR_ROI) is_done = 1;}
       else if (win->status4 & DISPLAY_ALL_ROIS_TISSUE_TYPE)
        {if (option == ALL_ROIS) is_done = 1;}
     disable_display_tissue_type(win);
     if (is_done) {
	 WinNewColorMultiCanvas(win);
	 return; }
    }
 enable_display_tissue_type(win,option);
 set_win_busy(win);
 win_image_tissue_type_to_screen(win);
 set_win_not_busy(win);

}


/*------------------------------------------------------------------------
dp_grow_region_params_proc - ???
------------------------------------------------------------------------*/

void 
dp_grow_region_params_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("dp_grow_region_params_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;

 enter_grow_region_params_proc(win,1);
}


/*------------------------------------------------------------------------
pixel_types_to_histo_rois_menu - ???
------------------------------------------------------------------------*/

Menu 
pixel_types_to_histo_rois_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                          MENU_STRING_ITEM,CUR_SLICE_TYPES_TO_HISTO_ROIS,
                            VALUE_CUR_SLICE_TYPES_TO_HISTO_ROIS,
                          MENU_STRING_ITEM,ALL_SLICE_TYPES_TO_HISTO_ROIS,
                            VALUE_ALL_SLICE_TYPES_TO_HISTO_ROIS,
                          0);
 return menu;
}


/*------------------------------------------------------------------------
pixel_types_to_histo_rois_proc - ???
------------------------------------------------------------------------*/

void 
pixel_types_to_histo_rois_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 struct img_buf_rec *img;
 int define;
 Menu root;
 struct buf_2d_rec *map;

 TRACE(printf("file_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     option = (int) xv_get(item,MENU_VALUE);}

 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
    return;
 if (!(img->file->pixel_type.status & PIXMAP_METHOD_DEFINED)) return;

 set_win_busy(win);
 if (option == VALUE_CUR_SLICE_TYPES_TO_HISTO_ROIS)
    {if ((map = get_cur_slice_map(img->file,img->cur_slice)) == NULL)
        ShowMsgStrs(win1->frame,0,NO_ERROR,0,2,
               "Pixel types are undefined for the current slice",
               OPERATION_ABORTED,NULL,0);
       else cur_slice_types_to_histo_rois(win);
    }
   else
    {if ((define = is_all_pixel_type_map_ready(img)) == 0)
        ShowMsgStrs(win1->frame,0,NO_ERROR,0,2,
               "Pixel types are undefined for all slices !!!",
               OPERATION_ABORTED,NULL,0);
       else 
        {if (define == 1)
            ShowMsgStrs(win1->frame,0,NO_ERROR,0,2,
               "Pixel types are only defined for some slices !!!",
               WILL_CONTINUE,NULL,0);

         ShowMsgStrs(win->dwin->frame,1,NO_ERROR,0,2,
               "Mapping pixel types to histo rois for all slices...",
               PLEASE_WAIT,all_slice_types_to_histo_rois,1,win);}
   }
 set_win_not_busy(win);
}
