/****************************************************************************
clipboard.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: clipboard.c,v 1.8 1999/07/07 17:41:14 hughett Exp $ Release $Name: nria_1_0_6 $";

/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define PRT3(x) x; fflush(stdout);
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT3(x)


/* Functions defined in this file */
int win_setup_clipboard(struct image_display_window *win);
int win_paint_clipboard(struct image_display_window *win);
int win_hide_clipboard(struct image_display_window *win);
int win_show_clipboard(struct image_display_window *win);
int win_move_show_clipboard(struct image_display_window *win);
int win_clipboard(struct image_display_window *win, int is_append,
    int which_curve, int option);



/*-------------------------------------------------------------------------
win_setup_clipboard - ???
-------------------------------------------------------------------------*/

int
win_setup_clipboard(win)
 struct image_display_window *win;
{
 struct draw_mask_rec *clipboard_mask;
 unsigned long dimx,dimy;
 int err;

 if ((err = WinColorDataDims(win,&dimx,&dimy,NULL)) != NO_ERROR) return err;
 clipboard_mask = win_rec_get_clipboard_mask(win->owner);
 if (!(clipboard_mask->mask._2d.status4 & BUF_NON_EMPTY) ||
     (clipboard_mask->mask._2d.dimx != dimx) ||
     (clipboard_mask->mask._2d.dimy != dimy))
    err = get_draw_mask_rec(clipboard_mask,dimx,dimy);
 return err;
}


/*-------------------------------------------------------------------------
win_paint_clipboard - ???
-------------------------------------------------------------------------*/

int
win_paint_clipboard(win)
 struct image_display_window *win;
{
 struct draw_mask_rec *clipboard_mask;
 struct slice_roi_rec *clipboard;
 int err;

 TRACE(printf("win_paint_clipboard...in\n"))
 if ((err = win_setup_clipboard(win)) != NO_ERROR) return err;
 clipboard_mask = win_rec_get_clipboard_mask(win->owner);
 if (err == NO_ERROR)
    {clipboard = win_rec_get_clipboard(win->owner);
     err = DrawCurRoiRec(clipboard,NULL,
                clipboard_mask,clipboard_mask,0);}
 TRACE(printf("win_paint_clipboard...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
win_hide_clipboard - ???
-------------------------------------------------------------------------*/

int
win_hide_clipboard(win)
 struct image_display_window *win;
{
 struct draw_mask_rec *clipboard_mask;
 int err;

 if (win->control.display_options & DISPLAY_CLIPBOARD)
    {
     TRACE(printf("win_hide_clipboard...in\n"))
     clipboard_mask = win_rec_get_clipboard_mask(win->owner);
     if (!(clipboard_mask->mask._2d.status4 & BUF_NON_EMPTY)) return CANCEL;
     set_paint_status(clipboard_mask,1,PAINT_ERASE);
     if (win->control.display_options & DISPLAY_CLIPBOARD_FIRST)
        err = paint_cur_curve_to_multiple_win(win,win->data.draw_masks,
                 win->data.num_draw_masks,0);
       else
        err = paint_curves_to_multiple_win(win,win->data.draw_masks,
              win->data.num_draw_masks,0);
     set_paint_status(clipboard_mask,1,PAINT_SUPERIMPOSE);
     WinMultiCanvas(win);

     TRACE(printf("win_hide_breaker...err = %d\n",err))
    }

 return err;
}


/*-------------------------------------------------------------------------
win_show_clipboard - ???
-------------------------------------------------------------------------*/

int
win_show_clipboard(win)
 struct image_display_window *win;
{
 int err;

 TRACE(printf("win_show_clipboard...in\n"))
 if (win->control.display_options & DISPLAY_CLIPBOARD)
    {
     if ((err = win_paint_clipboard(win)) != NO_ERROR) return err;
     if (win->control.display_options & DISPLAY_CLIPBOARD_FIRST)
        err = paint_cur_curve_to_multiple_win(win,win->data.draw_masks,
                  win->data.num_draw_masks,0);
       else
        err = paint_curves_to_multiple_win(win,win->data.draw_masks,
                win->data.num_draw_masks,0);
     WinMultiCanvas(win);
     TRACE(printf("win_show_clipboard...err = %d\n",err))}
 return err;
}


/*-------------------------------------------------------------------------
win_move_show_clipboard - ???
-------------------------------------------------------------------------*/

int
win_move_show_clipboard(win)
 struct image_display_window *win;
{
 int err;

 TRACE(printf("win_move_show_clipboard...in\n"))
 if ((err = win_hide_clipboard(win)) != NO_ERROR) return err;
 err = win_show_clipboard(win);
 TRACE(printf("win_move_show_clipboard...err = %d\n",err))
 return err;

}


/*-------------------------------------------------------------------------
win_clipboard - ???
-------------------------------------------------------------------------*/

#define CLIPBOARD_CUR_CURVE 1
#define CLIPBOARD_CUR_ROI 2
#define CLIPBOARD_ALL_ROIS 3

int
win_clipboard(win,is_append,which_curve,option)
 struct image_display_window *win;
 int is_append,which_curve,option;
{
 struct slice_roi_rec *clipboard,*dest,*source;
 struct roi_rec *roi,*roi1;
 struct curve_rec *cur_curve;
 struct curve_2d_rec *pen;
 struct img_buf_rec *img;
 int err;
 char *label;
 float sx,sy;
 unsigned long dimx,dimy;

 TRACE(printf("win_clipboard...win = %u\n",win);)
 if ((err = WinColorDataDims(win,&dimx,&dimy,NULL)) != NO_ERROR) return err;
 clipboard = win_rec_get_clipboard(win->owner);
 TRACE(printf("win_clipboard...clipboard = %u\n",clipboard);)
 TRACE(printf("win_clipboard...slice_roi_rec = %u\n",
        &(win->control.sroi.sroi_win->slice_roi));)
 if ((option != VALUE_PASTE) && !is_append)
    {TRACE(printf("free_slice_roi_rec(clipboard)\n"))
     free_slice_roi_rec(clipboard);}
 sx = sy = 1.0;
 if (option == VALUE_PASTE)
    {TRACE(printf("VALUE_PASTE...\n");)
     if (win->control.display_options & DISPLAY_BREAKER)
        dest = win_rec_get_breaker(win->owner);
       else dest = &(win->control.sroi.sroi_win->slice_roi);
     source = clipboard;
     TRACE(printf("status = %x\n",(unsigned long) source->status);)
     if (source->status & SLICE_ROI_PIXEL_SIZE_VALID)
        {if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NO_ERROR;
         TRACE(printf("===sx = %f  sy = %f sx = %f  sy = %f\n",img->file->hdr.data_info.xpixel_size,
         img->file->hdr.data_info.ypixel_size,source->xpixel_size,source->ypixel_size);)

         sx = (float) source->xpixel_size / (float) img->file->hdr.data_info.xpixel_size;
         sy = (float) source->ypixel_size / (float) img->file->hdr.data_info.ypixel_size;}
    /*
    if ((source->num_rois == 1) && 
        ((roi = get_cur_roi(source)) != NULL) &&
        (str_cmp(roi->label,SCRATCH_STR) == 0) &&
        (num_cur_roi_curves(source) == 1))
       {PRT3(printf("set to CLIPBOARD_CUR_CURVE...\n"))
        which_curve = CLIPBOARD_CUR_CURVE;}
     */
    }
   else
    {
     if (win->control.display_options & DISPLAY_BREAKER)
        source = win_rec_get_breaker(win->owner);
       else source = &(win->control.sroi.sroi_win->slice_roi);
     dest = clipboard;
     setup_slice_roi_rec_dim(dest,dimx,dimy);
     if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NO_ERROR;
     clipboard->status |= SLICE_ROI_PIXEL_SIZE_VALID;
     clipboard->xpixel_size = img->file->hdr.data_info.xpixel_size;
     clipboard->ypixel_size = img->file->hdr.data_info.ypixel_size;
    }
 TRACE(printf("sx = %f  sy = %f\n",sx,sy);)

 if ((win->type2 & DISPLAY_WINDOW_3D) &&
     (option == VALUE_PASTE) && (which_curve == CLIPBOARD_CUR_ROI))
    which_curve = CLIPBOARD_CUR_CURVE;
 err = NO_ERROR;
 TRACE(printf("win_clipboard...1..which_curve = %d  sx = %f  sy = %f\n",
              which_curve,sx,sy);)
 TRACE(printf("which_curve = %d...\n",which_curve);)
 switch (which_curve)
    {case CLIPBOARD_CUR_CURVE :
        PRT3(printf("CLIPBOARD_CUR_CURVE...CLIPBOARD_CUR_CURVE\n");)
        if (((roi = get_cur_roi(source)) != NULL) &&
            ((pen = get_cur_pen(source)) != NULL))
           {if ((cur_curve = get_cur_curve(source)) == NULL)
               {if (!(win->type2 & DISPLAY_WINDOW_3D) ||
                    ((cur_curve = locate_curve_of_type(source,
                      CURVE_NEVER_CURRENT,0)) == NULL))
                   err = CANCEL;
               }
            if (err == NO_ERROR)
               {
                if ((label = (char *) get_cur_roi_label(dest)) == NULL)
                   {
                    label = SCRATCH_STR;
                   }
                if ((err = JoinCurveToSliceRoiRec(dest,label,
                       pen->pen_type,cur_curve,1,1,1,sx,sy,
                       NULL,NULL,NULL)) == NO_ERROR)
                   {
                    if (option == VALUE_CUT)
                       err = delete_cur_roi_curve(source);
                   }
               }
           }
          else err = CANCEL;
        break;
     case CLIPBOARD_CUR_ROI :
        PRT3(printf("CLIPBOARD_CUR_ROI dest = %u source = %u...\n",dest,source);)
        if ((roi = get_cur_roi(source)) != NULL)
           { 
            if ((source == clipboard) &&
                ((roi1 = get_cur_roi(dest)) != NULL))
               {
                if ((err = JoinRoiRecs(roi1,roi,1,&(dest->status),
                      sx,sy,NULL,NULL,NULL)) == NO_ERROR)
                   {TRACE(printf("CLIPBOARD_CUR_ROI 2...\n"))
                    next_cur_roi(dest,roi1->label);
                    if (option == VALUE_CUT)
                       err = delete_roi(source,roi);}
               }
              else
               {if ((err = JoinRoiToSliceRoiRec(dest,roi,1,sx,sy,
                       NULL,NULL,NULL)) == NO_ERROR)
                   if (option == VALUE_CUT)
                      {TRACE(printf("CLIPBOARD_CUR_ROI VALUE_CUT...\n"))
                        err = delete_roi(source,roi);}
                TRACE(printf("CLIPBOARD_CUR_ROI err = %d...\n",err))}
            /*TRACE(pr_slice_roi_rec(dest))*/
           }
          else err = CANCEL;
        break;
     case CLIPBOARD_ALL_ROIS :
        PRT3(printf("CLIPBOARD_ALL_ROIS...\n");)
        if ((err = JoinRois(dest,source,1,sx,sy,NULL,NULL,NULL)) == NO_ERROR)
           if (option == VALUE_CUT)
              {delete_all_rois(source);
              }
           
        break;
    }
 TRACE(printf("win_clipboard...before display err = %d\n",err))
 if (option == VALUE_COPY)
    win_execute_proc_to_related_wins(win,win_move_show_clipboard,0,0);
   else
    {
     if (win->control.display_options & DISPLAY_BREAKER)
        {if (option == VALUE_CUT)
            win_delete_breaker(win);
           else
            {win_must_show_breaker(win);
             win_execute_proc_to_related_wins(win,WinMultiCanvas,0,0);}
        }
       else
        {win_execute_proc_to_related_wins(win,win_hide_clipboard,0,0);
         win_execute_proc_to_related_wins(win,win_set_control_pen_type,1,0);
         win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);
        }
    }
 if (err == NO_ERROR)
    if (!(win->control.display_options & DISPLAY_BREAKER))
       set_roi_saved(&(win->control.sroi.sroi_win->slice_roi));
 return err;

}
