/****************************************************************************
display_text_format.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: display_text_format.c,v 1.12 1999/07/07 17:41:15 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/notify.h>
#include <xview/wmgr.h>
#include <xview/cms.h>

#include "mri_format.h"
#include "text_format.h"

#include "nria_procedures.h"


#if 0
#  define TRACE(x) x; fflush(stdout);
#  define PRT(x) x; fflush(stdout);
#  define PRT1(x) x; fflush(stdout);
#else
#  define TRACE(x)
#  define PRT(x)
#  define PRT1(x)
#endif



#define SETUP_COUNT_FORMAT 1

#define CLEAN_UP_TEXT_FORMAT 0
#define SETUP_TEXT_FORMAT 1
#define GET_ALL_FORMAT_PTR 2


struct text_format_rec
{
  unsigned short status;
  struct image_display_window *win;
  struct display_win_rec *dwin;
  struct input_file_rec *file;
  Frame frame;
  Panel panel;
  Panel_item numgroups_item,next_group,delete_group,change_group_index,
    roi,type,done,insert_roi,insert_type,
    roi_order,type_order,pixel_type_label_item,roi_label_item;
  unsigned int total_groups,numgroups,cur_group,total_roi_labels,
    total_pixel_type_labels;
  /*    int roi_indx,type_indx;*/
  int cur_roi_indx,cur_type_indx;
  struct text_output_analysis_group_rec *groups;
};


struct all_text_format_recs
{
  int num_formats;
  struct text_format_rec **formats;
};


/* Functions defined in this file */
void init_text_format_rec(struct text_format_rec *format);
void free_text_format_rec(struct text_format_rec *format);
void init_all_text_format_recs(struct all_text_format_recs *all_formats);
static void SetupRoiProc(struct text_format_rec *format, int win_type2,
    int is_inc_all);
void format_setup_roi_proc(Panel_item item, Event *event);
static void setup_order_proc(struct text_format_rec *format, int select);
int is_format_empty(struct text_format_rec *format);
int sort_unsigned_long(unsigned long *num1, unsigned long *num2);
int update_labels(Panel_item item, char ***labels, unsigned long *num_labels);
int update_cur_group(struct text_format_rec *format);
int drop_empty_format(struct text_format_rec *format);
int new_group(struct text_format_rec *format);
int new_group_proc(Panel_item item, Event *event);
void display_format_group_nums(struct text_format_rec *format);
int next_group_proc(Panel_item item, int value, Event *event);
int change_group(struct text_format_rec *format, int new_group_num);
int change_format_group_proc(Panel_item item, int value, Event *event);
int delete_format_group_proc(struct text_format_rec *format);
void format_swap_proc(Panel_item item, char *str, int row, Panel_list_op op,
    Event *event);
void format_insert_proc(Panel_item item, Event *event);
void format_insert_all_proc(Panel_item item, Event *event);
void format_insert_label_proc(Panel_item item, char *text1, Event *event);
void format_sort_proc(Panel_item item, Event *event);
void format_delete_proc(Panel_item item, Event *event);
void format_delete_all_proc(Panel_item item, Event *event);
int delete_group_proc(Panel_item item, Event *event);
int save_pixel_type_format_proc(struct text_format_rec *format,
    struct text_output_rec *text);
int save_count_format_proc(struct text_format_rec *format,
    struct count_analysis_rec *count);
int save_the_pixel_type_format(struct text_format_rec *format, char *the_fn);
int save_the_count_format(struct text_format_rec *format, char *the_fn);
int save_the_text_format(struct text_format_rec *format, char *dir, char *fn);
void format_save_proc(Panel_item item, Event *event);
void format_activate_proc(Panel_item item, Event *event);
int rd_pixel_type_format(struct text_format_rec *format, char *fn, int option);
int rd_count_text_format(struct text_format_rec *format, char *fn, int option);
int rd_text_format_option(struct text_format_rec *format, char *fn,
    int option);
int rd_the_text_format(struct text_format_rec *format, char *dir, char *fn);
void format_read_proc(Panel_item item, Event *event);
int rd_and_append_format(struct text_format_rec *format, char *dir, char *fn);
void format_read_and_append_proc(Panel_item item, Event *event);
void format_help_proc(Panel_item item, Event *event);
void text_format_rec_done_proc(Frame frame);
int setup_format_groups(struct text_format_rec *format);
int setup_text_format_rec(struct text_format_rec *format,
    struct image_display_window *win, int is_count_format);
struct text_format_rec *find_text_format_rec(
   struct all_text_format_recs *all_formats, struct image_display_window *win);
struct text_format_rec *find_same_format_file(
   struct all_text_format_recs *all_formats, struct image_display_window *win);
int enter_text_format_rec(struct image_display_window *win, int status);



/*--------------------------------------------------------------------------
init_text_format_rec - ???
--------------------------------------------------------------------------*/

void
init_text_format_rec(format)
     struct text_format_rec *format;
{
  format->status = 0;
  format->win = NULL;
  format->frame = 0;
  format->cur_group = format->total_groups = format->numgroups = 0;
  format->groups = NULL;
  format->total_roi_labels = 0;
  format->total_pixel_type_labels = 0;

#if 0
  format->roi_indx = -1;
  format->type_indx = -1;
#endif

  format->cur_roi_indx = -1;
  format->cur_type_indx = -1;
}



/*--------------------------------------------------------------------------
free_text_format_rec - ???
--------------------------------------------------------------------------*/

void
free_text_format_rec(format)
     struct text_format_rec *format;
{
  struct all_text_format_recs *all_formats;
  
  TRACE(printf("free_text_format_rec...\n"));
  if (format->total_groups > 0)
  {
    free_analysis_group_recs(format->groups,format->numgroups);
    c_free(format->groups);
  }
  if (format->frame != 0)
  {
    destroy_all_subframes(format->frame);
    xv_destroy_safe(format->frame);
  }
  
  c_free(format);
  all_formats = (struct all_text_format_recs *) 
    enter_text_format_rec(NULL,GET_ALL_FORMAT_PTR);
  DropHandleAryPtr(&(all_formats->formats),&(all_formats->num_formats),format);
}



/*--------------------------------------------------------------------------
init_all_text_format_recs - ???
--------------------------------------------------------------------------*/

void
init_all_text_format_recs(all_formats)
     struct all_text_format_recs *all_formats;
{
  all_formats->num_formats = 0;
  all_formats->formats = NULL;
}



/*--------------------------------------------------------------------------
SetupRoiProc - ???
--------------------------------------------------------------------------*/

static void
SetupRoiProc(format,win_type2,is_inc_all)
     struct text_format_rec *format;
     unsigned short win_type2;
     int is_inc_all;
{
  struct strs_rec *main,*sub,labels,labels1;
  int num_rows,err;
  Panel_item item;
  struct img_buf_rec *img;

  if ((img = win_rec_cur_img_buf(format->win->owner)) == NULL)
      return /*CANCEL*/;

  init_strs_rec(&labels);

  if (is_inc_all)
  {
    main = win_rec_get_roi_labels_PTR(format->win->owner,win_type2);
    if (main != NULL)
      if ((err = add_str_ptr_ary_to_sorted_strs_rec(&labels,
						    main->strs,
						    main->num_strs,0))
	  != NO_ERROR)
      {
	free_strs_rec_ptrs(&labels);
	return /*err*/;
      }

    sub = win_rec_get_sec_roi_labels_PTR(format->win->owner,win_type2);
    if (sub != NULL)
      if ((err = add_str_ptr_ary_to_sorted_strs_rec(&labels,
						    sub->strs,
						    sub->num_strs,0))
	  != NO_ERROR)
      {
	free_strs_rec_ptrs(&labels);
	return /*err*/;
      }
  }

  init_strs_rec(&labels1);
  if (win_type2 & HISTOGRAM_WINDOW) 
    err = win_get_all_pixel_type_ptrs(format->win,&labels1);
  else
    err = FileGetAllRoiLabelPtrs(img->file,&labels1,0,1);
  if ((err != NO_ERROR) ||
      ((err = add_str_ptr_ary_to_sorted_strs_rec(&labels,
						 labels1.strs,
						 labels1.num_strs,0))
       != NO_ERROR))
  {
    free_strs_rec_ptrs(&labels);
    free_strs_rec_ptrs(&labels1);
    return /*err*/;
  }
  free_strs_rec_ptrs(&labels1);

  if (win_type2 == DISPLAY_WINDOW)
    item = format->roi;
  else
    item = format->type;
  delete_all_list_items(item);
  setup_list_items(&labels,item,0);
  TRACE(printf("num_strs = %d\n",labels.num_strs););
  free_strs_rec_ptrs(&labels);
  
  num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
  TRACE(printf("num_rows = %d\n",num_rows));

#if 0
  if (num_rows > 0)
  {
    xv_set(item,PANEL_LIST_SELECT,0,1,0);
    if (win_type2 == DISPLAY_WINDOW)
      format->roi_indx = 0;
    else
      format->type_indx = 0;
  }
  else if (win_type2 == DISPLAY_WINDOW)
    format->roi_indx = -1;
  else
    format->type_indx = -1;
#endif
}



/*--------------------------------------------------------------------------
format_setup_roi_proc - ???
--------------------------------------------------------------------------*/

void
format_setup_roi_proc(item,event)
     Panel_item item;
     Event *event;
{
  struct text_format_rec *format;
  Panel_item item1;
  int is_inc_all;

  item1 = (Panel_item) xv_get(item,PANEL_CLIENT_DATA);
  is_inc_all = (int) xv_get(item,XV_KEY_DATA,1);
  format = (struct text_format_rec *) xv_get(item1,PANEL_CLIENT_DATA);
  if (item1 == format->roi_label_item)
    SetupRoiProc(format,DISPLAY_WINDOW,is_inc_all);
  else
    SetupRoiProc(format,HISTOGRAM_WINDOW,is_inc_all);
}



/*--------------------------------------------------------------------------
setup_order_proc - ???
--------------------------------------------------------------------------*/

static void
setup_order_proc(format,select)
 struct text_format_rec *format;
 int select;
{
 struct text_output_analysis_group_rec *group;
 struct strs_rec labels;
 int err;

 PRT(printf(" setup_order_proc...sel = %d cur_group = %d  numgroups = %d\n",select,
          format->cur_group,format->numgroups))
 if (format->cur_group >= format->numgroups) return /*NO_ERROR*/;
 group = &(format->groups[format->cur_group]);
 PRT(printf(" group->num_rois = %d\n",group->num_rois))
 init_strs_rec(&labels);
 if (select == 1)
    {if (group->num_rois > 0)
        {TRACE(printf(" setup_order_proc num_rois = %d\n",group->num_rois))

         if ((err = add_str_ptr_ary_to_strs_rec(&labels,
             group->roi_labels,group->num_rois)) != NO_ERROR)
            {free_strs_rec_ptrs(&labels);
	    return /*err*/;}

         PRT(printf(" setup_order_proc...1..delete_all_list_items\n"))
         delete_all_list_items(format->roi_order);
         TRACE(printf(" setup_order_proc...format->roi_order = %u\n",
                   format->roi_order))
         TRACE(pr_strs_rec(&labels))
         format->cur_roi_indx = -1;
         setup_list_items(&labels,format->roi_order,0);
         TRACE(printf(" setup_order_proc...3\n"))
        }
    }
   else if (format->type_order != 0)
    {if (group->num_pixel_types > 0)
        {if ((err = add_str_ptr_ary_to_strs_rec(&labels,
             group->pixel_type_labels,group->num_pixel_types)) != NO_ERROR)
            {free_strs_rec_ptrs(&labels);
	    return /*err*/;}
         format->cur_type_indx = -1;
         delete_all_list_items(format->type_order);
         setup_list_items(&labels,format->type_order,0);
        }
    }
 free_strs_rec_ptrs(&labels);
}


/*--------------------------------------------------------------------------
is_format_empty - ???
--------------------------------------------------------------------------*/

int
is_format_empty(format)
 struct text_format_rec *format;
{
 if (is_list_item_empty(format->roi) &&
     is_list_item_empty(format->type))
    return 1;
   else return 0;
}


/*--------------------------------------------------------------------------
sort_unsigned_long - ???
--------------------------------------------------------------------------*/

int
sort_unsigned_long(num1,num2)
 unsigned long *num1,*num2;
{
 if (*num1 > *num2) return 1;
 if (*num1 < *num2) return -1;
 return 0;
}


/*********************
process_list(list,labels,num_labels,change)
 Panel_item list;
 char ***labels;
 unsigned int *num_labels;
 int *change;
{
 int num_rows,num_olds,num_news,lcv,err,num_strs,cnt;
 char **new,*str,**str_ptrs;
 unsigned long *old,indx;
 unsigned int total;

 *change = 0;
 num_rows = (int) xv_get(list,PANEL_LIST_NROWS);
 new = NULL;
 old = NULL;
 TRACE(printf("num_row = %d *num_labels = %d\n",num_rows,*num_labels))
 if (num_rows > 0)
    {total = 0;
     get_ptr_memory(&new,&total,num_rows,
         (size_t) sizeof(char *),&err);
     if (err != NO_ERROR) return err;}

 if (*num_labels > 0)
    {total = 0;
     get_ptr_memory(&old,&total,*num_labels,
         (size_t) sizeof(unsigned long),&err);
     if (err != NO_ERROR)
        {c_free(new);
         return err;}
    }
 for (num_news = num_olds = cnt = 0; cnt < num_rows; cnt++)
    if ((int) xv_get(list,PANEL_LIST_SELECTED,cnt))
       {str = (char *) xv_get(list,PANEL_LIST_STRING,cnt);
        if (*num_labels > 0)
           {indx = FindStrInHandleAryByContent(*labels,*num_labels,
                 str,&err);
            if (err == NOT_FOUND)
               {new[num_news++] = str;
               }
              else old[num_olds++] = indx;
           }
          else new[num_news++] = str;
       }
 if ((num_news > 0) || (num_olds != *num_labels))
    {TRACE(printf("change...num_news = %d num_olds = %d\n",num_news,num_olds))
     *change = 1;
     total = 0;
     cnt = num_news + num_olds;
     get_ptr_memory(&str_ptrs,&total,cnt,(size_t) sizeof(char *),&err);
     if (err != NO_ERROR)
        {
         c_free(old);
         c_free(new);
         return err;}
     qsort(old,num_olds,(size_t) sizeof(unsigned long),sort_unsigned_long);
     for (num_strs = 0,cnt = 0; cnt < num_news; cnt++)
        {if ((err = cp_str(&str,new[cnt])) != NO_ERROR)
            {for (lcv = 0; lcv < num_strs; lcv++)
                c_free(str_ptrs[lcv]);
             c_free(str_ptrs);
             c_free(old);
             c_free(new);
             return err;}
         str_ptrs[num_strs++] = str;}

     for (lcv = 0,cnt = 0; cnt < *num_labels; cnt++)
        if (lcv < num_olds)
           {if (old[lcv] != cnt)
               {
                c_free((*labels)[cnt]);
               }
              else
               {str_ptrs[num_strs++] = (*labels)[cnt];
                lcv++;}
           }
          else
           {;
            c_free((*labels)[cnt]);
           }
     c_free(*labels);
     for (cnt = 0; cnt < num_strs; cnt++)
        {TRACE(printf("%d) str = %s\n",cnt,str_ptrs[cnt]))
        }
     *labels = str_ptrs;
     *num_labels = num_strs;
    }
 c_free(old);
 c_free(new);
 return NO_ERROR;
}
*******************/


/*--------------------------------------------------------------------------
update_labels - ???
--------------------------------------------------------------------------*/

int
update_labels(item,labels,num_labels)
 Panel_item item;
 char ***labels;
 unsigned long *num_labels;
{
 struct strs_rec roi;
 char **the_labels;
 unsigned long total,lcv;
 int err,result;

 init_strs_rec(&roi);
 if ((err = list_items(&roi,item)) != NO_ERROR) return err;

 TRACE(printf("update_labels 0 num_strs = %d\n",roi.num_strs))
 if (((err = cmp_str_arys(roi.strs,roi.num_strs,*labels,*num_labels,
          &result)) == NO_ERROR) && (result != 0))
    {TRACE(printf("update_labels 0 result = %d\n",result))
     total = 0;
     if (roi.num_strs > 0)
        {get_ptr_memory(&the_labels,&total,roi.num_strs,
              (size_t) sizeof(char *),&err);
         if (err != NO_ERROR)
            {free_strs_rec(&roi);
             return err;}
         for (lcv = 0; lcv < total; lcv++)
            {the_labels[lcv] = roi.strs[lcv];
             TRACE(printf("%d) %s\n",lcv,the_labels[lcv]))
             roi.strs[lcv] = NULL;}
         free_strs_rec_ptrs(&roi);
        }

     if (*num_labels > 0) deallocate_2d_ary(*labels,*num_labels);
     if (total > 0)
        {*num_labels = total;
         *labels = the_labels;}
       else
        {*num_labels = 0;
         *labels = NULL;}
    }
   else free_strs_rec(&roi);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
update_cur_group - ???
--------------------------------------------------------------------------*/

int
update_cur_group(format)
 struct text_format_rec *format;
{
 int err;

 TRACE(printf("update_cur_group format->cur_group...= %d\n",format->cur_group))
 if (format->cur_group >= format->numgroups) return NO_ERROR;
 if ((err = update_labels(format->roi_order,
         &(format->groups[format->cur_group].roi_labels),
            &(format->groups[format->cur_group].num_rois))) != NO_ERROR)
     ShowMsgStrs(format->frame,0,err,0,1,
             "Error updating the roi labels !!!",NULL,0);
   else if ((format->type_order != 0) &&
            ((err = update_labels(format->type_order,
               &(format->groups[format->cur_group].pixel_type_labels),
            &(format->groups[format->cur_group].num_pixel_types))) != NO_ERROR))
    ShowMsgStrs(format->frame,0,err,0,1,
             "Error updating the pixel types labels !!!",NULL,0);

 return err;
}


/*--------------------------------------------------------------------------
drop_empty_format - ???
--------------------------------------------------------------------------*/

int
drop_empty_format(format)
 struct text_format_rec *format;
{
 long lcv,cnt;

 for (cnt = lcv = 0; lcv < format->numgroups; lcv++)
    {TRACE(printf("drop_empty_format lcv = %d cnt = %d num_rois = %d num_pixel_types = %d\n",lcv,cnt,
         format->groups[lcv].num_rois,format->groups[lcv].num_pixel_types))

     if ((format->groups[lcv].num_rois == 0) ||
         (!(format->status & SETUP_COUNT_FORMAT) &&
           (format->groups[lcv].num_pixel_types == 0)))
        {free_text_output_analysis_group_rec(&(format->groups[lcv]));
         continue;}
     if (cnt != lcv)
        format->groups[cnt] = format->groups[lcv];
     cnt++;}
 if (lcv == cnt) return 0;

 for (lcv = cnt; lcv < format->numgroups; lcv++)
    init_text_output_analysis_group_rec(&(format->groups[lcv]));

 format->numgroups = cnt;
 if (format->cur_group >= format->numgroups) 
    if (format->numgroups == 0) format->cur_group = 0;
      else format->cur_group = format->numgroups - 1;
 TRACE(printf("drop_empty_format...format->cur_group = %d\n",format->cur_group))
 return 1;
}


/*--------------------------------------------------------------------------
new_group - ???
--------------------------------------------------------------------------*/

int
new_group(format)
 struct text_format_rec *format;
{
 int err,new_group_num;

 if (format->numgroups >= format->total_groups)
    {if ((err = get_ptr(&(format->groups),&(format->total_groups),1,
        (size_t) sizeof(*(format->groups)))) != NO_ERROR)
        return err;}

 format->cur_group = format->numgroups;
 new_group_num = format->cur_group;
 init_text_output_analysis_group_rec(&(format->groups[format->cur_group]));
 format->numgroups += 1;
 change_group(format,new_group_num);
 display_format_group_nums(format);
 setup_order_proc(format,1);
 setup_order_proc(format,2);

 return err;
}


/*--------------------------------------------------------------------------
new_group_proc - ???
--------------------------------------------------------------------------*/

int
new_group_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;

 format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((format->status & SETUP_COUNT_FORMAT) && (format->numgroups >= 1))
    {ShowMsgStrs(format->frame,0,0,0,1,
             "Currently, only 1 group is possible !!!",NULL,0);
     return NO_ERROR;}
 update_cur_group(format);
 return new_group(format);
}


/*--------------------------------------------------------------------------
display_format_group_nums - ???
--------------------------------------------------------------------------*/

void
display_format_group_nums(format)
 struct text_format_rec *format;
{
 char str1[100];

 sprintf(str1,"TOTAL GROUPS = %d",format->numgroups);
 xv_set(format->numgroups_item,PANEL_LABEL_STRING,str1,0);
 if (format->numgroups == 0)
    {
     xv_set(format->next_group,PANEL_VALUE,0,PANEL_MIN_VALUE,0,
                 PANEL_MAX_VALUE,0,0);
     xv_set(format->change_group_index,PANEL_VALUE,0,PANEL_MIN_VALUE,0,
                 PANEL_MAX_VALUE,0,0);}
   else
    {
     xv_set(format->next_group,PANEL_VALUE,
                  format->cur_group + 1,PANEL_MIN_VALUE,0,
                  PANEL_MAX_VALUE,(int) format->numgroups,0);
     xv_set(format->change_group_index,PANEL_VALUE,
                  format->cur_group + 1,PANEL_MIN_VALUE,0,
                  PANEL_MAX_VALUE,(int) format->numgroups,0);
    }
}


/*--------------------------------------------------------------------------
next_group_proc - ???
--------------------------------------------------------------------------*/

int
next_group_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct text_format_rec *format;
 int err;

 format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value > 0)
    {
     update_cur_group(format);
     format->cur_group = value - 1;
     setup_order_proc(format,1);
     setup_order_proc(format,2);
    }
 display_format_group_nums(format);
 return err;
}


/*--------------------------------------------------------------------------
change_group - ???
--------------------------------------------------------------------------*/

int
change_group(format,new_group_num)
 struct text_format_rec *format;
 int new_group_num;
{
 struct text_output_analysis_group_rec group;
 long lcv;

 if ((new_group_num >= 0) && (new_group_num != format->cur_group))
    {group = format->groups[format->cur_group];
     if (format->cur_group > new_group_num)
        {for (lcv = format->cur_group; lcv > new_group_num; lcv--)
            format->groups[lcv] = format->groups[lcv - 1];
         format->groups[lcv] = group;}
       else
        {for (lcv = format->cur_group; lcv < new_group_num; lcv++)
            format->groups[lcv] = format->groups[lcv + 1];
         format->groups[lcv] = group;}
     format->cur_group = new_group_num;
     xv_set(format->next_group,PANEL_VALUE,format->cur_group + 1,0);
    }
   else xv_set(format->change_group_index,PANEL_VALUE,format->cur_group + 1,0);

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
change_format_group_proc - ???
--------------------------------------------------------------------------*/

int
change_format_group_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct text_format_rec *format;

 format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
 return change_group(format,value - 1);
}

/*--------------------------------------------------------------------------
delete_format_group_proc - ???
--------------------------------------------------------------------------*/

int
delete_format_group_proc(format)
 struct text_format_rec *format;
{
 int err;
 unsigned int lcv;

 TRACE(printf("delete_format_group_proc cur = %d num = %d total = %d\n",
    format->cur_group,format->numgroups,format->total_groups))
 if ((format->cur_group < format->numgroups) && (format->numgroups > 0))
    {
     free_text_output_analysis_group_rec(&(format->groups[format->cur_group]));
     format->numgroups -= 1;
     for (lcv = format->cur_group; lcv < format->numgroups; lcv++)
        format->groups[lcv] = format->groups[lcv+1];
     if (format->cur_group >= format->numgroups) 
        if (format->numgroups == 0) format->cur_group = 0;
          else format->cur_group = format->numgroups - 1;
     init_text_output_analysis_group_rec(&(format->groups[format->numgroups]));
    }
 TRACE(printf("delete_format_group_proc cur = %d total = %d\n",
    format->cur_group,format->total_groups))
 return err;

}


/*--------------------------------------------------------------------------
format_swap_proc - ???
--------------------------------------------------------------------------*/

void
format_swap_proc(item,str,row,op,event)
 Panel_item item;
 char *str;
 int row;
 Panel_list_op op;
 Event *event;
{
 struct text_format_rec *format;

 format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
/*
 if (item == format->type)
    {if (op) format->type_indx = row;
     return NO_ERROR;
    }
 if (item == format->roi)
    {if (op) format->roi_indx = row;
     return NO_ERROR;
    }
*/
 if (item == format->roi_order)
    list_swap(format->roi_order,op,&(format->cur_roi_indx),row,str);
   else if (format->type_order != 0)
    list_swap(format->type_order,op,&(format->cur_type_indx),row,str);
}



/*--------------------------------------------------------------------------
format_insert_proc - ???
--------------------------------------------------------------------------*/

void
format_insert_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;
 Panel_item which_item;
 int num_rows;
 unsigned long lcv;

 which_item = (Panel_item) xv_get(item,PANEL_CLIENT_DATA);
 format = (struct text_format_rec *) xv_get(which_item,PANEL_CLIENT_DATA);
 if (which_item == format->roi_order)
    {
/*
     TRACE(printf("format_insert_proc roi_indx = %d\n",format->roi_indx))
     if (format->roi_indx >= 0)
*/
     num_rows = (int) xv_get(format->roi,PANEL_LIST_NROWS);
     for (lcv = 0; lcv < num_rows; lcv++)
        if (xv_get(format->roi,PANEL_LIST_SELECTED,lcv))
           list_insert(format->roi,lcv,
                format->roi_order,&(format->cur_roi_indx));

/*
        }
*/
    }
   else if (format->type_order != 0)
    {TRACE(printf("format_insert_proc type_indx = %d\n",format->type_indx))
/*
     if (format->type_indx >= 0)
*/
     num_rows = (int) xv_get(format->type,PANEL_LIST_NROWS);
     for (lcv = 0; lcv < num_rows; lcv++)
        if (xv_get(format->type,PANEL_LIST_SELECTED,lcv))
           list_insert(format->type,lcv,
              format->type_order,&(format->cur_type_indx));
/*
        }
*/
    }
}


/*--------------------------------------------------------------------------
format_insert_all_proc - ???
--------------------------------------------------------------------------*/

void
format_insert_all_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;
 Panel_item which_item;
 int num_rows;
 unsigned long lcv;

 which_item = (Panel_item) xv_get(item,PANEL_CLIENT_DATA);
 format = (struct text_format_rec *) xv_get(which_item,PANEL_CLIENT_DATA);
 if (which_item == format->roi_order)
    {TRACE(printf("format_insert_proc roi_indx = %d\n",format->roi_indx))
/*
     if (format->roi_indx >= 0)
        {
*/
         num_rows = (int) xv_get(format->roi,PANEL_LIST_NROWS);
         for (lcv = 0; lcv < num_rows; lcv++)
            list_insert(format->roi,lcv,
                format->roi_order,&(format->cur_roi_indx));
/*
        }
*/
    }
   else if (format->type_order != 0)
    {TRACE(printf("format_insert_proc type_indx = %d\n",format->type_indx))
/*
     if (format->type_indx >= 0)
        {
*/
         num_rows = (int) xv_get(format->type,PANEL_LIST_NROWS);
         for (lcv = 0; lcv < num_rows; lcv++)
            list_insert(format->type,lcv,
               format->type_order,&(format->cur_type_indx));
/*
        }
*/
    }
}


/*--------------------------------------------------------------------------
format_insert_label_proc - ???
--------------------------------------------------------------------------*/

void
format_insert_label_proc(item,text1,event)
 Panel_item item;
 char *text1;
 Event *event;
{
 struct text_format_rec *format;
 char *text;
 unsigned long indx;
 int row,next;

 format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
 text = (char *) xv_get(item,PANEL_VALUE);
 PRT1(printf("text = %u text = %s\n",text,text))
 if (get_strlen(text) == 0) return /*NO_ERROR*/;
 if (item == format->insert_roi)
    {
     if (find_list_item_by_str(format->roi_order,text,&indx) == NO_ERROR)
	 return /*NO_ERROR*/;
     PRT1(printf("cur_roi_indx = %d\n",format->cur_roi_indx))
     row = (int) xv_get(format->roi_order,PANEL_LIST_NROWS);
     if ((format->cur_roi_indx < 0) || ((format->cur_roi_indx + 1) == row))
        next = row;
       else next = format->cur_roi_indx;
       
     xv_set(format->roi_order,PANEL_LIST_INSERT,next,
                          PANEL_LIST_STRING,next,text,0);
     row = (int) xv_get(format->roi_order,PANEL_LIST_NROWS);;
     if ((format->cur_roi_indx >= 0) && ((format->cur_roi_indx + 1) < row))
        format->cur_roi_indx += 1;
     PRT1(printf("row = %d next = %d cur_roi_indx = %d\n",
              row,next,format->cur_roi_indx))
     }
   else if (format->type_order != 0)
    {
     if (find_list_item_by_str(format->type_order,text,&indx) == NO_ERROR)
        return /*NO_ERROR*/;
     PRT1(printf("cur_type_indx = %d\n",format->cur_type_indx))
     row = (int) xv_get(format->type_order,PANEL_LIST_NROWS);;
     if ((format->cur_type_indx < 0) || ((format->cur_type_indx + 1) == row))
        next = row;
       else next = format->cur_type_indx;

     xv_set(format->type_order,PANEL_LIST_INSERT,next,
                          PANEL_LIST_STRING,next,text,0);
     row = (int) xv_get(format->type_order,PANEL_LIST_NROWS);;
     if ((format->cur_type_indx >= 0) && ((format->cur_type_indx + 1) < row))
        format->cur_type_indx += 1;
     PRT1(printf("row = %d next = %d cur_type_indx = %d\n",
              row,next,format->cur_type_indx))
    }
}


/*--------------------------------------------------------------------------
format_sort_proc - ???
--------------------------------------------------------------------------*/

void
format_sort_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;
 Panel_item which_item;
 struct strs_rec list,sel;

 which_item = (Panel_item) xv_get(item,PANEL_CLIENT_DATA);
 format = (struct text_format_rec *) xv_get(which_item,PANEL_CLIENT_DATA);
 init_strs_rec(&list);
 list_items(&list,which_item);
 if (list.num_strs > 0) 
    {init_strs_rec(&sel);
     selected_list_items(&sel,which_item);
     delete_all_list_items(which_item);
     sort_strs_rec_ascendingly(&list);
     setup_list_items(&list,which_item,0);
     if (sel.num_strs > 0)
        select_list_items(&sel,which_item);
     free_strs_rec(&sel);
    }
 free_strs_rec(&list);
}


/*--------------------------------------------------------------------------
format_delete_proc - ???
--------------------------------------------------------------------------*/

void
format_delete_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;
 Panel_item which_item;
 int row;

 which_item = (Panel_item) xv_get(item,PANEL_CLIENT_DATA);
 format = (struct text_format_rec *) xv_get(which_item,PANEL_CLIENT_DATA);
 if (which_item == format->roi_order)
    {
     PRT1(printf("format_delete_proc cur_roi_indx = %d\n",format->cur_roi_indx))
     list_delete(format->roi_order,&(format->cur_roi_indx));
     PRT1(printf("after cur_roi_indx = %d\n",format->cur_roi_indx))
     row = (int) xv_get(format->roi_order,PANEL_LIST_NROWS);
     if (format->cur_roi_indx < row)
        {if (format->cur_roi_indx >= 0)
            xv_set(format->roi_order,PANEL_LIST_SELECT,format->cur_roi_indx,1,0);
        }
       else format->cur_roi_indx = -1;
    }
   else if (format->type_order != 0)
    {
     PRT1(printf("format_delete_proc cur_type_indx = %d\n",format->cur_type_indx))
     list_delete(format->type_order,&(format->cur_type_indx));
     PRT1(printf("after cur_type_indx = %d\n",format->cur_type_indx))
     if (format->cur_type_indx < row)
        {if (format->cur_type_indx >= 0)
            xv_set(format->type_order,PANEL_LIST_SELECT,format->cur_type_indx,1,0);
        }
       else format->cur_type_indx = -1;
    }
}


/*--------------------------------------------------------------------------
format_delete_all_proc - ???
--------------------------------------------------------------------------*/

void
format_delete_all_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;
 Panel_item which_item;

 which_item = (Panel_item) xv_get(item,PANEL_CLIENT_DATA);
 format = (struct text_format_rec *) xv_get(which_item,PANEL_CLIENT_DATA);
 if (which_item == format->roi_order)
    format->cur_roi_indx = -1;
   else format->cur_type_indx = -1;
 delete_all_list_items(which_item);
}


/*--------------------------------------------------------------------------
delete_group_proc - ???
--------------------------------------------------------------------------*/

int
delete_group_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;

 format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (format->numgroups == 0) return CANCEL;
 delete_format_group_proc(format);
 display_format_group_nums(format);
 setup_order_proc(format,1);
 setup_order_proc(format,2);
 return NO_ERROR;
}



/*--------------------------------------------------------------------------
save_pixel_type_format_proc - ???
--------------------------------------------------------------------------*/

int
save_pixel_type_format_proc(format,text)
     struct text_format_rec *format;
     struct text_output_rec *text;
{
  int err;

  TRACE(printf("save_pixel_type_format_proc..begin....status = %x\n",
	       (int)  text->format.status));
  if ((err = update_cur_group(format)) != NO_ERROR)
    return err;

  TRACE(printf("update_cur_group...\n"));
  if (drop_empty_format(format))
  {
    if (format->numgroups == 0)
    {
      ShowMsgStrs(format->frame,0,err,0,3,
		  "No text format defined !!!",
		  "All groups are empty !!!",
		  OPERATION_ABORTED,NULL,0);
      new_group(format);
      return CANCEL;
    }
    display_format_group_nums(format);
    setup_order_proc(format,1);
    setup_order_proc(format,2);
  }

  TRACE(printf("drop_empty_format...format->numgroups = %d\n",format->numgroups));
  if (format->numgroups > 0)
  {
    TRACE(printf("text->groups...\n"));
    TRACE(pr_text_output_analysis_group_recs(text->groups,text->num_groups));
    TRACE(printf("format->groups...\n"));
    TRACE(pr_text_output_analysis_group_recs(format->groups,format->numgroups));

    if ((err = cp_text_output_analysis_group_recs(&(text->groups),
						  &(text->num_groups),
						  format->groups,
						  format->numgroups,1))
	!= NO_ERROR)
    {
      ShowMsgStrs(format->frame,0,err,0,1,
		  "Error saving the text format !!!",NULL,0);
      return err;
    }
    else if ((err = setup_output_format(text)) != NO_ERROR)
    {
      ShowMsgStrs(format->frame,0,err,0,1,
		  "Error setting up the output text format !!!",NULL,0);
      return err;
    }
    TRACE(printf("text->groups...\n"));
    TRACE(pr_text_output_analysis_group_recs(text->groups,text->num_groups));
  }
  TRACE(printf("text->num_groups = %d  format->numgroups = %d\n",
	       text->num_groups,format->numgroups));
  return NO_ERROR;
}



/*--------------------------------------------------------------------------
save_count_format_proc - ???
--------------------------------------------------------------------------*/

int
save_count_format_proc(format,count)
 struct text_format_rec *format;
 struct count_analysis_rec *count;
{
 int err;
 struct img_buf_rec *img;
 struct unit_2d_rec *unit;

 PRT1(printf("save_count_format_proc..begin....status = %x\n",
       (int)  count->format.status))
 if ((err = update_cur_group(format)) != NO_ERROR) return err;

 PRT1(printf("update_cur_group...\n"))
 if (drop_empty_format(format))
    {
     display_format_group_nums(format);
     setup_order_proc(format,1);
     setup_order_proc(format,2);
    }

 PRT1(printf("drop_empty_format...format->numgroups = %d\n",format->numgroups))
 PRT1(printf("count->groups...\n"))
 PRT1(pr_text_output_analysis_group_recs(count->groups,count->num_groups))

 PRT1(printf("format->groups...\n"))
 PRT1(pr_text_output_analysis_group_recs(format->groups,format->numgroups))
 if (format->numgroups == 0)
    {if (count->num_groups > 0)
        {free_analysis_group_recs(count->groups,count->num_groups);
         c_free(count->groups);
         count->groups = NULL;
         count->num_groups = 0;}
     count->status |= TEXT_OUTPUT_PIXEL_COUNT_ALL_ANALYSIS;
    }
   else
    {
     count->status &= ~TEXT_OUTPUT_PIXEL_COUNT_ALL_ANALYSIS;
     if ((err = cp_text_output_analysis_group_recs(&(count->groups),
          &(count->num_groups),format->groups,format->numgroups,1)) != NO_ERROR)
        {
         ShowMsgStrs(format->frame,0,err,0,1,
             "Error saving the count format !!!",NULL,0);
         return err;}
    }
 if ((img = win_rec_cur_img_buf(format->win->owner)) == NULL)
    err = CANCEL;
   else
    {if (img->unit.status2 & UNIT_2D_IN_USE)
        unit = &(img->unit);
       else unit = NULL;
     err = setup_count_output_format(count,unit);
    }
     
 if (err != NO_ERROR)
    {
     ShowMsgStrs(format->frame,0,err,0,1,
                  "Error setting up the output count format !!!",NULL,0);
     return err;
    }
 PRT1(printf("count->groups...\n"))
 PRT1(pr_text_output_analysis_group_recs(count->groups,count->num_groups))

 PRT1(printf("save_count_format_proc count->num_groups = %d  format->numgroups = %d\n",
           count->num_groups,format->numgroups))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
save_the_pixel_type_format - ???
--------------------------------------------------------------------------*/

int
save_the_pixel_type_format(format,the_fn)
 struct text_format_rec *format;
 char *the_fn;
{
 struct img_buf_rec *img;
 struct text_output_rec text;
 char str[255],*str1;
 int err;

 PRT1(printf("save_the_pixel_type_format...\n"))
 if ((img = win_rec_cur_img_buf(format->win->owner)) == NULL)
    return CANCEL;
 init_text_output_rec(&text,img->file);
 if ((err = copy_text_format_only(&text,&(format->file->text),1)) != NO_ERROR)
    {sprintf(str,"Memory error saving the text format...err = %d !!!",err);
     ShowMsgStrs(format->frame,0,err,0,1,str,NULL,0);
    }
   else
    {
     PRT1(printf("save_the_pixel_type_format ...the_fn = %s\n",the_fn))
     if ((err = save_pixel_type_format_proc(format,&text)) == NO_ERROR)
        {PRT1(printf("WrTextFormat...\n"))
         if ((err = WrTextFormat(the_fn,&(text.format),
                  text.groups,text.num_groups)) != NO_ERROR)
            {concat_strs(&str1,2,"Error writing to !!!",the_fn);
             ShowMsgStrs(format->frame,0,err,0,1,str1,NULL,0);
             c_free(str1);}
        }
    }
 PRT1(printf("save_the_pixel_type_format...err = %d\n",err))
 free_text_output_rec(&text);
 return err;
}


/*--------------------------------------------------------------------------
save_the_count_format - ???
--------------------------------------------------------------------------*/

int
save_the_count_format(format,the_fn)
 struct text_format_rec *format;
 char *the_fn;
{
 struct img_buf_rec *img;
 struct count_analysis_rec count;
 char str[255],*str1;
 int err;

 PRT1(printf("save_the_count_format...\n"))
 if ((img = win_rec_cur_img_buf(format->win->owner)) == NULL)
    return CANCEL;
 init_count_analysis_rec(&count,img->file);
 if ((err = copy_count_format_only(&count,&(format->file->count),1)) != NO_ERROR)
    {sprintf(str,"Memory error saving the count format...err = %d !!!",err);
     ShowMsgStrs(format->frame,0,err,0,1,str,NULL,0);
    }
   else
    {
     PRT1(printf("save_the_count_format ...the_fn = %s\n",the_fn))
     if ((err = save_count_format_proc(format,&count)) == NO_ERROR)
        {PRT1(printf("WrTextFormat...\n"))
         if ((err = WrTextFormat(the_fn,&(count.format),
                  count.groups,count.num_groups)) != NO_ERROR)
            {concat_strs(&str1,2,"Error writing to !!!",the_fn);
             ShowMsgStrs(format->frame,0,err,0,1,str1,NULL,0);
             c_free(str1);}
        }
    }
 PRT1(printf("save_the_count_format...err = %d\n",err))
 free_count_analysis_rec(&count);
 return err;
}


/*--------------------------------------------------------------------------
save_the_text_format - ???
--------------------------------------------------------------------------*/

int
save_the_text_format(format,dir,fn)
 struct text_format_rec *format;
 char *dir,*fn;
{
 int err;
 char *reason;
 char *the_fn;

 TRACE(printf("save_the_text_format...\n"))
 if ((err = build_fn(&the_fn,dir,fn,"")) != NO_ERROR) 
    {ShowMsgStrs(format->frame,0,err,0,1,
             "Error setting up the output text format fn  !!!",NULL,0);
     return err;}
 if ((err = file_access(the_fn,2,NULL,&reason)) != NO_ERROR)
    {ShowMsgStrs(format->frame,0,err,0,1,reason,NULL,0);
     c_free(the_fn);
     c_free(reason);
     return err;
    }

 if (get_strlen(the_fn) == 0)
    {c_free(the_fn);
     return CANCEL;}
 TRACE(printf("save_the_text_format...the_fn = %s\n",the_fn))
 if (format->status & SETUP_COUNT_FORMAT)
    err = save_the_count_format(format,the_fn);
   else err = save_the_pixel_type_format(format,the_fn);

 c_free(the_fn);
 TRACE(printf("save_the_text_format...end\n"))
 return err;
}


/*--------------------------------------------------------------------------
format_save_proc - ???
--------------------------------------------------------------------------*/

void
format_save_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;
 char *dir,*str;

 format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dir = get_prog_dir(format->win->owner->root->prog);
 if (format->status & SETUP_COUNT_FORMAT)
    str = win_rec_win_id_title(format->win->owner,"SAVE *.fmt COUNT FORMAT");
   else str = win_rec_win_id_title(format->win->owner,"SAVE *.fmt PIXEL TYPE FORMAT");
 ask_files(1,format->frame,str,
       NULL,1,0,save_the_text_format,format,
       NULL,NULL,0,"*.fmt",0,0,5,285,NULL,NULL,1,
       dir,NULL,NULL,
       "FN",DEFAULT_TXT_FORMAT_FN,NULL,NULL
      );
 c_free(dir);
 c_free(str);
}



/*--------------------------------------------------------------------------
format_activate_proc - ???

When "Apply Now" button is pressed inside Pixel Type Text Format
dialog.
--------------------------------------------------------------------------*/

void
format_activate_proc(item,event)
     Panel_item item;
     Event *event;
{
  struct text_format_rec *format;

  format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
  if (format->status & SETUP_COUNT_FORMAT)
  {
    if (save_count_format_proc(format,&(format->file->count)) == NO_ERROR)
    {
      ShowMsgStrs(format->frame,0,0,0,2,
		  "Old count format is overwritten !!!",
		  "You may display & check the count file !!!",NULL,0);
      set_dat_file_saved(format->file,1);
    }
  }
  else if (save_pixel_type_format_proc(format,&(format->file->text))
	   == NO_ERROR)
  {
    ShowMsgStrs(format->frame,0,0,0,2,
		"Old text format is overwritten !!!",
		"You may display & check the text file !!!",NULL,0);
    set_dat_file_saved(format->file,1);
  }
}



/*--------------------------------------------------------------------------
rd_pixel_type_format - ???
--------------------------------------------------------------------------*/

int
rd_pixel_type_format(format,fn,option)
 struct text_format_rec *format;
 char *fn;
 int option;
{
 struct text_output_rec text;
 struct img_buf_rec *img;
 char *str1;
 int err;

 if ((img = win_rec_cur_img_buf(format->win->owner)) == NULL)
    return CANCEL;
 init_text_output_rec(&text,img->file);
 if ((err = RdTextFormat(fn,
        &(text.groups),&(text.num_groups),&(text.format),0)) == NO_ERROR)
    {
     if ((err = cp_text_output_analysis_group_recs(&(format->groups),
          &(format->total_groups),text.groups,text.num_groups,option)) == NO_ERROR)
        {format->numgroups = format->total_groups;
         format->cur_group = 0;
         display_format_group_nums(format);
         setup_order_proc(format,1);
         setup_order_proc(format,2);
        }
       else
        {concat_strs(&str1,2,"Error processing input from ",fn);
         ShowMsgStrs(format->frame,0,err,0,1,str1,NULL,0);
         c_free(str1);
        }
    }
   else
    {concat_strs(&str1,2,"Error reading input from ",fn);
     ShowMsgStrs(format->frame,0,err,0,1,str1,NULL,0);
     c_free(str1);
    }

 free_text_output_rec(&text);
 return err;
}


/*--------------------------------------------------------------------------
rd_count_text_format - ???
--------------------------------------------------------------------------*/

int
rd_count_text_format(format,fn,option)
 struct text_format_rec *format;
 char *fn;
 int option;
{
 struct count_analysis_rec count;
 struct img_buf_rec *img;
 char *str1;
 int err;

 if ((img = win_rec_cur_img_buf(format->win->owner)) == NULL)
    return CANCEL;
 init_count_analysis_rec(&count,img->file);
 if ((err = RdCountFormat(fn,&count)) == NO_ERROR)
    {if (count.num_groups == 0)
        {if (format->total_groups > 0)
            {free_analysis_group_recs(format->groups,format->total_groups);
             c_free(format->groups);
             format->groups = NULL;
             format->total_groups = 0;}
        }
       else err = cp_text_output_analysis_group_recs(&(format->groups),
          &(format->total_groups),count.groups,count.num_groups,option);

     if (err == NO_ERROR)
        {format->numgroups = format->total_groups;
         format->cur_group = 0;
         display_format_group_nums(format);
         setup_order_proc(format,1);
         setup_order_proc(format,2);
        }
       else
        {concat_strs(&str1,2,"Error processing input from ",fn);
         ShowMsgStrs(format->frame,0,err,0,1,str1,NULL,0);
         c_free(str1);
        }
    }
   else
    {concat_strs(&str1,2,"Error reading input from ",fn);
     ShowMsgStrs(format->frame,0,err,0,1,str1,NULL,0);
     c_free(str1);
    }

 free_count_analysis_rec(&count);
 return err;
}


/*--------------------------------------------------------------------------
rd_text_format_option - ???
--------------------------------------------------------------------------*/

int
rd_text_format_option(format,fn,option)
 struct text_format_rec *format;
 char *fn;
 int option;
{
 char *reason;
 int err;

 if (fn == NULL) return CANCEL;
 if ((err = file_access(fn,12,NULL,&reason)) != NO_ERROR)
    {ShowMsgStrs(format->frame,0,err,0,1,reason,NULL,0);
     c_free(reason);
     return err;
    }
 if (format->status & SETUP_COUNT_FORMAT)
    err = rd_count_text_format(format,fn,option);
   else err = rd_pixel_type_format(format,fn,option);
 return err;
}


/*--------------------------------------------------------------------------
rd_the_text_format - ???
--------------------------------------------------------------------------*/

int
rd_the_text_format(format,dir,fn)
 struct text_format_rec *format;
 char *dir,*fn;
{
 char *str;
 int err;

 if ((err = build_fn(&str,dir,fn,"")) != NO_ERROR) 
    {ShowMsgStrs(format->frame,0,err,0,1,
             "Error setting up the input text format fn  !!!",NULL,0);
     return err;}

 err = rd_text_format_option(format,str,1);
 c_free(str);
 return err;
}


/*--------------------------------------------------------------------------
format_read_proc - ???
--------------------------------------------------------------------------*/

void
format_read_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;
 char *dir,*str;

 format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dir = get_prog_dir(format->win->owner->root->prog);
 if (format->status & SETUP_COUNT_FORMAT)
    str = win_rec_win_id_title(format->win->owner,"READ *.fmt COUNT FORMAT");
   else str = win_rec_win_id_title(format->win->owner,"READ *.fmt PIXEL TYPE FORMAT");
 ask_files(1,format->frame,str,NULL,1,0,rd_the_text_format,format,
       NULL,NULL,0,"*.fmt",1,0,5,285,NULL,NULL,1,
       dir,NULL,NULL,
       "FN",DEFAULT_TXT_FORMAT_FN,NULL,NULL
      );
 c_free(str);
 c_free(dir);
}


/*--------------------------------------------------------------------------
rd_and_append_format - ???
--------------------------------------------------------------------------*/

int
rd_and_append_format(format,dir,fn)
 struct text_format_rec *format;
 char *dir,*fn;
{
 char *the_fn;
 int err;

 if ((err = build_fn(&the_fn,dir,fn,"")) != NO_ERROR) 
    {ShowMsgStrs(format->frame,0,err,0,1,
             "Error setting up the input text format fn  !!!",NULL,0);
     return err;}
 err = rd_text_format_option(format,the_fn,2);
 c_free(the_fn);
 return err;
}


/*--------------------------------------------------------------------------
format_read_and_append_proc - ???
--------------------------------------------------------------------------*/

void
format_read_and_append_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;
 char *dir,*str;

 format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dir = get_prog_dir(format->win->owner->root->prog);
 if (format->status & SETUP_COUNT_FORMAT)
    str = win_rec_win_id_title(format->win->owner,"READ & APPEND *.fmt COUNT FORMAT");
   else str = win_rec_win_id_title(format->win->owner,"READ & APPEND *.fmt PIXEL TYPE FORMAT");
 ask_files(1,format->frame,str,NULL,1,0,rd_and_append_format,format,
       NULL,NULL,0,"*.fmt",1,0,5,285,NULL,NULL,1,
       dir,NULL,NULL,
       "FN",DEFAULT_TXT_FORMAT_FN,NULL,NULL
      );
 c_free(dir);
 c_free(str);
}


/*--------------------------------------------------------------------------
format_help_proc - ???
--------------------------------------------------------------------------*/

void
format_help_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct text_format_rec *format;
 char *fn;

 format = (struct text_format_rec *) xv_get(item,PANEL_CLIENT_DATA);
 fn = (char *) get_prog_def_fn(format->win->owner->root->prog,
              TEXT_FORMAT_HELP_FN);
 enter_display_text_file(format->frame,1,NULL,fn);
 c_free(fn);
}


/*--------------------------------------------------------------------------
text_format_rec_done_proc - ???
--------------------------------------------------------------------------*/

void
text_format_rec_done_proc(frame)
 Frame frame;
{
 struct text_format_rec *format;

 format = (struct text_format_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_text_format_rec(format);
}


/*--------------------------------------------------------------------------
setup_format_groups - ???
--------------------------------------------------------------------------*/

int
setup_format_groups(format)
 struct text_format_rec *format;
{
 unsigned long lcv;
 int err;

 if (format->status & SETUP_COUNT_FORMAT)
    {if ((err = cp_text_output_analysis_group_recs(&(format->groups),
          &(format->total_groups),format->file->count.groups,
          format->file->count.num_groups,1)) != NO_ERROR)
        return err;}
   else if ((err = cp_text_output_analysis_group_recs(&(format->groups),
       &(format->total_groups),format->file->text.groups,
       format->file->text.num_groups,1)) != NO_ERROR)
    return err;
 TRACE(printf("setup_format_groups...\n"))
 TRACE(pr_text_output_analysis_group_recs(format->groups,format->total_groups);)

 format->numgroups = format->total_groups;
 for (lcv = 0; lcv < format->numgroups; lcv++)
    {TRACE(printf("%d) total_rois = %d  roi_nums = %u   total_pixel_types = %d  pixel_type_nums = %u\n",lcv,format->groups[lcv].total_rois,format->groups[lcv].roi_nums,
     format->groups[lcv].total_pixel_types,
      format->groups[lcv].pixel_type_nums))

     if (format->groups[lcv].total_rois > 0)
        {c_free(format->groups[lcv].roi_nums);
         format->groups[lcv].total_rois = 0;}
     format->groups[lcv].roi_nums = NULL;
     if (format->groups[lcv].total_pixel_types > 0)
        {c_free(format->groups[lcv].pixel_type_nums);
         format->groups[lcv].total_pixel_types = 0;}
     format->groups[lcv].pixel_type_nums = NULL;
    }
 return NO_ERROR;
}



/*--------------------------------------------------------------------------
setup_text_format_rec - ???
--------------------------------------------------------------------------*/

int
setup_text_format_rec(format,win,is_count_format)
     struct text_format_rec *format;
     struct image_display_window *win;
     int is_count_format;
{
  char *str,str1[100];
  Panel_item item,item1,item2,sitem,item0;
  int err;
  struct img_buf_rec *img;
  int row,offset,temp,temp1,temp_row;
  Rect *rr,*rr1;


  PRT1(printf("setup_text_format_rec...is_count_format = %d\n",is_count_format));
  format->frame =
    xv_create( win->dwin->frame, FRAME,
	       FRAME_INHERIT_COLORS, TRUE,
	       NULL );
  if (format->frame == 0) 
  {
    free_text_format_rec(format);
    return CANCEL;
  }
  format->win = win;
  format->dwin = win->dwin;
  if (is_count_format)
    str = (char *) win_rec_win_id_title(win->owner,COUNT_FORMAT);
  else
    str = (char *) win_rec_win_id_title(win->owner,PIXEL_TYPE_FORMAT);
  xv_set( format->frame,
	  FRAME_SHOW_LABEL, TRUE,
	  XV_LABEL, str,
	  FRAME_NO_CONFIRM,TRUE,
	  FRAME_DONE_PROC, text_format_rec_done_proc,
	  WIN_CLIENT_DATA, format,
	  NULL );
  c_free(str);
  if (is_count_format)
    format->status |= SETUP_COUNT_FORMAT;

  format->panel =
    xv_create( format->frame, PANEL,
	       FRAME_INHERIT_COLORS, TRUE,
	       NULL );
  if (format->panel == 0)
  {
    free_text_format_rec(format);
    return CANCEL;
  }
  if ((img = win_rec_cur_img_buf(format->win->owner)) == NULL)
  {
    free_text_format_rec(format);
    return CANCEL;
  }
  format->file = img->file;
  if ((err = setup_format_groups(format)) != NO_ERROR)
  {
    free_text_format_rec(format);
    return CANCEL;
  }

  row = 0;
  offset = xv_rows(format->panel,1) - xv_rows(format->panel,0) - 10;
  sprintf(str1,"TOTAL GROUPS = %d",format->numgroups);
  format->numgroups_item =
    xv_create(format->panel,PANEL_MESSAGE,
	      XV_X,5,XV_Y,2,
	      PANEL_LABEL_STRING,str1,0);
  TRACE(printf("setup_text_format_rec...2\n"));

  str = "NEW GROUP";
  xv_create(format->panel,PANEL_BUTTON,
	    PANEL_LABEL_STRING,str,        
	    XV_Y,0,
	    PANEL_NOTIFY_PROC,new_group_proc,
	    PANEL_CLIENT_DATA,format,0);

  str = "DELETE CUR GROUP";
  xv_create(format->panel,PANEL_BUTTON,
	    XV_Y,0,
	    PANEL_LABEL_STRING,str,        
	    PANEL_NOTIFY_PROC,delete_group_proc,
	    PANEL_CLIENT_DATA,format,0);


  row += offset;
  format->next_group =
    xv_create(format->panel,PANEL_SLIDER,
	      PANEL_LABEL_STRING,"CUR GROUP(G)# :",
	      PANEL_SLIDER_WIDTH,50,
	      XV_X,35,XV_Y,row,
	      PANEL_NOTIFY_PROC,next_group_proc,
	      PANEL_CLIENT_DATA,format,
	      0);

  row += offset;
  str = "CHANGE CUR G# TO :";
  format->change_group_index =
    xv_create(format->panel,PANEL_SLIDER,
	      XV_X,35,XV_Y,row,
	      PANEL_LABEL_STRING,str,
	      PANEL_SLIDER_WIDTH,50,
	      PANEL_NOTIFY_PROC,change_format_group_proc,
	      PANEL_CLIENT_DATA,format,
	      0);
  TRACE(printf("display_format_group_nums...\n"));
  display_format_group_nums(format);
  TRACE(printf("after display_format_group_nums...\n"));

  row += offset;
  str = "ROIS";
  format->roi_label_item =
    xv_create(format->panel,PANEL_MESSAGE,
	      XV_X,5,XV_Y,row,
	      PANEL_CLIENT_DATA,format,
	      PANEL_LABEL_STRING,str,0);
  rr1 = (Rect *) xv_get(format->roi_label_item,XV_RECT);
  item1 =
    xv_create(format->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"ALL",
	      PANEL_NOTIFY_PROC,select_list_proc,
	      XV_X,rr1->r_left + rr1->r_width + 5,XV_Y,row,
	      0);
  rr1 = (Rect *) xv_get(item1,XV_RECT);
  item2 =
    xv_create(format->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"NONE",
	      PANEL_NOTIFY_PROC,deselect_list_proc,
	      XV_X,rr1->r_left + rr1->r_width + 5,XV_Y,row,
	      0);
  temp_row = row;
  row += offset;
  rr1 = (Rect *) xv_get(format->roi_label_item,XV_RECT);
  item0 =
    xv_create(format->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"ALL LABELS",
	      PANEL_NOTIFY_PROC,format_setup_roi_proc,
	      PANEL_CLIENT_DATA,format->roi_label_item,
	      XV_KEY_DATA,1,1,
	      XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
	      0);

  rr1 = (Rect *) xv_get(item0,XV_RECT);
  xv_create(format->panel,PANEL_BUTTON,
	    PANEL_LABEL_STRING,"FILE ROIS ONLY",
	    PANEL_NOTIFY_PROC,format_setup_roi_proc,
	    PANEL_CLIENT_DATA,format->roi_label_item,
	    XV_KEY_DATA,1,0,
	    XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
	    0);

  TRACE(printf("SetupRoiProc...\n"));
  format->roi =
    xv_create(format->panel,PANEL_LIST,
	      PANEL_LAYOUT,PANEL_VERTICAL,
	      PANEL_CHOOSE_ONE,FALSE,
	      PANEL_LIST_DISPLAY_ROWS,5,
	      XV_X,5,XV_Y,row + offset - 3,
	      PANEL_CLIENT_DATA,format,0);
  SetupRoiProc(format,DISPLAY_WINDOW,0);
  TRACE(printf("setup_text_format_rec...3\n"));
  xv_set(item1,PANEL_CLIENT_DATA,format->roi,0);
  xv_set(item2,PANEL_CLIENT_DATA,format->roi,0);

  temp1 = (int) xv_get(format->roi,PANEL_LIST_WIDTH);
  if (temp1 > 200)
    xv_set(format->roi,PANEL_LIST_WIDTH,200,0);

  rr = (Rect *) xv_get(format->roi,XV_RECT);
  temp = rr->r_top + rr->r_height + 5;

  format->insert_roi =
    xv_create(format->panel,PANEL_TEXT,
	      PANEL_LABEL_STRING,"Insert Roi",
	      PANEL_VALUE_DISPLAY_LENGTH,20,
	      PANEL_VALUE_STORED_LENGTH,100,
	      PANEL_VALUE,"",
	      PANEL_NOTIFY_PROC,format_insert_label_proc,
	      XV_X,5,XV_Y,temp,
	      PANEL_CLIENT_DATA,format,0);

  temp += offset;
  item =
    xv_create(format->panel,PANEL_MESSAGE,
	      XV_X,20,XV_Y,temp,
	      PANEL_LABEL_STRING,
	      "Click on any 2 of either ORDERs to swap !!!",0);
  temp = temp + offset - 10;

  str = "ROI ORDER";
  item =
    xv_create(format->panel,PANEL_MESSAGE,
	      XV_X,5,XV_Y,temp+3,
	      PANEL_LABEL_STRING,str,0);
  sitem =
    xv_create(format->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"SORT",
	      PANEL_NOTIFY_PROC,format_sort_proc,
	      XV_Y,temp+3,0);

  item0 =
    xv_create(format->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"INSERT ALL",
	      PANEL_NOTIFY_PROC,format_insert_all_proc,
	      XV_Y,temp+3,0);

  temp += offset;
  item2 =
    xv_create(format->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"DELETE ALL",
	      PANEL_NOTIFY_PROC,format_delete_all_proc,
	      XV_X,5,XV_Y,temp,
	      0);

  rr1 = (Rect *) xv_get(item2,XV_RECT);
  item =
    xv_create(format->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"INSERT V",
	      PANEL_NOTIFY_PROC,format_insert_proc,
	      XV_X,rr1->r_left + rr1->r_width + 3,XV_Y,temp,
	      0);
  rr1 = (Rect *) xv_get(item,XV_RECT);
  item1 =
    xv_create(format->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"DELETE",
	      PANEL_NOTIFY_PROC,format_delete_proc,
	      XV_X,rr1->r_left + rr1->r_width,XV_Y,temp,
	      0);

  rr1 = (Rect *) xv_get(item1,XV_RECT);
  if ((rr->r_left + rr->r_width) < (rr1->r_left + rr1->r_width))
  {
    temp1 = rr1->r_left + rr1->r_width - rr->r_left;
    xv_set(format->roi,PANEL_LIST_WIDTH,temp1,0);
    rr = (Rect *) xv_get(format->roi,XV_RECT);
  }

  temp1 = (int) xv_get(format->roi,PANEL_LIST_WIDTH);
  format->roi_order =
    xv_create(format->panel,PANEL_LIST,
	      PANEL_LIST_DISPLAY_ROWS,5,
	      PANEL_LIST_WIDTH,temp1,
	      PANEL_CHOOSE_ONE,FALSE,
	      PANEL_LAYOUT,PANEL_VERTICAL,
	      XV_X,rr->r_left,XV_Y,temp + offset - 4,
	      PANEL_NOTIFY_PROC,format_swap_proc,
	      PANEL_CLIENT_DATA,format,0);
  xv_set(item,PANEL_CLIENT_DATA,format->roi_order,0);
  xv_set(item0,PANEL_CLIENT_DATA,format->roi_order,0);
  xv_set(item1,PANEL_CLIENT_DATA,format->roi_order,0);
  xv_set(item2,PANEL_CLIENT_DATA,format->roi_order,0);
  xv_set(sitem,PANEL_CLIENT_DATA,format->roi_order,0);

  setup_order_proc(format,1);
  TRACE(printf("after setup_order_proc...\n"));
  if (!is_count_format)
  {
    row = temp_row;
    str = "PIXEL TYPES";
    format->pixel_type_label_item =
      xv_create(format->panel,PANEL_MESSAGE,
		XV_X,rr->r_left + rr->r_width,XV_Y,row,
		PANEL_CLIENT_DATA,format,
		PANEL_LABEL_STRING,str,0);
    rr1 = (Rect *) xv_get(format->pixel_type_label_item,XV_RECT);
    item1 =
      xv_create(format->panel,PANEL_BUTTON,
		PANEL_LABEL_STRING,"ALL",
		PANEL_NOTIFY_PROC,select_list_proc,
		XV_X,rr1->r_left + rr1->r_width + 5,XV_Y,row,
		0);
    rr1 = (Rect *) xv_get(item1,XV_RECT);
    item2 =
      xv_create(format->panel,PANEL_BUTTON,
		PANEL_LABEL_STRING,"NONE",
		PANEL_NOTIFY_PROC,deselect_list_proc,
		XV_X,rr1->r_left + rr1->r_width + 5,XV_Y,row,
		0);

    row += offset;
    rr1 = (Rect *) xv_get(format->pixel_type_label_item,XV_RECT);
    item0 =
      xv_create(format->panel,PANEL_BUTTON,
		PANEL_LABEL_STRING,"ALL LABELS",
		PANEL_NOTIFY_PROC,format_setup_roi_proc,
		PANEL_CLIENT_DATA,format->pixel_type_label_item,
		XV_KEY_DATA,1,1,
		XV_X,rr1->r_left + rr1->r_width - 20,XV_Y,row,
		0);

    rr1 = (Rect *) xv_get(item0,XV_RECT);
    xv_create(format->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"FILE ROIS ONLY",
	      PANEL_NOTIFY_PROC,format_setup_roi_proc,
	      PANEL_CLIENT_DATA,format->pixel_type_label_item,
	      XV_KEY_DATA,1,0,
	      XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
	      0);

    format->type =
      xv_create(format->panel,PANEL_LIST,
		PANEL_LIST_DISPLAY_ROWS,5,
		PANEL_CHOOSE_ONE,FALSE,
		PANEL_LAYOUT,PANEL_VERTICAL,
		XV_X,rr->r_left + rr->r_width + 5,XV_Y,row + offset - 3,
		PANEL_CLIENT_DATA,format,0);
    SetupRoiProc(format,HISTOGRAM_WINDOW,1);
    xv_set(item1,PANEL_CLIENT_DATA,format->type,0);
    xv_set(item2,PANEL_CLIENT_DATA,format->type,0);

    temp1 = (int) xv_get(format->type,PANEL_LIST_WIDTH);
    if (temp1 > 200)
      xv_set(format->type,PANEL_LIST_WIDTH,200,0);


    rr = (Rect *) xv_get(format->type,XV_RECT);
    row = rr->r_top + rr->r_height + 5;
    format->insert_type =
      xv_create(format->panel,PANEL_TEXT,
		PANEL_LABEL_STRING,"Insert TYPE",
		PANEL_VALUE_DISPLAY_LENGTH,20,
		PANEL_VALUE_STORED_LENGTH,100,
		PANEL_VALUE,"",
		PANEL_NOTIFY_PROC,format_insert_label_proc,
		XV_X,rr->r_left,XV_Y,row,
		PANEL_CLIENT_DATA,format,0);
    row += 2 * offset - 10;

    str = "TYPE ORDER";
    item =
      xv_create(format->panel,PANEL_MESSAGE,
		XV_X,rr->r_left,XV_Y,row,
		PANEL_LABEL_STRING,str,0);

    rr1 = (Rect *) xv_get(item,XV_RECT);
    sitem =
      xv_create(format->panel,PANEL_BUTTON,
		PANEL_LABEL_STRING,"SORT",
		PANEL_NOTIFY_PROC,format_sort_proc,
		XV_X,rr1->r_left + rr1->r_width + 5,XV_Y,row,
		0);

    rr1 = (Rect *) xv_get(sitem,XV_RECT);
    item0 =
      xv_create(format->panel,PANEL_BUTTON,
		PANEL_LABEL_STRING,"INSERT ALL",
		PANEL_NOTIFY_PROC,format_insert_all_proc,
		XV_X,rr1->r_left + rr1->r_width + 5,XV_Y,row,
		0);

    row += offset;
    item2 =
      xv_create(format->panel,PANEL_BUTTON,
		PANEL_LABEL_STRING,"DELETE ALL",
		PANEL_NOTIFY_PROC,format_delete_all_proc,
		XV_X,rr->r_left,XV_Y,row,
		0);
    rr1 = (Rect *) xv_get(item2,XV_RECT);
    item =
      xv_create(format->panel,PANEL_BUTTON,
		PANEL_LABEL_STRING,"INSERT V",
		PANEL_NOTIFY_PROC,format_insert_proc,
		XV_X,rr1->r_left + rr1->r_width + 3,XV_Y,row,
		0);
    rr1 = (Rect *) xv_get(item,XV_RECT);
    item1 =
      xv_create(format->panel,PANEL_BUTTON,
		PANEL_LABEL_STRING,"DELETE",
		PANEL_NOTIFY_PROC,format_delete_proc,
		XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
		0);
    rr1 = (Rect *) xv_get(item1,XV_RECT);
    if ((rr->r_left + rr->r_width) < (rr1->r_left + rr1->r_width))
    {
      temp1 = rr1->r_left + rr1->r_width - rr->r_left;
      xv_set(format->type,PANEL_LIST_WIDTH,temp1,0);
      rr = (Rect *) xv_get(format->type,XV_RECT);
    }
    TRACE(printf("setup_text_format_rec...6\n"));
    temp1 = (int) xv_get(format->type,PANEL_LIST_WIDTH);
    format->type_order =
      xv_create(format->panel,PANEL_LIST,
		PANEL_LIST_DISPLAY_ROWS,5,
		PANEL_LIST_WIDTH,temp1,
		PANEL_CHOOSE_ONE,FALSE,
		PANEL_LAYOUT,PANEL_VERTICAL,
		PANEL_NOTIFY_PROC,format_swap_proc,
		XV_X,rr->r_left,XV_Y,row + offset - 3,
		PANEL_CLIENT_DATA,format,0);
    xv_set(item,PANEL_CLIENT_DATA,format->type_order,0);
    xv_set(item0,PANEL_CLIENT_DATA,format->type_order,0);
    xv_set(item1,PANEL_CLIENT_DATA,format->type_order,0);
    xv_set(item2,PANEL_CLIENT_DATA,format->type_order,0);
    xv_set(sitem,PANEL_CLIENT_DATA,format->type_order,0);
    setup_order_proc(format,2);
  }
  else
  {
    format->type = 0;
    format->type_order = 0;
  }

 rr = (Rect *) xv_get(format->roi_order,XV_RECT);
 row = rr->r_top + rr->r_height + 5;
 if (is_count_format)
    {xv_create(format->panel,PANEL_MESSAGE,
        XV_X,5,XV_Y,row,
	PANEL_LABEL_STRING,"IF NO ROI LABELS ARE PRESENT,",        
        0);
     row += offset - 4;
     xv_create(format->panel,PANEL_MESSAGE,
        XV_X,15,XV_Y,row,
	PANEL_LABEL_STRING,"BY DEFAULT, All ROIS WILL BE COUNTED",        
        0);
     row += offset - 4;
    }
 str = "APPLY NOW";
 xv_create(format->panel,PANEL_BUTTON,
        XV_X,5,XV_Y,row,
	PANEL_LABEL_STRING,str,        
        PANEL_NOTIFY_PROC,format_activate_proc,
        PANEL_CLIENT_DATA,format,0);

 str = "READ FORMAT";
 xv_create(format->panel,PANEL_BUTTON,
        XV_Y,row,
	PANEL_LABEL_STRING,str,        
        PANEL_NOTIFY_PROC,format_read_proc,
        PANEL_CLIENT_DATA,format,0);

 str = "HELP";
 xv_create(format->panel,PANEL_BUTTON,
        XV_Y,row,
	PANEL_LABEL_STRING,str,        
        PANEL_NOTIFY_PROC,format_help_proc,
        PANEL_CLIENT_DATA,format,0);

 row += offset;
 str = "SAVE FORMAT";
 xv_create(format->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,str,        
        PANEL_NOTIFY_PROC,format_save_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,format,0);

 str = "READ AND APPEND FORMAT";
 xv_create(format->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,str,        
        XV_Y,row,
        PANEL_NOTIFY_PROC,format_read_and_append_proc,
        PANEL_CLIENT_DATA,format,0);

 window_fit(format->panel);
 window_fit(format->frame);
 make_2_wins_adjacent(format->frame,win->dwin->frame,0);
 win_set_mouse_at_center(format->frame);
 xv_set(format->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 TRACE(printf("setup_text_format_rec...7\n"))
 return NO_ERROR;

}



/*--------------------------------------------------------------------------
find_text_format_rec - ???
--------------------------------------------------------------------------*/

struct text_format_rec *
find_text_format_rec(all_formats,win)
     struct all_text_format_recs *all_formats;
     struct image_display_window *win;
{
  int lcv;

  for (lcv = 0; lcv < all_formats->num_formats; lcv++)
    if (all_formats->formats[lcv]->win == win)
      return all_formats->formats[lcv];
  return NULL;
}



/*--------------------------------------------------------------------------
find_same_format_file - ???
--------------------------------------------------------------------------*/

struct text_format_rec *
find_same_format_file(all_formats,win)
     struct all_text_format_recs *all_formats;
     struct image_display_window *win;
{
 int lcv;
 struct input_file_rec *f1;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NULL;
 f1 = img->file;
 for (lcv = 0; lcv < all_formats->num_formats; lcv++)
    {if ((img = win_rec_cur_img_buf(all_formats->formats[lcv]->win->owner)) != NULL)
        if (img->file == f1)
           return all_formats->formats[lcv];
    }
 return NULL;
}



/*--------------------------------------------------------------------------
enter_text_format_rec - ???
--------------------------------------------------------------------------*/

int
enter_text_format_rec( win, status )
     struct image_display_window *win;
     int status;
{
  static struct all_text_format_recs all_formats;
  struct text_format_rec *format;
  static char first_time = 1;
  int err = NO_ERROR;

  if (status == GET_ALL_FORMAT_PTR)
  {
    if (first_time)
      return 0;
    else
      return (unsigned long) &all_formats;     /* FIXME:  ptr as long */
  }

  else if (status == CLEAN_UP_TEXT_FORMAT)
  {
    if (!first_time)
      if ((format = find_text_format_rec(&all_formats,win)) != NULL)
	free_text_format_rec(format);
    return NO_ERROR;
  }

  if (first_time)
  {
    init_all_text_format_recs(&all_formats);
    first_time = 0;
  }
  else
  {
    if (((format = find_text_format_rec(&all_formats,win)) != NULL) &&
	(((status & 4) && (format->status & SETUP_COUNT_FORMAT)) ||
	 ((status & 1) && !(format->status & SETUP_COUNT_FORMAT))) )
    {
      xv_set(format->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
      win_set_mouse_at_center(format->frame);
      wmgr_top(format->frame);
      return NO_ERROR;
    }

    if (((format = find_same_format_file(&all_formats,win)) != NULL) &&
	(((status & 4) && (format->status & SETUP_COUNT_FORMAT)) ||
	 ((status & 1) && !(format->status & SETUP_COUNT_FORMAT))) )
      free_text_format_rec(format);
  }
  get_handle_memory(&(all_formats.formats),&(all_formats.num_formats),1,
		    (size_t) sizeof(**(all_formats.formats)),&err);
  if (err != NO_ERROR)
    return err;
  format = all_formats.formats[all_formats.num_formats - 1];
  init_text_format_rec(format);
  if ((err = setup_text_format_rec(format,win,status & 4)) != NO_ERROR)
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
		"An error occured when setting up",
		"   the TEXT FORMAT window !!!",NULL,0);
  return err;
}
