/****************************************************************************
dp_histogram.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: dp_histogram.c,v 1.10 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"


/*
#define PRT(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
*/
#define PRT(x)
#define PRT4(x)
#define PRT2(x)
#define PRT5(x)



#define CLEANUP_DP 0
#define GET_ALL_DP_PTR 2

struct histo_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame owner_frame;
    Frame frame;
    Panel panel;
    Panel_item wid,histo_roi,which_slice,exc_overlap,exc,region,histo_1d_line,
               clear_histo,
               dimx,dimy,which_slice_roi,bkgx,bkgy,auto_bkgx,auto_bkgy;
   };

struct all_histo_recs
   {
    int num_dps;
    struct histo_rec **dps;
   };


/* Functions defined in this file */
void init_histo_rec(struct histo_rec *dp);
void free_histo_rec(struct histo_rec *dp);
void init_all_histo_recs(struct all_histo_recs *all_dps);
void dp_histo_done_proc(Frame frame);
struct slice_roi_win_rec *dp_which_slice_roi_win_rec(struct histo_rec *dp);
int dp_histo_1d_options(struct histo_rec *dp, struct image_display_window *win,
    struct buf_2d_rec *histo_buf);
int dp_histo_2d_options(struct histo_rec *dp, struct image_display_window *win,
    struct buf_2d_rec *histo_buf);
int win_histo_options(struct image_display_window *win,
    struct buf_2d_rec *histo_buf, int type2);
int Setup1dhistoByOptions(struct buf_2d_rec *result, struct img_buf_rec *img);
int Setup2dhistoByOptions(struct buf_2d_rec *result, struct buf_2d_rec *echo1,
    struct buf_2d_rec *echo2, struct img_buf_rec *img);
int WinFindHistogramWin(struct image_display_window *win,
    struct image_display_window **histo_win, int type2);
int WinSetupAndShowHisto(struct image_display_window *win, unsigned long dimx,
    unsigned long dimy, int type2, unsigned long type4, int is_all_slices,
    int histo_kind, struct image_display_window **histo_win);
void histo_show_proc(Panel_item item, Event *event);
void histo_clear_proc(Panel_item item, Event *event);
void histo_region_proc(Panel_item item, int value, Event *event);
void histo_rois_proc(Panel_item item, Event *event);
void histo_roi_chosen_proc(Panel_item item, char *wid, caddr_t client_data,
    Panel_list_op op, Event *event);
void histo_show_image_proc(Panel_item item, Event *event);
void histo_get_wids_proc(Panel_item item, Event *event);
void dp_bkg_limit_proc(Panel_item item, int value, Event *event);
void dp_auto_bkg_proc(Panel_item item, int value, Event *event);
int win_setup_roi_list_item(struct image_display_window *win, Panel_item item,
    struct slice_roi_rec *slice_roi);
int setup_histo_rec(struct histo_rec *dp, struct image_display_window *win);
struct histo_rec *find_histo_rec(struct all_histo_recs *all_dps,
    struct image_display_window *win);
int enter_histogram(struct image_display_window *win, int status);



/*-------------------------------------------------------------------------
init_histo_rec - ???
-------------------------------------------------------------------------*/

void
init_histo_rec(dp)
 struct histo_rec *dp;
{
 dp->status = 0;
 dp->frame = 0;
 dp->win = NULL;
}


/*-------------------------------------------------------------------------
free_histo_rec - ???
-------------------------------------------------------------------------*/

void
free_histo_rec(dp)
 struct histo_rec *dp;
{
 struct all_histo_recs *all_dps;

 if (dp->frame != 0)
    {
     xv_destroy_safe(dp->frame);
    }
 all_dps = (struct all_histo_recs *) enter_histogram(NULL,
            GET_ALL_DP_PTR);
 c_free(dp);
 DropHandleAryPtr(&(all_dps->dps),&(all_dps->num_dps),dp);
}


/*-------------------------------------------------------------------------
init_all_histo_recs - ???
-------------------------------------------------------------------------*/

void
init_all_histo_recs(all_dps)
 struct all_histo_recs *all_dps;
{
 all_dps->num_dps = 0;
 all_dps->dps = NULL;
}


/*-------------------------------------------------------------------------
dp_histo_done_proc - ???
-------------------------------------------------------------------------*/

void
dp_histo_done_proc(frame)
 Frame frame;
{
 struct histo_rec *dp;

 dp = (struct histo_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_histo_rec(dp);
}


/*-------------------------------------------------------------------------
dp_which_slice_roi_win_rec - ???
-------------------------------------------------------------------------*/

struct slice_roi_win_rec *
dp_which_slice_roi_win_rec(dp)
 struct histo_rec *dp;
{
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(dp->win->owner)) == NULL) return NULL;
 if ((dp->which_slice_roi == 0) ||
     (xv_get(dp->which_slice_roi,PANEL_VALUE) == 0))
    return &(img->file->histo_params.slice_roi_win_1d);
   else return &(img->file->histo_params.slice_roi_win_2d);
}


/*-------------------------------------------------------------------------
dp_histo_1d_options - ???
-------------------------------------------------------------------------*/

int
dp_histo_1d_options(dp,win,histo_buf)
 struct histo_rec *dp;
 struct image_display_window *win;
 struct buf_2d_rec *histo_buf;
{
 int is_exc,region,exc_overlap,err,is_mask_dirty,bkg;
 struct strs_rec roi_labels;
 struct draw_mask_rec mask;
 struct int_bound_rec affected,*bound;
 unsigned long option,cnt;
 struct slice_roi_rec *slice_roi;
 long minx,maxx,miny,maxy;
 struct curve_rec *curve;
 struct img_buf_rec *img;

 PRT4(printf("dp_histo_1d_options...dp->win = %u win = %u\n",dp->win,win))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return 0;
 if (!(img->status4 & IMG_HISTO_AUTO_SET_X_BACKGROUND) &&
     ((bkg = (int) xv_get(dp->bkgx,PANEL_VALUE)) > 0))
    {PRT4(printf("dp_histo_1d_options set x bkg\n"))
     if (bkg > histo_buf->dimx) bkg = histo_buf->dimx;
     for (cnt = 0; cnt < bkg; cnt++)
        histo_buf->SetVal(histo_buf,0,cnt,(double) .0);
    }
 if ((region = (int) xv_get(dp->region,PANEL_VALUE)) == 0) return NO_ERROR;
 if (win->control.sroi.sroi_win == NULL)
    {PRT4(printf("dp_histo_1d_options sroi_win == NULL\n"))
     win->control.sroi.sroi_win = &(img->file->histo_params.slice_roi_win_1d);}
 slice_roi = &(win->control.sroi.sroi_win->slice_roi);
 is_exc = (int) xv_get(dp->exc,PANEL_VALUE);
 PRT4(printf("dp_histo_1d_options region = %d is_exc = %d\n",region,is_exc))
 init_draw_mask_rec(&mask);
 if (region == 2)
    {exc_overlap = (int) xv_get(dp->exc_overlap,PANEL_VALUE);
     if (is_exc) option = 0x00000005;
       else option = 0x00000002;
     if (exc_overlap)
        {if (!(option & 0x00000002)) option |= 0x0000000c;
           else option |= 0x00000008;}
       else option |= 0x00000010;
     init_strs_rec(&roi_labels);
     if (((err = selected_list_item_ptrs(&roi_labels,dp->histo_roi)) == NO_ERROR) &&
         ((err = Get1DRegionMask(slice_roi,win->control.sroi.localto,
              histo_buf->dimx,&mask,&affected,option,
              &roi_labels,&is_mask_dirty)) == NO_ERROR))
        bound = &affected;
     free_strs_rec_ptrs(&roi_labels);
    }
   else if ((err = get_draw_mask_rec(&mask,histo_buf->dimx,1)) == NO_ERROR)
    {bound = NULL;
     if (is_exc) InitBuf2dRecData(&(mask.mask._2d),(double) 1.0);
     if (((curve = get_cur_curve(slice_roi)) != NULL) &&
         is_curve_non_empty(curve) &&
         ((err = FindCurveLongMinMax(curve,win->control.sroi.localto,
              &minx,&maxx,&miny,&maxy,
              curve->status & DRAW_MODE,0,0,1)) == NO_ERROR))
        {
         if (minx < 0) minx = 0;
         if (minx <= maxx)
            {if (maxx >= histo_buf->dimx) maxx = histo_buf->dimx - 1;
             if (minx <= maxx)
                {if (is_exc)
                    for (cnt = minx; cnt <= maxx; cnt++)
                       mask.mask._2d.SetVal(&(mask.mask._2d),0,cnt,(double) 0);
                   else
                    for (cnt = minx; cnt <= maxx; cnt++)
                       mask.mask._2d.SetVal(&(mask.mask._2d),0,cnt,(double) 1);
                }
            }
         }
    }
 if (err == NO_ERROR)
    {PRT4(printf("dp_histo_1d_options...Set2d\n"))
     err = Set2d(histo_buf,0,0,&(mask.mask._2d),bound,(double) .0);}

 free_draw_mask_rec(&mask);
 return err;
}


/*-------------------------------------------------------------------------
dp_histo_2d_options - ???
-------------------------------------------------------------------------*/

int
dp_histo_2d_options(dp,win,histo_buf)
 struct histo_rec *dp;
 struct image_display_window *win;
 struct buf_2d_rec *histo_buf;
{
 int is_exc,region,exc_overlap,err,is_mask_dirty,bkgx,bkgy;
 struct strs_rec roi_labels;
 struct draw_mask_rec mask;
 struct int_bound_rec affected,*bound;
 unsigned long option,cnt,lcv;
 struct slice_roi_rec *slice_roi;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return 0;
 if (!(img->status4 & IMG_HISTO_AUTO_SET_X_BACKGROUND))
    {PRT4(printf("dp_histo_2d_options set x bkg\n"))

     bkgx = (int) xv_get(dp->bkgx,PANEL_VALUE); 
     if (bkgx > histo_buf->dimx) bkgx = histo_buf->dimx;
     for (cnt = 0; cnt < bkgx; cnt++)
        for (lcv = 0; lcv < histo_buf->dimy; lcv++)
           histo_buf->SetVal(histo_buf,lcv,cnt,(double) .0);
    }
 if (!(img->status4 & IMG_HISTO_AUTO_SET_Y_BACKGROUND) && (dp->bkgy != 0))
    {PRT4(printf("dp_histo_2d_options set y bkg\n"))
     bkgy = (int) xv_get(dp->bkgy,PANEL_VALUE); 
     if (bkgy > histo_buf->dimy) bkgy = histo_buf->dimy;
     for (lcv = 0; lcv < bkgy; lcv++)
        for (cnt = 0; cnt < histo_buf->dimx; cnt++)
           histo_buf->SetVal(histo_buf,lcv,cnt,(double) .0);
    }
 if ((region = (int) xv_get(dp->region,PANEL_VALUE)) == 0) return NO_ERROR;
 if (win->control.sroi.sroi_win == NULL)
    {PRT4(printf("dp_histo_2d_options sroi_win == NULL\n"))
     win->control.sroi.sroi_win = &(img->file->histo_params.slice_roi_win_2d);}
 slice_roi = &(win->control.sroi.sroi_win->slice_roi);
 is_exc = (int) xv_get(dp->exc,PANEL_VALUE);
 PRT4(printf("dp_histo_2d_options region = %d is_exc = %d\n",region,is_exc))
 init_draw_mask_rec(&mask);
 if (region == 2)
    {exc_overlap = (int) xv_get(dp->exc_overlap,PANEL_VALUE);
     if (is_exc) option = 0x00000005;
       else option = 0x00000002;
     if (exc_overlap)
        {if (!(option & 0x00000002)) option |= 0x0000000c;
           else option |= 0x00000008;}
       else option |= 0x00000010;
     init_strs_rec(&roi_labels);
     if (((err = selected_list_item_ptrs(&roi_labels,dp->histo_roi)) == NO_ERROR) &&
         ((err = GetRegionMask(slice_roi,win->control.sroi.localto,
              histo_buf->dimx,histo_buf->dimy,
              &mask,&affected,option,&roi_labels,&is_mask_dirty)) == NO_ERROR))
        bound = &affected;
     free_strs_rec_ptrs(&roi_labels);
    }
   else
    {if ((err = GetRoiMask(slice_roi,win->control.sroi.localto,
             histo_buf->dimx,histo_buf->dimy,
             &mask,&affected,region,NULL)) == NO_ERROR)
        if (!is_exc)
           {NotBitmap(&(mask.mask._2d),&(mask.mask._2d));
            bound = NULL;}
          else bound = &affected;
    }
 if (err == NO_ERROR)
    {PRT4(printf("dp_histo_2d_options...Set2d\n"))
     PRT4(if (bound != NULL) pr_int_bound_rec(bound))
     err = Set2d(histo_buf,0,0,&(mask.mask._2d),bound,(double) .0);}

 free_draw_mask_rec(&mask);
 return err;
}


/*-------------------------------------------------------------------------
win_histo_options - ???
-------------------------------------------------------------------------*/

int
win_histo_options(win,histo_buf,type2)
 struct image_display_window *win;
 struct buf_2d_rec *histo_buf;
 unsigned short type2;
{
 struct all_histo_recs *all_dps;
 struct histo_rec *dp;

 if (((all_dps = (struct all_histo_recs *) enter_histogram(NULL,
            GET_ALL_DP_PTR)) != NULL) &&
     ((dp = find_histo_rec(all_dps,win)) != NULL))
    {PRT4(printf("win_histo_options...dp = %u\n",dp))
     if (type2 & HISTO_2D_WINDOW)
        return dp_histo_2d_options(dp,win,histo_buf);
       else return dp_histo_1d_options(dp,win,histo_buf);
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Setup1dhistoByOptions - ???
-------------------------------------------------------------------------*/

int
Setup1dhistoByOptions(result,img)
 struct buf_2d_rec *result;
 struct img_buf_rec *img;
{
 unsigned long row_indx,col,indx,lcv;
 struct buf_2d_rec *histo_1d;
 double val;

 PRT4(printf("\nSetup1dhistoByOptions...img->status4 = %x dimx = %d\n",
             img->status4,result->dimx))
 if (img->status4 & IMG_HISTO_INITIALIZE_BUF)
    {PRT4(printf("IMG_HISTO_INITIALIZE_BUF...\n"))
     InitBuf2dRecData(result,(double) .0);}
 if (img->status4 & IMG_HISTO_1D_SHOW_EACH_HISTOGRAM)
    {row_indx = img->cur_slice->slice_num + 1;
     if (row_indx >= result->dimx) row_indx = result->dimx - 1;}
   else row_indx = 0;

 if (!is_img_histo_ready(img,result->dimx,&indx))
    {PRT4(printf("Setup1dhistoByOptions histo_1d\n"))
     PRT4(pr_buf_2d_rec(histo_1d))
     return CANCEL;}
 histo_1d = &(img->file->histo_params.histo_1d);

 if ((img->status4 & IMG_HISTO_AUTO_SET_X_BACKGROUND) &&
     !(img->status4 & IMG_HISTO_1D_DISABLE_AUTO_SET))
    {PRT4(printf("...AutoSetHisto1DBuf...indx = %d\n",indx))
     AutoSetHisto1DBuf(histo_1d,indx,7,20,&lcv,0);}
   else lcv = 1;
 for (col = lcv; col < histo_1d->dimx; col++)
    {if ((val = histo_1d->GetVal(histo_1d,indx,col)) > .0)
        Add2dVal(result,row_indx,col,val);
    }
 if ((img != NULL) && (img->win != NULL) &&
     (img->win->image_display != NULL))
    {
     win_histo_options(img->win->image_display,result,
          (unsigned short) HISTO_1D_WINDOW);
    }

 if (!(img->status4 & IMG_HISTO_1D_DO_NOT_SETUP_HISTOGRAM) &&
     !(img->status4 & IMG_HISTO_1D_SHOW_EACH_HISTOGRAM))
    {
     Histogram2d(result,result,0,1,1,(double) 255.0,1);
     result->minval = result->minval_set = .0;
     result->maxval = result->maxval_set = 255.0;
     result->status4 |= BUF_MIN_MAX_SET | BUF_MIN_MAX_COMPUTED;}

 PRT4(printf("Setup1dhistoByOptions...result = %u cnt = %d\n",
       result,CntNonValBuf2dRec(result,(double) 0)))
 result->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Setup2dhistoByOptions - ???
-------------------------------------------------------------------------*/

int
Setup2dhistoByOptions(result,echo1,echo2,img)
 struct buf_2d_rec *result,*echo1,*echo2;
 struct img_buf_rec *img;
{
 unsigned long row,col,lcv,indx;
 double val,val1;

 PRT4(printf("\nSetup2dhistoByOptions...img->status4 = %x\n",img->status4))
 if (img->status4 & IMG_HISTO_INITIALIZE_BUF) InitBuf2dRecData(result,(double) .0);
 if (img->status4 & IMG_HISTO_AUTO_SET_X_BACKGROUND)
    {PRT4(printf("Setup2dhistoByOptions...IMG_HISTO_AUTO_SET_X_BACKGROUND\n"))
     AutoSet2dBackground(echo1,result->dimx - 1,7,20);}

 Scale2dPixels(echo1,echo1,(double) .0,(double) (result->dimx - 1),
          0,(double) .0,(double) .0,0);
 PRT4(printf("Setup2dhistoByOptions...1\n"))

 if (img->status4 & IMG_HISTO_AUTO_SET_Y_BACKGROUND)
    {PRT4(printf("Setup2dhistoByOptions...IMG_HISTO_AUTO_SET_Y_BACKGROUND\n"))
      /* Changed following line to conform to the similar line above,
	 hopefully fixing rather than introducing a bug.  -PWH 19990305
	 Was:      AutoSet2dBackground(echo2,result->dimx - 1,20);} */
     AutoSet2dBackground(echo2,result->dimx - 1,7,20);}
 Scale2dPixels(echo2,echo2,(double) .0,(double) (result->dimy - 1),
          0,(double) .0,(double) .0,0);

 for (row = 0; row < echo1->dimy; row++)
    for (col = 0; col < echo1->dimx; col++)
       {val = echo1->GetVal(echo1,row,col);
        val1 = echo2->GetVal(echo2,row,col);
        indx = (unsigned long) floor(val + .5);
        lcv = (unsigned long) floor(val1 + .5);
        if ((indx > 0) && (lcv > 0))
           Add2dVal(result,lcv,indx,(double) 1.0);
       }

 PRT4(printf("Setup2dhistoByOptions...2\n"))
 if ((img != NULL) && (img->win != NULL) &&
     (img->win->image_display != NULL))
    {win_histo_options(img->win->image_display,result,
          (unsigned short) HISTO_2D_WINDOW);
    }

 PRT4(printf("Setup2dhistoByOptions...3\n"))
 result->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinFindHistogramWin - ???
-------------------------------------------------------------------------*/

int
WinFindHistogramWin(win,histo_win,type2)
 struct image_display_window *win,**histo_win;
 unsigned short type2;
{
 unsigned long lcv;
 struct img_buf_rec *img,*img1;
 struct image_display_window *win1;

 if (win->type2 & type2) *histo_win = win;
   else
    {*histo_win = NULL;
     if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NO_ERROR;
     for (lcv = 0; lcv < img->file->img.num_data; lcv++)
        {img1 = img->file->img.data[lcv];
         if ((img1->cur_slice == img->cur_slice) &&
             (img1 != NULL) && (img1->win != NULL) &&
             ((win1 = img1->win->image_display) != NULL) &&
             (win1->num_display_wins > 0) && (win1->dwin != NULL) &&
             (win1->type2 & type2))
            {*histo_win = win1;
             return NO_ERROR;}
        }
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinSetupAndShowHisto - ???
-------------------------------------------------------------------------*/

int
WinSetupAndShowHisto(win,dimx,dimy,type2,type4,is_all_slices,histo_kind,histo_win)
 struct image_display_window *win;
 unsigned long dimx,dimy;
 unsigned short type2;
 unsigned long type4;
 int is_all_slices,histo_kind;
 struct image_display_window **histo_win;
{
 int err,histo_option;
 struct img_buf_rec *img;
 struct buf_2d_rec _2d;
 unsigned long depth;

 PRT5(printf("WinSetupAndShowHisto...type2 = %x type4 = %x is_all_slices = %d\n",
    (unsigned long) type2,(unsigned long) type4,is_all_slices))
 if (win->type2 & type2) *histo_win = win;
   else *histo_win = NULL;
    /*WinFindHistogramWin(win,histo_win,(unsigned short) type2);*/
 
 PRT5(printf("WinSetupAndShowHisto...1\n"))
 if (*histo_win == NULL)
    {PRT4(printf("WinSetupAndShowHisto...0\n"))
     if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
     
     if (is_all_slices)
        {depth = 32;
         PRT5(printf("WinSetupAndShowHisto...is_all_slices\n"))
         if (type2 & HISTO_2D_WINDOW) histo_option = 1;
           else histo_option = 0;
         return NewWinAllSlicesHisto(win,type2,1,dimx,dimy,depth,0,
                       type4,histo_option,histo_kind,histo_win);
        }
       else 
        {depth = find_num_bytes_needed(img->_2d.dimx * img->_2d.dimy) * 8;
         return NewWin(win,type2,1,dimx,dimy,depth,0,type4,histo_win);}
    }
   else if ((img = win_rec_cur_img_buf((*histo_win)->owner)) == NULL) return CANCEL;
   else
    {img->status4 &= ~IMG_HISTO_AUTO_SET;
     img->status4 |= type4;
     PRT4(printf("WinSetupAndShowHisto...histo exists\n"))
     if ((img->_2d.dimx != dimx) || (img->_2d.dimy != dimy))
        {init_buf_2d_rec(&_2d);
         PRT4(printf("re init _2d\n"))
         if (((err = SetupBuf2dRec(&_2d,dimx,dimy,img->_2d.pixel_depth,
              img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR) ||
             ((err = win_setup_mask_bufs(*histo_win,0,0,dimx,dimy)) == NO_ERROR))
            {free_buf_2d_rec(&_2d);
             return err;}
         PRT4(printf("re init _2d..1\n"))
         free_buf_2d_rec(&(img->_2d));
         img->_2d = _2d;
         win_execute_proc_to_multiple_wins(*histo_win,WinScaleViewScreenDimXY,
                         img->_2d.dimx,img->_2d.dimy,1,1,1);
        }
     if (is_all_slices)
        {if (type2 & HISTO_2D_WINDOW) histo_option = 1;
           else histo_option = 0;
         if ((err = SetupAllSlicesHisto(img,0,NULL,0,histo_option,
                       histo_kind)) != NO_ERROR)
            return err;}
       else if ((err = RdSlice(img,0,NULL,0)) != NO_ERROR)
        return err;
     PRT4(printf("WinSetupAndShowHisto..WinNewColorMultiCanvas\n"))
     WinNewColorMultiCanvas(*histo_win);
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
histo_show_proc - ???
-------------------------------------------------------------------------*/

void
histo_show_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct histo_rec *dp;
 struct strs_rec wids;
 struct image_display_window *win,*histo_win;
 struct img_buf_rec *img;
 struct win_rec *rwin;
 unsigned long lcv,dimx,dimy;
 int err,which_histo,is_all_slices,histo_kind;
 unsigned long type4,indx;

 dp = (struct histo_rec *) xv_get(item,PANEL_CLIENT_DATA);
 PRT5(printf("histo_show_proc...\n"))
 init_strs_rec(&wids);
 if (((err = selected_list_item_ptrs(&wids,dp->wid)) == NO_ERROR) &&
     (wids.num_strs > 0))
    {which_histo = (int) xv_get(item,XV_KEY_DATA,1);
     is_all_slices = (int) xv_get(dp->which_slice,PANEL_VALUE);
     dimx = (int) xv_get(dp->dimx,PANEL_VALUE);
     dimy = (int) xv_get(dp->dimy,PANEL_VALUE);
     if ((int) xv_get(dp->auto_bkgx,PANEL_VALUE))
        {type4 = IMG_HISTO_AUTO_SET_X_BACKGROUND;
         PRT4(printf("SET_X...type4 = %x\n",(unsigned long) type4))}
       else type4 = 0;
     if ((which_histo == 2) &&
         (dp->auto_bkgy != 0) && (int) xv_get(dp->auto_bkgy,PANEL_VALUE))
        {type4 |= IMG_HISTO_AUTO_SET_Y_BACKGROUND;
         PRT4(printf("SET_Y...type4 = %x\n",(unsigned long) type4))}
     if (histo_kind = (int) xv_get(dp->histo_1d_line,PANEL_VALUE))
        type4 |= IMG_HISTO_1D_SHOW_EACH_HISTOGRAM;
     if ((int) xv_get(dp->clear_histo,PANEL_VALUE))
        type4 |= IMG_HISTO_INITIALIZE_BUF;
     if (err == NO_ERROR)
        for (lcv = 0; lcv < wids.num_strs; lcv++)
           {PRT5(printf("histo_show_proc...1\n"))

            if (((rwin = get_win_rec_by_wid_str(dp->win->owner,
                    wids.strs[lcv])) != NULL) &&
                ((win = rwin->image_display) != NULL) &&
                ((img = win_rec_cur_img_buf(rwin)) != NULL))
               {if (which_histo == 2)
                   {if ((err = WinSetupAndShowHisto(win,dimx,dimy,
                               (unsigned short) HISTO_2D_WINDOW,
                               type4,is_all_slices,histo_kind,&histo_win)) != NO_ERROR)
                       break;}
                  else if ((err = WinSetupAndShowHisto(win,dimx,dimy,
                           (unsigned short) HISTO_1D_WINDOW,type4,
                           is_all_slices,histo_kind,&histo_win)) != NO_ERROR)
                   break;
                if (histo_win != NULL)
                   if (find_list_item_by_str(dp->wid,histo_win->owner->wid,&indx) ==
                            NOT_FOUND)
                      histo_get_wids_proc(item,event);
               }
           }
    }
 free_strs_rec_ptrs(&wids);
}


/*-------------------------------------------------------------------------
histo_clear_proc - ???
-------------------------------------------------------------------------*/

void
histo_clear_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct histo_rec *dp;
 struct strs_rec wids;
 struct image_display_window *win;
 struct win_rec *rwin;
 unsigned long lcv;

 dp = (struct histo_rec *) xv_get(item,PANEL_CLIENT_DATA);
 init_strs_rec(&wids);
 if ((selected_list_item_ptrs(&wids,dp->wid) == NO_ERROR) &&
     (wids.num_strs > 0))
    for (lcv = 0; lcv < wids.num_strs; lcv++)
       {if (((rwin = get_win_rec_by_wid_str(dp->win->owner,
                    wids.strs[lcv])) != NULL) &&
            ((win = rwin->image_display) != NULL))
           win_histogram_clear(win);
       }
 free_strs_rec_ptrs(&wids);
}


/*-------------------------------------------------------------------------
histo_region_proc - ???
-------------------------------------------------------------------------*/

void
histo_region_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct histo_rec *dp;

 dp = (struct histo_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value == 0)
    {xv_set(dp->exc,PANEL_VALUE,0,0);
     xv_set(dp->exc,PANEL_INACTIVE,TRUE,0);}
   else xv_set(dp->exc,PANEL_INACTIVE,FALSE,0);
}


/*-------------------------------------------------------------------------
histo_rois_proc - ???
-------------------------------------------------------------------------*/

void
histo_rois_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct histo_rec *dp;
 struct slice_roi_win_rec *sroi_win;

 dp = (struct histo_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((sroi_win = dp_which_slice_roi_win_rec(dp)) != NULL)
    win_setup_roi_list_item(dp->win,dp->histo_roi,&(sroi_win->slice_roi));
}


/*-------------------------------------------------------------------------
histo_roi_chosen_proc - ???
-------------------------------------------------------------------------*/

void
histo_roi_chosen_proc(item,wid,client_data,op,event)
 Panel_item item;
 char *wid;
 caddr_t client_data;
 Panel_list_op op;
 Event *event;
{
 struct histo_rec *dp;
 unsigned long indx;

 PRT4(printf("draw_wid_list_proc op = %d\n",op))
 dp = (struct histo_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (next_selected_item(item,0,&indx) == NO_ERROR)
    {xv_set(dp->region,PANEL_VALUE,2,0);
     xv_set(dp->exc,PANEL_INACTIVE,FALSE,0);}
   else
    {if ((int) xv_get(dp->region,PANEL_VALUE) == 2)
        {xv_set(dp->region,PANEL_VALUE,0,0);
         xv_set(dp->exc,PANEL_INACTIVE,TRUE,0);}
    }
}


/*-------------------------------------------------------------------------
histo_show_image_proc - ???
-------------------------------------------------------------------------*/

void
histo_show_image_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct histo_rec *dp;

 dp = (struct histo_rec *) xv_get(item,PANEL_CLIENT_DATA);

}


/*-------------------------------------------------------------------------
histo_get_wids_proc - ???
-------------------------------------------------------------------------*/

void
histo_get_wids_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct histo_rec *dp;
 struct strs_rec wids;

 dp = (struct histo_rec *) xv_get(item,PANEL_CLIENT_DATA);
 init_strs_rec(&wids);
 if (selected_list_items(&wids,dp->wid) == NO_ERROR)
    {delete_all_list_items(dp->wid);
     WinSetupWindowListItem(dp->win,dp->wid,1,MANY_SLICES_WINDOWS);
     select_list_items(&wids,dp->wid);}
 free_strs_rec(&wids);
}


/*-------------------------------------------------------------------------
dp_bkg_limit_proc - ???
-------------------------------------------------------------------------*/

void
dp_bkg_limit_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct histo_rec *dp;

 dp = (struct histo_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (item == dp->dimx)
    xv_set(dp->bkgx,PANEL_MAX_VALUE,value - 1,0);
   else if (dp->bkgy != 0)
    xv_set(dp->bkgy,PANEL_MAX_VALUE,value - 1,0);
}


/*-------------------------------------------------------------------------
dp_auto_bkg_proc - ???
-------------------------------------------------------------------------*/

void
dp_auto_bkg_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct histo_rec *dp;
 Panel_item item1;

 dp = (struct histo_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (item == dp->auto_bkgx) item1 = dp->bkgx;
   else if (item == dp->auto_bkgy) item1 = dp->bkgy;
 if (value) xv_set(item1,PANEL_INACTIVE,TRUE,0);
   else xv_set(item1,PANEL_INACTIVE,FALSE,0);
}


/*-------------------------------------------------------------------------
win_setup_roi_list_item - ???
-------------------------------------------------------------------------*/

int
win_setup_roi_list_item(win,item,slice_roi)
 struct image_display_window *win;
 Panel_item item;
 struct slice_roi_rec *slice_roi;
{
 struct strs_rec labels;
 int err;

 init_strs_rec(&labels);
 delete_all_list_items(item);
 if ((err = GetRoiLabelPtrs(slice_roi,&labels,0,1)) == NO_ERROR)
    {setup_list_items(&labels,item,0);
    }
 free_strs_rec_ptrs(&labels);
 return err;
}


/*-------------------------------------------------------------------------
setup_histo_rec - ???
-------------------------------------------------------------------------*/

int
setup_histo_rec(dp,win)
 struct histo_rec *dp;
 struct image_display_window *win;
{
 char *str;
 int row,offset,temp;
 Rect *rr,*rr1;
 Panel_item item;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 dp->win = win;
 dp->dwin = win->dwin;
 dp->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              0);
 PRT4(printf("setup_histo_rec...1\n"))
 if (dp->frame == 0)
    {free_histo_rec(dp);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,HISTOGRAM_OPTIONS);
 xv_set(dp->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,dp_histo_done_proc,
              WIN_CLIENT_DATA,dp,
              0);
 c_free(str);
 PRT4(printf("ok111.,..."))
 dp->panel = xv_create(dp->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (dp->panel == 0)
    {free_histo_rec(dp);
     return CANCEL;}
 row = 2;
 offset = xv_rows(dp->panel,1) - xv_rows(dp->panel,0) - 12;
 item = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"WIDS",
	PANEL_NOTIFY_PROC,histo_get_wids_proc,
        PANEL_CLIENT_DATA,dp,
        XV_X,5,XV_Y,row,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 dp->wid = xv_create(dp->panel,PANEL_LIST,
        PANEL_LIST_DISPLAY_ROWS,4,
        PANEL_LIST_WIDTH,80,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_CLIENT_DATA,dp,
        XV_X,5,XV_Y,rr->r_top + rr->r_height,
        0);
 rr = (Rect *) xv_get(dp->wid,XV_RECT);
 item = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"HISTO ROIS",
	PANEL_NOTIFY_PROC,histo_rois_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);
 
 if (img->file->hdr.data_info.num_echoes == 2)
    {rr1 = (Rect *) xv_get(item,XV_RECT);
     dp->which_slice_roi = xv_create(dp->panel,PANEL_CHOICE_STACK,
                  PANEL_CHOICE_STRINGS,"1D ROIS","2D ROIS",NULL,
	          PANEL_NOTIFY_PROC,histo_rois_proc,
                  PANEL_VALUE,0,
                  PANEL_CLIENT_DATA,dp,
                  XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
                  0);
    }
   else dp->which_slice_roi = 0;

 rr1 = (Rect *) xv_get(item,XV_RECT);
 PRT4(printf("ok 222.,..."))
 dp->histo_roi = xv_create(dp->panel,PANEL_LIST,
        PANEL_LIST_DISPLAY_ROWS,4,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CLIENT_DATA,dp,
	PANEL_NOTIFY_PROC,histo_roi_chosen_proc,
        PANEL_CHOOSE_ONE,FALSE,
        XV_X,rr->r_left + rr->r_width,XV_Y,rr1->r_top + rr1->r_height,
        0);

 WinSetupWindowListItem(dp->win,dp->wid,1,MANY_SLICES_WINDOWS);
 if ((str = WinRecGetWid(dp->win->owner,dp->win->type2)) != NULL)
    {select_list_str_item(str,dp->wid,1);
    }
 histo_rois_proc(dp->histo_roi,NULL);

 PRT4(printf("ok 333.,..."))
 rr = (Rect *) xv_get(dp->wid,XV_RECT);
 row = rr->r_top + rr->r_height;
 item = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"1D HISTO",
	PANEL_NOTIFY_PROC,histo_show_proc,
        XV_X,5,XV_Y,row,
        XV_KEY_DATA,1,1,
        PANEL_CLIENT_DATA,dp,
	0);
 if (img->file->hdr.data_info.num_echoes == 2)
    {rr1 = (Rect *) xv_get(item,XV_RECT);
     item = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"2D HISTO",
	PANEL_NOTIFY_PROC,histo_show_proc,
        XV_KEY_DATA,1,2,
        XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);}

 rr1 = (Rect *) xv_get(item,XV_RECT);
 dp->which_slice = xv_create(dp->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_HORIZONTAL,
                  PANEL_CHOICE_STRINGS,"CUR SLICE",
                           "ALL SLICES",NULL,
                  PANEL_VALUE,0,
                  XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
                  0);
 row += offset;
 dp->histo_1d_line = xv_create(dp->panel,PANEL_CHECK_BOX,
                  PANEL_LAYOUT,PANEL_HORIZONTAL,
                  PANEL_CHOICE_STRINGS,"1D HISTOGRAM ON EACH LINE",NULL,
                  PANEL_VALUE,0,
                  XV_X,10,XV_Y,row,
                  0);
 row += offset - 3;
 dp->clear_histo = xv_create(dp->panel,PANEL_CHECK_BOX,
                  PANEL_LAYOUT,PANEL_HORIZONTAL,
                  PANEL_CHOICE_STRINGS,"AUTO CLEAR OLD HISTOGRAM ",NULL,
                  PANEL_VALUE,1,
                  XV_X,10,XV_Y,row,
                  0);
 rr1 = (Rect *) xv_get(dp->clear_histo,XV_RECT);
 item = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"CLEAR HISTO - K",
	PANEL_NOTIFY_PROC,histo_clear_proc,
        XV_KEY_DATA,1,2,
        XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);

 rr1 = (Rect *) xv_get(win->dwin->frame,WIN_SCREEN_RECT);
 temp = rr1->r_left + rr1->r_width;
 row += offset;
 dp->dimx = xv_create(dp->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"HISTO DIM X",
        PANEL_VALUE,256,
        PANEL_MIN_VALUE,50,
        PANEL_MAX_VALUE,temp,
	PANEL_SLIDER_WIDTH,50,
        XV_X,5,XV_Y,row,
	PANEL_NOTIFY_PROC,dp_bkg_limit_proc,
        PANEL_CLIENT_DATA,dp,
        PANEL_INACTIVE,TRUE,
	0);
 row += offset;
 dp->auto_bkgx = xv_create(dp->panel,PANEL_CHECK_BOX,
	          PANEL_LABEL_STRING,"BKG X =",
                  PANEL_CHOICE_STRINGS,"AUTO SET",0,
 	          PANEL_VALUE,1,
	          PANEL_NOTIFY_PROC,dp_auto_bkg_proc,
                  PANEL_CLIENT_DATA,dp,
                  XV_X,5,XV_Y,row - 5,
                  0);
 rr1 = (Rect *) xv_get(dp->auto_bkgx,XV_RECT);
 dp->bkgx = xv_create(dp->panel,PANEL_SLIDER,
        PANEL_LABEL_STRING,"OR <",
        PANEL_VALUE,8,
        PANEL_MIN_VALUE,1,
        PANEL_MAX_VALUE,255,
        PANEL_INACTIVE,TRUE,
	PANEL_SLIDER_WIDTH,50,
        XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
	0);
 row += offset;
 dp->dimy = xv_create(dp->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"HISTO DIM Y",
        PANEL_VALUE,256,
        PANEL_MIN_VALUE,50,
        PANEL_MAX_VALUE,temp,
	PANEL_SLIDER_WIDTH,50,
        XV_X,5,XV_Y,row,
	PANEL_NOTIFY_PROC,dp_bkg_limit_proc,
        PANEL_CLIENT_DATA,dp,
        PANEL_INACTIVE,TRUE,
	0);
 if (img->file->hdr.data_info.num_echoes == 2)
    {
     row += offset;
     dp->auto_bkgy = xv_create(dp->panel,PANEL_CHECK_BOX,
	          PANEL_LABEL_STRING,"BKG Y =",
                  PANEL_CHOICE_STRINGS,"AUTO SET",0,
 	          PANEL_VALUE,1,
	          PANEL_NOTIFY_PROC,dp_auto_bkg_proc,
                  PANEL_CLIENT_DATA,dp,
                  XV_X,5,XV_Y,row - 5,
                  0);
     rr1 = (Rect *) xv_get(dp->auto_bkgy,XV_RECT);
     dp->bkgy = xv_create(dp->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"OR <",
        PANEL_VALUE,8,
        PANEL_MIN_VALUE,1,
        PANEL_MAX_VALUE,255,
        PANEL_INACTIVE,TRUE,
	PANEL_SLIDER_WIDTH,50,
        XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
	0);
     }
    else
     {dp->auto_bkgy = 0;
      dp->bkgy = 0;}

 PRT4(printf("ok 444.,..."))
 row += offset;
 dp->exc = xv_create(dp->panel,PANEL_CHECK_BOX,
	          PANEL_LABEL_STRING,"BY",
                  PANEL_CHOICE_STRINGS,"EXCLUDING",0,
 	          PANEL_VALUE,0,
 	          PANEL_INACTIVE,TRUE,
                  XV_X,5,XV_Y,row,
                  0);
 rr = (Rect *) xv_get(dp->exc,XV_RECT);
 dp->region = xv_create(dp->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"EVERYTHING",
                           "HISTO CUR REGION","HISTO ROIS",NULL,
	          PANEL_NOTIFY_PROC,histo_region_proc,
                  PANEL_VALUE,0,
                  PANEL_CLIENT_DATA,dp,
                  XV_X,rr->r_left + rr->r_width,XV_Y,row,
                  0);
 row += offset;
 rr = (Rect *) xv_get(item,XV_RECT);
 dp->exc_overlap = xv_create(dp->panel,PANEL_CHOICE_STACK,
	          PANEL_LABEL_STRING,"OVERLAPPED REGION",
                  PANEL_CHOICE_STRINGS,"INCLUDED","EXCLUDED",NULL,
                  PANEL_VALUE,0,
                  PANEL_CLIENT_DATA,dp,
                  XV_X,10,XV_Y,row - 4,
                  0);
/*
 row += offset;
 item = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"SHOW IMAGE FOR SELECTED HISTO REGIONS",
	PANEL_NOTIFY_PROC,histo_show_image_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);
*/
 window_fit(dp->panel);
 rr = (Rect *) xv_get(dp->panel,XV_RECT);
 xv_set(dp->panel,XV_HEIGHT,rr->r_height - 13,XV_WIDTH,rr->r_width - 15,0);
 window_fit(dp->frame);
 make_2_wins_adjacent(dp->frame,win->dwin->frame,0);
 win_set_mouse_at_center(dp->frame);
 xv_set(dp->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 PRT4(printf("setup_histo_rec...end\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_histo_rec - ???
-------------------------------------------------------------------------*/

struct histo_rec *
find_histo_rec(all_dps,win)
 struct all_histo_recs *all_dps;
 struct image_display_window *win;
{
 int lcv;
 struct img_buf_rec *img,*img1;

 for (lcv = 0; lcv < all_dps->num_dps; lcv++)
    {if (all_dps->dps[lcv]->win == win) return all_dps->dps[lcv];
     if (((img = win_rec_cur_img_buf(all_dps->dps[lcv]->win->owner)) != NULL) &&
         ((img1 = win_rec_cur_img_buf(win->owner)) != NULL) &&
         (img->file == img1->file))
        return all_dps->dps[lcv];}
 return NULL;
}


/*-------------------------------------------------------------------------
enter_histogram - ???
-------------------------------------------------------------------------*/

int
enter_histogram(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_histo_recs all_dps;
 struct histo_rec *dp;
 static char first_time = 1;
 int err;

 PRT(printf("enter_histogram...0\n"))
 err = NO_ERROR;
 if (first_time)
    {init_all_histo_recs(&all_dps);
     first_time = 0;}
 if (status == GET_ALL_DP_PTR)
    {return (unsigned long) &all_dps;}     /* FIXME:  ptr as long */
  else if (status == CLEANUP_DP)
   {if ((dp = find_histo_rec(&all_dps,win)) != NULL)
       free_histo_rec(dp);
    return NO_ERROR;}
 PRT(printf("enter_histogram...1\n"))
 if ((dp = find_histo_rec(&all_dps,win)) != NULL)
    {xv_set(dp->frame,
               XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
     win_set_mouse_at_center(dp->frame);
     wmgr_top(dp->frame);
     return NO_ERROR;}

 PRT(printf("enter_histogram...2\n"))
 get_handle_memory(&(all_dps.dps),&(all_dps.num_dps),1,
     (size_t) sizeof(struct histo_rec),&err);
 if (err != NO_ERROR) return err;
 dp = all_dps.dps[all_dps.num_dps - 1];
 init_histo_rec(dp);
 PRT(printf("enter_histogram...2\n"))
 if ((err = setup_histo_rec(dp,win)) == NO_ERROR)
    {PRT(printf("setup_histo_rec...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up the window for",
               HISTOGRAM_OPTIONS,NULL,0);
 return err;

}

