/****************************************************************************
draw_bitmap.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: draw_bitmap.c,v 1.10 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/notify.h>

#include "mri_format.h"
#include "geometry.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)




/* Functions defined in this file */
int DrawCurveRec(struct draw_mask_rec *mask, struct curve_rec *curve,
    struct matrix_2d_rec *localto, int curve_type);
int DrawCurve2dRec(struct draw_mask_rec *cur_roi_mask,
    struct draw_mask_rec *cur_curve_mask, struct curve_2d_rec *pen,
    struct matrix_2d_rec *localto);
int DrawRoiRec(struct draw_mask_rec *cur_roi_mask,
    struct draw_mask_rec *cur_curve_mask, struct roi_rec *roi,
    struct matrix_2d_rec *localto);
int DrawSliceRoiRec(struct draw_mask_rec *other_roi_mask,
    struct draw_mask_rec *cur_roi_mask, struct draw_mask_rec *cur_curve_mask,
    struct slice_roi_rec *slice_roi, struct matrix_2d_rec *localto,
    unsigned long is_win_visible_option);
int FillDrawRoiRec(struct draw_mask_rec *cur_roi_mask,
    struct draw_mask_rec *cur_curve_mask, struct roi_rec *roi,
    struct matrix_2d_rec *localto);
int FillDrawSliceRoiRec(struct draw_mask_rec *other_roi_mask,
    struct draw_mask_rec *cur_roi_mask, struct draw_mask_rec *cur_curve_mask,
    struct slice_roi_rec *slice_roi, struct matrix_2d_rec *localto,
    int plot_cur_roi, unsigned long is_win_visible_option);
void DrawCurCurveRec(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, struct draw_mask_rec *cur_curve_mask);
int DrawCurRoiRec(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, struct draw_mask_rec *cur_roi_mask,
    struct draw_mask_rec *cur_curve_mask, int is_polygon);
int GetFilledCurveMask(struct curve_rec *curve, struct matrix_2d_rec *localto,
    int pen_type, struct draw_mask_rec *mask, struct int_bound_rec *affected);
int GetFilledRoiMask(struct roi_rec *roi, struct matrix_2d_rec *localto,
    struct draw_mask_rec *mask, struct int_bound_rec *affected);
int GetFilledAllRoisMask(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, struct draw_mask_rec *mask);
int win_draw_cur_curve_rec(struct image_display_window *win);
void win_draw_cur_roi_rec(struct image_display_window *win);
int GetRoiMask(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, long dimx, long dimy,
    struct draw_mask_rec *mask, struct int_bound_rec *affected, int option,
    struct roi_rec *image_view_roi);
int GetRegionMask(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, long dimx, long dimy,
    struct draw_mask_rec *mask, struct int_bound_rec *affected,
    unsigned long option, struct strs_rec *roi_labels, int *is_mask_dirty);
int Get1DRegionMask(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, long dimx, struct draw_mask_rec *mask,
    struct int_bound_rec *affected, unsigned long option,
    struct strs_rec *roi_labels, int *is_mask_dirty);



/*--------------------------------------------------------------------------
DrawCurveRec - ???
--------------------------------------------------------------------------*/

int
DrawCurveRec(mask,curve,localto,curve_type)
 struct draw_mask_rec *mask;
 struct curve_rec *curve;
 struct matrix_2d_rec *localto;
 unsigned short curve_type;
{
 unsigned long total_pts_drawn;

 if (curve == NULL) return NO_ERROR;
 PRT(printf("DrawCurveRec..curve_type = %x...curve->num_xys = %d\n",
       (unsigned int) curve_type,curve->num_xys))

 DrawInBuf(mask->mask._2d.buf,0,0,
          mask->mask._2d.dimx - 1,mask->mask._2d.dimy - 1,
          mask->mask._2d.pixel_depth,curve->xys,(unsigned int) curve->num_xys,
          (unsigned long) curve_type,&(curve->matrix),
          (int) (curve->status & CURVE_MATRIX_IN_USE),
          (long) 1,NULL,&total_pts_drawn,localto);
 PRT(printf("DrawCurveRec...DrawInBuf...total_pts_drawn = %d\n",total_pts_drawn))
 if (total_pts_drawn > 0)
    mask->paint_status |= PAINTED;
 return NO_ERROR;
}



/*--------------------------------------------------------------------------
DrawCurve2dRec - ???
--------------------------------------------------------------------------*/

int
DrawCurve2dRec(cur_roi_mask,cur_curve_mask,pen,localto)
 struct draw_mask_rec *cur_roi_mask,*cur_curve_mask;
 struct curve_2d_rec *pen;
 struct matrix_2d_rec *localto;
{
 int lcv,err;

 TRACE(printf("draw_curve_2d_rec cur_curve num_curves = %d %d\n",
         pen->cur_curve,pen->num_curves))

 for (lcv = 0; lcv < pen->num_curves; lcv++)
    if (lcv == pen->cur_curve)
       {TRACE(printf("draw_curve_2d_rec draw cur curve...check!!!\n"))
        if ((err = DrawCurveRec(cur_curve_mask,
              pen->curves[pen->cur_curve],localto,pen->pen_type)) != NO_ERROR)
           if (err != CANCEL) return err;}
      else
       {
        TRACE(printf("draw_curve_2d_rec draw other curve...check!!!\n"))
        if ((err = DrawCurveRec(cur_roi_mask,
             pen->curves[lcv],localto,pen->pen_type)) != NO_ERROR)
          if (err != CANCEL) return err;
       }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
DrawRoiRec - ???
--------------------------------------------------------------------------*/

int
DrawRoiRec(cur_roi_mask,cur_curve_mask,roi,localto)
 struct draw_mask_rec *cur_roi_mask,*cur_curve_mask;
 struct roi_rec *roi;
 struct matrix_2d_rec *localto;
{
 int lcv,err;

 TRACE(printf("draw_roi_rec...begin..cur_pen = %d num_pens = %d...\n",
      (int) roi->cur_pen,(int) roi->num_pens))

 if (!(roi->status & ROI_VISIBLE)) return NO_ERROR;

 for (lcv = 0; lcv < roi->num_pens; lcv++)
    if (lcv == roi->cur_pen)
       {if ((err = DrawCurve2dRec(cur_roi_mask,cur_curve_mask,
                          roi->pens[roi->cur_pen],localto)) != NO_ERROR)
           return err;}
      else
       {
        if ((err = DrawCurve2dRec(cur_roi_mask,cur_roi_mask,
                roi->pens[lcv],localto)) != NO_ERROR)
           return err;
       }
 TRACE(printf("draw_roi_rec...end..cur_pen = %d num_pens = %d...\n",
      (int) roi->cur_pen,(int) roi->num_pens))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
DrawSliceRoiRec - ???
--------------------------------------------------------------------------*/

int
DrawSliceRoiRec(other_roi_mask,cur_roi_mask,cur_curve_mask,
                slice_roi,localto,is_win_visible_option)
 struct draw_mask_rec *other_roi_mask,*cur_roi_mask,*cur_curve_mask;
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *localto;
 unsigned long is_win_visible_option;
{
 int lcv,err;

 TRACE(printf("DrawSliceRoiRec...slice_roi = %u\n",slice_roi))

 TRACE(printf("DrawSliceRoiRec...begin cur_roi = %d  num_rois = %d...",
            (int) slice_roi->cur_roi,slice_roi->num_rois))

 for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
    {/*printf("roi label = %s = %x\n",slice_roi->rois[lcv]->label,
             (unsigned long) slice_roi->rois[lcv]->status);*/
     if (!(slice_roi->rois[lcv]->status & ROI_VISIBLE)) continue;
     if (is_win_visible_option & HIDE_ALL_ROIS_BUT_CUR)
        if (lcv != slice_roi->cur_roi)
           continue;
     if (lcv == slice_roi->cur_roi)
        {if ((err = DrawRoiRec(cur_roi_mask,cur_curve_mask,
             slice_roi->rois[slice_roi->cur_roi],localto)) != NO_ERROR)
           return err;}
       else
        if ((err = DrawRoiRec(other_roi_mask,other_roi_mask,
             slice_roi->rois[lcv],localto)) != NO_ERROR)
            return err;
    }
 TRACE(printf("DrawSliceRoiRec...end\n\n"))

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
FillDrawRoiRec - ???
--------------------------------------------------------------------------*/

int
FillDrawRoiRec(cur_roi_mask,cur_curve_mask,roi,localto)
 struct draw_mask_rec *cur_roi_mask,*cur_curve_mask;
 struct roi_rec *roi;
 struct matrix_2d_rec *localto;
{
 int err;

 PRT2(printf("FillDrawRoiRec...cur_roi_mask = %u cur_curve_mask = %u\n",cur_roi_mask,cur_curve_mask))
 if (!(roi->status & ROI_VISIBLE)) return NO_ERROR;
 PRT1(printf("...cur_roi_mask mask._2d= %u \n",&(cur_roi_mask->mask._2d)))
 PRT2(printf("...localto = %u \n",localto))
 if ((err = FillROi(roi,localto,
		    &(cur_roi_mask->mask._2d),1,1,0)) != NO_ERROR) return err;
 cur_roi_mask->paint_status |= PAINTED;
 TRACE(printf("FillDrawRoiRec...1\n"))
 if (cur_curve_mask != NULL)
    {clear_draw_masks(cur_curve_mask,1);
     if ((roi->cur_pen < roi->num_pens) &&
        (roi->pens[roi->cur_pen]->cur_curve <
         roi->pens[roi->cur_pen]->num_curves))
        {
         if ((err = DrawCurveRec(cur_curve_mask,
             roi->pens[roi->cur_pen]->curves
                 [roi->pens[roi->cur_pen]->cur_curve],localto,
                 roi->pens[roi->cur_pen]->pen_type)) != NO_ERROR)
           if (err != CANCEL) return err;
        }
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
FillDrawSliceRoiRec - ???
--------------------------------------------------------------------------*/

int
FillDrawSliceRoiRec(other_roi_mask,cur_roi_mask,cur_curve_mask,
                   slice_roi,localto,plot_cur_roi,is_win_visible_option)
 struct draw_mask_rec *other_roi_mask,*cur_roi_mask,*cur_curve_mask;
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *localto;
 int plot_cur_roi;
 unsigned long is_win_visible_option;
{
 int lcv,err;

 PRT2(printf("FillDrawSliceRoiRec localto = %u\n",localto))
 clear_draw_masks(other_roi_mask,1);

 err = NO_ERROR;
 for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
    if ((lcv != slice_roi->cur_roi) || !plot_cur_roi)
       {TRACE(printf("lcv = %d\n",lcv))
        if (!(slice_roi->rois[lcv]->status & ROI_VISIBLE)) continue;
        if (is_win_visible_option & HIDE_ALL_ROIS_BUT_CUR)
           if (lcv != slice_roi->cur_roi)
              continue;

        if ((err = FillDrawRoiRec(cur_roi_mask,NULL,
             slice_roi->rois[lcv],localto)) != NO_ERROR)
           return err;
        OrBitmaps(&(other_roi_mask->mask._2d),&(other_roi_mask->mask._2d),
              &(cur_roi_mask->mask._2d));
        other_roi_mask->paint_status |= PAINTED;
        InitBuf2dRecData(&(cur_roi_mask->mask._2d),(double) .0);
       }

 if (plot_cur_roi)
    {if (slice_roi->rois[slice_roi->cur_roi]->status & ROI_VISIBLE)
        if ((err = FillDrawRoiRec(cur_roi_mask,cur_curve_mask,
             slice_roi->rois[slice_roi->cur_roi],localto)) != NO_ERROR)
        return err;}
 return err;
}


/*--------------------------------------------------------------------------
DrawCurCurveRec - ???
--------------------------------------------------------------------------*/

void
DrawCurCurveRec(slice_roi,localto,cur_curve_mask)
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *localto;
 struct draw_mask_rec *cur_curve_mask;
{
 struct curve_2d_rec *pen;

 clear_draw_masks(cur_curve_mask,1);
 if ((pen = get_cur_pen(slice_roi)) != NULL)
    {DrawCurveRec(cur_curve_mask,
       pen->curves[pen->cur_curve],localto,pen->pen_type);}
}


/*--------------------------------------------------------------------------
DrawCurRoiRec - ???
--------------------------------------------------------------------------*/

int
DrawCurRoiRec(slice_roi,localto,cur_roi_mask,cur_curve_mask,
                  is_polygon)
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *localto;
 struct draw_mask_rec *cur_roi_mask,*cur_curve_mask;
 int is_polygon;
{
 struct roi_rec *roi;

 if ((roi = get_cur_roi(slice_roi)) != NULL)
    {
     if (is_polygon) 
        {PRT1(printf("cur_roi_mask = %u cur_curve_mask = %u\n",
                      cur_roi_mask,cur_curve_mask))
         FillDrawRoiRec(cur_roi_mask,cur_curve_mask,roi,localto);}
       else
        {clear_draw_masks(cur_roi_mask,1);
         if (cur_roi_mask != cur_curve_mask) clear_draw_masks(cur_curve_mask,1);
         DrawRoiRec(cur_roi_mask,cur_curve_mask,roi,localto);}
     return NO_ERROR;
    }
 return CANCEL;
}


/*--------------------------------------------------------------------------
GetFilledCurveMask - ???
--------------------------------------------------------------------------*/

int
GetFilledCurveMask(curve,localto,pen_type,mask,affected)
 struct curve_rec *curve;
 struct matrix_2d_rec *localto;
 unsigned short pen_type;
 struct draw_mask_rec *mask;
 struct int_bound_rec *affected;
{
 int err;

 clear_draw_masks(mask,1);
 if (curve == NULL) return NO_ERROR;
 if (affected != NULL) 
    {
     FindCurveLongMinMax(curve,localto,&(affected->left),&(affected->right),
                  &(affected->top),&(affected->bottom),pen_type,0,0,0);
    }
 if (pen_type == DRAW_POINT)
    {if ((err = XorBitmapByCurves(&(mask->mask._2d),&curve,1,localto,0
             )) != NO_ERROR)
               return err;
    }
   else if ((err = FillEexclusiveObjRegions(&curve,1,
                localto,&(mask->mask._2d),1,0)) != NO_ERROR)
    return err;
 mask->paint_status |= PAINTED;

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
GetFilledRoiMask - ???
--------------------------------------------------------------------------*/

int
GetFilledRoiMask(roi,localto,mask,affected)
 struct roi_rec *roi;
 struct matrix_2d_rec *localto;
 struct draw_mask_rec *mask;
 struct int_bound_rec *affected;
{
 int err;

 TRACE(printf("GetFilledRoiMask...in\n"))
 if (roi == NULL) return NO_ERROR;
 if (affected != NULL) 
    FindRoiLongMinMax(roi,localto,&(affected->left),&(affected->right),
              &(affected->top),&(affected->bottom),0,0,0);
 TRACE(printf("GetFilledRoiMask...\n"))
 err = FillDrawRoiRec(mask,NULL,roi,localto);

 return err;
}


/*--------------------------------------------------------------------------
GetFilledAllRoisMask - ???
--------------------------------------------------------------------------*/

int
GetFilledAllRoisMask(slice_roi,localto,mask)
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *localto;
 struct draw_mask_rec *mask;
{
 struct draw_mask_rec mask1,mask2;
 int err;

 if (slice_roi == NULL) return NO_ERROR;
 init_draw_mask_rec(&mask1);
 init_draw_mask_rec(&mask2);
 if (((err = get_draw_mask_rec(&mask1,mask->mask._2d.dimx,mask->mask._2d.dimy)) 
          != NO_ERROR) ||
     ((err = get_draw_mask_rec(&mask2,mask->mask._2d.dimx,mask->mask._2d.dimy)) 
          != NO_ERROR))
    {free_draw_mask_rec(&mask1);
     free_draw_mask_rec(&mask2);
     return err;}

 PRT3(printf("GetFilledAllRoisMask mask = %u localto = %u\n",mask,localto))
 err = FillDrawSliceRoiRec(mask,&mask1,&mask2,slice_roi,localto,0,0);
 PRT3(printf("GetFilledAllRoisMask...1\n"))
 OrBitmaps(&(mask->mask._2d),&(mask->mask._2d),&(mask1.mask._2d));
 PRT3(printf("GetFilledAllRoisMask...2\n"))
 free_draw_mask_rec(&mask1);
 free_draw_mask_rec(&mask2);

 return err;
}


/*--------------------------------------------------------------------------
win_draw_cur_curve_rec - ???
--------------------------------------------------------------------------*/

int
win_draw_cur_curve_rec(win)
 struct image_display_window *win;
{
 struct curve_2d_rec *pen;
 struct curve_rec *cur_curve;

 if (win->control.display_options & DISPLAY_FILLED_ROI)
    {PRT1(printf("DRAW_MASK_CUR_CURVE = %d DRAW_MASK_CUR_ROI = %d\n",
           DRAW_MASK_CUR_CURVE,DRAW_MASK_CUR_ROI))
     PRT1(printf("num_masks = %d roi_mask = %u curve_mask = %u\n",
        win->data.num_draw_masks,
           &(win->data.draw_masks[DRAW_MASK_CUR_ROI]), &(win->data.draw_masks[DRAW_MASK_CUR_CURVE])))
     return DrawCurRoiRec(
            &(win->control.sroi.sroi_win->slice_roi),
            win->control.sroi.localto,
            &(win->data.draw_masks[DRAW_MASK_CUR_ROI]),
            &(win->data.draw_masks[DRAW_MASK_CUR_CURVE]),1);}
   else if ((pen = get_cur_pen(&(win->control.sroi.sroi_win->slice_roi))) != NULL)
    if ((cur_curve = get_cur_curve(&(win->control.sroi.sroi_win->slice_roi)))
            != NULL)
       return DrawCurveRec(
                   &(win->data.draw_masks[DRAW_MASK_CUR_CURVE]),
                   cur_curve,win->control.sroi.localto,pen->pen_type);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_draw_cur_roi_rec - ???
--------------------------------------------------------------------------*/

void
win_draw_cur_roi_rec(win)
 struct image_display_window *win;
{
 int is_polygon;

 if (win->control.display_options & DISPLAY_FILLED_ROI) is_polygon = 1;
   else is_polygon = 0;
 DrawCurRoiRec(&(win->control.sroi.sroi_win->slice_roi),
            win->control.sroi.localto,
            &(win->data.draw_masks[DRAW_MASK_CUR_ROI]),
            &(win->data.draw_masks[DRAW_MASK_CUR_CURVE]),is_polygon);
}


/*--------------------------------------------------------------------------
GetRoiMask - ???
--------------------------------------------------------------------------*/

int
GetRoiMask(slice_roi,localto,dimx,dimy,mask,affected,option,image_view_roi)
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *localto;
 long dimx,dimy;
 struct draw_mask_rec *mask;
 struct int_bound_rec *affected;
 int option;
 struct roi_rec *image_view_roi;
{
 struct curve_2d_rec *pen;
 struct roi_rec *roi;
 int err,yes;

 if ((err = get_draw_mask_rec(mask,dimx,dimy)) != NO_ERROR)
    {return err;}
 if (option == CUR_CURVE)
    {TRACE(printf("GetRoiMask...1\n"))
     if (!is_cur_curve_non_empty(slice_roi))
        {if (affected != NULL) setup_int_bound_rec(affected,1,1,0,0);
         return NO_ERROR;}
     TRACE(printf("GetFilledCurveMask...2\n"))
     if ((pen = get_cur_pen(slice_roi)) != NULL)
        err = GetFilledCurveMask(get_cur_curve(slice_roi),localto,
               pen->pen_type,mask,affected);
     TRACE(printf("GetFilledCurveMask...3\n"))
    }
   else if ((option == CUR_ROI) || (option == IMAGE_FILTER_ROI))
    {yes = 1;
     if (option == CUR_ROI)
        {if ((roi = get_cur_roi(slice_roi)) == NULL) yes = 0;
        }
       else if ((roi = image_view_roi) == NULL) yes = 0;
     if (!yes || !is_roi_non_empty(roi))
        {
         if (affected != NULL) setup_int_bound_rec(affected,1,1,0,0);
         return NO_ERROR;}
     err = GetFilledRoiMask(roi,localto,mask,affected);
    }
   else if (option == ALL_ROIS)
    {PRT3(printf("ALL_ROIS...\n"))
     if (!is_slice_roi_non_empty(slice_roi))
        {
         if (affected != NULL) setup_int_bound_rec(affected,1,1,0,0);
         return NO_ERROR;}
     PRT3(printf("ALL_ROIS...localto = %u\n",localto))
     GetFilledAllRoisMask(slice_roi,localto,mask);
     PRT3(printf("ALL_ROIS...1\n"))
     if (affected != NULL) setup_int_bound_rec(affected,0,0,
              mask->mask._2d.dimx - 1,mask->mask._2d.dimy - 1);
    }

 return err;
}


/*--------------------------------------------------------------------------
GetRegionMask - ???

option & 1 - rois 
option & 2 + rois
option & 4 then whole
option & 8 then - overlapped regions
option & 0x00000010 then + overlapped regions
--------------------------------------------------------------------------*/

int
GetRegionMask(slice_roi,localto,dimx,dimy,
              mask,affected,option,roi_labels,is_mask_dirty)
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *localto;
 long dimx,dimy;
 struct draw_mask_rec *mask;
 struct int_bound_rec *affected;
 struct strs_rec *roi_labels;
 unsigned long option;
 int *is_mask_dirty;
{
 unsigned long lcv;
 struct draw_mask_rec mask1;
 struct buf_2d_rec overlap,ormask;
 struct roi_rec *roi;
 unsigned long opt;
 int err,first,is_empty;

 PRT2(printf("GetRegionMask option = %x\n",option))
 *is_mask_dirty = 0;
 if ((err = get_draw_mask_rec(mask,dimx,dimy)) != NO_ERROR)
    return err;
 opt = option;
 if (opt & 0x00000009) opt &= 0xfffffff7;
 if (opt & 0x00000012) opt &= 0xffffffef;
 if ((opt & 1) && (opt & 2)) opt &= 0xfffffffc;
 if ((opt & 8) && (opt & 0x00000010)) opt &= 0xffffffe7;

 PRT2(printf("GetRegionMask opt = %x\n",opt))
 if (opt == 0) return NO_ERROR;
 if (opt & 4)
    {InitBuf2dRecData(&(mask->mask._2d),(double) 1.0);
     *is_mask_dirty = 1;
     if (!(option & 9))
        {if (affected != NULL) 
            setup_int_bound_rec(affected,0,0,mask->mask._2d.dimx - 1,
                   mask->mask._2d.dimy - 1);
         return NO_ERROR;}
    }
 init_draw_mask_rec(&mask1);
 init_buf_2d_rec(&ormask);
 if (((err = get_draw_mask_rec(&mask1,dimx,dimy)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&ormask,dimx,dimy,1,1)) != NO_ERROR))
    {free_draw_mask_rec(&mask1);
     return err;}

 init_buf_2d_rec(&overlap);
 if (opt & 0x00000018)
    if ((err = SetupBuf2dRec(&overlap,dimx,dimy,1,1)) != NO_ERROR)
       {free_draw_mask_rec(&mask1);
        free_buf_2d_rec(&ormask);
        return err;}
 for (first = 1,lcv = 0; lcv < roi_labels->num_strs; lcv++)
    {if (((roi = get_roi(slice_roi,roi_labels->strs[lcv])) != NULL) &&
         is_roi_non_empty(roi))
        {
         if ((err = GetFilledRoiMask(roi,localto,&mask1,NULL)) != NO_ERROR)
            break;
         if ((opt & 0x00000018) && !first)
            OrAndBitmaps(&overlap,&ormask,&(mask1.mask._2d));
           else first = 0;
         OrBitmaps(&ormask,&ormask,&(mask1.mask._2d));
        }
    }
 if (!first && (err == NO_ERROR))
    {*is_mask_dirty = 1;
     if (opt & 0x00000001)
        {NotBitmap(&ormask,&ormask);
         AndBitmaps(&(mask->mask._2d),&(mask->mask._2d),&ormask);}
       else if (opt & 0x00000002)
        OrBitmaps(&(mask->mask._2d),&(mask->mask._2d),&ormask);

     if (opt & 0x00000008)
        {NotBitmap(&overlap,&overlap);
         AndBitmaps(&(mask->mask._2d),&(mask->mask._2d),&overlap);}
       else if (opt & 0x00000010)
        OrBitmaps(&(mask->mask._2d),&(mask->mask._2d),&overlap);
     if (affected != NULL) 
        FindBitmapBound(&(mask->mask._2d),affected,&is_empty);
     mask->paint_status |= PAINTED;
    }
 free_draw_mask_rec(&mask1);
 free_buf_2d_rec(&overlap);
 free_buf_2d_rec(&ormask);
 return err;
}


/*--------------------------------------------------------------------------
Get1DRegionMask - ???

option & 1 - rois 
option & 2 + rois
option & 4 then whole
option & 8 then - overlapped regions
option & 0x00000010 then + overlapped regions
--------------------------------------------------------------------------*/

int
Get1DRegionMask(slice_roi,localto,dimx,
                mask,affected,option,roi_labels,is_mask_dirty)
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *localto;
 long dimx;
 struct draw_mask_rec *mask;
 struct int_bound_rec *affected;
 struct strs_rec *roi_labels;
 unsigned long option;
 int *is_mask_dirty;
{
 unsigned long lcv,cnt;
 struct buf_2d_rec mask1,overlap,ormask;
 struct roi_rec *roi;
 unsigned long opt;
 int err,first,is_empty;
 long minx,maxx,miny,maxy;

 PRT2(printf("GetRegionMask option = %x\n",option))
 *is_mask_dirty = 0;
 if ((err = get_draw_mask_rec(mask,dimx,1)) != NO_ERROR)
    return err;
 opt = option;
 if (opt & 0x00000009) opt &= 0xfffffff7;
 if (opt & 0x00000012) opt &= 0xffffffef;
 if ((opt & 1) && (opt & 2)) opt &= 0xfffffffc;
 if ((opt & 8) && (opt & 0x00000010)) opt &= 0xffffffe7;

 PRT2(printf("Get1DRegionMask opt = %x\n",opt))
 if (opt == 0) return NO_ERROR;
 if (opt & 4)
    {InitBuf2dRecData(&(mask->mask._2d),(double) 1);
     *is_mask_dirty = 1;
     if (!(option & 9))
        {if (affected != NULL) 
            setup_int_bound_rec(affected,0,0,mask->mask._2d.dimx - 1,
                   mask->mask._2d.dimy - 1);
         return NO_ERROR;}
    }
 init_buf_2d_rec(&mask1);
 init_buf_2d_rec(&ormask);
 /* FIXME:  Changed init_buf_2d_rec to SetupBuf2dRec in the line
    below, without truly understanding the code.  -PWH 19990301 */
 if (((err = SetupBuf2dRec(&mask1, dimx,1,1,0)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&ormask,dimx,1,1,1)) != NO_ERROR))
    {free_buf_2d_rec(&mask1);
     return err;}

 init_buf_2d_rec(&overlap);
 if (opt & 0x00000018)
    if ((err = SetupBuf2dRec(&overlap,dimx,1,1,1)) != NO_ERROR)
       {free_buf_2d_rec(&mask1);
        free_buf_2d_rec(&ormask);
        return err;}
 for (first = 1,lcv = 0; lcv < roi_labels->num_strs; lcv++)
    {if (((roi = get_roi(slice_roi,roi_labels->strs[lcv])) != NULL) &&
         is_roi_non_empty(roi))
        {if ((err = FindRoiLongMinMax(roi,localto,&minx,&maxx,&miny,&maxy,0,0,1))
              != NO_ERROR)
            break;
         if (minx < 0) minx = 0;
         if (minx <= maxx)
            {if (maxx >= dimx) maxx = dimx - 1;
             if (minx <= maxx)
                {for (cnt = 0; cnt < minx; cnt++)
                    mask1.SetVal(&mask1,0,cnt,(double) .0);
                 for (cnt = minx; cnt <= maxx; cnt++)
                    mask1.SetVal(&mask1,0,cnt,(double) 1);
                 for (cnt = maxx; cnt < dimx; cnt++)
                    mask1.SetVal(&mask1,0,cnt,(double) .0);
                 if ((opt & 0x00000018) && !first)
                    OrAndBitmaps(&overlap,&ormask,&mask1);
                   else first = 0;
                 OrBitmaps(&ormask,&ormask,&mask1);}
             }
         }
    }
 if (!first && (err == NO_ERROR))
    {*is_mask_dirty = 1;
     if (opt & 0x00000001)
        {NotBitmap(&ormask,&ormask);
         AndBitmaps(&(mask->mask._2d),&(mask->mask._2d),&ormask);}
       else if (opt & 0x00000002)
        OrBitmaps(&(mask->mask._2d),&(mask->mask._2d),&ormask);

     if (opt & 0x00000008)
        {NotBitmap(&overlap,&overlap);
         AndBitmaps(&(mask->mask._2d),&(mask->mask._2d),&overlap);}
       else if (opt & 0x00000010)
        OrBitmaps(&(mask->mask._2d),&(mask->mask._2d),&overlap);
     if (affected != NULL) 
        FindBitmapBound(&(mask->mask._2d),affected,&is_empty);
     mask->paint_status |= PAINTED;
    }
 free_buf_2d_rec(&mask1);
 free_buf_2d_rec(&overlap);
 free_buf_2d_rec(&ormask);
 return err;
}
