/****************************************************************************
draw_line_to_screen.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: draw_line_to_screen.c,v 1.12 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/cms.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT4(x)
#define PRT2(x)
#define PRT3(x)
#define PRT5(x)
#define PRT6(x)
#define PRT7(x)



/* Functions defined in this file */
int win_show_screen_bound(struct image_display_window *win);
int multiple_win_show_screen_bound(struct image_display_window *win);
int WinDrawWinCurLine(struct image_display_window *win, int use_start_pt,
    unsigned long start_pt, unsigned long num_pts, int is_erase,
    int is_display, struct coord_rec *coords, struct coord_rec *coords1);
int win_is_same_win_unit(struct image_display_window *win,
    struct image_display_window *win1);
int WinDrawCurLine(struct image_display_window *win, int use_start_pt,
    unsigned long start_pt, unsigned long num_pts, int is_erase,
    int is_display);
int WinListProcessCurLine(struct image_display_window *win,
    struct image_display_window *linkfrom_win, int use_start_pt,
    unsigned long start_pt, unsigned long num_pts, int is_erase, int select,
    struct list_rec *cur_list);
int WinDrawCurrentLine(struct image_display_window *win, int use_start_pt,
    unsigned long start_pt, unsigned long num_pts, int is_erase,
    int is_display);
int paint_cur_region_to_screen_by_coord_rec(struct image_display_window *win,
    int which_mask, struct coord_rec *coords, int is_erase,
    int is_cur_win_only);
int win_draw_cur_curve_to_screen(struct image_display_window *win,
    int is_erase, int is_display, int is_cur_win_only);
int win_draw_roi_to_screen(struct image_display_window *win,
    struct roi_rec *roi, int roi_mask, int cur_curve_mask, int is_erase,
    int is_display, int is_cur_win_only);
int win_draw_cur_roi_to_screen(struct image_display_window *win, int is_erase,
    int is_display, int is_cur_win_only);
int win_draw_all_rois_to_screen(struct image_display_window *win, int is_erase,
    int is_display, int is_cur_win_only);



/*--------------------------------------------------------------------------
win_show_screen_bound - ???
--------------------------------------------------------------------------*/

int
win_show_screen_bound(win)
 struct image_display_window *win;
{
 int left,top,right,bottom;
 struct display_win_rec *dwin;

 dwin = win->dwin;
 TRACE(printf("win_show_screen_bound win = %u\n",win);)
 if (dwin->display_status & WIN_SHOW_SCREEN_BOUND)
    {
     TRACE(printf(" l = %d t = %d r = %d b = %d\n",dwin->show_screen_bound.left,
            dwin->show_screen_bound.top,dwin->show_screen_bound.right,
            dwin->show_screen_bound.bottom);)
     left = bufx_to_screenx(&(dwin->screen),dwin->show_screen_bound.left);
     right = bufx_to_screenx(&(dwin->screen),dwin->show_screen_bound.right);
     right = right - left + dwin->screen.pixel.mask.dimx;
     top = bufy_to_screeny(&(dwin->screen),dwin->show_screen_bound.top);
     bottom = bufy_to_screeny(&(dwin->screen),dwin->show_screen_bound.bottom);
     bottom = bottom - top + dwin->screen.pixel.mask.dimy;
     dwin->display_status &= ~WIN_SHOW_SCREEN_BOUND;
     TRACE(printf("win_show_screen_bound l = %d t = %d w = %d h = %d\n",left,
            top,right,bottom);)
     dshow_buf(dwin,left,top,right,bottom);
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
multiple_win_show_screen_bound - ???
--------------------------------------------------------------------------*/

int
multiple_win_show_screen_bound(win)
 struct image_display_window *win;
{
 return win_execute_proc_to_multiple_wins(win,win_show_screen_bound,0,0,0,0,0);
}


/*--------------------------------------------------------------------------
WinDrawWinCurLine - ???

 if (is_erase != 0) then erase the line
 if (is_display) then display the result to the screen
--------------------------------------------------------------------------*/

int
WinDrawWinCurLine(win,use_start_pt,start_pt,num_pts,is_erase,is_display,
                  coords,coords1)
 struct image_display_window *win;
 unsigned long start_pt,num_pts;
 int use_start_pt,is_erase,is_display;
 struct coord_rec *coords,*coords1;
{
 int may_have_common,is_add_cur;
 struct curve_rec *curve;
 struct curve_2d_rec *pen;
 unsigned int num_real_color_indxs;
 unsigned long *real_color_indxs;
 Cms cms;
 unsigned int cnt;
 struct slice_roi_rec *slice_roi;
 struct draw_mask_rec *actual_draw_masks[10],*cur_mask;
 unsigned int num_masks,value;
 unsigned long total_pts_drawn,start_pt1,start_pt2,num_pts1;
 struct float_bound_rec fl_bound;
 long left,top,right,bottom;

 if (num_pts == 0) return NO_ERROR;
 win->control.num_display_cur_pts = 0;
 win_get_cur_slice_roi_rec(win,&slice_roi,NULL);
 if ((pen = get_cur_pen(slice_roi)) == NULL) return CANCEL;
 if ((curve = (struct curve_rec *) get_cur_curve(slice_roi)) == NULL) return CANCEL;

 if ((num_pts1 = win_num_cur_curve_pts(win)) == 0) return NO_ERROR;
 if (use_start_pt)
    {start_pt2 = start_pt;
     if (start_pt2 >= num_pts1) return NO_ERROR;}
   else
    {if (num_pts >= num_pts1) start_pt2 = 0;
       else start_pt2 = num_pts1 - num_pts;}

 PRT(printf("\nWinDrawCurLine..num_pts = %d num_pts1 = %d is_erase = %d is_display = %d\n",
         num_pts,num_pts1,is_erase,is_display))
 is_add_cur = 0;
 if ((num_pts1 <= num_pts) ||
     (pen->pen_type & DRAW_CIRCLE_OR_ELLIPSE_OR_RECT))
    {may_have_common = 0;
     start_pt1 = 0;}
   else
    {if ((num_pts1 > 1) && !(pen->pen_type & DRAW_POINT))
        {start_pt1 = start_pt2 - 1;
         is_add_cur = 1;
         if ((start_pt1 + num_pts) > num_pts1)
            num_pts1 = num_pts1 - start_pt1 + 1;
           else num_pts1 = num_pts + 1;}
       else
        {start_pt1 = start_pt2;
         if ((start_pt1 + num_pts) > num_pts1)
            num_pts1 = num_pts1 - start_pt1 + 1;
           else num_pts1 = num_pts;}
     may_have_common = 1;
    }
 PRT(printf("start_pt = %d start_pt2 = %d is_add_cur = %d start_pt1 = %d num_pts1 = %d\n",start_pt,start_pt2,is_add_cur,start_pt1,num_pts1))
 PRT4(printf("WinDrawCurLine...is_erase = %d is_display = %d start_pt2 = %d num_pts1 = %d\n",is_erase,is_display,start_pt1,num_pts1))

 if (is_erase) value = 0;
   else value = 1;
 if (win->dwin->frame_canvas.canvas != 0)
    cms = (Cms) xv_get(win->dwin->frame_canvas.canvas,WIN_CMS);
   else cms = (Cms) xv_get(win->dwin->frame,WIN_CMS);
 real_color_indxs = (unsigned long *) xv_get(cms,CMS_INDEX_TABLE);
 num_real_color_indxs = xv_get(cms,CMS_SIZE);

 win_get_actual_draw_masks(win,actual_draw_masks,10,
                &num_masks,win->data.draw_masks,win->data.num_draw_masks,1);
 cur_mask = actual_draw_masks[0];
 DrawInBuf(cur_mask->mask._2d.buf,0,0,cur_mask->mask._2d.dimx - 1,
       cur_mask->mask._2d.dimy - 1,cur_mask->mask._2d.pixel_depth,
       &(curve->xys[start_pt1]),num_pts1,
       (unsigned int) pen->pen_type,&(curve->matrix),
       (int) (curve->status & CURVE_MATRIX_IN_USE),
       value,coords,&total_pts_drawn,win->control.sroi.localto);

 TRACE(printf("WinDrawCurLine..1...5\n"))
 if (value) cur_mask->paint_status |= PAINTED;
 if (is_erase)
    {if (may_have_common)
        {
         fl_bound = curve->fl_bound;
         FindCurveLongMinMax(curve,win->control.sroi.localto,
                    &left,&right,&top,&bottom,pen->pen_type,
                    1,start_pt1,1);
         PRT2(printf("start_pt1 = %d l = %d t = %d r = %d b = %d\n",start_pt1,
              left,top,right,bottom))
         curve->fl_bound = fl_bound;
         if (is_add_cur) start_pt1 += 1;
         PRT2(printf("start_pt1 = %d num_pts1 = %d\n",start_pt1,num_pts1))
         DrawInBuf(NULL,left,top,right,bottom,
           cur_mask->mask._2d.pixel_depth,
           &(curve->xys[0]),start_pt1,
           (unsigned int) pen->pen_type,&(curve->matrix),
           (int) (curve->status & CURVE_MATRIX_IN_USE),
           1,coords1,&total_pts_drawn,win->control.sroi.localto);
         exclude_common_coords(coords,coords1);
        }
     PRT2(printf("is_erase may_have_common = %d.....num_pts = %d num_pts1 = %d\n",
              may_have_common,coords->num_pts,coords1->num_pts))
     cur_mask->paint_status &= ~PAINT_SUPERIMPOSE;
     cur_mask->paint_status |= PAINT_ERASE;
     ErasePtFromScreenBuf(&(win->dwin->screen),coords,
                 &(win->data),actual_draw_masks,num_masks,
                 real_color_indxs,num_real_color_indxs,
                 1 + win->intensity->color.num_system_colors,
                 &(win->dwin->show_screen_bound),&(win->dwin->display_status));
    }
   else 
    draw_pt_to_screen_buf(&(win->dwin->screen),coords,
        (int) cur_mask->pixel_value,
        real_color_indxs,num_real_color_indxs,
        &(win->dwin->show_screen_bound),&(win->dwin->display_status));


 TRACE(printf("WinDrawCurLine...2\n"))
 if (win->num_display_wins > 1)
    for (cnt = 0; cnt < win->num_display_wins; cnt++)
       if (win->dwin != win->dwins[cnt])
          {if (is_erase)
              ErasePtFromScreenBuf(&(win->dwins[cnt]->screen),
                           coords,&(win->data),
                           actual_draw_masks,num_masks,
                           real_color_indxs,num_real_color_indxs,
                           1 + win->intensity->color.num_system_colors,
                           &(win->dwins[cnt]->show_screen_bound),
                           &(win->dwins[cnt]->display_status));
              else
               draw_pt_to_screen_buf(&(win->dwins[cnt]->screen),
                       coords,(int) cur_mask->pixel_value,
                       real_color_indxs,num_real_color_indxs,
                           &(win->dwins[cnt]->show_screen_bound),
                           &(win->dwins[cnt]->display_status));
          }
 if (is_erase)
    {cur_mask->paint_status &= ~PAINT_ERASE;
     cur_mask->paint_status |= PAINT_SUPERIMPOSE;}
        
 if (is_display)
    {win_execute_proc_to_multiple_wins(win,win_show_screen_bound,0,0,0,0,0);
     if (is_erase)
        {win->control.num_display_cur_pts = start_pt1;
         win->control.must_display = 1;}
       else win->control.num_display_cur_pts = start_pt1 + num_pts1;}
   else 
    {win->control.num_display_cur_pts = start_pt1;
     win->control.must_display = 1;}

 PRT4(printf("WinDrawCurLine...end..must_display = %d\n",win->control.must_display))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_is_same_win_unit - ???
--------------------------------------------------------------------------*/

int
win_is_same_win_unit(win,win1)
 struct image_display_window *win,*win1;
{
 struct img_buf_rec *img,*img1;
 struct unit_2d_rec unit,unit1;
 struct matrix_2d_rec *mat,*mat1;
 struct data_info_rec *info;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return 0;
 if ((img1 = win_rec_cur_img_buf(win1->owner)) == NULL) return 0;
 if (!(img->unit.status2 & UNIT_2D_IN_USE) &&
     !(img1->unit.status2 & UNIT_2D_IN_USE))
    {PRT5(printf("win_is_same_win_unit...1\n"))
     if (img->file == img1->file) return 1;}
 if (!(img->unit.status2 & UNIT_2D_IN_USE))
    {info = &(img->file->hdr.data_info);
     setup_unit_2d_rec(&unit,.0,.0,info->xpixel_size,info->ypixel_size,
            info->dimx,info->dimy,.0,.0,info->xpixel_size,info->ypixel_size);
     mat = &(unit.tolocal_mat);}
   else mat = win->control.sroi.tolocal;

 if (!(img1->unit.status2 & UNIT_2D_IN_USE))
    {info = &(img1->file->hdr.data_info);
     setup_unit_2d_rec(&unit1,.0,.0,info->xpixel_size,info->ypixel_size,
            info->dimx,info->dimy,.0,.0,info->xpixel_size,info->ypixel_size);
     mat1 = &(unit.tolocal_mat);}
   else mat1 = win1->control.sroi.tolocal;
 PRT5(printf("win_is_same_win_unit...2\n"))

 return is_same_matrix_2d_rec(mat,mat1);
}





/*--------------------------------------------------------------------------
 - ???

  if (is_erase != 0) then erase the line
  if (is_display) then display the result to the screen
--------------------------------------------------------------------------*/

int
WinDrawCurLine(win,use_start_pt,start_pt,num_pts,is_erase,is_display)
     struct image_display_window *win;
     unsigned long start_pt,num_pts;
     int use_start_pt,is_erase,is_display;
{
  struct coord_rec coords,coords1;
  struct image_display_window *nextwin,*cur_win;
  struct draw_mask_rec *actual_draw_masks[10],*cur_mask;
  unsigned int num_masks;
  unsigned int lcv,next;
  int is_more,err;
  unsigned int num_real_color_indxs;
  unsigned long *real_color_indxs;
  Cms cms;


  init_coord_rec(&coords);
  init_coord_rec(&coords1);
  PRT5(printf("WinDrawCurLine...win = %u\n",win));
  if (((err = WinDrawWinCurLine(win,use_start_pt,start_pt,num_pts,
				is_erase,is_display,
				&coords,&coords1)) == NO_ERROR) &&
      (win->control.sroi.sroi_win->num_wins > 1))
  {
    for (lcv = 0; lcv < win->control.sroi.sroi_win->num_wins;lcv++)
    {
      win->control.sroi.sroi_win->wins[lcv]->process_status4 &=
	~WIN_PROCESSED;
    }
    win->process_status4 |= WIN_PROCESSED;
    cur_win = win;
    next = 0;
    is_more = 1;
    while (is_more)
    {
      for (is_more = 0,lcv = next;
	   lcv < win->control.sroi.sroi_win->num_wins;
	   lcv++)
      {
	nextwin = win->control.sroi.sroi_win->wins[lcv];
	if (cur_win == nextwin)
	  continue;
	if (nextwin->process_status4 & WIN_PROCESSED)
	  continue;

	if (win_is_same_win_unit(cur_win,nextwin))
	{
	  PRT5(printf("win_is_same_win_unit...nextwin = %u\n",nextwin));
	  win_get_actual_draw_masks(nextwin,actual_draw_masks,10,
				    &num_masks,nextwin->data.draw_masks,
				    nextwin->data.num_draw_masks,1);
	  cur_mask = actual_draw_masks[0];
	  if (!(win->control.display_options & DISPLAY_BREAKER))
	  {
	    copy_buf_2d_rec_content(
				    &(nextwin->data.draw_masks[DRAW_MASK_CUR_CURVE].mask._2d),
				    &(cur_win->data.draw_masks[DRAW_MASK_CUR_CURVE].mask._2d));
	    nextwin->data.draw_masks[DRAW_MASK_CUR_CURVE].paint_status |= 
	      PAINTED;
	  }

	  if (nextwin->dwin->frame_canvas.canvas != 0)
	    cms = (Cms) xv_get(nextwin->dwin->frame_canvas.canvas,WIN_CMS);
	  else
	    cms = (Cms) xv_get(nextwin->dwin->frame,WIN_CMS);
	  real_color_indxs = (unsigned long *) xv_get(cms,CMS_INDEX_TABLE);
	  num_real_color_indxs = xv_get(cms,CMS_SIZE);

	  if (is_erase)
	  {
	    TRACE(printf("WinDrawCurLine.....4...nextwin = %u\n",nextwin));
	    if ((nextwin->control.display_options & DISPLAY_BREAKER) ||
		!(win->control.display_options & DISPLAY_BREAKER))
	    {
	      cur_mask->paint_status &= ~PAINT_SUPERIMPOSE;
	      cur_mask->paint_status |= PAINT_ERASE;
	    }

	    ErasePtFromScreenBuf(&(nextwin->dwin->screen),
				 &coords,&(nextwin->data),
				 actual_draw_masks,num_masks,
				 real_color_indxs,num_real_color_indxs,
				 1 + win->intensity->color.num_system_colors,
				 &(nextwin->dwin->show_screen_bound),
				 &(nextwin->dwin->display_status));
	  }

	  else 
	    draw_pt_to_screen_buf(&(nextwin->dwin->screen),&coords,
				  (int) cur_mask->pixel_value,
				  real_color_indxs,num_real_color_indxs,
				  &(nextwin->dwin->show_screen_bound),
				  &(nextwin->dwin->display_status));
	  nextwin->process_status4 |= WIN_PROCESSED;
	  if (is_display)
	    win_execute_proc_to_multiple_wins(nextwin,win_show_screen_bound,
					      0,0,0,0,0);
	}

	else if (!is_more)
	{
	  next = lcv;
	  is_more = 1;
	}
      }	/* for () */

      if (is_more)
      {
	PRT5(printf("is_more...next = %d\n",next););
	cur_win = win->control.sroi.sroi_win->wins[next];
	cur_win->process_status4 |= WIN_PROCESSED;
	coords.num_pts = 0;
	coords1.num_pts = 0;
	WinDrawWinCurLine(cur_win,use_start_pt,start_pt,num_pts,
			  is_erase,is_display,&coords,&coords1);
      }

    } /* while (is_more) */

  }

  free_coord_rec(&coords);
  free_coord_rec(&coords1);
  return err;
}



/*--------------------------------------------------------------------------
WinListProcessCurLine - ???

making sure that the 2 cur curves are the same
if select & 1 then is_display
if select & 2 then no display
if select & 4 then next curve
if select & 8 then delete cur num_pts
--------------------------------------------------------------------------*/

int
WinListProcessCurLine(win,linkfrom_win,use_start_pt,start_pt,num_pts,
                      is_erase,select,cur_list)
 struct image_display_window *win,*linkfrom_win;
 unsigned long start_pt,num_pts;
 int use_start_pt,is_erase,select;
 struct list_rec *cur_list;
{
 int err,is_match_longer;
 struct file_register_rec *co;
 struct slice_roi_rec *slice_roi,*slice_roi1;
 struct curve_rec result,*curve,*cur_curve;
 char *label,*label1;
 unsigned long num_xys,startpt;
 struct img_buf_rec *img,*img1;
 struct matrix_2d_rec *mat;

 PRT6(printf("linkfrom_win = %u wid = %s win = %u wid = %s cur_list = %u\n",
        linkfrom_win,linkfrom_win->owner->wid,win,win->owner->wid,cur_list->item))
 PRT5(printf("WinListProcessCurLine...use = %d stpt = %d num_pts = %d is_erase = %d select = %x\n",
      use_start_pt,start_pt,num_pts,is_erase,(unsigned long) select))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((img1 = win_rec_cur_img_buf(linkfrom_win->owner)) == NULL) return CANCEL;
 if (((err = win_get_cur_slice_roi_rec(linkfrom_win,&slice_roi,&label)) != NO_ERROR) ||
     ((err = win_get_cur_slice_roi_rec(win,&slice_roi1,&label1)) != NO_ERROR))
    return err;
 PRT3(printf("WinListProcessCurLine...2\n"))
 if ((curve = get_cur_curve(slice_roi)) == NULL) return NO_ERROR;
 init_curve_rec(&result);
 if ((co = (struct file_register_rec *) cur_list->item1) == NULL)
    mat = NULL;
   else
    {mat = &(co->coregxyztoregxyz);
     PRT7(printf("WinListProcessCurLine mat\n"))
     PRT7(pr_2d_matrix(mat))}
 if ((err = NewMappedCurve(&result,curve,NULL/*linkfrom_win->control.sroi.localto*/,
            mat)) != NO_ERROR)
    return err;
 
 cur_curve = get_cur_curve(slice_roi1);
 if (linkfrom_win->control.pen_type != win->control.pen_type)
    {PRT5(printf("WinListProcessCurLine...win_change_cur_curve_pen\n"))
     win_change_cur_curve_pen(win,linkfrom_win->control.pen_type);
     PRT5(printf("...win_change_cur_curve_pen...\n"))}

 if ((err = MatchCurve(cur_curve,NULL/*win->control.sroi.localto */,&result,NULL,
        .001,&num_xys,&is_match_longer)) != NO_ERROR)
    {PRT3(printf(" not match result.num_xys = %d\n",result.num_xys))
     err = JoinCurveToSliceRoiRec(slice_roi1,label,
                 (unsigned short) result.status & DRAW_MODE,&result,1,1,
                 1,1.0,1.0,NULL /*win->control.sroi.tolocal*/,
                 NULL /*win->control.sroi.localto*/,NULL);
     PRT3(printf("after  JoinCurveToSliceRoiRec\n"))
     cur_curve = get_cur_curve(slice_roi1);
     if (is_curve_non_empty(cur_curve))
        if (str_cmp(label,label1) == 0)
           {PRT3(printf(" win_display_cur_roi !!!\n"))
            if (!(select & 2)) win_display_cur_roi(win);}
          else 
           {PRT3(printf(" win_display_all_curves !!!\n"))
            if (!(select & 2)) win_display_all_curves(win);}
    }
   else
    {
     PRT3(printf(" match !!! is_match_longer = %d num_xys = %d cnum_xys = %d\n",
             is_match_longer,num_xys,cur_curve->num_xys))
     if (is_match_longer < 0)
        {num_xys = cur_curve->num_xys - num_xys;
         if (!(select & 2)) WinDrawCurLine(win,0,0,num_xys,1,1);
         WinDeleteCurPts(win,0,0,num_xys);
        }
       else if (is_match_longer > 0)
        {if (num_xys > 0) startpt = num_xys - 1;
           else startpt = 0;
         if ((err = JoinCurveRec(cur_curve,&result,1,startpt,
                   &(slice_roi1->status),1.0,1.0,NULL/*win->control.sroi.tolocal*/,
                   NULL/*win->control.sroi.localto*/,NULL)) == NO_ERROR)
            {num_xys = result.num_xys - num_xys;
             if (!(select & 2)) WinDrawCurLine(win,0,0,num_xys,0,1);}
        }
     PRT3(printf("num_xys = %d cnum_xys = %d st = %x\n",
             num_xys,cur_curve->num_xys,
              (unsigned long) (cur_curve->status & DRAW_MODE)))
    }
 free_curve_rec(&result);
 if (err == NO_ERROR) 
    {
     if (!(select & 2))
        WinDrawCurLine(win,use_start_pt,start_pt,num_pts,is_erase,select & 1);
     if (select & 8)
        {PRT5(printf("WinListProcessCurLine...WinDeleteCurPts\n"))
         WinDeleteCurPts(win,use_start_pt,start_pt,num_pts);}
     if (select & 4)
        {next_curve(slice_roi1,1);
         curve = get_cur_curve(slice_roi1);
         PRT5(printf("  cur_curve = %u  next = %u\n",cur_curve,curve))
         if ((curve != cur_curve) && (curve != NULL))
            {win_display_cur_roi(win);
             win_set_pt_status(win);
            }
        }
    }
 PRT3(printf("WinListProcessCurLine...err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
WinDrawCurrentLine - ???
--------------------------------------------------------------------------*/

int
WinDrawCurrentLine(win,use_start_pt,start_pt,num_pts,is_erase,is_display)
 struct image_display_window *win;
 unsigned long start_pt,num_pts;
 int use_start_pt,is_erase,is_display;
{
 int err;

 PRT3(printf("WinDrawCurrentLine..win = %u use = %d stpt = %d num_pts = %d is_erase = %d is_display = %d\n",win,
      use_start_pt,start_pt,num_pts,is_erase,is_display))
 err = WinDrawCurLine(win,use_start_pt,start_pt,num_pts,is_erase,is_display);
 if ((err == NO_ERROR) && (win->draw_list.item != NULL))
    err = WinRunProcInList(WIN_DRAW_LIST,win,WinListProcessCurLine,
                win,use_start_pt,start_pt,num_pts,is_erase,is_display);
 return err;
}


/*--------------------------------------------------------------------------
paint_cur_region_to_screen_by_coord_rec - ???
--------------------------------------------------------------------------*/

int
paint_cur_region_to_screen_by_coord_rec(win,which_mask,coords,is_erase,is_cur_win_only)
 struct image_display_window *win;
 int which_mask;
 struct coord_rec *coords;
 int is_erase,is_cur_win_only;
{
 int num_draw_masks;
 struct draw_mask_rec *actual_draw_masks[10];
 unsigned int num_masks;
 struct display_win_rec *dwin;
 struct image_display_window *nextwin;
 unsigned int num_real_color_indxs;
 unsigned long *real_color_indxs;
 Cms cms;
 unsigned int lcv,cnt,indx;
 long val;

 num_draw_masks = win->data.num_draw_masks;
 win_get_actual_draw_masks(win,actual_draw_masks,10,
          &num_masks,win->data.draw_masks,
          num_draw_masks,0);
 for (lcv = 0; lcv < win->control.sroi.sroi_win->num_wins;lcv++)
     if (win == win->control.sroi.sroi_win->wins[lcv]) break;
 nextwin = win;
 if (is_erase) val = 0;
   else val = 1;
 for (cnt = 0; cnt < win->control.sroi.sroi_win->num_wins; cnt++)
    {nextwin = win->control.sroi.sroi_win->wins[lcv];

     if (nextwin->dwin->frame_canvas.canvas != 0)
        cms = (Cms) xv_get(nextwin->dwin->frame_canvas.canvas,WIN_CMS);
       else cms = (Cms) xv_get(nextwin->dwin->frame,WIN_CMS);

     real_color_indxs = (unsigned long *) xv_get(cms,CMS_INDEX_TABLE);
     num_real_color_indxs = xv_get(cms,CMS_SIZE);
     if (!is_cur_win_only && (nextwin != win))
        {set_buf_by_coord_rec(
                   &(win->data.draw_masks[which_mask].mask._2d),coords,val);
         if (val) win->data.draw_masks[which_mask].paint_status |= PAINTED;}
     for (indx = 0; indx < nextwin->num_display_wins; indx++)
        {dwin = nextwin->dwins[indx];
         if (is_erase)
            ErasePtFromScreenBuf(&(dwin->screen),coords,
                &(nextwin->data),actual_draw_masks,num_masks,
                real_color_indxs,num_real_color_indxs,
                1 + win->intensity->color.num_system_colors,
                &(dwin->show_screen_bound),&(dwin->display_status));
           else 
            draw_pt_to_screen_buf(&(dwin->screen),coords,
                 (int) nextwin->data.draw_masks[which_mask].pixel_value,
                  real_color_indxs,num_real_color_indxs,
                 &(dwin->show_screen_bound),&(dwin->display_status));
        }

     if (is_cur_win_only) break;
     lcv = (lcv + 1) % win->control.sroi.sroi_win->num_wins;
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_draw_cur_curve_to_screen - ???
--------------------------------------------------------------------------*/

int
win_draw_cur_curve_to_screen(win,is_erase,is_display,is_cur_win_only)
 struct image_display_window *win;
 int is_erase,is_display,is_cur_win_only;
{
 struct coord_rec coords;
 struct curve_rec *curve;
 struct curve_2d_rec *pen;
 long val;
 struct slice_roi_rec *slice_roi;
 unsigned long total_pts_drawn;

 TRACE(printf("win_draw_cur_curve_to_screen..is_erase = %d is_display = %d\n",
         is_erase,is_display))
 win_get_cur_slice_roi_rec(win,&slice_roi,NULL);
 if ((pen = get_cur_pen(slice_roi)) == NULL) return NO_ERROR;
 curve = (struct curve_rec *) get_cur_curve(slice_roi);
 if (curve->num_xys == 0) return NO_ERROR;
 init_coord_rec(&coords);

 TRACE(printf("win_draw_cur_curve_to_screen...4\n"))
 if (is_erase) val = 0;
   else val = 1;
 DrawInBuf(win->data.draw_masks[DRAW_MASK_CUR_CURVE].mask._2d.buf,0,0,
              win->data.draw_masks[DRAW_MASK_CUR_CURVE].mask._2d.dimx - 1,
              win->data.draw_masks[DRAW_MASK_CUR_CURVE].mask._2d.dimy - 1,
              win->data.draw_masks[DRAW_MASK_CUR_CURVE].mask._2d.pixel_depth,
              curve->xys,(unsigned long) curve->num_xys,
              (unsigned int) pen->pen_type,&(curve->matrix),
              (int) (curve->status & CURVE_MATRIX_IN_USE),
              val,&coords,&total_pts_drawn,win->control.sroi.localto);
 TRACE(printf("win_draw_cur_curve_to_screen..2\n"))
 if (is_erase)
     win->data.draw_masks[DRAW_MASK_CUR_CURVE].paint_status |= PAINT_ERASE;
 if (coords.num_pts > 0)
    {if (!is_erase) win->data.draw_masks[DRAW_MASK_CUR_CURVE].paint_status |= PAINTED;
     paint_cur_region_to_screen_by_coord_rec(win,DRAW_MASK_CUR_CURVE,&coords,
                is_erase,is_cur_win_only);}

 TRACE(printf("win_draw_cur_curve_to_screen..3\n"))
 if (is_erase)
    win->data.draw_masks[DRAW_MASK_CUR_CURVE].paint_status |= PAINT_SUPERIMPOSE;

 if (coords.num_pts == 0)
    if (is_display) is_display = 0;
 free_coord_rec(&coords);

 if (is_display)
    if (is_cur_win_only) 
       return win_execute_proc_to_multiple_wins(win,win_show_screen_bound,
						0,0,0,0,0);
    else win_execute_proc_to_related_wins(win,multiple_win_show_screen_bound,
					  0,0);

 TRACE(printf("win_draw_cur_curve_to_screen..end\n"))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_draw_roi_to_screen - ???
--------------------------------------------------------------------------*/

int
win_draw_roi_to_screen(win,roi,roi_mask,cur_curve_mask,is_erase,
                       is_display,is_cur_win_only)
 struct image_display_window *win;
 struct roi_rec *roi;
 int roi_mask,cur_curve_mask;
 int is_erase,is_display;
{
 struct coord_rec coords,coords1,*the_coord;
 struct curve_rec *curve;
 struct curve_2d_rec *pen;
 long val;
 unsigned long total_pts_drawn;
 unsigned long lcv,cnt;

 TRACE(printf("win_draw_roi_to_screen..roi_mask = %d cur_curve_mask = %d is_erase = %d is_display = %d\n",
    roi_mask,cur_curve_mask,is_erase,is_display))
 if (!is_roi_non_empty(roi)) return NO_ERROR;

 init_coord_rec(&coords);
 init_coord_rec(&coords1);

 TRACE(printf("win_draw_roi_to_screen..1...4\n"))
 if (is_erase) val = 0;
   else val = 1;
 for (lcv = 0; lcv < roi->num_pens; lcv++)
    {pen = roi->pens[lcv];
     for (cnt = 0; cnt < pen->num_curves; cnt++)
        {curve = pen->curves[cnt];
         if (curve->num_xys > 0)
            {if ((lcv == roi->cur_pen) && (cnt == pen->cur_curve))
                the_coord = &coords1;
               else the_coord = &coords;
             DrawInBuf(win->data.draw_masks[roi_mask].mask._2d.buf,0,0,
              win->data.draw_masks[roi_mask].mask._2d.dimx - 1,
              win->data.draw_masks[roi_mask].mask._2d.dimy - 1,
              win->data.draw_masks[roi_mask].mask._2d.pixel_depth,
              curve->xys,(unsigned long) curve->num_xys,
              (unsigned int) pen->pen_type,&(curve->matrix),
              (int) (curve->status & CURVE_MATRIX_IN_USE),
              val,the_coord,&total_pts_drawn,win->control.sroi.localto);
             if (the_coord == (struct coord_rec *) &coords1)
                {win->control.num_display_cur_pts = curve->num_xys;
                 set_buf_by_coord_rec(
                   &(win->data.draw_masks[cur_curve_mask].mask._2d),&coords1,val);
                }
            }
        }
    }
 TRACE(printf("win_draw_roi_to_screen..5...coords.num_pts = %d\n",coords.num_pts))
 if (is_erase)
    win->data.draw_masks[cur_curve_mask].paint_status |= PAINT_ERASE;
   else
    if ((coords1.num_pts > 0) || (coords.num_pts > 0))
       win->data.draw_masks[roi_mask].paint_status |= PAINTED;
 if (coords1.num_pts > 0)
    {
     if (!is_erase) win->data.draw_masks[cur_curve_mask].paint_status |= PAINTED;
     paint_cur_region_to_screen_by_coord_rec(win,cur_curve_mask,&coords1,
                       is_erase,is_cur_win_only);}
 if (is_erase)
    win->data.draw_masks[roi_mask].paint_status |= PAINT_ERASE;
 TRACE(printf("win_draw_roi_to_screen..6...paint_status = %x\n",(unsigned long) win->data.draw_masks[roi_mask].paint_status);)
 if (coords.num_pts > 0)
    {/*find_coord_rec_min_max(&coords,&minx,&maxx,&miny,&maxy);
     printf("coords minx = %d maxx = %d miny = %d maxy = %d\n",minx,maxx,miny,maxy);*/
     paint_cur_region_to_screen_by_coord_rec(win,roi_mask,&coords,
                       is_erase,is_cur_win_only);}
 if (is_erase)
    {win->data.draw_masks[roi_mask].paint_status |= PAINT_SUPERIMPOSE;
     win->data.draw_masks[cur_curve_mask].paint_status |= PAINT_SUPERIMPOSE;}

 if ((coords1.num_pts == 0) && (coords.num_pts == 0))
    if (is_display) is_display = 0;
 TRACE(printf("win_draw_roi_to_screen..7...paint_status = %x\n",(unsigned long) win->data.draw_masks[roi_mask].paint_status);)

 free_coord_rec(&coords);
 free_coord_rec(&coords1);
 if (is_display)
    if (is_cur_win_only) 
       return win_execute_proc_to_multiple_wins(win,win_show_screen_bound,
						0,0,0,0,0);
    else win_execute_proc_to_related_wins(win,multiple_win_show_screen_bound,
					  0,0);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_draw_cur_roi_to_screen - ???
--------------------------------------------------------------------------*/

int
win_draw_cur_roi_to_screen(win,is_erase,is_display,is_cur_win_only)
 struct image_display_window *win;
 int is_erase,is_display,is_cur_win_only;
{
 struct roi_rec *roi;
 struct slice_roi_rec *slice_roi;

 win_get_cur_slice_roi_rec(win,&slice_roi,NULL);
 if ((roi = get_cur_roi(slice_roi)) != NULL)
    return win_draw_roi_to_screen(win,roi,DRAW_MASK_CUR_ROI,DRAW_MASK_CUR_CURVE,
                is_erase,is_display,is_cur_win_only);
   else return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_draw_all_rois_to_screen - ???
--------------------------------------------------------------------------*/

int
win_draw_all_rois_to_screen(win,is_erase,is_display,is_cur_win_only)
 struct image_display_window *win;
 int is_erase,is_display,is_cur_win_only;
{
 struct slice_roi_rec *slice_roi;
 unsigned long lcv;
 int err,yes;

 TRACE(printf("win_draw_all_rois_to_screen...is_erase = %d\n",is_erase);)
 win_get_cur_slice_roi_rec(win,&slice_roi,NULL);
 yes = 0;
 for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
    if (is_roi_non_empty(slice_roi->rois[lcv]))
       {yes = 1;
        if (lcv == slice_roi->cur_roi)
          {if ((err = win_draw_roi_to_screen(win,slice_roi->rois[lcv],DRAW_MASK_CUR_ROI,
               DRAW_MASK_CUR_CURVE,is_erase,0,is_cur_win_only)) != NO_ERROR)
              return err;}
         else 
          if ((err = win_draw_roi_to_screen(win,slice_roi->rois[lcv],
               DRAW_MASK_OTHER_ROIS,
               DRAW_MASK_OTHER_ROIS,is_erase,0,is_cur_win_only)) != NO_ERROR)
              return err;
       }
 if (yes && is_display)
    {if (is_cur_win_only) 
        win_execute_proc_to_multiple_wins(win,win_show_screen_bound,0,0,0,0,0);
    else
	win_execute_proc_to_related_wins(win,multiple_win_show_screen_bound,
					 0,0);
    }

 return NO_ERROR;
}
