/****************************************************************************
draw_mask_rec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: draw_mask_rec.c,v 1.10 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


#include "common.h"
#include "nria_lib.h"

#include "mri_format.h"
#include "nria_procedures.h"


/* Functions defined in this file */
void init_draw_mask_rec(struct draw_mask_rec *draw_mask);
void free_draw_mask_rec(struct draw_mask_rec *draw_mask);
int get_draw_mask_rec(struct draw_mask_rec *draw_mask,
    unsigned int dimx, unsigned int dimy);
void clear_draw_masks(struct draw_mask_rec *draw_masks,
    unsigned int num_draw_masks);
void set_paint_status(struct draw_mask_rec *draw_masks,
    unsigned int num_draw_masks, int paint_status);
void pr_draw_mask_rec(struct draw_mask_rec *draw_mask);
int cp_draw_mask_rec(struct draw_mask_rec *dst, struct draw_mask_rec *src);



/*--------------------------------------------------------------------------
init_draw_mask_rec - ???
--------------------------------------------------------------------------*/

void
init_draw_mask_rec(draw_mask)
 struct draw_mask_rec *draw_mask;
{
 init_mask_rec(&(draw_mask->mask));
 draw_mask->paint_status = PAINT_SUPERIMPOSE;
 draw_mask->pixel_value = 0;
}



/*--------------------------------------------------------------------------
free_draw_mask_rec - ???
--------------------------------------------------------------------------*/

void
free_draw_mask_rec(draw_mask)
 struct draw_mask_rec *draw_mask;
{
 free_mask_rec1(&(draw_mask->mask));
 init_draw_mask_rec(draw_mask);
}



/*--------------------------------------------------------------------------
get_draw_mask_rec - ???
--------------------------------------------------------------------------*/

int
get_draw_mask_rec(draw_mask,dimx,dimy)
 struct draw_mask_rec *draw_mask;
 unsigned int dimx,dimy;
{
 if (!(draw_mask->mask._2d.status4 & BUF_NON_EMPTY) ||
     (draw_mask->mask._2d.dimx != dimx) ||
     (draw_mask->mask._2d.dimy != dimy))
    {return SetupBuf2dRec(&(draw_mask->mask._2d),dimx,dimy,1,1);
    }
   else if (draw_mask->paint_status & PAINTED)
    {InitBuf2dRecData(&(draw_mask->mask._2d),(double) .0);
     draw_mask->paint_status &= ~PAINTED;
    }
 return NO_ERROR;
}



/*--------------------------------------------------------------------------
clear_draw_masks - ???
--------------------------------------------------------------------------*/

void
clear_draw_masks(draw_masks,num_draw_masks)
 struct draw_mask_rec *draw_masks;
 unsigned int num_draw_masks;
{
 unsigned int lcv;

 for (lcv = 0; lcv < num_draw_masks; lcv++)
    {
     if (!(draw_masks[lcv].paint_status & PAINT_MUST_NOT_ERASE))
        {if (draw_masks[lcv].paint_status & PAINTED)
            {InitBuf2dRecData(&(draw_masks[lcv].mask._2d),(double) .0);
             }
        }
     draw_masks[lcv].paint_status &= ~PAINTED;}
}



/*--------------------------------------------------------------------------
set_paint_status - ???
--------------------------------------------------------------------------*/

void
set_paint_status(draw_masks,num_draw_masks,paint_status)
 struct draw_mask_rec *draw_masks;
 unsigned int num_draw_masks;
 unsigned short paint_status;
{
 unsigned int lcv;

 for (lcv = 0; lcv < num_draw_masks; lcv++)
    {
     if (paint_status == PAINT_ERASE)
       {draw_masks[lcv].paint_status &= ~PAINT_SUPERIMPOSE;
        draw_masks[lcv].paint_status |= paint_status;}
      else if (paint_status == PAINT_SUPERIMPOSE)
       {draw_masks[lcv].paint_status &= ~PAINT_ERASE;
        draw_masks[lcv].paint_status |= paint_status;}
      else draw_masks[lcv].paint_status = paint_status;
    }
}



/*--------------------------------------------------------------------------
pr_draw_mask_rec - ???
--------------------------------------------------------------------------*/

void
pr_draw_mask_rec(draw_mask)
 struct draw_mask_rec *draw_mask;
{
 printf("   draw_mask = %p  status = %x ",
        draw_mask,draw_mask->paint_status);
 fflush(stdout);
 pr_buf_2d_rec(&(draw_mask->mask._2d));
 printf("total = %d....\n",
            CntNonValBuf2dRec(&(draw_mask->mask._2d),(double) 0));
 fflush(stdout);
}



/*--------------------------------------------------------------------------
cp_draw_mask_rec - ???
--------------------------------------------------------------------------*/

int
cp_draw_mask_rec(dst,src)
 struct draw_mask_rec *dst,*src;
{
 int err;

 if ((err = cp_mask_rec(&(dst->mask),&(src->mask))) != NO_ERROR)
    return err;
 dst->paint_status = src->paint_status;
 dst->pixel_value = src->pixel_value;
 return err;
}
