/****************************************************************************
draw_setting_rec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: draw_setting_rec.c,v 1.8 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


#include "mri_format.h"
#include "nria_procedures.h"


/* Functions defined in this file */
void init_input_pt_state(struct draw_setting_rec *control);
void init_win_slice_roi_rec(struct win_slice_roi_rec *sroi);
void init_draw_setting_rec1(struct draw_setting_rec *control,
    unsigned int dimx, unsigned int dimy);
void free_draw_setting_rec(struct draw_setting_rec *control,
    unsigned int dimx, unsigned int dimy);
void set_allowable_pen_types(struct draw_setting_rec *control,
    int allowable_pen_types);
void clear_allowable_pen_types(struct draw_setting_rec *control);
void set_max_input_curve_pts(struct draw_setting_rec *control,
    int max_input_pts);
void set_proc_upon_input_done(struct draw_setting_rec *control,
    int (*proc_upon_input_done)(), void *proc_arg);
void set_proc_upon_cursor_change(struct draw_setting_rec *control,
    int (*proc_upon_cursor_change)(), void *proc_arg);
void clear_max_input_curve_pts(struct draw_setting_rec *control);
void win_enable_draw_pen(struct image_display_window *win);



/*--------------------------------------------------------------------------
init_input_pt_state - ???
--------------------------------------------------------------------------*/

void
init_input_pt_state(control)
 struct draw_setting_rec *control;
{
 control->first_pt = EXPECT_FIRST_PT;
 control->must_display = 1;
 control->num_display_cur_pts = 0;
 control->last_command_key = 0;
 control->lastx = control->lasty = 0;
 control->last_cursorx = control->last_cursory = 0;
}


/*--------------------------------------------------------------------------
init_win_slice_roi_rec - ???
--------------------------------------------------------------------------*/

void
init_win_slice_roi_rec(sroi)
 struct win_slice_roi_rec *sroi;
{
 sroi->tolocal = NULL;
 sroi->localto = NULL;
 sroi->sroi_win = NULL;
}


/*--------------------------------------------------------------------------
init_draw_setting_rec1 - ???
--------------------------------------------------------------------------*/

void
init_draw_setting_rec1(control,dimx,dimy)
 struct draw_setting_rec *control;
 unsigned int dimx,dimy;
{
 control->status = 0;
 control->which_cursor = 0;
 control->pen_type = DRAW_FREE_CLOSED;
 control->allowable_pen_type = 0;
 control->display_options = 0;
 control->display_options |= DISPLAY_ENABLED_LABEL | DISPLAY_ROW_COL_LABEL |
                  DISPLAY_ACTION_LABEL;
 control->delete_roi = 0;

 init_input_pt_state(control);
 control->max_input_pts = 0;
 control->proc_upon_input_done = NULL;
 control->proc_arg = NULL;
 control->proc_upon_cursor_change = NULL;
 control->proc_upon_cursor_change_arg = NULL;

 init_win_slice_roi_rec(&(control->sroi));
 init_trans_roi_rec(&(control->trans));
}


/*--------------------------------------------------------------------------
free_draw_setting_rec - ???

FIXME!!  This function doesn't make any sense at all, given its name.
It only gets called once, and incorrectly at that.  -PWH 19990607
--------------------------------------------------------------------------*/

void
free_draw_setting_rec(control,dimx,dimy)
 struct draw_setting_rec *control;
 unsigned int dimx,dimy;
{
/*
 free_slice_roi_rec(&(control->temp_slice_roi));
 free_slice_roi_rec(&(control->non_member_slice_roi));
*/
 init_draw_setting_rec1(control,0,0);
}


/*--------------------------------------------------------------------------
set_allowable_pen_types - ???
--------------------------------------------------------------------------*/

void
set_allowable_pen_types(control,allowable_pen_types)
 struct draw_setting_rec *control;
 unsigned short allowable_pen_types;
{
 control->display_options |= SET_ALLOWABLE_PEN_TYPE;
 control->allowable_pen_type |= allowable_pen_types;
}


/*--------------------------------------------------------------------------
clear_allowable_pen_types - ???
--------------------------------------------------------------------------*/

void
clear_allowable_pen_types(control)
 struct draw_setting_rec *control;
{
 control->display_options &= ~SET_ALLOWABLE_PEN_TYPE;
}


/*--------------------------------------------------------------------------
set_max_input_curve_pts - ???
--------------------------------------------------------------------------*/

void
set_max_input_curve_pts(control,max_input_pts)
 struct draw_setting_rec *control;
{
 control->display_options |= SET_MAX_INPUT_PTS;
 control->max_input_pts = max_input_pts;
}


/*--------------------------------------------------------------------------
set_proc_upon_input_done - ???
--------------------------------------------------------------------------*/

void
set_proc_upon_input_done(control,proc_upon_input_done,proc_arg)
 struct draw_setting_rec *control;
 int (*proc_upon_input_done)();
 void *proc_arg;
{
 control->proc_upon_input_done = proc_upon_input_done;
 control->proc_arg = proc_arg;
}


/*--------------------------------------------------------------------------
set_proc_upon_cursor_change - ???
--------------------------------------------------------------------------*/

void
set_proc_upon_cursor_change(control,proc_upon_cursor_change,proc_arg)
 struct draw_setting_rec *control;
 int (*proc_upon_cursor_change)();
 void *proc_arg;
{
 control->proc_upon_cursor_change = proc_upon_cursor_change;
 control->proc_upon_cursor_change_arg = proc_arg;
}


/*--------------------------------------------------------------------------
clear_max_input_curve_pts - ???
--------------------------------------------------------------------------*/

void
clear_max_input_curve_pts(control)
 struct draw_setting_rec *control;
{
 control->display_options &= ~SET_MAX_INPUT_PTS;
}


/*--------------------------------------------------------------------------
win_enable_draw_pen - ???
--------------------------------------------------------------------------*/

void
win_enable_draw_pen(win)
 struct image_display_window *win;
{
 win->control.status |= DRAW_ENABLED;
 win_set_def_cursor(win);
}


 
