/****************************************************************************
draw_to_screen.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: draw_to_screen.c,v 1.9 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/cms.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRINT(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRINT(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT1(x)



/* Functions defined in this file */
void ddisplay_buf(struct display_win_rec *win, int left, int top, int right,
    int bottom, int is_display);
void win_get_actual_draw_masks(struct image_display_window *win,
    struct draw_mask_rec **actual_draw_masks,
    unsigned int total_actual_draw_masks, unsigned int *num_actual_draw_masks,
    struct draw_mask_rec *draw_masks, unsigned int num_draw_masks,
    int is_paint_cur_curve);
int paint_cur_curve_to_multiple_win(struct image_display_window *win,
    struct draw_mask_rec *draw_masks, unsigned int num_draw_masks,
    int is_paint_cur_win_only);
int paint_curves_to_multiple_win(struct image_display_window *win,
    struct draw_mask_rec *draw_masks, unsigned int num_draw_masks,
    int is_paint_cur_win_only);


/*---------------------------------------------------------------------------
ddisplay_buf - ???

FIXME:  Apparently never used.
---------------------------------------------------------------------------*/

void
ddisplay_buf(win,left,top,right,bottom,is_display)
 struct display_win_rec *win;
 int left,top,right,bottom,is_display;
{
 static int left1,top1,right1,bottom1;
 static char valid = 0;

 if (valid && (is_display != 3))
    {if (left1 > left) left1 = left;
     if (right1 < right) right1 = right;
     if (top1 > top) top1 = top;
     if (bottom1 < bottom) bottom1 = bottom;
    }
 if (is_display == 2)
    {if (!valid)
        {valid = 1;
         left1 = left;
         top1 = top; 
         right1 = right;
         bottom1 = bottom;}
    return /*NO_ERROR*/;
    }
   else 
    {if (valid)
        {valid = 0;
         left = left1;
         top = top1; 
         right = right1;
         bottom = bottom1;}
    }
 if (left < win->screen.dimension.bound.left)
    left = win->screen.dimension.bound.left;
 left = bufx_to_screenx(&(win->screen),left);

 if (right > win->screen.dimension.bound.right)
    right = win->screen.dimension.bound.right;
 right = bufx_to_screenx(&(win->screen),right);
 right = right - left + win->screen.pixel.mask.dimx;

 if (top < win->screen.dimension.bound.top)
    top = win->screen.dimension.bound.top;
 top = bufy_to_screeny(&(win->screen),top);

 if (bottom > win->screen.dimension.bound.bottom)
    bottom = win->screen.dimension.bound.bottom;
 bottom = bufy_to_screeny(&(win->screen),bottom);
 bottom = bottom - top + win->screen.pixel.mask.dimy;
 dshow_buf(win,left,top,right,bottom);
}



/*---------------------------------------------------------------------------
win_get_actual_draw_masks - ???
---------------------------------------------------------------------------*/

void
win_get_actual_draw_masks(win,actual_draw_masks,total_actual_draw_masks,
                 num_actual_draw_masks,
                 draw_masks,num_draw_masks,is_paint_cur_curve)
 struct image_display_window *win;
 struct draw_mask_rec **actual_draw_masks,*draw_masks;
 unsigned int total_actual_draw_masks,*num_actual_draw_masks,num_draw_masks;
 int is_paint_cur_curve;
{
 unsigned int cnt,lcv;
 struct draw_mask_rec *draw_mask;
 int last;

 if (win->control.display_options & DISPLAY_BREAKER)
    {actual_draw_masks[0] = win_rec_get_breaker_mask(win->owner);
     if (actual_draw_masks[0]->mask._2d.status4 & BUF_NON_EMPTY)
        {
         cnt = 1;}
       else
        {
         cnt = 0;}
    }
   else cnt = 0;
 for (lcv = 0; (lcv < num_draw_masks) && (cnt < total_actual_draw_masks);
                      cnt++,lcv++)
    actual_draw_masks[cnt] = &(draw_masks[lcv]);

 if (win->control.display_options & DISPLAY_CLIPBOARD)
    {actual_draw_masks[cnt] = win_rec_get_clipboard_mask(win->owner);
     if (actual_draw_masks[cnt]->mask._2d.status4 & BUF_NON_EMPTY)
        {
         if (win->control.display_options & DISPLAY_CLIPBOARD_FIRST)
            {draw_mask = actual_draw_masks[cnt];
             if (is_paint_cur_curve) last = 1;
               else last = 0;
             for (lcv = cnt; lcv > last; lcv--)
                actual_draw_masks[lcv] = actual_draw_masks[lcv - 1];
             actual_draw_masks[last] = draw_mask;}
         cnt++;
        }
    }
 *num_actual_draw_masks = cnt;
}



/*---------------------------------------------------------------------------
paint_cur_curve_to_multiple_win - ???
---------------------------------------------------------------------------*/

int
paint_cur_curve_to_multiple_win(win,draw_masks,num_draw_masks,is_paint_cur_win_only)
 struct image_display_window *win;
 struct draw_mask_rec *draw_masks;
 unsigned int num_draw_masks;
 int is_paint_cur_win_only;
{
 struct draw_mask_rec *actual_draw_masks[10];
 unsigned int lcv,num_masks;
 struct display_win_rec *dwin;
 int err;
 unsigned int num_real_color_indxs;
 unsigned long *real_color_indxs;
 Cms cms;


 TRACE(printf("paint_cur_curve_to_multiple_win...begin\n"))

 win_get_actual_draw_masks(win,actual_draw_masks,10,
                          &num_masks,draw_masks,num_draw_masks,1);
 cms = (Cms) xv_get(win->dwin->frame,WIN_CMS);
 TRACE(printf("paint_cur_curve_to_multiple_win cms= %ld\n",cms))
 real_color_indxs = (unsigned long *) xv_get(cms,CMS_INDEX_TABLE);
 num_real_color_indxs = xv_get(cms,CMS_SIZE);
 if ((err = PaintCurCurve(&(win->dwin->screen),actual_draw_masks,
      num_masks,&(win->data),real_color_indxs,num_real_color_indxs,
      1 + win->intensity->color.num_system_colors)) != NO_ERROR)
    return err;
 win->control.must_display = 0;
 win->control.num_display_cur_pts = win_num_cur_curve_pts(win);
 TRACE(printf("$$$paint_cur_curve_to_multiple_win cms= %ld\n",cms))
 if (!is_paint_cur_win_only && (win->num_display_wins > 1))
    {dwin = win->dwin;
     for (lcv = 0; lcv < win->num_display_wins; lcv++)
        {if ((dwin != win->dwins[lcv]) && (win->dwins[lcv] != NULL) &&
             (win->dwins[lcv]->screen._2d.status4 & BUF_NON_EMPTY) &&
             is_int_region_rect_intersect(&(dwin->screen.dimension),
                   &(win->dwins[lcv]->screen.dimension)))
           {win->dwin = win->dwins[lcv];

            if ((err = PaintCurCurve(&(win->dwin->screen),
                   actual_draw_masks,num_masks,&(win->data),
                    real_color_indxs,num_real_color_indxs,
                   1 + win->intensity->color.num_system_colors)) != NO_ERROR)
               return err;

           }
        }
     win->dwin = dwin;
    }
 return NO_ERROR;
}



/*---------------------------------------------------------------------------
paint_curves_to_multiple_win - ???
---------------------------------------------------------------------------*/

int
paint_curves_to_multiple_win(win,draw_masks,num_draw_masks,is_paint_cur_win_only)
 struct image_display_window *win;
 struct draw_mask_rec *draw_masks;
 unsigned int num_draw_masks;
 int is_paint_cur_win_only;
{
 unsigned int lcv,num_masks;
 struct display_win_rec *dwin;
 struct draw_mask_rec *actual_draw_masks[10];
 int err;
 unsigned int num_real_color_indxs;
 unsigned long *real_color_indxs;
 Cms cms;

 PRT1(printf("paint_curves_to_multiple_win...1\n"))
 PRT1(printf("paint_curves_to_multiple_win...2\n"))
 win_get_actual_draw_masks(win,actual_draw_masks,10,
                          &num_masks,draw_masks,num_draw_masks,0);
 PRT1(printf("paint_curves_to_multiple_win...3..win->dwin = %u\n",win->dwin);
     if (win->dwin != NULL)
        printf("canvas = %u frame = %u\n",win->dwin->frame_canvas.canvas,win->dwin->frame);
     )
/*
 if (win->dwin->frame_canvas.canvas != NULL)
    cms = (Cms) xv_get(win->dwin->frame_canvas.canvas,WIN_CMS);
   else
*/
 cms = (Cms) xv_get(win->dwin->frame,WIN_CMS);
 PRT1(printf("paint_curves_to_multiple_win num_masks = %d\n",num_masks))

 real_color_indxs = (unsigned long *) xv_get(cms,CMS_INDEX_TABLE);
 num_real_color_indxs = xv_get(cms,CMS_SIZE);
 PRT1(printf("paint_curves_to_multiple_win...4\n"))
 if ((err = PaintCurvesToScreen(&(win->dwin->screen),actual_draw_masks,
         num_masks,&(win->data),real_color_indxs,num_real_color_indxs,
      1 + win->intensity->color.num_system_colors)) != NO_ERROR)
    return err;

 PRT1(printf("####win = %u num_display_wins = %d\n",win,win->num_display_wins))
 win->control.must_display = 0;
 win->control.num_display_cur_pts = win_num_cur_curve_pts(win);
 PRT1(printf("#### 1 win = %u num_display_wins = %d\n",win,win->num_display_wins))

 if (!is_paint_cur_win_only && (win->num_display_wins > 1))
    {dwin = win->dwin;
     for (lcv = 0; lcv < win->num_display_wins; lcv++)
        {PRT1(printf("dwin = %u dwins[%d] = %u\n",dwin,lcv,win->dwins[lcv]))
         if ((dwin != win->dwins[lcv]) && (win->dwins[lcv] != NULL) &&
             (win->dwins[lcv]->screen._2d.status4 & BUF_NON_EMPTY) &&
             is_int_region_rect_intersect(&(dwin->screen.dimension),
                   &(win->dwins[lcv]->screen.dimension)))
           {win->dwin = win->dwins[lcv];
            PRT1(printf("paint_curves_to_multiple_win...6\n"))
            if ((err = PaintCurvesToScreen(&(win->dwin->screen),
                   actual_draw_masks,num_masks,&(win->data),
                    real_color_indxs,num_real_color_indxs,
                1 + win->intensity->color.num_system_colors)) != NO_ERROR)
               return err;
           }
        }
     win->dwin = dwin;
    }
 PRT1(printf("paint_curves_to_multiple_win...end\n"))
 return NO_ERROR;
}

/********************
show_buf_2d_rec(_2d,msg)
 struct buf_2d_rec *_2d;
 char *msg;
{
 struct image_display_window *win;
 struct draw_mask_rec *draw_masks[1];
 char *strs[1];

 if (image_win == NULL) return;
 win = image_win;
 win_refresh_screen_data(win);

 InitBuf2dRecData(&(win->data.draw_masks[DRAW_MASK_CUR_CURVE].mask._2d),
          (double) .0);
 superimpose_any_size_pixel_maps(&(win->data.draw_masks
          [DRAW_MASK_CUR_CURVE].mask._2d),_2d);

 win->data.draw_masks[DRAW_MASK_CUR_CURVE].paint_status |= PAINTED;
 draw_masks[0] = &(win->data.draw_masks[DRAW_MASK_CUR_CURVE]);
 paint_cur_curve_to_multiple_win(win,draw_masks,1,0);
 WinCanvas(win,1);
}

************************/
