/****************************************************************************
grow_region.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: grow_region.c,v 1.14 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT3(x)
#define PRT4(x)



#define CLEAN_UP_GROW_ROI_MAP 0
#define SETUP_GROW_ROI_MAP 1
#define GET_ALL_PT_PTR 2
#define TOTAL_PIXELS "#PIXELS = "

struct pt_to_region_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    long save_which_cursor;
    Frame frame;
    Panel panel;
    Panel_item use_pixel_values,xy,lb_ub_option,mean_sd,lb,ub,select_option,
               load_original,grow_region,grow_lb_ub,which_region,
               map,options,auto_map,total_pixels,label,add_to,mark_roi_delete;
    long x,y,val;
    double mean,sd;
   };

struct all_pt_to_region_recs
   {
    int num_pts;
    struct pt_to_region_rec **pts;
   };


/* Functions defined in this file */
void init_pt_to_region_rec(struct pt_to_region_rec *pt);
void free_pt_to_region_rec(struct pt_to_region_rec *pt);
void init_all_pt_to_region_recs(struct all_pt_to_region_recs *all_pts);
void pt_to_region_frame_done_proc(Frame frame);
void pt_use_which_value_proc(Panel_item item, int value, Event *event);
void pt_cursor_proc(Panel_item item, Event *event);
void show_pt_params(struct pt_to_region_rec *pt);
void get_grow_region_lb_ub(struct pt_to_region_rec *pt, int *lb, int *ub);
void set_pt_range_proc(Panel_item item, Event *event);
void pt_params(struct pt_to_region_rec *pt, int x, int y);
int pt_label_cur_roi_to_histo_roi_proc(struct pt_to_region_rec *pt,
    char *label);
int pt_map_proc(Panel_item item, Event *event);
int auto_map_proc(Frame frame, int which);
int mask_to_curve_rec_proc(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, struct curve_rec *pt_curve);
int MaskTo_curve_rec(struct buf_2d_rec *mask,
    struct int_bound_rec *bound_area, struct slice_roi_rec *slice_roi,
    char *roi_label);
int grow_the_region(struct pt_to_region_rec *pt);
int grow_region_proc(Panel_item item, Event *event);
void delete_grown_roi_proc(Panel_item item, Event *event);
void mark_roi_delete_proc(Panel_item item, int value, Event *event);
int setup_pt_to_region_rec(struct pt_to_region_rec *pt,
    struct image_display_window *win);
struct pt_to_region_rec *find_pt_to_region_rec(
   struct all_pt_to_region_recs *all_pts, struct image_display_window *win);
void update_pt_to_region(struct image_display_window *win, Event *event);
int setup_pt_to_region(struct image_display_window *win);


/* Private functions */
static struct all_pt_to_region_recs *enter_pt_to_region(
    struct image_display_window *win, int status);


/*--------------------------------------------------------------------------
init_pt_to_region_rec - ???
---------------------------------------------------------------------------*/

void
init_pt_to_region_rec(pt)
 struct pt_to_region_rec *pt;
{
 pt->status = 0;
 pt->win = NULL;
 pt->frame = 0;
}


/*--------------------------------------------------------------------------
free_pt_to_region_rec - ???
---------------------------------------------------------------------------*/

void
free_pt_to_region_rec(pt)
 struct pt_to_region_rec *pt;
{
 struct all_pt_to_region_recs *all_pts;

 TRACE(printf("free_pt_to_region_rec...pt->win->dwin = %u\n",pt->win->dwin))
 win_select_cursor(pt->win,pt->save_which_cursor);
 TRACE(printf("free_pt_to_region_rec...1\n"))
 if (pt->frame != 0)
    {xv_destroy_safe(pt->frame);
     pt->frame = 0;
    }
 c_free(pt);
 all_pts = enter_pt_to_region(NULL,GET_ALL_PT_PTR);
 DropHandleAryPtr(&(all_pts->pts),&(all_pts->num_pts),pt);
 TRACE(printf("free_pt_to_region_rec...end\n"))
}


/*--------------------------------------------------------------------------
init_all_pt_to_region_recs - ???
---------------------------------------------------------------------------*/

void
init_all_pt_to_region_recs(all_pts)
 struct all_pt_to_region_recs *all_pts;
{
 all_pts->num_pts = 0;
 all_pts->pts = NULL;
}


/*--------------------------------------------------------------------------
pt_to_region_frame_done_proc - ???
---------------------------------------------------------------------------*/

void
pt_to_region_frame_done_proc(frame)
 Frame frame;
{
 struct pt_to_region_rec *pt;

 pt = (struct pt_to_region_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_pt_to_region_rec(pt);
}


/*--------------------------------------------------------------------------
pt_use_which_value_proc - ???
---------------------------------------------------------------------------*/

void
pt_use_which_value_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct pt_to_region_rec *pt;
 int lb,ub,max;
 struct img_buf_rec *img;
 unsigned long first,num_colors;

 pt = (struct pt_to_region_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value)
    {win_first_and_num_colors(pt->win,&first,&num_colors);
     max = num_colors - 1;}
   else
    {if ((img = win_rec_cur_img_buf(pt->win->owner)) == NULL)
	return /*CANCEL*/;
     max = num_bit_values(img->_2d.pixel_depth);
    }
 lb = (int) xv_get(pt->lb,PANEL_VALUE);
 ub = (int) xv_get(pt->ub,PANEL_VALUE);
 make_int_in_range(&lb,0,max);
 make_int_in_range(&ub,0,max);
 xv_set(pt->lb,PANEL_MAX_VALUE,max,PANEL_VALUE,lb,0);
 xv_set(pt->ub,PANEL_MAX_VALUE,max,PANEL_VALUE,ub,0);
}


/*--------------------------------------------------------------------------
 pt_cursor_proc- ???
---------------------------------------------------------------------------*/

void
pt_cursor_proc(item,event)
 Panel_item item;
 Event *event;       /* Ignored */
{
 struct pt_to_region_rec *pt;

 pt = (struct pt_to_region_rec *) xv_get(item,PANEL_CLIENT_DATA);
 PRT4(printf("pt_cursor_proc...CURSOR_PT_SCAN win = %u pt->x  = %d pt->y = %d\n",
               pt->win,pt->x,pt->y))
 win_select_cursor(pt->win,CURSOR_PT_SCAN);
 win_move_mouse_to(pt->win,pt->x,pt->y);
}


/*--------------------------------------------------------------------------
show_pt_params - ???
---------------------------------------------------------------------------*/

void
show_pt_params(pt)
 struct pt_to_region_rec *pt;
{
 char str[100];

 sprintf(str,"Y/X/VALUE = %-ld/%-ld/%-ld",pt->y,pt->x,pt->val);
 xv_set(pt->xy,PANEL_LABEL_STRING,str,0);
 sprintf(str,"MEAN = %-.2f    SD = %-.2f",pt->mean,pt->sd);
 xv_set(pt->mean_sd,PANEL_LABEL_STRING,str,0);
 set_pt_range_proc(pt->lb_ub_option,NULL);
}


/*--------------------------------------------------------------------------
get_grow_region_lb_ub - ???
---------------------------------------------------------------------------*/

void
get_grow_region_lb_ub(pt,lb,ub)
 struct pt_to_region_rec *pt;
 int *lb,*ub;
{
 int lb2,ub2,lb1,ub1;
 long mean;

 lb2 = (int) xv_get(pt->lb,PANEL_VALUE);
 ub2 = (int) xv_get(pt->ub,PANEL_VALUE);
 if ((lb2 == 0) && (ub2 == 0))
    *lb = *ub = pt->val;
   else
    {mean = (long) rint((double) pt->mean);
     lb1 = mean - lb2;
     if (lb1 > (pt->val - lb2)) *lb = pt->val - lb2;
       else *lb = lb1;
     ub1 = mean + ub2;
     if (ub1 < (pt->val + ub2)) *ub = pt->val + ub2;
       else *ub = ub1;
    }
}


/*--------------------------------------------------------------------------
set_pt_range_proc - ???
---------------------------------------------------------------------------*/

void
set_pt_range_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct pt_to_region_rec *pt;
 char str[100];
 int lb,ub;

 pt = (struct pt_to_region_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((int) xv_get(item,PANEL_VALUE) == 0)
    {TRACE(printf("set_pt_range_proc...1\n"))
     xv_set(pt->lb,PANEL_VALUE,(long) rint((double) pt->sd),0);
     xv_set(pt->ub,PANEL_VALUE,(long) rint((double) pt->sd),0);}
   else if ((int) xv_get(item,PANEL_VALUE) == 1)
    {xv_set(pt->lb,PANEL_VALUE,0,0);
     xv_set(pt->ub,PANEL_VALUE,0,0);}
 get_grow_region_lb_ub(pt,&lb,&ub);

 sprintf(str,"%-d <= GROW ROI Range <= %-d",lb,ub);
 xv_set(pt->grow_lb_ub,PANEL_LABEL_STRING,str,0);
}


/*--------------------------------------------------------------------------
pt_params - ???
---------------------------------------------------------------------------*/

void
pt_params(pt,x,y)
 struct pt_to_region_rec *pt;
 int x,y;
{
 int is_color_data;
 struct img_buf_rec *img;
 struct buf_2d_rec *the_2d;
 long num_vals,lcv;
 double vals[9],*the_vals,val;
 struct color_data_rec *color_data;
 struct color_scale_rec *scale;
 unsigned long *color_indxs,num_color_indxs;
 int err;

 PRT4(printf("pt_params...x = %d y = %d\n",x,y))
 if ((img = win_rec_cur_img_buf(pt->win->owner)) == NULL)
     return /*CANCEL*/;
 if ((color_data = WinCurColorData(pt->win)) == NULL)
     return /*CANCEL*/;
 is_color_data = (int) xv_get(pt->use_pixel_values,PANEL_VALUE,0);
 TRACE(printf("pt_params.1..x = %d y = %d\n",x,y))
 if ((x < 0) || (y < 0) || (x >= img->_2d.dimx) ||
     (y >= img->_2d.dimy))
    return /*CANCEL*/;
 pt->x = x;
 pt->y = y;
 if (is_color_data)
    {
     the_2d = &(color_data->_2d);
     the_vals = vals;
     PRT4(pr_buf_2d_rec(the_2d))
     Get2dAreavalues(the_2d,x - 1,y - 1,x+1,y + 1,the_vals,9,&num_vals);
     PRT4(for (lcv = 0; lcv < num_vals; lcv++) printf("%d) %f\n",lcv,the_vals[lcv]);
         )

     if ((err = WinCurScaleAndColorIndxs(pt->win,NULL,&scale,
              &color_indxs,&num_color_indxs)) != NO_ERROR)
	 return /*CANCEL*/;
     for (lcv = 0; lcv < num_vals; lcv++)
        {pt->val = (long) rint((double) the_vals[lcv]);
         if (pt->val < num_color_indxs)
            {pt->val = color_indxs[pt->val];
             the_vals[lcv] = (double) pt->val;}
        }

     val = the_2d->GetVal(the_2d,y,x);
     pt->val = (long) rint((double) val);
     if (pt->val < num_color_indxs)
        pt->val = color_indxs[pt->val];
     PtsMeanAndSd(the_vals,num_vals,&(pt->mean),&(pt->sd));
    }
   else
    {the_2d = &(img->_2d);
     val = the_2d->GetVal(the_2d,y,x);
     pt->val = (long) rint((double) val);
     _2dPtMeanAndSd(the_2d,pt->y,pt->x,&(pt->mean),&(pt->sd));}
 TRACE(printf("pt_params.2..x = %d y = %d\n",x,y))

 show_pt_params(pt);
}


/*--------------------------------------------------------------------------
pt_label_cur_roi_to_histo_roi_proc - ???
---------------------------------------------------------------------------*/

int
pt_label_cur_roi_to_histo_roi_proc(pt,label)
 struct pt_to_region_rec *pt;
 char *label;
{
 int option;

 option = xv_get(pt->options,PANEL_VALUE) + 1;
 /* FIXME!!  Inserted the argument 0 below to placate the compiler,
    but this is probably not the right value.  -PWH 19990527 */
 return roi_to_histo_roi(pt->win,0,option,label,pt->frame);

}


/*--------------------------------------------------------------------------
pt_map_proc - ???
---------------------------------------------------------------------------*/

int
pt_map_proc(item,event)
 Panel_item item;
 Event *event;     /* Ignored */
{
 struct pt_to_region_rec *pt;
 int option;

 pt = (struct pt_to_region_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (next_cur_roi(&(pt->win->control.sroi.sroi_win->slice_roi),
                           GROW_ROI_LABEL) == NULL)
    {ShowMsgStrs(pt->frame,0,0,0,2,
          "Please grow the region first !!!",
          OPERATION_ABORTED,NULL,0);
     return NO_ERROR;}

 if ((int) xv_get(pt->label,PANEL_VALUE))
    {
     return setup_label_roi(pt->win,pt->frame,
                pt_label_cur_roi_to_histo_roi_proc,pt,NULL,NULL,
                "GROW ROI : LABEL - CUR ROI TO HISTO-ROI",
                (unsigned short) HISTOGRAM_WINDOW);
    }
   else
    {option = xv_get(pt->options,PANEL_VALUE) + 1;
     return roi_to_histo_roi(pt->win,NULL,option,HISTO_ROI,pt->frame);}
}


/*--------------------------------------------------------------------------
auto_map_proc - ???
---------------------------------------------------------------------------*/

int
auto_map_proc(frame,which)
 Frame frame;
 int which;
{
 struct pt_to_region_rec *pt;

 (void) notify_set_itimer_func((Notify_client) frame,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 pt = (struct pt_to_region_rec *) xv_get(frame,WIN_CLIENT_DATA);
 TRACE(printf("auto_map_proc...\n"))
 return pt_map_proc(pt->map,NULL);
}


/*--------------------------------------------------------------------------
mask_to_curve_rec_proc - ???
---------------------------------------------------------------------------*/

int
mask_to_curve_rec_proc(_2d,row,col,pt_curve)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 struct curve_rec *pt_curve;
{
 unsigned short status;

 return EnterCurveXY(pt_curve,(float) col,(float) row, &status,NULL,1,0,0);
}


/*--------------------------------------------------------------------------
MaskTo_curve_rec - ???
---------------------------------------------------------------------------*/

int
MaskTo_curve_rec(mask,bound_area,slice_roi,roi_label)
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound_area;
 struct slice_roi_rec *slice_roi;
 char *roi_label;
{
 struct curve_rec *pt_curve;
 struct roi_rec *roi;
 int err;

 PRT3(printf("MaskTo_curve_rec...\n"))
 if ((err = setup_curve_rec_ptr(&pt_curve,DRAW_POINT)) == NO_ERROR)
    {PRT3(printf("MaskTo_curve_rec...1\n"))
     if ((err = process_buf_2d_rec_by_mask(mask,0,0,mask,bound_area,
               mask_to_curve_rec_proc,pt_curve,0,0,0,0,0,0,0,0)) == NO_ERROR)
        {
         PRT3(printf("MaskTo_curve_rec...2..slice_roi = %u\n",slice_roi))
         if ((err = setup_more_rois(slice_roi,roi_label,1)) == NO_ERROR)
            {if ((roi = get_roi(slice_roi,roi_label)) != NULL) 
                {pt_curve->status |= CURVE_OR;
                 PRT3(printf("MaskTo_curve_rec...3\n"))
                 err = append_curve_to_roi_rec(roi,pt_curve,
                        (unsigned short) DRAW_POINT,1,
                        &(slice_roi->status));
                }
               else err = CANCEL;
           }
        }
     if (err != NO_ERROR)
        {free_curve_rec(pt_curve);
         c_free(pt_curve);}
    }
 PRT3(printf("MaskTo_curve_rec...err = %d\n",err))
 return err;
}



/*--------------------------------------------------------------------------
grow_the_region - ???
---------------------------------------------------------------------------*/

int
grow_the_region(pt)
 struct pt_to_region_rec *pt;
{
 struct buf_2d_rec mask,*the_2d,*the_2d1,color_2d,color_2d1;
 struct img_buf_rec *img;
 struct int_bound_rec bound_area;
 int err;
 int is_color_data,lb,ub;
 struct curve_rec *pt_curve;
 struct roi_rec *roi;
 char str[50];
 unsigned short status;
 int select_option,num_echoes;
 struct color_data_rec *color_data,*color_data1;
 struct image_display_window *win1;

 if ((img = win_rec_cur_img_buf(pt->win->owner)) == NULL) return CANCEL;
 if ((color_data = WinCurColorData(pt->win)) == NULL) return CANCEL;
 is_color_data = (int) xv_get(pt->use_pixel_values,PANEL_VALUE,0);
 xv_set(pt->total_pixels,PANEL_LABEL_STRING,TOTAL_PIXELS,0);
 TRACE(printf("grow_the_region...1\n"))

 init_buf_2d_rec(&color_2d);
 init_buf_2d_rec(&color_2d1);
 num_echoes = img->file->hdr.data_info.num_echoes;
 select_option = (int) xv_get(pt->select_option,PANEL_VALUE);
 if (is_color_data)
    {
     if ((err = copy_buf_2d_rec(&color_2d,&(color_data->_2d)))
                   != NO_ERROR)
        return err;
     WinMapActualColorData(pt->win,NULL,&color_2d);
     the_2d = &color_2d;
     if ((select_option == 1) && (num_echoes == 2))
        {if ((img->partner->win != NULL) && 
             ((win1 = img->partner->win->image_display) != NULL) &&
             ((color_data1 = WinCurColorData(win1)) == NULL))
            {
             if ((err = copy_buf_2d_rec(&color_2d1,&(color_data1->_2d)))
                        != NO_ERROR)
                {free_buf_2d_rec(&color_2d);
                 free_buf_2d_rec(&color_2d1);
                 return err;}
             WinMapActualColorData(img->partner->win->image_display,NULL,&color_2d1);
            }
           else
            {if ((err = copy_buf_2d_rec(&color_2d1,&(img->partner->_2d)))
                        != NO_ERROR)
                {free_buf_2d_rec(&color_2d);
                 free_buf_2d_rec(&color_2d1);
                 return err;}
             win_scale_color_2d(pt->win,&color_2d1,&color_2d1);
             WinMapActualColorData(pt->win,NULL,&color_2d1);
            }
         the_2d1 = &color_2d1;
        }            
       else the_2d1 = NULL;
    }    
   else
    {the_2d = &(img->_2d);
     if ((select_option == 1) && (num_echoes == 2))
        the_2d1 = &(img->partner->_2d);
       else the_2d1 = NULL;
    }

 TRACE(printf("grow_the_region...2\n"))
 init_buf_2d_rec(&mask);
 if ((err = SetupBuf2dRec(&mask,the_2d->dimx,the_2d->dimy,1,0)) == NO_ERROR)
    if (select_option == 0)
       {get_grow_region_lb_ub(pt,&lb,&ub);
        PRT4(printf("grow_the_region...GrowRegion\n"))
        PRT4(printf("Y = %d x = %d lb = %d ub = %d\n",pt->y,pt->x,lb,ub))
        err = GrowRegion(the_2d,pt->y,pt->x,
                   (double) lb,(double) ub,&mask,&bound_area);
        PRT4(printf("mask = %d\n",CntValBuf2dRec(&mask,(double) .0)))
       }
      else
       err = pt_polarity(the_2d,the_2d1,num_echoes,2,pt->y,pt->x,
               &mask,&bound_area,NULL,NULL);

 free_buf_2d_rec(&color_2d);
 free_buf_2d_rec(&color_2d1);

 if (err == NO_ERROR)
    {if ((err = setup_curve_rec_ptr(&pt_curve,DRAW_POINT)) == NO_ERROR)
        {PRT4(printf("setup_curve_rec_ptr...\n"))
         if ((err = process_buf_2d_rec_by_mask(&mask,0,0,&mask,&bound_area,
               mask_to_curve_rec_proc,pt_curve,0,0,0,0,0,0,0,0)) == NO_ERROR)
            {PRT4(printf("setup_more_rois...\n"))
             if ((err = setup_more_rois(
                   &(pt->win->control.sroi.sroi_win->slice_roi),
                    GROW_ROI_LABEL,1)) == NO_ERROR)
                {if ((roi = get_roi(
                       &(pt->win->control.sroi.sroi_win->slice_roi),
                       GROW_ROI_LABEL)) != NULL) 
                    {PRT4(printf("append_curves_to_roi_rec...\n"))
                     TRACE(pr_curve_rec(pt_curve))
                     pt_curve->status |= CURVE_OR;
                     err = append_curve_to_roi_rec(roi,pt_curve,
                        (unsigned short) DRAW_POINT,1,
                        &(pt->win->control.sroi.sroi_win->slice_roi.status));
                     TRACE(printf("append_curve_to_roi_rec...err = %d\n",err))
                     if (err == NO_ERROR)
                        {sprintf(str,"%s%ld",TOTAL_PIXELS, pt_curve->num_xys);
                         xv_set(pt->total_pixels,PANEL_LABEL_STRING,str,0);
                         if (xv_get(pt->mark_roi_delete,PANEL_VALUE))
                            {mark_roi_delete(roi,&status,1);
                             /*pt->win->control.sroi.sroi_win->slice_roi |=
                                      SLICE_ROI_MARK_DELETE;*/
                             pt->win->status4 |= WIN_ROI_MARK_DELETE;}
                         PRT4(printf("grow_the_region win_redisplay_all_curves\n"))
                         win_execute_proc_to_related_wins(pt->win,
                                          win_redisplay_all_curves,0,0);
                        }
                    }
                }
            }
         if (err != NO_ERROR)
            {free_curve_rec(pt_curve);
             c_free(pt_curve);}
        }
    }

 PRT4(printf("grow_the_region...6\n"))

 free_buf_2d_rec(&mask);
 return err;
}


/*--------------------------------------------------------------------------
grow_region_proc - ???
---------------------------------------------------------------------------*/

int
grow_region_proc(item,event)
 Panel_item item;
 Event *event;      /* Ignored */
{
 struct pt_to_region_rec *pt;
 int err;
 struct roi_rec *roi;

 pt = (struct pt_to_region_rec *) xv_get(item,PANEL_CLIENT_DATA);
if (!(int) xv_get(pt->add_to,PANEL_VALUE))
   if ((roi = get_roi(&(pt->win->control.sroi.sroi_win->slice_roi),
                       GROW_ROI_LABEL)) != NULL) 
      delete_roi(&(pt->win->control.sroi.sroi_win->slice_roi),roi);

 set_win_busy(pt->win);
 if ((err = grow_the_region(pt)) != NO_ERROR)
    ShowMsgStrs(pt->frame,0,err,0,2,
          "An error occurred when growing the region",
          OPERATION_ABORTED,NULL,0);
   else if ((int) xv_get(pt->auto_map,PANEL_VALUE))
    (void) notify_set_itimer_func((Notify_client)pt->frame,
             (Notify_func) auto_map_proc,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
 set_win_not_busy(pt->win);

 return err;
}

/***************
delete_grown_region_proc(item,event)
 Panel_item item;
 Event event;
{



}
*****************/


/*--------------------------------------------------------------------------
delete_grown_roi_proc - ???
---------------------------------------------------------------------------*/

void
delete_grown_roi_proc(item,event)
 Panel_item item;
 Event *event;      /* Ignored */
{
 struct pt_to_region_rec *pt;

 pt = (struct pt_to_region_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win_delete_roi_by_label(pt->win,GROW_ROI_LABEL);
}


/*--------------------------------------------------------------------------
mark_roi_delete_proc - ???
---------------------------------------------------------------------------*/

void
mark_roi_delete_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;   /* Ignored */
{
 struct pt_to_region_rec *pt;
 unsigned short status;
 struct roi_rec *roi;

 pt = (struct pt_to_region_rec *) xv_get(item,PANEL_CLIENT_DATA);
 roi = get_roi(&(pt->win->control.sroi.sroi_win->slice_roi),GROW_ROI_LABEL);
 if (value)
    {if (roi != NULL) mark_roi_delete(roi,&status,1);
     pt->win->status4 |= WIN_ROI_MARK_DELETE;
     /*pt->win->control.sroi.sroi_win->slice_roi |= SLICE_ROI_MARK_DELETE;*/
    }
   else
    {if (roi != NULL) mark_roi_delete(roi,&status,0);
     /*pt->win->control.sroi.sroi_win->slice_roi &= ~SLICE_ROI_MARK_DELETE;*/
     pt->win->status4 &= ~WIN_ROI_MARK_DELETE;}
}

/***************
pt_original_proc(item,event)
 Panel_item item;
 Event event;
{
 struct pt_to_region_rec *pt;
 struct display_win_rec *dwin;

 pt = (struct pt_to_region_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dwin = pt->win->dwin;
 pt->win->dwin = pt->dwin;
 WinNewImgMultiCanvas(pt->win);
 pt->win->dwin = dwin;
}

transition_map(pt)
 struct pt_to_region_rec *pt;
{
 struct buf_2d_rec *mask_2d,*the_2d,color_2d;
 int is_color_data,lb,ub,which_region;
 struct img_buf_rec *img;
 struct draw_mask_rec mask;
 struct int_bound_rec *bound_area,affected;
 struct color_data_rec *color_data;
 int err;

 if ((img = win_rec_cur_img_buf(pt->win->owner)) == NULL) return CANCEL;
 if ((color_data = WinCurColorData(pt->win)) == NULL) return CANCEL;
 which_region = (int) xv_get(pt->which_region,PANEL_VALUE);
 
 if (which_region)
    {init_draw_mask_rec(&mask);
     if ((err = GetRoiMask(&(pt->win->control.sroi.sroi_win->slice_roi),
         pt->win->control.sroi.localto,
         img->_2d.dimx,img->_2d.dimy,&mask,&affected,which_region,
         &(pt->win->image_view_roi))) != NO_ERROR)
        {
         return err;}
     mask_2d = &(mask.mask._2d);
     bound_area = &affected;
    }
   else
    {bound_area = NULL;
     mask_2d = NULL;}

 is_color_data = (int) xv_get(pt->use_pixel_values,PANEL_VALUE,0);
 
 err = NO_ERROR;
 if (is_color_data)
    {init_buf_2d_rec(&color_2d);
     if ((err = copy_buf_2d_rec(&color_2d,&(color_data->_2d)))
                   == NO_ERROR)
        {WinMapActualColorData(pt->win,NULL,&color_2d);
         the_2d = &color_2d;}
    }    
   else
    the_2d = &(img->_2d);
 if (err == NO_ERROR)
    {get_grow_region_lb_ub(pt,&lb,&ub);
     _2dTransitionMap(the_2d,(double) lb,(double) ub,mask_2d,bound_area);
    }
 if (mask_2d != NULL) free_draw_mask_rec(&mask);
 if (is_color_data)
    {err = copy_buf_2d_rec_content(&(img->_2d),the_2d);
     img->_2d.status &= ~BUF_MIN_MAX_SET;
     img->_2d.status &= ~BUF_MIN_MAX_COMPUTED;
     MinMax2d(&(img->_2d),0,(double) .0,(double) .0);
     free_buf_2d_rec(&color_2d);
    }    
 if (err == NO_ERROR) WinNewColorMultiCanvas(pt->win);

 return err;
}

transition_map_proc(item,event)
 Panel_item item;
 Event event;
{
 struct pt_to_region_rec *pt;
 struct img_buf_rec *img;
 int err;
 unsigned long first,num_colors;
 struct color_data_rec *color_data;

 pt = (struct pt_to_region_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(pt->win->owner)) == NULL) return CANCEL;
 if ((color_data = WinCurColorData(pt->win)) == NULL) return CANCEL;
 win_first_and_num_colors(pt->win,&first,&num_colors);
 err = NO_ERROR;
 if ((int) xv_get(pt->load_original,PANEL_VALUE))
    {TRACE(printf("transition_map_proc load_cur_slice...\n"))
     RdSlice(img,0,NULL,4);
     if ((int) xv_get(pt->use_pixel_values,PANEL_VALUE))
        if ((err = scale_2d(&(color_data->_2d),&(img->_2d),
                first,first + num_colors - 1,0,0,0)) != NO_ERROR)
           return err;
    }
 if ((err != NO_ERROR) || (err = transition_map(pt)) != NO_ERROR)
    ShowMsgStrs(pt->frame,0,err,0,2,
          "An error occurred when generating the transition map",
          OPERATION_ABORTED,NULL,0);
 return err;
}
*****************/


/*--------------------------------------------------------------------------
setup_pt_to_region_rec - ???
---------------------------------------------------------------------------*/

int
setup_pt_to_region_rec(pt,win)
 struct pt_to_region_rec *pt;
 struct image_display_window *win;
{
 char *str;
 int row,offset;
 Rect *rr;
 struct img_buf_rec *img;
 unsigned long first,num_colors;
 Panel_item item;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) 
    {free_pt_to_region_rec(pt);
     return CANCEL;}
 pt->win = win;
 pt->dwin = win->dwin;
 pt->save_which_cursor = win->control.which_cursor;
 pt->frame = xv_create(win->dwin->frame, FRAME,
              /*WIN_DYNAMIC_VISUAL,TRUE,*/
              FRAME_INHERIT_COLORS,TRUE,
              0);
 TRACE(printf("setup_pt_to_region_rec...1\n"))
 if (pt->frame == 0)
    {free_pt_to_region_rec(pt);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,GROW_REGION);
 xv_set(pt->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,pt_to_region_frame_done_proc,
              WIN_CLIENT_DATA,pt,
              0);
 c_free(str);
 TRACE(printf("ok111.,..."))
 pt->panel = xv_create(pt->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (pt->panel == 0)
    {free_pt_to_region_rec(pt);
     return CANCEL;}
 row = 2;
 offset = xv_rows(pt->panel,1) - xv_rows(pt->panel,0) - 10;
 pt->use_pixel_values = xv_create(pt->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"USE PIXEL VALUES",
                                "USE COLOR VALUES",NULL,
 	          PANEL_VALUE,0,
                  XV_X,5,XV_Y,row,
                  PANEL_NOTIFY_PROC,pt_use_which_value_proc,
                  PANEL_CLIENT_DATA,pt,
                  0);
 row += offset;
 item = xv_create(pt->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,"CURSOR",
        PANEL_NOTIFY_PROC,pt_cursor_proc,
        PANEL_CLIENT_DATA,pt,
        XV_X,5,XV_Y,row,
        0);
 pt->xy = xv_create(pt->panel,PANEL_MESSAGE,
        PANEL_CLIENT_DATA,pt,
        XV_Y,row,
        0);

 row += offset - 5;
 pt->select_option = xv_create(pt->panel,PANEL_CHOICE_STACK,
	          PANEL_LABEL_STRING,"SELECT BY",
                  PANEL_CHOICE_STRINGS,"RANGE : VALUE & MEAN & SD",
                                "POLARITY",NULL,
 	          PANEL_VALUE,0,
                  XV_X,5,XV_Y,row,
                  0);

 row += offset;
 pt->mean_sd = xv_create(pt->panel,PANEL_MESSAGE,
        PANEL_CLIENT_DATA,pt,
        XV_X,25,XV_Y,row,
        0);
 row += offset - 10;
 pt->lb_ub_option = xv_create(pt->panel,PANEL_CHOICE_STACK,
	          PANEL_LABEL_STRING,"AFTER POINT SCAN :",
                  PANEL_CHOICE_STRINGS,"LB = UB = SD",
                                "LB = UB = 0","LB or UB = SET",NULL,
 	          PANEL_VALUE,0,
                  XV_X,5,XV_Y,row,
                  PANEL_NOTIFY_PROC,set_pt_range_proc,
                  PANEL_CLIENT_DATA,pt,
                  0);

 row += offset;
 win_first_and_num_colors(pt->win,&first,&num_colors);
 pt->lb = xv_create(pt->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"LB :",
        XV_X,15,XV_Y,row,
	PANEL_VALUE,0,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,(int) num_colors - 1,
	PANEL_SLIDER_WIDTH,50,
	0);
 row += offset;
 pt->ub = xv_create(pt->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"UB :",
        XV_X,15,XV_Y,row,
	PANEL_VALUE,0,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,(int) num_colors - 1,
	PANEL_SLIDER_WIDTH,50,
	0);
 TRACE(printf("setup_pt_to_region_rec...4\n"))
 row += offset;
 pt->grow_lb_ub = xv_create(pt->panel,PANEL_MESSAGE,
                    XV_X,5,XV_Y,row,
                    0);
 row += offset - 5;
 str = "GROW ROI = MIDDLE BUTTON";
 pt->grow_region = xv_create(pt->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,str,
        PANEL_NOTIFY_PROC,grow_region_proc,
        PANEL_CLIENT_DATA,pt,
        XV_X,5,XV_Y,row,
        0);
/*
 row += offset;
 str = "DELETE GROWN-ROI = <Sh> MIDDLE BUTTON";
 xv_create(pt->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,str,
        PANEL_NOTIFY_PROC,delete_grown_region_proc,
        PANEL_CLIENT_DATA,pt,
        XV_X,15,XV_Y,row,
        0);
*/
 row += offset;
 str = "DELETE GROWN-ROI NOW - F11";
 pt->grow_region = xv_create(pt->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,str,
        PANEL_NOTIFY_PROC,delete_grown_roi_proc,
        PANEL_CLIENT_DATA,pt,
        XV_X,5,XV_Y,row,
        0);
 row += offset - 5;
 pt->mark_roi_delete = xv_create(pt->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"DELETE GROWN-ROI BEFORE NEXT SLICE",NULL,
        PANEL_VALUE,1,XV_X,15,XV_Y,row,
        PANEL_CLIENT_DATA,pt,
        PANEL_NOTIFY_PROC,mark_roi_delete_proc,
        0);

 row += offset;
 if (img->file->hdr.data_info.num_echoes == 2)
    pt->options = xv_create(pt->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,
                      "GROWN ROI -> HISTO-ROI POINTS",
                      "GROWN ROI -> HISTO-ROI - CONVEX ROI",
                      "GROWN ROI -> HISTO-ROI - RANGE ROI",
                      NULL,
                  PANEL_VALUE,0,
                  XV_X,15,XV_Y,row,
                  0);
   else
    pt->options = xv_create(pt->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,
                      "GROWN ROI -> HISTO-ROI",
                      NULL,
                  PANEL_VALUE,0,
                  XV_X,15,XV_Y,row,
                  0);
 row += offset;
 pt->add_to = xv_create(pt->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"ADD TO GROWN ROI",NULL,
        PANEL_VALUE,1,
        XV_X,5,XV_Y,row - 3,
        0);
 rr = (Rect *) xv_get(pt->add_to,XV_RECT);
 pt->total_pixels = xv_create(pt->panel,PANEL_MESSAGE,
                  PANEL_LABEL_STRING,TOTAL_PIXELS,
                  XV_X,rr->r_left + rr->r_width + 15,XV_Y,row,
                  0);
 row += offset - 5;
 pt->auto_map = xv_create(pt->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"AUTO",NULL,
        XV_X,5,XV_Y,row,
        PANEL_VALUE,0,
        0);
 rr = (Rect *) xv_get(pt->auto_map,XV_RECT);
 pt->map = xv_create(pt->panel,PANEL_BUTTON,
                  PANEL_LABEL_STRING,"MAP = <Sh> RIGHT BUTTON",
                  XV_X,rr->r_left + rr->r_width,XV_Y,row,
                  PANEL_CLIENT_DATA,pt,
                  PANEL_NOTIFY_PROC,pt_map_proc,
                  0);
 row += offset;
 pt->label = xv_create(pt->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"LABEL HISTO-ROI",NULL,
        PANEL_VALUE,0,XV_X,20,XV_Y,row,
        0);

 pt_params(pt,(pt->win->dwin->screen.dimension.bound.left + 
          pt->win->dwin->screen.dimension.bound.right) / 2,
              (pt->win->dwin->screen.dimension.bound.top + 
          pt->win->dwin->screen.dimension.bound.bottom) / 2);
/*
 row += offset + 5;
 TRACE(printf("ok333.,..."))
 str = "TRANSITION MAP ON";
 xv_create(pt->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,str,
        PANEL_NOTIFY_PROC,transition_map_proc,
        PANEL_CLIENT_DATA,pt,
        XV_X,5,XV_Y,row,
        0);
 pt->which_region = xv_create(pt->panel,PANEL_CHOICE_STACK,
        PANEL_CHOICE_STRINGS,WHOLE_SLICE_STR,CUR_CURVE_STR,
                CUR_ROI_STR,ALL_ROIS_STR,VIEW_FILTER_ROI_STR,NULL,
        PANEL_VALUE,0,
        XV_Y,row,
        0);

 str = "ORIGINAL";
 xv_create(pt->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,str,
                   PANEL_NOTIFY_PROC,pt_original_proc,
                   PANEL_CLIENT_DATA,pt,
                   0);
 row += offset;
 pt->load_original = xv_create(pt->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"LOAD ORIGINAL BEFORE TRANSITION MAP ON",NULL,
        PANEL_VALUE,1,
        XV_X,5,XV_Y,row,
        0);
*/

 window_fit(pt->panel);
 rr = (Rect *) xv_get(pt->panel,XV_RECT);
 xv_set(pt->panel,XV_WIDTH,rr->r_width - 10,XV_HEIGHT,rr->r_height - 10,0);
 window_fit(pt->frame);
 make_2_wins_adjacent(pt->frame,win->dwin->frame,0);
 win_set_mouse_at_center(pt->frame);
 xv_set(pt->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 pt_cursor_proc(item,NULL);

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
find_pt_to_region_rec - ???
---------------------------------------------------------------------------*/

struct pt_to_region_rec *
find_pt_to_region_rec(all_pts,win)
 struct all_pt_to_region_recs *all_pts;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_pts->num_pts; lcv++)
    if (all_pts->pts[lcv]->win == win)
       return all_pts->pts[lcv];
 return NULL;
}


/*--------------------------------------------------------------------------
update_pt_to_region - ???
---------------------------------------------------------------------------*/

void
update_pt_to_region(win,event)
 struct image_display_window *win;
 Event *event;
{
 struct all_pt_to_region_recs *all_pts;
 struct pt_to_region_rec *pt;
 int x,y,is_selected;

 TRACE(printf("update_pt_to_region...\n"))
 if ((all_pts = enter_pt_to_region(NULL,GET_ALL_PT_PTR)) != NULL)
    {TRACE(printf("update_pt_to_region...1\n"))
     if ((pt = find_pt_to_region_rec(all_pts,win)) != NULL)
        {TRACE(printf("update_pt_to_region...2\n"))
         if (event_middle_is_down(event))
            grow_region_proc(pt->grow_region, event);
           else if (event_right_is_down(event) && event_shift_is_down(event))
            pt_map_proc(pt->map, event);
           else if (event_left_is_down(event))
            if (event_shift_is_down(event))
               SelectCurve(win,event,0,1,&is_selected);
              else
               {if (dwin_get_coord_xy_from_event(pt->win->dwin,event,&x,&y)
                      == NO_ERROR)
                   pt_params(pt,x,y);}
        }
    }
}


/*------------------------------------------------------------------------
enter_pt_to_region - ???

NOTE: The pre-19990225 version of this function was called
enter_pt_to_region and would sometimes return a pointer and sometimes
an int, depending on the value of status.  I have split it into two
functions enter_pt_to_region and setup_pt_to_region to keep the
returned type straight.  I think that I have caught all the callers
and selected the right callee.  -PWH
------------------------------------------------------------------------*/

static struct all_pt_to_region_recs All_pts_to_region;
static char All_pts_first_time = 1;

int
setup_pt_to_region(
     struct image_display_window *win)
{
 struct pt_to_region_rec *pt;
 int err;

 if (All_pts_first_time)
    {init_all_pt_to_region_recs(&All_pts_to_region);
     All_pts_first_time = 0;}
 else
    {if ((pt = find_pt_to_region_rec(&All_pts_to_region,win)) != NULL)
        {
         xv_set(pt->frame,
                XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
         win_set_mouse_at_center(pt->frame);
         wmgr_top(pt->frame);
         return NO_ERROR;}
    }

 err = NO_ERROR;
 get_handle_memory(&(All_pts_to_region.pts),&(All_pts_to_region.num_pts),1,
     (size_t) sizeof(struct pt_to_region_rec),&err);
 if (err != NO_ERROR) return err;
 pt = All_pts_to_region.pts[All_pts_to_region.num_pts - 1];
 init_pt_to_region_rec(pt);
 if ((err = setup_pt_to_region_rec(pt,win)) != NO_ERROR)
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up",
               "   the PT DETECTION window !!!",NULL,0);
 return err;
}


/*--------------------------------------------------------------------------
enter_pt_to_region - ???
--------------------------------------------------------------------------*/

static struct all_pt_to_region_recs *
enter_pt_to_region(
    struct image_display_window *win,
    int status)
{
 struct pt_to_region_rec *pt;

 if (status == GET_ALL_PT_PTR)
    {if (All_pts_first_time) 
	return NULL;
    else 
	return &All_pts_to_region;}
 else if (status == CLEAN_UP_GROW_ROI_MAP)
   {if (!All_pts_first_time)
       if ((pt = find_pt_to_region_rec(&All_pts_to_region,win)) != NULL)
          free_pt_to_region_rec(pt);
   return NULL;}     /* Was NO_ERROR.  -PWH 19990412 */
 else  { /* Should never happen, but just in case... */
     setup_pt_to_region(win);
     return NULL; }   /* FIXME:  Guessed at return value.  -PWH 19990412 */
}

