/****************************************************************************
histo_interface.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: histo_interface.c,v 1.11 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x) 




/* Functions defined in this file */
unsigned short WinTypeToHistoType(struct image_display_window *win);
unsigned short HistoTypeToWinType(int histo_type2);
struct buf_2d_rec *win_get_histo_buf(struct image_display_window *win);
void win_set_win_type(struct image_display_window *win, int win_type);
int win_histogram_show(struct image_display_window *win);
void win_histogram_show_it(struct image_display_window *win);
void win_histogram_clear(struct image_display_window *win);
int win_histogram(struct image_display_window *win, int option,
    int roi_option);
int drop_not_needed_histo_pixel_types(struct histo_params_rec *histo);
int win_build_pixel_type_maps(struct image_display_window *win);
int WinSegmentCurSlice(struct image_display_window *win, int sel);
int win_segment_and_get_pixel_types(struct image_display_window *win);
int win_partitioned_pixel_type(struct image_display_window *win);
int win_edited_pixel_type(struct image_display_window *win);



/*------------------------------------------------------------------------
WinTypeToHistoType - ???
------------------------------------------------------------------------*/

unsigned short 
WinTypeToHistoType(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 if (win->type2 & HISTOGRAM_1D_WINDOWS) return HISTO_1D;
 if (win->type2 & HISTOGRAM_2D_WINDOWS) return HISTO_MULTI_D;
 if ((img = win_rec_cur_img_buf(win->owner)) != NULL)
    return file_get_def_histo_type(img->file);
   else return HISTO_1D;
}


/*------------------------------------------------------------------------
HistoTypeToWinType - ???
------------------------------------------------------------------------*/

unsigned short 
HistoTypeToWinType(histo_type2)
 unsigned short histo_type2;
{
 if (histo_type2 & HISTO_MULTI_D) return HISTOGRAM_MULTI_D_WINDOW;
   else return HISTOGRAM_1D_WINDOW; 
}


/*------------------------------------------------------------------------
win_get_histo_buf - ???
------------------------------------------------------------------------*/

struct buf_2d_rec *
win_get_histo_buf(win)
 struct image_display_window *win;
{
 unsigned short status2;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) != NULL)
    {if ((win->type2 & HISTO_1D_WINDOW) || (win->type2 & HISTO_2D_WINDOW))
        return &(img->_2d);
     status2 = WinTypeToHistoType(win);
     return (struct buf_2d_rec *) GetHistoBuf(&(img->file->histo_params),
                status2);
    }
   else return NULL;
}


/*------------------------------------------------------------------------
win_set_win_type - ???
------------------------------------------------------------------------*/

void
win_set_win_type(win,win_type)
 struct image_display_window *win;
 unsigned short win_type;
{
 win->type2 &= ~ALL_WINDOWS;
 win->type2 |= win_type;
}


/*------------------------------------------------------------------------
win_histogram_show - ???
------------------------------------------------------------------------*/

int
win_histogram_show(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 unsigned short histo_type2,win_type;
 int err;

 PRT3(printf("win_histogram_show...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 histo_type2 = WinTypeToHistoType(win);
 if ((err = HistoBufReady(img->file,histo_type2)) != NO_ERROR) return err;

 PRT3(printf("win_histogram_show..1.\n"))
 win_type = HistoTypeToWinType(histo_type2);
 if (win->owner->histogram == NULL)
    {
     PRT3(printf("histogram == NULL...call win_rec_setup_histogram\n"))
     if ((err = win_rec_setup_histogram(win->owner,win_type)) !=
                NO_ERROR) return err;
    }
   else if (win->owner->histogram->num_display_wins > 0)
    {
     WinHistoNewColorMultiCanvas(win->owner->histogram);
     win_execute_proc_to_related_wins(win->owner->histogram,
                     win_redisplay_all_curves,0,0);
     win_show_multiple_windows(win->owner->histogram);
     win_multiple_win_top(win->owner->histogram);
    }
 PRT3(printf("win_histogram_show...end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_histogram_show_it - ???
------------------------------------------------------------------------*/

void
win_histogram_show_it(win)
 struct image_display_window *win;
{
 if (win->owner->histogram != NULL)
    WinNewColorRequest(win->owner->histogram);
 win_histogram_show(win);
}


/*------------------------------------------------------------------------
win_histogram_clear - ???
------------------------------------------------------------------------*/

void
win_histogram_clear(win)
 struct image_display_window *win;
{
 struct buf_2d_rec *_2d;

 if ((_2d = win_get_histo_buf(win)) != NULL)
    {
     InitBuf2dRecData(_2d,(unsigned int) (double) .0);
     if (!(win->type2 & HISTOGRAM_WINDOW))
        win = win->owner->histogram;

     if ((win == NULL) || (win->num_display_wins == 0))
	 return /*NO_ERROR*/;
     if ((win->type2 & HISTO_1D_WINDOW) || (win->type2 & HISTO_2D_WINDOW))
        WinNewColorMultiCanvas(win);
       else WinHistoNewColorMultiCanvas(win);
    }
}


/*------------------------------------------------------------------------
win_histogram - ???
------------------------------------------------------------------------*/

int
win_histogram(win,option,roi_option)
 struct image_display_window *win;
 int option,roi_option;
{
 unsigned short status2,win_type;
 int err;
 struct img_buf_rec *img;
 struct buf_2d_rec *_2d;

 TRACE(printf("win_histogram(...win->type2 = %x\n",(unsigned long) win->type2))
 if (!(win->type2 & IMAGE_WINDOWS)) return CANCEL;
 TRACE(printf("win_histogram...0\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 TRACE(printf("win_histogram...0...2\n"))
 if ((option == VALUE_HISTO_CURRENT_SLICE_1D) ||
     (option == VALUE_HISTO_ALL_SLICE_1D))
    {status2 = HISTO_1D;
     if (img->file->hdr.data_info.num_echoes == 2)
        win_type = HISTOGRAM_1D_WINDOW_DISPLAY_ONLY;
       else win_type = HISTOGRAM_1D_WINDOW;
    }
   else if (win->type2 & DISPLAY_WINDOW)
    {TRACE(printf("win_histogram...0...1\n"))
     status2 = HISTO_MULTI_D;
     if (img->file->hdr.data_info.num_echoes == 2)
        win_type = HISTOGRAM_MULTI_D_WINDOW;
       else return CANCEL;
    }
   else return CANCEL;

 TRACE(printf("win_histogram(...1\n"))
 if ((err = setup_histo_params_rec(&(img->file->histo_params),
               img->file,status2)) == NO_ERROR) 
    {
     if (win->owner->histogram != NULL)
        WinNewColorRequest(win->owner->histogram);
     _2d = (struct buf_2d_rec *) win_rec_cur_data_buf(win->owner,win_type);
     switch (option)
        {
         case VALUE_HISTO_CURRENT_SLICE_1D :
            err = HistoCurSlice(_2d,win->owner,HISTO_1D,roi_option,
                      &(win->image_view_roi),0);
            break;
         case VALUE_HISTO_ALL_SLICE_1D :
            err = HistoAllSlices(_2d,win->owner,HISTO_1D,roi_option,
                      &(win->image_view_roi));
            break;
         case VALUE_HISTO_CURRENT_SLICE :
            err = HistoCurSlice(_2d,win->owner,HISTO_MULTI_D,roi_option,
                      &(win->image_view_roi),0);
            break;
         case VALUE_HISTO_ALL_SLICE :
            err = HistoAllSlices(_2d,win->owner,HISTO_MULTI_D,roi_option,
                      &(win->image_view_roi));
            break;
        }
     if (err == NO_ERROR) err = win_histogram_show(win);
    }
 if (err != NO_ERROR)
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
        "An error occured when generating the histogram data !!!",
        "The operation is aborted !!!",NULL,0);
 TRACE(printf("win_histogram...end\n"))

 return err;
}


/*------------------------------------------------------------------------
drop_not_needed_histo_pixel_types - ???
------------------------------------------------------------------------*/

int
drop_not_needed_histo_pixel_types(histo)
 struct histo_params_rec *histo;
{
 unsigned int lcv;
 struct roi_rec *roi;
 char *str;
 struct slice_roi_win_rec *slice_roi_win;
 unsigned short histo_type2;

 histo_type2 = file_get_def_histo_type(histo->file);
 slice_roi_win = (struct slice_roi_win_rec *) GetHistoSliceRoiWinRec(histo,
               histo_type2);
 TRACE(printf("init...drop_not_needed_histo_pixel_types\n"))
 TRACE(pr_strs_rec(&(histo->pixel_type_order)))
 TRACE(printf("\n"))

 for (lcv = 0; lcv < histo->pixel_type_order.num_strs; )
    {str = histo->pixel_type_order.strs[lcv];
     if (((roi = get_roi(&(slice_roi_win->slice_roi),str)) == NULL) ||
         !is_roi_non_empty(roi) ||
         (!(roi->status & HISTO_EDITED_ROI) &&
          !(roi->status & HISTO_SEGMENTED_ROI)))
        {TRACE(printf("before...drop_not_needed_histo_pixel_types\n"))
         TRACE(pr_strs_rec(&(histo->pixel_type_order)))
         drop_indx_str_ptr_from_strs_rec(&(histo->pixel_type_order),lcv);
         c_free(str);
         TRACE(printf("after...drop_not_needed_histo_pixel_types\n"))
         TRACE(pr_strs_rec(&(histo->pixel_type_order)))
         TRACE(printf("...drop_not_needed_histo_pixel_types...end\n"))
        }
       else
        {
         lcv++;}
     }
 TRACE(printf("\nfinal...drop_not_needed_histo_pixel_types\n"))
 TRACE(pr_strs_rec(&(histo->pixel_type_order)))
 TRACE(printf("\n"))
 TRACE(printf("drop_not_needed_histo_pixel_types end\n"))

 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_build_pixel_type_maps - ???
------------------------------------------------------------------------*/

int
win_build_pixel_type_maps(win)
 struct image_display_window *win;
{
 int err;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((img->file->hdr.data_info.num_echoes < 1) || 
     (img->file->hdr.data_info.num_echoes > 2))
    {
     ShowMsgStrs(win->dwin->frame,0,0,0,2,
               "The # of echo images must be 1 or 2",
               "   to build the the pixel type map !!!",NULL,0);
     return CANCEL;
    }
 TRACE(printf("win_delete_all_slices_pixel_type_cnt_rec...begin\n"))
 win_delete_all_slices_pixel_type_cnt_rec(win);
 err = drop_not_needed_histo_pixel_types(&(img->file->histo_params));
 if (img->file->histo_params.pixel_type_order.num_strs == 0)
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "NO histogram pixel type ROIs have been defined yet...",
               "Please use the GET PIXEL TYPES option to define it !!!",NULL,0);
     return CANCEL;}

 
 TRACE(printf("build_pixel_type_map...begin\n"))
 if ((err = build_pixel_type_map(&(img->file->histo_params),
               &(img->file->pixel_type))) != NO_ERROR)
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when generating",
               "   the pixel type map !!!",NULL,0);
     return err;
    }
 img->file->pixel_type.status &= ~PIXEL_TYPE_SEGMENTED;
 img->file->pixel_type.status |= PIXEL_TYPE_2D_PARTITION;
 img->file->output.status |= FILE_TO_BE_SAVED;
 WinRedefine3dPixmaps(win);

 TRACE(printf("win_build_pixel_type_maps...end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
WinSegmentCurSlice - ???

FIXME:  The argument "sel" is never used.  -PWH 19990618
------------------------------------------------------------------------*/

int
WinSegmentCurSlice(win,sel)
 struct image_display_window *win;
 int sel;
{
 struct img_buf_rec *img;
 int err;
 unsigned short histo_type2;
 struct slice_roi_win_rec *slice_roi_win;

 if (!(win->type2 & EDITING_WINDOW)) return CANCEL;
 img = win_rec_cur_img_buf(win->owner);
 if (img == NULL) return NO_ERROR;
 histo_type2 = file_get_def_histo_type(img->file);
 if ((err = HistoBufReady(img->file,histo_type2)) != NO_ERROR)
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "Unable to get the histogram ready yet !!!",
               "Probably memory error !!!",NULL,0);
     return err;}

 PRT2(printf("WinSegmentCurSlice...status2 = %x\n",
       (unsigned long) img->file->histo_params.status2))

 slice_roi_win = (struct slice_roi_win_rec *)
          GetHistoSliceRoiWinRec(&(img->file->histo_params),histo_type2);
 DeleteRoisOfType(&(slice_roi_win->slice_roi),HISTO_SEGMENTED_ROI,1);
 if (!is_slice_roi_non_empty(&(slice_roi_win->slice_roi)))
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "No HISTOGRAM ROIS ARE DEFINED !!!",OPERATION_ABORTED,NULL,0);
     return CANCEL;}
 if (img->file->hdr.data_info.num_echoes == 1)
     /* Removed final argument "sel" below since the function definition
	does not expect it.  -PWH 19990618 */
    err =  segment_1_echo(&(img->file->histo_params),img,
                   &(img->file->pixel_type),
                   &(img->file->prog->win.pixel_type_priority),
		   img->file->slice_info.num_sroi_wins/*,sel*/);
   else err =  segment_2_echo(&(img->file->histo_params),img,
                   &(img->file->pixel_type),
                   &(img->file->prog->win.pixel_type_priority),
                   img->file->slice_info.num_sroi_wins);
 if (err != NO_ERROR)
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when segmenting the pixel type rois",
               "   before defining the pixel type map !!!",NULL,0);
     free_histo_pixel_tissue_type_rec(&(img->file->histo_params));
    }
   else
    {img->file->status |= FILE_SAVE_PIXEL_TYPE;
     img->file->output.status |= FILE_TO_BE_SAVED;
     PRT2(printf("WinSegmentCurSlice...WinReshowPixelTypesToScreen\n"))
     win_run_proc_to_all_file_wins(win,WinReshowPixelTypesToScreen,3,0,0,0);
     win_run_proc_to_all_file_wins(win,win_redisplay_all_curves,2,0,0,0);
     WinRedefine3dPixmaps(win);}

 PRT2(printf("WinSegmentCurSlice...3\n"))
 return err;
}


/*------------------------------------------------------------------------
win_segment_and_get_pixel_types - ???
------------------------------------------------------------------------*/

int
win_segment_and_get_pixel_types(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 int err;
 unsigned short histo_type2;
 struct slice_roi_win_rec *slice_roi_win;

 PRT1(printf("win_segment_and_get_pixel_types...begin\n"))
 if (!(win->type2 & EDITING_WINDOW)) return CANCEL;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NO_ERROR;
 histo_type2 = file_get_def_histo_type(img->file);
 PRT1(printf("win_segment_and_get_pixel_types...1\n"))
 if ((err = HistoBufReady(img->file,histo_type2)) != NO_ERROR)
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "Unable to get the histogram ready yet !!!",
               "Probably memory error !!!",NULL,0);
     return err;}
 PRT1(printf("win_segment_and_get_pixel_types...histo_type2 = %x\n",
         (unsigned long) histo_type2))
 slice_roi_win = (struct slice_roi_win_rec *) 
              GetHistoSliceRoiWinRec(&(img->file->histo_params),
                   histo_type2);

 DeleteRoisOfType(&(slice_roi_win->slice_roi),HISTO_SEGMENTED_ROI,1);
 if (!is_slice_roi_non_empty(&(slice_roi_win->slice_roi)))
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "No HISTOGRAM ROIS ARE DEFINED !!!",OPERATION_ABORTED,NULL,0);
     return CANCEL;}

 PRT1(printf("analysis_status...= %d\n",
          (unsigned long) win->dwin->analysis_status))
 if ((img->file->hdr.data_info.num_echoes != 2) ||
     (win->dwin->analysis_status & PIXEL_TYPE_GROW_REGION_ANALYSIS))
    {PRT1(printf("enter_dp_segment_echo...\n"))
     return enter_dp_segment_echo(win,1);
    }
   else
    {PRT1(printf("segment_pixels...\n"))
     if ((err = thresholding_pixels(&(img->file->histo_params))) == NO_ERROR)
        {err = win_build_pixel_type_maps(win);
        }
       else
        {/*printf("free_histo_pixel_center_rec...\n");fflush(stdout);*/
         free_histo_pixel_center_rec(&(img->file->histo_params));}
    }
 PRT1(printf("win_segment_and_get_pixel_types...err = %d\n",err))
 if (err != NO_ERROR)
    {
     ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when segmenting the pixel type rois",
               "   before defining the pixel type map !!!",NULL,0);
     }
    else
     {win_run_proc_to_all_file_wins(win,WinReshowPixelTypesToScreen,3,0,0,0);
      TRACE(printf("after WinReshowPixelTypesToScreen... \n"))
      win_run_proc_to_all_file_wins(win,win_redisplay_all_curves,2,0,0,0);}

 PRT1(printf("win_segment_and_get_pixel_types...err = %d\n",err))
 return err;
}


/**************************
     if (err == CANCEL)
        {
         if (!is_slice_roi_non_empty(&(slice_roi_win->slice_roi)))
            {ShowMsgStrs(win->dwin->frame,0,NO_ERROR,0,6,
                "No histogram pixel type rois have been defined yet...",
                "Cannot define pixel types yet !!!",
                "Only those :- 1) edited histo rois or",
                "              2) segmented pixel type rois",
                "   in the histogram window are counted",
                "   as histogram pixel type rois...",NULL,0);
            return err;}
        }
********************/


/*------------------------------------------------------------------------
win_partitioned_pixel_type - ???
------------------------------------------------------------------------*/

int
win_partitioned_pixel_type(win)
 struct image_display_window *win;
{
 struct roi_rec *roi;

 if ((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi))) != NULL)
    if ((roi->status & HISTO_EDITED_ROI) || (roi->status & HISTO_SEGMENTED_ROI))
    {
     win->control.sroi.sroi_win->slice_roi.status |= 
                  SLICE_ROI_NON_EMPTY | SLICE_ROI_TO_BE_SAVED;
     roi->status &= ~HISTO_SEGMENTED_ROI;
     roi->status &= ~HISTO_EDITED_ROI;
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_edited_pixel_type - ???
------------------------------------------------------------------------*/

int
win_edited_pixel_type(win)
 struct image_display_window *win;
{
 struct roi_rec *roi;

 if ((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi))) != NULL)
    {
     win->control.sroi.sroi_win->slice_roi.status |= 
                  SLICE_ROI_NON_EMPTY | SLICE_ROI_TO_BE_SAVED;
     roi->status |= HISTO_EDITED_ROI;
     roi->status &= ~HISTO_SEGMENTED_ROI;
     win_run_proc_to_all_file_wins(win,win_redisplay_all_curves,2,0,0,0);
    }
 return NO_ERROR;
}

