/****************************************************************************
img_menu.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: img_menu.c,v 1.11 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/textsw.h>
#include <xview/notify.h>

#include "mri_format.h"
#include "nria_procedures.h"


#if 0
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT15(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#else
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT15(x)
#define PRT8(x)
#endif




/* Functions defined in this file */
void image_contrast_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void edge_detection_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void image_enhancement_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void set_slice_min_max_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int select);
void image_view_filter_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void change_view_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int which_quadrant);
void pixel_selection_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void pt_to_region_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
void modify_image_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void reverse_images_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
int save_cur_win_image(struct display_win_rec *dwin, char *fn, int is_free_fn);
void print_or_save_image_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
Menu setup_print_or_save_image_menu(void);
void fusion_image_action_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int select);
void fusion_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
void enable_move_superimpose_cursor_proc(Menu menu, Menu_item item,
    void *arg, Xv_Window window, Event *last_event);
void co_register_file_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
void enter_co_register_file_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void overlay_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int value);
void process_slice_scans_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void resize_image_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void resize_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int option);
void rotate_2d_image_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, double angle);



/*---------------------------------------------------------------------
image_contrast_proc - ???
----------------------------------------------------------------------*/

void
image_contrast_proc( menu, item, arg, window, last_event )
     Menu menu;
     Menu_item item;
     void *arg;
     Xv_Window window;
     Event *last_event;
{
  struct display_win_rec *win1;
  struct image_display_window *win;
  Menu root;

  if (menu == 0)
  {
    win1 = (struct display_win_rec *) arg;
  }
  else
  {
    root = (Menu) root_menu(menu);
    if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
    {
      window = (Xv_Window) event_window(last_event);
      win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
    }
    else
      win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
  }
  win = win1->owner;
  win->dwin = win1;
  enter_image_contrast(win,1);	/* contrast.c */
}



/*---------------------------------------------------------------------
edge_detection_proc - ???
----------------------------------------------------------------------*/

void
edge_detection_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("edge_detection_proc...\n"))
 if (menu == 0)
    {dwin = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;

 TRACE(printf("edge_detection_proc...enter_edge_detector\n"))
 enter_edge_detector(win,1);

}

/***************
polarity_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("polarity_proc...\n"))
 if (menu == NULL)
    {dwin = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = dwin->owner;
 win->dwin = dwin;

 TRACE(printf("polarity_proc...enter_edge_detector\n"))
 win_image_polarity(win);

}
****************/


/*---------------------------------------------------------------------
image_enhancement_proc - ???
----------------------------------------------------------------------*/

void
image_enhancement_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 win_image_enhancement(win);
}



/*---------------------------------------------------------------------
set_slice_min_max_proc - ???
----------------------------------------------------------------------*/

void
set_slice_min_max_proc(menu,item,arg,window,last_event,select)
     Menu menu;
     Menu_item item;
     void *arg;
     Xv_Window window;
     Event *last_event;
     int select;
{
  struct display_win_rec *win1;
  struct image_display_window *win;
  Menu root;
  static int sel;


  if (menu == 0)
  {
    win1 = (struct display_win_rec *) arg;
  }
  else
  {
    root = (Menu) root_menu(menu);
    if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
    {
      window = (Xv_Window) event_window(last_event);
      win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
    }
    else
      win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
  }

  win = win1->owner;
  win->dwin = win1;
  sel = select;
  if (sel == 2)
    ShowMsgStrs(win1->frame,1,NO_ERROR,1,1,
		"Set slice Min & Max for the current file !!!",
		win_set_slice_min_max,2,win,sel);
  else if (sel == 3)
    ShowMsgStrs(win1->frame,1,NO_ERROR,1,1,
		"Set slice Min & Max for all files !!!",
		win_set_slice_min_max,2,win,sel);
  else ShowMsgStrs(win1->frame,1,NO_ERROR,1,1,
		   "Set slice Min & Max for the current slice !!!",
		   win_set_slice_min_max,2,win,sel);
}


/*---------------------------------------------------------------------
image_view_filter_proc - ???
----------------------------------------------------------------------*/

void
image_view_filter_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 enter_image_view_filter(win,1);
}


/*---------------------------------------------------------------------
change_view_roi_proc - ???
----------------------------------------------------------------------*/

void
change_view_roi_proc(menu,item,arg,window,last_event,which_quadrant)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int which_quadrant;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;
 int is_exc;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 if (which_quadrant < 0)
    {is_exc = 0;
     which_quadrant = -which_quadrant;}
   else is_exc = 1;
 PRT2(printf("is_exc = %d which_quadrant = %d\n",is_exc,which_quadrant))
 win_change_view_roi(win,is_exc,which_quadrant - 1);
}


/*---------------------------------------------------------------------
pixel_selection_proc - ???
----------------------------------------------------------------------*/

void
pixel_selection_proc(
    Menu menu,
    Menu_item item,
    void *arg,
    Xv_Window window,
    Event *last_event)
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 if (win1->owner->type2 & DISPLAY_WINDOW_3D)
    {ShowMsgStrs(win1->frame,0,NO_ERROR,0,2,
         "This future version will implement this command",
         "    for the 3D window !!!",NULL,0);
     return; }
   else
    {set_win_busy(win);
     setup_pixel_selection(win);
     set_win_not_busy(win);
     return;}
}


/*---------------------------------------------------------------------
pt_to_region_proc - ???
----------------------------------------------------------------------*/

void
pt_to_region_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 int err;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     option = 0;
    }
 win = win1->owner;
 win->dwin = win1;
/*
 if (win1->status & DISPLAY_WINDOW_3D)
    {ShowMsgStrs(win1->frame,0,NO_ERROR,0,2,
         "This future version will implement this command",
         "    for the 3D window !!!",NULL,0);
     return NO_ERROR;}
   else
    {
*/
     set_win_busy(win);
     if (option == 1) 
	 update_pt_to_region(win,last_event);
     else  
	 err = setup_pt_to_region(win);
     set_win_not_busy(win);
     if ((option != 1) && (err == NO_ERROR))
        win_select_cursor(win,CURSOR_PT_SCAN);
/*
    }
*/
}


/*---------------------------------------------------------------------
modify_image_proc - ???
----------------------------------------------------------------------*/

void
modify_image_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 enter_modify_image(win,1);
}


/*---------------------------------------------------------------------
reverse_images_proc - ???
----------------------------------------------------------------------*/

void
reverse_images_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 win_reverse_images(win);
}


/*---------------------------------------------------------------------
save_cur_win_image - ???
----------------------------------------------------------------------*/

int
save_cur_win_image(dwin,fn,is_free_fn)
 struct display_win_rec *dwin;
 char *fn;
 int is_free_fn;
{
 int err;
 char *err_reason;
 struct img_buf_rec *img;
 float xpix,ypix,zpix;
 unsigned long dimx,dimy;

 TRACE(printf("save_cur_image  fn = %s\n",fn))
 if ((img = win_rec_cur_img_buf(dwin->owner->owner)) == NULL) return CANCEL;
 if (((err = WinImageUnitSize(dwin->owner,&xpix,&ypix,&zpix,
            &dimx,&dimy)) != NO_ERROR) ||
     ((err = Wr2dImage(fn,&(dwin->screen._2d),"SCREEN IMAGE",&err_reason,
           &(img->file->hdr),xpix,ypix,zpix)) != NO_ERROR))
    ShowMsgStrs(dwin->frame,0,err,0,2,
             "Fail to save the current window image !!!",
             err_reason,NULL,0);

 if (is_free_fn) c_free(fn);
 return err;
}


/*---------------------------------------------------------------------
print_or_save_image_proc - ???
----------------------------------------------------------------------*/

void
print_or_save_image_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 int value;
 struct display_win_rec *win1;
 struct image_display_window *win;
 char *str,*fn;
 Menu root;

 TRACE(printf("output_image_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     value = option;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     value = (int) xv_get(item,MENU_VALUE);}
     
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;
 TRACE(printf("output_image_proc...value = %d\n",value))
 if (value == VALUE_SAVE_CURRENT_WIN_IMAGES)
    {str = win_rec_win_id_title(win->owner,"");
     lower_case_str(str);
     if ((fn = UniqueFn("",str,".img")) == NULL)
        ShowMsgStrs(win1->frame,0,NO_ERROR,0,2,
             "Fail to create a unique file name !!!",
             OPERATION_ABORTED,NULL,0);
       else
        ShowMsgStrs(win1->frame,1,NO_ERROR,0,3,
               "Saving the current window image...",fn,
               PLEASE_WAIT,save_cur_win_image,2,win1,fn,1);
     c_free(str);
    }
/*
   else
    {if (value == VALUE_PRINT_CURRENT_IMAGE)
        ShowMsgStrs(win1->frame,1,NO_ERROR,0,2,
             "PRINTING CURRENT IMAGE...!!!",
             PLEASE_WAIT,win_pr_cur_slice,1,win);
       else if (value == VALUE_PRINT_ALL_IMAGES)
        ShowMsgStrs(win1->frame,1,NO_ERROR,0,2,
             "PRINTING ALL IMAGES...!!!",
             PLEASE_WAIT,win_pr_all_slices,1,win);
    }
*/
}


/*---------------------------------------------------------------------
setup_print_or_save_image_menu - ???
----------------------------------------------------------------------*/

Menu 
setup_print_or_save_image_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                       MENU_NOTIFY_PROC,print_or_save_image_proc,
                       MENU_STRING_ITEM,SAVE_CUR_WIN_IMAGE,
                           (int) VALUE_SAVE_CURRENT_WIN_IMAGES,
/*
                       MENU_STRING_ITEM,PRINT_CURRENT_IMAGE,
                           (int) VALUE_PRINT_CURRENT_IMAGE,
                       MENU_STRING_ITEM,PRINT_ALL_IMAGES,
                           (int) VALUE_PRINT_ALL_IMAGES,
*/
                       0);
 return menu;
}


/*---------------------------------------------------------------------
fusion_image_action_proc - ???

FIXME:  Why should this function have a select argument, when all the
other functions similar to it do not?

NOTE:  The pre-19990225 version returned int but was used only in
contexts that require void.  Changed type to void.  -PWH
----------------------------------------------------------------------*/

void
fusion_image_action_proc(menu,item,arg,window,last_event,select)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int select;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;
 struct img_buf_rec *img;
 int is_ok;

 PRT1(printf("fusion_image_action_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;
 if (select == FUSION_WHICH_WIN) {
     win_fusion_which_win(win);
     return;
 }
 if ((img->_2d_fusion.status & FUSION_METHOD) &&
     (img->_2d_fusion._2d.status4 & BUF_NON_EMPTY))
     is_ok = 1;
   else if ((select == FUSION_SWITCHING) &&
            (img->num_dst_wids > 0))
     is_ok = 1;
   else
     is_ok = 0;

 if (is_ok) {
     if (select == FUSION_SHOW) {
	 win_show_fusion(win); 
	 return; }
     else if (select == FUSION_SHOW_SRC) {
	 win_show_hide_fusion(win);
	 return; }
     else if (select == FUSION_LAST_LEFT_TOP) {
	 win_fusion_last_left_top(win);
	 return; }
     else if (select == FUSION_SWITCHING) {
	 win_fusion_switching(win);
	 return; }
 }
 else 
     ShowMsgStrs(win1->frame,3,NO_ERROR,1,1,
		 "No Image Fusion yet !!!",NULL,0);

}


/*---------------------------------------------------------------------
fusion_proc - ???
----------------------------------------------------------------------*/

void
fusion_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 PRT1(printf("fusion_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 setup_fusion_menu(win);

}


/*---------------------------------------------------------------------
enable_move_superimpose_cursor_proc - ???

NOTE:  The pre-19990225 version returned int but was used only in
contexts that require void.  Changed type to void.  -PWH
----------------------------------------------------------------------*/

void
enable_move_superimpose_cursor_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;
 struct img_buf_rec *img;

 PRT15(printf("enable_move_superimpose_cursor_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;

 if (img->_2d_fusion.status & FUSION_METHOD)
    {
     PRT15(printf("enable_move_superimpose_cursor_proc...FUSION_METHOD\n"))
     if (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE)
        {PRT15(printf("enable_move_superimpose...win_delete_fusion\n"))
         win_delete_fusion(win);}
       else
        {win_select_cursor(win1->owner,CURSOR_MOVE_SUPERIMPOSE);
         PRT15(printf("enable_move_superimpose_cursor_proc...1\n"))}
    }
   else if (win->type2 & DISPLAY_WINDOW)
    {
     PRT15(printf("enable_move_superimpose_cursor_proc...FUSION_MOVE_SELF\n"))
     if (win_fusion_which_win_proc(win,win->owner->wid) == NO_ERROR)
        img->_2d_fusion.status |= FUSION_MOVE_SELF;
    }
   else
    {
     ShowMsgStrs(win1->frame,3,NO_ERROR,1,1,
               "No Image Fusion to move !!!",NULL,0);}
}


/*---------------------------------------------------------------------
co_register_file_proc - ???

NOTE:  The pre-19990225 version returned int but was used only in
contexts that require void.  Changed type to void.  -PWH
----------------------------------------------------------------------*/

void
co_register_file_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;
 struct strs_rec *wids;
 int err;
 struct img_buf_rec *img;
 char *str1;

 PRT1(printf("co_register_file_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     last_event = NULL;
     option = (int) xv_get(item,MENU_VALUE);
    }
 win = win1->owner;
 win->dwin = win1;
 if (!(win->type2 & DISPLAY_WINDOW))
    {win_alarm(win1->frame,2);
     return;}
 set_win_busy(win);
 if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
    {if ((option == REVERSE_CO_FILE_PARAMS_VALUE) ||
         (option == SAVE_CO_FILE_VALUE))
        {if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
            err = CANCEL;
           else if ((err = AllFiles(img->file,wids,1,0)) == NO_ERROR)
            {if (wids->num_strs == 0)
                {ShowMsgStrs(win1->frame,1,NO_ERROR,2,1,
                        "SORRY, NO OTHER FILES !!!",NULL,0);
                 c_free(wids);
                }
               else
                {if (option == REVERSE_CO_FILE_PARAMS_VALUE)
                    {str1 = win_rec_win_id_title(win->owner,
                            REVERSE_CO_FILE_PARAMS);
                     ShowMenuStrsProc(window,last_event,str1,
                            wids,USER_MENU_FREE_STRS_AND_PTR,
                            win_reverse_npco_2d_params,win,1,0,0);
                    }
                   else 
                    {str1 = win_rec_win_id_title(win->owner,SAVE_CO_FILE);
                     ShowMenuStrsProc(window,last_event,str1,
                         wids,USER_MENU_FREE_STRS_AND_PTR,
                          win_save_npco_2d,win,1,0,0);
                    }
                 c_free(str1);}
            }
        }
       else if (option == UNCO_WID_FILE_VALUE)
        {if ((err = WinCoRegFiles(win,wids)) == NO_ERROR)
            if (wids->num_strs == 0)
               {ShowMsgStrs(win1->frame,1,NO_ERROR,2,5,
                        "SORRY !!!",
                        "NO FILES HAVE BEEN CO-REGISTERED YET",
                        "USING NON-DEFAULT PARAMETERS !!!",
                        "BY DEFAULT, ALL FILES ARE",
                        "CO-REGISTERED IMPLICITLY !!!",NULL,0);
                c_free(wids);
               }
              else
               {str1 = win_rec_win_id_title(win->owner,UNCO_WID_FILE);
                ShowMenuStrsProc(window,last_event,str1,
                    wids,USER_MENU_FREE_STRS_AND_PTR,
                      win_unco_register_with_wid_file,win,1,0,0);
                c_free(str1);}
        }
       else if ((err = AllWids(win->owner,wids,1,2,DISPLAY_WINDOW)) == NO_ERROR)
        {if (wids->num_strs == 0)
            {ShowMsgStrs(win1->frame,1,NO_ERROR,2,2,
                        "SORRY !!!",
                        "NO OTHER WIDS OF OTHER FILES",NULL,0);
             c_free(wids);
            }
           else if (option == LOAD_CO_FILE_VALUE)
            {free_strs_rec(wids);
             c_free(wids);
             win_load_npco_2d(win);
            }
           else if (option == CO_WID_FILE_VALUE)
            {str1 = win_rec_win_id_title(win->owner,CO_WID_FILE);
             ShowMenuStrsProc(window,last_event,str1,
                    wids,USER_MENU_FREE_STRS_AND_PTR,
                      win_co_register_with_wid_file,win,1,0,0);
             c_free(str1);}
         }
    }
 if (err != NO_ERROR)
    {if (wids != NULL) free_strs_rec(wids);
     c_free(wids);
     ShowMsgStrs(win1->frame,0,err,0,1,
                  "Sorry...Memory err !!",NULL,0);
    }
 set_win_not_busy(win);
}


/*---------------------------------------------------------------------
enter_co_register_file_proc - ???
----------------------------------------------------------------------*/

void
enter_co_register_file_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 PRT1(printf("enter_co_register_file_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     last_event = NULL;
    }
 win = win1->owner;
 win->dwin = win1;
 enter_co_register_file(win,1);
}


/*---------------------------------------------------------------------
overlay_proc - ???

NOTE:  The pre-19990225 version returned int but was always used in
a context where void was required.  Changed type to void.  -PWH
----------------------------------------------------------------------*/

void
overlay_proc(menu,item,arg,window,last_event,value)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int value;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;
 static long val;
 struct strs_rec *wids;
 int err;
 static char *str,*str1;

 PRT1(printf("overlay_proc...value = %d\n",value))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     value = (int) xv_get(item,MENU_VALUE);
     last_event = NULL;
    }
 win = win1->owner;
 win->dwin = win1;
 PRT1(printf("overlay_proc...value = %d\n",value))
 val = value;
 err = NO_ERROR;
 if ((value == OVERLAYED_BY_WID_VALUE) || (value == OVERLAYED_BY_WID_STACK_VALUE) ||
     (value == OVERLAYED_BY_ALL_ECHO_WID_VALUE) ||
     (value == OVERLAYED_BY_ALL_ECHO_WID_STACK_VALUE))
    {if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
        {if ((err = AllWids(win->owner,wids,1,0,MANY_SLICES_WINDOWS)) == NO_ERROR)
            if (wids->num_strs > 0)
               {if (value == OVERLAYED_BY_ALL_ECHO_WID_VALUE)
                   str = OVERLAYED_BY_ALL_ECHO_WID;
                  else if (value == OVERLAYED_BY_ALL_ECHO_WID_STACK_VALUE)
                   str = OVERLAYED_BY_ALL_ECHO_WID_STACK;
                  else if (value == OVERLAYED_BY_WID_VALUE)
                   str = OVERLAYED_BY_WID;
                  else if (value == OVERLAYED_BY_WID_STACK_VALUE)
                   str = OVERLAYED_BY_WID_STACK;
                str1 = win_rec_win_id_title(win->owner,str);
                ShowMenuStrsProc(window,last_event,str1,
                       wids,USER_MENU_FREE_STRS_AND_PTR,
                       win_overlayed_by_wid,win,1,val,0);
                c_free(str1);
                return;}
              else
               {ShowMsgStrs(win1->frame,1,NO_ERROR,1,1,
                         "No other WID to overlay on !!!",NULL,0);
                c_free(wids);}
         if (err != NO_ERROR)
            {free_strs_rec(wids);
             c_free(wids);}
        }
    }
   else if (value == DELETE_OVERLAY_VALUE)
     err = WinDeleteOverlay(win);
   else if (value == DELETE_OVERLAY_STACK_VALUE)
    err = WinRunProcInList(WIN_LIST,win,WinDeleteOverlay,0,0,0,0,0,0);
   else if (value == SHOW_HIDE_OVERLAY_VALUE)
     err = WinShowHideOverlay(win);
   else if (value == SHOW_HIDE_OVERLAY_STACK_VALUE)
     err = WinRunProcInList(WIN_LIST,win,WinShowHideOverlay,0,0,0,0,0,0);
 if (err != NO_ERROR)
    {
     ShowMsgStrs(win1->frame,0,err,0,2,
                  "Sorry...An error occurred ",
                  "during the overlay process !!!",NULL,0);
    }
}


/*---------------------------------------------------------------------
process_slice_scans_proc - ???
----------------------------------------------------------------------*/

void
process_slice_scans_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("ca_options_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 if (!(win->type2 & EDITING_WINDOW)) return;
 enter_process_slice_scans(win,1);
}


/*---------------------------------------------------------------------
resize_image_proc - ???
----------------------------------------------------------------------*/

void
resize_image_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 if (!(win->type2 & IMAGE_WINDOWS))
    win_alarm(win1->frame,2);
   else enter_resize_image(win,1);
}


/*---------------------------------------------------------------------
resize_proc - ???

FIXME:  Is this function ever used?

NOTE:  The pre-19990225 version returned int but was always used in
a context where void was required.  Changed the type to void.  -PWH
----------------------------------------------------------------------*/

void
resize_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 struct strs_rec *wids;
 char *str1;
 Menu root;
 int err;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     option = (int) xv_get(item,MENU_VALUE);
     last_event = NULL;
    }
 win = win1->owner;
 win->dwin = win1;
 if (!(win->type2 & IMAGE_WINDOWS))
    {win_alarm(win1->frame,2);
     return;}
 PRT3(printf("resize_proc...option = %d\n",option))
 if (option == RESIZE_TO_WID_SIZE_VALUE)
    {if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
        if ((err = AllWids(win->owner,wids,1,0,IMAGE_WINDOWS)) == NO_ERROR)
           {if (wids->num_strs == 0)
               {ShowMsgStrs(win1->frame,1,NO_ERROR,2,3,
                         "No other WID available !!!",
                         "Use the RESIZE IMAGE menu to",
                         "resize the current image...",NULL,0);
                c_free(wids);}
              else
               {str1 = win_rec_win_id_title(win->owner,
                            "RESIZE TO WID XY PIXEL SIZE");
                ShowMenuStrsProc(window,last_event,str1,
                    wids,USER_MENU_FREE_STRS_AND_PTR,
                      win_resize_to_wid,win,1,0,0);
                c_free(str1);}
           }
          else
           {free_strs_rec(wids);
            c_free(wids);}
    }
   else
    {set_win_busy(win);
     if (option == RESIZE_ZOOM_IN_VALUE)
        err = win_zoom(win,1); 
       else if (option == RESIZE_ZOOM_OUT_VALUE)
        err = win_zoom(win,0);
       else if (option == RESIZE_DEFAULT_VALUE)
	   /* FIXME:  Removed final argument "0" in three places below, since
              the function definition doesn't allow it.  -PWH 19990623 */
	   err = WinResizeDefImgView(win/*,0*/);
       else if (option == RESIZE_DEFAULT_SIZE_VALUE)
	   err = WinResizeDefImgSize(win/*,0*/);
       else if (option == RESIZE_LAST_VALUE)
	   err = WinResizeLastImgSize(win/*,0*/);
     set_win_not_busy(win);
    }
 if (err != NO_ERROR)
    {
     ShowMsgStrs(win1->frame,0,err,0,2,
                  "Sorry...An error occurred ",
                  "during the overlay process !!!",NULL,0);
    }
}


/*---------------------------------------------------------------------
rotate_2d_image_proc - ???
----------------------------------------------------------------------*/

void
rotate_2d_image_proc(menu,item,arg,window,last_event,angle)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 float angle;
{
 struct display_win_rec *dwin;
 Menu root;
 int is_rel;

 if (menu == 0)
    dwin = (struct display_win_rec *) arg;
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     angle = 1.0;
    }
 dwin->owner->dwin = dwin;
 set_win_busy(dwin->owner);
 if (angle == .0) is_rel = 0;
   else is_rel = 1;
/*
 if ((last_event != NULL) && event_shift_is_down(last_event))
    angle = -angle;
*/
 PRT8(printf("rotate_2d_image_proc..angle = %f\n",angle))
 if (dwin->owner->type2 & DISPLAY_WINDOW)
    WinRotate2dImage(dwin->owner,angle,is_rel);
 set_win_not_busy(dwin->owner);
}

