/****************************************************************************
input_file_rec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

PWH 19980430:  This file is intended to be XView and GUI clean.
****************************************************************************/

static const char rcsid[] = "$Id: input_file_rec.c,v 1.8 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "geometry.h"
#include "buf_3d_rec.h"
#include "mri_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
*/
#define TRACE(x) 
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)
#define PRT7(x)



/* Functions defined in this file */
void init_slice_attr_rec(struct slice_attr_rec *slice);
void free_slice_attr_rec(struct slice_attr_rec *slice);
void init_slice_info_rec(struct slice_info_rec *slice_info);
void free_slice_info_rec(struct slice_info_rec *slice_info);
int setup_file_attrs(struct input_file_rec *file);
void file_def_3d_gravity(struct input_file_rec *file);
void init_co_register_rec(struct co_register_rec *co);
void free_co_register_rec(struct co_register_rec *co);
void init_file_register_rec(struct file_register_rec *freg);
void free_file_register_rec(struct file_register_rec *freg);
void init_file_co_register_rec(struct file_co_register_rec *fco);
void free_file_co_register_rec(struct file_co_register_rec *fco);
struct file_register_rec *find_file_register_rec(struct input_file_rec *file,
    struct input_file_rec *regfile, unsigned long *indx, int which);
int SetFileRegisterRecInUse(struct input_file_rec *file,
    struct input_file_rec *regfile, int which);
int add_file_register_rec(struct input_file_rec *file,
    struct input_file_rec *regfile, struct file_register_rec *co,
    unsigned long *coindx, int which);
int drop_file_co_register_rec(struct input_file_rec *file,
    struct file_register_rec *co);
int FileName(struct input_file_rec *file, char **fn);
int AllFiles(struct input_file_rec *file, struct strs_rec *fns, int is_sorted,
    int select);
struct input_file_rec *find_file(struct input_file_rec *file, char *fn,
    unsigned long *indx);
int setup_default_text_format_fn(struct input_file_rec *file);
void init_data_slice_rec(struct data_slice_rec *slice);
void free_data_slice_rec(struct data_slice_rec *slice);
int setup_data_slice_rec(struct data_slice_rec *slice,
    struct slice_info_rec *info, struct view_rec *view, char *img_label,
    unsigned long num, struct hdr_scan_entry_rec *prior_slice,
    struct hdr_scan_entry_rec *next_slice,
    struct hdr_scan_entry_rec *partner_slice);
void drop_data_slice(struct input_file_rec *file,
    struct data_slice_rec *data_slice);
int add_data_slice(struct input_file_rec *file,
    struct data_slice_rec *data_slice);
int add_slice_info_3d(struct slice_info_rec *slice_info,
    struct buf_3d_rec *_3d);
int drop_slice_info_3d(struct slice_info_rec *slice_info,
    struct buf_3d_rec *_3d);
int add_view_rec(struct slice_info_rec *slice_info, struct view_rec *view);
int drop_view_rec(struct slice_info_rec *slice_info, struct view_rec *view);
int change_group_view_ids(struct slice_info_rec *slice_info, char *view_id,
    char *new_id);
int change_slice_image_label(struct hdr_scan_entry_rec *slice,
    char *img_label);
void reflect_view_slice_num(struct view_rec *view);
void init_view_rec(struct view_rec *view);
void free_view_rec(struct view_rec *view);
void init_input_file_rec(struct input_file_rec *file, struct prog_rec *prog);
int free_input_file_rec(struct input_file_rec *file);
void init_input_rec(struct input_rec *input, struct prog_rec *prog);
void free_input_rec(struct input_rec *input);



/*-----------------------------------------------------------------------
init_slice_attr_rec - ???
-----------------------------------------------------------------------*/

void
init_slice_attr_rec(slice)
 struct slice_attr_rec *slice;
{
 slice->info = NULL;
 slice->slice_roi_win = NULL;
 slice->view = NULL;
 init_buf_2d_rec(&(slice->_2d));
 init_buf_2d_rec(&(slice->roi_2d));
 slice->min_pixel = 1.0;
 slice->max_pixel = 0;
}


/*-----------------------------------------------------------------------
free_slice_attr_rec - ???
-----------------------------------------------------------------------*/

void
free_slice_attr_rec(slice)
 struct slice_attr_rec *slice;
{
 free_buf_2d_rec(&(slice->_2d));
 free_buf_2d_rec(&(slice->roi_2d));
}


/*-----------------------------------------------------------------------
init_slice_info_rec - ???
-----------------------------------------------------------------------*/

void
init_slice_info_rec(slice_info)
 struct slice_info_rec *slice_info;
{
 slice_info->status = 0;
 slice_info->max_sroi_wins = slice_info->num_sroi_wins = 0;
 slice_info->sroi_wins = NULL;
 slice_info->num_slices = 0;
 slice_info->slices = NULL;
 slice_info->min_pixel = 1.0;
 slice_info->max_pixel = 0;
 slice_info->total_3ds = slice_info->num_3ds = 0;
 slice_info->_3ds = NULL;
 slice_info->num_3d_sampled_pts = 0;
 slice_info->total_views = slice_info->num_views = 0;
 slice_info->views = NULL;
 slice_info->select_3d_gravity = 0; 
 slice_info->group_num = 0;
 setup_vector_3d_rec(&(slice_info->translate),.0,.0,.0);
 setup_vector_3d_rec(&(slice_info->rotate),.0,.0,.0);

 slice_info->total_data_slices = slice_info->num_data_slices = 0;
 slice_info->data_slices = NULL;

}


/*-----------------------------------------------------------------------
free_slice_info_rec - ???
-----------------------------------------------------------------------*/

void
free_slice_info_rec(slice_info)
 struct slice_info_rec *slice_info;
{
 unsigned long cnt;

 PRT4(printf("free_slice_info_rec..max_sroi_wins = %d\n",slice_info->max_sroi_wins))

 FreeSliceRoiWinRecs(slice_info->sroi_wins,slice_info->max_sroi_wins);
 for (cnt = 0; cnt < slice_info->max_sroi_wins; cnt++)
    c_free(slice_info->sroi_wins[cnt]);
 c_free(slice_info->sroi_wins);

 PRT4(printf("free_slice_info_rec..num_slices = %d\n",slice_info->num_slices))
 for (cnt = 0; cnt < slice_info->num_slices; cnt++)
    free_slice_attr_rec(&(slice_info->slices[cnt]));
 c_free(slice_info->slices);

 PRT4(printf("free_slice_info_rec...total_3ds = %d\n",slice_info->total_3ds))

 if (slice_info->total_3ds > 0)
    {for (cnt = 0; cnt < slice_info->num_3ds; cnt++)
        free_buf_3d_rec(slice_info->_3ds[cnt]);
     for (cnt = 0; cnt < slice_info->total_3ds; cnt++)
        c_free(slice_info->_3ds[cnt]);
     c_free(slice_info->_3ds);
    }
 PRT4(printf("free_slice_info_rec...total_views = %d\n",slice_info->total_views))

 if (slice_info->total_views > 0)
    {
     for (cnt = 0; cnt < slice_info->num_views; cnt++)
        {
         free_view_rec(slice_info->views[cnt]);
         c_free(slice_info->views[cnt]);}
     c_free(slice_info->views);
    }

 PRT4(printf("free_slice_info_rec...total_data_slices = %d\n",
              slice_info->total_data_slices))
 if (slice_info->total_data_slices > 0)
    {
     for (cnt = 0; cnt < slice_info->num_data_slices; cnt++)
        {
         free_data_slice_rec(slice_info->data_slices[cnt]);
         c_free(slice_info->data_slices[cnt]);}
     c_free(slice_info->data_slices);
    }
 PRT4(printf("free_slice_info_rec...4\n"))
}


/*-----------------------------------------------------------------------
setup_file_attrs - ???
-----------------------------------------------------------------------*/

int
setup_file_attrs(file)
 struct input_file_rec *file;
{
 int err;
 unsigned long lcv,cnt;

 PRT3(printf("setup_file_attrs...num_slices = %d\n",
         file->slice_info.num_slices))
 file->slice_info.min_pixel = file->hdr.data_info.min_pixel;
 file->slice_info.max_pixel = file->hdr.data_info.max_pixel;
 for (cnt = 0; cnt < file->slice_info.num_slices; cnt++)
    free_slice_attr_rec(&(file->slice_info.slices[cnt]));
 c_free(file->slice_info.slices);
 file->slice_info.num_slices = 0;
 PRT3(printf("setup_file_attrs...file->hdr.num_scans = %d\n",
           file->hdr.num_scans))

 get_ptr_memory(&(file->slice_info.slices),&(file->slice_info.num_slices),
       file->hdr.num_scans,
       (size_t) sizeof(*(file->slice_info.slices)),&err);
 if (err) return err;
 for (lcv = 0; lcv < file->slice_info.num_slices; lcv++)
    {file->slice_info.slices[lcv].info = &(file->slice_info);
     file->slice_info.slices[lcv].min_pixel = 1.0;
     file->slice_info.slices[lcv].max_pixel = 0;
     file->slice_info.slices[lcv].slice_roi_win = NULL;
     init_buf_2d_rec(&(file->slice_info.slices[lcv]._2d));
     init_buf_2d_rec(&(file->slice_info.slices[lcv].roi_2d));
     file->slice_info.slices[lcv].view = NULL;
     file->hdr.scans[lcv].slice = &(file->slice_info.slices[lcv]);
    }
 PRT3(printf("setup_file_attrs...3\n"))
 err = build_slice_roi_win_rec(file);
 PRT3(printf("setup_file_attrs...err = %d end\n",err))
 return err;
}


/*-----------------------------------------------------------------------
file_def_3d_gravity - ???
-----------------------------------------------------------------------*/

void
file_def_3d_gravity(file)
 struct input_file_rec *file;
{
 if (file->hdr.data_info.var_use_status & _3D_IMAGE_ORDER_SET)
    {if (file->hdr.data_info.var_use_status & _3D_IMAGE_BOTTOM_TO_TOP)
        file->slice_info.select_3d_gravity = _3D_SLICE_BOTTOM_TO_TOP; 
    }
   else if (str_cmp(file->hdr.data_info.image_id,MRI) == 0)
    file->slice_info.select_3d_gravity = _3D_SLICE_BOTTOM_TO_TOP; 
}


/*-----------------------------------------------------------------------
init_co_register_rec - ???
-----------------------------------------------------------------------*/

void
init_co_register_rec(co)
 struct co_register_rec *co;
{
 co->wid = NULL;
 co->coplane_of_wid = NULL;
 co->status = 0;
}


/*-----------------------------------------------------------------------
free_co_register_rec - ???
-----------------------------------------------------------------------*/

void
free_co_register_rec(co)
 struct co_register_rec *co;
{
 c_free(co->wid);
 c_free(co->coplane_of_wid);
 init_co_register_rec(co);
}


/*-----------------------------------------------------------------------
init_file_register_rec - ???
-----------------------------------------------------------------------*/

void
init_file_register_rec(freg)
 struct file_register_rec *freg;
{
 freg->regfile = NULL;
 init_co_register_rec(&(freg->co));
}


/*-----------------------------------------------------------------------
free_file_register_rec - ???
-----------------------------------------------------------------------*/

void
free_file_register_rec(freg)
 struct file_register_rec *freg;
{
 freg->regfile = NULL;
 free_co_register_rec(&(freg->co));
}


/*-----------------------------------------------------------------------
init_file_co_register_rec - ???
-----------------------------------------------------------------------*/

void
init_file_co_register_rec(fco)
 struct file_co_register_rec *fco;
{
 fco->total_cos = 0;
 fco->num_cos = 0;
 fco->cos = NULL;
}


/*-----------------------------------------------------------------------
free_file_co_register_rec - ???
-----------------------------------------------------------------------*/

void
free_file_co_register_rec(fco)
 struct file_co_register_rec *fco;
{
 unsigned long lcv;

 if (fco->total_cos > 0)
    {for (lcv = 0; lcv < fco->num_cos; lcv++)
        {free_file_register_rec(fco->cos[lcv]);
         c_free(fco->cos[lcv]);
        }
     c_free(fco->cos);}
}


/*-----------------------------------------------------------------------
find_file_register_rec - ???

 which & 4 then the found co-reg param must be status & CO_REG_PARAM_IN_USE
 !(which & 1) && !(which & 2) then find co-reg param else default co-reg param
 which & 1 then find default co-reg param
 which & 2 then find co-reg param
-----------------------------------------------------------------------*/

struct file_register_rec *
find_file_register_rec( file, regfile, indx, which )
     struct input_file_rec *file,*regfile;
     unsigned long *indx;
     int which;
{
  unsigned long lcv,indx1;
  int exist;

  PRT4(printf("find_file_register_rec which = %d num_cos = %d\n",which,file->fco.num_cos));

  for (exist = 0,lcv = 0; lcv < file->fco.num_cos; lcv++)
  {
    if (file->fco.cos[lcv]->regfile == regfile)
    {
      exist = 1;
      indx1 = lcv;
      if (indx != NULL)
	*indx = lcv;
      if (which & 4)
	if (file->fco.cos[lcv]->co.status & CO_REG_PARAM_IN_USE)
	{
	  PRT4(printf("find_file_register_rec 1 status = %x\n",
		      (unsigned long) file->fco.cos[indx1]->co.status));
	  return file->fco.cos[lcv];
	}
      if (((which & 1) && (file->fco.cos[lcv]->co.status & CO_REG_PARAM_DEFAULT)) ||
	  ((which & 2) && (file->fco.cos[lcv]->co.status & CO_REG_PARAM_REG)))
      {
	PRT4(printf("find_file_register_rec 2 status = %x\n",
		    (unsigned long) file->fco.cos[indx1]->co.status));
	return file->fco.cos[lcv];
      }
    }
  }
  PRT4(printf("find_file_register_rec exist = %d which = %d\n",exist,which));

  if (exist && !(which & 3))
  {
    PRT4(printf("find_file_register_rec 3 status = %x\n",
		(unsigned long) file->fco.cos[indx1]->co.status));
    return file->fco.cos[indx1];
  }

  PRT4(printf("find_file_register_rec which NULL\n",which));
  return NULL;
}


/*-----------------------------------------------------------------------
SetFileRegisterRecInUse - ???
-----------------------------------------------------------------------*/

int
SetFileRegisterRecInUse(file,regfile,which)
 struct input_file_rec *file,*regfile;
 int which;
{
 int next;
 struct file_register_rec *fco;

 PRT4(printf("SetFileRegisterRecInUse...which = %d\n",which))
 if ((which != 1) && (which != 2)) return CANCEL;
 next = which % 2 + 1;
 if ((fco = find_file_register_rec(file,regfile,NULL,next)) != NULL)
    {PRT4(printf("...set next = %d   status = %x  not in use\n",next,
                (unsigned long) fco->co.status))
     fco->co.status &= ~CO_REG_PARAM_IN_USE;}

 if ((fco = find_file_register_rec(file,regfile,NULL,which)) == NULL)
    {PRT4(printf("...set next = %d == NULL\n",next))
     return CANCEL;}

 fco->co.status |= CO_REG_PARAM_IN_USE;
 PRT4(printf("SetFileR...which = %d status = %x IN_USE\n",fco,which,
                (unsigned long) fco->co.status))
 return NO_ERROR;
}




/*-----------------------------------------------------------------------
add_file_register_rec - ???
-----------------------------------------------------------------------*/

int
add_file_register_rec(file,regfile,co,coindx,which)
     struct input_file_rec *file,*regfile;
     struct file_register_rec *co;
     unsigned long *coindx;
     int which;
{
 struct file_register_rec *co1;
 unsigned long lcv,indx;
 int err;

 PRT4(printf("add_file_register_rec...1\n"))
 if ((co1 = find_file_register_rec(file,regfile,coindx,which)) != NULL)
    {co1->co.reg = co->co.reg;
     co1->co.coreg = co->co.coreg;
     co1->coregxyztoregxyz = co->coregxyztoregxyz;
     co1->localto = co->localto;
     co1->tolocal = co->tolocal;
     return NO_ERROR;}
 if (file->fco.num_cos >= file->fco.total_cos)
    {indx = file->fco.total_cos;
     if ((err = get_ptr(&(file->fco.cos),&(file->fco.total_cos),5,
            (size_t) sizeof(*(file->fco.cos)))) != NO_ERROR)
        return err;
     for (lcv = indx; lcv < file->fco.total_cos; lcv++)
        file->fco.cos[lcv] = NULL;
    }
 PRT4(printf("add_file_register_rec...2\n"))
 if ((err = get_ptr(&co1,NULL,1,(size_t) sizeof(*co1))) != NO_ERROR)
    return err;
 init_co_register_rec(&(co1->co));
 PRT4(printf("add_file_register_rec...3\n"))
 co1->regfile = regfile;
 co1->co.reg = co->co.reg;
 co1->co.coreg = co->co.coreg;
 co1->coregxyztoregxyz = co->coregxyztoregxyz;
 co1->localto = co->localto;
 co1->tolocal = co->tolocal;
 if (which == 1) 
    co1->co.status |= CO_REG_PARAM_DEFAULT;
   else co1->co.status |= CO_REG_PARAM_REG;
 file->fco.cos[file->fco.num_cos] = co1;
 if (coindx != NULL) *coindx = file->fco.num_cos;
 file->fco.num_cos += 1;
 PRT4(printf("add_file_register_rec...num_cos = %d\n",file->fco.num_cos))
 return NO_ERROR;
}




/*-----------------------------------------------------------------------
drop_file_co_register_rec - ???
-----------------------------------------------------------------------*/

int
drop_file_co_register_rec(file,co)
     struct input_file_rec *file;
     struct file_register_rec *co;
{
 unsigned long lcv;

 for (lcv = 0; lcv < file->fco.num_cos; lcv++)
    if (file->fco.cos[lcv] == co)
       {free_file_register_rec(co);
        c_free(co);
        file->fco.num_cos -= 1;
        for (; lcv < file->fco.num_cos; lcv++)
           file->fco.cos[lcv] = file->fco.cos[lcv + 1];
        file->fco.cos[lcv] = NULL;
        return NO_ERROR;}
 return NOT_FOUND;
}



/*-----------------------------------------------------------------------
FileName - ???
-----------------------------------------------------------------------*/

int
FileName(file,fn)
     struct input_file_rec *file;
     char **fn;
{
  return build_fn(fn,file->dirfn,file->fn,file->hdr_fn_suffix);
}




/*-----------------------------------------------------------------------
AllFiles - ???

if (select & 1) then include the current file
-----------------------------------------------------------------------*/

int
AllFiles( file, fns, is_sorted, select )
     struct input_file_rec *file;
     struct strs_rec *fns;
     int is_sorted;
     int select;
{
  struct input_file_rec *file1;
  int err;
  long lcv;
  char *fn,*cur_str;


  PRT(printf("AllFiles(...total_wins = %d\n",win->root->total_wins););

  cur_str = NULL;
  for (lcv = 0; lcv < file->prog->input.num_files; lcv++)
  {
    if (((file1 = file->prog->input.files[lcv]) != NULL) &&
	((file1 != file) || select))
    {
      if ((err = build_fn( &fn,
			   file1->dirfn,
			   file1->fn,
			   file1->hdr_fn_suffix)) == NO_ERROR)
      {
	if ((err = add_str_ptr_to_strs_rec(fns,fn)) != NO_ERROR)
	{
	  c_free(fn);
	  return err;
	}
      }
      else
	return err;
      if (file1 == file)
      {
	fns->cur_str = fns->num_strs - 1;
	cur_str = fns->strs[fns->cur_str];
      }
    }
  }
  PRT(printf("AllFiles(...1...num_strs = %d\n",fns->num_strs););

  if (is_sorted)
  {
    sort_strs_rec_ascendingly(fns);
    if (cur_str != NULL)
    {
      lcv = find_handle_element( fns->strs,
				 fns->num_strs,
				 cur_str,
				 &err );
      if (err == NO_ERROR)
	fns->cur_str = lcv;
      else
	fns->cur_str = 0;
    }
    else fns->cur_str = 0;
  }
  return NO_ERROR;
}




/*-----------------------------------------------------------------------
find_file - ???
-----------------------------------------------------------------------*/

struct input_file_rec *
find_file( file, fn, indx )
     struct input_file_rec *file;
     char *fn;
     unsigned long *indx;
{
  struct strs_rec fns;
  unsigned long indx1;

  init_strs_rec(&fns);
  AllFiles( file, &fns, 1, 1 );

  PRT4(printf("find_file...fn = %s, num_strs = %d\n",fn,fns.num_strs));

  if (FindStrInSortedStrsRec( &fns, fn, &indx1 ) == NO_ERROR)
  {
    PRT4(printf("find_file...indx1 = %d\n",indx1));
    free_strs_rec(&fns);
    if (indx != NULL)
      *indx = indx1;
    return file->prog->input.files[indx1];
  }
  free_strs_rec(&fns);
  return NULL;
}




/*-----------------------------------------------------------------------
setup_default_text_format_fn - ???
-----------------------------------------------------------------------*/

int
setup_default_text_format_fn(file)
 struct input_file_rec *file;
{
 int err;

 PRT(printf("setup_default_text_format_fn...\n"))
 if (file->hdr.data_info.num_echoes == 2)
    err = cp_str(&(file->txt_format_fn),
                 file->prog->defaults.whch.txt_format_fn);
   else
    err = cp_str(&(file->txt_format_fn),
             file->prog->defaults.whch.txt_format_fn_1_echo);
 if (err == NO_ERROR)
    err = cp_str(&(file->count_format_fn),
       file->prog->defaults.whch.txt_format_fn_count_value);
 PRT(printf("setup_default_text_format_fn...end\n"))

 return err;
}


/***************
update_hdr_file(file)
 struct input_file_rec *file;
{
 char *fn;
 int err;

 if (file->status & FILE_OPEN_ERROR) return CANCEL;
 str_dealloc_and_cpy(&(file->hdr.extra_info.last_edit_begin),file->edit_begin);
 str_dealloc_and_cpy(&(file->hdr.extra_info.last_edit_end),current_asctime());
 if (file->color_guide != NULL)
    {TRACE(printf("update_hdr_file...2 0\n"))
     memcpy(&(file->hdr.extra_info.color_control),
         &(file->color_guide->color_control),
         (size_t) sizeof(struct color_control_rec));}

 if ((err = build_fn(&fn,file->dirfn,file->fn,file->hdr_fn_suffix)) == NO_ERROR)
    {wr_the_hdr(fn,&(file->hdr));
     c_free(fn);}
 return err;
}
*****************/


/*-----------------------------------------------------------------------
init_data_slice_rec - ???
-----------------------------------------------------------------------*/

void
init_data_slice_rec(slice)
 struct data_slice_rec *slice;
{
 init_hdr_scan_entry_rec(&(slice->slice));
 init_slice_attr_rec(&(slice->attr));
 init_slice_roi_win_rec(&(slice->slice_roi_win),0,0);
}


/*-----------------------------------------------------------------------
free_data_slice_rec - ???
-----------------------------------------------------------------------*/

void
free_data_slice_rec(slice)
 struct data_slice_rec *slice;
{
 free_hdr_scan_entry_rec(&(slice->slice));
 free_slice_attr_rec(&(slice->attr));
 free_slice_roi_win_rec(&(slice->slice_roi_win));
}


/*-----------------------------------------------------------------------
setup_data_slice_rec - ???
-----------------------------------------------------------------------*/

int
setup_data_slice_rec(slice,info,
     view,img_label,num,prior_slice,next_slice,partner_slice)
 struct data_slice_rec *slice;
 struct slice_info_rec *info;
 struct view_rec *view;
 char *img_label;
 unsigned long num;
 struct hdr_scan_entry_rec *prior_slice;
 struct hdr_scan_entry_rec *next_slice;
 struct hdr_scan_entry_rec *partner_slice;
{
 cp_str(&(slice->slice.img_label),img_label);
 slice->slice.num = num + 1;
 slice->slice.img_addr = 0;
 slice->slice.slice_num = num;
 slice->slice.scan_num = 0;
 slice->slice.echo_num = 0;
 slice->slice.prior_slice = prior_slice;
 slice->slice.next_slice = next_slice;
 slice->slice.partner_slice = partner_slice;
 slice->slice.slice = &(slice->attr);
 slice->attr.slice_roi_win = &(slice->slice_roi_win);
 slice->attr.info = info;
 slice->attr.view = view;
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
drop_data_slice - ???
-----------------------------------------------------------------------*/

void
drop_data_slice(file,data_slice)
 struct input_file_rec *file;
 struct data_slice_rec *data_slice;
{
 unsigned long lcv,cnt;

 printf("drop_data_slice file->slice_info.num_data_slices = %ld\n",
           file->slice_info.num_data_slices);
 if (file->slice_info.num_data_slices > 0)
    {for (lcv = 0; lcv < file->slice_info.num_data_slices; lcv++)
        if (file->slice_info.data_slices[lcv] == data_slice)
           {for (cnt = lcv + 1; cnt < file->slice_info.num_data_slices; cnt++)
               file->slice_info.data_slices[cnt - 1] = 
                        file->slice_info.data_slices[cnt];
            file->slice_info.data_slices[cnt - 1] = NULL;
            file->slice_info.num_data_slices -= 1;
            break;}
    }
 printf("drop_data_slice end file->slice_info.num_data_slices = %ld\n",
           file->slice_info.num_data_slices);
}


/*-----------------------------------------------------------------------
add_data_slice - ???
-----------------------------------------------------------------------*/

int
add_data_slice(file,data_slice)
 struct input_file_rec *file;
 struct data_slice_rec *data_slice;
{
 unsigned long lcv;
 int err;

 if (file->slice_info.num_data_slices == file->slice_info.total_data_slices)
    {get_handle_memory(&(file->slice_info.data_slices),
            &(file->slice_info.total_data_slices),5,
            (size_t) sizeof(*(file->slice_info.data_slices)),&err);
     if (err != NO_ERROR) return err;
     for (lcv = file->slice_info.num_data_slices;
             lcv < file->slice_info.total_data_slices; lcv++)
        file->slice_info.data_slices[lcv] = NULL;
    }
 file->slice_info.data_slices[file->slice_info.num_data_slices] =
          data_slice;
 file->slice_info.num_data_slices += 1;
 return NO_ERROR;
}

/*******************
add_slice_info_3d(slice_info,_3d)
 struct slice_info_rec *slice_info;
 struct buf_3d_rec *_3d;
{
 int err;
 unsigned long cnt;

 if (slice_info->num_3ds == slice_info->total_3ds)
    {if ((err = get_ptr(&(slice_info->_3ds),&(slice_info->total_3ds),
         1,(size_t) sizeof(*(slice_info->_3ds)))) != NO_ERROR)
        return err;
    }
 slice_info->_3ds[slice_info->num_3ds] = _3d;
 slice_info->num_3ds += 1;
 PRT5(printf("add_slice_info_3d _3d = %u num_3ds = %d total_3ds = %d\n",
        slice_info->num_3ds,slice_info->total_3ds))
 PRT5(printf("add_slice_info_3d _3d->id = %s\n",_3d->id))
 PRT5(for (cnt = 0; cnt < slice_info->num_3ds; cnt++)
         printf("%d id = %s\n",cnt,slice_info->_3ds[cnt]->id))

 return NO_ERROR;
}
********************/


/*-----------------------------------------------------------------------
add_slice_info_3d - ???
-----------------------------------------------------------------------*/

int
add_slice_info_3d(slice_info,_3d)
 struct slice_info_rec *slice_info;
 struct buf_3d_rec *_3d;
{
 int err;
 unsigned long indx,cnt;

 if (slice_info->num_3ds == 0) indx = 0;
   else if (obj_binary_search(slice_info->_3ds,slice_info->num_3ds,
      (size_t) sizeof(*(slice_info->_3ds)),&_3d,SortBuf3dRec,&indx) == NO_ERROR)
    {PRT5(printf("add_slice_info_3d found indx = %d _3d->id = %s\n",
           indx,_3d->id))
     return NO_ERROR;}

 if (slice_info->num_3ds == slice_info->total_3ds)
    {if ((err = get_ptr(&(slice_info->_3ds),&(slice_info->total_3ds),
         1,(size_t) sizeof(*(slice_info->_3ds)))) != NO_ERROR)
        return err;
    }
 slice_info->_3ds[slice_info->num_3ds] = _3d;

 for (cnt = slice_info->num_3ds; cnt > indx; cnt--)
    slice_info->_3ds[cnt] = slice_info->_3ds[cnt - 1];
 slice_info->_3ds[indx] = _3d;

 slice_info->num_3ds += 1;
 PRT5(printf("add_slice_info_3d _3d = %u  indx = %d num_3ds = %d total_3ds = %d\n",
        _3d,indx,slice_info->num_3ds,slice_info->total_3ds))
 PRT5(printf("add_slice_info_3d _3d->id = %s\n",_3d->id))
 PRT5(for (cnt = 0; cnt < slice_info->num_3ds; cnt++)
         printf("%d id = %s\n",cnt,slice_info->_3ds[cnt]->id))

 return NO_ERROR;
}


/*-----------------------------------------------------------------------
drop_slice_info_3d - ???
-----------------------------------------------------------------------*/

int
drop_slice_info_3d(slice_info,_3d)
 struct slice_info_rec *slice_info;
 struct buf_3d_rec *_3d;
{
 long lcv;

 for (lcv = 0; lcv < slice_info->num_3ds; lcv++)
    if (slice_info->_3ds[lcv] == _3d)
       {slice_info->num_3ds -= 1;
        for (; lcv < slice_info->num_3ds; lcv++)
           slice_info->_3ds[lcv] = slice_info->_3ds[lcv + 1];
        slice_info->_3ds[slice_info->num_3ds] = NULL;
        return NO_ERROR;
       }

 return NO_ERROR;
}


/*-----------------------------------------------------------------------
add_view_rec - ???
-----------------------------------------------------------------------*/

int
add_view_rec(slice_info,view)
 struct slice_info_rec *slice_info;
 struct view_rec *view;
{
 int err;

 if (slice_info->total_views <= slice_info->num_views)
    {
     get_ptr_memory(&(slice_info->views),&(slice_info->total_views),4,
             (size_t) sizeof(*(slice_info->views)),&err);
     if (err != NO_ERROR) return err;}
 slice_info->views[(slice_info->num_views)++] = view;
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
drop_view_rec - ???
-----------------------------------------------------------------------*/

int
drop_view_rec(slice_info,view)
 struct slice_info_rec *slice_info;
 struct view_rec *view;
{
 unsigned long cnt;

 for (cnt = 0; cnt < slice_info->num_views; cnt++)
    if (slice_info->views[cnt] == view)
       {for (cnt += 1; cnt < slice_info->num_views; cnt++)
           slice_info->views[cnt - 1] = slice_info->views[cnt];
        (slice_info->num_views)--;
        slice_info->views[slice_info->num_views] = NULL;}
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
change_group_view_ids - ???
-----------------------------------------------------------------------*/

int
change_group_view_ids(slice_info,view_id,new_id)
 struct slice_info_rec *slice_info;
 char *view_id,*new_id;
{
 unsigned long cnt,total,lcv;
 int err;
 char **strs;

 total = 0;
 if ((err = get_ptr(&strs,&total,slice_info->num_views,
       (size_t) sizeof(*strs))) != NO_ERROR)
    return err;
 for (cnt = 0; cnt < total; cnt++)
    strs[cnt] = NULL;

 for (cnt = 0; cnt < total; cnt++)
    if (str_cmp(slice_info->views[cnt]->id,view_id) == 0)
       if ((err = cp_str(&(strs[cnt]),new_id)) != NO_ERROR)
          {
           for (lcv = 0; lcv < cnt; lcv++) c_free(strs[lcv]);
           break;
          }
 if (err == NO_ERROR)
    {for (cnt = 0; cnt < slice_info->num_views; cnt++)
        if (strs[cnt] != NULL)
           {c_free(slice_info->views[cnt]->id);
            slice_info->views[cnt]->id = strs[cnt];}
    }
 c_free(strs);
 return err;
}


/*-----------------------------------------------------------------------
change_slice_image_label - ???
-----------------------------------------------------------------------*/

int
change_slice_image_label(slice,img_label)
 struct hdr_scan_entry_rec *slice;
 char *img_label;
{
 char *str;
 int err;

 if ((err = cp_str(&str,img_label)) == NO_ERROR)
    {c_free(slice->img_label);
     slice->img_label = str;
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
reflect_view_slice_num - ???
-----------------------------------------------------------------------*/

void
reflect_view_slice_num(view)
 struct view_rec *view;
{
 view->sl.slice.num = view->gplane.plane_num + 1;
 view->sl.slice.slice_num = view->gplane.plane_num;
}


/*-----------------------------------------------------------------------
init_view_rec - ???
-----------------------------------------------------------------------*/

void
init_view_rec(view)
 struct view_rec *view;
{
 view->status = 0;
 view->more_status = 0;
 view->id = NULL;
 view->wid = NULL;
 view->group_num = 0;

 init_data_slice_rec(&(view->sl));
 setup_list_rec(&(view->_3d_list),NULL,NULL,NULL,NULL,NULL);
 view->img = NULL;

 init_plane_3d_rec(&(view->gplane));
 init_strs_rec(&(view->rois));
 init_strs_rec(&(view->pixel_types));
 init_strs_rec(&(view->roi_pixel_types));
 init_strs_rec(&(view->all_rois));
 view->total_roi_2ds = view->num_roi_2ds = 0;
 view->roi_2ds = NULL;
 view->total_type_2ds = view->num_type_2ds = 0;
 view->type_2ds = NULL;
 init_strs_rec(&(view->mask_rois));
 init_ary_3d_xyz_rec(&(view->xyz));
 view->num_cos = view->total_cos = 0;
 view->cos = NULL;
 view->dp_xyz_co_reg_wid = NULL;
}



/*-----------------------------------------------------------------------
free_view_rec - ???
-----------------------------------------------------------------------*/

void
free_view_rec(view)
     struct view_rec *view;
{
  unsigned long lcv;
  
  TRACE(printf("free_view_rec...view->img->file->slice_info.num_views = %d\n",
	       view->img->file->slice_info.num_views));
  c_free(view->id);
  c_free(view->wid);
  free_data_slice_rec(&(view->sl));
  free_strs_rec(&(view->rois));
  free_strs_rec(&(view->pixel_types));
  free_strs_rec(&(view->roi_pixel_types));
  free_strs_rec(&(view->all_rois));

  if (view->total_roi_2ds > 0)
  {
    for (lcv = 0; lcv < view->num_roi_2ds; lcv++)
    {
      free_buf_2d_rec(view->roi_2ds[lcv]);
      c_free(view->roi_2ds[lcv]);
    }
    c_free(view->roi_2ds);
  }

  if (view->total_type_2ds > 0)
  {
    for (lcv = 0; lcv < view->num_type_2ds; lcv++)
    {
      free_buf_2d_rec(view->type_2ds[lcv]);
      c_free(view->type_2ds[lcv]);
    }
    c_free(view->type_2ds);
  }

  delete_item_from_list(&(view->_3d_list));
  free_strs_rec(&(view->mask_rois));
  free_ary_3d_xyz_rec(&(view->xyz));
  if (view->total_cos > 0)
  {
    for (lcv = 0; lcv < view->num_cos; lcv++)
      free_co_register_rec(&(view->cos[lcv]));
    c_free(view->cos);
  }
  c_free(view->dp_xyz_co_reg_wid);

  init_view_rec(view);
}



/*-----------------------------------------------------------------------
init_input_file_rec - ???
-----------------------------------------------------------------------*/

void
init_input_file_rec(file,prog)
 struct input_file_rec *file;
 struct prog_rec *prog;
{
 TRACE(printf("init_input_file_rec...\n"))
 
 file->prog = prog;
 file->status = 0;
 file->dirfn = NULL;
 file->fn = NULL;
 file->hdr_fn_suffix = NULL;
 file->img_fn_suffix = NULL;
 init_hdr_rec(&(file->hdr));
 init_img_rec(&(file->img),file);
 init_slice_info_rec(&(file->slice_info));

 init_pixel_type_rec(&(file->pixel_type));

 init_histo_params_rec(&(file->histo_params),file);
 init_output_file_rec(&(file->output),file);
 file->color_guide = NULL;
 cp_str(&(file->edit_begin),current_asctime());
 file->txt_format_fn = NULL;
 file->count_format_fn = NULL;
 init_text_output_rec(&(file->text),file);
 init_count_analysis_rec(&(file->count),file);
 init_file_co_register_rec(&(file->fco));
}



/*-----------------------------------------------------------------------
free_input_file_rec - ???
-----------------------------------------------------------------------*/

int
free_input_file_rec(file)
     struct input_file_rec *file;
{
  PRT2(printf("free_input_file_rec....\n"));
  if (!(file->status & FILE_OPEN)) 
  {
    return NO_ERROR;
  }
  c_free(file->dirfn);
  c_free(file->fn);
  c_free(file->hdr_fn_suffix);
  c_free(file->img_fn_suffix);
  if (file->status & FILE_OPEN)
    fclose(file->img_fid);
  PRT2(printf("free_hdr_rec....\n"));
  free_hdr_rec(&(file->hdr));

  free_img_rec(&(file->img));

  PRT2(printf("after free_img_rec....\n"));
  PRT2(printf("before free_slice_info_rec....\n"));

  free_slice_info_rec(&(file->slice_info));

  PRT2(printf("before free_pixel_type_rec....\n"));
  free_pixel_type_rec(&(file->pixel_type));
  PRT2(printf("before free_histo_params_rec....\n"));
  free_histo_params_rec(&(file->histo_params));
  PRT2(printf("after free_histo_params_rec....\n"));

  PRT2(printf("close_output_file_rec....\n"));
  close_output_file_rec(&(file->output));
  PRT2(printf("after close_output_file_rec....\n"));

  c_free(file->edit_begin);
  PRT2(printf("after txt_format_fn....\n"));
  c_free(file->txt_format_fn);
  c_free(file->count_format_fn);

  free_text_output_rec(&(file->text));
  free_count_analysis_rec(&(file->count));

  free_file_co_register_rec(&(file->fco));

  init_input_file_rec(file,NULL);
  PRT2(printf("after free_input_file_rec....\n\n"));

  return NO_ERROR;
}



/*-----------------------------------------------------------------------
init_input_rec - ???
-----------------------------------------------------------------------*/

void
init_input_rec(input,prog)
struct input_rec *input;
 struct prog_rec *prog;
{
 input->total_files = input->num_files = 0;
 input->files = NULL;
 input->prog = prog;
}


/*-----------------------------------------------------------------------
free_input_rec - ???
-----------------------------------------------------------------------*/

void
free_input_rec(input)
struct input_rec *input;
{
 if (input->total_files > 0) c_free(input->files);
 init_input_rec(input,NULL);
}



#if 0      /**********************/

init_hdr_slice_roi_win_rec(hdr)
 struct hdr_rec *hdr;
{
 unsigned int lcv;

 TRACE(printf("hdr->num_slices = %d\n",hdr->num_slices))
 for (lcv = 0; lcv < hdr->num_slices; lcv++)
    hdr->slices[lcv].slice_roi_win = NULL;
 TRACE(printf("hdr->num_slices = %d end\n",hdr->num_slices))
}


unsigned int setup_img_type_slice_indx(scans,num_scans)
 struct hdr_scan_entry_rec *scans;
 unsigned int num_scans;
{
 struct hdr_scan_entry_rec *cur_slice;
 unsigned int indx,cnt;

 for (cnt = 0; cnt < num_scans; cnt++)
    {if (!(scans[cnt].status & SLICE_FIRST)) continue;
     cur_slice = &(scans[cnt]);
     indx = 0;
     do
        {cur_slice->slice->image_type_indx = indx;
         cur_slice = cur_slice->next_slice;
         indx++;
        }
     while (!(cur_slice->status & SLICE_FIRST)); 
    }
 return indx;
}
#endif   /***********************/


