/****************************************************************************
list_rec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  Should this be in the lib subdirectory instead?  It seems to
be reasonably generic rather than specific to nria.  -PWH 19990415
****************************************************************************/

static const char rcsid[] = "$Id: list_rec.c,v 1.5 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>

#include <sys/types.h>

#include "list_rec.h"
#include "error_constants.h"


/* Functions defined in this file */
void setup_list_rec(struct list_rec *list, void *item, void *item1,
 struct list_rec *head, struct list_rec *before, struct list_rec *next);
void setup_list_rec_common(struct list_rec *list, void *common);
struct list_rec *delete_item_from_list(struct list_rec *item_list);
int add_item_after_cur_list(struct list_rec *list, struct list_rec *item_list);
void add_item_before_cur_list(struct list_rec *list,
    struct list_rec *item_list);
void add_item_as_cur_list_head(struct list_rec *list,
    struct list_rec *item_list);
void add_item_as_cur_list_tail(struct list_rec *list,
    struct list_rec *item_list);
unsigned long cnt_num_list_items_from_head(struct list_rec *item_list);
unsigned long cnt_num_list_items_from_last(struct list_rec *item_list);
unsigned long cnt_num_list_items(struct list_rec *item_list);
struct list_rec *head_list(struct list_rec *list);
struct list_rec *tail_list(struct list_rec *list);
void *list_item(struct list_rec *list, int which_item);
void *head_item(struct list_rec *list, int which_item);
void *tail_item(struct list_rec *list, int which_item);
void *next_list_item(struct list_rec *list, int which_item);
void pr_list_rec(struct list_rec *list, int (*pr_item)());
void pr_list_rec1(struct list_rec *list, int (*pr_item)());
struct list_rec *find_item(struct list_rec *list, void *item, int select);



/*--------------------------------------------------------------------------
setup_list_rec - ???
--------------------------------------------------------------------------*/

void
setup_list_rec(list,item,item1,head,before,next)
 struct list_rec *list,*head,*before,*next;
 void *item,*item1;
{
 list->head = head;
 list->item = item;
 list->item1 = item1;
 if (head != NULL)
    list->common = head->common;
   else list->common = NULL;

 if (before != NULL) list->before = before;
   else list->before = list;

 if (next != NULL) list->next = next;
   else list->next = list;
}


/*--------------------------------------------------------------------------
setup_list_rec_common - ???
--------------------------------------------------------------------------*/

void
setup_list_rec_common(list,common)
 struct list_rec *list;
 void *common;
{
 struct list_rec *cur,*next;

 next = cur = list;
 do
    {
     next->common = common;
     next = next->next;
    }
 while (cur != next);
}


/*--------------------------------------------------------------------------
delete_item_from_list - ???
--------------------------------------------------------------------------*/

struct list_rec *
delete_item_from_list(item_list)
 struct list_rec *item_list;
{
 struct list_rec *list,*next;

 next = item_list->next;
 if (item_list->head == NULL)
    {
     next->head = NULL;
     if (next != item_list->before)
        {
         for (list = next->next; list->head != NULL; list = list->next)
            list->head = next;
        }
    }

 next->before = item_list->before;
 item_list->before->next = next;

 setup_list_rec(item_list,item_list->item,item_list->item1,NULL,NULL,NULL);
 return next;
}


/*--------------------------------------------------------------------------
add_item_after_cur_list - ???
--------------------------------------------------------------------------*/

int
add_item_after_cur_list(list,item_list)
 struct list_rec *list,*item_list;
{
 struct list_rec *before,*next;

 delete_item_from_list(item_list);
 before = list->before;
 next = list->next;
 if (next == list) list->next = item_list;
   else
    {next->before = item_list;
     list->next = item_list;}
 if (before == list) list->before = item_list;

 item_list->before = list;
 item_list->next = next;

 if (list->head == NULL) item_list->head = list;
   else item_list->head = list->head;

 return NO_ERROR;

}


/*--------------------------------------------------------------------------
add_item_before_cur_list - ???
--------------------------------------------------------------------------*/

void
add_item_before_cur_list(list,item_list)
 struct list_rec *list,*item_list;
{
 delete_item_from_list(item_list);
 add_item_after_cur_list(list->before,item_list);
}


/*--------------------------------------------------------------------------
add_item_as_cur_list_head - ???
--------------------------------------------------------------------------*/

void
add_item_as_cur_list_head(list,item_list)
 struct list_rec *list,*item_list;
{
 struct list_rec *cur,*next;

 if (list == item_list)
    {if (list->before == list->next) return;
     if (list->next != NULL) cur = list->next;
       else cur = list->before;
    }
   else cur = list;
 delete_item_from_list(item_list);

 if (cur->head != NULL) cur = cur->head;

 if (cur->head == NULL) next = cur;
   else next = cur->head;
 next = cur;
 do
    {
     next->head = item_list;
     next = next->next;
    }
 while (next != cur);

 cur->before->next = item_list;
 item_list->before = cur->before;
 item_list->next = cur;
 item_list->head = NULL;
 return /*NO_ERROR*/;

}


/*--------------------------------------------------------------------------
add_item_as_cur_list_tail - ???
--------------------------------------------------------------------------*/

void
add_item_as_cur_list_tail(list,item_list)
 struct list_rec *list,*item_list;
{
 struct list_rec *cur,*last;

 if (list == item_list)
    {if (list->before == list->next) return;
     if (list->next != NULL) cur = list->next;
       else cur = list->before;
    }
   else cur = list;
/*
 delete_item_from_list(item_list);
*/
 if (cur->head != NULL) cur = cur->head;

 last = item_list->before;
 cur->before->next = item_list;
 item_list->before = cur->before;

 cur->before = last;
 item_list->head = cur;

 last->next = cur;
 return /*NO_ERROR*/;
}


/*--------------------------------------------------------------------------
cnt_num_list_items_from_head - ???
--------------------------------------------------------------------------*/

unsigned long 
cnt_num_list_items_from_head(item_list)
 struct list_rec *item_list;
{
 struct list_rec *before;
 unsigned long cnt;

 cnt = 1;
 if (item_list->head == NULL) return cnt;
   else before = item_list->head->before;
 while (item_list != before)
    {item_list = item_list->before;
     cnt += 1;
    }
 return cnt;
}


/*--------------------------------------------------------------------------
cnt_num_list_items_from_last - ???
--------------------------------------------------------------------------*/

unsigned long 
cnt_num_list_items_from_last(item_list)
 struct list_rec *item_list;
{
 struct list_rec *last;
 unsigned long cnt;

 cnt = 1;
 if (item_list->head == NULL) last = item_list->before;
   else last = item_list->head->before;
 while (item_list != last)
    {item_list = item_list->next;
     cnt += 1;
    }
 return cnt;
}


/*--------------------------------------------------------------------------
cnt_num_list_items - ???
--------------------------------------------------------------------------*/

unsigned long 
cnt_num_list_items(item_list)
 struct list_rec *item_list;
{
 return cnt_num_list_items_from_head(item_list) +
        cnt_num_list_items_from_last(item_list) - 1;
}


/*--------------------------------------------------------------------------
head_list - ???
--------------------------------------------------------------------------*/

struct list_rec *
head_list(list)
 struct list_rec *list;
{
 if (list->head == NULL) return list;
   else return list->head;
}


/*--------------------------------------------------------------------------
tail_list - ???
--------------------------------------------------------------------------*/

struct list_rec *
tail_list(list)
 struct list_rec *list;
{
 if (list->head == NULL) return list->before;
   else return list->head->before;
}


/*--------------------------------------------------------------------------
list_item - ???
--------------------------------------------------------------------------*/

void *
list_item(list,which_item)
 struct list_rec *list;
 int which_item;
{
 if (list == NULL) return NULL;
 if (which_item == 0) return list->item;
 if (which_item == 1) return list->item1;
 return NULL;
}


/*--------------------------------------------------------------------------
head_item - ???
--------------------------------------------------------------------------*/

void *
head_item(list,which_item)
 struct list_rec *list;
 int which_item;
{
 return list_item(head_list(list),which_item);
}


/*--------------------------------------------------------------------------
tail_item - ???
--------------------------------------------------------------------------*/

void *
tail_item(list,which_item)
 struct list_rec *list;
 int which_item;
{
 return list_item(tail_list(list),which_item);
}


/*--------------------------------------------------------------------------
next_list_item - ???
--------------------------------------------------------------------------*/

void *
next_list_item(list,which_item)
 struct list_rec *list;
 int which_item;
{
 if (list == NULL) return NULL;
 return list_item(list->next,which_item);
}


/*--------------------------------------------------------------------------
pr_list_rec - ???
--------------------------------------------------------------------------*/

void
pr_list_rec(list,pr_item)
 struct list_rec *list;
 int (*pr_item)();
{
 struct list_rec *cur;

 if (list->head != NULL) cur = list->head;
   else cur = list;
 printf("\n");
 fflush(stdout);
 do
    {printf("list = %p  item = %p item1 = %p head = %p  before = %p  next = %p\n",
          cur,cur->item,cur->item1,cur->head,cur->before,cur->next);
     fflush(stdout);
     if (pr_item != NULL) pr_item(cur->item,cur->item1);
     cur = cur->next;
    }
 while (cur->head != NULL);
 printf("\n");
 fflush(stdout);
}



/*--------------------------------------------------------------------------
pr_list_rec1 - ???
--------------------------------------------------------------------------*/

void
pr_list_rec1(list,pr_item)
 struct list_rec *list;
 int (*pr_item)();
{
 struct list_rec *cur,*next;

 next = cur = list;
 printf("\n");
 fflush(stdout);
 do
    {printf("list = %p  item = %p item1 = %p common = %p head = %p  before = %p  next = %p\n",
          next,next->item,next->item1,next->common,next->head,next->before,next->next);
     fflush(stdout);
     if (pr_item != NULL) pr_item(next->item,next->item1);
     next = next->next;
    }
 while (cur != next);
 printf("\n");
 fflush(stdout);
}


/*--------------------------------------------------------------------------
find_item - ???
--------------------------------------------------------------------------*/

struct list_rec *
find_item(list,item,select)
 struct list_rec *list;
 void *item;
 int select;
{
 struct list_rec *next;

 next = list;
 do
    {if (next->item != NULL)
        if (select == 1)
           {if (item == next->item1) return next;}
          else 
           {if (item == next->item) return next;}
     next = next->next;
    }
 while (list != next);
 return NULL;
}


/********************
visit_each_list(list,arg1,arg2)
 struct list_rec *list;
 void *arg1,*arg2;
 int select;
{
 struct list_rec *next,*cur;
 int err;

 next = list;
 do
    {if (next->item != NULL)
        if (select == 1)
           {if (item == next->item1) return next;}
          else 
           {if (item == next->item) return next;}
     next = next->next;
    }
 while (list != next);
 return NULL;
}
***********************/

/*******************
main()
{
 struct list_rec list,l1,l2,l3,l4;

 setup_list_rec(&list,"a","a",NULL,NULL,NULL);
 setup_list_rec(&l1,"1","a",NULL,NULL,NULL);
 setup_list_rec(&l2,"2","a",NULL,NULL,NULL);
 setup_list_rec(&l3,"3","a",NULL,NULL,NULL);
 setup_list_rec(&l4,"4","a",NULL,NULL,NULL);
 add_item_after_cur_list(&list,&l1);
 add_item_after_cur_list(&l1,&l2);
 add_item_after_cur_list(&l2,&l3);
 add_item_after_cur_list(&l3,&l4);


 printf("cnt_num_list_items(item_list) = %d\n",
    cnt_num_list_items(&list));
 pr_list_rec(&list);
 printf("\n\n");
 delete_item_from_list(&l1);
 pr_list_rec(&list);

 printf("\n\n");

 add_item_before_cur_list(&l2,&l4);
 pr_list_rec(&list);
 printf("\n\n");

 add_item_as_cur_list_head(&l4,&l2);
 pr_list_rec(&l4);

 add_item_as_cur_list_tail(&l4,&l2);
 pr_list_rec(&l4);

}
****************************/

