/****************************************************************************
look_objects.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: look_objects.c,v 1.9 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "object.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define TRACE1(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define TRACE1(x)
#define PRT(x)



/* Functions defined in this file */
int neg_enter_xy_into_cur_obj(struct all_object_rec *all_objs, long x, long y,
    int is_breaker);
int get_neg_objs(struct all_object_rec *all_objs, struct object_rec *obj,
    struct object_rec *temp_obj, int is_breaker);
int scan_sub_objs(struct all_object_rec *sub, struct buf_2d_rec *obj_2d,
    struct buf_2d_rec *id_2d, struct int_bound_rec *bound, int lbval,
    int ubval, struct object_rec *obj, struct object_rec *temp_obj,
    int is_delete_internal_bpt, int is_breaker);
int detect_all_sub_objs(struct all_object_rec *all_objs,
    int is_delete_internal_bpt, int is_breaker);



/*------------------------------------------------------------------------
neg_enter_xy_into_cur_obj - ???

  By using the infection-like technique, each object element is assigned an
  object id by using the following rules :-
    Assumptions :
        a) the [x,y] element is the center element of a 3 * 3 matrix
        b) by scanning from left to right, only the object ids of the first 4 
           elements are considered

    Rules :
        1) if any of the first 4 elements are valid elements, since they are
           adjacent to [x,y], element [x,y] should then have the same ids as
           the 4.  And if the 4 and [x,y] are connected, they share the same id,
           therefore, if they have different ids, all the elements considered
           so far each having the same id as any of those ids should be 
           merged so that they have a common id.
        2) if the 4 are not valid, assign a new id for [x,y].
-----------------------------------------------------------------------*/

int
neg_enter_xy_into_cur_obj(all_objs,x,y,is_breaker)
 struct all_object_rec *all_objs;
 long x,y;
 int is_breaker;
{
 int err,err1,is_external,yes;
 unsigned long ids[4],num_ids;
 unsigned long tempx,tempy,val;
 struct object_rec *src_obj;
 unsigned long lcv;
 static int xy[4][2] = {{ -1, -1},{ 0, -1},{ 1, -1},{-1, 0}};
/*
 struct xy_rec xys[4];
*/
 if (all_objs->cur_obj == NULL)
    {all_objs->cur_obj = get_obj(all_objs,all_objs->next_id,&err);
     if (err != NO_ERROR) return err;
     if ((x <= all_objs->bound.left) || (x >= all_objs->bound.right) ||
         (y <= all_objs->bound.top) || (y >= all_objs->bound.bottom))
        {PRT(printf("1 is_external = 1 y = %d x = %d\n",y,x))
         all_objs->cur_obj->is_external = 1;}
    }
   else
    {num_ids = 0;
     is_external = 0;
     for (lcv = 0; lcv < 4; lcv++)
        {tempx = x + xy[lcv][0];
         tempy = y + xy[lcv][1];
         if ((tempx >= all_objs->bound.left) && 
             (tempx <= all_objs->bound.right) &&
             (tempy >= all_objs->bound.top) &&
             (tempy <= all_objs->bound.bottom))
            {
             if (val = get_1d_buf_value(all_objs->id_2d.buf[tempy],tempx,
                        all_objs->id_2d.pixel_depth))
                {if (lcv == 0)
                    {if (!(get_1d_buf_value(all_objs->in_2d->buf[y - 1],x,
                               all_objs->in_2d->pixel_depth) &&
                           get_1d_buf_value(all_objs->in_2d->buf[y],x - 1,
                               all_objs->in_2d->pixel_depth)))
                        yes = 1;
                       else if (is_breaker &&
                                ((x + 1) <= all_objs->bound.right) &&
                                ((y + 1) <= all_objs->bound.bottom))
                        {if (get_1d_buf_value(all_objs->in_2d->buf[y + 1],x,
                               all_objs->in_2d->pixel_depth) &&
                             get_1d_buf_value(all_objs->in_2d->buf[y],x + 1,
                               all_objs->in_2d->pixel_depth))
                            yes = 1;
                           else yes = 0;}
                       else yes = 0;
                     if (yes)
                        {/*xys[num_ids].x = tempx;
                         xys[num_ids].y = tempy;*/
                         ids[num_ids++] = val;
                        }
                      TRACE(else printf("Rejected lcv == 0 x = %d y = %d\n",x,y);)
                    }
                   else if (lcv == 2)
                    {if (!(get_1d_buf_value(all_objs->in_2d->buf[y - 1],x,
                               all_objs->in_2d->pixel_depth) &&
                           get_1d_buf_value(all_objs->in_2d->buf[y],x + 1,
                               all_objs->in_2d->pixel_depth)))
                        yes = 1;
                       else if (is_breaker &&
                                ((x - 1) >= all_objs->bound.left) &&
                                ((y + 1) <= all_objs->bound.bottom))
                        {if (get_1d_buf_value(all_objs->in_2d->buf[y + 1],x,
                               all_objs->in_2d->pixel_depth) &&
                             get_1d_buf_value(all_objs->in_2d->buf[y],x - 1,
                               all_objs->in_2d->pixel_depth))
                            yes = 1;
                           else yes = 0;}
                       else yes = 0;
                     if (yes)
                        {/*xys[num_ids].x = tempx;
                         xys[num_ids].y = tempy;*/
                         ids[num_ids++] = val;
                        }
                      TRACE(else printf("Rejected lcv == 2 x = %d y = %d\n",x,y);)
                    }
                   else
                   {
/*
                    xys[num_ids].x = tempx;
                    xys[num_ids].y = tempy;
*/
                    ids[num_ids++] = val;
                   }
                }
            }
           else 
            {
             is_external = 1;}
        }
     if (num_ids == 0)
        {
         all_objs->cur_obj = get_obj(all_objs,all_objs->next_id,&err);
         if (err != NO_ERROR) return err;
        }
       else
        {
         for (lcv = 1; lcv < num_ids; lcv++)
            if (ids[0] != ids[lcv]) break;
         if (lcv == num_ids)
            {if (ids[0] != all_objs->cur_obj->id)
                {all_objs->cur_obj = get_obj(all_objs,ids[0],&err);
                 if (err != NO_ERROR) return err;
                }
            }
           else 
            {

             for (lcv = 0; lcv < num_ids; lcv++)
                if (all_objs->cur_obj->id == ids[lcv])
                   break;
             if (lcv == num_ids)
                {all_objs->cur_obj = get_obj(all_objs,ids[0],&err);
                 if (err != NO_ERROR) return err;
                 lcv = 1;}
               else lcv = 0;

                for (; lcv < num_ids; lcv++)
                   if (all_objs->cur_obj->id != ids[lcv])
                      {src_obj = get_obj(all_objs,ids[lcv],&err1);
                       if (err1 == NO_ERROR)
                          {
/*
  PRT(printf("merge y = %d x = %d cur id = %d ext = %d is_ext = %d src = %d ext = %d tempy = %d x = %d\n",
                                 y,x,all_objs->cur_obj->id,
        (unsigned long) all_objs->cur_obj->is_external,is_external,src_obj->id,
               (unsigned long) src_obj->is_external,xys[lcv].y,xys[lcv].x);)
*/
                           merge_objs(all_objs,all_objs->cur_obj,src_obj);}
                      }
            }
        }
     if (is_external) 
        {all_objs->cur_obj->is_external = 1;
         PRT(
            printf("id = %d) y = %d x = %d is_external\n",
               all_objs->cur_obj->id,y,x))
        }
    }
 if ((err = enter_obj_xy(all_objs->cur_obj,OBJ_NEGATIVE_PT,x,y)) == NO_ERROR)
    set_1d_buf_value(all_objs->id_2d.buf[y],
                    x,all_objs->id_2d.pixel_depth,
                     (unsigned int) all_objs->cur_obj->id);

 return err;
}


/*------------------------------------------------------------------------
get_neg_objs - ???
-----------------------------------------------------------------------*/

int
get_neg_objs(all_objs,obj,temp_obj,is_breaker)
 struct all_object_rec *all_objs;
 struct object_rec *obj;
 struct object_rec *temp_obj;
 int is_breaker;
{
 unsigned long lcv,cnt,val;
 long tempx,tempy;
 static int xy[4][2] = {{ 0, -1},{ 1, 0},{ 0, 1},{-1, 0}};
 int err;

 temp_obj->num_pts = 0;
/*
     for (lcv = 0; lcv < 8; lcv++)
        {tempx = obj->pts[cnt].x + _EdgeOffset[lcv][0];
         tempy = obj->pts[cnt].y + _EdgeOffset[lcv][1];
*/
 for (cnt = 0; cnt < obj->num_pts; cnt++)
    {
     for (lcv = 0; lcv < 4; lcv++)
        {tempx = obj->pts[cnt].x + xy[lcv][0];
         tempy = obj->pts[cnt].y + xy[lcv][1];
         if ((tempx >= all_objs->bound.left) &&
             (tempx <= all_objs->bound.right) &&
             (tempy >= all_objs->bound.top) &&
             (tempy <= all_objs->bound.bottom))
            {
             if ((val = get_1d_buf_value(all_objs->in_2d->buf[tempy],
                    tempx,all_objs->in_2d->pixel_depth)) == 0)
                 if ((err = enter_obj_xy(temp_obj,0,tempx,tempy)) != NO_ERROR)
                    {
                     return err;
                    }
            }
        }

    }
 delete_duplicate_object_rec_obj_pts(temp_obj);
/*
 printf("get_neg_objs num_pts = %d..\n",temp_obj->num_pts);
 pr_object_rec(temp_obj,1,0);
*/
 PRT(printf("get_neg_objs is_breaker = %d\n",is_breaker))
 PRT(pr_int_bound_rec(&(all_objs->bound)))
 for (cnt = 0; cnt < temp_obj->num_pts; cnt++)
    {
     if ((err = neg_enter_xy_into_cur_obj(all_objs,
                (long) temp_obj->pts[cnt].x,
                (long) temp_obj->pts[cnt].y,is_breaker)) != NO_ERROR)
        return err;
    }
 TRACE1(printf("get_neg_objs before merge num_objs = %d is_pr = %d\n",
          all_objs->num_objs,is_pr);)
 if (all_objs->num_objs > 0)
    {
     merge_all_objs_rec_merged_objs(all_objs,0,0);
    }
/*

 printf("get_neg_objs after merge num_objs = %d is_pr = %d\n",all_objs->num_objs,is_pr);
 if (is_pr)
    {printf(" get_neg_objs....after merge_all_objs_rec_merged_objs\n");
     pr_all_object_rec(all_objs,0);
     printf(" get_neg_objs....\n");}

 printf("temp_obj total_pts = %d num_pts = %d  num_objs = %d\n",
    temp_obj->total_pts,temp_obj->num_pts,all_objs->num_objs);
*/
 return NO_ERROR;
}


/*------------------------------------------------------------------------
scan_sub_objs - ???
-----------------------------------------------------------------------*/

int
scan_sub_objs(sub,obj_2d,id_2d,bound,lbval,ubval,obj,temp_obj,
                is_delete_internal_bpt,is_breaker)
 struct all_object_rec *sub;
 struct buf_2d_rec *obj_2d,*id_2d;
 struct int_bound_rec *bound;
 struct object_rec *obj,*temp_obj;
 int is_delete_internal_bpt,is_breaker;
{
 int err;

 if ((err = setup_all_object_rec(sub,obj_2d,id_2d,0,bound,lbval,ubval))
            != NO_ERROR) return err;
 if (obj != NULL)
    {
     if ((err = get_neg_objs(sub,obj,temp_obj,is_breaker)) != NO_ERROR)
        return err;
     if (sub->num_objs == 0) return NO_ERROR;
     PRT(printf("scan_sub_objs1...get_neg_objs..exc-num_objs = %d\n",sub->num_objs);)
     PRT(pr_all_object_rec(sub,0);)
     PRT(printf("\n\n");)
     define_all_negative_boundary_objs(sub,obj);
     PRT(printf("scan_sub_objs1.....exc-num_objs = %d\n",sub->num_objs);)
     PRT(pr_all_object_rec(sub,1);)
     delete_all_negative_boundary_objs(sub);

     if (is_delete_internal_bpt)
        {
/*
         printf("scan_sub_objs1.....exc-num_objs = %d\n",
                 sub->num_objs);
         pr_all_object_rec(sub,0);
         printf(" scan_sub_objs1....is_delete_internal_bpt = %d\n",is_delete_internal_bpt);

         delete_obj_internal_boundary_pts(obj,sub);
         printf("after delete_obj_internal_boundary_pts.....exc-num_objs = %d\n",
                 sub->num_objs);
         pr_all_object_rec(sub,0);
         printf("\n\n");
*/
        }

    }

 return NO_ERROR;

}


/*------------------------------------------------------------------------
detect_all_sub_objs - ???
-----------------------------------------------------------------------*/

int
detect_all_sub_objs(all_objs,is_delete_internal_bpt,is_breaker)
 struct all_object_rec *all_objs;
 int is_delete_internal_bpt,is_breaker;
{
 unsigned long lcv,tot,num;
 int err;
 struct all_object_rec *sub;
 struct object_rec temp_obj;
 struct buf_2d_rec id_2d,*ptr_id_2d;
 
 TRACE1(printf("detect_all_sub_objs is_delete_internal_bpt = %d\n",
           is_delete_internal_bpt);)
 init_object_rec(&temp_obj);
 init_buf_2d_rec(&id_2d);
 ptr_id_2d = NULL;
 sub = NULL;
 err = NO_ERROR;
 num = 0;
 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    {
     if (all_objs->objs[lcv]->num_pts <= 3)
        continue;
     tot = 0;
     get_ptr_memory(&sub,&tot,(unsigned int) 1,
          (size_t) sizeof(struct all_object_rec),&err);
     if (err != NO_ERROR) return err;
     init_all_object_rec(sub);
     get_object_rec_obj_bound(all_objs->objs[lcv]);
     if ((err = scan_sub_objs(sub,
            &(all_objs->id_2d),ptr_id_2d,&(all_objs->objs[lcv]->bound),
            all_objs->objs[lcv]->id,all_objs->objs[lcv]->id,
            all_objs->objs[lcv],&temp_obj,is_delete_internal_bpt,
            is_breaker)) != NO_ERROR)
        {ptr_id_2d = NULL;
         free_all_object_rec1(sub,1);
         c_free(sub);
         break;}
     id_2d = sub->id_2d;
     ptr_id_2d = &id_2d;
     delete_all_object_rec_id_2d(sub,0);
     all_objs->objs[lcv]->excluded_regions = sub;
    }
 free_object_rec(&temp_obj);
 if (ptr_id_2d != NULL) free_buf_2d_rec(ptr_id_2d);

 return err;
}
