/****************************************************************************
magnify_img.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: magnify_img.c,v 1.9 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "common.h"
#include "ria_global.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)




/* Functions defined in this file */
void MagnifyBitPixel(unsigned char **_2d_buf, unsigned long dimx,
    unsigned long dimy, unsigned long pixel_depth, unsigned long x,
    unsigned long y, struct pixel_desc_rec *pixel_desc,
    struct ByteBitOrder_rec *ByteBitOrder, unsigned long pixel_values[8]);
void MagnifyBytePixel(unsigned char **_2d_buf, unsigned long dimx,
    unsigned long dimy, unsigned long pixel_depth, unsigned long x,
    unsigned long y, struct pixel_desc_rec *pixel_desc,
    struct ByteBitOrder_rec *ByteBitOrder, unsigned long pixel_values[8]);
void MagnifyShortPixel(unsigned short **_2d_buf, unsigned long dimx,
    unsigned long dimy, unsigned long pixel_depth, unsigned long x,
    unsigned long y, struct pixel_desc_rec *pixel_desc,
    struct ByteBitOrder_rec *ByteBitOrder, unsigned long pixel_values[8]);
void MagnifyIntPixel(unsigned int **_2d_buf, unsigned long dimx,
    unsigned long dimy, unsigned long pixel_depth, unsigned long x,
    unsigned long y, struct pixel_desc_rec *pixel_desc,
    struct ByteBitOrder_rec *ByteBitOrder, unsigned long pixel_values[8]);
void MagnifyAnySizePixel(unsigned int **_2d_buf, unsigned long dimx,
    unsigned long dimy, int pixel_depth, unsigned long x, unsigned long y,
    struct pixel_desc_rec *pixel_desc, struct ByteBitOrder_rec *ByteBitOrder,
    unsigned long pixel_values[8]);
void GetMagnifyPixelProc(int **whch_magnify_pixel_proc,
    unsigned long pixel_depth);
void magnify_bit_pixel(unsigned char **_2d_buf, unsigned long dimx,
    unsigned long dimy, unsigned long pixel_depth, unsigned long x,
    unsigned long y, struct pixel_desc_rec *pixel_desc,
    unsigned long pixel_value);
void magnify_byte_pixel(unsigned char **_2d_buf, unsigned long dimx,
    unsigned long dimy, unsigned long pixel_depth, unsigned long x,
    unsigned long y, struct pixel_desc_rec *pixel_desc,
    unsigned long pixel_value);
void magnify_short_pixel(unsigned short **_2d_buf, unsigned long dimx,
    unsigned long dimy, unsigned long pixel_depth, unsigned long x,
    unsigned long y, struct pixel_desc_rec *pixel_desc,
    unsigned long pixel_value);
void magnify_int_pixel(unsigned int **_2d_buf, unsigned long dimx,
    unsigned long dimy, unsigned long pixel_depth, unsigned long x,
    unsigned long y, struct pixel_desc_rec *pixel_desc,
    unsigned long pixel_value);
void magnify_any_size_pixel(unsigned int **_2d_buf, unsigned long dimx,
    unsigned long dimy, int pixel_depth, unsigned long x, unsigned long y,
    struct pixel_desc_rec *pixel_desc, unsigned long pixel_value);
void get_magnify_pixel_proc(int **whch_magnify_pixel_proc,
    unsigned long pixel_depth);
void get_mag_dim(unsigned long *mag_dimx, unsigned long *mag_dimy,
    unsigned long dimx, unsigned long dimy, struct pixel_desc_rec *pixel_desc);
void get_mag_image_size1(unsigned long *mag_total_size,
    unsigned long *mag_dimx, unsigned long *mag_dimy, unsigned long dimx,
    unsigned long dimy, unsigned long pixel_depth,
    struct pixel_desc_rec *pixel_desc);
void MagnifyBitImage(struct color_data_rec **colors, unsigned long num_colors,
    struct int_bound_rec *bound, unsigned char **out_2d_buf,
    unsigned out_dimx, unsigned out_dimy, struct int_region_rect *dimension,
    struct pixel_desc_rec *pixel_desc, unsigned long *map_values,
    unsigned long num_map_values, unsigned long bkg_color);
void MagnifyByteImage(struct color_data_rec **colors,
    unsigned long num_colors, struct int_bound_rec *bound,
    unsigned char **out_2d_buf, unsigned long out_dimx,
    unsigned long out_dimy, struct int_region_rect *dimension,
    struct pixel_desc_rec *pixel_desc, unsigned long *map_values,
    unsigned long num_map_values, unsigned long bkg_color);
void MagnifyShortImage(struct color_data_rec **colors,
    unsigned long num_colors, struct int_bound_rec *bound,
    unsigned char **out_2d_buf, unsigned long out_dimx,
    unsigned long out_dimy, struct int_region_rect *dimension,
    struct pixel_desc_rec *pixel_desc, unsigned long *map_values,
    unsigned long num_map_values, unsigned long bkg_color);
void MagnifyIntImage(struct color_data_rec **colors, unsigned long num_colors,
    struct int_bound_rec *bound, unsigned char **out_2d_buf,
    unsigned long out_dimx, unsigned long out_dimy,
    struct int_region_rect *dimension, struct pixel_desc_rec *pixel_desc,
    unsigned long *map_values, unsigned long num_map_values,
    unsigned long bkg_color);
void MagnifyAnySizeImage(struct color_data_rec **colors,
    unsigned long num_colors, struct int_bound_rec *bound,
    unsigned char **out_2d_buf, unsigned long out_dimx,
    unsigned long out_dimy, unsigned long out_pixel_depth,
    struct int_region_rect *dimension, struct pixel_desc_rec *pixel_desc,
    unsigned long *map_values, unsigned long num_map_values,
    unsigned long bkg_color);
int MagnifyTheImage(struct color_data_rec **colors, unsigned long num_colors,
    struct int_bound_rec *bound, unsigned short **out_2d_buf,
    unsigned long out_dimx, unsigned long out_dimy,
    unsigned long out_pixel_depth, struct int_region_rect *dimension,
    struct pixel_desc_rec *pixel_desc, unsigned long *map_values,
    unsigned long num_map_values, unsigned long bkg_color);
int get_shrink_dim(unsigned long dimx, unsigned long dimy,
    double shrink_xratio, double shrink_yratio, unsigned long *new_dimx,
    unsigned long *new_dimy);



/*------------------------------------------------------------------------
MagnifyBitPixel - ???
------------------------------------------------------------------------*/

void
MagnifyBitPixel(_2d_buf,dimx,dimy,pixel_depth,x,y,pixel_desc,
                   ByteBitOrder,pixel_values)
 unsigned char **_2d_buf;
 unsigned long dimx,dimy,pixel_depth;
 unsigned long x,y;
 struct pixel_desc_rec *pixel_desc;
 struct ByteBitOrder_rec *ByteBitOrder;
 unsigned long pixel_values[8];
{
 unsigned long x1,cnt,row,col,byte_indx,bit_indx,lcv;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 static unsigned char bits[] = {0x7f,0xbf,0xdf,0xef,0xf7,0xfb,0xfd,0xfe};

 for (cnt = 0; cnt < ByteBitOrder->num1bits; cnt++)
    {x1 = ByteBitOrder->bits[cnt] * pixel_desc->mask.dimx;
     for (lcv = 0; lcv < pixel_desc->fore.num_xys; lcv++)
        {row = y + pixel_desc->fore.y[lcv];
         col = x1 + x + pixel_desc->fore.x[lcv];
         if ((row < dimy) && (col < dimx))
            {byte_indx = col / 8;
             bit_indx = col % 8;
             if (pixel_values[ByteBitOrder->bits[cnt]])
                _2d_buf[row][byte_indx] |= _1_bit[bit_indx];
               else _2d_buf[row][byte_indx] &= bits[bit_indx];
            }
        }
    }
 for (cnt = 0; cnt < ByteBitOrder->num1bits; cnt++)
    {x1 = ByteBitOrder->bits[cnt] * pixel_desc->mask.dimx;
     for (lcv = 0; lcv < pixel_desc->back.num_xys; lcv++)
        {row = y + pixel_desc->back.y[lcv];
         col = x1 + x + pixel_desc->back.x[lcv];
         if ((row < dimy) && (col < dimx))
            {
             byte_indx = col / 8;
             bit_indx = col % 8;
             if (pixel_desc->back.value[lcv])
                _2d_buf[row][byte_indx] |= _1_bit[bit_indx];
               else _2d_buf[row][byte_indx] &= bits[bit_indx];}
        }
    }
}


/*------------------------------------------------------------------------
MagnifyBytePixel - ???
------------------------------------------------------------------------*/

void
MagnifyBytePixel(_2d_buf,dimx,dimy,pixel_depth,x,y,pixel_desc,
                   ByteBitOrder,pixel_values)
 unsigned char **_2d_buf;
 unsigned long dimx,dimy,pixel_depth;
 unsigned long x,y;
 struct pixel_desc_rec *pixel_desc;
 struct ByteBitOrder_rec *ByteBitOrder;
 unsigned long pixel_values[8];
{
 unsigned long x1,cnt,row,col,lcv,num_xys;
 unsigned long *xptr,*yptr,*back_value;

 num_xys = pixel_desc->fore.num_xys;
 xptr = (unsigned long *) pixel_desc->fore.x;
 yptr = (unsigned long *) pixel_desc->fore.y;
 for (cnt = 0; cnt < ByteBitOrder->num1bits; cnt++)
    {x1 = ByteBitOrder->bits[cnt] * pixel_desc->mask.dimx + x;

     for (lcv = 0; lcv < num_xys; lcv++)
        {row = y + yptr[lcv];
         col = x1 + xptr[lcv];
        _2d_buf[row][col] = pixel_values[ByteBitOrder->bits[cnt]];
        }
    }

 if (pixel_desc->back.num_xys > 0)
    {num_xys = pixel_desc->back.num_xys;
     xptr = (unsigned long *) pixel_desc->back.x;
     yptr = (unsigned long *) pixel_desc->back.y;
     back_value = pixel_desc->back.value;
     for (cnt = 0; cnt < ByteBitOrder->num1bits; cnt++)
        {x1 = ByteBitOrder->bits[cnt] * pixel_desc->mask.dimx + x;
         for (lcv = 0; lcv < num_xys; lcv++)
            {row = y + yptr[lcv];
             col = x1 + xptr[lcv];

             _2d_buf[row][col] = back_value[lcv];
            }
        }
    }

}


/*------------------------------------------------------------------------
MagnifyShortPixel - ???
------------------------------------------------------------------------*/

void
MagnifyShortPixel(_2d_buf,dimx,dimy,pixel_depth,x,y,pixel_desc,
                   ByteBitOrder,pixel_values)
 unsigned short **_2d_buf;
 unsigned long dimx,dimy,pixel_depth;
 unsigned long x,y;
 struct pixel_desc_rec *pixel_desc;
 struct ByteBitOrder_rec *ByteBitOrder;
 unsigned long pixel_values[8];
{
 unsigned long x1,cnt,row,col,lcv;

 for (cnt = 0; cnt < ByteBitOrder->num1bits; cnt++)
    {x1 = ByteBitOrder->bits[cnt] * pixel_desc->mask.dimx;
     for (lcv = 0; lcv < pixel_desc->fore.num_xys; lcv++)
        {row = y + pixel_desc->fore.y[lcv];
         col = x1 + x + pixel_desc->fore.x[lcv];
         if ((row < dimy) && (col < dimx))
            _2d_buf[row][col] = pixel_values[ByteBitOrder->bits[cnt]];
        }
    }

 for (cnt = 0; cnt < ByteBitOrder->num1bits; cnt++)
    {x1 = ByteBitOrder->bits[cnt] * pixel_desc->mask.dimx;
     for (lcv = 0; lcv < pixel_desc->back.num_xys; lcv++)
        {row = y + pixel_desc->back.y[lcv];
         col = x1 + x + pixel_desc->back.x[lcv];
         if ((row < dimy) && (col < dimx))
            _2d_buf[row][col] = pixel_desc->back.value[lcv];
        }
    }

}


/*------------------------------------------------------------------------
MagnifyIntPixel - ???
------------------------------------------------------------------------*/

void
MagnifyIntPixel(_2d_buf,dimx,dimy,pixel_depth,x,y,pixel_desc,
                   ByteBitOrder,pixel_values)
 unsigned int **_2d_buf;
 unsigned long dimx,dimy,pixel_depth;
 unsigned long x,y;
 struct pixel_desc_rec *pixel_desc;
 struct ByteBitOrder_rec *ByteBitOrder;
 unsigned long pixel_values[8];
{
 unsigned long x1,cnt,row,col,lcv;

 for (cnt = 0; cnt < ByteBitOrder->num1bits; cnt++)
    {x1 = ByteBitOrder->bits[cnt] * pixel_desc->mask.dimx;
     for (lcv = 0; lcv < pixel_desc->fore.num_xys; lcv++)
        {row = y + pixel_desc->fore.y[lcv];
         col = x1 + x + pixel_desc->fore.x[lcv];
         if ((row < dimy) && (col < dimx))
            _2d_buf[row][col] = pixel_values[ByteBitOrder->bits[cnt]];
        }
    }

 for (cnt = 0; cnt < ByteBitOrder->num1bits; cnt++)
    {x1 = ByteBitOrder->bits[cnt] * pixel_desc->mask.dimx;
     for (lcv = 0; lcv < pixel_desc->back.num_xys; lcv++)
        {row = y + pixel_desc->back.y[lcv];
         col = x1 + x + pixel_desc->back.x[lcv];
         if ((row < dimy) && (col < dimx))
            _2d_buf[row][col] = pixel_desc->back.value[lcv];
        }
    }
}


/*------------------------------------------------------------------------
MagnifyAnySizePixel - ???
------------------------------------------------------------------------*/

void
MagnifyAnySizePixel(_2d_buf,dimx,dimy,pixel_depth,x,y,pixel_desc,
                   ByteBitOrder,pixel_values)
 unsigned int **_2d_buf;
 unsigned long dimx,dimy;
 unsigned long x,y;
 struct pixel_desc_rec *pixel_desc;
 struct ByteBitOrder_rec *ByteBitOrder;
 unsigned long pixel_values[8];
{
 unsigned long x1,cnt,row,col,lcv;

 for (cnt = 0; cnt < ByteBitOrder->num1bits; cnt++)
    {x1 = ByteBitOrder->bits[cnt] * pixel_desc->mask.dimx;
     for (lcv = 0; lcv < pixel_desc->fore.num_xys; lcv++)
        {row = y + pixel_desc->fore.y[lcv];
         col = x1 + x + pixel_desc->fore.x[lcv];
         if ((row < dimy) && (col < dimx))
            set_1d_buf_value(_2d_buf[row],col,pixel_depth,
                  pixel_values[ByteBitOrder->bits[cnt]]);
        }
    }

 for (cnt = 0; cnt < ByteBitOrder->num1bits; cnt++)
    {x1 = ByteBitOrder->bits[cnt] * pixel_desc->mask.dimx;
     for (lcv = 0; lcv < pixel_desc->back.num_xys; lcv++)
        {row = y + pixel_desc->back.y[lcv];
         col = x1 + x + pixel_desc->back.x[lcv];
         if ((row < dimy) && (col < dimx))
            set_1d_buf_value(_2d_buf[row],col,pixel_depth,
                     (unsigned long) pixel_desc->back.value[lcv]);
        }
    }

}


/*------------------------------------------------------------------------
GetMagnifyPixelProc - ???
------------------------------------------------------------------------*/

void
GetMagnifyPixelProc(whch_magnify_pixel_proc,pixel_depth)
 int **whch_magnify_pixel_proc;
 unsigned long pixel_depth;
{
 switch (pixel_depth)
    {case 8 :
        *whch_magnify_pixel_proc = (int *) MagnifyBytePixel;
        break;
     case 16 : 
        *whch_magnify_pixel_proc = (int *) MagnifyShortPixel;
        break;
     case 32 : 
        *whch_magnify_pixel_proc = (int *) MagnifyIntPixel;
        break;
     case 1 :
        *whch_magnify_pixel_proc = (int *) MagnifyBitPixel;
        break;
     default : *whch_magnify_pixel_proc = (int *) MagnifyAnySizePixel;}
}



/*------------------------------------------------------------------------
magnify_bit_pixel - ???
------------------------------------------------------------------------*/

void
magnify_bit_pixel(_2d_buf,dimx,dimy,pixel_depth,x,y,pixel_desc,pixel_value)
 unsigned char **_2d_buf;
 unsigned long dimx,dimy,pixel_depth;
 unsigned long x,y;
 struct pixel_desc_rec *pixel_desc;
 unsigned long pixel_value;
{
 unsigned long row,col,byte_indx,bit_indx,lcv;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 static unsigned char bits[] = {0x7f,0xbf,0xdf,0xef,0xf7,0xfb,0xfd,0xfe};

 for (lcv = 0; lcv < pixel_desc->fore.num_xys; lcv++)
    {row = y + pixel_desc->fore.y[lcv];
     col = x + pixel_desc->fore.x[lcv];
     if ((row < dimy) && (col < dimx))
        {byte_indx = col / 8;
         bit_indx = col % 8;
         if (pixel_value) _2d_buf[row][byte_indx] |= _1_bit[bit_indx];
           else _2d_buf[row][byte_indx] &= bits[bit_indx];}
       else
        {TRACE(printf("invalid pixel addr row = %d col = %d\n",row,col))
         }
    }

 for (lcv = 0; lcv < pixel_desc->back.num_xys; lcv++)
    {row = y + pixel_desc->back.y[lcv];
     col = x + pixel_desc->back.x[lcv];
     if ((row < dimy) && (col < dimx))
        {
         byte_indx = col / 8;
         bit_indx = col % 8;
         if (pixel_desc->back.value[lcv])
             _2d_buf[row][byte_indx] |= _1_bit[bit_indx];
           else _2d_buf[row][byte_indx] &= bits[bit_indx];}
       else
        {TRACE(printf("invalid pixel addr row = %d col = %d\n",row,col))
         }
    }

}


/*------------------------------------------------------------------------
magnify_byte_pixel - ???
------------------------------------------------------------------------*/

void
magnify_byte_pixel(_2d_buf,dimx,dimy,pixel_depth,x,y,pixel_desc,pixel_value)
 unsigned char **_2d_buf;
 unsigned long dimx,dimy,pixel_depth;
 unsigned long x,y;
 struct pixel_desc_rec *pixel_desc;
 unsigned long pixel_value;
{
 unsigned long row,col,lcv,num_xys,value;
 unsigned long *xptr,*yptr,*back_value;

 num_xys = pixel_desc->fore.num_xys;
 xptr = (unsigned long *) pixel_desc->fore.x;
 yptr = (unsigned long *) pixel_desc->fore.y;
 value = pixel_value;
 for (lcv = 0; lcv < num_xys; lcv++)
    {row = y + yptr[lcv];
     col = x + xptr[lcv];
/*
     if ((row < dimy) && (col < dimx))
*/
        _2d_buf[row][col] = value;
    }

 num_xys = pixel_desc->back.num_xys;
 xptr = pixel_desc->back.x;
 yptr = pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 for (lcv = 0; lcv < num_xys; lcv++)
    {row = y + yptr[lcv];
     col = x + xptr[lcv];
/*
     if ((row < dimy) && (col < dimx))
*/
        _2d_buf[row][col] = back_value[lcv];
    }

}


/*------------------------------------------------------------------------
magnify_short_pixel - ???
------------------------------------------------------------------------*/

void
magnify_short_pixel(_2d_buf,dimx,dimy,pixel_depth,x,y,pixel_desc,pixel_value)
 unsigned short **_2d_buf;
 unsigned long dimx,dimy,pixel_depth;
 unsigned long x,y;
 struct pixel_desc_rec *pixel_desc;
 unsigned long pixel_value;
{
 unsigned long row,col,lcv;

 for (lcv = 0; lcv < pixel_desc->fore.num_xys; lcv++)
    {row = y + pixel_desc->fore.y[lcv];
     col = x + pixel_desc->fore.x[lcv];
     if ((row < dimy) && (col < dimx))
        _2d_buf[row][col] = pixel_value;
    }

 for (lcv = 0; lcv < pixel_desc->back.num_xys; lcv++)
    {row = y + pixel_desc->back.y[lcv];
     col = x + pixel_desc->back.x[lcv];
     if ((row < dimy) && (col < dimx))
        _2d_buf[row][col] = pixel_desc->back.value[lcv];
    }

}


/*------------------------------------------------------------------------
magnify_int_pixel - ???
------------------------------------------------------------------------*/

void
magnify_int_pixel(_2d_buf,dimx,dimy,pixel_depth,x,y,pixel_desc,pixel_value)
 unsigned int **_2d_buf;
 unsigned long dimx,dimy,pixel_depth;
 unsigned long x,y;
 struct pixel_desc_rec *pixel_desc;
 unsigned long pixel_value;
{
 unsigned long row,col,lcv;

 for (lcv = 0; lcv < pixel_desc->fore.num_xys; lcv++)
    {row = y + pixel_desc->fore.y[lcv];
     col = x + pixel_desc->fore.x[lcv];
     if ((row < dimy) && (col < dimx))
        _2d_buf[row][col] = pixel_value;
    }

 for (lcv = 0; lcv < pixel_desc->back.num_xys; lcv++)
    {row = y + pixel_desc->back.y[lcv];
     col = x + pixel_desc->back.x[lcv];
     if ((row < dimy) && (col < dimx))
        _2d_buf[row][col] = pixel_desc->back.value[lcv];
    }

}


/*------------------------------------------------------------------------
magnify_any_size_pixel - ???
------------------------------------------------------------------------*/

void
magnify_any_size_pixel(_2d_buf,dimx,dimy,pixel_depth,x,y,pixel_desc,pixel_value)
 unsigned int **_2d_buf;
 unsigned long dimx,dimy;
 unsigned long x,y;
 struct pixel_desc_rec *pixel_desc;
 unsigned long pixel_value;
{
 unsigned long row,col,lcv;

 for (lcv = 0; lcv < pixel_desc->fore.num_xys; lcv++)
    {row = y + pixel_desc->fore.y[lcv];
     col = x + pixel_desc->fore.x[lcv];
     if ((row < dimy) && (col < dimx))
        set_1d_buf_value(_2d_buf[row],col,pixel_depth,pixel_value);
    }

 for (lcv = 0; lcv < pixel_desc->back.num_xys; lcv++)
    {row = y + pixel_desc->back.y[lcv];
     col = x + pixel_desc->back.x[lcv];
     if ((row < dimy) && (col < dimx))
        set_1d_buf_value(_2d_buf[row],col,pixel_depth,
                     (unsigned long) pixel_desc->back.value[lcv]);
    }

}


/*------------------------------------------------------------------------
get_magnify_pixel_proc - ???
------------------------------------------------------------------------*/

void
get_magnify_pixel_proc(whch_magnify_pixel_proc,pixel_depth)
 int **whch_magnify_pixel_proc;
 unsigned long pixel_depth;
{
 PRT(printf("get_magnify_pixel_proc pixel_depth = %d\n",pixel_depth))
 switch (pixel_depth)
    {case 8 :
        *whch_magnify_pixel_proc = (int *) magnify_byte_pixel;
        break;
     case 16 : 
        *whch_magnify_pixel_proc = (int *) magnify_short_pixel;
        break;
     case 32 : 
        *whch_magnify_pixel_proc = (int *) magnify_int_pixel;
        break;
     case 1 :
        *whch_magnify_pixel_proc = (int *) magnify_bit_pixel;
        break;
     default : *whch_magnify_pixel_proc = (int *) magnify_any_size_pixel;}
}


/*------------------------------------------------------------------------
get_mag_dim - ???
------------------------------------------------------------------------*/

void
get_mag_dim(mag_dimx,mag_dimy,dimx,dimy,pixel_desc)
 unsigned long *mag_dimx,*mag_dimy;
 unsigned long dimx,dimy;
 struct pixel_desc_rec *pixel_desc;
{
 PRT5(printf("get_mag_dim pixel_desc = %u\n",pixel_desc))
 PRT5(printf("get_mag_dim dimx = %d dimy = %d magx = %d  magy = %d\n",
        dimx,dimy,pixel_desc->mask.dimx,pixel_desc->mask.dimy))
 *mag_dimx = dimx * pixel_desc->mask.dimx;
 *mag_dimy = dimy * pixel_desc->mask.dimy;
 PRT5(printf("get_mag_dim mag_dimx = %d mag_dimy = %d\n",*mag_dimx,*mag_dimy))
}


/*------------------------------------------------------------------------
get_mag_image_size1 - ???
------------------------------------------------------------------------*/

void
get_mag_image_size1(mag_total_size,mag_dimx,mag_dimy,
                   dimx,dimy,pixel_depth,pixel_desc)
 unsigned long *mag_total_size;
 unsigned long *mag_dimx,*mag_dimy;
 unsigned long dimx,dimy,pixel_depth;
 struct pixel_desc_rec *pixel_desc;
{
 unsigned long row_bytes;

 get_mag_dim(mag_dimx,mag_dimy,dimx,dimy,pixel_desc);
 row_bytes = GetRowBytes(*mag_dimx,pixel_depth);
 *mag_total_size = row_bytes * *mag_dimy;
}


/*------------------------------------------------------------------------
MagnifyBitImage - ???
------------------------------------------------------------------------*/

void
MagnifyBitImage(colors,num_colors,bound,
                out_2d_buf,out_dimx,out_dimy,dimension,pixel_desc,
                map_values,num_map_values,bkg_color)
 struct color_data_rec **colors;
 unsigned long num_colors;
 struct int_bound_rec *bound;
 unsigned char **out_2d_buf;
 unsigned out_dimx,out_dimy;
 struct int_region_rect *dimension;
 struct pixel_desc_rec *pixel_desc;
 unsigned long *map_values;
 unsigned long num_map_values,bkg_color;
{
 long y_out,x_out,x,y,lx,ly,num_bufs,last,num;
 unsigned long value;
 int left,right,top,bottom,yes;
 struct buf_2d_rec *_2d;

 if (num_colors == 0)
     return /*NO_ERROR*/;
/*
 get_valid_dimension_elems(dimension,colors[0]->_2d.dimx,
         colors[0]->_2d.dimy,&left,&right,&top,&bottom);
*/
 valid_bound(&(dimension->bound),bound,&left,&right,&top,&bottom);
 last = num_colors - 1;
 if (map_values == NULL)
    {for (y_out = 0,y = top; y <= bottom; y++,y_out += pixel_desc->mask.dimy)
        for (x_out = 0,x = left; x <= right; x++,x_out += pixel_desc->mask.dimx)
           {
            for (yes = 0,num_bufs = last; ; num_bufs--)
               {_2d = &(colors[num_bufs]->_2d);
                if (((ly = (y - _2d->startoffy)) < 0) ||
                    (ly >= (long) _2d->dimy) ||
                    ((lx = (x - _2d->startoffx)) < 0) ||
                    (lx >= (long) _2d->dimx))
                   {/*printf("%d) ly = %d startoffy = %d y = %d\n",
                             num_bufs,ly,_2d->startoffy,y);*/
                    if (num_bufs == 0) break;}
                  else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                           (num_bufs == 0))
                  {if ((colors[num_bufs]->num_color_indxs > 0) &&
                       (value >= colors[num_bufs]->scale.first) &&
                       ((num = (value - colors[num_bufs]->scale.first)) < 
                              colors[num_bufs]->num_color_indxs))
                      value = colors[num_bufs]->color_indxs[num];
                   yes = 1;
                   break;}
               }
            if (!yes) value = bkg_color;
            magnify_bit_pixel(out_2d_buf,out_dimx,out_dimy,
                 colors[0]->_2d.pixel_depth,x_out,y_out,pixel_desc,value);
           }
     }
    else
     for (y_out = 0,y = top; y <= bottom; y++,y_out += pixel_desc->mask.dimy)
        for (x_out = 0,x = left; x <= right; x++,x_out += pixel_desc->mask.dimx)
           {
            for (yes = 0,num_bufs = last; ; num_bufs--)
               {_2d = &(colors[num_bufs]->_2d);
                if (((ly = (y - _2d->startoffy)) < 0) ||
                    (ly >= (long) _2d->dimy) ||
                    ((lx = (x - _2d->startoffx)) < 0) ||
                    (lx >= (long) _2d->dimx))
                   {/*printf("%d) ly = %d startoffy = %d y = %d\n",
                             num_bufs,ly,_2d->startoffy,y);*/
                    if (num_bufs == 0) break;}
                  else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                      (num_bufs == 0))
                  {if ((colors[num_bufs]->num_color_indxs > 0) &&
                       (value >= colors[num_bufs]->scale.first) &&
                       ((num = (value - colors[num_bufs]->scale.first)) < 
                              colors[num_bufs]->num_color_indxs))
                      value = colors[num_bufs]->color_indxs[num];
                   yes = 1;
                   break;}
               }
            if (!yes) value = bkg_color;

            value = map_values[value];
            magnify_bit_pixel(out_2d_buf,out_dimx,out_dimy,
                colors[0]->_2d.pixel_depth,x_out,y_out,pixel_desc,value);
           }
}


/*------------------------------------------------------------------------
MagnifyByteImage - ???
------------------------------------------------------------------------*/

void
MagnifyByteImage(colors,num_colors,bound,
                 out_2d_buf,out_dimx,out_dimy,dimension,pixel_desc,
                 map_values,num_map_values,bkg_color)
 struct color_data_rec **colors;
 unsigned long num_colors;
 struct int_bound_rec *bound;
 unsigned char **out_2d_buf;
 unsigned long out_dimx,out_dimy;
 struct int_region_rect *dimension;
 struct pixel_desc_rec *pixel_desc;
 unsigned long *map_values;
 unsigned long num_map_values,bkg_color;
{
 long y_out,x_out,x,y,lx,ly,num_bufs,last,num;
 unsigned long lcv,fore_num_xys,back_num_xys;
 unsigned long *fore_xptr,*fore_yptr,*back_xptr,*back_yptr,*back_value;
 unsigned long pixel_dimx,pixel_dimy;
 unsigned long value;
 int left,right,top,bottom,yes;
 struct buf_2d_rec *_2d;

 if (num_colors == 0)
     return /*NO_ERROR*/;
 fore_num_xys = pixel_desc->fore.num_xys;
 back_num_xys = pixel_desc->back.num_xys;
 fore_xptr = (unsigned long *) pixel_desc->fore.x;
 fore_yptr = (unsigned long *) pixel_desc->fore.y;
 back_xptr = (unsigned long *) pixel_desc->back.x;
 back_yptr = (unsigned long *) pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 pixel_dimx = pixel_desc->mask.dimx;
 pixel_dimy = pixel_desc->mask.dimy;
 valid_bound(&(dimension->bound),bound,&left,&right,&top,&bottom);
/*
 get_valid_dimension_elems(dimension,colors[0]->_2d.dimx,colors[0]->_2d.dimy,
              &left,&right,&top,&bottom);
*/
 PRT4(pr_int_bound_rec(bound);
      printf("MagnifyByteImage bkg_color = %d l = %d t = %d r = %d b = %d dimx = %d dimy = %d\n",bkg_color,
       left,top,right,bottom,colors[0]->_2d.dimx,colors[0]->_2d.dimy))
 last = num_colors - 1;
 PRT3(if (last >= 0)
    for (num_bufs = last; num_bufs >= 0; num_bufs--)
       {_2d = &(colors[num_bufs]->_2d);
        pr_buf_2d_rec(_2d);
        printf("\n");
       })
 if (map_values == NULL)
    {
     for (y_out = 0,y = top; y <= bottom; y++,y_out += pixel_dimy)
         {
          for (x_out = 0,x = left; x <= right; 
                x++,x_out += pixel_dimx)
             {
              for (yes = 0,num_bufs = last; ; num_bufs--)
                 {_2d = &(colors[num_bufs]->_2d);
                  if (((ly = (y - _2d->startoffy)) < 0) ||
                      (ly >= (long) _2d->dimy) ||
                      ((lx = (x - _2d->startoffx)) < 0) ||
                      (lx >= (long) _2d->dimx))
                     {/*printf("%d) ly = %d startoffy = %d y = %d\n",
                             num_bufs,ly,_2d->startoffy,y);*/
                      if (num_bufs == 0) break;}
                    else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                      (num_bufs == 0))
                     {if ((colors[num_bufs]->num_color_indxs > 0) &&
                         (value >= colors[num_bufs]->scale.first) &&
                         ((num = (value - colors[num_bufs]->scale.first)) < 
                              colors[num_bufs]->num_color_indxs))
                        value = colors[num_bufs]->color_indxs[num];
                      yes = 1;
                      break;}
                 }
              if (!yes) value = bkg_color;
              for (lcv = 0; lcv < fore_num_xys; lcv++)
                 {
                  out_2d_buf[y_out + fore_yptr[lcv]]
                      [x_out + fore_xptr[lcv]] = value;
                 }
              for (lcv = 0; lcv < back_num_xys; lcv++)
                 {
                  out_2d_buf[y_out + back_yptr[lcv]]
                      [x_out + back_xptr[lcv]] = back_value[lcv];
                 }
             }
          }
   }
  else
   {PRT3(printf("MagnifyByteImage...\n"))
    for (y_out = 0,y = top; y <= bottom; y++,y_out += pixel_dimy)
       {
        for (x_out = 0,x = left; x <= right; x++,x_out += pixel_dimx)
           {
            for (yes = 0,num_bufs = last; ; num_bufs--)
               {_2d = &(colors[num_bufs]->_2d);
                if (((ly = (y - _2d->startoffy)) < 0) ||
                    (ly >= (long) _2d->dimy) ||
                    ((lx = (x - _2d->startoffx)) < 0) ||
                    (lx >= (long) _2d->dimx))
                   {/*printf("%d) =lx = %D ly = %d startoffy = %d X = %D y = %d\n",
                             num_bufs,lx,ly,_2d->startoffy,x,y);*/
                    if (num_bufs == 0) break;}
                  else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                    (num_bufs == 0))
                   {if ((colors[num_bufs]->num_color_indxs > 0) &&
                        (value >= colors[num_bufs]->scale.first) &&
                        ((num = (value - colors[num_bufs]->scale.first)) < 
                              colors[num_bufs]->num_color_indxs))
                       value = colors[num_bufs]->color_indxs[num];
                    yes = 1;
                    break;}
               }
            if (!yes) value = bkg_color;
            value = map_values[value];
            for (lcv = 0; lcv < fore_num_xys; lcv++)
               {
                out_2d_buf[y_out + fore_yptr[lcv]]
                      [x_out + fore_xptr[lcv]] = value;
               }
            for (lcv = 0; lcv < back_num_xys; lcv++)
               {
                out_2d_buf[y_out + back_yptr[lcv]]
                      [x_out + back_xptr[lcv]] = back_value[lcv];
               }
           }
       }
   }
}



/*------------------------------------------------------------------------
MagnifyShortImage - ???
------------------------------------------------------------------------*/

void
MagnifyShortImage(colors,num_colors,bound,
                  out_2d_buf,out_dimx,out_dimy,dimension,pixel_desc,
                  map_values,num_map_values,bkg_color)
 struct color_data_rec **colors;
 unsigned long num_colors;
 struct int_bound_rec *bound;
 unsigned char **out_2d_buf;
 unsigned long out_dimx,out_dimy;
 struct int_region_rect *dimension;
 struct pixel_desc_rec *pixel_desc;
 unsigned long *map_values;
 unsigned long num_map_values,bkg_color;
{
 long y_out,x_out,x,y,lx,ly,num_bufs,last,num;
 unsigned long value;
 int left,right,top,bottom,yes;
 struct buf_2d_rec *_2d;

 valid_bound(&(dimension->bound),bound,&left,&right,&top,&bottom);
/*
  get_valid_dimension_elems(dimension,colors[0]->_2d.dimx,colors[0]->_2d.dimy,
             &left,&right,&top,&bottom);
*/
 last = num_colors - 1;
 if (map_values == NULL)
    {for (y_out = 0,y = top; y <= bottom; y++,y_out += pixel_desc->mask.dimy)
        for (x_out = 0,x = left; x <= right; x++,x_out += pixel_desc->mask.dimx)
           {
            for (yes = 0,num_bufs = last; ; num_bufs--)
               {_2d = &(colors[num_bufs]->_2d);
                if (((ly = (y - _2d->startoffy)) < 0) ||
                    (ly >= (long) _2d->dimy) ||
                    ((lx = (x - _2d->startoffx)) < 0) ||
                    (lx >= (long) _2d->dimx))
                   {/*printf("%d) ly = %d startoffy = %d y = %d\n",
                             num_bufs,ly,_2d->startoffy,y);*/
                    if (num_bufs == 0) break;}
                  else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                             (num_bufs == 0))
                      {if ((colors[num_bufs]->num_color_indxs > 0) &&
                           (value >= colors[num_bufs]->scale.first) &&
                           ((num = (value - colors[num_bufs]->scale.first)) < 
                              colors[num_bufs]->num_color_indxs))
                          value = colors[num_bufs]->color_indxs[num];
                       yes = 1;
                       break;}
               }
            if (!yes) value = bkg_color;

            magnify_short_pixel(out_2d_buf,out_dimx,out_dimy,
                 colors[0]->_2d.pixel_depth,x_out,y_out,pixel_desc,
                  (unsigned long) value);}
    }
   else
    {for (y_out = 0,y = top; y <= bottom; y++,y_out += pixel_desc->mask.dimy)
        for (x_out = 0,x = left; x <= right; x++,x_out += pixel_desc->mask.dimx)
           {
            for (yes = 0,num_bufs = last; ; num_bufs--)
               {_2d = &(colors[num_bufs]->_2d);
                if (((ly = (y - _2d->startoffy)) < 0) ||
                    (ly >= (long) _2d->dimy) ||
                    ((lx = (x - _2d->startoffx)) < 0) ||
                    (lx >= (long) _2d->dimx))
                   {/*printf("%d) =lx = %D ly = %d startoffy = %d X = %D y = %d\n",
                             num_bufs,lx,ly,_2d->startoffy,x,y);*/
                    if (num_bufs == 0) break;}
                  else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                    (num_bufs == 0))
                  {if ((colors[num_bufs]->num_color_indxs > 0) &&
                       (value >= colors[num_bufs]->scale.first) &&
                       ((num = (value - colors[num_bufs]->scale.first)) < 
                              colors[num_bufs]->num_color_indxs))
                      value = colors[num_bufs]->color_indxs[num];
                   yes = 1;
                   break;}
               }
            if (!yes) value = bkg_color;
            magnify_short_pixel(out_2d_buf,out_dimx,out_dimy,
                 colors[0]->_2d.pixel_depth,
                 x_out,y_out,pixel_desc,(unsigned long) map_values[value]);}
    }
}


/*------------------------------------------------------------------------
MagnifyIntImage - ???
------------------------------------------------------------------------*/

void
MagnifyIntImage(colors,num_colors,bound,
                out_2d_buf,out_dimx,out_dimy,dimension,pixel_desc,
                map_values,num_map_values,bkg_color)
 struct color_data_rec **colors;
 unsigned long num_colors;
 struct int_bound_rec *bound;
 unsigned char **out_2d_buf;
 unsigned long out_dimx,out_dimy;
 struct int_region_rect *dimension;
 struct pixel_desc_rec *pixel_desc;
 unsigned long *map_values;
 unsigned long num_map_values,bkg_color;
{
 long y_out,x_out,x,y,lx,ly,num_bufs,last,num;
 int left,right,top,bottom,yes;
 unsigned long value;
 struct buf_2d_rec *_2d;

 valid_bound(&(dimension->bound),bound,&left,&right,&top,&bottom);
/*
 get_valid_dimension_elems(dimension,colors[0]->_2d.dimx,colors[0]->_2d.dimy,
           &left,&right,&top,&bottom);
*/
 last = num_colors - 1;
 if (map_values == NULL)
    {for (y_out = 0,y = top; y <= bottom; y++,y_out += pixel_desc->mask.dimy)
        for (x_out = 0,x = left; x <= right; x++,x_out += pixel_desc->mask.dimx)
           {
            for (yes = 0,num_bufs = last; ; num_bufs--)
               {_2d = &(colors[num_bufs]->_2d);
                if (((ly = (y - _2d->startoffy)) < 0) ||
                    (ly >= (long) _2d->dimy) ||
                    ((lx = (x - _2d->startoffx)) < 0) ||
                    (lx >= (long) _2d->dimx))
                   {/*printf("%d) ly = %d startoffy = %d y = %d\n",
                             num_bufs,ly,_2d->startoffy,y);*/
                    if (num_bufs == 0) break;}
                  else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                      (num_bufs == 0))
                  {if ((colors[num_bufs]->num_color_indxs > 0) &&
                       (value >= colors[num_bufs]->scale.first) &&
                       ((num = (value - colors[num_bufs]->scale.first)) < 
                              colors[num_bufs]->num_color_indxs))
                      value = colors[num_bufs]->color_indxs[num];
                   yes = 1;
                   break;}
               }
            if (!yes) value = bkg_color;
            magnify_int_pixel(out_2d_buf,out_dimx,out_dimy,
                colors[0]->_2d.pixel_depth,x_out,y_out,pixel_desc,value);
           }
    }
   else
    {for (y_out = 0,y = top; y <= bottom; y++,y_out += pixel_desc->mask.dimy)
        for (x_out = 0,x = left; x <= right; x++,x_out += pixel_desc->mask.dimx)
           {
            for (yes = 0,num_bufs = last; ; num_bufs--)
               {_2d = &(colors[num_bufs]->_2d);
                if (((ly = (y - _2d->startoffy)) < 0) ||
                    (ly >= (long) _2d->dimy) ||
                    ((lx = (x - _2d->startoffx)) < 0) ||
                    (lx >= (long) _2d->dimx))
                   {/*printf("%d) =lx = %D ly = %d startoffy = %d X = %D y = %d\n",
                             num_bufs,lx,ly,_2d->startoffy,x,y);*/
                    if (num_bufs == 0) break;}
                  else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                    (num_bufs == 0))
                  {if ((colors[num_bufs]->num_color_indxs > 0) &&
                       (value >= colors[num_bufs]->scale.first) &&
                       ((num = (value - colors[num_bufs]->scale.first)) < 
                              colors[num_bufs]->num_color_indxs))
                      value = colors[num_bufs]->color_indxs[num];
                   yes = 1;
                   break;}
               }
            if (!yes) value = bkg_color;
            magnify_int_pixel(out_2d_buf,out_dimx,out_dimy,
              colors[0]->_2d.pixel_depth,x_out,y_out,pixel_desc,map_values[value]);
           }
    }
}



/*------------------------------------------------------------------------
MagnifyAnySizeImage - ???
------------------------------------------------------------------------*/

void
MagnifyAnySizeImage(colors,num_colors,bound,
                    out_2d_buf,out_dimx,out_dimy,out_pixel_depth,
                    dimension,pixel_desc,map_values,num_map_values,bkg_color)
 struct color_data_rec **colors;
 unsigned long num_colors;
 struct int_bound_rec *bound;
 unsigned char **out_2d_buf;
 unsigned long out_dimx,out_dimy,out_pixel_depth;
 struct int_region_rect *dimension;
 struct pixel_desc_rec *pixel_desc;
 unsigned long *map_values;
 unsigned long num_map_values,bkg_color;
{
 long y_out,x_out,x,y,lx,ly,num_bufs,last,num;
 unsigned long value;
 int left,right,top,bottom,yes;
 struct buf_2d_rec *_2d;

 valid_bound(&(dimension->bound),bound,&left,&right,&top,&bottom);
/*
 get_valid_dimension_elems(dimension,colors[0]->_2d.dimx,colors[0]->_2d.dimy,
           &left,&right,&top,&bottom);
*/
 last = num_colors - 1;
 if (map_values == NULL)
    {for (y_out = 0,y = top; y <= bottom; y++,y_out += pixel_desc->mask.dimy)
        for (x_out = 0,x = left; x <= right; x++,x_out += pixel_desc->mask.dimx)
           {
            for (yes = 0,num_bufs = last; ; num_bufs--)
               {_2d = &(colors[num_bufs]->_2d);
                if (((ly = (y - _2d->startoffy)) < 0) ||
                    (ly >= (long) _2d->dimy) ||
                    ((lx = (x - _2d->startoffx)) < 0) ||
                    (lx >= (long) _2d->dimx))
                   {/*printf("%d) ly = %d startoffy = %d y = %d\n",
                             num_bufs,ly,_2d->startoffy,y);*/
                    if (num_bufs == 0) break;}
                  else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                      (num_bufs == 0))
                  {if ((colors[num_bufs]->num_color_indxs > 0) &&
                       (value >= colors[num_bufs]->scale.first) &&
                       ((num = (value - colors[num_bufs]->scale.first)) < 
                              colors[num_bufs]->num_color_indxs))
                      value = colors[num_bufs]->color_indxs[num];
                   yes = 1;
                   break;}
               }
            if (!yes) value = bkg_color;
            magnify_any_size_pixel(out_2d_buf,out_dimx,out_dimy,out_pixel_depth,
               x_out,y_out,pixel_desc,value);
           }
    }
   else
    {for (y_out = 0,y = top; y <= bottom; y++,y_out += pixel_desc->mask.dimy)
        for (x_out = 0,x = left; x <= right; x++,x_out += pixel_desc->mask.dimx)
           {
              for (yes = 0,num_bufs = last; ; num_bufs--)
                 {_2d = &(colors[num_bufs]->_2d);
                  if (((ly = (y - _2d->startoffy)) < 0) ||
                      (ly >= (long) _2d->dimy) ||
                      ((lx = (x - _2d->startoffx)) < 0) ||
                      (lx >= (long) _2d->dimx))
                     {/*printf("%d) ly = %d startoffy = %d y = %d\n",
                             num_bufs,ly,_2d->startoffy,y);*/
                      if (num_bufs == 0) break;}
                    else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                      (num_bufs == 0))
                  {if ((colors[num_bufs]->num_color_indxs > 0) &&
                       (value >= colors[num_bufs]->scale.first) &&
                       ((num = (value - colors[num_bufs]->scale.first)) < 
                              colors[num_bufs]->num_color_indxs))
                      value = colors[num_bufs]->color_indxs[num];
                   yes = 1;
                   break;}
               }
            if (!yes) value = bkg_color;

            value = map_values[value];
            magnify_any_size_pixel(out_2d_buf,out_dimx,out_dimy,out_pixel_depth,
               x_out,y_out,pixel_desc,value);
           }
    }
}


/*------------------------------------------------------------------------
MagnifyTheImage - ???
------------------------------------------------------------------------*/

int
MagnifyTheImage(colors,num_colors,bound,
                out_2d_buf,out_dimx,out_dimy,out_pixel_depth,
                dimension,pixel_desc,map_values,num_map_values,bkg_color)
 struct color_data_rec **colors;
 unsigned long num_colors;
 struct int_bound_rec *bound;
 unsigned short **out_2d_buf;
 unsigned long out_dimx,out_dimy,out_pixel_depth;
 struct int_region_rect *dimension;
 struct pixel_desc_rec *pixel_desc;
 unsigned long *map_values,num_map_values,bkg_color;
{

 PRT(printf("magnify_image...out_pixel_depth = %d\n",
          out_pixel_depth))
 if (colors[0]->_2d.pixel_depth != out_pixel_depth)
    {MagnifyAnySizeImage(colors,num_colors,bound,out_2d_buf,
                  out_dimx,out_dimy,out_pixel_depth,dimension,pixel_desc,
                  map_values,num_map_values,bkg_color);
     return NO_ERROR;}

 PRT(printf("magnify_image...1\n"))
 switch (colors[0]->_2d.pixel_depth)
    {
     case 8 :
        MagnifyByteImage(colors,num_colors,bound,
               out_2d_buf,out_dimx,out_dimy,dimension,pixel_desc,
               map_values,num_map_values,bkg_color);
        
        return NO_ERROR;
     case 1 : MagnifyBitImage(colors,num_colors,bound,
                  out_2d_buf,out_dimx,out_dimy,dimension,pixel_desc,
                  map_values,num_map_values,bkg_color);
        return NO_ERROR;
     case 16 : MagnifyShortImage(colors,num_colors,bound,
                  out_2d_buf,out_dimx,out_dimy,dimension,pixel_desc,
                  map_values,num_map_values,bkg_color);
        return NO_ERROR;
     case 32 : MagnifyIntImage(colors,num_colors,bound,
                  out_2d_buf,out_dimx,out_dimy,dimension,pixel_desc,
                  map_values,num_map_values,bkg_color);
        return NO_ERROR;
     default : 
        MagnifyAnySizeImage(colors,num_colors,bound,
                  out_2d_buf,out_dimx,out_dimy,out_pixel_depth,dimension,
                  pixel_desc,map_values,num_map_values,bkg_color);
        return NO_ERROR;
    };
}


/*------------------------------------------------------------------------
get_shrink_dim - ???
------------------------------------------------------------------------*/

int
get_shrink_dim(dimx,dimy,shrink_xratio,shrink_yratio,new_dimx,new_dimy)
 unsigned long dimx,dimy,*new_dimx,*new_dimy;
 float shrink_xratio,shrink_yratio;
{
 long num_xpixels,num_ypixels;

 num_xpixels = (long) ULongRound(1.0 / shrink_xratio);
 num_ypixels = (long) ULongRound(1.0 / shrink_yratio);
 *new_dimx = dimx / num_xpixels;
 if (dimx % num_xpixels) (*new_dimx)++;
 *new_dimy = dimy / num_ypixels;
 if (dimy % num_ypixels) (*new_dimy)++;
 return NO_ERROR;
}


/**************************
shrink_image_and_set(_2d,shrink_xratio,shrink_yratio,result,result_elem_value,
                is_fit_result)
 struct buf_2d_rec *_2d,*result;
 float shrink_xratio,shrink_yratio;
 unsigned long result_elem_value;
 int is_fit_result;
{
 unsigned long row,col,dimx,dimy,pixel_depth,lcv,cnt;
 long num_xpixels,num_ypixels;
 unsigned long first,last,first_row,last_row;
 int err,yes;

 if ((shrink_xratio <= .0) || (shrink_xratio > 1.0)) return ABORT;
 if ((shrink_yratio <= .0) || (shrink_yratio > 1.0)) return ABORT;
 if ((shrink_xratio == 1.0) && (shrink_yratio == 1.0)) return NO_ERROR;
 
 num_xpixels = (long) ULongRound(1 / shrink_xratio);
 num_ypixels = (long) ULongRound(1 / shrink_yratio);
 get_shrink_dim(_2d->dimx,_2d->dimy,shrink_xratio,shrink_yratio,&dimx,&dimy);
 if (result->pixel_depth) pixel_depth = result->pixel_depth;
   else pixel_depth = find_num_bits_needed(result_elem_value);

 if (_2d == result) yes = 0;
   else if (is_fit_result) yes = 1;
   else
    {if ((result->dimx < dimx) || (result->dimy < dimy) ||
         (result->pixel_depth < pixel_depth)) yes = 1;
       else yes = 0;}
 if (yes)
    if ((err = SetupBuf2dRec(result,dimx,dimy,pixel_depth,1)) != NO_ERROR)
       return err;
 for (row = 0; row < dimy; row++)
    for (col = 0; col < dimx; col++)
       {first_row = row * num_ypixels;
        last_row = first_row + num_ypixels;
        if (last_row > _2d->dimy) last_row = _2d->dimy;
        for (yes = 0,lcv = first_row; (lcv < last_row) && !yes; lcv++)
           {first = col * num_xpixels;
            last = first + num_xpixels;
            if (last > _2d->dimx) last = _2d->dimx;
            for (cnt = first; cnt < last; cnt++)
              if (get_1d_buf_value(_2d->buf[lcv],cnt,_2d->pixel_depth))
                 {yes = 1;
                  set_1d_buf_value(result->buf[row],col,result->pixel_depth,
                          result_elem_value);
                  break;}
           }
        if (!yes) set_1d_buf_value(result->buf[row],col,result->pixel_depth,0);
       }
 return NO_ERROR;
}


shrink_image_and_or(_2d,shrink_xratio,shrink_yratio,result)
 struct buf_2d_rec *_2d,*result;
 float shrink_xratio,shrink_yratio;
{
 unsigned long row,col,dimx,dimy,pixel_depth,lcv,cnt;
 unsigned long first,last,first_row,last_row;
 unsigned long result_elem_value;
 int err;

 if ((shrink_xratio <= .0) || (shrink_xratio > 1.0)) return ABORT;
 if ((shrink_yratio <= .0) || (shrink_yratio > 1.0)) return ABORT;
 if ((shrink_xratio == 1.0) && (shrink_yratio == 1.0)) return NO_ERROR;
 get_shrink_dim(_2d->dimx,_2d->dimy,shrink_xratio,shrink_yratio,&dimx,&dimy);

 if (result->pixel_depth) pixel_depth = result->pixel_depth;
   else pixel_depth = find_num_bits_needed(result_elem_value);

 if ((err = SetupBuf2dRec(result,dimx,dimy,pixel_depth,0)) != NO_ERROR)
    return err;
 for (row = 0; row < dimy; row++)
    for (col = 0; col < dimx; col++)
       {first_row = row * num_ypixels;
        last_row = first_row + num_ypixels;
        if (last_row > _2d->dimy) last_row = _2d->dimy;
        for (result_elem_value = 0,lcv = first_row; lcv < last_row; lcv++)
           {first = col * num_xpixels;
            last = first + num_xpixels;
            if (last > _2d->dimx) last = _2d->dimx;
            for (cnt = first; cnt < last; cnt++)
               result_elem_value |= get_1d_buf_value(_2d->buf[lcv],cnt,_
                      2d->pixel_depth);
           }
        set_1d_buf_value(result->buf[row],col,result->pixel_depth,
                           result_elem_value);
       }
 return NO_ERROR;
}
***************************/
