/****************************************************************************
magnify_pixels.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: magnify_pixel.c,v 1.9 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "ria_global.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)



/* Functions defined in this file */
int MagBitPixel(struct screen_data_rec *screen, struct buf_2d_rec *_2d,
    struct buf_2d_rec *mask, struct int_bound_rec *affected,
    unsigned long offset_pixel_value, unsigned long *real_color_indxs,
    unsigned long num_real_color_indxs);
int MagBytePixel(struct screen_data_rec *screen, struct buf_2d_rec *_2d,
    struct buf_2d_rec *mask, struct int_bound_rec *affected,
    unsigned long offset_pixel_value, unsigned long *real_color_indxs,
    unsigned long num_real_color_indxs);
int MagShortPixel(struct screen_data_rec *screen, struct buf_2d_rec *_2d,
    struct buf_2d_rec *mask, struct int_bound_rec *affected,
    unsigned long offset_pixel_value, unsigned long *real_color_indxs,
    unsigned long num_real_color_indxs);
int MagIntPixel(struct screen_data_rec *screen, struct buf_2d_rec *_2d,
    struct buf_2d_rec *mask, struct int_bound_rec *affected,
    unsigned long offset_pixel_value, unsigned long *real_color_indxs,
    unsigned long num_real_color_indxs);
int MagAnySizePixel(struct screen_data_rec *screen, struct buf_2d_rec *_2d,
    struct buf_2d_rec *mask, struct int_bound_rec *affected,
    unsigned long offset_pixel_value, unsigned long *real_color_indxs,
    unsigned long num_real_color_indxs);
int MagPixelProc(struct screen_data_rec *screen, struct buf_2d_rec *_2d,
    struct buf_2d_rec *mask, struct int_bound_rec *affected,
    unsigned long offset_pixel_value, unsigned long *real_color_indxs,
    unsigned long num_real_color_indxs);



/*------------------------------------------------------------------------
MagBitPixel - ???
------------------------------------------------------------------------*/

int
MagBitPixel(screen,_2d,mask,affected,offset_pixel_value,
            real_color_indxs,num_real_color_indxs)
 struct screen_data_rec *screen;
 struct buf_2d_rec *_2d,*mask;
 struct int_bound_rec *affected;
 unsigned long offset_pixel_value;
 unsigned long *real_color_indxs;
 unsigned long num_real_color_indxs;
{
 unsigned char **_2d_buf;
 struct pixel_desc_rec *pixel_desc;

 unsigned long byte_indx,bit_indx;
 unsigned long row1,col1,lcv,fnum_xys,bnum_xys;
 unsigned long *fxptr,*fyptr,*bxptr,*byptr,*back_value;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 static unsigned char bits[] = {0x7f,0xbf,0xdf,0xef,0xf7,0xfb,0xfd,0xfe};

 unsigned long row,col,x,y,value;
 unsigned long left,right,top,bottom;
 struct int_bound_rec bound;

 unsigned long start_byte,start_col_bit,stop_byte;
 unsigned long start_bit,end_bit,col_bit,cnt,indx;
 unsigned char cur_byte;

 setup_int_bound_rec(&bound,0,0,_2d->dimx - 1,_2d->dimy - 1);
 if (affected != NULL)
    {valid_bound(affected,&bound,&left,&right,&top,&bottom);
     setup_int_bound_rec(&bound,left,top,right,bottom);}
 valid_bound(&(screen->dimension.bound),&bound,&left,&right,&top,&bottom);
 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;

 pixel_desc = &(screen->pixel);
 fnum_xys = pixel_desc->fore.num_xys;
 fxptr = (unsigned long *) pixel_desc->fore.x;
 fyptr = (unsigned long *) pixel_desc->fore.y;
 bnum_xys = pixel_desc->back.num_xys;
 bxptr = (unsigned long *) pixel_desc->back.x;
 byptr = (unsigned long *) pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 _2d_buf = screen->_2d.buf;

 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     y = bufy_to_screeny(screen,row);
     for (col_bit = start_col_bit,col = start_byte;
              col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if ((mask == NULL) || (cur_byte = mask->buf[row][col]))
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if ((mask == NULL) || (cur_byte & _1_bit[cnt]))
                  {if (value = get_1d_buf_value(_2d->buf[row],indx,
                                        _2d->pixel_depth))
                     {x = bufx_to_screenx(screen,(int) indx);
                      value += offset_pixel_value;

                      value = (unsigned long) real_color_indxs[value];
                      for (lcv = 0; lcv < fnum_xys; lcv++)
                         {row1 = y + fyptr[lcv];
                          col1 = x + fxptr[lcv];
                          byte_indx = col1 / 8;
                          bit_indx = col1 % 8;
                          if (value) 
                             _2d_buf[row1][byte_indx] |= _1_bit[bit_indx];
                            else _2d_buf[row1][byte_indx] &= bits[bit_indx];
                         }

                      for (lcv = 0; lcv < bnum_xys; lcv++)
                         {row1 = y + byptr[lcv];
                          col1 = x + bxptr[lcv];
                          byte_indx = col1 / 8;
                          bit_indx = col1 % 8;
                          if (back_value[lcv])
                             _2d_buf[row1][byte_indx] |= _1_bit[bit_indx];
                            else _2d_buf[row1][byte_indx] &= bits[bit_indx];
                         }
                     }
                 }
           }
    }
 TRACE(printf("MagBitPixel..end\n"))
 return NO_ERROR;

}


/*------------------------------------------------------------------------
MagBytePixel - ???
------------------------------------------------------------------------*/

int
MagBytePixel(screen,_2d,mask,affected,offset_pixel_value,
            real_color_indxs,num_real_color_indxs)
 struct screen_data_rec *screen;
 struct buf_2d_rec *_2d,*mask;
 struct int_bound_rec *affected;
 unsigned long offset_pixel_value;
 unsigned long *real_color_indxs;
 unsigned long num_real_color_indxs;
{
 unsigned char **_2d_buf;
 struct pixel_desc_rec *pixel_desc;

 unsigned long row1,col1,lcv,fnum_xys,bnum_xys;
 unsigned long *fxptr,*fyptr,*bxptr,*byptr,*back_value;

 unsigned long row,col,x,y,value;
 unsigned long left,right,top,bottom;
 struct int_bound_rec bound;

 unsigned long start_byte,start_col_bit,stop_byte;
 unsigned long start_bit,end_bit,col_bit,cnt,indx;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 unsigned char cur_byte;

 TRACE(printf("MagBytePixel..\n"))
 setup_int_bound_rec(&bound,0,0,_2d->dimx - 1,_2d->dimy - 1);
 if (affected != NULL)
    {valid_bound(affected,&bound,&left,&right,&top,&bottom);
     setup_int_bound_rec(&bound,left,top,right,bottom);}
 valid_bound(&(screen->dimension.bound),&bound,&left,&right,&top,&bottom);
 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;

 pixel_desc = &(screen->pixel);
 fnum_xys = pixel_desc->fore.num_xys;
 fxptr = pixel_desc->fore.x;
 fyptr = pixel_desc->fore.y;
 bnum_xys = pixel_desc->back.num_xys;
 bxptr = pixel_desc->back.x;
 byptr = pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 _2d_buf = screen->_2d.buf;
 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     y = bufy_to_screeny(screen,row);
     for (col_bit = start_col_bit,col = start_byte;
              col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if ((mask == NULL) || (cur_byte = mask->buf[row][col]))
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if ((mask == NULL) || (cur_byte & _1_bit[cnt]))
                  {if (value = get_1d_buf_value(_2d->buf[row],indx,
                                        _2d->pixel_depth))
                      {x = bufx_to_screenx(screen,(int) indx);
                       value += offset_pixel_value;

                       value = (unsigned long) real_color_indxs[value];
                       for (lcv = 0; lcv < fnum_xys; lcv++)
                          {row1 = y + fyptr[lcv];
                           col1 = x + fxptr[lcv];
                           _2d_buf[row1][col1] = value;
                          }

                       for (lcv = 0; lcv < bnum_xys; lcv++)
                          {row1 = y + byptr[lcv];
                           col1 = x + bxptr[lcv];
                           _2d_buf[row1][col1] = back_value[lcv];
                          }
                      }
                  }
            }
    }
 TRACE(printf("MagBytePixel..end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
MagShortPixel - ???
------------------------------------------------------------------------*/

int
MagShortPixel(screen,_2d,mask,affected,offset_pixel_value,
            real_color_indxs,num_real_color_indxs)
 struct screen_data_rec *screen;
 struct buf_2d_rec *_2d,*mask;
 struct int_bound_rec *affected;
 unsigned long offset_pixel_value;
 unsigned long *real_color_indxs;
 unsigned long num_real_color_indxs;
{
 unsigned short **_2d_buf;
 struct pixel_desc_rec *pixel_desc;

 unsigned long row1,col1,lcv,fnum_xys,bnum_xys;
 unsigned long *fxptr,*fyptr,*bxptr,*byptr,*back_value;

 unsigned long row,col,x,y,value;
 unsigned long left,right,top,bottom;
 struct int_bound_rec bound;

 unsigned long start_byte,start_col_bit,stop_byte;
 unsigned long start_bit,end_bit,col_bit,cnt,indx;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 unsigned char cur_byte;

 TRACE(printf("MagShortPixel..\n"))
 setup_int_bound_rec(&bound,0,0,_2d->dimx - 1,_2d->dimy - 1);
 if (affected != NULL)
    {valid_bound(affected,&bound,&left,&right,&top,&bottom);
     setup_int_bound_rec(&bound,left,top,right,bottom);}
 valid_bound(&(screen->dimension.bound),&bound,&left,&right,&top,&bottom);
 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;

 pixel_desc = &(screen->pixel);
 fnum_xys = pixel_desc->fore.num_xys;
 fxptr = pixel_desc->fore.x;
 fyptr = pixel_desc->fore.y;
 bnum_xys = pixel_desc->back.num_xys;
 bxptr = pixel_desc->back.x;
 byptr = pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 _2d_buf = (unsigned short **) screen->_2d.buf;
 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     y = bufy_to_screeny(screen,row);
     for (col_bit = start_col_bit,col = start_byte;
              col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if ((mask == NULL) || (cur_byte = mask->buf[row][col]))
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if ((mask == NULL) || (cur_byte & _1_bit[cnt]))
                  {if (value = get_1d_buf_value(_2d->buf[row],indx,
                                        _2d->pixel_depth))
                      {x = bufx_to_screenx(screen,(int) indx);
                       value += offset_pixel_value;

                       value = (unsigned long) real_color_indxs[value];

                       for (lcv = 0; lcv < fnum_xys; lcv++)
                          {row1 = y + fyptr[lcv];
                           col1 = x + fxptr[lcv];
                           _2d_buf[row1][col1] = value;
                          }

                       for (lcv = 0; lcv < bnum_xys; lcv++)
                          {row1 = y + byptr[lcv];
                           col1 = x + bxptr[lcv];
                           _2d_buf[row1][col1] = back_value[lcv];
                          }
                       }
                  }
            }
    }
 TRACE(printf("MagShortPixel..end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
MagIntPixel - ???
------------------------------------------------------------------------*/

int
MagIntPixel(screen,_2d,mask,affected,offset_pixel_value,
            real_color_indxs,num_real_color_indxs)
 struct screen_data_rec *screen;
 struct buf_2d_rec *_2d,*mask;
 struct int_bound_rec *affected;
 unsigned long offset_pixel_value;
 unsigned long *real_color_indxs;
 unsigned long num_real_color_indxs;
{
 unsigned int **_2d_buf;
 struct pixel_desc_rec *pixel_desc;

 unsigned long row1,col1,lcv,fnum_xys,bnum_xys;
 unsigned long *fxptr,*fyptr,*bxptr,*byptr,*back_value;

 unsigned long row,col,x,y,value;
 unsigned long left,right,top,bottom;
 struct int_bound_rec bound;

 unsigned long start_byte,start_col_bit,stop_byte;
 unsigned long start_bit,end_bit,col_bit,cnt,indx;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 unsigned char cur_byte;

 TRACE(printf("MagIntPixel..\n"))
 setup_int_bound_rec(&bound,0,0,_2d->dimx - 1,_2d->dimy - 1);
 if (affected != NULL)
    {valid_bound(affected,&bound,&left,&right,&top,&bottom);
     setup_int_bound_rec(&bound,left,top,right,bottom);}
 valid_bound(&(screen->dimension.bound),&bound,&left,&right,&top,&bottom);
 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;

 pixel_desc = &(screen->pixel);
 fnum_xys = pixel_desc->fore.num_xys;
 fxptr = pixel_desc->fore.x;
 fyptr = pixel_desc->fore.y;
 bnum_xys = pixel_desc->back.num_xys;
 bxptr = pixel_desc->back.x;
 byptr = pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 _2d_buf = (unsigned int **) screen->_2d.buf;
 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     y = bufy_to_screeny(screen,row);
     for (col_bit = start_col_bit,col = start_byte;
              col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if ((mask == NULL) || (cur_byte = mask->buf[row][col]))
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if ((mask == NULL) || (cur_byte & _1_bit[cnt]))
                  {if (value = get_1d_buf_value(_2d->buf[row],indx,
                                        _2d->pixel_depth))
                      {x = bufx_to_screenx(screen,(int) indx);
                       value += offset_pixel_value;

                       value = (unsigned long) real_color_indxs[value];

                       for (lcv = 0; lcv < fnum_xys; lcv++)
                          {row1 = y + fyptr[lcv];
                           col1 = x + fxptr[lcv];
                           _2d_buf[row1][col1] = value;
                          }

                       for (lcv = 0; lcv < bnum_xys; lcv++)
                          {row1 = y + byptr[lcv];
                           col1 = x + bxptr[lcv];
                           _2d_buf[row1][col1] = back_value[lcv];
                          }
                      }
                   }
            }
    }
 TRACE(printf("MagIntPixel..end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
MagAnySizePixel - ???
------------------------------------------------------------------------*/

int
MagAnySizePixel(screen,_2d,mask,affected,offset_pixel_value,
            real_color_indxs,num_real_color_indxs)
 struct screen_data_rec *screen;
 struct buf_2d_rec *_2d,*mask;
 struct int_bound_rec *affected;
 unsigned long offset_pixel_value;
 unsigned long *real_color_indxs;
 unsigned long num_real_color_indxs;
{
 unsigned char **_2d_buf;
 struct pixel_desc_rec *pixel_desc;

 unsigned long row1,col1,lcv,fnum_xys,bnum_xys;
 unsigned long *fxptr,*fyptr,*bxptr,*byptr,*back_value;

 unsigned long row,col,x,y,value;
 unsigned long left,right,top,bottom;
 struct int_bound_rec bound;

 unsigned long start_byte,start_col_bit,stop_byte;
 unsigned long start_bit,end_bit,col_bit,cnt,indx;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 unsigned char cur_byte;

 TRACE(printf("MagAnySizePixel..\n"))
 setup_int_bound_rec(&bound,0,0,_2d->dimx - 1,_2d->dimy - 1);
 if (affected != NULL)
    {valid_bound(affected,&bound,&left,&right,&top,&bottom);
     setup_int_bound_rec(&bound,left,top,right,bottom);}
 valid_bound(&(screen->dimension.bound),&bound,&left,&right,&top,&bottom);
 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;

 pixel_desc = &(screen->pixel);
 fnum_xys = pixel_desc->fore.num_xys;
 fxptr = pixel_desc->fore.x;
 fyptr = pixel_desc->fore.y;
 bnum_xys = pixel_desc->back.num_xys;
 bxptr = pixel_desc->back.x;
 byptr = pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 _2d_buf = screen->_2d.buf;
 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     y = bufy_to_screeny(screen,row);
     for (col_bit = start_col_bit,col = start_byte;
              col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if ((mask == NULL) || (cur_byte = mask->buf[row][col]))
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if ((mask == NULL) || (cur_byte & _1_bit[cnt]))
                  {if (value = get_1d_buf_value(_2d->buf[row],indx,
                                        _2d->pixel_depth))
                      {x = bufx_to_screenx(screen,(int) indx);
                       value += offset_pixel_value;

                       value = (unsigned long) real_color_indxs[value];

                       for (lcv = 0; lcv < fnum_xys; lcv++)
                          {row1 = y + fyptr[lcv];
                           col1 = x + fxptr[lcv];
                           set_1d_buf_value(_2d_buf[row1],col1,
                                screen->_2d.pixel_depth,value);
                          }

                       for (lcv = 0; lcv < bnum_xys; lcv++)
                          {row1 = y + byptr[lcv];
                           col1 = x + bxptr[lcv];
                           set_1d_buf_value(_2d_buf[row1],col1,
                              screen->_2d.pixel_depth,back_value[lcv]);
                          }
                      }
                   }
            }
    }
 TRACE(printf("MagAnySizePixel..end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
MagPixelProc - ???
------------------------------------------------------------------------*/

int
MagPixelProc(screen,_2d,mask,affected,offset_pixel_value,
                   real_color_indxs,num_real_color_indxs)
 struct screen_data_rec *screen;
 struct buf_2d_rec *_2d,*mask;
 struct int_bound_rec *affected;
 unsigned long offset_pixel_value;
 unsigned long *real_color_indxs;
 unsigned long num_real_color_indxs;
{
 switch (screen->_2d.pixel_depth)
    {case 8 :
        return MagBytePixel(screen,_2d,mask,affected,offset_pixel_value,
                             real_color_indxs,num_real_color_indxs);
     case 16 : 
        return MagShortPixel(screen,_2d,mask,affected,offset_pixel_value,
                             real_color_indxs,num_real_color_indxs);
     case 32 : 
        return MagIntPixel(screen,_2d,mask,affected,offset_pixel_value,
                             real_color_indxs,num_real_color_indxs);
     case 1 :
        return MagBitPixel(screen,_2d,mask,affected,offset_pixel_value,
                             real_color_indxs,num_real_color_indxs);
     default : 
        return MagAnySizePixel(screen,_2d,mask,affected,offset_pixel_value,
                             real_color_indxs,num_real_color_indxs);
    }
}


/*********************************************************************
MagBitPixelByXys(screen,coords,value,dirty_screen_bound,display_status)
 struct screen_data_rec *screen;
 struct coord_rec *coords;
 int value;
 struct int_bound_rec *dirty_screen_bound;
 unsigned short *display_status;
{
 unsigned char **_2d_buf;
 struct pixel_desc_rec *pixel_desc;

 int yes;
 unsigned long byte_indx,bit_indx,dimx,dimy,cnt;
 unsigned long row1,col1,lcv,fnum_xys,bnum_xys;
 unsigned long *fxptr,*fyptr,*bxptr,*byptr,*back_value;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 static unsigned char bits[] = {0x7f,0xbf,0xdf,0xef,0xf7,0xfb,0xfd,0xfe};

 unsigned long row,col,x,y,x1,y1;

 pixel_desc = &(screen->pixel);
 fnum_xys = pixel_desc->fore.num_xys;
 fxptr = pixel_desc->fore.x;
 fyptr = pixel_desc->fore.y;
 bnum_xys = pixel_desc->back.num_xys;
 bxptr = pixel_desc->back.x;
 byptr = pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 _2d_buf = screen->_2d.buf;
 dimx = screen->_2d.dimx;
 dimy = screen->_2d.dimy;
 if (*display_status & WIN_SHOW_SCREEN_BOUND)
    yes = 1;
   else yes = 0;

 for (cnt = 0; cnt < coords->num_pts; cnt++)
    {y1 = coords->pts[cnt].y;
     x1 = coords->pts[cnt].x;
     y = bufy_to_screeny(screen,y1);
     x = bufx_to_screenx(screen,x1);
     if ((x >= 0) && (x < dimx) &&
         (y >= 0) && (y < dimy))
        {if (yes)
            {if (dirty_screen_bound->left > x1) dirty_screen_bound->left = x1;
             if (dirty_screen_bound->right < x1) dirty_screen_bound->right = x1;
             if (dirty_screen_bound->top > y1) dirty_screen_bound->top = y1;
             if (dirty_screen_bound->bottom < y1) dirty_screen_bound->bottom = y1;}
           else
            {yes = 1;
             setup_int_bound_rec(dirty_screen_bound,x1,y1,x1,y1);}

         for (lcv = 0; lcv < fnum_xys; lcv++)
            {row1 = y + fyptr[lcv];
             col1 = x + fxptr[lcv];
             byte_indx = col1 / 8;
             bit_indx = col1 % 8;
             if (value) _2d_buf[row1][byte_indx] |= _1_bit[bit_indx];
               else _2d_buf[row1][byte_indx] &= bits[bit_indx];
            }

         for (lcv = 0; lcv < bnum_xys; lcv++)
            {row1 = y + byptr[lcv];
             col1 = x + bxptr[lcv];
             byte_indx = col1 / 8;
             bit_indx = col1 % 8;
             if (back_value[lcv])
                _2d_buf[row1][byte_indx] |= _1_bit[bit_indx];
               else _2d_buf[row1][byte_indx] &= bits[bit_indx];
            }
        }
    }
 if (yes) *display_status |= WIN_SHOW_SCREEN_BOUND;
 TRACE(printf("MagBitPixelByXys..end\n"))
 return NO_ERROR;

}

MagBytePixelByXys(screen,coords,value,dirty_screen_bound,display_status)
 struct screen_data_rec *screen;
 struct coord_rec *coords;
 int value;
 struct int_bound_rec *dirty_screen_bound;
 unsigned short *display_status;
{
 unsigned char **_2d_buf;
 struct pixel_desc_rec *pixel_desc;

 unsigned long row1,col1,lcv,fnum_xys,bnum_xys,dimx,dimy,cnt;
 unsigned long *fxptr,*fyptr,*bxptr,*byptr,*back_value;
 int yes;

 unsigned long row,col,x,y,x1,y1;

 TRACE(printf("MagBytePixelByXys..\n");)
 pixel_desc = &(screen->pixel);
 fnum_xys = pixel_desc->fore.num_xys;
 fxptr = pixel_desc->fore.x;
 fyptr = pixel_desc->fore.y;
 bnum_xys = pixel_desc->back.num_xys;
 bxptr = pixel_desc->back.x;
 byptr = pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 _2d_buf = screen->_2d.buf;
 dimx = screen->_2d.dimx;
 dimy = screen->_2d.dimy;
 if (*display_status & WIN_SHOW_SCREEN_BOUND)
    yes = 1;
   else yes = 0;
 for (cnt = 0; cnt < coords->num_pts; cnt++)
    {y1 = coords->pts[cnt].y;
     x1 = coords->pts[cnt].x;
     y = bufy_to_screeny(screen,y1);
     x = bufx_to_screenx(screen,x1);
     if ((x >= 0) && (x < dimx) &&
         (y >= 0) && (y < dimy))
        {if (yes)
            {if (dirty_screen_bound->left > x1) dirty_screen_bound->left = x1;
             if (dirty_screen_bound->right < x1) dirty_screen_bound->right = x1;
             if (dirty_screen_bound->top > y1) dirty_screen_bound->top = y1;
             if (dirty_screen_bound->bottom < y1) dirty_screen_bound->bottom = y1;}
           else
            {yes = 1;
             setup_int_bound_rec(dirty_screen_bound,x1,y1,x1,y1);}

          for (lcv = 0; lcv < fnum_xys; lcv++)
             {row1 = y + fyptr[lcv];
              col1 = x + fxptr[lcv];
              _2d_buf[row1][col1] = value;
             }

          for (lcv = 0; lcv < bnum_xys; lcv++)
             {row1 = y + byptr[lcv];
              col1 = x + bxptr[lcv];
              _2d_buf[row1][col1] = back_value[lcv];
             }
         }
    }
 if (yes) *display_status |= WIN_SHOW_SCREEN_BOUND;
 TRACE(printf("MagBytePixelByXys..end\n"))
 return NO_ERROR;
}

MagShortPixelByXys(screen,coords,value,dirty_screen_bound,display_status)
 struct screen_data_rec *screen;
 struct coord_rec *coords;
 int value;
 struct int_bound_rec *dirty_screen_bound;
 unsigned short *display_status;
{
 unsigned short **_2d_buf;
 struct pixel_desc_rec *pixel_desc;

 int yes;
 unsigned long row1,col1,lcv,fnum_xys,bnum_xys,dimx,dimy,cnt;
 unsigned long *fxptr,*fyptr,*bxptr,*byptr,*back_value;

 unsigned long row,col,x,y,x1,y1;

 TRACE(printf("MagShortPixelByXys..\n"))
 pixel_desc = &(screen->pixel);
 fnum_xys = pixel_desc->fore.num_xys;
 fxptr = pixel_desc->fore.x;
 fyptr = pixel_desc->fore.y;
 bnum_xys = pixel_desc->back.num_xys;
 bxptr = pixel_desc->back.x;
 byptr = pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 _2d_buf = (unsigned short **) screen->_2d.buf;
 dimx = screen->_2d.dimx;
 dimy = screen->_2d.dimy;
 if (*display_status & WIN_SHOW_SCREEN_BOUND)
    yes = 1;
   else yes = 0;
 for (cnt = 0; cnt < coords->num_pts; cnt++)
    {y1 = coords->pts[cnt].y;
     x1 = coords->pts[cnt].x;
     y = bufy_to_screeny(screen,y1);
     x = bufx_to_screenx(screen,x1);
     if ((x >= 0) && (x < dimx) &&
         (y >= 0) && (y < dimy))
        {if (yes)
            {if (dirty_screen_bound->left > x1) dirty_screen_bound->left = x1;
             if (dirty_screen_bound->right < x1) dirty_screen_bound->right = x1;
             if (dirty_screen_bound->top > y1) dirty_screen_bound->top = y1;
             if (dirty_screen_bound->bottom < y1) dirty_screen_bound->bottom = y1;}
           else
            {yes = 1;
             setup_int_bound_rec(dirty_screen_bound,x1,y1,x1,y1);}
         for (lcv = 0; lcv < fnum_xys; lcv++)
            {row1 = y + fyptr[lcv];
             col1 = x + fxptr[lcv];
             _2d_buf[row1][col1] = value;
            }

         for (lcv = 0; lcv < bnum_xys; lcv++)
            {row1 = y + byptr[lcv];
             col1 = x + bxptr[lcv];
             _2d_buf[row1][col1] = back_value[lcv];
            }
        }
    }
 TRACE(printf("MagShortPixelByXys..end\n"))
 if (yes) *display_status |= WIN_SHOW_SCREEN_BOUND;
 return NO_ERROR;
}

MagIntPixelByXys(screen,coords,value,dirty_screen_bound,display_status)
 struct screen_data_rec *screen;
 struct coord_rec *coords;
 int value;
 struct int_bound_rec *dirty_screen_bound;
 unsigned short *display_status;
{
 unsigned int **_2d_buf;
 struct pixel_desc_rec *pixel_desc;

 int yes;
 unsigned long row1,col1,lcv,fnum_xys,bnum_xys,dimx,dimy,cnt;
 unsigned long *fxptr,*fyptr,*bxptr,*byptr,*back_value;

 unsigned long row,col,x,y,x1,y1;

 TRACE(printf("MagIntPixelByXys..\n"))
 pixel_desc = &(screen->pixel);
 fnum_xys = pixel_desc->fore.num_xys;
 fxptr = pixel_desc->fore.x;
 fyptr = pixel_desc->fore.y;
 bnum_xys = pixel_desc->back.num_xys;
 bxptr = pixel_desc->back.x;
 byptr = pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 _2d_buf = (unsigned int **) screen->_2d.buf;
 dimx = screen->_2d.dimx;
 dimy = screen->_2d.dimy;
 if (*display_status & WIN_SHOW_SCREEN_BOUND)
    yes = 1;
   else yes = 0;
 for (cnt = 0; cnt < coords->num_pts; cnt++)
    {y1 = coords->pts[cnt].y;
     x1 = coords->pts[cnt].x;
     y = bufy_to_screeny(screen,y1);
     x = bufx_to_screenx(screen,x1);
     if ((x >= 0) && (x < dimx) &&
         (y >= 0) && (y < dimy))
        {if (yes)
            {if (dirty_screen_bound->left > x1) dirty_screen_bound->left = x1;
             if (dirty_screen_bound->right < x1) dirty_screen_bound->right = x1;
             if (dirty_screen_bound->top > y1) dirty_screen_bound->top = y1;
             if (dirty_screen_bound->bottom < y1) dirty_screen_bound->bottom = y1;}
           else
            {yes = 1;
             setup_int_bound_rec(dirty_screen_bound,x1,y1,x1,y1);}

         for (lcv = 0; lcv < fnum_xys; lcv++)
            {row1 = y + fyptr[lcv];
             col1 = x + fxptr[lcv];
             _2d_buf[row1][col1] = value;
            }

         for (lcv = 0; lcv < bnum_xys; lcv++)
            {row1 = y + byptr[lcv];
             col1 = x + bxptr[lcv];
             _2d_buf[row1][col1] = back_value[lcv];
            }
        }
    }
 if (yes) *display_status |= WIN_SHOW_SCREEN_BOUND;
 TRACE(printf("MagIntPixelByXys..end\n"))
 return NO_ERROR;
}

MagAnySizePixelByXys(screen,coords,value,dirty_screen_bound,display_status)
 struct screen_data_rec *screen;
 struct coord_rec *coords;
 int value;
 struct int_bound_rec *dirty_screen_bound;
 unsigned short *display_status;
{
 unsigned char **_2d_buf;
 struct pixel_desc_rec *pixel_desc;

 int yes;
 unsigned long row1,col1,lcv,fnum_xys,bnum_xys,dimx,dimy,cnt;
 unsigned long *fxptr,*fyptr,*bxptr,*byptr,*back_value;

 unsigned long row,col,x,y,x1,y1;

 TRACE(printf("MagAnySizePixelByXys..\n"))
 pixel_desc = &(screen->pixel);
 fnum_xys = pixel_desc->fore.num_xys;
 fxptr = pixel_desc->fore.x;
 fyptr = pixel_desc->fore.y;
 bnum_xys = pixel_desc->back.num_xys;
 bxptr = pixel_desc->back.x;
 byptr = pixel_desc->back.y;
 back_value = pixel_desc->back.value;
 _2d_buf = screen->_2d.buf;
 dimx = screen->_2d.dimx;
 dimy = screen->_2d.dimy;
 if (*display_status & WIN_SHOW_SCREEN_BOUND)
    yes = 1;
   else yes = 0;
 for (cnt = 0; cnt < coords->num_pts; cnt++)
    {y1 = coords->pts[cnt].y;
     x1 = coords->pts[cnt].x;
     y = bufy_to_screeny(screen,y1);
     x = bufx_to_screenx(screen,x1);
     if ((x >= 0) && (x < dimx) &&
         (y >= 0) && (y < dimy))
        {if (yes)
            {if (dirty_screen_bound->left > x1) dirty_screen_bound->left = x1;
             if (dirty_screen_bound->right < x1) dirty_screen_bound->right = x1;
             if (dirty_screen_bound->top > y1) dirty_screen_bound->top = y1;
             if (dirty_screen_bound->bottom < y1) dirty_screen_bound->bottom = y1;}
           else
            {yes = 1;
             setup_int_bound_rec(dirty_screen_bound,x1,y1,x1,y1);}

          for (lcv = 0; lcv < fnum_xys; lcv++)
             {row1 = y + fyptr[lcv];
              col1 = x + fxptr[lcv];
              set_1d_buf_value(_2d_buf[row1],col1,screen->_2d.pixel_depth,
                            value);
             }

          for (lcv = 0; lcv < bnum_xys; lcv++)
             {row1 = y + byptr[lcv];
              col1 = x + bxptr[lcv];
              set_1d_buf_value(_2d_buf[row1],col1,screen->_2d.pixel_depth,
                            back_value[lcv]);
             }
        }
    }
 if (yes) *display_status |= WIN_SHOW_SCREEN_BOUND;
 TRACE(printf("MagAnySizePixelByXys..end\n"))
 return NO_ERROR;
}

MagPixelProcByXys(screen,coords,value,dirty_screen_bound,display_status)
 struct screen_data_rec *screen;
 struct coord_rec *coords;
 int value;
 struct int_bound_rec *dirty_screen_bound;
 unsigned short *display_status;
{
 switch (screen->_2d.pixel_depth)
    {case 8 :
        return MagBytePixelByXys(screen,coords,value,
                  dirty_screen_bound,display_status);
     case 16 : 
        return MagShortPixelByXys(screen,coords,value,
                  dirty_screen_bound,display_status);
     case 32 : 
        return MagIntPixelByXys(screen,coords,value,
                  dirty_screen_bound,display_status);
     case 1 :
        return MagBitPixelByXys(screen,coords,value,
                  dirty_screen_bound,display_status);
     default : 
        return MagAnySizePixelByXys(screen,coords,value,
                  dirty_screen_bound,display_status);
    }
}

*********************************************************************/
