/****************************************************************************
modify_img.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: modify_img.c,v 1.12 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <xview/xview.h>
#include <xview/notify.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "geometry.h"
#include "fft.h"
#include "nria_procedures.h"

/*
#define PRINT(x) printf(x); fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
*/
#define PRINT(x)
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)
#define PRT6(x)
#define PRT7(x)



#define SAVE_TYPE_PIXEL "SAVE ALL TYPE PIXELS"
#define CLEAN_UP_MODIFY_IMG 0
#define SETUP_MODIFY_IMG 1
#define GET_ALL_MODIFY_IMG_PTR 2

struct some_win_rec
   {
    Frame frame;
    Panel_item first,last;
    int min,max;
   };

struct gradient_win_rec
   {
    Frame frame;
    Panel panel;
    Panel_item which_option,display,set_threshold,threshold,
               set_gvalue,gvalue,set_image_value,image_value,
               testing,all_echoes;
    struct buf_2d_rec _2d;
   };

struct filter_win_rec
   {
    Frame frame;
    Panel panel;
    Panel_item which_filter,filter_which_freq,
               cut_off_freq,lb_cut_off_freq,order,
               testing;
   };

struct save_win_rec
   {
    Frame frame;
    Panel panel;
    Panel_item slice_num,label;
    int is_first_minmax;
    double min,max;
    struct hdr_scan_entry_rec *last_slice;
    struct buf_2d_rec slice_mask,*slice_map;
    struct img_rec img;
    unsigned long num_selected;
    unsigned char all_selected,*selected;
   };

struct modify_slice_option_rec
   {
    Frame frame;
    Panel_item snum_item,echo_item,scan_item,show_item;
    int is_comp,region_option,modify_option,show,auto_save;
    unsigned long fsnum,lsnum,fecho,lecho,fscan,lscan;
    unsigned long csnum,cecho,cscan;
    struct hdr_scan_entry_rec *cur_scan;
   };

#define SOME_SCANS_MIN_MAX_VALID 1
#define SOME_SLICES_MIN_MAX_VALID 2
#define INVERSE_FFT 4
struct modify_img_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item fill_val,region,apply_to,exc,pixel_type_item,smooth_which,
               which_slice,which_scan,threshold_color,on_each_slice,abs;
    int is_abs,is_on_each_slice;
    struct buf_2d_rec pixel_type_mask;

    struct hdr_scan_entry_rec *fft_cur_slice;
    struct buf_2d_rec fft,fft1;
    struct buf_2d_rec temp_2d;

    struct filter_win_rec filter;
    struct gradient_win_rec gradient;
    struct save_win_rec save;
    struct some_win_rec some_slices;
    struct some_win_rec some_scans;
    struct modify_slice_option_rec sl_options;
   };

#define FILL_IMAGE 1
#define SMOOTH_IMAGE_BY_9_NEIGHBORS 2
#define INVERT_IMAGE 3
#define ADD_IMAGE 4
#define MINUS_IMAGE 5
#define RESTORE_IMAGE 6
#define SAVE_IMAGE 7
#define FFT_IMAGE 8
#define FILTER_IMAGE 9
#define INVERSE_FFT_IMAGE 10
#define FFT_ON_INVERSE_FFT 11
#define INVERSE_FFT_ON_FFT 12
#define GRADIENT_IMAGE 13
#define PIXEL_TYPE_IMAGE 14
#define ADD_FILE_ECHOES 15
#define MINUS_FILE_ECHOES 16
#define THRESHOLD_COLOR_IMAGE 17
#define THRESHOLD_DARK_COLOR_IMAGE 18
#define RESAMPLE_IMAGE 19
#define ABS_ADD_IMAGE 20
#define ABS_MINUS_IMAGE 21
#define SMOOTH_IMAGE_BY_8_NEIGHBORS 22
#define SMOOTH_IMAGE_BY_16_NEIGHBORS 23
#define CONVOLUTION_IMAGE 24
#define CORRELATION_IMAGE 25

struct all_modify_img_recs
   {
    unsigned long num_mods;
    struct modify_img_rec **mods;
   };



/* Functions defined in this file */
void init_some_win_rec(struct some_win_rec *some);
void init_save_win_rec(struct save_win_rec *save);
void free_save_win_rec(struct save_win_rec *save);
void init_modify_img_rec(struct modify_img_rec *mod);
void free_modify_img_rec(struct modify_img_rec *mod);
void init_all_modify_img_recs(struct all_modify_img_recs *all_mods);
int SaveImage(struct modify_img_rec *mod, struct img_buf_rec *img);
int restore_image(struct modify_img_rec *mod, struct img_buf_rec *img);
int FftImage(Frame frame, struct buf_2d_rec *fftimg, struct buf_2d_rec *_2d);
int Fft(struct modify_img_rec *mod, struct img_buf_rec *img);
int InverseFftImage(Frame frame, struct buf_2d_rec *fftimg,
    struct buf_2d_rec *_2d);
int InverseFft(struct modify_img_rec *mod, struct img_buf_rec *img);
int InverseFftOnFft(struct modify_img_rec *mod, struct img_buf_rec *img);
int threshold_color_image(struct modify_img_rec *mod, struct img_buf_rec *img,
    struct buf_2d_rec *mask);
int threshold_dark_color_image(struct modify_img_rec *mod,
    struct img_buf_rec *img, struct buf_2d_rec *mask);
int mod_resample_image(struct modify_img_rec *mod, struct img_buf_rec *img,
    struct buf_2d_rec *mask);
int filter_image(struct modify_img_rec *mod, struct img_buf_rec *img);
int record_filter_image(Panel_item item, Event *event);
int add_image_echoes(struct modify_img_rec *mod, struct img_buf_rec *img,
    struct buf_2d_rec *mask, struct int_bound_rec *bound, int is_rd,
    int is_abs);
int minus_image_echoes(struct modify_img_rec *mod, struct img_buf_rec *img,
    struct buf_2d_rec *mask, struct int_bound_rec *bound, int is_rd,
    int is_abs);
int gradient_image(struct modify_img_rec *mod, struct img_buf_rec *img,
    struct buf_2d_rec *mask, struct int_bound_rec *bound);
int record_gradient_image(Panel_item item, Event *event);
int get_selected_pixel_types(struct img_buf_rec *img, Panel_item list,
    char **selected, unsigned long *num_selected, char *all_selected);
int pixel_type_image(struct modify_img_rec *mod, struct img_buf_rec *img,
    int is_display_err);
struct slice_roi_rec *mod_which_slice_roi(struct modify_img_rec *mod,
    struct img_buf_rec *img);
int ModifyImageOptionProc(struct modify_img_rec *mod, struct img_buf_rec *img,
    int is_comp, int region_option, int modify_option, int is_show_update);
int modify_is_update_slice(struct modify_img_rec *mod, unsigned long *fsnum,
    unsigned long *lsnum, unsigned long *fecho, unsigned long *lecho,
    unsigned long *fscan, unsigned long *lscan);
int modify_cur_image(struct modify_img_rec *mod, int modify_option);
int mod_slice_done_proc(Frame frame);
void modify_slice_show_proc(Panel_item item, int value, Event *event);
void modify_slice_cancel_proc(Panel_item item, Event *event);
int modify_slice_proc(Frame frame, int which);
int setup_modify_slice_option_rec(struct modify_img_rec *mod);
int modify_slice(struct modify_img_rec *mod, int modify_option);
int modify_image(Panel_item item, Event *event);
int win_convolution_with_wid(struct image_display_window *win, char *wid);
int win_correlation_with_wid(struct image_display_window *win, char *wid);
void modify_ask_win_proc(Panel_item item, Event *event);
void mod_set_on_each_slice_active(struct modify_img_rec *mod);
void mod_region_proc(Panel_item item, int value, Event *event);
void add_minus_echoes_proc(Panel_item item, int value, Event *event);
void smooth_image_proc(Panel_item item, Event *event);
void mod_some_slider_proc(Panel_item item, int value, Event *event);
void mod_some_done_proc(Frame frame);
int setup_some_win_rec(struct modify_img_rec *mod, int is_some_scans);
void mod_apply_to_proc(Panel_item item, int value, Event *event);
void mod_some_slices_proc(Panel_item item, int value, Event *event);
void mod_some_scans_proc(Panel_item item, int value, Event *event);
void mod_filter_done_proc(Frame frame);
int setup_filter_proc(Panel_item item, Event *event);
void mod_resume_image(Panel_item item, Event *event);
void mod_gradient_done_proc(Frame frame);
int setup_gradient_proc(Panel_item item, Event *event);
void mod_save_done_proc(Frame frame);
int save_the_file_pixels(Frame frame, int which);
void save_cancel_proc(Panel_item item, Event *event);
int save_file_pixels_proc(Panel_item item, Event *event);
void mod_done_proc(Frame frame);
void setup_mod_pixel_types(struct modify_img_rec *mod);
void modify_threshold_color_proc(Panel_item item, Event *event);
int setup_modify_img_rec(struct modify_img_rec *mod,
    struct image_display_window *win);
struct modify_img_rec *find_modify_img_rec(
   struct all_modify_img_recs *all_mods, struct image_display_window *win);
struct modify_img_rec *mod_find_same_win(struct all_modify_img_recs *all_mods,
    struct image_display_window *win);
int win_modify_update_color_opr(struct image_display_window *win);
struct all_modify_img_recs *enter_modify_image(
   struct image_display_window *win, int status);



/*-------------------------------------------------------------------------
init_some_win_rec - ???
-------------------------------------------------------------------------*/

void
init_some_win_rec(some)
 struct some_win_rec *some;
{
 some->frame = 0;
 some->first = 0;
 some->last  = 0;
}


/*-------------------------------------------------------------------------
init_save_win_rec - ???
-------------------------------------------------------------------------*/

void
init_save_win_rec(save)
 struct save_win_rec *save;
{
 save->frame = 0;
 init_img_rec(&(save->img),NULL);
 save->slice_map = NULL;
 init_buf_2d_rec(&(save->slice_mask));
 save->all_selected = 0;
 save->num_selected = 0;
 save->selected = NULL;
}


/*-------------------------------------------------------------------------
free_save_win_rec - ???
-------------------------------------------------------------------------*/

void
free_save_win_rec(save)
 struct save_win_rec *save;
{
 if (save->frame != 0) xv_destroy_safe(save->frame);
 save->frame = 0;
 free_img_rec(&(save->img));
 free_buf_2d_rec(&(save->slice_mask));
 c_free(save->selected);
 init_save_win_rec(save);
}


/*-------------------------------------------------------------------------
init_modify_img_rec - ???
-------------------------------------------------------------------------*/

void
init_modify_img_rec(mod)
 struct modify_img_rec *mod;
{
 mod->status = 0;
 mod->win    = NULL;
 mod->frame  = 0;
 mod->filter.frame   = 0;
 mod->gradient.frame = 0;

 mod->sl_options.frame = 0;

 init_save_win_rec(&(mod->save));
 init_buf_2d_rec(&(mod->gradient._2d));
 mod->gradient.frame = 0;
 mod->fft_cur_slice = NULL;
 init_some_win_rec(&(mod->some_slices));
 init_some_win_rec(&(mod->some_scans));
 init_buf_2d_rec(&(mod->pixel_type_mask));
 init_buf_2d_rec(&(mod->fft));
 init_buf_2d_rec(&(mod->fft1));
 init_buf_2d_rec(&(mod->temp_2d));
}


/*-------------------------------------------------------------------------
free_modify_img_rec - ???
-------------------------------------------------------------------------*/

void
free_modify_img_rec(mod)
 struct modify_img_rec *mod;
{
 struct all_modify_img_recs *all_mods;

 if (mod->frame != 0) 
    {destroy_all_subframes(mod->frame);
     xv_destroy_safe(mod->frame);}

 free_buf_2d_rec(&(mod->pixel_type_mask));
 free_buf_2d_rec(&(mod->fft));
 free_buf_2d_rec(&(mod->fft1));
 free_buf_2d_rec(&(mod->temp_2d));
 all_mods = enter_modify_image(NULL, GET_ALL_MODIFY_IMG_PTR);
 c_free(mod);
 DropHandleAryPtr(&(all_mods->mods),&(all_mods->num_mods),mod);
}


/*-------------------------------------------------------------------------
init_all_modify_img_recs - ???
-------------------------------------------------------------------------*/

void
init_all_modify_img_recs(all_mods)
 struct all_modify_img_recs *all_mods;
{
 all_mods->num_mods = 0;
 all_mods->mods = NULL;
}


/*-------------------------------------------------------------------------
SaveImage - ???
-------------------------------------------------------------------------*/

int
SaveImage(mod,img)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
{
 int err;
 char *fn,*reason,str[250];

 if ((err = wr_slice(img,NULL,&reason)) != NO_ERROR)
    {build_fn(&fn,img->file->dirfn,img->file->fn,".img");
     sprintf(str,"  Error writing to %s...",fn);
     ShowMsgStrs(mod->frame,0,err,0,3,str,reason,
               "Action aborted !!!",NULL,0);
     c_free(reason);
     c_free(fn);
    }

 return err;
}


/*-------------------------------------------------------------------------
restore_image - ???
-------------------------------------------------------------------------*/

int
restore_image(mod,img)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
{
 int err;
 char *fn,str[250];

 PRT1(printf("restore_image...\n"))
 if ((err = RdSlice(img,0,NULL,2)) != NO_ERROR)
    {build_fn(&fn,img->file->dirfn,img->file->fn,".img");
     sprintf(str,"  Error reading to %s...",fn);
     ShowMsgStrs(mod->frame,0,err,0,2,str,
               "Action aborted !!!",NULL,0);
    }
 PRT1(printf("restore_image...err = %d\n"))
 return err;
}


/*-------------------------------------------------------------------------
FftImage - ???
-------------------------------------------------------------------------*/

int
FftImage(frame,fftimg,_2d)
 Frame frame;
 struct buf_2d_rec *fftimg,*_2d;
{
 int err;

 PRT(printf("FftImage...begin\n"))
 if (((err = shift_fft_2d_to_center(fftimg)) != NO_ERROR) || 
     ((err = fft_2d(fftimg)) != NO_ERROR) ||
     ((err = AssignMagnitudeFftTo2d(_2d,fftimg,NULL,NULL)) != NO_ERROR))
    {ShowMsgStrs(frame,0,err,0,2,
               "Error occurred during the FFT processing..",
               "Action aborted !!!",NULL,0);
    }
 PRT(printf("FftImage...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
Fft - ???
-------------------------------------------------------------------------*/

int
Fft(mod,img)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
{
 int err;

 PRT(printf("Fft...begin\n"))
 if (((err = SetupBuf2dRec(&(mod->fft),img->_2d.dimx,img->_2d.dimy,
              (size_t) (8 * sizeof(struct complex_rec)),0)) != NO_ERROR) ||
     ((err = setup_fft_2d(&(mod->fft),&(img->_2d))) != NO_ERROR) ||
     ((err = FftImage(mod->frame,&(mod->fft),&(img->_2d))) != NO_ERROR))
    {mod->fft.status4 &= ~BUF_DATA_VALID;
     mod->fft_cur_slice = NULL;
    }
  else
   {mod->fft.status4 |= BUF_DATA_VALID;
    mod->fft_cur_slice = img->cur_slice;
    PRT6(printf("mod->fft & mod->fft1\n"))
    PRT6(pr_buf_2d_rec(&(mod->fft)))
    PRT6(pr_buf_2d_rec(&(mod->fft1)))
    if (copy_buf_2d_rec(&(mod->fft1),&(mod->fft)) == NO_ERROR)
       {shift_fft_2d_to_center(&(mod->fft1));
        ConjugateFftReal(&(mod->fft1));}
    PRT6(printf("after  mod->fft1\n"))
    PRT6(pr_buf_2d_rec(&(mod->fft1)))
   }
 PRT(printf("Fft...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
InverseFftImage - ???
-------------------------------------------------------------------------*/

int
InverseFftImage(frame,fftimg,_2d)
 Frame frame;
 struct buf_2d_rec *fftimg,*_2d;
{
 int err;

 PRT(printf("InverseFftImage....\n"))
 if (((err = inverse_fft_2d(fftimg)) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(fftimg)) != NO_ERROR) ||
     ((err = AssignMagnitudeFftTo2d(_2d,fftimg,NULL,NULL)) != NO_ERROR))
/*     ((err = AssignFftTo2d(_2d,fftimg)) != NO_ERROR))*/
    {ShowMsgStrs(frame,0,err,0,2,
               "Error occurred during the inverse fft processing..",
               "Action aborted !!!",NULL,0);
    }
 PRT(printf("InverseFftImage...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
InverseFft - ???
-------------------------------------------------------------------------*/

int
InverseFft(mod,img)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
{
 int err;

 PRT(printf("InverseFft...\n"))
 if (((err = SetupBuf2dRec(&(mod->fft1),img->_2d.dimx,img->_2d.dimy,
              (size_t) (8 * sizeof(struct complex_rec)),0)) != NO_ERROR) ||
     ((err = setup_fft_2d(&(mod->fft1),&(img->_2d))) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&(mod->fft1))) != NO_ERROR) ||
     ((err = InverseFftImage(mod->frame,&(mod->fft1),&(img->_2d))) != NO_ERROR))
    {mod->fft1.status4 &= ~BUF_DATA_VALID;
     mod->fft_cur_slice = NULL;
    }
  else
   {mod->fft1.status4 |= BUF_DATA_VALID;
    mod->fft_cur_slice = img->cur_slice;
    if (copy_buf_2d_rec(&(mod->fft),&(mod->fft1)) == NO_ERROR)
       {
        ConjugateFftImaginary(&(mod->fft));
        shift_fft_2d_to_center(&(mod->fft));
       }
   }
 PRT(printf("InverseFft...err = %d\n",err))
 return err;
}


/**********************
FftOnInverseFft(mod,img)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
{
 int err,yes;
 struct buf_2d_rec fftimg;

 TRACE(printf("FftOnInverseFft...\n"))
 if ((mod->fft_cur_slice != img->cur_slice) ||
    !(mod->fft1.status4 & BUF_DATA_VALID))
    {ShowMsgStrs(mod->frame,0,err,0,2,
               "The Inverse FFT image is not available yet..",
               "Cannot perform FFT on inverse FFT yet !!!",NULL,0);
     return CANCEL;}

 TRACE(printf("FftOnInverseFft...1\n"))
 init_buf_2d_rec(&fftimg);
 if ((err = copy_buf_2d_rec(&fftimg,&(mod->fft1))) == NO_ERROR)
    err = FftImage(mod->frame,&fftimg,&(img->_2d));
   else
    {ShowMsgStrs(mod->frame,0,err,0,2,
               "Not enough Memory !!!..",
               "Cannot perform FFT on inverse FFT...!!!",NULL,0);
    }

 free_buf_2d_rec(&fftimg);
 TRACE(printf("FftOnInverseFft...err = %d\n",err))
 return err;
}
****************/



/*-------------------------------------------------------------------------
InverseFftOnFft - ???
-------------------------------------------------------------------------*/

int
InverseFftOnFft(mod,img)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
{
 int err;
 struct buf_2d_rec fftimg;

 TRACE(printf("InverseFftOnFft...\n"))
 if ((mod->fft_cur_slice != img->cur_slice) ||
    !(mod->fft.status4 & BUF_DATA_VALID))
    {ShowMsgStrs(mod->frame,0,err,0,2,
               "The FFT image is not available yet..",
               "Cannot perform inverse FFT on FFT yet !!!",NULL,0);
     return CANCEL;}

 TRACE(printf("InverseFftOnFft...1\n"))
 init_buf_2d_rec(&fftimg);

 if ((err = copy_buf_2d_rec(&fftimg,&(mod->fft))) == NO_ERROR)
    err = InverseFftImage(mod->frame,&fftimg,&(img->_2d));
   else
    {ShowMsgStrs(mod->frame,0,err,0,2,
               "Not enough Memory !!!..",
               "Cannot perform inverse FFT on FFT...!!!",NULL,0);
    }
 free_buf_2d_rec(&fftimg);
 TRACE(printf("InverseFftOnFft...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
threshold_color_image - ???
-------------------------------------------------------------------------*/

int
threshold_color_image(mod,img,mask)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 struct buf_2d_rec *mask;
{
 unsigned long first_color_val,last_color_val;
 struct image_display_window *win;
 struct color_data_rec *color_data;

 win = mod->win;
 if ((color_data = WinCurColorData(win)) == NULL) return CANCEL;
 win_first_and_num_colors(win,&first_color_val,&last_color_val);
 last_color_val = xv_get(mod->threshold_color,PANEL_VALUE);
 if (!(color_data->_2d.status4 & BUF_DATA_VALID))
    WinNewColorData(win);
 WinSet2dByColorValueRange(win,&(img->_2d),mask,first_color_val,last_color_val);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
threshold_dark_color_image - ???
-------------------------------------------------------------------------*/

int
threshold_dark_color_image(mod,img,mask)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 struct buf_2d_rec *mask;
{
 struct image_display_window *win;
 unsigned long *color_indxs,first,num_color_indxs;
 struct color_scale_rec *scale;
 struct color_data_rec *color_data;
 int err;

 win = mod->win;
 if ((color_data = WinCurColorData(win)) == NULL) return CANCEL;
 if ((err = WinCurScaleAndColorIndxs(win,NULL,&scale,
        &color_indxs,&num_color_indxs)) != NO_ERROR)
    return err;
 first = scale->first;
 if (!(color_data->_2d.status4 & BUF_DATA_VALID))
    WinNewColorData(win);
 Set2dBackgroundColor(&(img->_2d),
          &(color_data->_2d),mask,&(win->intensity->color),
          color_indxs,num_color_indxs,first,(double) .0,0);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
mod_resample_image - ???
-------------------------------------------------------------------------*/

int
mod_resample_image(mod,img,mask)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 struct buf_2d_rec *mask;
{
 struct buf_2d_rec dst;
 struct unit_2d_rec resize_unit;
 int err;

 PRT2(printf("mod_resample_image...\n"))
 init_buf_2d_rec(&dst);
 setup_unit_2d_rec(&resize_unit,.0,.0,
       img->file->hdr.data_info.xpixel_size,
       img->file->hdr.data_info.ypixel_size,
       img->_2d.dimx,img->_2d.dimy,
       .0,.0,
       img->file->hdr.data_info.xpixel_size,
       img->file->hdr.data_info.ypixel_size);
 if ((err = ResizeBuf2dRec(&dst,&(img->_2d),
       resize_unit.dimx,resize_unit.dimy,&(resize_unit.tolocal_mat)))
         == NO_ERROR)
    {err = copy_buf_2d_rec_content(&(img->_2d),&dst);
    }
 PRT2(printf("mod_resample_image...1\n"))
 free_buf_2d_rec(&dst);
 return NO_ERROR;
}



/*-------------------------------------------------------------------------
filter_image - ???
-------------------------------------------------------------------------*/

int
filter_image(mod,img)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
{
 int err;
 int which_filter,cut_off_freq,lb_cut_off_freq,order,is_lowpass;
 float fl;

 if (!(mod->fft.status4 & BUF_DATA_VALID))
    {if ((err = Fft(mod,img)) != NO_ERROR) return err;
    }

 which_filter = (int) xv_get(mod->filter.which_filter,PANEL_VALUE);
 cut_off_freq = (int) xv_get(mod->filter.cut_off_freq,PANEL_VALUE);
 is_lowpass = (int) xv_get(mod->filter.filter_which_freq,PANEL_VALUE);
 if (is_lowpass == 0)
    {TRACE(printf("high pass...\n"))
    }
 TRACE(printf("which_filter = %d  cut_off_freq = %d  is_lowpass = %d\n",which_filter,cut_off_freq,
      is_lowpass))
 if (which_filter == 0)
    {filter_fft_2d(&(mod->fft1),(float) cut_off_freq,is_lowpass,
          precondition_ideal_filter_fft_2d,ideal_filter_fft_2d,NULL);
     TRACE(printf("ideal_filter_fft_2d....\n"))
    }
   else if (which_filter == 3)
    {lb_cut_off_freq = (int) xv_get(mod->filter.lb_cut_off_freq,PANEL_VALUE);
     fl = (float) lb_cut_off_freq;
     filter_fft_2d(&(mod->fft1),(float) cut_off_freq,is_lowpass,
          NULL,trapezoidal_filter_fft_2d,&fl);
     TRACE(printf("trapezoidal_filter_fft_2d....\n"))
    }
   else
    {order = (int) xv_get(mod->filter.order,PANEL_VALUE);
     if (which_filter == 1)
        {filter_fft_2d(&(mod->fft1),(float) cut_off_freq,is_lowpass,NULL,
                  butterworth_filter_fft_2d,&order);
         TRACE(printf("butterworth_filter_fft_2d....\n"))
        }
       else filter_fft_2d(&(mod->fft1),(float) cut_off_freq,is_lowpass,NULL,
                  exponential_filter_fft_2d,&order);
    }
 err = InverseFftImage(mod->frame,&(mod->fft1),&(img->_2d));
 return err;
}


/*-------------------------------------------------------------------------
record_filter_image - ???
-------------------------------------------------------------------------*/

int
record_filter_image(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 int display,err;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL)
    {return CANCEL;}
 display = 0;
 if (!(mod->fft1.status4 & BUF_DATA_VALID) ||
     !(mod->fft1.status4 & BUF_NON_EMPTY))
    err = modify_image(mod->filter.testing,event);
   else err = NO_ERROR;
 TRACE(printf("record_filter_image...err = %d\n",err))
 if ((err == NO_ERROR) &&
     (mod->fft1.status4 & BUF_DATA_VALID) &&
     (mod->fft1.status4 & BUF_NON_EMPTY))
    {TRACE(printf("record_filter_image...\n"))
     err = copy_buf_2d_rec(&(mod->fft),&(mod->fft1));
    }
 return err;
}


/*-------------------------------------------------------------------------
add_image_echoes - ???
-------------------------------------------------------------------------*/

int
add_image_echoes(mod,img,mask,bound,is_rd,is_abs)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 int is_rd,is_abs;
{
 int err;
 struct img_rec the_img;
 struct img_buf_rec *cur_img;

 err = NO_ERROR;
 if (is_rd)
    {init_img_rec(&the_img,img->file);
     if (NewImgBuf(&the_img,img->cur_slice,&err,0,0,0,0,0,0,1) == NULL)
        return CANCEL;
     cur_img = the_img.data[0];
     err = RdCurSliceEchoes(cur_img,0,0);
    }
   else cur_img = img;

 if (err == NO_ERROR)
    if (mask == NULL)
        err = Add2dsAndScale(&(cur_img->_2d),&(cur_img->partner->_2d),is_abs);
       else 
        err = Add2dsAndScaleByMask(&(cur_img->_2d),&(cur_img->partner->_2d),
                 0,0,mask,bound,is_abs);
 if (is_rd)
    {copy_buf_2d_rec_content(&(img->_2d),&(cur_img->_2d));
     free_img_rec(&the_img);}

 return err;
}


/*-------------------------------------------------------------------------
minus_image_echoes - ???
-------------------------------------------------------------------------*/

int
minus_image_echoes(mod,img,mask,bound,is_rd,is_abs)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 int is_rd,is_abs;
{
 int err;
 struct img_rec the_img;
 struct img_buf_rec *cur_img;

 err = NO_ERROR;
 if (is_rd)
    {init_img_rec(&the_img,img->file);
     if (NewImgBuf(&the_img,img->cur_slice,&err,0,0,0,0,0,0,0) == NULL)
        return CANCEL;
     cur_img = the_img.data[0];
     err = RdCurSliceEchoes(cur_img,0,0);
    }
   else cur_img = img;

 if (err == NO_ERROR)
    if (mask == NULL)
        err = Minus2dsAndScale(&(cur_img->_2d),&(cur_img->partner->_2d),is_abs);
       else
        err = Minus2dsAndScaleByMask(&(cur_img->_2d),&(cur_img->partner->_2d),
               0,0,mask,bound,is_abs);
 if (is_rd)
    {copy_buf_2d_rec_content(&(img->_2d),&(cur_img->_2d));
     free_img_rec(&the_img);}

 return err;
}


/*-------------------------------------------------------------------------
gradient_image - ???
-------------------------------------------------------------------------*/

int
gradient_image(mod,img,mask,bound)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
{
 int err;
 long threshold,image_value,gvalue,max;
 int set_not_selected,set_selected,set_threshold,which_option;
 struct image_display_window *win;

 if (img->win == NULL) return NO_ERROR;
 if ((win = img->win->image_display) == NULL) return NO_ERROR;
 which_option = (int) xv_get(mod->gradient.which_option,PANEL_VALUE);
 TRACE(printf("option = %d\n",which_option))
 if ((err = SetupBuf2dRec(&(mod->gradient._2d),img->_2d.dimx,img->_2d.dimy,
          img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR)
    return err;
 TRACE(printf("====option = %d\n",which_option))
 if (mask == NULL)
    {if (which_option == 1)
        {
         err = sharpen_2d(&(img->_2d),&(mod->gradient._2d));
        }
       else err = sobel_2d(&(img->_2d),&(mod->gradient._2d));
    }
   else
    {
     if (which_option == 1)
        err = sharpen_2d_by_mask(&(img->_2d),0,0,mask,bound,
                     &(mod->gradient._2d));
       else err = sobel_2d_by_mask(&(img->_2d),0,0,mask,bound,
                     &(mod->gradient._2d));
    }

 if (err != NO_ERROR)
    {free_buf_2d_rec(&(mod->gradient._2d));
     return err;
    }
 if (set_selected = xv_get(mod->gradient.set_gvalue,PANEL_VALUE))
    gvalue = (long) xv_get(mod->gradient.gvalue,PANEL_VALUE);
 set_threshold = xv_get(mod->gradient.set_threshold,PANEL_VALUE);


 if (set_not_selected = xv_get(mod->gradient.set_image_value,PANEL_VALUE))
    image_value = (long) xv_get(mod->gradient.image_value,PANEL_VALUE);
   else if (xv_get(mod->gradient.display,PANEL_VALUE) == 0)
    {set_not_selected = 1;
     image_value = 0;}

 TRACE(printf("set_threshold = %d  set_not_selected = %d set_selected = %d err = %d\n",
      set_threshold,set_not_selected,set_selected,err))
 copy_buf_2d_rec(&(mod->temp_2d),&(img->_2d));
 if (set_threshold || set_not_selected || set_selected)
    {if (set_threshold)
        threshold = (long) xv_get(mod->gradient.threshold,PANEL_VALUE);
       else threshold = 1;
     max = (long) xv_get(mod->gradient.threshold,PANEL_MAX_VALUE);

     if (mask == NULL)
        Select2d(&(mod->gradient._2d),
           (double) threshold,(double) max,&(img->_2d),
           set_selected,(double) gvalue,
           set_not_selected,(double) image_value);
       else Select2dByMask(&(mod->gradient._2d),0,0,mask,bound,
           (double) threshold,(double) max,&(img->_2d),
                  set_selected,(double) gvalue,
                  set_not_selected,(double) image_value);
    }
   else copy_buf_2d_rec(&(img->_2d),&(mod->gradient._2d));
 
 WinNewColorMultiCanvas(win);
 copy_buf_2d_rec(&(img->_2d),&(mod->temp_2d));

 return err;

}


/*-------------------------------------------------------------------------
record_gradient_image - ???
-------------------------------------------------------------------------*/

int
record_gradient_image(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 int display,err;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL)
    {return CANCEL;}
 display = 0;
 if (!(mod->gradient._2d.status4 & BUF_DATA_VALID) ||
     !(mod->gradient._2d.status4 & BUF_NON_EMPTY))
    {TRACE(printf("record_filter_image...modify_image...err = %d\n",err))
     err = modify_image(mod->gradient.testing,event);
    }
   else
    {err = NO_ERROR;
     display = 1;}
 PRT3(printf("record_filter_image...err = %d\n",err))
 if (err == NO_ERROR)
    {if ((err = copy_buf_2d_rec(&(img->_2d),&(mod->gradient._2d))) == NO_ERROR)
        {PRT3(printf("record_filter_image...copy_buf_2d_rec\n"))
         if (display) WinNewColorMultiCanvas(mod->win);}

    }
 if (err != NO_ERROR)
    win_alarm(mod->gradient.frame,2);
 return err;
}


/*-------------------------------------------------------------------------
get_selected_pixel_types - ???
-------------------------------------------------------------------------*/

int
get_selected_pixel_types(img,list,selected,num_selected,all_selected)
 struct img_buf_rec *img;
 Panel_item list;
 unsigned long *num_selected;
 char **selected,*all_selected;
{
 unsigned long total,lcv;
 int err;

 TRACE(printf("get_selected_pixel_types...\n"))
 *num_selected = 0;
 *all_selected = 0;
 total = 0;
 get_ptr_memory(selected,&total,img->file->pixel_type.order.num_strs + 1,
      (size_t) sizeof(**selected),&err);
 if (err == NO_ERROR)
    {if (xv_get(list,PANEL_LIST_SELECTED,0))
        {for (lcv = 0; lcv <= img->file->pixel_type.order.num_strs; lcv++)
            (*selected)[lcv] = 1;
         *all_selected = 1;}
       else 
        {(*selected)[0] = 0;
         for (lcv = 1; lcv <= img->file->pixel_type.order.num_strs; lcv++)
           if (xv_get(list,PANEL_LIST_SELECTED,lcv))
              (*selected)[lcv] = 1;
             else (*selected)[lcv] = 0;
        }
    }
 TRACE(for (lcv = 0; lcv <= img->file->pixel_type.order.num_strs; lcv++)
    printf("%d) sel = %d\n",lcv,(int) (*selected)[lcv]);
 )

 TRACE(printf("get_selected_pixel_types...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
pixel_type_image - ???
-------------------------------------------------------------------------*/

int
pixel_type_image(mod,img,is_display_err)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 int is_display_err;
{
 int err;
 unsigned char *selected,all_selected;
 unsigned long num_selected;

 if (xv_get(mod->pixel_type_item,PANEL_LIST_SELECTED,0))
    return NO_ERROR;
 if ((err = get_selected_pixel_types(img,mod->pixel_type_item,
            &selected,&num_selected,&all_selected)) == NO_ERROR)
    {err = get_slice_mask(img,NULL,&(mod->pixel_type_mask),selected);
     c_free(selected);
    }
 if (err != NO_ERROR)
    {if (is_display_err) ShowMsgStrs(mod->frame,0,0,0,2,
               "Sorry...AN ERROR OCCURRED WHEN GENERATING..",
               "THE SLICE MASK BASED ON THE PIXEL TYPES..",
               "Action aborted !!!",NULL,0);
    }
 return err;
}


/*-------------------------------------------------------------------------
mod_which_slice_roi - ???
-------------------------------------------------------------------------*/

struct slice_roi_rec *
mod_which_slice_roi(mod,img)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
{
 struct slice_roi_win_rec *slice_roi_win;
/*
 if (!xv_get(mod->on_each_slice,PANEL_INACTIVE) &&
     xv_get(mod->on_each_slice,PANEL_VALUE))
*/
 if (mod->is_on_each_slice)
    {slice_roi_win = file_scan_slice_roi_win(img->file,img->cur_slice);
     if (slice_roi_win == NULL) 
        return &(mod->win->control.sroi.sroi_win->slice_roi);
     return &(slice_roi_win->slice_roi);
    }
   else return &(mod->win->control.sroi.sroi_win->slice_roi);
}


/*-------------------------------------------------------------------------
ModifyImageOptionProc - ???
-------------------------------------------------------------------------*/

int
ModifyImageOptionProc(mod,img,is_comp,region_option,modify_option,
                      is_show_update)
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 int is_comp;
 int region_option;
 int modify_option,is_show_update;
{
 struct image_display_window *win;
 struct int_bound_rec affected,*bound;
 long value;
 struct draw_mask_rec mask;
 int err,modified,check;
 char str[255],*fn;
 double min,max,ratio;
 struct slice_roi_rec *slice_roi;

 PRT1(printf("ModifyImageOptionProc is_comp = %d  region_option = %d  modify_option = %d\n",
         is_comp,region_option,modify_option))
 if ((modify_option == ADD_IMAGE) || (modify_option == MINUS_IMAGE) ||
     (modify_option == ADD_FILE_ECHOES) || (modify_option == MINUS_FILE_ECHOES))
    if (img->file->hdr.data_info.num_echoes <= 1) return NO_ERROR;
 if (img->win == NULL) return NO_ERROR;
 if ((win = img->win->image_display) == NULL) return NO_ERROR;
 PRT1(printf("ModifyImageOptionProc...modify_option = %d\n",modify_option))
 modified = 0;
 check = 0;
 if (modify_option == PIXEL_TYPE_IMAGE)
    {if ((err = pixel_type_image(mod,img,1)) == NO_ERROR)
        modified = 1;
    }
   else if (modify_option == SAVE_IMAGE)
    err = SaveImage(mod,img);
   else if (modify_option == RESTORE_IMAGE)
    {if ((err = restore_image(mod,img)) == NO_ERROR)
        modified = 1;
    }
   else if (modify_option == FFT_IMAGE)
    {if ((err = Fft(mod,img)) == NO_ERROR)
        modified = 1;
    }
   else if (modify_option == INVERSE_FFT_IMAGE)
    {if ((err = InverseFft(mod,img)) == NO_ERROR)
        modified = 1;
    }
   else if (modify_option == INVERSE_FFT_ON_FFT)
    {if ((err = InverseFftOnFft(mod,img)) == NO_ERROR)
        modified = 1;
    }
   else if (modify_option == FILTER_IMAGE)
    {if ((err = filter_image(mod,img)) == NO_ERROR)
        modified = 1;
    }
   else if (modify_option == THRESHOLD_COLOR_IMAGE)
    {if ((err = err = threshold_color_image(mod,img,NULL)) == NO_ERROR)
        modified = 1;
    }
   else if (modify_option == THRESHOLD_DARK_COLOR_IMAGE)
    {if ((err = err = threshold_dark_color_image(mod,img,NULL)) == NO_ERROR)
        modified = 1;
    }
   else if (modify_option == RESAMPLE_IMAGE)
    {if ((err = err = mod_resample_image(mod,img,NULL)) == NO_ERROR)
        modified = 1;
    }
   else if (region_option == 0)
    {check = 1;
     if (!is_comp)
        {modified = 1;
         if (modify_option == SMOOTH_IMAGE_BY_9_NEIGHBORS)
            err = Smooth2d(&(img->_2d),9);
           else if (modify_option == SMOOTH_IMAGE_BY_8_NEIGHBORS)
            err = Smooth2d(&(img->_2d),8);
           else if (modify_option == SMOOTH_IMAGE_BY_16_NEIGHBORS)
            err = Smooth2d(&(img->_2d),16);
           else if (modify_option == FILL_IMAGE)
            {value = (long) xv_get(mod->fill_val,PANEL_VALUE);
             PRT7(printf("FILL_IMAGE...value = %d\n",value))
             err = InitBuf2dRecData(&(img->_2d),(double) value);
             PRT7(printf("FILL_IMAGE...value = %d\n",
                  CntValBuf2dRec(&(img->_2d),(double) .0)))
            }
           else if (modify_option == INVERT_IMAGE)
            err = Invert2d(&(img->_2d));
           else if (modify_option == ADD_IMAGE)
            err = add_image_echoes(mod,img,NULL,NULL,0,mod->is_abs);
           else if (modify_option == MINUS_IMAGE)
            err = minus_image_echoes(mod,img,NULL,NULL,0,mod->is_abs);
           else if (modify_option == ADD_FILE_ECHOES)
            err = add_image_echoes(mod,img,NULL,NULL,1,mod->is_abs);
           else if (modify_option == MINUS_FILE_ECHOES)
            err = minus_image_echoes(mod,img,NULL,NULL,1,mod->is_abs);
           else if (modify_option == GRADIENT_IMAGE)
            {err = gradient_image(mod,img,NULL,NULL);
             modified = 0;}
        }
    }
   else
    {check = 1;
     init_draw_mask_rec(&mask);
     slice_roi = mod_which_slice_roi(mod,img);

     if ((err = GetRoiMask(slice_roi,mod->win->control.sroi.localto,
             img->_2d.dimx,img->_2d.dimy,
             &mask,&affected,region_option,&(mod->win->image_view_roi))) == NO_ERROR)
        {
         if (affected.left <= affected.right)
            {modified = 1;
             if (is_comp)
                {NotBitmap(&(mask.mask._2d),&(mask.mask._2d));
                 bound = NULL;}
               else bound = &affected;

             if (modify_option == SMOOTH_IMAGE_BY_9_NEIGHBORS)
                err = Smooth2dByMask(&(img->_2d),0,0,&(mask.mask._2d),bound,9);
               else if (modify_option == SMOOTH_IMAGE_BY_8_NEIGHBORS)
                err = Smooth2dByMask(&(img->_2d),0,0,&(mask.mask._2d),bound,8);
               else if (modify_option == SMOOTH_IMAGE_BY_16_NEIGHBORS)
                err = Smooth2dByMask(&(img->_2d),0,0,&(mask.mask._2d),bound,16);
               else if (modify_option == FILL_IMAGE)
                {value = (long) xv_get(mod->fill_val,PANEL_VALUE);
                 err = Set2d(&(img->_2d),0,0,&(mask.mask._2d),bound,
                              (double) value);
                }
               else if (modify_option == INVERT_IMAGE)
                {ratio = -1.0;
                 DoubleMinMax(&max,&min);
                 TRACE(printf("min = %f max = %f\n",min,max))
                 if ((err = process_buf_2d_rec_by_mask(&(img->_2d),0,0,
                     &(mask.mask._2d),bound,MinMax2dByMaskProc,&min,&max,
                     0,0,0,0,0,0,0)) == NO_ERROR)
                    {TRACE(printf("Invert2dValProc min = %f max = %f\n",min,max))
                     err = process_buf_2d_rec_by_mask(&(img->_2d),0,0,
                      &(mask.mask._2d),bound,Invert2dValProc,&min,&max,&ratio,
                      0,0,0,0,0,0);}
                }
               else if (modify_option == ADD_IMAGE)
                err = add_image_echoes(mod,img,&(mask.mask._2d),bound,0,mod->is_abs);
               else if (modify_option == MINUS_IMAGE)
                err = minus_image_echoes(mod,img,&(mask.mask._2d),bound,0,mod->is_abs);
               else if (modify_option == ADD_FILE_ECHOES)
                err = add_image_echoes(mod,img,&(mask.mask._2d),bound,1,mod->is_abs);
               else if (modify_option == MINUS_FILE_ECHOES)
                err = minus_image_echoes(mod,img,&(mask.mask._2d),bound,1,mod->is_abs);
               else if (modify_option == GRADIENT_IMAGE)
                {err = gradient_image(mod,img,&(mask.mask._2d),bound);
                 modified = 0;}
/*
               else if (modify_option == THRESHOLD_COLOR_IMAGE)
               err = threshold_color_image(mod,img,&(mask.mask._2d));
               else if (modify_option == THRESHOLD_DARK_COLOR_IMAGE)
               err = threshold_dark_color_image(mod,img,&(mask.mask._2d));
*/
            }
        }
     free_draw_mask_rec(&mask);
    }
 PRT(printf("ModifyImageOptionProc...1\n"))
 if (modified && is_show_update)
    if (err == NO_ERROR)
       {img->_2d.status4 |= BUF_MODIFIED;
        img->_2d.status4 &= ~BUF_MIN_MAX_COMPUTED;
        WinNewColorMultiCanvas(win);}
 if (check && (err != NO_ERROR))
    {build_fn(&fn,img->file->dirfn,img->file->fn,"");
     sprintf(str,"For this file = %s  slice# = %ld\n",fn,
          img->cur_slice->num);
     c_free(fn);
     ShowMsgStrs(mod->frame,0,err,0,3,
               "Error occurred during the processing..",
               str,"Action aborted !!!",NULL,0);
    }
 PRT(printf("ModifyImageOptionProc...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
modify_is_update_slice - ???
-------------------------------------------------------------------------*/

int
modify_is_update_slice(mod,fsnum,lsnum,fecho,lecho,fscan,lscan)
 struct modify_img_rec *mod;
 unsigned long *fsnum,*lsnum,*fecho,*lecho,*fscan,*lscan;
{
 int which_slice,which_scan;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) return 0;
 which_slice = (int) xv_get(mod->which_slice,PANEL_VALUE);
 if (which_slice == 0) return 0;
 *fecho = *lecho = img->cur_slice->echo_num;
 if (which_slice == 1)
    {*fsnum = *lsnum = img->cur_slice->slice_num;
    }
   else if (which_slice == 2)
    {*fsnum = 0;
     *lsnum = NumberOfSliceCuts(&(img->file->hdr.data_info)) - 1;
    }
   else
    {if (mod->some_slices.frame != 0)
        {*fsnum = (int) xv_get(mod->some_slices.first,PANEL_VALUE) - 1;
         *lsnum = (int) xv_get(mod->some_slices.last,PANEL_VALUE) - 1;}
       else if (mod->status & SOME_SLICES_MIN_MAX_VALID)
        {*fsnum = mod->some_slices.min - 1;
         *lsnum = mod->some_slices.max - 1;}
       else
        {*fsnum = 0;
         *lsnum = NumberOfSliceCuts(&(img->file->hdr.data_info)) - 1;}
    }
 
 *fscan = *lscan = img->cur_slice->scan_num;
 if (mod->which_scan == 0) return 1;
 which_scan = (int) xv_get(mod->which_scan,PANEL_VALUE);
 if (which_scan == 0) return 1;
 if (which_scan == 1)
    {*fscan = 0;
     *lscan = NumberOfSliceScans(&(img->file->hdr.data_info)) - 1;}
   else
    {if (mod->some_scans.frame != 0)
        {*fscan = (int) xv_get(mod->some_scans.first,PANEL_VALUE) - 1;
         *lscan = (int) xv_get(mod->some_scans.last,PANEL_VALUE) - 1;}
       else if (mod->status & SOME_SCANS_MIN_MAX_VALID)
        {*fscan = mod->some_scans.min - 1;
         *lscan = mod->some_scans.max - 1;}
       else
        {*fscan = 0;
         *lscan = NumberOfSliceScans(&(img->file->hdr.data_info)) - 1;}
    }
 return 1;
}


/*-------------------------------------------------------------------------
modify_cur_image - ???

FIXME! This function is expected to return a value by modify_image, but
I had to add a final return here to always return one.  Unfortunately,
I am just guessing at the correct return value.  There is probably a
bug lurking here still.  -PWH 19990415
-------------------------------------------------------------------------*/

int
modify_cur_image(mod,modify_option)
 struct modify_img_rec *mod;
 int modify_option;
{
 struct img_buf_rec *img,*img1;
 unsigned long lcv,cnt;
 struct input_file_rec *file;
 int is_comp,region_option,apply_to;

 PRT(printf("mod_cur_image...\n"))
 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) return CANCEL;
 apply_to = (int) xv_get(mod->apply_to,PANEL_VALUE);
 region_option = (int) xv_get(mod->region,PANEL_VALUE);
 is_comp = (int) xv_get(mod->exc,PANEL_VALUE);

 if (mod->abs != 0) mod->is_abs = (int) xv_get(mod->abs,PANEL_VALUE);
   else mod->is_abs = 0;
 TRACE(printf("apply_to = %d\n",apply_to))

 if (apply_to == 0)
    {if ((img->win != NULL) && (img->win->image_display != NULL))
        ModifyImageOptionProc(mod,img,is_comp,region_option,modify_option,1);
    }
   else if (apply_to == 1)
    {
     for (lcv = 0; lcv < img->file->img.num_data; lcv++)
        {img1 = img->file->img.data[lcv];
         TRACE(printf("%d) img1->win = %u img = %u\n",lcv,img1->win,img1))
         if ((img1->win != NULL) &&
             (img1->win->image_display != NULL))
            {TRACE(printf("num_wins = %d\n",img1->win->image_display->num_display_wins))
             ModifyImageOptionProc(mod,img1,is_comp,
                region_option,modify_option,1);}
        }
    }
   else
    {
     for (cnt = 0; cnt < img->file->prog->input.num_files; cnt++)
        {file = img->file->prog->input.files[cnt];
         for (lcv = 0; lcv < file->img.num_data; lcv++)
            {img1 = file->img.data[lcv];
             TRACE(printf("%d) all file %d img = %u\n",lcv,cnt,img1))
             if ((img1->win != NULL) &&
                 (img1->win->image_display != NULL))
                ModifyImageOptionProc(mod,img1,is_comp,
                  region_option,modify_option,1);}
        }
    }

 return NO_ERROR;   /* FIXME! Guessed at right value.  -PWH 19990415 */
}


/*-------------------------------------------------------------------------
mod_slice_done_proc - ???
-------------------------------------------------------------------------*/

int
mod_slice_done_proc(frame)
 Frame frame;
{
 struct modify_img_rec *mod;
 struct img_buf_rec *img;

 TRACE(printf("mod_save_done_proc...\n"))
 mod = (struct modify_img_rec *) xv_get(frame,WIN_CLIENT_DATA);
 xv_set(mod->frame,FRAME_BUSY,FALSE,0);
 (void) notify_set_itimer_func(mod->sl_options.frame,NOTIFY_FUNC_NULL,
             ITIMER_REAL,(struct itimerval *) 0,(struct itimerval *) 0);
 xv_destroy_safe(mod->sl_options.frame);
 mod->sl_options.frame = 0;
 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) return NO_ERROR;
 if (img->cur_slice != mod->sl_options.cur_scan)
    {img->cur_slice = mod->sl_options.cur_scan;
     TRACE(printf("mod_slice_done_proc...WinNewColorMultiCanvas\n"))
     WinNewImgMultiCanvas(mod->win);}
   else WinNewColorMultiCanvas(mod->win);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
modify_slice_show_proc - ???
-------------------------------------------------------------------------*/

void
modify_slice_show_proc(item,value,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;
 struct img_buf_rec *img;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) {
    mod_slice_done_proc(mod->sl_options.frame);
    return; }
 if (!value)
    {img->cur_slice = mod->sl_options.cur_scan;
     TRACE(printf("modify_slice_show_proc...WinNewColorMultiCanvas\n"))
     WinNewImgMultiCanvas(mod->win);}
 mod->sl_options.show = value;
}


/*-------------------------------------------------------------------------
modify_slice_cancel_proc - ???
-------------------------------------------------------------------------*/

void
modify_slice_cancel_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 mod_slice_done_proc(mod->sl_options.frame);
}


/*-------------------------------------------------------------------------
modify_slice_proc - ???
-------------------------------------------------------------------------*/

int
modify_slice_proc(frame,which)
 Frame frame;
 int which;
{
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 struct hdr_scan_entry_rec *scan_entry;
 struct modify_slice_option_rec *sl;
 struct slice_roi_win_rec *temp_sroi_win,*sroi_win;
 struct image_display_window *win;
 unsigned long lcv;
 int err;

 mod = (struct modify_img_rec *) xv_get(frame,WIN_CLIENT_DATA);
 sl = &(mod->sl_options);
 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) 
    return mod_slice_done_proc(sl->frame);

 if ((sl->csnum <= sl->lsnum) && (sl->cecho <= sl->lecho) &&
     (sl->cscan <= sl->lscan))
    {PRT(printf("modify_slice_proc csnum = %d  cecho = %d  cscan = %d\n",
         sl->csnum,sl->cecho,sl->cscan))
     if (LocateScanEntry(&(img->file->hdr),sl->csnum,
                sl->cscan,sl->cecho,&scan_entry) == NO_ERROR)
        {img->cur_slice = scan_entry;
         if (((sl->modify_option == RESTORE_IMAGE) ||
              (((err = RdSlice(img,0,NULL,0)) == NO_ERROR) &&
               ((err = WinNewColorRequest(mod->win)) == NO_ERROR))) &&
             ((err = ModifyImageOptionProc(mod,img,sl->is_comp,
                 sl->region_option,sl->modify_option,sl->show)) == NO_ERROR) &&
              ((sl->auto_save && ((err = SaveImage(mod,img)) == NO_ERROR)) &&
               ((err = SaveImgBufToFileBuf(img)) == NO_ERROR)))
            {if (mod->is_on_each_slice)
                sroi_win = file_scan_slice_roi_win(img->file,img->cur_slice);
             for (lcv = 0; lcv < img->file->img.num_data; lcv++)
               if (((img->file->img.data[lcv] != img) || mod->is_on_each_slice ||
                    (sl->modify_option == SAVE_IMAGE)) &&
                   (img->file->img.data[lcv]->cur_slice == img->cur_slice) &&
                   (img->file->img.data[lcv]->win != NULL) &&
                   ((win = img->file->img.data[lcv]->win->image_display) != NULL))
                  {PRT5(printf("modify_slice_proc  img = %u scan  = %u on each = %d\n",
                      img,img->file->img.data[lcv],mod->is_on_each_slice))
                   if (mod->is_on_each_slice)
                      {temp_sroi_win = win->control.sroi.sroi_win;
                       win->control.sroi.sroi_win = sroi_win;
                       WinNewImgMultiCanvas(win);
                       win->control.sroi.sroi_win = temp_sroi_win;
                      }
                     else WinNewImgMultiCanvas(win);
                  }
            }
           else return mod_slice_done_proc(sl->frame);
        }
     sl->cscan += 1;
     if (sl->cscan > sl->lscan)
        {sl->cscan = sl->fscan;
         sl->cecho += 1;
         if (sl->cecho > sl->lecho)
            {sl->cecho = sl->fecho;
             sl->csnum += 1;
             if (sl->csnum > sl->lsnum) return mod_slice_done_proc(sl->frame);
             xv_set(sl->snum_item,PANEL_VALUE,sl->csnum+1,0);
            }
         xv_set(sl->echo_item,PANEL_VALUE,sl->cecho+1,0);
        }
     if (sl->scan_item != 0)
        xv_set(sl->scan_item,PANEL_VALUE,sl->cscan+1,0);
    }
   else return mod_slice_done_proc(sl->frame);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
setup_modify_slice_option_rec - ???
-------------------------------------------------------------------------*/

int
setup_modify_slice_option_rec(mod)
 struct modify_img_rec *mod;
{
 struct img_buf_rec *img;
 Panel panel;
 struct modify_slice_option_rec *sl;
 int row,offset;
 char *str;
 Rect *rr;

 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) return CANCEL;
 sl = &(mod->sl_options);

 str = win_rec_win_id_title(mod->win->owner,"MODIFY SLICES...");
 sl->frame = xv_create(mod->frame,FRAME,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              WIN_CLIENT_DATA,mod,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_CLOSED,FALSE,
              FRAME_DONE_PROC,mod_slice_done_proc,
              0);
 c_free(str);
 if (sl->frame == 0) return CANCEL;
 (void) notify_set_itimer_func((Notify_client) sl->frame,
             (Notify_func) modify_slice_proc,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
 panel = xv_create(sl->frame,PANEL,0);
 if (panel == 0)
    {mod_slice_done_proc(sl->frame);
     return CANCEL;}
 row = 5;
 offset = xv_rows(panel,1) - xv_rows(panel,0) - 5;
 sl->snum_item = xv_create(panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "SLICE#",
	PANEL_VALUE,sl->csnum+1,PANEL_MIN_VALUE,sl->fsnum,
        PANEL_MAX_VALUE,sl->lsnum+1,
        XV_X,5,XV_Y,row,
        PANEL_SLIDER_WIDTH,50,
	0);
 row += offset;
 sl->echo_item = xv_create(panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "ECHO#",
	PANEL_VALUE,sl->cecho+1,PANEL_MIN_VALUE,sl->fecho,
        PANEL_MAX_VALUE,sl->lecho+1,
        XV_X,5,XV_Y,row,
        PANEL_SLIDER_WIDTH,50,
	0);
 if (mod->which_scan != 0)
    {row += offset;
     sl->scan_item = xv_create(panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "SCAN#",
	PANEL_VALUE,sl->cscan+1,PANEL_MIN_VALUE,sl->fscan,
                    PANEL_MAX_VALUE,sl->lscan+1,
        XV_X,5,XV_Y,row,
        PANEL_SLIDER_WIDTH,50,
	0);
    }
   else sl->scan_item = 0;
 row += offset;
 sl->show_item = xv_create(panel,PANEL_CHECK_BOX,
                   XV_X,15,XV_Y,row,
 	           PANEL_CHOICE_STRINGS,"SHOW SCANS PROCESSED",NULL,
                   PANEL_NOTIFY_PROC,modify_slice_show_proc,
                   PANEL_CLIENT_DATA,mod,
                   PANEL_VALUE,1,
                   0);
 row += offset;
 xv_create(panel,PANEL_BUTTON,
 	PANEL_LABEL_STRING, "CANCEL",
        PANEL_NOTIFY_PROC,modify_slice_cancel_proc,
        PANEL_CLIENT_DATA,mod,
        XV_X,5,XV_Y,row,
	0);

 window_fit(panel);
 rr = (Rect *) xv_get(panel,XV_RECT);
 xv_set(panel,XV_WIDTH,rr->r_width - 10,XV_HEIGHT,rr->r_height - 10,0);
 window_fit(sl->frame);
 make_2_wins_adjacent(sl->frame,mod->frame,0);
 win_set_mouse_at_center(sl->frame);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
modify_slice - ???
-------------------------------------------------------------------------*/

int
modify_slice(mod,modify_option)
 struct modify_img_rec *mod;
 int modify_option;
{
 struct img_buf_rec *img;
 struct modify_slice_option_rec *sl;
 int err,result;

 PRT(printf("modify_slice...\n"))
 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) return CANCEL;
 sl = &(mod->sl_options);
 sl->auto_save = 0;
 if ((modify_option == FILL_IMAGE) || (modify_option == SMOOTH_IMAGE_BY_9_NEIGHBORS) ||
     (modify_option == INVERT_IMAGE) ||
     (modify_option == SMOOTH_IMAGE_BY_8_NEIGHBORS) ||
     (modify_option == SMOOTH_IMAGE_BY_16_NEIGHBORS))
    {PRT5(printf("notice_prompt...\n"))
     result = notice_prompt(mod->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,
               "Save the modified images automatically to the image file ?",
               0,
            NOTICE_BUTTON_YES," YES !",
            NOTICE_BUTTON_NO," NO !",
            0);
     if (result != NOTICE_NO) sl->auto_save = 1;
    }

 if (mod->abs != 0) mod->is_abs = (int) xv_get(mod->abs,PANEL_VALUE);
   else mod->is_abs = 0;
 sl->modify_option = modify_option;
 sl->region_option = (int) xv_get(mod->region,PANEL_VALUE);
 sl->is_comp = (int) xv_get(mod->exc,PANEL_VALUE);
 sl->cur_scan = img->cur_slice;
 sl->csnum = sl->fsnum;
 sl->cecho = sl->fecho;
 sl->cscan = sl->fscan;
 if ((err = setup_modify_slice_option_rec(mod)) != NO_ERROR) return err;
 if (mod->is_on_each_slice)
    sl->show = 0;
   else sl->show = xv_get(sl->show_item,PANEL_VALUE);
 xv_set(sl->frame,XV_SHOW,TRUE,0);
 xv_set(mod->frame,FRAME_BUSY,TRUE,0);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
modify_image - ???

FIXME! This function is sometimes expected to return a value (e.g. in
record_filter_image), even though functions to implement Panel_items
are normally void.  This may mask an error of some sort.  -PWH 19990415

FIXME! This function also returns the value from modify_cur_image, but
if you look at that function, it doesn't always return a value.  It looks
like something is seriously messed up here.  -PWH 19990415
-------------------------------------------------------------------------*/

int
modify_image(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;
 int is_update_slice,apply_to,modify_option;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (!xv_get(mod->on_each_slice,PANEL_INACTIVE) &&
                      xv_get(mod->on_each_slice,PANEL_VALUE))
    mod->is_on_each_slice = 1;
   else mod->is_on_each_slice = 0;
 modify_option = (int) xv_get(item,XV_KEY_DATA,1);

 apply_to = (int) xv_get(mod->apply_to,PANEL_VALUE);
 TRACE(printf("modify_image...apply_to = %d  modify_option= %d\n",
         apply_to,modify_option))
 if (apply_to > 0) return modify_cur_image(mod,modify_option);

 is_update_slice = modify_is_update_slice(mod,
       &(mod->sl_options.fsnum),&(mod->sl_options.lsnum),
       &(mod->sl_options.fecho),&(mod->sl_options.lecho),
       &(mod->sl_options.fscan),&(mod->sl_options.lscan));
 TRACE(if (is_update_slice)
          printf("fsnum = %d lsnum = %d fecho = %d lecho = %d fscan = %d lscan = %d\n",
      mod->sl_options.fsnum,mod->sl_options.lsnum,mod->sl_options.fecho,
mod->sl_options.lecho,mod->sl_options.fscan,mod->sl_options.lscan))

 if (!is_update_slice) return modify_cur_image(mod,modify_option);
   else return modify_slice(mod,modify_option);
}

/*
     ((err = shift_fft_2d_to_center(&fft)) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft)) != NO_ERROR) ||
     ((err = ConjugateFftReal(&fft)) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft1)) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft1)) != NO_ERROR) ||
     ((err = ConjugateFftReal(&fft1)) != NO_ERROR) ||
     ((err = ConjugateFftReal(&fft)) != NO_ERROR) ||
     ((err = ConjugateFft(&fft)) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft)) != NO_ERROR) ||
*/


/*-------------------------------------------------------------------------
win_convolution_with_wid - ???
-------------------------------------------------------------------------*/

int
win_convolution_with_wid(win,wid)
 struct image_display_window *win;
 char *wid;
{
 int err;
 struct buf_2d_rec fft,fft1;
 struct img_buf_rec *img,*img1;
 struct win_rec *rwin;

 PRT6(printf("win_convolution_with_wid\n"))

 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     ((rwin = get_win_rec_by_wid_str(win->owner,wid)) == NULL) ||
     ((img1 = win_rec_cur_img_buf(rwin)) == NULL))
    return CANCEL;
 init_buf_2d_rec(&fft);
 init_buf_2d_rec(&fft1);
 if (((err = SetupBuf2dRec(&fft,img->_2d.dimx,img->_2d.dimy,
              (size_t) (8 * sizeof(struct complex_rec)),0)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&fft1,img1->_2d.dimx,img1->_2d.dimy,
              (size_t) (8 * sizeof(struct complex_rec)),0)) != NO_ERROR) ||
     ((err = setup_fft_2d(&fft,&(img->_2d))) != NO_ERROR) ||
     ((err = setup_fft_2d(&fft1,&(img1->_2d))) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft)) != NO_ERROR) || 
     ((err = fft_2d(&fft)) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft1)) != NO_ERROR) || 
     ((err = fft_2d(&fft1)) != NO_ERROR) ||

     ((err = mult_complex_mat(&fft,&fft,&fft1)) != NO_ERROR) ||

     ((err = ConjugateFftReal(&fft)) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft)) != NO_ERROR) ||
     ((err = inverse_fft_2d(&fft)) != NO_ERROR) ||
/*     ((err = get_fft_2d_min_max(&fft,&min1,&max1)) != NO_ERROR) ||*/
     ((err = shift_fft_2d_to_center(&fft)) != NO_ERROR) ||
     ((err = AssignMagnitudeFftTo2d(&(img->_2d),&fft,NULL,NULL)) != NO_ERROR))
    {
    }
   else WinNewColorMultiCanvas(win);
/*
 PRT6(printf("complex_rec = %d\n",sizeof(struct complex_rec)))
 PRT6(printf("min1 = %f max1 = %f\n",min1,max1))
 PRT6(printf("fft & fft1\n"))
 PRT6(pr_buf_2d_rec(&fft))
 PRT6(pr_buf_2d_rec(&fft1))
 PRT6(pr_buf_2d_rec(&(img->_2d)))
 PRT6(printf("win_convolution_with_wid...err = %d\n",err))
*/
 free_buf_2d_rec(&fft);
 free_buf_2d_rec(&fft1);
 return err;
}


/*-------------------------------------------------------------------------
win_correlation_with_wid - ???
-------------------------------------------------------------------------*/

int
win_correlation_with_wid(win,wid)
 struct image_display_window *win;
 char *wid;
{
 int err;
 struct buf_2d_rec fft,fft1;
 struct img_buf_rec *img,*img1;
 struct win_rec *rwin;
 float min1,max1;
 double min,max;

 PRT6(printf("win_correlation_with_wid\n"))

 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     ((rwin = get_win_rec_by_wid_str(win->owner,wid)) == NULL) ||
     ((img1 = win_rec_cur_img_buf(rwin)) == NULL))
    return CANCEL;

 init_buf_2d_rec(&fft);
 init_buf_2d_rec(&fft1);

 if (((err = SetupBuf2dRec(&fft,img->_2d.dimx,img->_2d.dimy,
              (size_t) (8 * sizeof(struct complex_rec)),0)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&fft1,img1->_2d.dimx,img1->_2d.dimy,
              (size_t) (8 * sizeof(struct complex_rec)),0)) != NO_ERROR) ||
     ((err = setup_fft_2d(&fft,&(img->_2d))) != NO_ERROR) ||
     ((err = setup_fft_2d(&fft1,&(img1->_2d))) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft)) != NO_ERROR) || 
     ((err = fft_2d(&fft)) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft1)) != NO_ERROR) || 
     ((err = ConjugateFft(&fft1)) != NO_ERROR) ||

     ((err = fft_2d(&fft1)) != NO_ERROR) ||

     ((err = mult_complex_mat(&fft,&fft,&fft1)) != NO_ERROR) ||

     ((err = ConjugateFftReal(&fft)) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft)) != NO_ERROR) ||
     ((err = inverse_fft_2d(&fft)) != NO_ERROR) ||
     ((err = shift_fft_2d_to_center(&fft)) != NO_ERROR) ||
     ((err = get_fft_2d_min_max(&fft,&min1,&max1)) != NO_ERROR) ||
     ((err = AssignMagnitudeFftTo2d(&(img->_2d),&fft,&min,&max)) != NO_ERROR))
    {
    }
   else WinNewColorMultiCanvas(win);
  PRT6(printf("win_correlation_with_wid...err = %d\n",err))
 PRT6(printf("min = %f  max = %f min1 = %f max1 = %f\n",min,max,min1,max1))

 free_buf_2d_rec(&fft);
 free_buf_2d_rec(&fft1);
 return err;
}


/*-------------------------------------------------------------------------
modify_ask_win_proc - ???
-------------------------------------------------------------------------*/

void
modify_ask_win_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;
 int err,modify_option;
 struct strs_rec *wids;
 struct image_display_window *win;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 modify_option = (int) xv_get(item,XV_KEY_DATA,1);

 PRT6(printf("modify_ask_win_proc...\n"))
 win = mod->win;
 if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
    {if ((err = AllWids(win->owner,wids,1,0,IMAGE_WINDOWS)) == NO_ERROR)
        {if (wids->num_strs == 0)
            {ShowMsgStrs(win->dwin->frame,1,NO_ERROR,2,1,
                         "No other WID available !!!",NULL,0);
             c_free(wids);}
           else 
            {if (modify_option == CONVOLUTION_IMAGE)
                ShowMenuStrsProc(mod->frame,event,"CONVOLUTION",
                    wids,USER_MENU_FREE_STRS_AND_PTR,
                      win_convolution_with_wid,win,1,0,0);
               else if (modify_option == CORRELATION_IMAGE)
                ShowMenuStrsProc(mod->frame,event,"CORRELATION",
                    wids,USER_MENU_FREE_STRS_AND_PTR,
                      win_correlation_with_wid,win,1,0,0);
            }
        }
       else
        {free_strs_rec(wids);
         c_free(wids);}
    }
 PRT6(printf("modify_ask_win_proc...end\n"))
}


/*-------------------------------------------------------------------------
mod_set_on_each_slice_active - ???
-------------------------------------------------------------------------*/

void
mod_set_on_each_slice_active(mod)
 struct modify_img_rec *mod;
{
 int value;

 value = (int) xv_get(mod->region,PANEL_VALUE);
 if ((value == 0) || (value == 4))
    xv_set(mod->on_each_slice,PANEL_INACTIVE,TRUE,0);
   else 
    {value = (int) xv_get(mod->which_slice,PANEL_VALUE);
     if (value > 1) xv_set(mod->on_each_slice,PANEL_INACTIVE,FALSE,0);
       else
        {if ((int) xv_get(mod->apply_to,PANEL_VALUE) == 0)
            xv_set(mod->on_each_slice,PANEL_INACTIVE,TRUE,0);
           else xv_set(mod->on_each_slice,PANEL_INACTIVE,FALSE,0);}
    }
}


/*-------------------------------------------------------------------------
mod_region_proc - ???
-------------------------------------------------------------------------*/

void
mod_region_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct modify_img_rec *mod;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value == 0)
    {xv_set(mod->exc,PANEL_VALUE,0,0);
     xv_set(mod->exc,PANEL_INACTIVE,TRUE,0);}
   else xv_set(mod->exc,PANEL_INACTIVE,FALSE,0);
 mod_set_on_each_slice_active(mod);
}


/*-------------------------------------------------------------------------
add_minus_echoes_proc - ???
-------------------------------------------------------------------------*/

void
add_minus_echoes_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 if (value == 0) xv_set(item,XV_KEY_DATA,1,ADD_IMAGE,0);
   else if (value == 1) xv_set(item,XV_KEY_DATA,1,MINUS_IMAGE,0);
   else if (value == 2) xv_set(item,XV_KEY_DATA,1,ADD_FILE_ECHOES,0);
   else xv_set(item,XV_KEY_DATA,1,MINUS_FILE_ECHOES,0);
 modify_image(item,event);
 return;
}


/*-------------------------------------------------------------------------
smooth_image_proc - ???
-------------------------------------------------------------------------*/

void
smooth_image_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;
 int value;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 value = (int) xv_get(mod->smooth_which,PANEL_VALUE);
 if (value == 0) xv_set(item,XV_KEY_DATA,1,SMOOTH_IMAGE_BY_9_NEIGHBORS,0);
   else if (value == 1) xv_set(item,XV_KEY_DATA,1,SMOOTH_IMAGE_BY_8_NEIGHBORS,0);
   else xv_set(item,XV_KEY_DATA,1,SMOOTH_IMAGE_BY_16_NEIGHBORS,0);
 modify_image(item,event);
 return;
}


/*-------------------------------------------------------------------------
mod_some_slider_proc - ???
-------------------------------------------------------------------------*/

void
mod_some_slider_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct modify_img_rec *mod;
 int val;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (item == mod->some_scans.first)
    {val = (int) xv_get(mod->some_scans.last,PANEL_VALUE);
     if (val < value) xv_set(mod->some_scans.last,PANEL_VALUE,value,0);}
   else if (item == mod->some_scans.last)
    {val = (int) xv_get(mod->some_scans.first,PANEL_VALUE);
     if (val > value) xv_set(mod->some_scans.first,PANEL_VALUE,value,0);}
   else if (item == mod->some_slices.first)
    {val = (int) xv_get(mod->some_slices.last,PANEL_VALUE);
     if (val < value) xv_set(mod->some_slices.last,PANEL_VALUE,value,0);}
   else 
    {val = (int) xv_get(mod->some_slices.first,PANEL_VALUE);
     if (val > value) xv_set(mod->some_slices.first,PANEL_VALUE,value,0);
    }
}


/*-------------------------------------------------------------------------
mod_some_done_proc - ???
-------------------------------------------------------------------------*/

void
mod_some_done_proc(frame)
 Frame frame;
{
 struct modify_img_rec *mod;

 TRACE(printf("mod_some_done_proc...\n"))
 mod = (struct modify_img_rec *) xv_get(frame,WIN_CLIENT_DATA);
 if (mod->some_slices.frame == frame)
    {if (mod->some_slices.first != 0)
        mod->some_slices.min = (int) xv_get(mod->some_slices.first,PANEL_VALUE);
     if (mod->some_slices.last != 0)
        mod->some_slices.max = (int) xv_get(mod->some_slices.last,PANEL_VALUE);
     xv_destroy_safe(mod->some_slices.frame);
     init_some_win_rec(&(mod->some_slices));
    }
   else if (mod->some_scans.frame == frame) 
    {if (mod->some_scans.first != 0)
        mod->some_scans.min = (int) xv_get(mod->some_scans.first,PANEL_VALUE);
     if (mod->some_scans.last != 0)
        mod->some_scans.max = (int) xv_get(mod->some_scans.last,PANEL_VALUE);
     xv_destroy_safe(mod->some_scans.frame);
     init_some_win_rec(&(mod->some_scans));}
}


/*-------------------------------------------------------------------------
setup_some_win_rec - ???
-------------------------------------------------------------------------*/

int
setup_some_win_rec(mod,is_some_scans)
 struct modify_img_rec *mod;
 int is_some_scans;
{
 struct img_buf_rec *img;
 struct some_win_rec *some;
 Panel panel;
 int row,offset;
 Rect *rr;
 char *str,*str1;
 unsigned long max;

 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) return CANCEL;
 if (is_some_scans)
    {some = &(mod->some_scans);
     str1 = "SOME SCANS";}
   else
    {some = &(mod->some_slices);
     str1 = "SOME SLICES";}
 str = win_rec_win_id_title(mod->win->owner,str1);
 some->frame = xv_create(mod->frame,FRAME,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              WIN_CLIENT_DATA,mod,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_CLOSED,FALSE,
              FRAME_DONE_PROC,mod_some_done_proc,
              0);
 c_free(str);
 panel = xv_create(some->frame,PANEL,0);
 if (panel == 0)
    {mod_some_done_proc(some->frame);
     return CANCEL;}
 row = 5;
 offset = xv_rows(panel,1) - xv_rows(panel,0) - 5;
 if (is_some_scans)
    {max = NumberOfSliceScans(&(img->file->hdr.data_info));
     if (!(mod->status & SOME_SCANS_MIN_MAX_VALID))
        {some->min = 1;
         some->max = max;
         mod->status |= SOME_SCANS_MIN_MAX_VALID;}
    }
   else 
    {max = NumberOfSliceCuts(&(img->file->hdr.data_info));
     if (!(mod->status & SOME_SLICES_MIN_MAX_VALID))
        {some->min = 1;
         some->max = max;
         mod->status |= SOME_SLICES_MIN_MAX_VALID;}
    }
 some->first = xv_create(panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "FIRST",
	PANEL_VALUE,some->min,PANEL_MIN_VALUE,1,PANEL_MAX_VALUE,max,
        XV_X,5,XV_Y,row,
        PANEL_SLIDER_WIDTH,50,
        PANEL_NOTIFY_PROC,mod_some_slider_proc,
        PANEL_CLIENT_DATA,mod,
	0);

 row += offset;
 some->last = xv_create(panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "LAST",
	PANEL_VALUE,some->max,PANEL_MIN_VALUE,1,PANEL_MAX_VALUE,max,
        XV_X,5,XV_Y,row,
	PANEL_SLIDER_WIDTH,50,
        PANEL_NOTIFY_PROC,mod_some_slider_proc,
        PANEL_CLIENT_DATA,mod,
	0);
 if ((some->last == 0) || (some->first == 0))
    {mod_some_done_proc(some->frame);
     return CANCEL;}

 window_fit(panel);
 rr = (Rect *) xv_get(panel,XV_RECT);
 xv_set(panel,XV_WIDTH,rr->r_width - 10,XV_HEIGHT,rr->r_height - 10,0);
 window_fit(some->frame);
 make_2_wins_adjacent(some->frame,mod->frame,0);
 win_set_mouse_at_center(some->frame);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
mod_apply_to_proc - ???
-------------------------------------------------------------------------*/

void
mod_apply_to_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct modify_img_rec *mod;
 int inactive,show;
 
 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value != 0)
    {inactive = TRUE;
     show = FALSE;}
   else
    {inactive = FALSE;
     show = TRUE;}
 if (mod->which_scan != 0)
    {xv_set(mod->which_scan,PANEL_INACTIVE,inactive,0);
     if ((xv_get(mod->which_scan,PANEL_VALUE) == 2) &&
         (mod->some_scans.frame != 0))
        xv_set(mod->some_scans.frame,XV_SHOW,show,0);
    }
 if (mod->which_slice != 0)
    {xv_set(mod->which_slice,PANEL_INACTIVE,inactive,0);
     if ((xv_get(mod->which_slice,PANEL_VALUE) == 3) &&
         (mod->some_slices.frame != 0))
        xv_set(mod->some_slices.frame,XV_SHOW,show,0);
    }
 mod_set_on_each_slice_active(mod);
}


/*-------------------------------------------------------------------------
mod_some_slices_proc - ???
-------------------------------------------------------------------------*/

void
mod_some_slices_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct modify_img_rec *mod;
 int err;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 TRACE(printf("mod_some_scans_proc...value = %d %u\n",value,mod->some_slices.frame))
 if (value == 0)
    {if (mod->which_scan != 0)
        {xv_set(mod->which_scan,PANEL_INACTIVE,TRUE,0);
         if (mod->some_scans.frame != 0)
            xv_set(mod->some_scans.frame,XV_SHOW,FALSE,0);
        }
     if (mod->some_slices.frame != 0)
        xv_set(mod->some_slices.frame,XV_SHOW,FALSE,0);
    }
   else
    {if (mod->which_scan != 0)
        {xv_set(mod->which_scan,PANEL_INACTIVE,FALSE,0);
         if (xv_get(mod->which_scan,PANEL_VALUE) == 2)
            if (mod->some_scans.frame != 0)
               xv_set(mod->some_scans.frame,XV_SHOW,TRUE,0);
        }
     if (value == 3)
        {
         if (mod->some_slices.frame != 0) 
            {xv_set(mod->some_slices.frame,XV_SHOW,TRUE,0);
             wmgr_top(mod->some_slices.frame);
             win_set_mouse_at_center(mod->some_slices.frame);}
           else if ((err = setup_some_win_rec(mod,0)) != NO_ERROR)
            xv_set(item,PANEL_VALUE,0,0);
           else xv_set(mod->some_slices.frame,XV_SHOW,TRUE,0);
        }
       else if (mod->some_slices.frame != 0)
        xv_set(mod->some_slices.frame,XV_SHOW,FALSE,0);
    }
 mod_set_on_each_slice_active(mod);
}


/*-------------------------------------------------------------------------
mod_some_scans_proc - ???
-------------------------------------------------------------------------*/

void
mod_some_scans_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct modify_img_rec *mod;
 int err;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 TRACE(printf("mod_some_scans_proc...value = %d %u\n",value,mod->some_scans.frame))
 if (value == 2)
    {
     if (mod->some_scans.frame != 0) 
        {xv_set(mod->some_scans.frame,XV_SHOW,TRUE,0);
         wmgr_top(mod->some_scans.frame);
         win_set_mouse_at_center(mod->some_scans.frame);}
       else if ((err = setup_some_win_rec(mod,1)) != NO_ERROR)
        xv_set(item,PANEL_VALUE,0,0);
       else xv_set(mod->some_scans.frame,XV_SHOW,TRUE,0);
    }
   else if (mod->some_scans.frame != 0)
    xv_set(mod->some_scans.frame,XV_SHOW,FALSE,0);
}


/*-------------------------------------------------------------------------
mod_filter_done_proc - ???
-------------------------------------------------------------------------*/

void
mod_filter_done_proc(frame)
 Frame frame;
{
 struct modify_img_rec *mod;

 TRACE(printf("mod_filter_done_proc...\n"))
 mod = (struct modify_img_rec *) xv_get(frame,WIN_CLIENT_DATA);
 if (mod->filter.frame != 0) xv_destroy_safe(mod->filter.frame);
 mod->filter.frame = 0;
}


/*-------------------------------------------------------------------------
setup_filter_proc - ???
-------------------------------------------------------------------------*/

int
setup_filter_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 int row,offset;
 char *str;
 double cut_off_freq;
 Rect *rr;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (mod->filter.frame != 0)
    {xv_set(mod->filter.frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
     return NO_ERROR;
    }
 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) return CANCEL;
 mod->filter.frame = xv_create(mod->frame, FRAME,
              WIN_CLIENT_DATA,mod,
              FRAME_CLOSED,FALSE,
              0);
 if (mod->filter.frame == 0) return CANCEL;
 str = win_rec_win_id_title(mod->win->owner,"FILTER");
 xv_set(mod->filter.frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,mod_filter_done_proc,
              0);
 c_free(str);
 mod->filter.panel = xv_create(mod->filter.frame,PANEL,0);
 if (mod->filter.panel == 0)
    {xv_destroy_safe(mod->filter.frame);
     mod_filter_done_proc(mod->filter.frame);
     return CANCEL;}
 row = 5;
 offset = xv_rows(mod->filter.panel,1) - xv_rows(mod->filter.panel,0) - 5;
 mod->filter.which_filter = xv_create(mod->filter.panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"IDEAL FILTER",
                           "BUTTERWORTH FILTER",
                           "EXPONETIAL FILTER",
                           "TRAPIZOIDAL FILTER",NULL,
                  PANEL_VALUE,1,
                  XV_X,5,XV_Y,row,
                  PANEL_CLIENT_DATA,mod,
                  0);
 rr = (Rect *) xv_get(mod->filter.which_filter,XV_RECT);
 mod->filter.filter_which_freq = xv_create(mod->filter.panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"HIGH PASS",
                           "LOW PASS",NULL,
                  PANEL_VALUE,1,
                  XV_X,rr->r_left + rr->r_width + 10,XV_Y,row,
                  PANEL_CLIENT_DATA,mod,
                  0);

 if (img->_2d.dimy > img->_2d.dimx)
    cut_off_freq = sqrt((double) (img->_2d.dimy * img->_2d.dimy / 4.0));
   else cut_off_freq = sqrt((double) (img->_2d.dimx * img->_2d.dimx / 4.0));
 cut_off_freq = ceil(cut_off_freq);
 row += offset;

 mod->filter.cut_off_freq = xv_create(mod->filter.panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "CUT OFF FREQ",
	PANEL_VALUE,(int) ULongRound((double) cut_off_freq),
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,(int) ULongRound((double) cut_off_freq),
	PANEL_SLIDER_WIDTH,50,
        XV_X,5,XV_Y,row,
	0);
 row += offset;
 mod->filter.lb_cut_off_freq = xv_create(mod->filter.panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "LB CUT OFF FREQ",
	PANEL_VALUE,0,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,(int) ULongRound((double) cut_off_freq),
	PANEL_SLIDER_WIDTH,50,
        XV_X,5,XV_Y,row,
	0);

 row += offset;
 mod->filter.order = xv_create(mod->filter.panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "ORDER",
	PANEL_VALUE,1,
	PANEL_MIN_VALUE,1,
	PANEL_MAX_VALUE,5,
        XV_X,5,XV_Y,row,
	PANEL_SLIDER_WIDTH,50,
	0);
 row += offset;
 str = "RECORD FFT";
 xv_create(mod->filter.panel,PANEL_BUTTON,
 	PANEL_LABEL_STRING, str,
        XV_X,5,XV_Y,row,
        PANEL_NOTIFY_PROC,record_filter_image,
        PANEL_CLIENT_DATA,mod,
        0);
 str = "TESTING FILTER";
 mod->filter.testing = xv_create(mod->filter.panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   XV_KEY_DATA,1,FILTER_IMAGE,
                   PANEL_NOTIFY_PROC,modify_image,
                   PANEL_CLIENT_DATA,mod,
                   0);


 window_fit(mod->filter.panel);
 window_fit(mod->filter.frame);
 if (mod->gradient.frame != 0)
    xv_set(mod->filter.frame,WIN_BELOW,mod->gradient.frame,0);
   else make_2_wins_adjacent(mod->filter.frame,mod->frame,0);
 win_set_mouse_at_center(mod->filter.frame);
 xv_set(mod->filter.frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
mod_resume_image - ???
-------------------------------------------------------------------------*/

void
mod_resume_image(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 WinNewColorMultiCanvas(mod->win);
}


/*-------------------------------------------------------------------------
mod_gradient_done_proc - ???
-------------------------------------------------------------------------*/

void
mod_gradient_done_proc(frame)
 Frame frame;
{
 struct modify_img_rec *mod;

 TRACE(printf("mod_gradient_done_proc...\n"))
 mod = (struct modify_img_rec *) xv_get(frame,WIN_CLIENT_DATA);
 if (mod->gradient.frame != 0) xv_destroy_safe(mod->gradient.frame);
 mod->gradient.frame = 0;
 free_buf_2d_rec(&(mod->gradient._2d));
}


/*-------------------------------------------------------------------------
setup_gradient_proc - ???
-------------------------------------------------------------------------*/

int
setup_gradient_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 int row,offset;
 char *str;
 Rect *rr;
 static char *set_str = "SET";
 Panel_item item1;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (mod->gradient.frame != 0)
    {xv_set(mod->gradient.frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
     return NO_ERROR;
    }
 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) return CANCEL;
 mod->gradient.frame = xv_create(mod->frame, FRAME,
              WIN_CLIENT_DATA,mod,
              FRAME_CLOSED,FALSE,
              0);
 if (mod->gradient.frame == 0) return CANCEL;
 str = win_rec_win_id_title(mod->win->owner,"SHARPEN BY GRADIENT");
 xv_set(mod->gradient.frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,mod_gradient_done_proc,
              0);
 c_free(str);
 mod->gradient.panel = xv_create(mod->gradient.frame,PANEL,0);
 if (mod->gradient.panel == 0)
    {xv_destroy_safe(mod->gradient.frame);
     mod_gradient_done_proc(mod->gradient.frame);
     return CANCEL;}
 row = 2;
 offset = xv_rows(mod->gradient.panel,1) - xv_rows(mod->gradient.panel,0) - 8;
 mod->gradient.which_option = xv_create(mod->gradient.panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_HORIZONTAL,
 	          PANEL_LABEL_STRING, "GRADIENT OPERATOR",
                  PANEL_CHOICE_STRINGS,"SOBEL",
                           "2 NEXT/BELOW NEIGHBORS",NULL,
                  PANEL_VALUE,1,
                  XV_X,5,XV_Y,row,
                  PANEL_CLIENT_DATA,mod,
                  0);
 row += offset;
 mod->gradient.display = xv_create(mod->gradient.panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_HORIZONTAL,
 	          PANEL_LABEL_STRING, "RESULT =",
                  PANEL_CHOICE_STRINGS,"GRADIENT ONLY",
                           "GRADIENT + IMAGE",NULL,
                  XV_X,5,XV_Y,row,
                  PANEL_VALUE,1,
                  PANEL_CLIENT_DATA,mod,
                  0);
 row += offset;
 item1 = xv_create(mod->gradient.panel,PANEL_MESSAGE,
 	           PANEL_LABEL_STRING, "SHARPENING...",
                   XV_X,5,XV_Y,row,
                   PANEL_CLIENT_DATA,mod,
                   0);
 rr = (Rect *) xv_get(item1,XV_RECT);
 str = "TESTING ONLY";
 mod->gradient.testing = xv_create(mod->gradient.panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   XV_KEY_DATA,1,GRADIENT_IMAGE,
                   PANEL_NOTIFY_PROC,modify_image,
                   XV_X,rr->r_left + rr->r_width,XV_Y,row,
                   PANEL_CLIENT_DATA,mod,
                   0);

 rr = (Rect *) xv_get(mod->gradient.testing,XV_RECT);
 str = "NOW";
 item1 = xv_create(mod->gradient.panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   PANEL_NOTIFY_PROC,record_gradient_image,
                  XV_X,rr->r_left + rr->r_width,XV_Y,row,
                   PANEL_CLIENT_DATA,mod,
                   0);
 rr = (Rect *) xv_get(item1,XV_RECT);
 xv_create(mod->gradient.panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, "RESUME IMAGE",
                   PANEL_NOTIFY_PROC,mod_resume_image,
                   XV_X,rr->r_left + rr->r_width,XV_Y,row,
                   PANEL_CLIENT_DATA,mod,
                   0);
 row += offset;
 mod->gradient.set_threshold = xv_create(mod->gradient.panel,PANEL_CHECK_BOX,
        XV_X,5,XV_Y,row,
        PANEL_LABEL_STRING, set_str,PANEL_VALUE,1,
        0);
 rr = (Rect *) xv_get(mod->gradient.set_threshold,XV_RECT);
 mod->gradient.threshold = xv_create(mod->gradient.panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "GRADIENT THRESHOLD",
	PANEL_VALUE,70,
	PANEL_MIN_VALUE,1,
	PANEL_MAX_VALUE,num_bit_values(img->_2d.pixel_depth) - 1,
	PANEL_SLIDER_WIDTH,50,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 row += offset;
 mod->gradient.set_gvalue = xv_create(mod->gradient.panel,PANEL_CHECK_BOX,
        XV_X,5,XV_Y,row,
        PANEL_LABEL_STRING, set_str,PANEL_VALUE,0,
        0);
 rr = (Rect *) xv_get(mod->gradient.set_gvalue,XV_RECT);
 mod->gradient.gvalue = xv_create(mod->gradient.panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "GRADIENT VALUE",
	PANEL_VALUE,num_bit_values(img->_2d.pixel_depth) - 1,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,num_bit_values(img->_2d.pixel_depth) - 1,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	PANEL_SLIDER_WIDTH,50,
	0);
 row += offset;
 mod->gradient.set_image_value = xv_create(mod->gradient.panel,PANEL_CHECK_BOX,
        XV_X,5,XV_Y,row,
        PANEL_LABEL_STRING, set_str,PANEL_VALUE,0,
        0);
 rr = (Rect *) xv_get(mod->gradient.set_image_value,XV_RECT);
 mod->gradient.image_value = xv_create(mod->gradient.panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "IMAGE VALUE",
	PANEL_VALUE,0,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,num_bit_values(img->_2d.pixel_depth) - 1,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	PANEL_SLIDER_WIDTH,50,
	0);
 row += offset;
 window_fit(mod->gradient.panel);
 window_fit(mod->gradient.frame);
 if (mod->filter.frame != 0)
    xv_set(mod->gradient.frame,WIN_BELOW,mod->filter.frame,0);
   else make_2_wins_adjacent(mod->gradient.frame,mod->frame,0);
 win_set_mouse_at_center(mod->gradient.frame);
 xv_set(mod->gradient.frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
mod_save_done_proc - ???
-------------------------------------------------------------------------*/

void
mod_save_done_proc(frame)
 Frame frame;
{
 struct modify_img_rec *mod;

 TRACE(printf("mod_save_done_proc...\n"))
 mod = (struct modify_img_rec *) xv_get(frame,WIN_CLIENT_DATA);
 (void) notify_set_itimer_func(mod->save.frame,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 free_save_win_rec(&(mod->save));
 win_run_proc_to_all_file_wins(mod->win,WinNewColorMultiCanvas,1,0,0,0);
}


/*-------------------------------------------------------------------------
save_the_file_pixels - ???
-------------------------------------------------------------------------*/

int
save_the_file_pixels(frame,which)
 Frame frame;
 int which;
{
 struct modify_img_rec *mod;
 struct img_buf_rec *img;
 int err;
 struct hdr_scan_entry_rec *slice;
 char *reason;

 mod = (struct modify_img_rec *) xv_get(frame,WIN_CLIENT_DATA);
 TRACE(printf("save_the_file_pixels...frame = %u   mod = %u\n",frame,mod))
 InitBuf2dRecData(&(mod->save.slice_mask),(double) .0);
 TRACE(printf("save_the_file_pixels...mod->save.img.data[0] = %u all = %d\n",
          mod->save.img.data[0],mod->save.all_selected))
 err = CANCEL;
 if (mod->save.all_selected ||
     (((mod->save.slice_map = get_cur_slice_map(mod->save.img.data[0]->file,
           mod->save.img.data[0]->cur_slice)) != NULL) &&
      ((err = select_2d_by_val(mod->save.slice_map,
            &(mod->save.slice_mask),mod->save.selected)) == NO_ERROR)))
    {
     err = NO_ERROR;
     TRACE(printf("save_the_file_pixels...2222\n"))
     if (!mod->save.all_selected) 
        if ((int) xv_get(mod->exc,PANEL_VALUE) == 0)
           NotBitmap(&(mod->save.slice_mask),&(mod->save.slice_mask));
     slice = mod->save.img.data[0]->cur_slice;
     img = mod->save.img.data[0];
     reason = NULL;
     if ((err = RdCurSliceEchoes(img,1,0)) == NO_ERROR)
        {do
            {
             xv_set(mod->save.slice_num,PANEL_VALUE,
                   img->cur_slice->num,0);
             xv_set(mod->save.label,PANEL_VALUE,img->cur_slice->img_label,0);
             TRACE(printf("img->_2d = %d\n",CntValBuf2dRec(&(img->_2d),(double) 0));)
             if (!mod->save.all_selected)
                Set2d(&(img->_2d),0,0,&(mod->save.slice_mask),NULL,
                          (double) .0);
             TRACE(printf("img->_2d = %d\n",CntValBuf2dRec(&(img->_2d),(double) 0));)

             img->_2d.status4 &= ~BUF_MIN_MAX_COMPUTED;
             TRACE(printf("img->cur_slice = %u slice = %u slice# %d  %d label = %s\n",img->cur_slice,slice,slice->slice_num,
            slice->num,slice->img_label))

             MinMax2d(&(img->_2d),0,(double) .0,(double) .0);
             slice->slice->min_pixel = img->_2d.minval;
             slice->slice->max_pixel = img->_2d.maxval;
             if (mod->save.is_first_minmax)
                {mod->save.min = img->_2d.minval;
                 mod->save.max = img->_2d.maxval;
                 mod->save.is_first_minmax = 0;}
               else
                {if (mod->save.min > img->_2d.minval)
                    mod->save.min = img->_2d.minval;
                 if (mod->save.max < img->_2d.maxval)
                    mod->save.max = img->_2d.maxval;}
             TRACE(printf("...."))
             if ((err = wr_slice(img,NULL,&reason)) == NO_ERROR)
                {slice = slice->partner_slice;
                 img = img->partner;}
               else
                ShowMsgStrs(mod->frame,0,err,0,3,
                      "Write error occurred ..",reason,
                      OPERATION_ABORTED,NULL,0);
             TRACE(printf("....err = %d\n",err))
            }
          while ((err == NO_ERROR) && (slice != NULL) && 
                 (slice != mod->save.img.data[0]->cur_slice));
         }
     c_free(reason);
    }
 TRACE(printf("save pixels 1 err = %d\n",err))
 if ((err != NO_ERROR) || 
     (mod->save.img.data[0]->cur_slice == mod->save.last_slice))
    {
     win_run_proc_to_all_file_wins(mod->win,WinNewImgMultiCanvas,1,0,0,0);
     if (err == NO_ERROR)
        {mod->save.img.data[0]->file->hdr.data_info.min_pixel = 
                   mod->save.min;
         mod->save.img.data[0]->file->hdr.data_info.max_pixel = 
                   mod->save.max;
         err = wr_file_hdr(mod->save.img.data[0]->file);
        }
     (void) notify_set_itimer_func(frame,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
     free_save_win_rec(&(mod->save));
    }
   else get_all_next_slice_echoes(mod->save.img.data[0],
                     mod->save.img.data[0]->cur_slice->next_slice);
 TRACE(printf("save pixels err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
save_cancel_proc - ???
-------------------------------------------------------------------------*/

void
save_cancel_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);

 (void) notify_set_itimer_func(mod->save.frame,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 free_save_win_rec(&(mod->save));
 win_run_proc_to_all_file_wins(mod->win,WinNewColorMultiCanvas,1,0,0,0);
}


/*-------------------------------------------------------------------------
save_file_pixels_proc - ???
-------------------------------------------------------------------------*/

int
save_file_pixels_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;
 char *str;
 struct img_buf_rec *img;
 int row,offset;
 int err,define;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL) return CANCEL;
 if (xv_get(mod->pixel_type_item,PANEL_LIST_SELECTED,0))
    {ShowMsgStrs(mod->frame,0,0,0,3,
               "...Saving \"EVERYTHING\" does not do anything !!!..",
               "Choose the pixel types to be saved first..",
               OPERATION_ABORTED,NULL,0);
     return NO_ERROR;}
 if ((define = is_all_pixel_type_map_ready(img->file)) != 2)
    {if (define == 1)
        ShowMsgStrs(mod->frame,0,0,0,3,
               "Sorry : pixel type are only defined for some slices !!!..",
               "Please define all of them first..",
               OPERATION_ABORTED,NULL,0);
       else ShowMsgStrs(mod->frame,0,0,0,3,
               "Sorry : pixel type are not all defined for all slices !!!..",
               "Please define all of them first..",
               OPERATION_ABORTED,NULL,0);
     return NO_ERROR;}
 if (mod->save.frame != 0)
    {xv_set(mod->save.frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
     return NO_ERROR;
    }
 mod->save.frame = xv_create(mod->frame, FRAME,
              WIN_CLIENT_DATA,mod,
              FRAME_CLOSED,FALSE,
              0);
 if (mod->save.frame == 0) return CANCEL;

 str = win_rec_win_id_title(mod->win->owner,SAVE_TYPE_PIXEL);
 xv_set(mod->save.frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,mod_save_done_proc,
              0);
 c_free(str);
 mod->save.panel = xv_create(mod->save.frame,PANEL,0);
 if (mod->save.panel == 0)
    {
     mod_save_done_proc(mod->save.frame);
     return CANCEL;}
 row = 5;
 offset = xv_rows(mod->save.panel,1) - xv_rows(mod->save.panel,0) - 5;
 mod->save.slice_num = xv_create(mod->save.panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "SLICE#",
	PANEL_VALUE,0,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,img->file->slice_info.num_sroi_wins,
        XV_X,5,XV_Y,row,
	PANEL_SLIDER_WIDTH,50,
	0);
 row += offset;
 mod->save.label = xv_create(mod->save.panel,PANEL_TEXT,
 	PANEL_LABEL_STRING, "LABEL",
 	PANEL_VALUE_DISPLAY_LENGTH, 20,
        XV_X,5,XV_Y,row,
	PANEL_VALUE,"",
	0);
 xv_create(mod->save.panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, "CANCEL",
                   PANEL_NOTIFY_PROC,save_cancel_proc,
                   PANEL_CLIENT_DATA,mod,
                   0);

 window_fit(mod->save.panel);
 window_fit(mod->save.frame);
 make_2_wins_adjacent(mod->save.frame,mod->frame,0);
 win_set_mouse_at_center(mod->save.frame);
 xv_set(mod->save.panel,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 xv_set(mod->save.frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 init_img_rec(&(mod->save.img),img->file);
 if ((NewImgBuf(&(mod->save.img),img->cur_slice,&err,0,0,0,0,0,0,0) == NULL) ||
     ((err = SetupBuf2dRec(&(mod->save.slice_mask),img->_2d.dimx, 
                img->_2d.dimy,1,0)) != NO_ERROR) ||
     ((err = get_selected_pixel_types(img,
               mod->pixel_type_item,&(mod->save.selected),
            &(mod->save.num_selected),&(mod->save.all_selected))) != NO_ERROR))
    {
     mod_save_done_proc(mod->save.frame);
     return CANCEL;}

 mod->save.last_slice = img->cur_slice->prior_slice;
 mod->save.is_first_minmax = 1;
 xv_set(mod->save.frame,XV_KEY_DATA,1,mod->save.frame,
       XV_KEY_DATA,2,save_the_file_pixels,XV_KEY_DATA,3,1,0);

 notify_interpose_event_func((Notify_client) mod->save.frame,
      (Notify_func) next_func,NOTIFY_SAFE);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
mod_done_proc - ???
-------------------------------------------------------------------------*/

void
mod_done_proc(frame)
 Frame frame;
{
 struct modify_img_rec *mod;

 TRACE(printf("mod_done_proc...\n"))
 mod = (struct modify_img_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_modify_img_rec(mod);
}


/*-------------------------------------------------------------------------
setup_mod_pixel_types - ???
-------------------------------------------------------------------------*/

void
setup_mod_pixel_types(mod)
 struct modify_img_rec *mod;
{
 int cnt;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(mod->win->owner)) == NULL)
     return /*CANCEL*/;
 delete_all_list_items(mod->pixel_type_item);
 xv_set(mod->pixel_type_item,
             PANEL_LIST_STRING,0,"EVERYTHING",
             PANEL_LIST_SELECT,0,1,0);
 for (cnt = 0; cnt < img->file->pixel_type.order.num_strs; cnt++)
    xv_set(mod->pixel_type_item,
             PANEL_LIST_STRING,cnt+1,
             img->file->pixel_type.order.strs[cnt],
             PANEL_LIST_SELECT,cnt+1,0,0);
}


/*-------------------------------------------------------------------------
modify_threshold_color_proc - ???
-------------------------------------------------------------------------*/

void
modify_threshold_color_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct modify_img_rec *mod;

 mod = (struct modify_img_rec *) xv_get(item,PANEL_CLIENT_DATA);

}


/*-------------------------------------------------------------------------
setup_modify_img_rec - ???
-------------------------------------------------------------------------*/

int
setup_modify_img_rec(mod,win)
 struct modify_img_rec *mod;
 struct image_display_window *win;
{
 int row,offset;
 struct img_buf_rec *img;
 char *str;
 Rect *rr,*rr1;
 Panel_item item;
 unsigned long first,num_colors;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
    {free_modify_img_rec(mod);
     return CANCEL;}
 TRACE(printf("setup_modify_img_rec...\n"))
 mod->frame = xv_create(win->dwin->frame, FRAME,
              WIN_CLIENT_DATA,mod,
              FRAME_CLOSED,FALSE,
              0);
 if (mod->frame == 0)
    {free_modify_img_rec(mod);
     return CANCEL;}
 mod->win = win;
 mod->dwin = win->dwin;
 str = win_rec_win_id_title(win->owner,MODIFY_IMAGE);
 xv_set(mod->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,mod_done_proc,
              0);
 c_free(str);
 mod->panel = xv_create(mod->frame,PANEL,0);
 if (mod->panel == 0)
    {free_modify_img_rec(mod);
     return CANCEL;}
 TRACE(printf("setup_modify_img_rec...1\n"))

 row = 5;
 offset = xv_rows(mod->panel,1) - xv_rows(mod->panel,0) - 5;
/*
 item = xv_create(mod->panel,PANEL_BUTTON,
 	PANEL_LABEL_STRING, "CONVOLUTION",
        PANEL_NOTIFY_PROC,modify_ask_win_proc,
        XV_KEY_DATA,1,CONVOLUTION_IMAGE,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,mod,
        0);
 xv_create(mod->panel,PANEL_BUTTON,
 	PANEL_LABEL_STRING, "CORRELATION",
        PANEL_NOTIFY_PROC,modify_ask_win_proc,
        XV_KEY_DATA,1,CORRELATION_IMAGE,
        XV_Y,row,
        PANEL_CLIENT_DATA,mod,
        0);
 row += offset;
*/
 xv_create(mod->panel,PANEL_MESSAGE,
 	          PANEL_LABEL_STRING, "APPLY",
                   XV_X,5,XV_Y,row,
                  0);
 item = xv_create(mod->panel,PANEL_MESSAGE,
 	          PANEL_LABEL_STRING, "OPTIONS TO",
                   XV_X,5,XV_Y,row + offset-10,
                  0);
 rr = (Rect *) xv_get(item,XV_RECT);
 mod->apply_to = xv_create(mod->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,
                           "CUR WINDOW","CUR FILE WINDOWS","ALL FILE WINDOWS",NULL,
                  PANEL_VALUE,0,
                  XV_X,rr->r_left + rr->r_width,XV_Y,row,
                  PANEL_CLIENT_DATA,mod,
                  PANEL_NOTIFY_PROC,mod_apply_to_proc,
                  0);
 row += offset-10;
 rr = (Rect *) xv_get(mod->apply_to,XV_RECT);
 mod->which_slice = xv_create(mod->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"CUR IMAGE",
                 "CUR SLICE","ALL SLICES","SOME SLICES",NULL,
                  PANEL_VALUE,0,
                  XV_X,rr->r_left,XV_Y,row,
                  PANEL_CLIENT_DATA,mod,
                  PANEL_NOTIFY_PROC,mod_some_slices_proc,
                  0);
 if (NumberOfSliceScans(&(img->file->hdr.data_info)) > 1)
    {rr = (Rect *) xv_get(mod->which_slice,XV_RECT);
     mod->which_scan = xv_create(mod->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"CUR SCAN",
                           "ALL SCANS",
                           "SOME SCANS",NULL,
                  PANEL_VALUE,0,
                  XV_X,rr->r_left + rr->r_width,XV_Y,row,
                  PANEL_CLIENT_DATA,mod,
                  PANEL_NOTIFY_PROC,mod_some_scans_proc,
                  0);
     xv_set(mod->which_scan,PANEL_INACTIVE,TRUE,0);
    }
   else mod->which_scan = 0;

 row += offset;
 xv_create(mod->panel,PANEL_MESSAGE,
 	           PANEL_LABEL_STRING,"OPTIONS...",
                   XV_X,5,XV_Y,row,
                  0);
 str = "SAVE IMAGE";
 xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   XV_KEY_DATA,1,SAVE_IMAGE,
                   XV_Y,row+3,
                   PANEL_NOTIFY_PROC,modify_image,
                   PANEL_CLIENT_DATA,mod,
                   0);
 str = "RESTORE";
 xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   PANEL_NOTIFY_PROC,modify_image,
                   XV_KEY_DATA,1,RESTORE_IMAGE,
                   XV_Y,row+3,
                   PANEL_CLIENT_DATA,mod,
                   0);
 str = "SHARPEN...";
 xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   PANEL_NOTIFY_PROC,setup_gradient_proc,
                   PANEL_CLIENT_DATA,mod,
                   XV_Y,row+3,
                   0);

 row += offset;
 str = "FFT";
 item = xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   XV_KEY_DATA,1,FFT_IMAGE,
                   PANEL_NOTIFY_PROC,modify_image,
                   XV_X,5,XV_Y,row,
                   PANEL_CLIENT_DATA,mod,
                   0);
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, "INV(FFT) | INV(INV-FFT)",
                   XV_KEY_DATA,1,INVERSE_FFT_ON_FFT,
                   PANEL_NOTIFY_PROC,modify_image,
                   XV_X,rr->r_left + rr->r_width,XV_Y,row,
                   PANEL_CLIENT_DATA,mod,
                   0);
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, "INV-FFT",
                   XV_KEY_DATA,1,INVERSE_FFT_IMAGE,
                   PANEL_NOTIFY_PROC,modify_image,
                   XV_X,rr->r_left + rr->r_width,XV_Y,row,
                   PANEL_CLIENT_DATA,mod,
                   0);
 rr = (Rect *) xv_get(item,XV_RECT);
 str = "FILTER...";
 item = xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   PANEL_NOTIFY_PROC,setup_filter_proc,
                   XV_X,rr->r_left + rr->r_width + 2,XV_Y,row,
                   PANEL_CLIENT_DATA,mod,
                   0);

 row += offset - 5;
 item = xv_create(mod->panel,PANEL_BUTTON,
 	PANEL_LABEL_STRING, "BACKGROUND<=ACTUAL COLOR",
        PANEL_NOTIFY_PROC,modify_image,
        XV_KEY_DATA,1,THRESHOLD_COLOR_IMAGE,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,mod,
        0);
 win_first_and_num_colors(win,&first,&num_colors);
 rr = (Rect *) xv_get(item,XV_RECT);
 mod->threshold_color = xv_create(mod->panel,PANEL_SLIDER,
	PANEL_VALUE,first,PANEL_MIN_VALUE,first,
	PANEL_MAX_VALUE,first + num_colors - 1,
	PANEL_SLIDER_WIDTH,50,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);

 row += offset - 7;
 item = xv_create(mod->panel,PANEL_BUTTON,
 	PANEL_LABEL_STRING, "BACKGROUND = DARK COLOR",
        PANEL_NOTIFY_PROC,modify_image,
        XV_KEY_DATA,1,THRESHOLD_DARK_COLOR_IMAGE,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,mod,
        0);
/*
 item = xv_create(mod->panel,PANEL_BUTTON,
 	PANEL_LABEL_STRING, "RESAMPLE",
        PANEL_NOTIFY_PROC,modify_image,
        XV_KEY_DATA,1,RESAMPLE_IMAGE,
        XV_Y,row,
        PANEL_CLIENT_DATA,mod,
        0);
*/
 row += offset;
 mod->exc = xv_create(mod->panel,PANEL_CHECK_BOX,
                   XV_X,10,XV_Y,row,
                   PANEL_CHOICE_STRINGS,"EXCLUDING",0,
                   PANEL_VALUE,0,
                   PANEL_INACTIVE,TRUE,
                   0);
 rr1 = (Rect *) xv_get(mod->exc,XV_RECT);
 mod->region = xv_create(mod->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,WHOLE_SLICE_STR,
                           CUR_CURVE_STR,CUR_ROI_STR,
                           ALL_ROIS_STR,VIEW_FILTER_ROI_STR,NULL,
                  PANEL_VALUE,0,
                  XV_X,rr1->r_left + rr1->r_width - 5,XV_Y,row,
                  PANEL_CLIENT_DATA,mod,
                  PANEL_NOTIFY_PROC,mod_region_proc,
                  0);
 rr1 = (Rect *) xv_get(mod->region,XV_RECT);
 mod->on_each_slice = xv_create(mod->panel,PANEL_CHECK_BOX,
                    XV_X,rr1->r_left + rr1->r_width - 5,XV_Y,row,
                   PANEL_CHOICE_STRINGS,"ON EACH SLICE",NULL,
                   PANEL_VALUE,0,PANEL_INACTIVE,TRUE,
                  0);
 row += offset - 3;

 str = "SMOOTH BY";
 item = xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   XV_KEY_DATA,1,SMOOTH_IMAGE_BY_9_NEIGHBORS,
                   PANEL_NOTIFY_PROC,smooth_image_proc,
                   PANEL_CLIENT_DATA,mod,
                   XV_X,5,XV_Y,row,
                   0);
 rr = (Rect *) xv_get(item,XV_RECT);
 mod->smooth_which = xv_create(mod->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,
                           "OWN + 8 NEIGHBORS",
                           "8 NEIGHBORS",
                           "RESAMPLING",
                           NULL,
                  PANEL_VALUE,0,
                   XV_X,rr->r_left + rr->r_width + 2,XV_Y,row,
                  PANEL_CLIENT_DATA,mod,
                  0);

 str = "INVERT";
 rr = (Rect *) xv_get(mod->smooth_which,XV_RECT);
 item = xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   XV_KEY_DATA,1,INVERT_IMAGE,
                   PANEL_NOTIFY_PROC,modify_image,
                   XV_X,rr->r_left + rr->r_width + 2,XV_Y,row,
                   PANEL_CLIENT_DATA,mod,
                   0);
 row += offset;
 str = "FILL";
 item = xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   XV_X,5,XV_Y,row,
                   XV_KEY_DATA,1,FILL_IMAGE,
                   PANEL_NOTIFY_PROC,modify_image,
                   PANEL_CLIENT_DATA,mod,
                   0);
 rr = (Rect *) xv_get(item,XV_RECT);
 mod->fill_val = xv_create(mod->panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "FILL COLOR",
	PANEL_VALUE,0,
	PANEL_MIN_VALUE,(long) img->file->hdr.data_info.min_pixel,
	PANEL_MAX_VALUE,(long) img->file->hdr.data_info.max_pixel,
	PANEL_SLIDER_WIDTH,50,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);


 row += offset;
 mod->pixel_type_item = xv_create(mod->panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,3,
                  XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,mod,0);
 setup_mod_pixel_types(mod);

 rr = (Rect *) xv_get(mod->pixel_type_item,XV_RECT);
 str = "<- FILTER TYPES";
 xv_create(mod->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                  XV_X,rr->r_left + rr->r_width + 10,XV_Y,row,
                   XV_KEY_DATA,1,PIXEL_TYPE_IMAGE,
                   PANEL_NOTIFY_PROC,modify_image,
                   PANEL_CLIENT_DATA,mod,
                   0);
 row += offset - 4;
 xv_create(mod->panel,PANEL_BUTTON,
                  XV_X,rr->r_left + rr->r_width + 10,XV_Y,row,
 	          PANEL_LABEL_STRING,SAVE_TYPE_PIXEL,
                  PANEL_CLIENT_DATA,mod,
                  PANEL_NOTIFY_PROC,save_file_pixels_proc,
                  0);
 if (img->file->hdr.data_info.num_echoes > 1)
    {
     row = rr->r_top + rr->r_height + 7;
     xv_create(mod->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,
                           "+ ECHOES","- ECHOES",
                           "+ FILE ECHOES","- FILE ECHOES",
                           NULL,
                  PANEL_VALUE,0,
                   XV_X,5,XV_Y,row,
                  PANEL_NOTIFY_PROC,add_minus_echoes_proc,
                  PANEL_CLIENT_DATA,mod,
                  0);
      mod->abs = xv_create(mod->panel,PANEL_CHECK_BOX,
                   XV_Y,row,
 	           PANEL_LABEL_STRING, "RESULT = ABS(RESULT)",PANEL_VALUE,0,
                   0);
    }
   else mod->abs = 0;

 window_fit(mod->panel);
 rr = (Rect *) xv_get(mod->panel,XV_RECT);
 xv_set(mod->panel,XV_HEIGHT,rr->r_height - 10,XV_WIDTH,rr->r_width - 15,0);
 window_fit(mod->frame);
 make_2_wins_adjacent(mod->frame,win->dwin->frame,0);
 win_set_mouse_at_center(mod->frame);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_modify_img_rec - ???
-------------------------------------------------------------------------*/

struct modify_img_rec *
find_modify_img_rec(all_mods,win)
 struct all_modify_img_recs *all_mods;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_mods->num_mods; lcv++)
    if (all_mods->mods[lcv]->win == win)
       return all_mods->mods[lcv];
 return NULL;
}


/*-------------------------------------------------------------------------
mod_find_same_win - ???
-------------------------------------------------------------------------*/

struct modify_img_rec *
mod_find_same_win(all_mods,win)
 struct all_modify_img_recs *all_mods;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_mods->num_mods; lcv++)
    {if (all_mods->mods[lcv]->win == win)
        return all_mods->mods[lcv];
    }
 return NULL;
}


/*-------------------------------------------------------------------------
win_modify_update_color_opr - ???
-------------------------------------------------------------------------*/

int
win_modify_update_color_opr(win)
 struct image_display_window *win;
{
 struct all_modify_img_recs *all_mods;
 struct modify_img_rec *mod;
 unsigned long val,first,last,num_colors;

 if ((all_mods = enter_modify_image(NULL, GET_ALL_MODIFY_IMG_PTR)) != NULL)
    if ((mod = find_modify_img_rec(all_mods,win)) != NULL)
       {win_first_and_num_colors(win,&first,&num_colors);
        val = xv_get(mod->threshold_color,PANEL_VALUE);
        if (val < first) val = first;
        last = first + num_colors - 1;
        if (val > last) val = last;
	xv_set(mod->threshold_color,
             PANEL_VALUE,val,PANEL_MIN_VALUE,first,
	     PANEL_MAX_VALUE,last,0);
       }
 return NO_ERROR;
}


/*---------------------------------------------------------------------
enter_modify_image - ???

BEWARE: The pre-19990224 version of this function could return either
NULL, a pointer to a structure, or an integer error code.  Since the
last two of these cannot be reliably distinguished and since no one
ever seems to check for an error code, I replaced the error code by
NULL.  Of course, it is now impossible to distinguish between NO_ERROR
and NULL (=> error), but I don't think anyone ever looks at the error
code returned.  -PWH
-----------------------------------------------------------------------*/

struct all_modify_img_recs *
enter_modify_image(
    struct image_display_window *win,
    int status)
{
 static struct all_modify_img_recs all_mods;
 static char first_time = 1;
 int err;
 struct modify_img_rec *mod;
 char *str;

 err = NO_ERROR;
 if (status == GET_ALL_MODIFY_IMG_PTR)
    {if (first_time) return NULL;
       else return &all_mods;}
  else if (status == CLEAN_UP_MODIFY_IMG)
   {
    if (!first_time)
       if ((mod = find_modify_img_rec(&all_mods,win)) != NULL)
          free_modify_img_rec(mod);
    return NO_ERROR;}

 if (first_time)
    {init_all_modify_img_recs(&all_mods);
     first_time = 0;}
   else
    {
     if ((mod = mod_find_same_win(&all_mods,win)) != NULL)
        {
         xv_set(mod->frame,
                XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
         
         win_set_mouse_at_center(mod->frame);

         wmgr_top(mod->frame);
         c_free(str);
         return NO_ERROR;
        }
    }
 get_handle_memory(&(all_mods.mods),&(all_mods.num_mods),1,
     (size_t) sizeof(struct modify_img_rec),&err);
 if (err != NO_ERROR) return NULL;    /* Was: return err */
 mod = all_mods.mods[all_mods.num_mods - 1];
 init_modify_img_rec(mod);
 if ((err = setup_modify_img_rec(mod,win)) == NO_ERROR)
    xv_set(mod->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 return NULL;    /* Was:  return err */
}
