/****************************************************************************
outline_objects.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: outline_objects.c,v 1.9 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "object.h"
#include "edge.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define TRACE1(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define TRACE1(x)
#define PRT(x)


/* Functions defined in this file */
void pr_obj_edges(struct object_rec *obj, struct buf_2d_rec *edges);
int obj_rec_edges(struct object_rec *obj, struct buf_2d_rec *obj_2d,
    struct buf_2d_rec *edges);
int simplify_obj_rec_edges(struct object_rec *obj, struct buf_2d_rec *edges,
    struct buf_2d_rec *edges1);
int next_edge(struct buf_2d_rec *edges, int x, int y, int *newx, int *newy);
int get_line_coord(struct buf_2d_rec *edges, unsigned int x, unsigned int y,
    struct curve_rec *curve, int is_root);
void get_start_pt(struct object_rec *obj, struct buf_2d_rec *edges,
    int *whch_pt);
int ObjRecToCurve2dRec(struct object_rec *obj, struct buf_2d_rec *obj_2d,
    struct curve_rec *curve, struct buf_2d_rec *edges,
    struct buf_2d_rec *edges1);
int get_all_obj_curve_recs(struct all_object_rec *all_objs,
    struct curve_rec ***curves, unsigned int *total_curves,
    unsigned int *num_curves);
int all_object_rec_to_curves(struct all_object_rec *all_objs,
    struct curve_rec ***curves, unsigned int *total_curves,
    unsigned int *num_curves);



/*------------------------------------------------------------------------
pr_obj_edges - ???
------------------------------------------------------------------------*/

void
pr_obj_edges(obj,edges)
 struct object_rec *obj;
 struct buf_2d_rec *edges;
{
 int lcv;

 printf("\n pr_obj_edges...\n");
 for (lcv = 0; lcv < obj->num_pts; lcv++)
    printf("%d) y = %d x = %d edge = %x\n",lcv,
        (int) obj->pts[lcv].y,(int) obj->pts[lcv].x,
        (unsigned int) edges->buf[obj->pts[lcv].y][obj->pts[lcv].x]);
 printf("edge...end\n\n");
}


/*------------------------------------------------------------------------
obj_rec_edges - ???
------------------------------------------------------------------------*/

int
obj_rec_edges(obj,obj_2d,edges)
 struct object_rec *obj;
 struct buf_2d_rec *obj_2d,*edges;
{
 unsigned int lcv,cnt;
 static int xy[4][2] = {{ 1, 0},{ 1, 1},{ 0, 1},{-1, 1}};
 static unsigned char _1_bit[] = {0x08,0x10,0x20,0x40};
 static unsigned char _rev_1_bit[] = {0x80,0x01,0x02,0x04};
 long x,y;

 if (obj->num_pts == 0) return NO_ERROR;
 for (lcv = 0; lcv < obj->num_pts; lcv++)   
    {edges->buf[obj->pts[lcv].y][obj->pts[lcv].x] = 0;
     set_1d_buf_value(obj_2d->buf[obj->pts[lcv].y],(unsigned long) obj->pts[lcv].x,
                obj_2d->pixel_depth,obj->id);}

 for (lcv = 0; lcv < obj->num_pts; lcv++)
    {
     for (cnt = 0; cnt < 4; cnt++)
       {x = obj->pts[lcv].x + xy[cnt][0];
        y = obj->pts[lcv].y + xy[cnt][1];
        if ((x >= 0) & (x < obj_2d->dimx) &&
            (y >= 0) & (y < obj_2d->dimy))
           if (get_1d_buf_value(obj_2d->buf[y],x,obj_2d->pixel_depth) == obj->id)
              {edges->buf[obj->pts[lcv].y][obj->pts[lcv].x] |= _1_bit[cnt];
               edges->buf[y][x] |= _rev_1_bit[cnt];
              }
       }
   }

 return NO_ERROR;
}


/**********
 for (indx = 0; indx < obj->num_pts; indx++)
    {
     if (!(obj->pts[indx].status & OBJ_BOUNDED_EDGE))
        {x = obj->pts[indx].x;
         y = obj->pts[indx].y;
         edge = edges1->buf[y][x];
         if (_SimplifyEdge[edge][0])
            {edge1 = _SimplifyEdge[edge][1];
             for (cnt = 1; cnt <= _0Edge[edge1][0]; cnt++)
                {whch = _0Edge[edge1][cnt];
                 nexty = y + _EdgeOffset[whch][1];
                 nextx = x + _EdgeOffset[whch][0];
                 edges1->buf[nexty][nextx] &= ~_EdgeBit[_EdgeReversePosi[whch]];
                }
             edges1->buf[y][x] = edge & edge1;}
        }
    }
****************/


/*------------------------------------------------------------------------
simplify_obj_rec_edges - ???
------------------------------------------------------------------------*/

int
simplify_obj_rec_edges(obj,edges,edges1)
 struct object_rec *obj;
 struct buf_2d_rec *edges,*edges1;
{
 long x,y,indx,whch,nextx,nexty,cnt;
 unsigned char edge,edge1;
 int yes;

 for (indx = 0; indx < obj->num_pts; indx++)
    {x = obj->pts[indx].x;
     y = obj->pts[indx].y;
     edges1->buf[y][x] = edges->buf[y][x];}

 for (yes = 0,indx = 0; indx < obj->num_pts; indx++)
    {x = obj->pts[indx].x;
     y = obj->pts[indx].y;
     edge = edges->buf[y][x];
     if ((edge & 0xaa) == 0xaa)
        {yes = 1;
         edge = edges1->buf[y][x];
         edge = ~edge;
         for (cnt = 1; cnt <= (unsigned long)_0Edge[edge][0]; cnt++)
            {whch = _0Edge[edge][cnt];
             nexty = y + _EdgeOffset[whch][1];
             nextx = x + _EdgeOffset[whch][0];
             edges1->buf[nexty][nextx] &= ~_EdgeBit[_EdgeReversePosi[whch]];}
         edges1->buf[y][x] = 0;}
    }
 if (yes)
    {for (indx = 0; indx < obj->num_pts; indx++)
        {x = obj->pts[indx].x;
         y = obj->pts[indx].y;
         edges->buf[y][x] = edges1->buf[y][x];}
    }
 for (indx = 0; indx < obj->num_pts; indx++)
    {
     x = obj->pts[indx].x;
     y = obj->pts[indx].y;
     edge = edges->buf[y][x];
     if (_SimplifyEdge[edge][0])
        {edge1 = _SimplifyEdge[edge][1];
         edges1->buf[y][x] &= edge1;}
    }
 for (indx = 0; indx < obj->num_pts; indx++)
    {x = obj->pts[indx].x;
     y = obj->pts[indx].y;
     edges->buf[y][x] = edges1->buf[y][x];}
 return NO_ERROR;
}


/*------------------------------------------------------------------------
next_edge - ???
------------------------------------------------------------------------*/

int
next_edge(edges,x,y,newx,newy)
 struct buf_2d_rec *edges;
 int x,y,*newx,*newy;
{
 unsigned int value,cnt,bit_num;

 if (value = (unsigned int) edges->buf[y][x])
    {cnt = _EdgeFirstNonZeroBit[value];
     edges->buf[y][x] &= ~_EdgeBit[cnt];

     *newx = _EdgeOffset[cnt][0] + x;
     *newy = _EdgeOffset[cnt][1] + y;
     bit_num = _EdgeReversePosi[cnt];
     edges->buf[*newy][*newx] &= ~_EdgeBit[bit_num];

     return NO_ERROR;
    }
 return CANCEL;
}


/*------------------------------------------------------------------------
get_line_coord - ???
------------------------------------------------------------------------*/

int
get_line_coord(edges,x,y,curve,is_root)
 struct buf_2d_rec *edges;
 unsigned int x,y;
 struct curve_rec *curve;
 int is_root;
{
 unsigned short status;
 struct curve_rec curves[8];
 unsigned int num_curves,newx,newy,num,cnt,lcv,num_pts;
 int err;

 if ((num = _EdgeCounts[edges->buf[y][x]]) == 0)
    {TRACE(printf("get_line_coord num = %d ***\n",num))
     if ((err = EnterCurveXY(curve,
          (float) x,(float) y,&status,NULL,0,0,0)) != NO_ERROR)
        return err;
    }
   else if (num == 1)
    {TRACE(printf("get_line_coord num = %d\n",num))
     if ((err = EnterCurveXY(curve,
           (float) x,(float) y,&status,NULL,0,0,0)) != NO_ERROR)
        return err;
     if (next_edge(edges,x,y,&newx,&newy) == NO_ERROR)
        {
         TRACE(printf("1 edge = %x newx = %d newy = %d\n",
                    (unsigned int) edges->buf[y][x],newx,newy))

         get_line_coord(edges,newx,newy,curve,0);}
    }
   else
    {num_curves = 0;
     TRACE(printf("get_line_coord num = %d\n",num))
     err = NO_ERROR;
     do
        {
         if (next_edge(edges,x,y,&newx,&newy) != NO_ERROR)
            break;

         TRACE(printf("edge = %x newx = %d newy = %d\n",
                    (unsigned int) edges->buf[y][x],newx,newy))         
         init_curve_rec(&(curves[num_curves]));
         err = get_line_coord(edges,newx,newy,
                       &(curves[num_curves]),0);
         num_curves++;
        }
     while ((edges->buf[y][x] != 0) && (err == NO_ERROR));
     if (err != NO_ERROR)
        {for (cnt = 0; cnt < num_curves; cnt++)
            free_curve_rec(&(curves[cnt]));
         return err;}
     TRACE(printf("get_line_coord num_curves = %d...\n",num_curves))

     if ((num_curves == 2) && is_root)
        {TRACE(printf("get_line_coord reverse_curve_rec...\n"))
         reverse_curve_rec(&(curves[0]));
         TRACE(printf("get_line_coord JoinCurveRec...\n"))
         if (((err = JoinCurveRec(&(curves[0]),curve,0,0,
                       &status,1.0,1.0,NULL,NULL,NULL)) != NO_ERROR) ||
             ((err = EnterCurveXY(&(curves[0]),
                       (float) x,(float) y,
                        &status,NULL,0,0,0)) != NO_ERROR) ||
             ((err = JoinCurveRec(&(curves[0]),&(curves[1]),0,0,
                      &status,1.0,1.0,NULL,NULL,NULL)) != NO_ERROR))
            {free_curve_rec(&(curves[0]));
             free_curve_rec(&(curves[1]));
             return err;}
         TRACE(printf("get_line_coord JoinCurveRec...\n"))
         free_curve_rec(curve);
         *curve = curves[0];
         free_curve_rec(&(curves[1]));
        }
       else if (num_curves > 0)
        {
         lcv = 0;
         if (num_curves > 1)
            {for (num_pts = cnt = 0; cnt < num_curves; cnt++)
                if (num_pts < curves[cnt].num_xys)
                   {num_pts = curves[cnt].num_xys;
                    lcv = cnt;}
         
     TRACE(printf("get_line_coord 2...\n"))
             for (cnt = 0; cnt < num_curves; cnt++)
                {
                 if ((cnt != lcv) && (curves[cnt].num_xys > 0))
                   {
                    if (((err = EnterCurveXY(curve,
                          (float) x,(float) y,&status,NULL,0,0,0)) != 
                             NO_ERROR) ||
                        ((err = JoinCurveRec(curve,&(curves[cnt]),0,0,
                             &status,1.0,1.0,NULL,NULL,NULL)) != NO_ERROR))
                       {for (cnt = 0; cnt < num_curves; cnt++)
                           free_curve_rec(&(curves[cnt]));
                        return err;}
                    if (curves[cnt].num_xys > 1)
                       {
                        reverse_curve_rec(&(curves[cnt]));
                        if ((err = JoinCurveRec(curve,&(curves[cnt]),0,0,
                                &status,1.0,1.0,NULL,NULL,NULL)) != NO_ERROR)
                           {for (cnt = 0; cnt < num_curves; cnt++)
                               free_curve_rec(&(curves[cnt]));
                            return err;}
                       }
                   }
                }
            }
     TRACE(printf("get_line_coord 3...\n"))

         if (((err = EnterCurveXY(curve,
                   (float) x,(float) y,&status,NULL,0,0,0)) != NO_ERROR) ||
             ((err = JoinCurveRec(curve,&(curves[lcv]),0,0,
                          &status,1.0,1.0,NULL,NULL,NULL)) != NO_ERROR))
            {
             for (cnt = 0; cnt < num_curves; cnt++)
                free_curve_rec(&(curves[cnt]));
             return err;}

         for (cnt = 0; cnt < num_curves; cnt++)
            free_curve_rec(&(curves[cnt]));
        }
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
get_start_pt - ???
------------------------------------------------------------------------*/

void
get_start_pt(obj,edges,whch_pt)
 struct object_rec *obj;
 struct buf_2d_rec *edges;
 int *whch_pt;
{
 long lcv,num_edges,num;

 *whch_pt = 0;
 num_edges = 8;
 for (lcv = 0; lcv < obj->num_pts; lcv++)
    {num = _EdgeCounts[edges->buf[obj->pts[lcv].y][obj->pts[lcv].x]];
     if (num == 1)
        {*whch_pt = lcv;
         break;}
       else if (num < num_edges)
        {num_edges = num;
         *whch_pt = lcv;}
    }
 
}


/*------------------------------------------------------------------------
ObjRecToCurve2dRec - ???
------------------------------------------------------------------------*/

int
ObjRecToCurve2dRec(obj,obj_2d,curve,edges,edges1)
 struct object_rec *obj;
 struct curve_rec *curve;
 struct buf_2d_rec *obj_2d,*edges,*edges1;
{
 int err;
 int whch_pt;

 if (obj->num_pts == 0) return NO_ERROR;
 if (obj->num_pts > 1) sort_xy_rec(obj);
 if ((err = obj_rec_edges(obj,obj_2d,edges)) != NO_ERROR) 
    return err;
 get_start_pt(obj,edges,&whch_pt);
 TRACE(printf("\n get_start_pt ***whch_pt = %d\n",whch_pt))

 if ((err = get_line_coord(edges,(unsigned int) obj->pts[whch_pt].x,
            (unsigned int) obj->pts[whch_pt].y,curve,1)) != NO_ERROR)
    return err;

 optimize_curve_rec(curve);
 FindTheCurveMinMax(curve,NULL,0,0,0,1);
 TRACE(pr_float_bound_rec(&(curve->fl_bound));)

 TRACE(printf("\n\nafter optimize_curve_rec\n"))

 return err;
}


/*------------------------------------------------------------------------
get_all_obj_curve_recs - ???
------------------------------------------------------------------------*/

int
get_all_obj_curve_recs(all_objs,curves,total_curves,num_curves)
 struct all_object_rec *all_objs;
 struct curve_rec ***curves;
 unsigned int *total_curves,*num_curves;
{
 unsigned long lcv,cnt,total;
 struct buf_2d_rec edges,edges1;
 int err;
 struct object_rec *obj;
 struct all_object_rec *excluded_regions;

 TRACE(printf("get_all_obj_curve_recs...\n"))

 if ((err = discard_bounded_pts(all_objs)) != NO_ERROR) return err;

 if ((err = detect_all_sub_objs(all_objs,1,1)) != NO_ERROR) return err;

 init_buf_2d_rec(&edges);
 init_buf_2d_rec(&edges1);
 PRT(printf("get_all_obj_curve_recs...1\n"))
 if ((err = SetupBuf2dRec(&edges,all_objs->id_2d.dimx,
                all_objs->id_2d.dimy,8,0)) != NO_ERROR)
    {free_buf_2d_rec(&edges);
     free_buf_2d_rec(&edges1);
     return err;
    }

 PRT(printf("get_all_obj_curve_recs...2\n"))
 InitBuf2dRecData(&edges,(double) .0);
 for (total = *num_curves,lcv = 0; lcv < all_objs->num_objs; lcv++)
    {if (all_objs->objs[lcv]->excluded_regions != NULL)
        total += all_objs->objs[lcv]->excluded_regions->num_objs;
    }
 PRT(printf("get_all_obj_curve_recs...*total_curves = %d *num_curves = %d\n",*total_curves,*num_curves);)
 total += all_objs->num_objs;
 if (total > *total_curves)
    {lcv = *total_curves;
     get_handle_memory(curves,total_curves,(unsigned int) total,
            (size_t) sizeof(***curves),&err);
     if (err) 
        {free_buf_2d_rec(&edges);
         free_buf_2d_rec(&edges1);
         return err;}
     for (; lcv < *total_curves; lcv++)
        init_curve_rec((*curves)[lcv]);
    }
 PRT(printf("get_all_obj_curve_recs.1..*total_curves = %d *num_curves = %d\n",*total_curves,*num_curves);)
 InitBuf2dRecData(&(all_objs->id_2d),(double) .0);

/*
 pr_all_object_rec(all_objs,1);
*/
 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    {
     if ((err = ObjRecToCurve2dRec(all_objs->objs[lcv],
          &(all_objs->id_2d),(*curves)[*num_curves],&edges,&edges1)) != NO_ERROR)
        break;
/*
     PRT(printf("%d) ....\n",*num_curves);)
     PRT(pr_curve_rec_pts((*curves)[*num_curves]);)
*/
     (*num_curves)++;
     if ((excluded_regions = all_objs->objs[lcv]->excluded_regions) != NULL)
        {
         PRT(printf("excluded_regions ***** excluded_regions ****\n\n"))
         obj = all_objs->objs[lcv];
         for (cnt = 0; cnt < obj->num_pts; cnt++)   
            {edges.buf[obj->pts[cnt].y][obj->pts[cnt].x] = 0;
             set_1d_buf_value(all_objs->id_2d.buf[obj->pts[cnt].y],
                  (unsigned long) obj->pts[cnt].x,
                    all_objs->id_2d.pixel_depth,0);}
         PRT(printf("...total_curves = %d..num_curves = %d..lcv = %d..exc-num_objs = %d\n",
                 *total_curves,*num_curves,lcv,excluded_regions->num_objs);)

         for (cnt = 0; cnt < excluded_regions->num_objs; cnt++)
            {
             if ((obj = excluded_regions->objs[cnt]) == NULL) continue;
             TRACE1(printf("%d...exc  total_pts = %d num_pts= %d\n",
                 cnt,obj->total_pts,obj->num_pts))
             if ((err = ObjRecToCurve2dRec(obj,&(all_objs->id_2d),
                  (*curves)[*num_curves],&edges,&edges1)) != NO_ERROR)
                break;
             TRACE(printf("...ObjRecToCurve2dRec done..\n"))
             (*num_curves)++;}
         if (err != NO_ERROR) break;
        }

    }
 PRT(printf("get_all_obj_curve_recs.2..*total_curves = %d  num_curves = %d\n",*total_curves,*num_curves);)
 TRACE(printf("get_all_obj_curve_recs...5\n"))
 free_buf_2d_rec(&edges);
 free_buf_2d_rec(&edges1);
 return err;
}


/*------------------------------------------------------------------------
all_object_rec_to_curves - ???
------------------------------------------------------------------------*/

int
all_object_rec_to_curves(all_objs,curves,total_curves,num_curves)
 struct all_object_rec *all_objs;
 struct curve_rec ***curves;
 unsigned int *total_curves,*num_curves;
{
 unsigned long lcv,cnt,indx,total;
 int err;
 struct object_rec *obj;
 unsigned short status;

 for (total = *num_curves,lcv = 0; lcv < all_objs->num_objs; lcv++)
    {if (all_objs->objs[lcv]->excluded_regions != NULL)
        total += all_objs->objs[lcv]->excluded_regions->num_objs;
    }
 total += all_objs->num_objs;
 if (total > *total_curves)
    {lcv = *total_curves;
     get_handle_memory(curves,total_curves,(unsigned int) total,
            (size_t) sizeof(struct curve_rec),&err);
     if (err) return err;
     for (; lcv < *total_curves; lcv++)
        init_curve_rec((*curves)[lcv]);
    }
 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    {
     for (cnt = 0; cnt < all_objs->objs[lcv]->num_pts; cnt++)
        if ((err = EnterCurveXY((*curves)[*num_curves],
               (float) all_objs->objs[lcv]->pts[cnt].x,
               (float) all_objs->objs[lcv]->pts[cnt].y,
                        &status,NULL,0,0,0)) != NO_ERROR)
           return err;
     (*num_curves)++;
     if (all_objs->objs[lcv]->excluded_regions != NULL)
         for (indx = 0; indx < all_objs->objs[lcv]->excluded_regions->num_objs;
                      indx++)
            {
             obj = all_objs->objs[lcv]->excluded_regions->objs[indx];
             for (cnt = 0; cnt < obj->num_pts; cnt++)
                if ((err = EnterCurveXY((*curves)[*num_curves],
                      (float) obj->pts[cnt].x,(float) obj->pts[cnt].y,
                        &status,NULL,0,0,0)) != NO_ERROR)
                   return err;
             (*num_curves)++;
            }
    }
 return NO_ERROR;

}

