/****************************************************************************
process_region.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: process_region.c,v 1.10 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "common.h"
#include "nria_procedures.h"

/*
#define PRINT(x) printf(x);fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define PRINT(x) 
#define TRACE(x)
#define PRT(x) 
#define PRT1(x) 
#define PRT2(x) 
#define PRT3(x) 



/* Functions defined in this file */
int Select2dByMaskProc_1(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, struct buf_2d_rec *result_2d, double *lb, double *ub);
int Select2dByMaskProc_2(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, struct buf_2d_rec *result_2d, double *lb, double *ub,
    double *selected_val);
int Select2dByMaskProc_3(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, struct buf_2d_rec *result_2d, double *lb, double *ub,
    double *not_selected_val);
int Select2dByMaskProc_4(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, struct buf_2d_rec *result_2d, double *lb, double *ub,
    double *selected_val, double *not_selected_val);
int Select2dByMask(struct buf_2d_rec *_2d, unsigned long startleft,
    unsigned long starttop, struct buf_2d_rec *mask,
    struct int_bound_rec *affected, double lb, double ub,
    struct buf_2d_rec *result_2d, int set_selected, double selected_val,
    int set_not_selected, double not_selected_val);
int Select2d(struct buf_2d_rec *_2d, double lb, double ub,
    struct buf_2d_rec *result_2d, unsigned long set_selected,
    double selected_val, unsigned long set_not_selected,
    double not_selected_val);
int select_2d_by_val_by_mask_proc(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, struct buf_2d_rec *result_2d, unsigned char *selected);
void select_2d_by_val_by_mask(struct buf_2d_rec *_2d, unsigned long startleft,
    unsigned long starttop, int mask, struct int_bound_rec *affected,
    struct buf_2d_rec *result, unsigned char *selected);
int select_2d_by_val(struct buf_2d_rec *_2d, struct buf_2d_rec *result,
    unsigned char *selected);
int Compose2dByMaskProc(struct buf_2d_rec *dest, unsigned long row,
    unsigned long col, struct buf_2d_rec *src, unsigned long *startleft,
    unsigned long *starttop, double *src_opaque_min, double *src_opaque_max);
int Compose2dByMask(struct buf_2d_rec *dest, struct buf_2d_rec *src,
    unsigned long startleft, unsigned long starttop, struct buf_2d_rec *mask,
    struct int_bound_rec *bound, double src_opaque_min, double src_opaque_max);
int Or2dByMinMax(struct buf_2d_rec *dest, struct buf_2d_rec *src1, long dleft,
    long dtop, long dright, long dbottom, long dx, long dy,
    struct buf_2d_rec *src2, long sleft, long stop, long sright, long sbottom,
    double dstmin, double dstmax, double srcmin, double srcmax,
    int unselected_is_dest);
int Blend2d(struct buf_2d_rec *dest, struct buf_2d_rec *src1, long dleft,
    long dtop, long dright, long dbottom, long dx, long dy,
    struct buf_2d_rec *src2, long sleft, long stop, long sright, long sbottom,
    double dstmin, double dstmax, double srcmin, double srcmax,
    int unselected_is_dest, int blend_select);
int or_ary_2ds(struct buf_2d_rec *dest, struct buf_2d_rec **_2ds,
    unsigned long num_2ds);
int OrBitmaps(struct buf_2d_rec *result, struct buf_2d_rec *src1,
    struct buf_2d_rec *src2);
int OrOrBitmaps(struct buf_2d_rec *result, struct buf_2d_rec *src1,
    struct buf_2d_rec *src2);
int superimpose_bitmap_region(struct buf_2d_rec *dest,
    struct buf_2d_rec *source, struct int_bound_rec *source_dim);
int superimpose_any_size_pixel_maps(struct buf_2d_rec *dest,
    struct buf_2d_rec *src);
int AndBitmaps(struct buf_2d_rec *result, struct buf_2d_rec *src1,
    struct buf_2d_rec *src2);
int OrAndBitmaps(struct buf_2d_rec *result, struct buf_2d_rec *src1,
    struct buf_2d_rec *src2);
int and_any_size_pixel_maps(struct buf_2d_rec *dest, struct buf_2d_rec *src);
int NotBitmap(struct buf_2d_rec *result, struct buf_2d_rec *src);
int Invert2dValProc(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, double *min, double *newmin, double *ratio);
int Invert2d(struct buf_2d_rec *_2d);
int XorBitmaps(struct buf_2d_rec *result, struct buf_2d_rec *src1,
    struct buf_2d_rec *src2);
int OrXorBitmaps(struct buf_2d_rec *result, struct buf_2d_rec *src1,
    struct buf_2d_rec *src2);
int xor_same_size_bitmaps_by_bound(struct buf_2d_rec *dest,
    struct buf_2d_rec *source, unsigned long left, unsigned long top,
    unsigned long right, unsigned long bottom);
int xor_any_size_bitmaps_by_bound(struct buf_2d_rec *dest,
    struct buf_2d_rec *source, unsigned long left, unsigned long top,
    unsigned long right, unsigned long bottom);
int xor_bitmaps_by_bound(struct buf_2d_rec *dest, struct buf_2d_rec *source,
    unsigned long left, unsigned long top, unsigned long right,
    unsigned long bottom);
int dest_only_bitmaps(struct buf_2d_rec *dest, struct buf_2d_rec *source);
int fill_2d_convex_area(struct buf_2d_rec *_2d, unsigned long value);



/*-------------------------------------------------------------------------
Select2dByMaskProc_1 - ???
-------------------------------------------------------------------------*/

int
Select2dByMaskProc_1(_2d,row,col,result_2d,lb,ub)
 struct buf_2d_rec *_2d,*result_2d;
 unsigned long row,col;
 double *lb,*ub;
{
 double value;

 value = _2d->GetVal(_2d,row,col);
 if ((value >= *lb) && (value <= *ub))
    result_2d->SetVal(result_2d,row,col,value);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Select2dByMaskProc_2 - ???
-------------------------------------------------------------------------*/

int
Select2dByMaskProc_2(_2d,row,col,result_2d,lb,ub,selected_val)
 struct buf_2d_rec *_2d,*result_2d;
 unsigned long row,col;
 double *lb,*ub,*selected_val;
{
 double value;

 value = _2d->GetVal(_2d,row,col);
 if ((value >= *lb) && (value <= *ub))
    result_2d->SetVal(result_2d,row,col,*selected_val);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Select2dByMaskProc_3 - ???
-------------------------------------------------------------------------*/

int
Select2dByMaskProc_3(_2d,row,col,result_2d,lb,ub,not_selected_val)
 struct buf_2d_rec *_2d,*result_2d;
 unsigned long row,col;
 double *lb,*ub,*not_selected_val;
{
 double value;

 value = _2d->GetVal(_2d,row,col);
 if ((value < *lb) || (value > *ub)) value = *not_selected_val;
 result_2d->SetVal(result_2d,row,col,value);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Select2dByMaskProc_4 - ???
-------------------------------------------------------------------------*/

int
Select2dByMaskProc_4(_2d,row,col,result_2d,
                         lb,ub,selected_val,not_selected_val)
 struct buf_2d_rec *_2d,*result_2d;
 unsigned long row,col;
 double *lb,*ub,*selected_val,*not_selected_val;
{
 double value;

 value = _2d->GetVal(_2d,row,col);
 if ((value < *lb) || (value > *ub)) 
    result_2d->SetVal(result_2d,row,col,*not_selected_val);
   else
    result_2d->SetVal(result_2d,row,col,*selected_val);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Select2dByMask - ???
-------------------------------------------------------------------------*/

int
Select2dByMask(_2d,startleft,starttop,mask,affected,lb,ub,
               result_2d,set_selected,selected_val,
               set_not_selected,not_selected_val)
 struct buf_2d_rec *_2d,*mask,*result_2d;
 unsigned long startleft,starttop;
 struct int_bound_rec *affected;
 double lb,ub;
 int set_selected,set_not_selected;
 double selected_val,not_selected_val;
{
 if (set_selected && set_not_selected)
    return process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,affected,
           Select2dByMaskProc_4,result_2d,&lb,&ub,
                    &selected_val,&not_selected_val,0,0,0,0);
   else if (set_selected)
    return process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,affected,
           Select2dByMaskProc_2,result_2d,&lb,&ub,&selected_val,0,0,0,0,0);
   else if (set_not_selected)
    return process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,affected,
           Select2dByMaskProc_3,result_2d,&lb,&ub,&not_selected_val,0,0,0,0,0);
   else
    return process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,affected,
           Select2dByMaskProc_1,result_2d,&lb,&ub,0,0,0,0,0,0);
}


/*-------------------------------------------------------------------------
Select2d - ???
-------------------------------------------------------------------------*/

int
Select2d(_2d,lb,ub,result_2d,set_selected,selected_val,
         set_not_selected,not_selected_val)
 struct buf_2d_rec *_2d,*result_2d;
 double lb,ub,selected_val,not_selected_val;
 unsigned long set_selected,set_not_selected;
{
 unsigned long row,col;
 double value;

 for (row = 0; row < _2d->dimy; row++)
    {
     for (col = 0;col < _2d->dimx; col++)
        {value = _2d->GetVal(_2d,row,col);
         if ((value >= lb) && (value <= ub))
            {if (set_selected)
                result_2d->SetVal(result_2d,row,col,selected_val);
              else
                result_2d->SetVal(result_2d,row,col,value);
            }
           else if (set_not_selected)
                result_2d->SetVal(result_2d,row,col,not_selected_val);
        }
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
select_2d_by_val_by_mask_proc - ???
-------------------------------------------------------------------------*/

int
select_2d_by_val_by_mask_proc(_2d,row,col,result_2d,selected)
 struct buf_2d_rec *_2d,*result_2d;
 unsigned long row,col;
 unsigned char *selected;
{
 double val;
 unsigned long indx;

 val = _2d->GetVal(_2d,row,col);
 indx = ULongRound(val);
 if (selected[indx])
    result_2d->SetVal(result_2d,row,col,val);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
select_2d_by_val_by_mask - ???

FIXME!  The mask argument might want to be struct buf_2d_rec * rather than
defaulting to int.  -PWH 19990421
-------------------------------------------------------------------------*/

void
select_2d_by_val_by_mask(_2d,startleft,starttop,mask,affected,result,selected)
 struct buf_2d_rec *_2d,*result;
 unsigned long startleft,starttop;
 struct int_bound_rec *affected;
 unsigned char *selected;
{
 process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,affected,
           select_2d_by_val_by_mask_proc,result,selected,0,0,0,0,0,0,0);
}


/*-------------------------------------------------------------------------
select_2d_by_val - ???
-------------------------------------------------------------------------*/

int
select_2d_by_val(_2d,result,selected)
 struct buf_2d_rec *_2d,*result;
 unsigned char *selected;
{
 unsigned long row,col,indx;
 double val;

 for (row = 0; row < _2d->dimy; row++)
    {
     for (col = 0;col < _2d->dimx; col++)
        {val = _2d->GetVal(_2d,row,col);
         indx = ULongRound(val);
         if (selected[indx])
            result->SetVal(result,row,col,val);
           else result->SetVal(result,row,col,(double) .0);
        }
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Compose2dByMaskProc - ???
-------------------------------------------------------------------------*/

int
Compose2dByMaskProc(dest,row,col,src,startleft,starttop,
                    src_opaque_min,src_opaque_max)
 struct buf_2d_rec *dest,*src;
 unsigned long row,col;
 unsigned long *startleft,*starttop;
 double *src_opaque_min,*src_opaque_max;
{
 double val;

 val = src->GetVal(src,row - *starttop,col - *startleft);
 if ((val >= *src_opaque_min) && (val <= *src_opaque_max))
    dest->SetVal(dest,row,col,val);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Compose2dByMask - ???
-------------------------------------------------------------------------*/

int
Compose2dByMask(dest,src,startleft,starttop,mask,bound,
                src_opaque_min,src_opaque_max)
 struct buf_2d_rec *dest,*src,*mask;
 unsigned long startleft,starttop;
 struct int_bound_rec *bound;
 double src_opaque_min,src_opaque_max;
{
 return process_buf_2d_rec_by_mask(dest,startleft,starttop,mask,bound,
                           Compose2dByMaskProc,src,
                           &startleft,&starttop,
                           &src_opaque_min,&src_opaque_max,0,0,0,0);
}


/*-------------------------------------------------------------------------
Or2dByMinMax - ???
-------------------------------------------------------------------------*/

int
Or2dByMinMax(dest,src1,dleft,dtop,dright,dbottom,dx,dy,
             src2,sleft,stop,sright,sbottom,
             dstmin,dstmax,srcmin,srcmax,unselected_is_dest)
 struct buf_2d_rec *dest,*src1,*src2;
 long dleft,dtop,dright,dbottom,dx,dy,sleft,stop,sright,sbottom;
 double dstmin,dstmax,srcmin,srcmax;
 int unselected_is_dest;
{
 long dcol,drow,scol;
 double val,val1;
 unsigned long x,y,pixel_depth,type4;
 long vs1left,vs1top,vs1right,vs1bottom,vs2left,vs2top,vs2right,vs2bottom;
 int err,sel;

 PRT(printf("Or2dByMinMax..dstmin = %d dstmax = %d srcmin = %d srcmax = %d\n",
         dstmin,dstmax,srcmin,srcmax))
 if (dest->status4 & BUF_NON_EMPTY) dest->status4 &= ~BUF_DATA_VALID;
 if (ValidDstAndSrcBound(dleft,dtop,dright,dbottom,dx,dy,
       sleft,stop,sright,sbottom,
       &vs1left,&vs1top,&vs1right,&vs1bottom,&vs2left,&vs2top,&vs2right,&vs2bottom)
       != NO_ERROR)
    return NO_ERROR;

 PRT(printf("dest..in\n");pr_buf_2d_rec(dest);)
 DefineDstDepthAndType(src1,src2,&pixel_depth,&type4,0);
 if ((err = SetupBuf2dRecIfSmall(dest,
            vs1right - vs1left + 1,vs1bottom - vs1top + 1,
            pixel_depth,type4)) != NO_ERROR) 
    return err;

 PRT(printf("dest..out\n");pr_buf_2d_rec(dest);)

 Set2dStartOffsetXY(dest,vs1left,vs1top);
 for (y = 0,drow = vs1top; drow <= vs1bottom; drow++,y++,vs2top++)
    for (x = 0,scol = vs2left,dcol = vs1left; 
               dcol <= vs1right; scol++,dcol++,x++)
        {
         val1 = src2->GetVal(src2,vs2top,scol);
         if ((val1 >= srcmin) && (val1 <= srcmax))
            sel = 1;
           else sel = 0;
         val = src1->GetVal(src1,drow,dcol);
         if ((val >= dstmin) && (val <= dstmax))
            sel |= 2;
           else sel = 1;

         if (sel == 0)
            {if (!unselected_is_dest) val = 0;
            }
           else if (sel == 1) val = val1;
           else if (sel == 3) val = (val + val1) / 2.0;
         dest->SetVal(dest,y,x,val);
        }
 PRT(printf("Or2dByMinMax..end\n"))
 dest->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Blend2d - ???
-------------------------------------------------------------------------*/

int
Blend2d(dest,src1,dleft,dtop,dright,dbottom,dx,dy,
        src2,sleft,stop,sright,sbottom,
        dstmin,dstmax,srcmin,srcmax,unselected_is_dest,blend_select)
 struct buf_2d_rec *dest,*src1,*src2;
 long dleft,dtop,dright,dbottom,dx,dy,sleft,stop,sright,sbottom;
 double dstmin,dstmax,srcmin,srcmax;
 int unselected_is_dest,blend_select;
{
 long dcol,drow,scol,xsel,ysel;
 double val;
 unsigned long x,y,pixel_depth,type4;
 long vs1left,vs1top,vs1right,vs1bottom,vs2left,vs2top,vs2right,vs2bottom;
 int err;

 PRT(printf("Blend2d.blend_select = %d\n",blend_select))
 PRT(printf("Blend2d..dstmin = %d dstmax = %d srcmin = %d srcmax = %d\n",
         dstmin,dstmax,srcmin,srcmax))
 if (dest->status4 & BUF_NON_EMPTY) dest->status4 &= ~BUF_DATA_VALID;
 if (ValidDstAndSrcBound(dleft,dtop,dright,dbottom,dx,dy,
       sleft,stop,sright,sbottom,
       &vs1left,&vs1top,&vs1right,&vs1bottom,&vs2left,&vs2top,&vs2right,&vs2bottom)
       != NO_ERROR)
    return NO_ERROR;
 PRT(printf("dest..in\n");pr_buf_2d_rec(dest);)
 DefineDstDepthAndType(src1,src2,&pixel_depth,&type4,0);
 if ((err = SetupBuf2dRecIfSmall(dest,
            vs1right - vs1left + 1,vs1bottom - vs1top + 1,
            pixel_depth,type4)) != NO_ERROR) 
    return err;
 Set2dStartOffsetXY(dest,vs1left,vs1top);
 PRT(printf("dest..out\n");pr_buf_2d_rec(dest);)
 if (blend_select <= 1)
    {for (y = 0,drow = vs1top; drow <= vs1bottom; 
             drow++,y++,vs2top++)
        for (x = 0,scol = vs2left,dcol = vs1left;
                  dcol <= vs1right; scol++,dcol++,x++)
           {
            if (((vs2top + scol) % 2) == blend_select)
               {val = src2->GetVal(src2,vs2top,scol);
                if ((val < srcmin) || (val > srcmax))
                   if (unselected_is_dest)
                      {val = src1->GetVal(src1,drow,dcol);
                       if ((val < dstmin) || (val > dstmax))
                          val = 0;
                      }
                     else val = 0;
               }
              else 
               {val = src1->GetVal(src1,drow,dcol);
                if ((val < dstmin) || (val > dstmax))
                   val = 0;
               }
            dest->SetVal(dest,y,x,val);
           }
    }
   else
    {for (y = 0,drow = vs1top; drow <= vs1bottom; 
             drow++,y++,vs2top++)
        {ysel = drow % 4;
         for (x = 0,scol = vs2left,dcol = vs1left;
                  dcol <= vs1right; scol++,dcol++,x++)
            {xsel = dcol % 4;
             if ((ysel <= 1) && (xsel > 1))
                {val = src1->GetVal(src1,drow,dcol);
                 if ((val < dstmin) || (val > dstmax))
                    val = 0;}
               else if (xsel < 2) 
                {val = src1->GetVal(src1,drow,dcol);
                 if ((val < dstmin) || (val > dstmax))
                    val = 0;}
               else
                {val = src2->GetVal(src2,vs2top,scol);
                 if ((val < srcmin) || (val > srcmax))
                    if (unselected_is_dest)
                       {val = src1->GetVal(src1,drow,dcol);
                        if ((val < dstmin) || (val > dstmax))
                           val = 0;}
                      else val = 0;
                }
            dest->SetVal(dest,y,x,val);
           }
       }
    }

 dest->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}



/*-------------------------------------------------------------------------
or_ary_2ds - ???

 Condition
 ---------
  1) mask & bitmap should have the same size and x & y dimensions.
  2) both should be bitmaps.
-------------------------------------------------------------------------*/

int
or_ary_2ds(dest,_2ds,num_2ds)
 struct buf_2d_rec *dest,**_2ds;
 unsigned long num_2ds;
{
 unsigned long num;
 unsigned long cnt,lcv,row,row_bytes;

 row_bytes = GetRowBytes(dest->dimx,dest->pixel_depth);
 for (row = 0; row < dest->dimy; row++)
    for (cnt = 0; cnt < row_bytes; cnt++)
       {num = dest->buf[row][cnt];
        for (lcv = 0; lcv < num_2ds; lcv++)
           num |= _2ds[lcv]->buf[row][cnt];
        dest->buf[row][cnt] = num;
       }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
OrBitmaps - ???
-------------------------------------------------------------------------*/

int
OrBitmaps(result,src1,src2)
 struct buf_2d_rec *result,*src1,*src2;
{
 unsigned long row,col,row_bytes;

 PRT3(printf("OrBitmaps...0\n"))
 if (!is_same_buf_2d_rec_data_size(src1,src2)) return CANCEL;
 PRT3(printf("result...0\n"))
 PRT3(pr_buf_2d_rec(result))
 PRT3(printf("src1...0\n"))
 PRT3(pr_buf_2d_rec(src1))
 PRT3(printf("src2...0\n"))
 PRT3(pr_buf_2d_rec(src2))
 if ((result != src1) && (result != src2) &&
     !is_same_buf_2d_rec_data_size(result,src2)) return CANCEL;
 PRT3(printf("OrBitmaps...2\n"))
 row_bytes = GetRowBytes(result->dimx,result->pixel_depth);
 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < row_bytes; col++)
       result->buf[row][col] = src1->buf[row][col] | src2->buf[row][col];
 PRT3(printf("OrBitmaps...3\n"))

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
OrOrBitmaps - ???
-------------------------------------------------------------------------*/

int
OrOrBitmaps(result,src1,src2)
 struct buf_2d_rec *result,*src1,*src2;
{
 unsigned long row,col,row_bytes;

 PRT3(printf("OrOrBitmaps...0\n"))
 if (!is_same_buf_2d_rec_data_size(src1,src2)) return CANCEL;
 PRT3(printf("OrOrBitmaps...1\n"))
 if ((result != src1) && (result != src2) &&
     !is_same_buf_2d_rec_data_size(result,src2)) return CANCEL;
 PRT3(printf("OrOrBitmaps...2\n"))
 row_bytes = GetRowBytes(result->dimx,result->pixel_depth);
 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < row_bytes; col++)
       result->buf[row][col] |= src1->buf[row][col] | src2->buf[row][col];

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
superimpose_bitmap_region - ???
-------------------------------------------------------------------------*/

int
superimpose_bitmap_region(dest,source,source_dim)
 struct buf_2d_rec *dest,*source;
 struct int_bound_rec *source_dim;
{
 unsigned long left,right,top,bottom;
 unsigned long row,col;
 struct int_bound_rec bound;

 if (!is_same_buf_2d_rec_data_size(dest,source)) return CANCEL;

 setup_int_bound_rec(&bound,0,0,dest->dimx - 1,dest->dimy - 1);
 if (source_dim == NULL)
    valid_bound(&bound,&bound,&left,&right,&top,&bottom);
   else valid_bound(source_dim,&bound,&left,&right,&top,&bottom);

 left = left / 8;
 if (right % 8) right = right / 8 + 1;
   else right = right / 8;
 for (row = top; row <= bottom; row++)
     for (col = left; col <= right; col++)
       dest->buf[row][col] |= source->buf[row][col];

 return NO_ERROR;
 
}


/*-------------------------------------------------------------------------
superimpose_any_size_pixel_maps - ???
-------------------------------------------------------------------------*/

int
superimpose_any_size_pixel_maps(dest,src)
 struct buf_2d_rec *dest,*src;
{
 unsigned long row,col,pix,pix1;
 double val;

 if ((dest->dimx != src->dimx) ||
     (dest->dimy != src->dimy)) return CANCEL;

 for (row = 0; row < dest->dimy; row++)
    for (col = 0; col < dest->dimx; col++)
       {val = src->GetVal(src,row,col);
        pix = ULongRound(val);
        val = dest->GetVal(dest,row,col);
        pix1 = ULongRound(val);
        pix |= pix1;
        dest->SetVal(dest,row,col,(double) pix);}

 return NO_ERROR;

}


/*-------------------------------------------------------------------------
AndBitmaps - ???
-------------------------------------------------------------------------*/

int
AndBitmaps(result,src1,src2)
 struct buf_2d_rec *result,*src1,*src2;
{
 unsigned long row,col,row_bytes;

 PRT3(printf("AndBitmaps...0\n"))
 if (!is_same_buf_2d_rec_data_size(src1,src2)) return CANCEL;
 PRT3(printf("AndBitmaps...1\n"))
 if ((result != src1) && (result != src2) &&
     !is_same_buf_2d_rec_data_size(result,src2)) return CANCEL;
 PRT3(printf("AndBitmaps...2\n"))
 row_bytes = GetRowBytes(result->dimx,result->pixel_depth);
 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < row_bytes; col++)
       result->buf[row][col] = src1->buf[row][col] & src2->buf[row][col];

 return NO_ERROR;

}


/*-------------------------------------------------------------------------
OrAndBitmaps - ???
-------------------------------------------------------------------------*/

int
OrAndBitmaps(result,src1,src2)
 struct buf_2d_rec *result,*src1,*src2;
{
 unsigned long row,col,row_bytes;

 PRT3(printf("OrAndBitmaps...0\n"))
 if (!is_same_buf_2d_rec_data_size(src1,src2)) return CANCEL;
 PRT3(printf("OrAndBitmaps...1\n"))
 if ((result != src1) && (result != src2) &&
     !is_same_buf_2d_rec_data_size(result,src2)) return CANCEL;
 row_bytes = GetRowBytes(result->dimx,result->pixel_depth);
 PRT3(printf("OrAndBitmaps...2\n"))
 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < row_bytes; col++)
       result->buf[row][col] |= src1->buf[row][col] & src2->buf[row][col];

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
and_any_size_pixel_maps - ???
-------------------------------------------------------------------------*/

int
and_any_size_pixel_maps(dest,src)
 struct buf_2d_rec *dest,*src;
{
 unsigned long row,col,pix,pix1;
 double val;

 if ((dest->dimx != src->dimx) ||
     (dest->dimy != src->dimy)) return CANCEL;

 for (row = 0; row < dest->dimy; row++)
    for (col = 0; col < dest->dimx; col++)
       {val = src->GetVal(src,row,col);
        pix = ULongRound(val);
        val = dest->GetVal(dest,row,col);
        pix1 = ULongRound(val);
        pix &= pix1;
        dest->SetVal(dest,row,col,(double) pix);}

 return NO_ERROR;

}


/*-------------------------------------------------------------------------
NotBitmap - ???
-------------------------------------------------------------------------*/

int
NotBitmap(result,src)
 struct buf_2d_rec *result,*src;
{
 unsigned long cnt,row,row_bytes;

 if ((result != src) &&
     !is_same_buf_2d_rec_data_size(result,src))
    return CANCEL;
 row_bytes = GetRowBytes(result->dimx,result->pixel_depth);
 PRT1(printf("NotBitmap...row_bytes = %d dimx = %d pixel_depth = %d\n",
       row_bytes,result->dimx,result->pixel_depth))
 for (row = 0; row < result->dimy; row++)
    for (cnt = 0; cnt < row_bytes; cnt++)
       result->buf[row][cnt] = ~(src->buf[row][cnt]);

 if (result->pixel_depth != 1) result->status4 &= ~BUF_MIN_MAX_COMPUTED;
 return NO_ERROR;
}

/************
invert_2d_val(_2d,row,col)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
{
 double val;
 unsigned long val1;

 val = _2d->GetVal(_2d,row,col);
 val1 = ULongRound(val);
 val1 = ~val1;
 _2d->SetVal(_2d,row,col,(double) val1);
 return NO_ERROR;
}

invert_2d(_2d)
 struct buf_2d_rec *_2d;
{
 unsigned long row_bytes,row,col;

 row_bytes = GetRowBytes(_2d->dimx,_2d->pixel_depth);
 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < row_bytes; col++)
       _2d->buf[row][col] = ~_2d->buf[row][col];
 _2d->status4 &= ~BUF_MIN_MAX_COMPUTED;
 return NO_ERROR;
}
****************/


/*-------------------------------------------------------------------------
Invert2dValProc - ???
-------------------------------------------------------------------------*/

int
Invert2dValProc(_2d,row,col,min,newmin,ratio)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double *min,*newmin,*ratio;
{
 double val;

 if (_2d->pixel_depth == 1)
    {if ((val = _2d->GetVal(_2d,row,col)) == .0)
        _2d->SetVal(_2d,row,col,(double) 1.0);
       else _2d->SetVal(_2d,row,col,(double) .0);
     }
   else
    {
     val = _2d->GetVal(_2d,row,col);
     val = (val - *min) * (*ratio) + *newmin;
     _2d->SetVal(_2d,row,col,val);
    }

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Invert2d - ???
-------------------------------------------------------------------------*/

int
Invert2d(_2d)
 struct buf_2d_rec *_2d;
{
 double min,max;

 PRT1(printf("Invert2d...\n"))

 if (_2d->pixel_depth == 1) return NotBitmap(_2d,_2d);
 MinMax2dValues(_2d,0,(double) .0,(double) .0,&min,&max);
 PRT1(printf("Invert2d min = %f  max = %f\n",min,max))
 Scale2dValues(_2d,_2d,min,max,0,(double) .0,(double) .0,max,min);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
XorBitmaps - ???
-------------------------------------------------------------------------*/

int
XorBitmaps(result,src1,src2)
 struct buf_2d_rec *result,*src1,*src2;
{
 unsigned long row,col,row_bytes;

 PRT3(printf("XorBitmaps...0\n"))
 if (!is_same_buf_2d_rec_data_size(src1,src2)) return CANCEL;
 PRT3(printf("XorBitmaps...1\n"))
 if ((result != src1) && (result != src2) &&
     !is_same_buf_2d_rec_data_size(result,src2)) return CANCEL;
 PRT3(printf("XorBitmaps...2\n"))
 row_bytes = GetRowBytes(result->dimx,result->pixel_depth);
 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < row_bytes; col++)
       result->buf[row][col] = (src1->buf[row][col] ^ src2->buf[row][col]);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
OrXorBitmaps - ???
-------------------------------------------------------------------------*/

int
OrXorBitmaps(result,src1,src2)
 struct buf_2d_rec *result,*src1,*src2;
{
 unsigned long row,col,row_bytes;

 PRT3(printf("OrXorBitmaps...0\n"))
 if (!is_same_buf_2d_rec_data_size(src1,src2)) return CANCEL;
 PRT3(printf("OrXorBitmaps...1\n"))
 if ((result != src1) && (result != src2) &&
     !is_same_buf_2d_rec_data_size(result,src2)) return CANCEL;
 PRT3(printf("OrXorBitmaps...2\n"))
 row_bytes = GetRowBytes(result->dimx,result->pixel_depth);
 for (row = 0; row < result->dimy; row++)
    for (col = 0; col < row_bytes; col++)
       result->buf[row][col] |= (src1->buf[row][col] ^ src2->buf[row][col]);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
xor_same_size_bitmaps_by_bound - ???
-------------------------------------------------------------------------*/

int
xor_same_size_bitmaps_by_bound(dest,source,left,top,right,bottom)
 struct buf_2d_rec *dest,*source;
 unsigned long left,top,right,bottom;
{
 unsigned long col,row;
 unsigned long start,width,last;
 unsigned char first_and_byte,last_and_byte,val;
 struct int_bound_rec bound,bound1;
 unsigned long left1,top1,right1,bottom1;

 setup_int_bound_rec(&bound1,left,top,right,bottom);
 setup_int_bound_rec(&bound,0,0,dest->dimx - 1,dest->dimy - 1);
 valid_bound(&bound1,&bound,&left1,&right1,&top1,&bottom1);
 get_range_byte_offsets(left1,right1,dest->pixel_depth,
                       &first_and_byte,&start,&width,&last_and_byte);
 PRT2(printf("l1 = %d t1 = %d r1 = %d b1 = %d\n",
     left,top,right,bottom))
 PRT2(printf("l = %d t= %d r = %d b = %d\n",
     left1,top1,right1,bottom1))
/*
 printf("xor_same_size_ depth = %d first = %x start = %d width = %d last = %x\n",
     dest->pixel_depth,
    (unsigned int) first_and_byte,start,width,(unsigned int) last_and_byte);
*/
 if (width > 0)
    {last = start + width;
     for (row = top1; row <= bottom1; row++)
        for (col = start; col < last; col++)
           dest->buf[row][col] ^= source->buf[row][col];
    }
 if (first_and_byte)
    for (col = left1 / 8,row = top1; row <= bottom1; row++)
       {val = source->buf[row][col] & first_and_byte;
        dest->buf[row][col] ^= val;
       }
 if (last_and_byte)
    for (col = right1 / 8,row = top1; row <= bottom1; row++)
       {val = source->buf[row][col] & last_and_byte;
        dest->buf[row][col] ^= val;
       }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
xor_any_size_bitmaps_by_bound - ???
-------------------------------------------------------------------------*/

int
xor_any_size_bitmaps_by_bound(dest,source,left,top,right,bottom)
 struct buf_2d_rec *dest,*source;
 unsigned long left,top,right,bottom;
{
 unsigned long col,row;
 unsigned long start,width,last;
 unsigned char first_and_byte,last_and_byte,val;
 struct int_bound_rec bound,bound1;
 unsigned long left1,top1,right1,bottom1;

 setup_int_bound_rec(&bound1,left,top,right,bottom);
 setup_int_bound_rec(&bound,0,0,dest->dimx - 1,dest->dimy - 1);
 valid_bound(&bound1,&bound,&left1,&right1,&top1,&bottom1);
 get_range_byte_offsets(left1,right1,dest->pixel_depth,
                       &first_and_byte,&start,&width,&last_and_byte);
 if (width > 0)
    {last = start + width;
     for (row = top1; row <= bottom1; row++)
        for (col = start; col < last; col++)
           dest->buf[row][col] ^= source->buf[row][col];
    }
 if (first_and_byte)
    for (col = left1 / 8,row = top1; row <= bottom1; row++)
       {val = source->buf[row][col] & first_and_byte;
        dest->buf[row][col] ^= val;
       }
 if (last_and_byte)
    for (col = right1 / 8,row = top1; row <= bottom1; row++)
       {val = source->buf[row][col] & last_and_byte;
        dest->buf[row][col] ^= val;
       }

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
xor_bitmaps_by_bound - ???
-------------------------------------------------------------------------*/

int
xor_bitmaps_by_bound(dest,source,left,top,right,bottom)
 struct buf_2d_rec *dest,*source;
 unsigned long left,top,right,bottom;
{
 if (is_same_buf_2d_rec_data_size(dest,source))
    return xor_same_size_bitmaps_by_bound(dest,source,left,top,right,bottom);
   else return xor_any_size_bitmaps_by_bound(dest,source,left,top,right,bottom);
}


/*-------------------------------------------------------------------------
dest_only_bitmaps - ???
-------------------------------------------------------------------------*/

int
dest_only_bitmaps(dest,source)
 struct buf_2d_rec *dest,*source;
{
 unsigned long cnt,row,row_bytes;

 if (!is_same_buf_2d_rec_data_size(dest,source)) return CANCEL;
 row_bytes = GetRowBytes(dest->dimx,dest->pixel_depth);

 for (row = 0; row < source->dimy; row++)
    for (cnt = 0; cnt < row_bytes; cnt++)
       dest->buf[row][cnt] &= ~source->buf[row][cnt];

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
fill_2d_convex_area - ???
-------------------------------------------------------------------------*/

int
fill_2d_convex_area(_2d,value)
 struct buf_2d_rec *_2d;
 unsigned long value;
{
 unsigned long row,col,total,first,last,the_first,
              the_last,the_top,the_bottom,indx;
 unsigned long *top,*bottom,*left,*right;
 int err;
 unsigned long total_pts_drawn;

 total = 0;
 get_ptr_memory(&top,&total,(size_t) ((_2d->dimx + _2d->dimy) * 2),
    (size_t) sizeof(*top),&err);
 if (err != NO_ERROR) return err;
 bottom = top + _2d->dimx;
 left = bottom + _2d->dimy;
 right = left + _2d->dimy;
 for (col = 0; col < _2d->dimx; col++)
    {left[col] = top[col] = 0xffffffff;
     right[0] = bottom[col] = 0;}
 the_top = the_first = 0xffffffff;
 the_bottom = the_last = 0;
 for (row = 0; row < _2d->dimy; row++)
    if (Get1dBitMapFirstNon0Posi(_2d->buf[row],_2d->dimx,
             _2d->pixel_depth,&first) == NO_ERROR)
       {Get1dBitMapLastNon0Posi(_2d->buf[row],_2d->dimx,
              _2d->pixel_depth,&last);
        if (the_first > first) the_first = first;
        if (the_last < last) the_last = last;
        if (the_top > row) the_top = row;
        if (the_bottom < row) the_bottom = row;
        left[row] = first;
        right[row] = last;
       }
 for (total_pts_drawn = 0,row = the_top; row <= the_bottom; row++)
    {if (left[row] <= right[row])
       for (indx = row + 1; indx <= the_bottom; indx++)
          if (left[indx] <= right[indx])
             {
              DrawLineInBuf(_2d->buf,0,0,_2d->dimx - 1,
                     _2d->dimy - 1,_2d->pixel_depth,
                    (long) left[row],row,(long) left[indx],indx,1,NULL,
                    &total_pts_drawn,0);
              DrawLineInBuf(_2d->buf,0,0,_2d->dimx - 1,
                    _2d->dimy - 1,_2d->pixel_depth,
                    (long) right[row],row,(long) right[indx],indx,1,NULL,
                    &total_pts_drawn,0);
             }
         
    }
 for (row = the_top; row <= the_bottom; row++)
    if ((Get1dBitMapFirstNon0Posi(_2d->buf[row],_2d->dimx,
             _2d->pixel_depth,&first) == NO_ERROR) &&
         (Get1dBitMapLastNon0Posi(_2d->buf[row],_2d->dimx,
              _2d->pixel_depth,&last) == NO_ERROR))
       {
        for (col = first; col <= last; col++)
           {if (top[col] > row) top[col] = row;
            if (bottom[col] < row) bottom[col] = row;
           }
       }
 for (col = the_first; col <= the_last; col++)
    for (row = top[col]; row <= bottom[col]; row++)
       _2d->SetVal(_2d,row,col,(double) value);
 c_free(top);
 return NO_ERROR;
}

