/****************************************************************************
roi_menu.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: roi_menu.c,v 1.15 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/textsw.h>
#include <xview/notify.h>

#include "mri_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)
#define PRT6(x)
#define PRT(x)



/* Local structures */
struct clipboard_inter_rec
   {
    int selected,option;
    struct image_display_window *win;
   };


/* Functions defined in this file */
int win_enable_pen_draw_mode(struct image_display_window *win);
void activate_pen_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
Menu setup_pen_type_menu(void);
void pen_type_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int pen_type);
Menu gen_pen_type_proc(Menu menu, Menu_generate operation);
Menu get_roi_menu(struct display_win_rec *win);
void show_roi_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void show_the_menu(struct show_menu_rec *show_menu, int which);
void show_file_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void break_the_region(struct image_display_window *win);
void breaker_it_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int option);
void breaker_options_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
Menu setup_breaker_menu(void);
Menu setup_clipboard_menu(void);
int clipboard_opr(struct clipboard_inter_rec *inter);
void clipboard_action(struct clipboard_inter_rec *inter,
    struct user_menu_rec *user);
void clipboard_it_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int option);
void clipboard_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int option);
Menu gen_clipboard_proc(Menu menu, Menu_generate operation);
void label_roi_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
void show_roi_proc(Menu menu, Menu_item item);
Menu gen_show_roi_proc1(Menu main_menu, Menu_generate operation);
void show_roi_action_proc(struct display_win_rec *win, char *roi_label);
void show_histo_roi_action_proc(struct display_win_rec *win, char *roi_label);
int explain_histogram_rois(struct image_display_window *win,
    struct strs_rec *roi_labels, struct strs_rec *explain);
void key_activated_show_roi_proc(Menu menu, Menu_item item,
    struct display_win_rec *win, Xv_Window window, Event *last_event);
void show_pixel_type_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void highlight_next_curve_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int is_backward);
void highlight_next_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int is_backward);
void edit_next_empty_curve_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void edit_scratch_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
void all_wins_cur_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void slice_rect_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
int delete_curve_mode(Menu menu, Menu_item item, struct display_win_rec *win1,
    Xv_Window canvas_win, Event *event);
void delete_roi_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int arg_value);
Menu setup_delete_roi_menu(void);
void dp_delete_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void more_roi_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int display_option);
void dp_more_rois_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
Menu setup_more_roi_menu(void);
Menu gen_more_roi_proc(Menu menu, Menu_generate operation);
Menu setup_trans_roi_menu(void);
void trans_roi_mode_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
void dp_trans_roi_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int option);
int trans_roi_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
void dp_draw_list_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int option);
void draw_link_with_wid_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int is_delete);
void reverse_slice_rois_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void import_slice_rois_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void delete_the_grown_roi_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);



/*------------------------------------------------------------------------
win_enable_pen_draw_mode - ???
------------------------------------------------------------------------*/

int
win_enable_pen_draw_mode(win)
 struct image_display_window *win;
{
 clear_max_input_curve_pts(&(win->control));
 clear_allowable_pen_types(&(win->control));
 set_proc_upon_input_done(&(win->control),NULL,NULL);
 win->control.status |= DRAW_ENABLED;
 win->control.status &= ~_3D_DRAW_MODE;
 win_select_cursor(win,CURSOR_PEN);
 return NO_ERROR;
}



/*------------------------------------------------------------------------
activate_pen_proc - ???
------------------------------------------------------------------------*/

void
activate_pen_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {
     root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 if (!(win->type2 & EDITING_WINDOW)) return;
 if (win->type2 & DISPLAY_WINDOW_3D) 
    {win_select_cursor(win,CURSOR_CUT);
     return;}
 if (win->control.status & DRAW_ENABLED)
    {win_select_cursor(win,CURSOR_DEFAULT);
     win->control.status &= ~DRAW_ENABLED;
     return;
    }
   else
    {win_select_cursor(win,CURSOR_PEN);
    }
}


/*------------------------------------------------------------------------
setup_pen_type_menu - ???
------------------------------------------------------------------------*/

Menu 
setup_pen_type_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                MENU_RELEASE,
                MENU_TITLE_ITEM,"PEN TYPE",
                MENU_STRING_ITEM,PEN_FREE_AND_CLOSED,
                           (int) DRAW_FREE_CLOSED,
                MENU_STRING_ITEM,PEN_POLYGON,
                           (int) DRAW_POLYGON,
                MENU_STRING_ITEM,PEN_FREE,
                           (int) DRAW_FREE,
                MENU_STRING_ITEM,PEN_LINE,
                           (int) DRAW_LINE,
                MENU_STRING_ITEM,PEN_POINT_MODE,
                           (int) DRAW_POINT,
                MENU_STRING_ITEM,PEN_CIRCLE,
                           (int) DRAW_CIRCLE,
                MENU_STRING_ITEM,PEN_ELLIPSE,
                           (int) DRAW_CIRCLE,
                MENU_STRING_ITEM,PEN_RECT,
                           (int) DRAW_RECT,
                0);
 return menu;
}


/*----------------------------------------------------------------------
pen_type_proc - ???

NOTE:  The pre-19990225 version of this function returned int but was used
only in contexts that insist on void.  Changed the type to void.  -PWH
------------------------------------------------------------------------*/

void
pen_type_proc(menu,item,arg,window,last_event,pen_type)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int pen_type;
{
 int value;
 struct display_win_rec *win1;
 struct image_display_window *win;
 int is_clear,err,in;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     value = pen_type;}
   else
    {
     root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     value = (int) xv_get(item,MENU_VALUE);}
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;

 if (win->control.display_options & DISPLAY_BREAKER) return;
 if (win->control.display_options & SET_ALLOWABLE_PEN_TYPE)
    {if (!(win->control.allowable_pen_type & value))
        {notice_prompt(win->dwin->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,"CHANGE OF PEN TYPE NOT ALLOWED !!!",0,
            NOTICE_BUTTON_YES," OK !",
            0);
         return;}
    }
 is_clear = 1;
 if (!(value & DRAW_MODE)) return;
 in = 0;
 if (!(win->control.status & DRAW_ENABLED))
    {win->control.status |= DRAW_ENABLED;
     win_execute_proc_to_multiple_wins(win,win_set_def_cursor,0,0,0,0,0);
     set_cur_pen(&(win->control.sroi.sroi_win->slice_roi),
                   win->control.pen_type,1);
/*
     win_set_pt_status(win);
     win_execute_proc_to_multiple_wins(win,win_draw_enabled_label,&is_clear);
*/
    }
 if (win->control.pen_type != value)
    {
     if ((err = win_change_cur_curve_pen(win,(unsigned short) value)) != NO_ERROR)
        return;
    }
 win_execute_proc_to_related_wins(win,win_set_control_pen_type,1,0);
}


/*------------------------------------------------------------------------
gen_pen_type_proc - ???
------------------------------------------------------------------------*/

Menu 
gen_pen_type_proc(menu,operation)
 Menu menu;
 Menu_generate operation;
{
 Menu_item item;
 Menu pen_type_menu,root;
 struct display_win_rec *win1;
 struct image_display_window *win;
 Event *last_event;
 Xv_Window window;

 PRT2(printf("gen_pen_type_proc in...menu = %u\n",menu))
 
 switch (operation)
    {
     case MENU_DISPLAY : 
        root = (Menu) root_menu(menu);
        PRT2(printf("MENU_DISPLAY in...root = %u\n",root))
        if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
           {window = (Xv_Window) event_window(last_event);
            win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
           }
          else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
        PRT2(printf("MENU_DISPLAY in...last_event = %u win1 = %u\n",last_event,
   win1))
        if (win1 == NULL) return menu;
        win = win1->owner;

        pen_type_menu = setup_pen_type_menu();
        PRT2(printf("MENU_DISPLAY in...pen_type_menu = %u win = %u\n",pen_type_menu,win))

        xv_set(pen_type_menu,
                 MENU_NOTIFY_PROC,pen_type_proc,0);

        xv_set(menu,MENU_PULLRIGHT,pen_type_menu,0);
        if (win->control.status & DRAW_ENABLED)
           xv_set(menu,MENU_STRING,PEN_ENABLED,0);
          else  xv_set(menu,MENU_STRING,PEN_DISABLED,0);

        for (;(item = menu_find(pen_type_menu,MENU_INVERT,TRUE,0))!= 0;)
           xv_set(item,MENU_INVERT,FALSE,0);

        item = menu_find(pen_type_menu,MENU_VALUE,(int) 
                         win->control.pen_type,0);

        if (item != 0) xv_set(item,MENU_SELECTED,TRUE,MENU_INVERT,TRUE,0);
    }
 return menu;
}


/*------------------------------------------------------------------------
get_roi_menu - ???
------------------------------------------------------------------------*/

Menu 
get_roi_menu(win)
 struct display_win_rec *win;
{
 Menu menu1;

 PRT3(printf("get_roi_menu...1"))
 if ((menu1 = setup_roi_menu()) != 0)
    {TRACE(printf("get_roi_menu...menu = %u\n",menu1))
     xv_set(menu1,MENU_CLIENT_DATA,win,0);
    }
 PRT3(printf("get_roi_menu...end...menu1 = %u\n",menu1))
 return menu1;
}



/*------------------------------------------------------------------------
show_roi_menu_proc - ???
------------------------------------------------------------------------*/

void
show_roi_menu_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 PRT5(printf("show_roi_menu_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
 PRT3(printf("show_roi_menu_proc...1\n"))
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        {win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
         window = win1->panel;}
    }
 win = win1->owner;
 win->dwin = win1;
 PRT3(printf("show_roi_menu_proc...2\n"))
 if ((root = get_roi_menu(win1)) != 0)
    menu_show(root,window,last_event,0);
 PRT3(printf("show_roi_menu_proc...3\n"))
}


/*------------------------------------------------------------------------
show_the_menu - ???
------------------------------------------------------------------------*/

void
show_the_menu(show_menu,which)
 struct show_menu_rec *show_menu;
 int which;
{

 (void) notify_set_itimer_func((Notify_client) show_menu,
           NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 menu_show(show_menu->menu,show_menu->window,
           &(show_menu->event),0);
}


/*------------------------------------------------------------------------
show_file_menu_proc - ???
------------------------------------------------------------------------*/

void
show_file_menu_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 static struct show_menu_rec show_menu;
 Menu root;

 PRT5(printf("show_file_menu_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        {win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
         window = win1->panel;}
    }
 win = win1->owner;
 win->dwin = win1;
 show_menu.win = win1;
 show_menu.menu = win1->menu;
 show_menu.window = window;
 show_menu.event = *last_event;
 (void) notify_set_itimer_func((Notify_client) &show_menu,
             (Notify_func) show_the_menu,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);

}


/*------------------------------------------------------------------------
break_the_region - ???
------------------------------------------------------------------------*/

void
break_the_region(win)
 struct image_display_window *win;
{
 set_win_busy(win);
 if (win_is_cur_curve_non_empty(win))
    ShowMsgStrs(win->dwin->frame,1,NO_ERROR,0,2,
               "Breaking the current region...",
               PLEASE_WAIT,win_break_cur_curve,1,win);
   else
    ShowMsgStrs(win->dwin->frame,0,NO_ERROR,0,2,
               "The current region must be selected first",
               "   for the breaker to work !!!",NULL,0);
 set_win_not_busy(win);
}



/*------------------------------------------------------------------------
breaker_it_proc - ???
------------------------------------------------------------------------*/

void
breaker_it_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 int value;
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     value = option;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     value = (int) xv_get(item,MENU_VALUE);}
     
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;
 TRACE(printf("breaker_it_proc...\n"))
 if (value == VALUE_BREAKER_ENABLE)
    {if (win->control.display_options & DISPLAY_BREAKER)
        win_execute_proc_to_related_wins(win,win_hide_breaker,0,0);
    else win_execute_proc_to_related_wins(win,win_show_breaker,0,0);
     win_set_pt_status(win);
     win_execute_proc_to_related_wins(win,WinMultiCanvas,0,0);}
   else if (value == VALUE_BREAK_IT)
    {break_the_region(win);
    }
   else if (value == VALUE_BREAK_UNDO) win_break_undo_cur_curve(win);

}



/*------------------------------------------------------------------------
breaker_options_proc - ???
------------------------------------------------------------------------*/

void
breaker_options_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
     
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;
 enter_dp_breaker_options(win,1);
}


/*------------------------------------------------------------------------
setup_breaker_menu - ???
------------------------------------------------------------------------*/

Menu 
setup_breaker_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                       MENU_NOTIFY_PROC,breaker_it_proc,
                       MENU_STRING_ITEM,BREAKER_ENABLE,
                           (int) VALUE_BREAKER_ENABLE,
                       MENU_STRING_ITEM,BREAK_IT,
                           (int) VALUE_BREAK_IT,
                       MENU_STRING_ITEM,BREAK_UNDO,
                           (int) VALUE_BREAK_UNDO,
                       0);
 return menu;
}


/*------------------------------------------------------------------------
setup_clipboard_menu - ???
------------------------------------------------------------------------*/

Menu 
setup_clipboard_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                       MENU_STRING_ITEM,CUT,
                           (int) VALUE_CUT,
                       MENU_STRING_ITEM,CUT_APPEND,
                           (int) VALUE_CUT_APPEND,
                       MENU_STRING_ITEM,PASTE,
                           (int) VALUE_PASTE,
                       MENU_STRING_ITEM,PASTE_ALL,
                           (int) VALUE_PASTE_ALL,
                       MENU_STRING_ITEM,COPY,
                           (int) VALUE_COPY,
                       MENU_STRING_ITEM,COPY_APPEND,
                           (int) VALUE_COPY_APPEND,
                       MENU_STRING_ITEM,CLIPBOARD_FIRST,
                           (int) VALUE_CLIPBOARD_FIRST,
                       0);
 return menu;
}


/*------------------------------------------------------------------------
clipboard_opr - ???
------------------------------------------------------------------------*/

int
clipboard_opr(inter)
 struct clipboard_inter_rec *inter;
{
 int err;
 struct slice_roi_rec *slice_roi;

 TRACE(printf("clipboard_opr...\n"))
 switch (inter->option)
    {case VALUE_CUT :
     case VALUE_CUT_APPEND :
     if (inter->win->control.display_options & DISPLAY_BREAKER)
        {slice_roi = win_rec_get_breaker(inter->win->owner);
         if (!is_slice_roi_non_empty(slice_roi))
            {ShowMsgStrs(inter->win->dwin->frame,0,NO_ERROR,0,3,
                "The Breaker is empty...nothing to cut !!",
                "If you are not cutting from the Breaker,",
                "please disable the Breaker first !!!",NULL,0);
             return NO_ERROR;}
         }
     if (inter->option == VALUE_CUT)
        err = win_clipboard(inter->win,0,inter->selected,VALUE_CUT);
       else
        {TRACE(printf("VALUE_CUT_APPEND...\n"))
         err = win_clipboard(inter->win,1,inter->selected,VALUE_CUT);}
        break;
     case VALUE_COPY :
        err = win_clipboard(inter->win,0,inter->selected,VALUE_COPY);
        break;
     case VALUE_COPY_APPEND :
        err = win_clipboard(inter->win,1,inter->selected,VALUE_COPY);       
        break;
     case VALUE_PASTE :
        err = win_clipboard(inter->win,0,1,VALUE_PASTE);       
        break;
     case VALUE_PASTE_ALL :
        err = win_clipboard(inter->win,0,3,VALUE_PASTE);       
        break;
     case VALUE_CLIPBOARD_FIRST :
        if (inter->win->control.display_options & DISPLAY_CLIPBOARD_FIRST)
           inter->win->control.display_options &= ~DISPLAY_CLIPBOARD_FIRST;
          else inter->win->control.display_options |= DISPLAY_CLIPBOARD_FIRST;
        if (inter->win->control.display_options & DISPLAY_CLIPBOARD)
           win_display_masks_to_multiple_wins(inter->win);
        return NO_ERROR;
    }
 return err;
}


/*------------------------------------------------------------------------
clipboard_action - ???
------------------------------------------------------------------------*/

void
clipboard_action(inter,user)
 struct clipboard_inter_rec *inter;
 struct user_menu_rec *user;
{
 inter->selected = user->strs_rec_ptr->cur_str + 1;
 switch (inter->option)
    {case VALUE_CUT_OPTION :
        inter->option = VALUE_CUT;
        break;
     case VALUE_CUT_APPEND_OPTION :
        inter->option = VALUE_CUT_APPEND;
        break;
     case VALUE_COPY_OPTION :
        inter->option = VALUE_COPY;
        break;
     case VALUE_COPY_APPEND_OPTION :
        inter->option = VALUE_COPY_APPEND;
        break;
    }
 clipboard_opr(inter);
}


/*-----------------------------------------------------------------------
clipboard_it_proc - ???

NOTE:  The pre-19990225 version of this function returned int but is used
only in contexts that require void.  Changed the type to void.  -PWH
------------------------------------------------------------------------*/

void
clipboard_it_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 struct strs_rec *ptr;
 static struct clipboard_inter_rec inter;
 int err;
 Menu root;
 char *title;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        {win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
         window = win1->panel;}

     option = (int) xv_get(item,MENU_VALUE);}
     
 TRACE(printf("clipboard_it_proc...111\n"))
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;
 if ((err = win_setup_clipboard(win)) != NO_ERROR) return;
 TRACE(printf("clipboard_it_proc...111\n"))

 inter.option = option;
 inter.win = win;
 set_win_busy(win);
 title = NULL;
 switch (option)
    {case VALUE_CUT_OPTION : title = "CUT";
     case VALUE_CUT_APPEND_OPTION : if (title == NULL) title = "CUT APPEND";
     case VALUE_COPY_OPTION : if (title == NULL) title = "COPY";
     case VALUE_COPY_APPEND_OPTION : if (title == NULL) title = "COPY APPEND";
        if ((err = setup_strs_rec(&ptr,0,0)) != NO_ERROR) return;

        if ((option == VALUE_CUT_APPEND_OPTION) ||
            (option == VALUE_COPY_APPEND_OPTION))
           {if ((err = build_strs_rec(ptr,(unsigned int) 0,3,
              "APPEND CURRENT REGION","APPEND CURRENT ROI",
                      "APPEND ALL ROIS")) 
                 != NO_ERROR)
              {free_strs_rec(ptr);
               c_free(ptr);
              return;}
           }
          else
           if ((err = build_strs_rec(ptr,(unsigned int) 0,3,
                 "CURRENT REGION","CURRENT ROI","ALL ROIS")) != NO_ERROR)
              {free_strs_rec(ptr);
               c_free(ptr);
               return;}

        ShowMenuStrsProc(window,last_event,title,ptr,
              USER_MENU_FREE_STRS_AND_PTR,clipboard_action,&inter,0,0,0);
        break;
     default :
        inter.selected = 1;
        clipboard_opr(&inter);
    };
 set_win_not_busy(win);
}



/*------------------------------------------------------------------------
clipboard_proc - ???
------------------------------------------------------------------------*/

void
clipboard_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
     
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;

 if (win->control.display_options & DISPLAY_CLIPBOARD)
     {win_hide_clipboard(win);
      win->control.display_options &= ~DISPLAY_CLIPBOARD;}
   else
    {win->control.display_options |= DISPLAY_CLIPBOARD;
     win_show_clipboard(win);}
}


/*------------------------------------------------------------------------
gen_clipboard_proc - ???
------------------------------------------------------------------------*/

Menu
gen_clipboard_proc(menu,operation)
 Menu menu;
 Menu_generate operation;
{
 Menu menu2,root;
 Menu_item item;
 struct display_win_rec *win1;
 struct image_display_window *win;
 Event *last_event;
 Xv_Window window;

 TRACE(printf("gen_clipboard_proc in...\n"))
 switch (operation)
    {
     case MENU_DISPLAY : 
        root = (Menu) root_menu(menu);
        if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
           {window = (Xv_Window) event_window(last_event);
            win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
           }
          else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
        win = win1->owner;
        menu2 = setup_clipboard_menu();
        menu_set(menu2,
                 MENU_NOTIFY_PROC,clipboard_it_proc,0);
        if ((item = menu_find(menu2,
               MENU_VALUE,(int) VALUE_CLIPBOARD_FIRST,0)) != 0)
           if (win->control.display_options & DISPLAY_CLIPBOARD_FIRST)
              menu_set(item,MENU_STRING,CLIPBOARD_LAST,0);
             else menu_set(item,MENU_STRING,CLIPBOARD_FIRST,0);

        menu_set(menu,MENU_PULLRIGHT,menu2,0);
    }
 return menu;
}



/*------------------------------------------------------------------------
label_roi_proc - ???
------------------------------------------------------------------------*/

void
label_roi_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 setup_label_roi(win,win1->frame,NULL,NULL,NULL,NULL,NULL,0);
}


/*------------------------------------------------------------------------
show_roi_proc - ???
------------------------------------------------------------------------*/

void
show_roi_proc(menu,item)
 Menu menu;
 Menu_item item;
{
 char *str;
 int value;
 struct display_win_rec *win1;
 struct image_display_window *win;
 Event *last_event;
 Xv_Window window;
 Menu root;

 TRACE(printf("show_roi_proc menu = %u\n",menu))
 root = (Menu) root_menu(menu);
 if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
    {window = (Xv_Window) event_window(last_event);
     win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
    }
   else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
 TRACE(printf("show_roi_proc win1 = %u\n",win1))
 win = win1->owner;
 win->dwin = win1;

 if (!win_is_slice_roi_non_empty(win)) return;
 str = (char *) xv_get(item,MENU_STRING);
 value = (int) xv_get(item,MENU_VALUE);
 TRACE(printf("**********...%s  value = %d\n",str,value))
 win_highlight_roi_cur(win,str);
}


/*------------------------------------------------------------------------
gen_show_roi_proc1 - ???
------------------------------------------------------------------------*/

Menu 
gen_show_roi_proc1(main_menu,operation)
 Menu main_menu;
 Menu_generate operation;
{
 struct strs_rec roi_labels,explain;
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu menu,root;
 int err,is_inc_empty_roi;
 Event *last_event;
 Xv_Window window;

 TRACE(printf("gen_show_roi_proc1...\n"))
 root = (Menu) root_menu(main_menu);
 if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
    {window = (Xv_Window) event_window(last_event);
     win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
    }
   else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
 TRACE(printf("gen_show_roi_proc...win1 = %u main_menu = %u\n",win1,main_menu))

 win = win1->owner;
 win->dwin = win1;

 switch (operation)
    {
     case MENU_DISPLAY : 
     case MENU_NOTIFY :
        TRACE(printf("gen_show_roi_proc...2\n"))
        menu = (Menu) xv_get(main_menu,MENU_PULLRIGHT);
        if (menu != 0)
           {if (operation == MENU_NOTIFY) break;
            xv_destroy_safe(menu);
            menu = 0; }
        if (win->type2 & DISPLAY_WINDOW_3D) is_inc_empty_roi = 1;
          else is_inc_empty_roi = 0;
        init_strs_rec(&roi_labels);
        WinGetRoiLabelPtrs(win,&roi_labels,is_inc_empty_roi,1);
        if (roi_labels.num_strs > 0)
           {
            if ((win->type2 & HISTOGRAM_WINDOW) &&
                !(win->type2 & HISTOGRAM_1D_WINDOW_DISPLAY_ONLY))
               {init_strs_rec(&explain);
                if ((err = explain_histogram_rois(win,
                      &roi_labels,&explain)) != NO_ERROR)
                    {
                     SetupTheMenu(&menu,NULL,1,win1->frame,
                               &roi_labels,show_roi_proc,0);
                    }
                  else
                   {
                    SetupTheMenu(&menu,NULL,1,win1->frame,&explain,show_roi_proc,0);
                   }
                free_strs_rec(&explain);
               }
              else SetupTheMenu(&menu,NULL,1,win1->frame,&roi_labels,show_roi_proc,0);
           }
          else menu = (Menu) xv_create(0,MENU,0);
        if (menu != 0)
           {if (xv_get(menu,MENU_NITEMS) == 0)
               xv_set(menu,MENU_ITEM,MENU_STRING,
                        NO_ROI_STR,0,0);
            xv_set(main_menu,MENU_PULLRIGHT,menu,0);}

        free_strs_rec_ptrs(&roi_labels);

        break;
     case MENU_DISPLAY_DONE :
          break;
/*
     case MENU_NOTIFY :
        TRACE(printf("gen_show_roi_proc...3\n"))
       menu = (Menu) xv_get(main_menu,MENU_PULLRIGHT);
       if (menu == NULL) menu = (Menu) xv_create(NULL,MENU,0);
       if ((menu != NULL) && ((Menu_item) xv_get(menu,MENU_NITEMS) == 0))
          {xv_set(menu,MENU_ITEM,MENU_STRING,NO_ROI_STR,0,0);
           xv_set(main_menu,MENU_PULLRIGHT,menu,0);}
        break;
*/
     case MENU_NOTIFY_DONE :
        break;
    }
 TRACE(printf("gen_show_roi_proc...4\n"))

 return main_menu;
}


/*------------------------------------------------------------------------
show_roi_action_proc - ???
------------------------------------------------------------------------*/

void
show_roi_action_proc(win,roi_label)
 struct display_win_rec *win;
 char *roi_label;
{
 TRACE(printf("show_roi_action_proc...\n"))
 if (roi_label != NULL)
    {win_set_roi_visibility(win->owner,roi_label,ROI_VISIBLE);
     WinNextCurRoi(win->owner,roi_label);
     if (win->owner->type2 & DISPLAY_WINDOW_3D)
        _3d_after_next_roi_proc(win->owner);
    }
}


/*------------------------------------------------------------------------
show_histo_roi_action_proc - ???
------------------------------------------------------------------------*/

void
show_histo_roi_action_proc(win,roi_label)
 struct display_win_rec *win;
 char *roi_label;
{
 char *str1;
 int err;
 long indx,start_indx;

 TRACE(printf("show_histo_roi_action_proc...\n"))
 if (roi_label != NULL)
    {
     if ((err = cp_str(&str1,roi_label)) == NO_ERROR)
        {for (indx = 0;;indx = start_indx + 3)
            if (find_sub_str(&(str1[indx])," : ",&start_indx) != NO_ERROR)
               break;
         TRACE(printf("show_histo_roi_action_proc === str1 = %s\n",str1))

         if (indx != 0)
            {indx -= 3;
             str1[indx] = '\0';}
         TRACE(printf("show_histo_roi_action_proc str1 = %s\n",str1))

         win_set_roi_visibility(win->owner,str1,ROI_VISIBLE);
         WinNextCurRoi(win->owner,str1);
         c_free(str1);
         if (win->owner->type2 & DISPLAY_WINDOW_3D)
            _3d_after_next_roi_proc(win->owner);
        }
    }
}


/*------------------------------------------------------------------------
explain_histogram_rois - ???
------------------------------------------------------------------------*/

int
explain_histogram_rois(win,roi_labels,explain)
 struct image_display_window *win;
 struct strs_rec *roi_labels,*explain;
{
 struct roi_rec *roi;
 struct slice_roi_rec *slice_roi;
 unsigned long lcv;
 char *str,*str1;
 int err;

 slice_roi = &(win->control.sroi.sroi_win->slice_roi);
 for (lcv = 0; lcv < roi_labels->num_strs; lcv++)
    {if ((roi = get_roi(slice_roi,roi_labels->strs[lcv])) != NULL)
        {
         str1 = NULL;
         if (is_roi_non_empty(roi))
            {if (roi->status & HISTO_EDITED_ROI)
                {str1 = EDITED;}
               else if (roi->status & HISTO_SEGMENTED_ROI)
                str1 = SEGMENTED;
               else if (roi->status & ROI_MARKER)
                str1 = MARKER;
               else str1 = PARTITIONED;
             if ((err = concat_strs(&str,2,roi_labels->strs[lcv],
                        str1)) != NO_ERROR)
                return err;
            }
           else
            if ((err = concat_strs(&str,2,roi_labels->strs[lcv],
                            EMPTY)) != NO_ERROR)
                return err;

         if ((err = add_str_ptr_to_strs_rec(explain,str)) != NO_ERROR)
            {c_free(str);
             return err;
            }
        }
    }
 if (explain->num_strs > 1) sort_strs_rec_ascendingly(explain);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
key_activated_show_roi_proc - ???

NOTE:  The pre-19990225 version of this function returned int but was
used only in contexts that required void.  Changed the type to void. -PWH
-------------------------------------------------------------------------*/

void
key_activated_show_roi_proc(menu,item,win,window,last_event)
 Menu menu;
 Menu_item item;
 struct display_win_rec *win;
 Xv_Window window;
 Event *last_event;
{
 struct strs_rec *roi_labels;
 struct strs_rec explain;
 int err;
 static char *title = "ROIS DEFINED";
 int is_inc_empty_roi;

 TRACE(printf("key_activated_show_roi_proc...win = %u\n",win))
 if ((err = setup_strs_rec(&roi_labels,0,0)) != NO_ERROR) return;
 if (win->owner->type2 & DISPLAY_WINDOW_3D) is_inc_empty_roi = 1;
   else is_inc_empty_roi = 0;
 WinGetRoiLabelPtrs(win->owner,roi_labels,is_inc_empty_roi,1);
 win->owner->dwin = win;
 TRACE(printf("key_activated_show_roi_proc...\n"))
 TRACE(pr_strs_rec(roi_labels))
 if (roi_labels->num_strs == 0)
    {
     add_str_ptr_to_strs_rec(roi_labels,NO_ROI_STR);
     ShowMenuStrsProc(window,last_event,title,roi_labels,
            USER_MENU_FREE_STR_PTRS_AND_PTR,show_roi_action_proc,win,1,0,0);}
   else if ((win->owner->type2 & HISTOGRAM_WINDOW) &&
            !(win->owner->type2 & HISTOGRAM_1D_WINDOW_DISPLAY_ONLY))
    {init_strs_rec(&explain);
     if ((err = explain_histogram_rois(win->owner,roi_labels,&explain))
            != NO_ERROR)
        {free_strs_rec(&explain);
         ShowMenuStrsProc(window,last_event,title,roi_labels,
			  USER_MENU_FREE_STR_PTRS_AND_PTR,
			  show_histo_roi_action_proc,
			  win,1,0,0);
        }
       else
        {
         TRACE(pr_strs_rec(&explain))
         free_strs_rec_ptrs(roi_labels);
         *roi_labels = explain;
         ShowMenuStrsProc(window,last_event,title,roi_labels,
			  USER_MENU_FREE_STRS_AND_PTR,
			  show_histo_roi_action_proc,win,1,0,0);
        }
    }
   else
    {
     ShowMenuStrsProc(window,last_event,title,roi_labels,
		      USER_MENU_FREE_STR_PTRS_AND_PTR,
		      show_roi_action_proc,win,1,0,0);}
}



/*-------------------------------------------------------------------------
show_pixel_type_roi_proc - ???

NOTE:  The pre-19990225 version of this function returned int but was
used only in contexts that required void.  Changed the type to void. -PWH
--------------------------------------------------------------------------*/

void
show_pixel_type_roi_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 struct strs_rec *roi_labels;
 Menu root;
 int err;

 TRACE(printf("show_pixel_type_roi_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 TRACE(printf("show_pixel_type_roi_proc...win = %u\n",win))
 win->dwin = win1;
 if ((err = setup_strs_rec(&roi_labels,0,0)) != NO_ERROR) return;
 TRACE(printf("show_pixel_type_roi_proc...1\n"))

 if ((err = win_get_all_pixel_type_ptrs(win,roi_labels)) != NO_ERROR)
    {free_strs_rec_ptrs(roi_labels);
     c_free(roi_labels);
     return;}
 TRACE(printf("show_pixel_type_roi_proc...roi_labels->num_strs = %d\n",
           roi_labels->num_strs))

 if (roi_labels->num_strs == 0)
    add_str_ptr_to_strs_rec(roi_labels,NO_PIXEL_TYPE_STR);
 TRACE(printf("show_pixel_type_roi_proc...2\n"))
 ShowMenuStrsProc(window,last_event,TISSUE_TYPES_DEFINED,roi_labels,
		  USER_MENU_FREE_STR_PTRS_AND_PTR,
		  show_roi_action_proc,win1,1,0,0);
}



/*------------------------------------------------------------------------
highlight_next_curve_proc - ???
------------------------------------------------------------------------*/

void
highlight_next_curve_proc(menu,item,arg,window,last_event,is_backward)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int is_backward;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 if (win->control.display_options & DISPLAY_BREAKER) return;
 if ((last_event != NULL) && event_shift_is_down(last_event))
    is_backward = 1;
 if (win_is_non_empty_roi(win,NULL))
    {
     if (win_make_next_curve_cur(win,is_backward) != NO_ERROR) return;
     win_set_pt_status(win);
     win_execute_proc_to_related_wins(win,win_set_control_pen_type,1,0);
    }
}



/*------------------------------------------------------------------------
highlight_next_roi_proc - ???
------------------------------------------------------------------------*/

void
highlight_next_roi_proc(menu,item,arg,window,last_event,is_backward)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int is_backward;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 if (win->control.display_options & DISPLAY_BREAKER) return;
 if ((last_event != NULL) && event_shift_is_down(last_event))
    is_backward = 1;
 if (win_next_defined_roi(win,is_backward) == NO_ERROR)
    {
     win_execute_proc_to_related_wins(win,win_set_control_pen_type,1,0);
     if (win->type2 & DISPLAY_WINDOW_3D)
        _3d_after_next_roi_proc(win);
    }

}



/*------------------------------------------------------------------------
edit_next_empty_curve_proc - ???
------------------------------------------------------------------------*/

void
edit_next_empty_curve_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 if (win->control.display_options & DISPLAY_BREAKER) return;
 if (win_is_non_empty_roi(win,NULL))
    {win_next_curve(win);
    }

}



/*------------------------------------------------------------------------
edit_scratch_proc - ???
------------------------------------------------------------------------*/

void
edit_scratch_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;
 unsigned long mode;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 if (win->control.proc_upon_input_done != NULL)
    {mode = 0;
     if (last_event != NULL)
        {if (event_ctrl_is_down(last_event)) mode = CTRL_COMMAND_KEY;
        }
     win->control.proc_upon_input_done(win->control.proc_arg,mode);}
   else
    {if (win->control.display_options & DISPLAY_BREAKER)
        break_the_region(win);
       else
        WinMakeCurRoi(win,SCRATCH_STR);}

}



/*------------------------------------------------------------------------
all_wins_cur_roi_proc - ???
------------------------------------------------------------------------*/

void
all_wins_cur_roi_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 win_highlight_roi_in_all_wins(win,3);
}



/*-------------------------------------------------------------------------
show_pixel_type_roi_proc - ???

NOTE:  The pre-19990225 version of this function returned int but was
used only in contexts that required void.  Changed the type to void. -PWH
--------------------------------------------------------------------------*/

void
slice_rect_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 win_slice_rect_roi(win);
 return;
}



/*------------------------------------------------------------------------
delete_curve_mode - ???
------------------------------------------------------------------------*/

int
delete_curve_mode( menu, item, win1, canvas_win, event )
     Menu menu;
     Menu_item item;
     struct display_win_rec *win1;
     Xv_Window canvas_win;
     Event *event;
{
  struct image_display_window *win;
  int err, use_this_xybound;
  struct int_bound_rec xybound;	/* Bug fix: this was a *xybound, but no
				   space was created to hold information.
				   DRW 970309
				   */
  long x,y;

  win = win1->owner;
  win->dwin = win1;

  /*   printf("win p 1: %p\n", win); */
  if ((err = win_get_cursor_xy_and_bound( win, event,
					  &x, &y,
					  &use_this_xybound,
					  &xybound ))
      != NO_ERROR)
    return err;
  /* printf("win p 2: %p\n", win); */

  TRACE(printf("delete_curve_mode...\n"));
  if (win_find_enclosing_curve( win, x, y, use_this_xybound, &xybound ))
  {
    TRACE(printf("win_find_enclosing_curve...in\n"));
    win_delete_cur_roi_curve(win);
  }
  else
  {
    xv_set( win1->frame,
	    WIN_ALARM,
	    NULL );
  }

  win_display_row_col(win,x,y,1,1);
  return NO_ERROR;
}



/*------------------------------------------------------------------------
delete_roi_proc - ???
------------------------------------------------------------------------*/

void
delete_roi_proc( menu, item, arg, window, last_event, arg_value )
     Menu menu;
     Menu_item item;
     void *arg;
     Xv_Window window;
     Event *last_event;
     int arg_value;
{
  int value;
  struct display_win_rec *win1;
  struct image_display_window *win;
  Menu root;

  if (menu == 0)
  {
    win1 = (struct display_win_rec *) arg;
    value = arg_value;
  }
  else
  {
    root = (Menu) root_menu(menu);
    if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
    {
      window = (Xv_Window) event_window(last_event);
      win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
    }
    else
    {
      win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
      window = win1->panel;
    }
    value = (int) xv_get(item,MENU_VALUE);
  }
  win = win1->owner;
  win->dwin = win1;

  TRACE(printf("delete_roi_proc\n"));
  switch (value)
  {
  case DELETE_CUR_PT :
    WinEraseAndDisplayPts(win,0,0,1);
    /*win_delete_cur_roi_pt(win);*/
    break;
  case DELETE_CUR_CURVE :
    win_delete_cur_roi_curve(win);
    break;
  case DELETE_CUR_ROI :
    win_delete_cur_roi(win);
    break;
  case DELETE_EVERY_ROI :
    win_delete_all_rois(win,value);
    break;
  case DELETE_ALL_FILE_ROIS :
    if (win->type2 & DISPLAY_WINDOW)
      value = notice_prompt(win->dwin->frame,(Event *) NULL,
			    NOTICE_MESSAGE_STRINGS,
			    "DELETE ALL ROIS FOR ALL SLICES ?",0,
			    NOTICE_BUTTON_YES,YES,
			    NOTICE_BUTTON_NO,NO,
			    0);
    else
      value = NOTICE_YES;
    if (value == NOTICE_YES)
      win_delete_all_file_rois(win);
    break;
  case DELETE_CURVE_MODE :
    win_select_cursor(win1->owner,CURSOR_DELETE_ROI);
    break;
  }
}



/*------------------------------------------------------------------------
setup_delete_roi_menu - ???
------------------------------------------------------------------------*/

Menu
setup_delete_roi_menu()
{
  static Menu menu = 0;

  if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create( 0, MENU,

			     MENU_NOTIFY_PROC,delete_roi_proc,

			     MENU_STRING_ITEM,DELETE_CURRENT_POINT_STR,
			     (int) DELETE_CUR_PT,

			     MENU_STRING_ITEM,DELETE_CURRENT_CURVE_STR,
			     (int) DELETE_CUR_CURVE,

			     MENU_STRING_ITEM,DELETE_CURRENT_ROI_STR,
			     (int) DELETE_CUR_ROI,

			     MENU_STRING_ITEM,DELETE_ALL_ROIS_STR,
			     (int) DELETE_EVERY_ROI,

			     MENU_STRING_ITEM,DELETE_ALL_FILE_ROIS_STR,
			     (int) DELETE_ALL_FILE_ROIS,

			     MENU_STRING_ITEM,CURSOR_DELETE_ROI_MODE,
			     (int) DELETE_CURVE_MODE,

			     0 );
  return menu;
}




/*------------------------------------------------------------------------
dp_delete_roi_proc - ???
------------------------------------------------------------------------*/

void
dp_delete_roi_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 enter_dp_delete_roi(win,1);
}



/*------------------------------------------------------------------------
more_roi_proc - ???
------------------------------------------------------------------------*/

void
more_roi_proc(menu,item,arg,window,last_event,display_option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int display_option;
{
 int value;
 struct display_win_rec *win1;
 struct image_display_window *win;
 int is_clear;
 Menu root;

 PRT(printf("more_roi_proc ...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     value = display_option;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     value = (int) xv_get(item,MENU_VALUE);}
 win = win1->owner;
 win->dwin = win1;
 PRT(printf("more_roi_proc value = %d \n",value))
 switch (value)
    {
     case DISPLAY_HIDE_SHOW_ALL_ROIS :
        if (win->status4 & WIN_HIDE_ROIS)
           {win->status4 &= ~WIN_HIDE_ROIS;
            win_set_all_rois_visibility(win,ROI_VISIBLE,1);
            win_execute_proc_to_multiple_wins(win,win_display_all_curves,
					      0,0,0,0,0);}
          else
           {win->status4 |= HIDE_ALL_ROIS;
            win_execute_proc_to_multiple_wins(win,win_display_clear_curves,
					      0,0,0,0,0);}
        break;
     case DISPLAY_HIDE_ALL_ROIS_BUT_CUR :
        PRT4(printf("DISPLAY_HIDE_ALL_ROIS_BUT_CUR...\n"))
        if (win->status4 & HIDE_ALL_ROIS_BUT_CUR)
           win->status4 &= ~HIDE_ALL_ROIS_BUT_CUR;
          else
           {win->status4 &= ~HIDE_ALL_ROIS;
            win->status4 |= HIDE_ALL_ROIS_BUT_CUR;}
/*
        win_set_all_rois_visibility(win,~ROI_VISIBLE,0);
*/
        win_execute_proc_to_multiple_wins(win,win_redisplay_all_curves,
					  0,0,0,0,0);
        break;
     case DISPLAY_FILLED_ROI :
        if (win->control.display_options & DISPLAY_FILLED_ROI)
           win->control.display_options &= ~DISPLAY_FILLED_ROI;
          else win->control.display_options |= DISPLAY_FILLED_ROI;
        win_redisplay_all_curves(win);
        break;
     case VALUE_MAKE_ROI_CONVEX :
        ShowMsgStrs(win->dwin->frame,1,NO_ERROR,0,2,
               "Making the current ROI convex...",
               PLEASE_WAIT,win_make_cur_roi_convex,1,win);
        break;
     case VALUE_OUT_OF_BOUND_ROIS :
        win_bring_back_out_of_bound_rois(win);
        break;
     case DISPLAY_ENABLED_LABEL :
        if (win->control.display_options & DISPLAY_ENABLED_LABEL)
           win->control.display_options &= ~DISPLAY_ENABLED_LABEL;
          else
           win->control.display_options |= DISPLAY_ENABLED_LABEL;
        is_clear = 1;
        win_execute_proc_to_multiple_wins(win,win_draw_enabled_label,
					  &is_clear,0,0,0,0);
        break;
     case DISPLAY_ROW_COL_LABEL :
        if (win->control.display_options & DISPLAY_ROW_COL_LABEL)
           win->control.display_options &= ~DISPLAY_ROW_COL_LABEL;
          else
           win->control.display_options |= DISPLAY_ROW_COL_LABEL;
        win_show_row_col(win,1);
        break;
    }
}


/*------------------------------------------------------------------------
dp_more_rois_proc - ???
------------------------------------------------------------------------*/

void
dp_more_rois_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 enter_more_roi_options_proc(win,1);
}


/*------------------------------------------------------------------------
setup_more_roi_menu - ???
------------------------------------------------------------------------*/

Menu 
setup_more_roi_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                        MENU_ITEM,
                          MENU_STRING,HIDE_SHOW_ALL_ROIS_OF_CURRENT_SLICE,
                          MENU_VALUE,(int) DISPLAY_HIDE_SHOW_ALL_ROIS,0,
                        MENU_ITEM,
                          MENU_STRING,HIDE_ALL_ROIS_OF_CUR_SLICE_BUT_CUR,
                          MENU_VALUE,(int)DISPLAY_HIDE_ALL_ROIS_BUT_CUR,0,
                       MENU_ITEM,
                          MENU_STRING,FILL_ROIS,
                          MENU_VALUE,(int) DISPLAY_FILLED_ROI,0,
                       MENU_ITEM,
                          MENU_STRING,OUT_OF_BOUND_ROIS,
                          MENU_VALUE,(int) VALUE_OUT_OF_BOUND_ROIS,0,
                       MENU_ITEM,
                          MENU_STRING,MAKE_ROI_CONVEX,
                          MENU_VALUE,(int) VALUE_MAKE_ROI_CONVEX,0,
                       MENU_ITEM,
                          MENU_STRING,DONT_DISPLAY_PEN_ENABLED_LABEL,
                          MENU_VALUE,(int) DISPLAY_ENABLED_LABEL,0,
                       MENU_ITEM,
                          MENU_STRING,DONT_DISPLAY_THE_PIXEL_POSITION,
                          MENU_VALUE,(int) DISPLAY_ROW_COL_LABEL,0,
                       0);
 return menu;

}


/*------------------------------------------------------------------------
gen_more_roi_proc - ???
------------------------------------------------------------------------*/

Menu 
gen_more_roi_proc(menu,operation)
 Menu menu;
 Menu_generate operation;
{
 Menu_item item;
 unsigned char append;
 Menu display_options_menu,root;
 struct display_win_rec *win1;
 struct image_display_window *win;
 Xv_Window window;
 Event *last_event;

 TRACE(printf("gen_more_roi_proc in...\n"))
 
 switch (operation)
    {
     case MENU_DISPLAY : 
        root = (Menu) root_menu(menu);
        if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
           {window = (Xv_Window) event_window(last_event);
            win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
           }
          else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
        win = win1->owner;
        win->dwin = win1;
        display_options_menu = setup_more_roi_menu();

        xv_set(display_options_menu,
                 MENU_NOTIFY_PROC,more_roi_proc,0);
        xv_set(menu,MENU_PULLRIGHT,display_options_menu,0);
        append = 0;
        if ((item = menu_find(display_options_menu,
                 MENU_VALUE,(int) DISPLAY_FILLED_ROI,0)) != 0)
           if (win->control.display_options & DISPLAY_FILLED_ROI)
              xv_set(item,MENU_STRING,DONT_FILL_ROIS,0);
             else
              xv_set(item,MENU_STRING,FILL_ROIS,0);
        if ((item = menu_find(display_options_menu,
                 MENU_VALUE,(int) DISPLAY_ENABLED_LABEL,0)) != 0)
           if (win->control.display_options & DISPLAY_ENABLED_LABEL)
              xv_set(item,MENU_STRING,DONT_DISPLAY_PEN_ENABLED_LABEL,0);
             else xv_set(item,MENU_STRING,DISPLAY_PEN_ENABLED_LABEL,0);
        if ((item = menu_find(display_options_menu,
                 MENU_VALUE,(int) DISPLAY_ROW_COL_LABEL,0)) != 0)
           if (win->control.display_options & DISPLAY_ROW_COL_LABEL)
              xv_set(item,MENU_STRING,DONT_DISPLAY_THE_PIXEL_POSITION,0);
             else xv_set(item,MENU_STRING,DISPLAY_THE_PIXEL_POSITION,0);
    }
 return menu;
}


/*------------------------------------------------------------------------
setup_trans_roi_menu - ???
------------------------------------------------------------------------*/

Menu 
setup_trans_roi_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
        MENU_NOTIFY_PROC,select_cursor_proc,
        MENU_ITEM,
           MENU_STRING,CURSOR_MOVE_ROI_LABEL,
           MENU_CLIENT_DATA,CURSOR_MOVE_ROI,0,
        MENU_ITEM,
           MENU_STRING,CURSOR_RESIZE_ROI_LABEL,
           MENU_CLIENT_DATA,CURSOR_RESIZE_ROI,0,
        MENU_ITEM,
           MENU_STRING,CURSOR_ROTATE_ROI_LABEL,
           MENU_CLIENT_DATA,CURSOR_ROTATE_ROI,0,
                       0);
 return menu;
}


/*------------------------------------------------------------------------
trans_roi_mode_proc - ???

NOTE:  The pre-19990225 version of this function returned int but was
used only in contexts that required void.  Changed the type to void. -PWH
------------------------------------------------------------------------*/

void
trans_roi_mode_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     option = 0;
    }
 win = win1->owner;
 win->dwin = win1;
 if (!(win->type2 & EDIT_NO_3D_WINDOW)) return;

 if (option == ACTION_ON_ALL_SLICES)
    {if (win->control.status & ACTION_ON_ALL_SLICES)
        win->control.status &= ~ACTION_ON_ALL_SLICES;
       else win->control.status |= ACTION_ON_ALL_SLICES;
     update_dp_trans_roi(win);
     win_execute_proc_to_multiple_wins(win,win_action_label,0,0,0,0,0);     
    }
   else if (option == VALUE_SLICE_ROI_PRIOR)
    {win_move_slice_rois_prior(win);}
   else if (option == VALUE_SLICE_ROI_NEXT)
    {win_move_slice_rois_next(win);}
   else
    {win->control.status &= ~ACTION_ON_ROI;
     if (option == ACTION_ON_ALL_ROIS) win->control.status |= ACTION_ON_ALL_ROIS;
       else if (option == ACTION_ON_CUR_ROI)
        win->control.status |= ACTION_ON_CUR_ROI;
     update_dp_trans_roi(win);
     win_execute_proc_to_multiple_wins(win,win_action_label,0,0,0,0,0);
    }
}


/*------------------------------------------------------------------------
dp_trans_roi_proc - ???
------------------------------------------------------------------------*/

void
dp_trans_roi_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     option = 0;
    }
 win = win1->owner;
 win->dwin = win1;
 enter_dp_trans_roi(win,1);
}


/*------------------------------------------------------------------------
trans_roi_proc - ???
------------------------------------------------------------------------*/

int
trans_roi_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);

    }
 win = win1->owner;
 win->dwin = win1;
 if (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE)
    {}
   else
    {PRT6(printf("win->owner->owner-> = %x\n",(unsigned long) win->type2))
     if (!(win->type2 & EDITING_WINDOW))
        return NO_ERROR;
    }
 return trans_roi(win,last_event);
}


/*------------------------------------------------------------------------
dp_draw_list_proc - ???
------------------------------------------------------------------------*/

void
dp_draw_list_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 enter_dp_draw_list(win,1);
}


/*------------------------------------------------------------------------
draw_link_with_wid_proc - ???

NOTE:  The pre-19990225 version of this function returned int but was
used only in contexts that required void.  Changed the type to void. -PWH
------------------------------------------------------------------------*/

void
draw_link_with_wid_proc(menu,item,arg,window,last_event,is_delete)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int is_delete;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;
 struct strs_rec *wids;
 int err;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     is_delete = (int) xv_get(item,MENU_VALUE);
    }
 win = win1->owner;
 win->dwin = win1;
 if (!(win->type2 & IMAGE_WINDOWS))
    {win_alarm(win1->frame,2);
     return;}
 set_win_busy(win);
 if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
    {if (is_delete) 
        err = WinRunProcInList(WIN_DRAW_LIST | WIN_DO_NOT_PROCESS_CUR_WIN,win,
                  WinDrawListWids,wids,0,0,0,0,0);
       else err = AllWids(win->owner,wids,1,0,
                (unsigned long) (win->type2 & IMAGE_WINDOWS));
     if (err == NO_ERROR)
        {if (is_delete) 
            {if (wids->num_strs == 0)
                {c_free(wids);
                 ShowMsgStrs(win1->frame,1,err,2,1,
                  "Sorry...no links yet to other WID yet !!",NULL,0);
                }
	    else ShowMenuStrsProc(window,last_event,
				  DELETE_DRAW_LINK_WITH_WID,
				  wids,USER_MENU_FREE_STRS_AND_PTR,
				  win_delete_draw_link_with_wid,win,1,0,0);
            }
           else if (wids->num_strs == 0)
            {c_free(wids);
             ShowMsgStrs(win1->frame,1,err,2,1,
                  "Sorry...no other WID available !!",NULL,0);
            }
           else ShowMenuStrsProc(window,last_event,DRAW_LINK_WITH_WID,
				 wids,USER_MENU_FREE_STRS_AND_PTR,
				 win_draw_link_with_wid,win,1,0,0);
         }
    }
 if (err != NO_ERROR)
    {free_strs_rec(wids);
     c_free(wids);
     ShowMsgStrs(win1->frame,0,err,2,1,
                  "Sorry...Memory err !!",NULL,0);
    }
 set_win_not_busy(win);
}


/*------------------------------------------------------------------------
reverse_slice_rois_proc - ???
------------------------------------------------------------------------*/

void
reverse_slice_rois_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 win_reverse_slice_rois(win);
}


/*------------------------------------------------------------------------
import_slice_rois_proc - ???
------------------------------------------------------------------------*/

void
import_slice_rois_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 enter_import_rois(win,1);
}


/*------------------------------------------------------------------------
delete_the_grown_roi_proc - ???
------------------------------------------------------------------------*/

void
delete_the_grown_roi_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win1->owner->dwin = win1;
 win_delete_roi_by_label(win1->owner,GROW_ROI_LABEL);
}
