/****************************************************************************
roi_to_histo_roi.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: roi_to_histo_roi.c,v 1.12 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>

#include "mri_format.h"
#include "object.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)



/* Functions defined in this file */
int win_1_echo_mask_to_histo_roi(struct image_display_window *win,
    struct buf_2d_rec *mask, struct int_bound_rec *mask_area,
    char *histo_label);
int get_mask_coord_proc(struct buf_2d_rec *_2d, long row, long col,
    struct roi_rec *roi);
int win_multi_echo_mask_to_histo_roi(struct image_display_window *win,
    struct buf_2d_rec *mask, struct int_bound_rec *mask_area,
    char *histo_label, int option);
int win_mask_to_histo_roi(struct image_display_window *win,
    struct buf_2d_rec *mask, struct int_bound_rec *mask_area, char *label,
    int option, Frame frame);
int roi_to_histo_roi(struct image_display_window *win,
    struct roi_rec *this_roi, int option, char *histo_roi_label, Frame frame);
int _1_echo_histo_mask_to_sel_pixels(struct buf_2d_rec *histo_mask,
    struct buf_2d_rec *_2d, struct buf_2d_rec *sel_mask,
    struct curve_rec *curve);
int _2_echo_histo_mask_to_sel_pixels(struct buf_2d_rec *histo_mask,
    struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2,
    struct buf_2d_rec *sel_mask, struct curve_rec *curve);
int win_cur_histo_roi_to_slice_roi(struct image_display_window *win);
int _1_echo_slice_types_to_histo_rois(struct image_display_window *win);
int _2_echo_slice_types_to_histo_rois(struct image_display_window *win);
int cur_slice_types_to_histo_rois(struct image_display_window *win);
void all_slice_types_to_histo_rois(struct image_display_window *win);



/*-------------------------------------------------------------------------
win_1_echo_mask_to_histo_roi - ???
-------------------------------------------------------------------------*/

int
win_1_echo_mask_to_histo_roi(win,mask,mask_area,histo_label)
 struct image_display_window *win;
 struct buf_2d_rec *mask;
 struct int_bound_rec *mask_area;
 char *histo_label;
{
 struct img_buf_rec *img;
 double min,max;
 long minx,maxx,miny,maxy;
 struct buf_2d_rec _2d;
 int err,change;
 struct roi_rec roi1,*histo_roi;
 struct slice_roi_win_rec *slice_roi_win;
 unsigned int histo_dimx,histo_dimy,pixel_depth;
 unsigned short status;

 TRACE(printf("win_1_echo_mask_to_histo_roi...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 get_histo_dim(&(img->file->histo_params),
                  &histo_dimx,&histo_dimy,&pixel_depth,HISTO_1D);

 slice_roi_win = (struct slice_roi_win_rec *) 
              GetHistoSliceRoiWinRec(&(img->file->histo_params),HISTO_1D);
 PRT(printf("win_1_echo_mask_to_histo_roi ..2.\n"))
 histo_roi = get_roi(&(slice_roi_win->slice_roi),histo_label);

 init_buf_2d_rec(&_2d);
 if (((err = SetupBuf2dRec(&_2d,img->_2d.dimx,img->_2d.dimy,
         img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) == NO_ERROR) &&
     ((err = RdSlice(img,1,&_2d,0)) == NO_ERROR))
    {
     if (!(_2d.status4 & BUF_MIN_MAX_SET))
        {TRACE(printf("!_2d.status4 & BUF_MIN_MAX_SET...\n"))
         err = CANCEL;}
       else
        {MinMax2dByMask(&_2d,0,0,mask,mask_area,&min,&max);
         if (min <= max)
            {
             PRT(printf("min = %f ..max = %f...\n",min,max))
             min = ScaleVal(min,_2d.minval_set,_2d.maxval_set,
                         (double) .0,(double) (histo_dimx - 1));
             max = ScaleVal(max,_2d.minval_set,_2d.maxval_set,
                         (double) .0,(double) (histo_dimx - 1));
             if (histo_roi == NULL) change = 1;
               else
                {FindRoiLongMinMax(histo_roi,NULL,&minx,&maxx,&miny,&maxy,
                           0,0,1);
                 PRT(printf("min = %f ..max = %f minx = %d ..maxx = %d   miny = %d  maxy = %d\n",
                     min,max,minx,maxx,miny,maxy))
                 change = 0;
                 if (minx <= maxx)
                    {if (min < (double) minx) change = 1;
                       else min = (double) minx;
                     if (max >(double)  maxx) change = 1;
                       else max = (double) maxx;
                    }
                   else change = 1;
                }
             PRT(printf("==min = %f ..max = %f...change = %d\n",min,max,change))
             if (change)
                {PRT(printf("change min = %f   max = %f\n",min,max);)
                 init_roi_rec(&roi1,histo_label);
                 TRACE(printf("win_1_echo_mask_to_histo_roi ..3.\n"))
                 status = 0;
                 if (histo_dimy > 0) histo_dimy -= 1;
                 if ((err = EnterPtsIntoRoiRec(&roi1,
                     (unsigned short) DRAW_POLYGON,&status,NULL,0,5,(float) min,.0,
                      (float) max,.0,(float) max,(float) histo_dimy,
                      (float) min,(float) histo_dimy,(float) min,.0)) == NO_ERROR)
                    {slice_roi_win->slice_roi.status |= status;
                     if (histo_roi != NULL)
                        {
                         free_roi_rec(histo_roi);
                         *histo_roi = roi1;}
                       else
                        {err = JoinRoiToSliceRoiRec(
                                 &(slice_roi_win->slice_roi),
                                 &roi1,1,1.0,1.0,NULL,NULL,NULL);
                         free_roi_rec(&roi1);}
                     PRT(printf("win_1_echo_mask_to_histo_roi ..5.\n"))
                    }
                   else free_roi_rec(&roi1);
                }
            }
        }
    }
 free_buf_2d_rec(&_2d);
 return err;
}


/*-------------------------------------------------------------------------
get_mask_coord_proc - ???
-------------------------------------------------------------------------*/

int
get_mask_coord_proc(_2d,row,col,roi)
 struct buf_2d_rec *_2d;
 long row,col;
 struct roi_rec *roi;
{
 unsigned short status;

 return EnterRoiCurvePt(roi,DRAW_POINT,0,
          (float) col,(float) row,&status,NULL);

}


/*-------------------------------------------------------------------------
win_multi_echo_mask_to_histo_roi - ???
-------------------------------------------------------------------------*/

int
win_multi_echo_mask_to_histo_roi(win,mask,mask_area,histo_label,option)
 struct image_display_window *win;
 struct buf_2d_rec *mask;
 struct int_bound_rec *mask_area;
 char *histo_label;
 int option;
{
 struct img_buf_rec *img;
 struct buf_2d_rec result_map;
 struct int_bound_rec affected;
 struct draw_mask_rec mask1;
 struct curve_rec **curves;
 unsigned int num_curves,total_curves;
 struct roi_rec roi1,*histo_roi;
 struct slice_roi_win_rec *slice_roi_win;
 int err;
 unsigned long left,right,top,bottom;
 struct img_rec the_img;
 unsigned short status;

 TRACE(printf("win_multi_echo_mask_to_histo_roi...option = %d\n",option))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 slice_roi_win = (struct slice_roi_win_rec *) 
              GetHistoSliceRoiWinRec(&(img->file->histo_params),HISTO_MULTI_D);
 if ((histo_roi = get_roi(&(slice_roi_win->slice_roi),histo_label)) == NULL)
    if (setup_more_rois(&(slice_roi_win->slice_roi),histo_label,1) == NO_ERROR)
       if ((histo_roi = get_cur_roi(&(slice_roi_win->slice_roi))) == NULL)
          {
           return CANCEL;}

 init_buf_2d_rec(&result_map);
 if (mask_area == NULL)
    setup_int_bound_rec(&affected,0,0,mask->dimx - 1,mask->dimy - 1);
   else
    affected = *mask_area;
 init_img_rec(&the_img,img->file);
 if ((NewImgBuf(&the_img,img->cur_slice,&err,0,0,0,0,0,0,1) == NULL) ||
     ((err = RdCurSliceEchoes(the_img.data[0],1,0)) != NO_ERROR) ||
     ((err = GetHistoMapMask(the_img.data[0],&result_map,mask,&affected))
             != NO_ERROR))
    {free_img_rec(&the_img);
     free_buf_2d_rec(&result_map);
     return err;}
 free_img_rec(&the_img);

 TRACE(printf("win_multi_echo_mask_to_histo_roi ..result_map = %d\n",
        CntValBuf2dRec(&result_map,(double) 0)))

 if (is_roi_non_empty(histo_roi))
    {init_draw_mask_rec(&mask1);
     if ((err = get_draw_mask_rec(&mask1,result_map.dimx,
             result_map.dimy)) != NO_ERROR)
        {free_draw_mask_rec(&mask1);
         free_buf_2d_rec(&result_map);
         return err;}
     GetFilledRoiMask(histo_roi,NULL,&mask1,&affected);

     OrBitmaps(&result_map,&result_map,&(mask1.mask._2d));
     free_draw_mask_rec(&mask1);
    }
 if (option == HISTO_ROI_RANGE_REGION) 
    {
     get_buf_2d_rec_bound(&result_map,&left,&top,&right,&bottom);
     init_roi_rec(&roi1,histo_roi->label);
     if ((err = EnterPtsIntoRoiRec(&roi1,DRAW_POLYGON,&status,NULL,0,5,
          (float) left,(float) top,
          (float) right,(float) top,
          (float) right,(float) bottom,
          (float) left,(float) bottom,
          (float) left,(float) top)) == NO_ERROR)
        {
         free_roi_rec(histo_roi);
         *histo_roi = roi1;
         slice_roi_win->slice_roi.status |= 
             SLICE_ROI_NON_EMPTY | SLICE_ROI_TO_BE_SAVED;
        }
       else free_roi_rec(&roi1);
    }
  else if (option == HISTO_ROI_POINTS) 
    {TRACE(printf("option == HISTO_ROI_POINTS...\n"))
     init_roi_rec(&roi1,histo_roi->label);
     setup_int_bound_rec(&affected,0,0,result_map.dimx - 1,result_map.dimy - 1);      
     TRACE(printf(" ..result_map = %d\n",
        CntValBuf2dRec(&result_map,(double) 0)))

     if ((err = process_buf_2d_rec_by_mask(&result_map,0,0,&result_map,
                 &affected,get_mask_coord_proc,&roi1,0,0,0,0,0,0,0,0)) == NO_ERROR)
        {
         free_roi_rec(histo_roi);
         *histo_roi = roi1;
         apply_to_roi_rec(histo_roi,set_curve_or,0,0,0,0,0,0,0,0,0);
         slice_roi_win->slice_roi.status |= 
             SLICE_ROI_NON_EMPTY | SLICE_ROI_TO_BE_SAVED;
         /*pr_roi_rec(histo_roi);*/
        }
       else free_roi_rec(&roi1);
    }
  else
    {
     if (option == HISTO_ROI_CONVEX_REGION)
        if ((err = fill_2d_convex_area(&result_map,1)) != NO_ERROR)
           {free_buf_2d_rec(&result_map);
            return err;}
     TRACE(printf("scan_objects ..2.\n"))
     if ((err = scan_objects(&result_map,NULL,
          &curves,&total_curves,&num_curves,1,1)) == NO_ERROR)
        {TRACE(printf("scan_objects ..3.\n"))
         init_roi_rec(&roi1,histo_roi->label);
         err = append_curves_to_roi_rec(&roi1,curves,num_curves,
                &(slice_roi_win->slice_roi.status));
        }
     if (err == NO_ERROR)
        {free_roi_rec(histo_roi);
         *histo_roi = roi1;
        }
       else if (num_curves > 0)
        {free_roi_rec(&roi1);
         free_curve_recs(curves,num_curves);
        }
     c_free(curves);
    }
 free_buf_2d_rec(&result_map);
 return err;
}


/*-------------------------------------------------------------------------
win_mask_to_histo_roi - ???

option =
#define HISTO_ROI_POINTS 1
#define HISTO_ROI_CONVEX_REGION 2
#define HISTO_ROI_RANGE_REGION 3
-------------------------------------------------------------------------*/

int
win_mask_to_histo_roi(win,mask,mask_area,label,option,frame)
 struct image_display_window *win;
 struct buf_2d_rec *mask;
 struct int_bound_rec *mask_area;
 char *label;
 int option;
 Frame frame;
{
 struct img_buf_rec *img;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (img->file->hdr.data_info.num_echoes == 2)
    {if (option == HISTO_ROI_CONVEX_REGION)
        {if (frame == 0) frame = win->dwin->frame;
            ShowMsgStrs(frame,1,NO_ERROR,0,3,
               "Making a convex histo ROI convex that",
               "contains of all selected pixel values...",
               PLEASE_WAIT,NULL,0);
        }
     err = win_multi_echo_mask_to_histo_roi(win,
               mask,mask_area,label,option);
    }
   else err = win_1_echo_mask_to_histo_roi(win,
                  mask,mask_area,label);
 TRACE(printf("win_mask_to_histo_roi.\n"))

 if (err != NO_ERROR)
    {if (frame == 0) frame = win->dwin->frame;
     ShowMsgStrs(frame,0,err,0,2,
               "An error occured !!! -- Cannot add the histo roi !!!",
               "Operation aborted !!!",NULL,0);
    }
   else if (win->owner->histogram != NULL)
    win_execute_proc_to_related_wins(win->owner->histogram,
            win_redisplay_all_curves,0,0);
   else
    {TRACE(printf("win_histogram_show_it...\n"))
     win_histogram_show_it(win);
     if (win->owner->histogram != NULL)
        win_execute_proc_to_related_wins(win->owner->histogram,
                     win_redisplay_all_curves,0,0);}

 TRACE(printf("win_mask_to_histo_roi...err = %d\n",err))

 return err;
}


/*-------------------------------------------------------------------------
roi_to_histo_roi - ???
-------------------------------------------------------------------------*/

int
roi_to_histo_roi(win,this_roi,option,histo_roi_label,frame)
 struct image_display_window *win;
 struct roi_rec *this_roi;
 int option;
 char *histo_roi_label;
 Frame frame;
{
 int err;
 struct img_buf_rec *img;
 struct draw_mask_rec mask;
 struct int_bound_rec affected;
 struct roi_rec *roi;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (this_roi == NULL)
    {if (((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi))) == NULL) 
                || !is_roi_non_empty(roi))
        return CANCEL;
    }
   else if (!is_roi_non_empty(this_roi)) return CANCEL;

 init_draw_mask_rec(&mask);
 if (this_roi == NULL)
     /* FIXME!! Added a final argument 0 to placate the compiler, but
	that's probably not the right value.  -PWH 19990527 */
    err = GetRoiMask(&(win->control.sroi.sroi_win->slice_roi),
             win->control.sroi.localto,
             img->_2d.dimx,img->_2d.dimy,&mask,&affected,CUR_ROI,0);
 else err = GetFilledRoiMask(this_roi,NULL,&mask,&affected);

 TRACE(printf("roi_to_histo_roi...\n"))
 if (err == NO_ERROR)
    {
     TRACE(printf("roi_to_histo_roi...1\n"))
     err = win_mask_to_histo_roi(win,&(mask.mask._2d),&affected,
               histo_roi_label,option,frame);
     free_draw_mask_rec(&mask);
    }
 TRACE(printf("roi_to_histo_roi...\n"))
 return err;
}


/*-------------------------------------------------------------------------
_1_echo_histo_mask_to_sel_pixels - ???


 sel_mask if the output mask for the selected pixels
 curve is the output x & y positions for the selected pixels
 if (sel_mask == NULL) sel_mask will not be modified
 if (curve == NULL) curve will not be modified
-------------------------------------------------------------------------*/

int
_1_echo_histo_mask_to_sel_pixels(histo_mask,_2d,sel_mask,curve)
 struct buf_2d_rec *histo_mask,*_2d,*sel_mask;
 struct curve_rec *curve;
{
 unsigned long row,col,indx;
 double val,val1;
 unsigned short status;
 int err;

 TRACE(printf("_1_echo_histo_mask_to_sel_pixels...\n"))
 if (!(_2d->status4 & BUF_MIN_MAX_SET)) return CANCEL;
 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimy; col++)
       {val = _2d->GetVal(_2d,row,col);
        val1 = ScaleVal(val,_2d->minval_set,_2d->maxval_set,
                        (double) .0,(double) (histo_mask->dimx - 1));
        indx = (unsigned long) (val1 + .5);
        if ((indx < 0) || (indx >= histo_mask->dimx))
           continue;
        if (histo_mask->GetVal(histo_mask,0,indx))
           {if (sel_mask != NULL)
               sel_mask->SetVal(sel_mask,row,col,(double) 1.0);
            if (curve != NULL)
               if ((err = EnterCurveXY(curve,(float) col,
                    (float) row,&status,NULL,0,0,0)) != NO_ERROR)
                  return err;
           }
       }
 TRACE(printf("_1_echo_histo_mask_to_sel_pixels...end\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
_2_echo_histo_mask_to_sel_pixels - ???


 sel_mask if the output mask for the selected pixels
 curve is the output x & y positions for the selected pixels
 if (sel_mask == NULL) sel_mask will not be modified
 if (curve == NULL) curve will not be modified
-------------------------------------------------------------------------*/

int
_2_echo_histo_mask_to_sel_pixels(histo_mask,_2d1,_2d2,sel_mask,curve)
 struct buf_2d_rec *histo_mask,*_2d1,*_2d2,*sel_mask;
 struct curve_rec *curve;
{
 unsigned long indx1,indx2,row,col;
 double val4,val1,val2,val3;
 unsigned short status;
 int err;

 if (!(_2d1->status4 & BUF_MIN_MAX_SET)) return CANCEL;
 if (!(_2d2->status4 & BUF_MIN_MAX_SET)) return CANCEL;
 for (row = 0; row < _2d1->dimy; row++)
    for (col = 0; col < _2d1->dimy; col++)
       {val1 = _2d1->GetVal(_2d1,row,col);
        val2 = _2d2->GetVal(_2d2,row,col);
        val3 = ScaleVal(val1,_2d1->minval_set,_2d1->maxval_set,
                        (double) .0,(double) (histo_mask->dimx - 1));
        val4 = ScaleVal(val2,_2d2->minval_set,_2d2->maxval_set,
                         (double) .0,(double) (histo_mask->dimy - 1));
        if (((long) val3 < 0) || ((long) val3 >= histo_mask->dimx) ||
            ((long) val4 < 0) || ((long) val4 >= histo_mask->dimy))
           continue;
        indx1 = (unsigned long) (val3 + .5);
        indx2 = (unsigned long) (val4 + .5);
        if (histo_mask->GetVal(histo_mask,indx2,indx1) != .0)
           {if (sel_mask != NULL)
               sel_mask->SetVal(sel_mask,row,col,(double) 1);
            if (curve != NULL)
               if ((err = EnterCurveXY(curve,(float) col,
                    (float) row,&status,NULL,0,0,0)) != NO_ERROR)
                  return err;
           }
       }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_cur_histo_roi_to_slice_roi - ???
-------------------------------------------------------------------------*/

int
win_cur_histo_roi_to_slice_roi(win)
 struct image_display_window *win;
{
 struct img_rec the_img;
 struct img_buf_rec *img,*img1;
 struct roi_rec *roi;
 struct draw_mask_rec mask;
 struct int_bound_rec affected;
 unsigned int histo_dimx,histo_dimy,pixel_depth;
 unsigned short histo_type;
 struct curve_rec *curve;
 struct slice_roi_rec *slice_roi;
 int err;
 struct slice_roi_win_rec *slice_roi_win;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NO_ERROR;

 TRACE(printf("win_cur_histo_roi_to_slice_roi...\n"))
 histo_type = file_get_def_histo_type(img->file);
 /* Moved an apparently misplaced paren in next line.  -PWH 19990618 */
 if ((err = HistoBufReady(img->file,histo_type)) != NO_ERROR)
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "Unable to get the histogram ready yet !!!",
               "Probably memory error !!!",NULL,0);
     return err;}
 slice_roi = &(img->cur_slice->slice->slice_roi_win->slice_roi);
 if ((roi = get_roi(slice_roi,SLICE_ROI)) != NULL)
    delete_roi(slice_roi,roi);
 TRACE(printf("win_cur_histo_roi_to_slice_roi...0\n"))

 get_histo_dim(&(img->file->histo_params),
                  &histo_dimx,&histo_dimy,&pixel_depth,histo_type);

 slice_roi_win = (struct slice_roi_win_rec *)
          GetHistoSliceRoiWinRec(&(img->file->histo_params),histo_type);
 if (((roi = get_cur_roi(&(slice_roi_win->slice_roi))) == NULL) ||
     !is_roi_non_empty(roi))
    {if (win->owner->image_display != NULL)
        win_execute_proc_to_related_wins(win->owner->image_display,
                  win_redisplay_all_curves,0,0);
     ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "Sorry...no current histo roi selected !!!",
               OK,NULL,0);
     return NO_ERROR;}
 TRACE(printf("win_cur_histo_roi_to_slice_roi...1\n"))
 init_draw_mask_rec(&mask);
 curve = NULL;
 if (((err = GetHistoRoiMask(img,&mask,&affected,CUR_ROI,NULL)) == NO_ERROR) &&
     ((err = setup_curve_rec_ptr(&curve,DRAW_POINT)) == NO_ERROR))
    {TRACE(printf("win_cur_histo_roi_to_slice_roi...2..CURVE = %u\n",curve))
     init_img_rec(&the_img,img->file);
     if (NewImgBuf(&the_img,img->cur_slice,&err,0,0,0,0,0,0,1) != NULL)
        {
         TRACE(printf("win_cur_histo_roi_to_slice_roi.3..CURVE = %u\n",curve))
         if ((img1 = pick_first_img_buf_rec_partner(the_img.data[0])) == NULL)
            err = CANCEL;
           else
            {
         TRACE(printf("win_cur_histo_roi_to_slice_roi.3..1 = %u\n",curve))
             if ((err = RdCurSliceEchoes(img1,1,0)) == NO_ERROR)
                {
                 TRACE(printf("win_cur_histo_roi_to_slice_roi.3..2 = %u\n",curve))
                 if (img->file->hdr.data_info.num_echoes == 2)
                    err = _2_echo_histo_mask_to_sel_pixels(&(mask.mask._2d),
                         &(img1->_2d),&(img1->partner->_2d),NULL,curve);
                   else
                    err = _1_echo_histo_mask_to_sel_pixels(&(mask.mask._2d),
                               &(img1->_2d),NULL,curve);
                 TRACE(printf("win_cur_histo_roi_to_slice_roi..4.CURVE = %u\n",curve))
                 if (err == NO_ERROR)
                    {
                     if (setup_more_rois(slice_roi,SLICE_ROI,1) == NO_ERROR)
                        if ((roi = get_cur_roi(slice_roi)) != NULL)
                           if ((err = append_curve_to_roi_rec(roi,curve,DRAW_POINT,1,
                                &(slice_roi->status))) == NO_ERROR)
                              curve = NULL;
                    }
                 TRACE(printf("win_cur_histo_roi_to_slice_roi.5..CURVE = %u\n",curve))
                }
            }
        }
     free_img_rec(&the_img);
    }
 free_draw_mask_rec(&mask);
 if (curve != NULL)
    {free_curve_rec(curve);
     c_free(curve);
    }
 TRACE(printf("win_cur_histo_roi_to_slice_roi.6..err = %d\n",err))
 if (win->owner->image_display != NULL)
    {TRACE(printf("win_cur_histo_roi_to_slice_roi.win_redisplay_all_curves\n"))
     win_execute_proc_to_related_wins(win->owner->image_display,
               win_redisplay_all_curves,0,0);}

 return err;

}


/*-------------------------------------------------------------------------
_1_echo_slice_types_to_histo_rois - ???
-------------------------------------------------------------------------*/

int
_1_echo_slice_types_to_histo_rois(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct img_buf_rec *img1;
 struct buf_2d_rec *map;
 struct img_rec imgdata;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((map = get_cur_slice_map(img->file,img->cur_slice)) == NULL)
    return CANCEL;
 init_img_rec(&imgdata,img->file);
 if ((NewImgBuf(&imgdata,img->cur_slice,&err,0,0,0,0,0,0,1) != NULL) &&
     (img1 = imgdata.data[0]) &&
     ((err = RdCurSliceEchoes(img1,1,0)) == NO_ERROR) &&
     ((err = Scale2dPixels(&(img1->_2d),&(img1->_2d),
               (double) .0,(double) (map->dimx - 1), 
               0,(double) .0,(double) .0,0)) == NO_ERROR))
    {
/*
     for (row = 0; row < img1->_2d.dimy; row++)
        for (col = 0; col < img1->_2d.dimy; col++)
           {}
*/
    }
 free_img_rec(&imgdata);
 return err;
}


/*-------------------------------------------------------------------------
_2_echo_slice_types_to_histo_rois - ???
-------------------------------------------------------------------------*/

int
_2_echo_slice_types_to_histo_rois(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct img_buf_rec *img1;
 struct buf_2d_rec *map;
 struct img_rec imgdata;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((map = get_cur_slice_map(img->file,img->cur_slice)) == NULL)
    return CANCEL;
 init_img_rec(&imgdata,img->file);
 if ((NewImgBuf(&imgdata,img->cur_slice,&err,0,0,0,0,0,0,1) != NULL) &&
     ((img1 = pick_first_img_buf_rec_partner(imgdata.data[0])) != NULL) &&
     ((err = RdCurSliceEchoes(img1,1,0)) == NO_ERROR) &&
     ((err = Scale2dPixels(&(img1->_2d),&(img1->_2d),
                   (double) .0,(double) (map->dimx - 1),
                   0,(double) .0,(double) .0,0)) == NO_ERROR) &&
     ((err = Scale2dPixels(&(img1->partner->_2d),&(img1->partner->_2d),
                    (double) .0,(double) (map->dimy - 1),
                   0,(double) .0,(double) .0,0)) == NO_ERROR))
    {
/*
     for (row = 0; row < img1->_2d.dimy; row++)
        for (col = 0; col < img1->_2d.dimy; col++)
           {}
*/
    }
 free_img_rec(&imgdata);
 return err;
}


/*-------------------------------------------------------------------------
cur_slice_types_to_histo_rois - ???
-------------------------------------------------------------------------*/

int
cur_slice_types_to_histo_rois(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (img->file->hdr.data_info.num_echoes == 2)
    return _2_echo_slice_types_to_histo_rois(win);
 else return _1_echo_slice_types_to_histo_rois(win);
}


/*-------------------------------------------------------------------------
all_slice_types_to_histo_rois - ???

FIXME!! This function contains no code but appears to be actually called
by some other function.  -PWH 19990527
-------------------------------------------------------------------------*/

void
all_slice_types_to_histo_rois(win)
 struct image_display_window *win;
{
    /*struct img_buf_rec *img;*/

    /* FIXME:  Where's the code?? */

}
