/****************************************************************************
scan_objects.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: scan_objects.c,v 1.8 1999/07/07 17:41:19 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "object.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)


/* Functions defined in this file */
void init_object_rec(struct object_rec *obj);
void init_all_object_rec(struct all_object_rec *all_objs);
void free_object_rec_merged_objs(struct object_rec *obj);
void free_object_rec(struct object_rec *obj);
void free_object_recs(struct all_object_rec *all_objs);
void delete_all_object_rec_id_2d(struct all_object_rec *all_objs,
    int free_id_2d);
void free_all_object_rec1(struct all_object_rec *all_objs, int free_id_2d);
int sort_xy_rec_ascendingly_proc(const void *pt1, const void *pt2);
void sort_xy_rec(struct object_rec *obj);
void sort_all_obj_xys(struct all_object_rec *all_objs);
int sort_objs_ascendingly_proc(const void *obj1, const void *obj2);
void sort_objs(struct all_object_rec *all_objs);
int the_obj_binary_search(struct object_rec **objs, unsigned long num_objs,
    unsigned long id, unsigned long *insert_posi);
int delete_obj(struct all_object_rec *all_objs, struct object_rec *delete_obj);
int delete_obj_ptr(struct all_object_rec *all_objs,
    struct object_rec *delete_obj);
void delete_all_objs_rec_merged_objs(struct all_object_rec *all_objs);
int merge_objects_1(struct object_rec *dst, struct object_rec *src);
unsigned long total_merged_pts(struct object_rec *obj);
int merge_objects(struct object_rec *obj);
void pr_obj_merged_relation(struct object_rec *obj, long obj_num);
void update_merged_obj_relation(struct all_object_rec *all_objs);
void merge_id_2d_1(struct buf_2d_rec *id_2d, struct object_rec *dest_obj,
    struct object_rec *src_obj);
void merge_id_2d(struct buf_2d_rec *id_2d, struct object_rec *obj);
int merge_all_objs_rec_merged_objs(struct all_object_rec *all_objs,
    int update_id_2d, int is_pr);
int enter_merged_obj(struct object_rec *obj, struct object_rec *merged_obj);
int merge_objs(struct all_object_rec *all_objs, struct object_rec *dest_obj,
    struct object_rec *src_obj);
int setup_all_object_rec(struct all_object_rec *all_objs,
    struct buf_2d_rec *in_2d, struct buf_2d_rec *id_2d, int is_clear_id_2d,
    struct int_bound_rec *bound, unsigned long lbval, unsigned long ubval);
int assign_next_id(struct all_object_rec *all_objs, int id_flag,
    int next_id_flag, int all_used_flag, unsigned long max_id,
    unsigned long next_num_bits);
int get_next_id(struct all_object_rec *all_objs);
struct object_rec *get_obj(struct all_object_rec *all_objs, unsigned long id,
    int *err);
int sort_enter_obj_xy(struct object_rec *obj, int status, unsigned long x,
    unsigned long y);
int enter_obj_xy(struct object_rec *obj, int status, unsigned long x,
    unsigned long y);
int enter_obj_xy_by_posi(struct object_rec *obj, int status, unsigned long x,
    unsigned long y, unsigned long posi);
int enter_cur_obj_xy(struct all_object_rec *all_objs, int status,
    unsigned long x, unsigned long y);
int enter_xy_into_cur_obj(struct all_object_rec *all_objs, unsigned long x,
    unsigned long y);
void discard_internal_pts(struct object_rec *obj);
void discard_internal_buf_pts(struct object_rec *obj,
    struct buf_2d_rec *obj_2d);
int is_pt_bounded(struct buf_2d_rec *_2d, int x, int y);
void discard_redundant_pts(struct object_rec *obj, struct buf_2d_rec *obj_2d);
int discard_bounded_pts(struct all_object_rec *all_objs);
void get_affected_neighbors(struct xy_rec neighbors[4],
    struct int_bound_rec *bound, unsigned long x, unsigned long y);
void get_neighbor_ids(struct buf_2d_rec *in_2d, struct buf_2d_rec *id_2d,
    struct xy_rec xys[4], int ids[4], int *num_ids,
    struct int_bound_rec *bound, long x, long y);
struct object_rec *get_largest_obj(struct all_object_rec *all_objs);
void get_object_rec_obj_bound(struct object_rec *obj);
int delete_duplicate_object_rec_obj_pts(struct object_rec *obj);
int delete_obj_internal_boundary_pts(struct object_rec *obj,
    struct all_object_rec *sub);
int is_obj_pt_external(struct object_rec *obj, struct buf_2d_rec *in_2d,
    int fx, int fy);
int define_all_negative_boundary_objs(struct all_object_rec *sub,
    struct object_rec *obj);
int delete_all_negative_boundary_objs(struct all_object_rec *sub);
void pr_object_rec(struct object_rec *obj, long obj_num, int is_pr_xys);
void pr_all_object_rec(struct all_object_rec *all_objs, int is_pr_xys);
int detect_all_objs(struct all_object_rec *all_objs, int update_id_2d);
int detect_objects(struct buf_2d_rec *_2d, struct int_bound_rec *bound_area,
    struct curve_rec ***curves, unsigned int *total_curves,
    unsigned int *num_curves, unsigned long lbval, unsigned long ubval);
int scan_objects(struct buf_2d_rec *_2d, struct int_bound_rec *bound_area,
    struct curve_rec ***curves, unsigned int *total_curves,
    unsigned int *num_curves, unsigned long lbval, unsigned long ubval);



/*--------------------------------------------------------------------------
init_object_rec - ???
---------------------------------------------------------------------------*/

void
init_object_rec(obj)
 struct object_rec *obj;
{
 obj->status = 0;
 obj->id = 0;
 obj->is_external = 0;
/*
 setup_int_bound_rec(&(obj->bound),0x7fffffff,0x7fffffff,0,0);
*/
 obj->total_pts = obj->num_pts = 0;
 obj->total_merged_objs = obj->num_merged_objs = 0;
 obj->merged_objs = NULL;
 obj->owner = NULL;

 obj->pts = NULL;
 obj->excluded_regions = NULL;
}


/*--------------------------------------------------------------------------
init_all_object_rec - ???
---------------------------------------------------------------------------*/

void
init_all_object_rec(all_objs)
 struct all_object_rec *all_objs;
{
 all_objs->in_2d = NULL;
 init_buf_2d_rec(&(all_objs->id_2d));
 all_objs->cur_obj = NULL;
 all_objs->next_id = 1;
 all_objs->id_status = ID_IN_255;
 all_objs->total_objs = all_objs->num_objs = 0;
 all_objs->objs = NULL;
}


/*--------------------------------------------------------------------------
free_object_rec_merged_objs - ???
---------------------------------------------------------------------------*/

void
free_object_rec_merged_objs(obj)
 struct object_rec *obj;
{
 unsigned long lcv;

 if (obj->total_merged_objs > 0)
    {
     for (lcv = 0; lcv < obj->num_merged_objs; lcv++)
        {
         free_object_rec(obj->merged_objs[lcv]);
         c_free(obj->merged_objs[lcv]);
        }
     c_free(obj->merged_objs);
     obj->merged_objs = NULL;
     obj->total_merged_objs = obj->num_merged_objs = 0;
    }
}


/*--------------------------------------------------------------------------
free_object_rec - ???
---------------------------------------------------------------------------*/

void
free_object_rec(obj)
 struct object_rec *obj;
{
 free_object_rec_merged_objs(obj);
 if (obj->total_pts > 0)
    {c_free(obj->pts);
    }
 if (obj->excluded_regions != NULL) 
    free_all_object_rec1(obj->excluded_regions,1);
 init_object_rec(obj);
}


/*--------------------------------------------------------------------------
free_object_recs - ???
---------------------------------------------------------------------------*/

void
free_object_recs(all_objs)
 struct all_object_rec *all_objs;
{
 unsigned long lcv;

 if (all_objs->total_objs > 0)
    {for (lcv = 0; lcv < all_objs->num_objs; lcv++)
        {free_object_rec(all_objs->objs[lcv]);
         c_free(all_objs->objs[lcv]);
        }
     c_free(all_objs->objs);
     all_objs->total_objs = all_objs->num_objs = 0;
    }
}


/*--------------------------------------------------------------------------
delete_all_object_rec_id_2d - ???
---------------------------------------------------------------------------*/

void
delete_all_object_rec_id_2d(all_objs,free_id_2d)
 struct all_object_rec *all_objs;
 int free_id_2d;
{

 if (free_id_2d) free_buf_2d_rec(&(all_objs->id_2d));
 else init_buf_2d_rec(&(all_objs->id_2d));
}


/*--------------------------------------------------------------------------
free_all_object_rec1 - ???
---------------------------------------------------------------------------*/

void
free_all_object_rec1(all_objs,free_id_2d)
 struct all_object_rec *all_objs;
 int free_id_2d;
{

 if (free_id_2d) free_buf_2d_rec(&(all_objs->id_2d));
 free_object_recs(all_objs);
 init_all_object_rec(all_objs);
}

/*********************
sort_xy_rec_ascendingly_proc(pt1,pt2)
 struct xy_rec *pt1,*pt2;
{
 if (pt1->y > pt2->y) return 1;
 if (pt1->y < pt2->y) return -1;
 if (pt1->x > pt2->x) return 1;
 if (pt1->x < pt2->x) return -1;
 return 0;
}
*************************/


/*--------------------------------------------------------------------------
sort_xy_rec_ascendingly_proc - ???
---------------------------------------------------------------------------*/

int
sort_xy_rec_ascendingly_proc(pt1,pt2)
 const void *pt1,*pt2;
{
 if (((struct xy_rec *) pt1)->y > ((struct xy_rec *) pt2)->y) return 1;
 if (((struct xy_rec *) pt1)->y < ((struct xy_rec *) pt2)->y) return -1;
 if (((struct xy_rec *) pt1)->x > ((struct xy_rec *) pt2)->x) return 1;
 if (((struct xy_rec *) pt1)->x < ((struct xy_rec *) pt2)->x) return -1;
 return 0;
}


/*--------------------------------------------------------------------------
sort_xy_rec - ???
---------------------------------------------------------------------------*/

void
sort_xy_rec(obj)
 struct object_rec *obj;
{
 qsort(obj->pts,obj->num_pts,
        (size_t) sizeof(struct xy_rec),sort_xy_rec_ascendingly_proc);
}


/*--------------------------------------------------------------------------
sort_all_obj_xys - ???
---------------------------------------------------------------------------*/

void
sort_all_obj_xys(all_objs)
 struct all_object_rec *all_objs;
{
 unsigned long lcv;

 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    sort_xy_rec(all_objs->objs[lcv]);
}

/***************
sort_objs_ascendingly_proc(obj1,obj2)
 struct object_rec **obj1,**obj2;
{
 if ((*obj1)->id > (*obj2)->id) return 1;
 if ((*obj1)->id < (*obj2)->id) return -1;
 return 0;
}
*****************/


/*--------------------------------------------------------------------------
sort_objs_ascendingly_proc - ???
---------------------------------------------------------------------------*/

int
sort_objs_ascendingly_proc(obj1,obj2)
 const void *obj1,*obj2;
{
 if ((*((struct object_rec **) obj1))->id > 
     (*((struct object_rec **) obj2))->id) return 1;
 if ((*((struct object_rec **) obj1))->id <
     (*((struct object_rec **) obj2))->id) return -1;
 return 0;
}


/*--------------------------------------------------------------------------
sort_objs - ???
---------------------------------------------------------------------------*/

void
sort_objs(all_objs)
 struct all_object_rec *all_objs;
{
 qsort(all_objs->objs,all_objs->num_objs,
        (size_t) sizeof(struct object_rec *),sort_objs_ascendingly_proc);
}


/*--------------------------------------------------------------------------
the_obj_binary_search - ???
---------------------------------------------------------------------------*/

int
the_obj_binary_search(objs,num_objs,id,insert_posi)
 struct object_rec **objs;
 unsigned long num_objs;
 unsigned long id;
 unsigned long *insert_posi;
{
 int low,high,mid;

 low = *insert_posi = 0;
 if (num_objs > 0)
    {high = num_objs - 1;
     while (low <= high)
       {mid = (low + high) / 2;
        if (id > objs[mid]->id)
           {
            low = mid + 1;
            *insert_posi = low;
           }
          else if (id < objs[mid]->id)
           {*insert_posi = mid;
            high = mid - 1;
           }
          else
           {*insert_posi = mid;
            return NO_ERROR;}
       }
   }
 return NOT_FOUND;
}


/*--------------------------------------------------------------------------
delete_obj - ???
---------------------------------------------------------------------------*/

int
delete_obj(all_objs,delete_obj)
 struct all_object_rec *all_objs;
 struct object_rec *delete_obj;
{
 unsigned long posi,lcv;

 if (the_obj_binary_search(all_objs->objs,
            all_objs->num_objs,delete_obj->id,&posi) == NO_ERROR)
    {
     all_objs->num_objs -= 1;
     for (lcv = posi; lcv < all_objs->num_objs; lcv++)
        all_objs->objs[lcv] = all_objs->objs[lcv + 1];
     free_object_rec(delete_obj);
     c_free(delete_obj);
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
delete_obj_ptr - ???
---------------------------------------------------------------------------*/

int
delete_obj_ptr(all_objs,delete_obj)
 struct all_object_rec *all_objs;
 struct object_rec *delete_obj;
{
 unsigned long posi,lcv;

 if (the_obj_binary_search(all_objs->objs,
            all_objs->num_objs,delete_obj->id,&posi) == NO_ERROR)
    {
     all_objs->num_objs -= 1;
     for (lcv = posi; lcv < all_objs->num_objs; lcv++)
        all_objs->objs[lcv] = all_objs->objs[lcv + 1];
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
delete_all_objs_rec_merged_objs - ???
---------------------------------------------------------------------------*/

void
delete_all_objs_rec_merged_objs(all_objs)
 struct all_object_rec *all_objs;
{
 unsigned long lcv;

 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    {free_object_rec_merged_objs(all_objs->objs[lcv]);
    }
}


/*--------------------------------------------------------------------------
merge_objects_1 - ???
---------------------------------------------------------------------------*/

int
merge_objects_1(dst,src)
 struct object_rec *dst,*src;
{
 unsigned long lcv;
 int err;

 TRACE(printf("dst->id = %d merge = %d\n",dst->id,src->id);)
 for (lcv = 0; lcv < src->num_pts; lcv++)
    dst->pts[dst->num_pts++] = src->pts[lcv];
 if (src->num_merged_objs > 0) 
    {for (lcv = 0; lcv < src->num_merged_objs; lcv++)
        if ((err = merge_objects_1(dst,src->merged_objs[lcv])) != NO_ERROR)
            return err;
    }
 free_object_rec(src);

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
total_merged_pts - ???
---------------------------------------------------------------------------*/

unsigned long 
total_merged_pts(obj)
 struct object_rec *obj;
{
 unsigned long total,lcv;

 total = 0;
 for (lcv = 0; lcv < obj->num_merged_objs; lcv++)
    total = total + obj->merged_objs[lcv]->num_pts +
            total_merged_pts(obj->merged_objs[lcv]);
 return total;
}


/*--------------------------------------------------------------------------
merge_objects - ???
---------------------------------------------------------------------------*/

int
merge_objects(obj)
 struct object_rec *obj;
{
 unsigned long lcv,total;
 int err;

 if (obj->num_merged_objs == 0) return NO_ERROR;
 total = total_merged_pts(obj) + obj->num_pts;
 if (total >= obj->total_pts)
    {total = total - obj->total_pts + ADD_NUM_XY_RECS;
     get_ptr_memory(&(obj->pts),&(obj->total_pts),(size_t) total,
            (size_t) sizeof(struct xy_rec),&err);
     if (err != NO_ERROR) return err;
    }

 for (lcv = 0; lcv < obj->num_merged_objs; lcv++)
    {if ((err = merge_objects_1(obj,obj->merged_objs[lcv])) != NO_ERROR)
        return err;
    }
 for (lcv = 0; lcv < obj->num_merged_objs; lcv++)
    c_free(obj->merged_objs[lcv]);
 obj->num_merged_objs = 0;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
pr_obj_merged_relation - ???
---------------------------------------------------------------------------*/

void
pr_obj_merged_relation(obj,obj_num)
 struct object_rec *obj;
 long obj_num;
{
 unsigned long lcv;
 struct object_rec *obj1;

 if (obj->owner == NULL)
    printf("%ld) no owner obj id = %d ext = %d num_pts = %ld num_merged_objs = %ld\n",obj_num,
               (int) obj->id,obj->is_external,obj->num_pts,obj->num_merged_objs);
   else printf("%ld) owner = %ld id = %d ext = %d  num_pts = %ld num_merged_objs = %ld\n",
               obj_num,obj->owner->id,
             (int) obj->id,obj->is_external,obj->num_pts,obj->num_merged_objs);

 for (lcv = 0; lcv < obj->num_merged_objs; lcv++)
    {
     obj1 = obj->merged_objs[lcv];
     printf("   ");
     pr_obj_merged_relation(obj1,obj_num);
    }
 printf("\n");
}


/*--------------------------------------------------------------------------
update_merged_obj_relation - ???
---------------------------------------------------------------------------*/

void
update_merged_obj_relation(all_objs)
 struct all_object_rec *all_objs;
{
 unsigned long lcv;
 struct object_rec *obj;

 for (lcv = 0; lcv < all_objs->num_objs; )
    {obj = all_objs->objs[lcv];
     if (obj->owner != NULL)
        {
         if (obj->is_external) obj->owner->is_external =  1;
         delete_obj_ptr(all_objs,obj);
        }
       else lcv++;
    }
}


/*--------------------------------------------------------------------------
merge_id_2d_1 - ???
---------------------------------------------------------------------------*/

void
merge_id_2d_1(id_2d,dest_obj,src_obj)
 struct buf_2d_rec *id_2d;
 struct object_rec *dest_obj,*src_obj;
{
 unsigned long lcv;

 for (lcv = 0; lcv < src_obj->num_pts; lcv++)
    set_1d_buf_value(id_2d->buf[src_obj->pts[lcv].y],
        src_obj->pts[lcv].x,id_2d->pixel_depth,dest_obj->id);
 if (src_obj->num_merged_objs > 0)
    {for (lcv = 0; lcv < src_obj->num_merged_objs; lcv++)
        merge_id_2d_1(id_2d,dest_obj,src_obj->merged_objs[lcv]);
    }
}


/*--------------------------------------------------------------------------
merge_id_2d - ???
---------------------------------------------------------------------------*/

void
merge_id_2d(id_2d,obj)
 struct buf_2d_rec *id_2d;
 struct object_rec *obj;
{
 unsigned long lcv;

/*
 for (lcv = 0; lcv < obj->num_pts; lcv++)
    set_1d_buf_value(id_2d->buf[obj->pts[lcv].y],
        obj->pts[lcv].x,id_2d->pixel_depth,obj->id);
*/
 for (lcv = 0; lcv < obj->num_merged_objs; lcv++)
    merge_id_2d_1(id_2d,obj,obj->merged_objs[lcv]);
}



/*--------------------------------------------------------------------------
merge_all_objs_rec_merged_objs - ???
---------------------------------------------------------------------------*/

int
merge_all_objs_rec_merged_objs(all_objs,update_id_2d,is_pr)
 struct all_object_rec *all_objs;
 int update_id_2d;
 int is_pr;
{
 unsigned long lcv;
 int err;

 update_merged_obj_relation(all_objs);
/*
 if (is_pr)
    {printf("\n\nmerge_all_objs_rec_merged_objs...num_objs = %d\n",all_objs->num_objs);
     for (lcv = 0; lcv < all_objs->num_objs; lcv++)
        pr_obj_merged_relation(all_objs->objs[lcv],lcv);
     printf("\n");
     for (cnt = lcv = 0; lcv < all_objs->num_objs; lcv++)
        if (all_objs->objs[lcv]->owner == NULL) cnt++;
     printf("# of no owner = %d\n\n\n",cnt);
    }
*/
 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    {
     if (update_id_2d)
        {TRACE(printf("%d) num_merged_objs = %d\n",lcv,
                all_objs->objs[lcv]->num_merged_objs);)
         merge_id_2d(&(all_objs->id_2d),all_objs->objs[lcv]);}
     if ((err = merge_objects(all_objs->objs[lcv])) != NO_ERROR) return err;
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
enter_merged_obj - ???
---------------------------------------------------------------------------*/

int
enter_merged_obj(obj,merged_obj)
 struct object_rec *obj,*merged_obj;
{
 int err;
 unsigned long lcv;
 struct object_rec *owner_obj,*owner_merged_obj;

/*
 printf("merge...obj = %d ext = %d merged_obj = %d  ext = %d\n",obj->id,obj->is_external,merged_obj->id,merged_obj->is_external);
*/
 owner_obj = obj;
 owner_merged_obj = merged_obj;
 while (owner_obj->owner != NULL) owner_obj = owner_obj->owner;
 while (owner_merged_obj->owner != NULL)
    owner_merged_obj = owner_merged_obj->owner;
 if (owner_merged_obj == owner_obj)
    {if (merged_obj->is_external) owner_obj->is_external = 1;
     if (obj->is_external) owner_obj->is_external = 1;
/*
     printf("   owner_obj = %d ext = %d owner_merged_obj = %d ext = %d\n\n",
     owner_obj->id,owner_obj->is_external,
     owner_merged_obj->id,owner_merged_obj->is_external);
*/
     return NO_ERROR;}

 if (owner_obj->num_merged_objs >= owner_obj->total_merged_objs)
    {lcv = owner_obj->total_merged_objs;
     get_ptr_memory(&(owner_obj->merged_objs),&(owner_obj->total_merged_objs),10,
        (size_t) sizeof(struct object_rec *),&err);
     if (err != NO_ERROR) return err;
     for (; lcv < owner_obj->total_merged_objs;lcv++)
        owner_obj->merged_objs[lcv] = NULL;
    }
 owner_obj->merged_objs[(owner_obj->num_merged_objs)++] = owner_merged_obj;
 owner_merged_obj->owner = owner_obj;
 if (owner_merged_obj->is_external) owner_obj->is_external = 1;
 if (obj->is_external) owner_obj->is_external = 1;

/*
  printf("   owner_obj = %d ext = %d owner_merged_obj = %d ext = %d\n\n",
     owner_obj->id,owner_obj->is_external,
     owner_merged_obj->id,owner_merged_obj->is_external);
*/
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
merge_objs - ???
---------------------------------------------------------------------------*/

int
merge_objs(all_objs,dest_obj,src_obj)
 struct all_object_rec *all_objs;
 struct object_rec *dest_obj,*src_obj;
{
 int err;

 if ((err = enter_merged_obj(dest_obj,src_obj)) != NO_ERROR) return err;
 return err;
}


/*--------------------------------------------------------------------------
setup_all_object_rec - ???
---------------------------------------------------------------------------*/

int
setup_all_object_rec(all_objs,in_2d,id_2d,is_clear_id_2d,bound,lbval,ubval)
 struct all_object_rec *all_objs;
 struct buf_2d_rec *in_2d,*id_2d;
 int is_clear_id_2d;
 struct int_bound_rec *bound;
 unsigned long lbval,ubval;
{
 int err;

 if (id_2d != NULL)
    {all_objs->id_2d = *id_2d;
     if (is_clear_id_2d) InitBuf2dRecData(&(all_objs->id_2d),(double) .0);}
   else
    {if ((err = SetupBuf2dRec(&(all_objs->id_2d),in_2d->dimx,
         in_2d->dimy,8,0)) != NO_ERROR)
        return err;
     InitBuf2dRecData(&(all_objs->id_2d),(double) .0);
    }

 free_object_recs(all_objs);
 all_objs->in_2d = in_2d;
 all_objs->bound = *bound;
 all_objs->lbval = lbval;
 all_objs->ubval = ubval;
 all_objs->next_id = 1;
 all_objs->cur_obj = NULL;
 return NO_ERROR;

}


/*--------------------------------------------------------------------------
assign_next_id - ???
---------------------------------------------------------------------------*/

int
assign_next_id(all_objs,id_flag,next_id_flag,all_used_flag,max_id,next_num_bits)
 struct all_object_rec *all_objs;
 unsigned short id_flag,next_id_flag,all_used_flag;
 unsigned long max_id,next_num_bits;
{
 unsigned long lcv;
 unsigned long id;
 struct buf_2d_rec _2d;
 int err;

 if (all_objs->id_status & all_used_flag)
    {if (all_objs->num_objs < max_id)
        {id = 1;
         for (lcv = 0; lcv < all_objs->num_objs; lcv++)
            {if (id < all_objs->objs[lcv]->id) break;
               else if (id == all_objs->objs[lcv]->id) id++;
            }
         all_objs->next_id = id;
         return NO_ERROR;}
       else
        {if (next_id_flag == 0) return CANCEL;
         all_objs->id_status &= ~id_flag;
         all_objs->id_status |= next_id_flag;
         init_buf_2d_rec(&_2d);
         if ((err = SetupBuf2dRec(&_2d,all_objs->id_2d.dimx,
                   all_objs->id_2d.dimy,next_num_bits,0)) != NO_ERROR)
                return err;
         Assign2d(&_2d,&(all_objs->id_2d));
         free_buf_2d_rec(&(all_objs->id_2d));
         all_objs->id_2d = _2d;
         all_objs->next_id = max_id + 1;
        }
    }
   else
    {all_objs->next_id++;
     if (all_objs->next_id == max_id) all_objs->id_status |= all_used_flag;
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
get_next_id - ???
---------------------------------------------------------------------------*/

int
get_next_id(all_objs)
 struct all_object_rec *all_objs;
{
 if (all_objs->id_status & ID_IN_255)
    return assign_next_id(all_objs,(unsigned short) ID_IN_255,
       (unsigned short) ID_IN_65535,(unsigned short) ID_255_ALL_USED,255,16);
 if (all_objs->id_status & ID_IN_65535)
    return assign_next_id(all_objs,(unsigned short) ID_IN_65535,
       (unsigned short) ID_IN_4_BYTES,
       (unsigned short) ID_65535_ALL_USED,65535,32);
 if (all_objs->id_status & ID_IN_65535)
    return assign_next_id(all_objs,(unsigned short) ID_IN_4_BYTES,
      (unsigned short) 0,(unsigned short) ID_4_BYTES_ALL_USED,
      (unsigned long) 0xffffffff,32);
 return ~NO_ERROR;
}


/*--------------------------------------------------------------------------
get_obj - ???
---------------------------------------------------------------------------*/

struct object_rec *
get_obj(all_objs,id,err)
 struct all_object_rec *all_objs;
 unsigned long id;
 int *err;
{
 long lcv,posi,total;
 struct object_rec *obj;

 if (the_obj_binary_search(all_objs->objs,
          all_objs->num_objs,id,&posi) == NOT_FOUND)
    {if (all_objs->num_objs == all_objs->total_objs)
        {lcv = all_objs->total_objs;
         get_ptr_memory(&(all_objs->objs),&(all_objs->total_objs),(size_t) 5,
             (size_t) sizeof(struct object_rec *),err);
         if (*err != NO_ERROR) return NULL;
         for (; lcv < all_objs->total_objs;lcv++)
            all_objs->objs[lcv] = NULL;
        }
     total = 0;
     get_ptr_memory(&(all_objs->objs[all_objs->num_objs]),&total,(size_t) 1,
             (size_t) sizeof(struct object_rec),err);
     if (*err != NO_ERROR) return NULL;
     obj = all_objs->objs[all_objs->num_objs];
     init_object_rec(obj);
     if (all_objs->num_objs > 0)
        for (lcv = all_objs->num_objs; lcv > posi; lcv--)
            all_objs->objs[lcv] = all_objs->objs[lcv - 1];
     (all_objs->num_objs)++;
     all_objs->objs[posi] = obj;
     obj->id = id;
     if ((*err = get_next_id(all_objs)) != NO_ERROR) return NULL;
    }
 *err = NO_ERROR;
 return all_objs->objs[posi];
}


/*--------------------------------------------------------------------------
sort_enter_obj_xy - ???
---------------------------------------------------------------------------*/

int
sort_enter_obj_xy(obj,status,x,y)
 struct object_rec *obj;
 unsigned char status;
 unsigned long x,y;
{
 int err;
 struct xy_rec xy;

 xy.x = x;
 xy.y = y;
 if (obj->num_pts > 0)
    if (bsearch(&xy,obj->pts,obj->num_pts,sizeof(struct xy_rec),
          sort_xy_rec_ascendingly_proc) != NULL)
       return NO_ERROR;
 if (obj->num_pts >= obj->total_pts)
    {
     get_ptr_memory(&(obj->pts),&(obj->total_pts),(size_t) ADD_NUM_XY_RECS,
            (size_t) sizeof(struct xy_rec),&err);
     if (err != NO_ERROR) return err;
    }
 obj->pts[obj->num_pts].status = status;
 obj->pts[obj->num_pts].x = x;
 obj->pts[obj->num_pts++].y = y;

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
enter_obj_xy - ???
---------------------------------------------------------------------------*/

int
enter_obj_xy(obj,status,x,y)
 struct object_rec *obj;
 unsigned char status;
 unsigned long x,y;
{
 int err;

 if (obj->num_pts >= obj->total_pts)
    {
     get_ptr_memory(&(obj->pts),&(obj->total_pts),(size_t) ADD_NUM_XY_RECS,
            (size_t) sizeof(struct xy_rec),&err);
     if (err != NO_ERROR) return err;
    }
 obj->pts[obj->num_pts].status = status;
 obj->pts[obj->num_pts].x = x;
 obj->pts[obj->num_pts++].y = y;

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
enter_obj_xy_by_posi - ???
---------------------------------------------------------------------------*/

int
enter_obj_xy_by_posi(obj,status,x,y,posi)
 struct object_rec *obj;
 unsigned char status;
 unsigned long x,y,posi;
{
 int err;
 unsigned long lcv;

 if (obj->num_pts >= obj->total_pts)
    {
     get_ptr_memory(&(obj->pts),&(obj->total_pts),(size_t) ADD_NUM_XY_RECS,
            (size_t) sizeof(struct xy_rec),&err);
     if (err != NO_ERROR) return err;
    }
 obj->num_pts++;
 for (lcv = obj->num_pts; lcv > posi; lcv--)
    {obj->pts[lcv] = obj->pts[lcv - 1];
     if (lcv == 0) break;}
 obj->pts[posi].status = status;
 obj->pts[posi].x = x;
 obj->pts[posi].y = y;

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
enter_cur_obj_xy - ???
---------------------------------------------------------------------------*/

int
enter_cur_obj_xy(all_objs,status,x,y)
 struct all_object_rec *all_objs;
 unsigned char status;
 unsigned long x,y;
{
 int err;

 if (all_objs->cur_obj == NULL)
    {all_objs->cur_obj = get_obj(all_objs,all_objs->next_id,&err);
     if (err != NO_ERROR) return err;
    }
 return enter_obj_xy(all_objs->cur_obj,status,x,y);
}



/*--------------------------------------------------------------------------
enter_xy_into_cur_obj - ???

By using the infection-like technique, each object element is assigned an
object id by using the following rules :-
  Assumptions :
      a) the [x,y] element is the center element of a 3 * 3 matrix
      b) by scanning from left to right, only the object ids of the first 4 
         elements are considered

  Rules :
      1) if any of the first 4 elements are valid elements, since they are
         adjacent to [x,y], element [x,y] should then have the same ids as
         the 4.  And if the 4 and [x,y] are connected, they share the same id,
         therefore, if they have different ids, all the elements considered
         so far each having the same id as any of those ids should be 
         merged so that they have a common id.
      2) if the 4 are not valid, assign a new id for [x,y].
---------------------------------------------------------------------------*/

int
enter_xy_into_cur_obj(all_objs,x,y)
 struct all_object_rec *all_objs;
 unsigned long x,y;
{
 int err,err1;
 unsigned long ids[4],num_ids;
 unsigned char neighbors,status;
 static unsigned char internal_pt = 0x3a;
 unsigned long tempx,tempy,val;
 struct object_rec *src_obj;
 unsigned long lcv;
 static int xy[4][2] = {{ -1, -1},{ 0, -1},{ 1, -1},{-1, 0}};
 struct xy_rec xys[4];

 neighbors = 0;
 if (all_objs->cur_obj == NULL)
    {all_objs->cur_obj = get_obj(all_objs,all_objs->next_id,&err);
     if (err != NO_ERROR) return err;
    }
   else
    {num_ids = 0;
     for (lcv = 0; lcv < 4; lcv++)
        {tempx = x + xy[lcv][0];
         tempy = y + xy[lcv][1];
         if ((tempx >= all_objs->bound.left) && 
             (tempx <= all_objs->bound.right) &&
             (tempy >= all_objs->bound.top) &&
             (tempy <= all_objs->bound.bottom))
            {
             if (val = get_1d_buf_value(all_objs->id_2d.buf[tempy],tempx,
                        all_objs->id_2d.pixel_depth))
                {
                 xys[num_ids].x = tempx;
                 xys[num_ids].y = tempy;
                 ids[num_ids++] = val;
                 neighbors |= (1 << lcv);
                }
            }
        }
     if (num_ids == 0)
        {
         all_objs->cur_obj = get_obj(all_objs,all_objs->next_id,&err);
         if (err != NO_ERROR) return err;
        }
       else
        {
         for (lcv = 1; lcv < num_ids; lcv++)
            if (ids[lcv - 1] != ids[lcv]) break;
         if (lcv == num_ids)
            {if (ids[0] != all_objs->cur_obj->id)
                {all_objs->cur_obj = get_obj(all_objs,ids[0],&err);
                 if (err != NO_ERROR) return err;
                }
            }
           else 
            {
             for (lcv = 0; lcv < num_ids; lcv++)
                if (all_objs->cur_obj->id == ids[lcv])
                    break;
             if (lcv == num_ids)
                {all_objs->cur_obj = get_obj(all_objs,ids[0],&err);
                 if (err != NO_ERROR) return err;
                 lcv = 1;}
               else lcv = 0;
             for (; lcv < num_ids; lcv++)
                if (all_objs->cur_obj->id != ids[lcv])
                   {src_obj = get_obj(all_objs,ids[lcv],&err1);
                    if (err1 == NO_ERROR)
                       merge_objs(all_objs,all_objs->cur_obj,src_obj);
                   }
            }
        }
     if (((neighbors & 0x0a) == 0x0a))
        {tempx = x + 1;
         if ((tempx >= all_objs->bound.left) &&
             (tempx <= all_objs->bound.right))
            if (get_1d_buf_value(all_objs->in_2d->buf[y],tempx,
                        all_objs->in_2d->pixel_depth))
               {neighbors |= 16;
                tempy = y + 1;
                if ((tempy >= all_objs->bound.top) &&
                    (tempy <= all_objs->bound.bottom))
                   if (get_1d_buf_value(all_objs->in_2d->buf[tempy],x,
                        all_objs->in_2d->pixel_depth))
                      neighbors |= 32;
               }
        }

    }
 
 if ((neighbors & internal_pt) == internal_pt) status = OBJ_INTERNAL_PT;
   else status = OBJ_BOUNDARY_PT;
 if ((err = enter_obj_xy(all_objs->cur_obj,status,x,y)) == NO_ERROR)
    set_1d_buf_value(all_objs->id_2d.buf[y],x,all_objs->id_2d.pixel_depth,
                     (unsigned int) all_objs->cur_obj->id);

 return err;
}



/*--------------------------------------------------------------------------
discard_internal_pts - ???
---------------------------------------------------------------------------*/

void
discard_internal_pts(obj)
 struct object_rec *obj;
{
 unsigned long cnt,tot;

 for (tot = cnt = 0; cnt < obj->num_pts; cnt++)
    if (!(obj->pts[cnt].status & OBJ_INTERNAL_PT))
       {if (cnt != tot)
           obj->pts[tot] = obj->pts[cnt];
        tot++;
       }
 obj->num_pts = tot;
}


/*--------------------------------------------------------------------------
discard_internal_buf_pts - ???
---------------------------------------------------------------------------*/

void
discard_internal_buf_pts(obj,obj_2d)
 struct object_rec *obj;
 struct buf_2d_rec *obj_2d;
{
 unsigned long cnt,tot;

 for (tot = cnt = 0; cnt < obj->num_pts; cnt++)
    if (!(obj->pts[cnt].status & OBJ_INTERNAL_PT))
       {if (cnt != tot)
           obj->pts[tot] = obj->pts[cnt];
        tot++;
       }
      else set_1d_buf_value(obj_2d->buf[obj->pts[cnt].y],
                      (unsigned long) obj->pts[cnt].x,
                               obj_2d->pixel_depth,0);
 obj->num_pts = tot;
}



/*--------------------------------------------------------------------------
is_pt_bounded - ???
---------------------------------------------------------------------------*/

int
is_pt_bounded(_2d,x,y)
 struct buf_2d_rec *_2d;
 int x,y;
{
 long tempx,tempy,lcv,right,bottom;
 static int xy[4][2] = {{ 0, -1},{ 1, 0},{ 0, 1},{-1, 0}};

 right = _2d->dimx - 1;
 bottom = _2d->dimy - 1;
 for (lcv = 0; lcv < 4; lcv++)
    {tempx = x + xy[lcv][0];
     tempy = y + xy[lcv][1];
     if ((tempx >= 0) && (tempx <= right) &&
         (tempy >= 0) && (tempy <= bottom))
        {
         if (!get_1d_buf_value(_2d->buf[tempy],tempx,_2d->pixel_depth))
            return 0;
        }
       else return 0;
    }
 return 1;
}


/*--------------------------------------------------------------------------
discard_redundant_pts - ???
---------------------------------------------------------------------------*/

void
discard_redundant_pts(obj,obj_2d)
 struct object_rec *obj;
 struct buf_2d_rec *obj_2d;
{
 unsigned long cnt,tot;

 for (tot = cnt = 0; cnt < obj->num_pts; cnt++)
    if (!(obj->pts[cnt].status & OBJ_INTERNAL_PT))
       {if (is_pt_bounded(obj_2d,(int) obj->pts[cnt].x,(int) obj->pts[cnt].y))
           {
            obj->pts[cnt].status &= ~OBJ_SET_PT;
            obj->pts[cnt].status |= OBJ_INTERNAL_PT;}
       }
 discard_internal_buf_pts(obj,obj_2d);
}


/*--------------------------------------------------------------------------
discard_bounded_pts - ???
---------------------------------------------------------------------------*/

int
discard_bounded_pts(all_objs)
 struct all_object_rec *all_objs;
{
 unsigned long lcv,cnt,tot;

 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    {
     for (tot = cnt = 0; cnt < all_objs->objs[lcv]->num_pts; cnt++)
        discard_internal_pts(all_objs->objs[lcv]);
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
get_affected_neighbors - ???
---------------------------------------------------------------------------*/

void
get_affected_neighbors(neighbors,bound,x,y)
 struct xy_rec neighbors[4];
 struct int_bound_rec *bound;
 unsigned long x,y;
{
 long tempx,tempy,lcv;
 static int xy[4][2] = {{ 0, -1},{ 1, 0},{ 0, 1},{-1, 0}};

 for (lcv = 0; lcv < 4; lcv++)
    {tempx = x + xy[lcv][0];
     tempy = y + xy[lcv][1];
     if ((tempx >= bound->left) && (tempx <= bound->right) &&
         (tempy >= bound->top) && (tempy <= bound->bottom))
        {
         neighbors[lcv].x = tempx;
         neighbors[lcv].y = tempy;
         neighbors[lcv].status = 1;
        }
       else neighbors[lcv].status = 0;
    }
}


/*--------------------------------------------------------------------------
get_neighbor_ids - ???
---------------------------------------------------------------------------*/

void
get_neighbor_ids(in_2d,id_2d,xys,ids,num_ids,bound,x,y)
 struct buf_2d_rec *in_2d,*id_2d;
 struct xy_rec xys[4];
 int ids[4],*num_ids;
 struct int_bound_rec *bound;
 long x,y;
{
 long tempx,tempy,lcv;
 static int xy[4][2] = {{ 0, -1},{ 1, 0},{ 0, 1},{-1, 0}};
 unsigned long val;

 for (*num_ids = 0,lcv = 0; lcv < 4; lcv++)
    {tempx = x + xy[lcv][0];
     tempy = y + xy[lcv][1];
     if ((tempx >= bound->left) && (tempx <= bound->right) &&
         (tempy >= bound->top) && (tempy <= bound->bottom))
        {
         val = get_1d_buf_value(in_2d->buf[tempy],tempx,in_2d->pixel_depth);
         if (val == 0) continue;
         xys[*num_ids].x = tempx;
         xys[*num_ids].y = tempy;
         ids[(*num_ids)++] = get_1d_buf_value(id_2d->buf[tempy],
                       tempx,id_2d->pixel_depth);
        }
    }

}


/*--------------------------------------------------------------------------
get_largest_obj - ???
---------------------------------------------------------------------------*/

struct object_rec *
get_largest_obj(all_objs)
 struct all_object_rec *all_objs;
{
 unsigned long lcv,num_pts;
 struct object_rec *largest_obj;

 if (all_objs->num_objs == 0) return NULL;
 for (num_pts = lcv = 0; lcv < all_objs->num_objs; lcv++)
    if (all_objs->objs[lcv]->num_pts > num_pts)
       {num_pts = all_objs->objs[lcv]->num_pts;
        largest_obj = all_objs->objs[lcv];
       }
 return largest_obj;
}


/*--------------------------------------------------------------------------
get_object_rec_obj_bound - ???
---------------------------------------------------------------------------*/

void
get_object_rec_obj_bound(obj)
 struct object_rec *obj;
{
 unsigned long lcv;
 int left,right,top,bottom;

 left = 0x7fffffff;
 top = 0x7fffffff;
 right = bottom = 0;
 for (lcv = 0; lcv < obj->num_pts; lcv++)
    {
     if (left > obj->pts[lcv].x) left = obj->pts[lcv].x;
     if (right < obj->pts[lcv].x) right = obj->pts[lcv].x;
     if (top > obj->pts[lcv].y) top = obj->pts[lcv].y;
     if (bottom < obj->pts[lcv].y) bottom = obj->pts[lcv].y;
    }
 setup_int_bound_rec(&(obj->bound),left,top,right,bottom);
}


/*--------------------------------------------------------------------------
delete_duplicate_object_rec_obj_pts - ???
---------------------------------------------------------------------------*/

int
delete_duplicate_object_rec_obj_pts(obj)
 struct object_rec *obj;
{
 unsigned long lcv,cnt;

 if (obj->num_pts <= 1) return NO_ERROR;
 sort_xy_rec(obj);
 for (cnt = 0,lcv = 1; lcv < obj->num_pts; lcv++)
    if ((obj->pts[cnt].x != obj->pts[lcv].x) ||
        (obj->pts[cnt].y != obj->pts[lcv].y))
       {cnt++;
        if (cnt != lcv)
           {
            obj->pts[cnt].x = obj->pts[lcv].x;
            obj->pts[cnt].y = obj->pts[lcv].y;}
       }
 obj->num_pts = cnt + 1;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
delete_obj_internal_boundary_pts - ???
---------------------------------------------------------------------------*/

int
delete_obj_internal_boundary_pts(obj,sub)
 struct object_rec *obj;
 struct all_object_rec *sub;
{
 unsigned long lcv,cnt,val,cnt_valids;
 long tempx,tempy;
 static int xy[4][2] = {{ 0, -1},{ 1, 0},{ 0, 1},{-1, 0}};
 int is_delete,num_negs;
 unsigned long posi;

 for (is_delete = cnt = 0; cnt < obj->num_pts; cnt++)
    {
     for (cnt_valids = num_negs = 0,lcv = 0; lcv < 4; lcv++)
        {tempx = obj->pts[cnt].x + xy[lcv][0];
         tempy = obj->pts[cnt].y + xy[lcv][1];
         if ((tempx >= sub->bound.left) && (tempx <= sub->bound.right) &&
             (tempy >= sub->bound.top) && (tempy <= sub->bound.bottom))
            {
             if (val = get_1d_buf_value(sub->id_2d.buf[tempy],
                   tempx,sub->id_2d.pixel_depth))
                {
                 if (the_obj_binary_search(sub->objs,
                        sub->num_objs,val,&posi) == NO_ERROR)
                    if (sub->objs[posi]->is_external)
                       {num_negs = 0;
                        break;
                       }
                 num_negs += 1;
                }
            }
           else
            {num_negs = 0;
             break;}
        }
     if (num_negs)
        {is_delete = 1;
         obj->pts[cnt].status |= OBJ_DELETED_PT;
        }
    }
 if (is_delete)
    {for (lcv = cnt = 0; cnt < obj->num_pts; cnt++)
        {if (!(obj->pts[cnt].status & OBJ_DELETED_PT))
            {obj->pts[lcv] = obj->pts[cnt];
             lcv++;}
           else
            {
             set_1d_buf_value(sub->in_2d->buf[obj->pts[cnt].y],
                              (unsigned long) obj->pts[cnt].x,
                               sub->in_2d->pixel_depth,0);
            }
        }
     obj->num_pts = lcv;
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
is_obj_pt_external - ???
---------------------------------------------------------------------------*/

int
is_obj_pt_external(obj,in_2d,fx,fy)
 struct object_rec *obj;
 struct buf_2d_rec *in_2d;
 int fx,fy;
{
 int is_external;
 long x,y;
 unsigned long val;

 for (is_external = 1,x = fx - 1; x >= obj->bound.left; x--)
    if (val = get_1d_buf_value(in_2d->buf[fy],x,in_2d->pixel_depth))
       {
        if (val == obj->id) is_external = 0;
        break;}
 if (is_external) return 1;
 for (is_external = 1,x = fx + 1; x <= obj->bound.right; x++)
    if (val = get_1d_buf_value(in_2d->buf[fy],x,in_2d->pixel_depth))
       {
        if (val == obj->id) is_external = 0;
        break;}
 if (is_external) return 1;
 for (is_external = 1,y = fy + 1;y <= obj->bound.bottom; y++)
    if (val = get_1d_buf_value(in_2d->buf[y],fx,in_2d->pixel_depth))
       {
        if (val == obj->id) is_external = 0;
        break;}
 if (is_external) return 1;
 for (is_external = 1,y = fy - 1;y >= obj->bound.top; y--)
    if (val = get_1d_buf_value(in_2d->buf[y],fx,in_2d->pixel_depth))
       {
        if (val == obj->id) is_external = 0;
        break;}

 return is_external;
}


/*--------------------------------------------------------------------------
define_all_negative_boundary_objs - ???
---------------------------------------------------------------------------*/

int
define_all_negative_boundary_objs(sub,obj)
 struct all_object_rec *sub;
 struct object_rec *obj;
{
 unsigned long lcv,cnt;
 struct object_rec *obj1;

/*
 printf("obj l = %d t = %d  r = %d  b = %d\n",
        obj->bound.left,obj->bound.top,obj->bound.right,obj->bound.bottom);
*/
 for (lcv = 0; lcv < sub->num_objs; lcv++)
    {obj1 = sub->objs[lcv];
     if (obj1->is_external) continue;
     for (cnt = 0; cnt < obj1->num_pts; cnt++)
        if (obj1->is_external = is_obj_pt_external(obj,sub->in_2d,
              (int) obj1->pts[cnt].x,(int) obj1->pts[cnt].y))
           break;
/*
     printf("define_all obj1->is_external = %d\n",(unsigned long) obj1->is_external);
*/
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
delete_all_negative_boundary_objs - ???
---------------------------------------------------------------------------*/

int
delete_all_negative_boundary_objs(sub)
 struct all_object_rec *sub;
{
 unsigned long cnt,lcv;

 for (cnt = lcv = 0; lcv < sub->num_objs; lcv++)
    {if (sub->objs[lcv]->is_external)
        {free_object_rec(sub->objs[lcv]);
         c_free(sub->objs[lcv]);}
       else sub->objs[cnt++] = sub->objs[lcv];
    }
 sub->num_objs = cnt;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
pr_object_rec - ???
---------------------------------------------------------------------------*/

void
pr_object_rec(obj,obj_num,is_pr_xys)
 struct object_rec *obj;
 long obj_num;
 int is_pr_xys;
{
 unsigned long cnt;

 printf("obj# %p obj->num_pts = %ld id = %d ext = %d\n",
            obj,obj->num_pts,(int) obj->id,obj->is_external);
 printf(" l = %d t = %d  r = %d  b = %d\n",
        obj->bound.left,obj->bound.top,obj->bound.right,obj->bound.bottom);
 if (is_pr_xys)
    {
     for (cnt = 0; cnt < obj->num_pts; cnt++)
        printf("obj# %ld  id = %d ext = %d pt[%ld] status = %lx x = %d  y = %d\n",obj_num,
               (int) obj->id,obj->is_external,
               cnt,(unsigned long) obj->pts[cnt].status,
               obj->pts[cnt].x,obj->pts[cnt].y);
     printf("obj->num_pts = %ld\n",obj->num_pts);}
 printf("\n");
}


/*--------------------------------------------------------------------------
pr_all_object_rec - ???
---------------------------------------------------------------------------*/

void
pr_all_object_rec(all_objs,is_pr_xys)
 struct all_object_rec *all_objs;
 int is_pr_xys;
{
 unsigned long lcv,tot;
 struct object_rec *obj;

 printf ("\nall_objs->num_objs = %ld  total objs = %ld\n",
             all_objs->num_objs,all_objs->total_objs);
 pr_int_bound_rec(&(all_objs->bound));

 for (tot = lcv = 0; lcv < all_objs->num_objs; lcv++)
    {obj = all_objs->objs[lcv];
     tot += obj->num_pts;
     pr_object_rec(obj,lcv,is_pr_xys);

     if (obj->excluded_regions != NULL)
        {printf("\n");
         printf("**************sub region....\n");
         pr_all_object_rec(all_objs->objs[lcv]->excluded_regions,is_pr_xys);
         printf("**************sub region   end....\n");
         printf("\n");
        }
    }
 printf ("all_objs->num_objs = %ld  total pts = %ld\n",all_objs->num_objs,tot);
 pr_int_bound_rec(&(all_objs->bound));
 printf("\n");

 return /*NO_ERROR*/;
}


/*--------------------------------------------------------------------------
detect_all_objs - ???
---------------------------------------------------------------------------*/

int
detect_all_objs(all_objs,update_id_2d)
 struct all_object_rec *all_objs;
 int update_id_2d;
{
 unsigned long row,col,val;
 int err;

 TRACE(printf("detect_all_objs...1\n"))
 for (row = all_objs->bound.top; row <= all_objs->bound.bottom; row++)
    for (col = all_objs->bound.left; col <= all_objs->bound.right; col++)
       {
        val = get_1d_buf_value(all_objs->in_2d->buf[row],col,
                                all_objs->in_2d->pixel_depth);
        if ((val >= all_objs->lbval) && (val <= all_objs->ubval))
           {if ((err = enter_xy_into_cur_obj(all_objs,col,row)) != NO_ERROR)
                   return err;
           }
        
       }
 TRACE(printf("detect_all_objs...2\n"))
 merge_all_objs_rec_merged_objs(all_objs,update_id_2d,0);
 TRACE(printf("detect_all_objs...3\n"))

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
detect_objects - ???
---------------------------------------------------------------------------*/

int
detect_objects(_2d,bound_area,curves,total_curves,num_curves,lbval,ubval)
 struct buf_2d_rec *_2d;
 struct int_bound_rec *bound_area;
 struct curve_rec ***curves;
 unsigned int *total_curves,*num_curves;
 unsigned long lbval,ubval;
{
 struct all_object_rec all_objs;
 struct int_bound_rec bound;
 int err;

 init_all_object_rec(&all_objs);
 if (bound_area == NULL)
    setup_int_bound_rec(&bound,0,0,_2d->dimx - 1,_2d->dimy - 1);
   else bound = *bound_area;

 if ((err = setup_all_object_rec(&all_objs,_2d,NULL,0,&bound,lbval,ubval)) == 
                 NO_ERROR)
    {
     if ((err = detect_all_objs(&all_objs,1)) == NO_ERROR)
        {TRACE(printf("detect_objects...2\n"))
         err = get_all_obj_curve_recs(&all_objs,curves,
                    total_curves,num_curves);
/*
         printf("detect_objects...curves = %u total_curves = %d num_curves = %d\n",*curves,*total_curves,*num_curves);
*/
        }
    }
 free_all_object_rec1(&all_objs,1);

 return err;
}


/*--------------------------------------------------------------------------
scan_objects - ???
---------------------------------------------------------------------------*/

int
scan_objects(_2d,bound_area,curves,total_curves,num_curves,lbval,ubval)
 struct buf_2d_rec *_2d;
 struct int_bound_rec *bound_area;
 struct curve_rec ***curves;
 unsigned int *total_curves,*num_curves;
 unsigned long lbval,ubval;
{
 
 *total_curves = *num_curves = 0;
 *curves = NULL;
 return detect_objects(_2d,bound_area,
              curves,total_curves,num_curves,lbval,ubval);
}

