/****************************************************************************
segment_1_echo-1.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: segment_1_echo-1.c,v 1.7 1999/07/07 17:41:19 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "mri_format.h"
#include "segment.h"
#include "edge.h"
#include "nria_procedures.h"


/*
#define PRINT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
*/
#define PRINT(x)
#define PRT1(x)
#define PRT(x)
#define TRACE(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)



struct indx_weight_rec
   {
    unsigned char indx;
    float weight;
   };

struct type_diff_rec
   {
    unsigned short type;
    float diffx,diffy;
   };


/* Functions defined in this file */
int sort_indx_weight_rec_proc(const void *w1, const void *w2);
int SuggestNeighborType(struct neighbor_type_rec *neigh,
    struct type_val_rec *cur_pix, long x, long y, struct buf_2d_rec *neigh_2d,
    unsigned short *suggest_type, long num_connected);
int TypeSolvable(struct neighbor_type_rec *neigh,
    struct type_val_rec *cur_pix);
int solve_deadlock_pixels(struct pixel_type_ave_rec *type_aves,
    unsigned long num_type_aves, struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve,
    struct pixel_stack_rec_ptr *image_mask, int *is_done);



/*--------------------------------------------------------------------------
sort_indx_weight_rec_proc - ???
--------------------------------------------------------------------------*/

int
sort_indx_weight_rec_proc(w1,w2)
 const void *w1,*w2;
{
 if (((struct indx_weight_rec *) w1)->weight >
     ((struct indx_weight_rec *) w2)->weight) return -1;
 if (((struct indx_weight_rec *) w1)->weight <
     ((struct indx_weight_rec *) w2)->weight) return 1;
 return 0;
}


/***********
sort_xy_neighbor_type_rec_proc(xy1,xy2)
 const void *xy1,*xy2;
{
 int cnt1,cnt2;

 cnt1 = _EdgeCounts[
       ((struct xy_pixel_neighbor_type_rec *) xy1)->pix_neigh->neigh->done_neighs];
 cnt2 = _EdgeCounts[
       ((struct xy_pixel_neighbor_type_rec *) xy2)->pix_neigh->neigh->done_neighs];
 if (cnt1 > cnt2) return -1;
 if (cnt1 < cnt2) return 1;
 return 0;
}
**************/


/*--------------------------------------------------------------------------
SuggestNeighborType - ???
--------------------------------------------------------------------------*/

int
SuggestNeighborType(neigh,cur_pix,x,y,neigh_2d,suggest_type,num_connected)
 struct neighbor_type_rec *neigh;
 struct type_val_rec *cur_pix;
 long x,y;
 struct buf_2d_rec *neigh_2d;
 unsigned short *suggest_type;
 long num_connected;
{
 struct type_val_rec *pix;
 long indx,indx1,lcv,x1,y1,cnt_type;
 int next;
 struct pixel_neighbor_type_rec *pix_neigh;
 unsigned char done_neighs;
 struct type_conn_fac_rec neigh_weights[8];
 unsigned short type,num_neighs;

 done_neighs = neigh->done_neighs;
 if (num_connected > ((unsigned long) 8 - _0Edge[done_neighs][0]))
   return CANCEL;
 for (lcv = 0; lcv < (unsigned long)neigh->num_neighs; lcv++)
    neigh_weights[lcv] = neigh->neighs[lcv];
 num_neighs = neigh->num_neighs;

 for (lcv = 1; lcv <= (unsigned long)_0Edge[done_neighs][0]; lcv++)
    {next = _0Edge[done_neighs][lcv];
     x1 = x + neighbor_Offset[next][0];
     y1 = y + neighbor_Offset[next][1];
     pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(neigh_2d->buf[y1],
                         x1,neigh_2d->pixel_depth);
     pix = pix_neigh->pix;
     for (cnt_type = 0; cnt_type < (unsigned long)pix->num_types; cnt_type++)
        {
         type = pix->types[cnt_type].indx;
         for (indx = 0; indx < (unsigned long)cur_pix->num_types; indx++)
            if (cur_pix->types[indx].indx == type)
               break;
         if (indx == cur_pix->num_types)
            {continue;}

         for (indx1 = 0; indx1 < (unsigned long)num_neighs; indx1++)
            if (neigh_weights[indx1].type == type)
               {neigh_weights[indx1].conn_fac += neigh->weights[next];
                break;}
         if (indx1 == num_neighs)
            {neigh_weights[indx1].conn_fac = neigh->weights[next];
             neigh_weights[indx1].type = type;
             num_neighs += 1;
            }
        }
    }
 if (num_neighs > 1)
    qsort(neigh_weights,num_neighs,sizeof(*neigh_weights),
                                  sort_type_conn_fac_rec_proc);
 if (num_neighs > 0)
    {*suggest_type = neigh_weights[0].type;
     return NO_ERROR;}
   else return CANCEL;
}

/**********************
suggest_types(neigh_2d,resolve,image_mask)
 struct buf_2d_rec *neigh_2d;
 struct pixel_stack_rec_ptr *resolve,*image_mask;
{
 long num,total,lcv;
 struct neighbor_type_rec *neigh;
 struct pixel_neighbor_type_rec *pix_neigh;
 struct stack_xy_rec *top;
 int err;
 long row,col;
 unsigned short type;

 TRACE(printf("suggest_types resolve->num_lists = %d\n",resolve->num_lists))

 for (num = 0; num < resolve->num_lists; num++)
    {top = resolve->lists[num]->top.next;
     while (top != NULL)
        {pix_neigh = top->pix_neigh;
         neigh = pix_neigh->neigh;
         if (SuggestNeighborType(neigh,pix_neigh->pix,(long) top->x,(long) top->y,
                                      neigh_2d,&type,0) == NO_ERROR)
            {neigh->neighs[0].type = type;
             neigh->num_neighs = 1;
             neigh->status = TYPE_RESOLVED;
             if (neigh->xy_ptr->last != NULL)
                neigh->xy_ptr->last->next = neigh->xy_ptr->next;
             if (neigh->xy_ptr->next != NULL)
                neigh->xy_ptr->next->last = neigh->xy_ptr->last;
             c_free(neigh->xy_ptr);
             neigh->xy_ptr = NULL;
            }

         top = top->next;
        }
    }
 TRACE(printf("suggest_types 2\n"))
 return NO_ERROR;
}
*******************/


/*--------------------------------------------------------------------------
TypeSolvable - ???
--------------------------------------------------------------------------*/

int
TypeSolvable(neigh,cur_pix)
 struct neighbor_type_rec *neigh;
 struct type_val_rec *cur_pix;
{
 long keep;
 unsigned char done_neighs;
 float leftover;

 if (cur_pix->num_types == 1) return NO_ERROR;
 if (neigh->num_neighs == 0) return CANCEL; 
 done_neighs = neigh->done_neighs;
 if (_0Edge[done_neighs][0] > 0)
    {leftover = .0;
     for (keep = 1; keep <= (unsigned long)_0Edge[done_neighs][0]; keep++)
        leftover += neigh->weights[_0Edge[done_neighs][keep]];
     if ((leftover > neigh->neighs[0].conn_fac) ||
         ((neigh->num_neighs > 1) &&
          ((neigh->neighs[1].conn_fac + leftover)
               > neigh->neighs[0].conn_fac)))
        return CANCEL;
    }

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
solve_deadlock_pixels - ???
--------------------------------------------------------------------------*/

int
solve_deadlock_pixels(type_aves,num_type_aves,neigh_2d,resolve,image_mask,is_done)
 struct pixel_type_ave_rec *type_aves;
 unsigned long num_type_aves;
 struct buf_2d_rec *neigh_2d;
 struct pixel_stack_rec_ptr *resolve,*image_mask;
 int *is_done;
{
 long num,keep,lcv,next,next1,x,y,x1,y1,indx,cnt,cur,total,all,cnt_0,cnt18;
 unsigned short type,type1;
 struct type_val_rec *cur_pix,*pix;
 struct stack_xy_rec *top;
 unsigned char done_neighs1;
 int err,is_drop,done,ok,yes,is_max,is_avexy,flag;
 unsigned long total_xys,num_xys,num_xys1,total_local_incomps,num_local_incomps,
               total_type_diffs,num_type_diffs;
 struct xy_pixel_neighbor_type_rec *xys,*local_incomps;
 struct type_diff_rec *type_diffs;
 struct neighbor_type_rec *neigh,*neigh1,*neigh2;
 struct pixel_neighbor_type_rec *pix_neigh,*pix_neigh2;
 struct indx_weight_rec indx_weights[8],*indx_weight_ptr;
 unsigned long *type_cnts,*type_cnts1;
 float avex,avey,avex1,avey1,diffx,diffy,avexy,avexy1;

 *is_done = 1;
 type_cnts = NULL;
 type_cnts1 = NULL;
 if (((err = get_ptr(&type_cnts,NULL,num_type_aves,(size_t) sizeof(*type_cnts)))
       != NO_ERROR) ||
     ((err = get_ptr(&type_cnts1,NULL,num_type_aves,(size_t) sizeof(*type_cnts1)))
       != NO_ERROR))
    {c_free(type_cnts);
     c_free(type_cnts1);
     return err;}

 all = cnt_pixel_stack_rec_ptr(resolve);
 PRT2(printf("solve_deadlock_pixels...all = %d num_lists = %d  num_type_aves = %d\n",
           all,resolve->num_lists,num_type_aves))
 total = 0;
 total_local_incomps = total_xys = total_type_diffs = 0;
 num_local_incomps = 0;
 done = 0;
 err = NO_ERROR;
 PRT3(cnt10 = cnt12 = cnt14 = 0;)
 PRT4(cnt16 = cnt13 = cnt11 = cnt15 = cnt17 = cnt18 = 0;)
 indx_weight_ptr = (struct indx_weight_rec *) indx_weights;
 while (!done)
    {done = 1;
     is_drop = 0;
     cnt_0 = 0;
     for (yes = 0,num = 0; num < resolve->num_lists; num++)
        {if ((top = resolve->lists[num]->top.next) == NULL)
            {is_drop = 1;
             continue;}
         while (top != NULL) 
            {pix_neigh = top->pix_neigh;
             neigh = pix_neigh->neigh;
             if (neigh->num_neighs == 0)
                {top = top->next;
                 cnt_0 += 1;
                 continue;}
             yes = 1;
             if ((neigh->status & TYPE_PROCESSED) == 0)
                {
                 done = 0;
                 num_xys = 1;
                 if (num_xys >= total_xys)
                    if ((err = get_ptr(&xys,&total_xys,1000,(size_t) sizeof(*xys))) != NO_ERROR)
                       break;
                 cur_pix = pix_neigh->pix;
                 neigh->status |= TYPE_CONSIDER;
                 xys[0].x = top->x;
                 xys[0].y = top->y;
                 xys[0].pix_neigh = pix_neigh;

                 for (lcv = 0; lcv < num_type_aves; lcv++)
                    {type_cnts[lcv] = 0;
                     type_cnts1[lcv] = 0;}
                 for (cur = 0; cur < num_xys; cur++)
                    {neigh1 = xys[cur].pix_neigh->neigh;
                     x = xys[cur].x;
                     y = xys[cur].y;
                     done_neighs1 = neigh1->done_neighs;
                     for (keep = 0; keep < 8; keep++)
                        {indx_weights[keep].weight = neigh1->weights[keep];
                         indx_weights[keep].indx = keep;
                        }
                     qsort(indx_weight_ptr,8,sizeof(*indx_weight_ptr),sort_indx_weight_rec_proc);
                     if (indx_weights[0].weight > .0)
                        {for (keep = 0; keep < 8; keep++)
                            {if ((keep != 0) &&
                                 (indx_weights[0].weight > indx_weights[keep].weight))
                                break;
                             if (!(done_neighs1 & _EdgeBit[indx_weights[keep].indx]))
                                continue;
                             x1 = x + neighbor_Offset[indx_weights[keep].indx][0];
                             y1 = y + neighbor_Offset[indx_weights[keep].indx][1];
                             pix_neigh2 = (struct pixel_neighbor_type_rec *)
                                  get_1d_buf_value(neigh_2d->buf[y1],
                                        (long) x1,neigh_2d->pixel_depth);
                             if ((neigh2 = pix_neigh2->neigh) == NULL)
                                type_cnts[pix_neigh2->pix->types[0].indx] += 1;
                               else if (neigh2->status & TYPE_RESOLVED)
                                type_cnts[pix_neigh2->neigh->neighs[0].type] += 1;
                            }
                        }
                     for (lcv = 1; 
                         lcv <= (unsigned long)_0Edge[done_neighs1][0]; lcv++)
                        {next = _0Edge[done_neighs1][lcv];
                         x1 = x + neighbor_Offset[next][0];
                         y1 = y + neighbor_Offset[next][1];
                         pix_neigh2 = (struct pixel_neighbor_type_rec *)
                             get_1d_buf_value(neigh_2d->buf[y1],
                                  (long) x1,neigh_2d->pixel_depth);

                         if (((neigh2 = pix_neigh2->neigh) == NULL) ||
                             (neigh2->status & TYPE_RESOLVED_OR_CONSIDER_OR_DONT_CONSIDER))
                            continue;
                         ok = 0;
                         pix = pix_neigh2->pix;
                         for (indx = 0;indx < (unsigned long)pix->num_types; indx++)
                            {for (cnt = 0;cnt < (unsigned long)cur_pix->num_types; cnt++)
                                if (cur_pix->types[cnt].indx == pix->types[indx].indx)
                                   {ok = 1;
                                    break;}
                             if (!ok) break;
                            }

                         if (!ok)
                            {neigh2->status = TYPE_DONT_CONSIDER;

                             if (num_local_incomps >= total_local_incomps)
                                if ((err = get_ptr(&local_incomps,&total_local_incomps,200,
                                       (size_t) sizeof(*local_incomps))) != NO_ERROR)
                                   break;
                             local_incomps[num_local_incomps].x = x1;
                             local_incomps[num_local_incomps].y = y1;
                             local_incomps[num_local_incomps].pix_neigh = pix_neigh2;
                             num_local_incomps += 1;
                             continue;}

                         next1 = _EdgeReversePosi[next];
                         if (neigh2->weights[next1] >= indx_weights[0].weight)
                            {
                             is_max = 1;}
                           else for (is_max = 1,keep = 0; keep < 8; keep++)
                            {if ((keep != next1) &&
                                 (neigh2->weights[next1] < neigh2->weights[keep]))
                                {is_max = 0;
                                 break;}
                            } 
                         if (!is_max)
                            {neigh2->status |= TYPE_SCANNED;
                             continue;}

                         if (num_xys >= total_xys)
                            if ((err = get_ptr(&xys,&total_xys,500,
                                   (size_t) sizeof(*xys))) != NO_ERROR)
                               break;
                  
                         xys[num_xys].x = x1;
                         xys[num_xys].y = y1;
                         xys[num_xys].pix_neigh = pix_neigh2;
                         num_xys += 1;
                         neigh2->status = TYPE_CONSIDER | IN_SOLVE;
                        }
                     if (err != NO_ERROR) break;
                    }
                 if (err != NO_ERROR) break;
                 for (cnt = 0;cnt < (unsigned long) cur_pix->num_types; cnt++)
                    type_cnts1[cur_pix->types[cnt].indx] = type_cnts[cur_pix->types[cnt].indx];

                 for (type = 0,keep = 1; keep < num_type_aves; keep++) 
                    {if (type_cnts1[type] < type_cnts1[keep]) type = keep;
                    }
                 PRT4(printf("last type = %d [0] = %d  [1] = %d  [2] = %d\n",
                       type,type_cnts1[0],type_cnts1[1],type_cnts1[2]))
                 if (type_cnts1[type] > 0)
                    {PRT4(cnt13 += 1;)
                     PRT1(printf("1...... num_local_incomps = %d num_xys = %d   type= %d\n",
                           num_local_incomps,num_xys,(long) type);)
                     for (cur = 0; cur < num_local_incomps; cur++)
                        {if ((neigh1 = local_incomps[cur].pix_neigh->neigh) != NULL)
                           if (!(neigh1->status & TYPE_RESOLVED))
                           {neigh1->status &= ~TYPE_PROCESSED;
                            neigh1->status |= TYPE_SCANNED;
                            cnt18++;}
                        }
                     PRT4(printf("***num_local_incomps = %d cnt11 = %d cnt15 = %d cnt18 = %d cnt13 = %d  cnt17= %d cnt16 = %d\n",num_local_incomps,cnt11,cnt15,cnt18,cnt13,cnt17,cnt16))
                     break;
                    }
                   else
                    {
                     *is_done = 0;
                     for (keep = 0; keep < num_type_aves; keep++)
                        {type_cnts[keep] = 0;
                         type_cnts1[keep] = 0;}
                     avex = avey = .0;
                     flag = 0;
                     num_type_diffs = 0;
                     for (cur = 0; cur < num_xys; cur++)
                        {neigh = xys[cur].pix_neigh->neigh;
                         x = xys[cur].x;
                         y = xys[cur].y;
                         pix = xys[cur].pix_neigh->pix;
                         avex += (float) pix->valx;
                         avey += (float) pix->valy;
                         
                         done_neighs1 = neigh->done_neighs;
                         for (lcv = 1; 
                              lcv <= (unsigned long) _0Edge[done_neighs1][0]; lcv++)
                             {next = _0Edge[done_neighs1][lcv];
                              x1 = x + neighbor_Offset[next][0];
                              y1 = y + neighbor_Offset[next][1];

                              pix_neigh2 = (struct pixel_neighbor_type_rec *)
                                  get_1d_buf_value(neigh_2d->buf[y1],
                                           (long) x1,neigh_2d->pixel_depth);
                              neigh2 = pix_neigh2->neigh;
                              if (neigh2->status & IN_SOLVE) {PRT3(cnt10++;)continue;}
                              pix = pix_neigh2->pix;
                              for (indx = 0; indx < (unsigned long) pix->num_types; indx++)
                                 {type_cnts[pix->types[indx].indx] += 1;}
                              neigh2->status |= TYPE_SCANNED;
                              if (SuggestNeighborType(neigh2,pix_neigh2->pix,x1,y1,
                                      neigh_2d,&type,0) == NO_ERROR)
                                 {
                                  for (indx = 0; 
                                     indx < (unsigned long) cur_pix->num_types; indx++)
                                     if (cur_pix->types[indx].indx == type)
                                        break;
                                  if (indx == cur_pix->num_types) continue;
                                  if (num_type_diffs >= total_type_diffs)
                                     if ((err = get_ptr(&type_diffs,&total_type_diffs,1000,
                                         (size_t) sizeof(*type_diffs))) != NO_ERROR)
                                        break;
                                  type_diffs[num_type_diffs].diffx = 
                                      (float) (cur_pix->valx - pix_neigh2->pix->valx);
                                  type_diffs[num_type_diffs].diffy = 
                                      (float) (cur_pix->valy - pix_neigh2->pix->valy);
                                  type_diffs[num_type_diffs].type = type;
                                  num_type_diffs += 1;
                                  type_cnts1[type] += 1;
                                 }
                             }
                         if (err != NO_ERROR) break;
                        }
                      if (err != NO_ERROR) break;
                      for (type = 0,keep = 1; keep < num_type_aves; keep++) 
                         {PRT3(printf("111 [0] = %d [%d] = %d\n",type_cnts1[0],
                               keep,type_cnts1[keep]))
                          if (type_cnts1[type] < type_cnts1[keep]) type = keep;
                         }
                   
                      PRT3(printf("2. num_l-incomps = %d num_xys = %d type= %d flag = %x cnt13 = %d cnt11 = %d cnt14 = %d cnt15 = %d cnt16 = %d cnt17 = %d \n",
                           num_local_incomps,num_xys,(long) type,
                           (unsigned long) flag,cnt13,cnt11,cnt14,cnt15,cnt16,cnt17);)
                      if (num_type_diffs > 0)
                         for (keep = 0; keep < num_type_aves; keep++) 
                            if (type_cnts[keep] > 0)
                               {for (flag = 0,cur = 0; cur < num_type_diffs; cur++)
                                   {if (type_diffs[cur].type != keep)
                                       continue;
                                    if (type_diffs[cur].diffx > .0) flag |= 2;
                                      else if (type_diffs[cur].diffx < .0) flag |= 1;
                                    if (type_diffs[cur].diffy > .0) flag |= 8;
                                      else if (type_diffs[cur].diffy < .0) flag |= 4;
                                   }
                                PRT3(printf("***type = %d keep = %d flag = %x\n",
                                  type,keep,(unsigned long) flag))
                                if ((flag == 0x00000005) || (flag == 0x00000006) ||
                                    (flag == 0x00000009) || (flag == 0x0000000a) ||
                                    (flag == 0x00000001) || (flag == 0x00000002) ||
                                    (flag == 0x00000008))
                                   {PRT3(cnt14 += 1;)
                                    type_cnts[keep] = 0;}
                               }
                      PRT4(cnt11 += 1;) 
                      avex = avex / (float) num_xys;
                      avey = avey / (float) num_xys;
                      for (is_avexy = 0,keep = 0,next = type; keep < num_type_aves; keep++) 
                         {if (type_cnts[keep] > 0)
                             {avex1 = type_aves[keep].x / (float) type_aves[keep].num_freqs;
                              avey1 = type_aves[keep].y / (float) type_aves[keep].num_freqs;
                              diffx = (avex - avex1);
                              diffx *= diffx;
                              diffy = (avey - avey1);
                              diffy *= diffy;
                              avexy1 = (float) sqrt((double) (diffx + diffy));
                              if (!is_avexy)
                                 {is_avexy = 1;
                                  avexy = avexy1;
                                  type = keep;}
                                 else if (avexy > avexy1)
                                  {avexy = avexy1;
                                   type = keep;}
                              PRT3(printf("%d) avex1 = %f avey1 = %f diffx = %f diffy = %f avexy1 = %f avexy = %f type = %d\n",
                           keep,avex1,avey1,diffx,diffy,avexy1,avexy,type);)

                             }
                         }
                      PRT3(printf("***final last-type = %d type = %d num_xys = %d xys = %u\n",next,type,num_xys,xys))
                      PRT4(if (next != type) cnt15 += 1;)
                    }

                 for (cur = 0; cur < num_xys; cur++)
                    {
                     neigh2 = xys[cur].pix_neigh->neigh;
                     x = xys[cur].x;
                     y = xys[cur].y;

                     neigh2->neighs[0].type = type;
                     neigh2->num_neighs = 1;
                     neigh2->status = TYPE_RESOLVED;
                     if (neigh2->xy_ptr->next != NULL)
                        neigh2->xy_ptr->next->last = neigh2->xy_ptr->last;

                     if (neigh2->xy_ptr->last != NULL)
                        neigh2->xy_ptr->last->next = neigh2->xy_ptr->next;
                     c_free(neigh2->xy_ptr);
                     neigh2->xy_ptr = NULL;

                     update_neighs(neigh2,neigh_2d,y,x,(long) type);
                    }
                 for (cur = 0; cur < num_local_incomps; cur++)
                    {if ((neigh1 = local_incomps[cur].pix_neigh->neigh) != NULL)
                        if (!(neigh1->status & TYPE_RESOLVED))
                           {neigh1->status &= ~TYPE_PROCESSED;
                            neigh1->status |= TYPE_SCANNED;
                            cnt18++;}
                    }
                 num_xys1 = num_xys;
                 for (cur = 0; cur < num_xys; cur++)
                    {neigh1 = xys[cur].pix_neigh->neigh;
                     x = xys[cur].x;
                     y = xys[cur].y;
                     done_neighs1 = neigh1->done_neighs;
                     for (lcv = 1;lcv <= (unsigned long)_0Edge[done_neighs1][0]; lcv++)
                        {next = _0Edge[done_neighs1][lcv];
                         x1 = x + neighbor_Offset[next][0];
                         y1 = y + neighbor_Offset[next][1];
                         pix_neigh2 = (struct pixel_neighbor_type_rec *)
                             get_1d_buf_value(neigh_2d->buf[y1],
                                  (long) x1,neigh_2d->pixel_depth);

                         if (((neigh2 = pix_neigh2->neigh) == NULL) ||
                             (neigh2->status & TYPE_RESOLVED_OR_CONSIDER_OR_DONT_CONSIDER))
                            continue;

                         if ((SuggestNeighborType(neigh2,pix_neigh2->pix,x1,y1,
                                      neigh_2d,&type1,5) == NO_ERROR) &&
                             (type == type1))
                            {if (num_xys >= total_xys)
                                if ((err = get_ptr(&xys,&total_xys,500,
                                    (size_t) sizeof(*xys))) != NO_ERROR)
                                   break;
                             xys[num_xys].x = x1;
                             xys[num_xys].y = y1;
                             xys[num_xys].pix_neigh = pix_neigh2;
                             num_xys += 1;
                             neigh2->status = TYPE_CONSIDER;
                            }
                        }
                    }
                 if (num_xys1 != num_xys)
                    {for (cur = 0; cur < num_xys; cur++)
                        {neigh2 = xys[cur].pix_neigh->neigh;
                         if (neigh2->status & TYPE_RESOLVED) continue;
                         x = xys[cur].x;
                         y = xys[cur].y;
                         PRT4(cnt16 += 1)
                         neigh2->neighs[0].type = type;
                         neigh2->num_neighs = 1;
                         neigh2->status = TYPE_RESOLVED;
                         if (neigh2->xy_ptr->next != NULL)
                            neigh2->xy_ptr->next->last = neigh2->xy_ptr->last;

                         if (neigh2->xy_ptr->last != NULL)
                            neigh2->xy_ptr->last->next = neigh2->xy_ptr->next;
                         c_free(neigh2->xy_ptr);
                         neigh2->xy_ptr = NULL;
                         update_neighs(neigh2,neigh_2d,y,x,(long) type);
                        }
                    }
                 total += num_xys;


                 PRT4(printf("num_local_incomps = %d cnt11 = %d cnt15 = %d cnt18 = %d cnt13 = %d cnt17 = %d cnt16 = %d\n",num_local_incomps,cnt11,cnt15,cnt18,cnt13,cnt17,cnt16))
                 /*done = 1;*/
                 break;
                }
               else
                {PRT3(cnt12 += 1;)
                 top = top->next;}
            }
         if (err != NO_ERROR) break;
         if (resolve->lists[num]->top.next == NULL) is_drop = 1;
        }
     if (err != NO_ERROR) break;
     PRT(printf("**** done = %d is_drop = %d cnt_0 = %d all = %d segmented = %d  cnt12 = %d cnt13 = %d cnt11 = %d cnt14 = %d\n",
                done,is_drop,cnt_0,all,total,cnt12,cnt13,cnt11,cnt14);)
     if (is_drop)
        {is_drop = 0;
         drop_empty_stack_lists(resolve);}
     if (!yes) break;
    }

 for (num = 0; num < resolve->num_lists; num++)
    {if ((top = resolve->lists[num]->top.next) == NULL)
        continue;
     while (top != NULL)
        {if (top->pix_neigh->neigh != NULL)
            top->pix_neigh->neigh->status &= ~TYPE_PROCESSED;
         top = top->next;}
    }
 if (total_xys > 0) c_free(xys);
 if (total_local_incomps > 0) c_free(local_incomps);
 if (num_type_aves > 0) c_free(type_cnts);
 if (num_type_aves > 0) c_free(type_cnts1);
 if (total_type_diffs > 0) c_free(type_diffs);

 PRT2(lcv = cnt_pixel_stack_rec_ptr(resolve);
       printf("err = %d done = %d yes = %d ...all = %d segmented = %d  %d = left = %d num_lists = %d cnt11 = %d\n",
           err,done,yes,all,total,lcv + total,
           lcv,resolve->num_lists,cnt11);
     printf("solve_deadlock_pixels err = %d is_done = %d\n",err,*is_done);)
 return err;
}

/**********
                         if (ok)
                            {next1 = _EdgeReversePosi[next];
                             if (neigh2->weights[next1] >= indx_weights[0].weight)
                                {PRT(cnt17 += 1;)
                                 is_max = 1;}
                               else for (is_max = 1,keep = 0; keep < 8; keep++)
                                {if ((keep != next1) &&
                                     (neigh2->weights[next1] < neigh2->weights[keep]))
                                    {is_max = 0;
                                     break;}
                                } 
                             if (!is_max) ok = 0;
                            } 
*/
/*
                 for (cur = 0; cur < num_local_incomps; cur++)
                    {neigh1 = local_incomps[cur].pix_neigh->neigh;
                     x = local_incomps[cur].x;
                     y = local_incomps[cur].y;
                     done_neighs1 = neigh1->done_neighs;
                     for (lcv = 1;lcv <= (unsigned long) _0Edge[done_neighs1][0]; lcv++)
                        {next = _0Edge[done_neighs1][lcv];
                         x1 = x + neighbor_Offset[next][0];
                         y1 = y + neighbor_Offset[next][1];
                         pix_neigh2 = (struct pixel_neighbor_type_rec *)
                             get_1d_buf_value(neigh_2d->buf[y1],
                                  (long) x1,neigh_2d->pixel_depth);
                         neigh2 = pix_neigh2->neigh;
                         if (neigh2 == NULL) continue;
                         if (neigh2->status & TYPE_PROCESSED) continue;
                         neigh2->status = TYPE_DONT_CONSIDER;
                         if (num_local_incomps >= total_local_incomps)
                            if ((err = get_ptr(&local_incomps,&total_local_incomps,1000,
                                       (size_t) sizeof(*local_incomps))) != NO_ERROR)
                               break;
                         local_incomps[num_local_incomps].x = x1;
                         local_incomps[num_local_incomps].y = y1;
                         local_incomps[num_local_incomps].pix_neigh = pix_neigh2;
                         num_local_incomps += 1;}
                     if (err != NO_ERROR) break;
                    }
*******************/
