/****************************************************************************
slice_roi_rec_extra.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: slice_roi_rec_extra.c,v 1.7 1999/07/07 17:41:19 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "geometry.h"
#include "mri_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);

#define PRT5(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
*/
#define PRT(x)
#define TRACE(x)
#define PRT5(x)
#define PRT4(x)
#define PRT7(x)
#define PRT8(x)
#define PRT6(x)
#define PRT9(x)



/* Functions defined in this file */
int coord_y_sort_proc(struct float_xy_rec *pt1, struct float_xy_rec *pt2);
int roi_sort_proc(const void *roi1, const void *roi2);
struct roi_rec *find_roi_rec(struct slice_roi_rec *slice_roi, char *label,
    int set_cur_roi);
struct curve_2d_rec *find_pen(struct roi_rec *roi, int pen_type,
    int set_cur_pen);
struct roi_rec *get_roi(struct slice_roi_rec *slice_roi, char *label);
struct roi_rec *get_cur_roi(struct slice_roi_rec *slice_roi);
char *get_cur_roi_label(struct slice_roi_rec *slice_roi);
struct roi_rec *get_roi_of_type(struct slice_roi_rec *slice_roi, int roi_type,
    int set_cur_roi);
struct roi_rec *exclude_roi_of_type(struct slice_roi_rec *slice_roi,
    int roi_type, int set_cur_roi);
struct curve_2d_rec *get_cur_pen(struct slice_roi_rec *slice_roi);
struct curve_2d_rec *get_pen_of_type(struct slice_roi_rec *slice_roi,
    int roi_type, int set_cur_roi);
struct curve_rec *get_cur_curve(struct slice_roi_rec *slice_roi);
struct curve_rec *get_curve_of_type(struct slice_roi_rec *slice_roi,
    int roi_type, int set_cur_roi);
struct roi_rec *next_cur_roi(struct slice_roi_rec *slice_roi, char *label);
struct roi_rec *next_pen_type(struct slice_roi_rec *slice_roi);
struct roi_rec *next_non_empty_roi(struct slice_roi_rec *slice_roi);
struct roi_rec *next_roi(struct slice_roi_rec *slice_roi, int is_backward);
struct roi_rec *next_not_cur_roi(struct slice_roi_rec *slice_roi,
    char *label);
int next_curve(struct slice_roi_rec *slice_roi, int new_curve);
struct curve_rec *locate_curve_of_type(struct slice_roi_rec *slice_roi,
    int curve_type, int set_cur);
int make_next_curve_cur(struct slice_roi_rec *slice_roi, int is_backward);
int next_curve_of_type(struct slice_roi_rec *slice_roi, char *roi_label,
    int pen_type, int new_curve, int set_cur);
int find_curve_of_type(struct slice_roi_rec *slice_roi, char *roi_label,
    int pen_type, int curve_type, int set_cur);
int set_cur_pen(struct slice_roi_rec *slice_roi, int pen_type, int must_exist);
int point_to_visible_slice_roi(struct slice_roi_rec *slice_roi1,
    struct slice_roi_rec *slice_roi2);
int keep_only_visible_rois(struct slice_roi_rec *slice_roi);
int is_curve_closed(struct curve_rec *curve);
int is_curve_non_empty(struct curve_rec *curve);
int is_cur_curve_non_empty(struct slice_roi_rec *slice_roi);
int is_pen_non_empty(struct curve_2d_rec *pen);
int is_roi_non_empty(struct roi_rec *roi);
int is_slice_roi_non_empty(struct slice_roi_rec *slice_roi);
int is_slice_roi_no_roi(struct slice_roi_rec *slice_roi);
int is_save_roi(struct slice_roi_rec *slice_roi);
int is_cur_roi_pen_type(struct slice_roi_rec *slice_roi, unsigned short *ary,
    int num_pens);
int CloseCurCurve(struct curve_2d_rec *pen, unsigned short *status,
    int is_optional);
int LoopCurCurve(struct slice_roi_rec *slice_roi);
int MustLoopCurCurve(struct slice_roi_rec *slice_roi);
int GetRoiLabelPtrs(struct slice_roi_rec *slice_roi,
    struct strs_rec *roi_labels, int is_inc_empty_roi, int is_sort);
int rename_roi_label(struct slice_roi_rec *slice_roi, struct roi_rec *roi,
    char *label);
void pr_curve_rec_pts(struct curve_rec *curve);
void pr_curve_rec(struct curve_rec *curve);
void pr_curve_2d_rec(struct curve_2d_rec *pen);
void pr_roi_rec(struct roi_rec *roi);
void pr_slice_roi_rec(struct slice_roi_rec *slice_roi);
void set_cur_curve_status(struct slice_roi_rec *slice_roi, int or_status);
void set_roi_saved(struct slice_roi_rec *slice_roi);
void set_roi_visibility(struct roi_rec *roi, int visibility);
void set_all_rois_visibility(struct slice_roi_rec *slice_roi, int visibility);
int num_curve_pts(struct curve_rec *curve);
int num_cur_roi_curves(struct slice_roi_rec *slice_roi);
void total_curve_2d_rec_pts(struct curve_2d_rec *pen,
    unsigned long *cnt_curves, unsigned long *cnt_pts,
    unsigned long min_num_pts);
void set_curve_bound_computed_status(struct curve_rec *curve, int is_computed);
void curve_matrix(struct curve_rec *curve, struct matrix_2d_rec *trans_mat,
    struct matrix_2d_rec *mat, struct matrix_2d_rec **pmat, int is_localto);
int CurvePtByIndx(struct curve_rec *cur_curve, unsigned long indx, float *x,
    float *y, struct matrix_2d_rec *localto);
int LongCurvePtByIndx(struct curve_rec *cur_curve, unsigned long indx,
    long *x, long *y, struct matrix_2d_rec *localto);
int CurPtByIndx(struct slice_roi_rec *slice_roi, int indx, float *x, float *y,
    struct matrix_2d_rec *localto);
int LongCurPtByIndx(struct slice_roi_rec *slice_roi, unsigned long indx,
    long *x, long *y, struct matrix_2d_rec *localto);
int LongCurPt(struct slice_roi_rec *slice_roi, long *x, long *y,
    struct matrix_2d_rec *localto);
int GetCurveLast2LongPts(struct curve_rec *curve, long *x0, long *y0,
    long *x1, long *y1, struct matrix_2d_rec *localto);
int ReplaceCurveLastPt(struct curve_rec *curve, double x, double y,
    unsigned short *status, struct matrix_2d_rec *tolocal);
int sort_curve_min_max_lt(struct curve_rec **curve1,
    struct curve_rec **curve2);
int FindTheCurveMinMax(struct curve_rec *curve, struct matrix_2d_rec *localto,
    int curve_type, int use_start_indx, unsigned long start_indx,
    int is_recompute);
int FindCurveMinMax(struct curve_rec *curve, struct matrix_2d_rec *localto,
    float *minx, float *maxx, float *miny, float *maxy, int curve_type,
    int use_start_indx, unsigned long start_indx, int is_recompute);
int FindCurveLongMinMax(struct curve_rec *curve,
    struct matrix_2d_rec *localto, long *minx, long *maxx, long *miny,
    long *maxy, int curve_type, int use_start_indx, unsigned long start_indx,
    int is_recompute);
int FindPenMinMax(struct curve_2d_rec *pen, struct matrix_2d_rec *localto,
    float *minx, float *maxx, float *miny, float *maxy, int use_start_indx,
    unsigned long start_indx, int is_recompute);
int FindRoiMinMax(struct roi_rec *roi, struct matrix_2d_rec *localto,
    float *minx, float *maxx, float *miny, float *maxy, int use_start_indx,
    unsigned long start_indx, int is_recompute);
int FindRoiLongMinMax(struct roi_rec *roi, struct matrix_2d_rec *localto,
    long *minx, long *maxx, long *miny, long *maxy, int use_start_indx,
    unsigned long start_indx, int is_recompute);
int FindSliceRoiMinMax(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, float *minx, float *maxx, float *miny,
    float *maxy, int use_start_indx, unsigned long start_indx,
    int is_recompute);
int reverse_curve_rec(struct curve_rec *curve);
int same_gradient(struct float_xy_rec *pt1, struct float_xy_rec *pt2,
    struct float_xy_rec *pt3, struct float_xy_rec *pts, unsigned long *cur_pt);
int optimize_curve_rec(struct curve_rec *curve);
void no_duplicate_pts(struct curve_rec *curve);
int set_curve_matrix(struct curve_rec *curve, struct matrix_2d_rec *matrix,
    int is_mult, unsigned short *status);
int set_curve_or(struct curve_rec *curve);
int apply_to_pen(struct curve_2d_rec *pen, int (*proc)(), void *arg2,
    void *arg3, void *arg4, void *arg5, void *arg6, void *arg7, void *arg8,
    void *arg9, void *arg10);
int apply_to_roi_rec(struct roi_rec *roi, int (*proc)(), void *arg2,
    void *arg3, void *arg4, void *arg5, void *arg6, void *arg7, void *arg8,
    void *arg9, void *arg10);
int apply_to_slice_roi_rec(struct slice_roi_rec *slice_roi, int (*proc)(),
    void *arg2, void *arg3, void *arg4, void *arg5, void *arg6, void *arg7,
    void *arg8, void *arg9, void *arg10);
int transform_curve(struct curve_rec *result_curve, struct curve_rec *curve,
    struct matrix_2d_rec *matrix, unsigned short *status);
int transform_pen(struct curve_2d_rec *pen, struct matrix_2d_rec *matrix,
    unsigned short *status, int is_transform_cur_curve);
int transform_roi_rec(struct roi_rec *roi, struct matrix_2d_rec *matrix,
    unsigned short *status, int is_transform_cur_curve);
int transform_slice_roi_rec(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *matrix, int is_transform_cur_curve);
int check_and_transform_curve(struct curve_rec *curve, unsigned short *status);
void scale_slice_roi_rec_dim(struct slice_roi_rec *slice_roi,
    unsigned long dimx, unsigned long dimy);
void mark_roi_delete(struct roi_rec *roi, unsigned short *status,
    int is_mark_delete);
int delete_roi_marked_delete(struct slice_roi_rec *slice_roi,
    int *is_some_deleted);
int MoveOutOfBoundCurve(struct curve_rec *curve,
    struct matrix_2d_rec *localto, float *left, float *top, float *right,
    float *bottom, float *moveto_x, float *moveto_y, int *is_move,
    unsigned short *status);
int MoveOutOfBoundRois(struct slice_roi_rec *slice_roi,
    struct matrix_2d_rec *localto, double left, double top, double right,
    double bottom, double moveto_x, double moveto_y);
int AddOffsetToCurveXYs(struct curve_rec *curve, unsigned long select,
    long minx, long maxx, long miny, long maxy, long offset,
    unsigned short *status, struct matrix_2d_rec *tolocal,
    struct matrix_2d_rec *localto);
int AddOffsetToPenXYs(struct curve_2d_rec *pen, unsigned long select,
    long minx, long maxx, long miny, long maxy, long offset,
    unsigned short *status, struct matrix_2d_rec *tolocal,
    struct matrix_2d_rec *localto);
int AddOffsetToRoiXYs(struct roi_rec *roi, unsigned long select, long minx,
    long maxx, long miny, long maxy, long offset, unsigned short *status,
    struct matrix_2d_rec *tolocal, struct matrix_2d_rec *localto);
int NewMappedCurve(struct curve_rec *result, struct curve_rec *curve,
    struct matrix_2d_rec *localto, struct matrix_2d_rec *maptolocal);
int MatchCurve(struct curve_rec *curve, struct matrix_2d_rec *localto,
    struct curve_rec *match_curve, struct matrix_2d_rec *match_localto,
    double diff_allowed, unsigned long *num_xys, int *is_match_longer);
int SetSameRoisStatus(struct slice_roi_rec *slice_roi1,
    struct slice_roi_rec *slice_roi2, int and_status2, int or_status2,
    int and_prog_status2, int or_prog_status2);



/*-------------------------------------------------------------------------
coord_y_sort_proc - ???
-------------------------------------------------------------------------*/

int
coord_y_sort_proc(pt1,pt2)
 struct float_xy_rec *pt1,*pt2;
{
 return (int) ((int) pt1->y - (int) pt2->y);

}

/************
int roi_sort_proc(roi1,roi2)
 struct roi_rec **roi1,**roi2;
{
 return no_case_str_cmp((*roi1)->label,(*roi2)->label);
}
****************/


/*-------------------------------------------------------------------------
roi_sort_proc - ???
-------------------------------------------------------------------------*/

int 
roi_sort_proc(roi1,roi2)
 const void *roi1,*roi2;
{
 return no_case_str_cmp((*((struct roi_rec **) roi1))->label,
                        (*((struct roi_rec **) roi2))->label);
}


/*-------------------------------------------------------------------------
find_roi_rec - ???
-------------------------------------------------------------------------*/

struct roi_rec *
find_roi_rec(slice_roi,label,set_cur_roi)
 struct slice_roi_rec *slice_roi;
 char *label;
 int set_cur_roi;
{
 unsigned long lcv;

 for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
    {
     if (no_case_str_cmp(slice_roi->rois[lcv]->label,label) == 0)
       {if (set_cur_roi) slice_roi->cur_roi = lcv;
        return slice_roi->rois[lcv];}
    }
 return NULL;
}


/*-------------------------------------------------------------------------
find_pen - ???
-------------------------------------------------------------------------*/

struct curve_2d_rec *
find_pen(roi,pen_type,set_cur_pen)
 struct roi_rec *roi;
 unsigned short pen_type;
 int set_cur_pen;
{
 unsigned long lcv;

 for (lcv = 0; lcv < roi->num_pens; lcv++)
    if (roi->pens[lcv]->pen_type == pen_type)
       {if (set_cur_pen) roi->cur_pen = lcv;
        return roi->pens[lcv];}

 return NULL;
}


/*-------------------------------------------------------------------------
get_roi - ???
-------------------------------------------------------------------------*/

struct roi_rec *
get_roi(slice_roi,label)
 struct slice_roi_rec *slice_roi;
 char *label;
{
 return find_roi_rec(slice_roi,label,0);
}


/*-------------------------------------------------------------------------
get_cur_roi - ???
-------------------------------------------------------------------------*/

struct roi_rec *
get_cur_roi(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 if (slice_roi->cur_roi < slice_roi->num_rois)
    return slice_roi->rois[slice_roi->cur_roi];
  else
   {return NULL;
   }
}


/*-------------------------------------------------------------------------
get_cur_roi_label - ???
-------------------------------------------------------------------------*/

char *
get_cur_roi_label(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 struct roi_rec *roi;

 if ((roi = get_cur_roi(slice_roi)) != NULL)
    return roi->label;
   else return NULL;

}


/*-------------------------------------------------------------------------
get_roi_of_type - ???
-------------------------------------------------------------------------*/

struct roi_rec *
get_roi_of_type(slice_roi,roi_type,set_cur_roi)
 struct slice_roi_rec *slice_roi;
 unsigned short roi_type;
 int set_cur_roi;
{
 unsigned long lcv;

 if (slice_roi->cur_roi >= slice_roi->num_rois) slice_roi->cur_roi = 0;
 if (slice_roi->cur_roi < slice_roi->num_rois)
    {
     for (lcv = slice_roi->cur_roi;;)
        {lcv = (lcv + 1) % slice_roi->num_rois;
         TRACE(printf("status = %x roi_type = %x\n",
              (int) slice_roi->rois[lcv]->status,(int) roi_type))
         if (slice_roi->rois[lcv]->status & roi_type)
            {if (set_cur_roi) slice_roi->cur_roi = lcv;
             return slice_roi->rois[lcv];}
         if (lcv == slice_roi->cur_roi) return NULL;
        }
   }
 return NULL;
}


/*-------------------------------------------------------------------------
exclude_roi_of_type - ???
-------------------------------------------------------------------------*/

struct roi_rec *
exclude_roi_of_type(slice_roi,roi_type,set_cur_roi)
 struct slice_roi_rec *slice_roi;
 unsigned short roi_type;
 int set_cur_roi;
{
 unsigned long lcv;

 if (slice_roi->cur_roi >= slice_roi->num_rois) slice_roi->cur_roi = 0;
 if (slice_roi->cur_roi < slice_roi->num_rois)
    {
     for (lcv = slice_roi->cur_roi;;)
        {lcv = (lcv + 1) % slice_roi->num_rois;
         TRACE(printf("status = %x roi_type = %x  label = %s\n",
              (int) slice_roi->rois[lcv]->status,
              (int) roi_type,slice_roi->rois[lcv]->label))
         if (!(slice_roi->rois[lcv]->status & roi_type))
            {if (set_cur_roi) slice_roi->cur_roi = lcv;
             return slice_roi->rois[lcv];}
        if (lcv == slice_roi->cur_roi) return NULL;
       }
   }
 return NULL;
}


/*-------------------------------------------------------------------------
get_cur_pen - ???
-------------------------------------------------------------------------*/

struct curve_2d_rec *
get_cur_pen(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 if (slice_roi->cur_roi < slice_roi->num_rois)
    {
     if (slice_roi->rois[slice_roi->cur_roi]->cur_pen <
         slice_roi->rois[slice_roi->cur_roi]->num_pens)
        return slice_roi->rois[slice_roi->cur_roi]->pens[
               slice_roi->rois[slice_roi->cur_roi]->cur_pen];
       else return NULL;
    }
  else return NULL;
}



/*-------------------------------------------------------------------------
get_pen_of_type - ???
-------------------------------------------------------------------------*/

struct curve_2d_rec *
get_pen_of_type(slice_roi,roi_type,set_cur_roi)
 struct slice_roi_rec *slice_roi;
 unsigned short roi_type;
 int set_cur_roi;
{
 struct roi_rec *roi;

 if ((roi = get_roi_of_type(slice_roi,roi_type,set_cur_roi)) != NULL)
    if (roi->cur_pen < roi->num_pens)
       return roi->pens[roi->cur_pen];
      else return NULL;
   else return NULL;
}


/*-------------------------------------------------------------------------
get_cur_curve - ???
-------------------------------------------------------------------------*/

struct curve_rec *
get_cur_curve(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 struct curve_2d_rec *pen;

 pen = get_cur_pen(slice_roi);
 if ((pen != NULL) && (pen->cur_curve < pen->num_curves))
    {
     return pen->curves[pen->cur_curve];}
   else return NULL;
}


/*-------------------------------------------------------------------------
get_curve_of_type - ???
-------------------------------------------------------------------------*/

struct curve_rec *
get_curve_of_type(slice_roi,roi_type,set_cur_roi)
 struct slice_roi_rec *slice_roi;
 unsigned short roi_type;
 int set_cur_roi;
{
 struct curve_2d_rec *pen;

 pen = get_pen_of_type(slice_roi,roi_type,set_cur_roi);
 if ((pen != NULL) && (pen->cur_curve < pen->num_curves))
    {return pen->curves[pen->cur_curve];}
   else return NULL;
}



/*-------------------------------------------------------------------------
next_cur_roi - ???
-------------------------------------------------------------------------*/

struct roi_rec *
next_cur_roi(slice_roi,label)
 struct slice_roi_rec *slice_roi;
 char *label;
{
 return find_roi_rec(slice_roi,label,1);
}


/*-------------------------------------------------------------------------
next_pen_type - ???

FIXME!!  This function can fail to return a value.  Fortunately, the only
know caller never looks at the value.  -PWH 19990427
-------------------------------------------------------------------------*/

struct roi_rec *
next_pen_type(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 struct roi_rec *roi;
 unsigned long temp;

 if ((roi = get_cur_roi(slice_roi)) != NULL)
    {if (roi->num_pens == 0) return NULL;
     for (temp = roi->cur_pen;;)
        {roi->cur_pen = (roi->cur_pen + 1) % roi->num_pens;
         if (roi->pens[roi->cur_pen]->num_curves > 0)
            break;
         if (temp == roi->cur_pen) break;}
    }
 else return NULL;
}


/*-------------------------------------------------------------------------
next_non_empty_roi - ???
-------------------------------------------------------------------------*/

struct roi_rec *
next_non_empty_roi(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 unsigned long lcv,last;

 last = slice_roi->cur_roi;
 if (slice_roi->num_rois == 0) return NULL;
 if (slice_roi->cur_roi >= slice_roi->num_rois)
    slice_roi->cur_roi = slice_roi->num_rois - 1;
 for (lcv = slice_roi->cur_roi;;)
    {slice_roi->cur_roi = (slice_roi->cur_roi + 1) % slice_roi->num_rois;
     if (is_roi_non_empty(slice_roi->rois[slice_roi->cur_roi]))
        break;
     if (lcv == slice_roi->cur_roi) break;}
 return slice_roi->rois[slice_roi->cur_roi];
}


/*-------------------------------------------------------------------------
next_roi - ???
-------------------------------------------------------------------------*/

struct roi_rec *
next_roi(slice_roi,is_backward)
 struct slice_roi_rec *slice_roi;
 int is_backward;
{
 unsigned long last;

 last = slice_roi->cur_roi;
 if (slice_roi->num_rois == 0) return NULL;
 if (slice_roi->cur_roi >= slice_roi->num_rois)
    slice_roi->cur_roi = 0;
   else if (is_backward)
    {if (slice_roi->cur_roi == 0) slice_roi->cur_roi = slice_roi->num_rois - 1;
       else slice_roi->cur_roi -= 1;}
   else
    slice_roi->cur_roi = (slice_roi->cur_roi + 1) % slice_roi->num_rois;
 return slice_roi->rois[slice_roi->cur_roi];
}


/*-------------------------------------------------------------------------
next_not_cur_roi - ???
-------------------------------------------------------------------------*/

struct roi_rec *
next_not_cur_roi(slice_roi,label)
 struct slice_roi_rec *slice_roi;
 char *label;
{
 if (slice_roi->num_rois == 0) return NULL;
 if (slice_roi->cur_roi >= slice_roi->num_rois) slice_roi->cur_roi = 0;
 if (no_case_str_cmp(slice_roi->rois[slice_roi->cur_roi]->label,label) == 0)
    return next_roi(slice_roi,0);
 return slice_roi->rois[slice_roi->cur_roi];
}


/*-------------------------------------------------------------------------
next_curve - ???
-------------------------------------------------------------------------*/

int
next_curve(slice_roi,new_curve)
 struct slice_roi_rec *slice_roi;
 int new_curve;
{
 struct curve_2d_rec *pen;
 unsigned long temp;

 if ((pen = get_cur_pen(slice_roi)) == NULL) return CANCEL;
 if (pen->cur_curve >= pen->num_curves) pen->cur_curve = 0;
 if (new_curve)
    {
     for (pen->cur_curve = 0; pen->cur_curve < pen->num_curves;
              pen->cur_curve++)
        if (pen->curves[pen->cur_curve]->num_xys == 0)
           if (!(pen->curves[pen->cur_curve]->status & CURVE_NEVER_CURRENT))
              return NO_ERROR;
     return setup_cur_curve_rec(pen);
    }
   else
    {
     for (temp = pen->cur_curve;;)
        {pen->cur_curve = (pen->cur_curve + 1) % pen->num_curves;
         if ((pen->curves[pen->cur_curve]->num_xys != 0) &&
                 !(pen->curves[pen->cur_curve]->status & CURVE_NEVER_CURRENT))
            break;
         if (temp == pen->cur_curve) break;
        }
     return NO_ERROR;
    }
} 


/*-------------------------------------------------------------------------
locate_curve_of_type - ???
-------------------------------------------------------------------------*/

struct curve_rec *
locate_curve_of_type(slice_roi,curve_type,set_cur)
 struct slice_roi_rec *slice_roi;
 unsigned short curve_type;
 int set_cur;
{
 struct curve_2d_rec *pen;
 unsigned long temp,last;

 pen = get_cur_pen(slice_roi);
 if ((pen != NULL) && (pen->num_curves > 0))
    {if (pen->cur_curve >= pen->num_curves) temp = 0;
       else temp = pen->cur_curve;
     for (last = temp;;)
         {temp = (temp + 1) % pen->num_curves;
          if ((pen->curves[temp]->num_xys != 0) &&
              (pen->curves[temp]->status & curve_type))
             break;
          if (temp == last)
             {
              return NULL;}
          if (set_cur) pen->cur_curve = temp;
         }
     return pen->curves[temp];
    }
 return NULL;
} 


/*-------------------------------------------------------------------------
make_next_curve_cur - ???
-------------------------------------------------------------------------*/

int
make_next_curve_cur(slice_roi,is_backward)
 struct slice_roi_rec *slice_roi;
 int is_backward;
{
 struct curve_2d_rec *pen;
 struct roi_rec *roi;
 long cur_pen_indx,cur,lcv;
 struct curve_rec *cur_curve;

 PRT(printf("is_backward = %d\n",is_backward);)
 if ((roi = get_cur_roi(slice_roi)) != NULL)
    {if (roi->num_pens == 0) return CANCEL;
     pen = roi->pens[roi->cur_pen];
     cur_pen_indx = roi->cur_pen;
     if ((pen == NULL) || (pen->num_curves == 0))
        {
         for (;;)
            {if (is_backward)
                {if (roi->cur_pen == 0) roi->cur_pen = roi->num_pens - 1;
                   else roi->cur_pen -= 1;
                }
               else roi->cur_pen = (roi->cur_pen + 1) % roi->num_pens;
             if ((roi->pens[roi->cur_pen] != NULL) && 
                 (roi->pens[roi->cur_pen]->num_curves > 0))
                {pen = roi->pens[roi->cur_pen];
                 cur_pen_indx = roi->cur_pen;
                 pen->cur_curve = pen->num_curves - 1;
                 cur = pen->cur_curve;
                 break;}
             if (cur_pen_indx == roi->cur_pen) return CANCEL;
            }
        }
       else
        {
         if (pen->cur_curve >= pen->num_curves)
            pen->cur_curve = pen->num_curves - 1;
         if (is_backward)
            {if (pen->cur_curve == 0) cur = -1;
               else cur = pen->cur_curve - 1;
            }
           else cur = pen->cur_curve + 1;
        }

     PRT(printf("in cur_pen = %d num_curves = %d cur = %d\n",
         roi->cur_pen,pen->num_curves,pen->cur_curve);)
     cur_curve = pen->curves[pen->cur_curve];
     for (;;)
        {if ((pen != NULL) && (cur >= 0) && (cur < pen->num_curves))
            for (lcv = cur;; )
               {if ((pen->curves[lcv] != NULL) &&
                    (pen->curves[lcv]->num_xys != 0) &&
                    !(pen->curves[lcv]->status & CURVE_NEVER_CURRENT))
                   {pen->cur_curve = lcv;
                    return NO_ERROR;}
                  else if (cur_curve == pen->curves[lcv])
                   return NO_ERROR;
                if (is_backward)
                   {if (lcv == 0) break;
                    lcv -= 1;
                   }
                  else 
                   {lcv++;
                    if (lcv >= pen->num_curves) break;}
               }
         if (is_backward)
            {if (roi->cur_pen == 0) roi->cur_pen = roi->num_pens - 1;
               else roi->cur_pen -= 1;
            }
           else roi->cur_pen = (roi->cur_pen + 1) % roi->num_pens;
         PRT(printf("next pen = %d\n",roi->cur_pen))
         if (((pen = roi->pens[roi->cur_pen]) != NULL) &&
             (pen->num_curves > 0))
            if (is_backward) cur = pen->num_curves - 1;
              else cur = 0;
        }
    }
 return CANCEL;
}


/*-------------------------------------------------------------------------
next_curve_of_type - ???
-------------------------------------------------------------------------*/

int
next_curve_of_type(slice_roi,roi_label,pen_type,new_curve,set_cur)
 struct slice_roi_rec *slice_roi;
 char *roi_label;
 unsigned short pen_type;
 int new_curve;
 int set_cur;
{
 struct roi_rec *cur_roi,*roi;
 int err;

 err = NO_ERROR;
 if (!set_cur) cur_roi = get_cur_roi(slice_roi);
 if ((roi = next_cur_roi(slice_roi,roi_label)) != NULL)
    {if ((err = set_cur_pen(slice_roi,pen_type,0)) == NO_ERROR)
        next_curve(slice_roi,new_curve);
     if ((!set_cur) && (cur_roi != NULL) && (roi != cur_roi))
        next_cur_roi(slice_roi,cur_roi->label);
    }
 return err;
}


/*-------------------------------------------------------------------------
find_curve_of_type - ???

FIXME:  This function seems to never be called, which is a good thing
considering the bug described below.
-------------------------------------------------------------------------*/

int
find_curve_of_type(slice_roi,roi_label,pen_type,curve_type,set_cur)
 struct slice_roi_rec *slice_roi;
 char *roi_label;
 unsigned short pen_type,curve_type;
 int set_cur;
{
 struct roi_rec *cur_roi,*roi;
 int err;

 err = NO_ERROR;
 if (!set_cur) cur_roi = get_cur_roi(slice_roi);
 if ((roi = next_cur_roi(slice_roi,roi_label)) != NULL)
    {if ((err = set_cur_pen(slice_roi,pen_type,0)) == NO_ERROR)
	/* FIXME!!!  The next line was commented out because it
	   doesn't even come close to the right calling sequence.
	   This looks like a bad bug!  -PWH 19990427 */
        /* next_curve_of_type(slice_roi,curve_type) */;
     if ((!set_cur) && (cur_roi != NULL) && (roi != cur_roi))
        next_cur_roi(slice_roi,cur_roi->label);
    }
 return err;
}


/*-------------------------------------------------------------------------
set_cur_pen - ???
-------------------------------------------------------------------------*/

int
set_cur_pen(slice_roi,pen_type,must_exist)
 struct slice_roi_rec *slice_roi;
 unsigned short pen_type;
{
 struct roi_rec *roi;

 if ((roi = get_cur_roi(slice_roi)) != NULL)
    {
     if (find_pen(roi,pen_type,1) != NULL)
        {
         return NO_ERROR;}
       else if (must_exist)
        {return setup_cur_curve_2d_rec(roi,pen_type,1);
        }
    }
 return CANCEL;
}


/*-------------------------------------------------------------------------
point_to_visible_slice_roi - ???
-------------------------------------------------------------------------*/

int
point_to_visible_slice_roi(slice_roi1,slice_roi2)
 struct slice_roi_rec *slice_roi1,*slice_roi2;
{
 unsigned long lcv,cnt;
 int err;

 for (cnt = 0,lcv = 0; lcv < slice_roi2->num_rois; lcv++)
    if (slice_roi2->rois[lcv]->status & ROI_VISIBLE) cnt++;
 if (cnt == 0) return NO_ERROR;

 if ((err = add_roi_rec_handle(slice_roi1,cnt)) != NO_ERROR) return err;

 for (lcv = 0; lcv < slice_roi2->num_rois; lcv++)
    if (slice_roi2->rois[lcv]->status & ROI_VISIBLE)
       slice_roi1->rois[(slice_roi1->num_rois)++] = slice_roi2->rois[lcv];

 TRACE(printf("point_to_visible_slice_roi cnt = %d\n",cnt))
 if (is_slice_roi_non_empty(slice_roi1))
     slice_roi1->status |= SLICE_ROI_NON_EMPTY;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
keep_only_visible_rois - ???
-------------------------------------------------------------------------*/

int
keep_only_visible_rois(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 unsigned long lcv,cnt;
 int err;

 cnt = slice_roi->num_rois;
 for (lcv = 0; lcv < slice_roi->num_rois; )
    if (slice_roi->rois[lcv]->status & ROI_VISIBLE) lcv++;
      else 
       {slice_roi->cur_roi = lcv;
       if ((err = delete_cur_roi(slice_roi)) != NO_ERROR) return err;
       }
 if (slice_roi->cur_roi > slice_roi->num_rois) slice_roi->cur_roi = 0;
 TRACE(printf("keep_only_visible_rois...\n"))
 return err;
}


/*-------------------------------------------------------------------------
is_curve_closed - ???
-------------------------------------------------------------------------*/

int
is_curve_closed(curve)
 struct curve_rec *curve;
{
 float x,y,x1,y1;
 long last;

 PRT(printf("is_curve_closed..\n"))
 if ((curve != NULL) && (curve->num_xys > 0) &&
     (curve->num_xys <= curve->total_xys))
    if (curve->num_xys == 1) return 1;
      else 
       {CurvePtByIndx(curve,0,&x,&y,NULL);
        last = curve->num_xys - 1;
        CurvePtByIndx(curve,last,&x1,&y1,NULL);
        if ((x == x1) && (y == y1))
           {PRT(printf("is_curve_closed...yes end\n"))
            return 1;}
       }
 return 0;
}


/*-------------------------------------------------------------------------
is_curve_non_empty - ???
-------------------------------------------------------------------------*/

int
is_curve_non_empty(curve)
 struct curve_rec *curve;
{
 if ((curve == NULL) || (curve->num_xys == 0)) return 0;
   else return 1;
}


/*-------------------------------------------------------------------------
is_cur_curve_non_empty - ???
-------------------------------------------------------------------------*/

int
is_cur_curve_non_empty(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 return is_curve_non_empty(get_cur_curve(slice_roi));
}


/*-------------------------------------------------------------------------
is_pen_non_empty - ???
-------------------------------------------------------------------------*/

int
is_pen_non_empty(pen)
 struct curve_2d_rec *pen;
{
 unsigned long lcv;

 if ((pen != NULL) && (pen->num_curves > 0))
    for (lcv = 0; lcv < pen->num_curves; lcv++)
       if (is_curve_non_empty(pen->curves[lcv])) return 1;
 return 0;

}


/*-------------------------------------------------------------------------
is_roi_non_empty - ???
-------------------------------------------------------------------------*/

int
is_roi_non_empty(roi)
 struct roi_rec *roi;
{
 unsigned long lcv;

 if ((roi != NULL) && (roi->num_pens > 0))
    for (lcv = 0; lcv < roi->num_pens; lcv++)
       if (is_pen_non_empty(roi->pens[lcv])) return 1;
 return 0;
}


/*-------------------------------------------------------------------------
is_slice_roi_non_empty - ???
-------------------------------------------------------------------------*/

int
is_slice_roi_non_empty(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 unsigned long lcv;

 if ((slice_roi != NULL) && (slice_roi->num_rois > 0))
    for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
       if (is_roi_non_empty(slice_roi->rois[lcv])) return 1;
 return 0;
}


/*-------------------------------------------------------------------------
is_slice_roi_no_roi - ???
-------------------------------------------------------------------------*/

int
is_slice_roi_no_roi(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 unsigned long lcv;

 if ((slice_roi != NULL) && (slice_roi->num_rois > 0))
    for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
       if (slice_roi->rois[lcv]->label != NULL)
          if (str_cmp(slice_roi->rois[lcv]->label,"") != 0) return 0;
 return 1;
}


/*-------------------------------------------------------------------------
is_save_roi - ???
-------------------------------------------------------------------------*/

int
is_save_roi(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 if (slice_roi->status & SLICE_ROI_TO_BE_SAVED) return 1;
   else return 0;
}


/*-------------------------------------------------------------------------
is_cur_roi_pen_type - ???
-------------------------------------------------------------------------*/

int
is_cur_roi_pen_type(slice_roi,ary,num_pens)
 struct slice_roi_rec *slice_roi;
 unsigned short *ary;
 int num_pens;
{
 int cnt,lcv;
 struct roi_rec *roi;

 roi = get_cur_roi(slice_roi);
 if ((roi == NULL) || (roi->num_pens == 0)) return 0;
 for (lcv = 0; lcv < roi->num_pens; lcv++)
    for (cnt = 0; cnt < num_pens; cnt++)
       if (roi->pens[lcv]->pen_type == ary[cnt]) return 1;

 return 0;
}


/*-------------------------------------------------------------------------
CloseCurCurve - ???
-------------------------------------------------------------------------*/

int
CloseCurCurve(pen,status,is_optional)
 struct curve_2d_rec *pen;
 unsigned short *status;
 int is_optional;
{
 struct curve_rec *curve;

 if ((pen != NULL) && (pen->cur_curve < pen->num_curves))
    {if (is_optional)
        if ((pen->pen_type != DRAW_FREE_CLOSED) &&
            (pen->pen_type != DRAW_POLYGON))
           return NO_ERROR;
     curve = pen->curves[pen->cur_curve];
     if ((curve != NULL) && !is_curve_closed(curve) && (curve->num_xys > 0))
        {return EnterCurveXY(curve,curve->xys[0].x,
                             curve->xys[0].y,status,NULL,0,0,0);
        }
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
LoopCurCurve - ???
-------------------------------------------------------------------------*/

int
LoopCurCurve(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 struct curve_2d_rec *pen;

 if ((pen = get_cur_pen(slice_roi)) == NULL) return NO_ERROR;
 return CloseCurCurve(pen,&(slice_roi->status),1);
}


/*-------------------------------------------------------------------------
MustLoopCurCurve - ???
-------------------------------------------------------------------------*/

int
MustLoopCurCurve(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 struct curve_2d_rec *pen;

 if ((pen = get_cur_pen(slice_roi)) == NULL) return NO_ERROR;
 return CloseCurCurve(pen,&(slice_roi->status),0);
}


/*-------------------------------------------------------------------------
GetRoiLabelPtrs - ???
-------------------------------------------------------------------------*/

int
GetRoiLabelPtrs(slice_roi,roi_labels,is_inc_empty_roi,is_sort)
 struct slice_roi_rec *slice_roi;
 struct strs_rec *roi_labels;
 int is_inc_empty_roi,is_sort;
{
 unsigned long lcv;
 int err;

 if (slice_roi->status & SLICE_ROI_NON_EMPTY)
    {
     for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
        if (get_strlen(slice_roi->rois[lcv]->label) > 0)
           {if (!is_inc_empty_roi)
               if (!is_roi_non_empty(slice_roi->rois[lcv])) continue;

            FindStrInHandleAryByContent(roi_labels->strs,
                 roi_labels->num_strs,slice_roi->rois[lcv]->label,&err);
            if (err == NOT_FOUND)
               if ((err = add_str_ptr_to_strs_rec(roi_labels,
                   slice_roi->rois[lcv]->label)) != NO_ERROR)
                  return err;
           }
     if (is_sort) sort_strs_rec_ascendingly(roi_labels);
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
rename_roi_label - ???
-------------------------------------------------------------------------*/

int
rename_roi_label(slice_roi,roi,label)
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 char *label;
{
 int err;
 struct roi_rec *cur_roi;

 TRACE(printf("roi->label = %s rename to label ... = %s\n",roi->label,label))
 if (roi != NULL)
    {
     if ((err = str_dealloc_and_cpy(&(roi->label),label)) != NO_ERROR)
        return err;
     slice_roi->status |= SLICE_ROI_MUST_SAVE;
     cur_roi = get_cur_roi(slice_roi);
     qsort(slice_roi->rois,(size_t) slice_roi->num_rois,
           (size_t) sizeof(struct roi_rec *),roi_sort_proc);
     if (cur_roi == NULL) slice_roi->cur_roi = 0;
       else
        {slice_roi->cur_roi = find_handle_element(slice_roi->rois,
                              slice_roi->num_rois,cur_roi,&err);
        }
     return NO_ERROR;
    }
   else return CANCEL;
}


/*-------------------------------------------------------------------------
pr_curve_rec_pts - ???
-------------------------------------------------------------------------*/

void
pr_curve_rec_pts(curve)
 struct curve_rec *curve;
{
 unsigned long lcv;
 float x,y;

 printf("pr_curve_rec_pts curve = %p  status = %x num_xys = %ld\n",
        curve,(unsigned int) curve->status,curve->num_xys);
 pr_float_bound_rec(&(curve->fl_bound));
 if (curve->status & CURVE_MATRIX_IN_USE) pr_2d_matrix(&(curve->matrix));
 if (curve != NULL)
    if (curve->status & CURVE_MATRIX_IN_USE) 
       for (lcv = 0; lcv < curve->num_xys; lcv++)
          {trans_2d_pt(&(curve->matrix),curve->xys[lcv].x,
                  curve->xys[lcv].y,&x,&y,0);
           printf("lcv = %ld y/x = %f/%f --> %f/%f\n",lcv,
            curve->xys[lcv].y,curve->xys[lcv].x,y,x);
          }
      else
       for (lcv = 0; lcv < curve->num_xys; lcv++)
          printf("lcv = %ld y/x = %f/%f\n",lcv,
            curve->xys[lcv].y,curve->xys[lcv].x);
 printf("\n");
}


/*-------------------------------------------------------------------------
pr_curve_rec - ???
-------------------------------------------------------------------------*/

void
pr_curve_rec(curve)
 struct curve_rec *curve;
{

 if (curve != NULL)
    {
     printf("pr_curve_rec curve = %p  status = %x\n",
	    curve,(unsigned int) curve->status);
     pr_float_bound_rec(&(curve->fl_bound));
     if (curve->status & CURVE_MATRIX_IN_USE) pr_2d_matrix(&(curve->matrix));}

}
   

/*-------------------------------------------------------------------------
pr_curve_2d_rec - ???
-------------------------------------------------------------------------*/
     
void
pr_curve_2d_rec(pen)
 struct curve_2d_rec *pen;
{
 unsigned long lcv;

 if (pen != NULL)
    {printf("&&&&&curve_2d_rec = %p pen_type = %d cur = %ld"
	    " num = %ld  tot = %ld\n",
	    pen,(int)pen->pen_type,pen->cur_curve,
	    pen->num_curves,pen->total_curves);
     for (lcv = 0; lcv < pen->num_curves; lcv++)
        {pr_curve_rec_pts(pen->curves[lcv]);
        }
    }
}


/*-------------------------------------------------------------------------
pr_roi_rec - ???
-------------------------------------------------------------------------*/

void
pr_roi_rec(roi)
 struct roi_rec *roi;
{
 unsigned long lcv;

 if (roi != NULL)
    {
     printf("***roi_rec = %p label = %s cur = %ld total = %ld"
	    " num = %ld status = %x\n",
	    roi,roi->label,roi->cur_pen,roi->total_pens,roi->num_pens,
	    (unsigned int) roi->status);
     for (lcv = 0; lcv < roi->num_pens; lcv++)
        {printf("pen[%ld] = %p\n",lcv,roi->pens[lcv]);
         pr_curve_2d_rec(roi->pens[lcv]);}
     printf("pr_roi_rec end...\n");
    }
}
 

/*-------------------------------------------------------------------------
pr_slice_roi_rec - ???
-------------------------------------------------------------------------*/

void
pr_slice_roi_rec(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 unsigned long lcv;

 printf("$$$pr_slice_roi_rec slice_roi = %p dimx = %ld dimy = %ld"
        " cur roi= %ld num_rois = %ld total_rois = %ld\n",
	slice_roi,slice_roi->dimx,slice_roi->dimy,
	slice_roi->cur_roi,slice_roi->num_rois,slice_roi->total_rois);
 for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
    {printf("$$$***roi# = %ld\n",lcv);
     pr_roi_rec(slice_roi->rois[lcv]);}

}


/*-------------------------------------------------------------------------
set_cur_curve_status - ???
-------------------------------------------------------------------------*/

void
set_cur_curve_status(slice_roi,or_status)
 struct slice_roi_rec *slice_roi;
 unsigned short or_status;
{
 struct curve_rec *curve;

 if ((curve = get_cur_curve(slice_roi)) != NULL)
     curve->status |= or_status;
}


/*-------------------------------------------------------------------------
set_roi_saved - ???
-------------------------------------------------------------------------*/

void
set_roi_saved(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 slice_roi->status &= ~SLICE_ROI_TO_BE_SAVED;
}


/*-------------------------------------------------------------------------
set_roi_visibility - ???
-------------------------------------------------------------------------*/

void
set_roi_visibility(roi,visibility)
 struct roi_rec *roi;
 unsigned short visibility;
{
 
 if (roi != NULL) 
    {if (visibility == (unsigned short) ~ROI_VISIBLE) roi->status &= visibility;
       else roi->status |= visibility;
    }
}


/*-------------------------------------------------------------------------
set_all_rois_visibility - ???
-------------------------------------------------------------------------*/

void
set_all_rois_visibility(slice_roi,visibility)
 struct slice_roi_rec *slice_roi;
 unsigned short visibility;
{
 unsigned char lcv;

 for (lcv = 0;lcv < slice_roi->num_rois; lcv++)
    set_roi_visibility(slice_roi->rois[lcv],visibility);
}


/*-------------------------------------------------------------------------
num_curve_pts - ???
-------------------------------------------------------------------------*/

int
num_curve_pts(curve)
 struct curve_rec *curve;
{
 if (curve == NULL) return 0;
 if (curve->num_xys > curve->total_xys) return 0;
 return curve->num_xys;
}


/*-------------------------------------------------------------------------
num_cur_roi_curves - ???
-------------------------------------------------------------------------*/

int
num_cur_roi_curves(slice_roi)
 struct slice_roi_rec *slice_roi;
{
 struct roi_rec *roi;
 int cnt,lcv;

 roi = get_cur_roi(slice_roi);
 if (roi == NULL) return 0;
 for (cnt = 0,lcv = 0; lcv < roi->num_pens; lcv++)
    cnt += roi->pens[lcv]->num_curves;

 return cnt;
}


/*-------------------------------------------------------------------------
total_curve_2d_rec_pts - ???

FIXME:  This function appears to never be used.
-------------------------------------------------------------------------*/

void
total_curve_2d_rec_pts(pen,cnt_curves,cnt_pts,min_num_pts)
 struct curve_2d_rec *pen;
 unsigned long *cnt_curves,*cnt_pts,min_num_pts;
{
 unsigned long lcv;

 *cnt_curves = *cnt_pts = 0;
 if (pen == NULL)
     return /*0*/;

 for (lcv = 0; lcv < pen->num_curves; lcv++)
    if (pen->curves[lcv]->num_xys > 0)
       {if (pen->curves[lcv]->num_xys < min_num_pts)
           *cnt_pts += min_num_pts;
          else *cnt_pts += pen->curves[lcv]->num_xys;
        *cnt_curves += 1;}
}


/*-------------------------------------------------------------------------
set_curve_bound_computed_status - ???
-------------------------------------------------------------------------*/

void
set_curve_bound_computed_status(curve,is_computed)
 struct curve_rec *curve;
{
 if (is_computed) curve->status |= COORDINATE_BOUND_COMPUTED;
   else curve->status &= ~COORDINATE_BOUND_COMPUTED;
}


/*-------------------------------------------------------------------------
curve_matrix - ???
-------------------------------------------------------------------------*/

void
curve_matrix(curve,trans_mat,mat,pmat,is_localto)
 struct curve_rec *curve;
 struct matrix_2d_rec *trans_mat,*mat,**pmat;
{
 if (!(curve->status & CURVE_MATRIX_IN_USE))
    {if (trans_mat != NULL)
        {*mat = *trans_mat;
         *pmat = mat;}
       else *pmat = NULL;}
   else if (trans_mat != NULL)
    {if (is_localto)
        {if (trans_mat != NULL)
            {mult_2d_matrix(mat,trans_mat,&(curve->matrix));
             *pmat = mat;}
           else *pmat = &(curve->matrix);}
       else
        if (trans_mat != NULL)
           {mult_2d_matrix(mat,&(curve->inv),trans_mat);
            *pmat = mat;}
          else *pmat = &(curve->inv);
    }
   else if (is_localto)
    *pmat = &(curve->matrix);
   else *pmat = &(curve->inv);
}


/*-------------------------------------------------------------------------
CurvePtByIndx - ???
-------------------------------------------------------------------------*/

int
CurvePtByIndx(cur_curve,indx,x,y,localto)
 struct curve_rec *cur_curve;
 unsigned long indx;
 float *x,*y;
 struct matrix_2d_rec *localto;
{
 struct matrix_2d_rec mat,*pmat;

 *x = 0;
 *y = 0;
 if (cur_curve == NULL) return CANCEL;
   else if (cur_curve->num_xys <= indx) return CANCEL;
 curve_matrix(cur_curve,localto,&mat,&pmat,1);
 if (pmat != NULL)
    trans_2d_pt(pmat,cur_curve->xys[indx].x,
          cur_curve->xys[indx].y,x,y,0);
   else
    {*x = cur_curve->xys[indx].x;
     *y = cur_curve->xys[indx].y;}
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
LongCurvePtByIndx - ???
-------------------------------------------------------------------------*/

int
LongCurvePtByIndx(cur_curve,indx,x,y,localto)
 struct curve_rec *cur_curve;
 unsigned long indx;
 long *x,*y;
 struct matrix_2d_rec *localto;
{
 float x1,y1;
 int err;

 err = CurvePtByIndx(cur_curve,indx,&x1,&y1,localto);
 *x = floor((double) (x1 + .5));
 *y = floor((double) (y1 + .5));
 return err;
}


/*-------------------------------------------------------------------------
CurPtByIndx - ???
-------------------------------------------------------------------------*/

int
CurPtByIndx(slice_roi,indx,x,y,localto)
 struct slice_roi_rec *slice_roi;
 float *x,*y;
 struct matrix_2d_rec *localto;
{
 struct curve_rec *cur_curve;
 int err;

 cur_curve = get_cur_curve(slice_roi);
 err = CurvePtByIndx(cur_curve,indx,x,y,localto);
 return err;
}


/*-------------------------------------------------------------------------
LongCurPtByIndx - ???
-------------------------------------------------------------------------*/

int
LongCurPtByIndx(slice_roi,indx,x,y,localto)
 struct slice_roi_rec *slice_roi;
 unsigned long indx;
 long *x,*y;
 struct matrix_2d_rec *localto;
{
 struct curve_rec *cur_curve;
 float x1,y1;
 int err;

 cur_curve = get_cur_curve(slice_roi);
 err = CurvePtByIndx(cur_curve,indx,&x1,&y1,localto);
 *x = floor((double) (x1 + .5));
 *y = floor((double) (y1 + .5));
 return err;
}


/*-------------------------------------------------------------------------
LongCurPt - ???
-------------------------------------------------------------------------*/

int
LongCurPt(slice_roi,x,y,localto)
 struct slice_roi_rec *slice_roi;
 long *x,*y;
 struct matrix_2d_rec *localto;
{
 unsigned long num_pts;
 struct curve_rec *cur_curve;
 float x1,y1;
 int err;

 cur_curve = get_cur_curve(slice_roi);
 num_pts = num_curve_pts(cur_curve);
 if (num_pts == 0)
    {*x = 0;
     *y = 0;
     return CANCEL;}
 err = CurvePtByIndx(cur_curve,num_pts - 1,&x1,&y1,localto);
 *x = floor((double) (x1 + .5));
 *y = floor((double) (y1 + .5));
 PRT(printf("LongCurPt *x = %d *y = %d err = %d\n",*x,*y,err))
 return err;
}


/*-------------------------------------------------------------------------
GetCurveLast2LongPts - ???
-------------------------------------------------------------------------*/

int
GetCurveLast2LongPts(curve,x0,y0,x1,y1,localto)
 struct curve_rec *curve;
 long *x0,*y0,*x1,*y1;
 struct matrix_2d_rec *localto;
{
 long last;

 if ((curve != NULL) && (curve->num_xys > 0))
    {last = curve->num_xys - 1;
     LongCurvePtByIndx(curve,last,x1,y1,localto);
     if (curve->num_xys == 1)
        {*x0 = *x1;
         *y0 = *y1;}
       else
        {last -= 1;
         LongCurvePtByIndx(curve,last,x0,y0,localto);}
     return NO_ERROR;
    }
 return ~NO_ERROR;
}


/*-------------------------------------------------------------------------
ReplaceCurveLastPt - ???
-------------------------------------------------------------------------*/

int
ReplaceCurveLastPt(curve,x,y,status,tolocal)
 struct curve_rec *curve;
 float x,y;
 unsigned short *status;
 struct matrix_2d_rec *tolocal;
{
 if (curve == NULL) 
     /* Next line was just ~NO_ERROR -PH 19990427 */
     return ~NO_ERROR;
 if (curve->num_xys > 0)
     curve->num_xys -= 1;
 return EnterCurveXY(curve,x,y,status,tolocal,1,0,0);
}


/*-------------------------------------------------------------------------
sort_curve_min_max_lt - ???
-------------------------------------------------------------------------*/

int
sort_curve_min_max_lt(curve1,curve2)
 struct curve_rec **curve1,**curve2;
{
 if ((*curve1)->fl_bound.left > (*curve2)->fl_bound.left) return 1;
 if ((*curve1)->fl_bound.left < (*curve2)->fl_bound.left) return -1;
 if ((*curve1)->fl_bound.top > (*curve2)->fl_bound.top) return 1;
 if ((*curve1)->fl_bound.top < (*curve2)->fl_bound.top) return -1;
 return 0;
}


/*-------------------------------------------------------------------------
FindTheCurveMinMax - ???
-------------------------------------------------------------------------*/

int
FindTheCurveMinMax(curve,localto,curve_type,use_start_indx,start_indx,is_recompute)
 struct curve_rec *curve;
 struct matrix_2d_rec *localto;
 unsigned short curve_type;
 unsigned long start_indx;
 int use_start_indx,is_recompute;
{
 unsigned long lcv,num,start;
 float x,y,xs[4],ys[4];
 struct matrix_2d_rec mat,*pmat;

 PRT6(printf("FindTheCurveMinMax...curve_type = %x\n",
     (unsigned int) curve_type))
 if ((curve == NULL) && (curve->num_xys == 0)) return CANCEL;
 PRT6(printf("FindTheCurveMinMax status = %x num = %d is_recompute = %d\n",
      (unsigned int) curve->status,curve->num_xys,is_recompute);)
 if ((curve->num_xys > 1) &&
     ((curve_type & DRAW_CIRCLE_OR_ELLIPSE_OR_RECT) ||
      (curve->status & DRAW_CIRCLE_OR_ELLIPSE_OR_RECT)))
    {PRT6(printf("DRAW_CIRCLE_OR_ELLIPSE_OR_RECT\n"))
     if ((curve_type & DRAW_RECT) || (curve->status & DRAW_RECT))
        {xs[0] = curve->xys[0].x;
         ys[0] = curve->xys[0].y;
         ys[1] = curve->xys[1].y;
         xs[2] = curve->xys[1].x;
         num = 4;
        }
       else
        {x = curve->xys[0].x - curve->xys[1].x;
         if (x < 0) x = -x;
         y = curve->xys[0].y - curve->xys[0].y;
         if (y < 0) y = -y;
         x = (float) sqrt((double) (x * x + y * y));
         xs[0] = curve->xys[0].x - x;
         ys[0] = curve->xys[0].y - x;
         ys[1] = curve->xys[0].y + x;
         xs[2] = curve->xys[0].x + x;
         num = 4;
        }
     xs[1] = xs[0];
     ys[2] = ys[1];
     xs[3] = xs[2];
     ys[3] = ys[0];

     PRT6(for (lcv = 0; lcv < num; lcv++)
        printf("%d) y/x = %f/%f\n",lcv,ys[lcv],xs[lcv]);)

     if ((curve->status & CURVE_MATRIX_IN_USE) || (localto != NULL))
        {
         PRT6(printf(" curve_matrix...localto = %u\n",localto))
         curve_matrix(curve,localto,&mat,&pmat,1);
         PRT6(printf("after curve_matrix...pmat = %u\n",pmat))
         for (lcv = 0; lcv < num; lcv++)
            trans_2d_pt(pmat,xs[lcv],ys[lcv],&(xs[lcv]),&(ys[lcv]),0);
         PRT6(for (lcv = 0; lcv < num; lcv++)
            printf("%d) y/x = %f/%f\n",lcv,ys[lcv],xs[lcv]);)
        }
     curve->fl_bound.left = curve->fl_bound.right = xs[0];
     curve->fl_bound.top = curve->fl_bound.bottom = ys[0];
     for (lcv = 1; lcv < num; lcv++)
        {if (curve->fl_bound.left > xs[lcv]) curve->fl_bound.left = xs[lcv];
           else if (curve->fl_bound.right < xs[lcv])
            curve->fl_bound.right = xs[lcv];
         if (curve->fl_bound.top > ys[lcv]) curve->fl_bound.top = ys[lcv];
           else if (curve->fl_bound.bottom < ys[lcv])
            curve->fl_bound.bottom = ys[lcv];}

     PRT6(printf(" ..[0]/[1]  %f/%f  %f/%f\n",
                curve->xys[0].y,curve->xys[0].x,curve->xys[1].y,curve->xys[1].x);)
     PRT6(pr_float_bound_rec(&(curve->fl_bound));)
     curve->status |= COORDINATE_BOUND_COMPUTED;
    }
   else
    {
     if (!is_recompute && (localto == NULL) &&
         (curve->status & COORDINATE_BOUND_COMPUTED))
        {
         PRT6(printf("COORDINATE_BOUND_COMPUTED...\n");)
         return NO_ERROR;}
     PRT6(printf("curve_matrix status = %x localto = %u\n",
             (unsigned long) curve->status,localto);)
     curve_matrix(curve,localto,&mat,&pmat,1);

     PRT6(printf("FindTheCurveMinMax yes = %d\n",yes);)
     if (use_start_indx) start = lcv = start_indx;
       else start = lcv = 0;
     for (; lcv < curve->num_xys; lcv++)
        {
         if (pmat != NULL)
            {trans_2d_pt(pmat,(float) curve->xys[lcv].x,
                  (float) curve->xys[lcv].y,&x,&y,0);}
           else
            {x = curve->xys[lcv].x;
             y = curve->xys[lcv].y;}
         if (lcv == start)
            {curve->fl_bound.left = curve->fl_bound.right = x;
             curve->fl_bound.top = curve->fl_bound.bottom = y;
             continue;}

         if (x > curve->fl_bound.right) 
            curve->fl_bound.right = x;
         if (x < curve->fl_bound.left)
            curve->fl_bound.left = x;

         if (y > curve->fl_bound.bottom)
            curve->fl_bound.bottom = y;
         if (y < curve->fl_bound.top) 
            curve->fl_bound.top = y;}
     PRT6(printf(" curve->fl_bound...\n");
        pr_float_bound_rec(&(curve->fl_bound));)
     if (!use_start_indx || (start_indx == 0))
        curve->status |= COORDINATE_BOUND_COMPUTED;
    }
 PRT6(printf("CurveMinMax end minx = %f  maxx = %f miny = %f  maxy = %f\n",
     curve->fl_bound.left,curve->fl_bound.right,curve->fl_bound.top,
     curve->fl_bound.bottom);)

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
FindCurveMinMax - ???
-------------------------------------------------------------------------*/

int
FindCurveMinMax(curve,localto,minx,maxx,miny,maxy,curve_type,
                use_start_indx,start_indx,is_recompute)
 struct curve_rec *curve;
 struct matrix_2d_rec *localto;
 float *minx,*maxx,*miny,*maxy;
 unsigned short curve_type;
 unsigned long start_indx;
 int use_start_indx,is_recompute;
{
 int err;

 PRT(printf("FindCurveMinMax is_recompute = %d\n",is_recompute))
 if ((err = FindTheCurveMinMax(curve,localto,curve_type,
                   use_start_indx,start_indx,is_recompute)) == NO_ERROR)
    {*minx = curve->fl_bound.left;
     *maxx = curve->fl_bound.right;
     *miny = curve->fl_bound.top;
     *maxy = curve->fl_bound.bottom;
    }
 return err;
}


/*-------------------------------------------------------------------------
FindCurveLongMinMax - ???
-------------------------------------------------------------------------*/

int
FindCurveLongMinMax(curve,localto,minx,maxx,miny,maxy,curve_type,
                    use_start_indx,start_indx,is_recompute)
 struct curve_rec *curve;
 struct matrix_2d_rec *localto;
 long *minx,*maxx,*miny,*maxy;
 unsigned short curve_type;
 unsigned long start_indx;
 int use_start_indx,is_recompute;
{
 float minx1,maxx1,miny1,maxy1;
 int err;

 if ((err = FindCurveMinMax(curve,localto,&minx1,&maxx1,&miny1,&maxy1,
               curve_type,use_start_indx,start_indx,is_recompute)) == NO_ERROR)
    {*minx = floor((double) (minx1 + .5));
     *maxx = floor((double) (maxx1 + .5));
     *miny = floor((double) (miny1 + .5));
     *maxy = floor((double) (maxy1 + .5));
    }
   else
    {*minx = *miny = 0;
     *maxx = *maxy = -1;}
 return err;
}


/*-------------------------------------------------------------------------
FindPenMinMax - ???
-------------------------------------------------------------------------*/

int
FindPenMinMax(pen,localto,minx,maxx,miny,maxy,use_start_indx,start_indx,is_recompute)
 struct curve_2d_rec *pen;
 struct matrix_2d_rec *localto;
 float *minx,*maxx,*miny,*maxy;
 unsigned long start_indx;
 int use_start_indx,is_recompute;
{
 unsigned long lcv;
 float tempminx,tempmaxx,tempminy,tempmaxy;
 int err;

 *minx = *miny = 0;
 *maxx = *maxy = -1.0;
 PRT5(printf("FindPenMinMax is_recompute = %d num_curves\n",is_recompute,
         pen->num_curves))
 if (pen->num_curves == 0) return CANCEL;
 err = CANCEL;
 for (lcv = 0; lcv < pen->num_curves; lcv++)
    {if (FindCurveMinMax(pen->curves[lcv],localto,&tempminx,&tempmaxx,
              &tempminy,&tempmaxy,pen->pen_type,
              use_start_indx,start_indx,is_recompute) == NO_ERROR)
        {err = NO_ERROR;
         if (lcv == 0)
            {*minx = tempminx;
             *maxx = tempmaxx;
             *miny = tempminy;
             *maxy = tempmaxy;
             continue;}
         if (*minx > tempminx) *minx = tempminx;
         if (*miny > tempminy) *miny = tempminy;
         if (*maxx < tempmaxx) *maxx = tempmaxx;
         if (*maxy < tempmaxy) *maxy = tempmaxy;
        }
    }
 return err;
}


/*-------------------------------------------------------------------------
FindRoiMinMax - ???
-------------------------------------------------------------------------*/

int
FindRoiMinMax(roi,localto,minx,maxx,miny,maxy,use_start_indx,start_indx,is_recompute)
 struct roi_rec *roi;
 struct matrix_2d_rec *localto;
 float *minx,*maxx,*miny,*maxy;
 unsigned long start_indx;
 int use_start_indx,is_recompute;
{
 unsigned long lcv;
 float tempminx,tempmaxx,tempminy,tempmaxy;
 int err;

 *minx = *miny = 0;
 *maxx = *maxy = -1.0;
 if (roi == NULL) return CANCEL;
 PRT5(printf("FindRoiMinMax is_recompute = %d num_pens = %d\n",is_recompute,
            roi->num_pens))
 if (roi->num_pens == 0) return CANCEL;
 err = CANCEL;
 for (lcv = 0; lcv < roi->num_pens; lcv++)
    {if (FindPenMinMax(roi->pens[lcv],localto,&tempminx,&tempmaxx,
           &tempminy,&tempmaxy,use_start_indx,start_indx,is_recompute) == NO_ERROR)
        {err = NO_ERROR;
         if (lcv == 0)
            {*minx = tempminx;
             *maxx = tempmaxx;
             *miny = tempminy;
             *maxy = tempmaxy;
             continue;}
         if (*minx > tempminx) *minx = tempminx;
         if (*miny > tempminy) *miny = tempminy;
         if (*maxx < tempmaxx) *maxx = tempmaxx;
         if (*maxy < tempmaxy) *maxy = tempmaxy;
        }
    }
 PRT5(printf("final FindRoiMinMax minx = %f  maxx = %f\n",*minx,*maxx))
 PRT5(printf(" miny = %f  maxy = %f  err = %d\n",*miny,*maxy,err))
 return err;
}


/*-------------------------------------------------------------------------
FindRoiLongMinMax - ???
-------------------------------------------------------------------------*/

int
FindRoiLongMinMax(roi,localto,minx,maxx,miny,maxy,use_start_indx,start_indx,
                  is_recompute)
 struct roi_rec *roi;
 struct matrix_2d_rec *localto;
 long *minx,*maxx,*miny,*maxy;
 unsigned long start_indx;
 int use_start_indx,is_recompute;
{
 float minx1,maxx1,miny1,maxy1;
 int err;

 if ((err = FindRoiMinMax(roi,localto,&minx1,&maxx1,&miny1,&maxy1,
               use_start_indx,start_indx,is_recompute)) == NO_ERROR)
    {*minx = floor((double) (minx1 + .5));
     *maxx = floor((double) (maxx1 + .5));
     *miny = floor((double) (miny1 + .5));
     *maxy = floor((double) (maxy1 + .5));
    }
   else
    {*minx = *miny = 0;
     *maxx = *maxy = -1;}
 return err;
}


/*-------------------------------------------------------------------------
FindSliceRoiMinMax - ???
-------------------------------------------------------------------------*/

int
FindSliceRoiMinMax(slice_roi,localto,minx,maxx,miny,maxy,use_start_indx,start_indx,
                   is_recompute)
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *localto;
 float *minx,*maxx,*miny,*maxy;
 unsigned long start_indx;
 int use_start_indx,is_recompute;
{
 unsigned long lcv;
 float tempminx,tempmaxx,tempminy,tempmaxy;
 int err;

 *minx = *miny = 0;
 *maxx = *maxy = -1.0;
 err = CANCEL;
 for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
    {if (FindRoiMinMax(slice_roi->rois[lcv],localto,&tempminx,&tempmaxx,
         &tempminy,&tempmaxy,use_start_indx,start_indx,is_recompute) == NO_ERROR)
        {err = NO_ERROR;
         if (lcv == 0)
            {*minx = tempminx;
             *maxx = tempmaxx;
             *miny = tempminy;
             *maxy = tempmaxy;
             continue;}
         if (*minx > tempminx) *minx = tempminx;
         if (*miny > tempminy) *miny = tempminy;
         if (*maxx < tempmaxx) *maxx = tempmaxx;
         if (*maxy < tempmaxy) *maxy = tempmaxy;}
    }
 return err;
}


/*-------------------------------------------------------------------------
reverse_curve_rec - ???
-------------------------------------------------------------------------*/

int
reverse_curve_rec(curve)
 struct curve_rec *curve;
{
 unsigned long lcv,cnt,indx;
 struct float_xy_rec pt;
 unsigned long temp;

 if (curve->num_xys <= 1) return NO_ERROR;
 temp = curve->num_xys / 2;
 cnt =  curve->num_xys;
 for (lcv = 0,indx = 0; indx < temp; lcv++,indx++)
    {cnt--;
     pt = curve->xys[cnt];
     curve->xys[cnt] = curve->xys[lcv];
     curve->xys[lcv] = pt;}
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
same_gradient - ???
-------------------------------------------------------------------------*/

int
same_gradient(pt1,pt2,pt3,pts,cur_pt)
 struct float_xy_rec *pt1,*pt2,*pt3,*pts;
 unsigned long *cur_pt;
{
 float m1,m2;

 if (pt1->x == pt2->x)
    {if (pt2->x == pt3->x)
        {if (is_float_between(pt3->y,pt1->y,pt2->y))
            {if ((pts[*cur_pt - 1].x != pt1->x) ||
                 (pts[*cur_pt - 1].y != pt1->y))
                pts[(*cur_pt)++] = *pt1;
             *pt1 = *pt2;
             *pt2 = *pt3;}
           else if (is_float_between(pt2->y,pt1->y,pt3->y))
            *pt2 = *pt3;
           else
            {*pt1 = *pt2;
             *pt2 = *pt3;}

         return 1;}
     return 0;
    }
 if ((pt1->y == pt2->y) && (pt2->y == pt3->y))
    {if (is_float_between(pt3->x,pt1->x,pt2->x))
        {
         if ((pts[*cur_pt - 1].x != pt1->x) || 
             (pts[*cur_pt - 1].y != pt1->y))
            pts[(*cur_pt)++] = *pt1;
         *pt1 = *pt2;
         *pt2 = *pt3;}
       else if (is_float_between(pt2->x,pt1->x,pt3->x))
         *pt2 = *pt3;
       else
        {*pt1 = *pt2;
         *pt2 = *pt3;}
     return 1;}
 if (pt2->x == pt3->x) return 0;

 m1 = (float) pt1->y - (float) pt2->y;
 m1 /= (float) ((float) pt1->x - (float) pt2->x);

 m2 = (float) pt2->y - (float) pt3->y;
 m2 /= (float) ((float) pt2->x - (float) pt3->x);
 if (m1 == m2)
    {if (is_float_between(pt3->x,pt1->x,pt2->x))
        {
         *pt1 = *pt2;
         *pt2 = *pt3;}
       else if (is_float_between(pt2->x,pt1->x,pt3->x))
         *pt2 = *pt3;
       else
        {*pt1 = *pt2;
         *pt2 = *pt3;}
     return 1;}
 return 0;
}


/*-------------------------------------------------------------------------
optimize_curve_rec - ???
-------------------------------------------------------------------------*/

int
optimize_curve_rec(curve)
 struct curve_rec *curve;
{
 unsigned long indx;
 unsigned long cur_pt;
 struct float_xy_rec pt1,pt2;

 if (curve->num_xys <= 2) return NO_ERROR;
 PRT9(printf("optimize_curve_rec...num_xys = %d\n",curve->num_xys))
 pt1 = curve->xys[0];
 pt2 = curve->xys[1];
 for (cur_pt = 0,indx = 2; indx < curve->num_xys;)
    {if (same_gradient(&pt1,&pt2,&(curve->xys[indx]),curve->xys,&cur_pt))
        {indx++;
         continue;
        }
     if ((cur_pt == 0) || (curve->xys[cur_pt - 1].x != pt1.x) || 
         (curve->xys[cur_pt - 1].y != pt1.y))
        {
         curve->xys[cur_pt++] = pt1;
        }
     if ((curve->xys[cur_pt - 1].x != pt2.x) || 
         (curve->xys[cur_pt - 1].y != pt2.y))
        curve->xys[cur_pt++] = pt2;
     if (indx + 1 < curve->num_xys)
        {pt1 = pt2;
         pt2 = curve->xys[indx++];}
        else
         {
          curve->xys[cur_pt++] = curve->xys[indx];
          break;}
    }
 if (cur_pt == 0)
    {curve->xys[cur_pt++] = pt1;
     curve->xys[cur_pt++] = pt2;}
   else if (indx >= curve->num_xys)
    {
     if ((curve->xys[cur_pt - 1].x != pt1.x) || 
         (curve->xys[cur_pt - 1].y != pt1.y))
        curve->xys[cur_pt++] = pt1;
     curve->xys[cur_pt++] = pt2;}
 curve->num_xys = cur_pt;
 PRT9(printf("optimize_curve_rec...end num_xys = %d\n",curve->num_xys))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
no_duplicate_pts - ???
-------------------------------------------------------------------------*/

void
no_duplicate_pts(curve)
 struct curve_rec *curve;
{
 unsigned long lcv,cnt;

 if (curve->num_xys == 0) return;
 for (cnt = 0,lcv = 1; lcv < curve->num_xys; lcv++)
    if ((curve->xys[lcv].x != curve->xys[cnt].x) ||
        (curve->xys[lcv].y != curve->xys[cnt].y))
       {if ((cnt + 1) == lcv) cnt++;
          else curve->xys[++cnt] = curve->xys[lcv];}
 if (cnt == 0) curve->num_xys = 1;
   else curve->num_xys = cnt + 1;
}


/*-------------------------------------------------------------------------
set_curve_matrix - ???
-------------------------------------------------------------------------*/

int
set_curve_matrix(curve,matrix,is_mult,status)
 struct curve_rec *curve;
 struct matrix_2d_rec *matrix;
 int is_mult;
 unsigned short *status;
{
 PRT4(printf("curve->status = %x is_mult = %d\n",
        (unsigned long) curve->status,is_mult))
 if (is_mult)
    {if (curve->status & CURVE_MATRIX_IN_USE)
        {
         PRT4(printf("is_mult = %d\n",is_mult))
         mult_2d_matrix(&(curve->matrix),matrix,&(curve->matrix));
        }
       else
        {
         curve->matrix = *matrix;}
    }
   else 
    {
     curve->matrix = *matrix;}
 inverse_2d_matrix(&(curve->inv),&(curve->matrix));
 PRT4(pr_2d_matrix(matrix))
 curve->status |= CURVE_MATRIX_IN_USE;
 curve->status &= ~COORDINATE_BOUND_COMPUTED;
 *status |= SLICE_ROI_TO_BE_SAVED;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
set_curve_or - ???
-------------------------------------------------------------------------*/

int
set_curve_or(curve)
 struct curve_rec *curve;
{
 curve->status |= CURVE_OR;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
apply_to_pen - ???
-------------------------------------------------------------------------*/

int
apply_to_pen(pen,proc,
             arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10)
 struct curve_2d_rec *pen;
 int (*proc)();
 void *arg2,*arg3,*arg4,*arg5,*arg6,*arg7,*arg8,*arg9,*arg10;
{
 unsigned long lcv;
 int err;

 for (lcv = 0; lcv < pen->num_curves; lcv++)
    {pen->curves[lcv]->status |= pen->pen_type & DRAW_MODE;
     if ((err = proc(pen->curves[lcv],arg2,arg3,
             arg4,arg5,arg6,arg7,arg8,arg9,arg10)) != NO_ERROR)
       return err;
    }

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
apply_to_roi_rec - ???
-------------------------------------------------------------------------*/

int
apply_to_roi_rec(roi,proc,
                 arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10)
 struct roi_rec *roi;
 int (*proc)();
 void *arg2,*arg3,*arg4,*arg5,*arg6,*arg7,*arg8,*arg9,*arg10;
{
 unsigned long lcv;
 int err;

 for (lcv = 0; lcv < roi->num_pens; lcv++)
    if ((err = apply_to_pen(roi->pens[lcv],proc,arg2,arg3,arg4,arg5,
          arg6,arg7,arg8,arg9,arg10)) != NO_ERROR)
       return err;

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
apply_to_slice_roi_rec - ???
-------------------------------------------------------------------------*/

int
apply_to_slice_roi_rec(slice_roi,proc,
                       arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10)
 struct slice_roi_rec *slice_roi;
 int (*proc)();
 void *arg2,*arg3,*arg4,*arg5,*arg6,*arg7,*arg8,*arg9,*arg10;
{
 unsigned long lcv;
 int err;

 for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
    if ((err = apply_to_roi_rec(slice_roi->rois[lcv],proc,arg2,arg3,arg4,arg5,
            arg6,arg7,arg8,arg9,arg10)) != NO_ERROR)
       return err;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
transform_curve - ???
-------------------------------------------------------------------------*/

int
transform_curve(result_curve,curve,matrix,status)
 struct curve_rec *result_curve,*curve;
 struct matrix_2d_rec *matrix;
 unsigned short *status;
{
 unsigned long lcv;
 float x,y;

 PRT(printf("transform_curve curve->num_xys = %d\n",curve->num_xys))
 result_curve->status &= ~CURVE_MATRIX_IN_USE;
 result_curve->status &= ~COORDINATE_BOUND_COMPUTED;
 if (curve->num_xys == 0) return NO_ERROR;
 for (lcv = 0; lcv < curve->num_xys; lcv++)
    {x = matrix->buf[0][0] * (float) curve->xys[lcv].x + 
         matrix->buf[0][1] * (float) curve->xys[lcv].y + matrix->buf[0][2] + .5;
     y = matrix->buf[1][0] * (float) curve->xys[lcv].x + 
         matrix->buf[1][1] * (float) curve->xys[lcv].y + matrix->buf[1][2] + .5;
     result_curve->xys[lcv].x = floor((double) x);
     result_curve->xys[lcv].y = floor((double) y);
    }
 *status |= SLICE_ROI_TO_BE_SAVED;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
transform_pen - ???
-------------------------------------------------------------------------*/

int
transform_pen(pen,matrix,status,is_transform_cur_curve)
 struct curve_2d_rec *pen;
 struct matrix_2d_rec *matrix;
 unsigned short *status;
 int is_transform_cur_curve;
{
 unsigned long lcv;

 for (lcv = 0; lcv < pen->num_curves; lcv++)
    {if (lcv == pen->cur_curve)
        if (!is_transform_cur_curve) continue;
     transform_curve(pen->curves[lcv],pen->curves[lcv],matrix,status);
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
transform_roi_rec - ???
-------------------------------------------------------------------------*/

int
transform_roi_rec(roi,matrix,status,is_transform_cur_curve)
 struct roi_rec *roi;
 struct matrix_2d_rec *matrix;
 unsigned short *status;
 int is_transform_cur_curve;
{
 unsigned long lcv;

 for (lcv = 0; lcv < roi->num_pens; lcv++)
    transform_pen(roi->pens[lcv],matrix,status,is_transform_cur_curve);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
transform_slice_roi_rec - ???
-------------------------------------------------------------------------*/

int
transform_slice_roi_rec(slice_roi,matrix,is_transform_cur_curve)
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *matrix;
 int is_transform_cur_curve;
{
 unsigned long lcv;

 for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
    transform_roi_rec(slice_roi->rois[lcv],matrix,&(slice_roi->status),
          is_transform_cur_curve);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
check_and_transform_curve - ???
-------------------------------------------------------------------------*/

int
check_and_transform_curve(curve,status)
 struct curve_rec *curve;
 unsigned short *status;
{
 if (curve->status & CURVE_MATRIX_IN_USE)
    {
     return transform_curve(curve,curve,&(curve->matrix),status);}
   else return NO_ERROR;
}


/*-------------------------------------------------------------------------
scale_slice_roi_rec_dim - ???

FIXME:  This function appears to never be used.
-------------------------------------------------------------------------*/

void
scale_slice_roi_rec_dim(slice_roi,dimx,dimy)
 struct slice_roi_rec *slice_roi;
 unsigned long dimx,dimy;
{
 float sx,sy;
 struct matrix_2d_rec matrix;

 if (slice_roi->dimx == 0) slice_roi->dimx = dimx;
 if (slice_roi->dimy == 0) slice_roi->dimx = dimy;
 if ((slice_roi->dimx == dimx) && (slice_roi->dimy == dimy))
     return /*NO_ERROR*/;
 sx = (float) dimx / (float) slice_roi->dimx;
 sy = (float) dimy / (float) slice_roi->dimy;
 setup_scale_2d_matrix(&matrix,sx,sy);
 transform_slice_roi_rec(slice_roi,&matrix,1);

 slice_roi->dimx = dimx;
 slice_roi->dimy = dimy;
}


/*-------------------------------------------------------------------------
mark_roi_delete - ???
-------------------------------------------------------------------------*/

void
mark_roi_delete(roi,status,is_mark_delete)
 struct roi_rec *roi;
 unsigned short *status;
 int is_mark_delete;
{
 if (is_mark_delete)
    {roi->prog_status |= ROI_MARK_DELETE;
     *status |= SLICE_ROI_MARK_DELETE;}
   else
    roi->prog_status &= ~ROI_MARK_DELETE;
}



/*-------------------------------------------------------------------------
delete_roi_marked_delete - ???
-------------------------------------------------------------------------*/

int
delete_roi_marked_delete(slice_roi,is_some_deleted)
 struct slice_roi_rec *slice_roi;
 int *is_some_deleted;
{
 unsigned long lcv;

 for (*is_some_deleted = 0,lcv = 0; lcv < slice_roi->num_rois; )
    if ((slice_roi->rois[lcv] != NULL) && 
        (slice_roi->rois[lcv]->prog_status & ROI_MARK_DELETE))
       {*is_some_deleted = 1;
/*
        printf("status = %x  label = %s\n",slice_roi->rois[lcv]->status,
                slice_roi->rois[lcv]->label);
*/
        delete_roi(slice_roi,slice_roi->rois[lcv]);
       }
      else lcv++;
 slice_roi->status &= ~SLICE_ROI_MARK_DELETE;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
MoveOutOfBoundCurve - ???
-------------------------------------------------------------------------*/

int
MoveOutOfBoundCurve(curve,localto,left,top,right,bottom,moveto_x,moveto_y,
                    is_move,status)
 struct curve_rec *curve;
 struct matrix_2d_rec *localto;
 float *left,*top,*right,*bottom,*moveto_x,*moveto_y;
 int *is_move;
 unsigned short *status;
{
 struct matrix_2d_rec matrix;
 float minx,maxx,miny,maxy;

 PRT5(printf("MoveOutOfBoundCurve curve->num_xys = %d\n",curve->num_xys))
 if (curve->num_xys == 0) return NO_ERROR;
 PRT5(printf("MoveOutOfBoundCurve l = %f t = %f r = %f b = %f mx = %f my = %f\n",
     *left,*top,*right,*bottom,*moveto_x,*moveto_y))
 if (FindCurveMinMax(curve,localto,&minx,&maxx,&miny,&maxy,
           curve->status & DRAW_MODE,0,0,1) == NO_ERROR)
    {if ((minx >= *left) && (minx <= *right) &&
         (maxx >= *left) && (maxx <= *right) &&
         (miny >= *top) && (miny <= *bottom) &&
         (maxy >= *top) && (maxy <= *bottom))
       return NO_ERROR;
     PRT5(printf("MoveOutOfBoundCurve...1\n"))
     setup_translate_2d_matrix(&matrix,
       (float) (*moveto_x - (maxx + minx) / 2),
       (float) (*moveto_y - (maxy + miny) / 2));
     set_curve_matrix(curve,&matrix,1,status);
     *is_move = 1;

     PRT5(printf("MoveOutOfBoundCurve...2\n"))
     if (FindCurveMinMax(curve,localto,&minx,&maxx,&miny,&maxy,
           curve->status & DRAW_MODE,0,0,1) == NO_ERROR)
        {if ((minx >= *left) && (minx <= *right) &&
             (maxx >= *left) && (maxx <= *right) &&
             (miny >= *top) && (miny <= *bottom) &&
             (maxy >= *top) && (maxy <= *bottom))
            return NO_ERROR;}
     PRT5(printf("MoveOutOfBoundCurve...3\n"))
     if (curve->num_xys > 1)
        {setup_translate_2d_matrix(&matrix,*moveto_x,*moveto_y);
         set_curve_matrix(curve,&matrix,1,status);}
   }

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
MoveOutOfBoundRois - ???
-------------------------------------------------------------------------*/

int
MoveOutOfBoundRois(slice_roi,localto,left,top,right,bottom,moveto_x,moveto_y)
 struct slice_roi_rec *slice_roi;
 struct matrix_2d_rec *localto;
 float left,top,right,bottom,moveto_x,moveto_y;
{
 int is_move;
 float left1,top1,right1,bottom1,moveto_x1,moveto_y1;

 is_move = 0;
 PRT5(printf("MoveOutOfBoundRois l = %f t = %f r = %f b = %f mx = %f my = %f\n",
     left,top,right,bottom,moveto_x,moveto_y))
 left1 = left;
 top1 = top;
 right1 = right;
 bottom1 = bottom;
 moveto_x1 = moveto_x;
 moveto_y1 = moveto_y;
 apply_to_slice_roi_rec(slice_roi,MoveOutOfBoundCurve,localto,
            &left1,&top1,&right1,&bottom1,&moveto_x1,&moveto_y1,&is_move,
            &(slice_roi->status));
 return is_move;
}


/*-------------------------------------------------------------------------
AddOffsetToCurveXYs - ???
-------------------------------------------------------------------------*/

int
AddOffsetToCurveXYs(curve,select,minx,maxx,miny,maxy,offset,status,
                    tolocal,localto)
 struct curve_rec *curve;
 unsigned long select;
 long minx,maxx,miny,maxy,offset;
 unsigned short *status;
 struct matrix_2d_rec *tolocal,*localto;
{
 unsigned long lcv;
 long x,y;
 float x1,y1;
 int is_save;

 PRT5(printf("Add minx = %d miny = %d maxx = %d maxy = %d select = %x offset = %d\n",minx,miny,maxx,maxy,select,offset);)
 for (is_save = 0,lcv = 0; lcv < curve->num_xys; lcv++)
    {if (CurvePtByIndx(curve,lcv,&x1,&y1,localto) != NO_ERROR)
        break;
     x = floor((double) (x1 + .5));
     y = floor((double) (y1 + .5));
     if ((select & 1) && (minx == x))
        {if (select & 0x00000010) x1 -= offset;
           else x1 += offset;
         is_save = 1;}
     if (!is_save && (select & 2) && (miny == y))
        {if (select & 0x00000010) y1 -= offset;
           else y1 += offset;
         is_save = 1;}
     if (!is_save && (select & 0x00000004) && (maxx == x))
        {if (select & 0x00000010) x1 -= offset;
           else x1 += offset;
         is_save = 1;}
     if (!is_save && (select & 0x00000008) && (maxy == y))
        {if (select & 0x00000010) y1 -= offset;
           else y1 += offset;
         is_save = 1;}
     PRT5(printf("%d) x = %d x1 = %f  y = %d  y1 = %f is_save = %d\n",lcv,x,x1,
              y,y1,is_save);)
     if (is_save)
        {EnterCurveXY(curve,x1,y1,status,tolocal,1,1,lcv);
         is_save = 0;

         PRT5(CurvePtByIndx(curve,lcv,&x1,&y1,localto);
              printf("saved x = %d x1 = %f  y = %d  y1 = %f \n",x,x1,
              y,y1);)
        }
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
AddOffsetToPenXYs - ???
-------------------------------------------------------------------------*/

int
AddOffsetToPenXYs(pen,select,minx,maxx,miny,maxy,offset,status,tolocal,localto)
 struct curve_2d_rec *pen;
 unsigned long select;
 long minx,maxx,miny,maxy,offset;
 unsigned short *status;
 struct matrix_2d_rec *tolocal,*localto;
{
 unsigned long lcv;

 for (lcv = 0; lcv < pen->num_curves; lcv++)
    AddOffsetToCurveXYs(pen->curves[lcv],select,minx,maxx,miny,maxy,
             offset,status,tolocal,localto);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
AddOffsetToRoiXYs - ???
-------------------------------------------------------------------------*/

int
AddOffsetToRoiXYs(roi,select,minx,maxx,miny,maxy,offset,status,tolocal,localto)
 struct roi_rec *roi;
 unsigned long select;
 long minx,maxx,miny,maxy,offset;
 unsigned short *status;
 struct matrix_2d_rec *tolocal,*localto;
{
 unsigned long lcv;

 if (roi == NULL) return NO_ERROR;
 for (lcv = 0; lcv < roi->num_pens; lcv++)
    AddOffsetToPenXYs(roi->pens[lcv],select,minx,maxx,miny,maxy,offset,
             status,tolocal,localto);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
NewMappedCurve - ???
-------------------------------------------------------------------------*/

int
NewMappedCurve(result,curve,localto,maptolocal)
 struct curve_rec *result,*curve;
 struct matrix_2d_rec *localto,*maptolocal;
{
 unsigned long total;
 struct matrix_2d_rec mat,*pmat;
 int err;

 PRT7(printf("NewMappedCurve...\n"))
 if (curve->num_xys > result->total_xys)
    {total = curve->num_xys - result->total_xys + ALLOCATE_MAX_XY_PTS;
     if ((err = get_ptr(&(result->xys),&(result->total_xys),
         (unsigned long) total,(size_t) sizeof(*(result->xys)))) != NO_ERROR)
        return err;}
 PRT7(printf("NewMappedCurve...1\n"))
 curve_matrix(curve,localto,&mat,&pmat,1);
 if (pmat == NULL) pmat = maptolocal;
   else if (maptolocal != NULL) 
    mult_2d_matrix(pmat,maptolocal,pmat);

 result->status &= ~DRAW_MODE;
 result->status |= curve->status & DRAW_MODE;
 result->status &= ~COORDINATE_BOUND_COMPUTED;
 if (pmat != NULL)
    {result->status |= CURVE_MATRIX_IN_USE;
     result->matrix = *pmat;
     inverse_2d_matrix(&(result->inv),&(result->matrix));}
   else result->status &= ~CURVE_MATRIX_IN_USE;

 total = curve->num_xys * sizeof(*(curve->xys));
 PRT7(printf("NewMappedCurve...2\n"))
 memcpy(result->xys,curve->xys,total);
 result->num_xys = curve->num_xys;
 PRT7(printf("NewMappedCurve...result->num_xys - %d\n",result->num_xys))

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
MatchCurve - ???
-------------------------------------------------------------------------*/

int
MatchCurve(curve,localto,match_curve,match_localto,diff_allowed,num_xys,is_match_longer)
 struct curve_rec *curve,*match_curve;
 struct matrix_2d_rec *localto,*match_localto;
 float diff_allowed;
 unsigned long *num_xys;
 int *is_match_longer;
{
 unsigned long lcv,num_xys1;
 struct matrix_2d_rec mat,*pmat;
 struct matrix_2d_rec mat1,*pmat1;
 float x,y,x1,y1,diff;

 PRT7(printf(" match_curve...0\n"))
 if (curve == NULL)
    {*is_match_longer = 0;
     *num_xys = 0;
     return CANCEL;}
 if (match_curve->num_xys < curve->num_xys)
    {num_xys1 = match_curve->num_xys;
     *is_match_longer = -1;}
   else
    {num_xys1 = curve->num_xys;
     if (match_curve->num_xys == curve->num_xys) *is_match_longer = 0;
       else *is_match_longer = 1;
    }
 *num_xys = num_xys1;
 if ((curve->status & DRAW_MODE) != (match_curve->status & DRAW_MODE))
    {PRT7(printf("not match_curve status == %x match = %x\n",
        (unsigned long) curve->status & DRAW_MODE,
        (unsigned long) match_curve->status & DRAW_MODE))
     return CANCEL;
    }
 PRT7(printf(" match_curve...1\n"))
 curve_matrix(curve,localto,&mat,&pmat,1);
 curve_matrix(match_curve,match_localto,&mat1,&pmat1,1);
 for (lcv = 0; lcv < num_xys1; lcv++)
    {if (pmat != NULL)
        trans_2d_pt(pmat,curve->xys[lcv].x,
             curve->xys[lcv].y,&x,&y,0);
       else
        {x = curve->xys[lcv].x;
         y = curve->xys[lcv].y;}
     if (pmat1 != NULL)
        trans_2d_pt(pmat1,match_curve->xys[lcv].x,
             match_curve->xys[lcv].y,&x1,&y1,0);
       else
        {x1 = match_curve->xys[lcv].x;
         y1 = match_curve->xys[lcv].y;}
     diff = x - x1;
     if (diff < .0) diff = -diff;
     if (diff > diff_allowed) return CANCEL;
     diff = y - y1;
     if (diff < .0) diff = -diff;
     if (diff > diff_allowed) return CANCEL;
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
SetSameRoisStatus - ???
-------------------------------------------------------------------------*/

int
SetSameRoisStatus(slice_roi1,slice_roi2,and_status2,or_status2,
                      and_prog_status2,or_prog_status2)
 struct slice_roi_rec *slice_roi1,*slice_roi2;
 unsigned short and_status2,or_status2,and_prog_status2,or_prog_status2;
{
 unsigned long lcv;
 struct roi_rec *roi;

 for (lcv = 0; lcv < slice_roi2->num_rois; lcv++)
    if ((roi = get_roi(slice_roi1,slice_roi2->rois[lcv]->label)) != NULL)
       {roi->status &= and_status2;
        roi->status |= or_status2;
        roi->prog_status &= and_prog_status2;
        roi->prog_status |= or_prog_status2;}
 return NO_ERROR;
}
