/****************************************************************************
text_output.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: text_output.c,v 1.7 1999/07/07 17:41:20 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "mri_format.h"
#include "text_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT4(x)



/* Functions defined in this file */
int store_in_collection_rec_buf(unsigned char **buf,
    unsigned long *total_buf_size, unsigned long *buf_size, char *str,
    unsigned int str_len);
int get_collection(struct collection_rec *collection,
    struct output_field_rec *group, unsigned int pixel_type, double voxel,
    struct output_count_group_rec *counts, unsigned int num_slices,
    unsigned int group_indx);
int setup_page_rec(struct text_output_rec *text);
int setup_all_collection_rec(struct text_output_rec *text);
void flush_the_text_output(struct text_output_rec *text);
int is_text_output(struct text_output_rec *text);
int WrPixelTypeTextFileInfo(FILE *fid, char **text_printing_time,
    struct output_text_format_rec *format, struct hdr_rec *hdr,
    struct output_hdr_rec *ndathdr, struct pixel_type_rec *pixel_type,
    char *prog_name, char *prog_id, char *hdrdirfn, char *hdrfn,
    char *hdrsuffix, char *imgsuffix, char *ndatdir, char *ndatfn,
    char *ndatsuffix);
int WrPixelTypeTextLabels(FILE *fid, struct output_text_format_rec *format);
int PrintPixelTypeTextToFile(char *fn, struct input_file_rec *file,
    char **text_printing_time, struct output_text_format_rec *format,
    struct all_collection_rec *analysis, unsigned short *status);
int print_pixel_type_text_to_temp_file(struct text_output_rec *text);
int save_pixel_type_text_to_file(char *fn, struct text_output_rec *text);


/*-------------------------------------------------------------------------
store_in_collection_rec_buf - ???

FIXME:  The arguments total_buf_size and buf_size were unsigned int, but
this was incompatible with the arguments actually used by callers.  I
changed the definition here and the prototype.  Similarly, changed the
argument buf from plain char** to unsigned char**.   -PWH 19990429
-------------------------------------------------------------------------*/

int
store_in_collection_rec_buf(buf,total_buf_size,buf_size,str,str_len)
 unsigned char **buf;            /* Was plain char */
 unsigned long *total_buf_size;  /* Was unsigned int *  */
 unsigned long *buf_size;        /* Was unsigned int *  */
 char *str;
 unsigned int str_len;
{
 unsigned int temp;
 int err;

 temp = *buf_size + str_len + 2;
 TRACE(printf("store_in_collection_rec_buf...temp = %d *total_buf_size = %d\n",temp,
          *total_buf_size))
 if (temp >= *total_buf_size)
    {get_ptr_memory(buf,&(*total_buf_size),
            (unsigned int) 512,(size_t) sizeof(char),&err); 
     if (err)
        {TRACE(printf("store_in_collection_rec_buf...err = %d\n",err))
         return err;}
    }
 TRACE(printf("temp = %d *total_buf_size = %d\n",temp,*total_buf_size))
 (*buf)[(*buf_size)++] = str_len;
 memcpy(&((*buf)[*buf_size]),str,(size_t) str_len);
 (*buf)[(*buf_size)+str_len] = '\0';
 *buf_size = temp;

 return NO_ERROR;
}



/*-------------------------------------------------------------------------
get_collection - ???

 format...
  1) max_digit_chs
  2) num_fields
  3) num_digit_chs
  4) digit chs
     3) & 4) are as follow :
       --- a) the first line is the field titles...
           b) repeated by "num_fields" * "num_slices" times where the pixel
              count of each pixel type for each roi is represented.
           c) following b) is the total pixel count of each pixel type for 
              each roi.
           d) and the last line is the total voxel value of each pixel type for
              each roi.
-------------------------------------------------------------------------*/

#if 0
#undef TRACE
#define TRACE(x) x; fflush(stdout);
#endif

int
get_collection(collection,group,
                pixel_type,voxel,counts,num_slices,group_indx)
 struct collection_rec *collection;
 struct output_field_rec *group;
 unsigned int pixel_type;
 float voxel;
 struct output_count_group_rec *counts;
 unsigned int num_slices,group_indx;
{
 unsigned int cnt,lcv,size,temp,*total_pixels,num_fields,row_total,cnt_field,
                cnt_defined;
 char str[30];
 int err,is_pixel_type_undefined;

 if (pixel_type == 0) return NO_ERROR;
 pixel_type -= 1;

 collection->num_fields = group->num_roi_indxs;
 collection->num_slices = num_slices;

 TRACE(printf("\n\nget_collection..num_roi_indxs = %d num_fields = %d\n",
         group->num_roi_indxs,collection->num_fields))
 TRACE(printf("group_indx = %d counts[0].groups[group_indx].num_fields = %d\n",group_indx,counts[0].groups[group_indx].num_fields))

 collection->max_digit_chs = 0;
 for (num_fields = 0,lcv = 0; lcv < collection->num_fields; lcv++)
    {
     if (group->roi_indxs[lcv] > 0)
        {
         sprintf(str,"%-d/[%ld]",pixel_type + 1,group->roi_indxs[lcv]);
         size = (unsigned int) strlen(str);
         if ((err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,
                 size))!= NO_ERROR)
            return err;
         if (size > collection->max_digit_chs)
            collection->max_digit_chs = size;
         num_fields += 1;
        }
    }
 TRACE(printf("get_collection.&&&&&.num_roi_indxs = %d\n",
         group->num_roi_indxs))

 if (num_fields > 1)
    {num_fields += 1;
     if ((err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),"TOTAL",
                  (unsigned int) 5)) != NO_ERROR)
        return err;
     if (5 > collection->max_digit_chs) collection->max_digit_chs = size;
    }
 TRACE(printf("get_collection..num_fields = %d max_digit_chs = %d\n",num_fields,
           collection->max_digit_chs))
 if (num_fields == 0) return NO_ERROR;
 temp = 0;
 get_ptr_memory(&total_pixels,&temp,(unsigned int) num_fields,
      (size_t) sizeof(unsigned int),&err);
 if (err) return err;
 for (lcv = 0; lcv < num_fields; lcv++) total_pixels[lcv] = 0;
     
 TRACE(printf("setup_collection..group_indx = %d\n",group_indx))


/*  DRW  960906  By this point, the counts have already been "corrected"
 *    to account for shared regions.  */
#if 0
 for (cnt = 0; cnt < collection->num_slices; cnt++)
    for (lcv = 0; lcv < counts[cnt].groups[group_indx].num_fields; lcv++)
      if (counts[cnt].groups[group_indx].fields[lcv].valid)
	printf("Slice %d, Field %d) valid = %x val = %lu\n",
	       cnt,lcv,counts[cnt].groups[group_indx].fields[lcv].valid,
	       counts[cnt].groups[group_indx].fields[lcv].value);
#endif

 for (cnt = 0; cnt < collection->num_slices; cnt++)
    {cnt_defined = cnt_field = row_total = 0;
     is_pixel_type_undefined = 0;
     for (lcv = 0; lcv < collection->num_fields; lcv++)
        {if (group->roi_indxs[lcv] == 0) continue;
/*printf("slice#%d group_indx = %d f# = %d valid = %d\n",cnt,group_indx,lcv,
            (unsigned long) counts[cnt].groups[group_indx].fields[lcv].valid);*/
         if (counts[cnt].groups[group_indx].fields[lcv].valid &
                        COUNT_PIXEL_TYPE_NOT_DEFINED)
            {is_pixel_type_undefined = 1;
             sprintf(str,"?");}
           else if (counts[cnt].groups[group_indx].fields[lcv].valid &
                        COUNT_ROI_DEFINED)
            {if (counts[cnt].groups[group_indx].fields[lcv].valid &
                        COUNT_ROI_NOT_COMPUTED)
                sprintf(str,"-");
               else 
               {cnt_defined += 1;
                /*printf("value = %d\n",
                    counts[cnt].groups[group_indx].fields[lcv].value);*/
                sprintf(str,"%-ld",
                   counts[cnt].groups[group_indx].fields[lcv].value);

                total_pixels[lcv] += 
                    counts[cnt].groups[group_indx].fields[lcv].value;
                if (num_fields > 1)
                   row_total +=
                     counts[cnt].groups[group_indx].fields[lcv].value;
                cnt_field += 1;
               }
            }
           else sprintf(str,"*");
         size = (unsigned int) strlen(str);
         err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
         if (err != NO_ERROR)
            {c_free(total_pixels);
             return err;}
         if (size > collection->max_digit_chs)
            collection->max_digit_chs = size;
        }
     if (num_fields > 1)
        {if (cnt_defined == 0)
            {if (is_pixel_type_undefined) sprintf(str,"?");
               else sprintf(str,"*");
            }
           else if (cnt_field == 0) sprintf(str,"-");
           else sprintf(str,"%-d",row_total);
         total_pixels[num_fields - 1] += row_total;
         size = (unsigned int) strlen(str);
         err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
         if (err != NO_ERROR)
            {c_free(total_pixels);
             return err;}
         if (size > collection->max_digit_chs)
            collection->max_digit_chs = size;
        }
    }

 TRACE(printf("setup_collection..3 max = %d\n",collection->max_digit_chs))
 for (lcv = 0; lcv < collection->num_fields; lcv++)
    {
     if (group->roi_indxs[lcv] > 0)
        {sprintf(str,"%-d",total_pixels[lcv]);
         size = (unsigned int) strlen(str);
         err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
         if (err != NO_ERROR)
            {c_free(total_pixels);
             return err;}
         if (size > collection->max_digit_chs)
            collection->max_digit_chs = size;
        }

    }
 if (num_fields > 1)
    {sprintf(str,"%-d",total_pixels[num_fields - 1]);
     size = (unsigned int) strlen(str);
     err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
     if (size > collection->max_digit_chs)
        collection->max_digit_chs = size;
     if (err != NO_ERROR)
        {c_free(total_pixels);
         return err;}
    }

 TRACE(printf("setup_collection..4 max = %d\n",collection->max_digit_chs))
 for (lcv = 0; lcv < collection->num_fields; lcv++)
    {if (group->roi_indxs[lcv] > 0)
        {sprintf(str,"%-.2f",(float) (total_pixels[lcv] * voxel / 1000.0));
         size = (unsigned int) strlen(str);
         err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
         if (err != NO_ERROR)
            {c_free(total_pixels);
             return err;}
         if (size > collection->max_digit_chs)
            collection->max_digit_chs = size;
        }
    }
 if (num_fields > 1)
    {sprintf(str,"%-.2f",total_pixels[num_fields - 1] * voxel / 1000.0);
     size = (unsigned int) strlen(str);
     err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
     if (err != NO_ERROR)
        {c_free(total_pixels);
         return err;}
     if (size > collection->max_digit_chs)
        collection->max_digit_chs = size;
    }

 collection->num_fields = num_fields;
 TRACE(printf("setup_collection..end num_fields = %d max = %d\n",collection->num_fields,collection->max_digit_chs))
 c_free(total_pixels);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
setup_page_rec - ???
-------------------------------------------------------------------------*/

int
setup_page_rec(text)
 struct text_output_rec *text;
{
 struct all_collection_rec *analysis;
 unsigned int row_size,temp,cnt,lcv,indx;
 struct page_rec *page;
 int err;

 analysis = &(text->analysis);
 TRACE(printf("\n\nsetup_page_rec...begin analysis->num_collects = %d\n",
            analysis->num_collects))
 for (lcv = 0; lcv < analysis->num_collects; lcv = cnt)
    {row_size = analysis->num_line_label_spaces;
     for (cnt = lcv; cnt < analysis->num_collects; )
        {temp = row_size + text->format.num_collect_spaces +
                (text->format.num_field_spaces +
                  analysis->collects[cnt].max_digit_chs) *
                            analysis->collects[cnt].num_fields;
         if (temp >= text->format.page_row_size) break;
         cnt++;
         row_size = temp;
        }
     if (cnt == lcv) cnt++;
     get_ptr_memory(&(analysis->pages),&(analysis->num_pages),(unsigned int) 1,
          (size_t) sizeof(struct page_rec),&err);
     if (err) return err;
     page = &(analysis->pages[analysis->num_pages - 1]);
     init_page_rec(page);
     temp = cnt - lcv;
     get_ptr_memory(&(page->collects),&(page->num_collects),(unsigned int) temp,
          (size_t) sizeof(struct collection_rec *),&err);
     if (err) return err;
     for (temp = 0,indx = lcv; indx < cnt; indx++,temp++)
        page->collects[temp] = &(analysis->collects[indx]);
    }
 TRACE(printf("setup_page_rec...end\n"))
 return NO_ERROR;
}




/*-------------------------------------------------------------------------
setup_all_collection_rec - ???

DRW 960906: Seems to be where the text is formatted and written after
analysis.
-------------------------------------------------------------------------*/

int
setup_all_collection_rec(text)
 struct text_output_rec *text;
{
 struct all_collection_rec *analysis;
 unsigned int lcv,cnt;
 char str[20];
 int err;



 TRACE(printf("setup_all_collection_rec...\n"))
 if (!(text->format.status & OUT_FORMAT_DEFINED))
    {
     if ((err = setup_output_format(text)) != NO_ERROR) return err;
    }

/*
 if (!(text->format.status & OUT_FORMAT_COUNT_DEFINED))
    if ((err = setup_pixel_type_output(&(text->format),text->file)) != NO_ERROR)
       return err;
*/

 TRACE(printf("setup_all_collection_rec...1\n"))
 analysis = &(text->analysis);
 free_all_collection_rec(analysis);

 text->analysis.total_slices = text->format.num_slices;

 c_free(analysis->text_temp_fn);
 if ((err = cp_str(&(analysis->text_temp_fn),tmpnam(NULL))) != NO_ERROR)
    return err;
     
 sprintf(str,"%ld",analysis->total_slices);
 analysis->num_line_label_spaces = strlen(str);
 if (analysis->num_line_label_spaces < FIRST_COL_SPACES)
    analysis->num_line_label_spaces = FIRST_COL_SPACES;

 analysis->cur_collect = analysis->num_collects = 0;

 get_ptr_memory(&(analysis->collects),&(analysis->num_collects),
         text->format.num_groups,(size_t) sizeof(struct collection_rec),&err);
 if (err) return err;

 for (lcv = 0; lcv < analysis->num_collects; lcv++)
    init_collection_rec(&(analysis->collects[lcv]));

 for (cnt = 0; cnt < text->format.num_groups; cnt++)
    {
     if ((err = get_collection(&(analysis->collects[cnt]),
			       &(text->format.groups[cnt]),
			       text->format.groups[cnt].pixel_type_indx,
			       text->format.voxel_size,
			       text->format.counts,
			       text->format.num_slices,
			       cnt)) != NO_ERROR)
              {free_all_collection_rec(analysis);
               TRACE(printf("after setup_collection err = %d\n",err))
               return err;}
    }

 if ((err = setup_page_rec(text)) != NO_ERROR)
    {free_all_collection_rec(analysis);
     return err;}
 text->status |= TEXT_OUTPUT_COMPUTED;
 TRACE(printf("setup_all_collection_rec...END\n"))
 return err;
}


/*-------------------------------------------------------------------------
flush_the_text_output - ???
-------------------------------------------------------------------------*/

void
flush_the_text_output(text)
 struct text_output_rec *text;
{
 text->status &= FLUSH_TEXT_OUTPUT_STATUS;
}


/*-------------------------------------------------------------------------
is_text_output - ???
-------------------------------------------------------------------------*/

int
is_text_output(text)
 struct text_output_rec *text;
{
 if (!(text->status & TEXT_OUTPUT_PARAMS_SETUP))
    {TRACE(printf("TEXT_OUTPUT_PARAMS_SETUP not exist...\n"))
     return 0;}
   else if (!(text->status & TEXT_OUTPUT_FORMAT_SETUP))
    {TRACE(printf("TEXT_OUTPUT_FORMAT_SETUP not exist...\n"))
     return 0;}
   else if (text->status & TEXT_OUTPUT_IN_PROGRESS)
    {TRACE(printf("TEXT_OUTPUT_IN_PROGRESS...\n"))
     return 0;}
   else if (!(text->status & TEXT_OUTPUT_COMPUTED))
    {TRACE(printf("TEXT_OUTPUT_COMPUTED hasn't been computed yet...\n"))
     return 0;}
 return 1;
}


/*********************
WrPixelTypeTextFileInfo(fid,file,text_printing_time)
 FILE *fid;
 struct input_file_rec *file;
 char **text_printing_time;
{
 char *str,*fn;
 int err,define;
 unsigned long lcv;

 if (get_strlen(file->output.hdr.rater) == 0)
    fprintf(fid,"RATER = UNKNOWN\n");
   else fprintf(fid,"RATER = %s\n",file->output.hdr.rater);
 if (text_printing_time != NULL)
    {if (*text_printing_time == NULL)
        *text_printing_time = current_asctime();
     fprintf(fid,"PRINTING DATE : %s",*text_printing_time);}

 if (file->prog != NULL)
    {fprintf(fid,"PROGRAM : %s",file->prog->prog_name);
     fprintf(fid,"       VERSION : %s\n",file->prog->prog_id);}

 if (file->pixel_type.slice_map_data_creation_date != NULL)
    fprintf(fid,"PIXEL TYPE CREATION DATE : %s",
              file->pixel_type.slice_map_data_creation_date);

 if ((err = build_fn(&str,file->dirfn,file->fn,
                     file->hdr_fn_suffix)) != NO_ERROR)
    return CANCEL;
 if ((err = concat_strs(&fn,3,str,"-",file->img_fn_suffix)) != NO_ERROR)
    {c_free(str);
     return CANCEL;}

 fprintf(fid,"INPUT FILES : 1) %s   VERSION : %s\n",fn,file->hdr.id);
 c_free(str);
 c_free(fn);

 if ((err = build_fn(&fn,file->output.dirfn,file->output.fn,
                     file->output.dat_fn_suffix)) != NO_ERROR)
    return CANCEL;
 fprintf(fid,"              2) %s   VERSION : %s\n",fn,
            file->output.hdr.id);
 c_free(fn);

 if ((err = build_fn(&fn,file->output.dirfn,file->output.fn,
                     TXT_SUFFIX)) != NO_ERROR)
    return CANCEL;
 fprintf(fid,"OUTPUT FILE : 1) %s\n",fn);
 c_free(fn);

 fprintf(fid,"\n");
 fprintf(fid,"IMAGE INFO.\n");
 fprintf(fid,"   Image dimension size = %d * %d   Pixel size = %-d bits\n",
         (int) file->hdr.data_info.dimx,
         (int) file->hdr.data_info.dimy,
         (int) file->hdr.data_info.pixel_depth_bits);

 fprintf(fid,"   PIXEL SIZE (X,Y) = %-.4fmm,%-.4fmm   THICKNESS = %-.4fmm\n",
     text->format.xpixel_size,text->format.ypixel_size,
           text->format.pixel_thickness);
 fprintf(fid,"   VOXEL = %-.4f (Cubic mm)\n",text->format.voxel_size);
 fprintf(fid,"   Total slice cuts = %d   Total scans = %d\n",
           NumberOfSliceCuts(&(file->hdr.data_info)),
           NumberOfSliceScans(&(file->hdr.data_info)));
 fprintf(fid,"   Total image slices = %d\n",
           (int) file->hdr.data_info.max_scans);
 for (lcv = 0; lcv < file->hdr.analysis.num_img_labels; lcv++)
    fprintf(fid,"      Image slices of type %s = %d\n",
         file->hdr.analysis.img_labels[lcv],text->format.num_slices);

 fprintf(fid,"\n");
 if (define = is_all_pixel_type_map_ready(file))
    {if (define == 1)
        fprintf(fid,"WARNING : Pixel types are only defined for some slices  !!!\n");

     if (file->pixel_type.order.num_strs > 0)
        {fprintf(fid,"DEFINED PIXEL TYPES LISTED ACCORDING TO THEIR PRIORITY\n");
         for (lcv = 0; lcv < file->pixel_type.order.num_strs; lcv++)
            fprintf(fid,"   %-d. %s\n",lcv,file->pixel_type.order.strs[lcv]);
        }

     if (!(file->pixel_type.status & HISTO_AND_PIXEL_TYPE_RELATED))
        fprintf(fid,"WARNING : Pixel types are not defined based on the current histogram.\n");
     if (!(file->pixel_type.status & PIXEL_TYPE_AND_ANALYSIS_RELATED))
        fprintf(fid,"WARNING : Pixel types are not defined based on the current pixel types.\n");
    }
   else fprintf(fid,"WARNING : Pixel types are not defined for all slices !!!\n");
 fprintf(fid,"\n");

 return NO_ERROR;
}
****************/



/*-------------------------------------------------------------------------
WrPixelTypeTextFileInfo - ???
-------------------------------------------------------------------------*/

int
WrPixelTypeTextFileInfo(fid,text_printing_time,format,
           hdr,ndathdr,pixel_type,prog_name,prog_id,
           hdrdirfn,hdrfn,hdrsuffix,imgsuffix,ndatdir,ndatfn,ndatsuffix)
 FILE *fid;
 char **text_printing_time;
 struct output_text_format_rec *format;
 struct hdr_rec *hdr;
 struct output_hdr_rec *ndathdr;
 struct pixel_type_rec *pixel_type;
 char *prog_name,*prog_id,*hdrdirfn,*hdrfn,*hdrsuffix,*imgsuffix,
      *ndatdir,*ndatfn,*ndatsuffix;
{
 char *str,*fn;
 int err,define;
 unsigned int lcv;

 if (get_strlen(ndathdr->rater) == 0)
    fprintf(fid,"RATER = UNKNOWN\n");
   else fprintf(fid,"RATER = %s\n",ndathdr->rater);
 if (text_printing_time != NULL)
    {if (*text_printing_time == NULL)
        *text_printing_time = current_asctime();
     fprintf(fid,"PRINTING DATE : %s",*text_printing_time);
    }
 fprintf(fid,"PROGRAM : %s",prog_name);
 fprintf(fid,"       VERSION : %s\n",prog_id);

 if (pixel_type->slice_map_data_creation_date != NULL)
    fprintf(fid,"PIXEL TYPE CREATION DATE : %s",
              pixel_type->slice_map_data_creation_date);

 if ((err = build_fn(&str,hdrdirfn,hdrfn,hdrsuffix)) != NO_ERROR)
    return CANCEL;
 if ((err = concat_strs(&fn,3,str,"-",imgsuffix)) != NO_ERROR)
    {c_free(str);
     return CANCEL;}

 fprintf(fid,"INPUT FILES : 1) %s   VERSION : %s\n",fn,hdr->id);
 c_free(str);
 c_free(fn);

 if ((err = build_fn(&fn,ndatdir,ndatfn,ndatsuffix)) != NO_ERROR)
    return CANCEL;
 fprintf(fid,"              2) %s   VERSION : %s\n",fn,ndathdr->id);
 c_free(fn);

 if ((err = build_fn(&fn,ndatdir,ndatfn,TXT_SUFFIX)) != NO_ERROR)
    return CANCEL;
 fprintf(fid,"OUTPUT FILE : 1) %s\n",fn);
 c_free(fn);

 fprintf(fid,"\n");
 fprintf(fid,"IMAGE INFO.\n");
 fprintf(fid,"   Image dimension size = %d * %d   Pixel size = %-d bits\n",
         (int) hdr->data_info.dimx,
         (int) hdr->data_info.dimy,
         (int) hdr->data_info.pixel_depth_bits);

 fprintf(fid,"   PIXEL SIZE (X,Y) = %-.4fmm,%-.4fmm   THICKNESS = %-.4fmm\n",
     format->xpixel_size,format->ypixel_size,
           format->pixel_thickness);
 fprintf(fid,"   VOXEL = %-.4f (Cubic mm)\n",format->voxel_size);
 fprintf(fid,"   # of Slice Cuts = %ld  Scans/slice = %ld Total scans = %d\n",
           NumberOfSliceCuts(&(hdr->data_info)),
           NumberOfSliceScans(&(hdr->data_info)),
          (int) hdr->data_info.max_scans);
 for (lcv = 0; lcv < hdr->analysis.num_img_labels; lcv++)
    fprintf(fid,"      Image slices of type %s = %ld\n",
         hdr->analysis.img_labels[lcv],format->num_slices);

 fprintf(fid,"\n");
 if (define = IsAllPixelTypeMapReady(pixel_type,hdr))
    {if (define == 1)
        fprintf(fid,"WARNING : Pixel types are only defined for some slices  !!!\n");

     if (pixel_type->order.num_strs > 0)
        {fprintf(fid,"DEFINED PIXEL TYPES LISTED ACCORDING TO THEIR PRIORITY\n");
         for (lcv = 0; lcv < pixel_type->order.num_strs; lcv++)
            fprintf(fid,"   %-d. %s\n",lcv,pixel_type->order.strs[lcv]);
        }

     if (!(pixel_type->status & HISTO_AND_PIXEL_TYPE_RELATED))
        fprintf(fid,"WARNING : Pixel types are not defined based on the current histogram.\n");
     if (!(pixel_type->status & PIXEL_TYPE_AND_ANALYSIS_RELATED))
        fprintf(fid,"WARNING : Pixel types are not defined based on the current pixel types.\n");
    }
   else fprintf(fid,"WARNING : Pixel types are not defined for all slices !!!\n");
 fprintf(fid,"\n");

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WrPixelTypeTextLabels - ???
-------------------------------------------------------------------------*/

int
WrPixelTypeTextLabels(fid,format)
 FILE *fid;
 struct output_text_format_rec *format;
{
 char str[25],roi_format[25],pixel_type_format[25],format_str[256];
 unsigned int roi_len,pixel_type_len,temp,lcv,cnt,indx;
 static char *roi_label = "ROI NAMES";
 static char *pixel_type_label = "PIXEL TYPE NAMES";
 char is_pr_line;

 sprintf(str,"   [%-ld] ",format->roi_labels.num_strs - 1);
 roi_len = strlen(str) +
              get_strs_rec_max_some_str_len(&(format->roi_labels),format->roi_nums);
 if (roi_len < 9) roi_len = 9;

 sprintf(str,"   %-ld) ",format->pixel_type_labels.num_strs - 1);
 pixel_type_len = strlen(str) +
        get_strs_rec_max_some_str_len(&(format->pixel_type_labels),
        format->pixel_type_nums);
 if (pixel_type_len < 16) pixel_type_len = 16;

 temp = roi_len + pixel_type_len + 1;
 if (temp > format->page_row_size)
    {fprintf(fid,"%s\n",roi_label);
     for (lcv = 0; lcv < format->roi_labels.num_strs; lcv++)
        if (format->roi_nums[lcv] > 0)
           fprintf(fid,"   [%-ld] %s\n",format->roi_nums[lcv],
                format->roi_labels.strs[lcv]);

     fprintf(fid,"\n%s\n",pixel_type_label);
     for (lcv = 0; lcv < format->pixel_type_labels.num_strs; lcv++)
        if (format->pixel_type_nums[lcv] > 0)
           fprintf(fid,"   %-ld) %s\n",format->pixel_type_nums[lcv],
              format->pixel_type_labels.strs[lcv]);
    }
   else
    {
     sprintf(roi_format,"%%-%ds",roi_len);
     sprintf(pixel_type_format,"%%-%ds",pixel_type_len);
     temp = format->page_row_size - pixel_type_len - roi_len - 2;
     sprintf(str,"%%-%ds",temp);
     if (format->pixel_type_labels.num_strs > 
         format->roi_labels.num_strs)
        temp = format->pixel_type_labels.num_strs;
       else temp = format->roi_labels.num_strs;

     fprintf(fid,roi_format,roi_label);
     fprintf(fid,str," ");
     fprintf(fid,pixel_type_format,pixel_type_label);
     fprintf(fid,"\n");

     for (cnt = indx = lcv = 0; lcv < temp; lcv++,cnt++,indx++)
        {is_pr_line = 0;
         for (; cnt < format->roi_labels.num_strs; cnt++)
            if (format->roi_nums[cnt] > 0)
               {is_pr_line = 1;
                sprintf(format_str,"   [%-ld] %s",format->roi_nums[cnt],
                             format->roi_labels.strs[cnt]);
                fprintf(fid,roi_format,format_str);
                break;}
         for (; indx < format->pixel_type_labels.num_strs; indx++)
            if (format->pixel_type_nums[indx] > 0)
               {is_pr_line = 1;
                if (cnt >= format->roi_labels.num_strs)
                   fprintf(fid,roi_format," ");
                sprintf(format_str,"   %-ld) %s",format->pixel_type_nums[indx],
                      format->pixel_type_labels.strs[indx]);
                fprintf(fid,str," ");
                fprintf(fid,pixel_type_format,format_str);
                break;}
         if (is_pr_line) fprintf(fid,"\n");
        }
    }

 fprintf(fid,"\nNOTE : '?' = PIXEL TYPE UNDEFINED       '*' = ROI NOT DEFINED\n");
 fprintf(fid,  "       '-' = ROI PIXEL COUNT NOT COMPUTED\n");
 fprintf(fid,"\n");

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
PrintPixelTypeTextToFile - ???
-------------------------------------------------------------------------*/

int
PrintPixelTypeTextToFile(fn,file,text_printing_time,format,analysis,status)
 char *fn;
 struct input_file_rec *file;
 char **text_printing_time;
 struct output_text_format_rec *format;
 struct all_collection_rec *analysis;
 unsigned short *status;
{
 FILE *fid;
 struct page_rec *page;
 unsigned int lcv,cnt,indx,temp,num_line,total_lines,total_line_chs;
 char first_line_format[30],first_line_str_format[30],
      field_format[30],collect_format[30];
 int err;

 if ((analysis->num_pages == 0) ||
     (format->roi_labels.num_strs == 0) ||
     (format->pixel_type_labels.num_strs == 0))
    return CANCEL;
 TRACE(printf("PrintPixelTypeTextToFile...fn = %s num_pages = %d\n",
          fn,analysis->num_pages))
 if ((fid = fopen(fn,"w")) == NULL) return FILE_ACCESS_ERROR;
 if ((err = WrPixelTypeTextFileInfo(fid,text_printing_time,format,
           &(file->hdr),&(file->output.hdr),&(file->pixel_type),
           file->prog->prog_name,file->prog->prog_id,
           file->dirfn,file->fn,file->hdr_fn_suffix,file->img_fn_suffix,
           file->output.dirfn,file->output.fn,file->output.dat_fn_suffix))
       != NO_ERROR) 
    return err;
 TRACE(printf("PrintPixelTypeTextToFile...1...\n"))

 sprintf(first_line_format,"%%%ldd",analysis->num_line_label_spaces);
 sprintf(first_line_str_format,"%%%lds",analysis->num_line_label_spaces);
 sprintf(collect_format,"%%%lds",format->num_collect_spaces);
 TRACE(printf("PrintPixelTypeTextToFile...2...\n"))
 for (lcv = 0; lcv < analysis->num_pages; lcv++)
    {page = &(analysis->pages[lcv]);
     if ((err = WrPixelTypeTextLabels(fid,format)) != NO_ERROR)
        return err;
     TRACE(printf("PrintPixelTypeTextToFile...3...\n"))

     for (cnt = 0; cnt < page->num_collects; cnt++)
        page->collects[cnt]->cur_indx = 0;
     TRACE(printf("PrintPixelTypeTextToFile...4...\n"))
     total_lines = analysis->total_slices + 3;
     for (num_line = 0; num_line < total_lines; num_line++)
        {
         if (num_line == 0) fprintf(fid,first_line_str_format,"#");
           else if (num_line == (analysis->total_slices + 1))
            fprintf(fid,first_line_str_format,"PIXELS");
           else if (num_line == (analysis->total_slices + 2))
            fprintf(fid,first_line_str_format,"VOL(cc)");
           else fprintf(fid,first_line_format,num_line);
         if (num_line == 0)
            total_line_chs = analysis->num_line_label_spaces +
                           page->num_collects * format->num_collect_spaces;

         for (cnt = 0; cnt < page->num_collects; cnt++)
            {fprintf(fid,collect_format," ");
             temp = format->num_field_spaces +
                         page->collects[cnt]->max_digit_chs;
             sprintf(field_format,"%%%ds",temp);
             if (num_line == 0)
                total_line_chs += temp * page->collects[cnt]->num_fields;

             for (indx = 0; indx < page->collects[cnt]->num_fields; indx++)
                {
                 temp = page->collects[cnt]->cur_indx + 1;
                 fprintf(fid,field_format,&(page->collects[cnt]->buf[temp]));

                 page->collects[cnt]->cur_indx += page->collects[cnt]->buf[
                             page->collects[cnt]->cur_indx] + 2;
                }
            }

         fprintf(fid,"\n");
         if ((num_line == analysis->total_slices) || (num_line == 0))
            {
             for (indx = 0; indx < total_line_chs; indx++)
                fprintf(fid,"-");
             fprintf(fid,"\n");}
        }
     fprintf(fid,"%c",(char) 12);
     if ((lcv + 1) != analysis->num_pages) fprintf(fid,"\n");
    }
 fclose(fid);
 *status |= TEXT_OUTPUT_TO_FILE;
 TRACE(printf("PrintPixelTypeTextToFile...10...\n"))
 return NO_ERROR;
}






/*-------------------------------------------------------------------------
print_pixel_type_text_to_temp_file - ???
-------------------------------------------------------------------------*/

int
print_pixel_type_text_to_temp_file(text)
 struct text_output_rec *text;
{
 int err;

#if 0
#undef PRT4
#define PRT4(x) x; fflush(stdout);
#endif

 PRT4(printf("print_pixel_type_text_to_temp_file...1\n"));

 err = NO_ERROR;
 if (text->status & TEXT_OUTPUT_TO_TEMP_FILE)
    {delete_file(text->analysis.text_temp_fn);
     text->status &= ~TEXT_OUTPUT_TO_TEMP_FILE;}
 if (!(text->status & TEXT_OUTPUT_COMPUTED))
    {err = setup_all_collection_rec(text);
     if (err) return err;
    }

 if (text->status & TEXT_OUTPUT_COMPUTED)
    {

     PRT4(printf("text_temp_fn = %s\n",text->analysis.text_temp_fn));

     if (text->num_groups == 0) return CANCEL;
     if ((err = PrintPixelTypeTextToFile(text->analysis.text_temp_fn,
               text->file,&(text->text_printing_time),
               &(text->format),&(text->analysis),&(text->status))) == NO_ERROR)
        text->status |= TEXT_OUTPUT_TO_TEMP_FILE;
    }
   else return CANCEL;

 PRT4(printf("print_pixel_type_text_to_temp_file...err = %d\n",err));

 return err;
}


/*-------------------------------------------------------------------------
save_pixel_type_text_to_file - ???
-------------------------------------------------------------------------*/

int
save_pixel_type_text_to_file(fn,text)
 char *fn;
 struct text_output_rec *text;
{
 int err;

 TRACE(printf("save_pixel_type_text_to_file = %s\n",fn))
 if (!(text->status & TEXT_OUTPUT_COMPUTED))
    {err = setup_all_collection_rec(text);
     if (err) return err;
    }
 if (text->status & TEXT_OUTPUT_COMPUTED)
    {if (text->num_groups == 0) return CANCEL;
     err = PrintPixelTypeTextToFile(fn,
               text->file,&(text->text_printing_time),
               &(text->format),&(text->analysis),&(text->status));
    }
   else return CANCEL;
 return err;
}


