/****************************************************************************
trans_roi_rec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: trans_roi_rec.c,v 1.12 1999/07/07 17:41:20 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <X11/Xlib.h>
#include <X11/Xutil.h>         /* For XDestroyImage */

#include "mri_format.h"
#include <sys/timeb.h>        /* FIXME:  Is this truly necessary? */
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT30(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)
#define PRT6(x)
#define PRT7(x)
#define PRT30(x)
#define PRT8(x)
#define PRT9(x)
#define PRT10(x)



/* Functions defined in this file */
void init_trans_roi_rec(struct trans_roi_rec *trans);
void setup_trans_roi_rec(struct image_display_window *win);
void start_trans_roi_rec_proc(struct image_display_window *win, int x, int y);
void pr_trans_roi_rec(struct trans_roi_rec *trans);
int last_loc_drag_event(Xv_Window xvwin, Event *last_event, int sel);
void transform_slice_roi(struct image_display_window *win,
    struct slice_roi_rec *slice_roi);
int win_update_trans_roi_rec(struct image_display_window *win);
int transform_roi_proc(struct image_display_window *win, int use_degree,
    double xdegree, double ydegree);
int win_setup_move_superimpose_image(struct image_display_window *win);
int win_show_or_fusion(struct image_display_window *win, long offx, long offy);
int move_superimpose_proc(struct image_display_window *win, int use_degree,
    double xdegree, double ydegree);
int check_trans_roi_proc(struct image_display_window *win, int which);
int trans_roi(struct image_display_window *win, Event *event);
int win_transform_by_keypad(struct image_display_window *win, Event *event,
    int off);



/*--------------------------------------------------------------------------
init_trans_roi_rec - ???
--------------------------------------------------------------------------*/

void
init_trans_roi_rec(trans)
 struct trans_roi_rec *trans;
{
 trans->status = 0;
}


/*--------------------------------------------------------------------------
setup_trans_roi_rec - ???

FIXME!  This function returns no value but is apparently used in contexts
which expect an int.  -PWH 19990603
--------------------------------------------------------------------------*/

void
setup_trans_roi_rec(win)
 struct image_display_window *win;
{
 init_trans_roi_rec(&(win->control.trans));
 update_dp_trans_roi(win);
}


/*--------------------------------------------------------------------------
start_trans_roi_rec_proc - ???
--------------------------------------------------------------------------*/

void
start_trans_roi_rec_proc(win,x,y)
 struct image_display_window *win;
 int x,y;
{
 TRACE(printf("start_trans_roi_rec_proc...x = %d  y = %d\n",x,y);)
 win->control.trans.initx = win->control.trans.last_curx = 
       win->control.trans.curx = x;
 win->control.trans.inity = win->control.trans.last_cury = 
       win->control.trans.cury = y;

 win->control.trans.status = 0;
 win->control.trans.status |= TRANS_PARAMS_INITIALIZED;
 if (win->control.which_cursor == CURSOR_MOVE_ROI)
    win->control.trans.status |= TRANS_MOVE;
   else if (win->control.which_cursor == CURSOR_RESIZE_ROI)
    win->control.trans.status |= TRANS_RESIZE;
   else win->control.trans.status |= TRANS_ROTATE;
 identity_2d_matrix(&(win->control.trans.matrix));
 identity_2d_matrix(&(win->control.trans.mult_matrix));
}


/*--------------------------------------------------------------------------
pr_trans_roi_rec - ???
--------------------------------------------------------------------------*/

void
pr_trans_roi_rec(trans)
 struct trans_roi_rec *trans;
{
 printf("pr_trans_roi_rec...status = %lx\n",(unsigned long) trans->status);
 printf("initx = %d  inity = %d last_curx = %d last_cury = %d curx  = %d cury = %d\n",
            trans->initx,trans->inity,
             trans->last_curx,trans->last_cury,trans->curx,trans->cury);
 printf("pr_trans_roi_rec...end\n");

}


/*--------------------------------------------------------------------------
last_loc_drag_event - ???
--------------------------------------------------------------------------*/

int
last_loc_drag_event(xvwin,last_event,sel)
 Xv_Window xvwin;
 Event *last_event;
 int sel;
{
 Xv_Window win1;
 Event event1;
 int time,yes,cnt,lcv,action;

 cnt = time = 0;
 yes = 0;
 lcv = 0;
 while (1)
    if ((win1 = xv_input_readevent(xvwin,&event1,FALSE,FALSE,NULL)) != 0)
       {action = event_action(&event1);
        lcv = 0;
        cnt += 1;
        if (action != LOC_DRAG)
           {time += 1;
            if (time == 5) break;
           }
          else
           {time = 0;
            yes = 1;
            *last_event = event1;}
       }
      else
       {lcv += 1;
        if (lcv == 3) break;}
 if (yes) return NO_ERROR;
 return CANCEL;
}


/*--------------------------------------------------------------------------
transform_slice_roi - ???
--------------------------------------------------------------------------*/

void
transform_slice_roi(win,slice_roi)
 struct image_display_window *win;
 struct slice_roi_rec *slice_roi;
{
 struct curve_rec *cur_curve;
 struct roi_rec *roi,*roi1;

 if (win->control.status & ACTION_ON_CUR_ROI)
    {if (((roi1 = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi))) != NULL) &&
         ((roi = get_roi(slice_roi,roi1->label)) != NULL))
        {
         apply_to_roi_rec(roi,set_curve_matrix,&(win->control.trans.matrix),1,
                    &(slice_roi->status),0,0,0,0,0,0);
        }
    }
   else if (win->control.status & ACTION_ON_ALL_ROIS)
    {
     apply_to_slice_roi_rec(slice_roi,
             set_curve_matrix,&(win->control.trans.matrix),1,
                    &(slice_roi->status),0,0,0,0,0,0);
    }
   else
    {
     if (((cur_curve = get_cur_curve(slice_roi))
          != NULL) && is_curve_non_empty(cur_curve))
        set_curve_matrix(cur_curve,&(win->control.trans.matrix),0,
            &(slice_roi->status));
    }
}


/*--------------------------------------------------------------------------
win_update_trans_roi_rec - ???
--------------------------------------------------------------------------*/

int
win_update_trans_roi_rec(win)
 struct image_display_window *win;
{
 unsigned long lcv;
 struct img_buf_rec *img;
 struct slice_roi_win_rec *slice_roi_win;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (win->control.trans.status & TRANS_PERFORMED)
    {win->control.trans.status &= ~TRANS_PERFORMED;
     if (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE)
        {
         if (!(img->_2d_fusion.status & FUSION_METHOD))
            {win_select_cursor(win,win->control.last_which_cursor);
             return CANCEL;}
         if (img->_2d_fusion.status & FUSION_MOVE_SELF)
            {win_fusion_move_img(win);
             PRT7(printf("win_update_trans_roi_rec...FUSION_MOVE_SELF\n\n"))}
           else win_move_show_hide_fusion(win,1);
        }
       else
        {win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);
         if (win->control.status & ACTION_ON_ALL_SLICES)
            {
             for (lcv = 0; lcv < img->file->slice_info.num_sroi_wins;lcv++)
                {slice_roi_win = img->file->slice_info.sroi_wins[lcv];
                 if (slice_roi_win != win->control.sroi.sroi_win)
                    transform_slice_roi(win,&(slice_roi_win->slice_roi));
                }
             win_run_proc_to_all_file_wins(win,win_redisplay_all_curves,5,
					   0,0,0);
            }
        }
    }
 win->control.trans.status &= ~TRANS_DRAG;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
transform_roi_proc - ???
--------------------------------------------------------------------------*/

int
transform_roi_proc(win,use_degree,xdegree,ydegree)
 struct image_display_window *win;
 int use_degree;
 float xdegree,ydegree;
{
 struct curve_rec *cur_curve;
 Event event1;
 long minx,maxx,miny,maxy;
 float sx,sy,rad,centerx,centery;
 long yes,width,height;
 struct roi_rec *roi;
 struct curve_2d_rec *pen;
 static char first_time = 0;
 struct color_data_rec *color_data;
 int err;

 if ((color_data = WinCurColorData(win)) == NULL) return CANCEL;
 yes = 1;
 if (win->control.status & ACTION_ON_CUR_ROI)
    {if ((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi))) == NULL)
        return NO_ERROR;
    }
   else if (win->control.status & ACTION_ON_ALL_ROIS)
    {if (!is_slice_roi_non_empty(&(win->control.sroi.sroi_win->slice_roi)))
           return NO_ERROR;}
   else if (((cur_curve = get_cur_curve(&(win->control.sroi.sroi_win->slice_roi)))
          == NULL) || !is_curve_non_empty(cur_curve))
    return NO_ERROR;
   else yes = 0;

 if (!use_degree)
    if (last_loc_drag_event(
              canvas_paint_window(win->dwin->frame_canvas.canvas),&event1,2)
              == NO_ERROR)
    {if ((err = dwin_get_coord_xy_from_event(win->dwin,&event1,
             &(win->control.trans.curx),&(win->control.trans.cury))) != NO_ERROR)
        return err;
    }
 if (win->control.which_cursor != CURSOR_MOVE_ROI)
    {
     if (yes)
        if (((cur_curve = get_cur_curve(&(win->control.sroi.sroi_win->slice_roi)))
              != NULL) && is_curve_non_empty(cur_curve))
           yes = 0;
     if (yes)
        {centerx = (float) color_data->_2d.dimx / 2.0;
         centery = (float) color_data->_2d.dimy / 2.0;
         width = color_data->_2d.dimx;
         height = color_data->_2d.dimy;
        }
       else
        {if ((pen = get_cur_pen(&(win->control.sroi.sroi_win->slice_roi))) ==
              NULL)
            return NO_ERROR;
         FindCurveLongMinMax(cur_curve,win->control.sroi.localto,
                 &minx,&maxx,&miny,&maxy,pen->pen_type,0,0,0);
         centerx = (minx + maxx) / 2.0;
         centery = (miny + maxy) / 2.0;
         width = maxx - minx + 1;
         height = maxy - miny + 1;
        }
    }

 yes = 0;
 if (win->control.which_cursor == CURSOR_MOVE_ROI)
    {if (use_degree)
        {if ((xdegree == 0.0) && (ydegree == 0.0))
            inverse_2d_matrix(&(win->control.trans.matrix),
                      &(win->control.trans.mult_matrix));
           else setup_translate_2d_matrix(&(win->control.trans.matrix),
                   xdegree,ydegree);
        }
       else
        {if ((win->control.trans.last_curx == win->control.trans.curx) &&
             (win->control.trans.last_cury == win->control.trans.cury))
            return NO_ERROR;
         setup_translate_2d_matrix(&(win->control.trans.matrix),
               (float) (win->control.trans.curx - win->control.trans.last_curx),
               (float) (win->control.trans.cury - win->control.trans.last_cury));
        }
     yes = 1;
    }
  else if (win->control.which_cursor == CURSOR_RESIZE_ROI)
    {if (use_degree)
        {if ((xdegree == .0) && (ydegree == .0))
            inverse_2d_matrix(&(win->control.trans.matrix),
                      &(win->control.trans.mult_matrix));
           else 
            {if ((xdegree == 1.0) && (ydegree == 1.0)) return NO_ERROR;
             setup_scale_2d_matrix_from_xy(&(win->control.trans.matrix),
                xdegree,ydegree,centerx,centery);}
         yes = 1;
        }
       else
        {scale_xy_ratio(centerx,centery,
          (float) win->control.trans.last_curx,(float) win->control.trans.last_cury,
          (float) win->control.trans.curx,(float) win->control.trans.cury,
          (float) width,(float) height,&sx,&sy);

         PRT6(printf("scale sx = %f sy = %f fx = %d  fy = %d  nx = %d  ny = %d\n",sx,sy,win->control.trans.last_curx,win->control.trans.last_cury,
 win->control.trans.curx,win->control.trans.cury);)
         PRT6(printf("centerx = %f centery = %f w = %d h = %d\n",
                centerx,centery,width,height);)

         if ((sx != 1.0) || (sy != 1.0))
            {setup_scale_2d_matrix_from_xy(&(win->control.trans.matrix),sx,sy,
                         centerx,centery);
             yes = 1;}
        }
    }
   else if (win->control.which_cursor == CURSOR_ROTATE_ROI)
    {if (use_degree)
        {if ((xdegree == .0) && (ydegree == .0))
            inverse_2d_matrix(&(win->control.trans.matrix),
                      &(win->control.trans.mult_matrix));
           else 
            {rad = (float) radian(xdegree);
             setup_rotate_2d_matrix_from_xy(&(win->control.trans.matrix),rad,
                centerx,centery);}
         yes = 1;
        }
       else
        {if ((win->control.trans.last_curx == win->control.trans.curx) &&
             (win->control.trans.last_cury == win->control.trans.cury))
            return NO_ERROR;
 
         rotate_2d_rad(centerx,centery,
           (float) win->control.trans.last_curx,(float) win->control.trans.last_cury,
           (float) win->control.trans.curx,(float) win->control.trans.cury,&rad);

         TRACE(printf("rotate cx = %f cy = %f fx = %d  fy = %d  nx = %d  ny = %d   rad = %f\n",
            centerx,centery,win->control.trans.last_curx,win->control.trans.last_cury,
            win->control.trans.curx,win->control.trans.cury,rad))
         if (rad != .0)
            {setup_rotate_2d_matrix_from_xy(&(win->control.trans.matrix),rad,
                   centerx,centery);
             yes = 1;}
        }
    }

 if (yes)
    {
     if (win->control.status & ACTION_ON_CUR_ROI)
        {
         win_draw_cur_roi_to_screen(win,1,0,1);
         apply_to_roi_rec(roi,set_curve_matrix,&(win->control.trans.matrix),1,
			  &(win->control.sroi.sroi_win->slice_roi.status),
			  0,0,0,0,0,0);
         win_draw_cur_roi_to_screen(win,0,0,1);
        }
       else if (win->control.status & ACTION_ON_ALL_ROIS)
        {
         win_draw_all_rois_to_screen(win,1,0,1);
         apply_to_slice_roi_rec(&(win->control.sroi.sroi_win->slice_roi),
             set_curve_matrix,&(win->control.trans.matrix),1,
             &(win->control.sroi.sroi_win->slice_roi.status),0,0,0,0,0,0);
         win_draw_all_rois_to_screen(win,0,0,1);
        }
       else
        {win_draw_cur_curve_to_screen(win,1,0,1);
         set_curve_matrix(cur_curve,&(win->control.trans.matrix),1,
             &(win->control.sroi.sroi_win->slice_roi.status));
         win_draw_cur_curve_to_screen(win,0,0,1);
        }
     mult_2d_matrix(&(win->control.trans.mult_matrix),&(win->control.trans.matrix),
                 &(win->control.trans.mult_matrix));
    }
 if (!use_degree)
    {win->control.trans.last_curx = win->control.trans.curx;
     win->control.trans.last_cury = win->control.trans.cury;}
 if (yes)
    {win->control.trans.status |= TRANS_PERFORMED;
     if (!first_time &&
         (last_loc_drag_event(
              canvas_paint_window(win->dwin->frame_canvas.canvas),&event1,2)
              == NO_ERROR))
        {if ((err = dwin_get_coord_xy_from_event(win->dwin,&event1,
            &(win->control.trans.curx),&(win->control.trans.cury))) != NO_ERROR)
            return err;
         first_time += 1;
         transform_roi_proc(win,0,.0,.0);
        }
       else
        {first_time = 0;
         return win_execute_proc_to_multiple_wins(win,win_show_screen_bound,
						  0,0,0,0,0);}
    }
   else first_time = 0;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_setup_move_superimpose_image - ???
--------------------------------------------------------------------------*/

int
win_setup_move_superimpose_image(win)
 struct image_display_window *win;
{
 unsigned int mag_total_size;
 unsigned int mag_dimx,mag_dimy;
 struct img_buf_rec *img;
 long pixel_depth;
 int how,err;
 struct win_rec *rwin;
 struct image_display_window *win1;
 struct buf_2d_rec *_2d;
 struct color_data_rec *color_data1;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 PRT8(printf("\nwin_setup_move_superimpose_image...status = %x\n",
         (unsigned long) img->_2d_fusion.status);)
 if ((img->_2d_fusion.pixel.def_magx != win->dwin->screen.pixel.mask.dimx) ||
     (img->_2d_fusion.pixel.def_magy != win->dwin->screen.pixel.mask.dimy) ||
     (img->_2d_fusion.status & FUSION_MOVE_UPDATE) ||
     !(img->_2d_fusion.screen_2d.status4 & BUF_NON_EMPTY))
    {if (((rwin = get_win_rec_by_wid_str(img->win,img->src_wid)) == NULL) ||
         ((win1 = rwin->image_display) == NULL))
        how = 0;
       else how = 1;
    }
   else
    {PRT8(printf("win_setup_move_superimpose_image..no setup .done\n");)
     return NO_ERROR;}

 PRT8(printf("win_setup_move_superimpose_image check screen buf...how = %d\n",how);)
 if (how == 0)
    {if ((color_data1 = WinCurColorData(win1)) == NULL) return CANCEL;
     _2d = &(color_data1->_2d);
     PRT8(printf("***color_data1 startoffx = %d startoffy = %d\n",
          _2d->startoffx,_2d->startoffy))
    }
   else 
    {_2d = &(img->_2d_fusion.srcindst_2d);
     PRT8(printf("***srcindst_2d startoffx = %d startoffy = %d dimx = %d dimy = %d\n",
          _2d->startoffx,_2d->startoffy,img->_2d_fusion.srcindst_2d.dimx,
          img->_2d_fusion.srcindst_2d.dimy))
    }
 get_mag_image_size1(&mag_total_size,&mag_dimx,&mag_dimy,
                    _2d->dimx,_2d->dimy,_2d->pixel_depth,
                    &(win->dwin->screen.pixel));
 pixel_depth = _2d->pixel_depth;
 PRT8(printf("win_setup mag_dimx = %d...mag_dimy = %d  mag_total_size = %d\n",
                  mag_dimx,mag_dimy,mag_total_size))
 PRT8(printf("screen_2d dimx = %d dimy = %d   _2d_fusion dimx = %d dimy = %d\n",
            img->_2d_fusion.screen_2d.dimx,img->_2d_fusion.screen_2d.dimy,
            _2d->dimx,_2d->dimy))
 if (!(img->_2d_fusion.screen_2d.status4 & BUF_NON_EMPTY) ||
      (img->_2d_fusion.screen_2d.dimx != mag_dimx) ||
      (img->_2d_fusion.screen_2d.dimy != mag_dimy) ||
      (img->_2d_fusion.screen_2d.pixel_depth != pixel_depth))
    {if (img->_2d_fusion.im != NULL)
	{img->_2d_fusion.im->data = NULL;
	 XDestroyImage(img->_2d_fusion.im);
	 img->_2d_fusion.im = NULL;}
     PRT8(printf("...rebuild buf...\n");)
     if ((err = SetupBuf2dRec(&(img->_2d_fusion.screen_2d),
	     mag_dimx,mag_dimy,pixel_depth,0)) != NO_ERROR)
	return err;
     PRT1(pr_buf_2d_rec(&(img->_2d_fusion.screen_2d)))
     img->_2d_fusion.pixel.def_magx = win->dwin->screen.pixel.mask.dimx;
     img->_2d_fusion.pixel.def_magy = win->dwin->screen.pixel.mask.dimy;
    }
 img->_2d_fusion.status &= ~FUSION_MOVE_UPDATE;
 PRT9(printf("win_setup_move_superimpose_image...srcindst_2d & screen_2d\n");
      pr_buf_2d_rec(_2d);
      pr_buf_2d_rec(&(img->_2d_fusion.screen_2d));)
 WinBufScreenData(win,_2d,0,0,_2d->dimx - 1,_2d->dimy - 1,&(img->_2d_fusion.screen_2d));

 if (img->_2d_fusion.im == NULL)
    {create_image(&(img->_2d_fusion.im),win->dwin->dp.dp,
           win->dwin->dp.screen_num,&(img->_2d_fusion.screen_2d),
           img->_2d_fusion.screen_2d.pixel_depth);
     PRT1(printf("create_image screen_2d dimx = %d dimy = %d\n",
           img->_2d_fusion.screen_2d.dimx,img->_2d_fusion.screen_2d.dimy))
     if (img->_2d_fusion.im == NULL) return CANCEL;
    }
 PRT9(printf("win_setup_move_superimpose_image...NO_ERROR\n\n");)
 if (how) img->_2d_fusion.status |= FUSION_MOVE_WHOLE;
   else img->_2d_fusion.status &= ~FUSION_MOVE_WHOLE;

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_show_or_fusion - ???
--------------------------------------------------------------------------*/

int
win_show_or_fusion(win,offx,offy)
 struct image_display_window *win;
 long offx,offy;
{
 struct img_buf_rec *img;
 int err;
 long x,y,x1,y1,dimx,dimy,dx,dy;
 struct buf_2d_rec *_2d;
 long vs1left,vs1top,vs1right,vs1bottom;
 struct int_bound_rec *src_bound;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (!(img->_2d_fusion.status & FUSION_METHOD)) return CANCEL;
 PRT8(printf("win_show_or_fusion...\n");)
 if ((err = win_setup_move_superimpose_image(win)) != NO_ERROR) return err;

 if (!(img->_2d_fusion.status & FUSION_MOVE_CLEARED))
    {PRT8(printf("win_show_or_fusion FUSION_MOVE_CLEARED\n"))
     img->status4 &= ~IMAGE_2D_SUPERIMPOSED_READY;
     WinEnableDisableColorData(win,SUPERIMPOSE_ID,1);
     WinScreen(win);
     img->status4 |= IMAGE_2D_SUPERIMPOSED_READY;
     img->_2d_fusion.status |= (FUSION_MOVE_CLEARED | FUSION_LAST_LEFT_TOP_VALID);
     img->_2d_fusion.last_dst_left = img->_2d_fusion.dst_bound.left;
     img->_2d_fusion.last_dst_top = img->_2d_fusion.dst_bound.top;
     PRT2(printf("FUSION_MOVE_CLEARED...status = %x\n",img->_2d_fusion.status))
     PRT2(printf("FUSION_MOVE_CLEARED last left = %d top = %d\n",
      img->_2d_fusion.last_dst_left,img->_2d_fusion.last_dst_top))
     PRT2(printf("dst_bound  left = %d top = %d\n",
      img->_2d_fusion.dst_bound.left,img->_2d_fusion.dst_bound.top))
    }

 user_write(win->dwin->frame_canvas.canvas,0,0,
          win->dwin->screen._2d.dimx,win->dwin->screen._2d.dimy,GXcopy,
          win->dwin->screen.im,0,0);
 move_int_bound_rec(&(img->_2d_fusion.dst_bound),offx,offy);
 src_bound = &(img->_2d_fusion.src_bound);
 PRT8(if (img->_2d_fusion.status & FUSION_MOVE_UPDATE)
        printf("\n*** &&& FUSION_MOVE_UPDATE\n\n"))

 _2d = &(img->_2d_fusion.srcindst_2d);
 PRT8(printf("=== dst_bound...status = %x dimx = %d dimy = %d sdimx = %d sdimy = %d\n",
            img->_2d_fusion.status,_2d->dimx,_2d->dimy,
       img->_2d_fusion.screen_2d.dimx,img->_2d_fusion.screen_2d.dimy);
          pr_int_bound_rec(&(img->_2d_fusion.dst_bound));)
 PRT8(printf("*** src_bound...src_screen_bound statx = %d starty = %d\n",
            img->_2d_fusion._2d.startx,img->_2d_fusion._2d.starty);
          pr_int_bound_rec(&(img->_2d_fusion.src_bound));
          pr_int_bound_rec(&(img->_2d_fusion.src_screen_bound));)

 dx = img->_2d_fusion.dst_bound.left;
 dy = img->_2d_fusion.dst_bound.top;
 PRT10(printf("**dx = %d dy = %d bleft = %d btop = %d dst_bound left = %d top = %d  dimx = %d dimy = %d\n",
   dx,dy,win->dwin->screen.dimension.bound.left,win->dwin->screen.dimension.bound.top,
   img->_2d_fusion.dst_bound.left,img->_2d_fusion.dst_bound.top,
   _2d->dimx,_2d->dimy))
 PRT10(printf("src_bound left = %d top = %d   right = %d bottom = %d\n",
   src_bound->left,src_bound->top,
   src_bound->right,src_bound->bottom))
 PRT10(printf("img->_2d.dimx = %d img->_2d.dimy = %d\n",img->_2d.dimx,img->_2d.dimy))
 if (ValidDstAndSrcBound(0,0,img->_2d.dimx - 1,img->_2d.dimy - 1,
             dx,dy,
             src_bound->left,src_bound->top,
             src_bound->right,src_bound->bottom,
             &vs1left,&vs1top,&vs1right,&vs1bottom,
             &x1,&y1,&dimx,&dimy) != NO_ERROR)
    {PRT10(printf("NO intersec...vs1left = %d top = %d r = %d b = %d\n",
             vs1left,vs1top,vs1right,vs1bottom);)
     PRT10(printf("NO intersec...x1 = %d y1 = %d dimx = %d dimy = %d\n",
             x1,y1,dimx,dimy);)
     return NO_ERROR;}
 PRT8(printf("whole offx = %d offy = %d  dl = %d dt = %d  vdl = %d dt = %d dr = %d db = %d\n",
             offx,offy,img->_2d_fusion.dst_bound.left,
             img->_2d_fusion.dst_bound.top,vs1left,vs1top,vs1right,vs1bottom))
 PRT10(printf("x1 = %d y1 = %d sr = %d sb = %d\n",x1,y1,dimx,dimy);)

 y = bufy_to_screeny(&(win->dwin->screen),vs1top);
 x = bufx_to_screenx(&(win->dwin->screen),vs1left);
 y1 = bufy_to_screeny(&(win->dwin->screen),y1);
 x1 = bufx_to_screenx(&(win->dwin->screen),x1);
 dimy = bufy_to_screeny(&(win->dwin->screen),dimy + 1);
 dimx = bufx_to_screenx(&(win->dwin->screen),dimx + 1);
 PRT10(printf("&&& vs1left = %d vs1top = %d x1 = %d y1 = %d sr = %d sb = %d\n",
       vs1left,vs1top,x1,y1,dimx,dimy);)

 dimy = dimy - y1;
 dimx = dimx - x1;
 if (img->_2d_fusion.im != NULL)
    {
     PRT10(printf("user_write...x = %d y = %d sx1 = %d  sy1 = %d sdimx = %d  sdimy = %d\n",x,y,x1,y1,dimx,dimy))
     user_write(win->dwin->frame_canvas.canvas,x,y,dimx,
            dimy,GXor,img->_2d_fusion.im,x1,y1);
     img->_2d_fusion.status |= FUSION_MOVE_PERFORMED | FUSION_JUST_PERFORMED;
    }
 PRT8(printf("win_show_or_fusion...4\n\n");)
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
move_superimpose_proc - ???
--------------------------------------------------------------------------*/

int
move_superimpose_proc(win,use_degree,xdegree,ydegree)
 struct image_display_window *win;
 int use_degree;
 float xdegree,ydegree;
{
 Event event1;
 long offx,offy;
 struct img_buf_rec *img;
 int err;

 PRT8(printf("move_superimpose_proc...use_degree = %d\n",use_degree))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;

 if (!(img->_2d_fusion.status & FUSION_METHOD))
    {win_select_cursor(win,CURSOR_DEFAULT);
     return CANCEL;}
 img->_2d_fusion.status &= ~(FUSION_MOVE_IGNORED_EVENT_UP | FUSION_SHOW_ONLY_SRC);
 if (!use_degree)
    if (last_loc_drag_event(
              canvas_paint_window(win->dwin->frame_canvas.canvas),&event1,2)
              == NO_ERROR)
    {if ((err = dwin_get_coord_xy_from_event(win->dwin,&event1,
             &(win->control.trans.curx),&(win->control.trans.cury))) != NO_ERROR)
        return err;
    }
 if (use_degree)
    {
     offx = (long) xdegree;
     offy = (long) ydegree;
    }
   else
    {
     offx = win->control.trans.curx - win->control.trans.last_curx;
     offy = win->control.trans.cury - win->control.trans.last_cury;
    }
 PRT8(printf("move_super...offx = %d offy = %d initx = %d inity = %d curx = %d cury = %d lx = %d ly = %d\n",
      offx,offy,win->control.trans.initx,win->control.trans.inity,
      win->control.trans.curx,win->control.trans.cury,
      win->control.trans.last_curx,win->control.trans.last_cury))
 win->control.trans.last_curx += offx;
 win->control.trans.last_cury += offy;
 win_show_or_fusion(win,offx,offy);
 update_fusion_menu(win);

 win->control.trans.status |= TRANS_PERFORMED;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
check_trans_roi_proc - ???
--------------------------------------------------------------------------*/

int
check_trans_roi_proc(win,which)
 struct image_display_window *win;
 int which;
{
 struct img_buf_rec *img;
 int x,y;

 (void) notify_set_itimer_func((Notify_client) win,NOTIFY_FUNC_NULL,
             ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 if (win->control.trans.status & TRANS_ACCEPT_NEXT)
    {
     if (dwin_get_coord_xy_from_mouse_xy(win->dwin,&x,&y) == NO_ERROR)
        {PRT8(printf("check_trans_roi_proc...x = %d y = %d curx = %d cury = %d\n",
            x,y,win->control.trans.curx,win->control.trans.cury);)
         win->control.trans.curx = x;
         win->control.trans.cury = y;

         if (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE)
            {PRT8(printf("check_trans_roi_proc...1\n");)
             if ((img = win_rec_cur_img_buf(win->owner)) != NULL)
                if (!(img->_2d_fusion.status & FUSION_MOVE_IGNORED_EVENT_UP))
                   move_superimpose_proc(win,0,.0,.0);
                  else img->_2d_fusion.status &= ~FUSION_MOVE_IGNORED_EVENT_UP;
            }
           else transform_roi_proc(win,0,.0,.0);
        }
       else
        {PRT8(printf("check_trans_roi_proc invalid...x = %d y = %d\n",x,y);)
        }
     win->control.trans.status &= ~TRANS_ACCEPT_NEXT;
    }
   else
    {PRT8(printf("check_trans_roi_proc...else\n");)
    }
 return NOTIFY_DONE;
}


/*--------------------------------------------------------------------------
trans_roi - ???
--------------------------------------------------------------------------*/

int
trans_roi(win,event)
 struct image_display_window *win;
 Event *event;
{
 int err,is_selected,action,is_select_curve,is_continue;
 long x,y;
 static struct itimerval timer;
 struct img_buf_rec *img;

 action = event_action(event);
 PRT30(printf("\n...trans_roi..action = %d\n",action);)
 if (action == ACTION_SELECT)
    {PRT8(printf("...ACTION_SELECT..\n");)
     if (event_is_up(event))
        {PRT1(printf("ACTION_SELECT event_is_up\n"))
         if (!(win->control.trans.status & TRANS_DRAG) || event_shift_is_down(event))
            {if (((err = SelectCurve(win,event,is_select_curve,0,
                           &is_selected)) != CANCEL) &&
                 (is_selected == NO_ERROR))
                {
                 if ((err = dwin_get_coord_xy_from_event(win->dwin,event,&x,&y))
                        != NO_ERROR)
                    return err;
                 if ((err = win_update_trans_roi_rec(win)) != NO_ERROR)
                    return err;
                 start_trans_roi_rec_proc(win,x,y);
                 PRT8(printf("trans_roi...start_trans_roi_rec_proc\n");)
                }
             return err;
            }
         PRT1(printf("ACTION_SELECT 2 event_is_up\n"))
        }
     TRACE(printf("\n");)
    }

 is_continue = 0;
 if ((action == ACTION_SELECT) || (action == ACTION_ADJUST) ||
     (action == ACTION_MENU))
    {
     if (event_is_up(event))
        {PRT30(printf("...trans_roi..event_is_up\n");)
         if (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE)
            {is_continue = 1;
            }
           else win_update_trans_roi_rec(win);
          PRT1(printf("trans_roi 1 event_is_up\n"))
        }
       else
        {if ((err = dwin_get_coord_xy_from_event(win->dwin,event,&x,&y))
                        != NO_ERROR)
            return err;

         PRT8(x1 = (int) event_x(event);y1 = (int) event_y(event);
          printf("****x1 = %d y1 = %d  x = %d y = %d\n",x1,y1,x,y))
         start_trans_roi_rec_proc(win,x,y);
         if (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE)
            {
             PRT30(printf("...trans_roi..event_is_down\n");)
             if (action == ACTION_ADJUST)
                {PRT30(printf("...trans_roi..ACTION_ADJUST \n");)
                 fusion_event_action_proc(win,event);
                }
               else if (action == ACTION_MENU)
                {PRT7(printf("\nevent is up...ACTION_MENU\n"))
                 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
                    return CANCEL;
                 win_show_hide_fusion(win);
                 PRT7(printf("event is up...ACTION_MENU...done\n\n"))
                 img->_2d_fusion.status |= FUSION_MOVE_IGNORED_EVENT_UP;
                }
            }
           else
            if (action == ACTION_ADJUST)
               {if (win->control.status & ACTION_ON_CUR_ROI)
                   win->control.status &= ~ACTION_ON_CUR_ROI;
                  else
                   {win->control.status &= ~ACTION_ON_ROI;
                    win->control.status |= ACTION_ON_CUR_ROI;}
                update_dp_trans_roi(win);
                win_execute_proc_to_multiple_wins(win,win_action_label,
						  0,0,0,0,0);
               }
              else if (action == ACTION_MENU)
               {if (win->control.status & ACTION_ON_ALL_ROIS)
                   win->control.status &= ~ACTION_ON_ALL_ROIS;
                  else
                   {win->control.status &= ~ACTION_ON_ROI;
                    win->control.status |= ACTION_ON_ALL_ROIS;}
                update_dp_trans_roi(win);
                win_execute_proc_to_multiple_wins(win,win_action_label,
						  0,0,0,0,0);
               }
         }
     PRT8(printf("trans_roi action END\n"))
     if (!is_continue) return NO_ERROR;
    }
   else if ((action == LOC_DRAG) && event_left_is_down(event))
    {
     if ((err = dwin_get_coord_xy_from_event(win->dwin,event,&x,&y)) != NO_ERROR)
        return err;
     PRT8(x1 = (int) event_x(event);y1 = (int) event_y(event);
          printf(" x1 = %d y1 = %d  x = %d y = %d\n",x1,y1,x,y))
     if (!(win->control.trans.status & TRANS_PARAMS_INITIALIZED))
        {TRACE(printf(" LOC_DRAG ACTION_SELECT\n"))
         start_trans_roi_rec_proc(win,x,y);}
       else
        {win->control.trans.status |= TRANS_DRAG;
     
         if ((win->control.trans.curx == x) && (win->control.trans.cury == y))
            return NO_ERROR;
         win->control.trans.curx = x;
         win->control.trans.cury = y;

         if (win->control.trans.status & TRANS_ACCEPT_NEXT)
            {PRT8(printf("NeEXT...TRANS_ACCEPT_NEXT\n");)
             if (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE)
                {/*move_superimpose_proc(win,0,.0,.0);
                 is_continue = 2;*/
                }
               else transform_roi_proc(win,0,.0,.0);
             win->control.trans.status &= ~TRANS_ACCEPT_NEXT;
             (void) notify_set_itimer_func((Notify_client) win,
                 NOTIFY_FUNC_NULL,ITIMER_REAL,
                 (struct itimerval *) 0,(struct itimerval *) 0);
            }
           else
            {PRT8(printf("NeEXT...\n");)
             win->control.trans.status |= TRANS_ACCEPT_NEXT;
             timer.it_value.tv_usec = 2000;
             timer.it_interval.tv_usec = 2000;
             (void) notify_set_itimer_func((Notify_client) win,
                 (Notify_func) check_trans_roi_proc,ITIMER_REAL,
                &timer,NULL);}
        }
     if (!is_continue) return NO_ERROR;
    }
/*
   else return CANCEL;
*/
   else if (event_is_up(event))
    {PRT8(printf("...$$$$$ trans_roi..event_is_up\n");)
     if (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE)
        {if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
         if (img->_2d_fusion.status & FUSION_JUST_PERFORMED)
            is_continue = 2;
        }
     PRT1(printf("trans_roi $$$$$ event_is_up\n"))
    }
 if (is_continue)
    {PRT8(printf("...$$$$$ is_continue\n");)
     if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
     if ((is_continue == 2) ||
         !(img->_2d_fusion.status & FUSION_MOVE_IGNORED_EVENT_UP))
        {if (img->_2d_fusion.status & FUSION_MOVE_SELF)
            {win_fusion_move_img(win);
             PRT7(printf("event is up...FUSION_MOVE_SELF\n\n"))}
           else 
            win_move_show_hide_fusion(win,1);
         PRT8(printf("...$$$$$ is_continue...start_trans_roi_rec_proc\n");)

        }
     if (is_continue == 2) img->_2d_fusion.status &= ~FUSION_JUST_PERFORMED;
     return NO_ERROR;}
 PRT8(printf("trans_roi action CANCEL\n"))
 return CANCEL;

}


/*--------------------------------------------------------------------------
win_transform_by_keypad - ???
--------------------------------------------------------------------------*/

int
win_transform_by_keypad(win,event,off)
 struct image_display_window *win;
 Event *event;
 int off;
{
 float x,y;

 if ((win->control.which_cursor == CURSOR_MOVE_ROI) ||
     (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE))
    {x = .0;
     y = (float) off;
     if (event_shift_is_down(event)) y = -y;
     if (win->control.which_cursor == CURSOR_MOVE_ROI)
        return transform_roi_proc(win,1,x,y);
       else return move_superimpose_proc(win,1,x,y);
    }
   else if (win->control.which_cursor == CURSOR_RESIZE_ROI)
    {if (event_ctrl_is_down(event))
        {y = (float) off;
         if (event_shift_is_down(event)) y *= .1;
           else  y = (y * .1) + 1.0;
         x = 1.0;
        }
       else
        {x = (float) off;
         if (event_shift_is_down(event)) x *= .1;
           else  x = (x * .1) + 1.0;
         y = 1.0;
        }
     return transform_roi_proc(win,1,x,y);
    }
   else
    {y = .0;
     x = (float) off * 10.0;
     if (event_shift_is_down(event)) x = -x;

     return transform_roi_proc(win,1,x,y);}
}

/************
win_transform_by_arrow(win,event,x,y)
 struct image_display_window *win;
 Event *event;
 float x,y;
{
 int err;

 PRT4(printf("win_transform_by_arrow x = %f y = %f\n",x,y))
 if ((win->control.which_cursor == CURSOR_MOVE_ROI) ||
     (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE))
    {if (event_shift_is_down(event)) 
        {x = x * 2.0;
         y = y * 2.0;}
     if (win->control.which_cursor == CURSOR_MOVE_ROI)
        err = transform_roi_proc(win,1,x,y);
       else err = move_superimpose_proc(win,1,x,y);
    }
   else if (win->control.which_cursor == CURSOR_RESIZE_ROI)
    {if (event_shift_is_down(event))
        {x *= .1;
         y *= .1;}
       else 
        {x = (x * .1) + 1.0;
         y = (y * .1) + 1.0;}
     if (x == .0) x = 1.0;
     if (y == .0) y = 1.0;
     err = transform_roi_proc(win,1,x,y);
    }
   else
    {if (event_shift_is_down(event)) 
        {x = x * 2.0;
         y = y * 2.0;}
     if (x == .0)
        {x = y * 10.0;
         y = .0;}
     err = transform_roi_proc(win,1,x,y);
    }
 PRT4(printf("end x = %f y = %f\n",x,y))
 return err;
}
****************/
