/****************************************************************************
win_ask_text.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: win_ask_text.c,v 1.10 1999/07/07 17:41:20 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <X11/X.h>
#include <X11/Xlib.h>

#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/xv_xrect.h>
#include <xview/font.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "error_constants.h"
#include "rect.h"
#include "typedef.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)



struct user_win_rec
   {
    int status;
    Frame frame;
    int is_destroy_frame;
    struct strs_rec *strs_rec_ptr;
    int (*action_proc)();
    int (*proc)();
    void *arg;
    char *private_str;
   };


struct show_frame_menu_rec
   {
    Frame frame;
    Panel panel;
    Panel_item text;
    Menu menu;
    Event event;
   };


/* Functions defined in this file */
int setup_user_win_rec(struct user_win_rec **user, Frame frame,
    int is_free_frame, struct strs_rec *strs_rec_ptr, int free_str_status,
    int (*action_proc)(), int (*proc)(), void *arg, char *private_str);
void free_user_win_rec(struct user_win_rec **user);
void user_win_rec_menu_proc(Menu menu, Menu_item item);
void win_rd_text_proc(Panel_item item, Event *event);
void win_text_destroy_frame(Frame frame);
void win_rd_text_quit_proc(Panel_item item, Event *event);
void win_rd_text_done_proc(Frame frame);
void rd_text_event_proc(Xv_Window win, Event *event);
void show_win_rd_text_menu(struct show_frame_menu_rec *show_menu, int which);
static Notify_value win_rd_text_next_func(Xv_Window frame, Event *event,
    Notify_arg arg, Notify_event_type type);
int win_rd_text(Xv_Window win, char *win_label, char *msg,
    struct strs_rec *strs_rec_ptr, int free_str_status, int is_dp_menu,
    int str_display_len, int (*action)(), void *arg, char *default_str);



/*-------------------------------------------------------------------------
setup_user_win_rec - ???
-------------------------------------------------------------------------*/

int
setup_user_win_rec(user,frame,
                   is_free_frame,strs_rec_ptr,free_str_status,
                    action_proc,proc,arg,private_str)
 struct user_win_rec **user;
 Frame frame;
 int is_free_frame;
 struct strs_rec *strs_rec_ptr;
 int free_str_status;
 int (*action_proc)();
 int (*proc)();
 void *arg;
 char *private_str;
{
 unsigned long total;
 int err;

 total = 0;
 get_ptr_memory(user,&total,(unsigned long) 1,(size_t)
                   sizeof(struct user_win_rec),&err);
 if (err != NO_ERROR) return err;
 if ((err = cp_str(&((*user)->private_str),private_str)) != NO_ERROR)
    {c_free(*user);
     return err;}

 (*user)->frame = frame;

 (*user)->status = USER_WIN_SETUP;
 if (is_free_frame) (*user)->status |= USER_WIN_FREE_FRAME;

 (*user)->strs_rec_ptr = strs_rec_ptr;
 if (free_str_status) 
    (*user)->status |= free_str_status;

 (*user)->action_proc = action_proc;
 (*user)->proc = proc;
 (*user)->arg = arg;

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
free_user_win_rec - ???
-------------------------------------------------------------------------*/

void
free_user_win_rec(user)
 struct user_win_rec **user;
{
 TRACE(printf("free_user_win_rec...\n"))

 if (!((*user)->status & USER_WIN_SETUP)) return;
 if ((*user)->status & USER_WIN_FREE_FRAME)
    win_text_destroy_frame((*user)->frame);

 if ((*user)->strs_rec_ptr != NULL)
    if ((*user)->status & USER_WIN_FREE_STRS)
       {free_strs_rec((*user)->strs_rec_ptr);}
      else if ((*user)->status & USER_WIN_FREE_STR_PTRS)
       {free_strs_rec_ptrs((*user)->strs_rec_ptr);}
      else if ((*user)->status & USER_WIN_FREE_STRS_AND_PTR)
       {free_strs_rec((*user)->strs_rec_ptr);
        c_free((*user)->strs_rec_ptr);}
      else if ((*user)->status & USER_WIN_FREE_STR_PTRS_AND_PTR)
       {free_strs_rec_ptrs((*user)->strs_rec_ptr);
        c_free((*user)->strs_rec_ptr);}
 c_free((*user)->private_str);

 c_free((*user));
 *user = NULL;
 TRACE(printf("free_user_win_rec...end\n"))
}


/*-------------------------------------------------------------------------
user_win_rec_menu_proc - ???
-------------------------------------------------------------------------*/

void
user_win_rec_menu_proc(menu,item)
 Menu menu;
 Menu_item item;
{
 char *result;
 Panel_item owner;
 Panel panel;
 Frame frame;

 owner =  (Panel_item) xv_get(menu,MENU_CLIENT_DATA);
 result = (char *) xv_get(item,MENU_STRING);
 xv_set(owner,PANEL_VALUE,result,0);
 panel = (Panel) xv_get(owner,PANEL_PARENT_PANEL);
 frame = (Frame) xv_get(panel,XV_OWNER);
 win_set_kbd_focus(panel,xv_get(panel,XV_XID));
 owner = (Panel_item) xv_get(panel,PANEL_CLIENT_DATA);
/*
 xv_set(panel,PANEL_CARET_ITEM,owner,0);
 panel_backup_caret(panel);
*/
 win_rd_text_proc(owner, NULL);
}



/*-------------------------------------------------------------------------
win_rd_text_proc - ???
-------------------------------------------------------------------------*/

void
win_rd_text_proc(item, event)
 Panel_item	item;
 Event		*event;
{
 char *result;
 struct user_win_rec *user;

 user = (struct user_win_rec *) xv_get(item,PANEL_CLIENT_DATA);
 
 if (((result = (char *) xv_get(item,PANEL_VALUE)) != NULL) &&
     (get_strlen(result) > 0))
    {
     if (user->proc != NULL) user->proc(user->arg,result);
    }
 free_user_win_rec(&user);

}


/*-------------------------------------------------------------------------
win_text_destroy_frame - ???
-------------------------------------------------------------------------*/

void
win_text_destroy_frame(frame)
 Frame frame;
{
 Menu menu;
 Frame *addr;

 TRACE(printf("win_text_destroy_frame...frame = %u\n",frame))

 if (frame != 0)
    {addr = (Frame *) xv_get(frame,XV_KEY_DATA,1);
     menu = (Menu) xv_get(frame,XV_KEY_DATA,2);
 TRACE(printf("win_text_destroy_frame...addr = %u  menu = %u\n",*addr,menu))
     if (menu != 0) xv_destroy_safe(menu);
     xv_destroy_safe(frame);
     *addr = 0;
    }
 TRACE(printf("win_text_destroy_frame..end...frame = %u\n",frame))
}


/*-------------------------------------------------------------------------
win_rd_text_quit_proc - ???
-------------------------------------------------------------------------*/

void
win_rd_text_quit_proc(item, event)
 Panel_item	item;
 Event		*event;
{
 struct user_win_rec *user;
 Frame frame;
 Panel panel;

 user = (struct user_win_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (user != NULL) free_user_win_rec(&user);
   else
    {panel = xv_get(item,PANEL_PARENT_PANEL);
     frame = xv_get(panel,XV_OWNER);
     win_text_destroy_frame(frame);
    }
}


/*-------------------------------------------------------------------------
win_rd_text_done_proc - ???
-------------------------------------------------------------------------*/

void
win_rd_text_done_proc(frame)
 Frame frame;
{
 struct user_win_rec *user;

 user = (struct user_win_rec *) xv_get(frame,WIN_CLIENT_DATA);
 if (user != NULL) free_user_win_rec(&user);
   else
    {
     win_text_destroy_frame(frame);
    }
}


/*-------------------------------------------------------------------------
rd_text_event_proc - ???
-------------------------------------------------------------------------*/

void
rd_text_event_proc(win,event)
 Xv_Window win;
 Event *event;
{
 if ((event_id(event) == LOC_WINENTER) || (event_action(event) == LOC_WINENTER))
    {win_set_kbd_focus(win,xv_get(win,XV_XID));
    }
}


/*-------------------------------------------------------------------------
show_win_rd_text_menu - ???
-------------------------------------------------------------------------*/

void
show_win_rd_text_menu(show_menu,which)
 struct show_frame_menu_rec *show_menu;
 int which;
{
 int x,y;

 x = event_x(&(show_menu->event));
 y = event_y(&(show_menu->event));
 xv_set(show_menu->frame,WIN_MOUSE_XY,x,y,0);
 menu_show(show_menu->menu,show_menu->frame,&(show_menu->event),0);
}


/*-------------------------------------------------------------------------
win_rd_text_next_func - ???
-------------------------------------------------------------------------*/

static Notify_value 
win_rd_text_next_func(frame,event,arg,type)
 Xv_Window frame;
 Event *event;
 Notify_arg arg;
 Notify_event_type type;
{
 static Event event1;
 struct show_frame_menu_rec *show_menu;
 
 if (event_action(event) == ACTION_OPEN)
    {notify_next_event_func((Notify_client) frame,
               (Notify_event) event,arg,type);
     grap_keyboard(frame);
     event_set_action(&event1,32640);
     notify_post_event((Notify_client) frame,
          (Notify_event) &event1,NOTIFY_SAFE);}
   else if (event_action(event) == 32640)
    {
     show_menu = (struct show_frame_menu_rec *) xv_get(frame,XV_KEY_DATA,3);
     if (show_menu->menu != 0) 
        {
         show_win_rd_text_menu(show_menu,0);
         show_menu->menu = 0;
        }
       else
        {
         xv_set(show_menu->panel,PANEL_CARET_ITEM,show_menu->text,0);
        }
    }
   else if (event_action(event) == LOC_WINENTER)
    {grap_keyboard(frame);
     show_menu = (struct show_frame_menu_rec *) xv_get(frame,XV_KEY_DATA,3);
     if (show_menu != NULL)
        xv_set(show_menu->panel,PANEL_CARET_ITEM,show_menu->text,0);
     return NOTIFY_DONE;
    }
   else notify_next_event_func((Notify_client) frame,
               (Notify_event) event,arg,type);

}



/*-------------------------------------------------------------------------
win_rd_text - ???
-------------------------------------------------------------------------*/

int
win_rd_text(win,win_label,msg,strs_rec_ptr,free_str_status,is_dp_menu,
                     str_display_len,action,arg,default_str)
 Xv_Window win;
 char *win_label,*msg;
 struct strs_rec *strs_rec_ptr;
 int free_str_status,is_dp_menu;
 int str_display_len;
 int (*action)();
 void *arg;
 char *default_str;
{
 struct user_win_rec *user;
 static Frame frame = 0;
 char *win_label1,*msg1,*default_str1,*str;
 Panel_item item,quit;
 int err,x,y;
 Menu menu;
 Rect *rr;
 Panel panel;
 Panel_item text;
 static struct show_frame_menu_rec show_menu;

 TRACE(printf("win_rd_text...frame = %u   addr = %u\n",frame,&frame))
 if (frame != 0)
    {
     if ((Xv_pkg *) xv_get(frame,XV_TYPE) == FRAME)
         win_rd_text_done_proc(frame);
     frame = 0;}

 if (win_label == NULL) win_label1 = "";
   else win_label1 = win_label;
 frame = xv_create(win,FRAME,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL, win_label1,
              FRAME_DONE_PROC,win_rd_text_done_proc,
              XV_X,0,XV_Y,0,
              FRAME_NO_CONFIRM,TRUE,
              0);
 if (frame == 0) return 0;
 panel = xv_create(frame,PANEL,0);
 if (panel == 0)
    {xv_destroy_safe(frame);
     frame = 0;
     return 0;}
 xv_set(frame,XV_KEY_DATA,1,&frame,0);

 if (msg == NULL) msg1  = "";
   else msg1 = msg;

 if (default_str != NULL)
    default_str1 = default_str;
   else if ((strs_rec_ptr == NULL) || (strs_rec_ptr->num_strs == 0))
    default_str1 = "";
   else default_str1 = strs_rec_ptr->strs[strs_rec_ptr->cur_str];

 if (((strs_rec_ptr == NULL) || (strs_rec_ptr->num_strs == 0)) &&
     (get_strlen(msg1) == 0))
    {str = "QUIT";
     quit = (Panel_item) xv_create(panel,PANEL_BUTTON,
                   PANEL_LABEL_STRING,str,
	           PANEL_NOTIFY_PROC,win_rd_text_quit_proc,
                   0);
     rr = (Rect *) xv_get(quit,XV_RECT);}
   else
    {if ((strs_rec_ptr != NULL) && (strs_rec_ptr->num_strs > 0))
        {item = (Panel_item) xv_create(panel,PANEL_BUTTON,
                    PANEL_LABEL_STRING,msg1,0);
        }
       else
         item = (Panel_item) xv_create(panel,PANEL_MESSAGE,
                    PANEL_LABEL_STRING,msg1,0);

     rr = (Rect *) xv_get(item,XV_RECT);
     str = "QUIT";
     quit = (Panel_item) xv_create(panel,PANEL_BUTTON,
                   PANEL_LABEL_STRING,str,
                   XV_X,rr->r_left + rr->r_width + 20,
	           PANEL_NOTIFY_PROC,win_rd_text_quit_proc,
                   0);
    }
 text = (Panel_item) xv_create(panel,PANEL_TEXT,
                   PANEL_VALUE_DISPLAY_LENGTH,str_display_len,
                   PANEL_VALUE,default_str1,
                   XV_Y,rr->r_top + rr->r_height + 10,
                   XV_X,0,
                   PANEL_NOTIFY_PROC,win_rd_text_proc,
                   PANEL_CLIENT_DATA,user,
                   0);
 if ((strs_rec_ptr != NULL) && (strs_rec_ptr->num_strs > 0))
    {SetupTheMenu(&menu,NULL,1,frame,strs_rec_ptr,user_win_rec_menu_proc,0);
     if (menu != 0)
        {xv_set(menu,MENU_CLIENT_DATA,text,0);
         xv_set(item,PANEL_ITEM_MENU,menu,0);
        }
     xv_set(frame,XV_KEY_DATA,2,menu,0);
    }

 window_fit(panel);
 window_fit(frame);

 if ((err = setup_user_win_rec(&user,frame,1,
                    strs_rec_ptr,free_str_status,
                    action,action,arg,NULL)) != NO_ERROR)
    {win_text_destroy_frame(frame);
     return err;}

 xv_set(quit,PANEL_CLIENT_DATA,user,0);
 xv_set(text,PANEL_CLIENT_DATA,user,0);
 xv_set(panel,PANEL_CLIENT_DATA,text,0);
 xv_set(panel,
	WIN_EVENT_PROC,rd_text_event_proc,
	WIN_CONSUME_EVENTS,
            LOC_WINENTER,LOC_WINEXIT,0,
        0);

 move_win_to_mouse_xy(frame,win);
 win_in_screen_rect(frame);

 xv_set(frame,WIN_CLIENT_DATA,user,XV_SHOW,TRUE,0);
 wmgr_top(frame);
 notify_interpose_event_func(frame,win_rd_text_next_func,NOTIFY_SAFE);
 show_menu.frame = frame;
 show_menu.panel = panel;
 show_menu.text = text;
 xv_set(frame,WIN_CONSUME_EVENTS,LOC_WINENTER,NULL,
        WIN_IGNORE_EVENTS,WIN_UP_ASCII_EVENTS,NULL,
	0);
 xv_set(frame,XV_KEY_DATA,3,&show_menu,0);

 if ((is_dp_menu) && (strs_rec_ptr != NULL) && (strs_rec_ptr->num_strs > 0) &&
     (menu != 0))
    {show_menu.menu = menu;
     event_set_window(&(show_menu.event),show_menu.panel);
     rr = (Rect *) xv_get(item,PANEL_ITEM_RECT);
     x = rr->r_left + 5;
     y = rr->r_top + rr->r_height / 2;

     event_set_x(&(show_menu.event),x);
     event_set_y(&(show_menu.event),y);
   }
  else
   {show_menu.menu = 0;
    xv_set(frame,WIN_MOUSE_XY,25,35,0);
   }

 return err;
}

