/****************************************************************************
win_general.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  The function win_set_kbd_focus used in this file is never defined,
according to a tags-search.  But the program links successfully, so it
must be defined somewhere.
****************************************************************************/

static const char rcsid[] = "$Id: win_general.c,v 1.13 1999/07/07 17:41:20 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <X11/X.h>
#include <X11/Xlib.h>

#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/font.h>
#include <xview/canvas.h>
#include <xview/cursor.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/notify.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"


#if 0
#  define TRACE(x) x; fflush(stdout);
#  define PRT(x) x; fflush(stdout);
#  define PRT1(x) x; fflush(stdout);
#  define PRT2(x) x; fflush(stdout);
#else
#  define TRACE(x)
#  define PRT(x)
#  define PRT1(x)
#  define PRT2(x)
#endif


/* Functions defined in this file */
void win_alarm(Frame frame, int num_alarms);
int user_write(Xv_opaque win, int dx, int dy, int width, int height, int op,
    XImage *im, int sx, int sy);
int win_copy_from_and_to_pixmap(Xv_opaque win, Pixmap pm, int dx, int dy,
    int op, int sx, int sy, int width, int height, int is_copy_from);
void set_big_win(Xv_opaque win);
int get_color_indxs(Cms cms, Xv_singlecolor **colors,
    unsigned int *num_colors);
int win_x_screen_no(Xv_opaque win);
Screen *win_x_screen(Xv_opaque win);
int set_win_back_and_foreground(Xv_opaque win, int is_set_bg,
    unsigned long bg, int is_set_fg, unsigned long fg);
int get_singlecolor(Cms cms, unsigned long color_indx, Xv_singlecolor *color);
int set_win_foreground_to_default_gc(Xv_opaque win);
int set_win_background_to_default_gc(Xv_opaque win);
void get_win_absolute_area(Frame win, Rect *rr);
void set_win_absolute_area(Xv_opaque win, Rect *rr);
void win_in_screen_rect(Xv_opaque win);
int win_cur_event(Xv_opaque win, Event *event);
void Rect_to_int_rect_rec(Rect *rect, struct int_rect_rec *rr);
void int_rect_rec_to_Rect(struct int_rect_rec *rr, Rect *rect);
int pt_in_Rect(Rect *rr, int x, int y);
void pr_Rect(Rect *rr);
void make_2_wins_adjacent(Frame win_move_to, Frame win_same_place,
    int is_win_same_place_movable);
void make_2_wins_top_down(Frame win_move_to, Frame win_same_place,
    int is_win_same_place_movable);
void move_win_to_mouse_xy(Xv_opaque win, Xv_opaque mouse_win);
int get_xwin_valid_mouse_xy(Xv_opaque win, long *x, long *y);
void in_set_mouse_at_rect_center(Xv_opaque win, Rect *rect);
void win_set_mouse_at_center(Xv_opaque win);
void center_frame(Xv_opaque window, int is_just_setup);
void center_window(Xv_opaque window);
void win_clear(Xv_opaque win, Pixmap pm, int is_wr_to_win);
void win_clear_area(Xv_opaque win, Pixmap pm, int is_wr_to_win, int x, int y,
    int width, int height, int exposures);
void win_flush(Xv_opaque win);
void win_flush_input(Xv_opaque win);
void win_screen_dims(Xv_opaque win, unsigned int *width, unsigned int *height,
    unsigned int *depth);
Window win_x_rootwindow(Xv_opaque win);
int win_depth(Xv_opaque win, unsigned int *depth);
int win_pixmap_dims(Xv_opaque win, Pixmap pm, unsigned int *width,
    unsigned int *height, unsigned int *depth);
int win_setup_pixmap(Xv_opaque win, Pixmap *pm);
void win_free_pixmap(Xv_opaque win, Pixmap pm);
void grap_keyboard(Xv_opaque xvwin);
int is_cursor_in_window(Xv_opaque xvwin);
void get_Xv_opaque_info(Xv_opaque win, Display **dp, int *screen_num,
    Screen **screen);
int double_click(Xv_opaque canvas, Event *event);
int selected_list_items(struct strs_rec *list, Panel_item item);
int selected_list_item_ptrs(struct strs_rec *list, Panel_item item);
int next_selected_item(Panel_item item, int item_start_indx,
    int *selected_indx);
int is_list_item_empty(Panel_item list_item);
int list_items(struct strs_rec *list, Panel_item item);
int list_item_ptrs(struct strs_rec *list, Panel_item item);
int setup_list_items(struct strs_rec *list, Panel_item item,
    int is_select_all);
int setup_int_items(int *ary, int num_items, Panel_item item, int include_0);
void update_list_client_data(Panel_item item);
int select_list_items(struct strs_rec *list, Panel_item item);
int select_list_str_item(char *selected_item_str, Panel_item item, int is_sel);
void delete_all_list_items(Panel_item item);
int delete_selected_list_items(Panel_item item);
int delete_list_item_by_str(char *str, Panel_item item);
void deselect_all_list_items(Panel_item item);
int deselect_list_items(struct strs_rec *list, Panel_item item);
void select_all_list_items(Panel_item item);
int find_list_item_by_str(Panel_item item, char *str, unsigned long *indx);
void deselect_list_proc(Panel_item item, Event *event);
void select_list_proc(Panel_item item, Event *event);
void list_insert(Panel_item from_item, int from_item_indx, Panel_item to_item,
    int *to_item_indx);
void list_swap(Panel_item item, Panel_list_op op, int *cur_indx,
    int swap_indx, char *swap_str);
void list_delete(Panel_item item, int *item_indx);
void open_close_frame_and_subframes(Frame frame, int is_open);
void show_hide_frame_and_subframes(Xv_opaque win, int is_show);
void top_frame_and_subframes(Frame frame);
void destroy_all_subframes(Frame frame);
void apply_proc_to_all_tree_window(Xv_opaque win, int (*proc)(), void *arg1,
    void *arg2, void *arg3, void *arg4, int num);
Xv_opaque root_menu(Menu menu);
void destroy_menu_and_submenus(Menu menu, int num);
void none_list_proc(Panel_item item, Event *event);
void all_list_proc(Panel_item item, Event *event);



/*-------------------------------------------------------------------------
win_alarm - ???

WIN_ALARM is an obsolete routine from SunView (gasp!) to beep the server.

FIXME: Replace with current routine.
-------------------------------------------------------------------------*/

void
win_alarm( frame, num_alarms )
     Frame frame;
     int num_alarms;
{
  int lcv;

  for (lcv = 0; lcv < num_alarms; lcv++)
    xv_set( frame,
	    WIN_ALARM,
	    NULL );
}



/*-------------------------------------------------------------------------
user_write - ???
-------------------------------------------------------------------------*/

int
user_write(win,dx,dy,width,height,op,im,sx,sy)
     Xv_opaque win;
     int dx,dy,sx,sy,width,height,op;
     XImage *im;
{
 Display *dp;
 Drawable xid;
 XGCValues gc_val;
 GC gc;

 PRT(printf("user_write.1..\n"))
 if (!xv_get(win,XV_SHOW) || xv_get(win,FRAME_CLOSED))
    {TRACE(printf("not XV_SHOW...FRAME_CLOSED\n"))
     return NO_ERROR;}

 dp = (Display *) xv_get(win,XV_DISPLAY);
 if ((Xv_pkg *) xv_get(win,XV_TYPE) == CANVAS)
    {
     if ((xid = (Drawable) xv_get(canvas_paint_window(win),XV_XID)) == 0)
        return ~NO_ERROR;
    }
   else if ((xid = (Drawable) xv_get(win,XV_XID)) == 0)
        return ~NO_ERROR;
 PRT(printf("XPutImage...0\n"))
 gc_val.function = op;
 gc = XCreateGC(dp,xid,GCFunction,&gc_val);
 PRT(printf("XPutImage...1\n"))
 PRT(printf("XPutImage...dx = %d dy = %d sx = %d sy = %d w = %d h = %d\n",
      dx,dy,sx,sy,width,height))
 XPutImage(dp,xid,gc,im,sx,sy,dx,dy,width,height);
 PRT(printf("XPutImage...2\n"))
 XFlush(dp);
 XFreeGC(dp,gc);
 PRT(printf("XPutImage...end\n"))
 return NO_ERROR;
}

/********************
user_write1(win,dx,dy,width,height,op,im,sx,sy)
 Xv_opaque win;
 int dx,dy,sx,sy,width,height,op;
 XImage *im;
{
 struct timeb the_time;
 Display *dp;
 Drawable xid;
 XGCValues gc_val;
 GC gc;

 TRACE(printf("user_write.1..\n"))
 if (!xv_get(win,XV_SHOW) || xv_get(win,FRAME_CLOSED))
    {TRACE(printf("not XV_SHOW...FRAME_CLOSED\n"))
     return NO_ERROR;}

 dp = (Display *) xv_get(win,XV_DISPLAY);
 if ((Xv_pkg *) xv_get(win,XV_TYPE) == CANVAS)
    {
     if ((xid = (Drawable) xv_get(canvas_paint_window(win),XV_XID)) == NULL)
        return ~NO_ERROR;
    }
   else if ((xid = (Drawable) xv_get(win,XV_XID)) == NULL)
        return ~NO_ERROR;
 ftime(&the_time);
 printf("user_write1 sec = %d  msecs = %d \n",
                (int) the_time.time,the_time.millitm);
 gc_val.function = op;
 gc = XCreateGC(dp,xid,GCFunction,&gc_val);
 ftime(&the_time);
 printf("====== sec = %d  msecs = %d end\n",
                (int) the_time.time,the_time.millitm);
 XPutImage(dp,xid,gc,im,sx,sy,dx,dy,width,height);
 ftime(&the_time);
 printf("user_write1 sec = %d  msecs = %d end\n",
                (int) the_time.time,the_time.millitm);
 XFlush(dp);
 XFreeGC(dp,gc);
 return NO_ERROR;
}
*************************/


/*-------------------------------------------------------------------------
win_copy_from_and_to_pixmap - ???
-------------------------------------------------------------------------*/

int
win_copy_from_and_to_pixmap(win,pm,dx,dy,op,sx,sy,width,height,is_copy_from)
 Xv_opaque win;
 Pixmap pm;
 int dx,dy,sx,sy,width,height,op;
 int is_copy_from;
{
 Display *dp;
 Drawable xid;
 XGCValues gc_val;
 GC gc;

 dp = (Display *) xv_get(win,XV_DISPLAY);
 if ((Xv_pkg *) xv_get(win,XV_TYPE) == CANVAS)
    {
     if ((xid = (Drawable) xv_get(canvas_paint_window(win),XV_XID)) == 0)
        return ~NO_ERROR;
    }
   else if ((xid = (Drawable) xv_get(win,XV_XID)) == 0)
        return ~NO_ERROR;
 gc_val.function = op;
 gc = XCreateGC(dp,xid,GCFunction,&gc_val);
 if (is_copy_from)
    XCopyArea(dp,pm,xid,gc,sx,sy,width,height,dx,dy);
   else XCopyArea(dp,xid,pm,gc,sx,sy,width,height,dx,dy);
 XFlush(dp);
 XFreeGC(dp,gc);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
set_big_win - ???
-------------------------------------------------------------------------*/

void
set_big_win(win)
 Xv_opaque win;
{
 Rect *rr;
 int hmargin,vmargin,margin;

 rr = (Rect *) xv_get(win,WIN_SCREEN_RECT);

 if (rr != NULL)
    {
     hmargin = (int) xv_get(win,XV_LEFT_MARGIN) +  
               (int) xv_get(win,XV_RIGHT_MARGIN) + 10;
     vmargin = (int) xv_get(win,XV_TOP_MARGIN) + 
               (int) xv_get(win,XV_BOTTOM_MARGIN) + 30;
     margin = (int) xv_get(win,XV_MARGIN);
     xv_set(win,XV_X,0,XV_Y,0,
            XV_WIDTH,rr->r_width - hmargin,
            XV_HEIGHT,rr->r_height - vmargin,0);
    }

}


/*-------------------------------------------------------------------------
get_color_indxs - ???
-------------------------------------------------------------------------*/

int
get_color_indxs(cms,colors,num_colors)
 Cms cms;
 Xv_Singlecolor **colors;
 unsigned int *num_colors;
{
 unsigned long size,total;
 int err;

 *num_colors = 0;
 if (cms != 0)
    {
     size = (unsigned long) xv_get(cms,CMS_SIZE);
     if (size > 0)
        {total = 0;
         get_ptr_memory(colors,&total,size,(size_t)
                    sizeof(Xv_Singlecolor),&err);
         if (err != NO_ERROR) return err;
         xv_get(cms,CMS_COLORS,(*colors));
         *num_colors = total;
         return NO_ERROR;
        }
    }
 return ~NO_ERROR;
}


/*-------------------------------------------------------------------------
win_x_screen_no - ???
-------------------------------------------------------------------------*/

int
win_x_screen_no(win)
 Xv_opaque win;
{
 Xv_Screen xv_screen;

 xv_screen = (Xv_Screen) xv_get(win,XV_SCREEN);
 return (int) xv_get(xv_screen,SCREEN_NUMBER);

}


/*-------------------------------------------------------------------------
win_x_screen - ???
-------------------------------------------------------------------------*/

Screen *
win_x_screen(win)
 Xv_opaque win;
{
 Xv_Screen xv_screen;
 int screen_no;
 Display *dp;

 xv_screen = (Xv_Screen) xv_get(win,XV_SCREEN);
 screen_no = (int) xv_get(xv_screen,SCREEN_NUMBER);
 dp = (Display *) xv_get(win,XV_DISPLAY);
 return ScreenOfDisplay(dp,screen_no);
}


/*-------------------------------------------------------------------------
set_win_back_and_foreground - ???
-------------------------------------------------------------------------*/

int
set_win_back_and_foreground(win,is_set_bg,bg,is_set_fg,fg)
 Xv_opaque win;
 int is_set_fg,is_set_bg;
 unsigned long fg,bg;
{
/*
 Xv_Singlecolor *colors;
 unsigned long size;
 int err;
 Cms cms;

 if ((Xv_pkg *) xv_get(win,XV_TYPE) != FRAME)
    {
*/
     if (is_set_bg) xv_set(win,WIN_BACKGROUND_COLOR,bg,0);
     if (is_set_bg) xv_set(win,WIN_FOREGROUND_COLOR,fg,0);
     return NO_ERROR;
/*
    }
 cms = (Cms) xv_get(win,WIN_CMS);
 if ((err = get_color_indxs(cms,&colors,&size)) == NO_ERROR)
    {if (is_set_fg) xv_set(win,FRAME_FOREGROUND_COLOR,&(colors[fg]),0);
     if (is_set_bg) xv_set(win,FRAME_BACKGROUND_COLOR,&(colors[bg]),0);
     c_free(colors);
     return NO_ERROR;
    }
 return err;
*/
}


/*-------------------------------------------------------------------------
get_singlecolor - ???
-------------------------------------------------------------------------*/

int
get_singlecolor(cms,color_indx,color)
 Cms cms;
 unsigned long color_indx;
 Xv_Singlecolor *color;
{
 Xv_Singlecolor *colors;
 unsigned long size;
 int err;

 if ((err = get_color_indxs(cms,&colors,&size)) == NO_ERROR)
    {*color = colors[color_indx];
     c_free(colors);
    }
 return err;
}


/*-------------------------------------------------------------------------
set_win_foreground_to_default_gc - ???
-------------------------------------------------------------------------*/

int
set_win_foreground_to_default_gc(win)
 Xv_opaque win;
{
 Display *dp;
 GC gc;
 Cms cms;
 unsigned long fg;

 if ((cms = (Cms) xv_get(win,WIN_CMS)) != 0)
    {
     if ((dp = (Display *) xv_get(win,XV_DISPLAY)) == NULL) return ~NO_ERROR;
     fg = (unsigned long) xv_get(win,WIN_FOREGROUND_COLOR);
     fg = (unsigned long) xv_get(cms,CMS_PIXEL,fg);

     if ((gc = DefaultGC(dp,win_x_screen_no(win))) == NULL) return ~NO_ERROR;
     XSetForeground(dp,gc,fg);
     return NO_ERROR;
    }
   else return ~NO_ERROR;

}


/*-------------------------------------------------------------------------
set_win_background_to_default_gc - ???
-------------------------------------------------------------------------*/

int
set_win_background_to_default_gc(win)
 Xv_opaque win;
{
 Display *dp;
 GC gc;
 Cms cms;
 unsigned long bg;

 if ((cms = (Cms) xv_get(win,WIN_CMS)) != 0)
    {
     if ((dp = (Display *) xv_get(win,XV_DISPLAY)) == NULL) return ~NO_ERROR;
     bg = (unsigned long) xv_get(win,WIN_BACKGROUND_COLOR);
     bg = (unsigned long) xv_get(cms,CMS_PIXEL,bg);

     if ((gc = DefaultGC(dp,win_x_screen_no(win))) == NULL) return ~NO_ERROR;
     XSetBackground(dp,gc,bg);
     return NO_ERROR;
    }
   else return ~NO_ERROR;

}


/*-------------------------------------------------------------------------
get_win_absolute_area - ???
-------------------------------------------------------------------------*/

void
get_win_absolute_area(win,rr)
 Frame win;
 Rect *rr;
{
 frame_get_rect(win,rr);
}


/*-------------------------------------------------------------------------
set_win_absolute_area - ???
-------------------------------------------------------------------------*/

void
set_win_absolute_area(win,rr)
 Xv_opaque win;
 Rect *rr;
{
/*
 rr->r_left += 5;
 rr->r_top += 26;
*/
 frame_set_rect(win,rr);
/*
 rr->r_left -= 5;
 rr->r_top -= 26;
*/
}



/*-------------------------------------------------------------------------
win_in_screen_rect - ???
-------------------------------------------------------------------------*/

void
win_in_screen_rect(win)
 Xv_opaque win;
{
 Rect *rr;
 Rect rr1;
 int is_set;

 get_win_absolute_area(win,&rr1);

 rr = (Rect *) xv_get(win,WIN_SCREEN_RECT);
 if ((rr1.r_left + rr1.r_width) > (rr->r_left + rr->r_width))
    {is_set = 1;
     rr1.r_left = rr->r_left + rr->r_width - rr1.r_width - 2;}
   else is_set = 0;
 if ((rr1.r_top + rr1.r_height) > (rr->r_top + rr->r_height))
    {is_set = 1;
     rr1.r_top = rr->r_top + rr->r_height - rr1.r_height - 2;}
 if (is_set)
    set_win_absolute_area(win,&rr1);
}


/*-------------------------------------------------------------------------
win_cur_event - ???
-------------------------------------------------------------------------*/

int
win_cur_event(win,event)
 Xv_opaque win;
 Event *event;
{
 Rect *rr;

 event_set_window(event,win);
 if ((rr = (Rect *) xv_get(win,WIN_MOUSE_XY)) != NULL)
    {event_set_x(event,rr->r_left);
     event_set_y(event,rr->r_top);
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Rect_to_int_rect_rec - ???

  Setup the int_rect_rec rr based on the rect content.
  This subroutine exists for compatibility for the future since Rect is a
  xview struct.
-------------------------------------------------------------------------*/

void
Rect_to_int_rect_rec(rect,rr)
 Rect *rect;
 struct int_rect_rec *rr; 
{
 setup_int_rect_rec(rr,(int) rect->r_left,
         (int) rect->r_top,(int) rect->r_width, (int) rect->r_height);
}


/*-------------------------------------------------------------------------
int_rect_rec_to_Rect - ???

  Setup the rect based on the int_rect_rec rr content.
  This subroutine exists for compatibility for the future since Rect is a
  xview struct.
-------------------------------------------------------------------------*/

void
int_rect_rec_to_Rect(rr,rect)
 struct int_rect_rec *rr; 
 Rect *rect;
{
 rect->r_left = rr->left;
 rect->r_top = rr->top;
 rect->r_width = rr->width;
 rect->r_height = rr->height;
}


/*-------------------------------------------------------------------------
pt_in_Rect - ???
-------------------------------------------------------------------------*/

int
pt_in_Rect(rr,x,y)
 Rect *rr;
 int x,y;
{
 if ((x >= rr->r_left) && (x < rr->r_left + rr->r_width) &&
     (y >= rr->r_top) && (y < rr->r_top + rr->r_height))
    return 1;
   else return 0;
}


/*-------------------------------------------------------------------------
pr_Rect - ???
-------------------------------------------------------------------------*/

void
pr_Rect(rr)
 Rect *rr;
{
 printf("l = %d  r = %d  t = %d b = %d  w = %d  h = %d\n",
    (int) rr->r_left,(int) (rr->r_left + rr->r_width - 1),(int) rr->r_top,
    (int) (rr->r_top + rr->r_height - 1),(int) rr->r_width,(int) rr->r_height);
}


/*-------------------------------------------------------------------------
make_2_wins_adjacent - ???
-------------------------------------------------------------------------*/

void
make_2_wins_adjacent(win_move_to,win_same_place,is_win_same_place_movable)
 Frame win_move_to,win_same_place;
 int is_win_same_place_movable;
{
 Rect rr1,rr2,rr3;
 struct int_rect_rec r1,r2,r3; 
 int status;

 get_win_absolute_area(win_same_place,&rr1);
 get_win_absolute_area(win_move_to,&rr2);
 rr3 = *((Rect *) xv_get(win_move_to,WIN_SCREEN_RECT));
 Rect_to_int_rect_rec(&rr1,&r1);
 Rect_to_int_rect_rec(&rr2,&r2);
 Rect_to_int_rect_rec(&rr3,&r3);
 status = place_adjacent_rect(&r3,&r1,&r2);
 if (status && is_win_same_place_movable)
    {status = place_adjacent_rect(&r3,&r2,&r1);
     if (status == 0)
        {int_rect_rec_to_Rect(&r1,&rr1);
         set_win_absolute_area(win_same_place,&rr1);}
    }
 int_rect_rec_to_Rect(&r2,&rr2);
 frame_set_rect(win_move_to,&rr2);
/*
 frame_get_rect(win_move_to,&rr2);
*/
}


/*******************
make_2_wins_adjacent(win_move_to,win_same_place,is_win_same_place_movable)
 Frame win_move_to,win_same_place;
 int is_win_same_place_movable;
{
 int right,temp;
 Frame frame;
 Rect rr,rr1,screen_rr;

 get_win_absolute_area(win_same_place,&rr1);

 screen_rr = *((Rect *) xv_get(win_move_to,WIN_SCREEN_RECT));
 right = screen_rr.r_left + screen_rr.r_width;
 get_win_absolute_area(win_move_to,&rr);

 temp = rr1.r_left + rr1.r_width;
 if (((temp + rr.r_width + 5) <= screen_rr.r_width) ||
     (temp < (screen_rr.r_width / 2)) ||
     (rr.r_width < (right - temp)))
    {
     rr.r_left = temp + 5;
     right -= (rr.r_left + rr.r_width + 5);
     if (right < 0)
        {right = -right;
         if (is_win_same_place_movable)
            if (rr1.r_left > 0)
               {if (right < rr1.r_left)
                   {rr.r_left -= right;
                    rr1.r_left -= right;} 
                  else
                   {rr.r_left -= rr1.r_left;
                    rr1.r_left = 0;} 
                set_win_absolute_area(win_same_place,&rr1);
               }
        }
    }
   else
    {
     rr.r_left = rr1.r_left - rr.r_width - 5;
     if (rr.r_left < 0)
        {if (is_win_same_place_movable)
            {right -= (rr1.r_left + rr1.r_width);
             if (right > 0)
                {rr.r_left += right;
                 rr1.r_left += right;
                 set_win_absolute_area(win_same_place,&rr1);
                }
               else rr.r_left = 0;
            }
           else rr.r_left = 0;
       }
    }
 rr.r_top = rr1.r_top;
 set_win_absolute_area(win_move_to,&rr);
}
******************/


/*-------------------------------------------------------------------------
make_2_wins_top_down - ???
-------------------------------------------------------------------------*/

void
make_2_wins_top_down(win_move_to,win_same_place,is_win_same_place_movable)
 Frame win_move_to,win_same_place;
 int is_win_same_place_movable;
{
 int bottom,temp;
 Rect rr,rr1,screen_rr;

 get_win_absolute_area(win_same_place,&rr1);

 screen_rr = *((Rect *) xv_get(win_move_to,WIN_SCREEN_RECT));
 bottom = screen_rr.r_top + screen_rr.r_height;
 get_win_absolute_area(win_move_to,&rr);

 temp = rr1.r_top + rr1.r_height;
 if (((temp + rr.r_height + 5) <= screen_rr.r_height) ||
     (temp < (screen_rr.r_height / 2)) ||
     (rr.r_height < (bottom - temp)))
    {
     rr.r_top = temp + 5;
     bottom -= (rr.r_top + rr.r_height + 5);
     if (bottom < 0)
        {bottom = -bottom;
         if (is_win_same_place_movable)
            if (rr1.r_top > 0)
               {if (bottom < rr1.r_top)
                   {rr.r_top -= bottom;
                    rr1.r_top -= bottom;} 
                  else
                   {rr.r_top -= rr1.r_top;
                    rr1.r_top = 0;} 
                set_win_absolute_area(win_same_place,&rr1);
               }
        }
    }
   else
    {
     rr.r_top = rr1.r_top - rr.r_height - 5;
     if (rr.r_top < 0)
        {if (is_win_same_place_movable)
            {bottom -= (rr1.r_top + rr1.r_height);
             if (bottom > 0)
                {rr.r_top += bottom;
                 rr1.r_top += bottom;
                 set_win_absolute_area(win_same_place,&rr1);
                }
               else rr.r_top = 0;
            }
           else rr.r_top = 0;
       }
    }
 rr.r_left = rr1.r_left;
 set_win_absolute_area(win_move_to,&rr);
 get_win_absolute_area(win_move_to,&rr);
}



/*-------------------------------------------------------------------------
move_win_to_mouse_xy - ???
-------------------------------------------------------------------------*/

void
move_win_to_mouse_xy(win,mouse_win)
 Xv_opaque win,mouse_win;
{
 Rect *rr;
 Rect rr1,rr2;

 get_win_absolute_area(mouse_win,&rr1);

 rr = (Rect *) xv_get(mouse_win,WIN_MOUSE_XY);
 get_win_absolute_area(win,&rr2);
 rr2.r_left = rr1.r_left + rr->r_left;
 rr2.r_top = rr1.r_top + rr->r_top;
 set_win_absolute_area(win,&rr2);
 get_win_absolute_area(win,&rr2);
}


/*-------------------------------------------------------------------------
get_xwin_valid_mouse_xy - ???
-------------------------------------------------------------------------*/

int
get_xwin_valid_mouse_xy(win,x,y)
 Xv_opaque win;
 long *x,*y;
{
 Rect *rr;

 if ((rr = (Rect *) xv_get(win,WIN_MOUSE_XY)) == NULL)
    return CANCEL;
 *x = rr->r_left;
 *y = rr->r_top;
 return NO_ERROR;
/*
 frame_get_rect(win,&rr1);

 if ((rr->r_left >= rr1.r_left) &&
     (rr->r_left < (rr1.r_left + rr1.r_width)) &&
     (rr->r_top >= rr1.r_top) &&
     (rr->r_top < (rr1.r_top + rr1.r_height)))
    {
     *x = rr->r_left;
     *y = rr->r_top;
     return NO_ERROR;
    }
   else 
    {PRT2(printf("xwin_valid_mouse_xy invalid rect x = %d y = %d l = %d t = %d r = %d b = %d\n",
      rr->r_left,rr->r_top,
      rr1.r_left,rr1.r_top,rr1.r_left + rr1.r_width - 1,
      rr1.r_top + rr1.r_height - 1))
     return CANCEL;}
*/

}


/*-------------------------------------------------------------------------
in_set_mouse_at_rect_center - ???
-------------------------------------------------------------------------*/

void
in_set_mouse_at_rect_center(win,rect)
 Xv_opaque win;
 Rect *rect;
{
 Rect rr1;

/* for some unknown reason, without first making a call to frame_get_rect,
      when setting the mouse right after a window is moved, the mouse
      cursor will not be placed right....bug ??? */ 
 frame_get_rect(win,&rr1);
 TRACE(printf("win_set_mouse_at_rect_center l = %d t= %d w = %d h = %d\n",rect->r_left,rect->r_top,rect->r_width,
         rect->r_height))
 xv_set(win,WIN_MOUSE_XY,(int) (rect->r_left + rect->r_width / 2),
                  (int) (rect->r_top + rect->r_height / 2),0);
}



/*-------------------------------------------------------------------------
win_set_mouse_at_center - ???
-------------------------------------------------------------------------*/

void
win_set_mouse_at_center(win)
 Xv_opaque win;
{
 Rect rr1;

/* because of xview implementation, when a window's paramters are updated,
    they are not reflected immediately until all the calling routines
    terminate, the window frame's rect may not have been updated.
   However, by trial and error to overcome this bug, by calling
   frame_get_rect the second time will always get the actual updated rect
*/
 frame_get_rect(win,&rr1);
 frame_get_rect(win,&rr1);
 xv_set(win,WIN_MOUSE_XY,rr1.r_width / 2,rr1.r_height / 2,0);
}


/*******************
struct xv_set_attr_rec
   {
    void *opr;
    int num_args;
    void *arg1,*arg2;
   };

struct timer_xv_set_rec
   {
    Xv_opaque win;
    int num_attrs;
    struct xv_set_attr_rec *attrs;
   };

stop_timer_xv_set(timer,which)
 struct timer_xv_set_rec *timer;
 int which;
{
 int lcv;
 Rect rr;

 TRACE(printf("timer = %u\n",timer))
 TRACE(printf("timer = %u\n",timer->win))
 (void) notify_set_itimer_func(timer,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 frame_get_rect(timer->win,&rr);
 TRACE(printf("l = %d t = %d w = %d h = %d\n",rr.r_left,rr.r_top,
         rr.r_width,rr.r_height))

 for (lcv = 0; lcv < timer->num_attrs; lcv++)
    {TRACE(printf("%d %d %d\n",timer->attrs[lcv].num_args,
         timer->attrs[lcv].arg1,timer->attrs[lcv].arg2))
     if (timer->attrs[lcv].num_args > 1)
        xv_set(timer->win,timer->attrs[lcv].opr,timer->attrs[lcv].arg1,
               timer->attrs[lcv].arg2,0);
       else xv_set(timer->win,
           timer->attrs[lcv].opr,timer->attrs[lcv].arg1,0);
    }
 if (timer->num_attrs > 0)
    {c_free(timer->attrs);
    }
 c_free(timer);
}

timer_xv_set(va_alist)
 va_dcl
{
 va_list args;
 struct timer_xv_set_rec *timer;
 unsigned int total,lcv;
 int err,num_args;

 total = 0;
 get_ptr_memory(&timer,&total,1,
       (size_t) sizeof(struct timer_xv_set_rec),&err);
 if (err != NO_ERROR) return err;
 va_start(args);
 timer->win = va_arg(args,Xv_opaque);
 timer->num_attrs = va_arg(args,int);
 if (timer->num_attrs == 0)
    {c_free(timer);
     return NO_ERROR;}
 total = 0;
 get_ptr_memory(&(timer->attrs),&total,timer->num_attrs,
       (size_t) sizeof(*(timer->attrs)),&err);
 if (err != NO_ERROR)
    {c_free(timer);
     return err;}

 for (lcv = 0; lcv < timer->num_attrs; lcv++)
    {timer->attrs[lcv].opr = va_arg(args,void *);
     timer->attrs[lcv].num_args = va_arg(args,int);
     timer->attrs[lcv].arg1 = va_arg(args,void *);
     if (timer->attrs[lcv].num_args > 1)
        timer->attrs[lcv].arg2 = va_arg(args,void *);
       else timer->attrs[lcv].arg2 = NULL;
    };
 (void) notify_set_itimer_func(timer,
                 stop_timer_xv_set,ITIMER_REAL,
                 NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
 return NO_ERROR;
}
**********************/


/*-------------------------------------------------------------------------
center_frame - ???

center the *choice frame on the screen

FIXME:  The second argument is simply ignored, as this function is currently
written.  -PWH 19990527
-------------------------------------------------------------------------*/

void
center_frame(window,is_just_setup)
 Xv_opaque window;
 int is_just_setup;
{
 Rect rr,rr1;

 rr = *((Rect *) xv_get(window,WIN_SCREEN_RECT));
 frame_get_rect(window,&rr1);
 frame_get_rect(window,&rr1);
 TRACE(printf("center_frame l = %d t = %d w = %d h = %d\n",
       (int) rr1.r_left,(int) rr1.r_top,
       (int) rr1.r_width,(int) rr1.r_height))

 rr1.r_left = rr.r_left + rr.r_width / 2 - rr1.r_width / 2;
/*
 if (is_just_setup) rr1.r_left += 20;
*/
 rr1.r_top = rr.r_top + rr.r_height / 2 - rr1.r_height / 2;
 frame_set_rect(window,&rr1);
 TRACE(printf("center_frame l = %d t = %d w = %d h = %d\n",
       (int) rr1.r_left,(int) rr1.r_top,
       (int) rr1.r_width,(int) rr1.r_height))
}


/*-------------------------------------------------------------------------
center_window - ???

center the *choice frame on the screen
-------------------------------------------------------------------------*/

void
center_window(window)
 Xv_opaque window;
{
 Rect rr,rr1;
 Xv_opaque window1;

 window1 = (Xv_opaque) xv_get(window, XV_OWNER);
 if (window1 == 0)
    {
     rr = *((Rect *) xv_get(window,WIN_SCREEN_RECT));}
   else rr = *((Rect *) xv_get(window1,WIN_RECT));

 rr1 = *((Rect *) xv_get(window,WIN_RECT));
 rr.r_left = rr.r_width / 2 - rr1.r_width / 2;
 rr.r_top = rr.r_height / 2 - rr1.r_height / 2;
 xv_set(window,XV_X,rr.r_left,XV_Y,rr.r_top,0);
}


/*-------------------------------------------------------------------------
win_clear - ???
-------------------------------------------------------------------------*/

void
win_clear(win,pm,is_wr_to_win)
 Xv_opaque win;
 Pixmap pm;
 int is_wr_to_win;
{
 Display *dp;
 Drawable xid;
 unsigned long depth;
 struct int_rect_rec rr;
 Cms cms;
 int bg;

 if (is_wr_to_win == 0)
    {
     if ((cms = (Cms) xv_get(win,WIN_CMS)) != 0)
        {
         bg = (int) xv_get(win,WIN_BACKGROUND_COLOR);
         win_pixmap_dims(win,pm,&(rr.width),&(rr.height),&depth);
         rr.left = rr.top = 0;
         draw_int_rect(win,pm,is_wr_to_win,&rr,bg,1);
        }
     return;
    }
 dp = (Display *) xv_get(win,XV_DISPLAY);
 if ((Xv_pkg *) xv_get(win,XV_TYPE) == CANVAS)
    {
     if ((xid = (Drawable) xv_get(canvas_paint_window(win),XV_XID)) == 0)
	 return /* ~NO_ERROR */;
    }
   else if ((xid = (Drawable) xv_get(win,XV_XID)) == 0)
        return /* ~NO_ERROR */;
 XClearWindow(dp,xid);
}


/*-------------------------------------------------------------------------
win_clear_area - ???

FIXME:  This function appears to never be used.
-------------------------------------------------------------------------*/

void
win_clear_area(win,pm,is_wr_to_win,x,y,width,height,exposures)
 Xv_opaque win;
 Pixmap pm;
 int is_wr_to_win;
 int x,y,width,height;
 Bool exposures;
{
 Display *dp;
 Drawable xid;
 struct int_rect_rec rr;
 Cms cms;
 int bg;

 if (is_wr_to_win == 0)
    {
     if ((cms = (Cms) xv_get(win,WIN_CMS)) != 0)
        {
         bg = (int) xv_get(win,WIN_BACKGROUND_COLOR);
         rr.left = x;
         rr.top = y;
         rr.width = width;
         rr.height = height;
         draw_int_rect(win,pm,is_wr_to_win,&rr,bg,1);
        }
     return;
    }
 dp = (Display *) xv_get(win,XV_DISPLAY);
 if (is_wr_to_win == 0)
    xid = (XID) pm;
   else if ((Xv_pkg *) xv_get(win,XV_TYPE) == CANVAS)
    {
     if ((xid = (Drawable) xv_get(canvas_paint_window(win),XV_XID)) == 0)
	 return /* ~NO_ERROR */;
    }
   else if ((xid = (Drawable) xv_get(win,XV_XID)) == 0)
       return /* ~NO_ERROR */;
 XClearArea(dp,xid,x,y,width,height,exposures);
}


/*-------------------------------------------------------------------------
win_flush - ???
-------------------------------------------------------------------------*/

void
win_flush(win)
 Xv_opaque win;
{
 Display *dp;

 dp = (Display *) xv_get(win,XV_DISPLAY);
 XFlush(dp);
}


/*-------------------------------------------------------------------------
win_flush_input - ???
-------------------------------------------------------------------------*/

void
win_flush_input(win)
 Xv_opaque win;
{
 Xv_opaque win1;
 Event event;
 long lcv;

 if ((Xv_pkg *) xv_get(win,XV_TYPE) == FRAME)
    for (lcv = 1; ; lcv++)
       {if ((win1 = (Xv_opaque) xv_get(win,FRAME_NTH_SUBWINDOW,lcv)) != 0)
           win_flush_input(win1);
          else break;
       }
   else
    {if ((Xv_pkg *) xv_get(win,XV_TYPE) == CANVAS)
        win1 = canvas_paint_window(win);
       else win1 = win;
     while (xv_input_readevent(win1,&event,FALSE,FALSE,NULL) != 0)
        {};
    }
}


/*-------------------------------------------------------------------------
win_screen_dims - ???
-------------------------------------------------------------------------*/

void
win_screen_dims(win,width,height,depth)
 Xv_opaque win;
 unsigned int *width,*height,*depth;
{
 Screen *screen;

 screen = win_x_screen(win);
 *height = HeightOfScreen(screen);
 *width = WidthOfScreen(screen);
 *depth = PlanesOfScreen(screen);
}



/*-------------------------------------------------------------------------
win_x_rootwindow - ???
-------------------------------------------------------------------------*/

Window 
win_x_rootwindow(win)
 Xv_opaque win;
{
 return RootWindowOfScreen(win_x_screen(win));
}


/*-------------------------------------------------------------------------
win_depth - ???
-------------------------------------------------------------------------*/

int
win_depth(win,depth)
 Xv_opaque win;
 unsigned int *depth;
{
 Display *dp;
 Drawable xid;
 Window root;
 int x,y;
 unsigned int width,height,bwidth;

 dp = (Display *) xv_get(win,XV_DISPLAY);
 if ((Xv_pkg *) xv_get(win,XV_TYPE) == CANVAS)
    {
     if ((xid = (Drawable) xv_get(canvas_paint_window(win),XV_XID)) == 0)
        return ~NO_ERROR;
    }
   else if ((xid = (Drawable) xv_get(win,XV_XID)) == 0)
        return ~NO_ERROR;
 XGetGeometry(dp,xid,&root,&x,&y,&width,&height,&bwidth,depth);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_pixmap_dims - ???
-------------------------------------------------------------------------*/

int
win_pixmap_dims(win,pm,width,height,depth)
 Xv_opaque win;
 Pixmap pm;
 unsigned int *width,*height,*depth;
{
 Display *dp;
 Window root;
 int x,y;
 unsigned int bwidth;

 dp = (Display *) xv_get(win,XV_DISPLAY);
 XGetGeometry(dp,pm,&root,&x,&y,width,height,&bwidth,depth);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_setup_pixmap - ???
-------------------------------------------------------------------------*/

int
win_setup_pixmap(win,pm)
 Xv_opaque win;
 Pixmap *pm;
{
 int height,width,depth,height1,width1,depth1;
 Display *dp;
 Drawable xid;

 if ((Xv_pkg *) xv_get(win,XV_TYPE) == CANVAS)
    {
     if ((xid = (Drawable) xv_get(canvas_paint_window(win),XV_XID)) == 0)
        return ~NO_ERROR;
     height = (int) xv_get(win,CANVAS_HEIGHT);
     width = (int) xv_get(win,CANVAS_WIDTH);
    }
   else
    {
     if ((xid = (Drawable) xv_get(win,XV_XID)) == 0)
        return ~NO_ERROR;
     height = (int) xv_get(win,XV_HEIGHT);
     width = (int) xv_get(win,XV_WIDTH);
    }
 win_depth(win,&depth);
 dp = (Display *) xv_get(win,XV_DISPLAY);
 if (*pm != 0)
    {win_pixmap_dims(win,*pm,&width1,&height1,&depth1);
     if ((width != width1) || (height != height1) || (depth != depth1))
        {XFreePixmap(dp,*pm);
         *pm = 0;}
    }
 if (*pm == 0)
    *pm = XCreatePixmap(dp,xid,width,height,depth);
 if (*pm == 0) return ~NO_ERROR;

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_free_pixmap - ???
-------------------------------------------------------------------------*/

void
win_free_pixmap(win,pm)
 Xv_opaque win;
 Pixmap pm;
{
 Display *dp;

 if (pm != 0)
    {dp = (Display *) xv_get(win,XV_DISPLAY);
     XFreePixmap(dp,pm);
    }
}



/*-------------------------------------------------------------------------
grap_keyboard - ???

FIXME: This interferes with regular Window Manager functioning.
I.e. when resizing, and sometimes when dragging, the FOCUS will spasm
between the main window and the window being operated on.  DRW 970225
-------------------------------------------------------------------------*/

void
grap_keyboard( xvwin )
     Xv_opaque xvwin;
{
  if (!xv_get( xvwin, WIN_KBD_FOCUS ))
  {
    win_set_kbd_focus( xvwin,
		       xv_get( xvwin, XV_XID ) );
  }
}



/*-------------------------------------------------------------------------
is_cursor_in_window - ???
-------------------------------------------------------------------------*/

int
is_cursor_in_window(xvwin)
 Xv_opaque xvwin;
{
 Rect rr,*rr1;

 frame_get_rect(xvwin,&rr);
 TRACE(printf("rr l = %d t = %d r = %d b = %d\n",
     rr.r_left,rr.r_top,rr.r_left + rr.r_width - 1,rr.r_top + rr.r_height - 1))

 rr1 = (Rect *) xv_get(xvwin,WIN_MOUSE_XY);
 TRACE(printf("mouse l = %d t = %d\n",
     rr1->r_left,rr1->r_top))
 return is_pt_in_area((int) rr.r_left,rr.r_top,rr.r_left + rr.r_width - 1,
          rr.r_top + rr.r_height - 1,
          (int) rr1->r_left,(int) rr1->r_top);
}

/**************
main()
{
 char *str;
 struct strs_rec choice_strs;

 choice_strs.strs = (char **) setup_str_ptr("ABCD","CBGH","teong",0);
 if (choice_strs.strs != NULL)
    {choice_strs.num_strs = 3;
     choice_strs.cur_str = 0;}

 str = win_enter_text(NULL,"EXAMPLE","SAVE ROI AS :",choice_strs,0,20,NULL,0);
 if (str != NULL)
    printf("str = %s\n",str); 
}

***************/


/*-------------------------------------------------------------------------
get_Xv_opaque_info - ???
-------------------------------------------------------------------------*/

void
get_Xv_opaque_info(win,dp,screen_num,screen)
 Xv_opaque win;
 Display **dp;
 int *screen_num;
 Screen **screen;
{
 Xv_screen xvscreen;
 Display *dp1;
 int snum;

 if (dp != NULL) *dp = (Display *) xv_get(win,XV_DISPLAY);
 if (screen_num != NULL)
    {xvscreen = (Xv_screen) xv_get(win,XV_SCREEN);
     *screen_num = (int) xv_get(xvscreen,SCREEN_NUMBER);}
 if (screen != NULL)
    {if (dp != NULL) dp1 = *dp;
       else dp1 = (Display *) xv_get(win,XV_DISPLAY);
     if (screen_num != NULL) snum = *screen_num;
       else
        {xvscreen = (Xv_screen) xv_get(win,XV_SCREEN);
         snum = (int) xv_get(xvscreen,SCREEN_NUMBER);}
     *screen = (Screen *) ScreenOfDisplay(dp1,snum);
    }
}


/*-------------------------------------------------------------------------
double_click - ???
-------------------------------------------------------------------------*/

int
double_click(canvas,event)
 Xv_opaque canvas;
 Event *event;
{
 static Event event1;
 static int first = 0;
 unsigned long usecs;

 TRACE(printf("canvas = %u event->ie_time = %u %u\n",canvas,event->ie_time.tv_sec,event->ie_time.tv_usec))
 if ((event_action(event) == ACTION_SELECT) && event_is_down(event))
    if (first == 0)
       {event1 = *event;
        first = 1;
       }
      else
       {if (event_window(&event1) == canvas)
           {TRACE(printf("canvas = %u event1.ie_time = %u %u\n",canvas,event1.ie_time.tv_sec,event1.ie_time.tv_usec))

            if (event->ie_time.tv_sec == event1.ie_time.tv_sec)
               {usecs = event->ie_time.tv_usec - event1.ie_time.tv_usec;
                if (usecs <= 200000) return 1;
               }
              else if ((event->ie_time.tv_sec + 1) == event1.ie_time.tv_sec)
               {usecs = 1000000 + event->ie_time.tv_usec -
                      event1.ie_time.tv_usec;
                if (usecs <= 200000) return 1;
               }
            }
        event1 = *event;
       }
 return 0;
}


/*-------------------------------------------------------------------------
selected_list_items - ???
-------------------------------------------------------------------------*/

int
selected_list_items(list,item)
 struct strs_rec *list;
 Panel_item item;
{
 int num_rows,err;
 unsigned long lcv;
 char *str;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rows; lcv++)
    if (xv_get(item,PANEL_LIST_SELECTED,lcv))
       {str = (char *) xv_get(item,PANEL_LIST_STRING,lcv);
        if ((err = add_str_to_strs_rec(list,str)) != NO_ERROR)
           return err;
       }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
selected_list_item_ptrs - ???
-------------------------------------------------------------------------*/

int
selected_list_item_ptrs(list,item)
 struct strs_rec *list;
 Panel_item item;
{
 int num_rows,err;
 unsigned long lcv;
 char *str;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rows; lcv++)
    if (xv_get(item,PANEL_LIST_SELECTED,lcv))
       {str = (char *) xv_get(item,PANEL_LIST_STRING,lcv);
        if ((err = add_str_ptr_to_strs_rec(list,str)) != NO_ERROR)
           return err;
       }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
next_selected_item - ???
-------------------------------------------------------------------------*/

int
next_selected_item(item,item_start_indx,selected_indx)
 Panel_item item;
 int item_start_indx,*selected_indx;
{
 int num_rows;
 unsigned long lcv;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = item_start_indx; lcv < num_rows; lcv++)
    if (xv_get(item,PANEL_LIST_SELECTED,lcv))
       {*selected_indx = lcv;
        return NO_ERROR;
       }
 return CANCEL;
}


/*-------------------------------------------------------------------------
is_list_item_empty - ???
-------------------------------------------------------------------------*/

int
is_list_item_empty(list_item)
 Panel_item list_item;
{
 int num_rows,lcv;

 if (list_item == 0) return 1;
 num_rows = (int) xv_get(list_item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rows; lcv++)
    if (xv_get(list_item,PANEL_LIST_SELECTED,lcv)) return 0;
 return 1;
}


/*-------------------------------------------------------------------------
list_items - ???
-------------------------------------------------------------------------*/

int
list_items(list,item)
 struct strs_rec *list;
 Panel_item item;
{
 int num_rows,err;
 unsigned long lcv;
 char *str;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rows; lcv++)
    {str = (char *) xv_get(item,PANEL_LIST_STRING,lcv);
     if ((err = add_str_to_strs_rec(list,str)) != NO_ERROR)
        return err;
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
list_item_ptrs - ???
-------------------------------------------------------------------------*/

int
list_item_ptrs(list,item)
 struct strs_rec *list;
 Panel_item item;
{
 int num_rows,err;
 unsigned long lcv;
 char *str;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rows; lcv++)
    {str = (char *) xv_get(item,PANEL_LIST_STRING,lcv);
     if ((err = add_str_ptr_to_strs_rec(list,str)) != NO_ERROR)
        return err;
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
setup_list_items - ???
-------------------------------------------------------------------------*/

int
setup_list_items(list,item,is_select_all)
 struct strs_rec *list;
 Panel_item item;
 int is_select_all;
{
 unsigned long lcv;

 if (list != NULL)
    for (lcv = 0; lcv < list->num_strs; lcv++)
       {xv_set(item,PANEL_LIST_STRING,lcv,list->strs[lcv],
               PANEL_LIST_CLIENT_DATA,lcv,lcv,0);
        if (is_select_all) xv_set(item,PANEL_LIST_SELECT,lcv,1,0);
           else xv_set(item,PANEL_LIST_SELECT,lcv,0,0);}
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
setup_int_items - ???
-------------------------------------------------------------------------*/

int
setup_int_items(ary,num_items,item,include_0)
 int *ary,num_items;
 Panel_item item;
 int include_0;
{
 unsigned long lcv;
 char str[40];

 for (lcv = 0; lcv < num_items; lcv++)
    if (ary[lcv] || include_0)
       {sprintf(str,"%d",ary[lcv]);
        xv_set(item,PANEL_LIST_STRING,lcv,str,
               PANEL_LIST_CLIENT_DATA,lcv,lcv,PANEL_LIST_SELECT,lcv,0,0);
       }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
update_list_client_data - ???
-------------------------------------------------------------------------*/

void
update_list_client_data(item)
 Panel_item item;
{
 long lcv,num_rows;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rows; lcv++)
    xv_set(item,PANEL_LIST_CLIENT_DATA,lcv,lcv,0);

}


/*-------------------------------------------------------------------------
select_list_items - ???

assuming the lists and list items are sorted ascendingly
-------------------------------------------------------------------------*/

int
select_list_items(list,item)
 struct strs_rec *list;
 Panel_item item;
{
 unsigned long lcv,cnt;
 char *str;
 int num_rows;

 if (list->num_strs == 0) return NO_ERROR;
 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (cnt = 0; cnt < num_rows; cnt++)
    {str = (char *) xv_get(item,PANEL_LIST_STRING,cnt);
     for (lcv = 0; lcv < list->num_strs; lcv++)
        if (str_cmp(list->strs[lcv],str) == 0)
           {xv_set(item,PANEL_LIST_SELECT,cnt,1,0);
            break;}
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
select_list_str_item - ???
-------------------------------------------------------------------------*/

int
select_list_str_item(selected_item_str,item,is_sel)
 char *selected_item_str;
 Panel_item item;
 int is_sel;
{
 unsigned long cnt;
 int num_rows;
 char *str;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (cnt = 0;cnt < num_rows; cnt++)
    {str = (char *) xv_get(item,PANEL_LIST_STRING,cnt);
     if (str_cmp(selected_item_str,str) == 0)
        {xv_set(item,PANEL_LIST_SELECT,cnt,is_sel,0);
         return NO_ERROR;
        }
    }
 return CANCEL;
}


/*-------------------------------------------------------------------------
delete_all_list_items - ???
-------------------------------------------------------------------------*/

void
delete_all_list_items(item)
 Panel_item item;
{
 int num_rows;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 xv_set(item,PANEL_LIST_DELETE_ROWS,0,num_rows,0);
}


/*-------------------------------------------------------------------------
delete_selected_list_items - ???
-------------------------------------------------------------------------*/

int
delete_selected_list_items(item)
 Panel_item item;
{
 int num_rows;
 unsigned long lcv;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rows; )
    if (xv_get(item,PANEL_LIST_SELECTED,lcv))
       {xv_set(item,PANEL_LIST_DELETE,lcv,0);
        num_rows -= 1;
       }
      else lcv++;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
delete_list_item_by_str - ???
-------------------------------------------------------------------------*/

int
delete_list_item_by_str(str,item)
 char *str;
 Panel_item item;
{
 int num_rows;
 unsigned long lcv;
 char *str1;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rows; )
    {str1 = (char *) xv_get(item,PANEL_LIST_STRING,lcv);
     if (str_cmp(str,str1) == 0)
        {xv_set(item,PANEL_LIST_DELETE,lcv,0);
         break;}
    }
 return NO_ERROR;
}



/*-------------------------------------------------------------------------
deselect_all_list_items - ???
-------------------------------------------------------------------------*/

void
deselect_all_list_items(item)
 Panel_item item;
{
 int num_rows,lcv;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0;lcv < num_rows; lcv++)
    xv_set(item,PANEL_LIST_SELECT,lcv,0,0);
}


/*-------------------------------------------------------------------------
deselect_list_items - ???
-------------------------------------------------------------------------*/

int
deselect_list_items(list,item)
 struct strs_rec *list;
 Panel_item item;
{
 int num_rows;
 unsigned long lcv,indx;
 char *str;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rows; lcv++)
    if (xv_get(item,PANEL_LIST_SELECTED,lcv))
       {str = (char *) xv_get(item,PANEL_LIST_STRING,lcv);
        if (find_str_in_strs_rec(list,str,&indx) == NO_ERROR)
           xv_set(item,PANEL_LIST_SELECT,lcv,0,0);
       }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
select_all_list_items - ???
-------------------------------------------------------------------------*/

void
select_all_list_items(item)
 Panel_item item;
{
 int num_rows,lcv;

 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0;lcv < num_rows; lcv++)
    xv_set(item,PANEL_LIST_SELECT,lcv,1,0);
}


/*-------------------------------------------------------------------------
find_list_item_by_str - ???
-------------------------------------------------------------------------*/

int
find_list_item_by_str(item,str,indx)
 Panel_item item;
 char *str;
 unsigned long *indx;
{
 int num_rows,lcv;
 char *str1;

 *indx = 0;
 num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
 for (lcv = 0;lcv < num_rows; lcv++)
    {str1 = (char *) xv_get(item,PANEL_LIST_STRING,lcv);
     if (str_cmp(str1,str) == 0) 
        {*indx = lcv;
         return NO_ERROR;}
    }
 return NOT_FOUND;
}


/*-------------------------------------------------------------------------
deselect_list_proc - ???
-------------------------------------------------------------------------*/

void
deselect_list_proc(item,event)
 Panel_item item;
 Event *event;
{
 Panel_item item1;

 item1 = (Panel_item) xv_get(item,PANEL_CLIENT_DATA);
 deselect_all_list_items(item1);
}


/*-------------------------------------------------------------------------
select_list_proc - ???
-------------------------------------------------------------------------*/

void
select_list_proc(item,event)
 Panel_item item;
 Event *event;
{
 Panel_item item1;

 item1 = (Panel_item) xv_get(item,PANEL_CLIENT_DATA);
 select_all_list_items(item1);
}


/*-------------------------------------------------------------------------
list_insert - ???
-------------------------------------------------------------------------*/

void
list_insert(from_item,from_item_indx,to_item,to_item_indx)
 Panel_item from_item,to_item;
 int from_item_indx,*to_item_indx;
{
 int num_rows,indx;
 char *str1,*str,*str2;
 int err;

 str1 = (char *) xv_get(from_item,PANEL_LIST_STRING,from_item_indx);
 TRACE(printf("...list_insert from_item_indx = %d str1 = %s\n",from_item_indx,str1))
 TRACE(printf("...list_insert to_item_indx = %d\n",*to_item_indx))

 if (find_list_item_by_str(to_item,str1,&indx) != NO_ERROR)
    {TRACE(printf("...order_insert_proc...1\n"))
     if (*to_item_indx >= 0)
        {xv_set(to_item,PANEL_LIST_INSERT,*to_item_indx,
                          PANEL_LIST_STRING,*to_item_indx,str1,0);
         *to_item_indx += 1;}         
       else
        {num_rows = (int) xv_get(to_item,PANEL_LIST_NROWS);
         TRACE(printf("list_insert 1 num_rows = %d\n",num_rows))
         xv_set(to_item,PANEL_LIST_INSERT,num_rows,
                          PANEL_LIST_STRING,num_rows,str1,0);
         TRACE(printf("list_insert 2 num_rows = %d\n",num_rows))}
   }
  else if (*to_item_indx >= 0)
   {TRACE(printf("...list_insert...*to_item_indx = %d...indx = %d\n",
                 *to_item_indx,indx))
    str = (char *) xv_get(to_item,PANEL_LIST_STRING,*to_item_indx);
    if (str_cmp(str,str1) != 0)
       {if (indx < *to_item_indx) *to_item_indx -= 1;
           if (indx != *to_item_indx)
              if ((err = cp_str(&str2,str1)) == NO_ERROR)
                 {xv_set(to_item,PANEL_LIST_DELETE,indx,
                      PANEL_LIST_INSERT,*to_item_indx,
                      PANEL_LIST_STRING,*to_item_indx,str2,0);
                  c_free(str2);}

        *to_item_indx += 1;}
   }
  else
   {TRACE(printf("...list_insert...3...indx = %d\n",indx))
    if ((err = cp_str(&str2,str1)) == NO_ERROR)
       {xv_set(to_item,PANEL_LIST_DELETE,indx,0);
        num_rows = (int) xv_get(to_item,PANEL_LIST_NROWS);
        xv_set(to_item,PANEL_LIST_INSERT,num_rows,
                          PANEL_LIST_STRING,num_rows,str2,0);
        c_free(str2);}

    TRACE(printf("list_insert 4 num_rows = %d\n",num_rows))
   }

 update_list_client_data(to_item);
 TRACE(printf("...list_insert out to_item_indx = %d\n",*to_item_indx))
}


/*-------------------------------------------------------------------------
list_swap - ???
-------------------------------------------------------------------------*/

void
list_swap(item,op,cur_indx,swap_indx,swap_str)
 Panel_item item;
 Panel_list_op op;
 int *cur_indx,swap_indx;
 char *swap_str;
{
 char *str1,*str2;
 int err;

 TRACE(printf("list_swap op = %d cur_indx = %d  swap_indx = %d\n",
         op,*cur_indx,swap_indx))

 if (op) 
    {if (*cur_indx < 0) *cur_indx = swap_indx;
       else if (*cur_indx != swap_indx)
        {str2 = NULL;
         if (((str1 = (char *) xv_get(item,PANEL_LIST_STRING,*cur_indx)) != NULL) &&
             ((err = cp_str(&str2,swap_str)) == NO_ERROR))
            {xv_set(item,PANEL_LIST_STRING,swap_indx,str1,
                         PANEL_LIST_SELECT,swap_indx,0,0);
             xv_set(item,PANEL_LIST_STRING,*cur_indx,str2,
                         PANEL_LIST_SELECT,*cur_indx,0,0);
             *cur_indx = -1;
            }
           else
            {xv_set(item,PANEL_LIST_SELECT,*cur_indx,0,0);
             *cur_indx = swap_indx;}
         c_free(str2);
        }
    }
   else
    {*cur_indx = -1;}
 TRACE(printf("list_swap out op = %d cur_indx = %d  swap_indx = %d\n",
         op,*cur_indx,swap_indx))
}


/*-------------------------------------------------------------------------
list_delete - ???
-------------------------------------------------------------------------*/

void
list_delete(item,item_indx)
 Panel_item item;
 int *item_indx;
{
 int num_rows;

 if (*item_indx >= 0)
    {
     xv_set(item,PANEL_LIST_DELETE,*item_indx,0);
     num_rows = (int) xv_get(item,PANEL_LIST_NROWS);
     update_list_client_data(item);
     if (*item_indx >= num_rows)
        *item_indx = -1;
    }
}



/*-------------------------------------------------------------------------
open_close_frame_and_subframes - ???
-------------------------------------------------------------------------*/

void
open_close_frame_and_subframes(frame,is_open)
     Frame frame;
{
  int lcv;
  Frame subframe;
  int status;
  
  if (frame != 0) 
  {
    if (is_open)
      status = FALSE;
    else
      status = TRUE;
    for (lcv = 1; ; lcv++)
    {
      if ((subframe = (Frame) xv_get(frame,FRAME_NTH_SUBFRAME,lcv)) != 0)
	open_close_frame_and_subframes(subframe,is_open);
      else
	break;
    }
    xv_set(frame,FRAME_CLOSED,status,0);
  }
}



/*-------------------------------------------------------------------------
show_hide_frame_and_subframes - ???
-------------------------------------------------------------------------*/

void
show_hide_frame_and_subframes(win,is_show)
 Xv_opaque win;
 int is_show;
{
 int lcv;
 Xv_opaque subwin;
 int status1,status;

 if (win != 0) 
    {if (is_show) status = TRUE;
       else status = FALSE;
     if ((Xv_pkg *) xv_get(win,XV_TYPE) == FRAME)
        {
         for (lcv = 1; ; lcv++)
            {if ((subwin = (Xv_opaque) xv_get(win,FRAME_NTH_SUBWINDOW,lcv))
                       != 0)
                show_hide_frame_and_subframes(subwin,is_show);
               else break;
            }
         if ((status1 = (int) xv_get(win,XV_KEY_DATA,EXTRA_FRAME_STATUS)) ==
                  0)
            xv_set(win,XV_SHOW,status,0);
           else if (status1 & EXTRA_FRAME_SHOW) xv_set(win,XV_SHOW,status,0);
        }
       else xv_set(win,XV_SHOW,status,0);
    }
}


/*-------------------------------------------------------------------------
top_frame_and_subframes - ???
-------------------------------------------------------------------------*/

void
top_frame_and_subframes(frame)
 Frame frame;
{
 int lcv;
 Frame subframe;

 if (frame != 0) 
    {
     for (lcv = 1; ; lcv++)
       {if ((subframe = (Frame) xv_get(frame,FRAME_NTH_SUBFRAME,lcv)) != 0)
           top_frame_and_subframes(subframe);
          else break;
       }
     wmgr_top(frame);
    }
}


/*-------------------------------------------------------------------------
destroy_all_subframes - ???
-------------------------------------------------------------------------*/

void
destroy_all_subframes(frame)
 Frame frame;
{
 int lcv;
 Frame subframe;
 int (*proc)();

 if (frame != 0) 
    {
     for (lcv = 1; ; lcv++)
       {if ((subframe = (Frame) xv_get(frame,FRAME_NTH_SUBFRAME,lcv)) != 0)
           {destroy_all_subframes(subframe);
            if ((proc = (int (*)()) xv_get(subframe,FRAME_DONE_PROC)) != NULL)
               proc(subframe);
              else xv_destroy_safe(subframe);
           }
          else break;
       }
    }
}


/*-------------------------------------------------------------------------
apply_proc_to_all_tree_window - ???

The argument "num" appears to be a tree depth and is usually initialized
to 0 when this recursive function is called.
-------------------------------------------------------------------------*/

void
apply_proc_to_all_tree_window(win,proc,arg1,arg2,arg3,arg4,num)
 Xv_opaque win;
 int (*proc)();
 void *arg1,*arg2,*arg3,*arg4;
{
 int lcv;
 Xv_opaque subwin;
 
 if (win != 0) 
    {proc(win,arg1,arg2,arg3,arg4);
     /*printf("%d) frame = %u\n",num,win);*/
     if ((Xv_pkg *) xv_get(win,XV_TYPE) == FRAME)
        {for (lcv = 1; ; lcv++)
            {if ((subwin = (Xv_opaque) xv_get(win,FRAME_NTH_SUBWINDOW,lcv)) != 0)
                {
                 if ((Xv_pkg *) xv_get(subwin,XV_TYPE) == FRAME)
                   {/*printf("...ppp %d) %d  frame = %u\n",num,lcv,subwin);*/
                    apply_proc_to_all_tree_window(subwin,proc,arg1,
                              arg2,arg3,arg4,num+1);}
                   else 
                    {proc(subwin,arg1,arg2,arg3,arg4);
                     /*printf("...%d) %d non frame = %u\n",num,lcv,subwin);*/}
                }
               else break;
            }
         for (lcv = 1; ; lcv++)
            {if ((subwin = (Xv_opaque)xv_get(win,FRAME_NTH_SUBFRAME,lcv)) != 0)
                {/*printf("...call %d) %d  frame = %u\n",num,lcv,subwin);*/
                 apply_proc_to_all_tree_window(subwin,proc,arg1,
                           arg2,arg3,arg4,num+1);}
               else break;
            }
        }
    }
}


/*-------------------------------------------------------------------------
root_menu - ???
-------------------------------------------------------------------------*/

Xv_opaque 
root_menu(menu)
 Menu menu;
{
 Menu item;

 TRACE(printf("menu_root_parent...menu = %u\n",menu))
 while (item = (Xv_opaque) xv_get(menu,MENU_PARENT))
    {TRACE(printf("item = %u   ",item))
     if ((Xv_pkg *) xv_get(item,XV_TYPE) != MENUITEM)
        {TRACE(printf("Object...\n"))
         break;}
       else
        {TRACE(printf("MENUITEM...\n"))
         menu = item;}
    }
 if (item != 0)
    {if ((Xv_pkg *) xv_get(item,XV_TYPE) != MENU)
        item = menu;}
   else item = menu;
 return item;
}



/*-------------------------------------------------------------------------
destroy_menu_and_submenus - ???
-------------------------------------------------------------------------*/

void
destroy_menu_and_submenus(menu,num)
     Menu menu;
     int num;
{
  int num_items,lcv;
  Menu_item item;
  Menu menu1;
  char *str;

  num_items = (int) xv_get(menu,MENU_NITEMS);
  TRACE( printf( "%d) destroy_menu menu = %u num_items = %u\n",
		num, menu, num_items ); );
  for (lcv = 1; lcv <= num_items; lcv++)
  {
    item = (Menu_item) xv_get(menu,MENU_NTH_ITEM,lcv);
    if ((item != 0) && 
	((menu1 = (Menu) xv_get(item,MENU_PULLRIGHT)) != 0))
    {
      str = (char *) xv_get(item,MENU_STRING);
      TRACE( printf("%d)   item = %u  str = %s menu1 = %u\n",
		    num,item,str,menu1); );
      destroy_menu_and_submenus(menu1,num+1);
    }
  }
  xv_destroy(menu);
}

/***************
menu_item_inactive(menu)
 Menu menu;
{
 int num_items,lcv;
 Menu_item item;

 num_items = (int) xv_get(menu,NMENU_ITEMS);
 for (lcv = 1; lcv <= num_items; lcv++)
    {item = (Menu_item) xv_get(item,MENU_NTH_ITEM,lcv);
     if (item != NULL) xv_set(item,MENU_INACTIVE,TRUE,0);}
 return NO_ERROR;
}
*****************/


/*-------------------------------------------------------------------------
none_list_proc - ???
-------------------------------------------------------------------------*/

void
none_list_proc(item,event)
 Panel_item item;
 Event *event;
{
 Panel_item *item1;

 item1 = (Panel_item *) xv_get(item,XV_KEY_DATA,1);
 deselect_all_list_items(*item1);
}


/*-------------------------------------------------------------------------
all_list_proc - ???
-------------------------------------------------------------------------*/

void
all_list_proc(item,event)
 Panel_item item;
 Event *event;
{
 Panel_item *item1;

 item1 = (Panel_item *) xv_get(item,XV_KEY_DATA,1);
 select_all_list_items(*item1);
}

