/****************************************************************************
dump_dicom.c - Dump DICOM-format image information

Author:  Dan R. Widyono 19960922

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: dumpdicom.c,v 1.5 1999/07/07 18:07:14 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>

#include <sys/types.h>        /* Needed to define off_t for bbl_dicom.h */

#include "bbl_dicom.h"



#define PRT(x) x; fflush(stdout);
#undef PRT
#define PRT(x)


/*-------------------------------------------------------------------------
main - ???
-------------------------------------------------------------------------*/

int
main( argc, argv )
     int argc;
     char *argv[];
{
  MessagePtr		message;
  ElementGroupId	groupId;
  ElementId		id;


  if (argc != 2 && argc != 4) {
    printf( "Usage: %s <ACRNEMA-or-DICOM-format-file name>", argv[0] );
    printf( " [ GroupId ElementId ]\n" );
    exit( 0 );
  }

  if ((message = msgOpen( argv[1], MSG_READ )) == NULL) {
    msgClose( message );
    exit( 1 );
  }

  if (getElements( message ) == 0) {
    if (argc == 2)
      dumpElements( message );
    else {
      sscanf( argv[2], "%hu", &groupId ); /* %hu = unsigned short int */
      sscanf( argv[3], "%hu", &id );
      dumpElement( message, groupId, id );
    }
  }

  msgClose( message );
  exit( 0 );
}
