/****************************************************************************
ria2text.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: ria2text.c,v 1.8 1999/07/07 18:07:14 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>

#include <unistd.h>
#include <sys/types.h>

#include "typedef.h"
#include "ia_hdr.h"
#include "error_constants.h"
#include "common_constants.h"
#include "mri_hdr_constants.h"
#include "nria_lib.h"

/*
 *  Teong's old debugging macros, wrapped in modern #ifdef DEBUG
 */
#ifdef DEBUG
#define PRT1(x) x; fflush(stdout)
#else
#define PRT1(x)
#endif


/* The library debugging code checks the following variable */
int debugFlag;


/* ria2text.c */
int construct_text_from_hdr(char *hdrfn, char *textfn, FILE *textfid);
void prog_usage(int argc, char *argv[]);
void main(int argc, char *argv[]);


/*--------------------------------------------------------------------------
construct_text_from_hdr - ???
--------------------------------------------------------------------------*/

int
construct_text_from_hdr(hdrfn,textfn,textfid)
     char *textfn,*hdrfn;
     FILE *textfid;
{
  struct hdr_rec hdr;
  int err;

  init_hdr_rec(&hdr);
  PRT1(printf("construct_text_from_hdr...1\n"));
  if ((err = rd_the_hdr(hdrfn,&hdr)) != NO_ERROR) return err;
  PRT1(printf("construct_text_from_hdr...2\n"));

  return WrTextHdrSpec(textfid,hdrfn,&hdr,mri_hdr_fields);
}



/*--------------------------------------------------------------------------
prog_usage - explain how to use this program
--------------------------------------------------------------------------*/

void
prog_usage(argc,argv)
     int argc;
     char *argv[];
{
  if (argc != 3)
    {
      printf("Usage : %s ria.nhdr text_spec_file\n",argv[0]);
      printf("Example 1 : %s mri10010a.nhdr text_mri10010a_hdr.dat\n",argv[0]);
      printf("Input .hdr file : mri10010a.nhdr\n");
      printf("Output text specification file : text_mri10010a_hdr.dat\n");
      printf("\n");
      printf("Example 2 : %s mri*.hdr text.dat\n",argv[0]);
      printf("Input .hdr file : mri*.hdr\n");
      printf("Output text specification file : text.dat\n");
      exit(1);
    }
}



/*--------------------------------------------------------------------------
main - main routine
--------------------------------------------------------------------------*/

void
main(argc,argv)
     int argc;
     char *argv[];
{
  int err;
  char **fns;
  unsigned int num_fns;
  unsigned long lcv;
  char *dirfn,fn[200];
  FILE *textfid;

  prog_usage(argc,argv);
  dirfn = (char *) locate_dirfn(argv[1]);
  drop_dirfn(argv[1]);
  if (dirfn == NULL) dirfn = ".";
  if ((err = get_fns(dirfn,NULL,0,0,NULL,&fns,&num_fns,1,argv[1],
		     NULL,0,0,NULL)) != NO_ERROR) exit(err);
  if (num_fns == 0)
    {printf("Sorry...No file names...\n");
     sprintf(fn,"%s/%s",dirfn,argv[1]);
     printf("...Fn specification processed = %s\n",fn);
   }
  else
    {
      printf("\n");
      if ((textfid = fopen(argv[2],"w")) == NULL)
	{
	  printf("Error opening the input fn = %s\n",argv[2]);
	  exit(FILE_ACCESS_ERROR);
	}

      for (lcv = 0; lcv < num_fns; lcv++)
	{
	  sprintf(fn,"%s/%s",dirfn,fns[lcv]);
	  printf("%ld) processing %s\n",lcv,fn);
	  if ((err = construct_text_from_hdr(fn,argv[2],textfid)) != NO_ERROR)
	    {
	      printf("error id = %d....hdr not constructed...\n",err);
	      break;
	    }
	}

      fclose(textfid);
      if (err != NO_ERROR)
	{
	  printf("The text output file %s is deleted...\n",argv[2]);
	  unlink(argv[2]);
	}
    }

  exit(err);
}
